/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var re=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/base/common/errors","vs/base/common/uri","vs/platform/log/common/log","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/base/common/path","vs/platform/files/common/files","vs/base/common/types","vs/platform/environment/common/environment","vs/platform/configuration/common/configuration","vs/base/common/buffer","vs/platform/userDataProfile/common/userDataProfile","vs/platform/telemetry/common/telemetry","vs/platform/storage/common/storage","vs/base/common/arrays","vs/base/common/resources","vs/base/common/cancellation","vs/base/common/network","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/base/node/pfs","vs/platform/uriIdentity/common/uriIdentity","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/uuid","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagementUtil","os","vs/base/common/json","vs/base/common/process","vs/base/common/map","vs/base/common/errorMessage","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/userDataSync/common/abstractSynchronizer","vs/platform/extensions/common/extensions","vs/base/common/jsonFormatter","vs/base/common/stream","vs/platform/externalServices/common/serviceMachineId","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/base/common/extpath","vs/base/common/ternarySearchTree","child_process","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/codicons","fs","vs/base/common/semver/semver","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/ipc/electron-sandbox/services","vs/platform/native/electron-sandbox/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataSync/common/content","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/date","vs/base/common/hash","vs/base/common/marshalling","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/normalization","net","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/glob","vs/base/node/powershell","vs/base/node/processes","vs/base/parts/ipc/common/ipc.net","electron","vs/platform/environment/common/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/electron-browser/sharedProcessLifecycleService","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/base/node/zip","vs/platform/extensionManagement/node/extensionManagementService","vs/base/common/assert","vs/base/common/lazy","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/base/node/ports","vs/base/parts/request/common/request","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","vs/base/node/id","vs/base/node/extpath","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/base/parts/ipc/node/ipc.net","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/electron-browser/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/environment/node/argv","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policyIpc","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/nodeSocketFactory","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/request/electron-browser/sharedProcessRequestService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/shell/node/shellEnv","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/remoteTunnel/electron-browser/remoteTunnelService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/tunnel/node/tunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/electron-browser/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/electron-sandbox/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/storage/electron-sandbox/storageService","vs/platform/userDataProfile/electron-sandbox/userDataProfile","vs/platform/userDataProfile/electron-sandbox/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/electron-browser/sharedProcess/contrib/extensions","util","minimist","assert","path","graceful-fs","https","yauzl","yazl","vs/code/electron-browser/sharedProcess/sharedProcessMain"],ae=function(_){for(var e=[],A=0,n=_.length;A<n;A++)e[A]=re[_[A]];return e};define(re[52],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.Codicon=e.getCodiconAriaLabel=void 0;function A(k){return k?k.replace(/\$\((.*?)\)/g,(T,R)=>` ${R} `).trim():""}e.getCodiconAriaLabel=A;class n{constructor(T,R,P){this.id=T,this.definition=R,this.description=P,n.a.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return n.a}}e.Codicon=n,n.a=[],n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",n.add.definition),n.gistNew=new n("gist-new",n.add.definition),n.repoCreate=new n("repo-create",n.add.definition),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",n.circleFilled.definition),n.closeDirty=new n("close-dirty",n.circleFilled.definition),n.debugBreakpoint=new n("debug-breakpoint",n.circleFilled.definition),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",n.circleFilled.definition),n.debugHint=new n("debug-hint",n.circleFilled.definition),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circle=new n("circle",{fontCharacter:"\\eabc"}),n.circleOutline=new n("circle-outline",n.circle.definition),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",n.circle.definition),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolCustomColor=new n("symbol-customcolor",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.circleSmallFilled=new n("circle-small-filled",{fontCharacter:"\\eb8a"}),n.debugStackframeDot=new n("debug-stackframe-dot",n.circleSmallFilled.definition),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLarge=new n("circle-large",{fontCharacter:"\\ebb5"}),n.circleLargeOutline=new n("circle-large-outline",n.circleLarge.definition),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.runErrors=new n("run-errors",{fontCharacter:"\\ebde"}),n.folderLibrary=new n("folder-library",{fontCharacter:"\\ebdf"}),n.debugContinueSmall=new n("debug-continue-small",{fontCharacter:"\\ebe0"}),n.beakerStop=new n("beaker-stop",{fontCharacter:"\\ebe1"}),n.graphLine=new n("graph-line",{fontCharacter:"\\ebe2"}),n.graphScatter=new n("graph-scatter",{fontCharacter:"\\ebe3"}),n.pieChart=new n("pie-chart",{fontCharacter:"\\ebe4"}),n.bracket=new n("bracket",n.json.definition),n.bracketDot=new n("bracket-dot",{fontCharacter:"\\ebe5"}),n.bracketError=new n("bracket-error",{fontCharacter:"\\ebe6"}),n.lockSmall=new n("lock-small",{fontCharacter:"\\ebe7"}),n.azureDevops=new n("azure-devops",{fontCharacter:"\\ebe8"}),n.verifiedFilled=new n("verified-filled",{fontCharacter:"\\ebe9"}),n.newLine=new n("newline",{fontCharacter:"\\ebea"}),n.layout=new n("layout",{fontCharacter:"\\ebeb"}),n.layoutActivitybarLeft=new n("layout-activitybar-left",{fontCharacter:"\\ebec"}),n.layoutActivitybarRight=new n("layout-activitybar-right",{fontCharacter:"\\ebed"}),n.layoutPanelLeft=new n("layout-panel-left",{fontCharacter:"\\ebee"}),n.layoutPanelCenter=new n("layout-panel-center",{fontCharacter:"\\ebef"}),n.layoutPanelJustify=new n("layout-panel-justify",{fontCharacter:"\\ebf0"}),n.layoutPanelRight=new n("layout-panel-right",{fontCharacter:"\\ebf1"}),n.layoutPanel=new n("layout-panel",{fontCharacter:"\\ebf2"}),n.layoutSidebarLeft=new n("layout-sidebar-left",{fontCharacter:"\\ebf3"}),n.layoutSidebarRight=new n("layout-sidebar-right",{fontCharacter:"\\ebf4"}),n.layoutStatusbar=new n("layout-statusbar",{fontCharacter:"\\ebf5"}),n.layoutMenubar=new n("layout-menubar",{fontCharacter:"\\ebf6"}),n.layoutCentered=new n("layout-centered",{fontCharacter:"\\ebf7"}),n.layoutSidebarRightOff=new n("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),n.layoutPanelOff=new n("layout-panel-off",{fontCharacter:"\\ec01"}),n.layoutSidebarLeftOff=new n("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),n.target=new n("target",{fontCharacter:"\\ebf8"}),n.indent=new n("indent",{fontCharacter:"\\ebf9"}),n.recordSmall=new n("record-small",{fontCharacter:"\\ebfa"}),n.errorSmall=new n("error-small",{fontCharacter:"\\ebfb"}),n.arrowCircleDown=new n("arrow-circle-down",{fontCharacter:"\\ebfc"}),n.arrowCircleLeft=new n("arrow-circle-left",{fontCharacter:"\\ebfd"}),n.arrowCircleRight=new n("arrow-circle-right",{fontCharacter:"\\ebfe"}),n.arrowCircleUp=new n("arrow-circle-up",{fontCharacter:"\\ebff"}),n.heartFilled=new n("heart-filled",{fontCharacter:"\\ec04"}),n.map=new n("map",{fontCharacter:"\\ec05"}),n.mapFilled=new n("map-filled",{fontCharacter:"\\ec06"}),n.circleSmall=new n("circle-small",{fontCharacter:"\\ec07"}),n.bellSlash=new n("bell-slash",{fontCharacter:"\\ec08"}),n.bellSlashDot=new n("bell-slash-dot",{fontCharacter:"\\ec09"}),n.commentUnresolved=new n("comment-unresolved",{fontCharacter:"\\ec0a"}),n.gitPullRequestGoToChanges=new n("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),n.gitPullRequestNewChanges=new n("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),n.searchFuzzy=new n("search-fuzzy",{fontCharacter:"\\ec0d"}),n.commentDraft=new n("comment-draft",{fontCharacter:"\\ec0e"}),n.dialogError=new n("dialog-error",n.error.definition),n.dialogWarning=new n("dialog-warning",n.warning.definition),n.dialogInfo=new n("dialog-info",n.info.definition),n.dialogClose=new n("dialog-close",n.close.definition),n.treeItemExpanded=new n("tree-item-expanded",n.chevronDown.definition),n.treeFilterOnTypeOn=new n("tree-filter-on-type-on",n.listFilter.definition),n.treeFilterOnTypeOff=new n("tree-filter-on-type-off",n.listSelection.definition),n.treeFilterClear=new n("tree-filter-clear",n.close.definition),n.treeItemLoading=new n("tree-item-loading",n.loading.definition),n.menuSelection=new n("menu-selection",n.check.definition),n.menuSubmenu=new n("menu-submenu",n.chevronRight.definition),n.menuBarMore=new n("menubar-more",n.more.definition),n.scrollbarButtonLeft=new n("scrollbar-button-left",n.triangleLeft.definition),n.scrollbarButtonRight=new n("scrollbar-button-right",n.triangleRight.definition),n.scrollbarButtonUp=new n("scrollbar-button-up",n.triangleUp.definition),n.scrollbarButtonDown=new n("scrollbar-button-down",n.triangleDown.definition),n.toolBarMore=new n("toolbar-more",n.more.definition),n.quickInputBack=new n("quick-input-back",n.arrowLeft.definition);var D;(function(k){k.iconNameSegment="[A-Za-z0-9]+",k.iconNameExpression="[A-Za-z0-9-]+",k.iconModifierExpression="~[A-Za-z]+",k.iconNameCharacter="[A-Za-z0-9~-]";const T=new RegExp(`^(${k.iconNameExpression})(${k.iconModifierExpression})?$`);function R(C){if(C instanceof n)return["codicon","codicon-"+C.id];const b=T.exec(C.id);if(!b)return R(n.error);const[,m,p]=b,h=["codicon","codicon-"+m];return p&&h.push("codicon-modifier-"+p.substring(1)),h}k.asClassNameArray=R;function P(C){return R(C).join(" ")}k.asClassName=P;function S(C){return"."+R(C).join(".")}k.asCSSSelector=S})(D=e.CSSIcon||(e.CSSIcon={}))}),define(re[63],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function A(T){return(R,P,S)=>{let C=null,b=null;if(typeof S.value=="function"?(C="value",b=S.value):typeof S.get=="function"&&(C="get",b=S.get),!b)throw new Error("not supported");S[C]=T(b,P)}}function n(T,R,P){let S=null,C=null;if(typeof P.value=="function"?(S="value",C=P.value,C.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof P.get=="function"&&(S="get",C=P.get),!C)throw new Error("not supported");const b=`$memoize$${R}`;P[S]=function(...m){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:C.apply(this,m)}),this[b]}}e.memoize=n;function D(T,R,P){return A((S,C)=>{const b=`$debounce$${C}`,m=`$debounce$result$${C}`;return function(...p){this[m]||(this[m]=P?P():void 0),clearTimeout(this[b]),R&&(this[m]=R(this[m],...p),p=[this[m]]),this[b]=setTimeout(()=>{S.apply(this,p),this[m]=P?P():void 0},T)}})}e.debounce=D;function k(T,R,P){return A((S,C)=>{const b=`$throttle$timer$${C}`,m=`$throttle$result$${C}`,p=`$throttle$lastRun$${C}`,h=`$throttle$pending$${C}`;return function(...y){if(this[m]||(this[m]=P?P():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),R&&(this[m]=R(this[m],...y)),this[h])return;const f=this[p]+T;f<=Date.now()?(this[p]=Date.now(),S.apply(this,[this[m]]),this[m]=P?P():void 0):(this[h]=!0,this[b]=setTimeout(()=>{this[h]=!1,this[p]=Date.now(),S.apply(this,[this[m]]),this[m]=P?P():void 0},f-Date.now()))}})}e.throttle=k}),define(re[7],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class A{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?g.isErrorNoTelemetry(i)?new g(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(r=>{r(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.ErrorHandler=A,e.errorHandler=new A;function n(I){e.errorHandler.setUnexpectedErrorHandler(I)}e.setUnexpectedErrorHandler=n;function D(I){P(I)||e.errorHandler.onUnexpectedError(I)}e.onUnexpectedError=D;function k(I){P(I)||e.errorHandler.onUnexpectedExternalError(I)}e.onUnexpectedExternalError=k;function T(I){if(I instanceof Error){const{name:i,message:r}=I,t=I.stacktrace||I.stack;return{$isError:!0,name:i,message:r,stack:t,noTelemetry:g.isErrorNoTelemetry(I)}}return I}e.transformErrorForSerialization=T;const R="Canceled";function P(I){return I instanceof S?!0:I instanceof Error&&I.name===R&&I.message===R}e.isCancellationError=P;class S extends Error{constructor(){super(R),this.name=this.message}}e.CancellationError=S;function C(){const I=new Error(R);return I.name=I.message,I}e.canceled=C;function b(I){return I?new Error(`Illegal argument: ${I}`):new Error("Illegal argument")}e.illegalArgument=b;function m(I){return I?new Error(`Illegal state: ${I}`):new Error("Illegal state")}e.illegalState=m;function p(I){return I?new Error(`readonly property '${I} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=p;function h(I){const i=new Error(`${I} has been disposed`);return i.name="DISPOSED",i}e.disposed=h;function y(I){return I?I.message?I.message:I.stack?I.stack.split(`
`)[0]:String(I):"Error"}e.getErrorMessage=y;class f extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.NotImplementedError=f;class l extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.NotSupportedError=l;class d extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=d;class g extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof g)return i;const r=new g;return r.message=i.message,r.stack=i.stack,r}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.ErrorNoTelemetry=g;class v extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,v.prototype);debugger}}e.BugIndicatingError=v}),define(re[21],ae([0,1,7]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function n(J,Z=0){return J[J.length-(1+Z)]}e.tail=n;function D(J){if(J.length===0)throw new Error("Invalid tail call");return[J.slice(0,J.length-1),J[J.length-1]]}e.tail2=D;function k(J,Z,se=(le,ue)=>le===ue){if(J===Z)return!0;if(!J||!Z||J.length!==Z.length)return!1;for(let le=0,ue=J.length;le<ue;le++)if(!se(J[le],Z[le]))return!1;return!0}e.equals=k;function T(J,Z){const se=J.length-1;Z<se&&(J[Z]=J[se]),J.pop()}e.removeFastWithoutKeepingOrder=T;function R(J,Z,se){return P(J.length,le=>se(J[le],Z))}e.binarySearch=R;function P(J,Z){let se=0,le=J-1;for(;se<=le;){const ue=(se+le)/2|0,pe=Z(ue);if(pe<0)se=ue+1;else if(pe>0)le=ue-1;else return ue}return-(se+1)}e.binarySearch2=P;function S(J,Z){let se=0,le=J.length;if(le===0)return 0;for(;se<le;){const ue=Math.floor((se+le)/2);Z(J[ue])?le=ue:se=ue+1}return se}e.findFirstInSorted=S;function C(J,Z,se){if(J=J|0,J>=Z.length)throw new TypeError("invalid index");const le=Z[Math.floor(Z.length*Math.random())],ue=[],pe=[],we=[];for(const be of Z){const Ee=se(be,le);Ee<0?ue.push(be):Ee>0?pe.push(be):we.push(be)}return J<ue.length?C(J,ue,se):J<ue.length+we.length?we[0]:C(J-(ue.length+we.length),pe,se)}e.quickSelect=C;function b(J,Z){const se=[];let le;for(const ue of J.slice(0).sort(Z))!le||Z(le[0],ue)!==0?(le=[ue],se.push(le)):le.push(ue);return se}e.groupBy=b;function m(J,Z,se){const le=[];function ue(be,Ee,Te){if(Ee===0&&Te.length===0)return;const Ue=le[le.length-1];Ue&&Ue.start+Ue.deleteCount===be?(Ue.deleteCount+=Ee,Ue.toInsert.push(...Te)):le.push({start:be,deleteCount:Ee,toInsert:Te})}let pe=0,we=0;for(;;){if(pe===J.length){ue(pe,0,Z.slice(we));break}if(we===Z.length){ue(pe,J.length-pe,[]);break}const be=J[pe],Ee=Z[we],Te=se(be,Ee);Te===0?(pe+=1,we+=1):Te<0?(ue(pe,1,[]),pe+=1):Te>0&&(ue(pe,0,[Ee]),we+=1)}return le}e.sortedDiff=m;function p(J,Z,se){const le=m(J,Z,se),ue=[],pe=[];for(const we of le)ue.push(...J.slice(we.start,we.start+we.deleteCount)),pe.push(...we.toInsert);return{removed:ue,added:pe}}e.delta=p;function h(J,Z,se){if(se===0)return[];const le=J.slice(0,se).sort(Z);return f(J,Z,le,se,J.length),le}e.top=h;function y(J,Z,se,le,ue){return se===0?Promise.resolve([]):new Promise((pe,we)=>{(async()=>{const be=J.length,Ee=J.slice(0,se).sort(Z);for(let Te=se,Ue=Math.min(se+le,be);Te<be;Te=Ue,Ue=Math.min(Ue+le,be)){if(Te>se&&await new Promise(Ye=>setTimeout(Ye)),ue&&ue.isCancellationRequested)throw new A.CancellationError;f(J,Z,Ee,Te,Ue)}return Ee})().then(pe,we)})}e.topAsync=y;function f(J,Z,se,le,ue){for(const pe=se.length;le<ue;le++){const we=J[le];if(Z(we,se[pe-1])<0){se.pop();const be=S(se,Ee=>Z(we,Ee)<0);se.splice(be,0,we)}}}function l(J){return J.filter(Z=>!!Z)}e.coalesce=l;function d(J){let Z=0;for(let se=0;se<J.length;se++)J[se]&&(J[Z]=J[se],Z+=1);J.length=Z}e.coalesceInPlace=d;function g(J,Z,se){J.splice(se,0,J.splice(Z,1)[0])}e.move=g;function v(J){return!Array.isArray(J)||J.length===0}e.isFalsyOrEmpty=v;function I(J){return Array.isArray(J)&&J.length>0}e.isNonEmptyArray=I;function i(J,Z=se=>se){const se=new Set;return J.filter(le=>{const ue=Z(le);return se.has(ue)?!1:(se.add(ue),!0)})}e.distinct=i;function r(J){const Z=new Set;return se=>{const le=J(se);return Z.has(le)?!1:(Z.add(le),!0)}}e.uniqueFilter=r;function t(J,Z){const se=s(J,Z);if(se!==-1)return J[se]}e.findLast=t;function s(J,Z){for(let se=J.length-1;se>=0;se--){const le=J[se];if(Z(le))return se}return-1}e.lastIndex=s;function o(J,Z){return J.length>0?J[0]:Z}e.firstOrDefault=o;function c(J,Z){return J.length>0?J[J.length-1]:Z}e.lastOrDefault=c;function a(J,Z,se=(le,ue)=>le===ue){let le=0;for(let ue=0,pe=Math.min(J.length,Z.length);ue<pe&&se(J[ue],Z[ue]);ue++)le++;return le}e.commonPrefixLength=a;function u(J){return[].concat(...J)}e.flatten=u;function w(J,Z){let se=typeof Z=="number"?J:0;typeof Z=="number"?se=J:(se=0,Z=J);const le=[];if(se<=Z)for(let ue=se;ue<Z;ue++)le.push(ue);else for(let ue=se;ue>Z;ue--)le.push(ue);return le}e.range=w;function E(J,Z,se){return J.reduce((le,ue)=>(le[Z(ue)]=se?se(ue):ue,le),Object.create(null))}e.index=E;function N(J,Z){return J.push(Z),()=>O(J,Z)}e.insert=N;function O(J,Z){const se=J.indexOf(Z);if(se>-1)return J.splice(se,1),Z}e.remove=O;function j(J,Z,se){const le=J.slice(0,Z),ue=J.slice(Z);return le.concat(se,ue)}e.arrayInsert=j;function M(J,Z){let se;if(typeof Z=="number"){let le=Z;se=()=>{const ue=Math.sin(le++)*179426549;return ue-Math.floor(ue)}}else se=Math.random;for(let le=J.length-1;le>0;le-=1){const ue=Math.floor(se()*(le+1)),pe=J[le];J[le]=J[ue],J[ue]=pe}}e.shuffle=M;function L(J,Z){const se=J.indexOf(Z);se>-1&&(J.splice(se,1),J.unshift(Z))}e.pushToStart=L;function F(J,Z){const se=J.indexOf(Z);se>-1&&(J.splice(se,1),J.push(Z))}e.pushToEnd=F;function z(J,Z){for(const se of Z)J.push(se)}e.pushMany=z;function H(J,Z){return Array.isArray(J)?J.map(Z):Z(J)}e.mapArrayOrNot=H;function Q(J){return Array.isArray(J)?J:[J]}e.asArray=Q;function K(J){return J[Math.floor(Math.random()*J.length)]}e.getRandomElement=K;function V(J,Z){for(const se of J){const le=Z(se);if(le!==void 0)return le}}e.mapFind=V;function W(J,Z,se){const le=X(J,Z),ue=J.length,pe=se.length;J.length=ue+pe;for(let we=ue-1;we>=le;we--)J[we+pe]=J[we];for(let we=0;we<pe;we++)J[we+le]=se[we]}e.insertInto=W;function G(J,Z,se,le){const ue=X(J,Z),pe=J.splice(ue,se);return W(J,ue,le),pe}e.splice=G;function X(J,Z){return Z<0?Math.max(Z+J.length,0):Math.min(Z,J.length)}var ie;(function(J){function Z(ue){return ue<0}J.isLessThan=Z;function se(ue){return ue>0}J.isGreaterThan=se;function le(ue){return ue===0}J.isNeitherLessOrGreaterThan=le,J.greaterThan=1,J.lessThan=-1,J.neitherLessOrGreaterThan=0})(ie=e.CompareResult||(e.CompareResult={}));function oe(J,Z){return(se,le)=>Z(J(se),J(le))}e.compareBy=oe;function te(...J){return(Z,se)=>{for(const le of J){const ue=le(Z,se);if(!ie.isNeitherLessOrGreaterThan(ue))return ue}return ie.neitherLessOrGreaterThan}}e.tieBreakComparators=te;const U=(J,Z)=>J-Z;e.numberComparator=U;function $(J,Z){if(J.length===0)return;let se=J[0];for(let le=1;le<J.length;le++){const ue=J[le];Z(ue,se)>0&&(se=ue)}return se}e.findMaxBy=$;function q(J,Z){if(J.length===0)return;let se=J[0];for(let le=1;le<J.length;le++){const ue=J[le];Z(ue,se)>=0&&(se=ue)}return se}e.findLastMaxBy=q;function B(J,Z){return $(J,(se,le)=>-Z(se,le))}e.findMinBy=B;class x{constructor(Z){this.f=Z,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(Z){let se=this.c;for(;se<this.f.length&&Z(this.f[se]);)se++;const le=se===this.c?null:this.f.slice(this.c,se);return this.c=se,le}takeFromEndWhile(Z){let se=this.d;for(;se>=0&&Z(this.f[se]);)se--;const le=se===this.d?null:this.f.slice(se+1,this.d+1);return this.d=se,le}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const Z=this.f[this.c];return this.c++,Z}removeLast(){const Z=this.f[this.d];return this.d--,Z}takeCount(Z){const se=this.f.slice(this.c,this.c+Z);return this.c+=Z,se}}e.ArrayQueue=x;class ee{constructor(Z){this.iterate=Z}forEach(Z){this.iterate(se=>(Z(se),!0))}toArray(){const Z=[];return this.iterate(se=>(Z.push(se),!0)),Z}filter(Z){return new ee(se=>this.iterate(le=>Z(le)?se(le):!0))}map(Z){return new ee(se=>this.iterate(le=>se(Z(le))))}some(Z){let se=!1;return this.iterate(le=>(se=Z(le),!se)),se}findFirst(Z){let se;return this.iterate(le=>Z(le)?(se=le,!1):!0),se}findLast(Z){let se;return this.iterate(le=>(Z(le)&&(se=le),!0)),se}findLastMaxBy(Z){let se,le=!0;return this.iterate(ue=>((le||ie.isGreaterThan(Z(ue,se)))&&(le=!1,se=ue),!0)),se}}e.CallbackIterable=ee,ee.empty=new ee(J=>{})}),define(re[128],ae([0,1,7]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function n(P,S){if(!P)throw new Error(S?`Assertion failed (${S})`:"Assertion Failed")}e.ok=n;function D(P,S="Unreachable"){throw new Error(S)}e.assertNever=D;function k(P){if(!P)throw new A.BugIndicatingError("Assertion Failed")}e.assert=k;function T(P){if(!P()){debugger;P(),(0,A.onUnexpectedError)(new A.BugIndicatingError("Assertion Failed"))}}e.assertFn=T;function R(P,S){let C=0;for(;C<P.length-1;){const b=P[C],m=P[C+1];if(!S(b,m))return!1;C++}return!0}e.checkAdjacentItems=R}),define(re[82],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function A(n){const D=this;let k=!1,T;return function(){return k||(k=!0,T=n.apply(D,arguments)),T}}e.once=A}),define(re[64],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var A;(function(n){function D(v){return v&&typeof v=="object"&&typeof v[Symbol.iterator]=="function"}n.is=D;const k=Object.freeze([]);function T(){return k}n.empty=T;function*R(v){yield v}n.single=R;function P(v){return D(v)?v:R(v)}n.wrap=P;function S(v){return v||k}n.from=S;function C(v){return!v||v[Symbol.iterator]().next().done===!0}n.isEmpty=C;function b(v){return v[Symbol.iterator]().next().value}n.first=b;function m(v,I){for(const i of v)if(I(i))return!0;return!1}n.some=m;function p(v,I){for(const i of v)if(I(i))return i}n.find=p;function*h(v,I){for(const i of v)I(i)&&(yield i)}n.filter=h;function*y(v,I){let i=0;for(const r of v)yield I(r,i++)}n.map=y;function*f(...v){for(const I of v)for(const i of I)yield i}n.concat=f;function l(v,I,i){let r=i;for(const t of v)r=I(r,t);return r}n.reduce=l;function*d(v,I,i=v.length){for(I<0&&(I+=v.length),i<0?i+=v.length:i>v.length&&(i=v.length);I<i;I++)yield v[I]}n.slice=d;function g(v,I=Number.POSITIVE_INFINITY){const i=[];if(I===0)return[i,v];const r=v[Symbol.iterator]();for(let t=0;t<I;t++){const s=r.next();if(s.done)return[i,n.empty()];i.push(s.value)}return[i,{[Symbol.iterator](){return r}}]}n.consume=g})(A=e.Iterable||(e.Iterable={}))}),define(re[35],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var A;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(A=e.ScanError||(e.ScanError={}));var n;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(n=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var k;(function(i){i.DEFAULT={allowTrailingComma:!0}})(k=e.ParseOptions||(e.ParseOptions={}));function T(i,r=!1){let t=0;const s=i.length;let o="",c=0,a=16,u=0;function w(F){let z=0,H=0;for(;z<F;){const Q=i.charCodeAt(t);if(Q>=48&&Q<=57)H=H*16+Q-48;else if(Q>=65&&Q<=70)H=H*16+Q-65+10;else if(Q>=97&&Q<=102)H=H*16+Q-97+10;else break;t++,z++}return z<F&&(H=-1),H}function E(F){t=F,o="",c=0,a=16,u=0}function N(){const F=t;if(i.charCodeAt(t)===48)t++;else for(t++;t<i.length&&S(i.charCodeAt(t));)t++;if(t<i.length&&i.charCodeAt(t)===46)if(t++,t<i.length&&S(i.charCodeAt(t)))for(t++;t<i.length&&S(i.charCodeAt(t));)t++;else return u=3,i.substring(F,t);let z=t;if(t<i.length&&(i.charCodeAt(t)===69||i.charCodeAt(t)===101))if(t++,(t<i.length&&i.charCodeAt(t)===43||i.charCodeAt(t)===45)&&t++,t<i.length&&S(i.charCodeAt(t))){for(t++;t<i.length&&S(i.charCodeAt(t));)t++;z=t}else u=3;return i.substring(F,z)}function O(){let F="",z=t;for(;;){if(t>=s){F+=i.substring(z,t),u=2;break}const H=i.charCodeAt(t);if(H===34){F+=i.substring(z,t),t++;break}if(H===92){if(F+=i.substring(z,t),t++,t>=s){u=2;break}switch(i.charCodeAt(t++)){case 34:F+='"';break;case 92:F+="\\";break;case 47:F+="/";break;case 98:F+="\b";break;case 102:F+="\f";break;case 110:F+=`
`;break;case 114:F+="\r";break;case 116:F+="	";break;case 117:{const K=w(4);K>=0?F+=String.fromCharCode(K):u=4;break}default:u=5}z=t;continue}if(H>=0&&H<=31)if(P(H)){F+=i.substring(z,t),u=2;break}else u=6;t++}return F}function j(){if(o="",u=0,c=t,t>=s)return c=s,a=17;let F=i.charCodeAt(t);if(R(F)){do t++,o+=String.fromCharCode(F),F=i.charCodeAt(t);while(R(F));return a=15}if(P(F))return t++,o+=String.fromCharCode(F),F===13&&i.charCodeAt(t)===10&&(t++,o+=`
`),a=14;switch(F){case 123:return t++,a=1;case 125:return t++,a=2;case 91:return t++,a=3;case 93:return t++,a=4;case 58:return t++,a=6;case 44:return t++,a=5;case 34:return t++,o=O(),a=10;case 47:{const z=t-1;if(i.charCodeAt(t+1)===47){for(t+=2;t<s&&!P(i.charCodeAt(t));)t++;return o=i.substring(z,t),a=12}if(i.charCodeAt(t+1)===42){t+=2;const H=s-1;let Q=!1;for(;t<H;){if(i.charCodeAt(t)===42&&i.charCodeAt(t+1)===47){t+=2,Q=!0;break}t++}return Q||(t++,u=1),o=i.substring(z,t),a=13}return o+=String.fromCharCode(F),t++,a=16}case 45:if(o+=String.fromCharCode(F),t++,t===s||!S(i.charCodeAt(t)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=N(),a=11;default:for(;t<s&&M(F);)t++,F=i.charCodeAt(t);if(c!==t){switch(o=i.substring(c,t),o){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return o+=String.fromCharCode(F),t++,a=16}}function M(F){if(R(F)||P(F))return!1;switch(F){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function L(){let F;do F=j();while(F>=12&&F<=15);return F}return{setPosition:E,getPosition:()=>t,scan:r?L:j,getToken:()=>a,getTokenValue:()=>o,getTokenOffset:()=>c,getTokenLength:()=>t-c,getTokenError:()=>u}}e.createScanner=T;function R(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function P(i){return i===10||i===13||i===8232||i===8233}function S(i){return i>=48&&i<=57}var C;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(C||(C={}));function b(i,r){const t=[],s=new Object;let o;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function u(w,E,N,O){c.value=w,c.offset=E,c.length=N,c.type=O,c.colonOffset=void 0,o=c}try{g(i,{onObjectBegin:(w,E)=>{if(r<=w)throw s;o=void 0,a=r>w,t.push("")},onObjectProperty:(w,E,N)=>{if(r<E||(u(w,E,N,"property"),t[t.length-1]=w,r<=E+N))throw s},onObjectEnd:(w,E)=>{if(r<=w)throw s;o=void 0,t.pop()},onArrayBegin:(w,E)=>{if(r<=w)throw s;o=void 0,t.push(0)},onArrayEnd:(w,E)=>{if(r<=w)throw s;o=void 0,t.pop()},onLiteralValue:(w,E,N)=>{if(r<E||(u(w,E,N,I(w)),r<=E+N))throw s},onSeparator:(w,E,N)=>{if(r<=E)throw s;if(w===":"&&o&&o.type==="property")o.colonOffset=E,a=!1,o=void 0;else if(w===","){const O=t[t.length-1];typeof O=="number"?t[t.length-1]=O+1:(a=!0,t[t.length-1]=""),o=void 0}}})}catch(w){if(w!==s)throw w}return{path:t,previousNode:o,isAtPropertyKey:a,matches:w=>{let E=0;for(let N=0;E<w.length&&N<t.length;N++)if(w[E]===t[N]||w[E]==="*")E++;else if(w[E]!=="**")return!1;return E===w.length}}}e.getLocation=b;function m(i,r=[],t=k.DEFAULT){let s=null,o=[];const c=[];function a(w){Array.isArray(o)?o.push(w):s!==null&&(o[s]=w)}return g(i,{onObjectBegin:()=>{const w={};a(w),c.push(o),o=w,s=null},onObjectProperty:w=>{s=w},onObjectEnd:()=>{o=c.pop()},onArrayBegin:()=>{const w=[];a(w),c.push(o),o=w,s=null},onArrayEnd:()=>{o=c.pop()},onLiteralValue:a,onError:(w,E,N)=>{r.push({error:w,offset:E,length:N})}},t),o[0]}e.parse=m;function p(i,r=[],t=k.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(w){s.type==="property"&&(s.length=w-s.offset,s=s.parent)}function c(w){return s.children.push(w),w}g(i,{onObjectBegin:w=>{s=c({type:"object",offset:w,length:-1,parent:s,children:[]})},onObjectProperty:(w,E,N)=>{s=c({type:"property",offset:E,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:w,offset:E,length:N,parent:s})},onObjectEnd:(w,E)=>{s.length=w+E-s.offset,s=s.parent,o(w+E)},onArrayBegin:(w,E)=>{s=c({type:"array",offset:w,length:-1,parent:s,children:[]})},onArrayEnd:(w,E)=>{s.length=w+E-s.offset,s=s.parent,o(w+E)},onLiteralValue:(w,E,N)=>{c({type:I(w),offset:E,length:N,parent:s,value:w}),o(E+N)},onSeparator:(w,E,N)=>{s.type==="property"&&(w===":"?s.colonOffset=E:w===","&&o(E))},onError:(w,E,N)=>{r.push({error:w,offset:E,length:N})}},t);const u=s.children[0];return u&&delete u.parent,u}e.parseTree=p;function h(i,r){if(!i)return;let t=i;for(const s of r)if(typeof s=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let o=!1;for(const c of t.children)if(Array.isArray(c.children)&&c.children[0].value===s){t=c.children[1],o=!0;break}if(!o)return}else{const o=s;if(t.type!=="array"||o<0||!Array.isArray(t.children)||o>=t.children.length)return;t=t.children[o]}return t}e.findNodeAtLocation=h;function y(i){if(!i.parent||!i.parent.children)return[];const r=y(i.parent);if(i.parent.type==="property"){const t=i.parent.children[0].value;r.push(t)}else if(i.parent.type==="array"){const t=i.parent.children.indexOf(i);t!==-1&&r.push(t)}return r}e.getNodePath=y;function f(i){switch(i.type){case"array":return i.children.map(f);case"object":{const r=Object.create(null);for(const t of i.children){const s=t.children[1];s&&(r[t.children[0].value]=f(s))}return r}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=f;function l(i,r,t=!1){return r>=i.offset&&r<i.offset+i.length||t&&r===i.offset+i.length}e.contains=l;function d(i,r,t=!1){if(l(i,r,t)){const s=i.children;if(Array.isArray(s))for(let o=0;o<s.length&&s[o].offset<=r;o++){const c=d(s[o],r,t);if(c)return c}return i}}e.findNodeAtOffset=d;function g(i,r,t=k.DEFAULT){const s=T(i,!1);function o(oe){return oe?()=>oe(s.getTokenOffset(),s.getTokenLength()):()=>!0}function c(oe){return oe?te=>oe(te,s.getTokenOffset(),s.getTokenLength()):()=>!0}const a=o(r.onObjectBegin),u=c(r.onObjectProperty),w=o(r.onObjectEnd),E=o(r.onArrayBegin),N=o(r.onArrayEnd),O=c(r.onLiteralValue),j=c(r.onSeparator),M=o(r.onComment),L=c(r.onError),F=t&&t.disallowComments,z=t&&t.allowTrailingComma;function H(){for(;;){const oe=s.scan();switch(s.getTokenError()){case 4:Q(14);break;case 5:Q(15);break;case 3:Q(13);break;case 1:F||Q(11);break;case 2:Q(12);break;case 6:Q(16);break}switch(oe){case 12:case 13:F?Q(10):M();break;case 16:Q(1);break;case 15:case 14:break;default:return oe}}}function Q(oe,te=[],U=[]){if(L(oe),te.length+U.length>0){let $=s.getToken();for(;$!==17;){if(te.indexOf($)!==-1){H();break}else if(U.indexOf($)!==-1)break;$=H()}}}function K(oe){const te=s.getTokenValue();return oe?O(te):u(te),H(),!0}function V(){switch(s.getToken()){case 11:{let oe=0;try{oe=JSON.parse(s.getTokenValue()),typeof oe!="number"&&(Q(2),oe=0)}catch{Q(2)}O(oe);break}case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return H(),!0}function W(){return s.getToken()!==10?(Q(3,[],[2,5]),!1):(K(!1),s.getToken()===6?(j(":"),H(),ie()||Q(4,[],[2,5])):Q(5,[],[2,5]),!0)}function G(){a(),H();let oe=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(oe||Q(4,[],[]),j(","),H(),s.getToken()===2&&z)break}else oe&&Q(6,[],[]);W()||Q(4,[],[2,5]),oe=!0}return w(),s.getToken()!==2?Q(7,[2],[]):H(),!0}function X(){E(),H();let oe=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(oe||Q(4,[],[]),j(","),H(),s.getToken()===4&&z)break}else oe&&Q(6,[],[]);ie()||Q(4,[],[4,5]),oe=!0}return N(),s.getToken()!==4?Q(8,[4],[]):H(),!0}function ie(){switch(s.getToken()){case 3:return X();case 1:return G();case 10:return K(!0);default:return V()}}return H(),s.getToken()===17?t.allowEmptyContent?!0:(Q(4,[],[]),!1):ie()?(s.getToken()!==17&&Q(9,[],[]),!0):(Q(4,[],[]),!1)}e.visit=g;function v(i,r){const t=T(i),s=[];let o,c=0,a;do switch(a=t.getPosition(),o=t.scan(),o){case 12:case 13:case 17:c!==a&&s.push(i.substring(c,a)),r!==void 0&&s.push(t.getTokenValue().replace(/[^\r\n]/g,r)),c=t.getPosition();break}while(o!==17);return s.join("")}e.stripComments=v;function I(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=I}),define(re[43],ae([0,1,35]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function n(S,C,b){let m,p,h,y,f;if(C){for(y=C.offset,f=y+C.length,h=y;h>0&&!P(S,h-1);)h--;let a=f;for(;a<S.length&&!P(S,a);)a++;p=S.substring(h,a),m=T(p,b)}else p=S,m=0,h=0,y=0,f=S.length;const l=R(b,S);let d=!1,g=0,v;b.insertSpaces?v=k(" ",b.tabSize||4):v="	";const I=(0,A.createScanner)(p,!1);let i=!1;function r(){return l+k(v,m+g)}function t(){let a=I.scan();for(d=!1;a===15||a===14;)d=d||a===14,a=I.scan();return i=a===16||I.getTokenError()!==0,a}const s=[];function o(a,u,w){!i&&u<f&&w>y&&S.substring(u,w)!==a&&s.push({offset:u,length:w-u,content:a})}let c=t();if(c!==17){const a=I.getTokenOffset()+h,u=k(v,m);o(u,h,a)}for(;c!==17;){let a=I.getTokenOffset()+I.getTokenLength()+h,u=t(),w="";for(;!d&&(u===12||u===13);){const N=I.getTokenOffset()+h;o(" ",a,N),a=I.getTokenOffset()+I.getTokenLength()+h,w=u===12?r():"",u=t()}if(u===2)c!==1&&(g--,w=r());else if(u===4)c!==3&&(g--,w=r());else{switch(c){case 3:case 1:g++,w=r();break;case 5:case 12:w=r();break;case 13:d?w=r():w=" ";break;case 6:w=" ";break;case 10:if(u===6){w="";break}case 7:case 8:case 9:case 11:case 2:case 4:u===12||u===13?w=" ":u!==5&&u!==17&&(i=!0);break;case 16:i=!0;break}d&&(u===12||u===13)&&(w=r())}const E=I.getTokenOffset()+h;o(w,a,E),c=u}return s}e.format=n;function D(S,C){const b=JSON.stringify(S,void 0,C.insertSpaces?C.tabSize||4:"	");return C.eol!==void 0?b.replace(/\r\n|\r|\n/g,C.eol):b}e.toFormattedString=D;function k(S,C){let b="";for(let m=0;m<C;m++)b+=S;return b}function T(S,C){let b=0,m=0;const p=C.tabSize||4;for(;b<S.length;){const h=S.charAt(b);if(h===" ")m++;else if(h==="	")m+=p;else break;b++}return Math.floor(m/p)}function R(S,C){for(let b=0;b<C.length;b++){const m=C.charAt(b);if(m==="\r")return b+1<C.length&&C.charAt(b+1)===`
`?`\r
`:"\r";if(m===`
`)return`
`}return S&&S.eol||`
`}e.getEOL=R;function P(S,C){return`\r
`.indexOf(S.charAt(C))!==-1}e.isEOL=P}),define(re[83],ae([0,1,35,43]),function(_,e,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function D(S,C,b){return k(S,C,void 0,b)}e.removeProperty=D;function k(S,C,b,m,p){const h=C.slice(),y=[],f=(0,A.parseTree)(S,y);let l,d;for(;h.length>0&&(d=h.pop(),l=(0,A.findNodeAtLocation)(f,h),l===void 0&&b!==void 0);)typeof d=="string"?b={[d]:b}:b=[b];if(l)if(l.type==="object"&&typeof d=="string"&&Array.isArray(l.children)){const g=(0,A.findNodeAtLocation)(l,[d]);if(g!==void 0)if(b===void 0){if(!g.parent)throw new Error("Malformed AST");const v=l.children.indexOf(g.parent);let I,i=g.parent.offset+g.parent.length;if(v>0){const r=l.children[v-1];I=r.offset+r.length}else I=l.offset+1,l.children.length>1&&(i=l.children[1].offset);return T(S,{offset:I,length:i-I,content:""},m)}else return T(S,{offset:g.offset,length:g.length,content:JSON.stringify(b)},m);else{if(b===void 0)return[];const v=`${JSON.stringify(d)}: ${JSON.stringify(b)}`,I=p?p(l.children.map(r=>r.children[0].value)):l.children.length;let i;if(I>0){const r=l.children[I-1];i={offset:r.offset+r.length,length:0,content:","+v}}else l.children.length===0?i={offset:l.offset+1,length:0,content:v}:i={offset:l.offset+1,length:0,content:v+","};return T(S,i,m)}}else if(l.type==="array"&&typeof d=="number"&&Array.isArray(l.children))if(b!==void 0){const g=`${JSON.stringify(b)}`;let v;if(l.children.length===0||d===0)v={offset:l.offset+1,length:0,content:l.children.length===0?g:g+","};else{const I=d===-1||d>l.children.length?l.children.length:d,i=l.children[I-1];v={offset:i.offset+i.length,length:0,content:","+g}}return T(S,v,m)}else{const g=d,v=l.children[g];let I;if(l.children.length===1)I={offset:l.offset+1,length:l.length-2,content:""};else if(l.children.length-1===g){const i=l.children[g-1],r=i.offset+i.length,t=l.offset+l.length;I={offset:r,length:t-2-r,content:""}}else I={offset:v.offset,length:l.children[g+1].offset-v.offset,content:""};return T(S,I,m)}else throw new Error(`Can not add ${typeof d!="number"?"index":"property"} to parent of type ${l.type}`);else{if(b===void 0)throw new Error("Can not delete in empty document");return T(S,{offset:f?f.offset:0,length:f?f.length:0,content:JSON.stringify(b)},m)}}e.setProperty=k;function T(S,C,b){let m=R(S,C),p=C.offset,h=C.offset+C.content.length;if(C.length===0||C.content.length===0){for(;p>0&&!(0,n.isEOL)(m,p-1);)p--;for(;h<m.length&&!(0,n.isEOL)(m,h);)h++}const y=(0,n.format)(m,{offset:p,length:h-p},b);for(let l=y.length-1;l>=0;l--){const d=y[l];m=R(m,d),p=Math.min(p,d.offset),h=Math.max(h,d.offset+d.length),h+=d.content.length-d.length}const f=S.length-(m.length-h)-p;return[{offset:p,length:f,content:m.substring(p,h)}]}e.withFormatting=T;function R(S,C){return S.substring(0,C.offset)+C.content+S.substring(C.offset+C.length)}e.applyEdit=R;function P(S,C){const b=C.slice(0).sort((p,h)=>{const y=p.offset-h.offset;return y===0?p.length-h.length:y});let m=S.length;for(let p=b.length-1;p>=0;p--){const h=b[p];if(h.offset+h.length<=m)S=R(S,h);else throw new Error("Overlapping edit");m=h.offset}return S}e.applyEdits=P}),define(re[129],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class A{constructor(D){this.d=D,this.a=!1}hasValue(){return this.a}getValue(){if(!this.a)try{this.b=this.d()}catch(D){this.c=D}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}map(D){return new A(()=>D(this.getValue()))}}e.Lazy=A}),define(re[2],ae([0,1,82,64]),function(_,e,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let k=null;function T(c){k=c}if(e.setDisposableTracker=T,D){const c="__is_disposable_tracked__";T(new class{trackDisposable(a){const u=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[c]||console.log(u)},3e3)}setParent(a,u){if(a&&a!==d.None)try{a[c]=!0}catch{}}markAsDisposed(a){if(a&&a!==d.None)try{a[c]=!0}catch{}}markAsSingleton(a){}})}function R(c){return k?.trackDisposable(c),c}function P(c){k?.markAsDisposed(c)}function S(c,a){k?.setParent(c,a)}function C(c,a){if(!!k)for(const u of c)k.setParent(u,a)}function b(c){return k?.markAsSingleton(c),c}e.markAsSingleton=b;function m(c){return typeof c.dispose=="function"&&c.dispose.length===0}e.isDisposable=m;function p(c){if(n.Iterable.is(c)){const a=[];for(const u of c)if(u)try{u.dispose()}catch(w){a.push(w)}if(a.length===1)throw a[0];if(a.length>1)throw new AggregateError(a,"Encountered errors while disposing of store");return Array.isArray(c)?[]:c}else if(c)return c.dispose(),c}e.dispose=p;function h(c){for(const a of c)m(a)&&a.dispose();return[]}e.disposeIfDisposable=h;function y(...c){const a=f(()=>p(c));return C(c,a),a}e.combinedDisposable=y;function f(c){const a=R({dispose:(0,A.once)(()=>{P(a),c()})});return a}e.toDisposable=f;class l{constructor(){this.c=new Set,this.f=!1,R(this)}dispose(){this.f||(P(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{p(this.c)}finally{this.c.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return S(a,this),this.f?l.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(a),a}}e.DisposableStore=l,l.DISABLE_DISPOSED_WARNING=!1;class d{constructor(){this.q=new l,R(this),S(this.q,this)}dispose(){P(this),this.q.dispose()}B(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(a)}}e.Disposable=d,d.None=Object.freeze({dispose(){}});class g{constructor(){this.b=!1,R(this)}get value(){return this.b?void 0:this.a}set value(a){this.b||a===this.a||(this.a?.dispose(),a&&S(a,this),this.a=a)}clear(){this.value=void 0}dispose(){this.b=!0,P(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const a=this.a;return this.a=void 0,a&&S(a,null),a}}e.MutableDisposable=g;class v{constructor(a){this.b=a,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=v;class I{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,R(this)}set(a){let u=a;return this.unset=()=>u=void 0,this.isset=()=>u!==void 0,this.dispose=()=>{u&&(u(),u=void 0,P(this))},this}}e.SafeDisposable=I;class i{constructor(){this.a=new Map}acquire(a,...u){let w=this.a.get(a);w||(w={counter:0,object:this.b(a,...u)},this.a.set(a,w));const{object:E}=w,N=(0,A.once)(()=>{--w.counter===0&&(this.c(a,w.object),this.a.delete(a))});return w.counter++,{object:E,dispose:N}}}e.ReferenceCollection=i;class r{constructor(a){this.a=a}async acquire(a,...u){const w=this.a.acquire(a,...u);try{return{object:await w.object,dispose:()=>w.dispose()}}catch(E){throw w.dispose(),E}}}e.AsyncReferenceCollection=r;class t{constructor(a){this.object=a}dispose(){}}e.ImmortalReference=t;function s(c){const a=new l;try{c(a)}finally{a.dispose()}}e.disposeOnReturn=s;class o{constructor(){this.a=new Map,this.b=!1,R(this)}dispose(){P(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{p(this.a.values())}finally{this.a.clear()}}has(a){return this.a.has(a)}get(a){return this.a.get(a)}set(a,u,w=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),w||this.a.get(a)?.dispose(),this.a.set(a,u)}deleteAndDispose(a){this.a.get(a)?.dispose(),this.a.delete(a)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=o}),define(re[84],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class A{constructor(k){this.element=k,this.next=A.Undefined,this.prev=A.Undefined}}A.Undefined=new A(void 0);class n{constructor(){this.a=A.Undefined,this.b=A.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===A.Undefined}clear(){let k=this.a;for(;k!==A.Undefined;){const T=k.next;k.prev=A.Undefined,k.next=A.Undefined,k=T}this.a=A.Undefined,this.b=A.Undefined,this.c=0}unshift(k){return this.d(k,!1)}push(k){return this.d(k,!0)}d(k,T){const R=new A(k);if(this.a===A.Undefined)this.a=R,this.b=R;else if(T){const S=this.b;this.b=R,R.prev=S,S.next=R}else{const S=this.a;this.a=R,R.next=S,S.prev=R}this.c+=1;let P=!1;return()=>{P||(P=!0,this.e(R))}}shift(){if(this.a!==A.Undefined){const k=this.a.element;return this.e(this.a),k}}pop(){if(this.b!==A.Undefined){const k=this.b.element;return this.e(this.b),k}}e(k){if(k.prev!==A.Undefined&&k.next!==A.Undefined){const T=k.prev;T.next=k.next,k.next.prev=T}else k.prev===A.Undefined&&k.next===A.Undefined?(this.a=A.Undefined,this.b=A.Undefined):k.next===A.Undefined?(this.b=this.b.prev,this.b.next=A.Undefined):k.prev===A.Undefined&&(this.a=this.a.next,this.a.prev=A.Undefined);this.c-=1}*[Symbol.iterator](){let k=this.a;for(;k!==A.Undefined;)yield k.element,k=k.next}}e.LinkedList=n}),define(re[37],ae([0,1]),function(_,e){"use strict";var A,n,D;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function k(h,y,f){let l=h.get(y);return l===void 0&&(l=f,h.set(y,l)),l}e.getOrSet=k;function T(h){const y=[];return h.forEach((f,l)=>{y.push(`${l} => ${f}`)}),`Map(${h.size}) {${y.join(", ")}}`}e.mapToString=T;function R(h){const y=[];return h.forEach(f=>{y.push(f)}),`Set(${h.size}) {${y.join(", ")}}`}e.setToString=R;class P{constructor(y,f){this.uri=y,this.value=f}}class S{constructor(y,f){this[A]="ResourceMap",y instanceof S?(this.b=new Map(y.b),this.c=f??S.a):(this.b=new Map,this.c=y??S.a)}set(y,f){return this.b.set(this.c(y),new P(y,f)),this}get(y){return this.b.get(this.c(y))?.value}has(y){return this.b.has(this.c(y))}get size(){return this.b.size}clear(){this.b.clear()}delete(y){return this.b.delete(this.c(y))}forEach(y,f){typeof f<"u"&&(y=y.bind(f));for(const[l,d]of this.b)y(d.value,d.uri,this)}*values(){for(const y of this.b.values())yield y.value}*keys(){for(const y of this.b.values())yield y.uri}*entries(){for(const y of this.b.values())yield[y.uri,y.value]}*[(A=Symbol.toStringTag,Symbol.iterator)](){for(const[,y]of this.b)yield[y.uri,y.value]}}e.ResourceMap=S,S.a=h=>h.toString();class C{constructor(y,f){this[n]="ResourceSet",!y||typeof y=="function"?this.a=new S(y):(this.a=new S(f),y.forEach(this.add,this))}get size(){return this.a.size}add(y){return this.a.set(y,y),this}clear(){this.a.clear()}delete(y){return this.a.delete(y)}forEach(y,f){this.a.forEach((l,d)=>y.call(f,d,d,this))}has(y){return this.a.has(y)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=C;var b;(function(h){h[h.None=0]="None",h[h.AsOld=1]="AsOld",h[h.AsNew=2]="AsNew"})(b=e.Touch||(e.Touch={}));class m{constructor(){this[D]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(y){return this.a.has(y)}get(y,f=0){const l=this.a.get(y);if(!!l)return f!==0&&this.j(l,f),l.value}set(y,f,l=0){let d=this.a.get(y);if(d)d.value=f,l!==0&&this.j(d,l);else{switch(d={key:y,value:f,next:void 0,previous:void 0},l){case 0:this.h(d);break;case 1:this.g(d);break;case 2:this.h(d);break;default:this.h(d);break}this.a.set(y,d),this.d++}return this}delete(y){return!!this.remove(y)}remove(y){const f=this.a.get(y);if(!!f)return this.a.delete(y),this.i(f),this.d--,f.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const y=this.b;return this.a.delete(y.key),this.i(y),this.d--,y.value}forEach(y,f){const l=this.e;let d=this.b;for(;d;){if(f?y.bind(f)(d.value,d.key,this):y(d.value,d.key,this),this.e!==l)throw new Error("LinkedMap got modified during iteration.");d=d.next}}keys(){const y=this,f=this.e;let l=this.b;const d={[Symbol.iterator](){return d},next(){if(y.e!==f)throw new Error("LinkedMap got modified during iteration.");if(l){const g={value:l.key,done:!1};return l=l.next,g}else return{value:void 0,done:!0}}};return d}values(){const y=this,f=this.e;let l=this.b;const d={[Symbol.iterator](){return d},next(){if(y.e!==f)throw new Error("LinkedMap got modified during iteration.");if(l){const g={value:l.value,done:!1};return l=l.next,g}else return{value:void 0,done:!0}}};return d}entries(){const y=this,f=this.e;let l=this.b;const d={[Symbol.iterator](){return d},next(){if(y.e!==f)throw new Error("LinkedMap got modified during iteration.");if(l){const g={value:[l.key,l.value],done:!1};return l=l.next,g}else return{value:void 0,done:!0}}};return d}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(y){if(y>=this.size)return;if(y===0){this.clear();return}let f=this.b,l=this.size;for(;f&&l>y;)this.a.delete(f.key),f=f.next,l--;this.b=f,this.d=l,f&&(f.previous=void 0),this.e++}g(y){if(!this.b&&!this.c)this.c=y;else if(this.b)y.next=this.b,this.b.previous=y;else throw new Error("Invalid list");this.b=y,this.e++}h(y){if(!this.b&&!this.c)this.b=y;else if(this.c)y.previous=this.c,this.c.next=y;else throw new Error("Invalid list");this.c=y,this.e++}i(y){if(y===this.b&&y===this.c)this.b=void 0,this.c=void 0;else if(y===this.b){if(!y.next)throw new Error("Invalid list");y.next.previous=void 0,this.b=y.next}else if(y===this.c){if(!y.previous)throw new Error("Invalid list");y.previous.next=void 0,this.c=y.previous}else{const f=y.next,l=y.previous;if(!f||!l)throw new Error("Invalid list");f.previous=l,l.next=f}y.next=void 0,y.previous=void 0,this.e++}j(y,f){if(!this.b||!this.c)throw new Error("Invalid list");if(!(f!==1&&f!==2)){if(f===1){if(y===this.b)return;const l=y.next,d=y.previous;y===this.c?(d.next=void 0,this.c=d):(l.previous=d,d.next=l),y.previous=void 0,y.next=this.b,this.b.previous=y,this.b=y,this.e++}else if(f===2){if(y===this.c)return;const l=y.next,d=y.previous;y===this.b?(l.previous=void 0,this.b=l):(l.previous=d,d.next=l),y.next=void 0,y.previous=this.c,this.c.next=y,this.c=y,this.e++}}}toJSON(){const y=[];return this.forEach((f,l)=>{y.push([l,f])}),y}fromJSON(y){this.clear();for(const[f,l]of y)this.set(f,l)}}e.LinkedMap=m;class p extends m{constructor(y,f=1){super(),this.k=y,this.l=Math.min(Math.max(0,f),1)}get limit(){return this.k}set limit(y){this.k=y,this.m()}get ratio(){return this.l}set ratio(y){this.l=Math.min(Math.max(0,y),1),this.m()}get(y,f=2){return super.get(y,f)}peek(y){return super.get(y,0)}set(y,f){return super.set(y,f,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=p}),define(re[85],ae([0,1,37]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const n=new A.LRUCache(1e4);function D(S){return P(S,"NFC",n)}e.normalizeNFC=D;const k=new A.LRUCache(1e4);function T(S){return P(S,"NFD",k)}e.normalizeNFD=T;const R=/[^\u0000-\u0080]/;function P(S,C,b){if(!S)return S;const m=b.get(S);if(m)return m;let p;return R.test(S)?p=S.normalize(C):p=S,b.set(S,p),p}e.removeAccents=function(){const S=/[\u0300-\u036f]/g;return function(C){return T(C).replace(S,"")}}()}),define(re[130],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function A(R,P,S){return Math.min(Math.max(R,P),S)}e.clamp=A;function n(R,P){return(P+R%P)%P}e.rot=n;class D{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=D;class k{constructor(){this.a=1,this.b=0}update(P){return this.b=this.b+(P-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=k;class T{constructor(P){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(P),this.c.fill(0,0,P)}update(P){const S=this.c[this.d];return this.c[this.d]=P,this.d=(this.d+1)%this.c.length,this.e-=S,this.e+=P,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=T}),function(){function _(D){const k=[];typeof D=="number"&&k.push("code/timeOrigin",D);function T(P){k.push(P,Date.now())}function R(){const P=[];for(let S=0;S<k.length;S+=2)P.push({name:k[S],startTime:k[S+1]});return P}return{mark:T,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?_():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const k=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const T of performance.getEntriesByType("mark"))k.push({name:T.name,startTime:Math.round(D+T.startTime)});return k}};if(typeof process=="object"){const D=Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return _(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),_()}function A(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var n;typeof global=="object"?n=global:typeof self=="object"?n=self:n={},typeof define=="function"?define("vs/base/common/performance",[],function(){return A(n)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=A(n):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),n.perf=A(n))}(),function(_,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var A=e();for(var n in A)(typeof exports=="object"?exports:_)[n]=A[n]}}(typeof self<"u"?self:this,function(){return function(_){var e={};function A(n){if(e[n])return e[n].exports;var D=e[n]={i:n,l:!1,exports:{}};return _[n].call(D.exports,D,D.exports,A),D.l=!0,D.exports}return A.m=_,A.c=e,A.d=function(n,D,k){A.o(n,D)||Object.defineProperty(n,D,{enumerable:!0,get:k})},A.r=function(n){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(n,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(n,"__esModule",{value:!0})},A.t=function(n,D){if(1&D&&(n=A(n)),8&D||4&D&&typeof n=="object"&&n&&n.__esModule)return n;var k=Object.create(null);if(A.r(k),Object.defineProperty(k,"default",{enumerable:!0,value:n}),2&D&&typeof n!="string")for(var T in n)A.d(k,T,function(R){return n[R]}.bind(null,T));return k},A.n=function(n){var D=n&&n.__esModule?function(){return n.default}:function(){return n};return A.d(D,"a",D),D},A.o=function(n,D){return Object.prototype.hasOwnProperty.call(n,D)},A.p="",A(A.s=0)}([function(_,e,A){(function(n){var D;e=_.exports=U,D=typeof n=="object"&&n.env&&n.env.NODE_DEBUG&&/\bsemver\b/i.test(n.env.NODE_DEBUG)?function(){var ce=Array.prototype.slice.call(arguments,0);ce.unshift("SEMVER"),console.log.apply(console,ce)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var k=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],P=e.src=[],S=0,C=S++;P[C]="0|[1-9]\\d*";var b=S++;P[b]="[0-9]+";var m=S++;P[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=S++;P[p]="("+P[C]+")\\.("+P[C]+")\\.("+P[C]+")";var h=S++;P[h]="("+P[b]+")\\.("+P[b]+")\\.("+P[b]+")";var y=S++;P[y]="(?:"+P[C]+"|"+P[m]+")";var f=S++;P[f]="(?:"+P[b]+"|"+P[m]+")";var l=S++;P[l]="(?:-("+P[y]+"(?:\\."+P[y]+")*))";var d=S++;P[d]="(?:-?("+P[f]+"(?:\\."+P[f]+")*))";var g=S++;P[g]="[0-9A-Za-z-]+";var v=S++;P[v]="(?:\\+("+P[g]+"(?:\\."+P[g]+")*))";var I=S++,i="v?"+P[p]+P[l]+"?"+P[v]+"?";P[I]="^"+i+"$";var r="[v=\\s]*"+P[h]+P[d]+"?"+P[v]+"?",t=S++;P[t]="^"+r+"$";var s=S++;P[s]="((?:<|>)?=?)";var o=S++;P[o]=P[b]+"|x|X|\\*";var c=S++;P[c]=P[C]+"|x|X|\\*";var a=S++;P[a]="[v=\\s]*("+P[c]+")(?:\\.("+P[c]+")(?:\\.("+P[c]+")(?:"+P[l]+")?"+P[v]+"?)?)?";var u=S++;P[u]="[v=\\s]*("+P[o]+")(?:\\.("+P[o]+")(?:\\.("+P[o]+")(?:"+P[d]+")?"+P[v]+"?)?)?";var w=S++;P[w]="^"+P[s]+"\\s*"+P[a]+"$";var E=S++;P[E]="^"+P[s]+"\\s*"+P[u]+"$";var N=S++;P[N]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=S++;P[O]="(?:~>?)";var j=S++;P[j]="(\\s*)"+P[O]+"\\s+",R[j]=new RegExp(P[j],"g");var M=S++;P[M]="^"+P[O]+P[a]+"$";var L=S++;P[L]="^"+P[O]+P[u]+"$";var F=S++;P[F]="(?:\\^)";var z=S++;P[z]="(\\s*)"+P[F]+"\\s+",R[z]=new RegExp(P[z],"g");var H=S++;P[H]="^"+P[F]+P[a]+"$";var Q=S++;P[Q]="^"+P[F]+P[u]+"$";var K=S++;P[K]="^"+P[s]+"\\s*("+r+")$|^$";var V=S++;P[V]="^"+P[s]+"\\s*("+i+")$|^$";var W=S++;P[W]="(\\s*)"+P[s]+"\\s*("+r+"|"+P[a]+")",R[W]=new RegExp(P[W],"g");var G=S++;P[G]="^\\s*("+P[a]+")\\s+-\\s+("+P[a]+")\\s*$";var X=S++;P[X]="^\\s*("+P[u]+")\\s+-\\s+("+P[u]+")\\s*$";var ie=S++;P[ie]="(<|>)?=?\\s*\\*";for(var oe=0;oe<35;oe++)D(oe,P[oe]),R[oe]||(R[oe]=new RegExp(P[oe]));function te(ce,de){if(ce instanceof U)return ce;if(typeof ce!="string"||ce.length>k||!(de?R[t]:R[I]).test(ce))return null;try{return new U(ce,de)}catch{return null}}function U(ce,de){if(ce instanceof U){if(ce.loose===de)return ce;ce=ce.version}else if(typeof ce!="string")throw new TypeError("Invalid Version: "+ce);if(ce.length>k)throw new TypeError("version is longer than "+k+" characters");if(!(this instanceof U))return new U(ce,de);D("SemVer",ce,de),this.loose=de;var ge=ce.trim().match(de?R[t]:R[I]);if(!ge)throw new TypeError("Invalid Version: "+ce);if(this.raw=ce,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(Ce){if(/^[0-9]+$/.test(Ce)){var Pe=+Ce;if(Pe>=0&&Pe<T)return Pe}return Ce}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=te,e.valid=function(ce,de){var ge=te(ce,de);return ge?ge.version:null},e.clean=function(ce,de){var ge=te(ce.trim().replace(/^[=v]+/,""),de);return ge?ge.version:null},e.SemVer=U,U.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},U.prototype.toString=function(){return this.version},U.prototype.compare=function(ce){return D("SemVer.compare",this.version,this.loose,ce),ce instanceof U||(ce=new U(ce,this.loose)),this.compareMain(ce)||this.comparePre(ce)},U.prototype.compareMain=function(ce){return ce instanceof U||(ce=new U(ce,this.loose)),q(this.major,ce.major)||q(this.minor,ce.minor)||q(this.patch,ce.patch)},U.prototype.comparePre=function(ce){if(ce instanceof U||(ce=new U(ce,this.loose)),this.prerelease.length&&!ce.prerelease.length)return-1;if(!this.prerelease.length&&ce.prerelease.length)return 1;if(!this.prerelease.length&&!ce.prerelease.length)return 0;var de=0;do{var ge=this.prerelease[de],Ce=ce.prerelease[de];if(D("prerelease compare",de,ge,Ce),ge===void 0&&Ce===void 0)return 0;if(Ce===void 0)return 1;if(ge===void 0)return-1;if(ge!==Ce)return q(ge,Ce)}while(++de)},U.prototype.inc=function(ce,de){switch(ce){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",de);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",de);break;case"prepatch":this.prerelease.length=0,this.inc("patch",de),this.inc("pre",de);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",de),this.inc("pre",de);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}de&&(this.prerelease[0]===de?isNaN(this.prerelease[1])&&(this.prerelease=[de,0]):this.prerelease=[de,0]);break;default:throw new Error("invalid increment argument: "+ce)}return this.format(),this.raw=this.version,this},e.inc=function(ce,de,ge,Ce){typeof ge=="string"&&(Ce=ge,ge=void 0);try{return new U(ce,ge).inc(de,Ce).version}catch{return null}},e.diff=function(ce,de){if(J(ce,de))return null;var ge=te(ce),Ce=te(de);if(ge.prerelease.length||Ce.prerelease.length){for(var Pe in ge)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&ge[Pe]!==Ce[Pe])return"pre"+Pe;return"prerelease"}for(var Pe in ge)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&ge[Pe]!==Ce[Pe])return Pe},e.compareIdentifiers=q;var $=/^[0-9]+$/;function q(ce,de){var ge=$.test(ce),Ce=$.test(de);return ge&&Ce&&(ce=+ce,de=+de),ge&&!Ce?-1:Ce&&!ge?1:ce<de?-1:ce>de?1:0}function B(ce,de,ge){return new U(ce,ge).compare(new U(de,ge))}function x(ce,de,ge){return B(ce,de,ge)>0}function ee(ce,de,ge){return B(ce,de,ge)<0}function J(ce,de,ge){return B(ce,de,ge)===0}function Z(ce,de,ge){return B(ce,de,ge)!==0}function se(ce,de,ge){return B(ce,de,ge)>=0}function le(ce,de,ge){return B(ce,de,ge)<=0}function ue(ce,de,ge,Ce){var Pe;switch(de){case"===":typeof ce=="object"&&(ce=ce.version),typeof ge=="object"&&(ge=ge.version),Pe=ce===ge;break;case"!==":typeof ce=="object"&&(ce=ce.version),typeof ge=="object"&&(ge=ge.version),Pe=ce!==ge;break;case"":case"=":case"==":Pe=J(ce,ge,Ce);break;case"!=":Pe=Z(ce,ge,Ce);break;case">":Pe=x(ce,ge,Ce);break;case">=":Pe=se(ce,ge,Ce);break;case"<":Pe=ee(ce,ge,Ce);break;case"<=":Pe=le(ce,ge,Ce);break;default:throw new TypeError("Invalid operator: "+de)}return Pe}function pe(ce,de){if(ce instanceof pe){if(ce.loose===de)return ce;ce=ce.value}if(!(this instanceof pe))return new pe(ce,de);D("comparator",ce,de),this.loose=de,this.parse(ce),this.semver===we?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(ce,de){return q(de,ce)},e.major=function(ce,de){return new U(ce,de).major},e.minor=function(ce,de){return new U(ce,de).minor},e.patch=function(ce,de){return new U(ce,de).patch},e.compare=B,e.compareLoose=function(ce,de){return B(ce,de,!0)},e.rcompare=function(ce,de,ge){return B(de,ce,ge)},e.sort=function(ce,de){return ce.sort(function(ge,Ce){return e.compare(ge,Ce,de)})},e.rsort=function(ce,de){return ce.sort(function(ge,Ce){return e.rcompare(ge,Ce,de)})},e.gt=x,e.lt=ee,e.eq=J,e.neq=Z,e.gte=se,e.lte=le,e.cmp=ue,e.Comparator=pe;var we={};function be(ce,de){if(ce instanceof be)return ce.loose===de?ce:new be(ce.raw,de);if(ce instanceof pe)return new be(ce.value,de);if(!(this instanceof be))return new be(ce,de);if(this.loose=de,this.raw=ce,this.set=ce.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ce);this.format()}function Ee(ce){return!ce||ce.toLowerCase()==="x"||ce==="*"}function Te(ce,de,ge,Ce,Pe,Ae,De,je,Oe,Fe,Be,ke,Ne){return((de=Ee(ge)?"":Ee(Ce)?">="+ge+".0.0":Ee(Pe)?">="+ge+"."+Ce+".0":">="+de)+" "+(je=Ee(Oe)?"":Ee(Fe)?"<"+(+Oe+1)+".0.0":Ee(Be)?"<"+Oe+"."+(+Fe+1)+".0":ke?"<="+Oe+"."+Fe+"."+Be+"-"+ke:"<="+je)).trim()}function Ue(ce,de){for(var ge=0;ge<ce.length;ge++)if(!ce[ge].test(de))return!1;if(de.prerelease.length){for(ge=0;ge<ce.length;ge++)if(D(ce[ge].semver),ce[ge].semver!==we&&ce[ge].semver.prerelease.length>0){var Ce=ce[ge].semver;if(Ce.major===de.major&&Ce.minor===de.minor&&Ce.patch===de.patch)return!0}return!1}return!0}function Ye(ce,de,ge){try{de=new be(de,ge)}catch{return!1}return de.test(ce)}function ze(ce,de,ge,Ce){var Pe,Ae,De,je,Oe;switch(ce=new U(ce,Ce),de=new be(de,Ce),ge){case">":Pe=x,Ae=le,De=ee,je=">",Oe=">=";break;case"<":Pe=ee,Ae=se,De=x,je="<",Oe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ye(ce,de,Ce))return!1;for(var Fe=0;Fe<de.set.length;++Fe){var Be=de.set[Fe],ke=null,Ne=null;if(Be.forEach(function(ne){ne.semver===we&&(ne=new pe(">=0.0.0")),ke=ke||ne,Ne=Ne||ne,Pe(ne.semver,ke.semver,Ce)?ke=ne:De(ne.semver,Ne.semver,Ce)&&(Ne=ne)}),ke.operator===je||ke.operator===Oe||(!Ne.operator||Ne.operator===je)&&Ae(ce,Ne.semver)||Ne.operator===Oe&&De(ce,Ne.semver))return!1}return!0}pe.prototype.parse=function(ce){var de=this.loose?R[K]:R[V],ge=ce.match(de);if(!ge)throw new TypeError("Invalid comparator: "+ce);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new U(ge[2],this.loose):this.semver=we},pe.prototype.toString=function(){return this.value},pe.prototype.test=function(ce){return D("Comparator.test",ce,this.loose),this.semver===we||(typeof ce=="string"&&(ce=new U(ce,this.loose)),ue(ce,this.operator,this.semver,this.loose))},pe.prototype.intersects=function(ce,de){if(!(ce instanceof pe))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new be(ce.value,de),Ye(this.value,ge,de);if(ce.operator==="")return ge=new be(this.value,de),Ye(ce.semver,ge,de);var Ce=!(this.operator!==">="&&this.operator!==">"||ce.operator!==">="&&ce.operator!==">"),Pe=!(this.operator!=="<="&&this.operator!=="<"||ce.operator!=="<="&&ce.operator!=="<"),Ae=this.semver.version===ce.semver.version,De=!(this.operator!==">="&&this.operator!=="<="||ce.operator!==">="&&ce.operator!=="<="),je=ue(this.semver,"<",ce.semver,de)&&(this.operator===">="||this.operator===">")&&(ce.operator==="<="||ce.operator==="<"),Oe=ue(this.semver,">",ce.semver,de)&&(this.operator==="<="||this.operator==="<")&&(ce.operator===">="||ce.operator===">");return Ce||Pe||Ae&&De||je||Oe},e.Range=be,be.prototype.format=function(){return this.range=this.set.map(function(ce){return ce.join(" ").trim()}).join("||").trim(),this.range},be.prototype.toString=function(){return this.range},be.prototype.parseRange=function(ce){var de=this.loose;ce=ce.trim(),D("range",ce,de);var ge=de?R[X]:R[G];ce=ce.replace(ge,Te),D("hyphen replace",ce),ce=ce.replace(R[W],"$1$2$3"),D("comparator trim",ce,R[W]),ce=(ce=(ce=ce.replace(R[j],"$1~")).replace(R[z],"$1^")).split(/\s+/).join(" ");var Ce=de?R[K]:R[V],Pe=ce.split(" ").map(function(Ae){return function(De,je){return D("comp",De),De=function(Oe,Fe){return Oe.trim().split(/\s+/).map(function(Be){return function(ke,Ne){D("caret",ke,Ne);var ne=Ne?R[Q]:R[H];return ke.replace(ne,function(he,fe,me,ve,Ie){var Re;return D("caret",ke,he,fe,me,ve,Ie),Ee(fe)?Re="":Ee(me)?Re=">="+fe+".0.0 <"+(+fe+1)+".0.0":Ee(ve)?Re=fe==="0"?">="+fe+"."+me+".0 <"+fe+"."+(+me+1)+".0":">="+fe+"."+me+".0 <"+(+fe+1)+".0.0":Ie?(D("replaceCaret pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Re=fe==="0"?me==="0"?">="+fe+"."+me+"."+ve+Ie+" <"+fe+"."+me+"."+(+ve+1):">="+fe+"."+me+"."+ve+Ie+" <"+fe+"."+(+me+1)+".0":">="+fe+"."+me+"."+ve+Ie+" <"+(+fe+1)+".0.0"):(D("no pr"),Re=fe==="0"?me==="0"?">="+fe+"."+me+"."+ve+" <"+fe+"."+me+"."+(+ve+1):">="+fe+"."+me+"."+ve+" <"+fe+"."+(+me+1)+".0":">="+fe+"."+me+"."+ve+" <"+(+fe+1)+".0.0"),D("caret return",Re),Re})}(Be,Fe)}).join(" ")}(De,je),D("caret",De),De=function(Oe,Fe){return Oe.trim().split(/\s+/).map(function(Be){return function(ke,Ne){var ne=Ne?R[L]:R[M];return ke.replace(ne,function(he,fe,me,ve,Ie){var Re;return D("tilde",ke,he,fe,me,ve,Ie),Ee(fe)?Re="":Ee(me)?Re=">="+fe+".0.0 <"+(+fe+1)+".0.0":Ee(ve)?Re=">="+fe+"."+me+".0 <"+fe+"."+(+me+1)+".0":Ie?(D("replaceTilde pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Re=">="+fe+"."+me+"."+ve+Ie+" <"+fe+"."+(+me+1)+".0"):Re=">="+fe+"."+me+"."+ve+" <"+fe+"."+(+me+1)+".0",D("tilde return",Re),Re})}(Be,Fe)}).join(" ")}(De,je),D("tildes",De),De=function(Oe,Fe){return D("replaceXRanges",Oe,Fe),Oe.split(/\s+/).map(function(Be){return function(ke,Ne){ke=ke.trim();var ne=Ne?R[E]:R[w];return ke.replace(ne,function(he,fe,me,ve,Ie,Re){D("xRange",ke,he,fe,me,ve,Ie,Re);var He=Ee(me),$e=He||Ee(ve),Le=$e||Ee(Ie);return fe==="="&&Le&&(fe=""),He?he=fe===">"||fe==="<"?"<0.0.0":"*":fe&&Le?($e&&(ve=0),Le&&(Ie=0),fe===">"?(fe=">=",$e?(me=+me+1,ve=0,Ie=0):Le&&(ve=+ve+1,Ie=0)):fe==="<="&&(fe="<",$e?me=+me+1:ve=+ve+1),he=fe+me+"."+ve+"."+Ie):$e?he=">="+me+".0.0 <"+(+me+1)+".0.0":Le&&(he=">="+me+"."+ve+".0 <"+me+"."+(+ve+1)+".0"),D("xRange return",he),he})}(Be,Fe)}).join(" ")}(De,je),D("xrange",De),De=function(Oe,Fe){return D("replaceStars",Oe,Fe),Oe.trim().replace(R[ie],"")}(De,je),D("stars",De),De}(Ae,de)}).join(" ").split(/\s+/);return this.loose&&(Pe=Pe.filter(function(Ae){return!!Ae.match(Ce)})),Pe=Pe.map(function(Ae){return new pe(Ae,de)})},be.prototype.intersects=function(ce,de){if(!(ce instanceof be))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(Ce){return ce.set.some(function(Pe){return Pe.every(function(Ae){return Ce.intersects(Ae,de)})})})})},e.toComparators=function(ce,de){return new be(ce,de).set.map(function(ge){return ge.map(function(Ce){return Ce.value}).join(" ").trim().split(" ")})},be.prototype.test=function(ce){if(!ce)return!1;typeof ce=="string"&&(ce=new U(ce,this.loose));for(var de=0;de<this.set.length;de++)if(Ue(this.set[de],ce))return!0;return!1},e.satisfies=Ye,e.maxSatisfying=function(ce,de,ge){var Ce=null,Pe=null;try{var Ae=new be(de,ge)}catch{return null}return ce.forEach(function(De){Ae.test(De)&&(Ce&&Pe.compare(De)!==-1||(Pe=new U(Ce=De,ge)))}),Ce},e.minSatisfying=function(ce,de,ge){var Ce=null,Pe=null;try{var Ae=new be(de,ge)}catch{return null}return ce.forEach(function(De){Ae.test(De)&&(Ce&&Pe.compare(De)!==1||(Pe=new U(Ce=De,ge)))}),Ce},e.validRange=function(ce,de){try{return new be(ce,de).range||"*"}catch{return null}},e.ltr=function(ce,de,ge){return ze(ce,de,"<",ge)},e.gtr=function(ce,de,ge){return ze(ce,de,">",ge)},e.outside=ze,e.prerelease=function(ce,de){var ge=te(ce,de);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(ce,de,ge){return ce=new be(ce,ge),de=new be(de,ge),ce.intersects(de)},e.coerce=function(ce){if(ce instanceof U)return ce;if(typeof ce!="string")return null;var de=ce.match(R[N]);return de==null?null:te((de[1]||"0")+"."+(de[2]||"0")+"."+(de[3]||"0"))}}).call(this,A(1))},function(_,e){var A,n,D=_.exports={};function k(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function R(f){if(A===setTimeout)return setTimeout(f,0);if((A===k||!A)&&setTimeout)return A=setTimeout,setTimeout(f,0);try{return A(f,0)}catch{try{return A.call(null,f,0)}catch{return A.call(this,f,0)}}}(function(){try{A=typeof setTimeout=="function"?setTimeout:k}catch{A=k}try{n=typeof clearTimeout=="function"?clearTimeout:T}catch{n=T}})();var P,S=[],C=!1,b=-1;function m(){C&&P&&(C=!1,P.length?S=P.concat(S):b=-1,S.length&&p())}function p(){if(!C){var f=R(m);C=!0;for(var l=S.length;l;){for(P=S,S=[];++b<l;)P&&P[b].run();b=-1,l=S.length}P=null,C=!1,function(d){if(n===clearTimeout)return clearTimeout(d);if((n===T||!n)&&clearTimeout)return n=clearTimeout,clearTimeout(d);try{n(d)}catch{try{return n.call(null,d)}catch{return n.call(this,d)}}}(f)}}function h(f,l){this.fun=f,this.array=l}function y(){}D.nextTick=function(f){var l=new Array(arguments.length-1);if(arguments.length>1)for(var d=1;d<arguments.length;d++)l[d-1]=arguments[d];S.push(new h(f,l)),S.length!==1||C||R(p)},h.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=y,D.addListener=y,D.once=y,D.off=y,D.removeListener=y,D.removeAllListeners=y,D.emit=y,D.prependListener=y,D.prependOnceListener=y,D.listeners=function(f){return[]},D.binding=function(f){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(f){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(re[131],ae([0,1]),function(_,e){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class n{constructor(R,P,S){this.level=R,this.key=P,this.value=S,this.forward=[]}}const D=void 0;class k{constructor(R,P=2**16){this.comparator=R,this[A]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(P)|0),this.e=new n(this.c,D,D)}get size(){return this.f}clear(){this.e=new n(this.c,D,D)}has(R){return Boolean(k.g(this,R,this.comparator))}get(R){return k.g(this,R,this.comparator)?.value}set(R,P){return k.h(this,R,P,this.comparator)&&(this.f+=1),this}delete(R){const P=k.k(this,R,this.comparator);return P&&(this.f-=1),P}forEach(R,P){let S=this.e.forward[0];for(;S;)R.call(P,S.value,S.key,this),S=S.forward[0]}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this.e.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this.e.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this.e.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",P=this.e.forward[0];for(;P;)R+=`node(${P.key}, ${P.value}, lvl:${P.level})`,P=P.forward[0];return R}static g(R,P,S){let C=R.e;for(let b=R.d-1;b>=0;b--)for(;C.forward[b]&&S(C.forward[b].key,P)<0;)C=C.forward[b];if(C=C.forward[0],C&&S(C.key,P)===0)return C}static h(R,P,S,C){const b=[];let m=R.e;for(let p=R.d-1;p>=0;p--){for(;m.forward[p]&&C(m.forward[p].key,P)<0;)m=m.forward[p];b[p]=m}if(m=m.forward[0],m&&C(m.key,P)===0)return m.value=S,!1;{const p=k.j(R);if(p>R.d){for(let h=R.d;h<p;h++)b[h]=R.e;R.d=p}m=new n(p,P,S);for(let h=0;h<p;h++)m.forward[h]=b[h].forward[h],b[h].forward[h]=m;return!0}}static j(R,P=.5){let S=1;for(;Math.random()<P&&S<R.c;)S+=1;return S}static k(R,P,S){const C=[];let b=R.e;for(let m=R.d-1;m>=0;m--){for(;b.forward[m]&&S(b.forward[m].key,P)<0;)b=b.forward[m];C[m]=b}if(b=b.forward[0],!b||S(b.key,P)!==0)return!1;for(let m=0;m<R.d&&C[m].forward[m]===b;m++)C[m].forward[m]=b.forward[m];for(;R.d>0&&R.e.forward[R.d-1]===D;)R.d-=1;return!0}}e.SkipList=k}),define(re[44],ae([0,1,7,2]),function(_,e,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function D(v){const I=v;return I?typeof I.read=="function":!1}e.isReadable=D;function k(v){const I=v;return I?[I.on,I.pause,I.resume,I.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=k;function T(v){const I=v;return I?k(I.stream)&&Array.isArray(I.buffer)&&typeof I.ended=="boolean":!1}e.isReadableBufferedStream=T;function R(v,I){return new P(v,I)}e.newWriteableStream=R;class P{constructor(I,i){this.e=I,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(I){if(!this.a.destroyed){if(this.a.flowing)this.g(I);else if(this.b.data.push(I),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(I){this.a.destroyed||(this.a.flowing?this.h(I):this.b.error.push(I))}end(I){this.a.destroyed||(typeof I<"u"&&this.write(I),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(I){this.c.data.slice(0).forEach(i=>i(I))}h(I){this.c.error.length===0?(0,A.onUnexpectedError)(I):this.c.error.slice(0).forEach(i=>i(I))}i(){this.c.end.slice(0).forEach(I=>I())}on(I,i){if(!this.a.destroyed)switch(I){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(I,i){if(this.a.destroyed)return;let r;switch(I){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const t=r.indexOf(i);t>=0&&r.splice(t,1)}}j(){if(this.b.data.length>0){const I=this.e(this.b.data);this.g(I),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const I of this.b.error)this.h(I);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function S(v,I){const i=[];let r;for(;(r=v.read())!==null;)i.push(r);return I(i)}e.consumeReadable=S;function C(v,I,i){const r=[];let t;for(;(t=v.read())!==null&&r.length<i;)r.push(t);return t===null&&r.length>0?I(r):{read:()=>{if(r.length>0)return r.shift();if(typeof t<"u"){const s=t;return t=void 0,s}return v.read()}}}e.peekReadable=C;function b(v,I){return new Promise((i,r)=>{const t=[];m(v,{onData:s=>{I&&t.push(s)},onError:s=>{I?r(s):i(void 0)},onEnd:()=>{i(I?I(t):void 0)}})})}e.consumeStream=b;function m(v,I){let i=!1;return v.on("error",r=>{i||I.onError(r)}),v.on("end",()=>{i||I.onEnd()}),v.on("data",r=>{i||I.onData(r)}),(0,n.toDisposable)(()=>i=!0)}e.listenStream=m;function p(v,I){return new Promise((i,r)=>{const t=new n.DisposableStore,s=[],o=u=>{if(s.push(u),s.length>I)return t.dispose(),v.pause(),i({stream:v,buffer:s,ended:!1})},c=u=>r(u),a=()=>i({stream:v,buffer:s,ended:!0});t.add((0,n.toDisposable)(()=>v.removeListener("error",c))),v.on("error",c),t.add((0,n.toDisposable)(()=>v.removeListener("end",a))),v.on("end",a),t.add((0,n.toDisposable)(()=>v.removeListener("data",o))),v.on("data",o)})}e.peekStream=p;function h(v,I){const i=R(I);return i.end(v),i}e.toStream=h;function y(){const v=R(()=>{throw new Error("not supported")});return v.end(),v}e.emptyStream=y;function f(v){let I=!1;return{read:()=>I?null:(I=!0,v)}}e.toReadable=f;function l(v,I,i){const r=R(i);return m(v,{onData:t=>r.write(I.data(t)),onError:t=>r.error(I.error?I.error(t):t),onEnd:()=>r.end()}),r}e.transform=l;function d(v,I,i){let r=!1;return{read:()=>{const t=I.read();return r?t:(r=!0,t!==null?i([v,t]):v)}}}e.prefixedReadable=d;function g(v,I,i){let r=!1;const t=R(i);return m(I,{onData:s=>r?t.write(s):(r=!0,t.write(i([v,s]))),onError:s=>t.error(s),onEnd:()=>{r||(r=!0,t.write(v)),t.end()}}),t}e.prefixedStream=g}),define(re[17],ae([0,1,44]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const n=typeof Buffer<"u";let D,k;class T{static alloc(u){return n?new T(Buffer.allocUnsafe(u)):new T(new Uint8Array(u))}static wrap(u){return n&&!Buffer.isBuffer(u)&&(u=Buffer.from(u.buffer,u.byteOffset,u.byteLength)),new T(u)}static fromString(u,w){return!(w?.dontUseNodeBuffer||!1)&&n?new T(Buffer.from(u)):(D||(D=new TextEncoder),new T(D.encode(u)))}static fromByteArray(u){const w=T.alloc(u.length);for(let E=0,N=u.length;E<N;E++)w.buffer[E]=u[E];return w}static concat(u,w){if(typeof w>"u"){w=0;for(let O=0,j=u.length;O<j;O++)w+=u[O].byteLength}const E=T.alloc(w);let N=0;for(let O=0,j=u.length;O<j;O++){const M=u[O];E.set(M,N),N+=M.byteLength}return E}constructor(u){this.buffer=u,this.byteLength=this.buffer.byteLength}clone(){const u=T.alloc(this.byteLength);return u.set(this),u}toString(){return n?this.buffer.toString():(k||(k=new TextDecoder),k.decode(this.buffer))}slice(u,w){return new T(this.buffer.subarray(u,w))}set(u,w){if(u instanceof T)this.buffer.set(u.buffer,w);else if(u instanceof Uint8Array)this.buffer.set(u,w);else if(u instanceof ArrayBuffer)this.buffer.set(new Uint8Array(u),w);else if(ArrayBuffer.isView(u))this.buffer.set(new Uint8Array(u.buffer,u.byteOffset,u.byteLength),w);else throw new Error("Unknown argument 'array'")}readUInt32BE(u){return S(this.buffer,u)}writeUInt32BE(u,w){C(this.buffer,u,w)}readUInt32LE(u){return b(this.buffer,u)}writeUInt32LE(u,w){m(this.buffer,u,w)}readUInt8(u){return p(this.buffer,u)}writeUInt8(u,w){h(this.buffer,u,w)}}e.VSBuffer=T;function R(a,u){return a[u+0]<<0>>>0|a[u+1]<<8>>>0}e.readUInt16LE=R;function P(a,u,w){a[w+0]=u&255,u=u>>>8,a[w+1]=u&255}e.writeUInt16LE=P;function S(a,u){return a[u]*2**24+a[u+1]*2**16+a[u+2]*2**8+a[u+3]}e.readUInt32BE=S;function C(a,u,w){a[w+3]=u,u=u>>>8,a[w+2]=u,u=u>>>8,a[w+1]=u,u=u>>>8,a[w]=u}e.writeUInt32BE=C;function b(a,u){return a[u+0]<<0>>>0|a[u+1]<<8>>>0|a[u+2]<<16>>>0|a[u+3]<<24>>>0}e.readUInt32LE=b;function m(a,u,w){a[w+0]=u&255,u=u>>>8,a[w+1]=u&255,u=u>>>8,a[w+2]=u&255,u=u>>>8,a[w+3]=u&255}e.writeUInt32LE=m;function p(a,u){return a[u]}e.readUInt8=p;function h(a,u,w){a[w]=u}e.writeUInt8=h;function y(a){return A.consumeReadable(a,u=>T.concat(u))}e.readableToBuffer=y;function f(a){return A.toReadable(a)}e.bufferToReadable=f;function l(a){return A.consumeStream(a,u=>T.concat(u))}e.streamToBuffer=l;async function d(a){return a.ended?T.concat(a.buffer):T.concat([...a.buffer,await l(a.stream)])}e.bufferedStreamToBuffer=d;function g(a){return A.toStream(a,u=>T.concat(u))}e.bufferToStream=g;function v(a){return A.transform(a,{data:u=>typeof u=="string"?T.fromString(u):T.wrap(u)},u=>T.concat(u))}e.streamToBufferReadableStream=v;function I(a){return A.newWriteableStream(u=>T.concat(u),a)}e.newWriteableBufferStream=I;function i(a,u){return A.prefixedReadable(a,u,w=>T.concat(w))}e.prefixedBufferReadable=i;function r(a,u){return A.prefixedStream(a,u,w=>T.concat(w))}e.prefixedBufferStream=r;function t(a){let u=0,w=0,E=0;const N=new Uint8Array(Math.floor(a.length/4*3)),O=M=>{switch(w){case 3:N[E++]=u|M,w=0;break;case 2:N[E++]=u|M>>>2,u=M<<6,w=3;break;case 1:N[E++]=u|M>>>4,u=M<<4,w=2;break;default:u=M<<2,w=1}};for(let M=0;M<a.length;M++){const L=a.charCodeAt(M);if(L>=65&&L<=90)O(L-65);else if(L>=97&&L<=122)O(L-97+26);else if(L>=48&&L<=57)O(L-48+52);else if(L===43||L===45)O(62);else if(L===47||L===95)O(63);else{if(L===61)break;throw new SyntaxError(`Unexpected base64 character ${a[M]}`)}}const j=E;for(;w>0;)O(0);return T.wrap(N).slice(0,j)}e.decodeBase64=t;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function c({buffer:a},u=!0,w=!1){const E=w?o:s;let N="";const O=a.byteLength%3;let j=0;for(;j<a.byteLength-O;j+=3){const M=a[j+0],L=a[j+1],F=a[j+2];N+=E[M>>>2],N+=E[(M<<4|L>>>4)&63],N+=E[(L<<2|F>>>6)&63],N+=E[F&63]}if(O===1){const M=a[j+0];N+=E[M>>>2],N+=E[M<<4&63],u&&(N+="==")}else if(O===2){const M=a[j+0],L=a[j+1];N+=E[M>>>2],N+=E[(M<<4|L>>>4)&63],N+=E[L<<2&63],u&&(N+="=")}return N}e.encodeBase64=c}),define(re[14],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function A(r){return typeof r=="string"}e.isString=A;function n(r){return Array.isArray(r)&&r.every(t=>A(t))}e.isStringArray=n;function D(r){return typeof r=="object"&&r!==null&&!Array.isArray(r)&&!(r instanceof RegExp)&&!(r instanceof Date)}e.isObject=D;function k(r){const t=Object.getPrototypeOf(Uint8Array);return typeof r=="object"&&r instanceof t}e.isTypedArray=k;function T(r){return typeof r=="number"&&!isNaN(r)}e.isNumber=T;function R(r){return!!r&&typeof r[Symbol.iterator]=="function"}e.isIterable=R;function P(r){return r===!0||r===!1}e.isBoolean=P;function S(r){return typeof r>"u"}e.isUndefined=S;function C(r){return!b(r)}e.isDefined=C;function b(r){return S(r)||r===null}e.isUndefinedOrNull=b;function m(r,t){if(!r)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.assertType=m;function p(r){if(b(r))throw new Error("Assertion Failed: argument is undefined or null");return r}e.assertIsDefined=p;function h(...r){const t=[];for(let s=0;s<r.length;s++){const o=r[s];if(b(o))throw new Error(`Assertion Failed: argument at index ${s} is undefined or null`);t.push(o)}return t}e.assertAllDefined=h;const y=Object.prototype.hasOwnProperty;function f(r){if(!D(r))return!1;for(const t in r)if(y.call(r,t))return!1;return!0}e.isEmptyObject=f;function l(r){return typeof r=="function"}e.isFunction=l;function d(...r){return r.length>0&&r.every(l)}e.areFunctions=d;function g(r,t){const s=Math.min(r.length,t.length);for(let o=0;o<s;o++)v(r[o],t[o])}e.validateConstraints=g;function v(r,t){if(A(t)){if(typeof r!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(l(t)){try{if(r instanceof t)return}catch{}if(!b(r)&&r.constructor===t||t.length===1&&t.call(void 0,r)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=v;function I(r){return r===null?void 0:r}e.withNullAsUndefined=I;function i(r){return typeof r>"u"?null:r}e.withUndefinedAsNull=i}),define(re[32],ae([0,1,14]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function n(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const d=Array.isArray(l)?[]:{};return Object.entries(l).forEach(([g,v])=>{d[g]=v&&typeof v=="object"?n(v):v}),d}e.deepClone=n;function D(l){if(!l||typeof l!="object")return l;const d=[l];for(;d.length>0;){const g=d.shift();Object.freeze(g);for(const v in g)if(k.call(g,v)){const I=g[v];typeof I=="object"&&!Object.isFrozen(I)&&!(0,A.isTypedArray)(I)&&d.push(I)}}return l}e.deepFreeze=D;const k=Object.prototype.hasOwnProperty;function T(l,d){return R(l,d,new Set)}e.cloneAndChange=T;function R(l,d,g){if((0,A.isUndefinedOrNull)(l))return l;const v=d(l);if(typeof v<"u")return v;if(Array.isArray(l)){const I=[];for(const i of l)I.push(R(i,d,g));return I}if((0,A.isObject)(l)){if(g.has(l))throw new Error("Cannot clone recursive data-structure");g.add(l);const I={};for(const i in l)k.call(l,i)&&(I[i]=R(l[i],d,g));return g.delete(l),I}return l}function P(l,d,g=!0){return(0,A.isObject)(l)?((0,A.isObject)(d)&&Object.keys(d).forEach(v=>{v in l?g&&((0,A.isObject)(l[v])&&(0,A.isObject)(d[v])?P(l[v],d[v],g):l[v]=d[v]):l[v]=d[v]}),l):d}e.mixin=P;function S(l,d){if(l===d)return!0;if(l==null||d===null||d===void 0||typeof l!=typeof d||typeof l!="object"||Array.isArray(l)!==Array.isArray(d))return!1;let g,v;if(Array.isArray(l)){if(l.length!==d.length)return!1;for(g=0;g<l.length;g++)if(!S(l[g],d[g]))return!1}else{const I=[];for(v in l)I.push(v);I.sort();const i=[];for(v in d)i.push(v);if(i.sort(),!S(I,i))return!1;for(g=0;g<I.length;g++)if(!S(l[I[g]],d[I[g]]))return!1}return!0}e.equals=S;function C(l){const d=new Set;return JSON.stringify(l,(g,v)=>{if((0,A.isObject)(v)||Array.isArray(v)){if(d.has(v))return"[Circular]";d.add(v)}return v})}e.safeStringify=C;function b(l,d){const g=Object.create(null);return!l||!d||Object.keys(d).forEach(I=>{const i=l[I],r=d[I];S(i,r)||(g[I]=r)}),g}e.distinct=b;function m(l,d){const g=d.toLowerCase(),v=Object.keys(l).find(I=>I.toLowerCase()===g);return v?l[v]:l[d]}e.getCaseInsensitive=m;function p(l,d){const g=Object.create(null);for(const[v,I]of Object.entries(l))d(v,I)&&(g[v]=I);return g}e.filter=p;function h(l){let d=[],g=Object.getPrototypeOf(l);for(;Object.prototype!==g;)d=d.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return d}e.getAllPropertyNames=h;function y(l){const d=[];for(const g of h(l))typeof l[g]=="function"&&d.push(g);return d}e.getAllMethodNames=y;function f(l,d){const g=I=>function(){const i=Array.prototype.slice.call(arguments,0);return d(I,i)},v={};for(const I of l)v[I]=g(I);return v}e.createProxyObject=f}),define(re[31],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const A=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function n(D){return A.test(D)}e.isUUID=n,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(R){for(let P=0;P<R.length;P++)R[P]=Math.floor(Math.random()*256);return R};const k=new Uint8Array(16),T=[];for(let R=0;R<256;R++)T.push(R.toString(16).padStart(2,"0"));return function(){D(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let P=0,S="";return S+=T[k[P++]],S+=T[k[P++]],S+=T[k[P++]],S+=T[k[P++]],S+="-",S+=T[k[P++]],S+=T[k[P++]],S+="-",S+=T[k[P++]],S+=T[k[P++]],S+="-",S+=T[k[P++]],S+=T[k[P++]],S+="-",S+=T[k[P++]],S+=T[k[P++]],S+=T[k[P++]],S+=T[k[P++]],S+=T[k[P++]],S+=T[k[P++]],S}}()}),define(re[132],ae([0,1,34]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const n=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(T){const R=T.replace(/\-/g,":").toLowerCase();return!n.has(R)}function k(){const T=(0,A.networkInterfaces)();for(const R in T){const P=T[R];if(P){for(const{mac:S}of P)if(D(S))return S}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=k}),define(re[133],ae([0,1,86]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function n(R,P,S,C=1){let b=!1;return new Promise(m=>{const p=setTimeout(()=>{if(!b)return b=!0,m(0)},S);D(R,P,C,h=>{if(!b)return b=!0,clearTimeout(p),m(h)})})}e.findFreePort=n;function D(R,P,S,C){if(P===0)return C(0);const b=new A.Socket;b.once("connect",()=>(T(b),D(R+S,P-1,S,C))),b.once("data",()=>{}),b.once("error",m=>(T(b),m.code!=="ECONNREFUSED"?D(R+S,P-1,S,C):C(R))),b.connect(R,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function k(R,P,S,C="127.0.0.1"){let b=!1,m,p=1;const h=A.createServer({pauseOnConnect:!0});function y(f,l){b||(b=!0,h.removeAllListeners(),h.close(),m&&clearTimeout(m),l(f))}return new Promise(f=>{m=setTimeout(()=>{y(0,f)},S),h.on("listening",()=>{y(R,f)}),h.on("error",l=>{l&&(l.code==="EADDRINUSE"||l.code==="EACCES")&&p<P?(R++,p++,h.listen(R,C)):y(0,f)}),h.on("close",()=>{y(0,f)}),h.listen(R,C)})}e.findFreePortFaster=k;function T(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(P){console.error(P)}}}),define(re[134],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OfflineError=e.isOfflineError=void 0;const A="Offline";function n(k){return k instanceof D?!0:k instanceof Error&&k.name===A&&k.message===A}e.isOfflineError=n;class D extends Error{constructor(){super(A),this.name=this.message}}e.OfflineError=D}),define(re[135],ae([0,1,17,7,134]),function(_,e,A,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function k(P,S){if(!navigator.onLine)throw new D.OfflineError;P.proxyAuthorization&&(P.headers={...P.headers||{},"Proxy-Authorization":P.proxyAuthorization});const C=new XMLHttpRequest;return new Promise((b,m)=>{C.open(P.type||"GET",P.url||"",!0,P.user,P.password),T(C,P),C.responseType="arraybuffer",C.onerror=p=>m(new Error(C.statusText&&"XHR failed: "+C.statusText||"XHR failed")),C.onload=p=>{b({res:{statusCode:C.status,headers:R(C)},stream:(0,A.bufferToStream)(A.VSBuffer.wrap(new Uint8Array(C.response)))})},C.ontimeout=p=>m(new Error(`XHR timeout: ${P.timeout}ms`)),P.timeout&&(C.timeout=P.timeout),C.send(P.data),S.onCancellationRequested(()=>{C.abort(),m((0,n.canceled)())})})}e.request=k;function T(P,S){if(S.headers){e:for(const C in S.headers){switch(C){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}P.setRequestHeader(C,S.headers[C])}}}function R(P){const S=Object.create(null);for(const C of P.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(C){const b=C.indexOf(":");S[C.substr(0,b).trim().toLowerCase()]=C.substr(b+1).trim()}return S}}),define(re[136],ae([10,11]),function(_,e){return _.create("vs/base/common/date",e)}),define(re[65],ae([0,1,136]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const n=60,D=n*60,k=D*24,T=k*7,R=k*30,P=k*365;function S(b,m,p,h){typeof b!="number"&&(b=b.getTime());const y=Math.round((new Date().getTime()-b)/1e3);if(y<-30)return(0,A.localize)(0,null,S(new Date().getTime()+y*1e3,!1));if(!h&&y<30)return(0,A.localize)(1,null);let f;return y<n?(f=y,m?f===1?p?(0,A.localize)(2,null,f):(0,A.localize)(3,null,f):p?(0,A.localize)(4,null,f):(0,A.localize)(5,null,f):f===1?p?(0,A.localize)(6,null,f):(0,A.localize)(7,null,f):p?(0,A.localize)(8,null,f):(0,A.localize)(9,null,f)):y<D?(f=Math.floor(y/n),m?f===1?p?(0,A.localize)(10,null,f):(0,A.localize)(11,null,f):p?(0,A.localize)(12,null,f):(0,A.localize)(13,null,f):f===1?p?(0,A.localize)(14,null,f):(0,A.localize)(15,null,f):p?(0,A.localize)(16,null,f):(0,A.localize)(17,null,f)):y<k?(f=Math.floor(y/D),m?f===1?p?(0,A.localize)(18,null,f):(0,A.localize)(19,null,f):p?(0,A.localize)(20,null,f):(0,A.localize)(21,null,f):f===1?p?(0,A.localize)(22,null,f):(0,A.localize)(23,null,f):p?(0,A.localize)(24,null,f):(0,A.localize)(25,null,f)):y<T?(f=Math.floor(y/k),m?f===1?(0,A.localize)(26,null,f):(0,A.localize)(27,null,f):f===1?(0,A.localize)(28,null,f):(0,A.localize)(29,null,f)):y<R?(f=Math.floor(y/T),m?f===1?p?(0,A.localize)(30,null,f):(0,A.localize)(31,null,f):p?(0,A.localize)(32,null,f):(0,A.localize)(33,null,f):f===1?p?(0,A.localize)(34,null,f):(0,A.localize)(35,null,f):p?(0,A.localize)(36,null,f):(0,A.localize)(37,null,f)):y<P?(f=Math.floor(y/R),m?f===1?p?(0,A.localize)(38,null,f):(0,A.localize)(39,null,f):p?(0,A.localize)(40,null,f):(0,A.localize)(41,null,f):f===1?p?(0,A.localize)(42,null,f):(0,A.localize)(43,null,f):p?(0,A.localize)(44,null,f):(0,A.localize)(45,null,f)):(f=Math.floor(y/P),m?f===1?p?(0,A.localize)(46,null,f):(0,A.localize)(47,null,f):p?(0,A.localize)(48,null,f):(0,A.localize)(49,null,f):f===1?p?(0,A.localize)(50,null,f):(0,A.localize)(51,null,f):p?(0,A.localize)(52,null,f):(0,A.localize)(53,null,f))}e.fromNow=S;function C(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=C}),define(re[137],ae([10,11]),function(_,e){return _.create("vs/base/common/errorMessage",e)}),define(re[38],ae([0,1,21,14,137]),function(_,e,A,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function k(b,m){return m&&(b.stack||b.stacktrace)?D.localize(0,null,R(b),T(b.stack)||T(b.stacktrace)):R(b)}function T(b){return Array.isArray(b)?b.join(`
`):b}function R(b){return typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?D.localize(1,null,b.message):b.message||D.localize(2,null)}function P(b=null,m=!1){if(!b)return D.localize(3,null);if(Array.isArray(b)){const p=A.coalesce(b),h=P(p[0],m);return p.length>1?D.localize(4,null,h,p.length):h}if(n.isString(b))return b;if(b.detail){const p=b.detail;if(p.error)return k(p.error,m);if(p.exception)return k(p.exception,m)}return b.stack?k(b,m):b.message?b.message:D.localize(5,null)}e.toErrorMessage=P;function S(b){const m=b;return m instanceof Error&&Array.isArray(m.actions)}e.isErrorWithActions=S;function C(b,m){let p;return typeof b=="string"?p=new Error(b):p=b,p.actions=m,p}e.createErrorWithActions=C}),define(re[138],ae([10,11]),function(_,e){return _.create("vs/base/common/jsonErrorMessages",e)}),define(re[139],ae([0,1,138]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function n(D){switch(D){case 1:return(0,A.localize)(0,null);case 2:return(0,A.localize)(1,null);case 3:return(0,A.localize)(2,null);case 4:return(0,A.localize)(3,null);case 5:return(0,A.localize)(4,null);case 6:return(0,A.localize)(5,null);case 7:return(0,A.localize)(6,null);case 8:return(0,A.localize)(7,null);case 9:return(0,A.localize)(8,null);default:return""}}e.getParseErrorMessage=n}),define(re[140],ae([10,11]),function(_,e){return _.create("vs/base/common/platform",e)}),define(re[5],ae([0,1,140]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let n=!1,D=!1,k=!1,T=!1,R=!1,P=!1,S=!1,C=!1,b=!1,m=!1,p,h=e.LANGUAGE_DEFAULT,y,f;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let l;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?l=e.globals.vscode.process:typeof process<"u"&&(l=process);const d=typeof l?.versions?.electron=="string",g=d&&l?.type==="renderer";if(typeof navigator=="object"&&!g)f=navigator.userAgent,n=f.indexOf("Windows")>=0,D=f.indexOf("Macintosh")>=0,C=(f.indexOf("Macintosh")>=0||f.indexOf("iPad")>=0||f.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,k=f.indexOf("Linux")>=0,m=f?.indexOf("Mobi")>=0,P=!0,p=A.getConfiguredDefaultLocale(A.localize(0,null))||e.LANGUAGE_DEFAULT,h=p;else if(typeof l=="object"){n=l.platform==="win32",D=l.platform==="darwin",k=l.platform==="linux",T=k&&!!l.env.SNAP&&!!l.env.SNAP_REVISION,S=d,b=!!l.env.CI||!!l.env.BUILD_ARTIFACTSTAGINGDIRECTORY,p=e.LANGUAGE_DEFAULT,h=e.LANGUAGE_DEFAULT;const a=l.env.VSCODE_NLS_CONFIG;if(a)try{const u=JSON.parse(a),w=u.availableLanguages["*"];p=u.locale,h=w||e.LANGUAGE_DEFAULT,y=u._translationsConfigFile}catch{}R=!0}else console.error("Unable to resolve platform.");var v;(function(a){a[a.Web=0]="Web",a[a.Mac=1]="Mac",a[a.Linux=2]="Linux",a[a.Windows=3]="Windows"})(v=e.Platform||(e.Platform={}));function I(a){switch(a){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=I;let i=0;D?i=1:n?i=3:k&&(i=2),e.isWindows=n,e.isMacintosh=D,e.isLinux=k,e.isLinuxSnap=T,e.isNative=R,e.isElectron=S,e.isWeb=P,e.isWebWorker=P&&typeof e.globals.importScripts=="function",e.isIOS=C,e.isMobile=m,e.isCI=b,e.platform=i,e.userAgent=f,e.language=h;var r;(function(a){function u(){return e.language}a.value=u;function w(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}a.isDefaultVariant=w;function E(){return e.language==="en"}a.isDefault=E})(r=e.Language||(e.Language={})),e.locale=p,e.translationsConfigFile=y,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const a=[];e.globals.addEventListener("message",w=>{if(w.data&&w.data.vscodeScheduleAsyncWork)for(let E=0,N=a.length;E<N;E++){const O=a[E];if(O.id===w.data.vscodeScheduleAsyncWork){a.splice(E,1),O.callback();return}}});let u=0;return w=>{const E=++u;a.push({id:E,callback:w}),e.globals.postMessage({vscodeScheduleAsyncWork:E},"*")}}return a=>setTimeout(a)})();var t;(function(a){a[a.Windows=1]="Windows",a[a.Macintosh=2]="Macintosh",a[a.Linux=3]="Linux"})(t=e.OperatingSystem||(e.OperatingSystem={})),e.OS=D||C?2:n?1:3;let s=!0,o=!1;function c(){if(!o){o=!0;const a=new Uint8Array(2);a[0]=1,a[1]=2,s=new Uint16Array(a.buffer)[0]===(2<<8)+1}return s}e.isLittleEndian=c,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(re[36],ae([0,1,5]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let n;if(typeof A.globals.vscode<"u"&&typeof A.globals.vscode.process<"u"){const D=A.globals.vscode.process;n={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()}}}else typeof process<"u"?n={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:n={get platform(){return A.isWindows?"win32":A.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=n.cwd,e.env=n.env,e.platform=n.platform,e.arch=n.arch}),define(re[12],ae([0,1,36]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const n=65,D=97,k=90,T=122,R=46,P=47,S=92,C=58,b=63;class m extends Error{constructor(r,t,s){let o;typeof t=="string"&&t.indexOf("not ")===0?(o="must not be",t=t.replace(/^not /,"")):o="must be";const c=r.indexOf(".")!==-1?"property":"argument";let a=`The "${r}" ${c} ${o} of type ${t}`;a+=`. Received type ${typeof s}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function p(i,r){if(i===null||typeof i!="object")throw new m(r,"Object",i)}function h(i,r){if(typeof i!="string")throw new m(r,"string",i)}const y=A.platform==="win32";function f(i){return i===P||i===S}function l(i){return i===P}function d(i){return i>=n&&i<=k||i>=D&&i<=T}function g(i,r,t,s){let o="",c=0,a=-1,u=0,w=0;for(let E=0;E<=i.length;++E){if(E<i.length)w=i.charCodeAt(E);else{if(s(w))break;w=P}if(s(w)){if(!(a===E-1||u===1))if(u===2){if(o.length<2||c!==2||o.charCodeAt(o.length-1)!==R||o.charCodeAt(o.length-2)!==R){if(o.length>2){const N=o.lastIndexOf(t);N===-1?(o="",c=0):(o=o.slice(0,N),c=o.length-1-o.lastIndexOf(t)),a=E,u=0;continue}else if(o.length!==0){o="",c=0,a=E,u=0;continue}}r&&(o+=o.length>0?`${t}..`:"..",c=2)}else o.length>0?o+=`${t}${i.slice(a+1,E)}`:o=i.slice(a+1,E),c=E-a-1;a=E,u=0}else w===R&&u!==-1?++u:u=-1}return o}function v(i,r){p(r,"pathObject");const t=r.dir||r.root,s=r.base||`${r.name||""}${r.ext||""}`;return t?t===r.root?`${t}${s}`:`${t}${i}${s}`:s}e.win32={resolve(...i){let r="",t="",s=!1;for(let o=i.length-1;o>=-1;o--){let c;if(o>=0){if(c=i[o],h(c,"path"),c.length===0)continue}else r.length===0?c=A.cwd():(c=A.env[`=${r}`]||A.cwd(),(c===void 0||c.slice(0,2).toLowerCase()!==r.toLowerCase()&&c.charCodeAt(2)===S)&&(c=`${r}\\`));const a=c.length;let u=0,w="",E=!1;const N=c.charCodeAt(0);if(a===1)f(N)&&(u=1,E=!0);else if(f(N))if(E=!0,f(c.charCodeAt(1))){let O=2,j=O;for(;O<a&&!f(c.charCodeAt(O));)O++;if(O<a&&O!==j){const M=c.slice(j,O);for(j=O;O<a&&f(c.charCodeAt(O));)O++;if(O<a&&O!==j){for(j=O;O<a&&!f(c.charCodeAt(O));)O++;(O===a||O!==j)&&(w=`\\\\${M}\\${c.slice(j,O)}`,u=O)}}}else u=1;else d(N)&&c.charCodeAt(1)===C&&(w=c.slice(0,2),u=2,a>2&&f(c.charCodeAt(2))&&(E=!0,u=3));if(w.length>0)if(r.length>0){if(w.toLowerCase()!==r.toLowerCase())continue}else r=w;if(s){if(r.length>0)break}else if(t=`${c.slice(u)}\\${t}`,s=E,E&&r.length>0)break}return t=g(t,!s,"\\",f),s?`${r}\\${t}`:`${r}${t}`||"."},normalize(i){h(i,"path");const r=i.length;if(r===0)return".";let t=0,s,o=!1;const c=i.charCodeAt(0);if(r===1)return l(c)?"\\":i;if(f(c))if(o=!0,f(i.charCodeAt(1))){let u=2,w=u;for(;u<r&&!f(i.charCodeAt(u));)u++;if(u<r&&u!==w){const E=i.slice(w,u);for(w=u;u<r&&f(i.charCodeAt(u));)u++;if(u<r&&u!==w){for(w=u;u<r&&!f(i.charCodeAt(u));)u++;if(u===r)return`\\\\${E}\\${i.slice(w)}\\`;u!==w&&(s=`\\\\${E}\\${i.slice(w,u)}`,t=u)}}}else t=1;else d(c)&&i.charCodeAt(1)===C&&(s=i.slice(0,2),t=2,r>2&&f(i.charCodeAt(2))&&(o=!0,t=3));let a=t<r?g(i.slice(t),!o,"\\",f):"";return a.length===0&&!o&&(a="."),a.length>0&&f(i.charCodeAt(r-1))&&(a+="\\"),s===void 0?o?`\\${a}`:a:o?`${s}\\${a}`:`${s}${a}`},isAbsolute(i){h(i,"path");const r=i.length;if(r===0)return!1;const t=i.charCodeAt(0);return f(t)||r>2&&d(t)&&i.charCodeAt(1)===C&&f(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let r,t;for(let c=0;c<i.length;++c){const a=i[c];h(a,"path"),a.length>0&&(r===void 0?r=t=a:r+=`\\${a}`)}if(r===void 0)return".";let s=!0,o=0;if(typeof t=="string"&&f(t.charCodeAt(0))){++o;const c=t.length;c>1&&f(t.charCodeAt(1))&&(++o,c>2&&(f(t.charCodeAt(2))?++o:s=!1))}if(s){for(;o<r.length&&f(r.charCodeAt(o));)o++;o>=2&&(r=`\\${r.slice(o)}`)}return e.win32.normalize(r)},relative(i,r){if(h(i,"from"),h(r,"to"),i===r)return"";const t=e.win32.resolve(i),s=e.win32.resolve(r);if(t===s||(i=t.toLowerCase(),r=s.toLowerCase(),i===r))return"";let o=0;for(;o<i.length&&i.charCodeAt(o)===S;)o++;let c=i.length;for(;c-1>o&&i.charCodeAt(c-1)===S;)c--;const a=c-o;let u=0;for(;u<r.length&&r.charCodeAt(u)===S;)u++;let w=r.length;for(;w-1>u&&r.charCodeAt(w-1)===S;)w--;const E=w-u,N=a<E?a:E;let O=-1,j=0;for(;j<N;j++){const L=i.charCodeAt(o+j);if(L!==r.charCodeAt(u+j))break;L===S&&(O=j)}if(j!==N){if(O===-1)return s}else{if(E>N){if(r.charCodeAt(u+j)===S)return s.slice(u+j+1);if(j===2)return s.slice(u+j)}a>N&&(i.charCodeAt(o+j)===S?O=j:j===2&&(O=3)),O===-1&&(O=0)}let M="";for(j=o+O+1;j<=c;++j)(j===c||i.charCodeAt(j)===S)&&(M+=M.length===0?"..":"\\..");return u+=O,M.length>0?`${M}${s.slice(u,w)}`:(s.charCodeAt(u)===S&&++u,s.slice(u,w))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const r=e.win32.resolve(i);if(r.length<=2)return i;if(r.charCodeAt(0)===S){if(r.charCodeAt(1)===S){const t=r.charCodeAt(2);if(t!==b&&t!==R)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(d(r.charCodeAt(0))&&r.charCodeAt(1)===C&&r.charCodeAt(2)===S)return`\\\\?\\${r}`;return i},dirname(i){h(i,"path");const r=i.length;if(r===0)return".";let t=-1,s=0;const o=i.charCodeAt(0);if(r===1)return f(o)?i:".";if(f(o)){if(t=s=1,f(i.charCodeAt(1))){let u=2,w=u;for(;u<r&&!f(i.charCodeAt(u));)u++;if(u<r&&u!==w){for(w=u;u<r&&f(i.charCodeAt(u));)u++;if(u<r&&u!==w){for(w=u;u<r&&!f(i.charCodeAt(u));)u++;if(u===r)return i;u!==w&&(t=s=u+1)}}}}else d(o)&&i.charCodeAt(1)===C&&(t=r>2&&f(i.charCodeAt(2))?3:2,s=t);let c=-1,a=!0;for(let u=r-1;u>=s;--u)if(f(i.charCodeAt(u))){if(!a){c=u;break}}else a=!1;if(c===-1){if(t===-1)return".";c=t}return i.slice(0,c)},basename(i,r){r!==void 0&&h(r,"ext"),h(i,"path");let t=0,s=-1,o=!0,c;if(i.length>=2&&d(i.charCodeAt(0))&&i.charCodeAt(1)===C&&(t=2),r!==void 0&&r.length>0&&r.length<=i.length){if(r===i)return"";let a=r.length-1,u=-1;for(c=i.length-1;c>=t;--c){const w=i.charCodeAt(c);if(f(w)){if(!o){t=c+1;break}}else u===-1&&(o=!1,u=c+1),a>=0&&(w===r.charCodeAt(a)?--a===-1&&(s=c):(a=-1,s=u))}return t===s?s=u:s===-1&&(s=i.length),i.slice(t,s)}for(c=i.length-1;c>=t;--c)if(f(i.charCodeAt(c))){if(!o){t=c+1;break}}else s===-1&&(o=!1,s=c+1);return s===-1?"":i.slice(t,s)},extname(i){h(i,"path");let r=0,t=-1,s=0,o=-1,c=!0,a=0;i.length>=2&&i.charCodeAt(1)===C&&d(i.charCodeAt(0))&&(r=s=2);for(let u=i.length-1;u>=r;--u){const w=i.charCodeAt(u);if(f(w)){if(!c){s=u+1;break}continue}o===-1&&(c=!1,o=u+1),w===R?t===-1?t=u:a!==1&&(a=1):t!==-1&&(a=-1)}return t===-1||o===-1||a===0||a===1&&t===o-1&&t===s+1?"":i.slice(t,o)},format:v.bind(null,"\\"),parse(i){h(i,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return r;const t=i.length;let s=0,o=i.charCodeAt(0);if(t===1)return f(o)?(r.root=r.dir=i,r):(r.base=r.name=i,r);if(f(o)){if(s=1,f(i.charCodeAt(1))){let O=2,j=O;for(;O<t&&!f(i.charCodeAt(O));)O++;if(O<t&&O!==j){for(j=O;O<t&&f(i.charCodeAt(O));)O++;if(O<t&&O!==j){for(j=O;O<t&&!f(i.charCodeAt(O));)O++;O===t?s=O:O!==j&&(s=O+1)}}}}else if(d(o)&&i.charCodeAt(1)===C){if(t<=2)return r.root=r.dir=i,r;if(s=2,f(i.charCodeAt(2))){if(t===3)return r.root=r.dir=i,r;s=3}}s>0&&(r.root=i.slice(0,s));let c=-1,a=s,u=-1,w=!0,E=i.length-1,N=0;for(;E>=s;--E){if(o=i.charCodeAt(E),f(o)){if(!w){a=E+1;break}continue}u===-1&&(w=!1,u=E+1),o===R?c===-1?c=E:N!==1&&(N=1):c!==-1&&(N=-1)}return u!==-1&&(c===-1||N===0||N===1&&c===u-1&&c===a+1?r.base=r.name=i.slice(a,u):(r.name=i.slice(a,c),r.base=i.slice(a,u),r.ext=i.slice(c,u))),a>0&&a!==s?r.dir=i.slice(0,a-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null};const I=(()=>{if(y){const i=/\\/g;return()=>{const r=A.cwd().replace(i,"/");return r.slice(r.indexOf("/"))}}return()=>A.cwd()})();e.posix={resolve(...i){let r="",t=!1;for(let s=i.length-1;s>=-1&&!t;s--){const o=s>=0?i[s]:I();h(o,"path"),o.length!==0&&(r=`${o}/${r}`,t=o.charCodeAt(0)===P)}return r=g(r,!t,"/",l),t?`/${r}`:r.length>0?r:"."},normalize(i){if(h(i,"path"),i.length===0)return".";const r=i.charCodeAt(0)===P,t=i.charCodeAt(i.length-1)===P;return i=g(i,!r,"/",l),i.length===0?r?"/":t?"./":".":(t&&(i+="/"),r?`/${i}`:i)},isAbsolute(i){return h(i,"path"),i.length>0&&i.charCodeAt(0)===P},join(...i){if(i.length===0)return".";let r;for(let t=0;t<i.length;++t){const s=i[t];h(s,"path"),s.length>0&&(r===void 0?r=s:r+=`/${s}`)}return r===void 0?".":e.posix.normalize(r)},relative(i,r){if(h(i,"from"),h(r,"to"),i===r||(i=e.posix.resolve(i),r=e.posix.resolve(r),i===r))return"";const t=1,s=i.length,o=s-t,c=1,a=r.length-c,u=o<a?o:a;let w=-1,E=0;for(;E<u;E++){const O=i.charCodeAt(t+E);if(O!==r.charCodeAt(c+E))break;O===P&&(w=E)}if(E===u)if(a>u){if(r.charCodeAt(c+E)===P)return r.slice(c+E+1);if(E===0)return r.slice(c+E)}else o>u&&(i.charCodeAt(t+E)===P?w=E:E===0&&(w=0));let N="";for(E=t+w+1;E<=s;++E)(E===s||i.charCodeAt(E)===P)&&(N+=N.length===0?"..":"/..");return`${N}${r.slice(c+w)}`},toNamespacedPath(i){return i},dirname(i){if(h(i,"path"),i.length===0)return".";const r=i.charCodeAt(0)===P;let t=-1,s=!0;for(let o=i.length-1;o>=1;--o)if(i.charCodeAt(o)===P){if(!s){t=o;break}}else s=!1;return t===-1?r?"/":".":r&&t===1?"//":i.slice(0,t)},basename(i,r){r!==void 0&&h(r,"ext"),h(i,"path");let t=0,s=-1,o=!0,c;if(r!==void 0&&r.length>0&&r.length<=i.length){if(r===i)return"";let a=r.length-1,u=-1;for(c=i.length-1;c>=0;--c){const w=i.charCodeAt(c);if(w===P){if(!o){t=c+1;break}}else u===-1&&(o=!1,u=c+1),a>=0&&(w===r.charCodeAt(a)?--a===-1&&(s=c):(a=-1,s=u))}return t===s?s=u:s===-1&&(s=i.length),i.slice(t,s)}for(c=i.length-1;c>=0;--c)if(i.charCodeAt(c)===P){if(!o){t=c+1;break}}else s===-1&&(o=!1,s=c+1);return s===-1?"":i.slice(t,s)},extname(i){h(i,"path");let r=-1,t=0,s=-1,o=!0,c=0;for(let a=i.length-1;a>=0;--a){const u=i.charCodeAt(a);if(u===P){if(!o){t=a+1;break}continue}s===-1&&(o=!1,s=a+1),u===R?r===-1?r=a:c!==1&&(c=1):r!==-1&&(c=-1)}return r===-1||s===-1||c===0||c===1&&r===s-1&&r===t+1?"":i.slice(r,s)},format:v.bind(null,"/"),parse(i){h(i,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return r;const t=i.charCodeAt(0)===P;let s;t?(r.root="/",s=1):s=0;let o=-1,c=0,a=-1,u=!0,w=i.length-1,E=0;for(;w>=s;--w){const N=i.charCodeAt(w);if(N===P){if(!u){c=w+1;break}continue}a===-1&&(u=!1,a=w+1),N===R?o===-1?o=w:E!==1&&(E=1):o!==-1&&(E=-1)}if(a!==-1){const N=c===0&&t?1:c;o===-1||E===0||E===1&&o===a-1&&o===c+1?r.base=r.name=i.slice(N,a):(r.name=i.slice(N,o),r.base=i.slice(N,a),r.ext=i.slice(o,a))}return c>0?r.dir=i.slice(0,c-1):t&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=y?e.win32.normalize:e.posix.normalize,e.isAbsolute=y?e.win32.isAbsolute:e.posix.isAbsolute,e.join=y?e.win32.join:e.posix.join,e.resolve=y?e.win32.resolve:e.posix.resolve,e.relative=y?e.win32.relative:e.posix.relative,e.dirname=y?e.win32.dirname:e.posix.dirname,e.basename=y?e.win32.basename:e.posix.basename,e.extname=y?e.win32.extname:e.posix.extname,e.format=y?e.win32.format:e.posix.format,e.parse=y?e.win32.parse:e.posix.parse,e.toNamespacedPath=y?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=y?e.win32.sep:e.posix.sep,e.delimiter=y?e.win32.delimiter:e.posix.delimiter}),define(re[141],ae([0,1,12]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const n={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},D={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function k(C){const b=(0,A.extname)(C),m=n[b.toLowerCase()];return m!==void 0?m:T(C)}e.getMediaOrTextMime=k;function T(C){const b=(0,A.extname)(C);return D[b.toLowerCase()]}e.getMediaMime=T;function R(C){for(const b in D)if(D[b]===C)return b}e.getExtensionForMimeType=R;const P=/^(.+)\/(.+?)(;.+)?$/;function S(C,b){const m=P.exec(C);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:b?void 0:C}e.normalizeMimeType=S}),define(re[87],ae([0,1,5]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var n;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(n=e.Source||(e.Source={}));var D;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(D=e.TerminateResponseCode||(e.TerminateResponseCode={}));function k(R,...P){const S=P.reduce((m,p)=>(m[p]=!0,m),{}),C=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(R).filter(m=>!S[m]).forEach(m=>{for(let p=0;p<C.length;p++)if(m.search(C[p])!==-1){delete R[m];break}})}e.sanitizeProcessEnvironment=k;function T(R){!R||(delete R.DEBUG,A.isMacintosh&&delete R.DYLD_LIBRARY_PATH,A.isLinux&&delete R.LD_PRELOAD)}e.removeDangerousEnvVariables=T}),define(re[88],ae([0,1,5]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const n=A.globals.performance&&typeof A.globals.performance.now=="function";class D{static create(T=!0){return new D(T)}constructor(T){this.a=n&&T,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?A.globals.performance.now():Date.now()}}e.StopWatch=D}),define(re[3],ae([0,1,7,82,2,84,88]),function(_,e,A,n,D,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const R=!1,P=!1;var S;(function(c){c.None=()=>D.Disposable.None;function a(B){if(P){const{onDidAddListener:x}=B,ee=h.create();let J=0;B.onDidAddListener=()=>{++J===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ee.print()),x?.()}}}function u(B,x){return z(B,()=>{},0,void 0,void 0,x)}c.defer=u;function w(B){return(x,ee=null,J)=>{let Z=!1,se;return se=B(le=>{if(!Z)return se?se.dispose():Z=!0,x.call(ee,le)},null,J),Z&&se.dispose(),se}}c.once=w;function E(B,x,ee){return F((J,Z=null,se)=>B(le=>J.call(Z,x(le)),null,se),ee)}c.map=E;function N(B,x,ee){return F((J,Z=null,se)=>B(le=>{x(le),J.call(Z,le)},null,se),ee)}c.forEach=N;function O(B,x,ee){return F((J,Z=null,se)=>B(le=>x(le)&&J.call(Z,le),null,se),ee)}c.filter=O;function j(B){return B}c.signal=j;function M(...B){return(x,ee=null,J)=>(0,D.combinedDisposable)(...B.map(Z=>Z(se=>x.call(ee,se),null,J)))}c.any=M;function L(B,x,ee,J){let Z=ee;return E(B,se=>(Z=x(Z,se),Z),J)}c.reduce=L;function F(B,x){let ee;const J={onWillAddFirstListener(){ee=B(Z.fire,Z)},onDidRemoveLastListener(){ee?.dispose()}};x||a(J);const Z=new f(J);return x?.add(Z),Z.event}function z(B,x,ee=100,J=!1,Z,se){let le,ue,pe,we=0;const be={leakWarningThreshold:Z,onWillAddFirstListener(){le=B(Te=>{we++,ue=x(ue,Te),J&&!pe&&(Ee.fire(ue),ue=void 0),clearTimeout(pe),pe=setTimeout(()=>{const Ue=ue;ue=void 0,pe=void 0,(!J||we>1)&&Ee.fire(Ue),we=0},ee)})},onDidRemoveLastListener(){le.dispose()}};se||a(be);const Ee=new f(be);return se?.add(Ee),Ee.event}c.debounce=z;function H(B,x=0,ee){return c.debounce(B,(J,Z)=>J?(J.push(Z),J):[Z],x,void 0,void 0,ee)}c.accumulate=H;function Q(B,x=(J,Z)=>J===Z,ee){let J=!0,Z;return O(B,se=>{const le=J||!x(se,Z);return J=!1,Z=se,le},ee)}c.latch=Q;function K(B,x,ee){return[c.filter(B,x,ee),c.filter(B,J=>!x(J),ee)]}c.split=K;function V(B,x=!1,ee=[]){let J=ee.slice(),Z=B(ue=>{J?J.push(ue):le.fire(ue)});const se=()=>{J?.forEach(ue=>le.fire(ue)),J=null},le=new f({onWillAddFirstListener(){Z||(Z=B(ue=>le.fire(ue)))},onDidAddFirstListener(){J&&(x?setTimeout(se):se())},onDidRemoveLastListener(){Z&&Z.dispose(),Z=null}});return le.event}c.buffer=V;class W{constructor(x){this.event=x,this.c=new D.DisposableStore}map(x){return new W(E(this.event,x,this.c))}forEach(x){return new W(N(this.event,x,this.c))}filter(x){return new W(O(this.event,x,this.c))}reduce(x,ee){return new W(L(this.event,x,ee,this.c))}latch(){return new W(Q(this.event,void 0,this.c))}debounce(x,ee=100,J=!1,Z){return new W(z(this.event,x,ee,J,Z,this.c))}on(x,ee,J){return this.event(x,ee,J)}once(x,ee,J){return w(this.event)(x,ee,J)}dispose(){this.c.dispose()}}function G(B){return new W(B)}c.chain=G;function X(B,x,ee=J=>J){const J=(...ue)=>le.fire(ee(...ue)),Z=()=>B.on(x,J),se=()=>B.removeListener(x,J),le=new f({onWillAddFirstListener:Z,onDidRemoveLastListener:se});return le.event}c.fromNodeEventEmitter=X;function ie(B,x,ee=J=>J){const J=(...ue)=>le.fire(ee(...ue)),Z=()=>B.addEventListener(x,J),se=()=>B.removeEventListener(x,J),le=new f({onWillAddFirstListener:Z,onDidRemoveLastListener:se});return le.event}c.fromDOMEventEmitter=ie;function oe(B){return new Promise(x=>w(B)(x))}c.toPromise=oe;function te(B,x){return x(void 0),B(ee=>x(ee))}c.runAndSubscribe=te;function U(B,x){let ee=null;function J(se){ee?.dispose(),ee=new D.DisposableStore,x(se,ee)}J(void 0);const Z=B(se=>J(se));return(0,D.toDisposable)(()=>{Z.dispose(),ee?.dispose()})}c.runAndSubscribeWithStore=U;class ${constructor(x,ee){this.obs=x,this.c=0,this.d=!1;const J={onWillAddFirstListener:()=>{x.addObserver(this)},onDidRemoveLastListener:()=>{x.removeObserver(this)}};ee||a(J),this.emitter=new f(J),ee&&ee.add(this.emitter)}beginUpdate(x){this.c++}handleChange(x,ee){this.d=!0}endUpdate(x){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function q(B,x){return new $(B,x).emitter.event}c.fromObservable=q})(S=e.Event||(e.Event={}));class C{constructor(a){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${a}_${C.c++}`,C.all.add(this)}start(a){this.d=new T.StopWatch(!0),this.listenerCount=a}stop(){if(this.d){const a=this.d.elapsed();this.durations.push(a),this.elapsedOverall+=a,this.invocationCount+=1,this.d=void 0}}}e.EventProfiling=C,C.all=new Set,C.c=0;let b=-1;function m(c){const a=b;return b=c,{dispose(){b=a}}}e.setGlobalLeakWarningThreshold=m;class p{constructor(a,u=Math.random().toString(18).slice(2,5)){this.threshold=a,this.name=u,this.d=0}dispose(){this.c?.clear()}check(a,u){const w=this.threshold;if(w<=0||u<w)return;this.c||(this.c=new Map);const E=this.c.get(a.value)||0;if(this.c.set(a.value,E+1),this.d-=1,this.d<=0){this.d=w*.5;let N,O=0;for(const[j,M]of this.c)(!N||O<M)&&(N=j,O=M);console.warn(`[${this.name}] potential listener LEAK detected, having ${u} listeners already. MOST frequent listener (${O}):`),console.warn(N)}return()=>{const N=this.c.get(a.value)||0;this.c.set(a.value,N-1)}}}class h{static create(){return new h(new Error().stack??"")}constructor(a){this.value=a}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class y{constructor(a,u,w){this.callback=a,this.callbackThis=u,this.stack=w,this.subscription=new D.SafeDisposable}invoke(a){this.callback.call(this.callbackThis,a)}}class f{constructor(a){this.j=!1,this.d=a,this.f=b>0||this.d?.leakWarningThreshold?new p(this.d?.leakWarningThreshold??b):void 0,this.g=this.d?._profName?new C(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(R){const a=Array.from(this.q);queueMicrotask(()=>{for(const u of a)u.subscription.isset()&&(u.subscription.unset(),u.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(a,u,w)=>{if(this.q||(this.q=new k.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),D.Disposable.None;const E=this.q.isEmpty();E&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let N,O;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(O=h.create(),N=this.f.check(O,this.q.size+1)),R&&(O=O??h.create());const j=new y(a,u,O),M=this.q.push(j);E&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,a,u);const L=j.subscription.set(()=>{N?.(),this.j||(M(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return w instanceof D.DisposableStore?w.add(L):Array.isArray(w)&&w.push(L),L}),this.l}fire(a){if(this.q){this.m||(this.m=new d);for(const u of this.q)this.m.push(this,u,a);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=f;class l{constructor(){this.c=new k.LinkedList}get size(){return this.c.size}push(a,u,w){this.c.push(new g(a,u,w))}clear(a){const u=new k.LinkedList;for(const w of this.c)w.emitter!==a&&u.push(w);this.c=u}deliver(){for(;this.c.size>0;){const a=this.c.shift();try{a.listener.invoke(a.event)}catch(u){(0,A.onUnexpectedError)(u)}}}}e.EventDeliveryQueue=l;class d extends l{clear(a){this.c.clear()}}class g{constructor(a,u,w){this.emitter=a,this.listener=u,this.event=w}}class v extends f{async fireAsync(a,u,w){if(!!this.q){this.c||(this.c=new k.LinkedList);for(const E of this.q)this.c.push([E,a]);for(;this.c.size>0&&!u.isCancellationRequested;){const[E,N]=this.c.shift(),O=[],j={...N,token:u,waitUntil:M=>{if(Object.isFrozen(O))throw new Error("waitUntil can NOT be called asynchronous");w&&(M=w(M,E.callback)),O.push(M)}};try{E.invoke(j)}catch(M){(0,A.onUnexpectedError)(M);continue}Object.freeze(O),await Promise.allSettled(O).then(M=>{for(const L of M)L.status==="rejected"&&(0,A.onUnexpectedError)(L.reason)})}}}}e.AsyncEmitter=v;class I extends f{constructor(a){super(a),this.h=0,this.s=new k.LinkedList,this.t=a?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const a=Array.from(this.s);this.s.clear(),super.fire(this.t(a))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(a){this.q&&(this.h!==0?this.s.push(a):super.fire(a))}}e.PauseableEmitter=I;class i extends I{constructor(a){super(a),this.c=a.delay??100}fire(a){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(a)}}e.DebounceEmitter=i;class r extends f{constructor(a){super(a),this.c=[],this.h=a?.merge}fire(a){!this.hasListeners()||(this.c.push(a),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(u=>super.fire(u)),this.c=[]}))}}e.MicrotaskEmitter=r;class t{constructor(){this.d=!1,this.f=[],this.c=new f({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(a){const u={event:a,listener:null};this.f.push(u),this.d&&this.j(u);const w=()=>{this.d&&this.k(u);const E=this.f.indexOf(u);this.f.splice(E,1)};return(0,D.toDisposable)((0,n.once)(w))}g(){this.d=!0,this.f.forEach(a=>this.j(a))}h(){this.d=!1,this.f.forEach(a=>this.k(a))}j(a){a.listener=a.event(u=>this.c.fire(u))}k(a){a.listener&&a.listener.dispose(),a.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=t;class s{constructor(){this.c=[]}wrapEvent(a){return(u,w,E)=>a(N=>{const O=this.c[this.c.length-1];O?O.push(()=>u.call(w,N)):u.call(w,N)},void 0,E)}bufferEvents(a){const u=[];this.c.push(u);const w=a();return this.c.pop(),u.forEach(E=>E()),w}}e.EventBufferer=s;class o{constructor(){this.c=!1,this.d=S.None,this.f=D.Disposable.None,this.g=new f({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(a){this.d=a,this.c&&(this.f.dispose(),this.f=a(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=o}),define(re[23],ae([0,1,3]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const n=Object.freeze(function(R,P){const S=setTimeout(R.bind(P),0);return{dispose(){clearTimeout(S)}}});var D;(function(R){function P(S){return S===R.None||S===R.Cancelled||S instanceof k?!0:!S||typeof S!="object"?!1:typeof S.isCancellationRequested=="boolean"&&typeof S.onCancellationRequested=="function"}R.isCancellationToken=P,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:A.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:n})})(D=e.CancellationToken||(e.CancellationToken={}));class k{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?n:(this.b||(this.b=new A.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class T{constructor(P){this.a=void 0,this.b=void 0,this.b=P&&P.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new k),this.a}cancel(){this.a?this.a instanceof k&&this.a.cancel():this.a=D.Cancelled}dispose(P=!1){P&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof k&&this.a.dispose():this.a=D.None}}e.CancellationTokenSource=T}),define(re[142],ae([0,1,23]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class n{constructor(R){this.b=R,this.a=null}get(){if(this.a)return this.a;const R=new A.CancellationTokenSource,P=this.b(R.token);return this.a={promise:P,dispose:()=>{this.a=null,R.cancel(),R.dispose()}},this.a}}e.Cache=n;class D{constructor(R){this.c=R,this.a=void 0,this.b=void 0}get(R){const P=JSON.stringify(R);return this.b!==P&&(this.b=P,this.a=this.c(R)),this.a}}e.LRUCachedFunction=D;class k{get cachedValues(){return this.a}constructor(R){this.b=R,this.a=new Map}get(R){if(this.a.has(R))return this.a.get(R);const P=this.b(R);return this.a.set(R,P),P}}e.CachedFunction=k}),define(re[27],ae([0,1,142,129]),function(_,e,A,n){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function k(ne){return!ne||typeof ne!="string"?!0:ne.trim().length===0}e.isFalsyOrWhitespace=k;const T=/{(\d+)}/g;function R(ne,...he){return he.length===0?ne:ne.replace(T,function(fe,me){const ve=parseInt(me,10);return isNaN(ve)||ve<0||ve>=he.length?fe:he[ve]})}e.format=R;const P=/{([^}]+)}/g;function S(ne,he){return ne.replace(P,(fe,me)=>he[me]??fe)}e.format2=S;function C(ne){return ne.replace(/[<>&]/g,function(he){switch(he){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return he}})}e.escape=C;function b(ne){return ne.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=b;function m(ne,he){let fe=0;const me=he.charCodeAt(0);for(let ve=ne.length-1;ve>=0;ve--)ne.charCodeAt(ve)===me&&fe++;return fe}e.count=m;function p(ne,he,fe="\u2026"){return ne.length<=he?ne:`${ne.substr(0,he)}${fe}`}e.truncate=p;function h(ne,he=" "){const fe=y(ne,he);return f(fe,he)}e.trim=h;function y(ne,he){if(!ne||!he)return ne;const fe=he.length;if(fe===0||ne.length===0)return ne;let me=0;for(;ne.indexOf(he,me)===me;)me=me+fe;return ne.substring(me)}e.ltrim=y;function f(ne,he){if(!ne||!he)return ne;const fe=he.length,me=ne.length;if(fe===0||me===0)return ne;let ve=me,Ie=-1;for(;Ie=ne.lastIndexOf(he,ve-1),!(Ie===-1||Ie+fe!==ve);){if(Ie===0)return"";ve=Ie}return ne.substring(0,ve)}e.rtrim=f;function l(ne){return ne.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=l;function d(ne){return ne.replace(/\*/g,"")}e.stripWildcards=d;function g(ne,he,fe={}){if(!ne)throw new Error("Cannot create regex from empty string");he||(ne=b(ne)),fe.wholeWord&&(/\B/.test(ne.charAt(0))||(ne="\\b"+ne),/\B/.test(ne.charAt(ne.length-1))||(ne=ne+"\\b"));let me="";return fe.global&&(me+="g"),fe.matchCase||(me+="i"),fe.multiline&&(me+="m"),fe.unicode&&(me+="u"),new RegExp(ne,me)}e.createRegExp=g;function v(ne){return ne.source==="^"||ne.source==="^$"||ne.source==="$"||ne.source==="^\\s*$"?!1:!!(ne.exec("")&&ne.lastIndex===0)}e.regExpLeadsToEndlessLoop=v;function I(ne){return!!ne.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=I;function i(ne){return(ne.global?"g":"")+(ne.ignoreCase?"i":"")+(ne.multiline?"m":"")+(ne.unicode?"u":"")}e.regExpFlags=i;function r(ne){return ne.split(/\r\n|\r|\n/)}e.splitLines=r;function t(ne){for(let he=0,fe=ne.length;he<fe;he++){const me=ne.charCodeAt(he);if(me!==32&&me!==9)return he}return-1}e.firstNonWhitespaceIndex=t;function s(ne,he=0,fe=ne.length){for(let me=he;me<fe;me++){const ve=ne.charCodeAt(me);if(ve!==32&&ve!==9)return ne.substring(he,me)}return ne.substring(he,fe)}e.getLeadingWhitespace=s;function o(ne,he=ne.length-1){for(let fe=he;fe>=0;fe--){const me=ne.charCodeAt(fe);if(me!==32&&me!==9)return fe}return-1}e.lastNonWhitespaceIndex=o;function c(ne,he,fe){const me=[];let ve=0;for(const Ie of ne.matchAll(he)){if(me.push(ne.slice(ve,Ie.index)),Ie.index===void 0)throw new Error("match.index should be defined");ve=Ie.index+Ie[0].length,me.push(fe(Ie[0],...Ie.slice(1),Ie.index,ne,Ie.groups))}return me.push(ne.slice(ve)),Promise.all(me).then(Ie=>Ie.join(""))}e.replaceAsync=c;function a(ne,he){return ne<he?-1:ne>he?1:0}e.compare=a;function u(ne,he,fe=0,me=ne.length,ve=0,Ie=he.length){for(;fe<me&&ve<Ie;fe++,ve++){const $e=ne.charCodeAt(fe),Le=he.charCodeAt(ve);if($e<Le)return-1;if($e>Le)return 1}const Re=me-fe,He=Ie-ve;return Re<He?-1:Re>He?1:0}e.compareSubstring=u;function w(ne,he){return E(ne,he,0,ne.length,0,he.length)}e.compareIgnoreCase=w;function E(ne,he,fe=0,me=ne.length,ve=0,Ie=he.length){for(;fe<me&&ve<Ie;fe++,ve++){let $e=ne.charCodeAt(fe),Le=he.charCodeAt(ve);if($e===Le)continue;if($e>=128||Le>=128)return u(ne.toLowerCase(),he.toLowerCase(),fe,me,ve,Ie);O($e)&&($e-=32),O(Le)&&(Le-=32);const qe=$e-Le;if(qe!==0)return qe}const Re=me-fe,He=Ie-ve;return Re<He?-1:Re>He?1:0}e.compareSubstringIgnoreCase=E;function N(ne){return ne>=48&&ne<=57}e.isAsciiDigit=N;function O(ne){return ne>=97&&ne<=122}e.isLowerAsciiLetter=O;function j(ne){return ne>=65&&ne<=90}e.isUpperAsciiLetter=j;function M(ne,he){return ne.length===he.length&&E(ne,he)===0}e.equalsIgnoreCase=M;function L(ne,he){const fe=he.length;return he.length>ne.length?!1:E(ne,he,0,fe)===0}e.startsWithIgnoreCase=L;function F(ne,he){const fe=Math.min(ne.length,he.length);let me;for(me=0;me<fe;me++)if(ne.charCodeAt(me)!==he.charCodeAt(me))return me;return fe}e.commonPrefixLength=F;function z(ne,he){const fe=Math.min(ne.length,he.length);let me;const ve=ne.length-1,Ie=he.length-1;for(me=0;me<fe;me++)if(ne.charCodeAt(ve-me)!==he.charCodeAt(Ie-me))return me;return fe}e.commonSuffixLength=z;function H(ne){return 55296<=ne&&ne<=56319}e.isHighSurrogate=H;function Q(ne){return 56320<=ne&&ne<=57343}e.isLowSurrogate=Q;function K(ne,he){return(ne-55296<<10)+(he-56320)+65536}e.computeCodePoint=K;function V(ne,he,fe){const me=ne.charCodeAt(fe);if(H(me)&&fe+1<he){const ve=ne.charCodeAt(fe+1);if(Q(ve))return K(me,ve)}return me}e.getNextCodePoint=V;function W(ne,he){const fe=ne.charCodeAt(he-1);if(Q(fe)&&he>1){const me=ne.charCodeAt(he-2);if(H(me))return K(me,fe)}return fe}class G{get offset(){return this.e}constructor(he,fe=0){this.c=he,this.d=he.length,this.e=fe}setOffset(he){this.e=he}prevCodePoint(){const he=W(this.c,this.e);return this.e-=he>=65536?2:1,he}nextCodePoint(){const he=V(this.c,this.d,this.e);return this.e+=he>=65536?2:1,he}eol(){return this.e>=this.d}}e.CodePointIterator=G;class X{get offset(){return this.c.offset}constructor(he,fe=0){this.c=new G(he,fe)}nextGraphemeLength(){const he=Ae.getInstance(),fe=this.c,me=fe.offset;let ve=he.getGraphemeBreakType(fe.nextCodePoint());for(;!fe.eol();){const Ie=fe.offset,Re=he.getGraphemeBreakType(fe.nextCodePoint());if(Ce(ve,Re)){fe.setOffset(Ie);break}ve=Re}return fe.offset-me}prevGraphemeLength(){const he=Ae.getInstance(),fe=this.c,me=fe.offset;let ve=he.getGraphemeBreakType(fe.prevCodePoint());for(;fe.offset>0;){const Ie=fe.offset,Re=he.getGraphemeBreakType(fe.prevCodePoint());if(Ce(Re,ve)){fe.setOffset(Ie);break}ve=Re}return me-fe.offset}eol(){return this.c.eol()}}e.GraphemeIterator=X;function ie(ne,he){return new X(ne,he).nextGraphemeLength()}e.nextCharLength=ie;function oe(ne,he){return new X(ne,he).prevGraphemeLength()}e.prevCharLength=oe;function te(ne,he){he>0&&Q(ne.charCodeAt(he))&&he--;const fe=he+ie(ne,he);return[fe-oe(ne,fe),fe]}e.getCharContainingOffset=te;function U(ne){const he=new X(ne);let fe=0;for(;!he.eol();)fe++,he.nextGraphemeLength();return fe}e.charCount=U;let $;function q(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function B(ne){return $||($=q()),$.test(ne)}e.containsRTL=B;const x=/^[\t\n\r\x20-\x7E]*$/;function ee(ne){return x.test(ne)}e.isBasicASCII=ee,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function J(ne){return e.UNUSUAL_LINE_TERMINATORS.test(ne)}e.containsUnusualLineTerminators=J;function Z(ne){return ne>=11904&&ne<=55215||ne>=63744&&ne<=64255||ne>=65281&&ne<=65374}e.isFullWidthCharacter=Z;function se(ne){return ne>=127462&&ne<=127487||ne===8986||ne===8987||ne===9200||ne===9203||ne>=9728&&ne<=10175||ne===11088||ne===11093||ne>=127744&&ne<=128591||ne>=128640&&ne<=128764||ne>=128992&&ne<=129008||ne>=129280&&ne<=129535||ne>=129648&&ne<=129782}e.isEmojiImprecise=se;function le(ne,he){if(ne.length<he)return ne;const fe=/\b/g;let me=0;for(;fe.test(ne)&&!(ne.length-fe.lastIndex<he);)me=fe.lastIndex,fe.lastIndex+=1;return ne.substring(me).replace(/^\s/,"")}e.lcut=le;const ue=/\x1B\x5B[12]?K/g,pe=/\x1b\[\d+m/g,we=/\x1b\[0?m/g;function be(ne){return ne&&(ne=ne.replace(ue,""),ne=ne.replace(pe,""),ne=ne.replace(we,"")),ne}e.removeAnsiEscapeCodes=be,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ee(ne){return!!(ne&&ne.length>0&&ne.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ee;function Te(ne){return Ee(ne)?ne.substr(1):ne}e.stripUTF8BOM=Te;function Ue(ne,he){if(!ne||!he||ne.length<he.length)return!1;const fe=he.length,me=ne.toLowerCase();let ve=0,Ie=-1;for(;ve<fe;){const Re=me.indexOf(he[ve],Ie+1);if(Re<0)return!1;Ie=Re,ve++}return!0}e.fuzzyContains=Ue;function Ye(ne,he=!1){return ne?(he&&(ne=ne.replace(/\\./g,"")),ne.toLowerCase()!==ne):!1}e.containsUppercaseCharacter=Ye;function ze(ne){return ne.charAt(0).toUpperCase()+ne.slice(1)}e.uppercaseFirstLetter=ze;function ce(ne,he=1){if(he===0)return"";let fe=-1;do fe=ne.indexOf(`
`,fe+1),he--;while(he>0&&fe>=0);return fe===-1?ne:(ne[fe-1]==="\r"&&fe--,ne.substr(0,fe))}e.getNLines=ce;function de(ne){return ne=ne%(2*26),ne<26?String.fromCharCode(97+ne):String.fromCharCode(65+ne-26)}e.singleLetterHash=de;function ge(ne){return Ae.getInstance().getGraphemeBreakType(ne)}e.getGraphemeBreakType=ge;function Ce(ne,he){return ne===0?he!==5&&he!==7:ne===2&&he===3?!1:ne===4||ne===2||ne===3||he===4||he===2||he===3?!0:!(ne===8&&(he===8||he===9||he===11||he===12)||(ne===11||ne===9)&&(he===9||he===10)||(ne===12||ne===10)&&he===10||he===5||he===13||he===7||ne===1||ne===13&&he===14||ne===6&&he===6)}var Pe;(function(ne){ne[ne.Other=0]="Other",ne[ne.Prepend=1]="Prepend",ne[ne.CR=2]="CR",ne[ne.LF=3]="LF",ne[ne.Control=4]="Control",ne[ne.Extend=5]="Extend",ne[ne.Regional_Indicator=6]="Regional_Indicator",ne[ne.SpacingMark=7]="SpacingMark",ne[ne.L=8]="L",ne[ne.V=9]="V",ne[ne.T=10]="T",ne[ne.LV=11]="LV",ne[ne.LVT=12]="LVT",ne[ne.ZWJ=13]="ZWJ",ne[ne.Extended_Pictographic=14]="Extended_Pictographic"})(Pe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ae{static getInstance(){return Ae.c||(Ae.c=new Ae),Ae.c}constructor(){this.d=De()}getGraphemeBreakType(he){if(he<32)return he===10?3:he===13?2:4;if(he<127)return 0;const fe=this.d,me=fe.length/3;let ve=1;for(;ve<=me;)if(he<fe[3*ve])ve=2*ve;else if(he>fe[3*ve+1])ve=2*ve+1;else return fe[3*ve+2];return 0}}Ae.c=null;function De(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function je(ne,he){if(ne===0)return 0;const fe=Oe(ne,he);if(fe!==void 0)return fe;const me=new G(he,ne);return me.prevCodePoint(),me.offset}e.getLeftDeleteOffset=je;function Oe(ne,he){const fe=new G(he,ne);let me=fe.prevCodePoint();for(;Fe(me)||me===65039||me===8419;){if(fe.offset===0)return;me=fe.prevCodePoint()}if(!se(me))return;let ve=fe.offset;return ve>0&&fe.prevCodePoint()===8205&&(ve=fe.offset),ve}function Fe(ne){return 127995<=ne&&ne<=127999}var Be;(function(ne){ne[ne.zwj=8205]="zwj",ne[ne.emojiVariantSelector=65039]="emojiVariantSelector",ne[ne.enclosingKeyCap=8419]="enclosingKeyCap"})(Be||(Be={})),e.noBreakWhitespace="\xA0";class ke{static getInstance(he){return ke.d.get(Array.from(he))}static getLocales(){return ke.e.getValue()}constructor(he){this.f=he}isAmbiguous(he){return this.f.has(he)}getPrimaryConfusable(he){return this.f.get(he)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.AmbiguousCharacters=ke,D=ke,ke.c=new n.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),ke.d=new A.LRUCachedFunction(ne=>{function he(Le){const qe=new Map;for(let Ge=0;Ge<Le.length;Ge+=2)qe.set(Le[Ge],Le[Ge+1]);return qe}function fe(Le,qe){const Ge=new Map(Le);for(const[et,ot]of qe)Ge.set(et,ot);return Ge}function me(Le,qe){if(!Le)return qe;const Ge=new Map;for(const[et,ot]of Le)qe.has(et)&&Ge.set(et,ot);return Ge}const ve=D.c.getValue();let Ie=ne.filter(Le=>!Le.startsWith("_")&&Le in ve);Ie.length===0&&(Ie=["_default"]);let Re;for(const Le of Ie){const qe=he(ve[Le]);Re=me(Re,qe)}const He=he(ve._common),$e=fe(He,Re);return new ke($e)}),ke.e=new n.Lazy(()=>Object.keys(ke.c.getValue()).filter(ne=>!ne.startsWith("_")));class Ne{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Ne.c())),this.d}static isInvisibleCharacter(he){return Ne.e().has(he)}static get codePoints(){return Ne.e()}}e.InvisibleCharacters=Ne,Ne.d=void 0}),define(re[48],ae([0,1,12,5,27,14]),function(_,e,A,n,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function T(o){return o===47||o===92}e.isPathSeparator=T;function R(o){return o.replace(/[\\/]/g,A.posix.sep)}e.toSlashes=R;function P(o){return o.indexOf("/")===-1&&(o=R(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=P;function S(o,c=A.posix.sep){if(!o)return"";const a=o.length,u=o.charCodeAt(0);if(T(u)){if(T(o.charCodeAt(1))&&!T(o.charCodeAt(2))){let E=3;const N=E;for(;E<a&&!T(o.charCodeAt(E));E++);if(N!==E&&!T(o.charCodeAt(E+1))){for(E+=1;E<a;E++)if(T(o.charCodeAt(E)))return o.slice(0,E+1).replace(/[\\/]/g,c)}}return c}else if(l(u)&&o.charCodeAt(1)===58)return T(o.charCodeAt(2))?o.slice(0,2)+c:o.slice(0,2);let w=o.indexOf("://");if(w!==-1){for(w+=3;w<a;w++)if(T(o.charCodeAt(w)))return o.slice(0,w+1)}return""}e.getRoot=S;function C(o){if(!n.isWindows||!o||o.length<5)return!1;let c=o.charCodeAt(0);if(c!==92||(c=o.charCodeAt(1),c!==92))return!1;let a=2;const u=a;for(;a<o.length&&(c=o.charCodeAt(a),c!==92);a++);return!(u===a||(c=o.charCodeAt(a+1),isNaN(c)||c===92))}e.isUNC=C;const b=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(o,c=n.isWindows){const a=c?b:m;return!(!o||o.length===0||/^\s+$/.test(o)||(a.lastIndex=0,a.test(o))||c&&p.test(o)||o==="."||o===".."||c&&o[o.length-1]==="."||c&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=h;function y(o,c,a){const u=o===c;return!a||u?u:!o||!c?!1:(0,D.equalsIgnoreCase)(o,c)}e.isEqual=y;function f(o,c,a,u=A.sep){if(o===c)return!0;if(!o||!c||c.length>o.length)return!1;if(a){if(!(0,D.startsWithIgnoreCase)(o,c))return!1;if(c.length===o.length)return!0;let E=c.length;return c.charAt(c.length-1)===u&&E--,o.charAt(E)===u}return c.charAt(c.length-1)!==u&&(c+=u),o.indexOf(c)===0}e.isEqualOrParent=f;function l(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=l;function d(o,c){return n.isWindows&&o.endsWith(":")&&(o+=A.sep),(0,A.isAbsolute)(o)||(o=(0,A.join)(c,o)),o=(0,A.normalize)(o),n.isWindows?(o=(0,D.rtrim)(o,A.sep),o.endsWith(":")&&(o+=A.sep)):(o=(0,D.rtrim)(o,A.sep),o||(o=A.sep)),o}e.sanitizeFilePath=d;function g(o){const c=(0,A.normalize)(o);return n.isWindows?o.length>3?!1:v(c)&&(o.length===2||c.charCodeAt(2)===92):c===A.posix.sep}e.isRootOrDriveLetter=g;function v(o,c=n.isWindows){return c?l(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=v;function I(o){return v(o)?o[0]:void 0}e.getDriveLetter=I;function i(o,c,a){return c.length>o.length?-1:o===c?0:(a&&(o=o.toLowerCase(),c=c.toLowerCase()),o.indexOf(c))}e.indexOfPath=i;function r(o){const c=o.split(":");let a,u,w;for(const E of c){const N=Number(E);(0,k.isNumber)(N)?u===void 0?u=N:w===void 0&&(w=N):a=a?[a,E].join(":"):E}if(!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:u!==void 0?u:void 0,column:w!==void 0?w:u!==void 0?1:void 0}}e.parseLineAndColumnAware=r;const t="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function s(o,c,a=8){let u="";for(let E=0;E<a;E++)u+=t.charAt(Math.floor(Math.random()*t.length));let w;return c?w=`${c}-${u}`:w=u,o?(0,A.join)(o,w):w}e.randomPath=s}),define(re[66],ae([0,1,27]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function n(l){return D(l,0)}e.hash=n;function D(l,d){switch(typeof l){case"object":return l===null?k(349,d):Array.isArray(l)?P(l,d):S(l,d);case"string":return R(l,d);case"boolean":return T(l,d);case"number":return k(l,d);case"undefined":return k(937,d);default:return k(617,d)}}e.doHash=D;function k(l,d){return(d<<5)-d+l|0}e.numberHash=k;function T(l,d){return k(l?433:863,d)}function R(l,d){d=k(149417,d);for(let g=0,v=l.length;g<v;g++)d=k(l.charCodeAt(g),d);return d}e.stringHash=R;function P(l,d){return d=k(104579,d),l.reduce((g,v)=>D(v,g),d)}function S(l,d){return d=k(181387,d),Object.keys(l).sort().reduce((g,v)=>(g=R(v,g),D(l[v],g)),d)}class C{constructor(){this.g=0}get value(){return this.g}hash(d){return this.g=D(d,this.g),this.g}}e.Hasher=C;var b;(function(l){l[l.BLOCK_SIZE=64]="BLOCK_SIZE",l[l.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(b||(b={}));function m(l,d,g=32){const v=g-d,I=~((1<<v)-1);return(l<<d|(I&l)>>>v)>>>0}function p(l,d=0,g=l.byteLength,v=0){for(let I=0;I<g;I++)l[d+I]=v}function h(l,d,g="0"){for(;l.length<d;)l=g+l;return l}function y(l,d=32){return l instanceof ArrayBuffer?Array.from(new Uint8Array(l)).map(g=>g.toString(16).padStart(2,"0")).join(""):h((l>>>0).toString(16),d/4)}e.toHexString=y;class f{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(d){const g=d.length;if(g===0)return;const v=this.p;let I=this.r,i=this.u,r,t;for(i!==0?(r=i,t=-1,i=0):(r=d.charCodeAt(0),t=0);;){let s=r;if(A.isHighSurrogate(r))if(t+1<g){const o=d.charCodeAt(t+1);A.isLowSurrogate(o)?(t++,s=A.computeCodePoint(r,o)):s=65533}else{i=r;break}else A.isLowSurrogate(r)&&(s=65533);if(I=this.w(v,I,s),t++,t<g)r=d.charCodeAt(t);else break}this.r=I,this.u=i}w(d,g,v){return v<128?d[g++]=v:v<2048?(d[g++]=192|(v&1984)>>>6,d[g++]=128|(v&63)>>>0):v<65536?(d[g++]=224|(v&61440)>>>12,d[g++]=128|(v&4032)>>>6,d[g++]=128|(v&63)>>>0):(d[g++]=240|(v&1835008)>>>18,d[g++]=128|(v&258048)>>>12,d[g++]=128|(v&4032)>>>6,d[g++]=128|(v&63)>>>0),g>=64&&(this.y(),g-=64,this.t+=64,d[0]=d[64+0],d[1]=d[64+1],d[2]=d[64+2]),g}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),y(this.h)+y(this.l)+y(this.m)+y(this.n)+y(this.o)}x(){this.p[this.r++]=128,p(this.p,this.r),this.r>56&&(this.y(),p(this.p));const d=8*this.t;this.q.setUint32(56,Math.floor(d/4294967296),!1),this.q.setUint32(60,d%4294967296,!1),this.y()}y(){const d=f.g,g=this.q;for(let a=0;a<64;a+=4)d.setUint32(a,g.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)d.setUint32(a,m(d.getUint32(a-12,!1)^d.getUint32(a-32,!1)^d.getUint32(a-56,!1)^d.getUint32(a-64,!1),1),!1);let v=this.h,I=this.l,i=this.m,r=this.n,t=this.o,s,o,c;for(let a=0;a<80;a++)a<20?(s=I&i|~I&r,o=1518500249):a<40?(s=I^i^r,o=1859775393):a<60?(s=I&i|I&r|i&r,o=2400959708):(s=I^i^r,o=3395469782),c=m(v,5)+s+t+o+d.getUint32(a*4,!1)&4294967295,t=r,r=i,i=m(I,30),I=v,v=c;this.h=this.h+v&4294967295,this.l=this.l+I&4294967295,this.m=this.m+i&4294967295,this.n=this.n+r&4294967295,this.o=this.o+t&4294967295}}e.StringSHA1=f,f.g=new DataView(new ArrayBuffer(320))}),define(re[89],ae([0,1,27]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var n;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(n||(n={})),function(D){const k="error",T="warning",R="warn",P="info",S="ignore";function C(m){return m?A.equalsIgnoreCase(k,m)?D.Error:A.equalsIgnoreCase(T,m)||A.equalsIgnoreCase(R,m)?D.Warning:A.equalsIgnoreCase(P,m)?D.Info:D.Ignore:D.Ignore}D.fromValue=C;function b(m){switch(m){case D.Error:return k;case D.Warning:return T;case D.Info:return P;default:return S}}D.toString=b}(n||(n={})),e.default=n}),define(re[49],ae([0,1,21,27]),function(_,e,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class D{constructor(){this.b="",this.c=0}reset(p){return this.b=p,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(p){const h=p.charCodeAt(0),y=this.b.charCodeAt(this.c);return h-y}value(){return this.b[this.c]}}e.StringIterator=D;class k{constructor(p=!0){this.e=p}reset(p){return this.b=p,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let p=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(p)this.c++;else break;else p=!1;return this}cmp(p){return this.e?(0,n.compareSubstring)(p,this.b,0,p.length,this.c,this.d):(0,n.compareSubstringIgnoreCase)(p,this.b,0,p.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=k;class T{constructor(p=!0,h=!0){this.f=p,this.g=h}reset(p){this.d=0,this.e=0,this.b=p,this.c=p.length;for(let h=p.length-1;h>=0;h--,this.c--){const y=this.b.charCodeAt(h);if(!(y===47||this.f&&y===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let p=!0;for(;this.e<this.c;this.e++){const h=this.b.charCodeAt(this.e);if(h===47||this.f&&h===92)if(p)this.d++;else break;else p=!1}return this}cmp(p){return this.g?(0,n.compareSubstring)(p,this.b,0,p.length,this.d,this.e):(0,n.compareSubstringIgnoreCase)(p,this.b,0,p.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=T;var R;(function(m){m[m.Scheme=1]="Scheme",m[m.Authority=2]="Authority",m[m.Path=3]="Path",m[m.Query=4]="Query",m[m.Fragment=5]="Fragment"})(R||(R={}));class P{constructor(p,h){this.f=p,this.g=h,this.d=[],this.e=0}reset(p){return this.c=p,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new T(!1,!this.f(p)),this.b.reset(p.path),this.b.value()&&this.d.push(3)),this.g(p)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(p){if(this.d[this.e]===1)return(0,n.compareIgnoreCase)(p,this.c.scheme);if(this.d[this.e]===2)return(0,n.compareIgnoreCase)(p,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(p);if(this.d[this.e]===4)return(0,n.compare)(p,this.c.query);if(this.d[this.e]===5)return(0,n.compare)(p,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=P;class S{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const p=this.right;return this.right=p.left,p.left=this,this.updateHeight(),p.updateHeight(),p}rotateRight(){const p=this.left;return this.left=p.right,p.right=this,this.updateHeight(),p.updateHeight(),p}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var C;(function(m){m[m.Left=-1]="Left",m[m.Mid=0]="Mid",m[m.Right=1]="Right"})(C||(C={}));class b{static forUris(p=()=>!1,h=()=>!1){return new b(new P(p,h))}static forPaths(p=!1){return new b(new T(void 0,!p))}static forStrings(){return new b(new D)}static forConfigKeys(){return new b(new k)}constructor(p){this.b=p}clear(){this.c=void 0}fill(p,h){if(h){const y=h.slice(0);(0,A.shuffle)(y);for(const f of y)this.set(f,p)}else{const y=p.slice(0);(0,A.shuffle)(y);for(const f of y)this.set(f[0],f[1])}}set(p,h){const y=this.b.reset(p);let f;this.c||(this.c=new S,this.c.segment=y.value());const l=[];for(f=this.c;;){const g=y.cmp(f.segment);if(g>0)f.left||(f.left=new S,f.left.segment=y.value()),l.push([-1,f]),f=f.left;else if(g<0)f.right||(f.right=new S,f.right.segment=y.value()),l.push([1,f]),f=f.right;else if(y.hasNext())y.next(),f.mid||(f.mid=new S,f.mid.segment=y.value()),l.push([0,f]),f=f.mid;else break}const d=f.value;f.value=h,f.key=p;for(let g=l.length-1;g>=0;g--){const v=l[g][1];v.updateHeight();const I=v.balanceFactor();if(I<-1||I>1){const i=l[g][0],r=l[g+1][0];if(i===1&&r===1)l[g][1]=v.rotateLeft();else if(i===-1&&r===-1)l[g][1]=v.rotateRight();else if(i===1&&r===-1)v.right=l[g+1][1]=l[g+1][1].rotateRight(),l[g][1]=v.rotateLeft();else if(i===-1&&r===1)v.left=l[g+1][1]=l[g+1][1].rotateLeft(),l[g][1]=v.rotateRight();else throw new Error;if(g>0)switch(l[g-1][0]){case-1:l[g-1][1].left=l[g][1];break;case 1:l[g-1][1].right=l[g][1];break;case 0:l[g-1][1].mid=l[g][1];break}else this.c=l[0][1]}}return d}get(p){return this.d(p)?.value}d(p){const h=this.b.reset(p);let y=this.c;for(;y;){const f=h.cmp(y.segment);if(f>0)y=y.left;else if(f<0)y=y.right;else if(h.hasNext())h.next(),y=y.mid;else break}return y}has(p){const h=this.d(p);return!(h?.value===void 0&&h?.mid===void 0)}delete(p){return this.e(p,!1)}deleteSuperstr(p){return this.e(p,!0)}e(p,h){const y=this.b.reset(p),f=[];let l=this.c;for(;l;){const d=y.cmp(l.segment);if(d>0)f.push([-1,l]),l=l.left;else if(d<0)f.push([1,l]),l=l.right;else if(y.hasNext())y.next(),f.push([0,l]),l=l.mid;else break}if(!!l){if(h?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const d=this.f(l.right);if(d.key){const{key:g,value:v,segment:I}=d;this.e(d.key,!1),l.key=g,l.value=v,l.segment=I}}else{const d=l.left??l.right;if(f.length>0){const[g,v]=f[f.length-1];switch(g){case-1:v.left=d;break;case 0:v.mid=d;break;case 1:v.right=d;break}}else this.c=d}for(let d=f.length-1;d>=0;d--){const g=f[d][1];g.updateHeight();const v=g.balanceFactor();if(v>1?(g.right.balanceFactor()>=0||(g.right=g.right.rotateRight()),f[d][1]=g.rotateLeft()):v<-1&&(g.left.balanceFactor()<=0||(g.left=g.left.rotateLeft()),f[d][1]=g.rotateRight()),d>0)switch(f[d-1][0]){case-1:f[d-1][1].left=f[d][1];break;case 1:f[d-1][1].right=f[d][1];break;case 0:f[d-1][1].mid=f[d][1];break}else this.c=f[0][1]}}}f(p){for(;p.left;)p=p.left;return p}findSubstr(p){const h=this.b.reset(p);let y=this.c,f;for(;y;){const l=h.cmp(y.segment);if(l>0)y=y.left;else if(l<0)y=y.right;else if(h.hasNext())h.next(),f=y.value||f,y=y.mid;else break}return y&&y.value||f}findSuperstr(p){return this.g(p,!1)}g(p,h){const y=this.b.reset(p);let f=this.c;for(;f;){const l=y.cmp(f.segment);if(l>0)f=f.left;else if(l<0)f=f.right;else if(y.hasNext())y.next(),f=f.mid;else return f.mid?this.h(f.mid):h?f.value:void 0}}hasElementOrSubtree(p){return this.g(p,!0)!==void 0}forEach(p){for(const[h,y]of this)p(y,h)}*[Symbol.iterator](){yield*this.h(this.c)}h(p){const h=[];return this.j(p,h),h[Symbol.iterator]()}j(p,h){!p||(p.left&&this.j(p.left,h),p.value&&h.push([p.key,p.value]),p.mid&&this.j(p.mid,h),p.right&&this.j(p.right,h))}_isBalanced(){const p=h=>{if(!h)return!0;const y=h.balanceFactor();return y<-1||y>1?!1:p(h.left)&&p(h.right)};return p(this.c)}}e.TernarySearchTree=b}),define(re[8],ae([0,1,12,5]),function(_,e,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,k=/^\//,T=/^\/\//;function R(t,s){if(!t.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${t.authority}", path: "${t.path}", query: "${t.query}", fragment: "${t.fragment}"}`);if(t.scheme&&!D.test(t.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(t.path){if(t.authority){if(!k.test(t.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(T.test(t.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function P(t,s){return!t&&!s?"file":t}function S(t,s){switch(t){case"https":case"http":case"file":s?s[0]!==b&&(s=b+s):s=b;break}return s}const C="",b="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class p{static isUri(s){return s instanceof p?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}constructor(s,o,c,a,u,w=!1){typeof s=="object"?(this.scheme=s.scheme||C,this.authority=s.authority||C,this.path=s.path||C,this.query=s.query||C,this.fragment=s.fragment||C):(this.scheme=P(s,w),this.authority=o||C,this.path=S(this.scheme,c||C),this.query=a||C,this.fragment=u||C,R(this,w))}get fsPath(){return g(this,!1)}with(s){if(!s)return this;let{scheme:o,authority:c,path:a,query:u,fragment:w}=s;return o===void 0?o=this.scheme:o===null&&(o=C),c===void 0?c=this.authority:c===null&&(c=C),a===void 0?a=this.path:a===null&&(a=C),u===void 0?u=this.query:u===null&&(u=C),w===void 0?w=this.fragment:w===null&&(w=C),o===this.scheme&&c===this.authority&&a===this.path&&u===this.query&&w===this.fragment?this:new y(o,c,a,u,w)}static parse(s,o=!1){const c=m.exec(s);return c?new y(c[2]||C,r(c[4]||C),r(c[5]||C),r(c[7]||C),r(c[9]||C),o):new y(C,C,C,C,C)}static file(s){let o=C;if(n.isWindows&&(s=s.replace(/\\/g,b)),s[0]===b&&s[1]===b){const c=s.indexOf(b,2);c===-1?(o=s.substring(2),s=b):(o=s.substring(2,c),s=s.substring(c)||b)}return new y("file",o,s,C,C)}static from(s){const o=new y(s.scheme,s.authority,s.path,s.query,s.fragment);return R(o,!0),o}static joinPath(s,...o){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return n.isWindows&&s.scheme==="file"?c=p.file(A.win32.join(g(s,!0),...o)).path:c=A.posix.join(s.path,...o),s.with({path:c})}toString(s=!1){return v(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof p)return s;{const o=new y(s);return o._formatted=s.external,o._fsPath=s._sep===h?s.fsPath:null,o}}else return s}}e.URI=p;const h=n.isWindows?1:void 0;class y extends p{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=g(this,!1)),this._fsPath}toString(s=!1){return s?v(this,!0):(this._formatted||(this._formatted=v(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=h),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const f={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function l(t,s,o){let c,a=-1;for(let u=0;u<t.length;u++){const w=t.charCodeAt(u);if(w>=97&&w<=122||w>=65&&w<=90||w>=48&&w<=57||w===45||w===46||w===95||w===126||s&&w===47||o&&w===91||o&&w===93||o&&w===58)a!==-1&&(c+=encodeURIComponent(t.substring(a,u)),a=-1),c!==void 0&&(c+=t.charAt(u));else{c===void 0&&(c=t.substr(0,u));const E=f[w];E!==void 0?(a!==-1&&(c+=encodeURIComponent(t.substring(a,u)),a=-1),c+=E):a===-1&&(a=u)}}return a!==-1&&(c+=encodeURIComponent(t.substring(a))),c!==void 0?c:t}function d(t){let s;for(let o=0;o<t.length;o++){const c=t.charCodeAt(o);c===35||c===63?(s===void 0&&(s=t.substr(0,o)),s+=f[c]):s!==void 0&&(s+=t[o])}return s!==void 0?s:t}function g(t,s){let o;return t.authority&&t.path.length>1&&t.scheme==="file"?o=`//${t.authority}${t.path}`:t.path.charCodeAt(0)===47&&(t.path.charCodeAt(1)>=65&&t.path.charCodeAt(1)<=90||t.path.charCodeAt(1)>=97&&t.path.charCodeAt(1)<=122)&&t.path.charCodeAt(2)===58?s?o=t.path.substr(1):o=t.path[1].toLowerCase()+t.path.substr(2):o=t.path,n.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=g;function v(t,s){const o=s?d:l;let c="",{scheme:a,authority:u,path:w,query:E,fragment:N}=t;if(a&&(c+=a,c+=":"),(u||a==="file")&&(c+=b,c+=b),u){let O=u.indexOf("@");if(O!==-1){const j=u.substr(0,O);u=u.substr(O+1),O=j.lastIndexOf(":"),O===-1?c+=o(j,!1,!1):(c+=o(j.substr(0,O),!1,!1),c+=":",c+=o(j.substr(O+1),!1,!0)),c+="@"}u=u.toLowerCase(),O=u.lastIndexOf(":"),O===-1?c+=o(u,!1,!0):(c+=o(u.substr(0,O),!1,!0),c+=u.substr(O))}if(w){if(w.length>=3&&w.charCodeAt(0)===47&&w.charCodeAt(2)===58){const O=w.charCodeAt(1);O>=65&&O<=90&&(w=`/${String.fromCharCode(O+32)}:${w.substr(3)}`)}else if(w.length>=2&&w.charCodeAt(1)===58){const O=w.charCodeAt(0);O>=65&&O<=90&&(w=`${String.fromCharCode(O+32)}:${w.substr(2)}`)}c+=o(w,!0,!1)}return E&&(c+="?",c+=o(E,!1,!1)),N&&(c+="#",c+=s?N:l(N,!1,!1)),c}function I(t){try{return decodeURIComponent(t)}catch{return t.length>3?t.substr(0,3)+I(t.substr(3)):t}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(t){return t.match(i)?t.replace(i,s=>I(s)):t}}),define(re[143],ae([0,1,8]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function n(S){const C=S;return C&&typeof C.type=="string"&&typeof C.severity=="string"}e.isRemoteConsoleLog=n;function D(S){const C=[];let b;try{const m=JSON.parse(S.arguments),p=m[m.length-1];p&&p.__$stack&&(m.pop(),b=p.__$stack),C.push(...m)}catch{C.push("Unable to log remote console arguments",S.arguments)}return{args:C,stack:b}}e.parse=D;function k(S){if(typeof S!="string")return k(D(S).stack);const C=S;if(C){const b=T(C),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(b||"");if(m&&m.length===4)return{uri:A.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.getFirstFrame=k;function T(S){if(!S)return S;const C=S.indexOf(`
`);return C===-1?S:S.substring(0,C)}function R(S,C){const{args:b,stack:m}=D(S),p=typeof b[0]=="string"&&b.length===1;let h=T(m);h&&(h=`(${h.trim()})`);let y=[];if(typeof b[0]=="string"?h&&p?y=[`%c[${C}] %c${b[0]} %c${h}`,P("blue"),P(""),P("grey")]:y=[`%c[${C}] %c${b[0]}`,P("blue"),P(""),...b.slice(1)]:y=[`%c[${C}]%`,P("blue"),...b],h&&!p&&y.push(h),typeof console[S.severity]!="function")throw new Error("Unknown console method");console[S.severity].apply(console,y)}e.log=R;function P(S){return`color: ${S}`}}),define(re[67],ae([0,1,17,27,8]),function(_,e,A,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function k(S){return JSON.stringify(S,R)}e.stringify=k;function T(S){let C=JSON.parse(S);return C=P(C),C}e.parse=T;function R(S,C){return C instanceof RegExp?{$mid:2,source:C.source,flags:(0,n.regExpFlags)(C)}:C}function P(S,C=0){if(!S||C>200)return S;if(typeof S=="object"){switch(S.$mid){case 1:return D.URI.revive(S);case 2:return new RegExp(S.source,S.flags);case 16:return new Date(S.source)}if(S instanceof A.VSBuffer||S instanceof Uint8Array)return S;if(Array.isArray(S))for(let b=0;b<S.length;++b)S[b]=P(S[b],C+1);else for(const b in S)Object.hasOwnProperty.call(S,b)&&(S[b]=P(S[b],C+1))}return S}e.revive=P}),define(re[24],ae([0,1,7,5,8]),function(_,e,A,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var k;(function(S){S.inMemory="inmemory",S.vscode="vscode",S.internal="private",S.walkThrough="walkThrough",S.walkThroughSnippet="walkThroughSnippet",S.http="http",S.https="https",S.file="file",S.mailto="mailto",S.untitled="untitled",S.data="data",S.command="command",S.vscodeRemote="vscode-remote",S.vscodeRemoteResource="vscode-remote-resource",S.vscodeUserData="vscode-userdata",S.vscodeCustomEditor="vscode-custom-editor",S.vscodeNotebook="vscode-notebook",S.vscodeNotebookCell="vscode-notebook-cell",S.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",S.vscodeNotebookCellOutput="vscode-notebook-cell-output",S.vscodeInteractive="vscode-interactive",S.vscodeInteractiveInput="vscode-interactive-input",S.vscodeSettings="vscode-settings",S.vscodeWorkspaceTrust="vscode-workspace-trust",S.vscodeTerminal="vscode-terminal",S.webviewPanel="webview-panel",S.vscodeWebview="vscode-webview",S.extension="extension",S.vscodeFileResource="vscode-file",S.tmp="tmp",S.vsls="vsls",S.vscodeSourceControl="vscode-scm"})(k=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class T{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${k.vscodeRemoteResource}`}setPreferredWebSchema(C){this.d=C}setDelegate(C){this.e=C}setServerRootPath(C){this.f=`${C}/${k.vscodeRemoteResource}`}set(C,b,m){this.a[C]=b,this.b[C]=m}setConnectionToken(C,b){this.c[C]=b}getPreferredWebSchema(){return this.d}rewrite(C){if(this.e)try{return this.e(C)}catch(f){return A.onUnexpectedError(f),C}const b=C.authority;let m=this.a[b];m&&m.indexOf(":")!==-1&&m.indexOf("[")===-1&&(m=`[${m}]`);const p=this.b[b],h=this.c[b];let y=`path=${encodeURIComponent(C.path)}`;return typeof h=="string"&&(y+=`&${e.connectionTokenQueryName}=${encodeURIComponent(h)}`),D.URI.from({scheme:n.isWeb?this.d:k.vscodeRemoteResource,authority:`${m}:${p}`,path:this.f,query:y})}}e.RemoteAuthorities=new T,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class R{asBrowserUri(C){const b=this.b(C,_);return this.uriToBrowserUri(b)}uriToBrowserUri(C){return C.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(C):C.scheme===k.file&&(n.isNative||n.isWebWorker&&n.globals.origin===`${k.vscodeFileResource}://${R.a}`)?C.with({scheme:k.vscodeFileResource,authority:C.authority||R.a,query:null,fragment:null}):C}asFileUri(C){const b=this.b(C,_);return this.uriToFileUri(b)}uriToFileUri(C){return C.scheme===k.vscodeFileResource?C.with({scheme:k.file,authority:C.authority!==R.a?C.authority:null,query:null,fragment:null}):C}b(C,b){return D.URI.isUri(C)?C:D.URI.parse(b.toUrl(C))}}R.a="vscode-app",e.FileAccess=new R;var P;(function(S){const C=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);S.CoopAndCoep=Object.freeze(C.get("3"));const b="vscode-coi";function m(h){let y;typeof h=="string"?y=new URL(h).searchParams:h instanceof URL?y=h.searchParams:D.URI.isUri(h)&&(y=new URL(h.toString(!0)).searchParams);const f=y?.get(b);if(!!f)return C.get(f)}S.getHeadersFromQuery=m;function p(h,y,f){if(!globalThis.crossOriginIsolated)return;const l=y&&f?"3":f?"2":"1";h instanceof URLSearchParams?h.set(b,l):h[b]=l}S.addSearchParam=p})(P=e.COI||(e.COI={}))}),define(re[22],ae([0,1,48,24,12,5,27,8]),function(_,e,A,n,D,k,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function P(p){return(0,R.uriToFsPath)(p,!0)}e.originalFSPath=P;class S{constructor(h){this.a=h}compare(h,y,f=!1){return h===y?0:(0,T.compare)(this.getComparisonKey(h,f),this.getComparisonKey(y,f))}isEqual(h,y,f=!1){return h===y?!0:!h||!y?!1:this.getComparisonKey(h,f)===this.getComparisonKey(y,f)}getComparisonKey(h,y=!1){return h.with({path:this.a(h)?h.path.toLowerCase():void 0,fragment:y?null:void 0}).toString()}ignorePathCasing(h){return this.a(h)}isEqualOrParent(h,y,f=!1){if(h.scheme===y.scheme){if(h.scheme===n.Schemas.file)return A.isEqualOrParent(P(h),P(y),this.a(h))&&h.query===y.query&&(f||h.fragment===y.fragment);if((0,e.isEqualAuthority)(h.authority,y.authority))return A.isEqualOrParent(h.path,y.path,this.a(h),"/")&&h.query===y.query&&(f||h.fragment===y.fragment)}return!1}joinPath(h,...y){return R.URI.joinPath(h,...y)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return D.posix.basename(h.path)}extname(h){return D.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let y;return h.scheme===n.Schemas.file?y=R.URI.file(D.dirname(P(h))).path:(y=D.posix.dirname(h.path),h.authority&&y.length&&y.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),y="/")),h.with({path:y})}normalizePath(h){if(!h.path.length)return h;let y;return h.scheme===n.Schemas.file?y=R.URI.file(D.normalize(P(h))).path:y=D.posix.normalize(h.path),h.with({path:y})}relativePath(h,y){if(h.scheme!==y.scheme||!(0,e.isEqualAuthority)(h.authority,y.authority))return;if(h.scheme===n.Schemas.file){const d=D.relative(P(h),P(y));return k.isWindows?A.toSlashes(d):d}let f=h.path||"/";const l=y.path||"/";if(this.a(h)){let d=0;for(const g=Math.min(f.length,l.length);d<g&&!(f.charCodeAt(d)!==l.charCodeAt(d)&&f.charAt(d).toLowerCase()!==l.charAt(d).toLowerCase());d++);f=l.substr(0,d)+f.substr(d)}return D.posix.relative(f,l)}resolvePath(h,y){if(h.scheme===n.Schemas.file){const f=R.URI.file(D.resolve(P(h),y));return h.with({authority:f.authority,path:f.path})}return y=A.toPosixPath(y),h.with({path:D.posix.resolve(h.path,y)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,y){return h===y||h!==void 0&&y!==void 0&&(0,T.equalsIgnoreCase)(h,y)}hasTrailingPathSeparator(h,y=D.sep){if(h.scheme===n.Schemas.file){const f=P(h);return f.length>A.getRoot(f).length&&f[f.length-1]===y}else{const f=h.path;return f.length>1&&f.charCodeAt(f.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,y=D.sep){return(0,e.hasTrailingPathSeparator)(h,y)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,y=D.sep){let f=!1;if(h.scheme===n.Schemas.file){const l=P(h);f=l!==void 0&&l.length===A.getRoot(l).length&&l[l.length-1]===y}else{y="/";const l=h.path;f=l.length===1&&l.charCodeAt(l.length-1)===47}return!f&&!(0,e.hasTrailingPathSeparator)(h,y)?h.with({path:h.path+"/"}):h}}e.ExtUri=S,e.extUri=new S(()=>!1),e.extUriBiasedIgnorePathCase=new S(p=>p.scheme===n.Schemas.file?!k.isLinux:!0),e.extUriIgnorePathCase=new S(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function C(p,h){const y=[];for(let f=0;f<p.length;f++){const l=h(p[f]);p.some((d,g)=>g===f?!1:(0,e.isEqualOrParent)(l,h(d)))||y.push(p[f])}return y}e.distinctParents=C;var b;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function h(y){const f=new Map;y.path.substring(y.path.indexOf(";")+1,y.path.lastIndexOf(";")).split(";").forEach(g=>{const[v,I]=g.split(":");v&&I&&f.set(v,I)});const d=y.path.substring(0,y.path.indexOf(";"));return d&&f.set(p.META_DATA_MIME,d),f}p.parseMetaData=h})(b=e.DataUri||(e.DataUri={}));function m(p,h,y){if(h){let f=p.path;return f&&f[0]!==D.posix.sep&&(f=D.posix.sep+f),p.with({scheme:y,authority:h,path:f})}return p.with({scheme:y})}e.toLocalResource=m}),define(re[6],ae([0,1,23,7,3,2,22,5]),function(_,e,A,n,D,k,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function P(te){return!!te&&typeof te.then=="function"}e.isThenable=P;function S(te){const U=new A.CancellationTokenSource,$=te(U.token),q=new Promise((B,x)=>{const ee=U.token.onCancellationRequested(()=>{ee.dispose(),U.dispose(),x(new n.CancellationError)});Promise.resolve($).then(J=>{ee.dispose(),U.dispose(),B(J)},J=>{ee.dispose(),U.dispose(),x(J)})});return new class{cancel(){U.cancel()}then(B,x){return q.then(B,x)}catch(B){return this.then(void 0,B)}finally(B){return q.finally(B)}}}e.createCancelablePromise=S;function C(te,U,$){return new Promise((q,B)=>{const x=U.onCancellationRequested(()=>{x.dispose(),q($)});te.then(q,B).finally(()=>x.dispose())})}e.raceCancellation=C;function b(te,U){return new Promise(($,q)=>{const B=U.onCancellationRequested(()=>{B.dispose(),q(new n.CancellationError)});te.then($,q).finally(()=>B.dispose())})}e.raceCancellationError=b;async function m(te){let U=-1;const $=te.map((B,x)=>B.then(ee=>(U=x,ee))),q=await Promise.race($);return te.forEach((B,x)=>{x!==U&&B.cancel()}),q}e.raceCancellablePromises=m;function p(te,U,$){let q;const B=setTimeout(()=>{q?.(void 0),$?.()},U);return Promise.race([te.finally(()=>clearTimeout(B)),new Promise(x=>q=x)])}e.raceTimeout=p;function h(te){return new Promise((U,$)=>{const q=te();P(q)?q.then(U,$):U(q)})}e.asPromise=h;class y{constructor(){this.a=null,this.b=null,this.d=null}queue(U){if(this.a){if(this.d=U,!this.b){const $=()=>{this.b=null;const q=this.queue(this.d);return this.d=null,q};this.b=new Promise(q=>{this.a.then($,$).then(q)})}return new Promise(($,q)=>{this.b.then($,q)})}return this.a=U(),new Promise(($,q)=>{this.a.then(B=>{this.a=null,$(B)},B=>{this.a=null,q(B)})})}}e.Throttler=y;class f{constructor(){this.a=Promise.resolve(null)}queue(U){return this.a=this.a.then(()=>U(),()=>U())}}e.Sequencer=f;class l{constructor(){this.a=new Map}queue(U,$){const B=(this.a.get(U)??Promise.resolve()).catch(()=>{}).then($).finally(()=>{this.a.get(U)===B&&this.a.delete(U)});return this.a.set(U,B),B}}e.SequencerByKey=l;const d=(te,U)=>{let $=!0;const q=setTimeout(()=>{$=!1,U()},te);return{isTriggered:()=>$,dispose:()=>{clearTimeout(q),$=!1}}},g=te=>{let U=!0;return queueMicrotask(()=>{U&&(U=!1,te())}),{isTriggered:()=>U,dispose:()=>{U=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class v{constructor(U){this.defaultDelay=U,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(U,$=this.defaultDelay){this.g=U,this.h(),this.b||(this.b=new Promise((B,x)=>{this.d=B,this.f=x}).then(()=>{if(this.b=null,this.d=null,this.g){const B=this.g;return this.g=null,B()}}));const q=()=>{this.a=null,this.d?.(null)};return this.a=$===e.MicrotaskDelay?g(q):d($,q),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new n.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=v;class I{constructor(U){this.a=new v(U),this.b=new y}trigger(U,$){return this.a.trigger(()=>this.b.queue(U),$)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=I;class i{constructor(){this.a=!1,this.b=new Promise((U,$)=>{this.d=U})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=i;class r extends i{constructor(U){super(),this.f=setTimeout(()=>this.open(),U)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=r;function t(te,U){return U?new Promise(($,q)=>{const B=setTimeout(()=>{x.dispose(),$()},te),x=U.onCancellationRequested(()=>{clearTimeout(B),x.dispose(),q(new n.CancellationError)})}):S($=>t(te,$))}e.timeout=t;function s(te,U=0){const $=setTimeout(te,U);return(0,k.toDisposable)(()=>clearTimeout($))}e.disposableTimeout=s;function o(te){const U=[];let $=0;const q=te.length;function B(){return $<q?te[$++]():null}function x(ee){ee!=null&&U.push(ee);const J=B();return J?J.then(x):Promise.resolve(U)}return Promise.resolve(null).then(x)}e.sequence=o;function c(te,U=q=>!!q,$=null){let q=0;const B=te.length,x=()=>{if(q>=B)return Promise.resolve($);const ee=te[q++];return Promise.resolve(ee()).then(Z=>U(Z)?Promise.resolve(Z):x())};return x()}e.first=c;function a(te,U=q=>!!q,$=null){if(te.length===0)return Promise.resolve($);let q=te.length;const B=()=>{q=-1;for(const x of te)x.cancel?.()};return new Promise((x,ee)=>{for(const J of te)J.then(Z=>{--q>=0&&U(Z)?(B(),x(Z)):q===0&&x($)}).catch(Z=>{--q>=0&&(B(),ee(Z))})})}e.firstParallel=a;class u{constructor(U){this.a=0,this.d=U,this.f=[],this.b=0,this.g=new D.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(U){return this.a++,new Promise(($,q)=>{this.f.push({factory:U,c:$,e:q}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const U=this.f.shift();this.b++;const $=U.factory();$.then(U.c,U.e),$.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=u;class w extends u{constructor(){super(1)}}e.Queue=w;class E{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const U=new V;return this.b.add(U),U.p}d(){for(const[,U]of this.a)if(U.size>0)return!1;return!0}queueFor(U,$=T.extUri){const q=$.getComparisonKey(U);let B=this.a.get(q);return B||(B=new w,D.Event.once(B.onDrained)(()=>{B?.dispose(),this.a.delete(q),this.f()}),this.a.set(q,B)),B}f(){!this.d()||this.g()}g(){for(const U of this.b)U.complete();this.b.clear()}dispose(){for(const[,U]of this.a)U.dispose();this.a.clear(),this.g()}}e.ResourceQueue=E;class N{constructor(U,$){this.a=-1,typeof U=="function"&&typeof $=="number"&&this.setIfNotSet(U,$)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(U,$){this.cancel(),this.a=setTimeout(()=>{this.a=-1,U()},$)}setIfNotSet(U,$){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,U()},$))}}e.TimeoutTimer=N;class O{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(U,$){this.cancel(),this.a=setInterval(()=>{U()},$)}}e.IntervalTimer=O;class j{constructor(U,$){this.b=-1,this.a=U,this.d=$,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(U=this.d){this.cancel(),this.b=setTimeout(this.f,U)}get delay(){return this.d}set delay(U){this.d=U}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=j;class M{constructor(U,$){$%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${$}ms is not a multiple of 1000ms.`),this.a=U,this.b=$,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(U=this.b){U%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(U/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=M;class L extends j{constructor(U,$){super(U,$),this.j=[]}work(U){this.j.push(U),this.isScheduled()||this.schedule()}h(){const U=this.j;this.j=[],this.a?.(U)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=L;class F extends k.Disposable{constructor(U,$){super(),this.g=U,this.h=$,this.a=[],this.b=this.B(new k.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(U){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+U.length>this.g.maxBufferedWork)return!1}else if(this.pending+U.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const $ of U)this.a.push($);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new j(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=F,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=te=>{(0,R.setTimeout0)(()=>{if(U)return;const $=Date.now()+15;te(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,$-Date.now())}}))});let U=!1;return{dispose(){U||(U=!0)}}}:e.runWhenIdle=(te,U)=>{const $=requestIdleCallback(te,typeof U=="number"?{timeout:U}:void 0);let q=!1;return{dispose(){q||(q=!0,cancelIdleCallback($))}}}}();class z{constructor(U){this.d=!1,this.a=()=>{try{this.f=U()}catch($){this.g=$}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=z;async function H(te,U,$){let q;for(let B=0;B<$;B++)try{return await te()}catch(x){q=x,await t(U)}throw q}e.retry=H;class Q{hasPending(U){return this.a?typeof U=="number"?this.a.taskId===U:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(U,$,q){return this.a={taskId:U,cancel:()=>q?.(),promise:$},$.then(()=>this.d(U),()=>this.d(U)),$}d(U){this.a&&U===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const U=this.b;this.b=void 0,U.run().then(U.promiseResolve,U.promiseReject)}}setNext(U){if(this.b)this.b.run=U;else{let $,q;const B=new Promise((x,ee)=>{$=x,q=ee});this.b={run:U,promise:B,promiseResolve:$,promiseReject:q}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=Q;class K{constructor(U,$=()=>Date.now()){this.d=U,this.f=$,this.a=0,this.b=0}increment(){const U=this.f();return U-this.a>this.d&&(this.a=U,this.b=0),this.b++,this.b}}e.IntervalCounter=K;class V{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((U,$)=>{this.a=U,this.b=$})}complete(U){return new Promise($=>{this.a(U),this.f=!0,$()})}error(U){return new Promise($=>{this.b(U),this.d=!0,$()})}cancel(){new Promise(U=>{this.b(new n.CancellationError),this.d=!0,U()})}}e.DeferredPromise=V;var W;(function(te){async function U(q){let B;const x=await Promise.all(q.map(ee=>ee.then(J=>J,J=>{B||(B=J)})));if(typeof B<"u")throw B;return x}te.settled=U;function $(q){return new Promise(async(B,x)=>{try{await q(B,x)}catch(ee){x(ee)}})}te.withAsyncBody=$})(W=e.Promises||(e.Promises={}));var G;(function(te){te[te.Initial=0]="Initial",te[te.DoneOK=1]="DoneOK",te[te.DoneError=2]="DoneError"})(G||(G={}));class X{static fromArray(U){return new X($=>{$.emitMany(U)})}static fromPromise(U){return new X(async $=>{$.emitMany(await U)})}static fromPromises(U){return new X(async $=>{await Promise.all(U.map(async q=>$.emitOne(await q)))})}static merge(U){return new X(async $=>{await Promise.all(U.map(async q=>{for await(const B of q)$.emitOne(B)}))})}constructor(U){this.a=0,this.b=[],this.d=null,this.f=new D.Emitter,queueMicrotask(async()=>{const $={emitOne:q=>this.g(q),emitMany:q=>this.h(q),reject:q=>this.k(q)};try{await Promise.resolve(U($)),this.j()}catch(q){this.k(q)}finally{$.emitOne=void 0,$.emitMany=void 0,$.reject=void 0}})}[Symbol.asyncIterator](){let U=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(U<this.b.length)return{done:!1,value:this.b[U++]};if(this.a===1)return{done:!0,value:void 0};await D.Event.toPromise(this.f.event)}while(!0)}}}static map(U,$){return new X(async q=>{for await(const B of U)q.emitOne($(B))})}map(U){return X.map(this,U)}static filter(U,$){return new X(async q=>{for await(const B of U)$(B)&&q.emitOne(B)})}filter(U){return X.filter(this,U)}static coalesce(U){return X.filter(U,$=>!!$)}coalesce(){return X.coalesce(this)}static async toPromise(U){const $=[];for await(const q of U)$.push(q);return $}toPromise(){return X.toPromise(this)}g(U){this.a===0&&(this.b.push(U),this.f.fire())}h(U){this.a===0&&(this.b=this.b.concat(U),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(U){this.a===0&&(this.a=2,this.d=U,this.f.fire())}}e.AsyncIterableObject=X,X.EMPTY=X.fromArray([]);class ie extends X{constructor(U,$){super($),this.l=U}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=ie;function oe(te){const U=new A.CancellationTokenSource,$=te(U.token);return new ie(U,async q=>{const B=U.token.onCancellationRequested(()=>{B.dispose(),U.dispose(),q.reject(new n.CancellationError)});try{for await(const x of $){if(U.token.isCancellationRequested)return;q.emitOne(x)}B.dispose(),U.dispose()}catch(x){B.dispose(),U.dispose(),q.reject(x)}})}e.createCancelableAsyncIterable=oe}),define(re[90],ae([0,1,21,6,48,37,12,5,27]),function(_,e,A,n,D,k,T,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function S(){return Object.create(null)}e.getEmptyExpression=S,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const C="[/\\\\]",b="[^/\\\\]",m=/\//g;function p(V,W){switch(V){case 0:return"";case 1:return`${b}*?`;default:return`(?:${C}|${b}+${C}${W?`|${C}${b}+`:""})*?`}}function h(V,W){if(!V)return[];const G=[];let X=!1,ie=!1,oe="";for(const te of V){switch(te){case W:if(!X&&!ie){G.push(oe),oe="";continue}break;case"{":X=!0;break;case"}":X=!1;break;case"[":ie=!0;break;case"]":ie=!1;break}oe+=te}return oe&&G.push(oe),G}e.splitGlobAware=h;function y(V){if(!V)return"";let W="";const G=h(V,e.GLOB_SPLIT);if(G.every(X=>X===e.GLOBSTAR))W=".*";else{let X=!1;G.forEach((ie,oe)=>{if(ie===e.GLOBSTAR){if(X)return;W+=p(2,oe===G.length-1)}else{let te=!1,U="",$=!1,q="";for(const B of ie){if(B!=="}"&&te){U+=B;continue}if($&&(B!=="]"||!q)){let x;B==="-"?x=B:(B==="^"||B==="!")&&!q?x="^":B===e.GLOB_SPLIT?x="":x=(0,P.escapeRegExpCharacters)(B),q+=x;continue}switch(B){case"{":te=!0;continue;case"[":$=!0;continue;case"}":{W+=`(?:${h(U,",").map(J=>y(J)).join("|")})`,te=!1,U="";break}case"]":{W+="["+q+"]",$=!1,q="";break}case"?":W+=b;continue;case"*":W+=p(1);continue;default:W+=(0,P.escapeRegExpCharacters)(B)}}oe<G.length-1&&(G[oe+1]!==e.GLOBSTAR||oe+2<G.length)&&(W+=C)}X=ie===e.GLOBSTAR})}return W}const f=/^\*\*\/\*\.[\w\.-]+$/,l=/^\*\*\/([\w\.-]+)\/?$/,d=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,g=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,v=/^\*\*((\/[\w\.-]+)+)\/?$/,I=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new k.LRUCache(1e4),r=function(){return!1},t=function(){return null};function s(V,W){if(!V)return t;let G;typeof V!="string"?G=V.pattern:G=V,G=G.trim();const X=`${G}_${!!W.trimForExclusions}`;let ie=i.get(X);if(ie)return o(ie,V);let oe;return f.test(G)?ie=a(G.substr(4),G):(oe=l.exec(c(G,W)))?ie=u(oe[1],G):(W.trimForExclusions?g:d).test(G)?ie=w(G,W):(oe=v.exec(c(G,W)))?ie=E(oe[1].substr(1),G,!0):(oe=I.exec(c(G,W)))?ie=E(oe[1],G,!1):ie=N(G),i.set(X,ie),o(ie,V)}function o(V,W){if(typeof W=="string")return V;const G=function(X,ie){return(0,D.isEqualOrParent)(X,W.base,!R.isLinux)?V((0,P.ltrim)(X.substr(W.base.length),T.sep),ie):null};return G.allBasenames=V.allBasenames,G.allPaths=V.allPaths,G.basenames=V.basenames,G.patterns=V.patterns,G}function c(V,W){return W.trimForExclusions&&V.endsWith("/**")?V.substr(0,V.length-2):V}function a(V,W){return function(G,X){return typeof G=="string"&&G.endsWith(V)?W:null}}function u(V,W){const G=`/${V}`,X=`\\${V}`,ie=function(te,U){return typeof te!="string"?null:U?U===V?W:null:te===V||te.endsWith(G)||te.endsWith(X)?W:null},oe=[V];return ie.basenames=oe,ie.patterns=[W],ie.allBasenames=oe,ie}function w(V,W){const G=Q(V.slice(1,-1).split(",").map(U=>s(U,W)).filter(U=>U!==t),V),X=G.length;if(!X)return t;if(X===1)return G[0];const ie=function(U,$){for(let q=0,B=G.length;q<B;q++)if(G[q](U,$))return V;return null},oe=G.find(U=>!!U.allBasenames);oe&&(ie.allBasenames=oe.allBasenames);const te=G.reduce((U,$)=>$.allPaths?U.concat($.allPaths):U,[]);return te.length&&(ie.allPaths=te),ie}function E(V,W,G){const X=T.sep===T.posix.sep,ie=X?V:V.replace(m,T.sep),oe=T.sep+ie,te=T.posix.sep+V;let U;return G?U=function($,q){return typeof $=="string"&&($===ie||$.endsWith(oe)||!X&&($===V||$.endsWith(te)))?W:null}:U=function($,q){return typeof $=="string"&&($===ie||!X&&$===V)?W:null},U.allPaths=[(G?"*/":"./")+V],U}function N(V){try{const W=new RegExp(`^${y(V)}$`);return function(G){return W.lastIndex=0,typeof G=="string"&&W.test(G)?V:null}}catch{return t}}function O(V,W,G){return!V||typeof W!="string"?!1:j(V)(W,void 0,G)}e.match=O;function j(V,W={}){if(!V)return r;if(typeof V=="string"||M(V)){const G=s(V,W);if(G===t)return r;const X=function(ie,oe){return!!G(ie,oe)};return G.allBasenames&&(X.allBasenames=G.allBasenames),G.allPaths&&(X.allPaths=G.allPaths),X}return z(V,W)}e.parse=j;function M(V){const W=V;return W?typeof W.base=="string"&&typeof W.pattern=="string":!1}e.isRelativePattern=M;function L(V){return V.allBasenames||[]}e.getBasenameTerms=L;function F(V){return V.allPaths||[]}e.getPathTerms=F;function z(V,W){const G=Q(Object.getOwnPropertyNames(V).map(U=>H(U,V[U],W)).filter(U=>U!==t)),X=G.length;if(!X)return t;if(!G.some(U=>!!U.requiresSiblings)){if(X===1)return G[0];const U=function(B,x){let ee;for(let J=0,Z=G.length;J<Z;J++){const se=G[J](B,x);if(typeof se=="string")return se;(0,n.isThenable)(se)&&(ee||(ee=[]),ee.push(se))}return ee?(async()=>{for(const J of ee){const Z=await J;if(typeof Z=="string")return Z}return null})():null},$=G.find(B=>!!B.allBasenames);$&&(U.allBasenames=$.allBasenames);const q=G.reduce((B,x)=>x.allPaths?B.concat(x.allPaths):B,[]);return q.length&&(U.allPaths=q),U}const ie=function(U,$,q){let B,x;for(let ee=0,J=G.length;ee<J;ee++){const Z=G[ee];Z.requiresSiblings&&q&&($||($=(0,T.basename)(U)),B||(B=$.substr(0,$.length-(0,T.extname)(U).length)));const se=Z(U,$,B,q);if(typeof se=="string")return se;(0,n.isThenable)(se)&&(x||(x=[]),x.push(se))}return x?(async()=>{for(const ee of x){const J=await ee;if(typeof J=="string")return J}return null})():null},oe=G.find(U=>!!U.allBasenames);oe&&(ie.allBasenames=oe.allBasenames);const te=G.reduce((U,$)=>$.allPaths?U.concat($.allPaths):U,[]);return te.length&&(ie.allPaths=te),ie}function H(V,W,G){if(W===!1)return t;const X=s(V,G);if(X===t)return t;if(typeof W=="boolean")return X;if(W){const ie=W.when;if(typeof ie=="string"){const oe=(te,U,$,q)=>{if(!q||!X(te,U))return null;const B=ie.replace("$(basename)",()=>$),x=q(B);return(0,n.isThenable)(x)?x.then(ee=>ee?V:null):x?V:null};return oe.requiresSiblings=!0,oe}}return X}function Q(V,W){const G=V.filter(U=>!!U.basenames);if(G.length<2)return V;const X=G.reduce((U,$)=>{const q=$.basenames;return q?U.concat(q):U},[]);let ie;if(W){ie=[];for(let U=0,$=X.length;U<$;U++)ie.push(W)}else ie=G.reduce((U,$)=>{const q=$.patterns;return q?U.concat(q):U},[]);const oe=function(U,$){if(typeof U!="string")return null;if(!$){let B;for(B=U.length;B>0;B--){const x=U.charCodeAt(B-1);if(x===47||x===92)break}$=U.substr(B)}const q=X.indexOf($);return q!==-1?ie[q]:null};oe.basenames=X,oe.patterns=ie,oe.allBasenames=X;const te=V.filter(U=>!U.basenames);return te.push(oe),te}function K(V,W){return(0,A.equals)(V,W,(G,X)=>typeof G=="string"&&typeof X=="string"?G===X:typeof G!="string"&&typeof X!="string"?G.base===X.base&&G.pattern===X.pattern:!1)}e.patternsEquals=K}),define(re[144],ae([0,1,8]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function n(C){return C.toJSON()}class D{constructor(b){this.a=b}transformIncoming(b){const m=this.a.transformIncoming(b);return m===b?b:n(A.URI.from(m))}transformOutgoing(b){const m=this.a.transformOutgoing(b);return m===b?b:n(A.URI.from(m))}transformOutgoingURI(b){const m=this.a.transformOutgoing(b);return m===b?b:A.URI.from(m)}transformOutgoingScheme(b){return this.a.transformOutgoingScheme(b)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(C){return C}transformOutgoing(C){return C}transformOutgoingURI(C){return C}transformOutgoingScheme(C){return C}};function k(C,b,m){if(!C||m>200)return null;if(typeof C=="object"){if(C instanceof A.URI)return b.transformOutgoing(C);for(const p in C)if(Object.hasOwnProperty.call(C,p)){const h=k(C[p],b,m+1);h!==null&&(C[p]=h)}}return null}function T(C,b){const m=k(C,b,0);return m===null?C:m}e.transformOutgoingURIs=T;function R(C,b,m,p){if(!C||p>200)return null;if(typeof C=="object"){if(C.$mid===1)return m?A.URI.revive(b.transformIncoming(C)):b.transformIncoming(C);for(const h in C)if(Object.hasOwnProperty.call(C,h)){const y=R(C[h],b,m,p+1);y!==null&&(C[h]=y)}}return null}function P(C,b){const m=R(C,b,!1,0);return m===null?C:m}e.transformIncomingURIs=P;function S(C,b){const m=R(C,b,!0,0);return m===null?C:m}e.transformAndReviveIncomingURIs=S}),define(re[145],ae([0,1,34,7,49,31,132]),function(_,e,A,n,D,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(C){return this.a||(this.a=D.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(C)}value(){if(this.b===void 0){let C=0,b=0;const m=(0,A.networkInterfaces)();for(const p in m){const h=m[p];if(h)for(const{mac:y,internal:f}of h)f||(b+=1,this.c(y.toUpperCase())&&(C+=1))}this.b=b>0?C/b:0}return this.b}};let R;async function P(){return R||(R=(async()=>await S()||k.generateUuid())()),R}e.getMachineId=P;async function S(){try{const C=await new Promise((m,p)=>{_(["crypto"],m,p)}),b=(0,T.getMac)();return C.createHash("sha256").update(b,"utf8").digest("hex")}catch(C){n.onUnexpectedError(C);return}}}),define(re[28],ae([0,1,53,34,284,6,48,85,12,5,22,8]),function(_,e,A,n,D,k,T,R,P,S,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var m;(function(z){z[z.UNLINK=0]="UNLINK",z[z.MOVE=1]="MOVE"})(m=e.RimRafMode||(e.RimRafMode={}));async function p(z,H=m.UNLINK){if((0,T.isRootOrDriveLetter)(z))throw new Error("rimraf - will refuse to recursively delete root");return H===m.UNLINK?y(z):h(z)}async function h(z){try{const H=(0,T.randomPath)((0,n.tmpdir)());try{await A.promises.rename(z,H)}catch(Q){return Q.code==="ENOENT"?void 0:y(z)}y(H).catch(Q=>{})}catch(H){if(H.code!=="ENOENT")throw H}}async function y(z){return(0,D.promisify)(A.rm)(z,{recursive:!0,force:!0,maxRetries:3})}function f(z){if((0,T.isRootOrDriveLetter)(z))throw new Error("rimraf - will refuse to recursively delete root");A.rmSync(z,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=f;async function l(z,H){return v(await(H?d(z):(0,D.promisify)(A.readdir)(z)))}async function d(z){try{return await(0,D.promisify)(A.readdir)(z,{withFileTypes:!0})}catch(K){console.warn("[node.js fs] readdir with filetypes failed with error: ",K)}const H=[],Q=await l(z);for(const K of Q){let V=!1,W=!1,G=!1;try{const X=await e.Promises.lstat((0,P.join)(z,K));V=X.isFile(),W=X.isDirectory(),G=X.isSymbolicLink()}catch(X){console.warn("[node.js fs] unexpected error from lstat after readdir: ",X)}H.push({name:K,isFile:()=>V,isDirectory:()=>W,isSymbolicLink:()=>G})}return H}function g(z){return v(A.readdirSync(z))}e.readdirSync=g;function v(z){return z.map(H=>typeof H=="string"?S.isMacintosh?(0,R.normalizeNFC)(H):H:(H.name=S.isMacintosh?(0,R.normalizeNFC)(H.name):H.name,H))}async function I(z){const H=await l(z),Q=[];for(const K of H)await r.existsDirectory((0,P.join)(z,K))&&Q.push(K);return Q}function i(z,H=1e3){return new Promise(Q=>{let K=!1;const V=setInterval(()=>{K||(K=!0,A.access(z,W=>{K=!1,W&&(clearInterval(V),Q(void 0))}))},H)})}e.whenDeleted=i;var r;(function(z){async function H(V){let W;try{if(W=await e.Promises.lstat(V),!W.isSymbolicLink())return{stat:W}}catch{}try{return{stat:await e.Promises.stat(V),symbolicLink:W?.isSymbolicLink()?{dangling:!1}:void 0}}catch(G){if(G.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};if(S.isWindows&&G.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(V)),symbolicLink:{dangling:!1}}}catch(X){if(X.code==="ENOENT"&&W)return{stat:W,symbolicLink:{dangling:!0}};throw X}throw G}}z.stat=H;async function Q(V){try{const{stat:W,symbolicLink:G}=await z.stat(V);return W.isFile()&&G?.dangling!==!0}catch{}return!1}z.existsFile=Q;async function K(V){try{const{stat:W,symbolicLink:G}=await z.stat(V);return W.isDirectory()&&G?.dangling!==!0}catch{}return!1}z.existsDirectory=K})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const t=new k.ResourceQueue;function s(z,H,Q){return t.queueFor(b.URI.file(z),C.extUriBiasedIgnorePathCase).queue(()=>{const K=w(Q);return new Promise((V,W)=>a(z,H,K,G=>G?W(G):V()))})}let o=!0;function c(z){o=z}e.configureFlushOnWrite=c;function a(z,H,Q,K){if(!o)return A.writeFile(z,H,{mode:Q.mode,flag:Q.flag},K);A.open(z,Q.flag,Q.mode,(V,W)=>{if(V)return K(V);A.writeFile(W,H,G=>{if(G)return A.close(W,()=>K(G));A.fdatasync(W,X=>(X&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",X),c(!1)),A.close(W,ie=>K(ie))))})})}function u(z,H,Q){const K=w(Q);if(!o)return A.writeFileSync(z,H,{mode:K.mode,flag:K.flag});const V=A.openSync(z,K.flag,K.mode);try{A.writeFileSync(V,H);try{A.fdatasyncSync(V)}catch(W){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",W),c(!1)}}finally{A.closeSync(V)}}e.writeFileSync=u;function w(z){return z?{mode:typeof z.mode=="number"?z.mode:438,flag:typeof z.flag=="string"?z.flag:"w"}:{mode:438,flag:"w"}}async function E(z,H){if(z!==H)try{await e.Promises.rename(z,H)}catch(Q){if(z.toLowerCase()!==H.toLowerCase()&&Q.code==="EXDEV"||z.endsWith("."))await N(z,H,{preserveSymlinks:!1}),await p(z,m.MOVE);else throw Q}}async function N(z,H,Q){return j(z,H,{root:{source:z,target:H},options:Q,handledSourcePaths:new Set})}const O=511;async function j(z,H,Q){if(Q.handledSourcePaths.has(z))return;Q.handledSourcePaths.add(z);const{stat:K,symbolicLink:V}=await r.stat(z);if(V){if(Q.options.preserveSymlinks)try{return await F(z,H,Q)}catch(W){console.warn("[node.js fs] copy of symlink failed: ",W)}if(V.dangling)return}return K.isDirectory()?M(z,H,K.mode&O,Q):L(z,H,K.mode&O)}async function M(z,H,Q,K){await e.Promises.mkdir(H,{recursive:!0,mode:Q});const V=await l(z);for(const W of V)await j((0,P.join)(z,W),(0,P.join)(H,W),K)}async function L(z,H,Q){await e.Promises.copyFile(z,H),await e.Promises.chmod(H,Q)}async function F(z,H,Q){let K=await e.Promises.readlink(z);(0,T.isEqualOrParent)(K,Q.root.source,!S.isLinux)&&(K=(0,P.join)(Q.root.target,K.substr(Q.root.source.length+1))),await e.Promises.symlink(K,H)}e.Promises=new class{get access(){return(0,D.promisify)(A.access)}get stat(){return(0,D.promisify)(A.stat)}get lstat(){return(0,D.promisify)(A.lstat)}get utimes(){return(0,D.promisify)(A.utimes)}get read(){return(z,H,Q,K,V)=>new Promise((W,G)=>{A.read(z,H,Q,K,V,(X,ie,oe)=>X?G(X):W({bytesRead:ie,buffer:oe}))})}get readFile(){return(0,D.promisify)(A.readFile)}get write(){return(z,H,Q,K,V)=>new Promise((W,G)=>{A.write(z,H,Q,K,V,(X,ie,oe)=>X?G(X):W({bytesWritten:ie,buffer:oe}))})}get appendFile(){return(0,D.promisify)(A.appendFile)}get fdatasync(){return(0,D.promisify)(A.fdatasync)}get truncate(){return(0,D.promisify)(A.truncate)}get rename(){return(0,D.promisify)(A.rename)}get copyFile(){return(0,D.promisify)(A.copyFile)}get open(){return(0,D.promisify)(A.open)}get close(){return(0,D.promisify)(A.close)}get symlink(){return(0,D.promisify)(A.symlink)}get readlink(){return(0,D.promisify)(A.readlink)}get chmod(){return(0,D.promisify)(A.chmod)}get mkdir(){return(0,D.promisify)(A.mkdir)}get unlink(){return(0,D.promisify)(A.unlink)}get rmdir(){return(0,D.promisify)(A.rmdir)}get realpath(){return(0,D.promisify)(A.realpath)}async exists(z){try{return await e.Promises.access(z),!0}catch{return!1}}get readdir(){return l}get readDirsInDir(){return I}get writeFile(){return s}get rm(){return p}get move(){return E}get copy(){return N}}}),define(re[146],ae([0,1,53,12,5,27,28]),function(_,e,A,n,D,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function R(m){if(D.isLinux)return m;const p=(0,n.dirname)(m);if(m===p)return m;const h=((0,n.basename)(m)||m).toLowerCase();try{const f=(0,T.readdirSync)(p).filter(l=>l.toLowerCase()===h);if(f.length===1){const l=R(p);if(l)return(0,n.join)(l,f[0])}else if(f.length>1){const l=f.indexOf(h);if(l>=0){const d=R(p);if(d)return(0,n.join)(d,f[l])}}}catch{}return null}e.realcaseSync=R;async function P(m){if(D.isLinux)return m;const p=(0,n.dirname)(m);if(m===p)return m;const h=((0,n.basename)(m)||m).toLowerCase();try{const f=(await T.Promises.readdir(p)).filter(l=>l.toLowerCase()===h);if(f.length===1){const l=await P(p);if(l)return(0,n.join)(l,f[0])}else if(f.length>1){const l=f.indexOf(h);if(l>=0){const d=await P(p);if(d)return(0,n.join)(d,f[l])}}}catch{}return null}e.realcase=P;async function S(m){try{return await T.Promises.realpath(m)}catch{const h=b(m);return await T.Promises.access(h,A.constants.R_OK),h}}e.realpath=S;function C(m){try{return A.realpathSync(m)}catch{const h=b(m);return A.accessSync(h,A.constants.R_OK),h}}e.realpathSync=C;function b(m){return(0,k.rtrim)((0,n.normalize)(m),n.sep)}}),define(re[91],ae([0,1,34,12,28]),function(_,e,A,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const k=/^\d+$/,T=/^Microsoft.PowerShell_.*/,R=/^Microsoft.PowerShellPreview_.*/;var P;(function(v){v[v.x64=0]="x64",v[v.x86=1]="x86",v[v.ARM=2]="ARM"})(P||(P={}));let S;switch(process.arch){case"ia32":case"x32":S=1;break;case"arm":case"arm64":S=2;break;default:S=0;break}let C;process.env.PROCESSOR_ARCHITEW6432?C=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?C=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?C=1:C=0;class b{constructor(I,i,r){this.exePath=I,this.displayName=i,this.a=r}async exists(){return this.a===void 0&&(this.a=await D.SymlinkSupport.existsFile(this.exePath)),this.a}}function m({useAlternateBitness:v=!1}={}){return v?S===0?process.env["ProgramFiles(x86)"]||null:C===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function p({useAlternateBitness:v=!1,findPreview:I=!1}={}){const i=m({useAlternateBitness:v});if(!i)return null;const r=n.join(i,"PowerShell");if(!await D.SymlinkSupport.existsDirectory(r))return null;let t=-1,s=null;for(const a of await D.Promises.readdir(r)){let u=-1;if(I){const E=a.indexOf("-");if(E<0)continue;const N=a.substring(0,E);if(!k.test(N)||a.substring(E+1)!=="preview")continue;u=parseInt(N,10)}else{if(!k.test(a))continue;u=parseInt(a,10)}if(u<=t)continue;const w=n.join(r,a,"pwsh.exe");!await D.SymlinkSupport.existsFile(w)||(s=w,t=u)}if(!s)return null;const o=i.includes("x86")?" (x86)":"",c=I?" Preview":"";return new b(s,`PowerShell${c}${o}`,!0)}async function h({findPreview:v}={}){if(!process.env.LOCALAPPDATA)return null;const I=n.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await D.SymlinkSupport.existsDirectory(I))return null;const{pwshMsixDirRegex:i,pwshMsixName:r}=v?{pwshMsixDirRegex:R,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:T,pwshMsixName:"PowerShell (Store)"};for(const t of await D.Promises.readdir(I))if(i.test(t)){const s=n.join(I,t,"pwsh.exe");return new b(s,r)}return null}function y(){const v=n.join(A.homedir(),".dotnet","tools","pwsh.exe");return new b(v,".NET Core PowerShell Global Tool")}function f(){const v=n.join(process.env.windir,S===1&&C!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new b(v,"Windows PowerShell",!0)}async function*l(){let v=await p();v&&(yield v),v=await p({useAlternateBitness:!0}),v&&(yield v),v=await h(),v&&(yield v),v=y(),v&&(yield v),v=await p({findPreview:!0}),v&&(yield v),v=await h({findPreview:!0}),v&&(yield v),v=await p({useAlternateBitness:!0,findPreview:!0}),v&&(yield v),v=f(),v&&(yield v)}async function*d(){for await(const v of l())await v.exists()&&(yield v)}e.enumeratePowerShellInstallations=d;async function g(){for await(const v of d())return v;return null}e.getFirstAvailablePowerShellInstallation=g}),define(re[92],ae([0,1,12,5,36,87,14,28]),function(_,e,A,n,D,k,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return k.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return k.TerminateResponseCode}});function P(b=D.env){return b.comspec||"cmd.exe"}e.getWindowsShell=P;function S(b){let m=[],p=!1;const h=function(y){if(p){m.push(y);return}(!b.send(y,l=>{if(l&&console.error(l),p=!1,m.length>0){const d=m.slice(0);m=[],d.forEach(g=>h(g))}})||n.isWindows)&&(p=!0)};return{send:h}}e.createQueuedSender=S;var C;(function(b){async function m(p,h,y){if(A.isAbsolute(p))return p;if(h===void 0&&(h=D.cwd()),A.dirname(p)!=="."||(y===void 0&&T.isString(D.env.PATH)&&(y=D.env.PATH.split(A.delimiter)),y===void 0||y.length===0))return A.join(h,p);async function l(d){if(await R.Promises.exists(d)){let g;try{g=await R.Promises.stat(d)}catch(v){v.message.startsWith("EACCES")&&(g=await R.Promises.lstat(d))}return g?!g.isDirectory():!1}return!1}for(const d of y){let g;if(A.isAbsolute(d)?g=A.join(d,p):g=A.join(h,d,p),await l(g))return g;let v=g+".com";if(await l(v)||(v=g+".exe",await l(v)))return v}return A.join(h,p)}b.findExecutable=m})(C=e.win32||(e.win32={}))}),define(re[147],ae([0,1,50,24]),function(_,e,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function D(T){return new Promise((R,P)=>{let S;const C=new Map;function b(p,h,y,f,l){const d=C.get(h);if(p===T||d){const g={name:m(y),cmd:y,pid:p,ppid:h,load:f,mem:l};C.set(p,g),p===T&&(S=g),d&&(d.children||(d.children=[]),d.children.push(g),d.children.length>1&&(d.children=d.children.sort((v,I)=>v.pid-I.pid)))}}function m(p){const h=/--vscode-window-kind=shared-process/,y=/--vscode-window-kind=issue-reporter/,f=/--vscode-window-kind=process-explorer/,l=/--utility-sub-type=network/,d=/--utility-sub-type=node.mojom.NodeService/,g=/--crashes-directory/,v=/\\pipe\\winpty-control/,I=/conhost\.exe/,i=/--type=([a-zA-Z-]+)/;if(g.exec(p))return"electron-crash-reporter";if(v.exec(p))return"winpty-process";if(I.exec(p))return"console-window-host (Windows internal process)";let r=i.exec(p);if(r&&r.length===2){if(r[1]==="renderer")return h.exec(p)?"shared-process":y.exec(p)?"issue-reporter":f.exec(p)?"process-explorer":"window";if(r[1]==="utility"){if(l.exec(p))return"utility-network-service";if(d.exec(p))return"extension-host"}else if(r[1]==="extensionHost")return"extension-host";return r[1]}const t=/[a-zA-Z-]+\.js/g;let s="";do r=t.exec(p),r&&(s+=r+" ");while(r);return s&&p.indexOf("node ")<0&&p.indexOf("node.exe")<0?`electron_node ${s}`:p}if(process.platform==="win32"){const p=h=>h.indexOf("\\\\?\\")===0||h.indexOf("\\??\\")===0?h.substr(4):h.indexOf('"\\\\?\\')===0||h.indexOf('"\\??\\')===0?'"'+h.substr(5):h;new Promise((h,y)=>{_(["windows-process-tree"],h,y)}).then(h=>{h.getProcessList(T,y=>{if(!y){P(new Error(`Root process ${T} not found`));return}h.getProcessCpuUsage(y,f=>{const l=new Map;f.forEach(d=>{const g=p(d.commandLine||"");l.set(d.pid,{name:m(g),cmd:g,pid:d.pid,ppid:d.ppid,load:d.cpu||0,mem:d.memory||0})}),S=l.get(T),S?(l.forEach(d=>{const g=l.get(d.ppid);g&&(g.children||(g.children=[]),g.children.push(d))}),l.forEach(d=>{d.children&&(d.children=d.children.sort((g,v)=>g.pid-v.pid))}),R(S)):P(new Error(`Root process ${T} not found`))})},h.ProcessDataFlag.CommandLine|h.ProcessDataFlag.Memory)})}else{let p=function(){let h=[S];const y=[];for(;h.length;){const l=h.shift();l&&(y.push(l.pid),l.children&&(h=h.concat(l.children)))}let f=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);f+=" "+y.join(" "),(0,A.exec)(f,{},(l,d,g)=>{if(l||g)P(l||new Error(g.toString()));else{const v=d.toString().split(`
`);for(let I=0;I<y.length;I++){const i=C.get(y[I]);i.load=parseFloat(v[I])}if(!S){P(new Error(`Root process ${T} not found`));return}R(S)}})};(0,A.exec)("which ps",{},(h,y,f)=>{if(h||f)if(process.platform!=="linux")P(h||new Error(f.toString()));else{const l=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,A.exec)(l,{},(d,g,v)=>{d||v?P(d||new Error(v.toString())):(k(g,b),p())})}else{const l=y.toString().trim(),d="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,A.exec)(`${l} ${d}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(g,v,I)=>{g||I&&!I.includes("screen size is bogus")?P(g||new Error(I.toString())):(k(v,b),process.platform==="linux"?p():S?R(S):P(new Error(`Root process ${T} not found`)))})}})}})}e.listProcesses=D;function k(T,R){const P=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,S=T.toString().split(`
`);for(const C of S){const b=P.exec(C.trim());b&&b.length===6&&R(parseInt(b[1]),parseInt(b[2]),b[5],parseFloat(b[3]),parseFloat(b[4]))}}}),define(re[148],ae([0,1,34,5,91,92]),function(_,e,A,n,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function T(b,m){return b===1?n.isWindows?C():k.getWindowsShell(m):P(b,m)}e.getSystemShell=T;let R=null;function P(b,m){if(n.isLinux&&b===2||n.isMacintosh&&b===3)return"/bin/bash";if(!R){let p;if(n.isWindows)p="/bin/bash";else{if(p=m.SHELL,!p)try{p=(0,A.userInfo)().shell}catch{}p||(p="sh"),p==="/bin/false"&&(p="/bin/bash")}R=p}return R}let S=null;async function C(){return S||(S=(await(0,D.getFirstAvailablePowerShellInstallation)()).exePath),S}});var ye=this&&this.__decorate||function(_,e,A,n){var D=arguments.length,k=D<3?e:n===null?n=Object.getOwnPropertyDescriptor(e,A):n,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")k=Reflect.decorate(_,e,A,n);else for(var R=_.length-1;R>=0;R--)(T=_[R])&&(k=(D<3?T(k):D>3?T(e,A,k):T(e,A))||k);return D>3&&k&&Object.defineProperty(e,A,k),k};define(re[39],ae([0,1,21,6,17,23,63,7,3,2,67,27,14]),function(_,e,A,n,D,k,T,R,P,S,C,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var p;(function(W){W[W.Promise=100]="Promise",W[W.PromiseCancel=101]="PromiseCancel",W[W.EventListen=102]="EventListen",W[W.EventDispose=103]="EventDispose"})(p||(p={}));function h(W){switch(W){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var y;(function(W){W[W.Initialize=200]="Initialize",W[W.PromiseSuccess=201]="PromiseSuccess",W[W.PromiseError=202]="PromiseError",W[W.PromiseErrorObj=203]="PromiseErrorObj",W[W.EventFire=204]="EventFire"})(y||(y={}));function f(W){switch(W){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var l;(function(W){W[W.Uninitialized=0]="Uninitialized",W[W.Idle=1]="Idle"})(l||(l={}));function d(W){let G=0;for(let X=0;;X+=7){const ie=W.read(1);if(G|=(ie.buffer[0]&127)<<X,!(ie.buffer[0]&128))return G}}const g=t(0);function v(W,G){if(G===0){W.write(g);return}let X=0;for(let oe=G;oe!==0;oe=oe>>>7)X++;const ie=D.VSBuffer.alloc(X);for(let oe=0;G!==0;oe++)ie.buffer[oe]=G&127,G=G>>>7,G>0&&(ie.buffer[oe]|=128);W.write(ie)}class I{constructor(G){this.b=G,this.a=0}read(G){const X=this.b.slice(this.a,this.a+G);return this.a+=X.byteLength,X}}e.BufferReader=I;class i{constructor(){this.a=[]}get buffer(){return D.VSBuffer.concat(this.a)}write(G){this.a.push(G)}}e.BufferWriter=i;var r;(function(W){W[W.Undefined=0]="Undefined",W[W.String=1]="String",W[W.Buffer=2]="Buffer",W[W.VSBuffer=3]="VSBuffer",W[W.Array=4]="Array",W[W.Object=5]="Object",W[W.Int=6]="Int"})(r||(r={}));function t(W){const G=D.VSBuffer.alloc(1);return G.writeUInt8(W,0),G}const s={Undefined:t(r.Undefined),String:t(r.String),Buffer:t(r.Buffer),VSBuffer:t(r.VSBuffer),Array:t(r.Array),Object:t(r.Object),Uint:t(r.Int)},o=typeof Buffer<"u";function c(W,G){if(typeof G>"u")W.write(s.Undefined);else if(typeof G=="string"){const X=D.VSBuffer.fromString(G);W.write(s.String),v(W,X.byteLength),W.write(X)}else if(o&&Buffer.isBuffer(G)){const X=D.VSBuffer.wrap(G);W.write(s.Buffer),v(W,X.byteLength),W.write(X)}else if(G instanceof D.VSBuffer)W.write(s.VSBuffer),v(W,G.byteLength),W.write(G);else if(Array.isArray(G)){W.write(s.Array),v(W,G.length);for(const X of G)c(W,X)}else if(typeof G=="number"&&(G|0)===G)W.write(s.Uint),v(W,G);else{const X=D.VSBuffer.fromString(JSON.stringify(G));W.write(s.Object),v(W,X.byteLength),W.write(X)}}e.serialize=c;function a(W){switch(W.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return W.read(d(W)).toString();case r.Buffer:return W.read(d(W)).buffer;case r.VSBuffer:return W.read(d(W));case r.Array:{const X=d(W),ie=[];for(let oe=0;oe<X;oe++)ie.push(a(W));return ie}case r.Object:return JSON.parse(W.read(d(W)).toString());case r.Int:return d(W)}}e.deserialize=a;class u{constructor(G,X,ie=null,oe=1e3){this.h=G,this.j=X,this.k=ie,this.l=oe,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(te=>this.q(te)),this.m({type:200})}registerChannel(G,X){this.b.set(G,X),setTimeout(()=>this.w(G),0)}m(G){switch(G.type){case 200:{const X=this.o([G.type]);this.k?.logOutgoing(X,0,1,f(G.type));return}case 201:case 202:case 204:case 203:{const X=this.o([G.type,G.id],G.data);this.k?.logOutgoing(X,G.id,1,f(G.type),G.data);return}}}o(G,X=void 0){const ie=new i;return c(ie,G),c(ie,X),this.p(ie.buffer)}p(G){try{return this.h.send(G),G.byteLength}catch{return 0}}q(G){const X=new I(G),ie=a(X),oe=a(X),te=ie[0];switch(te){case 100:return this.k?.logIncoming(G.byteLength,ie[1],1,`${h(te)}: ${ie[2]}.${ie[3]}`,oe),this.s({type:te,id:ie[1],channelName:ie[2],name:ie[3],arg:oe});case 102:return this.k?.logIncoming(G.byteLength,ie[1],1,`${h(te)}: ${ie[2]}.${ie[3]}`,oe),this.t({type:te,id:ie[1],channelName:ie[2],name:ie[3],arg:oe});case 101:return this.k?.logIncoming(G.byteLength,ie[1],1,`${h(te)}`),this.u({type:te,id:ie[1]});case 103:return this.k?.logIncoming(G.byteLength,ie[1],1,`${h(te)}`),this.u({type:te,id:ie[1]})}}s(G){const X=this.b.get(G.channelName);if(!X){this.v(G);return}const ie=new k.CancellationTokenSource;let oe;try{oe=X.call(this.j,G.name,G.arg,ie.token)}catch($){oe=Promise.reject($)}const te=G.id;oe.then($=>{this.m({id:te,data:$,type:201}),this.d.delete(G.id)},$=>{$ instanceof Error?this.m({id:te,data:{message:$.message,name:$.name,stack:$.stack?$.stack.split?$.stack.split(`
`):$.stack:void 0},type:202}):this.m({id:te,data:$,type:203}),this.d.delete(G.id)});const U=(0,S.toDisposable)(()=>ie.cancel());this.d.set(G.id,U)}t(G){const X=this.b.get(G.channelName);if(!X){this.v(G);return}const ie=G.id,te=X.listen(this.j,G.name,G.arg)(U=>this.m({id:ie,data:U,type:204}));this.d.set(G.id,te)}u(G){const X=this.d.get(G.id);X&&(X.dispose(),this.d.delete(G.id))}v(G){let X=this.g.get(G.channelName);X||(X=[],this.g.set(G.channelName,X));const ie=setTimeout(()=>{console.error(`Unknown channel: ${G.channelName}`),G.type===100&&this.m({id:G.id,data:{name:"Unknown channel",message:`Channel name '${G.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);X.push({request:G,timeoutTimer:ie})}w(G){const X=this.g.get(G);if(X){for(const ie of X)switch(clearTimeout(ie.timeoutTimer),ie.request.type){case 100:this.s(ie.request);break;case 102:this.t(ie.request);break}this.g.delete(G)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,S.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=u;var w;(function(W){W[W.LocalSide=0]="LocalSide",W[W.OtherSide=1]="OtherSide"})(w=e.RequestInitiator||(e.RequestInitiator={}));class E{constructor(G,X=null){this.l=G,this.a=!1,this.b=l.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new P.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ie=>this.s(ie)),this.j=X}getChannel(G){const X=this;return{call(ie,oe,te){return X.a?Promise.reject(new R.CancellationError):X.m(G,ie,oe,te)},listen(ie,oe){return X.a?P.Event.None:X.o(G,ie,oe)}}}m(G,X,ie,oe=k.CancellationToken.None){const te=this.g++,$={id:te,type:100,channelName:G,name:X,arg:ie};if(oe.isCancellationRequested)return Promise.reject(new R.CancellationError);let q;return new Promise((x,ee)=>{if(oe.isCancellationRequested)return ee(new R.CancellationError);const J=()=>{const ue=pe=>{switch(pe.type){case 201:this.f.delete(te),x(pe.data);break;case 202:{this.f.delete(te);const we=new Error(pe.data.message);we.stack=Array.isArray(pe.data.stack)?pe.data.stack.join(`
`):pe.data.stack,we.name=pe.data.name,ee(we);break}case 203:this.f.delete(te),ee(pe.data);break}};this.f.set(te,ue),this.p($)};let Z=null;this.b===l.Idle?J():(Z=(0,n.createCancelablePromise)(ue=>this.u()),Z.then(()=>{Z=null,J()}));const se=()=>{Z?(Z.cancel(),Z=null):this.p({id:te,type:101}),ee(new R.CancellationError)},le=oe.onCancellationRequested(se);q=(0,S.combinedDisposable)((0,S.toDisposable)(se),le),this.d.add(q)}).finally(()=>{this.d.delete(q)})}o(G,X,ie){const oe=this.g++,U={id:oe,type:102,channelName:G,name:X,arg:ie};let $=null;const q=new P.Emitter({onWillAddFirstListener:()=>{$=(0,n.createCancelablePromise)(x=>this.u()),$.then(()=>{$=null,this.d.add(q),this.p(U)})},onDidRemoveLastListener:()=>{$?($.cancel(),$=null):(this.d.delete(q),this.p({id:oe,type:103}))}}),B=x=>q.fire(x.data);return this.f.set(oe,B),q.event}p(G){switch(G.type){case 100:case 102:{const X=this.q([G.type,G.id,G.channelName,G.name],G.arg);this.j?.logOutgoing(X,G.id,0,`${h(G.type)}: ${G.channelName}.${G.name}`,G.arg);return}case 101:case 103:{const X=this.q([G.type,G.id]);this.j?.logOutgoing(X,G.id,0,h(G.type));return}}}q(G,X=void 0){const ie=new i;return c(ie,G),c(ie,X),this.r(ie.buffer)}r(G){try{return this.l.send(G),G.byteLength}catch{return 0}}s(G){const X=new I(G),ie=a(X),oe=a(X),te=ie[0];switch(te){case 200:return this.j?.logIncoming(G.byteLength,0,0,f(te)),this.t({type:ie[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(G.byteLength,ie[1],0,f(te),oe),this.t({type:ie[0],id:ie[1],data:oe})}}t(G){if(G.type===200){this.b=l.Idle,this.k.fire();return}this.f.get(G.id)?.(G)}get onDidInitializePromise(){return P.Event.toPromise(this.onDidInitialize)}u(){return this.b===l.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,S.dispose)(this.d.values()),this.d.clear()}}ye([T.memoize],E.prototype,"onDidInitializePromise",null),e.ChannelClient=E;class N{get connections(){const G=[];return this.f.forEach(X=>G.push(X)),G}constructor(G){this.a=new Map,this.f=new Set,this.g=new P.Emitter,this.onDidAddConnection=this.g.event,this.h=new P.Emitter,this.onDidRemoveConnection=this.h.event,G(({protocol:X,onDidClientDisconnect:ie})=>{P.Event.once(X.onMessage)(te=>{const U=new I(te),$=a(U),q=new u(X,$),B=new E(X);this.a.forEach((ee,J)=>q.registerChannel(J,ee));const x={channelServer:q,channelClient:B,ctx:$};this.f.add(x),this.g.fire(x),ie(()=>{q.dispose(),B.dispose(),this.f.delete(x),this.h.fire(x)})})})}getChannel(G,X){const ie=this;return{call(oe,te,U){let $;if((0,m.isFunction)(X)){const B=(0,A.getRandomElement)(ie.connections.filter(X));$=B?Promise.resolve(B):P.Event.toPromise(P.Event.filter(ie.onDidAddConnection,X))}else $=X.routeCall(ie,oe,te);const q=$.then(B=>B.channelClient.getChannel(G));return j(q).call(oe,te,U)},listen(oe,te){if((0,m.isFunction)(X))return ie.j(G,X,oe,te);const U=X.routeEvent(ie,oe,te).then($=>$.channelClient.getChannel(G));return j(U).listen(oe,te)}}}j(G,X,ie,oe){const te=this;let U=new S.DisposableStore;const $=new P.Emitter({onWillAddFirstListener:()=>{U=new S.DisposableStore;const q=new P.EventMultiplexer,B=new Map,x=J=>{const se=J.channelClient.getChannel(G).listen(ie,oe),le=q.add(se);B.set(J,le)},ee=J=>{const Z=B.get(J);!Z||(Z.dispose(),B.delete(J))};te.connections.filter(X).forEach(x),P.Event.filter(te.onDidAddConnection,X)(x,void 0,U),te.onDidRemoveConnection(ee,void 0,U),q.event($.fire,$,U),U.add(q)},onDidRemoveLastListener:()=>{U.dispose()}});return $.event}registerChannel(G,X){this.a.set(G,X),this.f.forEach(ie=>{ie.channelServer.registerChannel(G,X)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=N;class O{constructor(G,X,ie=null){const oe=new i;c(oe,X),G.send(oe.buffer),this.a=new E(G,ie),this.d=new u(G,X,ie)}getChannel(G){return this.a.getChannel(G)}registerChannel(G,X){this.d.registerChannel(G,X)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=O;function j(W){return{call(G,X,ie){return W.then(oe=>oe.call(G,X,ie))},listen(G,X){const ie=new P.Relay;return W.then(oe=>ie.input=oe.listen(G,X)),ie.event}}}e.getDelayedChannel=j;function M(W){let G=!1;return{call(X,ie,oe){return G?W.call(X,ie,oe):(0,n.timeout)(0).then(()=>G=!0).then(()=>W.call(X,ie,oe))},listen(X,ie){if(G)return W.listen(X,ie);const oe=new P.Relay;return(0,n.timeout)(0).then(()=>G=!0).then(()=>oe.input=W.listen(X,ie)),oe.event}}}e.getNextTickChannel=M;class L{constructor(G){this.a=G}routeCall(G){return this.b(G)}routeEvent(G){return this.b(G)}async b(G){for(const X of G.connections)if(await Promise.resolve(this.a(X.ctx)))return Promise.resolve(X);return await P.Event.toPromise(G.onDidAddConnection),await this.b(G)}}e.StaticRouter=L;var F;(function(W){function G(te,U){const $=te,q=U&&U.disableMarshalling,B=new Map;for(const x in $)ie(x)&&B.set(x,P.Event.buffer($[x],!0));return new class{listen(x,ee,J){const Z=B.get(ee);if(Z)return Z;if(oe(ee)){const se=$[ee];if(typeof se=="function")return se.call($,J)}throw new Error(`Event not found: ${ee}`)}call(x,ee,J){const Z=$[ee];if(typeof Z=="function"){if(!q&&Array.isArray(J))for(let se=0;se<J.length;se++)J[se]=(0,C.revive)(J[se]);return Z.apply($,J)}throw new Error(`Method not found: ${ee}`)}}}W.fromService=G;function X(te,U){const $=U&&U.disableMarshalling;return new Proxy({},{get(q,B){if(typeof B=="string")return U?.properties?.has(B)?U.properties.get(B):oe(B)?function(x){return te.listen(B,x)}:ie(B)?te.listen(B):async function(...x){let ee;U&&!(0,m.isUndefinedOrNull)(U.context)?ee=[U.context,...x]:ee=x;const J=await te.call(B,ee);return $?J:(0,C.revive)(J)};throw new Error(`Property not found: ${String(B)}`)}})}W.toService=X;function ie(te){return te[0]==="o"&&te[1]==="n"&&b.isUpperAsciiLetter(te.charCodeAt(2))}function oe(te){return/^onDynamic/.test(te)&&b.isUpperAsciiLetter(te.charCodeAt(9))}})(F=e.ProxyChannel||(e.ProxyChannel={}));const z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function H(W){if(Array.isArray(W))return W;if(W&&typeof W=="object"&&typeof W.toString=="function"){const G=W.toString();if(G!=="[object Object]")return G}return W}function Q(W){return Array.isArray(W)?W.map(H):H(W)}function K(W,G,X,ie,oe,te,U){U=Q(U);const $=z[oe],q=$[ie%$.length];let B=[`%c[${W}]%c[${String(G).padStart(7," ")}]%c[len: ${String(X).padStart(5," ")}]%c${String(ie).padStart(5," ")} - ${te}`,"color: darkgreen","color: grey","color: grey",`color: ${q}`];/\($/.test(te)?(B=B.concat(U),B.push(")")):B.push(U),console.log.apply(console,B)}class V{constructor(G,X){this.d=G,this.f=X,this.a=0,this.b=0}logOutgoing(G,X,ie,oe,te){this.b+=G,K(this.d,this.b,G,X,ie,oe,te)}logIncoming(G,X,ie,oe,te){this.a+=G,K(this.f,this.a,G,X,ie,oe,te)}}e.IPCLogger=V}),define(re[149],ae([0,1,17,3,39]),function(_,e,A,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class k{constructor(P){this.a=P,this.onMessage=n.Event.fromDOMEventEmitter(this.a,"message",S=>A.VSBuffer.wrap(S.data)),P.start()}send(P){this.a.postMessage(P.buffer)}disconnect(){this.a.close()}}e.Protocol=k;class T extends D.IPCClient{constructor(P,S){const C=new k(P);super(C,S),this.b=C}dispose(){this.b.disconnect()}}e.Client=T}),define(re[93],ae([0,1,6,17,3,2,39]),function(_,e,A,n,D,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var R;(function(E){E.Created="created",E.Read="read",E.Write="write",E.Open="open",E.Error="error",E.Close="close",E.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",E.NodeEndReceived="nodeEndReceived",E.NodeEndSent="nodeEndSent",E.NodeDrainBegin="nodeDrainBegin",E.NodeDrainEnd="nodeDrainEnd",E.zlibInflateError="zlibInflateError",E.zlibInflateData="zlibInflateData",E.zlibInflateInitialWrite="zlibInflateInitialWrite",E.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",E.zlibInflateWrite="zlibInflateWrite",E.zlibInflateFlushFired="zlibInflateFlushFired",E.zlibDeflateError="zlibDeflateError",E.zlibDeflateData="zlibDeflateData",E.zlibDeflateWrite="zlibDeflateWrite",E.zlibDeflateFlushFired="zlibDeflateFlushFired",E.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",E.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",E.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",E.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",E.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",E.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",E.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",E.ProtocolHeaderRead="protocolHeaderRead",E.ProtocolMessageRead="protocolMessageRead",E.ProtocolHeaderWrite="protocolHeaderWrite",E.ProtocolMessageWrite="protocolMessageWrite",E.ProtocolWrite="protocolWrite"})(R=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var P;(function(E){E.enableDiagnostics=!1,E.records=[];const N=new WeakMap;let O=0;function j(L,F){if(!N.has(L)){const z=String(++O);N.set(L,z)}return N.get(L)}function M(L,F,z,H){if(!E.enableDiagnostics)return;const Q=j(L,F);if(H instanceof n.VSBuffer||H instanceof Uint8Array||H instanceof ArrayBuffer||ArrayBuffer.isView(H)){const K=n.VSBuffer.alloc(H.byteLength);K.set(H),E.records.push({timestamp:Date.now(),id:Q,label:F,type:z,buff:K})}else E.records.push({timestamp:Date.now(),id:Q,label:F,type:z,data:H})}E.traceSocketEvent=M})(P=e.SocketDiagnostics||(e.SocketDiagnostics={}));var S;(function(E){E[E.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",E[E.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(S=e.SocketCloseEventType||(e.SocketCloseEventType={}));let C=null;function b(){return C||(C=n.VSBuffer.alloc(0)),C}class m{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(N){this.a.push(N),this.b+=N.byteLength}read(N){return this.c(N,!0)}peek(N){return this.c(N,!1)}c(N,O){if(N===0)return b();if(N>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===N){const F=this.a[0];return O&&(this.a.shift(),this.b-=N),F}if(this.a[0].byteLength>N){const F=this.a[0].slice(0,N);return O&&(this.a[0]=this.a[0].slice(N),this.b-=N),F}const j=n.VSBuffer.alloc(N);let M=0,L=0;for(;N>0;){const F=this.a[L];if(F.byteLength>N){const z=F.slice(0,N);j.set(z,M),M+=N,O&&(this.a[L]=F.slice(N),this.b-=N),N-=N}else j.set(F,M),M+=F.byteLength,O?(this.a.shift(),this.b-=F.byteLength):L++,N-=F.byteLength}return j}}e.ChunkStream=m;var p;(function(E){E[E.None=0]="None",E[E.Regular=1]="Regular",E[E.Control=2]="Control",E[E.Ack=3]="Ack",E[E.Disconnect=5]="Disconnect",E[E.ReplayRequest=6]="ReplayRequest",E[E.Pause=7]="Pause",E[E.Resume=8]="Resume",E[E.KeepAlive=9]="KeepAlive",E[E.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",E[E.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(p||(p={}));function h(E){switch(E){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var y;(function(E){E[E.HeaderLength=13]="HeaderLength",E[E.AcknowledgeTime=2e3]="AcknowledgeTime",E[E.TimeoutTime=2e4]="TimeoutTime",E[E.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",E[E.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",E[E.KeepAliveSendTime=5e3]="KeepAliveSendTime",E[E.LatencySampleTime=6e4]="LatencySampleTime",E[E.LatencySampleCount=5]="LatencySampleCount",E[E.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",E[E.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(y=e.ProtocolConstants||(e.ProtocolConstants={}));class f{constructor(N,O,j,M){this.type=N,this.id=O,this.ack=j,this.data=M,this.writtenTime=0}get size(){return this.data.byteLength}}class l extends k.Disposable{constructor(N){super(),this.f=this.B(new D.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=N,this.b=!1,this.c=new m,this.B(this.a.onData(O=>this.acceptChunk(O))),this.lastReadTime=Date.now()}acceptChunk(N){if(!(!N||N.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(N);this.c.byteLength>=this.g.readLen;){const O=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=O.readUInt32BE(9),this.g.messageType=O.readUInt8(0),this.g.id=O.readUInt32BE(1),this.g.ack=O.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:h(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const j=this.g.messageType,M=this.g.id,L=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",O),this.f.fire(new f(j,M,L,O)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class d{constructor(N){this.k=null,this.a=!1,this.b=!1,this.c=N,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(N){if(this.a)return;N.writtenTime=Date.now(),this.lastWriteTime=Date.now();const O=n.VSBuffer.alloc(13);O.writeUInt8(N.type,0),O.writeUInt32BE(N.id,1),O.writeUInt32BE(N.ack,5),O.writeUInt32BE(N.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:h(N.type),id:N.id,ack:N.ack,messageSize:N.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",N.data),this.j(O,N.data)}g(N,O){const j=this.f===0;return this.d.push(N,O),this.f+=N.byteLength+O.byteLength,j}h(){const N=n.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,N}j(N,O){this.g(N,O)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const N=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:N.byteLength}),this.c.write(N)}}class g extends k.Disposable{constructor(N){super(),this.f=new D.Emitter,this.onMessage=this.f.event,this.g=new D.Emitter,this.onDidDispose=this.g.event,this.a=N,this.b=this.B(new d(this.a)),this.c=this.B(new l(this.a)),this.B(this.c.onMessage(O=>{O.type===1&&this.f.fire(O.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(N){this.b.write(new f(1,0,0,N))}}e.Protocol=g;class v extends T.IPCClient{static fromSocket(N,O){return new v(new g(N),O)}get onDidDispose(){return this.b.onDidDispose}constructor(N,O,j=null){super(N,O,j),this.b=N}dispose(){super.dispose();const N=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),N.end()}}e.Client=v;class I{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new D.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(N){this.b?this.d.length>0?this.d.push(N):this.a.fire(N):this.d.push(N)}flushBuffer(){this.d=[]}}e.BufferedEmitter=I;class i{constructor(N){this.data=N,this.next=null}}class r{constructor(){this.a=null,this.b=null}length(){let N=0,O=this.a;for(;O;)O=O.next,N++;return N}peek(){return this.a?this.a.data:null}toArray(){const N=[];let O=0,j=this.a;for(;j;)N[O++]=j.data,j=j.next;return N}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(N){const O=new i(N);if(!this.a){this.a=O,this.b=O;return}this.b.next=O,this.b=O}}class t{static getInstance(){return t.b||(t.b=new t),t.b}constructor(){this.c=[];const N=Date.now();for(let O=0;O<t.a;O++)this.c[O]=N-1e3*O;setInterval(()=>{for(let O=t.a;O>=1;O--)this.c[O]=this.c[O-1];this.c[0]=Date.now()},1e3)}d(){const N=Date.now(),O=(1+t.a)*1e3;let j=0;for(let M=0;M<t.a;M++)N-this.c[M]<=O&&j++;return 1-j/t.a}hasHighLoad(){return this.d()>=.5}}t.a=10,t.b=null;var s;(function(E){E[E.Good=0]="Good",E[E.Poor=1]="Poor"})(s=e.ConnectionHealth||(e.ConnectionHealth={}));function o(E){switch(E){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=o;class c{constructor(N){this.connectionHealth=N}}e.ConnectionHealthChangedEvent=c;class a{constructor(N,O){this.roundTripTime=N,this.recentHighRoundTripCount=O}}e.HighRoundTripTimeEvent=a;class u{get unacknowledgedCount(){return this.c-this.d}constructor(N){this.x=new I,this.onControlMessage=this.x.event,this.y=new I,this.onMessage=this.y.event,this.z=new I,this.onDidDispose=this.z.event,this.A=new I,this.onSocketClose=this.A.event,this.B=new I,this.onSocketTimeout=this.B.event,this.C=new I,this.onHighRoundTripTime=this.C.event,this.D=new I,this.onDidChangeConnectionHealth=this.D.event,this.u=N.loadEstimator??t.getInstance(),this.v=N.measureRoundTripTime??!1,this.w=N.sendKeepAlive??!0,this.a=!1,this.b=new r,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.t=new k.DisposableStore,this.o=N.socket,this.p=this.t.add(new d(this.o)),this.q=this.t.add(new l(this.o)),this.t.add(this.q.onMessage(O=>this.E(O))),this.t.add(this.o.onClose(O=>this.A.fire(O))),this.r=this.t.add(new w),this.t.add(this.r.onSendLatencyRequest(O=>this.J(O))),this.t.add(this.r.onHighRoundTripTime(O=>this.C.fire(O))),this.t.add(this.r.onDidChangeConnectionHealth(O=>this.D.fire(O))),this.v&&this.r.start(),N.initialChunk&&this.q.acceptChunk(N.initialChunk),this.w?this.l=setInterval(()=>{this.I()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.t.dispose()}drain(){return this.p.drain()}sendDisconnect(){const N=new f(5,0,0,b());this.p.write(N),this.p.flush()}sendPause(){const N=new f(7,0,0,b());this.p.write(N)}sendResume(){const N=new f(8,0,0,b());this.p.write(N)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(N,O){this.a=!0,this.t.dispose(),this.t=new k.DisposableStore,this.x.flushBuffer(),this.A.flushBuffer(),this.B.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=N,this.p=this.t.add(new d(this.o)),this.q=this.t.add(new l(this.o)),this.t.add(this.q.onMessage(j=>this.E(j))),this.t.add(this.o.onClose(j=>this.A.fire(j))),this.r=this.t.add(new w),this.t.add(this.r.onSendLatencyRequest(j=>this.J(j))),this.t.add(this.r.onHighRoundTripTime(j=>this.C.fire(j))),this.t.add(this.r.onDidChangeConnectionHealth(j=>this.D.fire(j))),this.q.acceptChunk(O)}endAcceptReconnection(){this.a=!1,this.v&&this.r.start(),this.h=this.g;const N=new f(3,0,this.h,b());this.p.write(N);const O=this.b.toArray();for(let j=0,M=O.length;j<M;j++)this.p.write(O[j]);this.G()}acceptDisconnect(){this.z.fire()}E(N){if(N.ack>this.d){this.d=N.ack;do{const O=this.b.peek();if(O&&O.id<=N.ack)this.b.pop();else break}while(!0)}switch(N.type){case 0:break;case 1:{if(N.id>this.g)if(N.id!==this.g+1){const O=Date.now();O-this.m>1e4&&(this.m=O,this.p.write(new f(6,0,0,b())))}else this.g=N.id,this.j=Date.now(),this.F(),this.y.fire(N.data);break}case 2:{this.x.fire(N.data);break}case 3:break;case 5:{this.z.fire();break}case 6:{const O=this.b.toArray();for(let j=0,M=O.length;j<M;j++)this.p.write(O[j]);this.G();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break;case 10:{this.K(N.data);break}case 11:{this.r.handleResponse(N.data);break}}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(N){const O=++this.c;this.h=this.g;const j=new f(1,O,this.h,N);this.b.push(j),this.a||(this.p.write(j),this.G())}sendControl(N){const O=new f(2,0,0,N);this.p.write(O)}F(){if(this.g<=this.h||this.k)return;const N=Date.now()-this.j;if(N>=2e3){this.H();return}this.k=setTimeout(()=>{this.k=null,this.F()},2e3-N+5)}G(){if(this.c<=this.d||this.f||this.a)return;const N=this.b.peek(),O=Date.now()-N.writtenTime,j=Date.now()-this.q.lastReadTime,M=Date.now()-this.n;if(O>=2e4&&j>=2e4&&M>=2e4&&!this.u.hasHighLoad()){this.n=Date.now(),this.B.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:O,timeSinceLastReceivedSomeData:j});return}const L=Math.max(2e4-O,2e4-j,2e4-M,500);this.f=setTimeout(()=>{this.f=null,this.G()},L)}H(){if(this.g<=this.h)return;this.h=this.g;const N=new f(3,0,this.h,b());this.p.write(N)}I(){this.h=this.g;const N=new f(9,0,this.h,b());this.p.write(N)}J(N){this.h=this.g;const O=new f(10,0,this.h,N);this.p.write(O)}K(N){this.h=this.g;const O=new f(11,0,this.h,N);this.p.write(O)}}e.PersistentProtocol=u;class w extends k.Disposable{constructor(){super(),this.a=this.B(new D.Emitter),this.onSendLatencyRequest=this.a.event,this.b=this.B(new D.Emitter),this.onHighRoundTripTime=this.b.event,this.c=this.B(new D.Emitter),this.onDidChangeConnectionHealth=this.c.event,this.f=this.B(new A.IntervalTimer),this.g=-1,this.h=0,this.j=Array.from({length:5},N=>0),this.k=0,this.l=0}start(){this.f.cancelAndSet(()=>{this.g=Date.now();const N=++this.h,O=n.VSBuffer.alloc(4);O.writeUInt32BE(N,0),this.a.fire(O)},6e4)}handleResponse(N){if(N.byteLength!==4)return;const O=N.readUInt32BE(0);if(this.g<=0||O!==this.h)return;const j=Date.now()-this.g,M=this.k++;this.j[M%this.j.length]=j;const L=this.l,F=this.j.filter(z=>z>=1e3).length;this.l=F>=3?1:0,j>1e3&&this.b.fire(new a(j,F)),L!==this.l&&this.c.fire(this.l)}}}),define(re[150],ae([0,1,94,3,39,149]),function(_,e,A,n,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class T extends D.IPCServer{static b(){const P=n.Event.fromNodeEventEmitter(A.ipcRenderer,"vscode:createMessageChannel",(S,C)=>C);return n.Event.map(P,S=>{const{port1:C,port2:b}=new MessageChannel,p={protocol:new k.Protocol(C),onDidClientDisconnect:n.Event.fromDOMEventEmitter(C,"close")};return A.ipcRenderer.postMessage("vscode:createMessageChannelResult",S,[b]),p})}constructor(){super(T.b())}}e.Server=T}),define(re[68],ae([0,1,50,6,17,23,143,7,3,2,32,92,87,39]),function(_,e,A,n,D,k,T,R,P,S,C,b,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class h extends p.ChannelServer{constructor(l){super({send:d=>{try{process.send?.(d.buffer.toString("base64"))}catch{}},onMessage:P.Event.fromNodeEventEmitter(process,"message",d=>D.VSBuffer.wrap(Buffer.from(d,"base64")))},l),process.once("disconnect",()=>this.dispose())}}e.Server=h;class y{constructor(l,d){this.i=l,this.j=d,this.c=new Set,this.g=new Map,this.h=new P.Emitter,this.onDidProcessExit=this.h.event;const g=d&&d.timeout?d.timeout:6e4;this.b=new n.Delayer(g),this.d=null,this.f=null}getChannel(l){const d=this;return{call(g,v,I){return d.k(l,g,v,I)},listen(g,v){return d.l(l,g,v)}}}k(l,d,g,v=k.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(v.isCancellationRequested)return Promise.reject(R.canceled());this.b.cancel();const I=this.n(l),i=(0,n.createCancelablePromise)(s=>I.call(d,g,s)),r=v.onCancellationRequested(()=>i.cancel()),t=(0,S.toDisposable)(()=>i.cancel());return this.c.add(t),i.finally(()=>{r.dispose(),this.c.delete(t),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(l,d,g){if(!this.b)return P.Event.None;this.b.cancel();let v;const I=new P.Emitter({onWillAddFirstListener:()=>{v=this.n(l).listen(d,g)(I.fire,I),this.c.add(v)},onDidRemoveLastListener:()=>{this.c.delete(v),v.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return I.event}get m(){if(!this.f){const l=this.j&&this.j.args?this.j.args:[],d=Object.create(null);d.env={...(0,C.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(d.env={...d.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(d.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(d.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(d.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),d.execArgv===void 0&&(d.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o))),(0,m.removeDangerousEnvVariables)(d.env),this.d=(0,A.fork)(this.i,l,d);const g=new P.Emitter;P.Event.fromNodeEventEmitter(this.d,"message",o=>o)(o=>{if((0,T.isRemoteConsoleLog)(o)){(0,T.log)(o,`IPC Library: ${this.j.serverName}`);return}g.fire(D.VSBuffer.wrap(Buffer.from(o,"base64")))});const I=this.j.useQueue?(0,b.createQueuedSender)(this.d):this.d,i=o=>this.d&&this.d.connected&&I.send(o.buffer.toString("base64")),r=g.event,t={send:i,onMessage:r};this.f=new p.ChannelClient(t);const s=()=>this.o();process.once("exit",s),this.d.on("error",o=>console.warn('IPC "'+this.j.serverName+'" errored with '+o)),this.d.on("exit",(o,c)=>{process.removeListener("exit",s),this.c.forEach(a=>(0,S.dispose)(a)),this.c.clear(),o!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+o+" and signal "+c),this.b?.cancel(),this.o(),this.h.fire({code:o,signal:c})})}return this.f}n(l){let d=this.g.get(l);return d||(d=this.m.getChannel(l),this.g.set(l,d)),d}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=y}),define(re[151],ae([0,1,17,7,3,2,12,5,31,39,93]),function(_,e,A,n,D,k,T,R,P,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function b(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class m{traceSocketEvent(a,u){C.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,a,u)}constructor(a,u=""){this.f=!0,this.debugLabel=u,this.socket=a,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=w=>{if(this.traceSocketEvent("error",{code:w?.code,message:w?.message}),w){if(w.code==="EPIPE")return;(0,n.onUnexpectedError)(w)}},this.socket.on("error",this.a),this.b=w=>{this.traceSocketEvent("close",{hadError:w}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(a){const u=w=>{this.traceSocketEvent("read",w),a(A.VSBuffer.wrap(w))};return this.socket.on("data",u),{dispose:()=>this.socket.off("data",u)}}onClose(a){const u=w=>{a({type:0,hadError:w,error:void 0})};return this.socket.on("close",u),{dispose:()=>this.socket.off("close",u)}}onEnd(a){const u=()=>{a()};return this.socket.on("end",u),{dispose:()=>this.socket.off("end",u)}}write(a){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",a),this.socket.write(a.buffer,u=>{if(u){if(u.code==="EPIPE")return;(0,n.onUnexpectedError)(u)}})}catch(u){if(u.code==="EPIPE")return;(0,n.onUnexpectedError)(u)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((a,u)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),a();return}const w=()=>{this.socket.off("close",w),this.socket.off("end",w),this.socket.off("error",w),this.socket.off("timeout",w),this.socket.off("drain",w),this.traceSocketEvent("nodeDrainEnd"),a()};this.socket.on("close",w),this.socket.on("end",w),this.socket.on("error",w),this.socket.on("timeout",w),this.socket.on("drain",w)})}}e.NodeSocket=m;var p;(function(c){c[c.MinHeaderByteSize=2]="MinHeaderByteSize"})(p||(p={}));var h;(function(c){c[c.PeekHeader=1]="PeekHeader",c[c.ReadHeader=2]="ReadHeader",c[c.ReadBody=3]="ReadBody",c[c.Fin=4]="Fin"})(h||(h={}));class y extends k.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(a,u){this.socket.traceSocketEvent(a,u)}constructor(a,u,w,E){super(),this.f=this.B(new D.Emitter),this.g=this.B(new D.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=a,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:u,inflateBytesLength:w?.byteLength||0,recordInflateBytes:E}),this.a=this.B(new f(this,u,w,E,this.f,(N,O)=>this.k(N,O))),this.B(this.a.onError(N=>{console.error(N),(0,n.onUnexpectedError)(N),this.g.fire({type:0,hadError:!0,error:N})})),this.b=new C.ChunkStream,this.B(this.socket.onData(N=>this.l(N))),this.B(this.socket.onClose(N=>this.g.fire(N)))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(a){return this.f.event(a)}onClose(a){return this.g.event(a)}onEnd(a){return this.socket.onEnd(a)}write(a){this.a.writeMessage(a)}k(a,u){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",a);let w=2;a.byteLength<126?w+=0:a.byteLength<2**16?w+=2:w+=8;const E=A.VSBuffer.alloc(w);if(u?E.writeUInt8(194,0):E.writeUInt8(130,0),a.byteLength<126)E.writeUInt8(a.byteLength,1);else if(a.byteLength<2**16){E.writeUInt8(126,1);let N=1;E.writeUInt8(a.byteLength>>>8&255,++N),E.writeUInt8(a.byteLength>>>0&255,++N)}else{E.writeUInt8(127,1);let N=1;E.writeUInt8(0,++N),E.writeUInt8(0,++N),E.writeUInt8(0,++N),E.writeUInt8(0,++N),E.writeUInt8(a.byteLength>>>24&255,++N),E.writeUInt8(a.byteLength>>>16&255,++N),E.writeUInt8(a.byteLength>>>8&255,++N),E.writeUInt8(a.byteLength>>>0&255,++N)}this.socket.write(A.VSBuffer.concat([E,a]))}end(){this.h=!0,this.socket.end()}l(a){if(a.byteLength!==0){for(this.b.acceptChunk(a);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const u=this.b.peek(this.j.readLen),w=u.readUInt8(0),E=(w&128)>>>7,N=(w&64)>>>6,O=u.readUInt8(1),j=(O&128)>>>7,M=O&127;this.j.state=2,this.j.readLen=2+(j?4:0)+(M===126?2:0)+(M===127?8:0),this.j.fin=E,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(N)),this.j.firstFrameOfMessage=Boolean(E),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const u=this.b.read(this.j.readLen),w=u.readUInt8(1),E=(w&128)>>>7;let N=w&127,O=1;N===126?N=u.readUInt8(++O)*2**8+u.readUInt8(++O):N===127&&(N=u.readUInt8(++O)*0+u.readUInt8(++O)*0+u.readUInt8(++O)*0+u.readUInt8(++O)*0+u.readUInt8(++O)*2**24+u.readUInt8(++O)*2**16+u.readUInt8(++O)*2**8+u.readUInt8(++O));let j=0;E&&(j=u.readUInt8(++O)*2**24+u.readUInt8(++O)*2**16+u.readUInt8(++O)*2**8+u.readUInt8(++O)),this.j.state=3,this.j.readLen=N,this.j.mask=j,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const u=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",u),g(u,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",u),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(u,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await D.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=y;class f extends k.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:A.VSBuffer.alloc(0)}constructor(a,u,w,E,N,O){super(),this.k=a,this.l=N,this.m=O,this.a=this.B(new D.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new D.Emitter),this.onDidFinishProcessingWriteQueue=this.j.event,this.n=!1,this.s=!1,u?(this.b=this.B(new l(this.k,E,w,{windowBits:15})),this.f=this.B(new d(this.k,{windowBits:15})),this.B(this.b.onError(j=>this.a.fire(j))),this.B(this.f.onError(j=>this.a.fire(j)))):(this.b=null,this.f=null)}writeMessage(a){this.g.push(a),this.p()}async p(){if(!this.n){for(this.n=!0;this.g.length>0;){const a=this.g.shift();if(this.f){const u=await this.r(this.f,a);this.m(u,!0)}else this.m(a,!1)}this.n=!1,this.j.fire()}}isProcessingWriteQueue(){return this.n}r(a,u){return new Promise((w,E)=>{a.write(u),a.flush(N=>w(N))})}acceptFrame(a,u,w){this.h.push({data:a,isCompressed:u,isLastFrameOfMessage:w}),this.t()}async t(){if(!this.s){for(this.s=!0;this.h.length>0;){const a=this.h.shift();if(this.b&&a.isCompressed){const u=await this.u(this.b,a.data,a.isLastFrameOfMessage);this.l.fire(u)}else this.l.fire(a.data)}this.s=!1}}u(a,u,w){return new Promise((E,N)=>{a.write(u),w&&a.write(A.VSBuffer.fromByteArray([0,0,255,255])),a.flush(O=>E(O))})}}class l extends k.Disposable{get recordedInflateBytes(){return this.j?A.VSBuffer.concat(this.f):A.VSBuffer.alloc(0)}constructor(a,u,w,E){super(),this.h=a,this.j=u,this.a=this.B(new D.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=b().zlib.createInflateRaw(E),this.b.on("error",N=>{this.h.traceSocketEvent("zlibInflateError",{message:N?.message,code:N?.code}),this.a.fire(N)}),this.b.on("data",N=>{this.h.traceSocketEvent("zlibInflateData",N),this.g.push(A.VSBuffer.wrap(N))}),w&&(this.h.traceSocketEvent("zlibInflateInitialWrite",w.buffer),this.b.write(w.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(a){this.j&&this.f.push(a.clone()),this.h.traceSocketEvent("zlibInflateWrite",a),this.b.write(a.buffer)}flush(a){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const u=A.VSBuffer.concat(this.g);this.g.length=0,a(u)})}}class d extends k.Disposable{constructor(a,u){super(),this.g=a,this.a=this.B(new D.Emitter),this.onError=this.a.event,this.f=[],this.b=b().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",w=>{this.g.traceSocketEvent("zlibDeflateError",{message:w?.message,code:w?.code}),this.a.fire(w)}),this.b.on("data",w=>{this.g.traceSocketEvent("zlibDeflateData",w),this.f.push(A.VSBuffer.wrap(w))})}write(a){this.g.traceSocketEvent("zlibDeflateWrite",a.buffer),this.b.write(a.buffer)}flush(a){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let u=A.VSBuffer.concat(this.f);this.f.length=0,u=u.slice(0,u.byteLength-4),a(u)})}}function g(c,a){if(a===0)return;const u=c.byteLength>>>2;for(let M=0;M<u;M++){const L=c.readUInt32BE(M*4);c.writeUInt32BE(L^a,M*4)}const w=u*4,E=c.byteLength-w,N=a>>>24&255,O=a>>>16&255,j=a>>>8&255;E>=1&&c.writeUInt8(c.readUInt8(w)^N,w),E>=2&&c.writeUInt8(c.readUInt8(w+1)^O,w+1),E>=3&&c.writeUInt8(c.readUInt8(w+2)^j,w+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const v={[2]:107,[1]:103};function I(){const c=(0,P.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${c}-sock`;let a;return e.XDG_RUNTIME_DIR?a=(0,T.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${c}.sock`):a=(0,T.join)(b().os.tmpdir(),`vscode-ipc-${c}.sock`),r(a),a}e.createRandomIPCHandle=I;function i(c,a,u){const w=b().crypto.createHash("md5").update(c).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${w}-${u}-${a}-sock`;let E;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?E=(0,T.join)(e.XDG_RUNTIME_DIR,`vscode-${w.substr(0,8)}-${u}-${a}.sock`):E=(0,T.join)(c,`${u}-${a}.sock`),r(E),E}e.createStaticIPCHandle=i;function r(c){const a=v[R.platform];typeof a=="number"&&c.length>=a&&console.warn(`WARNING: IPC handle "${c}" is longer than ${a} chars, try a shorter --user-data-dir`)}class t extends S.IPCServer{static b(a){const u=D.Event.fromNodeEventEmitter(a,"connection");return D.Event.map(u,w=>({protocol:new C.Protocol(new m(w,"ipc-server-connection")),onDidClientDisconnect:D.Event.once(D.Event.fromNodeEventEmitter(w,"close"))}))}constructor(a){super(t.b(a)),this.d=a}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=t;function s(c){return new Promise((a,u)=>{const w=b().net.createServer();w.on("error",u),w.listen(c,()=>{w.removeListener("error",u),a(new t(w))})})}e.serve=s;function o(c,a){return new Promise((u,w)=>{const E=b().net.createConnection(c,()=>{E.removeListener("error",w),u(C.Client.fromSocket(new m(E,`ipc-client${a}`),a))});E.once("error",w)})}e.connect=o}),define(re[69],ae([0,1,6,3,2,14]),function(_,e,A,n,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var T;(function(b){b[b.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",b[b.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(T=e.StorageHint||(e.StorageHint={}));function R(b){const m=b;return m?.changed instanceof Map||m?.deleted instanceof Set}e.isStorageItemsChangeEvent=R;var P;(function(b){b[b.None=0]="None",b[b.Initialized=1]="Initialized",b[b.Closed=2]="Closed"})(P=e.StorageState||(e.StorageState={}));class S extends D.Disposable{constructor(m,p=Object.create(null)){super(),this.m=m,this.n=p,this.b=this.B(new n.Emitter),this.onDidChangeStorage=this.b.event,this.c=P.None,this.f=new Map,this.g=new A.ThrottledDelayer(S.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(m=>this.r(m)))}r(m){m.changed?.forEach((p,h)=>this.s(h,p)),m.deleted?.forEach(p=>this.s(p,void 0))}s(m,p){if(this.c===P.Closed)return;let h=!1;(0,k.isUndefinedOrNull)(p)?h=this.f.delete(m):this.f.get(m)!==p&&(this.f.set(m,p),h=!0),h&&this.b.fire(m)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===P.None&&(this.c=P.Initialized,this.n.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(m,p){const h=this.f.get(m);return(0,k.isUndefinedOrNull)(h)?p:h}getBoolean(m,p){const h=this.get(m);return(0,k.isUndefinedOrNull)(h)?p:h==="true"}getNumber(m,p){const h=this.get(m);return(0,k.isUndefinedOrNull)(h)?p:parseInt(h,10)}async set(m,p){if(this.c===P.Closed)return;if((0,k.isUndefinedOrNull)(p))return this.delete(m);const h=String(p);if(this.f.get(m)!==h)return this.f.set(m,h),this.j.set(m,h),this.h.delete(m),this.b.fire(m),this.w()}async delete(m){if(!(this.c===P.Closed||!this.f.delete(m)))return this.h.has(m)||this.h.add(m),this.j.delete(m),this.b.fire(m),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=P.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const m={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(m).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(m){if(!!this.u)return this.w(m)}async w(m){return this.g.trigger(()=>this.v(),m)}async whenFlushed(){if(!!this.u)return new Promise(m=>this.l.push(m))}isInMemory(){return this.n.hint===T.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}e.Storage=S,S.a=100;class C{constructor(){this.onDidChangeItemsExternal=n.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(m){m.insert?.forEach((p,h)=>this.a.set(h,p)),m.delete?.forEach(p=>this.a.delete(p))}async close(){}}e.InMemoryStorageDatabase=C}),define(re[152],ae([10,11]),function(_,e){return _.create("vs/base/node/zip",e)}),define(re[153],ae([10,11]),function(_,e){return _.create("vs/platform/configuration/common/configurationRegistry",e)}),define(re[154],ae([10,11]),function(_,e){return _.create("vs/platform/environment/node/argv",e)}),define(re[155],ae([10,11]),function(_,e){return _.create("vs/platform/environment/node/argvHelper",e)}),define(re[156],ae([10,11]),function(_,e){return _.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(re[157],ae([10,11]),function(_,e){return _.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(re[158],ae([10,11]),function(_,e){return _.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(re[159],ae([10,11]),function(_,e){return _.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(re[160],ae([10,11]),function(_,e){return _.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(re[161],ae([10,11]),function(_,e){return _.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(re[162],ae([10,11]),function(_,e){return _.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(re[163],ae([10,11]),function(_,e){return _.create("vs/platform/extensions/common/extensionValidator",e)}),define(re[164],ae([10,11]),function(_,e){return _.create("vs/platform/files/common/fileService",e)}),define(re[165],ae([10,11]),function(_,e){return _.create("vs/platform/files/common/files",e)}),define(re[166],ae([10,11]),function(_,e){return _.create("vs/platform/files/common/io",e)}),define(re[167],ae([10,11]),function(_,e){return _.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(re[168],ae([10,11]),function(_,e){return _.create("vs/platform/languagePacks/common/languagePacks",e)}),define(re[169],ae([10,11]),function(_,e){return _.create("vs/platform/remoteTunnel/electron-browser/remoteTunnelService",e)}),define(re[170],ae([10,11]),function(_,e){return _.create("vs/platform/request/common/request",e)}),define(re[171],ae([10,11]),function(_,e){return _.create("vs/platform/shell/node/shellEnv",e)}),define(re[172],ae([10,11]),function(_,e){return _.create("vs/platform/telemetry/common/telemetryService",e)}),define(re[173],ae([10,11]),function(_,e){return _.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(re[174],ae([10,11]),function(_,e){return _.create("vs/platform/terminal/common/terminalProfiles",e)}),define(re[175],ae([10,11]),function(_,e){return _.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(re[176],ae([10,11]),function(_,e){return _.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(re[177],ae([10,11]),function(_,e){return _.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(re[178],ae([10,11]),function(_,e){return _.create("vs/platform/userDataSync/common/settingsSync",e)}),define(re[179],ae([10,11]),function(_,e){return _.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(re[180],ae([10,11]),function(_,e){return _.create("vs/platform/userDataSync/common/userDataSync",e)}),define(re[181],ae([10,11]),function(_,e){return _.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(re[182],ae([10,11]),function(_,e){return _.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(re[183],ae([10,11]),function(_,e){return _.create("vs/platform/workspace/common/workspace",e)}),define(re[95],ae([0,1,65,63,24,12,36,22,8]),function(_,e,A,n,D,k,T,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class S{get appRoot(){return(0,k.dirname)(D.FileAccess.asFileUri("").fsPath)}get userHome(){return P.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return P.URI.file((0,k.join)(this.userDataPath,"User"))}get tmpDir(){return P.URI.file(this.b.tmpDir)}get cacheHome(){return P.URI.file(this.userDataPath)}get stateResource(){return(0,R.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,R.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const h=(0,A.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,k.join)(this.userDataPath,"logs",h)}return this.args.logsPath}get userDataSyncLogResource(){return P.URI.file((0,k.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return P.URI.file((0,k.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.joinPath)(P.URI.file((0,k.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,R.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,R.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=T.env.VSCODE_PORTABLE;return h?P.URI.file((0,k.join)(h,"argv.json")):(0,R.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return P.URI.file((0,k.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,k.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,k.resolve)(h):(0,k.normalize)((0,k.join)(D.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const h=this.args["extensions-download-dir"];return h?P.URI.file((0,k.resolve)(h)):P.URI.file((0,k.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,k.resolve)(h);const y=T.env.VSCODE_EXTENSIONS;if(y)return y;const f=T.env.VSCODE_PORTABLE;return f?(0,k.join)(f,"extensions"):(0,R.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(y=>/^[^:/?#]+?:\/\//.test(y)?P.URI.parse(y):P.URI.file((0,k.normalize)(y)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?P.URI.parse(h):P.URI.file((0,k.normalize)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return C(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!T.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(h=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(h))}get extensionLogLevel(){const h=[];for(const y of this.args.log||[]){const f=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(y);f&&f[1]&&f[2]&&h.push([f[1],f[2]])}return h.length?h:void 0}get serviceMachineIdResource(){return(0,R.joinPath)(P.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return P.URI.file((0,k.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const h=T.env.VSCODE_PORTABLE;return h?P.URI.file((0,k.join)(h,"policy.json")):(0,R.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(h){this.args.continueOn=h}get args(){return this.a}constructor(h,y,f){this.a=h,this.b=y,this.c=f,this.editSessionId=this.args.editSessionId}}ye([n.memoize],S.prototype,"appRoot",null),ye([n.memoize],S.prototype,"userHome",null),ye([n.memoize],S.prototype,"userDataPath",null),ye([n.memoize],S.prototype,"appSettingsHome",null),ye([n.memoize],S.prototype,"tmpDir",null),ye([n.memoize],S.prototype,"cacheHome",null),ye([n.memoize],S.prototype,"stateResource",null),ye([n.memoize],S.prototype,"userRoamingDataHome",null),ye([n.memoize],S.prototype,"userDataSyncHome",null),ye([n.memoize],S.prototype,"userDataSyncLogResource",null),ye([n.memoize],S.prototype,"editSessionsLogResource",null),ye([n.memoize],S.prototype,"sync",null),ye([n.memoize],S.prototype,"machineSettingsResource",null),ye([n.memoize],S.prototype,"workspaceStorageHome",null),ye([n.memoize],S.prototype,"localHistoryHome",null),ye([n.memoize],S.prototype,"keyboardLayoutResource",null),ye([n.memoize],S.prototype,"argvResource",null),ye([n.memoize],S.prototype,"isExtensionDevelopment",null),ye([n.memoize],S.prototype,"untitledWorkspacesHome",null),ye([n.memoize],S.prototype,"installSourcePath",null),ye([n.memoize],S.prototype,"builtinExtensionsPath",null),ye([n.memoize],S.prototype,"extensionsPath",null),ye([n.memoize],S.prototype,"extensionDevelopmentLocationURI",null),ye([n.memoize],S.prototype,"extensionDevelopmentKind",null),ye([n.memoize],S.prototype,"extensionTestsLocationURI",null),ye([n.memoize],S.prototype,"debugExtensionHost",null),ye([n.memoize],S.prototype,"logLevel",null),ye([n.memoize],S.prototype,"extensionLogLevel",null),ye([n.memoize],S.prototype,"serviceMachineIdResource",null),ye([n.memoize],S.prototype,"telemetryLogResource",null),ye([n.memoize],S.prototype,"disableWorkspaceTrust",null),ye([n.memoize],S.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=S;function C(p,h){return m(p["inspect-extensions"],p["inspect-brk-extensions"],5870,h,p.debugId,p.extensionEnvironment)}e.parseExtensionHostPort=C;function b(p,h){return m(p["inspect-ptyhost"],p["inspect-brk-ptyhost"],5877,h,p.extensionEnvironment)}e.parsePtyHostPort=b;function m(p,h,y,f,l,d){const v=Number(h||p)||(f?null:y),I=v?Boolean(!!h):!1;let i;if(d)try{i=JSON.parse(d)}catch{}return{port:v,break:I,debugId:l,env:i}}}),define(re[184],ae([0,1,285,5,154]),function(_,e,A,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const k={o:(0,D.localize)(0,null),e:(0,D.localize)(1,null),t:(0,D.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,D.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,D.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,D.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,D.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,D.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,D.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,D.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,D.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,D.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,D.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,D.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,D.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,D.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,D.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,D.localize)(17,null)},category:{type:"string",cat:"e",description:(0,D.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,D.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,D.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,D.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,D.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,D.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,D.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,D.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,D.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,D.localize)(27,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,D.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,D.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,D.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,D.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,D.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,D.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,D.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,D.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const T={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function R(y,f,l=T){const d=y.find(c=>c.length>0&&c[0]!=="-"),g={},v=["_"],I=[],i={};let r;for(const c in f){const a=f[c];a.type==="subcommand"?c===d&&(r=a):(a.alias&&(g[c]=a.alias),a.type==="string"||a.type==="string[]"?(v.push(c),a.deprecates&&v.push(...a.deprecates)):a.type==="boolean"&&(I.push(c),a.deprecates&&I.push(...a.deprecates)),a.global&&(i[c]=a))}if(r&&d){const c=i;for(const E in r.options)c[E]=r.options[E];const a=y.filter(E=>E!==d),u=l.getSubcommandReporter?l.getSubcommandReporter(d):void 0,w=R(a,c,u);return{[d]:w,_:[]}}const t=A(y,{string:v,boolean:I,alias:g}),s={},o=t;s._=t._.map(c=>String(c)).filter(c=>c.length>0),delete o._;for(const c in f){const a=f[c];if(a.type==="subcommand")continue;a.alias&&delete o[a.alias];let u=o[c];if(a.deprecates)for(const w of a.deprecates)o.hasOwnProperty(w)&&(u||(u=o[w],u&&l.onDeprecatedOption(w,a.deprecationMessage||(0,D.localize)(36,null,c))),delete o[w]);if(typeof u<"u"){if(a.type==="string[]"){if(Array.isArray(u)||(u=[u]),!a.allowEmptyValue){const w=u.filter(E=>E.length>0);w.length!==u.length&&(l.onEmptyValue(c),u=w.length>0?w:void 0)}}else a.type==="string"&&(Array.isArray(u)?(u=u.pop(),l.onMultipleValues(c,u)):!u&&!a.allowEmptyValue&&(l.onEmptyValue(c),u=void 0));s[c]=u,a.deprecationMessage&&l.onDeprecatedOption(c,a.deprecationMessage)}delete o[c]}for(const c in o)l.onUnknownOption(c);return s}e.parseArgs=R;function P(y,f){let l="";return f.args&&(Array.isArray(f.args)?l=` <${f.args.join("> <")}>`:l=` <${f.args}>`),f.alias?`-${f.alias} --${y}${l}`:`--${y}${l}`}function S(y,f){const l=[];for(const d in y){const g=y[d],v=P(d,g);l.push([v,g.description])}return C(l,f)}e.formatOptions=S;function C(y,f){const d=y.reduce((I,i)=>Math.max(I,i[0].length),12)+2+1;if(f-d<25)return y.reduce((I,i)=>I.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);const g=f-d-1,v=[];for(const I of y){const i=I[0],r=m(I[1],g),t=b(d-i.length-2);v.push("  "+i+t+r[0]);for(let s=1;s<r.length;s++)v.push(b(d)+r[s])}return v}function b(y){return" ".repeat(y)}function m(y,f){const l=[];for(;y.length;){const d=y.length<f?y.length:y.lastIndexOf(" ",f),g=y.slice(0,d).trim();y=y.slice(d),l.push(g)}return l}function p(y,f,l,d,g){const v=process.stdout.isTTY&&process.stdout.columns||80,I=g?.noInputFiles!==!0?`[${(0,D.localize)(37,null)}...]`:"",i=[`${y} ${l}`];i.push(""),i.push(`${(0,D.localize)(38,null)}: ${f} [${(0,D.localize)(39,null)}]${I}`),i.push(""),g?.noPipe!==!0&&(n.isWindows?i.push((0,D.localize)(40,null,f)):i.push((0,D.localize)(41,null,f)),i.push(""));const r={},t=[];for(const s in d){const o=d[s];if(o.type==="subcommand")o.description&&t.push({command:s,description:o.description});else if(o.description&&o.cat){let c=r[o.cat];c||(r[o.cat]=c={}),c[s]=o}}for(const s in r){const o=s,c=r[o];c&&(i.push(k[o]),i.push(...S(c,v)),i.push(""))}return t.length&&(i.push((0,D.localize)(42,null)),i.push(...C(t.map(s=>[s.command,s.description]),v)),i.push("")),i.join(`
`)}e.buildHelpMessage=p;function h(y,f){return`${y||(0,D.localize)(43,null)}
${f||(0,D.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=h}),define(re[185],ae([0,1,286,155,184]),function(_,e,A,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const k=2048;function T(m,p){const h=(v,I)=>{console.warn((0,n.localize)(0,null,v,I))},y=v=>{console.warn((0,n.localize)(1,null,v))},f=(v,I)=>{console.warn((0,n.localize)(2,null,v,I))},l=v=>({onUnknownOption:I=>{v!=="tunnel"&&console.warn((0,n.localize)(3,null,I,v))},onMultipleValues:h,onEmptyValue:y,onDeprecatedOption:f,getSubcommandReporter:v!=="tunnel"?l:void 0}),d={onUnknownOption:v=>{console.warn((0,n.localize)(4,null,v))},onMultipleValues:h,onEmptyValue:y,onDeprecatedOption:f,getSubcommandReporter:l},g=(0,D.parseArgs)(m,D.OPTIONS,p?d:void 0);return g.goto&&g._.forEach(v=>A(/^(\w:)?[^:]+(:\d*){0,2}$/.test(v),(0,n.localize)(5,null))),g["max-memory"]&&A(parseInt(g["max-memory"])>=k,`The max-memory argument cannot be specified lower than ${k} MB.`),g}function R(m){const p=m.findIndex(h=>!/^-/.test(h));if(p>-1)return[...m.slice(0,p),...m.slice(p+1)]}function P(m){let[,...p]=m;process.env.VSCODE_DEV&&(p=R(p)||[]);const h=!b(process.env);return T(p,h)}e.parseMainProcessArgv=P;function S(m){let[,,...p]=m;return process.env.VSCODE_DEV&&(p=R(p)||[]),T(p,!0)}e.parseCLIProcessArgv=S;function C(m,...p){const h=m.indexOf("--");return h===-1?m.push(...p):m.splice(h,0,...p),m}e.addArg=C;function b(m){return m.VSCODE_CLI==="1"}e.isLaunchedFromCli=b}),function(){"use strict";function _(e,A,n){function D(T,R){const P=k(T,R),S=[P];return e.isAbsolute(P)||S.unshift(n),e.resolve(...S)}function k(T,R){process.env.VSCODE_DEV&&(R="code-oss-dev");const P=process.env.VSCODE_PORTABLE;if(P)return e.join(P,"user-data");let S=process.env.VSCODE_APPDATA;if(S)return e.join(S,R);const C=T["user-data-dir"];if(C)return C;switch(process.platform){case"win32":if(S=process.env.APPDATA,!S){const b=process.env.USERPROFILE;if(typeof b!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");S=e.join(b,"AppData","Roaming")}break;case"darwin":S=e.join(A.homedir(),"Library","Application Support");break;case"linux":S=process.env.XDG_CONFIG_HOME||e.join(A.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(S,R)}return{getUserDataPath:D}}if(typeof define=="function")define(re[186],ae([287,34,36]),function(e,A,n){return _(e,A,n.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),A=require("os");module.exports=_(e,A,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(re[187],ae([0,1,34,95,186]),function(_,e,A,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class k extends n.AbstractNativeEnvironmentService{constructor(R,P){super(R,{homeDir:(0,A.homedir)(),tmpDir:(0,A.tmpdir)(),userDataDir:(0,D.getUserDataPath)(R,P.nameShort)},P)}}e.NativeEnvironmentService=k}),define(re[188],ae([0,1,8]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const n=/^([^@:]+@)?([^:]+):/,D=/^([^@:]+@)?([^:]+):(.+)$/,k=/^([^@]+@)?([^:]+)(:\d+)?$/,T=/([^@:.]+\.[^@:.]+)(:\d+)?$/,R=/^\s*url\s*=\s*(.+\S)\s*$/mg,P=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function S(f){const l=f.match(T);return l?l[1]:null}function C(f){if(f.indexOf("://")===-1){const l=f.match(n);return l?S(l[2]):null}try{const l=A.URI.parse(f);if(l.authority)return S(l.authority)}catch{}return null}function b(f,l){const d=new Set;let g;for(;g=R.exec(f);){const I=C(g[1]);I&&d.add(I)}const v=new Set(l);return Array.from(d).map(I=>v.has(I)?I:I.replace(P,"a"))}e.getDomainsOfRemotes=b;function m(f){const l=f.match(k);return l?l[2]:null}function p(f,l,d){return f&&l?(d&&l.endsWith(".git")&&(l=l.substr(0,l.length-4)),l.indexOf("/")===0?`${f}${l}`:`${f}/${l}`):null}function h(f,l){if(f.indexOf("://")===-1){const d=f.match(D);if(d)return p(d[2],d[3],l)}try{const d=A.URI.parse(f);if(d.authority)return p(m(d.authority),d.path,l)}catch{}return null}function y(f,l=!1){const d=[];let g;for(;g=R.exec(f);){const v=h(g[1],l);v&&d.push(v)}return d}e.getRemotes=y}),define(re[189],ae([0,1,14,158]),function(_,e,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function D(T,R,P){try{k(T,R,P)}catch(S){console.error(S?.message??S)}return T}e.localizeManifest=D;function k(T,R,P){const S=(C,b,m)=>{const p=C[b];if((0,A.isString)(p)){const h=p,y=h.length;if(y>1&&h[0]==="%"&&h[y-1]==="%"){const f=h.substr(1,y-2);let l=R[f];l===void 0&&P&&(l=P[f]);const d=typeof l=="string"?l:l?.message,g=P?.[f],v=typeof g=="string"?g:g?.message;if(!d){v||console.warn(`[${T.name}]: ${(0,n.localize)(0,null,f)}`);return}if(m&&(b==="title"||b==="category")&&v&&v!==d){const I={value:d,original:v};C[b]=I}else C[b]=d}}else if((0,A.isObject)(p))for(const h in p)p.hasOwnProperty(h)&&(h==="commands"?S(p,h,!0):S(p,h,m));else if(Array.isArray(p))for(let h=0;h<p.length;h++)S(p,h,m)};for(const C in T)T.hasOwnProperty(C)&&S(T,C)}}),define(re[190],ae([0,1,7]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class n{constructor(){this.a=new Map}register(k,T){this.a.set(k,T)}updateManifest(k){if(!(typeof k.main>"u"&&typeof k.browser>"u")&&(k.activationEvents===void 0&&Object.assign(k,{activationEvents:[]}),!(!Array.isArray(k.activationEvents)||!k.contributes)))for(const T in k.contributes){const R=this.a.get(T);if(!R)continue;const P=k.contributes[T],S=Array.isArray(P)?P:[P];try{R(S,k.activationEvents)}catch(C){(0,A.onUnexpectedError)(C)}}}}e.ImplicitActivationEventsImpl=n,e.ImplicitActivationEvents=new n}),define(re[191],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class A{constructor(k){this.a=k}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(k,T,R,P){return this.a.call("promptImportantExtensionsInstallNotification",[k,T,R,P])}promptWorkspaceRecommendations(k){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=A;class n{constructor(k){this.a=k}listen(k,T){throw new Error(`Event not found: ${T}`)}call(k,T,R){switch(T){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(R[0],R[1],R[2],R[3])}throw new Error(`Call not found: ${T}`)}}e.ExtensionRecommendationNotificationServiceChannel=n}),define(re[70],ae([0,1,22,89,163,54]),function(_,e,A,n,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function P(l){return l=l.trim(),l==="*"||T.test(l)}e.isValidVersionStr=P;function S(l){if(!P(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const d=l.match(T);return d?{hasCaret:d[1]==="^",hasGreaterEquals:d[1]===">=",majorBase:d[2]==="x"?0:parseInt(d[2],10),majorMustEqual:d[2]!=="x",minorBase:d[4]==="x"?0:parseInt(d[4],10),minorMustEqual:d[4]!=="x",patchBase:d[6]==="x"?0:parseInt(d[6],10),patchMustEqual:d[6]!=="x",preRelease:d[8]||null}:null}e.parseVersion=S;function C(l){if(!l)return null;const d=l.majorBase,g=l.majorMustEqual,v=l.minorBase;let I=l.minorMustEqual;const i=l.patchBase;let r=l.patchMustEqual;l.hasCaret&&(d===0||(I=!1),r=!1);let t=0;if(l.preRelease){const s=R.exec(l.preRelease);if(s){const[,o,c,a]=s;t=Date.UTC(Number(o),Number(c)-1,Number(a))}}return{majorBase:d,majorMustEqual:g,minorBase:v,minorMustEqual:I,patchBase:i,patchMustEqual:r,isMinimum:l.hasGreaterEquals,notBefore:t}}e.normalizeVersion=C;function b(l,d,g){let v;typeof l=="string"?v=C(S(l)):v=l;let I;d instanceof Date?I=d.getTime():typeof d=="string"&&(I=new Date(d).getTime());let i;if(typeof g=="string"?i=C(S(g)):i=g,!v||!i)return!1;const r=v.majorBase,t=v.minorBase,s=v.patchBase;let o=i.majorBase,c=i.minorBase,a=i.patchBase;const u=i.notBefore;let w=i.majorMustEqual,E=i.minorMustEqual,N=i.patchMustEqual;return i.isMinimum?r>o?!0:r<o?!1:t>c?!0:t<c||I&&I<u?!1:s>=a:(r===1&&o===0&&(!w||!E||!N)&&(o=1,c=0,a=0,w=!0,E=!1,N=!1),r<o?!1:r>o?!w:t<c?!1:t>c?!E:s<a?!1:s>a?!N:!(I&&I<u))}e.isValidVersion=b;function m(l,d,g,v,I){const i=[];if(typeof v.publisher<"u"&&typeof v.publisher!="string")return i.push([n.default.Error,D.localize(0,null)]),i;if(typeof v.name!="string")return i.push([n.default.Error,D.localize(1,null,"name")]),i;if(typeof v.version!="string")return i.push([n.default.Error,D.localize(2,null,"version")]),i;if(!v.engines)return i.push([n.default.Error,D.localize(3,null,"engines")]),i;if(typeof v.engines.vscode!="string")return i.push([n.default.Error,D.localize(4,null,"engines.vscode")]),i;if(typeof v.extensionDependencies<"u"&&!f(v.extensionDependencies))return i.push([n.default.Error,D.localize(5,null,"extensionDependencies")]),i;if(typeof v.activationEvents<"u"){if(!f(v.activationEvents))return i.push([n.default.Error,D.localize(6,null,"activationEvents")]),i;if(typeof v.main>"u"&&typeof v.browser>"u")return i.push([n.default.Error,D.localize(7,null,"activationEvents","main")]),i}if(typeof v.extensionKind<"u"&&typeof v.main>"u"&&i.push([n.default.Warning,D.localize(8,null,"extensionKind")]),typeof v.main<"u"){if(typeof v.main!="string")return i.push([n.default.Error,D.localize(9,null,"main")]),i;{const s=(0,A.joinPath)(g,v.main);(0,A.isEqualOrParent)(s,g)||i.push([n.default.Warning,D.localize(10,null,s.path,g.path)])}if(typeof v.activationEvents>"u")return i.push([n.default.Error,D.localize(11,null,"activationEvents","main")]),i}if(typeof v.browser<"u"){if(typeof v.browser!="string")return i.push([n.default.Error,D.localize(12,null,"browser")]),i;{const s=(0,A.joinPath)(g,v.browser);(0,A.isEqualOrParent)(s,g)||i.push([n.default.Warning,D.localize(13,null,s.path,g.path)])}if(typeof v.activationEvents>"u")return i.push([n.default.Error,D.localize(14,null,"activationEvents","browser")]),i}if(!k.valid(v.version))return i.push([n.default.Error,D.localize(15,null)]),i;const r=[];if(!p(l,d,v,I,r))for(const s of r)i.push([n.default.Error,s]);return i}e.validateExtensionManifest=m;function p(l,d,g,v,I){return v||typeof g.main>"u"&&typeof g.browser>"u"?!0:y(l,d,g.engines.vscode,I)}e.isValidExtensionVersion=p;function h(l,d,g){return l==="*"||y(d,g,l)}e.isEngineValid=h;function y(l,d,g,v=[]){const I=C(S(g));if(!I)return v.push(D.localize(16,null,g)),!1;if(I.majorBase===0){if(!I.majorMustEqual||!I.minorMustEqual)return v.push(D.localize(17,null,g)),!1}else if(!I.majorMustEqual)return v.push(D.localize(18,null,g)),!1;return b(l,d,I)?!0:(v.push(D.localize(19,null,l,g)),!1)}function f(l){if(!Array.isArray(l))return!1;for(let d=0,g=l.length;d<g;d++)if(typeof l[d]!="string")return!1;return!0}}),define(re[45],ae([0,1,17,31]),function(_,e,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function D(k,T,R){let P=R&&R.get("storage.serviceMachineId",-1)||null;if(P)return P;try{const C=(await T.readFile(k.serviceMachineIdResource)).value.toString();P=(0,n.isUUID)(C)?C:null}catch{P=null}if(!P){P=(0,n.generateUuid)();try{await T.writeFile(k.serviceMachineIdResource,A.VSBuffer.fromString(P))}catch{}}return R?.store("storage.serviceMachineId",P,-1,1),P}e.getServiceMachineId=D}),define(re[55],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class A{constructor(D,k=[],T=!1){this.ctor=D,this.staticArguments=k,this.supportsDelayedInstantiation=T}}e.SyncDescriptor=A}),define(re[71],ae([0,1,55]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const n=[];var D;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(D=e.InstantiationType||(e.InstantiationType={}));function k(R,P,S){P instanceof A.SyncDescriptor||(P=new A.SyncDescriptor(P,[],Boolean(S))),n.push([R,P])}e.registerSingleton=k;function T(){return n}e.getSingletonServiceDescriptors=T}),define(re[192],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class A{constructor(k,T){this.key=k,this.data=T,this.incoming=new Map,this.outgoing=new Map}}e.Node=A;class n{constructor(k){this.b=k,this.a=new Map}roots(){const k=[];for(const T of this.a.values())T.outgoing.size===0&&k.push(T);return k}insertEdge(k,T){const R=this.lookupOrInsertNode(k),P=this.lookupOrInsertNode(T);R.outgoing.set(P.key,P),P.incoming.set(R.key,R)}removeNode(k){const T=this.b(k);this.a.delete(T);for(const R of this.a.values())R.outgoing.delete(T),R.incoming.delete(T)}lookupOrInsertNode(k){const T=this.b(k);let R=this.a.get(T);return R||(R=new A(T,k),this.a.set(T,R)),R}lookup(k){return this.a.get(this.b(k))}isEmpty(){return this.a.size===0}toString(){const k=[];for(const[T,R]of this.a)k.push(`${T}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return k.join(`
`)}findCycleSlow(){for(const[k,T]of this.a){const R=new Set([k]),P=this.c(T,R);if(P)return P}}c(k,T){for(const[R,P]of k.outgoing){if(T.has(R))return[...T,R].join(" -> ");T.add(R);const S=this.c(P,T);if(S)return S;T.delete(R)}}}e.Graph=n}),define(re[4],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var A;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function R(P){return P[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=R})(A=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function n(T,R,P){R[A.DI_TARGET]===R?R[A.DI_DEPENDENCIES].push({id:T,index:P}):(R[A.DI_DEPENDENCIES]=[{id:T,index:P}],R[A.DI_TARGET]=R)}function D(T){if(A.serviceIds.has(T))return A.serviceIds.get(T);const R=function(P,S,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");n(R,P,C)};return R.toString=()=>T,A.serviceIds.set(T,R),R}e.createDecorator=D;function k(T){return T}e.refineServiceDecorator=k}),define(re[193],ae([0,1,4]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,A.createDecorator)("checksumService")}),define(re[16],ae([0,1,14,8,4]),function(_,e,A,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function k(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof n.URI)}e.isConfigurationOverrides=k;function T(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||Array.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof n.URI)}e.isConfigurationUpdateOverrides=T;var R;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.USER=2]="USER",l[l.USER_LOCAL=3]="USER_LOCAL",l[l.USER_REMOTE=4]="USER_REMOTE",l[l.WORKSPACE=5]="WORKSPACE",l[l.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",l[l.DEFAULT=7]="DEFAULT",l[l.MEMORY=8]="MEMORY"})(R=e.ConfigurationTarget||(e.ConfigurationTarget={}));function P(l){switch(l){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=P;function S(l,d){const g=Object.create(null);for(const v in l)C(g,v,l[v],d);return g}e.toValuesTree=S;function C(l,d,g,v){const I=d.split("."),i=I.pop();let r=l;for(let t=0;t<I.length;t++){const s=I[t];let o=r[s];switch(typeof o){case"undefined":o=r[s]=Object.create(null);break;case"object":break;default:v(`Ignoring ${d} as ${I.slice(0,t+1).join(".")} is ${JSON.stringify(o)}`);return}r=o}if(typeof r=="object"&&r!==null)try{r[i]=g}catch{v(`Ignoring ${d} as ${I.join(".")} is ${JSON.stringify(r)}`)}else v(`Ignoring ${d} as ${I.join(".")} is ${JSON.stringify(r)}`)}e.addToValueTree=C;function b(l,d){const g=d.split(".");m(l,g)}e.removeFromValueTree=b;function m(l,d){const g=d.shift();if(d.length===0){delete l[g];return}if(Object.keys(l).indexOf(g)!==-1){const v=l[g];typeof v=="object"&&!Array.isArray(v)&&(m(v,d),Object.keys(v).length===0&&delete l[g])}}function p(l,d,g){function v(r,t){let s=r;for(const o of t){if(typeof s!="object"||s===null)return;s=s[o]}return s}const I=d.split("."),i=v(l,I);return typeof i>"u"?g:i}e.getConfigurationValue=p;function h(l,d,g){Object.keys(d).forEach(v=>{v!=="__proto__"&&(v in l?A.isObject(l[v])&&A.isObject(d[v])?h(l[v],d[v],g):g&&(l[v]=d[v]):l[v]=d[v])})}e.merge=h;function y(l,d,g){const v=l.inspect(d),I=l.inspect(g);return typeof v.userValue<"u"||typeof v.workspaceValue<"u"||typeof v.workspaceFolderValue<"u"?v.value:typeof I.userValue<"u"||typeof I.workspaceValue<"u"||typeof I.workspaceFolderValue<"u"?I.value:v.defaultValue}e.getMigratedSettingValue=y;function f(l){return l.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=f}),define(re[194],ae([0,1,5,27,4]),function(_,e,A,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const k=new Map;k.set("false",!1),k.set("true",!0),k.set("isMac",A.isMacintosh),k.set("isLinux",A.isLinux),k.set("isWindows",A.isWindows),k.set("isWeb",A.isWeb),k.set("isMacNative",A.isMacintosh&&!A.isWeb),k.set("isEdge",A.isEdge),k.set("isFirefox",A.isFirefox),k.set("isChrome",A.isChrome),k.set("isSafari",A.isSafari);const T=Object.prototype.hasOwnProperty;var R;(function(M){M[M.False=0]="False",M[M.True=1]="True",M[M.Defined=2]="Defined",M[M.Not=3]="Not",M[M.Equals=4]="Equals",M[M.NotEquals=5]="NotEquals",M[M.And=6]="And",M[M.Regex=7]="Regex",M[M.NotRegex=8]="NotRegex",M[M.Or=9]="Or",M[M.In=10]="In",M[M.NotIn=11]="NotIn",M[M.Greater=12]="Greater",M[M.GreaterEquals=13]="GreaterEquals",M[M.Smaller=14]="Smaller",M[M.SmallerEquals=15]="SmallerEquals"})(R=e.ContextKeyExprType||(e.ContextKeyExprType={}));class P{static false(){return b.INSTANCE}static true(){return m.INSTANCE}static has(L){return p.create(L)}static equals(L,F){return h.create(L,F)}static notEquals(L,F){return l.create(L,F)}static regex(L,F){return t.create(L,F)}static in(L,F){return y.create(L,F)}static notIn(L,F){return f.create(L,F)}static not(L){return d.create(L)}static and(...L){return c.create(L,null,!0)}static or(...L){return a.create(L,null,!0)}static greater(L,F){return v.create(L,F)}static greaterEquals(L,F){return I.create(L,F)}static smaller(L,F){return i.create(L,F)}static smallerEquals(L,F){return r.create(L,F)}static deserialize(L,F=!1){if(!!L)return this.c(L,F)}static c(L,F){const z=L.split("||");return a.create(z.map(H=>this.d(H,F)),null,!0)}static d(L,F){const z=L.split("&&");return c.create(z.map(H=>this.f(H,F)),null,!0)}static f(L,F){if(L=L.trim(),L.indexOf("!=")>=0){const z=L.split("!=");return l.create(z[0].trim(),this.g(z[1],F))}if(L.indexOf("==")>=0){const z=L.split("==");return h.create(z[0].trim(),this.g(z[1],F))}if(L.indexOf("=~")>=0){const z=L.split("=~");return t.create(z[0].trim(),this.h(z[1],F))}if(L.indexOf(" not in ")>=0){const z=L.split(" not in ");return f.create(z[0].trim(),this.g(z[1],F))}if(L.indexOf(" in ")>=0){const z=L.split(" in ");return y.create(z[0].trim(),this.g(z[1],F))}if(/^[^<=>]+>=[^<=>]+$/.test(L)){const z=L.split(">=");return I.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(L)){const z=L.split(">");return v.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(L)){const z=L.split("<=");return r.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(L)){const z=L.split("<");return i.create(z[0].trim(),z[1].trim())}return/^\!\s*/.test(L)?d.create(L.substr(1).trim()):p.create(L)}static g(L,F){if(L=L.trim(),L==="true")return!0;if(L==="false")return!1;const z=/^'([^']*)'$/.exec(L);return z?z[1].trim():L}static h(L,F){if((0,n.isFalsyOrWhitespace)(L)){if(F)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const z=L.indexOf("/"),H=L.lastIndexOf("/");if(z===H||z<0){if(F)throw new Error(`bad regexp-value '${L}', missing /-enclosure`);return console.warn(`bad regexp-value '${L}', missing /-enclosure`),null}const Q=L.slice(z+1,H),K=L[H+1]==="i"?"i":"";try{return new RegExp(Q,K)}catch(V){if(F)throw new Error(`bad regexp-value '${L}', parse error: ${V}`);return console.warn(`bad regexp-value '${L}', parse error: ${V}`),null}}}e.ContextKeyExpr=P;function S(M,L){const F=M?M.substituteConstants():void 0,z=L?L.substituteConstants():void 0;return!F&&!z?!0:!F||!z?!1:F.equals(z)}e.expressionsAreEqualWithConstantSubstitution=S;function C(M,L){return M.cmp(L)}class b{constructor(){this.type=0}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!1}serialize(){return"false"}keys(){return[]}map(L){return this}negate(){return m.INSTANCE}}e.ContextKeyFalseExpr=b,b.INSTANCE=new b;class m{constructor(){this.type=1}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!0}serialize(){return"true"}keys(){return[]}map(L){return this}negate(){return b.INSTANCE}}e.ContextKeyTrueExpr=m,m.INSTANCE=new m;class p{static create(L,F=null){const z=k.get(L);return typeof z=="boolean"?z?m.INSTANCE:b.INSTANCE:new p(L,F)}constructor(L,F){this.key=L,this.c=F,this.type=2}cmp(L){return L.type!==this.type?this.type-L.type:w(this.key,L.key)}equals(L){return L.type===this.type?this.key===L.key:!1}substituteConstants(){const L=k.get(this.key);return typeof L=="boolean"?L?m.INSTANCE:b.INSTANCE:this}evaluate(L){return!!L.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(L){return L.mapDefined(this.key)}negate(){return this.c||(this.c=d.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=p;class h{static create(L,F,z=null){if(typeof F=="boolean")return F?p.create(L,z):d.create(L,z);const H=k.get(L);return typeof H=="boolean"?F===(H?"true":"false")?m.INSTANCE:b.INSTANCE:new h(L,F,z)}constructor(L,F,z){this.c=L,this.d=F,this.f=z,this.type=4}cmp(L){return L.type!==this.type?this.type-L.type:E(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){const L=k.get(this.c);if(typeof L=="boolean"){const F=L?"true":"false";return this.d===F?m.INSTANCE:b.INSTANCE}return this}evaluate(L){return L.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(L){return L.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=l.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=h;class y{static create(L,F){return new y(L,F)}constructor(L,F){this.d=L,this.f=F,this.type=10,this.c=null}cmp(L){return L.type!==this.type?this.type-L.type:E(this.d,this.f,L.d,L.f)}equals(L){return L.type===this.type?this.d===L.d&&this.f===L.f:!1}substituteConstants(){return this}evaluate(L){const F=L.getValue(this.f),z=L.getValue(this.d);return Array.isArray(F)?F.includes(z):typeof z=="string"&&typeof F=="object"&&F!==null?T.call(F,z):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(L){return L.mapIn(this.d,this.f)}negate(){return this.c||(this.c=f.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=y;class f{static create(L,F){return new f(L,F)}constructor(L,F){this.d=L,this.f=F,this.type=11,this.c=y.create(L,F)}cmp(L){return L.type!==this.type?this.type-L.type:this.c.cmp(L.c)}equals(L){return L.type===this.type?this.c.equals(L.c):!1}substituteConstants(){return this}evaluate(L){return!this.c.evaluate(L)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(L){return L.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=f;class l{static create(L,F,z=null){if(typeof F=="boolean")return F?d.create(L,z):p.create(L,z);const H=k.get(L);return typeof H=="boolean"?F===(H?"true":"false")?b.INSTANCE:m.INSTANCE:new l(L,F,z)}constructor(L,F,z){this.c=L,this.d=F,this.f=z,this.type=5}cmp(L){return L.type!==this.type?this.type-L.type:E(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){const L=k.get(this.c);if(typeof L=="boolean"){const F=L?"true":"false";return this.d===F?b.INSTANCE:m.INSTANCE}return this}evaluate(L){return L.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(L){return L.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=h.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=l;class d{static create(L,F=null){const z=k.get(L);return typeof z=="boolean"?z?b.INSTANCE:m.INSTANCE:new d(L,F)}constructor(L,F){this.c=L,this.d=F,this.type=3}cmp(L){return L.type!==this.type?this.type-L.type:w(this.c,L.c)}equals(L){return L.type===this.type?this.c===L.c:!1}substituteConstants(){const L=k.get(this.c);return typeof L=="boolean"?L?b.INSTANCE:m.INSTANCE:this}evaluate(L){return!L.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(L){return L.mapNot(this.c)}negate(){return this.d||(this.d=p.create(this.c,this)),this.d}}e.ContextKeyNotExpr=d;function g(M,L){if(typeof M=="string"){const F=parseFloat(M);isNaN(F)||(M=F)}return typeof M=="string"||typeof M=="number"?L(M):b.INSTANCE}class v{static create(L,F,z=null){return g(F,H=>new v(L,H,z))}constructor(L,F,z){this.c=L,this.d=F,this.f=z,this.type=12}cmp(L){return L.type!==this.type?this.type-L.type:E(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(L){return L.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=r.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=v;class I{static create(L,F,z=null){return g(F,H=>new I(L,H,z))}constructor(L,F,z){this.c=L,this.d=F,this.f=z,this.type=13}cmp(L){return L.type!==this.type?this.type-L.type:E(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(L){return L.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=i.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=I;class i{static create(L,F,z=null){return g(F,H=>new i(L,H,z))}constructor(L,F,z){this.c=L,this.d=F,this.f=z,this.type=14}cmp(L){return L.type!==this.type?this.type-L.type:E(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(L){return L.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=i;class r{static create(L,F,z=null){return g(F,H=>new r(L,H,z))}constructor(L,F,z){this.c=L,this.d=F,this.f=z,this.type=15}cmp(L){return L.type!==this.type?this.type-L.type:E(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(L){return L.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=r;class t{static create(L,F){return new t(L,F)}constructor(L,F){this.d=L,this.f=F,this.type=7,this.c=null}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.d<L.d)return-1;if(this.d>L.d)return 1;const F=this.f?this.f.source:"",z=L.f?L.f.source:"";return F<z?-1:F>z?1:0}equals(L){if(L.type===this.type){const F=this.f?this.f.source:"",z=L.f?L.f.source:"";return this.d===L.d&&F===z}return!1}substituteConstants(){return this}evaluate(L){const F=L.getValue(this.d);return this.f?this.f.test(F):!1}serialize(){const L=this.f?`/${this.f.source}/${this.f.ignoreCase?"i":""}`:"/invalid/";return`${this.d} =~ ${L}`}keys(){return[this.d]}map(L){return L.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=s.create(this)),this.c}}e.ContextKeyRegexExpr=t;class s{static create(L){return new s(L)}constructor(L){this.c=L,this.type=8}cmp(L){return L.type!==this.type?this.type-L.type:this.c.cmp(L.c)}equals(L){return L.type===this.type?this.c.equals(L.c):!1}substituteConstants(){return this}evaluate(L){return!this.c.evaluate(L)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(L){return new s(this.c.map(L))}negate(){return this.c}}e.ContextKeyNotRegexExpr=s;function o(M){let L=null;for(let F=0,z=M.length;F<z;F++){const H=M[F].substituteConstants();if(M[F]!==H&&L===null){L=[];for(let Q=0;Q<F;Q++)L[Q]=M[Q]}L!==null&&(L[F]=H)}return L===null?M:L}class c{static create(L,F,z){return c.d(L,F,z)}constructor(L,F){this.expr=L,this.c=F,this.type=6}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let F=0,z=this.expr.length;F<z;F++){const H=C(this.expr[F],L.expr[F]);if(H!==0)return H}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let F=0,z=this.expr.length;F<z;F++)if(!this.expr[F].equals(L.expr[F]))return!1;return!0}return!1}substituteConstants(){const L=o(this.expr);return L===this.expr?this:c.create(L,this.c,!1)}evaluate(L){for(let F=0,z=this.expr.length;F<z;F++)if(!this.expr[F].evaluate(L))return!1;return!0}static d(L,F,z){const H=[];let Q=!1;for(const K of L)if(!!K){if(K.type===1){Q=!0;continue}if(K.type===0)return b.INSTANCE;if(K.type===6){H.push(...K.expr);continue}H.push(K)}if(H.length===0&&Q)return m.INSTANCE;if(H.length!==0){if(H.length===1)return H[0];H.sort(C);for(let K=1;K<H.length;K++)H[K-1].equals(H[K])&&(H.splice(K,1),K--);if(H.length===1)return H[0];for(;H.length>1;){const K=H[H.length-1];if(K.type!==9)break;H.pop();const V=H.pop(),W=H.length===0,G=a.create(K.expr.map(X=>c.create([X,V],null,z)),null,W);G&&(H.push(G),H.sort(C))}if(H.length===1)return H[0];if(z){for(let K=0;K<H.length;K++)for(let V=K+1;V<H.length;V++)if(H[K].negate().equals(H[V]))return b.INSTANCE;if(H.length===1)return H[0]}return new c(H,F)}}serialize(){return this.expr.map(L=>L.serialize()).join(" && ")}keys(){const L=[];for(const F of this.expr)L.push(...F.keys());return L}map(L){return new c(this.expr.map(F=>F.map(L)),null)}negate(){if(!this.c){const L=[];for(const F of this.expr)L.push(F.negate());this.c=a.create(L,this,!0)}return this.c}}class a{static create(L,F,z){return a.d(L,F,z)}constructor(L,F){this.expr=L,this.c=F,this.type=9}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let F=0,z=this.expr.length;F<z;F++){const H=C(this.expr[F],L.expr[F]);if(H!==0)return H}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let F=0,z=this.expr.length;F<z;F++)if(!this.expr[F].equals(L.expr[F]))return!1;return!0}return!1}substituteConstants(){const L=o(this.expr);return L===this.expr?this:a.create(L,this.c,!1)}evaluate(L){for(let F=0,z=this.expr.length;F<z;F++)if(this.expr[F].evaluate(L))return!0;return!1}static d(L,F,z){let H=[],Q=!1;if(L){for(let K=0,V=L.length;K<V;K++){const W=L[K];if(!!W){if(W.type===0){Q=!0;continue}if(W.type===1)return m.INSTANCE;if(W.type===9){H=H.concat(W.expr);continue}H.push(W)}}if(H.length===0&&Q)return b.INSTANCE;H.sort(C)}if(H.length!==0){if(H.length===1)return H[0];for(let K=1;K<H.length;K++)H[K-1].equals(H[K])&&(H.splice(K,1),K--);if(H.length===1)return H[0];if(z){for(let K=0;K<H.length;K++)for(let V=K+1;V<H.length;V++)if(H[K].negate().equals(H[V]))return m.INSTANCE;if(H.length===1)return H[0]}return new a(H,F)}}serialize(){return this.expr.map(L=>L.serialize()).join(" || ")}keys(){const L=[];for(const F of this.expr)L.push(...F.keys());return L}map(L){return new a(this.expr.map(F=>F.map(L)),null)}negate(){if(!this.c){const L=[];for(const F of this.expr)L.push(F.negate());for(;L.length>1;){const F=L.shift(),z=L.shift(),H=[];for(const Q of j(F))for(const K of j(z))H.push(c.create([Q,K],null,!1));L.unshift(a.create(H,null,!1))}this.c=a.create(L,this,!0)}return this.c}}class u extends p{static all(){return u.d.values()}constructor(L,F,z){super(L,null),this.f=F,typeof z=="object"?u.d.push({...z,key:L}):z!==!0&&u.d.push({key:L,description:z,type:F!=null?typeof F:void 0})}bindTo(L){return L.createKey(this.key,this.f)}getValue(L){return L.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(L){return h.create(this.key,L)}notEqualsTo(L){return l.create(this.key,L)}}e.RawContextKey=u,u.d=[],e.IContextKeyService=(0,D.createDecorator)("contextKeyService");function w(M,L){return M<L?-1:M>L?1:0}function E(M,L,F,z){return M<F?-1:M>F?1:L<z?-1:L>z?1:0}function N(M,L){if(M.type===0||L.type===1)return!0;if(M.type===9)return L.type===9?O(M.expr,L.expr):!1;if(L.type===9){for(const F of L.expr)if(N(M,F))return!0;return!1}if(M.type===6){if(L.type===6)return O(L.expr,M.expr);for(const F of M.expr)if(N(F,L))return!0;return!1}return M.equals(L)}e.implies=N;function O(M,L){let F=0,z=0;for(;F<M.length&&z<L.length;){const H=M[F].cmp(L[z]);if(H<0)return!1;H===0&&F++,z++}return F===M.length}function j(M){return M.type===9?M.expr:[M]}}),define(re[96],ae([0,1,4]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,A.createDecorator)(e.ID);function n(k){return!!k.hostName&&!!k.errorMessage}e.isRemoteDiagnosticError=n;class D{async getPerformanceInfo(T,R){return{}}async getSystemInfo(T,R){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(T,R){return""}async getWorkspaceFileExtensions(T){return{extensions:[]}}async reportWorkspaceStats(T){}}e.NullDiagnosticsService=D}),define(re[97],ae([0,1,4]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,A.createDecorator)("downloadService")}),define(re[15],ae([0,1,4]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,A.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,A.refineServiceDecorator)(e.IEnvironmentService)}),define(re[30],ae([0,1,157,4]),function(_,e,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function D(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=D;function k(l){switch(l){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=k;function T(l,d){switch(l){case 3:return d==="x64"?"win32-x64":d==="ia32"?"win32-ia32":d==="arm64"?"win32-arm64":"unknown";case 2:return d==="x64"?"linux-x64":d==="arm64"?"linux-arm64":d==="arm"?"linux-armhf":"unknown";case"alpine":return d==="x64"?"alpine-x64":d==="arm64"?"alpine-arm64":"unknown";case 1:return d==="x64"?"darwin-x64":d==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=T;function R(l,d){return d==="web"&&!l.includes("web")}e.isNotWebExtensionInWebTargetPlatform=R;function P(l,d,g){return R(d,g)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===g?!0:S(g).includes(l)}e.isTargetPlatformCompatible=P;function S(l){switch(l){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=S;function C(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.isIExtensionIdentifier=C;var b;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(b=e.SortBy||(e.SortBy={}));var m;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(m=e.SortOrder||(e.SortOrder={}));var p;(function(l){l.Install="install",l.Uninstall="uninstall"})(p=e.StatisticType||(e.StatisticType={}));var h;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(h=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,n.createDecorator)("extensionGalleryService");var y;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatiblePreRelease="IncompatiblePreRelease",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.Extract="Extract",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Internal="Internal",l.Signature="Signature"})(y=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class f extends Error{constructor(d,g){super(d),this.code=g,this.name=g}}e.ExtensionManagementError=f,e.IExtensionManagementService=(0,n.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,n.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,n.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,A.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,A.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(re[195],ae([0,1,3,2,67,32,8,144,30]),function(_,e,A,n,D,k,T,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function S(f,l){return T.URI.revive(l?l.transformIncoming(f):f)}function C(f,l){return l?l.transformOutgoingURI(f):f}function b(f,l){l=l||R.DefaultURITransformer;const d=f.manifest;return{...(0,R.transformAndReviveIncomingURIs)({...f,manifest:void 0},l),manifest:d}}function m(f,l){return l?(0,k.cloneAndChange)(f,d=>d instanceof T.URI?l.transformOutgoingURI(d):void 0):f}class p{constructor(l,d){this.a=l,this.b=d,this.onInstallExtension=A.Event.buffer(l.onInstallExtension,!0),this.onDidInstallExtensions=A.Event.buffer(l.onDidInstallExtensions,!0),this.onUninstallExtension=A.Event.buffer(l.onUninstallExtension,!0),this.onDidUninstallExtension=A.Event.buffer(l.onDidUninstallExtension,!0)}listen(l,d){const g=this.b(l);switch(d){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return A.Event.map(this.onDidInstallExtensions,v=>v.map(I=>({...I,local:I.local?m(I.local,g):I.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(l,d,g){const v=this.b(l);switch(d){case"zip":return this.a.zip(b(g[0],v)).then(I=>C(I,v));case"unzip":return this.a.unzip(S(g[0],v));case"install":return this.a.install(S(g[0],v),(0,D.revive)(g[1]));case"installFromLocation":return this.a.installFromLocation(S(g[0],v),T.URI.revive(g[1]));case"getManifest":return this.a.getManifest(S(g[0],v));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(g[0]);case"installFromGallery":return this.a.installFromGallery(g[0],(0,D.revive)(g[1]));case"uninstall":return this.a.uninstall(b(g[0],v),(0,D.revive)(g[1]));case"reinstallFromGallery":return this.a.reinstallFromGallery(b(g[0],v));case"getInstalled":return this.a.getInstalled(g[0],T.URI.revive(g[1])).then(I=>I.map(i=>m(i,v)));case"getMetadata":return this.a.getMetadata(b(g[0],v));case"updateMetadata":return this.a.updateMetadata(b(g[0],v),g[1]).then(I=>m(I,v));case"updateExtensionScope":return this.a.updateExtensionScope(b(g[0],v),g[1]).then(I=>m(I,v));case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(g[0],g[1])}throw new Error("Invalid call")}}e.ExtensionManagementChannel=p;class h extends n.Disposable{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}constructor(l){super(),this.j=l,this.c=this.B(new A.Emitter),this.f=this.B(new A.Emitter),this.g=this.B(new A.Emitter),this.h=this.B(new A.Emitter),this.B(this.j.listen("onInstallExtension")(d=>this.c.fire({identifier:d.identifier,source:this.k(d.source)?T.URI.revive(d.source):d.source,profileLocation:T.URI.revive(d.profileLocation)}))),this.B(this.j.listen("onDidInstallExtensions")(d=>this.f.fire(d.map(g=>({...g,local:g.local?b(g.local,null):g.local,source:this.k(g.source)?T.URI.revive(g.source):g.source,profileLocation:T.URI.revive(g.profileLocation)}))))),this.B(this.j.listen("onUninstallExtension")(d=>this.g.fire({identifier:d.identifier,profileLocation:T.URI.revive(d.profileLocation)}))),this.B(this.j.listen("onDidUninstallExtension")(d=>this.h.fire({...d,profileLocation:T.URI.revive(d.profileLocation)})))}k(l){return l?typeof l.path=="string"&&typeof l.scheme=="string":!1}getTargetPlatform(){return this.l||(this.l=this.j.call("getTargetPlatform")),this.l}async canInstall(l){const d=await this.getTargetPlatform();return l.allTargetPlatforms.some(g=>(0,P.isTargetPlatformCompatible)(g,l.allTargetPlatforms,d))}zip(l){return Promise.resolve(this.j.call("zip",[l]).then(d=>T.URI.revive(d)))}unzip(l){return Promise.resolve(this.j.call("unzip",[l]))}install(l,d){return Promise.resolve(this.j.call("install",[l,d])).then(g=>b(g,null))}installFromLocation(l,d){return Promise.resolve(this.j.call("installFromLocation",[l,d])).then(g=>b(g,null))}getManifest(l){return Promise.resolve(this.j.call("getManifest",[l]))}installFromGallery(l,d){return Promise.resolve(this.j.call("installFromGallery",[l,d])).then(g=>b(g,null))}uninstall(l,d){return Promise.resolve(this.j.call("uninstall",[l,d]))}reinstallFromGallery(l){return Promise.resolve(this.j.call("reinstallFromGallery",[l])).then(d=>b(d,null))}getInstalled(l=null,d){return Promise.resolve(this.j.call("getInstalled",[l,d])).then(g=>g.map(v=>b(v,null)))}getMetadata(l){return Promise.resolve(this.j.call("getMetadata",[l]))}updateMetadata(l,d){return Promise.resolve(this.j.call("updateMetadata",[l,d])).then(g=>b(g,null))}updateExtensionScope(l,d){return Promise.resolve(this.j.call("updateExtensionScope",[l,d])).then(g=>b(g,null))}getExtensionsControlManifest(){return Promise.resolve(this.j.call("getExtensionsControlManifest"))}async download(l,d){const g=await this.j.call("download",[l,d]);return T.URI.revive(g)}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=h;class y{constructor(l){this.a=l}listen(l,d){throw new Error("Invalid listen")}call(l,d,g){switch(d){case"getConfigBasedTips":return this.a.getConfigBasedTips(T.URI.revive(g[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=y}),define(re[98],ae([0,1,4]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,A.createDecorator)("IExtensionSignatureVerificationService");class n{b(){return this.a||(this.a=new Promise((k,T)=>_(["node-vsce-sign"],async R=>k(R),T))),this.a}async verify(k,T){let R;try{R=await this.b()}catch{return!1}return R.verify(k,T)}}e.ExtensionSignatureVerificationService=n}),define(re[99],ae([0,1,4]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var n;(function(T){T[T.FILE=1]="FILE",T[T.WORKSPACE=2]="WORKSPACE",T[T.EXE=3]="EXE"})(n=e.RecommendationSource||(e.RecommendationSource={}));function D(T){switch(T){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=D;var k;(function(T){T.Ignored="ignored",T.Cancelled="cancelled",T.TooMany="toomany",T.IncompatibleWindow="incompatibleWindow",T.Accepted="reacted"})(k=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,A.createDecorator)("IExtensionRecommendationNotificationService")}),define(re[13],ae([0,1,49,12,27,14,8,165,4]),function(_,e,A,n,D,k,T,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,P.createDecorator)("fileService");function S(K){return K.create===!0}e.isFileOpenForWriteOptions=S;var C;(function(K){K[K.Unknown=0]="Unknown",K[K.File=1]="File",K[K.Directory=2]="Directory",K[K.SymbolicLink=64]="SymbolicLink"})(C=e.FileType||(e.FileType={}));var b;(function(K){K[K.Readonly=1]="Readonly"})(b=e.FilePermission||(e.FilePermission={}));var m;(function(K){K[K.None=0]="None",K[K.FileReadWrite=2]="FileReadWrite",K[K.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",K[K.FileReadStream=16]="FileReadStream",K[K.FileFolderCopy=8]="FileFolderCopy",K[K.PathCaseSensitive=1024]="PathCaseSensitive",K[K.Readonly=2048]="Readonly",K[K.Trash=4096]="Trash",K[K.FileWriteUnlock=8192]="FileWriteUnlock",K[K.FileAtomicRead=16384]="FileAtomicRead",K[K.FileClone=32768]="FileClone"})(m=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function p(K){return!!(K.capabilities&2)}e.hasReadWriteCapability=p;function h(K){return!!(K.capabilities&8)}e.hasFileFolderCopyCapability=h;function y(K){return!!(K.capabilities&32768)}e.hasFileCloneCapability=y;function f(K){return!!(K.capabilities&4)}e.hasOpenReadWriteCloseCapability=f;function l(K){return!!(K.capabilities&16)}e.hasFileReadStreamCapability=l;function d(K){return p(K)?!!(K.capabilities&16384):!1}e.hasFileAtomicReadCapability=d;var g;(function(K){K.FileExists="EntryExists",K.FileNotFound="EntryNotFound",K.FileNotADirectory="EntryNotADirectory",K.FileIsADirectory="EntryIsADirectory",K.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",K.FileTooLarge="EntryTooLarge",K.FileWriteLocked="EntryWriteLocked",K.NoPermissions="NoPermissions",K.Unavailable="Unavailable",K.Unknown="Unknown"})(g=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class v extends Error{constructor(V,W){super(V),this.code=W}}e.FileSystemProviderError=v;function I(K,V){const W=new v(K.toString(),V);return r(W,V),W}e.createFileSystemProviderError=I;function i(K){return K||I((0,R.localize)(0,null),g.Unknown)}e.ensureFileSystemProviderError=i;function r(K,V){return K.name=V?`${V} (FileSystemError)`:"FileSystemError",K}e.markAsFileSystemProviderError=r;function t(K){if(!K)return g.Unknown;if(K instanceof v)return K.code;const V=/^(.+) \(FileSystemError\)$/.exec(K.name);if(!V)return g.Unknown;switch(V[1]){case g.FileExists:return g.FileExists;case g.FileIsADirectory:return g.FileIsADirectory;case g.FileNotADirectory:return g.FileNotADirectory;case g.FileNotFound:return g.FileNotFound;case g.FileExceedsMemoryLimit:return g.FileExceedsMemoryLimit;case g.FileTooLarge:return g.FileTooLarge;case g.FileWriteLocked:return g.FileWriteLocked;case g.NoPermissions:return g.NoPermissions;case g.Unavailable:return g.Unavailable}return g.Unknown}e.toFileSystemProviderErrorCode=t;function s(K){if(K instanceof E)return K.fileOperationResult;switch(t(K)){case g.FileNotFound:return 1;case g.FileIsADirectory:return 0;case g.FileNotADirectory:return 10;case g.FileWriteLocked:return 5;case g.NoPermissions:return 6;case g.FileExists:return 4;case g.FileExceedsMemoryLimit:return 9;case g.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var o;(function(K){K[K.CREATE=0]="CREATE",K[K.DELETE=1]="DELETE",K[K.MOVE=2]="MOVE",K[K.COPY=3]="COPY",K[K.WRITE=4]="WRITE"})(o=e.FileOperation||(e.FileOperation={}));class c{constructor(V,W,G){this.resource=V,this.operation=W,this.target=G}isOperation(V){return this.operation===V}}e.FileOperationEvent=c;var a;(function(K){K[K.UPDATED=0]="UPDATED",K[K.ADDED=1]="ADDED",K[K.DELETED=2]="DELETED"})(a=e.FileChangeType||(e.FileChangeType={}));class u{constructor(V,W){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const G=new Map;for(const X of V){const ie=G.get(X.type);switch(ie?ie.push([X.resource,X]):G.set(X.type,[[X.resource,X]]),X.type){case 1:this.rawAdded.push(X.resource);break;case 0:this.rawUpdated.push(X.resource);break;case 2:this.rawDeleted.push(X.resource);break}}for(const[X,ie]of G)switch(X){case 1:this.a=A.TernarySearchTree.forUris(()=>W),this.a.fill(ie);break;case 0:this.b=A.TernarySearchTree.forUris(()=>W),this.b.fill(ie);break;case 2:this.c=A.TernarySearchTree.forUris(()=>W),this.c.fill(ie);break}}contains(V,...W){return this.d(V,{includeChildren:!1},...W)}affects(V,...W){return this.d(V,{includeChildren:!0},...W)}d(V,W,...G){if(!V)return!1;const X=G.length>0;return!!((!X||G.includes(1))&&(this.a?.get(V)||W.includeChildren&&this.a?.findSuperstr(V))||(!X||G.includes(0))&&(this.b?.get(V)||W.includeChildren&&this.b?.findSuperstr(V))||(!X||G.includes(2))&&(this.c?.findSubstr(V)||W.includeChildren&&this.c?.findSuperstr(V)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=u;function w(K,V,W){return!K||!V||K===V||V.length>K.length?!1:(V.charAt(V.length-1)!==n.sep&&(V+=n.sep),W?(0,D.startsWithIgnoreCase)(K,V):K.indexOf(V)===0)}e.isParent=w;class E extends Error{constructor(V,W,G){super(V),this.fileOperationResult=W,this.options=G}}e.FileOperationError=E;class N extends E{constructor(V,W,G,X){super(V,W,X),this.fileOperationResult=W,this.size=G}}e.TooLargeFileOperationError=N;class O extends E{constructor(V,W,G){super(V,2,G),this.stat=W}}e.NotModifiedSinceFileOperationError=O;var j;(function(K){K[K.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",K[K.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",K[K.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",K[K.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",K[K.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",K[K.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",K[K.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",K[K.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",K[K.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",K[K.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",K[K.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",K[K.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(j=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var M;(function(K){K[K.FILE=0]="FILE",K[K.FOLDER=1]="FOLDER",K[K.ROOT_FOLDER=2]="ROOT_FOLDER"})(M=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function L(K){if(!(typeof K.size!="number"||typeof K.mtime!="number"))return K.mtime.toString(29)+K.size.toString(31)}e.etag=L;async function F(K,V){if(!V.hasProvider(T.URI.from({scheme:K.scheme})))return new Promise(W=>{const G=V.onDidChangeFileSystemProviderRegistrations(X=>{X.scheme===K.scheme&&X.added&&(G.dispose(),W())})})}e.whenProviderRegistered=F,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class z{static formatSize(V){return(0,k.isNumber)(V)||(V=0),V<z.KB?(0,R.localize)(1,null,V.toFixed(0)):V<z.MB?(0,R.localize)(2,null,(V/z.KB).toFixed(2)):V<z.GB?(0,R.localize)(3,null,(V/z.MB).toFixed(2)):V<z.TB?(0,R.localize)(4,null,(V/z.GB).toFixed(2)):(0,R.localize)(5,null,(V/z.TB).toFixed(2))}}e.ByteSize=z,z.KB=1024,z.MB=z.KB*z.KB,z.GB=z.MB*z.KB,z.TB=z.GB*z.KB;var H;(function(K){K[K.IA32=0]="IA32",K[K.OTHER=1]="OTHER"})(H=e.Arch||(e.Arch={}));function Q(K){return{maxFileSize:K===0?300*z.MB:16*z.GB,maxHeapSize:K===0?700*z.MB:2*700*z.MB}}e.getPlatformLimits=Q});var Y=this&&this.__param||function(_,e){return function(A,n){e(A,n,_)}};define(re[196],ae([0,1,100,44,13]),function(_,e,A,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let k=class{constructor(R){this.a=R}async checksum(R){const P=(await this.a.readFileStream(R)).value;return new Promise((S,C)=>{const b=(0,A.createHash)("md5");(0,n.listenStream)(P,{onData:m=>b.update(m.buffer),onError:m=>C(m),onEnd:()=>S(b.digest("base64").replace(/=+$/,""))})})}};k=ye([Y(0,D.IFileService)],k),e.ChecksumService=k}),define(re[197],ae([0,1,17,38,7,3,2,44,8,31,13]),function(_,e,A,n,D,k,T,R,P,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class b extends T.Disposable{constructor(p,h){super(),this.a=p,this.b=h,this.onDidChangeCapabilities=k.Event.None,this.f=this.B(new k.Emitter),this.onDidChangeFile=this.f.event,this.g=this.B(new k.Emitter),this.onDidWatchError=this.g.event,this.h=(0,S.generateUuid)(),this.i()}get capabilities(){return this.c||(this.c=57374,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(p){return this.a.call("stat",[p])}readdir(p){return this.a.call("readdir",[p])}async readFile(p,h){const{buffer:y}=await this.a.call("readFile",[p,h]);return y}readFileStream(p,h,y){const f=(0,R.newWriteableStream)(d=>A.VSBuffer.concat(d.map(g=>A.VSBuffer.wrap(g))).buffer),l=this.a.listen("readFileStream",[p,h])(d=>{if(d instanceof A.VSBuffer)f.write(d.buffer);else{if(d==="end")f.end();else{let g;if(d instanceof Error)g=d;else{const v=d;g=(0,C.createFileSystemProviderError)(v.message??(0,n.toErrorMessage)(v),v.code??C.FileSystemProviderErrorCode.Unknown)}f.error(g),f.end()}l.dispose()}});return y.onCancellationRequested(()=>{f.error((0,D.canceled)()),f.end(),l.dispose()}),f}writeFile(p,h,y){return this.a.call("writeFile",[p,A.VSBuffer.wrap(h),y])}open(p,h){return this.a.call("open",[p,h])}close(p){return this.a.call("close",[p])}async read(p,h,y,f,l){const[d,g]=await this.a.call("read",[p,h,l]);return y.set(d.buffer.slice(0,g),f),g}write(p,h,y,f,l){return this.a.call("write",[p,h,A.VSBuffer.wrap(y),f,l])}mkdir(p){return this.a.call("mkdir",[p])}delete(p,h){return this.a.call("delete",[p,h])}rename(p,h,y){return this.a.call("rename",[p,h,y])}copy(p,h,y){return this.a.call("copy",[p,h,y])}cloneFile(p,h){return this.a.call("cloneFile",[p,h])}i(){this.B(this.a.listen("fileChange",[this.h])(p=>{if(Array.isArray(p)){const h=p;this.f.fire(h.map(y=>({resource:P.URI.revive(y.resource),type:y.type})))}else{const h=p;this.g.fire(h)}}))}watch(p,h){const y=(0,S.generateUuid)();return this.a.call("watch",[this.h,y,p,h]),(0,T.toDisposable)(()=>this.a.call("unwatch",[this.h,y]))}}e.DiskFileSystemProviderClient=b}),define(re[101],ae([0,1,17,7,166,13]),function(_,e,A,n,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function T(C,b,m,p,h,y){let f;try{await R(C,b,m,p,h,y)}catch(l){f=l}finally{f&&h.errorTransformer&&(f=h.errorTransformer(f)),typeof f<"u"&&m.error(f),m.end()}}e.readFileIntoStream=T;async function R(C,b,m,p,h,y){P(y);const f=await C.open(b,{create:!1});try{P(y);let l=0,d=0,g=h&&typeof h.length=="number"?h.length:void 0,v=A.VSBuffer.alloc(Math.min(h.bufferSize,typeof g=="number"?g:h.bufferSize)),I=h&&typeof h.position=="number"?h.position:0,i=0;do d=await C.read(f,I,v.buffer,i,v.byteLength-i),I+=d,i+=d,l+=d,typeof g=="number"&&(g-=d),i===v.byteLength&&(await m.write(p(v)),v=A.VSBuffer.alloc(Math.min(h.bufferSize,typeof g=="number"?g:h.bufferSize)),i=0);while(d>0&&(typeof g!="number"||g>0)&&P(y)&&S(l,h));if(i>0){let r=i;typeof g=="number"&&(r=Math.min(i,g)),m.write(p(v.slice(0,r)))}}catch(l){throw(0,k.ensureFileSystemProviderError)(l)}finally{await C.close(f)}}function P(C){if(C.isCancellationRequested)throw(0,n.canceled)();return!0}function S(C,b){if(b?.limits){if(typeof b.limits.memory=="number"&&C>b.limits.memory)throw(0,k.createFileSystemProviderError)((0,D.localize)(0,null),k.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof b.limits.size=="number"&&C>b.limits.size)throw(0,k.createFileSystemProviderError)((0,D.localize)(1,null),k.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(re[56],ae([0,1,90,2,12,5,8,13]),function(_,e,A,n,D,k,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function P(l){return l.recursive===!0}e.isRecursiveWatchRequest=P;class S extends n.Disposable{constructor(d,g,v,I){super(),this.h=d,this.i=g,this.j=v,this.k=I,this.c=this.B(new n.MutableDisposable),this.f=void 0,this.g=0}m(){const d=new n.DisposableStore;this.c.value=d,this.b=this.l(d),this.b.setVerboseLogging(this.j),d.add(this.b.onDidChangeFile(g=>this.h(g))),d.add(this.b.onDidLogMessage(g=>this.i(g))),d.add(this.b.onDidError(g=>this.n(g)))}n(d){this.k.restartOnError?this.g<S.a&&this.f?(this.r(`restarting watcher after error: ${d}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${d}`):this.r(d)}p(d){this.g++,this.m(),this.watch(d)}async watch(d){this.f=d,await this.b?.watch(d)}async setVerboseLogging(d){this.j=d,await this.b?.setVerboseLogging(d)}r(d){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${d}`})}dispose(){return this.b=void 0,super.dispose()}}e.AbstractWatcherClient=S,S.a=5;class C extends S{constructor(d,g,v){super(d,g,v,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=C;class b extends S{constructor(d,g,v){super(d,g,v,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=b;function m(l){return l.map(d=>({type:d.type,resource:T.URI.file(d.path)}))}e.toFileChanges=m;function p(l){const d=new f;for(const g of l)d.processEvent(g);return d.coalesce()}e.coalesceEvents=p;function h(l,d){return typeof d=="string"&&!d.startsWith(A.GLOBSTAR)&&!(0,D.isAbsolute)(d)?{base:l,pattern:d}:d}e.normalizeWatcherPattern=h;function y(l,d){const g=[];for(const v of d)g.push((0,A.parse)(h(l,v)));return g}e.parseWatcherPatterns=y;class f{constructor(){this.a=new Set,this.b=new Map}c(d){return k.isLinux?d.path:d.path.toLowerCase()}processEvent(d){const g=this.b.get(this.c(d));let v=!1;if(g){const I=g.type,i=d.type;g.path!==d.path&&(d.type===2||d.type===1)?v=!0:I===1&&i===2?(this.b.delete(this.c(d)),this.a.delete(g)):I===2&&i===1?g.type=0:I===1&&i===0||(g.type=i)}else v=!0;v&&(this.a.add(d),this.b.set(this.c(d),d))}coalesce(){const d=[],g=[];return Array.from(this.a).filter(v=>v.type!==2?(d.push(v),!1):!0).sort((v,I)=>v.path.length-I.path.length).filter(v=>g.some(I=>(0,R.isParent)(v.path,I,!k.isLinux))?!1:(g.push(v.path),!0)).concat(d)}}}),define(re[198],ae([0,1,53,6,23,48,2,85,12,5,146,28,56]),function(_,e,A,n,D,k,T,R,P,S,C,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class p extends T.Disposable{constructor(f,l,d,g){super(),this.j=f,this.k=l,this.l=d,this.m=g,this.c=this.B(new n.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},v=>this.k(v))),this.f=this.B(new n.RunOnceWorker(v=>this.u(v),p.b)),this.g=(0,m.parseWatcherPatterns)(this.j.path,this.j.excludes),this.h=this.j.includes?(0,m.parseWatcherPatterns)(this.j.path,this.j.includes):void 0,this.i=new D.CancellationTokenSource,this.ready=this.n()}async n(){try{const f=await this.r(this.j);if(this.i.token.isCancellationRequested)return;const l=await b.Promises.stat(f);this.B(await this.s(f,l.isDirectory()))}catch(f){f.code!=="ENOENT"?this.w(f):this.z(f)}}async r(f){let l=f.path;try{l=await b.Promises.realpath(f.path),f.path===l&&(l=await(0,C.realcase)(f.path)??f.path),f.path!==l&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${f.path}, real: ${l})`)}catch{}return l}async s(f,l){if(S.isMacintosh&&(0,k.isEqualOrParent)(f,"/Volumes/",!0))return this.w(`Refusing to watch ${f} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),T.Disposable.None;const d=new D.CancellationTokenSource(this.i.token),g=new T.DisposableStore;try{const v=(0,P.basename)(f),I=(0,A.watch)(f);g.add((0,T.toDisposable)(()=>{I.removeAllListeners(),I.close()})),this.z(`Started watching: '${f}'`);const i=new Set;if(l)try{for(const t of await b.Promises.readdir(f))i.add(t)}catch(t){this.w(t)}const r=new Map;g.add((0,T.toDisposable)(()=>{for(const[,t]of r)t.dispose();r.clear()})),I.on("error",(t,s)=>{this.w(`Failed to watch ${f} for changes using fs.watch() (${t}, ${s})`),this.dispose()}),I.on("change",(t,s)=>{if(d.token.isCancellationRequested)return;this.z(`[raw] ["${t}"] ${s}`);let o="";if(s&&(o=s.toString(),S.isMacintosh&&(o=(0,R.normalizeNFC)(o))),!(!o||t!=="change"&&t!=="rename"))if(l)if(t==="rename"){r.get(o)?.dispose();const c=setTimeout(async()=>{if(r.delete(o),o===v&&!await b.Promises.exists(f)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const a=await this.v((0,P.join)(f,o));if(d.token.isCancellationRequested)return;let u;a?i.has(o)?u=0:(u=1,i.add(o)):(i.delete(o),u=2),this.t({path:(0,P.join)(this.j.path,o),type:u})},p.a);r.set(o,(0,T.toDisposable)(()=>clearTimeout(c)))}else{let c;i.has(o)?c=0:(c=1,i.add(o)),this.t({path:(0,P.join)(this.j.path,o),type:c})}else if(t==="rename"||o!==v){const c=setTimeout(async()=>{const a=await b.Promises.exists(f);d.token.isCancellationRequested||(a?(this.t({path:this.j.path,type:0},!0),g.add(await this.s(f,!1))):(this.t({path:this.j.path,type:2},!0),this.f.flush(),this.dispose()))},p.a);g.clear(),g.add((0,T.toDisposable)(()=>clearTimeout(c)))}else this.t({path:this.j.path,type:0},!0)})}catch(v){await b.Promises.exists(f)&&!d.token.isCancellationRequested&&this.w(`Failed to watch ${f} for changes using fs.watch() (${v.toString()})`)}return(0,T.toDisposable)(()=>{d.dispose(!0),g.dispose()})}t(f,l=!1){this.i.token.isCancellationRequested||(this.m&&this.z(`${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.path}`),!l&&this.g.some(d=>d(f.path))?this.m&&this.z(` >> ignored (excluded) ${f.path}`):!l&&this.h&&this.h.length>0&&!this.h.some(d=>d(f.path))?this.m&&this.z(` >> ignored (not included) ${f.path}`):this.f.work(f))}u(f){const l=(0,m.coalesceEvents)(f);if(l.length>0){if(this.m)for(const g of l)this.z(`>> normalized ${g.type===1?"[ADDED]":g.type===2?"[DELETED]":"[CHANGED]"} ${g.path}`);this.c.work(l)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${l[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${l.length}, most recent change: ${l[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async v(f){if(S.isLinux)return b.Promises.exists(f);try{const l=(0,P.basename)(f);return(await b.Promises.readdir((0,P.dirname)(f))).some(g=>g===l)}catch(l){return this.z(l),!1}}setVerboseLogging(f){this.m=f}w(f){this.i.token.isCancellationRequested||this.l?.({type:"error",message:`[File Watcher (node.js)] ${f}`})}y(f){this.i.token.isCancellationRequested||this.l?.({type:"warn",message:`[File Watcher (node.js)] ${f}`})}z(f){!this.i.token.isCancellationRequested&&this.m&&this.l?.({type:"trace",message:`[File Watcher (node.js)] ${f}`})}dispose(){this.z(`stopping file watcher on ${this.j.path}`),this.i.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=p,p.a=100,p.b=75;async function h(y,f,l,d,g=512){const v=await b.Promises.open(y,"r"),I=Buffer.allocUnsafe(g),i=new D.CancellationTokenSource(d);let r,t=!1;const s={path:y,excludes:[],recursive:!1},o=new p(s,c=>{(async()=>{for(const{type:a}of c)if(a===0){if(t)return;t=!0;try{for(;!i.token.isCancellationRequested;){const{bytesRead:u}=await b.Promises.read(v,I,0,g,null);if(!u||i.token.isCancellationRequested)break;f(I.slice(0,u))}}catch(u){r=new Error(u),i.dispose(!0)}finally{t=!1}}})()});return await o.ready,l(),new Promise((c,a)=>{i.token.onCancellationRequested(async()=>{o.dispose();try{await b.Promises.close(v)}catch(u){r=new Error(u)}r?a(r):c()})})}e.watchFileContents=h}),define(re[199],ae([0,1,3,90,2,5,198]),function(_,e,A,n,D,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class R extends D.Disposable{constructor(){super(...arguments),this.a=this.B(new A.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new A.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=A.Event.None,this.c=new Map,this.f=!1}async watch(S){const C=this.i(S),b=C.filter(p=>{const h=this.c.get(p.path);return h?!(0,n.patternsEquals)(h.request.excludes,p.excludes)||!(0,n.patternsEquals)(h.request.includes,p.includes):!0}),m=Array.from(this.c.values()).filter(({request:p})=>!C.find(h=>h.path===p.path&&(0,n.patternsEquals)(h.excludes,p.excludes)&&(0,n.patternsEquals)(h.includes,p.includes))).map(({request:p})=>p.path);b.length&&this.j(`Request to start watching: ${b.map(p=>`${p.path} (excludes: ${p.excludes.length>0?p.excludes:"<none>"}, includes: ${p.includes&&p.includes.length>0?JSON.stringify(p.includes):"<all>"})`).join(",")}`),m.length&&this.j(`Request to stop watching: ${m.join(",")}`);for(const p of m)this.h(p);for(const p of b)this.g(p)}g(S){const C=new T.NodeJSFileWatcherLibrary(S,m=>this.a.fire(m),m=>this.b.fire(m),this.f),b={request:S,instance:C};this.c.set(S.path,b)}async stop(){for(const[S]of this.c)this.h(S);this.c.clear()}h(S){const C=this.c.get(S);C&&(this.c.delete(S),C.instance.dispose())}i(S){const C=new Map;for(const b of S){const m=k.isLinux?b.path:b.path.toLowerCase();C.set(m,b)}return Array.from(C.values())}async setVerboseLogging(S){this.f=S;for(const[,C]of this.c)C.instance.setVerboseLogging(S)}j(S){this.f&&this.b.fire({type:"trace",message:this.k(S)})}k(S,C){return C?`[File Watcher (node.js)] ${S} (path: ${C.request.path})`:`[File Watcher (node.js)] ${S}`}}e.NodeJSWatcher=R}),define(re[200],ae([0,1,56,199]),function(_,e,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class D extends A.AbstractNonRecursiveWatcherClient{constructor(T,R,P){super(T,R,P),this.m()}l(){return new n.NodeJSWatcher}}e.NodeJSWatcherClient=D}),define(re[201],ae([0,1,24,39,68,56]),function(_,e,A,n,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class T extends k.AbstractUniversalWatcherClient{constructor(P,S,C){super(P,S,C),this.m()}l(P){const S=P.add(new D.Client(A.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return P.add(S.onDidProcessExit(({code:C,signal:b})=>this.n(`terminated by itself with code ${C}, signal: ${b}`))),n.ProxyChannel.toService((0,n.getNextTickChannel)(S.getChannel("watcher")))}}e.UniversalWatcherClient=T}),define(re[72],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class A{constructor(...D){this.a=new Map;for(const[k,T]of D)this.set(k,T)}set(D,k){const T=this.a.get(D);return this.a.set(D,k),T}has(D){return this.a.has(D)}get(D){return this.a.get(D)}}e.ServiceCollection=A}),define(re[202],ae([0,1,6,7,2,55,192,4,72,84]),function(_,e,A,n,D,k,T,R,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const C=!1;class b extends Error{constructor(f){super("cyclic dependency between services"),this.message=f.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class m{constructor(f=new P.ServiceCollection,l=!1,d,g=C){this.f=f,this.g=l,this.h=d,this.i=g,this.o=new Set,this.f.set(R.IInstantiationService,this),this._globalGraph=g?d?._globalGraph??new T.Graph(v=>v):void 0}createChild(f){return new m(f,this.g,this,this.i)}invokeFunction(f,...l){const d=h.traceInvocation(this.i,f);let g=!1;try{return f({get:I=>{if(g)throw(0,n.illegalState)("service accessor is only valid during the invocation of its target method");const i=this.m(I,d);if(!i)throw new Error(`[invokeFunction] unknown service '${I}'`);return i}},...l)}finally{g=!0,d.stop()}}createInstance(f,...l){let d,g;return f instanceof k.SyncDescriptor?(d=h.traceCreation(this.i,f.ctor),g=this.j(f.ctor,f.staticArguments.concat(l),d)):(d=h.traceCreation(this.i,f),g=this.j(f,l,d)),d.stop(),g}j(f,l=[],d){const g=R._util.getServiceDependencies(f).sort((i,r)=>i.index-r.index),v=[];for(const i of g){const r=this.m(i.id,d);r||this.u(`[createInstance] ${f.name} depends on UNKNOWN service ${i.id}.`,!1),v.push(r)}const I=g.length>0?g[0].index:l.length;if(l.length!==I){console.trace(`[createInstance] First service dependency of ${f.name} at position ${I+1} conflicts with ${l.length} static arguments`);const i=I-l.length;i>0?l=l.concat(new Array(i)):l=l.slice(0,I)}return Reflect.construct(f,l.concat(v))}k(f,l){if(this.f.get(f)instanceof k.SyncDescriptor)this.f.set(f,l);else if(this.h)this.h.k(f,l);else throw new Error("illegalState - setting UNKNOWN service instance")}l(f){const l=this.f.get(f);return!l&&this.h?this.h.l(f):l}m(f,l){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(f));const d=this.l(f);return d instanceof k.SyncDescriptor?this.q(f,d,l.branch(f,!0)):(l.branch(f,!1),d)}q(f,l,d){if(this.o.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this.o.add(f);try{return this.r(f,l,d)}finally{this.o.delete(f)}}r(f,l,d){const g=new T.Graph(i=>i.id.toString());let v=0;const I=[{id:f,desc:l,_trace:d}];for(;I.length;){const i=I.pop();if(g.lookupOrInsertNode(i),v++>1e3)throw new b(g);for(const r of R._util.getServiceDependencies(i.desc.ctor)){const t=this.l(r.id);if(t||this.u(`[createInstance] ${f} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(r.id)),t instanceof k.SyncDescriptor){const s={id:r.id,desc:t,_trace:i._trace.branch(r.id,!0)};g.insertEdge(i,s),I.push(s)}}}for(;;){const i=g.roots();if(i.length===0){if(!g.isEmpty())throw new b(g);break}for(const{data:r}of i){if(this.l(r.id)instanceof k.SyncDescriptor){const s=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,s)}g.removeNode(r)}}return this.l(f)}s(f,l,d=[],g,v){if(this.f.get(f)instanceof k.SyncDescriptor)return this.t(f,l,d,g,v);if(this.h)return this.h.s(f,l,d,g,v);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}t(f,l,d=[],g,v){if(g){const I=new m(void 0,this.g,this,this.i);I.c=String(f);const i=new Map,r=new A.IdleValue(()=>{const t=I.j(l,d,v);for(const[s,o]of i){const c=t[s];if(typeof c=="function")for(const a of o)c.apply(t,a)}return i.clear(),t});return new Proxy(Object.create(null),{get(t,s){if(!r.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let a=i.get(s);return a||(a=new S.LinkedList,i.set(s,a)),(w,E,N)=>{const O=a.push([w,E,N]);return(0,D.toDisposable)(O)}}if(s in t)return t[s];const o=r.value;let c=o[s];return typeof c!="function"||(c=c.bind(o),t[s]=c),c},set(t,s,o){return r.value[s]=o,!0},getPrototypeOf(t){return l.prototype}})}else return this.j(l,d,v)}u(f,l){if(l&&console.warn(f),this.g)throw new Error(f)}}e.InstantiationService=m;var p;(function(y){y[y.None=0]="None",y[y.Creation=1]="Creation",y[y.Invocation=2]="Invocation",y[y.Branch=3]="Branch"})(p||(p={}));class h{static traceInvocation(f,l){return f?new h(2,l.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):h.c}static traceCreation(f,l){return f?new h(1,l.name):h.c}constructor(f,l){this.type=f,this.name=l,this.g=Date.now(),this.h=[]}branch(f,l){const d=new h(3,f.toString());return this.h.push([f,l,d]),d}stop(){const f=Date.now()-this.g;h.f+=f;let l=!1;function d(v,I){const i=[],r=new Array(v+1).join("	");for(const[t,s,o]of I.h)if(s&&o){l=!0,i.push(`${r}CREATES -> ${t}`);const c=d(v+1,o);c&&i.push(c)}else i.push(`${r}uses -> ${t}`);return i.join(`
`)}const g=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${h.f.toFixed(2)}ms)`];(f>2||l)&&h.all.add(g.join(`
`))}}e.Trace=h,h.all=new Set,h.c=new class extends h{constructor(){super(0,null)}stop(){}branch(){return this}},h.f=0}),define(re[203],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class A{constructor(D,k){this.a=D,this.b=k}getChannel(D){return this.a.getChannel(D,this.b)}registerChannel(D,k){this.a.registerChannel(D,k)}}e.MessagePortMainProcessService=A}),define(re[57],ae([0,1,39,55,71,4]),function(_,e,A,n,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class T{constructor(p,h,y,f){const l=y.getChannel(p);return R(h)?f.createInstance(new n.SyncDescriptor(h.channelClientCtor,[l])):A.ProxyChannel.toService(l,h?.proxyOptions)}}function R(m){return!!m?.channelClientCtor}e.IMainProcessService=(0,k.createDecorator)("mainProcessService");let P=class extends T{constructor(p,h,y,f){super(p,h,y,f)}};P=ye([Y(2,e.IMainProcessService),Y(3,k.IInstantiationService)],P);function S(m,p,h){(0,D.registerSingleton)(m,new n.SyncDescriptor(P,[p,h],!0))}e.registerMainProcessRemoteService=S,e.ISharedProcessService=(0,k.createDecorator)("sharedProcessService");let C=class extends T{constructor(p,h,y,f){super(p,h,y,f)}};C=ye([Y(2,e.ISharedProcessService),Y(3,k.IInstantiationService)],C);function b(m,p,h){(0,D.registerSingleton)(m,new n.SyncDescriptor(C,[p,h],!0))}e.registerSharedProcessRemoteService=b}),define(re[73],ae([0,1,23,2,5,168,30,4]),function(_,e,A,n,D,k,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function P(C){return C.tags.find(b=>b.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=P,e.ILanguagePackService=(0,R.createDecorator)("languagePackService");let S=class extends n.Disposable{constructor(b){super(),this.c=b}async getAvailableLanguages(){const b=new A.CancellationTokenSource;setTimeout(()=>b.cancel(),1e3);let m;try{m=await this.c.query({text:'category:"language packs"',pageSize:20},b.token)}catch{return[]}const h=m.firstPage.filter(y=>y.properties.localizedLanguages?.length&&y.tags.some(f=>f.startsWith("lp-"))).map(y=>{const f=y.properties.localizedLanguages?.[0],l=P(y);return{...this.f(l,f,y),extensionId:y.identifier.id,galleryExtension:y}});return h.push({...this.f("en","English"),extensionId:"default"}),h}f(b,m,p){const h=m??b;let y;if(h!==b&&(y=`(${b})`),b.toLowerCase()===D.language.toLowerCase()&&(y??="",y+=(0,k.localize)(0,null)),p?.installCount){y??="";const f=p.installCount;let l;f>1e6?l=`${Math.floor(f/1e5)/10}M`:f>1e3?l=`${Math.floor(f/1e3)}K`:l=String(f),y+=` $(cloud-download) ${l}`}return{id:b,label:h,description:y}}};S=ye([Y(0,T.IExtensionGalleryService)],S),e.LanguagePackBaseService=S}),define(re[204],ae([0,1,2,73]),function(_,e,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let D=class extends A.Disposable{constructor(T){super(),this.a=T,this.b()}b(){this.a.update()}};D=ye([Y(0,n.ILanguagePackService)],D),e.LocalizationsUpdater=D}),define(re[9],ae([0,1,38,3,2,37,5,8,4]),function(_,e,A,n,D,k,T,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,P.createDecorator)("logService"),e.ILoggerService=(0,P.createDecorator)("loggerService");function S(){return new Date().toISOString()}var C;(function(c){c[c.Off=0]="Off",c[c.Trace=1]="Trace",c[c.Debug=2]="Debug",c[c.Info=3]="Info",c[c.Warning=4]="Warning",c[c.Error=5]="Error"})(C=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=C.Info;function b(c,a,u){switch(a){case C.Trace:c.trace(u);break;case C.Debug:c.debug(u);break;case C.Info:c.info(u);break;case C.Warning:c.warn(u);break;case C.Error:c.error(u);break;case C.Off:break;default:throw new Error(`Invalid log level ${a}`)}}e.log=b;function m(c){let a="";for(let u=0;u<c.length;u++){let w=c[u];if(typeof w=="object")try{w=JSON.stringify(w)}catch{}a+=(u>0?" ":"")+w}return a}e.format=m;class p extends D.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new n.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(a){this.b!==a&&(this.b=a,this.c.fire(this.b))}getLevel(){return this.b}f(a){return this.b!==C.Off&&this.b<=a}}e.AbstractLogger=p;class h extends p{constructor(a){super(),this.h=a}f(a){return this.h||super.f(a)}trace(a,...u){this.f(C.Trace)&&this.g(C.Trace,m([a,...u]))}debug(a,...u){this.f(C.Debug)&&this.g(C.Debug,m([a,...u]))}info(a,...u){this.f(C.Info)&&this.g(C.Info,m([a,...u]))}warn(a,...u){this.f(C.Warning)&&this.g(C.Warning,m([a,...u]))}error(a,...u){if(this.f(C.Error))if(a instanceof Error){const w=Array.prototype.slice.call(arguments);w[0]=a.stack,this.g(C.Error,m(w))}else this.g(C.Error,m([a,...u]))}flush(){}}e.AbstractMessageLogger=h;class y extends p{constructor(a=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(a),this.g=!T.isWindows}trace(a,...u){this.f(C.Trace)&&(this.g?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,a,...u):console.log(`[main ${S()}]`,a,...u))}debug(a,...u){this.f(C.Debug)&&(this.g?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,a,...u):console.log(`[main ${S()}]`,a,...u))}info(a,...u){this.f(C.Info)&&(this.g?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,a,...u):console.log(`[main ${S()}]`,a,...u))}warn(a,...u){this.f(C.Warning)&&(this.g?console.warn(`\x1B[93m[main ${S()}]\x1B[0m`,a,...u):console.warn(`[main ${S()}]`,a,...u))}error(a,...u){this.f(C.Error)&&(this.g?console.error(`\x1B[91m[main ${S()}]\x1B[0m`,a,...u):console.error(`[main ${S()}]`,a,...u))}dispose(){}flush(){}}e.ConsoleMainLogger=y;class f extends p{constructor(a=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(a)}trace(a,...u){this.f(C.Trace)&&console.log("%cTRACE","color: #888",a,...u)}debug(a,...u){this.f(C.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",a,...u)}info(a,...u){this.f(C.Info)&&console.log("%c INFO","color: #33f",a,...u)}warn(a,...u){this.f(C.Warning)&&console.log("%c WARN","color: #993",a,...u)}error(a,...u){this.f(C.Error)&&console.log("%c  ERR","color: #f33",a,...u)}dispose(){}flush(){}}e.ConsoleLogger=f;class l extends p{constructor(a,u=e.DEFAULT_LOG_LEVEL){super(),this.g=a,this.setLevel(u)}trace(a,...u){this.f(C.Trace)&&this.g.log(C.Trace,[this.h(a),...u])}debug(a,...u){this.f(C.Debug)&&this.g.log(C.Debug,[this.h(a),...u])}info(a,...u){this.f(C.Info)&&this.g.log(C.Info,[this.h(a),...u])}warn(a,...u){this.f(C.Warning)&&this.g.log(C.Warning,[this.h(a),...u])}error(a,...u){this.f(C.Error)&&this.g.log(C.Error,[this.h(a),...u])}h(a){return typeof a=="string"?a:(0,A.toErrorMessage)(a,this.f(C.Trace))}dispose(){}flush(){}}e.AdapterLogger=l;class d extends p{constructor(a){super(),this.g=a,a.length&&this.setLevel(a[0].getLevel())}setLevel(a){for(const u of this.g)u.setLevel(a);super.setLevel(a)}trace(a,...u){for(const w of this.g)w.trace(a,...u)}debug(a,...u){for(const w of this.g)w.debug(a,...u)}info(a,...u){for(const w of this.g)w.info(a,...u)}warn(a,...u){for(const w of this.g)w.warn(a,...u)}error(a,...u){for(const w of this.g)w.error(a,...u)}flush(){for(const a of this.g)a.flush()}dispose(){for(const a of this.g)a.dispose()}}e.MultiplexLogService=d;class g extends D.Disposable{constructor(a){super(),this.b=a,this.B(a)}get onDidChangeLogLevel(){return this.b.onDidChangeLogLevel}setLevel(a){this.b.setLevel(a)}getLevel(){return this.b.getLevel()}trace(a,...u){this.b.trace(a,...u)}debug(a,...u){this.b.debug(a,...u)}info(a,...u){this.b.info(a,...u)}warn(a,...u){this.b.warn(a,...u)}error(a,...u){this.b.error(a,...u)}flush(){this.b.flush()}}e.LogService=g;class v extends D.Disposable{constructor(a,u){super(),this.c=a,this.b=new k.ResourceMap,this.B(u(w=>this.setLevel(w)))}getLoggers(){return[...this.b.values()].map(({logger:a})=>a)}getLogger(a){return this.b.get(a)?.logger}createLogger(a,u,w){let E=this.b.get(a)?.logger;return E||(w=u?.always?C.Trace:w,E=this.f(a,w??this.c,u),this.b.set(a,{logger:E,logLevel:w})),E}setLevel(a,u){const w=R.URI.isUri(a)?a:void 0,E=w?u:a;if(w){const N=this.b.get(w);N&&N.logLevel!==E&&(N.logLevel=E,N.logger.setLevel(E))}else this.c=E,this.b.forEach(({logLevel:N,logger:O})=>{N===void 0&&O.setLevel(this.c)})}getLogLevel(a){return this.b.get(a)?.logLevel}dispose(){this.b.forEach(({logger:a})=>a.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=v;class I{constructor(){this.onDidChangeLogLevel=new n.Emitter().event}setLevel(a){}getLevel(){return C.Info}trace(a,...u){}debug(a,...u){}info(a,...u){}warn(a,...u){}error(a,...u){}critical(a,...u){}dispose(){}flush(){}}e.NullLogger=I;class i extends I{}e.NullLogService=i;class r extends v{constructor(){super(C.Info,n.Event.None)}f(a,u,w){return new I}}e.NullLoggerService=r;function t(c){if(c.verbose)return C.Trace;if(typeof c.logLevel=="string"){const a=o(c.logLevel.toLowerCase());if(a!==void 0)return a}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=t;function s(c){switch(c){case C.Trace:return"trace";case C.Debug:return"debug";case C.Info:return"info";case C.Warning:return"warn";case C.Error:return"error";case C.Off:return"off"}}e.LogLevelToString=s;function o(c){switch(c){case"trace":return C.Trace;case"debug":return C.Debug;case"info":return C.Info;case"warn":return C.Warning;case"error":return C.Error;case"critical":return C.Error;case"off":return C.Off}}e.parseLogLevel=o}),define(re[205],ae([0,1,6,7,2,12,28,15,9]),function(_,e,A,n,D,k,T,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let S=class extends D.Disposable{constructor(b,m){super(),this.a=b,this.b=m,this.B(new A.RunOnceScheduler(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const b=(0,k.basename)(this.a.logsPath),m=(0,k.dirname)(this.a.logsPath),y=(await T.Promises.readdir(m)).filter(l=>/^\d{8}T\d{6}$/.test(l)).sort().filter(l=>l!==b),f=y.slice(0,Math.max(0,y.length-9));f.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${f.join(", ")}'`),await Promise.all(f.map(l=>T.Promises.rm((0,k.join)(m,l)))))}catch(b){(0,n.onUnexpectedError)(b)}}};S=ye([Y(0,R.IEnvironmentService),Y(1,P.ILogService)],S),e.LogsDataCleaner=S}),define(re[206],ae([0,1,21,6,7,3,2,12,56,9]),function(_,e,A,n,D,k,T,R,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class C extends T.Disposable{constructor(m,p){super(),this.a=m,this.b=p,this.c=this.B(new k.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new k.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new n.ThrottledDelayer(0)),this.s=[],this.t=this.B(new n.ThrottledDelayer(0))}watch(m,p){return p.recursive||this.b?.watcher?.forceUniversal?this.l(m,p):this.u(m,p)}l(m,p){const h={path:this.C(m),excludes:p.excludes,includes:p.includes,recursive:p.recursive},y=(0,A.insert)(this.j,h);return this.m(),(0,T.toDisposable)(()=>{y(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(m=>(0,D.onUnexpectedError)(m))}n(){this.h||(this.h=this.B(this.p(p=>this.c.fire((0,P.toFileChanges)(p)),p=>this.z(p),this.a.getLevel()===S.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===S.LogLevel.Trace)})));const m=this.b?.watcher?.recursive?.usePolling;if(m===!0)for(const p of this.j)(0,P.isRecursiveWatchRequest)(p)&&(p.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const p of this.j)(0,P.isRecursiveWatchRequest)(p)&&m.includes(p.path)&&(p.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(m,p){const h={path:this.C(m),excludes:p.excludes,includes:p.includes,recursive:!1},y=(0,A.insert)(this.s,h);return this.v(),(0,T.toDisposable)(()=>{y(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(m=>(0,D.onUnexpectedError)(m))}w(){return this.r||(this.r=this.B(this.y(m=>this.c.fire((0,P.toFileChanges)(m)),m=>this.z(m),this.a.getLevel()===S.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===S.LogLevel.Trace)}))),this.r.watch(this.s)}z(m){m.type==="error"&&this.g.fire(m.message),this.a[m.type](m.message)}C(m){return(0,R.normalize)(m.fsPath)}}e.AbstractDiskFileSystemProvider=C}),define(re[207],ae([0,1,21,6,17,23,3,66,64,2,49,24,102,22,44,164,13,101,9,7]),function(_,e,A,n,D,k,T,R,P,S,C,b,m,p,h,y,f,l,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let v=class extends S.Disposable{constructor(i){super(),this.b=i,this.a=256*1024,this.c=this.B(new T.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new T.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new T.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new T.Emitter),this.onDidRunOperation=this.m.event,this.R=this.B(new T.Emitter),this.onDidFilesChange=this.R.event,this.S=this.B(new T.Emitter),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new n.ResourceQueue)}registerProvider(i,r){if(this.h.has(i))throw new Error(`A filesystem provider for the scheme '${i}' is already registered.`);(0,m.mark)(`code/registerFilesystem/${i}`);const t=new S.DisposableStore;return this.h.set(i,r),this.c.fire({added:!0,scheme:i,provider:r}),t.add(r.onDidChangeFile(s=>this.R.fire(new f.FileChangesEvent(s,!this.O(r))))),typeof r.onDidWatchError=="function"&&t.add(r.onDidWatchError(s=>this.S.fire(new Error(s)))),t.add(r.onDidChangeCapabilities(()=>this.g.fire({provider:r,scheme:i}))),(0,S.toDisposable)(()=>{this.c.fire({added:!1,scheme:i,provider:r}),this.h.delete(i),(0,S.dispose)(t)})}getProvider(i){return this.h.get(i)}async activateProvider(i){const r=[];this.f.fire({scheme:i,join(t){r.push(t)}}),!this.h.has(i)&&await n.Promises.settled(r)}async canHandleResource(i){return await this.activateProvider(i.scheme),this.hasProvider(i)}hasProvider(i){return this.h.has(i.scheme)}hasCapability(i,r){const t=this.h.get(i.scheme);return!!(t&&t.capabilities&r)}listCapabilities(){return P.Iterable.map(this.h,([i,r])=>({scheme:i,capabilities:r.capabilities}))}async j(i){if(!(0,p.isAbsolutePath)(i))throw new f.FileOperationError((0,y.localize)(0,null,this.nb(i)),8);await this.activateProvider(i.scheme);const r=this.h.get(i.scheme);if(!r){const t=new g.ErrorNoTelemetry;throw t.message=(0,y.localize)(1,null,i.toString()),t}return r}async k(i){const r=await this.j(i);if((0,f.hasOpenReadWriteCloseCapability)(r)||(0,f.hasReadWriteCapability)(r)||(0,f.hasFileReadStreamCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(i){const r=await this.j(i);if((0,f.hasOpenReadWriteCloseCapability)(r)||(0,f.hasReadWriteCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(i,r){try{return await this.n(i,r)}catch(t){throw(0,f.toFileSystemProviderErrorCode)(t)===f.FileSystemProviderErrorCode.FileNotFound?new f.FileOperationError((0,y.localize)(2,null,this.nb(i)),1):(0,f.ensureFileSystemProviderError)(t)}}async n(i,r){const t=await this.j(i),s=this.O(t),o=r?.resolveTo,c=r?.resolveSingleChildDescendants,a=r?.resolveMetadata,u=await t.stat(i);let w;return this.p(t,i,u,void 0,!!a,(E,N)=>(w||(w=C.TernarySearchTree.forUris(()=>!s),w.set(i,!0),o&&w.fill(!0,o)),w.get(E.resource)||w.findSuperstr(E.resource.with({query:null,fragment:null}))?!0:E.isDirectory&&c?N===1:!1))}async p(i,r,t,s,o,c){const{providerExtUri:a}=this.N(i),u={resource:r,name:a.basename(r),isFile:(t.type&f.FileType.File)!==0,isDirectory:(t.type&f.FileType.Directory)!==0,isSymbolicLink:(t.type&f.FileType.SymbolicLink)!==0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:Boolean((t.permissions??0)&f.FilePermission.Readonly)||Boolean(i.capabilities&2048),etag:(0,f.etag)({mtime:t.mtime,size:t.size}),children:void 0};if(u.isDirectory&&c(u,s)){try{const w=await i.readdir(r),E=await n.Promises.settled(w.map(async([N,O])=>{try{const j=a.joinPath(r,N),M=o?await i.stat(j):{type:O};return await this.p(i,j,M,w.length,o,c)}catch(j){return this.b.trace(j),null}}));u.children=(0,A.coalesce)(E)}catch(w){this.b.trace(w),u.children=[]}return u}return u}async resolveAll(i){return n.Promises.settled(i.map(async r=>{try{return{stat:await this.n(r.resource,r.options),success:!0}}catch(t){return this.b.trace(t),{stat:void 0,success:!1}}}))}async stat(i){const r=await this.j(i),t=await r.stat(i);return this.p(r,i,t,void 0,!0,()=>!1)}async exists(i){const r=await this.j(i);try{return!!await r.stat(i)}catch{return!1}}async canCreateFile(i,r){try{await this.r(i,r)}catch(t){return t}return!0}async r(i,r){if(!r?.overwrite&&await this.exists(i))throw new f.FileOperationError((0,y.localize)(3,null,this.nb(i)),3,r)}async createFile(i,r=D.VSBuffer.fromString(""),t){await this.r(i,t);const s=await this.writeFile(i,r);return this.m.fire(new f.FileOperationEvent(i,0,s)),s}async writeFile(i,r,t){const s=this.lb(await this.l(i),i),{providerExtUri:o}=this.N(s);try{await this.s(s,i,t)||await this.P(s,o.dirname(i));let a;if((0,f.hasReadWriteCapability)(s)&&!(r instanceof D.VSBuffer))if((0,h.isReadableStream)(r)){const u=await(0,h.peekStream)(r,3);u.ended?a=D.VSBuffer.concat(u.buffer):a=u}else a=(0,h.peekReadable)(r,u=>D.VSBuffer.concat(u),3);else a=r;!(0,f.hasOpenReadWriteCloseCapability)(s)||(0,f.hasReadWriteCapability)(s)&&a instanceof D.VSBuffer?await this.cb(s,i,t,a):await this.Y(s,i,t,a instanceof D.VSBuffer?(0,D.bufferToReadable)(a):a),this.m.fire(new f.FileOperationEvent(i,4))}catch(c){throw new f.FileOperationError((0,y.localize)(4,null,this.nb(i),(0,f.ensureFileSystemProviderError)(c).toString()),(0,f.toFileOperationResult)(c),t)}return this.resolve(i,{resolveMetadata:!0})}async s(i,r,t){if(!!t?.unlock&&!(i.capabilities&8192))throw new Error((0,y.localize)(5,null,this.nb(r)));let o;try{o=await i.stat(r)}catch{return}if((o.type&f.FileType.Directory)!==0)throw new f.FileOperationError((0,y.localize)(6,null,this.nb(r)),0,t);if(this.mb(r,o),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==f.ETAG_DISABLED&&typeof o.mtime=="number"&&typeof o.size=="number"&&t.mtime<o.mtime&&t.etag!==(0,f.etag)({mtime:t.mtime,size:o.size}))throw new f.FileOperationError((0,y.localize)(7,null),3,t);return o}async readFile(i,r,t){const s=await this.k(i);return r?.atomic?this.t(s,i,r,t):this.u(s,i,r,t)}async t(i,r,t,s){return new Promise((o,c)=>{this.X.queueFor(r,this.N(i).providerExtUri).queue(async()=>{try{const a=await this.u(i,r,t,s);o(a)}catch(a){c(a)}})})}async u(i,r,t,s){const o=await this.v(i,r,{...t,preferUnbuffered:!0},s);return{...o,value:await(0,D.streamToBuffer)(o.value)}}async readFileStream(i,r,t){const s=await this.k(i);return this.v(s,i,r,t)}async v(i,r,t,s){const o=new k.CancellationTokenSource(s),c=this.F(r,t).then(u=>u,u=>{throw o.cancel(),u});let a;try{return typeof t?.etag=="string"&&t.etag!==f.ETAG_DISABLED&&await c,t?.atomic&&(0,f.hasFileAtomicReadCapability)(i)||!((0,f.hasOpenReadWriteCloseCapability)(i)||(0,f.hasFileReadStreamCapability)(i))||(0,f.hasReadWriteCapability)(i)&&t?.preferUnbuffered?a=this.D(i,r,t):(0,f.hasFileReadStreamCapability)(i)?a=this.z(i,r,o.token,t):a=this.C(i,r,o.token,t),{...await c,value:a}}catch(u){throw a&&await(0,h.consumeStream)(a),this.w(u,r,t)}}w(i,r,t){const s=(0,y.localize)(8,null,this.nb(r),(0,f.ensureFileSystemProviderError)(i).toString());return i instanceof f.NotModifiedSinceFileOperationError?new f.NotModifiedSinceFileOperationError(s,i.stat,t):i instanceof f.TooLargeFileOperationError?new f.TooLargeFileOperationError(s,i.fileOperationResult,i.size,i.options):new f.FileOperationError(s,(0,f.toFileOperationResult)(i),t)}z(i,r,t,s=Object.create(null)){const o=i.readFileStream(r,s,t);return(0,h.transform)(o,{data:c=>c instanceof D.VSBuffer?c:D.VSBuffer.wrap(c),error:c=>this.w(c,r,s)},c=>D.VSBuffer.concat(c))}C(i,r,t,s=Object.create(null)){const o=(0,D.newWriteableBufferStream)();return(0,l.readFileIntoStream)(i,r,o,c=>c,{...s,bufferSize:this.a,errorTransformer:c=>this.w(c,r,s)},t),o}D(i,r,t){const s=(0,h.newWriteableStream)(o=>D.VSBuffer.concat(o));return(async()=>{try{let o;t?.atomic&&(0,f.hasFileAtomicReadCapability)(i)?o=await i.readFile(r,{atomic:!0}):o=await i.readFile(r),typeof t?.position=="number"&&(o=o.slice(t.position)),typeof t?.length=="number"&&(o=o.slice(0,t.length)),this.G(r,o.byteLength,t),s.end(D.VSBuffer.wrap(o))}catch(o){s.error(o),s.end()}})(),s}async F(i,r){const t=await this.resolve(i,{resolveMetadata:!0});if(t.isDirectory)throw new f.FileOperationError((0,y.localize)(9,null,this.nb(i)),0,r);if(typeof r?.etag=="string"&&r.etag!==f.ETAG_DISABLED&&r.etag===t.etag)throw new f.NotModifiedSinceFileOperationError((0,y.localize)(10,null),t,r);return this.G(i,t.size,r),t}G(i,r,t){if(t?.limits){let s;if(typeof t.limits.memory=="number"&&r>t.limits.memory&&(s=9),typeof t.limits.size=="number"&&r>t.limits.size&&(s=7),typeof s=="number")throw new f.TooLargeFileOperationError((0,y.localize)(11,null,this.nb(i)),s,r,t)}}async canMove(i,r,t){return this.H(i,r,"move",t)}async canCopy(i,r,t){return this.H(i,r,"copy",t)}async H(i,r,t,s){if(i.toString()!==r.toString())try{const o=t==="move"?this.lb(await this.l(i),i):await this.k(i),c=this.lb(await this.l(r),r);await this.M(o,i,c,r,t,s)}catch(o){return o}return!0}async move(i,r,t){const s=this.lb(await this.l(i),i),o=this.lb(await this.l(r),r),c=await this.I(s,i,o,r,"move",!!t),a=await this.resolve(r,{resolveMetadata:!0});return this.m.fire(new f.FileOperationEvent(i,c==="move"?2:3,a)),a}async copy(i,r,t){const s=await this.k(i),o=this.lb(await this.l(r),r),c=await this.I(s,i,o,r,"copy",!!t),a=await this.resolve(r,{resolveMetadata:!0});return this.m.fire(new f.FileOperationEvent(i,c==="copy"?3:2,a)),a}async I(i,r,t,s,o,c){if(r.toString()===s.toString())return o;const{exists:a,isSameResourceWithDifferentPathCase:u}=await this.M(i,r,t,s,o,c);if(a&&!u&&c&&await this.del(s,{recursive:!0}),await this.P(t,this.N(t).providerExtUri.dirname(s)),o==="copy"){if(i===t&&(0,f.hasFileFolderCopyCapability)(i))await i.copy(r,s,{overwrite:c});else{const w=await this.resolve(r);w.isDirectory?await this.L(i,w,t,s):await this.J(i,r,t,s)}return o}else return i===t?(await i.rename(r,s,{overwrite:c}),o):(await this.I(i,r,t,s,"copy",c),await this.del(r,{recursive:!0}),"copy")}async J(i,r,t,s){if((0,f.hasOpenReadWriteCloseCapability)(i)&&(0,f.hasOpenReadWriteCloseCapability)(t))return this.eb(i,r,t,s);if((0,f.hasOpenReadWriteCloseCapability)(i)&&(0,f.hasReadWriteCapability)(t))return this.kb(i,r,t,s);if((0,f.hasReadWriteCapability)(i)&&(0,f.hasOpenReadWriteCloseCapability)(t))return this.ib(i,r,t,s);if((0,f.hasReadWriteCapability)(i)&&(0,f.hasReadWriteCapability)(t))return this.gb(i,r,t,s)}async L(i,r,t,s){await t.mkdir(s),Array.isArray(r.children)&&await n.Promises.settled(r.children.map(async o=>{const c=this.N(t).providerExtUri.joinPath(s,o.name);return o.isDirectory?this.L(i,await this.resolve(o.resource),t,c):this.J(i,o.resource,t,c)}))}async M(i,r,t,s,o,c){let a=!1;if(i===t){const{providerExtUri:w,isPathCaseSensitive:E}=this.N(i);if(E||(a=w.isEqual(r,s)),a&&o==="copy")throw new Error((0,y.localize)(12,null,this.nb(r),this.nb(s)));if(!a&&w.isEqualOrParent(s,r))throw new Error((0,y.localize)(13,null,this.nb(r),this.nb(s)))}const u=await this.exists(s);if(u&&!a){if(!c)throw new f.FileOperationError((0,y.localize)(14,null,this.nb(r),this.nb(s)),4);if(i===t){const{providerExtUri:w}=this.N(i);if(w.isEqualOrParent(r,s))throw new Error((0,y.localize)(15,null,this.nb(r),this.nb(s)))}}return{exists:u,isSameResourceWithDifferentPathCase:a}}N(i){const r=this.O(i);return{providerExtUri:r?p.extUri:p.extUriIgnorePathCase,isPathCaseSensitive:r}}O(i){return!!(i.capabilities&1024)}async createFolder(i){const r=this.lb(await this.j(i),i);await this.P(r,i);const t=await this.resolve(i,{resolveMetadata:!0});return this.m.fire(new f.FileOperationEvent(i,0,t)),t}async P(i,r){const t=[],{providerExtUri:s}=this.N(i);for(;!s.isEqual(r,s.dirname(r));)try{if(((await i.stat(r)).type&f.FileType.Directory)===0)throw new Error((0,y.localize)(16,null,this.nb(r)));break}catch(o){if((0,f.toFileSystemProviderErrorCode)(o)!==f.FileSystemProviderErrorCode.FileNotFound)throw o;t.push(s.basename(r)),r=s.dirname(r)}for(let o=t.length-1;o>=0;o--){r=s.joinPath(r,t[o]);try{await i.mkdir(r)}catch(c){if((0,f.toFileSystemProviderErrorCode)(c)!==f.FileSystemProviderErrorCode.FileExists)throw c}}}async canDelete(i,r){try{await this.Q(i,r)}catch(t){return t}return!0}async Q(i,r){const t=this.lb(await this.j(i),i);if(!!r?.useTrash&&!(t.capabilities&4096))throw new Error((0,y.localize)(17,null,this.nb(i)));let o;try{o=await t.stat(i)}catch{}if(o)this.mb(i,o);else throw new f.FileOperationError((0,y.localize)(18,null,this.nb(i)),1);if(!!!r?.recursive){const a=await this.resolve(i);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,y.localize)(19,null,this.nb(i)))}return t}async del(i,r){const t=await this.Q(i,r),s=!!r?.useTrash,o=!!r?.recursive;await t.delete(i,{recursive:o,useTrash:s}),this.m.fire(new f.FileOperationEvent(i,1))}async cloneFile(i,r){const t=await this.j(i),s=this.lb(await this.l(r),r);if(t===s&&this.N(t).providerExtUri.isEqual(i,r))return;if(t===s&&(0,f.hasFileCloneCapability)(t))return t.cloneFile(i,r);await this.P(s,this.N(s).providerExtUri.dirname(r));const o=this.X.queueFor(i,this.N(t).providerExtUri);return t===s&&(0,f.hasFileFolderCopyCapability)(t)?o.queue(()=>t.copy(i,r,{overwrite:!0})):o.queue(()=>this.J(t,i,s,r))}watch(i,r={recursive:!1,excludes:[]}){const t=new S.DisposableStore;let s=!1,o=()=>{s=!0};return t.add((0,S.toDisposable)(()=>o())),(async()=>{try{const c=await this.W(i,r);s?(0,S.dispose)(c):o=()=>(0,S.dispose)(c)}catch(c){this.b.error(c)}})(),t}async W(i,r){const t=await this.j(i),s=(0,R.hash)([this.N(t).providerExtUri.getComparisonKey(i),r]);let o=this.U.get(s);return o||(o={count:0,disposable:t.watch(i,r)},this.U.set(s,o)),o.count+=1,(0,S.toDisposable)(()=>{o&&(o.count--,o.count===0&&((0,S.dispose)(o.disposable),this.U.delete(s)))})}dispose(){super.dispose();for(const[,i]of this.U)(0,S.dispose)(i.disposable);this.U.clear()}async Y(i,r,t,s){return this.X.queueFor(r,this.N(i).providerExtUri).queue(async()=>{const o=await i.open(r,{create:!0,unlock:t?.unlock??!1});try{(0,h.isReadableStream)(s)||(0,h.isReadableBufferedStream)(s)?await this.Z(i,o,s):await this.ab(i,o,s)}catch(c){throw(0,f.ensureFileSystemProviderError)(c)}finally{await i.close(o)}})}async Z(i,r,t){let s=0,o;if((0,h.isReadableBufferedStream)(t)){if(t.buffer.length>0){const c=D.VSBuffer.concat(t.buffer);await this.bb(i,r,c,c.byteLength,s,0),s+=c.byteLength}if(t.ended)return;o=t.stream}else o=t;return new Promise((c,a)=>{(0,h.listenStream)(o,{onData:async u=>{o.pause();try{await this.bb(i,r,u,u.byteLength,s,0)}catch(w){return a(w)}s+=u.byteLength,setTimeout(()=>o.resume())},onError:u=>a(u),onEnd:()=>c()})})}async ab(i,r,t){let s=0,o;for(;(o=t.read())!==null;)await this.bb(i,r,o,o.byteLength,s,0),s+=o.byteLength}async bb(i,r,t,s,o,c){let a=0;for(;a<s;)a+=await i.write(r,o+a,t.buffer,c+a,s-a)}async cb(i,r,t,s){return this.X.queueFor(r,this.N(i).providerExtUri).queue(()=>this.db(i,r,t,s))}async db(i,r,t,s){let o;s instanceof D.VSBuffer?o=s:(0,h.isReadableStream)(s)?o=await(0,D.streamToBuffer)(s):(0,h.isReadableBufferedStream)(s)?o=await(0,D.bufferedStreamToBuffer)(s):o=(0,D.readableToBuffer)(s),await i.writeFile(r,o.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1})}async eb(i,r,t,s){return this.X.queueFor(s,this.N(t).providerExtUri).queue(()=>this.fb(i,r,t,s))}async fb(i,r,t,s){let o,c;try{o=await i.open(r,{create:!1}),c=await t.open(s,{create:!0,unlock:!1});const a=D.VSBuffer.alloc(this.a);let u=0,w=0,E=0;do E=await i.read(o,u,a.buffer,w,a.byteLength-w),await this.bb(t,c,a,E,u,w),u+=E,w+=E,w===a.byteLength&&(w=0);while(E>0)}catch(a){throw(0,f.ensureFileSystemProviderError)(a)}finally{await n.Promises.settled([typeof o=="number"?i.close(o):Promise.resolve(),typeof c=="number"?t.close(c):Promise.resolve()])}}async gb(i,r,t,s){return this.X.queueFor(s,this.N(t).providerExtUri).queue(()=>this.hb(i,r,t,s))}async hb(i,r,t,s){return t.writeFile(s,await i.readFile(r),{create:!0,overwrite:!0,unlock:!1})}async ib(i,r,t,s){return this.X.queueFor(s,this.N(t).providerExtUri).queue(()=>this.jb(i,r,t,s))}async jb(i,r,t,s){const o=await t.open(s,{create:!0,unlock:!1});try{const c=await i.readFile(r);await this.bb(t,o,D.VSBuffer.wrap(c),c.byteLength,0,0)}catch(c){throw(0,f.ensureFileSystemProviderError)(c)}finally{await t.close(o)}}async kb(i,r,t,s){const o=await(0,D.streamToBuffer)(this.C(i,r,k.CancellationToken.None));await this.cb(t,s,void 0,o)}lb(i,r){if(i.capabilities&2048)throw new f.FileOperationError((0,y.localize)(20,null,this.nb(r)),6);return i}mb(i,r){if((r.permissions??0)&f.FilePermission.Readonly)throw new f.FileOperationError((0,y.localize)(21,null,this.nb(i)),6)}nb(i){return i.scheme===b.Schemas.file?i.fsPath:i.toString(!0)}};v=ye([Y(0,d.ILogService)],v),e.FileService=v}),define(re[208],ae([0,1,53,288,6,37,17,3,48,2,12,5,22,44,28,167,13,101,206,38,201,200]),function(_,e,A,n,D,k,T,R,P,S,C,b,m,p,h,y,f,l,d,g,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,n.gracefulify)(A)}catch(r){console.error(`Error enabling graceful-fs: ${(0,g.toErrorMessage)(r)}`)}})();class i extends d.AbstractDiskFileSystemProvider{constructor(t,s){super(t,s),this.onDidChangeCapabilities=R.Event.None,this.H=new k.ResourceMap(o=>m.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,b.isLinux&&(this.F|=1024)),this.F}async stat(t){try{const{stat:s,symbolicLink:o}=await h.SymlinkSupport.stat(this.C(t));return{type:this.G(s,o),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size}}catch(s){throw this.Y(s)}}async readdir(t){try{const s=await h.Promises.readdir(this.C(t),{withFileTypes:!0}),o=[];return await Promise.all(s.map(async c=>{try{let a;c.isSymbolicLink()?a=(await this.stat((0,m.joinPath)(t,c.name))).type:a=this.G(c),o.push([c.name,a])}catch(a){this.a.trace(a)}})),o}catch(s){throw this.Y(s)}}G(t,s){let o;return s?.dangling?o=f.FileType.Unknown:t.isFile()?o=f.FileType.File:t.isDirectory()?o=f.FileType.Directory:o=f.FileType.Unknown,s&&(o|=f.FileType.SymbolicLink),o}async I(t){const s=this.C(t);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${s})`);let o;for(;o=this.H.get(t);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${s})`),await o.wait();const c=new D.Barrier;return this.H.set(t,c),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${s})`),(0,S.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${s})`),this.H.get(t)===c&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${s})`),this.H.delete(t)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${s})`),c.open()})}async readFile(t,s){let o;try{s?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.C(t)})`),o=await this.I(t));const c=this.C(t);return await h.Promises.readFile(c)}catch(c){throw this.Y(c)}finally{o?.dispose()}}J(t){i.D&&this.a.trace(t)}readFileStream(t,s,o){const c=(0,p.newWriteableStream)(a=>T.VSBuffer.concat(a.map(u=>T.VSBuffer.wrap(u))).buffer);return(0,l.readFileIntoStream)(this,t,c,a=>a.buffer,{...s,bufferSize:256*1024},o),c}async writeFile(t,s,o){let c;try{const a=this.C(t);if(!o.create||!o.overwrite){if(await h.Promises.exists(a)){if(!o.overwrite)throw(0,f.createFileSystemProviderError)((0,y.localize)(0,null),f.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,f.createFileSystemProviderError)((0,y.localize)(1,null),f.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(t,{create:!0,unlock:o.unlock}),await this.write(c,0,s,0,s.byteLength)}catch(a){throw await this.Z(t,a)}finally{typeof c=="number"&&await this.close(c)}}static configureFlushOnWrite(t){i.O=t}async open(t,s){const o=this.C(t);let c;(0,f.isFileOpenForWriteOptions)(s)&&(c=await this.I(t));let a;try{if((0,f.isFileOpenForWriteOptions)(s)&&s.unlock)try{const{stat:w}=await h.SymlinkSupport.stat(o);w.mode&128||await h.Promises.chmod(o,w.mode|128)}catch(w){this.a.trace(w)}let u;if((0,f.isFileOpenForWriteOptions)(s)){if(b.isWindows)try{await h.Promises.truncate(o,0),u="r+"}catch(w){w.code!=="ENOENT"&&this.a.trace(w)}u||(u="w")}else u="r";a=await h.Promises.open(o,u)}catch(u){throw c?.dispose(),(0,f.isFileOpenForWriteOptions)(s)?await this.Z(t,u):this.Y(u)}if(this.L.set(a,0),(0,f.isFileOpenForWriteOptions)(s)&&this.N.set(a,t),c){const u=this.M.get(a);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${a} (${o})`),this.M.set(a,c),u&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${a} (${o})`),u.dispose())}return a}async close(t){const s=this.M.get(t);try{if(this.L.delete(t),this.N.delete(t)&&i.O)try{await h.Promises.fdatasync(t)}catch(o){i.configureFlushOnWrite(!1),this.a.error(o)}return await h.Promises.close(t)}catch(o){throw this.Y(o)}finally{s&&(this.M.get(t)===s&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.M.delete(t)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),s.dispose())}}async read(t,s,o,c,a){const u=this.P(t,s);let w=null;try{w=(await h.Promises.read(t,o,c,a,u)).bytesRead}catch(E){throw this.Y(E)}finally{this.Q(t,u,w)}return w}P(t,s){return s===this.L.get(t)?null:s}Q(t,s,o){const c=this.L.get(t);typeof c=="number"&&(typeof s=="number"||(typeof o=="number"?this.L.set(t,c+o):this.L.delete(t)))}async write(t,s,o,c,a){return(0,D.retry)(()=>this.R(t,s,o,c,a),100,3)}async R(t,s,o,c,a){const u=this.P(t,s);let w=null;try{w=(await h.Promises.write(t,o,c,a,u)).bytesWritten}catch(E){throw await this.Z(this.N.get(t),E)}finally{this.Q(t,u,w)}return w}async mkdir(t){try{await h.Promises.mkdir(this.C(t))}catch(s){throw this.Y(s)}}async delete(t,s){try{const o=this.C(t);s.recursive?await h.Promises.rm(o,h.RimRafMode.MOVE):await h.Promises.unlink(o)}catch(o){throw this.Y(o)}}async rename(t,s,o){const c=this.C(t),a=this.C(s);if(c!==a)try{await this.S(t,s,"move",o.overwrite),await h.Promises.move(c,a)}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,y.localize)(2,null,(0,C.basename)(c),(0,C.basename)((0,C.dirname)(a)),u.toString()))),this.Y(u)}}async copy(t,s,o){const c=this.C(t),a=this.C(s);if(c!==a)try{await this.S(t,s,"copy",o.overwrite),await h.Promises.copy(c,a,{preserveSymlinks:!0})}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,y.localize)(3,null,(0,C.basename)(c),(0,C.basename)((0,C.dirname)(a)),u.toString()))),this.Y(u)}}async S(t,s,o,c){const a=this.C(t),u=this.C(s);let w=!1;if(!!(this.capabilities&1024)||(w=(0,P.isEqual)(a,u,!0)),w&&o==="copy")throw(0,f.createFileSystemProviderError)((0,y.localize)(4,null),f.FileSystemProviderErrorCode.FileExists);if(!w&&await h.Promises.exists(u)){if(!c)throw(0,f.createFileSystemProviderError)((0,y.localize)(5,null),f.FileSystemProviderErrorCode.FileExists);await this.delete(s,{recursive:!0,useTrash:!1})}}async cloneFile(t,s){return this.U(t,s,!1)}async U(t,s,o){const c=this.C(t),a=this.C(s),u=!!(this.capabilities&1024);if((0,P.isEqual)(c,a,!u))return;const w=new S.DisposableStore;try{const[E,N]=await Promise.all([this.I(t),this.I(s)]);w.add(E),w.add(N),o&&await h.Promises.mkdir((0,C.dirname)(a),{recursive:!0}),await h.Promises.copyFile(c,a)}catch(E){if(E.code==="ENOENT"&&!o)return this.U(t,s,!0);throw this.Y(E)}finally{w.dispose()}}p(t,s,o){return new v.UniversalWatcherClient(c=>t(c),c=>s(c),o)}y(t,s,o){return new I.NodeJSWatcherClient(c=>t(c),c=>s(c),o)}Y(t){if(t instanceof f.FileSystemProviderError)return t;let s;switch(t.code){case"ENOENT":s=f.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=f.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=f.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=f.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=f.FileSystemProviderErrorCode.NoPermissions;break;default:s=f.FileSystemProviderErrorCode.Unknown}return(0,f.createFileSystemProviderError)(t,s)}async Z(t,s){let o=this.Y(s);if(t&&o.code===f.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await h.SymlinkSupport.stat(this.C(t));c.mode&128||(o=(0,f.createFileSystemProviderError)(s,f.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.a.trace(c)}return o}}e.DiskFileSystemProvider=i,i.D=!1,i.O=!0}),define(re[103],ae([0,1,6,3,2,4,9]),function(_,e,A,n,D,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessLifecycleService=e.ISharedProcessLifecycleService=void 0,e.ISharedProcessLifecycleService=(0,k.createDecorator)("lifecycleSharedProcessService");let R=class extends D.Disposable{constructor(S){super(),this.c=S,this.a=void 0,this.b=this.B(new n.Emitter),this.onWillShutdown=this.b.event}fireOnWillShutdown(){if(this.a)return this.a;this.c.trace("Lifecycle#onWillShutdown.fire()");const S=[];return this.b.fire({join(C){S.push(C)}}),this.a=(async()=>{try{await A.Promises.settled(S)}catch(C){this.c.error(C)}})(),this.a}};R=ye([Y(0,T.ILogService)],R),e.SharedProcessLifecycleService=R}),define(re[104],ae([0,1,3,8,9]),function(_,e,A,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class k{constructor(m,p){this.a=m,this.b=p,this.onDidChangeLogLevel=A.Event.buffer(m.onDidChangeLogLevel,!0)}listen(m,p){switch(p){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${p}`)}async call(m,p,h){switch(p){case"setLevel":return h[1]?this.b.setLevel(n.URI.revive(h[1]),h[0]):this.a.setLevel(h[0])}throw new Error(`Call not found: ${p}`)}}e.LogLevelChannel=k;class T{constructor(m){this.a=m}get onDidChangeLogLevel(){return this.a.listen("onDidChangeLogLevel")}setLevel(m,p){T.setLevel(this.a,m,p)}static setLevel(m,p,h){return m.call("setLevel",[p,h])}}e.LogLevelChannelClient=T;class R{constructor(m){this.b=m,this.a=new Map}listen(m,p){throw new Error(`Event not found: ${p}`)}async call(m,p,h){switch(p){case"createLogger":this.c(n.URI.revive(h[0]),h[1]);return;case"log":return this.e(n.URI.revive(h[0]),h[1]);case"consoleLog":return this.d(h[0],h[1])}throw new Error(`Call not found: ${p}`)}c(m,p){this.a.set(m.toString(),this.b.createLogger(m,p))}d(m,p){let h=console.log;switch(m){case D.LogLevel.Error:h=console.error;break;case D.LogLevel.Warning:h=console.warn;break;case D.LogLevel.Info:h=console.info;break}h.call(console,...p)}e(m,p){const h=this.a.get(m.toString());if(!h)throw new Error("Create the logger before logging");for(const[y,f]of p)(0,D.log)(h,y,f)}}e.LoggerChannel=R;class P extends D.AbstractLoggerService{constructor(m,p,h){super(m,p),this.g=h}createConsoleMainLogger(){return new D.AdapterLogger({log:(m,p)=>{this.g.call("consoleLog",[m,p])}})}f(m,p,h){return new S(this.g,m,p,h)}}e.LoggerChannelClient=P;class S extends D.AbstractMessageLogger{constructor(m,p,h,y){super(y?.always),this.m=m,this.n=p,this.k=!1,this.l=[],this.setLevel(h),this.m.call("createLogger",[p,y]).then(()=>{this.r(this.l),this.k=!0})}g(m,p){const h=[[m,p]];this.k?this.r(h):this.l.push(...h)}r(m){this.m.call("log",[this.n,m])}}class C extends D.LogService{constructor(m,p){super(p),this.c=m,this.B(m.onDidChangeLogLevel(h=>p.setLevel(h)))}setLevel(m){super.setLevel(m),this.c.setLevel(m)}}e.FollowerLogService=C}),define(re[58],ae([0,1,4]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,A.createDecorator)("nativeHostService")}),define(re[59],ae([0,1,3,64,2,4]),function(_,e,A,n,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,k.createDecorator)("policy");class T extends D.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new A.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(S){const C=Object.keys(this.f).length;return this.f={...S,...this.f},C!==Object.keys(this.f).length&&await this.i(S),n.Iterable.reduce(this.g.entries(),(b,[m,p])=>({...b,[m]:p}),{})}getPolicyValue(S){return this.g.get(S)}serialize(){return n.Iterable.reduce(Object.entries(this.f),(S,[C,b])=>({...S,[C]:{definition:b,value:this.g.get(C)}}),{})}}e.AbstractPolicyService=T;class R{constructor(){this.onDidChange=A.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=R}),define(re[209],ae([0,1,3,2,59]),function(_,e,A,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class k{constructor(P){this.b=P,this.a=new n.DisposableStore}listen(P,S){switch(S){case"onDidChange":return A.Event.map(this.b.onDidChange,C=>C.reduce((b,m)=>({...b,[m]:this.b.getPolicyValue(m)??null}),{}),this.a)}throw new Error(`Event not found: ${S}`)}call(P,S,C){switch(S){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(C)}throw new Error(`Call not found: ${S}`)}dispose(){this.a.dispose()}}e.PolicyChannel=k;class T extends D.AbstractPolicyService{constructor(P,S){super(),this.a=S;for(const C in P){const{definition:b,value:m}=P[C];this.f[C]=b,m!==void 0&&this.g.set(C,m)}this.a.listen("onDidChange")(C=>{for(const b in C){const m=C[b];m===null?this.g.delete(b):this.g.set(b,m)}this.h.fire(Object.keys(C))})}async i(P){const S=await this.a.call("updatePolicyDefinitions",P);for(const C in S)this.g.set(C,S[C])}}e.PolicyChannelClient=T}),define(re[105],ae([0,1,5,36]),function(_,e,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let D;if(typeof A.globals.vscode<"u"&&typeof A.globals.vscode.context<"u"){const k=A.globals.vscode.context.configuration();if(k)D=k.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(D=globalThis._VSCODE_PRODUCT_JSON,n.env.VSCODE_DEV&&Object.assign(D,{nameShort:`${D.nameShort} Dev`,nameLong:`${D.nameLong} Dev`,dataFolderName:`${D.dataFolderName}-dev`,serverDataFolderName:D.serverDataFolderName?`${D.serverDataFolderName}-dev`:void 0}),!D.version){const k=globalThis._VSCODE_PACKAGE_JSON;Object.assign(D,{version:k.version})}}else D={},Object.keys(D).length===0&&Object.assign(D,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=D}),define(re[25],ae([0,1,4]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,A.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(re[210],ae([0,1,6,7,2,12,28,9,25]),function(_,e,A,n,D,k,T,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let S=class extends D.Disposable{constructor(b,m,p){super(),this.b=m,this.c=p,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,b&&this.B(new A.RunOnceScheduler(()=>{this.f(b)},3e4)).schedule()}async f(b){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const m=Date.now(),p=(0,k.dirname)(b),h=(0,k.basename)(b),y=await T.Promises.readdir(p);await Promise.all(y.map(async f=>{if(f===h)return;const l=(0,k.join)(p,f),d=await T.Promises.stat(l);if(d.isDirectory()&&m-d.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${f}.`),T.Promises.rm(l)}))}catch(m){(0,n.onUnexpectedError)(m)}}};S=ye([Y(1,P.IProductService),Y(2,R.ILogService)],S),e.CodeCacheCleaner=S}),define(re[211],ae([0,1,6,7,2,12,28,15,9,25]),function(_,e,A,n,D,k,T,R,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let C=class extends D.Disposable{constructor(m,p,h){super(),this.b=m,this.c=p,this.f=h,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new A.RunOnceScheduler(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const m=Object.create(null),p=JSON.parse(await T.Promises.readFile((0,k.join)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const d of Object.keys(p)){const g=p[d];m[`${g.hash}.${d}`]=!0}const h=(0,k.join)(this.b.userDataPath,"clp");if(!await T.Promises.exists(h))return;const f=await T.Promises.readdir(h);for(const d of f){if(m[d]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${d}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${d}`),await T.Promises.rm((0,k.join)(h,d))}const l=Date.now();for(const d of Object.keys(m)){const g=(0,k.join)(h,d),v=await T.Promises.readdir(g);for(const I of v){if(I==="tcf.json")continue;const i=(0,k.join)(g,I),r=await T.Promises.stat(i);r.isDirectory()&&l-r.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,k.join)(d,I)}`),await T.Promises.rm(i))}}}catch(m){(0,n.onUnexpectedError)(m)}}};C=ye([Y(0,R.INativeEnvironmentService),Y(1,P.ILogService),Y(2,S.IProductService)],C),e.LanguagePackCachedDataCleaner=C}),define(re[212],ae([0,1,21,2,22,188,13,25]),function(_,e,A,n,D,k,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let P=class extends n.Disposable{constructor(C,b){super(),this.b=C,this.c=b,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,m])=>this.a.set(m.configPath,m))}getConfigBasedTips(C){return this.f(C)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(C){const b=[];for(const[m,p]of this.a)if(!(p.configScheme&&p.configScheme!==C.scheme))try{const h=await this.b.readFile((0,D.joinPath)(C,m)),y=new Map;Object.entries(p.recommendations).forEach(([l,d])=>{if((0,A.isNonEmptyArray)(d.remotes))for(const g of d.remotes)y.set(g,{extensionId:l,extensionName:d.name,configName:p.configName,important:!!d.important,isExtensionPack:!!d.isExtensionPack,whenNotInstalled:d.whenNotInstalled});else b.push({extensionId:l,extensionName:d.name,configName:p.configName,important:!!d.important,isExtensionPack:!!d.isExtensionPack,whenNotInstalled:d.whenNotInstalled})});const f=(0,k.getDomainsOfRemotes)(h.value.toString(),[...y.keys()]);for(const l of f){const d=y.get(l);d&&b.push(d)}}catch{}return b}};P=ye([Y(0,T.IFileService),Y(1,R.IProductService)],P),e.ExtensionTipsService=P}),define(re[213],ae([0,1,12,4]),function(_,e,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,n.createDecorator)("IV8InspectProfilingService");var D;(function(k){function T(P){return Boolean(P.samples&&P.timeDeltas)}k.isValidProfile=T;function R(P,S="noAbsolutePaths"){for(const C of P.nodes)C.callFrame&&C.callFrame.url&&((0,A.isAbsolute)(C.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(C.callFrame.url))&&(C.callFrame.url=(0,A.join)(S,(0,A.basename)(C.callFrame.url)));return P}k.rewriteAbsolutePaths=R})(D=e.Utils||(e.Utils={}))}),define(re[214],ae([0,1,31]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class n{constructor(){this.a=new Map}async startProfiling(k){const R=await(await new Promise((S,C)=>{_(["v8-inspect-profiler"],S,C)})).startProfiling({port:k.port,checkForPaused:!0}),P=(0,A.generateUuid)();return this.a.set(P,R),P}async stopProfiling(k){const T=this.a.get(k);if(!T)throw new Error(`UNKNOWN session '${k}'`);const R=await T.stop();return this.a.delete(k),R.profile}}e.InspectProfilingService=n}),define(re[40],ae([0,1,128,14]),function(_,e,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.a=new Map}add(T,R){A.ok(n.isString(T)),A.ok(n.isObject(R)),A.ok(!this.a.has(T),"There is already an extension with this id"),this.a.set(T,R)}knows(T){return this.a.has(T)}as(T){return this.a.get(T)||null}}e.Registry=new D}),define(re[106],ae([0,1,3,40]),function(_,e,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class k{constructor(){this.b=new A.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(P,S){this.a[D(P)]=S,this.b.fire(P)}notifySchemaChanged(P){this.b.fire(P)}getSchemaContributions(){return{schemas:this.a}}}const T=new k;n.Registry.add(e.Extensions.JSONContribution,T)}),define(re[46],ae([0,1,21,3,14,153,16,106,40]),function(_,e,A,n,D,k,T,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var S;(function(I){I.Multiline="multilineText",I.Singleline="singlelineText"})(S=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var C;(function(I){I[I.APPLICATION=1]="APPLICATION",I[I.MACHINE=2]="MACHINE",I[I.WINDOW=3]="WINDOW",I[I.RESOURCE=4]="RESOURCE",I[I.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",I[I.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const b=P.Registry.as(R.Extensions.JSONContribution);class m{constructor(){this.h=new Set,this.i=new n.Emitter,this.onDidSchemaChange=this.i.event,this.j=new n.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:k.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},b.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(i,r=!0){this.registerConfigurations([i],r)}registerConfigurations(i,r=!0){const t=new Set;this.n(i,r,t),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:t})}deregisterConfigurations(i){const r=new Set;this.o(i,r),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:i,remove:r}){const t=new Set;this.o(r,t),this.n(i,!1,t),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:t})}registerDefaultConfigurations(i){const r=new Set;this.k(i,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(i,r){const t=[];for(const{overrides:s,source:o}of i)for(const c in s)if(r.add(c),e.OVERRIDE_PROPERTY_REGEX.test(c)){const a=this.a.get(c),u=a?.valuesSources??new Map;if(o)for(const O of Object.keys(s[c]))u.set(O,o);const w={...a?.value||{},...s[c]};this.a.set(c,{source:o,value:w,valuesSources:u});const E=(0,T.getLanguageTagSettingPlainKey)(c),N={type:"object",default:w,description:k.localize(1,null,E),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:w,source:D.isString(o)?void 0:o,defaultValueSource:o};t.push(...y(c)),this.d[c]=N,this.b.properties[c]=N}else{this.a.set(c,{value:s[c],source:o});const a=this.d[c];a&&(this.w(c,a),this.r(c,a))}this.m(t)}deregisterDefaultConfigurations(i){const r=new Set;this.l(i,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(i,r){for(const{overrides:t,source:s}of i)for(const o in t){const c=this.a.get(o),a=D.isString(s)?s:s?.id,u=D.isString(c?.source)?c?.source:c?.source?.id;if(a===u)if(r.add(o),this.a.delete(o),e.OVERRIDE_PROPERTY_REGEX.test(o))delete this.d[o],delete this.b.properties[o];else{const w=this.d[o];w&&(this.w(o,w),this.r(o,w))}}this.u()}deltaConfiguration(i){let r=!1;const t=new Set;i.removedDefaults&&(this.l(i.removedDefaults,t),r=!0),i.addedDefaults&&(this.k(i.addedDefaults,t),r=!0),i.removedConfigurations&&this.o(i.removedConfigurations,t),i.addedConfigurations&&this.n(i.addedConfigurations,!1,t),this.i.fire(),this.j.fire({properties:t,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const r of i)this.h.add(r);this.u()}n(i,r,t){i.forEach(s=>{this.p(s,r,s.extensionInfo,s.restrictedProperties,void 0,t),this.c.push(s),this.q(s)})}o(i,r){const t=s=>{if(s.properties)for(const o in s.properties){r.add(o);const c=this.d[o];c?.policy?.name&&this.e.delete(c.policy.name),delete this.d[o],this.s(o,s.properties[o])}s.allOf?.forEach(o=>t(o))};for(const s of i){t(s);const o=this.c.indexOf(s);o!==-1&&this.c.splice(o,1)}}p(i,r=!0,t,s,o=3,c){o=D.isUndefinedOrNull(i.scope)?o:i.scope;const a=i.properties;if(a)for(const w in a){const E=a[w];if(r&&g(w,E)){delete a[w];continue}if(E.source=t,E.defaultDefaultValue=a[w].default,this.w(w,E),e.OVERRIDE_PROPERTY_REGEX.test(w)?E.scope=void 0:(E.scope=D.isUndefinedOrNull(E.scope)?o:E.scope,E.restricted=D.isUndefinedOrNull(E.restricted)?!!s?.includes(w):E.restricted),a[w].hasOwnProperty("included")&&!a[w].included){this.f[w]=a[w],delete a[w];continue}else this.d[w]=a[w],a[w].policy?.name&&this.e.set(a[w].policy.name,w);!a[w].deprecationMessage&&a[w].markdownDeprecationMessage&&(a[w].deprecationMessage=a[w].markdownDeprecationMessage),c.add(w)}const u=i.allOf;if(u)for(const w of u)this.p(w,r,t,s,o,c)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const r=t=>{const s=t.properties;if(s)for(const c in s)this.r(c,s[c]);t.allOf?.forEach(r)};r(i)}r(i,r){switch(e.allSettings.properties[i]=r,r.scope){case 1:e.applicationSettings.properties[i]=r;break;case 2:e.machineSettings.properties[i]=r;break;case 6:e.machineOverridableSettings.properties[i]=r;break;case 3:e.windowSettings.properties[i]=r;break;case 4:e.resourceSettings.properties[i]=r;break;case 5:e.resourceSettings.properties[i]=r,this.g.properties[i]=r;break}}s(i,r){switch(delete e.allSettings.properties[i],r.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const r=`[${i}]`,t={type:"object",description:k.localize(2,null),errorMessage:k.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(r,t),e.allSettings.properties[r]=t,e.applicationSettings.properties[r]=t,e.machineSettings.properties[r]=t,e.machineOverridableSettings.properties[r]=t,e.windowSettings.properties[r]=t,e.resourceSettings.properties[r]=t}}v(){const i={type:"object",description:k.localize(4,null),errorMessage:k.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this.i.fire()}w(i,r){const t=this.a.get(i);let s=t?.value,o=t?.source;D.isUndefined(s)&&(s=r.defaultDefaultValue,o=void 0),D.isUndefined(s)&&(s=l(r.type)),r.default=s,r.defaultValueSource=o}}const p="\\[([^\\]]+)\\]",h=new RegExp(p,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${p})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function y(I){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(I)){let r=h.exec(I);for(;r?.length;){const t=r[1].trim();t&&i.push(t),r=h.exec(I)}}return(0,A.distinct)(i)}e.overrideIdentifiersFromKey=y;function f(I){return I.reduce((i,r)=>`${i}[${r}]`,"")}e.keyFromOverrideIdentifiers=f;function l(I){switch(Array.isArray(I)?I[0]:I){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=l;const d=new m;P.Registry.add(e.Extensions.Configuration,d);function g(I,i){return I.trim()?e.OVERRIDE_PROPERTY_REGEX.test(I)?k.localize(7,null,I):d.getConfigurationProperties()[I]!==void 0?k.localize(8,null,I):i.policy?.name&&d.getPolicyConfigurations().get(i.policy?.name)!==void 0?k.localize(9,null,I,i.policy?.name,d.getPolicyConfigurations().get(i.policy?.name)):null:k.localize(6,null)}e.validateProperty=g;function v(){const I=[],i=d.getConfigurationProperties();for(const r of Object.keys(i))I.push([r,i[r].scope]);return I.push(["launch",4]),I.push(["task",4]),I}e.getScopes=v}),define(re[74],ae([0,1,21,3,35,2,37,32,14,8,16,46,40]),function(_,e,A,n,D,k,T,R,P,S,C,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class p{constructor(r={},t=[],s=[],o){this.c=r,this.d=t,this.f=s,this.raw=o,this.a=!1,this.b=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const r=this.raw.map(t=>{if(t instanceof p)return t;const s=new h("");return s.parseRaw(t),s.configurationModel});this.g=r.reduce((t,s)=>s===t?s:t.merge(s),r[0])}else this.g=this;return this.g}get contents(){return this.k(this.c)}get overrides(){return this.k(this.f)}get keys(){return this.k(this.d)}isEmpty(){return this.d.length===0&&Object.keys(this.c).length===0&&this.f.length===0}isFrozen(){return this.a}getValue(r){return r?(0,C.getConfigurationValue)(this.contents,r):this.contents}inspect(r,t){const s=this.rawConfiguration.getValue(r),o=t?this.rawConfiguration.getOverrideValue(r,t):void 0,c=t?this.rawConfiguration.override(t).getValue(r):s;return{value:s,override:o,merged:c}}getOverrideValue(r,t){const s=this.l(t);return s?r?(0,C.getConfigurationValue)(s,r):s:void 0}getKeysForOverrideIdentifier(r){const t=[];for(const s of this.overrides)s.identifiers.includes(r)&&t.push(...s.keys);return A.distinct(t)}getAllOverrideIdentifiers(){const r=[];for(const t of this.overrides)r.push(...t.identifiers);return A.distinct(r)}override(r){let t=this.b.get(r);return t||(t=this.h(r),this.b.set(r,t)),t}merge(...r){const t=R.deepClone(this.contents),s=R.deepClone(this.overrides),o=[...this.keys],c=this.raw?.length?[...this.raw]:[this];for(const a of r)if(c.push(...a.raw?.length?a.raw:[a]),!a.isEmpty()){this.j(t,a.contents);for(const u of a.overrides){const[w]=s.filter(E=>A.equals(E.identifiers,u.identifiers));w?(this.j(w.contents,u.contents),w.keys.push(...u.keys),w.keys=A.distinct(w.keys)):s.push(R.deepClone(u))}for(const u of a.keys)o.indexOf(u)===-1&&o.push(u)}return new p(t,o,s,c.every(a=>a instanceof p)?void 0:c)}freeze(){return this.a=!0,this}h(r){const t=this.l(r);if(!t||typeof t!="object"||!Object.keys(t).length)return this;const s={};for(const o of A.distinct([...Object.keys(this.contents),...Object.keys(t)])){let c=this.contents[o];const a=t[o];a&&(typeof c=="object"&&typeof a=="object"?(c=R.deepClone(c),this.j(c,a)):c=a),s[o]=c}return new p(s,this.keys,this.overrides)}j(r,t){for(const s of Object.keys(t)){if(s in r&&P.isObject(r[s])&&P.isObject(t[s])){this.j(r[s],t[s]);continue}r[s]=R.deepClone(t[s])}}k(r){return this.a&&!Object.isFrozen(r)?R.deepFreeze(r):r}l(r){let t=null,s=null;const o=c=>{c&&(s?this.j(s,c):s=R.deepClone(c))};for(const c of this.overrides)A.equals(c.identifiers,[r])?t=c.contents:c.identifiers.includes(r)&&o(c.contents);return o(t),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,t){this.m(r),(0,C.addToValueTree)(this.contents,r,t,s=>{throw new Error(s)})}removeValue(r){this.n(r)&&(0,C.removeFromValueTree)(this.contents,r)}m(r){let t=this.keys.length;for(let s=0;s<t;s++)r.indexOf(this.keys[s])===0&&(t=s);this.keys.splice(t,1,r)}n(r){const t=this.keys.indexOf(r);return t!==-1?(this.keys.splice(t,1),!0):!1}}e.ConfigurationModel=p;class h{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new p}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,t){if(!P.isUndefinedOrNull(r)){const s=this.g(r);this.parseRaw(s,t)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,t){this.a=r;const{contents:s,keys:o,overrides:c,restricted:a,hasExcludedProperties:u}=this.h(r,t);this.b=new p(s,o,c,u?[r]:void 0),this.c=a||[]}g(r){let t={},s=null,o=[];const c=[],a=[];function u(E){Array.isArray(o)?o.push(E):s!==null&&(o[s]=E)}const w={onObjectBegin:()=>{const E={};u(E),c.push(o),o=E,s=null},onObjectProperty:E=>{s=E},onObjectEnd:()=>{o=c.pop()},onArrayBegin:()=>{const E=[];u(E),c.push(o),o=E,s=null},onArrayEnd:()=>{o=c.pop()},onLiteralValue:u,onError:(E,N,O)=>{a.push({error:E,offset:N,length:O})}};if(r)try{D.visit(r,w),t=o[0]||{}}catch(E){console.error(`Error while parsing settings file ${this.f}: ${E}`),this.d=[E]}return t}h(r,t){const s=m.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),o=this.j(r,s,!0,t);r=o.raw;const c=(0,C.toValuesTree)(r,w=>console.error(`Conflict in settings file ${this.f}: ${w}`)),a=Object.keys(r),u=this.l(r,w=>console.error(`Conflict in settings file ${this.f}: ${w}`));return{contents:c,keys:a,overrides:u,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}j(r,t,s,o){let c=!1;if(!o?.scopes&&!o?.skipRestricted)return{raw:r,restricted:[],hasExcludedProperties:c};const a={},u=[];for(const w in r)if(b.OVERRIDE_PROPERTY_REGEX.test(w)&&s){const E=this.j(r[w],t,!1,o);a[w]=E.raw,c=c||E.hasExcludedProperties,u.push(...E.restricted)}else{const E=t[w],N=E?typeof E.scope<"u"?E.scope:3:void 0;E?.restricted&&u.push(w),(N===void 0||o.scopes===void 0||o.scopes.includes(N))&&!(o.skipRestricted&&E?.restricted)?a[w]=r[w]:c=!0}return{raw:a,restricted:u,hasExcludedProperties:c}}l(r,t){const s=[];for(const o of Object.keys(r))if(b.OVERRIDE_PROPERTY_REGEX.test(o)){const c={};for(const a in r[o])c[a]=r[o][a];s.push({identifiers:(0,b.overrideIdentifiersFromKey)(o),keys:Object.keys(c),contents:(0,C.toValuesTree)(c,t)})}return s}}e.ConfigurationModelParser=h;class y extends k.Disposable{constructor(r,t,s,o){super(),this.f=r,this.g=t,this.h=o,this.c=this.B(new n.Emitter),this.onDidChange=this.c.event,this.a=new h(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(s.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(n.Event.any(n.Event.filter(this.h.onDidFilesChange,c=>c.contains(this.f)),n.Event.filter(this.h.onDidRunOperation,c=>(c.isOperation(0)||c.isOperation(3)||c.isOperation(1)||c.isOperation(4))&&s.isEqual(c.resource,r)))(()=>this.c.fire()))}async loadConfiguration(){try{const r=await this.h.readFile(this.f);return this.a.parse(r.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new p}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=y;class f{constructor(r,t,s,o,c,a,u,w,E,N,O,j,M){this.a=r,this.b=t,this.value=s,this.overrideIdentifiers=o,this.c=c,this.d=a,this.f=u,this.g=w,this.h=E,this.j=N,this.k=O,this.l=j,this.m=M}get p(){return this.n||(this.n=this.c.inspect(this.a,this.b.overrideIdentifier)),this.n}get defaultValue(){return this.p.merged}get default(){return this.p.value!==void 0||this.p.override!==void 0?{value:this.p.value,override:this.p.override}:void 0}get r(){return this.q===void 0&&(this.q=this.d?this.d.inspect(this.a):null),this.q}get policyValue(){return this.r?.merged}get policy(){return this.r?.value!==void 0?{value:this.r.value}:void 0}get t(){return this.s===void 0&&(this.s=this.f?this.f.inspect(this.a):null),this.s}get applicationValue(){return this.t?.merged}get application(){return this.t?.value!==void 0||this.t?.override!==void 0?{value:this.t.value,override:this.t.override}:void 0}get v(){return this.u||(this.u=this.g.inspect(this.a,this.b.overrideIdentifier)),this.u}get userValue(){return this.v.merged}get user(){return this.v.value!==void 0||this.v.override!==void 0?{value:this.v.value,override:this.v.override}:void 0}get x(){return this.w||(this.w=this.h.inspect(this.a,this.b.overrideIdentifier)),this.w}get userLocalValue(){return this.x.merged}get userLocal(){return this.x.value!==void 0||this.x.override!==void 0?{value:this.x.value,override:this.x.override}:void 0}get z(){return this.y||(this.y=this.j.inspect(this.a,this.b.overrideIdentifier)),this.y}get userRemoteValue(){return this.z.merged}get userRemote(){return this.z.value!==void 0||this.z.override!==void 0?{value:this.z.value,override:this.z.override}:void 0}get B(){return this.A===void 0&&(this.A=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.A}get workspaceValue(){return this.B?.merged}get workspace(){return this.B?.value!==void 0||this.B?.override!==void 0?{value:this.B.value,override:this.B.override}:void 0}get E(){return this.D===void 0&&(this.D=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.D}get workspaceFolderValue(){return this.E?.merged}get workspaceFolder(){return this.E?.value!==void 0||this.E?.override!==void 0?{value:this.E.value,override:this.E.override}:void 0}get memoryValue(){return this.m.merged}get memory(){return this.m.value!==void 0||this.m.override!==void 0?{value:this.m.value,override:this.m.override}:void 0}}class l{constructor(r,t,s,o,c=new p,a=new p,u=new T.ResourceMap,w=new p,E=new T.ResourceMap,N=!0){this.c=r,this.d=t,this.f=s,this.g=o,this.h=c,this.j=a,this.l=u,this.m=w,this.n=E,this.p=N,this.a=null,this.b=new T.ResourceMap,this.q=null}getValue(r,t,s){return this.s(r,t,s).getValue(r)}updateValue(r,t,s={}){let o;s.resource?(o=this.n.get(s.resource),o||(o=new p,this.n.set(s.resource,o))):o=this.m,t===void 0?o.removeValue(r):o.setValue(r,t),s.resource||(this.a=null)}inspect(r,t,s){const o=this.s(r,t,s),c=this.w(t.resource,s),a=t.resource?this.n.get(t.resource)||this.m:this.m,u=new Set;for(const w of o.overrides)for(const E of w.identifiers)o.getOverrideValue(r,E)!==void 0&&u.add(E);return new f(r,t,o.getValue(r),u.size?[...u]:void 0,this.c,this.d.isEmpty()?void 0:this.d.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),s?this.j.freeze():void 0,c?c.freeze():void 0,a.inspect(r,t.overrideIdentifier))}keys(r){const t=this.w(void 0,r);return{default:this.c.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this.j.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.q=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.q=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.j=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,t){this.l.set(r,t),this.b.delete(r)}deleteFolderConfiguration(r){this.r.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,t){const s=[];if(!t){const{added:o,updated:c,removed:a}=v(this.c,r);t=[...o,...c,...a]}for(const o of t)for(const c of(0,b.overrideIdentifiersFromKey)(o)){const a=this.c.getKeysForOverrideIdentifier(c),u=r.getKeysForOverrideIdentifier(c),w=[...u.filter(E=>a.indexOf(E)===-1),...a.filter(E=>u.indexOf(E)===-1),...a.filter(E=>!R.equals(this.c.override(c).getValue(E),r.override(c).getValue(E)))];s.push([c,w])}return this.updateDefaultConfiguration(r),{keys:t,overrides:s}}compareAndUpdatePolicyConfiguration(r){const{added:t,updated:s,removed:o}=v(this.d,r),c=[...t,...s,...o];return c.length&&this.updatePolicyConfiguration(r),{keys:c,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:t,updated:s,removed:o,overrides:c}=v(this.applicationConfiguration,r),a=[...t,...s,...o];return a.length&&this.updateApplicationConfiguration(r),{keys:a,overrides:c}}compareAndUpdateLocalUserConfiguration(r){const{added:t,updated:s,removed:o,overrides:c}=v(this.localUserConfiguration,r),a=[...t,...s,...o];return a.length&&this.updateLocalUserConfiguration(r),{keys:a,overrides:c}}compareAndUpdateRemoteUserConfiguration(r){const{added:t,updated:s,removed:o,overrides:c}=v(this.remoteUserConfiguration,r),a=[...t,...s,...o];return a.length&&this.updateRemoteUserConfiguration(r),{keys:a,overrides:c}}compareAndUpdateWorkspaceConfiguration(r){const{added:t,updated:s,removed:o,overrides:c}=v(this.workspaceConfiguration,r),a=[...t,...s,...o];return a.length&&this.updateWorkspaceConfiguration(r),{keys:a,overrides:c}}compareAndUpdateFolderConfiguration(r,t){const s=this.r.get(r),{added:o,updated:c,removed:a,overrides:u}=v(s,t),w=[...o,...c,...a];return(w.length||!s)&&this.updateFolderConfiguration(r,t),{keys:w,overrides:u}}compareAndDeleteFolderConfiguration(r){const t=this.r.get(r);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:s,updated:o,removed:c,overrides:a}=v(t,void 0);return{keys:[...s,...o,...c],overrides:a}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.q||(this.q=this.h.isEmpty()?this.g:this.g.merge(this.h),this.p&&this.q.freeze()),this.q}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.j}get r(){return this.l}s(r,t,s){let o=this.t(t,s);return t.overrideIdentifier&&(o=o.override(t.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(o=o.merge(this.d)),o}t({resource:r},t){let s=this.u();if(t&&r){const o=t.getFolder(r);o&&(s=this.v(o.uri)||s);const c=this.n.get(r);c&&(s=s.merge(c))}return s}u(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.j,this.m),this.p&&(this.j=this.j.freeze())),this.a}v(r){let t=this.b.get(r);if(!t){const s=this.u(),o=this.l.get(r);o?(t=s.merge(o),this.p&&(t=t.freeze()),this.b.set(r,t)):t=s}return t}w(r,t){if(t&&r){const s=t.getFolder(r);if(s)return this.l.get(s.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},folders:[...this.l.keys()].reduce((r,t)=>{const{contents:s,overrides:o,keys:c}=this.l.get(t);return r.push([t,{contents:s,overrides:o,keys:c}]),r},[])}}allKeys(){const r=new Set;return this.c.freeze().keys.forEach(t=>r.add(t)),this.userConfiguration.freeze().keys.forEach(t=>r.add(t)),this.j.freeze().keys.forEach(t=>r.add(t)),this.l.forEach(t=>t.freeze().keys.forEach(s=>r.add(s))),[...r.values()]}x(){const r=new Set;return this.c.freeze().getAllOverrideIdentifiers().forEach(t=>r.add(t)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>r.add(t)),this.j.freeze().getAllOverrideIdentifiers().forEach(t=>r.add(t)),this.l.forEach(t=>t.freeze().getAllOverrideIdentifiers().forEach(s=>r.add(s))),[...r.values()]}y(r){const t=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(s=>t.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(s=>t.add(s)),this.j.getKeysForOverrideIdentifier(r).forEach(s=>t.add(s)),this.l.forEach(s=>s.getKeysForOverrideIdentifier(r).forEach(o=>t.add(o))),[...t.values()]}static parse(r){const t=this.z(r.defaults),s=this.z(r.policy),o=this.z(r.application),c=this.z(r.user),a=this.z(r.workspace),u=r.folders.reduce((w,E)=>(w.set(S.URI.revive(E[0]),this.z(E[1])),w),new T.ResourceMap);return new l(t,s,o,c,new p,a,u,new p,new T.ResourceMap,!1)}static z(r){return new p(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=l;function d(...i){if(i.length===0)return{keys:[],overrides:[]};if(i.length===1)return i[0];const r=new Set,t=new Map;for(const o of i)o.keys.forEach(c=>r.add(c)),o.overrides.forEach(([c,a])=>{const u=(0,T.getOrSet)(t,c,new Set);a.forEach(w=>u.add(w))});const s=[];return t.forEach((o,c)=>s.push([c,[...o.values()]])),{keys:[...r.values()],overrides:s}}e.mergeChanges=d;class g{constructor(r,t,s,o){this.change=r,this.f=t,this.g=s,this.h=o,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.j=void 0;for(const c of r.keys)this.affectedKeys.add(c);for(const[,c]of r.overrides)for(const a of c)this.affectedKeys.add(a);this.d=this.a;for(const c of this.affectedKeys)this.d+=c+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=l.parse(this.f.data)),this.j}affectsConfiguration(r,t){const s=this.a+r,o=this.d.indexOf(s);if(o<0)return!1;const c=o+s.length;if(c>=this.d.length)return!1;const a=this.d.charCodeAt(c);if(a!==this.b&&a!==this.c)return!1;if(t){const u=this.previousConfiguration?this.previousConfiguration.getValue(r,t,this.f?.workspace):void 0,w=this.g.getValue(r,t,this.h);return!R.equals(u,w)}return!0}}e.ConfigurationChangeEvent=g;function v(i,r){const{added:t,removed:s,updated:o}=I(r?.rawConfiguration,i?.rawConfiguration),c=[],a=i?.getAllOverrideIdentifiers()||[],u=r?.getAllOverrideIdentifiers()||[];if(r){const w=u.filter(E=>!a.includes(E));for(const E of w)c.push([E,r.getKeysForOverrideIdentifier(E)])}if(i){const w=a.filter(E=>!u.includes(E));for(const E of w)c.push([E,i.getKeysForOverrideIdentifier(E)])}if(r&&i){for(const w of a)if(u.includes(w)){const E=I({contents:i.getOverrideValue(void 0,w)||{},keys:i.getKeysForOverrideIdentifier(w)},{contents:r.getOverrideValue(void 0,w)||{},keys:r.getKeysForOverrideIdentifier(w)});c.push([w,[...E.added,...E.removed,...E.updated]])}}return{added:t,removed:s,updated:o,overrides:c}}function I(i,r){const t=i?r?i.keys.filter(c=>r.keys.indexOf(c)===-1):[...i.keys]:[],s=r?i?r.keys.filter(c=>i.keys.indexOf(c)===-1):[...r.keys]:[],o=[];if(i&&r){for(const c of r.keys)if(i.keys.indexOf(c)!==-1){const a=(0,C.getConfigurationValue)(r.contents,c),u=(0,C.getConfigurationValue)(i.contents,c);R.equals(a,u)||o.push(c)}}return{added:t,removed:s,updated:o}}}),define(re[215],ae([0,1,21,3,2,32,14,16,74,46,9,59,40]),function(_,e,A,n,D,k,T,R,P,S,C,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class p extends D.Disposable{constructor(){super(...arguments),this.a=this.B(new n.Emitter),this.onDidChangeConfiguration=this.a.event}get configurationModel(){return this.b||(this.b=new h(this.f())),this.b}async initialize(){return this.b=void 0,this.B(m.Registry.as(S.Extensions.Configuration).onDidUpdateConfiguration(({properties:d,defaultsOverrides:g})=>this.c(Array.from(d),g))),this.configurationModel}reload(){return this.b=void 0,this.configurationModel}c(d,g){this.b=void 0,this.a.fire({defaults:this.configurationModel,properties:d})}f(){return{}}}e.DefaultConfiguration=p;class h extends P.ConfigurationModel{constructor(d={}){const g=m.Registry.as(S.Extensions.Configuration).getConfigurationProperties(),v=Object.keys(g),I=Object.create(null),i=[];for(const r in g){const t=d[r],s=t!==void 0?t:g[r].default;(0,R.addToValueTree)(I,r,s,o=>console.error(`Conflict in default settings: ${o}`))}for(const r of Object.keys(I))S.OVERRIDE_PROPERTY_REGEX.test(r)&&i.push({identifiers:(0,S.overrideIdentifiersFromKey)(r),keys:Object.keys(I[r]),contents:(0,R.toValuesTree)(I[r],t=>console.error(`Conflict in default settings file: ${t}`))});super(I,v,i)}}e.DefaultConfigurationModel=h;class y{constructor(){this.onDidChangeConfiguration=n.Event.None,this.configurationModel=new P.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=y;let f=class extends D.Disposable{get configurationModel(){return this.b}constructor(d,g,v){super(),this.c=d,this.f=g,this.g=v,this.a=this.B(new n.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new P.ConfigurationModel}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(d=>this.i(d))),this.B(this.c.onDidChangeConfiguration(async({properties:d})=>this.j(await this.h(d),!0))),this.b}async h(d){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",d);const g={},v=[],I=m.Registry.as(S.Extensions.Configuration).getConfigurationProperties();for(const i of d){const r=I[i];if(!r){v.push(i);continue}if(r.policy){if(r.type!=="string"&&r.type!=="number"){this.g.warn(`Policy ${r.policy.name} has unsupported type ${r.type}`);continue}v.push(i),g[r.policy.name]={type:r.type}}}return(0,T.isEmptyObject)(g)||await this.f.updatePolicyDefinitions(g),v}i(d){this.g.trace("PolicyConfiguration#onDidChangePolicies",d);const g=m.Registry.as(S.Extensions.Configuration).getPolicyConfigurations(),v=(0,A.coalesce)(d.map(I=>g.get(I)));this.j(v,!0)}j(d,g){this.g.trace("PolicyConfiguration#update",d);const v=m.Registry.as(S.Extensions.Configuration).getConfigurationProperties(),I=[],i=this.b.isEmpty();for(const r of d){const t=v[r]?.policy?.name;if(t){const s=this.f.getPolicyValue(t);(i?s!==void 0:!(0,k.equals)(this.b.getValue(r),s))&&I.push([r,s])}else this.b.getValue(r)!==void 0&&I.push([r,void 0])}if(I.length){this.g.trace("PolicyConfiguration#changed",I);const r=this.b;this.b=new P.ConfigurationModel;for(const t of r.keys)this.b.setValue(t,r.getValue(t));for(const[t,s]of I)s===void 0?this.b.removeValue(t):this.b.setValue(t,s);g&&this.a.fire(this.b)}}};f=ye([Y(1,b.IPolicyService),Y(2,C.ILogService)],f),e.PolicyConfiguration=f}),define(re[216],ae([0,1,6,3,2,22,16,74,215,59]),function(_,e,A,n,D,k,T,R,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class C extends D.Disposable{constructor(m,p,h,y){super(),this.i=m,this.h=this.B(new n.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new P.DefaultConfiguration),this.c=h instanceof S.NullPolicyService?new P.NullPolicyConfiguration:this.B(new P.PolicyConfiguration(this.b,h,y)),this.f=this.B(new R.UserSettings(this.i,void 0,k.extUriBiasedIgnorePathCase,p)),this.a=new R.Configuration(this.b.configurationModel,this.c.configurationModel,new R.ConfigurationModel,new R.ConfigurationModel),this.g=this.B(new A.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:f,properties:l})=>this.k(f,l))),this.B(this.c.onDidChangeConfiguration(f=>this.l(f))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[m,p,h]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new R.Configuration(m,p,new R.ConfigurationModel,h)}getConfigurationData(){return this.a.toData()}getValue(m,p){const h=typeof m=="string"?m:void 0,y=(0,T.isConfigurationOverrides)(m)?m:(0,T.isConfigurationOverrides)(p)?p:{};return this.a.getValue(h,y,void 0)}updateValue(m,p,h,y){return Promise.reject(new Error("not supported"))}inspect(m){return this.a.inspect(m,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const m=await this.f.loadConfiguration();this.j(m)}j(m){const p=this.a.toData(),h=this.a.compareAndUpdateLocalUserConfiguration(m);this.m(h,p,2)}k(m,p){const h=this.a.toData(),y=this.a.compareAndUpdateDefaultConfiguration(m,p);this.m(y,h,7)}l(m){const p=this.a.toData(),h=this.a.compareAndUpdatePolicyConfiguration(m);this.m(h,p,7)}m(m,p,h){const y=new R.ConfigurationChangeEvent(m,{data:p},this.a);y.source=h,y.sourceConfig=this.n(h),this.h.fire(y)}n(m){switch(m){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=C}),define(re[217],ae([0,1,7,4]),function(_,e,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,n.createDecorator)("remoteAuthorityResolverService");var D;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound"})(D=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class k extends A.ErrorNoTelemetry{static isNotAvailable(P){return P instanceof k&&P._code===D.NotAvailable}static isTemporarilyNotAvailable(P){return P instanceof k&&P._code===D.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof k&&P._code===D.NoResolverFound}static isHandled(P){return P instanceof k&&P.isHandled}constructor(P,S=D.Unknown,C){super(P),this._message=P,this._code=S,this._detail=C,this.isHandled=S===D.NotAvailable&&C===!0,Object.setPrototypeOf(this,k.prototype)}}e.RemoteAuthorityResolverError=k;function T(R){const P=R.indexOf("+");return P===-1?R:R.substring(0,P)}e.getRemoteAuthorityPrefix=T}),define(re[75],ae([0,1,24]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function n(S){return S.scheme===A.Schemas.vscodeRemote?S.authority:void 0}e.getRemoteAuthority=n;function D(S){if(!S)return;const C=S.indexOf("+");return C<0?S:S.substr(0,C)}e.getRemoteName=D;function k(S){return`/${S.quality??"oss"}-${S.commit??"dev"}`}e.getRemoteServerRootPath=k;function T(S){const{host:C,port:b}=P(S);if(typeof b>"u")throw new Error("Remote authority doesn't contain a port!");return{host:C,port:b}}e.parseAuthorityWithPort=T;function R(S,C){let{host:b,port:m}=P(S);return typeof m>"u"&&(m=C),{host:b,port:m}}e.parseAuthorityWithOptionalPort=R;function P(S){const C=S.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(C)return{host:C[1],port:parseInt(C[2],10)};const b=S.match(/^(\[[0-9a-z:]+\])$/);if(b)return{host:b[1],port:void 0};const m=S.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:S,port:void 0}}}),define(re[42],ae([0,1,27,4,75]),function(_,e,A,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function k(h){if(typeof h=="object"&&h!==null&&h.supported!==!0)return h.description}e.getWorkspaceSupportTypeMessage=k;function T(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(h){h[h.System=0]="System",h[h.User=1]="User"})(R=e.ExtensionType||(e.ExtensionType={}));var P;(function(h){h.WIN32_X64="win32-x64",h.WIN32_IA32="win32-ia32",h.WIN32_ARM64="win32-arm64",h.LINUX_X64="linux-x64",h.LINUX_ARM64="linux-arm64",h.LINUX_ARMHF="linux-armhf",h.ALPINE_X64="alpine-x64",h.ALPINE_ARM64="alpine-arm64",h.DARWIN_X64="darwin-x64",h.DARWIN_ARM64="darwin-arm64",h.WEB="web",h.UNIVERSAL="universal",h.UNKNOWN="unknown",h.UNDEFINED="undefined"})(P=e.TargetPlatform||(e.TargetPlatform={}));class S{constructor(y){this.value=y,this.c=y.toLowerCase()}static equals(y,f){if(typeof y>"u"||y===null)return typeof f>"u"||f===null;if(typeof f>"u"||f===null)return!1;if(typeof y=="string"||typeof f=="string"){const l=typeof y=="string"?y:y.value,d=typeof f=="string"?f:f.value;return A.equalsIgnoreCase(l,d)}return y.c===f.c}static toKey(y){return typeof y=="string"?y.toLowerCase():y.c}}e.ExtensionIdentifier=S;function C(h){return b(h)}e.isApplicationScopedExtension=C;function b(h){return h.contributes&&h.contributes.localizations?h.contributes.localizations.length>0:!1}e.isLanguagePackExtension=b;function m(h){return h.contributes&&h.contributes.authentication?h.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=m;function p(h,y){if(y){const f=`onResolveRemoteAuthority:${(0,D.getRemoteName)(y)}`;return h.activationEvents?.indexOf(f)!==-1}return!1}e.isResolverExtension=p,e.IBuiltinExtensionsScannerService=(0,n.createDecorator)("IBuiltinExtensionsScannerService")}),define(re[218],ae([0,1,2,12,28,42]),function(_,e,A,n,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class T extends A.Disposable{constructor(P,S){super(),this.b=P,this.a=(0,n.join)(this.b.userDataPath,k.MANIFEST_CACHE_FOLDER,k.USER_MANIFEST_CACHE_FILE),this.B(S.onDidInstallExtensions(C=>this.c(C))),this.B(S.onDidUninstallExtension(C=>this.f(C)))}c(P){P.some(S=>!!S.local)&&this.invalidate()}f(P){P.error||this.invalidate()}invalidate(){D.Promises.rm(this.a,D.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=T}),define(re[219],ae([0,1,6,17,23,7,3,2,102,88,31,93,217,75]),function(_,e,A,n,D,k,T,R,P,S,C,b,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionHealthChangedEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const h=30*1e3;var y;(function(q){q[q.Management=1]="Management",q[q.ExtensionHost=2]="ExtensionHost",q[q.Tunnel=3]="Tunnel"})(y=e.ConnectionType||(e.ConnectionType={}));function f(q){switch(q){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function l(q){const B=new D.CancellationTokenSource;return setTimeout(()=>B.cancel(),q),B.token}function d(q,B){if(q.isCancellationRequested||B.isCancellationRequested)return D.CancellationToken.Cancelled;const x=new D.CancellationTokenSource;return q.onCancellationRequested(()=>x.cancel()),B.onCancellationRequested(()=>x.cancel()),x.token}class g{get didTimeout(){return this.c==="timedout"}constructor(B){this.c="pending",this.d=new R.DisposableStore,this.promise=new Promise((x,ee)=>{this.f=x,this.g=ee}),B.isCancellationRequested?this.h():this.d.add(B.onCancellationRequested(()=>this.h()))}registerDisposable(B){this.c==="pending"?this.d.add(B):B.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const B=new Error("Time limit reached");return B.code="ETIMEDOUT",B.syscall="connect",B}resolve(B){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(B))}reject(B){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(B))}}function v(q,B){const x=new g(B);return x.registerDisposable(q.onControlMessage(ee=>{const J=JSON.parse(ee.toString()),Z=X(J);Z?x.reject(Z):x.resolve(J)})),x.promise}function I(q,B,x,ee,J,Z,se,le,ue){const pe=new g(ue),we=S.StopWatch.create(!1);return q.info(`Creating a socket (${le})...`),P.mark(`code/willCreateSocket/${se}`),B.connect(x,ee,J,Z,le,(be,Ee)=>{pe.didTimeout?(P.mark(`code/didCreateSocketError/${se}`),q.info(`Creating a socket (${le}) finished after ${we.elapsed()} ms, but this is too late and has timed out already.`),be&&q.error(be),Ee?.dispose()):be||!Ee?(P.mark(`code/didCreateSocketError/${se}`),q.info(`Creating a socket (${le}) returned an error after ${we.elapsed()} ms.`),pe.reject(be)):(P.mark(`code/didCreateSocketOK/${se}`),q.info(`Creating a socket (${le}) was successful after ${we.elapsed()} ms.`),pe.resolve(Ee))}),pe.promise}function i(q,B){const x=new g(B);return q.then(ee=>{x.didTimeout||x.resolve(ee)},ee=>{x.didTimeout||x.reject(ee)}),x.promise}async function r(q,B,x,ee){const J=U(q,B);q.logService.trace(`${J} 1/6. invoking socketFactory.connect().`);let Z;try{Z=await I(q.logService,q.socketFactory,q.host,q.port,(0,p.getRemoteServerRootPath)(q),`reconnectionToken=${q.reconnectionToken}&reconnection=${q.reconnectionProtocol?"true":"false"}`,f(B),`renderer-${f(B)}-${q.reconnectionToken}`,ee)}catch(we){throw q.logService.error(`${J} socketFactory.connect() failed or timed out. Error:`),q.logService.error(we),we}q.logService.trace(`${J} 2/6. socketFactory.connect() was successful.`);let se,le;q.reconnectionProtocol?(q.reconnectionProtocol.beginAcceptReconnection(Z,null),se=q.reconnectionProtocol,le=!1):(se=new b.PersistentProtocol({socket:Z,measureRoundTripTime:!0}),le=!0),q.logService.trace(`${J} 3/6. sending AuthRequest control message.`);const ue=await i(q.signService.createNewMessage((0,C.generateUuid)()),ee),pe={type:"auth",auth:q.connectionToken||"00000000000000000000",data:ue.data};se.sendControl(n.VSBuffer.fromString(JSON.stringify(pe)));try{const we=await v(se,d(ee,l(1e4)));if(we.type!=="sign"||typeof we.data!="string"){const Ue=new Error("Unexpected handshake message");throw Ue.code="VSCODE_CONNECTION_ERROR",Ue}if(q.logService.trace(`${J} 4/6. received SignRequest control message.`),!await i(q.signService.validate(ue,we.signedData),ee)){const Ue=new Error("Refused to connect to unsupported server");throw Ue.code="VSCODE_CONNECTION_ERROR",Ue}const Ee=await i(q.signService.sign(we.data),ee),Te={type:"connectionType",commit:q.commit,signedData:Ee,desiredConnectionType:B};return x&&(Te.args=x),q.logService.trace(`${J} 5/6. sending ConnectionTypeRequest control message.`),se.sendControl(n.VSBuffer.fromString(JSON.stringify(Te))),{protocol:se,ownsProtocol:le}}catch(we){throw we&&we.code==="ETIMEDOUT"&&(q.logService.error(`${J} the handshake timed out. Error:`),q.logService.error(we)),we&&we.code==="VSCODE_CONNECTION_ERROR"&&(q.logService.error(`${J} received error control message when negotiating connection. Error:`),q.logService.error(we)),le&&G(se),we}}async function t(q,B,x,ee){const J=Date.now(),Z=U(q,B),{protocol:se,ownsProtocol:le}=await r(q,B,x,ee),ue=new g(ee);return ue.registerDisposable(se.onControlMessage(pe=>{const we=JSON.parse(pe.toString()),be=X(we);be?(q.logService.error(`${Z} received error control message when negotiating connection. Error:`),q.logService.error(be),le&&G(se),ue.reject(be)):(q.reconnectionProtocol?.endAcceptReconnection(),q.logService.trace(`${Z} 6/6. handshake finished, connection is up and running after ${$(J)}!`),ue.resolve({protocol:se,firstMessage:we}))})),ue.promise}async function s(q,B){const{protocol:x}=await t(q,1,void 0,B);return{protocol:x}}async function o(q,B,x){const{protocol:ee,firstMessage:J}=await t(q,2,B,x),Z=J&&J.debugPort;return{protocol:ee,debugPort:Z}}async function c(q,B,x){const ee=Date.now(),J=U(q,3),{protocol:Z}=await r(q,3,B,x);return q.logService.trace(`${J} 6/6. handshake finished, connection is up and running after ${$(ee)}!`),Z}async function a(q,B,x){const{host:ee,port:J,connectionToken:Z}=await q.addressProvider.getAddress();return{commit:q.commit,quality:q.quality,host:ee,port:J,connectionToken:Z,reconnectionToken:B,reconnectionProtocol:x,socketFactory:q.socketFactory,signService:q.signService,logService:q.logService}}async function u(q,B,x){return E(q,async ee=>{const{protocol:J}=await s(ee,D.CancellationToken.None);return new V(q,B,x,ee.reconnectionToken,J)})}e.connectRemoteAgentManagement=u;async function w(q,B){return E(q,async x=>{const{protocol:ee,debugPort:J}=await o(x,B,D.CancellationToken.None);return new W(q,B,x.reconnectionToken,ee,J)})}e.connectRemoteAgentExtensionHost=w;async function E(q,B){for(let ee=1;;ee++)try{const J=(0,C.generateUuid)(),Z=await a(q,J,null);return await B(Z)}catch(J){if(ee<5)q.logService.error(`[remote-connection][attempt ${ee}] An error occurred in initial connection! Will retry... Error:`),q.logService.error(J);else throw q.logService.error(`[remote-connection][attempt ${ee}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),q.logService.error(J),K.triggerPermanentFailure(0,0,m.RemoteAuthorityResolverError.isHandled(J)),J}}async function N(q,B,x){const ee=await a(q,(0,C.generateUuid)(),null);return await c(ee,{host:B,port:x},D.CancellationToken.None)}e.connectRemoteAgentTunnel=N;function O(q){return(0,A.createCancelablePromise)(B=>new Promise((x,ee)=>{const J=setTimeout(x,q*1e3);B.onCancellationRequested(()=>{clearTimeout(J),x()})}))}var j;(function(q){q[q.ConnectionLost=0]="ConnectionLost",q[q.ReconnectionWait=1]="ReconnectionWait",q[q.ReconnectionRunning=2]="ReconnectionRunning",q[q.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",q[q.ConnectionGain=4]="ConnectionGain",q[q.ConnectionHealthChanged=5]="ConnectionHealthChanged"})(j=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class M{constructor(B,x){this.reconnectionToken=B,this.millisSinceLastIncomingData=x,this.type=0}}e.ConnectionLostEvent=M;class L{constructor(B,x,ee,J){this.reconnectionToken=B,this.millisSinceLastIncomingData=x,this.durationSeconds=ee,this.c=J,this.type=1}skipWait(){this.c.cancel()}}e.ReconnectionWaitEvent=L;class F{constructor(B,x,ee){this.reconnectionToken=B,this.millisSinceLastIncomingData=x,this.attempt=ee,this.type=2}}e.ReconnectionRunningEvent=F;class z{constructor(B,x,ee){this.reconnectionToken=B,this.millisSinceLastIncomingData=x,this.attempt=ee,this.type=4}}e.ConnectionGainEvent=z;class H{constructor(B,x){this.reconnectionToken=B,this.connectionHealth=x,this.type=5}}e.ConnectionHealthChangedEvent=H;class Q{constructor(B,x,ee,J){this.reconnectionToken=B,this.millisSinceLastIncomingData=x,this.attempt=ee,this.handled=J,this.type=3}}e.ReconnectionPermanentFailureEvent=Q;class K extends R.Disposable{static triggerPermanentFailure(B,x,ee){this._permanentFailure=!0,this.f=B,this.g=x,this.h=ee,this.i.forEach(J=>J.u(this.f,this.g,this.h))}static debugTriggerReconnection(){this.i.forEach(B=>B.r())}static debugPauseSocketWriting(){this.i.forEach(B=>B.v())}get k(){return this.c||K._permanentFailure}constructor(B,x,ee,J,Z){super(),this.m=B,this.n=x,this.reconnectionToken=ee,this.protocol=J,this.p=Z,this.j=this.B(new T.Emitter),this.onDidStateChange=this.j.event,this.c=!1,this.l=!1,this.j.fire(new z(this.reconnectionToken,0,0)),this.B(J.onSocketClose(se=>{const le=te(this.m,this.reconnectionToken,!0);se?se.type===0?(this.n.logService.info(`${le} received socket close event (hadError: ${se.hadError}).`),se.error&&this.n.logService.error(se.error)):(this.n.logService.info(`${le} received socket close event (wasClean: ${se.wasClean}, code: ${se.code}, reason: ${se.reason}).`),se.event&&this.n.logService.error(se.event)):this.n.logService.info(`${le} received socket close event.`),this.r()})),this.B(J.onSocketTimeout(se=>{const le=te(this.m,this.reconnectionToken,!0);this.n.logService.info(`${le} received socket timeout event (unacknowledgedMsgCount: ${se.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${se.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${se.timeSinceLastReceivedSomeData}).`),this.r()})),this.B(J.onHighRoundTripTime(se=>{const le=oe(this.m,this.reconnectionToken);this.n.logService.info(`${le} high roundtrip time: ${se.roundTripTime}ms (${se.recentHighRoundTripCount} of ${5} recent samples)`)})),this.B(J.onDidChangeConnectionHealth(se=>{this.j.fire(new H(this.reconnectionToken,se))})),K.i.push(this),this.B((0,R.toDisposable)(()=>{const se=K.i.indexOf(this);se>=0&&K.i.splice(se,1)})),this.k&&this.u(K.f,K.g,K.h)}async r(){if(!this.l)try{this.l=!0,await this.s()}finally{this.l=!1}}async s(){if(this.k)return;const B=te(this.m,this.reconnectionToken,!0);this.n.logService.info(`${B} starting reconnecting loop. You can get more information with the trace log level.`),this.j.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const x=[0,5,5,10,10,10,10,10,30];let ee=-1;do{ee++;const J=ee<x.length?x[ee]:x[x.length-1];try{if(J>0){const se=O(J);this.j.fire(new L(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),J,se)),this.n.logService.info(`${B} waiting for ${J} seconds before reconnecting...`);try{await se}catch{}}if(this.k){this.n.logService.error(`${B} permanent failure occurred while running the reconnecting loop.`);break}this.j.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ee+1)),this.n.logService.info(`${B} resolving connection...`);const Z=await a(this.n,this.reconnectionToken,this.protocol);this.n.logService.info(`${B} connecting to ${Z.host}:${Z.port}...`),await this.w(Z,l(h)),this.n.logService.info(`${B} reconnected!`),this.j.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ee+1));break}catch(Z){if(Z.code==="VSCODE_CONNECTION_ERROR"){this.n.logService.error(`${B} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.n.logService.error(Z),this.t(this.protocol.getMillisSinceLastIncomingData(),ee+1,!1);break}if(ee>360){this.n.logService.error(`${B} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.n.logService.error(Z),this.t(this.protocol.getMillisSinceLastIncomingData(),ee+1,!1);break}if(m.RemoteAuthorityResolverError.isTemporarilyNotAvailable(Z)){this.n.logService.info(`${B} A temporarily not available error occurred while trying to reconnect, will try again...`),this.n.logService.trace(Z);continue}if((Z.code==="ETIMEDOUT"||Z.code==="ENETUNREACH"||Z.code==="ECONNREFUSED"||Z.code==="ECONNRESET")&&Z.syscall==="connect"){this.n.logService.info(`${B} A network error occurred while trying to reconnect, will try again...`),this.n.logService.trace(Z);continue}if((0,k.isCancellationError)(Z)){this.n.logService.info(`${B} A promise cancelation error occurred while trying to reconnect, will try again...`),this.n.logService.trace(Z);continue}if(Z instanceof m.RemoteAuthorityResolverError){this.n.logService.error(`${B} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.n.logService.error(Z),this.t(this.protocol.getMillisSinceLastIncomingData(),ee+1,m.RemoteAuthorityResolverError.isHandled(Z));break}this.n.logService.error(`${B} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.n.logService.error(Z),this.t(this.protocol.getMillisSinceLastIncomingData(),ee+1,!1);break}}while(!this.k)}t(B,x,ee){this.p?K.triggerPermanentFailure(B,x,ee):this.u(B,x,ee)}u(B,x,ee){this.j.fire(new Q(this.reconnectionToken,B,x,ee)),G(this.protocol)}v(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=K,K._permanentFailure=!1,K.f=0,K.g=0,K.h=!1,K.i=[];class V extends K{constructor(B,x,ee,J,Z){super(1,B,J,Z,!0),this.client=this.B(new b.Client(Z,{remoteAuthority:x,clientId:ee},B.ipcLogger))}async w(B,x){await s(B,x)}}e.ManagementPersistentConnection=V;class W extends K{constructor(B,x,ee,J,Z){super(2,B,ee,J,!1),this.y=x,this.debugPort=Z}async w(B,x){await o(B,this.y,x)}}e.ExtensionHostPersistentConnection=W;function G(q){try{q.acceptDisconnect();const B=q.getSocket();q.dispose(),B.dispose()}catch(B){(0,k.onUnexpectedError)(B)}}function X(q){if(q&&q.type==="error"){const B=new Error(`Connection error: ${q.reason}`);return B.code="VSCODE_CONNECTION_ERROR",B}return null}function ie(q,B){for(;q.length<B;)q+=" ";return q}function oe(q,B){return`[remote-connection][${ie(f(q),13)}][${B.substr(0,5)}\u2026]`}function te(q,B,x){return`${oe(q,B)}[${x?"reconnect":"initial"}]`}function U(q,B){return`${te(B,q.reconnectionToken,!!q.reconnectionProtocol)}[${q.host}:${q.port}]`}function $(q){return`${Date.now()-q} ms`}}),define(re[220],ae([0,1,4]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,A.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(re[221],ae([0,1,86,151]),function(_,e,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(D,k,T,R,P,S){const C=m=>S(m,void 0),b=A.createConnection({host:D,port:k},()=>{b.removeListener("error",C);const m=Buffer.alloc(16);for(let f=0;f<16;f++)m[f]=Math.round(Math.random()*256);const p=m.toString("base64"),h=[`GET ws://${/:/.test(D)?`[${D}]`:D}:${k}${T}?${R}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${p}`];b.write(h.join(`\r
`)+`\r
\r
`);const y=f=>{f.toString().indexOf(`\r
\r
`)>=0&&(b.off("data",y),S(void 0,new n.NodeSocket(b,P)))};b.on("data",y)});b.setNoDelay(!0),b.once("error",C)}}}),define(re[107],ae([0,1,4]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LOG_CHANNEL_ID=e.LOGGER_NAME=e.LOG_FILE_NAME=e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX=e.TunnelStates=e.IRemoteTunnelService=void 0,e.IRemoteTunnelService=(0,A.createDecorator)("IRemoteTunnelService");var n;(function(D){D.disconnected={type:"disconnected"},D.uninitialized={type:"uninitialized"},D.connected=k=>({type:"connected",info:k}),D.connecting=k=>({type:"connecting",progress:k})})(n=e.TunnelStates||(e.TunnelStates={})),e.CONFIGURATION_KEY_PREFIX="remote.tunnels.access",e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX+".hostNameOverride",e.LOG_FILE_NAME="remoteTunnelService.log",e.LOGGER_NAME="remoteTunnelService",e.LOG_CHANNEL_ID="remoteTunnelServiceLog"}),define(re[222],ae([0,1,135,16,9]),function(_,e,A,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let k=class{constructor(R,P){this.a=R,this.b=P}async request(R,P){this.b.trace("RequestService#request (browser) - begin",R.url),R.proxyAuthorization||(R.proxyAuthorization=this.a.getValue("http.proxyAuthorization"));try{const S=await(0,A.request)(R,P);return this.b.trace("RequestService#request (browser) - success",R.url),S}catch(S){throw this.b.error("RequestService#request (browser) - error",R.url,S),S}}async resolveProxy(R){}};k=ye([Y(0,n.IConfigurationService),Y(1,D.ILogService)],k),e.RequestService=k}),define(re[60],ae([0,1,17,170,46,4,40]),function(_,e,A,n,D,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,k.createDecorator)("requestService");function R(y){return y.res.statusCode&&y.res.statusCode>=200&&y.res.statusCode<300||y.res.statusCode===1223}e.isSuccess=R;function P(y){return y.res.statusCode===204}async function S(y){return P(y)?null:(await(0,A.streamToBuffer)(y.stream)).toString()}e.asText=S;async function C(y){if(!R(y))throw new Error("Server returned "+y.res.statusCode);return S(y)}e.asTextOrError=C;async function b(y){if(!R(y))throw new Error("Server returned "+y.res.statusCode);if(P(y))return null;const l=(await(0,A.streamToBuffer)(y.stream)).toString();try{return JSON.parse(l)}catch(d){throw d.message+=`:
`+l,d}}e.asJson=b;function m(y){h(y)}e.updateProxyConfigurationsScope=m;let p;function h(y){const f=T.Registry.as(D.Extensions.Configuration),l=p;p={id:"http",order:15,title:(0,n.localize)(0,null),type:"object",scope:y,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,n.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,n.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,n.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,n.localize)(4,null),(0,n.localize)(5,null),(0,n.localize)(6,null),(0,n.localize)(7,null)],default:"override",description:(0,n.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,n.localize)(9,null),restricted:!0}}},f.updateConfigurations({add:[p],remove:l?[l]:[]})}h(2)}),define(re[223],ae([0,1,23,24,13,60]),function(_,e,A,n,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let T=class{constructor(P,S){this.a=P,this.b=S}async download(P,S,C=A.CancellationToken.None){if(P.scheme===n.Schemas.file||P.scheme===n.Schemas.vscodeRemote){await this.b.copy(P,S);return}const b={type:"GET",url:P.toString(!0)},m=await this.a.request(b,C);if(m.res.statusCode===200)await this.b.writeFile(S,m.stream);else{const p=await(0,k.asTextOrError)(m);throw new Error(`Expected 200, got back ${m.res.statusCode} instead.

${p}`)}}};T=ye([Y(0,k.IRequestService),Y(1,D.IFileService)],T),e.DownloadService=T}),define(re[224],ae([0,1,17,23]),function(_,e,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class D{constructor(R){this.a=R}listen(R,P){throw new Error("Invalid listen")}call(R,P,S,C=n.CancellationToken.None){switch(P){case"request":return this.a.request(S[0],C).then(async({res:b,stream:m})=>{const p=await(0,A.streamToBuffer)(m);return[{statusCode:b.statusCode,headers:b.headers},p]});case"resolveProxy":return this.a.resolveProxy(S[0])}throw new Error("Invalid call")}}e.RequestChannel=D;class k{constructor(R){this.a=R}async request(R,P){const[S,C]=await this.a.call("request",[R],P);return{res:S,stream:(0,A.bufferToStream)(C)}}async resolveProxy(R){return this.a.call("resolveProxy",[R])}}e.RequestChannelClient=k}),define(re[225],ae([0,1,14,222,224]),function(_,e,A,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessRequestService=void 0;class k{constructor(R,P,S,C){this.c=P,this.d=S,this.e=C,this.a=new n.RequestService(P,C),this.b=new D.RequestChannelClient(R.getChannel("request"))}request(R,P){return this.f().request(R,P)}async resolveProxy(R){return this.f().resolveProxy(R)}f(){return this.g()?(this.e.trace("Using main request service"),this.b):(this.e.trace("Using browser request service"),this.a)}g(){const R=this.c.getValue("developer.sharedProcess.redirectRequestsToMain");return(0,A.isBoolean)(R)?R:this.d.quality!=="stable"}}e.SharedProcessRequestService=k}),define(re[108],ae([0,1,66,4]),function(_,e,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function D(k){return(0,A.hash)({moduleId:k.process.moduleId,windowId:k.reply.windowId})}e.hash=D,e.ISharedProcessWorkerService=(0,n.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(re[226],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var A;(function(n){n.Spawn="vscode:shared-process->shared-process-worker=spawn",n.Terminate="vscode:shared-process->shared-process-worker=terminate",n.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",n.Ready="vscode:shared-process-worker->shared-process=ready",n.Ack="vscode:shared-process-worker->shared-process=ack",n.Trace="vscode:shared-process-worker->shared-process=trace",n.Info="vscode:shared-process-worker->shared-process=info",n.Warn="vscode:shared-process-worker->shared-process=warn",n.Error="vscode:shared-process-worker->shared-process=error"})(A=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(re[227],ae([0,1,94,6,23,3,2,24,31,9,108,226]),function(_,e,A,n,D,k,T,R,P,S,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let m=class{constructor(y){this.d=y,this.a=new Map,this.b=new Map,this.c=new Map}async createWorker(y){const f=`window: ${y.reply.windowId}, moduleId: ${y.process.moduleId}`;this.d.trace(`SharedProcess: createWorker (${f})`);const l=(0,C.hash)(y);this.b.has(l)&&(this.d.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${f})`),this.f(y));const d=new D.CancellationTokenSource;let g,v,I;this.b.set(l,s=>{d.dispose(!0),g?.terminate(y,D.CancellationToken.None),v?.close(),I?.close(),this.b.delete(l);const o=this.c.get(l);o&&(this.c.delete(l),o({reason:s}))}),g=await this.e(y);const i=new Promise(s=>{this.c.set(l,s)});if(d.token.isCancellationRequested)return i;const{port1:r,port2:t}=new MessageChannel;return v=r,I=t,await g.spawn(y,I,d.token),d.token.isCancellationRequested||(this.d.trace(`SharedProcess: createWorker sending message port back to window (${f})`),A.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",y,[v])),i}e(y){let f=this.a.get(y.process.moduleId);if(!f){this.d.trace(`SharedProcess: creating new web worker (${y.process.moduleId})`);const l=new p(y.process.type,this.d);f=l.init(),l.onDidProcessSelfTerminate(({configuration:d,reason:g})=>{this.f(d,g)}),this.a.set(y.process.moduleId,f)}return f}async disposeWorker(y){return this.f(y)}f(y,f){const l=this.b.get((0,C.hash)(y));l&&(this.d.trace(`SharedProcess: disposeWorker (window: ${y.reply.windowId}, moduleId: ${y.process.moduleId})`),l(f))}};m=ye([Y(0,S.ILogService)],m),e.SharedProcessWorkerService=m;class p extends T.Disposable{constructor(y,f){super(),this.f=y,this.g=f,this.a=this.B(new k.Emitter),this.onDidProcessSelfTerminate=this.a.event,this.b=this.h(),this.c=new Map}async init(){return await this.b,this}h(){const y=new n.DeferredPromise,f=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.f})`});return f.onerror=l=>{this.g.error(`SharedProcess: worker error (${this.f})`,l.message)},f.onmessageerror=l=>{this.g.error(`SharedProcess: worker message error (${this.f})`,l)},f.onmessage=l=>{const{id:d,message:g,configuration:v,nonce:I}=l.data;switch(d){case b.SharedProcessWorkerMessages.Ready:y.complete(f);break;case b.SharedProcessWorkerMessages.Ack:if(I){const i=this.c.get(I);i&&(this.c.delete(I),i())}break;case b.SharedProcessWorkerMessages.SelfTerminated:v&&g&&this.a.fire({configuration:v,reason:JSON.parse(g)});break;case b.SharedProcessWorkerMessages.Trace:this.g.trace(`SharedProcess (worker, ${this.f}):`,g);break;case b.SharedProcessWorkerMessages.Info:g&&this.g.info(g);break;case b.SharedProcessWorkerMessages.Warn:this.g.warn(`SharedProcess (worker, ${this.f}):`,g);break;case b.SharedProcessWorkerMessages.Error:this.g.error(`SharedProcess (worker, ${this.f}):`,g);break;default:this.g.warn(`SharedProcess: unexpected worker message (${this.f})`,l)}},f.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),y.p}async i(y,f,l){const d=await this.b;if(!f.isCancellationRequested)return new Promise(g=>{const v=(0,P.generateUuid)();this.c.set(v,g);const I={...y,nonce:v};l?d.postMessage(I,[l]):d.postMessage(I),f.onCancellationRequested(()=>{this.c.delete(v)&&g()})})}spawn(y,f,l){const d={id:b.SharedProcessWorkerMessages.Spawn,configuration:y,environment:{bootstrapPath:R.FileAccess.asFileUri("bootstrap-fork").fsPath}};return this.i(d,l,f)}terminate(y,f){const l={id:b.SharedProcessWorkerMessages.Terminate,configuration:y};return this.i(l,f)}}}),define(re[228],ae([0,1,63,24,187]),function(_,e,A,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class k extends D.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:n.Schemas.vscodeUserData})}}ye([A.memoize],k.prototype,"userRoamingDataHome",null),e.SharedProcessEnvironmentService=k}),define(re[229],ae([0,1,50,12,171,23,38,7,5,31,148,185,6,130]),function(_,e,A,n,D,k,T,R,P,S,C,b,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let h;async function y(l,d,g,v){return g["force-disable-user-env"]?(d.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):P.isWindows?(d.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,b.isLaunchedFromCli)(v)&&!g["force-user-env"]?(d.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,b.isLaunchedFromCli)(v)?d.trace("resolveShellEnv(): running (--force-user-env)"):d.trace("resolveShellEnv(): running (macOS/Linux)"),h||(h=m.Promises.withAsyncBody(async(I,i)=>{const r=new k.CancellationTokenSource;let t=1e4;const s=l.getValue("application.shellEnvironmentResolutionTimeout");typeof s=="number"&&(t=(0,p.clamp)(s,1,120)*1e3);const o=setTimeout(()=>{r.dispose(!0),i(new Error((0,D.localize)(0,null)))},t);try{I(await f(d,r.token))}catch(c){!(0,R.isCancellationError)(c)&&!r.token.isCancellationRequested?i(new Error((0,D.localize)(1,null,(0,T.toErrorMessage)(c)))):I({})}finally{clearTimeout(o),r.dispose()}})),h)}e.getResolvedShellEnv=y;async function f(l,d){const g=process.env.ELECTRON_RUN_AS_NODE;l.trace("getUnixShellEnvironment#runAsNode",g);const v=process.env.ELECTRON_NO_ATTACH_CONSOLE;l.trace("getUnixShellEnvironment#noAttach",v);const I=(0,S.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(I+"({.*})"+I),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};l.trace("getUnixShellEnvironment#env",r);const t=await(0,C.getSystemShell)(P.OS,r);return l.trace("getUnixShellEnvironment#shell",t),new Promise((s,o)=>{if(d.isCancellationRequested)return o(new R.CancellationError);const c=(0,n.basename)(t);let a,u;const w=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(c)?(a=`& '${process.execPath}' ${w} -p '''${I}'' + JSON.stringify(process.env) + ''${I}'''`,u=["-Login","-Command"]):(a=`'${process.execPath}' ${w} -p '"${I}" + JSON.stringify(process.env) + "${I}"'`,c==="tcsh"||c==="csh"?u=["-ic"]:u=["-i","-l","-c"]),l.trace("getUnixShellEnvironment#spawn",JSON.stringify(u),a);const E=(0,A.spawn)(t,[...u,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});d.onCancellationRequested(()=>(E.kill(),o(new R.CancellationError))),E.on("error",j=>{l.error("getUnixShellEnvironment#errorChildProcess",(0,T.toErrorMessage)(j)),o(j)});const N=[];E.stdout.on("data",j=>N.push(j));const O=[];E.stderr.on("data",j=>O.push(j)),E.on("close",(j,M)=>{const L=Buffer.concat(N).toString("utf8");l.trace("getUnixShellEnvironment#raw",L);const F=Buffer.concat(O).toString("utf8");if(F.trim()&&l.trace("getUnixShellEnvironment#stderr",F),j||M)return o(new Error((0,D.localize)(2,null,j,M)));const z=i.exec(L),H=z?z[1]:"{}";try{const Q=JSON.parse(H);g?Q.ELECTRON_RUN_AS_NODE=g:delete Q.ELECTRON_RUN_AS_NODE,v?Q.ELECTRON_NO_ATTACH_CONSOLE=v:delete Q.ELECTRON_NO_ATTACH_CONSOLE,delete Q.VSCODE_RESOLVING_ENVIRONMENT,delete Q.XDG_RUNTIME_DIR,l.trace("getUnixShellEnvironment#result",Q),s(Q)}catch(Q){l.error("getUnixShellEnvironment#errorCaught",(0,T.toErrorMessage)(Q)),o(Q)}})})}}),define(re[109],ae([0,1,4]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,A.createDecorator)(e.SIGN_SERVICE_ID)}),define(re[230],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class A{constructor(){this.b=new Map}c(){return new Promise((D,k)=>_(["vsda"],D,k))}async createNewMessage(D){try{const k=await this.c(),T=new k.validator;if(T){const R=String(A.a++);return this.b.set(R,T),{id:R,data:T.createNewMessage(D)}}}catch{}return{id:"",data:D}}async validate(D,k){if(!D.id)return!0;const T=this.b.get(D.id);if(!T)return!1;this.b.delete(D.id);try{return T.validate(k)==="ok"}catch{return!1}}async sign(D){try{const k=await this.c(),T=new k.signer;if(T)return T.sign(D)}catch{}return D}}e.SignService=A,A.a=1}),define(re[76],ae([0,1,3,2]),function(_,e,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageClient=e.WorkspaceStorageDatabaseClient=e.ProfileStorageDatabaseClient=e.ApplicationStorageDatabaseClient=void 0;class D extends n.Disposable{constructor(b,m,p){super(),this.a=b,this.b=m,this.c=p}async getItems(){const b={profile:this.b,workspace:this.c},m=await this.a.call("getItems",b);return new Map(m)}updateItems(b){const m={profile:this.b,workspace:this.c};return b.insert&&(m.insert=Array.from(b.insert.entries())),b.delete&&(m.delete=Array.from(b.delete.values())),this.a.call("updateItems",m)}}class k extends D{constructor(b,m){super(b,m,void 0),this.f=this.B(new A.Emitter),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(b=>this.h(b)))}h(b){(Array.isArray(b.changed)||Array.isArray(b.deleted))&&this.f.fire({changed:b.changed?new Map(b.changed):void 0,deleted:b.deleted?new Set(b.deleted):void 0})}}class T extends k{constructor(b){super(b,void 0)}async close(){this.dispose()}}e.ApplicationStorageDatabaseClient=T;class R extends k{constructor(b,m){super(b,m)}async close(){this.dispose()}}e.ProfileStorageDatabaseClient=R;class P extends D{constructor(b,m){super(b,void 0,m),this.onDidChangeItemsExternal=A.Event.None}async close(){this.dispose()}}e.WorkspaceStorageDatabaseClient=P;class S{constructor(b){this.a=b}isUsed(b){const m={payload:b,profile:void 0,workspace:void 0};return this.a.call("isUsed",m)}}e.StorageClient=S}),define(re[110],ae([0,1,5,36,8,31]),function(_,e,A,n,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function T(S){if(A.platform===2&&/^penguin(\.|$)/i.test(S))return"chromebook"}async function R(S,C,b,m,p,h,y,f,l,d){const g=Object.create(null);g["common.machineId"]=y,g.sessionID=(0,k.generateUuid)()+Date.now(),g.commitHash=p,g.version=h,g["common.platformVersion"]=(C||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),g["common.platform"]=(0,A.PlatformToString)(A.platform),g["common.nodePlatform"]=n.platform,g["common.nodeArch"]=m,g["common.product"]=d||"desktop",f&&(g["common.msftInternal"]=f);let v=0;const I=Date.now();Object.defineProperties(g,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-I,enumerable:!0},"common.sequence":{get:()=>v++,enumerable:!0}}),A.isLinuxSnap&&(g["common.snap"]="true");const i=T(b);i&&(g["common.platformDetail"]=i);try{const r=await S.readFile(D.URI.file(l));g["common.source"]=r.value.toString().slice(0,30)}catch{}return g}e.resolveCommonProperties=R;function P(S){const C=n.env.USERDNSDOMAIN;if(!C)return!1;const b=C.toLowerCase();return S.some(m=>b===m)}e.verifyMicrosoftInternalDomain=P}),define(re[19],ae([0,1,4]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,A.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,A.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var n;(function(k){k[k.NONE=0]="NONE",k[k.CRASH=1]="CRASH",k[k.ERROR=2]="ERROR",k[k.USAGE=3]="USAGE"})(n=e.TelemetryLevel||(e.TelemetryLevel={}));var D;(function(k){k.OFF="off",k.CRASH="crash",k.ERROR="error",k.ON="all"})(D=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(re[231],ae([0,1,34,6,35,24,12,5,8,145,28,147,96,13,25,19]),function(_,e,A,n,D,k,T,R,P,S,C,b,m,p,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const f=new Map;async function l(i,r){const t=`${i}::${r.join(":")}`,s=f.get(t);if(s)return s;const o=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],c=new Map,a=new Map,u=2e4;function w(N,O,j,M){const L=O.substring(N.length+1);return n.Promises.withAsyncBody(async F=>{let z;try{z=await C.Promises.readdir(O,{withFileTypes:!0})}catch{F();return}if(M.count>=u){M.count+=z.length,M.maxReached=!0,F();return}let H=z.length;if(H===0){F();return}let Q=z;M.count+z.length>u&&(M.maxReached=!0,H=u-M.count,Q=z.slice(0,H)),M.count+=z.length;for(const K of Q)if(K.isDirectory()){if(j.includes(K.name)||await w(N,(0,T.join)(O,K.name),j,M),--H===0){F();return}}else{const V=K.name.lastIndexOf(".");if(V>=0){const W=K.name.substring(V+1);W&&c.set(W,(c.get(W)??0)+1)}for(const W of o)W.relativePathPattern?.test(L)!==!1&&W.filePattern.test(K.name)&&a.set(W.tag,(a.get(W.tag)??0)+1);if(--H===0){F();return}}})}const E=n.Promises.withAsyncBody(async N=>{const O={count:0,maxReached:!1};await w(i,i,r,O);const j=await v(i);N({configFiles:d(a),fileTypes:d(c),fileCount:O.count,maxFilesReached:O.maxReached,launchConfigFiles:j})});return f.set(t,E),E}e.collectWorkspaceStats=l;function d(i){return Array.from(i.entries(),([r,t])=>({name:r,count:t})).sort((r,t)=>t.count-r.count)}function g(){const i={os:`${A.type()} ${A.arch()} ${A.release()}`,memory:`${(A.totalmem()/p.ByteSize.GB).toFixed(2)}GB (${(A.freemem()/p.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(S.virtualMachineHint.value()*100)}%`},r=A.cpus();return r&&r.length>0&&(i.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),i}e.getMachineInfo=g;async function v(i){try{const r=new Map,t=(0,T.join)(i,".vscode","launch.json"),s=await C.Promises.readFile(t),o=[],c=(0,D.parse)(s.toString(),o);if(o.length)return console.log(`Unable to parse ${t}`),[];if((0,D.getNodeType)(c)==="object"&&c.configurations)for(const a of c.configurations){const u=a.type;u&&(r.has(u)?r.set(u,r.get(u)+1):r.set(u,1))}return d(r)}catch{return[]}}e.collectLaunchConfigs=v;let I=class{constructor(r,t){this.c=r,this.d=t}f(r){const t=[];return t.push(`OS Version:       ${r.os}`),t.push(`CPUs:             ${r.cpus}`),t.push(`Memory (System):  ${r.memory}`),t.push(`VM:               ${r.vmHint}`),t.join(`
`)}g(r){const t=[];t.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),t.push(`OS Version:       ${A.type()} ${A.arch()} ${A.release()}`);const s=A.cpus();return s&&s.length>0&&t.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),t.push(`Memory (System):  ${(A.totalmem()/p.ByteSize.GB).toFixed(2)}GB (${(A.freemem()/p.ByteSize.GB).toFixed(2)}GB free)`),R.isWindows||t.push(`Load (avg):       ${A.loadavg().map(o=>Math.round(o)).join(", ")}`),t.push(`VM:               ${Math.round(S.virtualMachineHint.value()*100)}%`),t.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),t.push(`Process Argv:     ${r.mainArguments.join(" ")}`),t.push(`GPU Status:       ${this.j(r.gpuFeatureStatus)}`),t.join(`
`)}async getPerformanceInfo(r,t){return Promise.all([(0,b.listProcesses)(r.mainPID),this.k(r)]).then(async s=>{let[o,c]=s,a=this.m(r,o);return t.forEach(u=>{if((0,m.isRemoteDiagnosticError)(u))a+=`
${u.errorMessage}`,c+=`
${u.errorMessage}`;else if(a+=`

Remote: ${u.hostName}`,u.processes&&(a+=`
${this.m(r,u.processes)}`),u.workspaceMetadata){c+=`
|  Remote: ${u.hostName}`;for(const w of Object.keys(u.workspaceMetadata)){const E=u.workspaceMetadata[w];let N=`${E.fileCount} files`;E.maxFilesReached&&(N=`more than ${N}`),c+=`|    Folder (${w}): ${N}`,c+=this.h(E)}}}),{processInfo:a,workspaceInfo:c}})}async getSystemInfo(r,t){const{memory:s,vmHint:o,os:c,cpus:a}=g(),u={os:c,memory:s,cpus:a,vmHint:o,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:t};return R.isWindows||(u.load=`${A.loadavg().map(w=>Math.round(w)).join(", ")}`),R.isLinux&&(u.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(u)}async getDiagnostics(r,t){const s=[];return(0,b.listProcesses)(r.mainPID).then(async o=>(s.push(""),s.push(this.g(r)),s.push(""),s.push(this.m(r,o)),r.windows.some(c=>c.folderURIs&&c.folderURIs.length>0&&!c.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.k(r))),t.forEach(c=>{if((0,m.isRemoteDiagnosticError)(c))s.push(`
${c.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${c.hostName}`),s.push(this.f(c.machineInfo)),c.processes&&s.push(this.m(r,c.processes)),c.workspaceMetadata)for(const a of Object.keys(c.workspaceMetadata)){const u=c.workspaceMetadata[a];let w=`${u.fileCount} files`;u.maxFilesReached&&(w=`more than ${w}`),s.push(`Folder (${a}): ${w}`),s.push(this.h(u))}}),s.push(""),s.push(""),s.join(`
`)))}h(r){const t=[];let o=0;const c=(E,N)=>{const O=` ${E}(${N})`;o+O.length>60?(t.push(a),a="|                 ",o=a.length):o+=O.length,a+=O};let a="|      File types:";const u=10,w=r.fileTypes.length>u?u:r.fileTypes.length;for(let E=0;E<w;E++){const N=r.fileTypes[E];c(N.name,N.count)}if(t.push(a),r.configFiles.length>=0&&(a="|      Conf files:",o=0,r.configFiles.forEach(E=>{c(E.name,E.count)}),t.push(a)),r.launchConfigFiles.length>0){let E="|      Launch Configs:";r.launchConfigFiles.forEach(N=>{E+=N.count>1?` ${N.name}(${N.count})`:` ${N.name}`}),t.push(E)}return t.join(`
`)}j(r){const t=Math.max(...Object.keys(r).map(s=>s.length));return Object.keys(r).map(s=>`${s}:  ${" ".repeat(t-s.length)}  ${r[s]}`).join(`
                  `)}k(r){const t=[],s=[];return r.windows.forEach(o=>{o.folderURIs.length===0||!!o.remoteAuthority||(t.push(`|  Window (${o.title})`),o.folderURIs.forEach(c=>{const a=P.URI.revive(c);if(a.scheme===k.Schemas.file){const u=a.fsPath;s.push(l(u,["node_modules",".git"]).then(w=>{let E=`${w.fileCount} files`;w.maxFilesReached&&(E=`more than ${E}`),t.push(`|    Folder (${(0,T.basename)(u)}): ${E}`),t.push(this.h(w))}).catch(w=>{t.push(`|      Error: Unable to collect workspace stats for folder ${u} (${w.toString()})`)}))}else t.push(`|    Folder (${a.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(o=>t.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}m(r,t){const s=new Map;r.windows.forEach(c=>s.set(c.pid,c.title));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),t&&this.n(r.mainPID,s,o,t,0),o.join(`
`)}n(r,t,s,o,c){const a=c===0;let u;a?u=o.pid===r?`${this.d.applicationName} main`:"remote agent":(u=`${"  ".repeat(c)} ${o.name}`,o.name==="window"&&(u=`${u} (${t.get(o.pid)})`));const w=process.platform==="win32"?o.mem:A.totalmem()*(o.mem/100);s.push(`${o.load.toFixed(0).padStart(5," ")}	${(w/p.ByteSize.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${u}`),Array.isArray(o.children)&&o.children.forEach(E=>this.n(r,t,s,E,c+1))}async getWorkspaceFileExtensions(r){const t=new Set;for(const{uri:s}of r.folders){const o=P.URI.revive(s);if(o.scheme!==k.Schemas.file)continue;const c=o.fsPath;try{(await l(c,["node_modules",".git"])).fileTypes.forEach(u=>t.add(u.name))}catch{}}return{extensions:[...t]}}async reportWorkspaceStats(r){for(const{uri:t}of r.folders){const s=P.URI.revive(t);if(s.scheme!==k.Schemas.file)continue;const o=s.fsPath;try{const c=await l(o,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),c.fileTypes.forEach(a=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:a.name,count:a.count})}),c.launchConfigFiles.forEach(a=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:a.name,count:a.count})}),c.configFiles.forEach(a=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:a.name,count:a.count})})}catch{}}}};I=ye([Y(0,y.ITelemetryService),Y(1,h.IProductService)],I),e.DiagnosticsService=I}),define(re[232],ae([0,1,107,3,19,15,2,9,12,50,25,5,6,103,16,169,34,8]),function(_,e,A,n,D,k,T,R,P,S,C,b,m,p,h,y,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTunnelService=void 0;let d=class extends T.Disposable{constructor(v,I,i,r,t,s){super(),this.p=v,this.r=I,this.s=i,this.t=s,this.b=new n.Emitter,this.onDidTokenFailed=this.b.event,this.c=new n.Emitter,this.onDidChangeTunnelStatus=this.c.event,this.f=new n.Emitter,this.onDidChangeAccount=this.f.event,this.j=A.TunnelStates.disconnected;const o=l.URI.file((0,P.join)(i.logsPath,A.LOG_FILE_NAME));this.g=this.B(r.createLogger(o,{name:A.LOGGER_NAME})),this.k=new m.Delayer(100),this.B(this.g.onDidChangeLogLevel(c=>this.g.info("Log level changed to "+(0,R.LogLevelToString)(c)))),this.B(t.onWillShutdown(c=>{this.i&&(this.i.cancel(),this.i=void 0),this.dispose()})),this.B(s.onDidChangeConfiguration(c=>{c.affectsConfiguration(A.CONFIGURATION_KEY_HOST_NAME)&&this.k.trigger(()=>this.v())}))}async getAccount(){return this.h}async updateAccount(v){if(v&&this.h?v.token!==this.h.token||v.providerId!==this.h.providerId:v!==this.h){this.h=v,this.f.fire(v),v?this.g.info(`Account updated: ${v.accountLabel} (${v.providerId})`):this.g.info("Account reset"),this.p.publicLog2("remoteTunnel.enablement",{enabled:!!v});try{await this.k.trigger(()=>this.v())}catch(I){this.g.error(I)}}return this.j}u(){if(!this.n){let v;b.isMacintosh?v=this.s.appRoot:v=(0,P.dirname)((0,P.dirname)(this.s.appRoot)),this.n=(0,P.join)(v,"bin",`${this.r.tunnelApplicationName}${b.isWindows?".exe":""}`)}return this.n}async v(){if(this.i&&(this.i.cancel(),this.i=void 0),!this.h){this.w(A.TunnelStates.disconnected);return}const{token:v,providerId:I,accountLabel:i}=this.h;this.w(A.TunnelStates.connecting((0,y.localize)(0,null,i,I)));const r=(a,u)=>{a=a.replaceAll(v,"*".repeat(4)),u?this.g.error(a):this.g.info(a),!this.s.isBuilt&&a.startsWith("   Compiling")&&this.w(A.TunnelStates.connecting((0,y.localize)(1,null)))},t=this.y("login",["user","login","--provider",I,"--access-token",v,"--log",(0,R.LogLevelToString)(this.g.getLevel())],r);this.i=t;try{if(await t,this.i!==t)return}catch(a){this.g.error(a),this.i=void 0,this.b.fire(!0),this.w(A.TunnelStates.disconnected);return}const s=this.z();s?this.w(A.TunnelStates.connecting((0,y.localize)(2,null,s))):this.w(A.TunnelStates.connecting((0,y.localize)(3,null)));const o=["--parent-process-id",String(process.pid),"--accept-server-license-terms","--log",(0,R.LogLevelToString)(this.g.getLevel())];s?o.push("--name",s):o.push("--random-name");const c=this.y("tunnel",o,(a,u)=>{u?this.g.error(a):this.g.info(a);const w=a.match(/^\s*Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(w){const E={link:w[1],domain:w[2],hostName:w[4]};this.w(A.TunnelStates.connected(E))}else a.match(/error refreshing token/)&&(c.cancel(),this.b.fire(!0),this.w(A.TunnelStates.disconnected))});this.i=c,c.finally(()=>{c===this.i&&(this.g.info("tunnel process terminated"),this.i=void 0,this.h=void 0,this.w(A.TunnelStates.disconnected))})}async getTunnelStatus(){return this.j}w(v){this.j=v,this.c.fire(v)}y(v,I,i=()=>{}){return(0,m.createCancelablePromise)(r=>new Promise((t,s)=>{r.isCancellationRequested&&t();let o;if(r.onCancellationRequested(()=>{o&&(this.g.info(`${v} terminating(${o.pid})`),o.kill())}),!this.s.isBuilt)i("Building tunnel CLI from sources and run",!1),i(`${v} Spawning: cargo run -- tunnel ${I.join(" ")}`,!1),o=(0,S.spawn)("cargo",["run","--","tunnel",...I],{cwd:(0,P.join)(this.s.appRoot,"cli")});else{i("Running tunnel CLI",!1);const c=this.u();i(`${v} Spawning: ${c} tunnel ${I.join(" ")}`,!1),o=(0,S.spawn)(c,["tunnel",...I],{cwd:(0,f.homedir)()})}o.stdout.on("data",c=>{if(o){const a=c.toString();i(a,!1)}}),o.stderr.on("data",c=>{if(o){const a=c.toString();i(a,!0)}}),o.on("exit",c=>{o&&(i(`${v} exit(${o.pid}): + ${c} `,!1),o=void 0,c===0?t():s())}),o.on("error",c=>{o&&(i(`${v} error(${o.pid}): + ${c} `,!0),o=void 0,s())})}))}async getHostName(){return this.z()}z(){let v=this.t.getValue(A.CONFIGURATION_KEY_HOST_NAME)||(0,f.hostname)();return v=v.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),v||void 0}};d=ye([Y(0,D.ITelemetryService),Y(1,C.IProductService),Y(2,k.INativeEnvironmentService),Y(3,R.ILoggerService),Y(4,p.ISharedProcessLifecycleService),Y(5,h.IConfigurationService)],d),e.RemoteTunnelService=d}),define(re[111],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class A{constructor(k){this.b=k}listen(k,T){throw new Error(`Event not found: ${T}`)}call(k,T,{eventName:R,data:P}){return this.b.forEach(S=>S.log(R,P)),Promise.resolve(null)}}e.TelemetryAppenderChannel=A;class n{constructor(k){this.b=k}log(k,T){return this.b.call("log",{eventName:k,data:T}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=n}),define(re[47],ae([0,1,32,14,3,16,75,110,19]),function(_,e,A,n,D,k,T,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class S{constructor(a){this.value=a}}e.TelemetryTrustedValue=S;class C{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(a,u){return Promise.resolve(void 0)}publicLog2(a,u){return this.publicLog(a,u)}publicLogError(a,u){return Promise.resolve(void 0)}publicLogError2(a,u){return this.publicLogError(a,u)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=C,e.NullTelemetryService=new C;class b{async publicLog(a,u,w){}async publicLogError(a,u,w){}}e.NullEndpointTelemetryService=b,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function m(c,a){return D.Event.debounce(a.onDidChangeConfiguration,(w,E)=>{const N=w?new Set([...w.affectedKeys,...E.affectedKeys]):E.affectedKeys;return{...E,affectedKeys:N}},1e3,!0)(w=>{w.source!==7&&c.publicLog2("updateConfiguration",{configurationSource:(0,k.ConfigurationTargetToString)(w.source),configurationKeys:v(w.affectedKeys)})})}e.configurationTelemetry=m;function p(c,a){return!a.isBuilt&&!a.disableTelemetry?!0:!(a.disableTelemetry||!c.enableTelemetry||a.extensionTestsLocationURI)}e.supportsTelemetry=p;function h(c,a){return!(a.isBuilt||a.disableTelemetry||c.enableTelemetry&&c.aiConfig?.ariaKey)}e.isLoggingOnly=h;function y(c){const a=c.getValue(P.TELEMETRY_SETTING_ID),u=c.getValue(P.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(c.getValue(P.TELEMETRY_OLD_SETTING_ID)===!1||u===!1)return 0;switch(a??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=y;function f(c){const a={},u={},w={};g(c,w);for(let E in w){E=E.length>150?E.substr(E.length-149):E;const N=w[E];typeof N=="number"?u[E]=N:typeof N=="boolean"?u[E]=N?1:0:typeof N=="string"?(N.length>8192&&console.warn(`Telemetry property: ${E} has been trimmed to 8192, the original length is ${N.length}`),a[E]=N.substring(0,8191)):typeof N<"u"&&N!==null&&(a[E]=N)}return{properties:a,measurements:u}}e.validateTelemetryData=f;const l=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function d(c){if(!c)return"none";const a=(0,T.getRemoteName)(c);return l.has(a)?a:"other"}e.cleanRemoteAuthority=d;function g(c,a,u=0,w){if(!!c)for(const E of Object.getOwnPropertyNames(c)){const N=c[E],O=w?w+E:E;Array.isArray(N)?a[O]=(0,A.safeStringify)(N):N instanceof Date?a[O]=N.toISOString():(0,n.isObject)(N)?u<2?g(N,a,u+1,O+"."):a[O]=(0,A.safeStringify)(N):a[O]=N}}function v(c){if(!c)return[];const a=[];return I(a,"",c),a}function I(c,a,u){u&&typeof u=="object"&&!Array.isArray(u)?Object.keys(u).forEach(w=>I(c,a?`${a}.${w}`:w,u[w])):c.push(a)}function i(c,a){const u=c.msftInternalDomains||[],w=a.getValue("telemetry.internalTesting");return(0,R.verifyMicrosoftInternalDomain)(u)||w}e.isInternalTelemetry=i;function r(c){return[c.appRoot,c.extensionsPath,c.userHome.fsPath,c.tmpDir.fsPath,c.userDataPath]}e.getPiiPathsFromEnvironment=r;function t(c,a){if(!c||!c.includes("/")&&!c.includes("\\"))return c;let u=c;const w=[];for(const j of a)for(;;){const M=j.exec(c);if(!M)break;w.push([M.index,j.lastIndex])}const E=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,N=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let O=0;for(u="";;){const j=N.exec(c);if(!j)break;const M=w.some(([L,F])=>j.index<F&&L<N.lastIndex);!E.test(j[0])&&!M&&(u+=c.substring(O,j.index)+"<REDACTED: user-file-path>",O=N.lastIndex)}return O<c.length&&(u+=c.substr(O)),u}function s(c){if(!c)return c;const a=c.toLowerCase(),u=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const w of u)if(w.regex.test(a))return`<REDACTED: ${w.label}>`;return c}function o(c,a){return(0,A.cloneAndChange)(c,u=>{if(u instanceof S)return u.value;if(typeof u=="string"){let w=u.replaceAll("%20"," ");w=t(w,a);for(const E of a)w=w.replace(E,"");return w=s(w),w}})}e.cleanData=o}),define(re[33],ae([0,1,27,30,42,5,8,7,36,47]),function(_,e,A,n,D,k,T,R,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function C(t,s){return t.uuid&&s.uuid?t.uuid===s.uuid:t.id===s.id?!0:(0,A.compareIgnoreCase)(t.id,s.id)===0}e.areSameExtensions=C;const b=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(s){const o=s.manifest?s.manifest.version:s.version,c=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new m(s.identifier,o,c)}static parse(s){const o=b.exec(s);return o&&o[1]&&o[2]?new m({id:o[1]},o[2],o[4]||void 0):null}constructor(s,o,c="undefined"){this.version=o,this.targetPlatform=c,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof m?C(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.ExtensionKey=m;const p=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function h(t){const s=p.exec(t);return s&&s[1]?[f(s[1]),s[2]]:[f(t),void 0]}e.getIdAndVersion=h;function y(t,s){return`${t}.${s}`}e.getExtensionId=y;function f(t){return t.toLocaleLowerCase()}e.adoptToGalleryExtensionId=f;function l(t,s){return f(y(t,s))}e.getGalleryExtensionId=l;function d(t,s){const o=[],c=a=>{for(const u of o)if(u.some(w=>C(s(w),s(a))))return u;return null};for(const a of t){const u=c(a);u?u.push(a):o.push([a])}return o}e.groupByExtension=d;function g(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=g;function v(t){return{id:new S.TelemetryTrustedValue(t.identifier.id),name:new S.TelemetryTrustedValue(t.name),galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),isSigned:t.isSigned,...t.telemetryData}}e.getGalleryExtensionTelemetryData=v,e.BetterMergeId=new D.ExtensionIdentifier("pprice.better-merge");function I(t,s){const o=[],c=s.manifest.extensionDependencies?.slice(0)??[];for(;c.length;){const a=c.shift();if(a&&o.every(u=>!C(u.identifier,{id:a}))){const u=t.filter(w=>C(w.identifier,{id:a}));u.length===1&&(o.push(u[0]),c.push(...u[0].manifest.extensionDependencies?.slice(0)??[]))}}return o}e.getExtensionDependencies=I;async function i(t,s){if(!k.isLinux)return!1;let o;try{o=(await t.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{o=(await t.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){s.debug("Error while getting the os-release file.",(0,R.getErrorMessage)(a))}}return!!o&&(o.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=i;async function r(t,s){const o=await i(t,s),c=(0,n.getTargetPlatform)(o?"alpine":k.platform,P.arch);return s.debug("ComputeTargetPlatform:",c),c}e.computeTargetPlatform=r}),define(re[233],ae([0,1,23,33]),function(_,e,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function D(k,T,R,P,S){try{const C=await k.getExtensionsControlManifest();if(!C.deprecated)return;const b=await k.getInstalled(1);for(const[m,p]of Object.entries(C.deprecated)){if(!p?.extension)continue;const{id:h,autoMigrate:y,preRelease:f}=p.extension;if(!y)continue;const l=b.find(g=>(0,n.areSameExtensions)(g.identifier,{id:m}));if(!l)continue;const d=(await T.getExtensions([{id:h,preRelease:f}],{targetPlatform:await k.getTargetPlatform(),compatible:!0},A.CancellationToken.None))[0];if(!d){S.info(`Skipping migrating '${l.identifier.id}' extension because, the comaptible target '${h}' extension is not found`);continue}try{S.info(`Migrating '${l.identifier.id}' extension to '${h}' extension...`);const g=!P.getDisabledExtensions().some(I=>(0,n.areSameExtensions)(I,l.identifier));await k.uninstall(l),S.info(`Uninstalled the unsupported extension '${l.identifier.id}'`);let v=b.find(I=>(0,n.areSameExtensions)(I.identifier,{id:h}));(!v||!v.isPreReleaseVersion&&g)&&(v=await k.installFromGallery(d,{installPreReleaseVersion:!0,isMachineScoped:l.isMachineScoped,operation:4}),S.info(`Installed the pre-release extension '${v.identifier.id}'`),g||(await P.disableExtension(v.identifier),S.info(`Disabled the pre-release extension '${v.identifier.id}' because the unsupported extension '${l.identifier.id}' is disabled`)),y.storage&&(R.addToMigrationList((0,n.getExtensionId)(l.manifest.publisher,l.manifest.name),(0,n.getExtensionId)(v.manifest.publisher,v.manifest.name)),S.info("Added pre-release extension to the storage migration list"))),S.info(`Migrated '${l.identifier.id}' extension to '${h}' extension.`)}catch(g){S.error(g)}}}catch(C){S.error(C)}}e.migrateUnsupportedExtensions=D}),define(re[234],ae([0,1,6,7,2,24,5,22,54,14,31,28,16,15,30,33,98,13,9,25]),function(_,e,A,n,D,k,T,R,P,S,C,b,m,p,h,y,f,l,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let v=class yt extends D.Disposable{constructor(i,r,t,s,o,c,a){super(),this.h=r,this.i=t,this.j=s,this.k=o,this.l=c,this.m=a,this.extensionsDownloadDir=i.extensionsDownloadLocation,this.f=20,this.g=this.v()}async download(i,r){await this.g;const t=(0,R.joinPath)(this.extensionsDownloadDir,this.w(i));try{await this.t(i,t,o=>this.i.download(i,o,r))}catch(o){throw new h.ExtensionManagementError(o.message,h.ExtensionManagementErrorCode.Download)}let s="Unverified";if(await this.n(i)){const o=await this.r(i);try{await this.l.verify(t.fsPath,o.fsPath)&&(s="Verified"),this.m.info(`Extension signature verification: ${i.identifier.id}. Verification status: ${s}.`)}catch(c){const a=c.code;if(a==="UnknownError")s="UnknownError",this.m.warn(`Extension signature verification: ${i.identifier.id}. Verification status: ${s}.`);else throw await this.delete(o),await this.delete(t),new h.ExtensionManagementError(a,h.ExtensionManagementErrorCode.Signature)}}return{location:t,verificationStatus:s}}async n(i){if(!i.isSigned)return!1;const r=this.j.getValue("extensions.verifySignature");return(0,S.isBoolean)(r)?r:this.k.quality!=="stable"}async r(i){await this.g;const r=(0,R.joinPath)(this.extensionsDownloadDir,`${this.w(i)}${yt.c}`);return await this.t(i,r,t=>this.i.downloadSignatureArchive(i,t)),r}async t(i,r,t){if(await this.h.exists(r))return;if(r.scheme!==k.Schemas.file){await t(r);return}const s=(0,R.joinPath)(this.extensionsDownloadDir,`.${(0,C.generateUuid)()}`);await this.h.exists(s)||await t(s);try{await this.u(s,r,Date.now()+2*60*1e3)}catch(o){try{await this.h.del(s)}catch{}if(o.code==="ENOTEMPTY")this.m.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",i.identifier.id,r.path);else throw this.m.info(`Rename failed because of ${(0,n.getErrorMessage)(o)}. Deleted the file from downloaded location`,s.path),o}}async delete(i){await this.g,await this.h.del(i)}async u(i,r,t){try{await b.Promises.rename(i.fsPath,r.fsPath)}catch(s){if(T.isWindows&&s&&s.code==="EPERM"&&Date.now()<t)return this.m.info(`Failed renaming ${i} to ${r} with 'EPERM' error. Trying again...`),this.u(i,r,t);throw s}}async v(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.m.trace("Extension VSIX downloads cache dir does not exist");return}const i=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(i.children){const r=[],t=[],s=[];for(const a of i.children)if(a.name.endsWith(yt.c))s.push(a.resource);else{const u=y.ExtensionKey.parse(a.name);u&&t.push([u,a])}const o=(0,y.groupByExtension)(t,([a])=>a),c=[];for(const a of o)a.sort((u,w)=>P.rcompare(u[0].version,w[0].version)),r.push(...a.slice(1).map(u=>u[1].resource)),c.push(a[0][1]);c.sort((a,u)=>a.mtime-u.mtime),r.push(...c.slice(0,Math.max(0,c.length-this.f)).map(a=>a.resource)),r.push(...s),await A.Promises.settled(r.map(a=>(this.m.trace("Deleting from cache",a.path),this.h.del(a))))}}catch(i){this.m.error(i)}}w(i){return this.f?y.ExtensionKey.create(i).toString().toLowerCase():(0,C.generateUuid)()}};v.c=".sigzip",v=ye([Y(0,p.INativeEnvironmentService),Y(1,l.IFileService),Y(2,h.IExtensionGalleryService),Y(3,m.IConfigurationService),Y(4,g.IProductService),Y(5,f.IExtensionSignatureVerificationService),Y(6,d.ILogService)],v),e.ExtensionsDownloader=v}),define(re[235],ae([0,1,3,2,37,33,42]),function(_,e,A,n,D,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class R extends n.Disposable{constructor(S,C,b,m,p,h,y){super(),this.f=S,this.g=C,this.h=b,this.i=m,this.j=p,this.k=h,this.l=y,this.a=this.B(new A.Emitter),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new n.DisposableMap),this.m().then(null,f=>y.error(f))}async m(){await this.g.initializeDefaultProfileExtensions(),await this.p(this.h.profiles,[]),this.n(),await this.C()}n(){this.B(this.h.onDidChangeProfiles(S=>this.p(S.added,S.removed))),this.B(this.i.onAddExtensions(S=>this.r(S))),this.B(this.i.onDidAddExtensions(S=>this.s(S))),this.B(this.i.onRemoveExtensions(S=>this.t(S))),this.B(this.i.onDidRemoveExtensions(S=>this.u(S))),this.B(this.k.onDidFilesChange(S=>this.v(S)))}async p(S,C){try{await Promise.all(C.map(b=>(this.c.deleteAndDispose(b.id),this.z(b.extensionsResource)))),S.length&&await Promise.all(S.map(b=>(this.c.set(b.id,(0,n.combinedDisposable)(this.k.watch(this.j.extUri.dirname(b.extensionsResource)),this.k.watch(b.extensionsResource))),this.y(b.extensionsResource))))}catch(b){throw this.l.error(b),b}}async r(S){for(const C of S.extensions)this.D(this.G(C.identifier,C.version),S.profileLocation)}async s(S){for(const C of S.extensions){const b=this.G(C.identifier,C.version);S.error?this.F(b,S.profileLocation):this.D(b,S.profileLocation)}}async t(S){for(const C of S.extensions)this.F(this.G(C.identifier,C.version),S.profileLocation)}async u(S){let C=!1;for(const b of S.extensions){const m=this.G(b.identifier,b.version);S.error?this.D(m,S.profileLocation):(this.F(m,S.profileLocation),C=C||!this.b.has(m))}C&&await this.C()}v(S){for(const C of this.h.profiles)S.contains(C.extensionsResource,0,1)&&this.w(C.extensionsResource)}async w(S){const C=[],b=[],m=await this.i.scanProfileExtensions(S),p=new Set,h=new Set;for(const[y,f]of this.b)f.has(S)&&h.add(y);for(const y of m){const f=this.G(y.identifier,y.version);p.add(f),h.has(f)||(C.push(y.identifier),this.D(f,S))}for(const y of h)if(!p.has(y)){const f=this.H(y);f&&(b.push(f.identifier),this.F(y,S))}(C.length||b.length)&&this.a.fire({added:C.length?{extensions:C,profileLocation:S}:void 0,removed:b.length?{extensions:b,profileLocation:S}:void 0})}async y(S){const C=await this.i.scanProfileExtensions(S);for(const b of C)this.D(this.G(b.identifier,b.version),S)}async z(S){for(const C of[...this.b.keys()])this.F(C,S);await this.C()}async C(){const C=(await this.f.getAllUserInstalled()).filter(b=>b.installedTimestamp&&!this.b.has(this.G(b.identifier,b.manifest.version)));C.length&&await this.f.markAsUninstalled(...C)}D(S,C){let b=this.b.get(S);b||this.b.set(S,b=new D.ResourceSet(m=>this.j.extUri.getComparisonKey(m))),b.add(C)}F(S,C){const b=this.b.get(S);b&&b.delete(C),b?.size||this.b.delete(S)}G(S,C){return`${T.ExtensionIdentifier.toKey(S.id)}@${C}`}H(S){const[C,b]=(0,k.getIdAndVersion)(S);return b?{identifier:{id:C},version:b}:void 0}}e.ExtensionsWatcher=R}),define(re[236],ae([0,1,45,47]),function(_,e,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function D(k,T,R,P,S,C,b){const m={"X-Market-Client-Id":`VSCode ${k}`,"User-Agent":`VSCode ${k} (${T.nameShort})`};if((0,n.supportsTelemetry)(T,R)&&(0,n.getTelemetryLevel)(P)===3){const p=await(0,A.getServiceMachineId)(R,S,C),{machineId:h}=await b.getTelemetryInfo();m["X-Market-User-Id"]=p,m["VSCode-SessionId"]=h||p}return m}e.resolveMarketplaceHeaders=D}),define(re[237],ae([0,1,100,21,6,2,24,12,28,15,30,33,9,73,5,8]),function(_,e,A,n,D,k,T,R,P,S,C,b,m,p,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let f=class extends p.LanguagePackBaseService{constructor(v,I,i,r){super(i),this.h=v,this.i=r,this.g=this.B(new l(I,r)),this.h.registerParticipant({postInstall:async t=>this.j(t),postUninstall:async t=>this.k(t)})}async getBuiltInExtensionTranslationsUri(v){const i=(await this.g.getLanguagePacks())[h.Language.value()];if(!i){this.i.warn(`No language pack found for ${h.Language.value()}`);return}const r=i.translations[v];return r?y.URI.file(r):void 0}async getInstalledLanguages(){const v=await this.g.getLanguagePacks(),I=Object.keys(v).map(i=>{const r=v[i];return{...this.f(i,r.label),extensionId:r.extensions[0].extensionIdentifier.id}});return I.push({...this.f("en","English"),extensionId:"default"}),I.sort((i,r)=>i.label.localeCompare(r.label)),I}async j(v){v&&v.manifest&&v.manifest.contributes&&v.manifest.contributes.localizations&&v.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",v.identifier.id),await this.update())}async k(v){const I=await this.g.getLanguagePacks();Object.keys(I).some(i=>I[i]&&I[i].extensions.some(r=>(0,b.areSameExtensions)(r.extensionIdentifier,v.identifier)))&&(this.i.info("Removing language packs from the extension",v.identifier.id),await this.update())}async update(){const[v,I]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),i=await this.g.update(I);return!(0,n.equals)(Object.keys(v),Object.keys(i))}};f=ye([Y(0,C.IExtensionManagementService),Y(1,S.INativeEnvironmentService),Y(2,C.IExtensionGalleryService),Y(3,m.ILogService)],f),e.NativeLanguagePackService=f;let l=class extends k.Disposable{constructor(v,I){super(),this.i=I,this.c={},this.f=(0,R.join)(v.userDataPath,"languagepacks.json"),this.g=new D.Queue}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update(v){return this.m(I=>{Object.keys(I).forEach(i=>delete I[i]),this.j(I,...v)}).then(()=>this.c)}j(v,...I){for(const i of I)i&&i.manifest&&i.manifest.contributes&&i.manifest.contributes.localizations&&i.manifest.contributes.localizations.length&&this.k(v,i);Object.keys(v).forEach(i=>this.l(v[i]))}k(v,I){const i=I.identifier,r=I.manifest.contributes&&I.manifest.contributes.localizations?I.manifest.contributes.localizations:[];for(const t of r)if(I.location.scheme===T.Schemas.file&&d(t)){let s=v[t.languageId];s||(s={hash:"",extensions:[],translations:{},label:t.localizedLanguageName??t.languageName},v[t.languageId]=s);const o=s.extensions.filter(c=>(0,b.areSameExtensions)(c.extensionIdentifier,i))[0];o?o.version=I.manifest.version:s.extensions.push({extensionIdentifier:i,version:I.manifest.version});for(const c of t.translations)s.translations[c.id]=(0,R.join)(I.location.fsPath,c.path)}}l(v){if(v){const I=(0,A.createHash)("md5");for(const i of v.extensions)I.update(i.extensionIdentifier.uuid||i.extensionIdentifier.id).update(i.version);v.hash=I.digest("hex")}}m(v=()=>null){return this.g.queue(()=>{let I=null;return P.Promises.readFile(this.f,"utf8").then(void 0,i=>i.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(i)).then(i=>{try{return JSON.parse(i)}catch{return{}}}).then(i=>(I=v(i),i)).then(i=>{for(const t of Object.keys(i))i[t]||delete i[t];this.c=i,this.h=!0;const r=JSON.stringify(this.c);return this.i.debug("Writing language packs",r),P.Promises.writeFile(this.f,r)}).then(()=>I,i=>this.i.error(i))})}};l=ye([Y(0,S.INativeEnvironmentService),Y(1,m.ILogService)],l);function d(g){if(typeof g.languageId!="string"||!Array.isArray(g.translations)||g.translations.length===0)return!1;for(const v of g.translations)if(typeof v.id!="string"||typeof v.path!="string")return!1;return!(g.languageName&&typeof g.languageName!="string"||g.localizedLanguageName&&typeof g.localizedLanguageName!="string")}}),define(re[238],ae([0,1,7,32,47]),function(_,e,A,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const k="https://mobile.events.data.microsoft.com/OneCollector/1.0",T="https://mobile.events.data.microsoft.com/ping";async function R(S,C,b){const m=await new Promise((l,d)=>{_(["@microsoft/1ds-core-js"],l,d)}),p=await new Promise((l,d)=>{_(["@microsoft/1ds-post-js"],l,d)}),h=new m.AppInsightsCore,y=new p.PostChannel,f={instrumentationKey:S,endpointUrl:k,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[y]]};if(b){f.extensionConfig={};const l={alwaysUseXhrOverride:!0,httpXHROverride:b};f.extensionConfig[y.identifier]=l}return h.initialize(f,[]),h.addTelemetryInitializer(l=>{C&&(l.ext=l.ext??{},l.ext.utc=l.ext.utc??{},l.ext.utc.flags=8462029)}),h}class P{constructor(C,b,m,p,h){this.e=C,this.f=b,this.g=m,this.h=h,this.c=k,this.d=T,this.g||(this.g={}),typeof p=="function"?this.a=p():this.a=p,this.b=null}i(C){if(!!this.a){if(typeof this.a!="string"){C(this.a);return}this.b||(this.b=R(this.a,this.e,this.h)),this.b.then(b=>{C(b)},b=>{(0,A.onUnexpectedError)(b),console.error(b)})}}log(C,b){if(!this.a)return;b=(0,n.mixin)(b,this.g),b=(0,D.validateTelemetryData)(b);const m=this.f+"/"+C;try{this.i(p=>{p.pluginVersionString=b?.properties.version??"Unknown",p.track({name:m,baseData:{name:m,properties:b?.properties,measurements:b?.measurements}})})}catch{}}flush(){return this.a?new Promise(C=>{this.i(b=>{b.unload(!0,()=>{this.a=void 0,C(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=P}),define(re[112],ae([0,1,2,15,9,47]),function(_,e,A,n,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let T=class extends A.Disposable{constructor(P,S,C=""){super(),this.b=C;const b=P.getLogger(S.telemetryLogResource);b?this.a=this.B(b):(this.a=this.B(P.createLogger(S.telemetryLogResource)),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(P,S){this.a.trace(`${this.b}telemetry/${P}`,(0,k.validateTelemetryData)(S))}};T=ye([Y(0,D.ILoggerService),Y(1,n.IEnvironmentService)],T),e.TelemetryLogAppender=T}),define(re[113],ae([0,1,2,32,5,27,172,16,46,105,25,40,19,47]),function(_,e,A,n,D,k,T,R,P,S,C,b,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let h=class{constructor(l,d,g){this.k=d,this.l=g,this.d={},this.i=new A.DisposableStore,this.j=[],this.b=l.appenders,this.c=l.commonProperties||Promise.resolve({}),this.f=l.piiPaths||[],this.g=3,this.h=!!l.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const v of this.f)this.j.push(new RegExp((0,k.escapeRegExpCharacters)(v),"gi")),v.indexOf("\\")>=0&&this.j.push(new RegExp((0,k.escapeRegExpCharacters)(v.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(v=>{(v.affectsConfiguration(m.TELEMETRY_SETTING_ID)||v.affectsConfiguration(m.TELEMETRY_OLD_SETTING_ID)||v.affectsConfiguration(m.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this.m()}))}setExperimentProperty(l,d){this.d[l]=d}m(){let l=(0,p.getTelemetryLevel)(this.k);const d=this.l.enabledTelemetryLevels;if(d){this.h=this.sendErrorTelemetry?d.error:!1;const g=d.usage?3:d.error?2:0;l=Math.min(l,g)}this.g=l}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}async getTelemetryInfo(){const l=await this.c,d=l.sessionID,g=l["common.machineId"],v=l["common.firstSessionDate"],I=l["common.msftInternal"];return{sessionId:d,machineId:g,firstSessionDate:v,msftInternal:I}}dispose(){this.i.dispose()}n(l,d,g){return this.g<d?Promise.resolve(void 0):this.c.then(v=>{g=(0,n.mixin)(g,this.d),g=(0,p.cleanData)(g,this.j),g=(0,n.mixin)(g,v),this.b.forEach(I=>I.log(l,g))},v=>{console.error(v)})}publicLog(l,d){return this.n(l,3,d)}publicLog2(l,d){return this.publicLog(l,d)}publicLogError(l,d){return this.h?this.n(l,2,d):Promise.resolve(void 0)}publicLogError2(l,d){return this.publicLogError(l,d)}};h.IDLE_START_EVENT_NAME="UserIdleStart",h.IDLE_STOP_EVENT_NAME="UserIdleStop",h=ye([Y(1,R.IConfigurationService),Y(2,C.IProductService)],h),e.TelemetryService=h;function y(){const f=(0,T.localize)(0,null,S.default.nameLong),l=S.default.privacyStatementUrl?(0,T.localize)(2,null,"https://aka.ms/vscode-telemetry",S.default.privacyStatementUrl):(0,T.localize)(1,null,"https://aka.ms/vscode-telemetry"),d=D.isWeb?"":(0,T.localize)(3,null),g=(0,T.localize)(4,null),v=(0,T.localize)(5,null),I=(0,T.localize)(6,null),i=(0,T.localize)(7,null),r=`
|       | ${g} | ${v} | ${I} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,t=(0,T.localize)(8,null);return`
${f} ${l} ${d}

&nbsp;

${i}
${r}

&nbsp;

${t}
`}b.Registry.as(P.Extensions.Configuration).registerConfiguration({id:m.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,T.localize)(9,null),properties:{[m.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,T.localize)(10,null),(0,T.localize)(11,null),(0,T.localize)(12,null),(0,T.localize)(13,null)],markdownDescription:y(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),b.Registry.as(P.Extensions.Configuration).registerConfiguration({id:m.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,T.localize)(14,null),properties:{[m.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:S.default.privacyStatementUrl?(0,T.localize)(16,null,S.default.nameLong,S.default.privacyStatementUrl):(0,T.localize)(15,null,S.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,T.localize)(17,null,`\`#${m.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(re[239],ae([0,1,289,238]),function(_,e,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class D extends n.AbstractOneDataSystemAppender{constructor(T,R,P,S){const C={sendPOST:(b,m)=>{const p={method:"POST",headers:{...b.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(b.data)}};try{const h=A.request(b.urlString,p,y=>{y.on("data",function(f){m(y.statusCode??200,y.headers,f.toString())}),y.on("error",function(f){m(0,{})})});h.write(b.data),h.end()}catch{m(0,{})}}};super(T,R,P,S,C)}}e.OneDataSystemAppender=D}),define(re[240],ae([0,1,24,68,16,15,9,25,19,111,112,113]),function(_,e,A,n,D,k,T,R,P,S,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let m=class{constructor(h,y,f,l,d){this.b=h,this.c=y,this.d=f,this.e=l,this.f=d,this.a=new Map}async g(h){if(!this.a.has(h.id)){const{machineId:y,sessionId:f}=await this.c.getTelemetryInfo(),l=Object.create(null);l["common.vscodemachineid"]=y,l["common.vscodesessionid"]=f;const d=[h.id,JSON.stringify(l),h.aiKey],v=new n.Client(A.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:d,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),I=[new S.TelemetryAppenderClient(v),new C.TelemetryLogAppender(this.d,this.e,`[${h.id}] `)];this.a.set(h.id,new b.TelemetryService({appenders:I,sendErrorTelemetry:h.sendErrorTelemetry},this.b,this.f))}return this.a.get(h.id)}async publicLog(h,y,f){await(await this.g(h)).publicLog(y,f)}async publicLogError(h,y,f){await(await this.g(h)).publicLogError(y,f)}};m=ye([Y(0,D.IConfigurationService),Y(1,P.ITelemetryService),Y(2,T.ILoggerService),Y(3,k.IEnvironmentService),Y(4,R.IProductService)],m),e.CustomEndpointTelemetryService=m}),define(re[241],ae([0,1,6,23,3,2,9]),function(_,e,A,n,D,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let R=class extends k.Disposable{constructor(S,C){super(),this.h=C,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new D.Emitter),this.onCreateRequest=this.g.event,this.b=S===void 0?15e3:S}createRequest(S){return new Promise((C,b)=>{const m=++this.a;this.c.set(m,C),this.g.fire({requestId:m,...S});const p=new n.CancellationTokenSource;(0,A.timeout)(this.b,p.token).then(()=>b(`Request ${m} timed out (${this.b}ms)`)),this.f.set(m,[(0,k.toDisposable)(()=>p.cancel())])})}acceptReply(S,C){const b=this.c.get(S);b?(this.c.delete(S),(0,k.dispose)(this.f.get(S)||[]),this.f.delete(S),b(C)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${S}`)}};R=ye([Y(1,T.ILogService)],R),e.RequestStore=R}),define(re[114],ae([0,1,4]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalLogConstants=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var n;(function(g){g.Shell="terminal.integrated.shell.",g.ShellArgs="terminal.integrated.shellArgs.",g.DefaultProfile="terminal.integrated.defaultProfile.",g.Profiles="terminal.integrated.profiles."})(n=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var D;(function(g){g.ShellLinux="terminal.integrated.shell.linux",g.ShellMacOs="terminal.integrated.shell.osx",g.ShellWindows="terminal.integrated.shell.windows",g.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",g.AutomationShellLinux="terminal.integrated.automationShell.linux",g.AutomationShellMacOs="terminal.integrated.automationShell.osx",g.AutomationShellWindows="terminal.integrated.automationShell.windows",g.AutomationProfileLinux="terminal.integrated.automationProfile.linux",g.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",g.AutomationProfileWindows="terminal.integrated.automationProfile.windows",g.ShellArgsLinux="terminal.integrated.shellArgs.linux",g.ShellArgsMacOs="terminal.integrated.shellArgs.osx",g.ShellArgsWindows="terminal.integrated.shellArgs.windows",g.ProfilesWindows="terminal.integrated.profiles.windows",g.ProfilesMacOs="terminal.integrated.profiles.osx",g.ProfilesLinux="terminal.integrated.profiles.linux",g.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",g.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",g.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",g.UseWslProfiles="terminal.integrated.useWslProfiles",g.TabsDefaultColor="terminal.integrated.tabs.defaultColor",g.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",g.TabsEnabled="terminal.integrated.tabs.enabled",g.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",g.TabsHideCondition="terminal.integrated.tabs.hideCondition",g.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",g.TabsShowActions="terminal.integrated.tabs.showActions",g.TabsLocation="terminal.integrated.tabs.location",g.TabsFocusMode="terminal.integrated.tabs.focusMode",g.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",g.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",g.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",g.CopyOnSelection="terminal.integrated.copyOnSelection",g.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",g.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",g.FontFamily="terminal.integrated.fontFamily",g.FontSize="terminal.integrated.fontSize",g.LetterSpacing="terminal.integrated.letterSpacing",g.LineHeight="terminal.integrated.lineHeight",g.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",g.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",g.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",g.BellDuration="terminal.integrated.bellDuration",g.FontWeight="terminal.integrated.fontWeight",g.FontWeightBold="terminal.integrated.fontWeightBold",g.CursorBlinking="terminal.integrated.cursorBlinking",g.CursorStyle="terminal.integrated.cursorStyle",g.CursorWidth="terminal.integrated.cursorWidth",g.Scrollback="terminal.integrated.scrollback",g.DetectLocale="terminal.integrated.detectLocale",g.DefaultLocation="terminal.integrated.defaultLocation",g.GpuAcceleration="terminal.integrated.gpuAcceleration",g.TerminalTitleSeparator="terminal.integrated.tabs.separator",g.TerminalTitle="terminal.integrated.tabs.title",g.TerminalDescription="terminal.integrated.tabs.description",g.RightClickBehavior="terminal.integrated.rightClickBehavior",g.Cwd="terminal.integrated.cwd",g.ConfirmOnExit="terminal.integrated.confirmOnExit",g.ConfirmOnKill="terminal.integrated.confirmOnKill",g.EnableBell="terminal.integrated.enableBell",g.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",g.AllowChords="terminal.integrated.allowChords",g.AllowMnemonics="terminal.integrated.allowMnemonics",g.EnvMacOs="terminal.integrated.env.osx",g.EnvLinux="terminal.integrated.env.linux",g.EnvWindows="terminal.integrated.env.windows",g.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",g.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",g.ShowExitAlert="terminal.integrated.showExitAlert",g.SplitCwd="terminal.integrated.splitCwd",g.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",g.WordSeparators="terminal.integrated.wordSeparators",g.EnableFileLinks="terminal.integrated.enableFileLinks",g.UnicodeVersion="terminal.integrated.unicodeVersion",g.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",g.LocalEchoEnabled="terminal.integrated.localEchoEnabled",g.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",g.LocalEchoStyle="terminal.integrated.localEchoStyle",g.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",g.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",g.CustomGlyphs="terminal.integrated.customGlyphs",g.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",g.InheritEnv="terminal.integrated.inheritEnv",g.ShowLinkHover="terminal.integrated.showLinkHover",g.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",g.AutoReplies="terminal.integrated.autoReplies",g.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",g.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",g.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",g.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",g.SmoothScrolling="terminal.integrated.smoothScrolling"})(D=e.TerminalSettingId||(e.TerminalSettingId={}));var k;(function(g){g.FileName="ptyhost"})(k=e.TerminalLogConstants||(e.TerminalLogConstants={}));var T;(function(g){g.PowerShell="pwsh",g.Bash="bash",g.Fish="fish",g.Sh="sh",g.Csh="csh",g.Ksh="ksh",g.Zsh="zsh"})(T=e.PosixShellType||(e.PosixShellType={}));var R;(function(g){g.CommandPrompt="cmd",g.PowerShell="pwsh",g.Wsl="wsl",g.GitBash="gitbash"})(R=e.WindowsShellType||(e.WindowsShellType={}));var P;(function(g){g[g.Api=0]="Api",g[g.Process=1]="Process",g[g.Sequence=2]="Sequence",g[g.Config=3]="Config"})(P=e.TitleEventSource||(e.TitleEventSource={}));var S;(function(g){g.LocalPty="localPty",g.PtyHost="ptyHost",g.Log="log",g.Heartbeat="heartbeat"})(S=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,A.createDecorator)("ptyService");var C;(function(g){g.Cwd="cwd",g.InitialCwd="initialCwd",g.FixedDimensions="fixedDimensions",g.Title="title",g.ShellType="shellType",g.HasChildProcesses="hasChildProcesses",g.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",g.OverrideDimensions="overrideDimensions",g.FailedShellIntegrationActivation="failedShellIntegrationActivation",g.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(C=e.ProcessPropertyType||(e.ProcessPropertyType={}));var b;(function(g){g[g.BeatInterval=5e3]="BeatInterval",g[g.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",g[g.SecondWaitMultiplier=1]="SecondWaitMultiplier",g[g.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(b=e.HeartbeatConstants||(e.HeartbeatConstants={}));var m;(function(g){g[g.Panel=1]="Panel",g[g.Editor=2]="Editor"})(m=e.TerminalLocation||(e.TerminalLocation={}));var p;(function(g){g.TerminalView="view",g.Editor="editor"})(p=e.TerminalLocationString||(e.TerminalLocationString={}));var h;(function(g){g[g.GraceTime=6e4]="GraceTime",g[g.ShortGraceTime=6e3]="ShortGraceTime"})(h=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var y;(function(g){g[g.HighWatermarkChars=1e5]="HighWatermarkChars",g[g.LowWatermarkChars=5e3]="LowWatermarkChars",g[g.CharCountAckSize=5e3]="CharCountAckSize"})(y=e.FlowControlConstants||(e.FlowControlConstants={}));var f;(function(g){g.GitBash="Git Bash",g.Pwsh="PowerShell"})(f=e.ProfileSource||(e.ProfileSource={}));var l;(function(g){g[g.Off=0]="Off",g[g.FinalTerm=1]="FinalTerm",g[g.VSCode=2]="VSCode"})(l=e.ShellIntegrationStatus||(e.ShellIntegrationStatus={}));var d;(function(g){g[g.Unknown=0]="Unknown",g[g.Shutdown=1]="Shutdown",g[g.Process=2]="Process",g[g.User=3]="User",g[g.Extension=4]="Extension"})(d=e.TerminalExitReason||(e.TerminalExitReason={}))}),define(re[242],ae([0,1,4]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,A.createDecorator)("localPtyService")}),define(re[243],ae([0,1,34,24,32,12,5,36,27,14,28]),function(_,e,A,n,D,k,T,R,P,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function b(){const I=/(\d+)\.(\d+)\.(\d+)/g.exec(A.release());let i=0;return I&&I.length===4&&(i=parseInt(I[3])),i}e.getWindowsBuildNumber=b;async function m(I,i,r,t=R.env,s=C.Promises.exists){if(k.isAbsolute(I))return await s(I)?I:void 0;if(i===void 0&&(i=R.cwd()),k.dirname(I)!=="."){const u=k.join(i,I);return await s(u)?u:void 0}const c=(0,D.getCaseInsensitive)(t,"PATH");if(r===void 0&&(0,S.isString)(c)&&(r=c.split(k.delimiter)),r===void 0||r.length===0){const u=k.join(i,I);return await s(u)?u:void 0}for(const u of r){let w;if(k.isAbsolute(u)?w=k.join(u,I):w=k.join(i,u,I),await s(w))return w;if(T.isWindows){let E=w+".com";if(await s(E)||(E=w+".exe",await s(E)))return E}}const a=k.join(i,I);return await s(a)?a:void 0}e.findExecutable=m;function p(I,i,r,t,s){if(!i.shellIntegration.enabled||!I.executable||I.isFeatureTerminal||I.hideFromUser||I.ignoreShellIntegration||T.isWindows&&!i.windowsEnableConpty)return;const o=I.args,c=R.platform==="win32"?k.basename(I.executable).toLowerCase():k.basename(I.executable),a=k.dirname(n.FileAccess.asFileUri("").fsPath);let u;const w={VSCODE_INJECTION:"1"};if(T.isWindows){if(c==="pwsh.exe"||c==="powershell.exe")return!o||g(o)?u=y.get(h.WindowsPwsh):d(o)&&(u=y.get(h.WindowsPwshLogin)),u?(u=[...u],u[u.length-1]=(0,P.format)(u[u.length-1],a,""),{newArgs:u,envMixin:w}):void 0;t.warn(`Shell integration cannot be enabled for executable "${I.executable}" and args`,I.args);return}switch(c){case"bash":return!o||o.length===0?u=y.get(h.Bash):v(o)&&(w.VSCODE_SHELL_LOGIN="1",u=y.get(h.Bash)),u?(u=[...u],u[u.length-1]=(0,P.format)(u[u.length-1],a),{newArgs:u,envMixin:w}):void 0;case"fish":{const E=r?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",N=k.join(a,"out/vs/workbench/contrib/xdg_data");return w.XDG_DATA_DIRS=`${E}:${N}`,{newArgs:void 0,envMixin:w}}case"pwsh":return!o||g(o)?u=y.get(h.Pwsh):d(o)&&(u=y.get(h.PwshLogin)),u?(u=[...u],u[u.length-1]=(0,P.format)(u[u.length-1],a,""),{newArgs:u,envMixin:w}):void 0;case"zsh":{if(!o||o.length===0?u=y.get(h.Zsh):v(o)?u=y.get(h.ZshLogin):(o===y.get(h.Zsh)||o===y.get(h.ZshLogin))&&(u=o),!u)return;u=[...u],u[u.length-1]=(0,P.format)(u[u.length-1],a);let E;try{E=A.userInfo().username}catch{E="unknown"}const N=k.join(A.tmpdir(),`${E}-${s.applicationName}-zsh`);w.ZDOTDIR=N;const O=r?.ZDOTDIR??A.homedir()??"~";w.USER_ZDOTDIR=O;const j=[];return j.push({source:k.join(a,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:k.join(N,".zshrc")}),j.push({source:k.join(a,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:k.join(N,".zprofile")}),j.push({source:k.join(a,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:k.join(N,".zshenv")}),j.push({source:k.join(a,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:k.join(N,".zlogin")}),{newArgs:u,envMixin:w,filesToCopy:j}}}t.warn(`Shell integration cannot be enabled for executable "${I.executable}" and args`,I.args)}e.getShellIntegrationInjection=p;var h;(function(I){I.WindowsPwsh="windows-pwsh",I.WindowsPwshLogin="windows-pwsh-login",I.Pwsh="pwsh",I.PwshLogin="pwsh-login",I.Zsh="zsh",I.ZshLogin="zsh-login",I.Bash="bash"})(h||(h={}));const y=new Map;y.set(h.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),y.set(h.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),y.set(h.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),y.set(h.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),y.set(h.Zsh,["-i"]),y.set(h.ZshLogin,["-il"]),y.set(h.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const f=["-login","-l"],l=["-nol","-nologo"];function d(I){return typeof I=="string"?f.includes(I.toLowerCase()):I.length===1&&f.includes(I[0].toLowerCase())||I.length===2&&(f.includes(I[0].toLowerCase())||f.includes(I[1].toLowerCase()))&&(l.includes(I[0].toLowerCase())||l.includes(I[1].toLowerCase()))}function g(I){return typeof I=="string"?l.includes(I.toLowerCase()):I.length===0||I?.length===1&&l.includes(I[0].toLowerCase())}function v(I){return I==="string"&&f.includes(I.toLowerCase())||typeof I!="string"&&I.length===1&&f.includes(I[0].toLowerCase())}}),define(re[244],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var A;(function(k){k.DARK="dark",k.LIGHT="light",k.HIGH_CONTRAST_DARK="hcDark",k.HIGH_CONTRAST_LIGHT="hcLight"})(A=e.ColorScheme||(e.ColorScheme={}));function n(k){return k===A.HIGH_CONTRAST_DARK||k===A.HIGH_CONTRAST_LIGHT}e.isHighContrast=n;function D(k){return k===A.DARK||k===A.HIGH_CONTRAST_DARK}e.isDark=D}),define(re[115],ae([0,1,52,3,2,4,40,244]),function(_,e,A,n,D,k,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,k.createDecorator)("themeService");var P;(function(f){function l(d){return d&&typeof d=="object"&&typeof d.id=="string"}f.isThemeColor=l})(P=e.ThemeColor||(e.ThemeColor={}));function S(f){return{id:f}}e.themeColorFromId=S;var C;(function(f){function l(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color>"u"||P.isThemeColor(s.color))}f.isThemeIcon=l;const d=new RegExp(`^\\$\\((${A.CSSIcon.iconNameExpression}(?:${A.CSSIcon.iconModifierExpression})?)\\)$`);function g(s){const o=d.exec(s);if(!o)return;const[,c]=o;return{id:c}}f.fromString=g;function v(s){return{id:s}}f.fromId=v;function I(s,o){let c=s.id;const a=c.lastIndexOf("~");return a!==-1&&(c=c.substring(0,a)),o&&(c=`${c}~${o}`),{id:c}}f.modify=I;function i(s){const o=s.id.lastIndexOf("~");if(o!==-1)return s.id.substring(o+1)}f.getModifier=i;function r(s,o){return s.id===o.id&&s.color?.id===o.color?.id}f.isEqual=r;function t(s,o){return{id:s.id,color:o?S(o):void 0}}f.asThemeIcon=t,f.asClassNameArray=A.CSSIcon.asClassNameArray,f.asClassName=A.CSSIcon.asClassName,f.asCSSSelector=A.CSSIcon.asCSSSelector})(C=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=A.Codicon.file,e.FolderThemeIcon=A.Codicon.folder;function b(f){switch(f){case R.ColorScheme.DARK:return"vs-dark";case R.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case R.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=b,e.Extensions={ThemingContribution:"base.contributions.theming"};class m{constructor(){this.a=[],this.a=[],this.b=new n.Emitter}onColorThemeChange(l){return this.a.push(l),this.b.fire(l),(0,D.toDisposable)(()=>{const d=this.a.indexOf(l);this.a.splice(d,1)})}get onThemingParticipantAdded(){return this.b.event}getThemingParticipants(){return this.a}}const p=new m;T.Registry.add(e.Extensions.ThemingContribution,p);function h(f){return p.onColorThemeChange(f)}e.registerThemingParticipant=h;class y extends D.Disposable{constructor(l){super(),this.k=l,this.h=l.getColorTheme(),this.B(this.k.onDidColorThemeChange(d=>this.n(d)))}n(l){this.h=l,this.updateStyles()}updateStyles(){}w(l,d){let g=this.h.getColor(l);return g&&d&&(g=d(g,this.h)),g?g.toString():null}}e.Themable=y}),define(re[245],ae([0,1,52,8,174,115]),function(_,e,A,n,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function T(m,p){const h=[{name:null,description:(0,D.localize)(0,null)}];return h.push(...m.map(y=>({name:y.profileName,description:R(y)}))),p&&h.push(...p.map(y=>({name:y.title,description:P(y)}))),{values:h.map(y=>y.name),markdownDescriptions:h.map(y=>y.description)}}e.createProfileSchemaEnums=T;function R(m){let p=`$(${k.ThemeIcon.isThemeIcon(m.icon)?m.icon.id:m.icon?m.icon:A.Codicon.terminal.id}) ${m.profileName}
- path: ${m.path}`;return m.args&&(typeof m.args=="string"?p+=`
- args: "${m.args}"`:p+=`
- args: [${m.args.length===0?"":`'${m.args.join("','")}'`}]`),m.overrideName!==void 0&&(p+=`
- overrideName: ${m.overrideName}`),m.color&&(p+=`
- color: ${m.color}`),m.env&&(p+=`
- env: ${JSON.stringify(m.env)}`),p}function P(m){return`$(${k.ThemeIcon.isThemeIcon(m.icon)?m.icon.id:m.icon?m.icon:A.Codicon.terminal.id}) ${m.title}
- extensionIdentifier: ${m.extensionIdentifier}`}function S(m,p){if(!m&&!p)return!0;if(typeof m=="string"&&typeof p=="string")return m===p;if(Array.isArray(m)&&Array.isArray(p)){if(m.length!==p.length)return!1;for(let h=0;h<m.length;h++)if(m[h]!==p[h])return!1;return!0}return!1}e.terminalProfileArgsMatch=S;function C(m,p){if(!m&&!p)return!0;if(!m||!p)return!1;if(k.ThemeIcon.isThemeIcon(m)&&k.ThemeIcon.isThemeIcon(p))return m.id===p.id&&m.color===p.color;if(typeof m=="object"&&"light"in m&&"dark"in m&&typeof p=="object"&&"light"in p&&"dark"in p){const h=m,y=p;if((n.URI.isUri(h.light)||b(h.light))&&(n.URI.isUri(h.dark)||b(h.dark))&&(n.URI.isUri(y.light)||b(y.light))&&(n.URI.isUri(y.dark)||b(y.dark)))return h.light.path===y.light.path&&h.dark.path===y.dark.path}if(n.URI.isUri(m)&&n.URI.isUri(p)||b(m)||b(p)){const h=m,y=p;return h.path===y.path&&h.scheme===y.scheme}return!1}e.terminalIconsEqual=C;function b(m){return m?typeof m.path=="string"&&typeof m.scheme=="string":!1}e.isUriComponents=b}),define(re[246],ae([0,1,52,173,46,40,245]),function(_,e,A,n,D,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from(A.Codicon.getAll(),v=>v.id),markdownEnumDescriptions:Array.from(A.Codicon.getAll(),v=>`$(${v.id})`)};const R={args:{description:(0,n.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,n.localize)(1,null),type:"boolean"},icon:{description:(0,n.localize)(2,null),...e.terminalIconSchema},color:{description:(0,n.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,n.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},P={type:"object",required:["path"],properties:{path:{description:(0,n.localize)(5,null),type:["string","array"],items:{type:"string"}},...R}},S={type:"object",required:["path"],properties:{path:{description:(0,n.localize)(6,null),type:["string"],items:{type:"string"}},...R}},C=(0,n.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),b=(0,n.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),m=(0,n.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),p=(0,n.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),h=(0,n.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),y=(0,n.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),f={id:"terminal",order:100,title:(0,n.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:p},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:h},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:y},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(17,null,"`terminal.integrated.automationShell.linux`"),type:["object","null"],default:null,anyOf:[{type:"null"},S],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(18,null,"`terminal.integrated.automationShell.osx`"),type:["object","null"],default:null,anyOf:[{type:"null"},S],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(19,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},S],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:C},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:b},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:m},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:C},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:b},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,n.localize)(26,null)}},{type:"string",markdownDescription:(0,n.localize)(27,null)}],default:[],markdownDeprecationMessage:m},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,n.localize)(29,null),enum:["PowerShell","Git Bash"]},...R}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(30,null),type:"string"},id:{description:(0,n.localize)(31,null),type:"string"},title:{description:(0,n.localize)(32,null),type:"string"},...R}},{type:"null"},P]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(34,null),type:"string"},id:{description:(0,n.localize)(35,null),type:"string"},title:{description:(0,n.localize)(36,null),type:"string"},...R}},{type:"null"},P]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(38,null),type:"string"},id:{description:(0,n.localize)(39,null),type:"string"},title:{description:(0,n.localize)(40,null),type:"string"},...R}},{type:"null"},P]}},["terminal.integrated.useWslProfiles"]:{description:(0,n.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,n.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,n.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,n.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,n.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function l(){k.Registry.as(D.Extensions.Configuration).registerConfiguration(f),g()}e.registerTerminalPlatformConfiguration=l;let d;function g(v,I){const i=k.Registry.as(D.Extensions.Configuration);let r;v&&(r=(0,T.createProfileSchemaEnums)(v?.profiles,I));const t=d;d={id:"terminal",order:100,title:(0,n.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:v?.os===3?r?.values:void 0,markdownEnumDescriptions:v?.os===3?r?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:v?.os===2?r?.values:void 0,markdownEnumDescriptions:v?.os===2?r?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:v?.os===1?r?.values:void 0,markdownEnumDescriptions:v?.os===1?r?.markdownDescriptions:void 0}}},i.updateConfigurations({add:[d],remove:t?[t]:[]})}e.registerTerminalDefaultProfileConfiguration=g}),define(re[247],ae([0,1,50,52,12,5,28,91,243,115]),function(_,e,A,n,D,k,T,R,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let C,b=!0;function m(r,t,s,o,c=process.env,a,u,w,E){return a=a||{existsFile:T.SymlinkSupport.existsFile,readFile:T.Promises.readFile},k.isWindows?p(s,a,c,u,o.getValue("terminal.integrated.useWslProfiles")!==!1,r&&typeof r=="object"?{...r}:o.getValue("terminal.integrated.profiles.windows"),typeof t=="string"?t:o.getValue("terminal.integrated.defaultProfile.windows"),E,w):v(a,u,s,r&&typeof r=="object"?{...r}:o.getValue(k.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof t=="string"?t:o.getValue(k.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),E,w,c)}e.detectAvailableProfiles=m;async function p(r,t,s,o,c,a,u,w,E){const N=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),O=`${process.env.windir}\\${N?"Sysnative":"System32"}`;let j=!1;(0,P.getWindowsBuildNumber)()>=16299&&(j=!0),await f(w);const M=new Map;r&&(M.set("PowerShell",{source:"PowerShell",icon:n.Codicon.terminalPowershell,isAutoDetected:!0}),M.set("Windows PowerShell",{path:`${O}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:n.Codicon.terminalPowershell,isAutoDetected:!0}),M.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),M.set("Command Prompt",{path:`${O}\\cmd.exe`,icon:n.Codicon.terminalCmd,isAutoDetected:!0}),M.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),M.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:n.Codicon.terminalBash,isAutoDetected:!0})),I(a,M);const L=await h(M.entries(),u,t,s,o,E);if(r||c)try{const F=await d(`${O}\\${j?"wsl":"bash"}.exe`,u);for(const z of F)(!a||!(z.profileName in a))&&L.push(z)}catch{b&&(o?.info("WSL is not installed, so could not detect WSL profiles"),b=!1)}return L}async function h(r,t,s,o=process.env,c,a){const u=[];for(const[w,E]of r){if(E===null)continue;let N,O,j;if("source"in E){const F=C?.get(E.source);if(!F)continue;N=F.paths,O=E.args||F.args,E.icon?j=y(E.icon):F.icon&&(j=F.icon)}else N=Array.isArray(E.path)?E.path:[E.path],O=k.isWindows||Array.isArray(E.args)?E.args:void 0,j=y(E.icon);let M;if(a){const F=N.map(H=>typeof H=="string"?H:H.path),z=await a(F);M=new Array(N.length);for(let H=0;H<N.length;H++)typeof N[H]=="string"?M[H]=N[H]:M[H]={path:z[H],isUnsafe:!0}}else M=N.slice();const L=await i(w,t,M,s,o,O,E.env,E.overrideName,E.isAutoDetected,c);L?(L.isAutoDetected=E.isAutoDetected,L.icon=j,L.color=E.color,u.push(L)):c?.debug("Terminal profile not validated",w,N)}return c?.debug("Validated terminal profiles",u),u}function y(r){return typeof r=="string"?{id:r}:r}async function f(r){C&&!r||(C=new Map,C.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login","-i"]}),C.set("PowerShell",{profileName:"PowerShell",paths:r||await l(),icon:S.ThemeIcon.asThemeIcon(n.Codicon.terminalPowershell)}))}async function l(){const r=[];for await(const t of(0,R.enumeratePowerShellInstallations)())r.push(t.exePath);return r}async function d(r,t){const s=[],o=await new Promise((u,w)=>{A.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(E,N)=>{if(E)return w("Problem occurred when getting wsl distros");u(N)})});if(!o)return[];const c=new RegExp(/[\r?\n]/),a=o.split(c).filter(u=>u.trim().length>0&&u!=="");for(const u of a){if(u===""||u.startsWith("docker-desktop"))continue;const w=`${u} (WSL)`,E={profileName:w,path:r,args:["-d",`${u}`],isDefault:w===t,icon:g(u),isAutoDetected:!1};s.push(E)}return s}function g(r){return r.includes("Ubuntu")?S.ThemeIcon.asThemeIcon(n.Codicon.terminalUbuntu):r.includes("Debian")?S.ThemeIcon.asThemeIcon(n.Codicon.terminalDebian):S.ThemeIcon.asThemeIcon(n.Codicon.terminalLinux)}async function v(r,t,s,o,c,a,u,w){const E=new Map;if(s){const N=(await r.readFile("/etc/shells")).toString(),O=a||N.split(`
`).filter(M=>M.trim().includes("#")&&M.trim().length>0),j=new Map;for(const M of O){let L=(0,D.basename)(M),F=j.get(L)||0;F++,F>1&&(L=`${L} (${F})`),j.set(L,F),E.set(L,{path:M,isAutoDetected:!0})}}return I(o,E),await h(E.entries(),c,r,w,t,u)}function I(r,t){if(!!r)for(const[s,o]of Object.entries(r))o===null||!("path"in o)&&!("source"in o)?t.delete(s):(o.icon=o.icon||t.get(s)?.icon,t.set(s,o))}async function i(r,t,s,o,c,a,u,w,E,N){if(s.length===0)return Promise.resolve(void 0);const O=s.shift();if(O==="")return i(r,t,s,o,c,a,u,w,E);const j=typeof O!="string"&&O.isUnsafe,M=typeof O=="string"?O:O.path,L={profileName:r,path:M,args:a,env:u,overrideName:w,isAutoDetected:E,isDefault:r===t,isUnsafePath:j};if((0,D.basename)(M)===M){const z=c.PATH?c.PATH.split(D.delimiter):void 0,H=await(0,P.findExecutable)(M,void 0,z,void 0,o.existsFile);return H?(L.path=H,L.isFromPath=!0,L):i(r,t,s,o,c,a)}return await o.existsFile((0,D.normalize)(M))?L:i(r,t,s,o,c,a,u,w,E)}}),define(re[248],ae([0,1,3,2,24,5,39,68,16,15,95,229,9,104,241,114,246,247]),function(_,e,A,n,D,k,T,R,P,S,C,b,m,p,h,y,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var d;(function(I){I[I.MaxRestarts=5]="MaxRestarts"})(d||(d={}));let g=0,v=class extends n.Disposable{constructor(i,r,t,s){super(),this.C=i,this.D=r,this.F=t,this.G=s,this.g=0,this.h=!0,this.i=!1,this.l=this.B(new A.Emitter),this.onPtyHostExit=this.l.event,this.m=this.B(new A.Emitter),this.onPtyHostStart=this.m.event,this.n=this.B(new A.Emitter),this.onPtyHostUnresponsive=this.n.event,this.p=this.B(new A.Emitter),this.onPtyHostResponsive=this.p.event,this.r=this.B(new A.Emitter),this.onPtyHostRequestResolveVariables=this.r.event,this.s=this.B(new A.Emitter),this.onProcessData=this.s.event,this.t=this.B(new A.Emitter),this.onProcessReady=this.t.event,this.u=this.B(new A.Emitter),this.onProcessReplay=this.u.event,this.v=this.B(new A.Emitter),this.onProcessOrphanQuestion=this.v.event,this.w=this.B(new A.Emitter),this.onDidRequestDetach=this.w.event,this.y=this.B(new A.Emitter),this.onDidChangeProperty=this.y.event,this.z=this.B(new A.Emitter),this.onProcessExit=this.z.event,(0,f.registerTerminalPlatformConfiguration)(),this.c=this.J(),this.B((0,n.toDisposable)(()=>this.M())),this.f=this.B(new h.RequestStore(void 0,this.G)),this.f.onCreateRequest(this.r.fire,this.r),[this.a,this.b]=this.L(),this.B(this.D.onDidChangeConfiguration(async o=>{o.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.I()}))}initialize(){this.I()}get H(){return this.D.getValue("terminal.integrated.ignoreProcessNames")}async I(){return this.b.refreshIgnoreProcessNames?.(this.H)}async J(){if(k.isWindows)return process.env;try{return await(0,b.getResolvedShellEnv)(this.D,this.G,{_:[]},process.env)}catch(i){return this.G.error("ptyHost was unable to resolve shell environment",i),{}}}L(){const i={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this.F.logsPath],env:{VSCODE_LAST_PTY_ID:g,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this.C.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this.C.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this.C.scrollback}},r=(0,C.parsePtyHostPort)(this.F.args,this.F.isBuilt);r&&(r.break&&r.port?i.debugBrk=r.port:!r.break&&r.port&&(i.debug=r.port));const t=new R.Client(D.FileAccess.asFileUri("bootstrap-fork").fsPath,i);this.m.fire(),T.ProxyChannel.toService(t.getChannel(y.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.N()),this.N(),this.B(t.onDidProcessExit(a=>{this.l.fire(a.code),this.i||(this.g<=d.MaxRestarts?(this.G.error(`ptyHost terminated unexpectedly with code ${a.code}`),this.g++,this.restartPtyHost()):this.G.error(`ptyHost terminated unexpectedly with code ${a.code}, giving up`))}));const o=t.getChannel(y.TerminalIpcChannels.Log);p.LogLevelChannelClient.setLevel(o,this.G.getLevel()),this.B(this.G.onDidChangeLogLevel(()=>{p.LogLevelChannelClient.setLevel(o,this.G.getLevel())}));const c=T.ProxyChannel.toService(t.getChannel(y.TerminalIpcChannels.PtyHost));return this.B(c.onProcessData(a=>this.s.fire(a))),this.B(c.onProcessReady(a=>this.t.fire(a))),this.B(c.onProcessExit(a=>this.z.fire(a))),this.B(c.onDidChangeProperty(a=>this.y.fire(a))),this.B(c.onProcessReplay(a=>this.u.fire(a))),this.B(c.onProcessOrphanQuestion(a=>this.v.fire(a))),this.B(c.onDidRequestDetach(a=>this.w.fire(a))),[t,c]}dispose(){this.i=!0,super.dispose()}async createProcess(i,r,t,s,o,c,a,u,w,E,N){const O=setTimeout(()=>this.Q(),y.HeartbeatConstants.CreateProcessTimeout),j=await this.b.createProcess(i,r,t,s,o,c,a,u,w,E,N);return clearTimeout(O),g=Math.max(g,j),j}updateTitle(i,r,t){return this.b.updateTitle(i,r,t)}updateIcon(i,r,t,s){return this.b.updateIcon(i,r,t,s)}attachToProcess(i){return this.b.attachToProcess(i)}detachFromProcess(i,r){return this.b.detachFromProcess(i,r)}listProcesses(){return this.b.listProcesses()}reduceConnectionGraceTime(){return this.b.reduceConnectionGraceTime()}start(i){return this.b.start(i)}shutdown(i,r){return this.b.shutdown(i,r)}input(i,r){return this.b.input(i,r)}processBinary(i,r){return this.b.processBinary(i,r)}resize(i,r,t){return this.b.resize(i,r,t)}acknowledgeDataEvent(i,r){return this.b.acknowledgeDataEvent(i,r)}setUnicodeVersion(i,r){return this.b.setUnicodeVersion(i,r)}getInitialCwd(i){return this.b.getInitialCwd(i)}getCwd(i){return this.b.getCwd(i)}getLatency(i){return this.b.getLatency(i)}orphanQuestionReply(i){return this.b.orphanQuestionReply(i)}installAutoReply(i,r){return this.b.installAutoReply(i,r)}uninstallAllAutoReplies(){return this.b.uninstallAllAutoReplies()}uninstallAutoReply(i){return this.b.uninstallAutoReply(i)}getDefaultSystemShell(i){return this.b.getDefaultSystemShell(i)}async getProfiles(i,r,t,s=!1){const o=await this.c;return(0,l.detectAvailableProfiles)(r,t,s,this.D,o,void 0,this.G,this.S.bind(this,i))}getEnvironment(){return this.b.getEnvironment()}getWslPath(i,r){return this.b.getWslPath(i,r)}getRevivedPtyNewId(i){return this.b.getRevivedPtyNewId(i)}setTerminalLayoutInfo(i){return this.b.setTerminalLayoutInfo(i)}async getTerminalLayoutInfo(i){return await this.b.getTerminalLayoutInfo(i)}async requestDetachInstance(i,r){return this.b.requestDetachInstance(i,r)}async acceptDetachInstanceReply(i,r){return this.b.acceptDetachInstanceReply(i,r)}async freePortKillProcess(i){if(!this.b.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.b.freePortKillProcess(i)}async serializeTerminalState(i){return this.b.serializeTerminalState(i)}async reviveTerminalProcesses(i,r){return this.b.reviveTerminalProcesses(i,r)}async refreshProperty(i,r){return this.b.refreshProperty(i,r)}async updateProperty(i,r,t){return this.b.updateProperty(i,r,t)}async restartPtyHost(){this.h=!0,this.M(),[this.a,this.b]=this.L()}M(){this.b.shutdownAll?.(),this.a.dispose()}N(){this.R(),this.j=setTimeout(()=>this.O(),y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier),this.h||(this.h=!0,this.p.fire())}O(){this.G.warn(`No ptyHost heartbeat after ${y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.j=void 0,this.k=setTimeout(()=>this.P(),y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.SecondWaitMultiplier)}P(){this.G.error(`No ptyHost heartbeat after ${(y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier+y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.k=void 0,this.h&&(this.h=!1,this.n.fire())}Q(){this.R(),this.G.error(`No ptyHost response to createProcess after ${y.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.h&&(this.h=!1,this.n.fire())}R(){this.j&&(clearTimeout(this.j),this.j=void 0),this.k&&(clearTimeout(this.k),this.k=void 0)}S(i,r){return this.f.createRequest({workspaceId:i,originalText:r})}async acceptPtyHostResolvedVariables(i,r){this.f.acceptReply(i,r)}};v=ye([Y(1,P.IConfigurationService),Y(2,S.IEnvironmentService),Y(3,m.ILogService)],v),e.PtyHostService=v}),define(re[77],ae([0,1,3,16,4,9]),function(_,e,A,n,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,D.createDecorator)("sharedTunnelsService");var T;(function(y){y.Http="http",y.Https="https"})(T=e.TunnelProtocol||(e.TunnelProtocol={}));var R;(function(y){y.ConstantPrivate="constantPrivate",y.Private="private",y.Public="public"})(R=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var P;(function(y){y[y.Notify=1]="Notify",y[y.OpenBrowser=2]="OpenBrowser",y[y.OpenPreview=3]="OpenPreview",y[y.Silent=4]="Silent",y[y.Ignore=5]="Ignore",y[y.OpenBrowserOnce=6]="OpenBrowserOnce"})(P=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function S(y){if(y.scheme!=="http"&&y.scheme!=="https")return;const f=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(y.authority);if(!!f)return{address:f[1],port:+f[2]}}e.extractLocalHostUriMetaDataForPortMapping=S,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function C(y){return e.LOCALHOST_ADDRESSES.indexOf(y)>=0}e.isLocalhost=C,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function b(y){return e.ALL_INTERFACES_ADDRESSES.indexOf(y)>=0}e.isAllInterfaces=b;function m(y,f,l,d){if(l===1)return!1;if(l===2&&b(f)){const g=/(\d+)\.(\d+)\.(\d+)/g.exec(d);if(g?.length===4&&parseInt(g[1])>=18)return!1}return y<1024}e.isPortPrivileged=m;class p{constructor(f,l,d){this.remoteAddress=f,this.localAddress=l,this.b=d,this.a=new A.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=p;let h=class{constructor(f,l){this.i=f,this.j=l,this.a=new A.Emitter,this.onTunnelOpened=this.a.event,this.b=new A.Emitter,this.onTunnelClosed=this.b.event,this.c=new A.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const f=this.j.getValue("remote.localPortHost");return!f||f==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(f){return this.e=f,f?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(f){this.f=f.elevation,this.g=f.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const f=[],l=Array.from(this.d.values());for(const d of l){const g=Array.from(d.values());for(const v of g){const I=await v.value;I&&f.push(I)}}return f}async dispose(){for(const f of this.d.values()){for(const{value:l}of f.values())await l.then(d=>d?.dispose());f.clear()}this.d.clear()}setEnvironmentTunnel(f,l,d,g,v){this.o(f,l,Promise.resolve({tunnelRemoteHost:f,tunnelRemotePort:l,localAddress:d,privacy:g,protocol:v,dispose:()=>Promise.resolve()}))}async getExistingTunnel(f,l){(b(f)||C(f))&&(f=e.LOCALHOST_ADDRESSES[0]);const d=this.q(f,l);if(d)return++d.refcount,d.value}openTunnel(f,l,d,g,v=!1,I,i){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${l}:${d} on local port ${g}.`),!f)return;if(l||(l="localhost"),this.e&&this.h.has(d)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.r(f,l,d,g,v,I,i);return r?r.then(t=>{if(!t){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(l,d);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.m(t);return(t.tunnelRemoteHost!==l||t.tunnelRemotePort!==d)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(s),s}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}m(f){return{tunnelRemotePort:f.tunnelRemotePort,tunnelRemoteHost:f.tunnelRemoteHost,tunnelLocalPort:f.tunnelLocalPort,localAddress:f.localAddress,privacy:f.privacy,protocol:f.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${f.tunnelRemoteHost}:${f.tunnelRemotePort} `);const l=this.d.get(f.tunnelRemoteHost);if(l){const d=l.get(f.tunnelRemotePort);d&&(d.refcount--,await this.n(f.tunnelRemoteHost,f.tunnelRemotePort,d))}}}}async n(f,l,d){if(d.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${f}:${l}.`);const g=d.value.then(async v=>{v&&(await v.dispose(!0),this.b.fire({host:v.tunnelRemoteHost,port:v.tunnelRemotePort}))});return this.d.has(f)&&this.d.get(f).delete(l),g}}async closeTunnel(f,l){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${f}:${l} `);const d=this.d.get(f);if(d&&d.has(l)){const g=d.get(l);g.refcount=0,await this.n(f,l,g)}}o(f,l,d){this.d.has(f)||this.d.set(f,new Map),this.d.get(f).set(l,{refcount:1,value:d})}async p(f,l){const d=this.d.get(f);d&&(await d.get(l)||d.delete(l),d.size===0&&this.d.delete(f))}q(f,l){const d=[f];C(f)?(d.push(...e.LOCALHOST_ADDRESSES),d.push(...e.ALL_INTERFACES_ADDRESSES)):b(f)&&d.push(...e.ALL_INTERFACES_ADDRESSES);const g=d.map(v=>this.d.get(v));for(const v of g){const I=v?.get(l);if(I)return I}}canTunnel(f){return!!S(f)}s(f,l,d,g,v,I,i){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${l}:${d} on local port ${g}.`);const r=d;this.h.add(r);const t=g===void 0?d:g,s={elevationRequired:v?this.isPortPrivileged(t):!1},o={remoteAddress:{host:l,port:d},localAddressPort:g,privacy:I,public:I?I!==R.Private:void 0,protocol:i},c=f.forwardPort(o,s);return c?(this.o(l,d,c),c.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(r)})):this.h.delete(r),c}};h=ye([Y(0,k.ILogService),Y(1,n.IConfigurationService)],h),e.AbstractTunnelService=h}),define(re[249],ae([0,1,9,77,2,7,6]),function(_,e,A,n,D,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class R extends D.Disposable{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new T.DeferredPromise),this.b.p)}setAddress(C){this.a=C,this.b&&(this.b.complete(C),this.b=null)}setTunnel(C){this.B(C)}}let P=class Dt extends D.Disposable{constructor(C,b){super(),this.f=C,this.g=b,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(C=>C.dispose())}async createTunnel(){return{id:String(++Dt.a)}}async startTunnel(C,b,m,p,h,y){const f=new R,l=await Promise.resolve(this.f.openTunnel(C,f,m,p,h,y));if(!l)throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${m}:${p} (remote).`),f.dispose(),new Error("Could not create tunnel");if(this.c.has(b))throw this.c.delete(b),f.dispose(),await l.dispose(),(0,k.canceled)();return f.setTunnel(l),this.b.set(b,f),this.g.info(`[SharedProcessTunnelService] Created tunnel ${b}: ${l.localAddress} (local) to ${m}:${p} (remote).`),{tunnelLocalPort:l.tunnelLocalPort,localAddress:l.localAddress}}async setAddress(C,b){const m=this.b.get(C);!m||m.setAddress(b)}async destroyTunnel(C){const b=this.b.get(C);if(b){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${C}.`),this.b.delete(C),await b.dispose();return}this.c.add(C)}};P.a=0,P=ye([Y(0,n.ISharedTunnelsService),Y(1,A.ILogService)],P),e.SharedProcessTunnelService=P}),define(re[250],ae([0,1,86,34,133,221,6,2,16,9,25,219,77,109,5]),function(_,e,A,n,D,k,T,R,P,S,C,b,m,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function y(v,I,i,r,t){let s;for(let o=3;o&&(s?.dispose(),s=await new f(v,I,i,r,t).waitForReady(),!(t&&D.BROWSER_RESTRICTED_PORTS[t]||!D.BROWSER_RESTRICTED_PORTS[s.tunnelLocalPort]));o--);return s}class f extends R.Disposable{constructor(I,i,r,t,s){super(),this.j=i,this.k=s,this.privacy=m.TunnelPrivacyId.Private,this.i=new Map,this.a=I,this.b=A.createServer(),this.c=new T.Barrier,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=o=>this.l(o),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=t,this.tunnelRemoteHost=r}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.i.values()).forEach(i=>{i()})}async waitForReady(){const I=this.k??this.tunnelRemotePort,i=(0,m.isAllInterfaces)(this.j)?"0.0.0.0":"127.0.0.1";let r=await(0,D.findFreePortFaster)(I,2,1e3,i),t=null;return this.b.listen(r,this.j),await this.c.wait(),t=this.b.address(),t||(r=0,this.b.listen(r,this.j),await this.c.wait(),t=this.b.address()),this.tunnelLocalPort=t.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${t.port}`,this}async l(I){I.pause();const i=(0,m.isLocalhost)(this.tunnelRemoteHost)||(0,m.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,r=await(0,b.connectRemoteAgentTunnel)(this.a,i,this.tunnelRemotePort),t=r.getSocket().socket,s=r.readEntireBuffer();r.dispose(),s.byteLength>0&&I.write(s.buffer),I.on("end",()=>{I.localAddress&&this.i.delete(I.localAddress),t.end()}),I.on("close",()=>t.end()),I.on("error",()=>{I.localAddress&&this.i.delete(I.localAddress),t.destroy()}),t.on("end",()=>I.end()),t.on("close",()=>I.end()),t.on("error",()=>{I.destroy()}),I.pipe(t),t.pipe(I),I.localAddress&&this.i.set(I.localAddress,()=>{I.end(),t.end()})}}let l=class extends m.AbstractTunnelService{constructor(I,i,r,t,s){super(i,s),this.t=I,this.u=r,this.v=t}isPortPrivileged(I){return(0,m.isPortPrivileged)(I,this.k,h.OS,n.release())}r(I,i,r,t,s,o,c){const a=this.q(i,r);if(a)return++a.refcount,a.value;if(this.e)return this.s(this.e,i,r,t,s,o,c);{this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${i}:${r} on local port ${t}.`);const u={commit:this.v.commit,quality:this.v.quality,socketFactory:this.t,addressProvider:I,signService:this.u,logService:this.i,ipcLogger:null},w=y(u,this.k,i,r,t);return this.i.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.o(i,r,w),w}}};l=ye([Y(1,S.ILogService),Y(2,p.ISignService),Y(3,C.IProductService),Y(4,P.IConfigurationService)],l),e.BaseTunnelService=l;let d=class extends l{constructor(I,i,r,t){super(k.nodeSocketFactory,I,i,r,t)}};d=ye([Y(0,S.ILogService),Y(1,p.ISignService),Y(2,C.IProductService),Y(3,P.IConfigurationService)],d),e.TunnelService=d;let g=class extends R.Disposable{constructor(I,i,r,t){super(),this.b=I,this.c=i,this.f=r,this.g=t,this.a=new Map}async openTunnel(I,i,r,t,s,o,c,a){if(this.b.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${r}:${t} on local port ${s}.`),!this.a.has(I)){const u=new d(this.b,this.f,this.c,this.g);this.B(u),this.a.set(I,u),u.onTunnelClosed(async()=>{(await u.tunnels).length===0&&(u.dispose(),this.a.delete(I))})}return this.a.get(I).openTunnel(i,r,t,s,o,c,a)}};g=ye([Y(0,S.ILogService),Y(1,C.IProductService),Y(2,p.ISignService),Y(3,P.IConfigurationService)],g),e.SharedTunnelsService=g}),define(re[29],ae([0,1,4]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,A.createDecorator)("IUriIdentityService")}),define(re[251],ae([0,1,29,71,13,22,131,3,2]),function(_,e,A,n,D,k,T,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class S{constructor(m){this.uri=m,this.time=S._clock++}touch(){return this.time=S._clock++,this}}S._clock=0;let C=class{constructor(m){this.g=m,this.c=new P.DisposableStore,this.f=2**16;const p=new Map,h=y=>{let f=p.get(y.scheme);return f===void 0&&(f=m.hasProvider(y)&&!this.g.hasCapability(y,1024),p.set(y.scheme,f)),f};this.c.add(R.Event.any(m.onDidChangeFileSystemProviderRegistrations,m.onDidChangeFileSystemProviderCapabilities)(y=>{p.delete(y.scheme)})),this.extUri=new k.ExtUri(h),this.d=new T.SkipList((y,f)=>this.extUri.compare(y,f,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(m){this.g.hasProvider(m)&&(m=(0,k.normalizePath)(m));const p=this.d.get(m);return p?p.touch().uri.with({fragment:m.fragment}):(this.d.set(m,new S(m)),this.h(),m)}h(){if(this.d.size<this.f)return;const m=[...this.d.entries()].sort((h,y)=>h[1].touch<y[1].touch?1:h[1].touch>y[1].touch?-1:0);S._clock=0,this.d.clear();const p=this.f*.5;for(let h=0;h<p;h++)this.d.set(m[h][0],m[h][1].touch())}};C=ye([Y(0,D.IFileService)],C),e.UriIdentityService=C,(0,n.registerSingleton)(A.IUriIdentityService,C,1)}),define(re[252],ae([0,1,3,2,13,44,49,17]),function(_,e,A,n,D,k,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class P extends n.Disposable{get capabilities(){return this.f.capabilities&-5}constructor(C,b,m,p){super(),this.c=C,this.f=b,this.g=m,this.h=p,this.onDidChangeCapabilities=this.f.onDidChangeCapabilities,this.a=this.B(new A.Emitter),this.onDidChangeFile=this.a.event,this.b=T.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this.B(this.f.onDidChangeFile(h=>this.i(h)))}watch(C,b){this.b.set(C,C);const m=this.f.watch(this.j(C),b);return(0,n.toDisposable)(()=>{this.b.delete(C),m.dispose()})}stat(C){return this.f.stat(this.j(C))}mkdir(C){return this.f.mkdir(this.j(C))}rename(C,b,m){return this.f.rename(this.j(C),this.j(b),m)}readFile(C){return this.f.readFile(this.j(C),{atomic:!0})}readFileStream(C,b,m){const p=(0,k.newWriteableStream)(h=>R.VSBuffer.concat(h.map(y=>R.VSBuffer.wrap(y))).buffer);return(async()=>{try{const h=await this.readFile(C);p.end(h)}catch(h){p.error(h),p.end()}})(),p}readdir(C){return this.f.readdir(this.j(C))}writeFile(C,b,m){return this.f.writeFile(this.j(C),b,m)}delete(C,b){return this.f.delete(this.j(C),b)}copy(C,b,m){if((0,D.hasFileFolderCopyCapability)(this.f))return this.f.copy(this.j(C),this.j(b),m);throw new Error("copy not supported")}i(C){const b=[];for(const m of C){if(m.resource.scheme!==this.c)continue;const p=this.k(m.resource);this.b.findSubstr(p)&&b.push({resource:p,type:m.type})}b.length&&(this.h.debug("User data changed"),this.a.fire(b))}j(C){return C.with({scheme:this.c})}k(C){return C.with({scheme:this.g})}}e.FileUserDataProvider=P}),define(re[61],ae([0,1,83]),function(_,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function n(T,R,P,S){const C=(0,A.setProperty)(T,R,P,S)[0];return C&&(T=T.substring(0,C.offset)+C.content+T.substring(C.offset+C.length)),T}e.edit=n;function D(T,R,P){let S=P;for(;S>=0;){if(T.charAt(S)===R.charAt(R.length-1)&&R.length===1)return S+1;if(S--,R.length===2&&S>=0&&T.charAt(S)===R.charAt(0))return S+2}return 0}e.getLineStartOffset=D;function k(T,R,P){let S=P;for(;S>=0;)if(T.charAt(S)===R.charAt(R.length-1)&&R.length===1||(S++,R.length===2&&S>=0&&T.charAt(S)===R.charAt(1)))return S;return T.length-1}e.getLineEndOffset=k}),define(re[253],ae([0,1,32,54,14]),function(_,e,A,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function k(p,h,y,f,l,d){const g=[],v=[],I=[];if(!h){const F=p.filter(({identifier:z})=>l.every(H=>H.toLowerCase()!==z.id.toLowerCase()));return{local:{added:g,removed:v,updated:I},remote:F.length>0?{added:F,updated:[],removed:[],all:F}:null}}p=p.map(b),h=h.map(b),y=y?y.map(b):null;const i=new Map,r=F=>{F.uuid&&i.set(F.id.toLowerCase(),F.uuid)};p.forEach(({identifier:F})=>r(F)),h.forEach(({identifier:F})=>r(F)),y?.forEach(({identifier:F})=>r(F));const t=F=>{const z=F.identifier.uuid||i.get(F.identifier.id.toLowerCase());return z?`uuid:${z}`:`id:${F.identifier.id.toLowerCase()}`},s=(F,z)=>(F.set(t(z),z),F),o=p.reduce(s,new Map),c=h.reduce(s,new Map),a=h.reduce((F,z)=>s(F,(0,A.deepClone)(z)),new Map),u=y?y.reduce(s,new Map):null,w=f.reduce(s,new Map),E=l.reduce((F,z)=>{const H=i.get(z.toLowerCase());return F.add(H?`uuid:${H}`:`id:${z.toLowerCase()}`)},new Set),N=d.reduce((F,{id:z,uuid:H})=>(H=H??i.get(z.toLowerCase()),F.add(H?`uuid:${H}`:`id:${z.toLowerCase()}`)),new Set),O=T(o,c,E,!1);if(O.added.size>0||O.removed.size>0||O.updated.size>0){const F=T(u,o,E,!1),z=T(u,c,E,!0),H=(Q,K,V,W)=>({...W,installed:K.installed||V.installed,version:V.version&&(!K.installed||n.gt(V.version,K.version))?V.version:K.version,state:P(K,V,u?.get(Q)),preRelease:(K.installed?W.preRelease:V.preRelease)??K.preRelease});for(const Q of z.removed.values()){const K=o.get(Q);if(!K)continue;const V=(0,D.assertIsDefined)(u?.get(Q)),W=!N.has(Q)&&V.installed;K.installed&&W?v.push(K.identifier):a.set(Q,K)}for(const Q of z.added.values()){const K=(0,D.assertIsDefined)(c.get(Q)),V=o.get(Q);if(V){if(O.updated.has(Q)){const W=H(Q,V,K,K);R(V,K,!1,!1)||I.push(m(W,Q)),a.set(Q,W)}}else K.installed&&g.push(m(K,Q))}for(const Q of z.updated.values()){const K=(0,D.assertIsDefined)(c.get(Q)),V=(0,D.assertIsDefined)(u?.get(Q)),W=o.get(Q);if(W)if(!N.has(Q)&&V.installed&&W.installed&&!K.installed)v.push(W.identifier);else{const X=H(Q,W,K,K);I.push(m(X,Q)),a.set(Q,X)}else K.installed&&g.push(m(K,Q))}for(const Q of F.added.values())z.added.has(Q)||a.set(Q,(0,D.assertIsDefined)(o.get(Q)));for(const Q of F.updated.values()){if(z.removed.has(Q)||z.updated.has(Q))continue;const K=(0,D.assertIsDefined)(o.get(Q)),V=(0,D.assertIsDefined)(c.get(Q));a.set(Q,H(Q,K,V,K))}for(const Q of F.removed.values())z.updated.has(Q)||z.removed.has(Q)||w.has(Q)||!(0,D.assertIsDefined)(c.get(Q)).installed||N.has(Q)||!(0,D.assertIsDefined)(u?.get(Q)).installed||a.delete(Q)}const j=[],M=T(c,a,new Set,!0),L=M.added.size>0||M.updated.size>0||M.removed.size>0;return L&&a.forEach((F,z)=>j.push(m(F,z))),{local:{added:g,removed:v,updated:I},remote:L?{added:[...M.added].map(F=>a.get(F)),updated:[...M.updated].map(F=>a.get(F)),removed:[...M.removed].map(F=>c.get(F)),all:j}:null}}e.merge=k;function T(p,h,y,f){const l=p?[...p.keys()].filter(i=>!y.has(i)):[],d=[...h.keys()].filter(i=>!y.has(i)),g=d.filter(i=>l.indexOf(i)===-1).reduce((i,r)=>(i.add(r),i),new Set),v=l.filter(i=>d.indexOf(i)===-1).reduce((i,r)=>(i.add(r),i),new Set),I=new Set;for(const i of l){if(v.has(i))continue;const r=p.get(i),t=h.get(i);(!t||!R(r,t,f,!0))&&I.add(i)}return{added:g,removed:v,updated:I}}function R(p,h,y,f){return!(p.disabled!==h.disabled||f&&p.installed!==h.installed||p.installed&&h.installed&&p.preRelease!==h.preRelease||!C(p.state,h.state)||y&&p.version!==h.version)}function P(p,h,y){const f=p.state,l=h.state,d=y?.state;if(!h.version||f&&n.gt(p.version,h.version))return f;if(l&&n.gt(h.version,p.version)||!f)return l;if(!l)return f;const g=(0,A.deepClone)(f),v=d?S(d,l):{added:Object.keys(l).reduce((i,r)=>(i.add(r),i),new Set),removed:new Set,updated:new Set},I=d?S(d,f):{added:Object.keys(f).reduce((i,r)=>(i.add(r),i),new Set),removed:new Set,updated:new Set};for(const i of[...v.added.values(),...v.updated.values()])g[i]=l[i];for(const i of v.removed.values())I.updated.has(i)||delete g[i];return g}function S(p,h){const y=Object.keys(p),f=Object.keys(h),l=f.filter(v=>y.indexOf(v)===-1).reduce((v,I)=>(v.add(I),v),new Set),d=y.filter(v=>f.indexOf(v)===-1).reduce((v,I)=>(v.add(I),v),new Set),g=new Set;for(const v of y){if(d.has(v))continue;const I=p[v],i=h[v];(0,A.equals)(I,i)||g.add(v)}return{added:l,removed:d,updated:g}}function C(p={},h={}){const{added:y,removed:f,updated:l}=S(p,h);return y.size===0&&f.size===0&&l.size===0}function b(p){return{...p,disabled:!!p.disabled,installed:!!p.installed}}function m(p,h){const y={identifier:{id:p.identifier.id,uuid:h.startsWith("uuid:")?h.substring(5):void 0},preRelease:!!p.preRelease};return p.version&&(y.version=p.version),p.disabled&&(y.disabled=!0),p.installed&&(y.installed=!0),p.state&&(y.state=p.state),y}}),define(re[116],ae([0,1,21,16,4]),function(_,e,A,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,D.createDecorator)("IIgnoredExtensionsManagementService");let k=class{constructor(R){this.a=R}hasToNeverSyncExtension(R){return this.b().includes(R.toLowerCase())}hasToAlwaysSyncExtension(R){return this.b().includes(`-${R.toLowerCase()}`)}updateIgnoredExtensions(R,P){let S=[...this.a.getValue("settingsSync.ignoredExtensions")].map(C=>C.toLowerCase());return S=S.filter(C=>C!==R&&C!==`-${R}`),P&&S.push(R.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",S.length?S:void 0,2)}updateSynchronizedExtensions(R,P){let S=[...this.a.getValue("settingsSync.ignoredExtensions")].map(C=>C.toLowerCase());return S=S.filter(C=>C!==R&&C!==`-${R}`),P&&S.push(`-${R.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",S.length?S:void 0,2)}getIgnoredExtensions(R){const P=R.filter(m=>m.isMachineScoped).map(m=>m.identifier.id.toLowerCase()),S=this.b().map(m=>m.toLowerCase()),C=[],b=[];if(Array.isArray(S))for(const m of S)m.startsWith("-")?b.push(m.substring(1)):C.push(m);return(0,A.distinct)([...P,...C].filter(m=>b.indexOf(m)===-1))}b(){let R=this.a.inspect("settingsSync.ignoredExtensions").userValue;return R!==void 0||(R=this.a.inspect("sync.ignoredExtensions").userValue,R!==void 0)?R:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(P=>P.toLowerCase())}};k=ye([Y(0,n.IConfigurationService)],k),e.IgnoredExtensionsManagementService=k}),define(re[254],ae([0,1,21,35,32,194,61]),function(_,e,A,n,D,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function R(v){return(0,n.parse)(v)||[]}e.parseKeybindings=R;async function P(v,I,i,r,t){const s=R(v),o=R(I),c=i?R(i):null,a=[...s,...o,...c||[]].map(H=>H.key),u=await t.resolveUserBindings(a),w=C(s,o,c,u);if(!w.hasLocalForwarded&&!w.hasRemoteForwarded)return{mergeContent:v,hasChanges:!1,hasConflicts:!1};if(!w.hasLocalForwarded&&w.hasRemoteForwarded)return{mergeContent:I,hasChanges:!0,hasConflicts:!1};if(w.hasLocalForwarded&&!w.hasRemoteForwarded)return{mergeContent:v,hasChanges:!0,hasConflicts:!1};const E=m(s),N=m(o),O=c?m(c):null,j=h(E,N,u),M=O?h(O,E,u):{added:[...E.keys()].reduce((H,Q)=>(H.add(Q),H),new Set),removed:new Set,updated:new Set},L=O?h(O,N,u):{added:[...N.keys()].reduce((H,Q)=>(H.add(Q),H),new Set),removed:new Set,updated:new Set},F=S(j,M,L);let z=v;for(const H of F.removed.values())F.conflicts.has(H)||(z=d(z,H,r));for(const H of F.added.values()){if(F.conflicts.has(H))continue;const Q=N.get(H);if(Q.some(K=>K.command!==`-${H}`&&w.conflicts.has(u[K.key]))){F.conflicts.add(H);continue}z=l(z,Q,r)}for(const H of F.updated.values()){if(F.conflicts.has(H))continue;const Q=N.get(H);if(Q.some(K=>K.command!==`-${H}`&&w.conflicts.has(u[K.key]))){F.conflicts.add(H);continue}z=g(z,H,Q,r)}return{mergeContent:z,hasChanges:!0,hasConflicts:F.conflicts.size>0}}e.merge=P;function S(v,I,i){const r=new Set,t=new Set,s=new Set,o=new Set;for(const c of I.removed.values())i.updated.has(c)&&o.add(c);for(const c of i.removed.values())o.has(c)||(I.updated.has(c)?o.add(c):t.add(c));for(const c of I.added.values())o.has(c)||i.added.has(c)&&v.updated.has(c)&&o.add(c);for(const c of i.added.values())o.has(c)||(I.added.has(c)?v.updated.has(c)&&o.add(c):r.add(c));for(const c of I.updated.values())o.has(c)||i.updated.has(c)&&v.updated.has(c)&&o.add(c);for(const c of i.updated.values())o.has(c)||(I.updated.has(c)?v.updated.has(c)&&o.add(c):s.add(c));return{added:r,removed:t,updated:s,conflicts:o}}function C(v,I,i,r){const t=new Set,s=b(v,r),o=b(I,r),c=i?b(i,r):null,a=p(s,o);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const u=c?p(c,s):{added:[...s.keys()].reduce((M,L)=>(M.add(L),M),new Set),removed:new Set,updated:new Set};if(u.added.size===0&&u.removed.size===0&&u.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:t,removed:t,updated:t,conflicts:t};const w=c?p(c,o):{added:[...o.keys()].reduce((M,L)=>(M.add(L),M),new Set),removed:new Set,updated:new Set};if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const{added:E,removed:N,updated:O,conflicts:j}=S(a,u,w);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:E,removed:N,updated:O,conflicts:j}}function b(v,I){const i=new Map;for(const r of v){const t=I[r.key];let s=i.get(t);s||(s=[],i.set(t,s)),s.push(r)}return i}function m(v){const I=new Map;for(const i of v){const r=i.command[0]==="-"?i.command.substring(1):i.command;let t=I.get(r);t||(t=[],I.set(r,t)),t.push(i)}return I}function p(v,I){const i=[...v.keys()],r=[...I.keys()],t=r.filter(c=>i.indexOf(c)===-1).reduce((c,a)=>(c.add(a),c),new Set),s=i.filter(c=>r.indexOf(c)===-1).reduce((c,a)=>(c.add(a),c),new Set),o=new Set;for(const c of i){if(s.has(c))continue;const a=v.get(c).map(w=>({...w,key:c})),u=I.get(c).map(w=>({...w,key:c}));(0,A.equals)(a,u,(w,E)=>f(w,E))||o.add(c)}return{added:t,removed:s,updated:o}}function h(v,I,i){const r=[...v.keys()],t=[...I.keys()],s=t.filter(a=>r.indexOf(a)===-1).reduce((a,u)=>(a.add(u),a),new Set),o=r.filter(a=>t.indexOf(a)===-1).reduce((a,u)=>(a.add(u),a),new Set),c=new Set;for(const a of r){if(o.has(a))continue;const u=v.get(a).map(E=>({...E,key:i[E.key]})),w=I.get(a).map(E=>({...E,key:i[E.key]}));y(u,w)||c.add(a)}return{added:s,removed:o,updated:c}}function y(v,I){return!(!(0,A.equals)(v.filter(({command:i})=>i[0]!=="-"),I.filter(({command:i})=>i[0]!=="-"),(i,r)=>f(i,r))||!(0,A.equals)(v.filter(({command:i})=>i[0]==="-"),I.filter(({command:i})=>i[0]==="-"),(i,r)=>f(i,r)))}function f(v,I){if(v.command!==I.command||v.key!==I.key)return!1;const i=k.ContextKeyExpr.deserialize(v.when),r=k.ContextKeyExpr.deserialize(I.when);return!(i&&!r||!i&&r||i&&r&&!i.equals(r)||!D.equals(v.args,I.args))}function l(v,I,i){for(const r of I)v=T.edit(v,[-1],r,i);return v}function d(v,I,i){const r=R(v);for(let t=r.length-1;t>=0;t--)(r[t].command===I||r[t].command===`-${I}`)&&(v=T.edit(v,[t],void 0,i));return v}function g(v,I,i,r){const t=R(v),s=t.findIndex(o=>o.command===I||o.command===`-${I}`);for(let o=t.length-1;o>=0;o--)(t[o].command===I||t[o].command===`-${I}`)&&(v=T.edit(v,[o],void 0,r));for(let o=i.length-1;o>=0;o--)v=T.edit(v,[s],i[o],r);return v}}),define(re[255],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function A(k,T,R){const P={},S={},C=new Set;if(!T)return{local:{added:P,updated:S,removed:[...C.values()]},remote:{added:k,updated:{},removed:[]},conflicts:[]};const b=n(k,T);if(b.added.size===0&&b.removed.size===0&&b.updated.size===0)return{local:{added:P,updated:S,removed:[...C.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const m=n(R,k),p=n(R,T),h={},y={},f=new Set,l=new Set;for(const d of m.removed.values())p.updated.has(d)?P[d]=T[d]:f.add(d);for(const d of p.removed.values())l.has(d)||(m.updated.has(d)?l.add(d):C.add(d));for(const d of m.updated.values())l.has(d)||(p.updated.has(d)?b.updated.has(d)&&l.add(d):y[d]=k[d]);for(const d of p.updated.values())l.has(d)||(m.updated.has(d)?b.updated.has(d)&&l.add(d):k[d]!==void 0&&(S[d]=T[d]));for(const d of m.added.values())l.has(d)||(p.added.has(d)?b.updated.has(d)&&l.add(d):h[d]=k[d]);for(const d of p.added.values())l.has(d)||(m.added.has(d)?b.updated.has(d)&&l.add(d):P[d]=T[d]);return{local:{added:P,removed:[...C.values()],updated:S},remote:{added:h,removed:[...f.values()],updated:y},conflicts:[...l.values()]}}e.merge=A;function n(k,T){const R=k?Object.keys(k):[],P=T?Object.keys(T):[],S=P.filter(m=>R.indexOf(m)===-1).reduce((m,p)=>(m.add(p),m),new Set),C=R.filter(m=>P.indexOf(m)===-1).reduce((m,p)=>(m.add(p),m),new Set),b=new Set;for(const m of R){if(C.has(m))continue;const p=k[m],h=T[m];p!==h&&b.add(m)}return{added:S,removed:C,updated:b}}function D(k,T){const{added:R,removed:P,updated:S}=n(k,T);return R.size===0&&P.size===0&&S.size===0}e.areSame=D}),define(re[256],ae([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function A(D,k,T,R){const P={added:[],removed:[],updated:[]};let S={added:[],removed:[],updated:[]};if(!k){const b=D.filter(({id:m})=>!R.includes(m));return b.length?S.added=b:S=null,{local:P,remote:S}}const C=n(D,k,R);if(C.added.length>0||C.removed.length>0||C.updated.length>0){const b=n(T,D,R),m=n(T,k,R);for(const p of m.removed){const h=D.find(y=>y.id===p);h&&P.removed.push(h)}for(const p of m.added){const h=k.find(y=>y.id===p);b.added.includes(p)?C.updated.includes(p)&&P.updated.push(h):P.added.push(h)}for(const p of m.updated)P.updated.push(k.find(h=>h.id===p));for(const p of b.added)m.added.includes(p)||S.added.push(D.find(h=>h.id===p));for(const p of b.updated)m.removed.includes(p)||m.updated.includes(p)||S.updated.push(D.find(h=>h.id===p));for(const p of b.removed){const h=k.find(y=>y.id===p);h&&S.removed.push(h)}}return S.added.length===0&&S.removed.length===0&&S.updated.length===0&&(S=null),{local:P,remote:S}}e.merge=A;function n(D,k,T){D=D?D.filter(({id:m})=>!T.includes(m)):[],k=k.filter(({id:m})=>!T.includes(m));const R=D.map(({id:m})=>m),P=k.map(({id:m})=>m),S=P.filter(m=>R.indexOf(m)===-1),C=R.filter(m=>P.indexOf(m)===-1),b=[];for(const{id:m,name:p,shortName:h}of D){if(C.includes(m))continue;const y=k.find(f=>f.id===m);(!y||y.name!==p||y.shortName!==h)&&b.push(m)}return{added:S,removed:C,updated:b}}}),define(re[26],ae([0,1,21,14,180,46,30,4,106,40]),function(_,e,A,n,D,k,T,R,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EXTENSIONS_SYNC_CONTEXT_KEY=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncResourceProviderService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.getPathSegments=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function C(){const o=S.Registry.as(k.Extensions.Configuration).getConfigurationProperties();return Object.keys(o).filter(c=>!!o[c].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=C;function b(){const o=S.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),c=Object.keys(o).filter(w=>!!o[w].ignoreSync),a=Object.keys(o).filter(w=>o[w].scope===2||o[w].scope===6),u=C();return(0,A.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...c,...a,...u])}e.getDefaultIgnoredSettings=b,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync",e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM="settingsSync.keybindingsPerPlatform";function m(){const o="vscode://schemas/ignoredSettings",c=S.Registry.as(k.Extensions.Configuration);c.registerConfiguration({id:"settingsSync",order:30,title:(0,D.localize)(0,null),type:"object",properties:{[e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM]:{type:"boolean",description:(0,D.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,D.localize)(2,null),items:[{type:"string",pattern:T.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,D.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,D.localize)(4,null),default:[],scope:1,$ref:o,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const a=S.Registry.as(P.Extensions.JSONContribution),u=()=>{const w=C(),E=b().filter(M=>M!==e.CONFIGURATION_SYNC_STORE_KEY),N=Object.keys(k.allSettings.properties).filter(M=>E.indexOf(M)===-1),O=E.filter(M=>w.indexOf(M)===-1),j={items:{type:"string",enum:[...N,...O.map(M=>`-${M}`)]}};a.registerSchema(o,j)};return c.onDidUpdateConfiguration(()=>u())}e.registerConfiguration=m;function p(o){return o&&(0,n.isObject)(o)&&(0,n.isString)(o.id)&&Array.isArray(o.scopes)}e.isAuthenticationProvider=p;var h;(function(o){o.Settings="settings",o.Keybindings="keybindings",o.Snippets="snippets",o.Tasks="tasks",o.Extensions="extensions",o.GlobalState="globalState",o.Profiles="profiles"})(h=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function y(o,...c){return o?[o,...c]:c}e.getPathSegments=y;function f(o,c,a,u){return u.joinPath(a.userDataSyncHome,...y(o,c,`lastSync${c}.json`))}e.getLastSyncResourceUri=f,e.IUserDataSyncStoreManagementService=(0,R.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,R.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,R.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function l(o){const c={};return c[e.HEADER_EXECUTION_ID]=o,c}e.createSyncHeaders=l;var d;(function(o){o.Unauthorized="Unauthorized",o.NotFound="NotFound",o.MethodNotFound="MethodNotFound",o.Conflict="Conflict",o.Gone="Gone",o.PreconditionFailed="PreconditionFailed",o.TooLarge="TooLarge",o.UpgradeRequired="UpgradeRequired",o.PreconditionRequired="PreconditionRequired",o.TooManyRequests="RemoteTooManyRequests",o.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",o.RequestFailed="RequestFailed",o.RequestCanceled="RequestCanceled",o.RequestTimeout="RequestTimeout",o.RequestProtocolNotSupported="RequestProtocolNotSupported",o.RequestPathNotEscaped="RequestPathNotEscaped",o.RequestHeadersNotObject="RequestHeadersNotObject",o.NoCollection="NoCollection",o.NoRef="NoRef",o.EmptyResponse="EmptyResponse",o.TurnedOff="TurnedOff",o.SessionExpired="SessionExpired",o.ServiceChanged="ServiceChanged",o.DefaultServiceChanged="DefaultServiceChanged",o.LocalTooManyProfiles="LocalTooManyProfiles",o.LocalTooManyRequests="LocalTooManyRequests",o.LocalPreconditionFailed="LocalPreconditionFailed",o.LocalInvalidContent="LocalInvalidContent",o.LocalError="LocalError",o.IncompatibleLocalContent="IncompatibleLocalContent",o.IncompatibleRemoteContent="IncompatibleRemoteContent",o.Unknown="Unknown"})(d=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class g extends Error{constructor(c,a,u,w){super(c),this.code=a,this.resource=u,this.operationId=w,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=g;class v extends g{constructor(c,a,u,w,E){super(c,u,void 0,E),this.url=a,this.serverCode=w}}e.UserDataSyncStoreError=v;class I extends g{constructor(c,a){super(c,a)}}e.UserDataAutoSyncError=I,function(o){function c(a){if(a instanceof o)return a;const u=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(a.name);if(u&&u[1]){const w=u[2]==="unknown"?void 0:u[2],E=u[3]==="unknown"?void 0:u[3];return new o(a.message,u[1],w,E)}return new o(a.message,"Unknown")}o.toUserDataSyncError=c}(g=e.UserDataSyncError||(e.UserDataSyncError={}));var i;(function(o){o.Uninitialized="uninitialized",o.Idle="idle",o.Syncing="syncing",o.HasConflicts="hasConflicts"})(i=e.SyncStatus||(e.SyncStatus={}));var r;(function(o){o[o.None=0]="None",o[o.Added=1]="Added",o[o.Modified=2]="Modified",o[o.Deleted=3]="Deleted"})(r=e.Change||(e.Change={}));var t;(function(o){o.Preview="preview",o.Conflict="conflict",o.Accepted="accepted"})(t=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function s(o){return`sync.enable.${o}`}e.getEnablementKey=s,e.IUserDataSyncEnablementService=(0,R.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,R.createDecorator)("IUserDataSyncService"),e.IUserDataSyncResourceProviderService=(0,R.createDecorator)("IUserDataSyncResourceProviderService"),e.IUserDataAutoSyncService=(0,R.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,R.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,R.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview",e.EXTENSIONS_SYNC_CONTEXT_KEY="extensionsSync"}),define(re[257],ae([0,1,32,26]),function(_,e,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function D(T,R,P,S,C){if(!R)return{remote:{added:Object.keys(T),removed:[],updated:[],all:Object.keys(T).length>0?T:null},local:{added:{},removed:[],updated:{}}};const b=k(T,R);if(b.added.size===0&&b.removed.size===0&&b.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const m=P?k(P,R):{added:Object.keys(R).reduce((d,g)=>(d.add(g),d),new Set),removed:new Set,updated:new Set},p=P?k(P,T):{added:Object.keys(T).reduce((d,g)=>(d.add(g),d),new Set),removed:new Set,updated:new Set},h={added:{},removed:[],updated:{}},y=A.deepClone(R),f=!P;for(const d of p.added.values())d!==n.SYNC_SERVICE_URL_TYPE&&f&&m.added.has(d)||(y[d]=T[d]);for(const d of p.updated.values())y[d]=T[d];for(const d of p.removed.values())S.unregistered.includes(d)||delete y[d];for(const d of m.added.values()){const g=R[d];if(S.machine.includes(d)){C.info(`GlobalState: Skipped adding ${d} in local storage because it is declared as machine scoped.`);continue}if(P&&p.added.has(d))continue;const v=T[d];v&&v.value===g.value||d===n.SYNC_SERVICE_URL_TYPE&&f&&p.added.has(d)||(v?h.updated[d]=g:h.added[d]=g)}for(const d of m.updated.values()){const g=R[d];if(S.machine.includes(d)){C.info(`GlobalState: Skipped updating ${d} in local storage because it is declared as machine scoped.`);continue}if(p.updated.has(d)||p.removed.has(d))continue;const v=T[d];v&&v.value===g.value||(h.updated[d]=g)}for(const d of m.removed.values()){if(S.machine.includes(d)){C.trace(`GlobalState: Skipped removing ${d} in local storage because it is declared as machine scoped.`);continue}p.updated.has(d)||p.removed.has(d)||h.removed.push(d)}const l=k(R,y);return{local:h,remote:{added:[...l.added],updated:[...l.updated],removed:[...l.removed],all:l.added.size===0&&l.removed.size===0&&l.updated.size===0?null:y}}}e.merge=D;function k(T,R){const P=Object.keys(T),S=Object.keys(R),C=S.filter(p=>P.indexOf(p)===-1).reduce((p,h)=>(p.add(h),p),new Set),b=P.filter(p=>S.indexOf(p)===-1).reduce((p,h)=>(p.add(h),p),new Set),m=new Set;for(const p of P){if(b.has(p))continue;const h=T[p],y=R[p];A.equals(h,y)||m.add(p)}return{added:C,removed:b,updated:m}}}),define(re[258],ae([0,1,21,35,83,43,32,61,26]),function(_,e,A,n,D,k,T,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.removeComments=e.getIgnoredSettings=void 0;function S(a,u,w){let E=[];w?E=b(w):E=C(u);const N=[],O=[...(0,P.getDisallowedIgnoredSettings)()];if(Array.isArray(E))for(const j of E)j.startsWith("-")?O.push(j.substring(1)):N.push(j);return(0,A.distinct)([...a,...N].filter(j=>O.indexOf(j)===-1))}e.getIgnoredSettings=S;function C(a){let u=a.inspect("settingsSync.ignoredSettings").userValue;return u!==void 0||(u=a.inspect("sync.ignoredSettings").userValue,u!==void 0)?u:a.getValue("settingsSync.ignoredSettings")||[]}function b(a){const u=(0,n.parse)(a);return u?u["settingsSync.ignoredSettings"]||u["sync.ignoredSettings"]||[]:[]}function m(a,u){const w=(0,n.parse)(a)||{};let E="{}";for(const N of Object.keys(w)){const O=(0,D.setProperty)(E,[N],w[N],u);E=(0,D.applyEdits)(E,O)}return E}e.removeComments=m;function p(a,u,w,E){if(w.length){const N=c(u),O=(0,n.parse)(u)||{},j=(0,n.parse)(a);if(!j)return a;const M=[];for(const L of w){const F=O[L],z=j[L];F===void 0?a=R.edit(a,[L],void 0,E):z!==void 0?a=R.edit(a,[L],F,E):M.push(i(L,N))}M.sort((L,F)=>L.startOffset-F.startOffset),M.forEach(L=>a=d(L.setting.key,u,a,E))}return a}e.updateIgnoredSettings=p;function h(a,u,w,E,N,O){const j=p(a,u,E,O),M=w!==j,L=w!==u;if(!M&&!L)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(M&&!L)return{conflictsSettings:[],localContent:null,remoteContent:j,hasConflicts:!1};if(L&&!M)return{conflictsSettings:[],localContent:p(u,a,E,O),remoteContent:null,hasConflicts:!1};if(w===null&&f(a)){const B=y(a,u,E)?null:p(u,a,E,O);return{conflictsSettings:[],localContent:B,remoteContent:null,hasConflicts:!1}}let F=a,z=u;const H=(0,n.parse)(a),Q=(0,n.parse)(u),K=w?(0,n.parse)(w):null,V=E.reduce((B,x)=>(B.add(x),B),new Set),W=l(H,Q,V),G=l(K,H,V),X=l(K,Q,V),ie=new Map,oe=new Set,te=B=>{oe.add(B);const x=N.filter(({key:ee})=>ee===B)[0];x?(F=R.edit(F,[B],x.value,O),z=R.edit(z,[B],x.value,O)):ie.set(B,{key:B,localValue:H[B],remoteValue:Q[B]})};for(const B of G.removed.values())X.updated.has(B)?te(B):z=R.edit(z,[B],void 0,O);for(const B of X.removed.values())oe.has(B)||(G.updated.has(B)?te(B):F=R.edit(F,[B],void 0,O));for(const B of G.updated.values())oe.has(B)||(X.updated.has(B)?W.updated.has(B)&&te(B):z=R.edit(z,[B],H[B],O));for(const B of X.updated.values())oe.has(B)||(G.updated.has(B)?W.updated.has(B)&&te(B):F=R.edit(F,[B],Q[B],O));for(const B of G.added.values())oe.has(B)||(X.added.has(B)?W.updated.has(B)&&te(B):z=d(B,F,z,O));for(const B of X.added.values())oe.has(B)||(G.added.has(B)?W.updated.has(B)&&te(B):F=d(B,z,F,O));const U=ie.size>0||!y(F,z,E),$=U||!y(F,a,[]),q=U||!y(z,u,[]);return{localContent:$?F:null,remoteContent:q?z:null,conflictsSettings:[...ie.values()],hasConflicts:U}}e.merge=h;function y(a,u,w){if(a===u)return!0;const E=(0,n.parse)(a),N=(0,n.parse)(u),O=w.reduce((L,F)=>(L.add(F),L),new Set),j=c(a).filter(L=>!(L.setting&&O.has(L.setting.key))),M=c(u).filter(L=>!(L.setting&&O.has(L.setting.key)));if(j.length!==M.length)return!1;for(let L=0;L<j.length;L++){const F=j[L],z=M[L];if(F.setting&&z.setting){if(F.setting.key!==z.setting.key||!T.equals(E[F.setting.key],N[F.setting.key]))return!1}else if(!F.setting&&!z.setting){if(F.value!==z.value)return!1}else return!1}return!0}e.areSame=y;function f(a){return a?c(a).length===0:!0}e.isEmpty=f;function l(a,u,w){const E=a?Object.keys(a).filter(L=>!w.has(L)):[],N=Object.keys(u).filter(L=>!w.has(L)),O=N.filter(L=>E.indexOf(L)===-1).reduce((L,F)=>(L.add(F),L),new Set),j=E.filter(L=>N.indexOf(L)===-1).reduce((L,F)=>(L.add(F),L),new Set),M=new Set;if(a)for(const L of E){if(j.has(L))continue;const F=a[L],z=u[L];T.equals(F,z)||M.add(L)}return{added:O,removed:j,updated:M}}function d(a,u,w,E){const N=(0,n.parse)(u),O=c(u),j=c(w),M=g(a,O,j);return v(w,a,N[a],M,j,E)}e.addSetting=d;function g(a,u,w){const E=u.findIndex(O=>O.setting?.key===a),N=u[E-1];if(N){if(N.setting){const j=i(N.setting.key,w);if(j)return{index:w.indexOf(j),insertAfter:!0}}else{const j=r(E,u);if(j){const M=i(j.setting.key,w);if(M){const L=t(w.indexOf(M),w),F=s(u,j,u[E]);if(L){const z=s(w,M,L),H=o(F,z);return H?{index:w.indexOf(H),insertAfter:!0}:{index:w.indexOf(L),insertAfter:!1}}else{const z=s(w,M,w[w.length-1]),H=o(F,z);return H?{index:w.indexOf(H),insertAfter:!0}:{index:w.length-1,insertAfter:!0}}}}}const O=u[E+1];if(O)if(O.setting){const j=i(O.setting.key,w);if(j)return{index:w.indexOf(j),insertAfter:!1}}else{const j=t(E,u);if(j){const M=i(j.setting.key,w);if(M){const L=r(w.indexOf(M),w),F=s(u,u[E],j);if(L){const z=s(w,L,M),H=o(F.reverse(),z.reverse());return H?{index:w.indexOf(H),insertAfter:!1}:{index:w.indexOf(L),insertAfter:!0}}else{const z=s(w,w[0],M),H=o(F.reverse(),z.reverse());return H?{index:w.indexOf(H),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:w.length-1,insertAfter:!0}}function v(a,u,w,E,N,O){let j;return E.index===-1?j=(0,D.setProperty)(a,[u],w,O):j=I(a,u,w,E,N,O).map(M=>(0,D.withFormatting)(a,M,O)[0]),(0,D.applyEdits)(a,j)}function I(a,u,w,E,N,O){const j=`${JSON.stringify(u)}: ${JSON.stringify(w)}`,M=(0,k.getEOL)(O,a),L=N[E.index];if(E.insertAfter){const F=[];if(L.setting)F.push({offset:L.endOffset,length:0,content:","+j});else{const z=t(E.index,N),H=r(E.index,N),Q=H?.setting?.commaOffset;H&&Q===void 0&&F.push({offset:H.endOffset,length:0,content:","});const K=Q!==void 0&&Q>L.endOffset;F.push({offset:K?Q+1:L.endOffset,length:0,content:z?M+j+",":M+j})}return F}else{if(L.setting)return[{offset:L.startOffset,length:0,content:j+","}];const F=(N[E.index-1]&&!N[E.index-1].setting?M:"")+j+(t(E.index,N)?",":"")+M;return[{offset:L.startOffset,length:0,content:F}]}}function i(a,u){return u.filter(w=>w.setting?.key===a)[0]}function r(a,u){for(let w=a-1;w>=0;w--)if(u[w].setting)return u[w]}function t(a,u){for(let w=a+1;w<u.length;w++)if(u[w].setting)return u[w]}function s(a,u,w){const E=a.indexOf(u),N=a.indexOf(w);return a.filter((O,j)=>E<j&&j<N)}function o(a,u){if(a.length&&u.length){let w=0;for(;w<u.length&&w<a.length;w++)if(a[w].value!==u[w].value)return u[w-1];return u[w-1]}}function c(a){const u=[];let w=-1,E,N;const O={onObjectBegin:j=>{w++},onObjectProperty:(j,M,L)=>{w===0&&(E=M,N=j)},onObjectEnd:(j,M)=>{w--,w===0&&u.push({startOffset:E,endOffset:j+M,value:a.substring(E,j+M),setting:{key:N,commaOffset:void 0}})},onArrayBegin:(j,M)=>{w++},onArrayEnd:(j,M)=>{w--,w===0&&u.push({startOffset:E,endOffset:j+M,value:a.substring(E,j+M),setting:{key:N,commaOffset:void 0}})},onLiteralValue:(j,M,L)=>{w===0&&u.push({startOffset:E,endOffset:M+L,value:a.substring(E,M+L),setting:{key:N,commaOffset:void 0}})},onSeparator:(j,M,L)=>{if(w===0&&j===","){let F=u.length-1;for(;F>=0&&!u[F].setting;F--);const z=u[F];z&&u.splice(F,1,{startOffset:z.startOffset,endOffset:z.endOffset,value:z.value,setting:{key:z.setting.key,commaOffset:M}})}},onComment:(j,M)=>{w===0&&u.push({startOffset:j,endOffset:j+M,value:a.substring(j,j+M)})}};return(0,n.visit)(a,O),u}}),define(re[78],ae([0,1,3,2,4,26]),function(_,e,A,n,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,D.createDecorator)("IUserDataSyncAccountService");let T=class extends n.Disposable{get account(){return this.a}constructor(P,S){super(),this.g=P,this.h=S,this.b=this.B(new A.Emitter),this.onDidChangeAccount=this.b.event,this.c=this.B(new A.Emitter),this.onTokenFailed=this.c.event,this.f=!1,this.B(P.onTokenFailed(()=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f),this.updateAccount(void 0),this.c.fire(this.f),this.f=!0})),this.B(P.onTokenSucceed(()=>this.f=!1))}async updateAccount(P){(P&&this.a?P.token!==this.a.token||P.authenticationProviderId!==this.a.authenticationProviderId:P!==this.a)&&(this.a=P,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(P))}};T=ye([Y(0,k.IUserDataSyncStoreService),Y(1,k.IUserDataSyncLogService)],T),e.UserDataSyncAccountService=T}),define(re[259],ae([0,1,2,8]),function(_,e,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class D{constructor(m){this.a=m}listen(m,p){switch(p){case"onError":return this.a.onError}throw new Error(`Event not found: ${p}`)}call(m,p,h){switch(p){case"triggerSync":return this.a.triggerSync(h[0],h[1],h[2]);case"turnOn":return this.a.turnOn();case"turnOff":return this.a.turnOff(h[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=D;class k{constructor(m){this.a=m}listen(m,p){throw new Error(`Event not found: ${p}`)}call(m,p,h){switch(p){case"resolveDefaultIgnoredSettings":return this.a.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.a.resolveUserBindings(h[0]);case"resolveFormattingOptions":return this.a.resolveFormattingOptions(n.URI.revive(h[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=k;class T{constructor(m){this.a=m}async resolveDefaultIgnoredSettings(){return this.a.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(m){return this.a.call("resolveUserKeybindings",[m])}async resolveFormattingOptions(m){return this.a.call("resolveFormattingOptions",[m])}}e.UserDataSyncUtilServiceClient=T;class R{constructor(m){this.a=m}listen(m,p){switch(p){case"onDidChange":return this.a.onDidChange}throw new Error(`Event not found: ${p}`)}async call(m,p,h){switch(p){case"getMachines":return this.a.getMachines();case"addCurrentMachine":return this.a.addCurrentMachine();case"removeCurrentMachine":return this.a.removeCurrentMachine();case"renameMachine":return this.a.renameMachine(h[0],h[1]);case"setEnablements":return this.a.setEnablements(h)}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=R;class P{constructor(m){this.a=m}listen(m,p){switch(p){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`Event not found: ${p}`)}call(m,p,h){switch(p){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(h)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=P;class S{constructor(m){this.a=m}listen(m,p){switch(p){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${p}`)}call(m,p,h){switch(p){case"switch":return this.a.switch(h[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=S;class C extends A.Disposable{constructor(m){super(),this.a=m,this.onDidChangeUserDataSyncStore=this.a.listen("onDidChangeUserDataSyncStore")}async switch(m){return this.a.call("switch",[m])}async getPreviousUserDataSyncStore(){const m=await this.a.call("getPreviousUserDataSyncStore");return this.b(m)}b(m){return{url:n.URI.revive(m.url),type:m.type,defaultUrl:n.URI.revive(m.defaultUrl),insidersUrl:n.URI.revive(m.insidersUrl),stableUrl:n.URI.revive(m.stableUrl),canSwitch:m.canSwitch,authenticationProviders:m.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=C}),define(re[260],ae([0,1,15,9]),function(_,e,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let D=class extends n.AbstractLogger{constructor(T,R){super(),this.g=this.B(T.createLogger(R.userDataSyncLogResource,{name:"settingssync"}))}trace(T,...R){this.g.trace(T,...R)}debug(T,...R){this.g.debug(T,...R)}info(T,...R){this.g.info(T,...R)}warn(T,...R){this.g.warn(T,...R)}error(T,...R){this.g.error(T,...R)}flush(){this.g.flush()}};D=ye([Y(0,n.ILoggerService),Y(1,A.IEnvironmentService)],D),e.UserDataSyncLogService=D}),define(re[261],ae([0,1,6,3,2]),function(_,e,A,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class k extends D.Disposable{constructor({onDidOpenWindow:R,onDidFocusWindow:P,getActiveWindowId:S}){super(),this.a=this.B(new D.DisposableStore),n.Event.latch(n.Event.any(R,P))(this.f,this,this.a),this.b=(0,A.createCancelablePromise)(()=>S()),(async()=>{try{const b=await this.b;this.c=typeof this.c=="number"?this.c:b}catch{}finally{this.b=void 0}})()}f(R){this.b&&(this.b.cancel(),this.b=void 0),this.c=R}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.ActiveWindowManager=k}),define(re[117],ae([0,1,183,12,49,22,8,4,24]),function(_,e,A,n,D,k,T,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,R.createDecorator)("contextService");function S(t){const s=t;return typeof s?.id=="string"&&T.URI.isUri(s.uri)}e.isSingleFolderWorkspaceIdentifier=S;function C(t){return typeof t?.id=="string"&&!S(t)&&!m(t)}e.isEmptyWorkspaceIdentifier=C,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function b(t,s){if(typeof t=="string"||typeof t>"u")return typeof t=="string"?{id:(0,n.basename)(t)}:s?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const o=t;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}e.toWorkspaceIdentifier=b;function m(t){const s=t;return typeof s?.id=="string"&&T.URI.isUri(s.configPath)}e.isWorkspaceIdentifier=m;function p(t){const s=t;if(s?.uri)return{id:s.id,uri:T.URI.revive(s.uri)};const o=t;if(o?.configPath)return{id:o.id,configPath:T.URI.revive(o.configPath)};if(t?.id)return{id:t.id}}e.reviveIdentifier=p;var h;(function(t){t[t.EMPTY=1]="EMPTY",t[t.FOLDER=2]="FOLDER",t[t.WORKSPACE=3]="WORKSPACE"})(h=e.WorkbenchState||(e.WorkbenchState={}));function y(t){const s=t;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}e.isWorkspace=y;function f(t){const s=t;return!!(s&&typeof s=="object"&&T.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}e.isWorkspaceFolder=f;class l{constructor(s,o,c,a,u){this.h=s,this.j=c,this.k=a,this.l=u,this.c=D.TernarySearchTree.forUris(this.l,()=>!0),this.folders=o}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=D.TernarySearchTree.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=l;class d{constructor(s,o){this.raw=o,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,k.joinPath)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=d;function g(t){return new d({uri:t,index:0,name:(0,k.basenameOrAuthority)(t)},{uri:t.toString()})}e.toWorkspaceFolder=g,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,A.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function v(t,s){return k.extUriBiasedIgnorePathCase.isEqualOrParent(t,s.untitledWorkspacesHome)}e.isUntitledWorkspace=v;function I(t){let s;return T.URI.isUri(t)?s=t:s=t.configuration,s?.scheme===P.Schemas.tmp}e.isTemporaryWorkspace=I;function i(t,s){return!v(t,s)&&!I(t)}e.isSavedWorkspace=i;function r(t){return(typeof t=="string"?(0,n.extname)(t):(0,k.extname)(t))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=r}),define(re[18],ae([0,1,66,3,2,22,8,175,15,13,4,9,117,37,29,6,31,27,14]),function(_,e,A,n,D,k,T,R,P,S,C,b,m,p,h,y,f,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function g(t){const s=t;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&T.URI.isUri(s.location)&&T.URI.isUri(s.globalStorageHome)&&T.URI.isUri(s.settingsResource)&&T.URI.isUri(s.keybindingsResource)&&T.URI.isUri(s.tasksResource)&&T.URI.isUri(s.snippetsHome)&&T.URI.isUri(s.extensionsResource))}e.isUserDataProfile=g,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,C.createDecorator)("IUserDataProfilesService");function v(t,s){return{id:t.id,isDefault:t.isDefault,name:t.name,shortName:t.shortName,location:T.URI.revive(t.location).with({scheme:s}),globalStorageHome:T.URI.revive(t.globalStorageHome).with({scheme:s}),settingsResource:T.URI.revive(t.settingsResource).with({scheme:s}),keybindingsResource:T.URI.revive(t.keybindingsResource).with({scheme:s}),tasksResource:T.URI.revive(t.tasksResource).with({scheme:s}),snippetsHome:T.URI.revive(t.snippetsHome).with({scheme:s}),extensionsResource:T.URI.revive(t.extensionsResource)?.with({scheme:s}),useDefaultFlags:t.useDefaultFlags,isTransient:t.isTransient}}e.reviveProfile=v;function I(t,s,o,c){return{id:t,name:s,location:o,isDefault:!1,shortName:c?.shortName,globalStorageHome:(0,k.joinPath)(o,"globalStorage"),settingsResource:(0,k.joinPath)(o,"settings.json"),keybindingsResource:(0,k.joinPath)(o,"keybindings.json"),tasksResource:(0,k.joinPath)(o,"tasks.json"),snippetsHome:(0,k.joinPath)(o,"snippets"),extensionsResource:(0,k.joinPath)(o,"extensions.json"),useDefaultFlags:c?.useDefaultFlags,isTransient:c?.transient}}e.toUserDataProfile=I;let i=class extends D.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.u.profiles,...this.l.profiles]}constructor(s,o,c,a){super(),this.m=s,this.n=o,this.r=c,this.s=a,this.f=!1,this.g=this.B(new n.Emitter),this.onDidChangeProfiles=this.g.event,this.h=this.B(new n.Emitter),this.onWillCreateProfile=this.h.event,this.i=this.B(new n.Emitter),this.onWillRemoveProfile=this.i.event,this.j=this.B(new n.Emitter),this.onDidResetWorkspaces=this.j.event,this.k=new Map,this.l={profiles:[],workspaces:new p.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,k.joinPath)(this.m.userRoamingDataHome,"profiles")}setEnablement(s){this.f!==s&&(this.t=void 0,this.f=s)}isEnabled(){return this.f}get u(){if(!this.t){const s=[];if(this.f)for(const u of this.G()){if(!u.name||!(0,d.isString)(u.name)||!u.location){this.s.warn("Skipping the invalid stored profile",u.location||u.name);continue}s.push(I((0,k.basename)(u.location),u.name,u.location,{shortName:u.shortName,useDefaultFlags:u.useDefaultFlags}))}const o=new p.ResourceMap,c=new Map,a=I((0,A.hash)(this.m.userRoamingDataHome.path).toString(16),(0,R.localize)(0,null),this.m.userRoamingDataHome);if(s.unshift({...a,extensionsResource:this.L()??a.extensionsResource,isDefault:!0}),s.length){const u=this.I();if(u.workspaces)for(const[w,E]of Object.entries(u.workspaces)){const N=T.URI.parse(w),O=T.URI.parse(E),j=s.find(M=>this.r.extUri.isEqual(M.location,O));j&&o.set(N,j)}if(u.emptyWindows)for(const[w,E]of Object.entries(u.emptyWindows)){const N=T.URI.parse(E),O=s.find(j=>this.r.extUri.isEqual(j.location,N));O&&c.set(w,O)}}this.t={profiles:s,workspaces:o,emptyWindows:c}}return this.t}async createTransientProfile(s){const o="Temp",c=new RegExp(`${(0,l.escapeRegExpCharacters)(o)}\\s(\\d+)`);let a=0;for(const w of this.profiles){const E=c.exec(w.name),N=E?parseInt(E[1]):0;a=N>a?N:a}const u=`${o} ${a+1}`;return this.createProfile((0,A.hash)((0,f.generateUuid)()).toString(16),u,{transient:!0},s)}async createNamedProfile(s,o,c){return this.createProfile((0,A.hash)((0,f.generateUuid)()).toString(16),s,o,c)}async createProfile(s,o,c,a){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const u=await this.v(s,o,c);return a&&await this.setProfileForWorkspace(a,u),u}async v(s,o,c){if(!(0,d.isString)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let a=this.k.get(o);return a||(a=(async()=>{try{const u=this.profiles.find(N=>N.name===o||N.id===s);if(u)return u;const w=I(s,o,(0,k.joinPath)(this.profilesHome,s),c);await this.n.createFolder(w.location);const E=[];return this.h.fire({profile:w,join(N){E.push(N)}}),await y.Promises.settled(E),this.z([w],[],[]),w}finally{this.k.delete(o)}})(),this.k.set(o,a)),a}async updateProfile(s,o){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let c=this.profiles.find(a=>a.id===s.id);if(!c)throw new Error(`Profile '${s.name}' does not exist`);return c=I(c.id,o.name??c.name,c.location,{shortName:o.shortName??c.shortName,transient:o.transient??c.isTransient,useDefaultFlags:o.useDefaultFlags??c.useDefaultFlags}),this.z([],[],[c]),c}async removeProfile(s){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(s.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(a=>a.id===s.id);if(!o)throw new Error(`Profile '${s.name}' does not exist`);const c=[];this.i.fire({profile:o,join(a){c.push(a)}});try{await Promise.allSettled(c)}catch(a){this.s.error(a)}for(const a of[...this.u.emptyWindows.keys()])o.id===this.u.emptyWindows.get(a)?.id&&this.u.emptyWindows.delete(a);for(const a of[...this.u.workspaces.keys()])o.id===this.u.workspaces.get(a)?.id&&this.u.workspaces.delete(a);this.F(),this.z([],[o],[]);try{this.profiles.length===1?await this.n.del(this.profilesHome,{recursive:!0}):await this.n.del(o.location,{recursive:!0})}catch(a){this.s.error(a)}}async setProfileForWorkspace(s,o){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const c=this.profiles.find(a=>a.id===o.id);if(!c)throw new Error(`Profile '${o.name}' does not exist`);this.D(s,c)}unsetWorkspace(s,o){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.D(s,void 0,o)}async resetWorkspaces(){this.l.workspaces.clear(),this.l.emptyWindows.clear(),this.u.workspaces.clear(),this.u.emptyWindows.clear(),this.F(),this.j.fire()}async cleanUp(){if(!!this.f&&await this.n.exists(this.profilesHome)){const s=await this.n.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(o=>o.isDirectory&&this.profiles.every(c=>!this.r.extUri.isEqual(c.location,o.resource))).map(o=>this.n.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const s=this.l.profiles.filter(o=>!this.y(o));await Promise.allSettled(s.map(o=>this.removeProfile(o)))}getProfileForWorkspace(s){const o=this.w(s);return T.URI.isUri(o)?this.l.workspaces.get(o)??this.u.workspaces.get(o):this.l.emptyWindows.get(o)??this.u.emptyWindows.get(o)}w(s){return(0,m.isSingleFolderWorkspaceIdentifier)(s)?s.uri:(0,m.isWorkspaceIdentifier)(s)?s.configPath:s.id}y(s){return!!([...this.l.emptyWindows.values()].some(o=>this.r.extUri.isEqual(o.location,s.location))||[...this.l.workspaces.values()].some(o=>this.r.extUri.isEqual(o.location,s.location))||[...this.u.emptyWindows.values()].some(o=>this.r.extUri.isEqual(o.location,s.location))||[...this.u.workspaces.values()].some(o=>this.r.extUri.isEqual(o.location,s.location)))}z(s,o,c){const a=[...this.profiles,...s],u=[];this.l.profiles=[];for(let w of a)w.isDefault||o.some(E=>w.id===E.id)||(w=c.find(E=>w.id===E.id)??w,w.isTransient?this.l.profiles.push(w):u.push({location:w.location,name:w.name,shortName:w.shortName,useDefaultFlags:w.useDefaultFlags}));this.H(u),this.t=void 0,this.C(s,o,c)}C(s,o,c){this.g.fire({added:s,removed:o,updated:c,all:this.profiles})}D(s,o,c){c=o?.isTransient?!0:c,c||this.D(s,void 0,!0);const a=this.w(s),u=c?this.l:this.u;T.URI.isUri(a)?(u.workspaces.delete(a),o&&u.workspaces.set(a,o)):(u.emptyWindows.delete(a),o&&u.emptyWindows.set(a,o)),c||this.F()}F(){const s={};for(const[c,a]of this.u.workspaces.entries())s[c.toString()]=a.location.toString();const o={};for(const[c,a]of this.u.emptyWindows.entries())o[c.toString()]=a.location.toString();this.J({workspaces:s,emptyWindows:o}),this.t=void 0}G(){return[]}H(s){throw new Error("not implemented")}I(){return{}}J(s){throw new Error("not implemented")}L(){}};i.b="userDataProfiles",i.c="profileAssociations",i=ye([Y(0,P.IEnvironmentService),Y(1,S.IFileService),Y(2,h.IUriIdentityService),Y(3,b.ILogService)],i),e.UserDataProfilesService=i;class r extends i{constructor(){super(...arguments),this.a=[],this.O={}}G(){return this.a}H(s){this.a=s}I(){return this.O}J(s){this.O=s}}e.InMemoryUserDataProfilesService=r}),define(re[262],ae([0,1,6,2,18]),function(_,e,A,n,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesCleaner=void 0;let k=class extends n.Disposable{constructor(R){super(),this.B(new A.RunOnceScheduler(()=>{R.cleanUp()},10*1e3)).schedule()}};k=ye([Y(0,D.IUserDataProfilesService)],k),e.UserDataProfilesCleaner=k}),define(re[263],ae([0,1,21,6,23,7,3,2,5,8,156,30,33,42,9,25,19,18]),function(_,e,A,n,D,k,T,R,P,S,C,b,m,p,h,y,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=e.ExtensionVerificationStatus=void 0;var d;(function(t){t.Verified="Verified",t.Unverified="Unverified",t.UnknownError="UnknownError"})(d=e.ExtensionVerificationStatus||(e.ExtensionVerificationStatus={}));let g=class extends R.Disposable{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}constructor(s,o,c,a,u){super(),this.t=s,this.u=o,this.v=c,this.w=a,this.y=u,this.h=0,this.j=new Map,this.k=new Map,this.l=this.B(new T.Emitter),this.m=this.B(new T.Emitter),this.n=this.B(new T.Emitter),this.p=this.B(new T.Emitter),this.s=[],this.B((0,R.toDisposable)(()=>{this.j.forEach(({task:w})=>w.cancel()),this.k.forEach(w=>w.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(s){const o=await this.getTargetPlatform();return s.allTargetPlatforms.some(c=>(0,b.isTargetPlatformCompatible)(c,s.allTargetPlatforms,o))}async installFromGallery(s,o={}){try{if(!this.t.isEnabled())throw new b.ExtensionManagementError(C.localize(0,null),b.ExtensionManagementErrorCode.Internal);const c=await this.G(s,!!o.installGivenVersion,!!o.installPreReleaseVersion);return await this.z(c.manifest,c.extension,o)}catch(c){throw i(this.u,"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(s),error:c}),this.v.error("Failed to install extension.",s.identifier.id),this.v.error(c),I(c)}}async uninstall(s,o={}){return this.v.trace("ExtensionManagementService#uninstall",s.identifier.id),this.I(s,o)}getExtensionsControlManifest(){const s=new Date().getTime();return(!this.g||s-this.h>1e3*60*5)&&(this.g=this.O(),this.h=s),this.g}registerParticipant(s){this.s.push(s)}async z(s,o,c){const a={...c,installOnlyNewlyAddedFromExtensionPack:S.URI.isUri(o)?c.installOnlyNewlyAddedFromExtensionPack:!0,profileLocation:(0,p.isApplicationScopedExtension)(s)?this.y.defaultProfile.extensionsResource:c.profileLocation??this.P()},u=M=>`${m.ExtensionKey.create(M).toString()}${a.profileLocation?`-${a.profileLocation.toString()}`:""}`;if(!S.URI.isUri(o)){const M=this.j.get(u(o));if(M){this.v.info("Extensions is already requested to install",o.identifier.id);const{local:L}=await M.task.waitUntilTaskIsFinished();return L}}const w=[],E=[],N=[],O=this.Q(s,o,a);S.URI.isUri(o)||this.j.set(u(o),{task:O,waitingTasks:[]}),this.l.fire({identifier:O.identifier,source:o,profileLocation:a.profileLocation}),this.v.info("Installing extension:",O.identifier.id),w.push({task:O,manifest:s});let j=!1;try{if(a.donotIncludePackAndDependencies)this.v.info("Installing the extension without checking dependencies and pack",O.identifier.id);else try{const L=await this.F(O.identifier,s,!!a.installOnlyNewlyAddedFromExtensionPack,!!a.installPreReleaseVersion,a.profileLocation),F=await this.getInstalled(void 0,a.profileLocation);for(const{gallery:z,manifest:H}of(0,A.distinct)(L,({gallery:Q})=>Q.identifier.id)){j=j||!!H.extensionDependencies?.some(V=>(0,m.areSameExtensions)({id:V},O.identifier));const Q=u(z),K=this.j.get(Q);if(K){if(this.C(O,K.task)){const V=K.task.identifier;this.v.info("Waiting for already requested installing extension",V.id,O.identifier.id),K.waitingTasks.push(O),E.push(T.Event.toPromise(T.Event.filter(this.onDidInstallExtensions,W=>W.some(G=>(0,m.areSameExtensions)(G.identifier,V)))).then(W=>{if(this.v.info("Finished waiting for already requested installing extension",V.id,O.identifier.id),!W.find(X=>(0,m.areSameExtensions)(X.identifier,V))?.local)throw new Error(`Extension ${V.id} is not installed`)}))}}else if(!F.some(({identifier:V})=>(0,m.areSameExtensions)(V,z.identifier))){const V=this.Q(H,z,{...a,donotIncludePackAndDependencies:!0});this.j.set(Q,{task:V,waitingTasks:[O]}),this.l.fire({identifier:V.identifier,source:z,profileLocation:a.profileLocation}),this.v.info("Installing extension:",V.identifier.id,O.identifier.id),w.push({task:V,manifest:H})}}}catch(L){if(S.URI.isUri(O.source))(0,A.isNonEmptyArray)(s.extensionDependencies)&&this.v.warn("Cannot install dependencies of extension:",O.identifier.id,L.message),(0,A.isNonEmptyArray)(s.extensionPack)&&this.v.warn("Cannot install packed extensions of extension:",O.identifier.id,L.message);else throw this.v.error("Error while preparing to install dependencies and extension packs of the extension:",O.identifier.id),L}const M=w.reduce((L,{task:F,manifest:z})=>(L.set(F.identifier.id.toLowerCase(),{task:F,manifest:z}),L),new Map);for(;M.size;){let L;const F=[...M.values()].filter(({manifest:z})=>!z.extensionDependencies?.some(H=>M.has(H.toLowerCase())));F.length?L=M.size===1?F:F.filter(({task:z})=>!(z===O&&!j)):(this.v.info("Found extensions with circular dependencies",F.map(({task:z})=>z.identifier.id)),L=[...M.values()]),await this.D(L.map(async({task:z})=>{const H=new Date().getTime();try{const{local:Q}=await z.run();if(await this.D(this.s.map(K=>K.postInstall(Q,z.source,a,D.CancellationToken.None))),!S.URI.isUri(z.source)){const K=z.operation===3,V=K?void 0:(new Date().getTime()-z.source.lastUpdated)/1e3;if(i(this.u,K?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(z.source),verificationStatus:z.verificationStatus,duration:new Date().getTime()-H,durationSinceUpdate:V}),P.isWeb&&z.operation!==3)try{await this.t.reportStatistic(Q.manifest.publisher,Q.manifest.name,Q.manifest.version,"install")}catch{}}N.push({local:Q,identifier:z.identifier,operation:z.operation,source:z.source,context:a.context,profileLocation:a.profileLocation,applicationScoped:Q.isApplicationScoped})}catch(Q){throw S.URI.isUri(z.source)||i(this.u,z.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(z.source),verificationStatus:z.verificationStatus,duration:new Date().getTime()-H,error:Q}),this.v.error("Error while installing the extension:",z.identifier.id),Q}finally{M.delete(z.identifier.id.toLowerCase())}}))}return E.length&&await this.D(E),N.forEach(({identifier:L})=>this.v.info("Extension installed successfully:",L.id)),this.m.fire(N),N.filter(({identifier:L})=>(0,m.areSameExtensions)(L,O.identifier))[0].local}catch(M){if(w.forEach(({task:L})=>L.cancel()),N.length)try{const L=await Promise.allSettled(N.map(({local:F})=>this.R(F,{versionOnly:!0,profileLocation:a.profileLocation}).run()));for(let F=0;F<L.length;F++){const z=L[F],{identifier:H}=N[F];z.status==="fulfilled"?this.v.info("Rollback: Uninstalled extension",H.id):this.v.warn("Rollback: Error while uninstalling extension",H.id,(0,k.getErrorMessage)(z.reason))}}catch(L){this.v.warn("Error while rolling back extensions",(0,k.getErrorMessage)(L),N.map(({identifier:F})=>F.id))}throw this.m.fire(w.map(({task:L})=>({identifier:L.identifier,operation:2,source:L.source,context:a.context,profileLocation:a.profileLocation}))),M}finally{for(const{task:M}of w)M.source&&!S.URI.isUri(M.source)&&this.j.delete(u(M.source))}}C(s,o){for(const[,{task:c,waitingTasks:a}]of this.j.entries())if(c===s&&(a.includes(o)||a.some(u=>this.C(u,o)))||c===o&&a[0]&&!this.C(s,a[0]))return!1;return!0}async D(s){const o=[],c=[],a=await Promise.allSettled(s);for(const u of a)u.status==="fulfilled"?o.push(u.value):c.push(u.reason);if(c.length)throw v(c);return o}async F(s,o,c,a,u){if(!this.t.isEnabled())return[];const w=await this.getInstalled(void 0,u),E=[],N=[],O=async(j,M)=>{E.push(j);const L=M.extensionDependencies||[],F=[...L];if(M.extensionPack){const z=c?w.find(H=>(0,m.areSameExtensions)(H.identifier,j)):void 0;for(const H of M.extensionPack)z&&z.manifest.extensionPack&&z.manifest.extensionPack.some(Q=>(0,m.areSameExtensions)({id:Q},{id:H}))||F.every(Q=>!(0,m.areSameExtensions)({id:Q},{id:H}))&&F.push(H)}if(F.length){const z=F.filter(H=>E.every(Q=>!(0,m.areSameExtensions)(Q,{id:H})));if(z.length){const H=await this.t.getExtensions(z.map(Q=>({id:Q,preRelease:a})),D.CancellationToken.None);for(const Q of H){if(E.find(W=>(0,m.areSameExtensions)(W,Q.identifier)))continue;const K=L.some(W=>(0,m.areSameExtensions)({id:W},Q.identifier));let V;try{V=await this.G(Q,!1,a)}catch(W){if(W instanceof b.ExtensionManagementError&&W.code===b.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!K){this.v.info("Skipping the packed extension as it cannot be installed",Q.identifier.id);continue}else throw W}N.push({gallery:V.extension,manifest:V.manifest}),await O(V.extension.identifier,V.manifest)}}}};return await O(s,o),N}async G(s,o,c){if((await this.getExtensionsControlManifest()).malicious.some(E=>(0,m.areSameExtensions)(s.identifier,E)))throw new b.ExtensionManagementError(C.localize(1,null,s.identifier.id),b.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(s)){const E=await this.getTargetPlatform();throw new b.ExtensionManagementError(C.localize(2,null,s.identifier.id,this.w.nameLong,(0,b.TargetPlatformToString)(E)),b.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const u=await this.H(s,o,c);if(u){if(c&&!o&&s.hasPreReleaseVersion&&!u.properties.isPreReleaseVersion)throw new b.ExtensionManagementError(C.localize(3,null,s.identifier.id,this.w.nameLong,this.w.version),b.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!c&&s.properties.isPreReleaseVersion&&(await this.t.getExtensions([s.identifier],D.CancellationToken.None))[0]?new b.ExtensionManagementError(C.localize(4,null,s.identifier.id),b.ExtensionManagementErrorCode.ReleaseVersionNotFound):new b.ExtensionManagementError(C.localize(5,null,s.identifier.id,this.w.nameLong,this.w.version),b.ExtensionManagementErrorCode.Incompatible);this.v.info("Getting Manifest...",u.identifier.id);const w=await this.t.getManifest(u,D.CancellationToken.None);if(w===null)throw new b.ExtensionManagementError(`Missing manifest for extension ${s.identifier.id}`,b.ExtensionManagementErrorCode.Invalid);if(w.version!==u.version)throw new b.ExtensionManagementError(`Cannot install '${s.identifier.id}' extension because of version mismatch in Marketplace`,b.ExtensionManagementErrorCode.Invalid);return{extension:u,manifest:w}}async H(s,o,c){const a=await this.getTargetPlatform();let u=null;return!o&&s.hasPreReleaseVersion&&s.properties.isPreReleaseVersion!==c&&(u=(await this.t.getExtensions([{...s.identifier,preRelease:c}],{targetPlatform:a,compatible:!0},D.CancellationToken.None))[0]||null),!u&&await this.t.isExtensionCompatible(s,c,a)&&(u=s),u||(o?u=(await this.t.getExtensions([{...s.identifier,version:s.version}],{targetPlatform:a,compatible:!0},D.CancellationToken.None))[0]||null:u=await this.t.getCompatibleExtension(s,c,a)),u}async I(s,o){const c={...o,profileLocation:s.isApplicationScoped?this.y.defaultProfile.extensionsResource:o.profileLocation??this.P()},a=j=>`${j.id.toLowerCase()}${c.versionOnly?`-${s.manifest.version}`:""}${c.profileLocation?`@${c.profileLocation.toString()}`:""}`,u=this.k.get(a(s.identifier));if(u)return this.v.info("Extensions is already requested to uninstall",s.identifier.id),u.waitUntilTaskIsFinished();const w=j=>{const M=this.R(j,c);return this.k.set(a(M.extension.identifier),M),c.profileLocation?this.v.info("Uninstalling extension from the profile:",`${j.identifier.id}@${j.manifest.version}`,c.profileLocation.toString()):this.v.info("Uninstalling extension:",`${j.identifier.id}@${j.manifest.version}`),this.n.fire({identifier:j.identifier,profileLocation:c.profileLocation,applicationScoped:j.isApplicationScoped}),M},E=(j,M)=>{M?c.profileLocation?this.v.error("Failed to uninstall extension from the profile:",`${j.identifier.id}@${j.manifest.version}`,c.profileLocation.toString(),M.message):this.v.error("Failed to uninstall extension:",`${j.identifier.id}@${j.manifest.version}`,M.message):c.profileLocation?this.v.info("Successfully uninstalled extension from the profile",`${j.identifier.id}@${j.manifest.version}`,c.profileLocation.toString()):this.v.info("Successfully uninstalled extension:",`${j.identifier.id}@${j.manifest.version}`),i(this.u,"extensionGallery:uninstall",{extensionData:(0,m.getLocalExtensionTelemetryData)(j),error:M}),this.p.fire({identifier:j.identifier,error:M?.code,profileLocation:c.profileLocation,applicationScoped:j.isApplicationScoped})},N=[],O=[];try{N.push(w(s));const j=await this.getInstalled(1,c.profileLocation);if(c.donotIncludePack)this.v.info("Uninstalling the extension without including packed extension",`${s.identifier.id}@${s.manifest.version}`);else{const M=this.M(s,j);for(const L of M)this.k.has(a(L.identifier))?this.v.info("Extensions is already requested to uninstall",L.identifier.id):N.push(w(L))}c.donotCheckDependents?this.v.info("Uninstalling the extension without checking dependents",`${s.identifier.id}@${s.manifest.version}`):this.J(N.map(M=>M.extension),j,s),await this.D(N.map(async M=>{try{if(await M.run(),await this.D(this.s.map(L=>L.postUninstall(M.extension,c,D.CancellationToken.None))),M.extension.identifier.uuid)try{await this.t.reportStatistic(M.extension.manifest.publisher,M.extension.manifest.name,M.extension.manifest.version,"uninstall")}catch{}E(M.extension)}catch(L){const F=L instanceof b.ExtensionManagementError?L:new b.ExtensionManagementError((0,k.getErrorMessage)(L),b.ExtensionManagementErrorCode.Internal);throw E(M.extension,F),F}finally{O.push(M)}}))}catch(j){const M=j instanceof b.ExtensionManagementError?j:new b.ExtensionManagementError((0,k.getErrorMessage)(j),b.ExtensionManagementErrorCode.Internal);for(const L of N){try{L.cancel()}catch{}O.includes(L)||E(L.extension,M)}throw M}finally{for(const j of N)this.k.delete(a(j.extension.identifier))||this.v.warn("Uninstallation task is not found in the cache",j.extension.identifier.id)}}J(s,o,c){for(const a of s){const u=this.N(a,o);if(u.length){const w=u.filter(E=>!s.some(N=>(0,m.areSameExtensions)(N.identifier,E.identifier)));if(w.length)throw new Error(this.L(a,w,c))}}}L(s,o,c){return c===s?o.length===1?C.localize(6,null,c.manifest.displayName||c.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?C.localize(7,null,c.manifest.displayName||c.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):C.localize(8,null,c.manifest.displayName||c.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):o.length===1?C.localize(9,null,c.manifest.displayName||c.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?C.localize(10,null,c.manifest.displayName||c.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):C.localize(11,null,c.manifest.displayName||c.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name)}M(s,o,c=[]){if(c.indexOf(s)!==-1)return[];c.push(s);const a=s.manifest.extensionPack?s.manifest.extensionPack:[];if(a.length){const u=o.filter(E=>!E.isBuiltin&&a.some(N=>(0,m.areSameExtensions)({id:N},E.identifier))),w=[];for(const E of u)w.push(...this.M(E,o,c));return[...u,...w]}return[]}N(s,o){return o.filter(c=>c.manifest.extensionDependencies&&c.manifest.extensionDependencies.some(a=>(0,m.areSameExtensions)({id:a},s.identifier)))}async O(){try{this.v.trace("ExtensionManagementService.refreshReportedCache");const s=await this.t.getExtensionsControlManifest();return this.v.trace("ExtensionManagementService.refreshControlCache",s),s}catch{return this.v.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};g=ye([Y(0,b.IExtensionGalleryService),Y(1,f.ITelemetryService),Y(2,h.ILogService),Y(3,y.IProductService),Y(4,l.IUserDataProfilesService)],g),e.AbstractExtensionManagementService=g;function v(t){const s=Array.isArray(t)?t:[t];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((o,c)=>new Error(`${o.message}${o.message?",":""}${c instanceof Error?c.message:c}`),new Error(""))}e.joinErrors=v;function I(t){if(t instanceof b.ExtensionManagementError)return t;const s=new b.ExtensionManagementError(t.message,b.ExtensionManagementErrorCode.Internal);return s.stack=t.stack,s}function i(t,s,{extensionData:o,verificationStatus:c,duration:a,error:u,durationSinceUpdate:w}){let E,N;u&&(u instanceof b.ExtensionManagementError?(E=u.code,u.code===b.ExtensionManagementErrorCode.Signature&&(N=u.message)):E=b.ExtensionManagementErrorCode.Internal),t.publicLog(s,{...o,verificationStatus:c,success:!u,duration:a,errorcode:E,errorcodeDetail:N,durationSinceUpdate:w})}e.reportTelemetry=i;class r{constructor(){this.d=new n.Barrier}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,n.createCancelablePromise)(s=>this.h(s))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,n.createCancelablePromise)(s=>new Promise((o,c)=>{const a=s.onCancellationRequested(()=>{a.dispose(),c(new k.CancellationError)})})),this.d.open()),this.g.cancel()}}e.AbstractExtensionTask=r}),define(re[51],ae([0,1,6,17,2,3,37,8,33,42,13,4,9,18,29,14,7,19]),function(_,e,A,n,D,k,T,R,P,S,C,b,m,p,h,y,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var d;(function(r){r.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",r.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(d=e.ExtensionsProfileScanningErrorCode||(e.ExtensionsProfileScanningErrorCode={}));class g extends Error{constructor(t,s){super(t),this.code=s}}e.ExtensionsProfileScanningError=g,e.IExtensionsProfileScannerService=(0,b.createDecorator)("IExtensionsProfileScannerService");let v=class extends D.Disposable{constructor(t,s,o,c,a,u){super(),this.h=t,this.i=s,this.j=o,this.k=c,this.l=a,this.m=u,this.a=this.B(new k.Emitter),this.onAddExtensions=this.a.event,this.b=this.B(new k.Emitter),this.onDidAddExtensions=this.b.event,this.c=this.B(new k.Emitter),this.onRemoveExtensions=this.c.event,this.f=this.B(new k.Emitter),this.onDidRemoveExtensions=this.f.event,this.g=new T.ResourceMap}scanProfileExtensions(t,s){return this.n(t,void 0,s)}async addExtensionsToProfile(t,s){const o=[],c=[];try{return await this.n(s,a=>{const u=[];for(const w of a)t.some(([E])=>(0,P.areSameExtensions)(E.identifier,w.identifier)&&E.manifest.version!==w.version)?o.push(w):u.push(w);for(const[w,E]of t)if(!u.some(N=>(0,P.areSameExtensions)(N.identifier,w.identifier)&&N.version===w.manifest.version)){const N={identifier:w.identifier,version:w.manifest.version,location:w.location,metadata:E};c.push(N),u.push(N)}return c.length&&this.a.fire({extensions:c,profileLocation:s}),o.length&&this.c.fire({extensions:o,profileLocation:s}),u}),c.length&&this.b.fire({extensions:c,profileLocation:s}),o.length&&this.f.fire({extensions:o,profileLocation:s}),c}catch(a){throw c.length&&this.b.fire({extensions:c,error:a,profileLocation:s}),o.length&&this.f.fire({extensions:o,error:a,profileLocation:s}),a}}async removeExtensionFromProfile(t,s){const o=[];this.c.fire({extensions:o,profileLocation:s});try{await this.n(s,c=>{const a=[];for(const u of c)(0,P.areSameExtensions)(u.identifier,t.identifier)?o.push(u):a.push(u);return o.length&&this.c.fire({extensions:o,profileLocation:s}),a}),o.length&&this.f.fire({extensions:o,profileLocation:s})}catch(c){throw o.length&&this.f.fire({extensions:o,error:c,profileLocation:s}),c}}async n(t,s,o){return this.v(t).queue(async()=>{let c=[],a;try{const u=await this.i.readFile(t);a=JSON.parse(u.value.toString())}catch(u){if((0,C.toFileOperationResult)(u)!==1)throw u;if(this.k.extUri.isEqual(t,this.j.defaultProfile.extensionsResource)&&(a=await this.u()),!a&&o?.bailOutWhenFileNotFound)throw new g((0,f.getErrorMessage)(u),"ERROR_PROFILE_NOT_FOUND")}if(a){Array.isArray(a)||this.p(t);let u=!1;for(const w of a){I(w)||this.p(t);let E;if((0,y.isString)(w.location))E=this.s(w.location);else{E=R.URI.revive(w.location);const N=this.r(E);N&&(u=!0,w.location=N)}c.push({identifier:w.identifier,location:E,version:w.version,metadata:w.metadata})}u&&await this.i.writeFile(t,n.VSBuffer.fromString(JSON.stringify(a)))}if(s){c=s(c);const u=c.map(w=>({identifier:w.identifier,version:w.version,location:this.r(w.location)??w.location.toJSON(),metadata:w.metadata}));await this.i.writeFile(t,n.VSBuffer.fromString(JSON.stringify(u)))}return c})}p(t){const s=new g(`Invalid extensions content in ${t.toString()}`,"ERROR_INVALID_CONTENT");throw this.l.publicLogError2("extensionsProfileScanningError",{code:s.code}),s}r(t){return this.k.extUri.isEqualOrParent(t,this.h)?this.k.extUri.relativePath(this.h,t):void 0}s(t){return this.k.extUri.joinPath(this.h,t)}async u(){return this.t||(this.t=(async()=>{const t=this.k.extUri.joinPath(this.j.defaultProfile.location,"extensions.json");let s;try{s=(await this.i.readFile(t)).value.toString()}catch(c){if((0,C.toFileOperationResult)(c)===1)return;throw c}this.m.info("Migrating extensions from old default profile location",t.toString());let o;try{const c=JSON.parse(s);Array.isArray(c)&&c.every(a=>I(a))?o=c:this.m.warn("Skipping migrating from old default profile locaiton: Found invalid data",c)}catch(c){this.m.error(c)}if(o)try{await this.i.createFile(this.j.defaultProfile.extensionsResource,n.VSBuffer.fromString(JSON.stringify(o)),{overwrite:!1}),this.m.info("Migrated extensions from old default profile location to new location",t.toString(),this.j.defaultProfile.extensionsResource.toString())}catch(c){if((0,C.toFileOperationResult)(c)===3)this.m.info("Migration from old default profile location to new location is done by another window",t.toString(),this.j.defaultProfile.extensionsResource.toString());else throw c}try{await this.i.del(t)}catch(c){(0,C.toFileOperationResult)(c)!==1&&this.m.error(c)}return o})()),this.t}v(t){let s=this.g.get(t);return s||(s=new A.Queue,this.g.set(t,s)),s}};v=ye([Y(1,C.IFileService),Y(2,p.IUserDataProfilesService),Y(3,h.IUriIdentityService),Y(4,l.ITelemetryService),Y(5,m.ILogService)],v),e.AbstractExtensionsProfileScannerService=v;function I(r){return(0,y.isObject)(r)&&(0,S.isIExtensionIdentifier)(r.identifier)&&(i(r.location)||(0,y.isString)(r.location))&&r.version&&(0,y.isString)(r.version)}function i(r){return r?(0,y.isString)(r.path)&&(0,y.isString)(r.scheme):!1}}),define(re[79],ae([0,1,21,6,32,17,7,35,139,2,24,12,5,22,54,89,14,8,159,15,33,42,70,13,4,9,25,3,67,51,18,29,189,190]),function(_,e,A,n,D,k,T,R,P,S,C,b,m,p,h,y,f,l,d,g,v,I,i,r,t,s,o,c,a,u,w,E,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var j;(function(K){function V(W,G){if(W===G)return!0;const X=Object.keys(W),ie=new Set;for(const oe of Object.keys(G))ie.add(oe);if(X.length!==ie.size)return!1;for(const oe of X){if(W[oe]!==G[oe])return!1;ie.delete(oe)}return ie.size===0}K.equals=V})(j=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,t.createDecorator)("IExtensionsScannerService");let M=class extends S.Disposable{constructor(V,W,G,X,ie,oe,te,U,$,q,B,x){super(),this.systemExtensionsLocation=V,this.userExtensionsLocation=W,this.l=G,this.m=X,this.n=ie,this.p=oe,this.r=te,this.s=U,this.t=$,this.u=q,this.v=B,this.w=x,this.g=this.B(new c.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,p.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.w.createInstance(z,(0,p.joinPath)(this.m,I.BUILTIN_MANIFEST_CACHE_FILE),this.h)),this.j=this.B(this.w.createInstance(z,(0,p.joinPath)(this.m,I.USER_MANIFEST_CACHE_FILE),this.h)),this.k=this.B(this.w.createInstance(F,this.h)),this.z=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.y||(this.y=(0,v.computeTargetPlatform)(this.r,this.s)),this.y}async scanAllExtensions(V,W,G){const[X,ie]=await Promise.all([this.scanSystemExtensions(V),this.scanUserExtensions(W)]),oe=G?await this.scanExtensionsUnderDevelopment(V,[...X,...ie]):[];return this.F(X,ie,oe,await this.getTargetPlatform(),!0)}async scanSystemExtensions(V){const W=[];W.push(this.G(!!V.useCache,V.language)),W.push(this.H(V.language,!!V.checkControlFile));const[G,X]=await Promise.all(W);return this.D([...G,...X],0,V,!1)}async scanUserExtensions(V){const W=V.profileLocation??this.userExtensionsLocation;this.s.trace("Started scanning user extensions",W);const G=this.v.extUri.isEqual(V.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,X=await this.J(W,!!V.profileLocation,1,!V.includeUninstalled,V.language,!0,G),ie=V.useCache&&!X.devMode&&X.excludeObsolete?this.j:this.k;let oe;try{oe=await ie.scanExtensions(X)}catch(te){if(te instanceof u.ExtensionsProfileScanningError&&te.code==="ERROR_PROFILE_NOT_FOUND")await this.C(),oe=await ie.scanExtensions(X);else throw te}return oe=await this.D(oe,1,V,!0),this.s.trace("Scanned user extensions:",oe.length),oe}async scanExtensionsUnderDevelopment(V,W){if(this.t.isExtensionDevelopment&&this.t.extensionDevelopmentLocationURI){const G=(await Promise.all(this.t.extensionDevelopmentLocationURI.filter(X=>X.scheme===C.Schemas.file).map(async X=>{const ie=await this.J(X,!1,1,!0,V.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(ie)).map(te=>(te.type=W.find(U=>(0,v.areSameExtensions)(U.identifier,te.identifier))?.type??te.type,this.k.validate(te,ie)))}))).flat();return this.D(G,"development",V,!0)}return[]}async scanExistingExtension(V,W,G){const X=await this.J(V,!1,W,!0,G.language,!0,void 0),ie=await this.k.scanExtension(X);return!ie||!G.includeInvalid&&!ie.isValid?null:ie}async scanOneOrMultipleExtensions(V,W,G){const X=await this.J(V,!1,W,!0,G.language,!0,void 0),ie=await this.k.scanOneOrMultipleExtensions(X);return this.D(ie,W,G,!0)}async scanMetadata(V){const W=(0,p.joinPath)(V,"package.json"),G=(await this.r.readFile(W)).value.toString();return JSON.parse(G).__metadata}async updateMetadata(V,W){const G=(0,p.joinPath)(V,"package.json"),X=(await this.r.readFile(G)).value.toString(),ie=JSON.parse(X);W.isMachineScoped=W.isMachineScoped||void 0,W.isBuiltin=W.isBuiltin||void 0,W.installedTimestamp=W.installedTimestamp||void 0,ie.__metadata={...ie.__metadata,...W},await this.r.writeFile((0,p.joinPath)(V,"package.json"),k.VSBuffer.fromString(JSON.stringify(ie,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.p.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(V){if(V instanceof u.ExtensionsProfileScanningError&&V.code==="ERROR_PROFILE_NOT_FOUND")await this.C();else throw V}}async C(){return this.z||(this.z=(async()=>{try{this.s.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const V=await this.scanUserExtensions({includeInvalid:!0});if(V.length)await this.p.addExtensionsToProfile(V.map(W=>[W,W.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.r.createFile(this.n.defaultProfile.extensionsResource,k.VSBuffer.fromString(JSON.stringify([])))}catch(W){(0,r.toFileOperationResult)(W)!==1&&this.s.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,T.getErrorMessage)(W))}this.s.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(V){this.s.error(V)}finally{this.z=void 0}})()),this.z}async D(V,W,G,X){return G.includeAllVersions||(V=this.F(W===0?V:void 0,W===1?V:void 0,W==="development"?V:void 0,await this.getTargetPlatform(),X)),G.includeInvalid||(V=V.filter(ie=>ie.isValid)),V.sort((ie,oe)=>{const te=b.basename(ie.location.fsPath),U=b.basename(oe.location.fsPath);return te<U?-1:te>U?1:0})}F(V,W,G,X,ie){const oe=(U,$,q)=>{if(U.isValid&&!$.isValid)return!1;if(U.isValid===$.isValid){if(ie&&h.gt(U.manifest.version,$.manifest.version))return this.s.debug(`Skipping extension ${$.location.path} with lower version ${$.manifest.version} in favour of ${U.location.path} with version ${U.manifest.version}`),!1;if(h.eq(U.manifest.version,$.manifest.version)){if(U.type===0)return this.s.debug(`Skipping extension ${$.location.path} in favour of system extension ${U.location.path} with same version`),!1;if(U.targetPlatform===X)return this.s.debug(`Skipping extension ${$.location.path} from different target platform ${$.targetPlatform}`),!1}}return q?this.s.warn(`Overwriting user extension ${U.location.path} with ${$.location.path}.`):this.s.debug(`Overwriting user extension ${U.location.path} with ${$.location.path}.`),!0},te=new Map;return V?.forEach(U=>{const $=I.ExtensionIdentifier.toKey(U.identifier.id),q=te.get($);(!q||oe(q,U,!1))&&te.set($,U)}),W?.forEach(U=>{const $=I.ExtensionIdentifier.toKey(U.identifier.id),q=te.get($);if(!q&&V&&U.type===0){this.s.debug(`Skipping obsolete system extension ${U.location.path}.`);return}(!q||oe(q,U,!1))&&te.set($,U)}),G?.forEach(U=>{const $=I.ExtensionIdentifier.toKey(U.identifier.id),q=te.get($);(!q||oe(q,U,!0))&&te.set($,U),te.set($,U)}),[...te.values()]}async G(V,W){this.s.trace("Started scanning system extensions");const G=await this.J(this.systemExtensionsLocation,!1,0,!0,W,!0,void 0),ie=await(V&&!G.devMode?this.i:this.k).scanExtensions(G);return this.s.trace("Scanned system extensions:",ie.length),ie}async H(V,W){const G=this.t.isBuilt?[]:this.u.builtInExtensions;if(!G?.length)return[];this.s.trace("Started scanning dev system extensions");const X=W?await this.I():{},ie=[],oe=l.URI.file(b.normalize(b.join(C.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const U of G){const $=X[U.name]||"marketplace";switch($){case"disabled":break;case"marketplace":ie.push((0,p.joinPath)(oe,U.name));break;default:ie.push(l.URI.file($));break}}const te=await Promise.all(ie.map(async U=>this.k.scanExtension(await this.J(U,!1,0,!0,V,!0,void 0))));return this.s.trace("Scanned dev system extensions:",te.length),(0,A.coalesce)(te)}async I(){try{const V=await this.r.readFile(this.l);return JSON.parse(V.value.toString())}catch{return{}}}async J(V,W,G,X,ie,oe,te){const U=await this.f(ie??m.language),$=await this.L(V),q=W&&!this.v.extUri.isEqual(V,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,B=q?await this.L(q):void 0;return new L(V,$,q,B,W,te,G,X,oe,this.u.version,this.u.date,this.u.commit,!this.t.isBuilt,ie,U)}async L(V){try{const W=await this.r.stat(V);if(typeof W.mtime=="number")return W.mtime}catch{}}};M=ye([Y(4,w.IUserDataProfilesService),Y(5,u.IExtensionsProfileScannerService),Y(6,r.IFileService),Y(7,s.ILogService),Y(8,g.IEnvironmentService),Y(9,o.IProductService),Y(10,E.IUriIdentityService),Y(11,t.IInstantiationService)],M),e.AbstractExtensionsScannerService=M;class L{constructor(V,W,G,X,ie,oe,te,U,$,q,B,x,ee,J,Z){this.location=V,this.mtime=W,this.applicationExtensionslocation=G,this.applicationExtensionslocationMtime=X,this.profile=ie,this.profileScanOptions=oe,this.type=te,this.excludeObsolete=U,this.validate=$,this.productVersion=q,this.productDate=B,this.productCommit=x,this.devMode=ee,this.language=J,this.translations=Z}static createNlsConfiguration(V){return{language:V.language,pseudo:V.language==="pseudo",devMode:V.devMode,translations:V.translations}}static equals(V,W){return(0,p.isEqual)(V.location,W.location)&&V.mtime===W.mtime&&(0,p.isEqual)(V.applicationExtensionslocation,W.applicationExtensionslocation)&&V.applicationExtensionslocationMtime===W.applicationExtensionslocationMtime&&V.profile===W.profile&&D.equals(V.profileScanOptions,W.profileScanOptions)&&V.type===W.type&&V.excludeObsolete===W.excludeObsolete&&V.validate===W.validate&&V.productVersion===W.productVersion&&V.productDate===W.productDate&&V.productCommit===W.productCommit&&V.devMode===W.devMode&&V.language===W.language&&j.equals(V.translations,W.translations)}}e.ExtensionScannerInput=L;let F=class extends S.Disposable{constructor(V,W,G,X,ie){super(),this.f=V,this.g=W,this.h=G,this.i=X,this.j=ie}async scanExtensions(V){const W=V.profile?await this.l(V):await this.k(V);let G={};if(V.excludeObsolete&&V.type===1)try{const X=(await this.i.readFile(this.f)).value.toString();G=JSON.parse(X)}catch{}return(0,f.isEmptyObject)(G)?W:W.filter(X=>!G[v.ExtensionKey.create(X).toString()])}async k(V){const W=await this.i.resolve(V.location);if(!W.children?.length)return[];const G=await Promise.all(W.children.map(async X=>{if(!X.isDirectory||V.type===1&&(0,p.basename)(X.resource).indexOf(".")===0)return null;const ie=new L(X.resource,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(ie)}));return(0,A.coalesce)(G).sort((X,ie)=>X.location.path<ie.location.path?-1:1)}async l(V){let W=await this.m(V.location,()=>!0,V);if(V.applicationExtensionslocation&&!this.h.extUri.isEqual(V.location,V.applicationExtensionslocation)){W=W.filter(X=>!X.metadata?.isApplicationScoped);const G=await this.m(V.applicationExtensionslocation,X=>!!X.metadata?.isApplicationScoped,V);W.push(...G)}return W}async m(V,W,G){const X=await this.g.scanProfileExtensions(V,G.profileScanOptions);if(!X.length)return[];const ie=await Promise.all(X.map(async oe=>{if(W(oe)){const te=new L(oe.location,G.mtime,G.applicationExtensionslocation,G.applicationExtensionslocationMtime,G.profile,G.profileScanOptions,G.type,G.excludeObsolete,G.validate,G.productVersion,G.productDate,G.productCommit,G.devMode,G.language,G.translations);return this.scanExtension(te,oe.metadata)}return null}));return(0,A.coalesce)(ie)}async scanOneOrMultipleExtensions(V){try{if(await this.i.exists((0,p.joinPath)(V.location,"package.json"))){const W=await this.scanExtension(V);return W?[W]:[]}else return await this.scanExtensions(V)}catch(W){return this.j.error(`Error scanning extensions at ${V.location.path}:`,(0,T.getErrorMessage)(W)),[]}}async scanExtension(V,W){try{let G=await this.scanExtensionManifest(V.location);if(G){G.publisher||(G.publisher=I.UNDEFINED_PUBLISHER),W=W??G.__metadata,delete G.__metadata;const X=(0,v.getGalleryExtensionId)(G.publisher,G.name),ie=W?.id?{id:X,uuid:W.id}:{id:X},oe=W?.isSystem?0:V.type,te=oe===0||!!W?.isBuiltin;O.ImplicitActivationEvents.updateManifest(G),G=await this.n(V.location,G,L.createNlsConfiguration(V));const U={type:oe,identifier:ie,manifest:G,location:V.location,isBuiltin:te,targetPlatform:W?.targetPlatform??"undefined",metadata:W,isValid:!0,validations:[]};return V.validate?this.validate(U,V):U}}catch(G){V.type!==0&&this.j.error(G)}return null}validate(V,W){let G=!0;const X=(0,i.validateExtensionManifest)(W.productVersion,W.productDate,W.location,V.manifest,V.isBuiltin);for(const[ie,oe]of X)ie===y.default.Error&&(G=!1,this.j.error(this.t(W.location,oe)));return V.isValid=G,V.validations=X,V}async scanExtensionManifest(V){const W=(0,p.joinPath)(V,"package.json");let G;try{G=(await this.i.readFile(W)).value.toString()}catch(ie){return(0,r.toFileOperationResult)(ie)!==1&&this.j.error(this.t(V,(0,d.localize)(0,null,W.path,ie.message))),null}let X;try{X=JSON.parse(G)}catch{const oe=[];(0,R.parse)(G,oe);for(const te of oe)this.j.error(this.t(V,(0,d.localize)(1,null,W.path,te.offset,te.length,(0,P.getParseErrorMessage)(te.error))));return null}return(0,R.getNodeType)(X)!=="object"?(this.j.error(this.t(V,(0,d.localize)(2,null,W.path))),null):X}async n(V,W,G){const X=await this.p(V,W,G);if(X)try{const ie=[],oe=await this.r(X.default,ie);if(ie.length>0)return ie.forEach(U=>{this.j.error(this.t(V,(0,d.localize)(3,null,X.default?.path,(0,P.getParseErrorMessage)(U.error))))}),W;if((0,R.getNodeType)(X)!=="object")return this.j.error(this.t(V,(0,d.localize)(4,null,X.default?.path))),W;const te=X.values||Object.create(null);return(0,N.localizeManifest)(W,te,oe)}catch{}return W}async p(V,W,G){const X=(0,p.joinPath)(V,"package.nls.json"),ie=($,q)=>{q.forEach(B=>{this.j.error(this.t(V,(0,d.localize)(5,null,$?.path,(0,P.getParseErrorMessage)(B.error))))})},oe=$=>{this.j.error(this.t(V,(0,d.localize)(6,null,$?.path)))},te=`${W.publisher}.${W.name}`,U=G.translations[te];if(U)try{const $=l.URI.file(U),q=(await this.i.readFile($)).value.toString(),B=[],x=(0,R.parse)(q,B);return B.length>0?(ie($,B),{values:void 0,default:X}):(0,R.getNodeType)(x)!=="object"?(oe($),{values:void 0,default:X}):{values:x.contents?x.contents.package:void 0,default:X}}catch{return{values:void 0,default:X}}else{if(!await this.i.exists(X))return;let q;try{q=await this.s(V,G)}catch{return}if(!q.localized)return{values:void 0,default:q.original};try{const B=(await this.i.readFile(q.localized)).value.toString(),x=[],ee=(0,R.parse)(B,x);return x.length>0?(ie(q.localized,x),{values:void 0,default:q.original}):(0,R.getNodeType)(ee)!=="object"?(oe(q.localized),{values:void 0,default:q.original}):{values:ee,default:q.original}}catch{return{values:void 0,default:q.original}}}}async r(V,W){if(V)try{const G=(await this.i.readFile(V)).value.toString();return(0,R.parse)(G,W)}catch{}}s(V,W){return new Promise((G,X)=>{const ie=oe=>{const te=(0,p.joinPath)(V,`package.nls.${oe}.json`);this.i.exists(te).then(U=>{U&&G({localized:te,original:(0,p.joinPath)(V,"package.nls.json")});const $=oe.lastIndexOf("-");$===-1?G({localized:(0,p.joinPath)(V,"package.nls.json"),original:null}):(oe=oe.substring(0,$),ie(oe))})};if(W.devMode||W.pseudo||!W.language)return G({localized:(0,p.joinPath)(V,"package.nls.json"),original:null});ie(W.language)})}t(V,W){return`[${V.path}]: ${W}`}};F=ye([Y(1,u.IExtensionsProfileScannerService),Y(2,E.IUriIdentityService),Y(3,r.IFileService),Y(4,s.ILogService)],F);let z=class extends F{constructor(V,W,G,X,ie,oe){super(W,G,X,ie,oe),this.y=V,this.v=this.B(new n.ThrottledDelayer(3e3)),this.w=this.B(new c.Emitter),this.onDidChangeCache=this.w.event}async scanExtensions(V){const W=await this.z();if(this.u=V,W&&W.input&&L.equals(W.input,this.u))return this.j.debug("Using cached extensions scan result",V.location.toString()),this.v.trigger(()=>this.D()),W.result.map(X=>(X.location=l.URI.revive(X.location),X));const G=await super.scanExtensions(V);return await this.C({input:V,result:G}),G}async z(){try{const V=await this.i.readFile(this.y),W=JSON.parse(V.value.toString());return{result:W.result,input:(0,a.revive)(W.input)}}catch(V){this.j.debug("Error while reading the extension cache file:",this.y.path,(0,T.getErrorMessage)(V))}return null}async C(V){try{await this.i.writeFile(this.y,k.VSBuffer.fromString(JSON.stringify(V)))}catch(W){this.j.debug("Error while writing the extension cache file:",this.y.path,(0,T.getErrorMessage)(W))}}async D(){if(!this.u)return;const V=await this.z();if(!V)return;const W=V.result,G=JSON.parse(JSON.stringify(await super.scanExtensions(this.u)));if(!D.equals(G,W))try{await this.i.del(this.y),this.w.fire()}catch(X){this.j.error(X)}}};z=ye([Y(2,u.IExtensionsProfileScannerService),Y(3,E.IUriIdentityService),Y(4,r.IFileService),Y(5,s.ILogService)],z);function H(K,V){const W=(0,v.getExtensionId)(K.manifest.publisher,K.manifest.name);return{id:W,identifier:new I.ExtensionIdentifier(W),isBuiltin:K.type===0,isUserBuiltin:K.type===1&&K.isBuiltin,isUnderDevelopment:V,extensionLocation:K.location,uuid:K.identifier.uuid,targetPlatform:K.targetPlatform,...K.manifest}}e.toExtensionDescription=H;class Q extends M{constructor(V,W,G,X,ie,oe,te,U,$,q,B,x){super(V,W,(0,p.joinPath)(G,".vscode-oss-dev","extensions","control.json"),(0,p.joinPath)(X,I.MANIFEST_CACHE_FOLDER),ie,oe,te,U,$,q,B,x),this.M=(async()=>{if(m.translationsConfigFile)try{const ee=await this.r.readFile(l.URI.file(m.translationsConfigFile));return JSON.parse(ee.value.toString())}catch{}return Object.create(null)})()}f(V){return this.M}}e.NativeExtensionsScannerService=Q}),define(re[264],ae([0,1,9,18,29,19,51,13,15,8]),function(_,e,A,n,D,k,T,R,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let C=class extends T.AbstractExtensionsProfileScannerService{constructor(m,p,h,y,f,l){super(S.URI.file(m.extensionsPath),p,h,y,f,l)}};C=ye([Y(0,P.INativeEnvironmentService),Y(1,R.IFileService),Y(2,n.IUserDataProfilesService),Y(3,D.IUriIdentityService),Y(4,k.ITelemetryService),Y(5,A.ILogService)],C),e.ExtensionsProfileScannerService=C}),define(re[265],ae([0,1,50,6,38,3,2,24,12,28,9,18]),function(_,e,A,n,D,k,T,R,P,S,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let m=class extends T.Disposable{constructor(h,y){super(),this.b=h,this.f=y,this.a=new n.Limiter(5)}async postUninstall(h){const y=this.g(h,"uninstall");return y&&(this.f.info(h.identifier.id,h.manifest.version,"Running post uninstall script"),await this.a.queue(()=>this.h(y.script,"uninstall",y.args,!0,h).then(()=>this.f.info(h.identifier.id,h.manifest.version,"Finished running post uninstall script"),f=>this.f.error(h.identifier.id,h.manifest.version,`Failed to run post uninstall script: ${f}`)))),S.Promises.rm(this.j(h)).then(void 0,f=>this.f.error("Error while removing extension storage path",f))}g(h,y){const f=`vscode:${y}`;if(h.location.scheme===R.Schemas.file&&h.manifest&&h.manifest.scripts&&typeof h.manifest.scripts[f]=="string"){const l=h.manifest.scripts[f].split(" ");return l.length<2||l[0]!=="node"||!l[1]?(this.f.warn(h.identifier.id,h.manifest.version,`${f} should be a node script`),null):{script:(0,P.join)(h.location.fsPath,l[1]),args:l.slice(2)||[]}}return null}h(h,y,f,l,d){return new Promise((g,v)=>{const I=this.i(h,y,f,d);let i;const r=t=>{i&&(clearTimeout(i),i=null),t?v(t):g(void 0)};I.on("error",t=>{r((0,D.toErrorMessage)(t)||"Unknown")}),I.on("exit",(t,s)=>{r(t?`post-${y} process exited with code ${t}`:void 0)}),l&&(i=setTimeout(()=>{i=null,I.kill(),v("timed out")},5e3))})}i(h,y,f,l){const d={silent:!0,execArgv:void 0},g=(0,A.fork)(h,[`--type=extension-post-${y}`,...f],d);g.stdout.setEncoding("utf8"),g.stderr.setEncoding("utf8");const v=k.Event.fromNodeEventEmitter(g.stdout,"data"),I=k.Event.fromNodeEventEmitter(g.stderr,"data");v(t=>this.f.info(l.identifier.id,l.manifest.version,`post-${y}`,t)),I(t=>this.f.error(l.identifier.id,l.manifest.version,`post-${y}`,t));const i=k.Event.any(k.Event.map(v,t=>({data:`%c${t}`,format:[""]})),k.Event.map(I,t=>({data:`%c${t}`,format:["color: red"]})));return k.Event.debounce(i,(t,s)=>t?{data:t.data+s.data,format:[...t.format,...s.format]}:{data:s.data,format:s.format},100)(t=>{console.group(l.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),g}j(h){return(0,P.join)(this.b.defaultProfile.globalStorageHome.fsPath,h.identifier.id.toLowerCase())}};m=ye([Y(0,b.IUserDataProfilesService),Y(1,C.ILogService)],m),e.ExtensionsLifecycle=m}),define(re[266],ae([0,1,8,15,51,79,13,4,9,25,29,18]),function(_,e,A,n,D,k,T,R,P,S,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let m=class extends k.NativeExtensionsScannerService{constructor(h,y,f,l,d,g,v,I){super(A.URI.file(d.builtinExtensionsPath),A.URI.file(d.extensionsPath),d.userHome,A.URI.file(d.userDataPath),h,y,f,l,d,g,v,I)}};m=ye([Y(0,b.IUserDataProfilesService),Y(1,D.IExtensionsProfileScannerService),Y(2,T.IFileService),Y(3,P.ILogService),Y(4,n.INativeEnvironmentService),Y(5,S.IProductService),Y(6,C.IUriIdentityService),Y(7,R.IInstantiationService)],m),e.ExtensionsScannerService=m}),define(re[20],ae([0,1,6,3,2,102,14,69,4,18]),function(_,e,A,n,D,k,T,R,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,P.createDecorator)("storageService");var C;(function(d){d[d.NONE=0]="NONE",d[d.SHUTDOWN=1]="SHUTDOWN"})(C=e.WillSaveStateReason||(e.WillSaveStateReason={}));var b;(function(d){d[d.APPLICATION=-1]="APPLICATION",d[d.PROFILE=0]="PROFILE",d[d.WORKSPACE=1]="WORKSPACE"})(b=e.StorageScope||(e.StorageScope={}));var m;(function(d){d[d.USER=0]="USER",d[d.MACHINE=1]="MACHINE"})(m=e.StorageTarget||(e.StorageTarget={}));function p(d){const g=d.get(e.TARGET_KEY);if(g)try{return JSON.parse(g)}catch{}return Object.create(null)}e.loadKeyTargets=p;class h extends D.Disposable{constructor(g={flushInterval:h.a}){super(),this.j=g,this.b=this.B(new n.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new n.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new n.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new A.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new D.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,A.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,D.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,k.mark)("code/willInitStorage");try{await this.J()}finally{(0,k.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(g,v){if(v===e.TARGET_KEY){switch(g){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:g})}else this.b.fire({scope:g,key:v,target:this.F(g)[v]})}r(g){this.f.fire({reason:g})}get(g,v,I){return this.L(v)?.get(g,I)}getBoolean(g,v,I){return this.L(v)?.getBoolean(g,I)}getNumber(g,v,I){return this.L(v)?.getNumber(g,I)}store(g,v,I,i){if((0,T.isUndefinedOrNull)(v)){this.remove(g,I);return}this.t(()=>{this.u(g,I,i),this.L(I)?.set(g,v)})}remove(g,v){this.t(()=>{this.u(g,v,void 0),this.L(v)?.delete(g)})}t(g){this.b.pause(),this.c.pause();try{g()}finally{this.b.resume(),this.c.resume()}}keys(g,v){const I=[],i=this.F(g);for(const r of Object.keys(i))i[r]===v&&I.push(r);return I}u(g,v,I){const i=this.F(v);typeof I=="number"?i[g]!==I&&(i[g]=I,this.L(v)?.set(e.TARGET_KEY,JSON.stringify(i))):typeof i[g]=="number"&&(delete i[g],this.L(v)?.set(e.TARGET_KEY,JSON.stringify(i)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(g){switch(g){case-1:return this.D;case 0:return this.z;default:return this.w}}G(g){const v=this.L(g);return v?p(v):Object.create(null)}isNew(g){return this.getBoolean(e.IS_NEW_KEY,g)===!0}async flush(g=C.NONE){this.f.fire({reason:g});const v=this.L(-1),I=this.L(0),i=this.L(1);switch(g){case C.NONE:await A.Promises.settled([v?.whenFlushed()??Promise.resolve(),I?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case C.SHUTDOWN:await A.Promises.settled([v?.flush(0)??Promise.resolve(),I?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const g=this.L(-1)?.items??new Map,v=this.L(0)?.items??new Map,I=this.L(1)?.items??new Map;return l(g,v,I,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(g,v){return this.r(C.NONE),(0,S.isUserDataProfile)(g)?this.N(g,v):this.O(g,v)}H(g,v){return!(g.id===v.id||y(v)&&y(g))}I(g,v,I,i){this.t(()=>{if(i)for(const[r,t]of g)v.set(r,t);else{const r=new Set;for(const[t,s]of g)r.add(t),v.get(t)!==s&&this.n(I,t);for(const[t]of v.items)r.has(t)||this.n(I,t)}})}}e.AbstractStorageService=h,h.a=60*1e3;function y(d){return d.isDefault||!!d.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=y;class f extends h{constructor(){super(),this.p=this.B(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(g=>this.n(1,g))),this.B(this.P.onDidChangeStorage(g=>this.n(0,g))),this.B(this.p.onDidChangeStorage(g=>this.n(-1,g)))}L(g){switch(g){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(g){switch(g){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(g){return!1}}e.InMemoryStorageService=f;async function l(d,g,v,I,i,r){const t=O=>{try{return JSON.parse(O)}catch{return O}},s=new Map,o=new Map;d.forEach((O,j)=>{s.set(j,O),o.set(j,t(O))});const c=new Map,a=new Map;g.forEach((O,j)=>{c.set(j,O),a.set(j,t(O))});const u=new Map,w=new Map;v.forEach((O,j)=>{u.set(j,O),w.set(j,t(O))}),console.group(I!==i?`Storage: Application (path: ${I})`:`Storage: Application & Profile (path: ${I}, default profile)`);const E=[];if(s.forEach((O,j)=>{E.push({key:j,value:O})}),console.table(E),console.groupEnd(),console.log(o),I!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const O=[];c.forEach((j,M)=>{O.push({key:M,value:j})}),console.table(O),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${r})`);const N=[];u.forEach((O,j)=>{N.push({key:j,value:O})}),console.table(N),console.groupEnd(),console.log(w)}e.logStorage=l}),define(re[118],ae([0,1,3,2,14,30,33,20]),function(_,e,A,n,D,k,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let P=class extends n.Disposable{constructor(b,m){super(),this.a=new A.Emitter,this.onDidChangeEnablement=this.a.event,this.b=this.B(new S(b)),this.B(this.b.onDidChange(p=>this.a.fire({extensions:p,source:"storage"}))),this.B(m.onDidInstallExtensions(p=>p.forEach(({local:h,operation:y})=>{h&&y===4&&this.f(h.identifier)})))}async enableExtension(b,m){return this.f(b)?(this.a.fire({extensions:[b],source:m}),!0):!1}async disableExtension(b,m){return this.c(b)?(this.a.fire({extensions:[b],source:m}),!0):!1}getDisabledExtensions(){return this.h(k.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(b){const m=this.getDisabledExtensions();return m.every(p=>!(0,T.areSameExtensions)(p,b))?(m.push(b),this.g(m),!0):!1}f(b){const m=this.getDisabledExtensions();for(let p=0;p<m.length;p++){const h=m[p];if((0,T.areSameExtensions)(h,b))return m.splice(p,1),this.g(m),!0}return!1}g(b){this.i(k.DISABLED_EXTENSIONS_STORAGE_PATH,b)}h(b){return this.b.get(b,0)}i(b,m){this.b.set(b,m,0)}};P=ye([Y(0,R.IStorageService),Y(1,k.IExtensionManagementService)],P),e.GlobalExtensionEnablementService=P;class S extends n.Disposable{constructor(b){super(),this.c=b,this.a=Object.create(null),this.b=this.B(new A.Emitter),this.onDidChange=this.b.event,this.B(b.onDidChangeValue(m=>this.f(m)))}get(b,m){let p;return m===0?((0,D.isUndefinedOrNull)(this.a[b])&&(this.a[b]=this.g(b,m)),p=this.a[b]):p=this.g(b,m),JSON.parse(p)}set(b,m,p){const h=JSON.stringify(m.map(({id:f,uuid:l})=>({id:f,uuid:l})));this.g(b,p)!==h&&(p===0&&(m.length?this.a[b]=h:delete this.a[b]),this.h(b,m.length?h:void 0,p))}f(b){if(b.scope===0&&!(0,D.isUndefinedOrNull)(this.a[b.key])&&this.g(b.key,b.scope)!==this.a[b.key]){const p=this.get(b.key,b.scope);delete this.a[b.key];const h=this.get(b.key,b.scope),y=p.filter(l=>!h.some(d=>(0,T.areSameExtensions)(l,d))),f=h.filter(l=>!p.some(d=>(0,T.areSameExtensions)(d,l)));(y.length||f.length)&&this.b.fire([...y,...f])}}g(b,m){return this.c.get(b,m,"[]")}h(b,m,p){m?this.c.store(b,m,p,1):this.c.remove(b,p)}}e.StorageManager=S}),define(re[267],ae([0,1,21,23,7,5,36,14,8,16,15,30,33,70,13,9,25,60,236,20,19]),function(_,e,A,n,D,k,T,R,P,S,C,b,m,p,h,y,f,l,d,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const I=k.isWeb?"web":(0,b.getTargetPlatform)(k.platform,T.arch);var i;(function(U){U[U.None=0]="None",U[U.IncludeVersions=1]="IncludeVersions",U[U.IncludeFiles=2]="IncludeFiles",U[U.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",U[U.IncludeSharedAccounts=8]="IncludeSharedAccounts",U[U.IncludeVersionProperties=16]="IncludeVersionProperties",U[U.ExcludeNonValidated=32]="ExcludeNonValidated",U[U.IncludeInstallationTargets=64]="IncludeInstallationTargets",U[U.IncludeAssetUri=128]="IncludeAssetUri",U[U.IncludeStatistics=256]="IncludeStatistics",U[U.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",U[U.Unpublished=4096]="Unpublished",U[U.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(i||(i={}));function r(...U){return String(U.reduce(($,q)=>$|q,0))}var t;(function(U){U[U.Tag=1]="Tag",U[U.ExtensionId=4]="ExtensionId",U[U.Category=5]="Category",U[U.ExtensionName=7]="ExtensionName",U[U.Target=8]="Target",U[U.Featured=9]="Featured",U[U.SearchText=10]="SearchText",U[U.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const s={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},a={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:i.None,criteria:[],assetTypes:[]};class u{constructor($=a){this.d=$}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage($,q=this.d.pageSize){return new u({...this.d,pageNumber:$,pageSize:q})}withFilter($,...q){const B=[...this.d.criteria,...q.length?q.map(x=>({filterType:$,value:x})):[{filterType:$}]];return new u({...this.d,criteria:B})}withSortBy($){return new u({...this.d,sortBy:$})}withSortOrder($){return new u({...this.d,sortOrder:$})}withFlags(...$){return new u({...this.d,flags:$.reduce((q,B)=>q|B,0)})}withAssetTypes(...$){return new u({...this.d,assetTypes:$})}withSource($){return new u({...this.d,source:$})}get raw(){const{criteria:$,pageNumber:q,pageSize:B,sortBy:x,sortOrder:ee,flags:J,assetTypes:Z}=this.d;return{filters:[{criteria:$,pageNumber:q,pageSize:B,sortBy:x,sortOrder:ee}],assetTypes:Z,flags:J}}get searchText(){const $=this.d.criteria.filter(q=>q.filterType===t.SearchText)[0];return $&&$.value?$.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map($=>String($.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function w(U,$){const q=(U||[]).filter(B=>B.statisticName===$)[0];return q?q.value:0}function E(U){const $="Microsoft.VisualStudio.Code.Translation.";return U.files.filter(B=>B.assetType.indexOf($)===0).reduce((B,x)=>{const ee=j(U,x.assetType);return ee&&B.push([x.assetType.substring($.length),ee]),B},[])}function N(U){if(U.properties){const $=U.properties.filter(x=>x.key===s.Repository),q=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),B=$.filter(x=>q.test(x.value))[0];return B?{uri:B.value,fallbackUri:B.value}:null}return j(U,s.Repository)}function O(U){return{uri:`${U.fallbackAssetUri}/${s.VSIX}?redirect=true${U.targetPlatform?`&targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${s.VSIX}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}}function j(U,$){return U.files.filter(B=>B.assetType===$)[0]?{uri:`${U.assetUri}/${$}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${$}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}:null}function M(U,$){const q=U.properties?U.properties.filter(x=>x.key===$):[],B=q.length>0&&q[0].value;return B?B.split(",").map(x=>(0,m.adoptToGalleryExtensionId)(x)):[]}function L(U){const $=U.properties?U.properties.filter(q=>q.key===o.Engine):[];return $.length>0&&$[0].value||""}function F(U){const $=U.properties?U.properties.filter(q=>q.key===o.PreRelease):[];return $.length>0&&$[0].value==="true"}function z(U){const $=U.properties?U.properties.filter(B=>B.key===o.LocalizedLanguages):[],q=$.length>0&&$[0].value||"";return q?q.split(","):[]}function H(U){return U.properties?.find($=>$.key===o.SponsorLink)?.value}function Q(U){return U.indexOf("preview")!==-1}function K(U){return U.targetPlatform?(0,b.toTargetPlatform)(U.targetPlatform):"undefined"}function V(U){const $=(0,A.distinct)(U.versions.map(K)),q=!!U.tags?.includes(b.WEB_EXTENSION_TAG),B=$.indexOf("web");return q?B===-1&&$.push("web"):B!==-1&&$.splice(B,1),$}function W(U,$){const q=(0,b.getFallbackTargetPlarforms)($);for(let B=0;B<U.length;B++){const x=U[B];if(x.version===U[B-1]?.version){let ee=B;const J=K(x);if(J===$)for(;ee>0&&U[ee-1].version===x.version;)ee--;else if(q.includes(J))for(;ee>0&&U[ee-1].version===x.version&&K(U[ee-1])!==$;)ee--;ee!==B&&(U.splice(B,1),U.splice(ee,0,x))}}return U}e.sortExtensionVersions=W;function G(U,$,q){U.telemetryData={index:$,querySource:q}}function X(U,$,q){const B=U.versions[0],x={manifest:j($,s.Manifest),readme:j($,s.Details),changelog:j($,s.Changelog),license:j($,s.License),repository:N($),download:O($),icon:j($,s.Icon),signature:j($,s.Signature),coreTranslations:E($)};return{identifier:{id:(0,m.getGalleryExtensionId)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},name:U.extensionName,version:$.version,displayName:U.displayName,publisherId:U.publisher.publisherId,publisher:U.publisher.publisherName,publisherDisplayName:U.publisher.displayName,publisherDomain:U.publisher.domain?{link:U.publisher.domain,verified:!!U.publisher.isDomainVerified}:void 0,publisherSponsorLink:H(B),description:U.shortDescription||"",installCount:w(U.statistics,"install"),rating:w(U.statistics,"averagerating"),ratingCount:w(U.statistics,"ratingcount"),categories:U.categories||[],tags:U.tags||[],releaseDate:Date.parse(U.releaseDate),lastUpdated:Date.parse(U.lastUpdated),allTargetPlatforms:q,assets:x,properties:{dependencies:M($,o.Dependency),extensionPack:M($,o.ExtensionPack),engine:L($),localizedLanguages:z($),targetPlatform:K($),isPreReleaseVersion:F($)},hasPreReleaseVersion:F(B),hasReleaseVersion:!0,preview:Q(U.flags),isSigned:!!x.signature}}let ie=class{constructor($,q,B,x,ee,J,Z,se){this.k=q,this.l=B,this.n=x,this.o=ee,this.q=J,this.u=Z,this.w=se;const le=Z.extensionsGallery,ue=le?.servicePPEUrl&&se.getValue("_extensionsGallery.enablePPE");this.d=ue?le.servicePPEUrl:le?.serviceUrl,this.g=ue?void 0:le?.searchUrl,this.h=le?.controlUrl,this.j=(0,d.resolveMarketplaceHeaders)(Z.version,Z,this.n,this.w,this.q,$,this.o)}x($=""){return`${this.d}${$}`}isEnabled(){return!!this.d}async getExtensions($,q,B){const x=n.CancellationToken.isCancellationToken(q)?{}:q,ee=n.CancellationToken.isCancellationToken(q)?q:B,J=[],Z=[],se=[],le=[];let ue=!0;for(const be of $){be.uuid?Z.push(be.uuid):J.push(be.id);const Ee=!!(be.version||be.preRelease);se.push({id:be.id,uuid:be.uuid,includePreRelease:Ee}),be.version&&le.push({id:be.id,uuid:be.uuid,version:be.version}),ue=ue&&!!be.hasPreRelease&&!Ee}if(!Z.length&&!J.length)return[];let pe=new u().withPage(1,$.length);Z.length&&(pe=pe.withFilter(t.ExtensionId,...Z)),J.length&&(pe=pe.withFilter(t.ExtensionName,...J)),(x.queryAllVersions||ue)&&(pe=pe.withFlags(pe.flags,i.IncludeVersions)),x.source&&(pe=pe.withSource(x.source));const{extensions:we}=await this.z(pe,{targetPlatform:x.targetPlatform??I,includePreRelease:se,versions:le,compatible:!!x.compatible},ee);return x.source&&we.forEach((be,Ee)=>G(be,Ee,x.source)),we}async getCompatibleExtension($,q,B){if((0,b.isNotWebExtensionInWebTargetPlatform)($.allTargetPlatforms,B))return null;if(await this.isExtensionCompatible($,q,B))return $;const x=new u().withFlags(i.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,$.identifier.uuid),{extensions:ee}=await this.z(x,{targetPlatform:B,compatible:!0,includePreRelease:q},n.CancellationToken.None);return ee[0]||null}async isExtensionCompatible($,q,B){if(!(0,b.isTargetPlatformCompatible)($.properties.targetPlatform,$.allTargetPlatforms,B)||!q&&$.properties.isPreReleaseVersion)return!1;let x=$.properties.engine;if(!x){const ee=await this.getManifest($,n.CancellationToken.None);if(!ee)throw new Error("Manifest was not found");x=ee.engines.vscode}return(0,p.isEngineValid)(x,this.u.version,this.u.date)}async y($,q,B,x,ee){if(!(0,b.isTargetPlatformCompatible)(K($),x,ee)||q!=="any"&&F($)!==(q==="prerelease"))return!1;if(B)try{const J=await this.E($);if(!(0,p.isEngineValid)(J,this.u.version,this.u.date))return!1}catch(J){return this.l.error(`Error while getting the engine for the version ${$.version}.`,(0,D.getErrorMessage)(J)),!1}return!0}async query($,q){let B=$.text||"";const x=$.pageSize??50;let ee=new u().withPage(1,x);B?(B=B.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ue,pe,we)=>(ee=ee.withFilter(t.Category,we||pe),"")),B=B.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ue,pe,we)=>(ee=ee.withFilter(t.Tag,we||pe),"")),B=B.replace(/\bfeatured(\s+|\b|$)/g,()=>(ee=ee.withFilter(t.Featured),"")),B=B.trim(),B&&(B=B.length<200?B:B.substring(0,200),ee=ee.withFilter(t.SearchText,B)),ee=ee.withSortBy(0)):$.ids?ee=ee.withFilter(t.ExtensionId,...$.ids):$.names?ee=ee.withFilter(t.ExtensionName,...$.names):ee=ee.withSortBy(4),typeof $.sortBy=="number"&&(ee=ee.withSortBy($.sortBy)),typeof $.sortOrder=="number"&&(ee=ee.withSortOrder($.sortOrder)),$.source&&(ee=ee.withSource($.source));const J=async(ue,pe)=>{const{extensions:we,total:be}=await this.z(ue,{targetPlatform:I,compatible:!1,includePreRelease:!!$.includePreRelease},pe);return we.forEach((Ee,Te)=>G(Ee,(ue.pageNumber-1)*ue.pageSize+Te,$.source)),{extensions:we,total:be}},{extensions:Z,total:se}=await J(ee,q),le=async(ue,pe)=>{if(pe.isCancellationRequested)throw new D.CancellationError;const{extensions:we}=await J(ee.withPage(ue+1),pe);return we};return{firstPage:Z,total:se,pageSize:ee.pageSize,getPage:le}}async z($,q,B){const x=$.flags;!!($.flags&i.IncludeLatestVersionOnly)&&!!($.flags&i.IncludeVersions)&&($=$.withFlags($.flags&~i.IncludeVersions,i.IncludeLatestVersionOnly)),!($.flags&i.IncludeLatestVersionOnly)&&!($.flags&i.IncludeVersions)&&($=$.withFlags($.flags,i.IncludeLatestVersionOnly)),q.versions?.length&&($=$.withFlags($.flags&~i.IncludeLatestVersionOnly,i.IncludeVersions)),$=$.withFlags($.flags,i.IncludeAssetUri,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeStatistics,i.IncludeVersionProperties);const{galleryExtensions:ee,total:J}=await this.B($,B);if(!($.flags&i.IncludeLatestVersionOnly)){const ue=[];for(const pe of ee){const we=await this.A(pe,q);we&&ue.push(we)}return{extensions:ue,total:J}}const se=[],le=new Map;for(let ue=0;ue<ee.length;ue++){const pe=ee[ue],we={id:(0,m.getGalleryExtensionId)(pe.publisher.publisherName,pe.extensionName),uuid:pe.extensionId},be=(0,R.isBoolean)(q.includePreRelease)?q.includePreRelease:!!q.includePreRelease.find(Te=>(0,m.areSameExtensions)(Te,we))?.includePreRelease;if(q.compatible&&(0,b.isNotWebExtensionInWebTargetPlatform)(V(pe),q.targetPlatform))continue;const Ee=await this.A(pe,q);!Ee||Ee.properties.isPreReleaseVersion&&(!be||!Ee.hasReleaseVersion)||!Ee.properties.isPreReleaseVersion&&Ee.properties.targetPlatform!==q.targetPlatform&&Ee.hasPreReleaseVersion?le.set(pe.extensionId,ue):se.push([ue,Ee])}if(le.size){const ue=new Date().getTime(),pe=new u().withFlags(x&~i.IncludeLatestVersionOnly,i.IncludeVersions).withPage(1,le.size).withFilter(t.ExtensionId,...le.keys()),{extensions:we}=await this.z(pe,q,B);this.o.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-ue,count:le.size});for(const be of we){const Ee=le.get(be.identifier.uuid);se.push([Ee,be])}}return{extensions:se.sort((ue,pe)=>ue[0]-pe[0]).map(([,ue])=>ue),total:J}}async A($,q){const B={id:(0,m.getGalleryExtensionId)($.publisher.publisherName,$.extensionName),uuid:$.extensionId},x=q.versions?.find(se=>(0,m.areSameExtensions)(se,B))?.version,ee=(0,R.isBoolean)(q.includePreRelease)?q.includePreRelease:!!q.includePreRelease.find(se=>(0,m.areSameExtensions)(se,B))?.includePreRelease,J=V($),Z=W($.versions,q.targetPlatform);if(q.compatible&&(0,b.isNotWebExtensionInWebTargetPlatform)(J,q.targetPlatform))return null;for(let se=0;se<Z.length;se++){const le=Z[se];if(!(x&&le.version!==x)){if(await this.y(le,ee?"any":"release",q.compatible,J,q.targetPlatform))return X($,le,J);if(x&&le.version===x)return null}}return x||q.compatible?null:X($,$.versions[0],J)}async B($,q){if(!this.isEnabled())throw new Error("No extension gallery service configured.");$=$.withFlags($.flags,i.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,r(i.Unpublished));const B=await this.j,x=JSON.stringify($.raw),ee={...B,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(x.length)},J=new Date().getTime();let Z,se,le=0;try{if(Z=await this.k.request({type:"POST",url:this.g&&$.criteria.some(pe=>pe.filterType===t.SearchText)?this.g:this.x("/extensionquery"),data:x,headers:ee},q),Z.res.statusCode&&Z.res.statusCode>=400&&Z.res.statusCode<500)return{galleryExtensions:[],total:le};const ue=await(0,l.asJson)(Z);if(ue){const pe=ue.results[0],we=pe.extensions,be=pe.resultMetadata&&pe.resultMetadata.filter(Ee=>Ee.metadataType==="ResultCount")[0];return le=be&&be.metadataItems.filter(Ee=>Ee.name==="TotalCount")[0].count||0,{galleryExtensions:we,total:le}}return{galleryExtensions:[],total:le}}catch(ue){throw se=ue,ue}finally{this.o.publicLog2("galleryService:query",{...$.telemetryData,requestBodySize:String(x.length),duration:new Date().getTime()-J,success:!!Z&&(0,l.isSuccess)(Z),responseBodySize:Z?.res.headers["Content-Length"],statusCode:Z?String(Z.res.statusCode):void 0,errorCode:se?(0,D.isCancellationError)(se)?"canceled":(0,D.getErrorMessage)(se).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(le)})}}async reportStatistic($,q,B,x){if(!this.isEnabled())return;const ee=k.isWeb?this.x(`/itemName/${$}.${q}/version/${B}/statType/${x==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${$}/extensions/${q}/${B}/stats?statType=${x}`),J=k.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",se={...await this.j,Accept:J};try{await this.k.request({type:"POST",url:ee,headers:se},n.CancellationToken.None)}catch{}}async download($,q,B){this.l.trace("ExtensionGalleryService#download",$.identifier.id);const x=(0,m.getGalleryExtensionTelemetryData)($),ee=new Date().getTime(),J=ue=>this.o.publicLog("galleryService:downloadVSIX",{...x,duration:ue}),Z=B===2?"install":B===3?"update":"",se=Z?{uri:`${$.assets.download.uri}${P.URI.parse($.assets.download.uri).query?"&":"?"}${Z}=true`,fallbackUri:`${$.assets.download.fallbackUri}${P.URI.parse($.assets.download.fallbackUri).query?"&":"?"}${Z}=true`}:$.assets.download,le=await this.D(se);await this.q.writeFile(q,le.stream),J(new Date().getTime()-ee)}async downloadSignatureArchive($,q){if(!$.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",$.identifier.id);const B=await this.D($.assets.signature);await this.q.writeFile(q,B.stream)}async getReadme($,q){if($.assets.readme){const B=await this.D($.assets.readme,{},q);return await(0,l.asTextOrError)(B)||""}return""}async getManifest($,q){if($.assets.manifest){const B=await this.D($.assets.manifest,{},q),x=await(0,l.asTextOrError)(B);return x?JSON.parse(x):null}return null}async C($,q){const B=j($,s.Manifest);if(!B)throw new Error("Manifest was not found");const x={"Accept-Encoding":"gzip"},ee=await this.D(B,{headers:x});return await(0,l.asJson)(ee)}async getCoreTranslation($,q){const B=$.assets.coreTranslations.filter(x=>x[0]===q.toUpperCase())[0];if(B){const x=await this.D(B[1]),ee=await(0,l.asTextOrError)(x);return ee?JSON.parse(ee):null}return null}async getChangelog($,q){if($.assets.changelog){const B=await this.D($.assets.changelog,{},q);return await(0,l.asTextOrError)(B)||""}return""}async getAllCompatibleVersions($,q,B){let x=new u().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1);$.identifier.uuid?x=x.withFilter(t.ExtensionId,$.identifier.uuid):x=x.withFilter(t.ExtensionName,$.identifier.id);const{galleryExtensions:ee}=await this.B(x,n.CancellationToken.None);if(!ee.length)return[];const J=V(ee[0]);if((0,b.isNotWebExtensionInWebTargetPlatform)(J,B))return[];const Z=[];await Promise.all(ee[0].versions.map(async ue=>{try{await this.y(ue,q?"any":"release",!0,J,B)&&Z.push(ue)}catch{}}));const se=[],le=new Set;for(const ue of W(Z,B))le.has(ue.version)||(le.add(ue.version),se.push({version:ue.version,date:ue.lastUpdated,isPreReleaseVersion:F(ue)}));return se}async D($,q={},B=n.CancellationToken.None){const x=await this.j,ee={type:"GET"},J={...x,...q.headers||{}};q={...q,...ee,headers:J};const Z=$.uri,se=$.fallbackUri,le={...q,url:Z};try{const ue=await this.k.request(le,B);if(ue.res.statusCode===200)return ue;const pe=await(0,l.asTextOrError)(ue);throw new Error(`Expected 200, got back ${ue.res.statusCode} instead.

${pe}`)}catch(ue){if((0,D.isCancellationError)(ue))throw ue;const pe=(0,D.getErrorMessage)(ue);this.o.publicLog2("galleryService:cdnFallback",{url:Z,message:pe});const we={...q,url:se};return this.k.request(we,B)}}async E($){let q=L($);if(!q){const B=await this.C($,n.CancellationToken.None);if(!B)throw new Error("Manifest was not found");q=B.engines.vscode}return q}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{}};const $=await this.k.request({type:"GET",url:this.h},n.CancellationToken.None);if($.res.statusCode!==200)throw new Error("Could not get extensions report.");const q=await(0,l.asJson)($),B=[],x={};if(q){for(const ee of q.malicious)B.push({id:ee});if(q.migrateToPreRelease)for(const[ee,J]of Object.entries(q.migrateToPreRelease))(!J.engine||(0,p.isEngineValid)(J.engine,this.u.version,this.u.date))&&(x[ee.toLowerCase()]={disallowInstall:!0,extension:{id:J.id,displayName:J.displayName,autoMigrate:{storage:!!J.migrateStorage},preRelease:!0}});if(q.deprecated)for(const[ee,J]of Object.entries(q.deprecated))J&&(x[ee.toLowerCase()]=(0,R.isBoolean)(J)?{}:J)}return{malicious:B,deprecated:x}}};ie=ye([Y(1,l.IRequestService),Y(2,y.ILogService),Y(3,C.IEnvironmentService),Y(4,v.ITelemetryService),Y(5,h.IFileService),Y(6,f.IProductService),Y(7,S.IConfigurationService)],ie);let oe=class extends ie{constructor($,q,B,x,ee,J,Z,se){super($,q,B,x,ee,J,Z,se)}};oe=ye([Y(0,g.IStorageService),Y(1,l.IRequestService),Y(2,y.ILogService),Y(3,C.IEnvironmentService),Y(4,v.ITelemetryService),Y(5,h.IFileService),Y(6,f.IProductService),Y(7,S.IConfigurationService)],oe),e.ExtensionGalleryService=oe;let te=class extends ie{constructor($,q,B,x,ee,J,Z){super(void 0,$,q,B,x,ee,J,Z)}};te=ye([Y(0,l.IRequestService),Y(1,y.ILogService),Y(2,C.IEnvironmentService),Y(3,v.ITelemetryService),Y(4,h.IFileService),Y(5,f.IProductService),Y(6,S.IConfigurationService)],te),e.ExtensionGalleryServiceWithNoStorageService=te}),define(re[80],ae([0,1,4,3,2,20,33,25,21,9,14]),function(_,e,A,n,D,k,T,R,P,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,A.createDecorator)("IExtensionStorageService");const b=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let m=class Ze extends D.Disposable{static b(h){return`extensionKeys/${(0,T.adoptToGalleryExtensionId)(h.id)}@${h.version}`}static c(h){const y=b.exec(h);if(y&&y[1])return{id:y[1],version:y[2]}}static async removeOutdatedExtensionVersions(h,y){const f=await h.getInstalled(),l=[];for(const[d,g]of Ze.f(y)){const v=f.find(I=>(0,T.areSameExtensions)(I.identifier,{id:d}))?.manifest.version;for(const I of g)v!==I&&l.push(Ze.b({id:d,version:I}))}for(const d of l)y.remove(d,0)}static f(h){const y=new Map,f=h.keys(0,1);for(const l of f){const d=Ze.c(l);if(d){let g=y.get(d.id.toLowerCase());g||y.set(d.id.toLowerCase(),g=[]),g.push(d.version)}}return y}constructor(h,y,f){super(),this.i=h,this.j=y,this.k=f,this.g=this.B(new n.Emitter),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=Ze.f(h),this.B(this.i.onDidChangeValue(l=>this.l(l)))}l(h){if(h.scope!==0)return;if(this.h.has(h.key.toLowerCase())){this.g.fire();return}const y=Ze.c(h.key);if(y){if(this.i.get(h.key,0)===void 0)this.h.delete(y.id.toLowerCase());else{let f=this.h.get(y.id.toLowerCase());f||this.h.set(y.id.toLowerCase(),f=[]),f.push(y.version),this.g.fire()}return}}m(h){if((0,C.isString)(h))return h;const y=h.manifest?h.manifest.publisher:h.publisher,f=h.manifest?h.manifest.name:h.name;return(0,T.getExtensionId)(y,f)}getExtensionState(h,y){const f=this.m(h),l=this.getExtensionStateRaw(h,y);if(l)try{return JSON.parse(l)}catch(d){this.k.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${f}, global: ${y}): ${d}`)}}getExtensionStateRaw(h,y){const f=this.m(h),l=this.i.get(f,y?0:1);return l&&l?.length>Ze.a&&this.k.warn(`[mainThreadStorage] large extension state detected (extensionId: ${f}, global: ${y}): ${l.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),l}setExtensionState(h,y,f){const l=this.m(h);y===void 0?this.i.remove(l,f?0:1):this.i.store(l,JSON.stringify(y),f?0:1,1)}setKeysForSync(h,y){this.i.store(Ze.b(h),JSON.stringify(y),0,1)}getKeysForSync(h){const y=this.j.extensionSyncedKeys?.[h.id.toLowerCase()],f=this.i.get(Ze.b(h),0),l=f?JSON.parse(f):void 0;return l&&y?(0,P.distinct)([...l,...y]):l||y}addToMigrationList(h,y){if(h!==y){const f=this.n.filter(l=>!l.includes(h)&&!l.includes(y));f.push([h,y]),this.n=f}}getSourceExtensionToMigrate(h){const y=this.n.find(([,f])=>h===f);return y?y[0]:void 0}get n(){const h=this.i.get("extensionStorage.migrationList",-1,"[]");try{const y=JSON.parse(h);if(Array.isArray(y))return y}catch{}return[]}set n(h){h.length?this.i.store("extensionStorage.migrationList",JSON.stringify(h),-1,1):this.i.remove("extensionStorage.migrationList",-1)}};m.a=512*1024,m=ye([Y(0,k.IStorageService),Y(1,R.IProductService),Y(2,S.ILogService)],m),e.ExtensionStorageService=m}),define(re[268],ae([0,1,21,6,3,12,5,36,8,160,15,30,33,212,99,13,58,25,20,19]),function(_,e,A,n,D,k,T,R,P,S,C,b,m,p,h,y,f,l,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const v="extensionTips/promptedExecutableTips",I="extensionTips/lastPromptedMediumImpExeTime";let i=class extends p.ExtensionTipsService{constructor(t,s,o,c,a,u,w,E){super(w,E),this.m=t,this.n=s,this.p=o,this.r=c,this.s=a,this.t=u,this.g=new Map,this.h=new Map,this.j=new Map,this.k=new Map,this.l=new Map,E.exeBasedExtensionTips&&Object.entries(E.exeBasedExtensionTips).forEach(([N,O])=>{const j=[],M=[],L=[];Object.entries(O.recommendations).forEach(([F,z])=>{z.important?O.important?j.push({extensionId:F,extensionName:z.name,isExtensionPack:!!z.isExtensionPack}):M.push({extensionId:F,extensionName:z.name,isExtensionPack:!!z.isExtensionPack}):L.push({extensionId:F,extensionName:z.name,isExtensionPack:!!z.isExtensionPack})}),j.length&&this.g.set(N,{exeFriendlyName:O.friendlyName,windowsPath:O.windowsPath,recommendations:j}),M.length&&this.h.set(N,{exeFriendlyName:O.friendlyName,windowsPath:O.windowsPath,recommendations:M}),L.length&&this.j.set(N,{exeFriendlyName:O.friendlyName,windowsPath:O.windowsPath,recommendations:L})}),(0,n.timeout)(3e3).then(async()=>{await this.u(),this.w(),this.y()})}async getImportantExecutableBasedTips(){const t=await this.I(this.g),s=await this.I(this.h);return[...t,...s]}getOtherExecutableBasedTips(){return this.I(this.j)}async u(){const t=await this.I(this.g),s=await this.I(this.h),o=await this.p.getInstalled();this.k=this.v(t,o),this.l=this.v(s,o)}v(t,s){const o=new Map;t.forEach(E=>o.set(E.extensionId.toLowerCase(),E));const{installed:c,uninstalled:a}=this.H([...o.keys()],s);for(const E of c){const N=o.get(E);N&&this.n.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:E,exeName:N.exeName})}for(const E of a){const N=o.get(E);N&&this.n.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:E,exeName:N.exeName})}const u=this.F(),w=new Map;for(const E of a){const N=o.get(E);if(N&&(!u[N.exeName]||!u[N.exeName].includes(N.extensionId))){let O=w.get(N.exeName);O||(O=[],w.set(N.exeName,O)),O.push(N)}}return w}w(){if(this.k.size===0)return;const[t,s]=[...this.k.entries()][0];this.z(s).then(o=>{switch(o){case"reacted":this.G(s[0].exeName,s);break;case"ignored":this.k.delete(t);break;case"incompatibleWindow":{const c=D.Event.once(D.Event.latch(D.Event.any(this.s.onDidOpenWindow,this.s.onDidFocusWindow)));this.B(c(()=>this.w()));break}case"toomany":{const c=this.B((0,n.disposableTimeout)(()=>{c.dispose(),this.w()},36e5));break}}})}y(){if(this.l.size===0)return;const t=this.C(),s=Date.now()-t,o=7*24*60*60*1e3;if(s<o){const u=this.B((0,n.disposableTimeout)(()=>{u.dispose(),this.y()},o-s));return}const[c,a]=[...this.l.entries()][0];this.z(a).then(u=>{switch(u){case"reacted":{this.D(Date.now()),this.l.delete(c),this.G(a[0].exeName,a);const w=this.B((0,n.disposableTimeout)(()=>{w.dispose(),this.y()},o));break}case"ignored":this.l.delete(c),this.y();break;case"incompatibleWindow":{const w=D.Event.once(D.Event.latch(D.Event.any(this.s.onDidOpenWindow,this.s.onDidFocusWindow)));this.B(w(()=>this.y()));break}case"toomany":{const w=this.B((0,n.disposableTimeout)(()=>{w.dispose(),this.y()},36e5));break}}})}async z(t){const s=await this.p.getInstalled(1),o=t.filter(a=>!a.whenNotInstalled||a.whenNotInstalled.every(u=>s.every(w=>!(0,m.areSameExtensions)(w.identifier,{id:u})))).map(({extensionId:a})=>a.toLowerCase()),c=(0,S.localize)(0,null,t[0].exeFriendlyName);return this.t.promptImportantExtensionsInstallNotification(o,c,`@exe:"${t[0].exeName}"`,3)}C(){let t=this.r.getNumber(I,-1);return t||(t=Date.now(),this.D(t)),t}D(t){this.r.store(I,t,-1,1)}F(){return JSON.parse(this.r.get(v,-1,"{}"))}G(t,s){const o=this.F();o[t]=s.map(({extensionId:c})=>c.toLowerCase()),this.r.store(v,JSON.stringify(o),-1,0)}H(t,s){const o=[],c=[],a=s.reduce((u,w)=>(u.add(w.identifier.id.toLowerCase()),u),new Set);return t.forEach(u=>{a.has(u.toLowerCase())?o.push(u):c.push(u)}),{installed:o,uninstalled:c}}async I(t){const s=[],o=new Map;for(const c of t.keys()){const a=t.get(c);if(!a||!(0,A.isNonEmptyArray)(a.recommendations))continue;const u=[];T.isWindows?a.windowsPath&&u.push(a.windowsPath.replace("%USERPROFILE%",()=>R.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>R.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>R.env.ProgramFiles).replace("%APPDATA%",()=>R.env.APPDATA).replace("%WINDIR%",()=>R.env.WINDIR)):(u.push((0,k.join)("/usr/local/bin",c)),u.push((0,k.join)("/usr/bin",c)),u.push((0,k.join)(this.m.userHome.fsPath,c)));for(const w of u){let E=o.get(w);if(E===void 0&&(E=await this.b.exists(P.URI.file(w)),o.set(w,E)),E)for(const{extensionId:N,extensionName:O,isExtensionPack:j,whenNotInstalled:M}of a.recommendations)s.push({extensionId:N,extensionName:O,isExtensionPack:j,exeName:c,exeFriendlyName:a.exeFriendlyName,windowsPath:a.windowsPath,whenNotInstalled:M})}}return s}};i=ye([Y(0,C.INativeEnvironmentService),Y(1,g.ITelemetryService),Y(2,b.IExtensionManagementService),Y(3,d.IStorageService),Y(4,f.INativeHostService),Y(5,h.IExtensionRecommendationNotificationService),Y(6,y.IFileService),Y(7,l.IProductService)],i),e.ExtensionTipsService=i}),define(re[269],ae([0,1,6,2,22,69,20,76,18]),function(_,e,A,n,D,k,T,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class S extends T.AbstractStorageService{constructor(b,m,p,h){super(),this.X=b,this.Y=m,this.Z=p,this.ab=h,this.p=this.Y.defaultProfile,this.s=this.bb(),this.P=this.Y.currentProfile,this.Q=this.B(new n.DisposableStore),this.R=this.cb(this.P),this.S=this.X?.id,this.U=this.B(new n.DisposableStore),this.W=this.db(this.X)}bb(){const b=this.B(new R.ApplicationStorageDatabaseClient(this.Z.getChannel("storage"))),m=this.B(new k.Storage(b));return this.B(m.onDidChangeStorage(p=>this.n(-1,p))),m}cb(b){this.Q.clear(),this.P=b;let m;if((0,T.isProfileUsingDefaultStorage)(b))m=this.s;else{const p=this.Q.add(new R.ProfileStorageDatabaseClient(this.Z.getChannel("storage"),b));m=this.Q.add(new k.Storage(p))}return this.Q.add(m.onDidChangeStorage(p=>this.n(0,p))),m}db(b){this.U.clear(),this.S=b?.id;let m;if(b){const p=this.U.add(new R.WorkspaceStorageDatabaseClient(this.Z.getChannel("storage"),b));m=this.U.add(new k.Storage(p)),this.U.add(m.onDidChangeStorage(h=>this.n(1,h)))}return m}async J(){await A.Promises.settled([this.s.init(),this.R.init(),this.W?.init()??Promise.resolve()])}L(b){switch(b){case-1:return this.s;case 0:return this.R;default:return this.W}}M(b){switch(b){case-1:return this.p.globalStorageHome.fsPath;case 0:return this.P?.globalStorageHome.fsPath;default:return this.S?`${(0,D.joinPath)(this.ab.workspaceStorageHome,this.S,"state.vscdb").fsPath}`:void 0}}async close(){this.m(),this.r(T.WillSaveStateReason.SHUTDOWN),await A.Promises.settled([this.s.close(),this.R.close(),this.W?.close()??Promise.resolve()])}async N(b,m){if(!this.H(this.P,b))return;const p=this.R,h=p.items;p!==this.s&&await p.close(),this.R=this.cb(b),await this.R.init(),this.I(h,this.R,0,m)}async O(b,m){const p=this.W,h=p?.items??new Map;await p?.close(),this.W=this.db(b),await this.W.init(),this.I(h,this.W,1,m)}hasScope(b){return(0,P.isUserDataProfile)(b)?this.P.id===b.id:this.S===b.id}}e.NativeStorageService=S}),define(re[62],ae([0,1,2,69,4,20]),function(_,e,A,n,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUserDataProfileStorageService=e.IUserDataProfileStorageService=void 0,e.IUserDataProfileStorageService=(0,D.createDecorator)("IUserDataProfileStorageService");let T=class extends A.Disposable{constructor(S){super(),this.a=S}async readStorageData(S){return this.withProfileScopedStorageService(S,async C=>this.b(C))}async updateStorageData(S,C,b){return this.withProfileScopedStorageService(S,async m=>this.c(m,C,b))}async withProfileScopedStorageService(S,C){if(this.a.hasScope(S))return C(this.a);const b=await this.createStorageDatabase(S),m=new R(b);try{await m.initialize();const p=await C(m);return await m.flush(),p}finally{m.dispose(),await this.f(b)}}b(S){const C=new Map,b=m=>{for(const p of S.keys(0,m))C.set(p,{value:S.get(p,0),target:m})};return b(0),b(1),C}c(S,C,b){for(const[m,p]of C)S.store(m,p,0,b)}async f(S){try{await S.close()}finally{(0,A.isDisposable)(S)&&S.dispose()}}};T=ye([Y(0,k.IStorageService)],T),e.AbstractUserDataProfileStorageService=T;class R extends k.AbstractStorageService{constructor(S){super({flushInterval:100}),this.p=this.B(new n.Storage(S))}J(){return this.p.init()}L(S){return S===0?this.p:void 0}M(){}async N(){}async O(){}hasScope(){return!1}}}),define(re[270],ae([0,1,3,2,22,15,57,18]),function(_,e,A,n,D,k,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesNativeService=void 0;let P=class extends n.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return this.b}constructor(C,b,m){super(),this.b=[],this.c=this.B(new A.Emitter),this.onDidChangeProfiles=this.c.event,this.f=!0,this.a=b.getChannel("userDataProfiles"),this.profilesHome=(0,D.joinPath)(m.userRoamingDataHome,"profiles"),this.b=C.map(p=>(0,R.reviveProfile)(p,this.profilesHome.scheme)),this.B(this.a.listen("onDidChangeProfiles")(p=>{const h=p.added.map(l=>(0,R.reviveProfile)(l,this.profilesHome.scheme)),y=p.removed.map(l=>(0,R.reviveProfile)(l,this.profilesHome.scheme)),f=p.updated.map(l=>(0,R.reviveProfile)(l,this.profilesHome.scheme));this.b=p.all.map(l=>(0,R.reviveProfile)(l,this.profilesHome.scheme)),this.c.fire({added:h,removed:y,updated:f,all:this.profiles})})),this.onDidResetWorkspaces=this.a.listen("onDidResetWorkspaces")}setEnablement(C){this.f=C}isEnabled(){return this.f}async createNamedProfile(C,b,m){const p=await this.a.call("createNamedProfile",[C,b,m]);return(0,R.reviveProfile)(p,this.profilesHome.scheme)}async createProfile(C,b,m,p){const h=await this.a.call("createProfile",[C,b,m,p]);return(0,R.reviveProfile)(h,this.profilesHome.scheme)}async createTransientProfile(C){const b=await this.a.call("createTransientProfile",[C]);return(0,R.reviveProfile)(b,this.profilesHome.scheme)}async setProfileForWorkspace(C,b){await this.a.call("setProfileForWorkspace",[C,b])}removeProfile(C){return this.a.call("removeProfile",[C])}async updateProfile(C,b){const m=await this.a.call("updateProfile",[C,b]);return(0,R.reviveProfile)(m,this.profilesHome.scheme)}resetWorkspaces(){return this.a.call("resetWorkspaces")}cleanUp(){return this.a.call("cleanUp")}cleanUpTransientProfiles(){return this.a.call("cleanUpTransientProfiles")}};P=ye([Y(1,T.IMainProcessService),Y(2,k.IEnvironmentService)],P),e.UserDataProfilesNativeService=P}),define(re[271],ae([0,1,3,2,57,9,62,20,76,18,71]),function(_,e,A,n,D,k,T,R,P,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfileStorageService=void 0;let b=class extends T.AbstractUserDataProfileStorageService{constructor(p,h,y,f){super(y),this.h=p;const l=p.getChannel("profileStorageListener"),d=this.B(new n.MutableDisposable);this.g=this.B(new A.Emitter({onWillAddFirstListener:()=>{d.value=l.listen("onDidChange")(g=>{f.trace("profile storage changes",g),this.g.fire({targetChanges:g.targetChanges.map(v=>(0,S.reviveProfile)(v,h.profilesHome.scheme)),valueChanges:g.valueChanges.map(v=>({...v,profile:(0,S.reviveProfile)(v.profile,h.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>d.value=void 0})),this.onDidChange=this.g.event}async createStorageDatabase(p){const h=this.h.getChannel("storage");return(0,R.isProfileUsingDefaultStorage)(p)?new P.ApplicationStorageDatabaseClient(h):new P.ProfileStorageDatabaseClient(h,p)}};b=ye([Y(0,D.IMainProcessService),Y(1,S.IUserDataProfilesService),Y(2,R.IStorageService),Y(3,k.ILogService)],b),e.UserDataProfileStorageService=b,(0,C.registerSingleton)(T.IUserDataProfileStorageService,b,1)}),define(re[41],ae([0,1,21,6,17,23,3,35,2,27,14,176,16,15,13,9,45,20,19,29,26,18]),function(_,e,A,n,D,k,T,R,P,S,C,b,m,p,h,y,f,l,d,g,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.getSyncResourceLogLabel=e.isSyncData=e.isRemoteUserData=void 0;function i(u){return!!(u&&u.ref!==void 0&&typeof u.ref=="string"&&u.ref!==""&&u.syncData!==void 0&&(u.syncData===null||r(u.syncData)))}e.isRemoteUserData=i;function r(u){return!!(u&&u.version!==void 0&&typeof u.version=="number"&&u.content!==void 0&&typeof u.content=="string"&&(Object.keys(u).length===2||Object.keys(u).length===3&&u.machineId!==void 0&&typeof u.machineId=="string"))}e.isSyncData=r;function t(u,w){return`${(0,S.uppercaseFirstLetter)(u)}${w.isDefault?"":` (${w.name})`}`}e.getSyncResourceLogLabel=t;let s=class extends P.Disposable{get status(){return this.k}get conflicts(){return{...this.syncResource,conflicts:this.m}}constructor(w,E,N,O,j,M,L,F,z,H,Q,K){super(),this.syncResource=w,this.collection=E,this.C=N,this.D=O,this.F=j,this.G=M,this.H=L,this.I=F,this.J=z,this.L=H,this.M=Q,this.c=null,this.k="idle",this.l=this.B(new T.Emitter),this.onDidChangeStatus=this.l.event,this.m=[],this.n=this.B(new T.Emitter),this.onDidChangeConflicts=this.n.event,this.s=new n.ThrottledDelayer(50),this.t=this.B(new T.Emitter),this.onDidChangeLocal=this.t.event,this.v=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.w=!1,this.z={},this.resource=this.syncResource.syncResource,this.y=t(w.syncResource,w.profile),this.h=K.extUri,this.f=this.h.joinPath(O.userDataSyncHome,...(0,v.getPathSegments)(w.profile.isDefault?void 0:w.profile.id,w.syncResource)),this.g=this.h.joinPath(this.f,v.PREVIEW_DIR_NAME),this.u=(0,v.getLastSyncResourceUri)(w.profile.isDefault?void 0:w.profile.id,w.syncResource,O,this.h),this.j=(0,f.getServiceMachineId)(O,N,j)}triggerLocalChange(){this.s.trigger(()=>this.N())}async N(){if(this.status==="hasConflicts"){this.L.info(`${this.y}: In conflicts state and local change detected. Syncing again...`);const w=await this.c;this.c=null;const E=await this.S(w.remoteUserData,w.lastSyncUserData,!0,this.lb());this.O(E)}else{this.L.trace(`${this.y}: Checking for local changes...`);const w=await this.getLastSyncUserData();(w?await this.rb(w):!0)&&this.t.fire()}}O(w){this.k!==w&&(this.k=w,this.l.fire(w))}async sync(w,E={}){await this.P(w,!0,this.lb(),E)}async preview(w,E,N={}){return this.P(w,!1,E,N)}async apply(w,E={}){try{this.z={...E};const N=await this.X(w);return this.O(N),this.c}finally{this.z={}}}async P(w,E,N,O){try{if(this.z={...O},this.status==="hasConflicts")return this.L.info(`${this.y}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status==="syncing")return this.L.info(`${this.y}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.L.trace(`${this.y}: Started synchronizing ${this.resource.toLowerCase()}...`),this.O("syncing");let j="idle";try{const M=await this.getLastSyncUserData(),L=await this.R(w,M);return j=await this.S(L,M,E,N),j==="hasConflicts"?this.L.info(`${this.y}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):j==="idle"&&this.L.trace(`${this.y}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.O(j)}}finally{this.z={}}}async replace(w){const E=this.hb(w);if(!E)return!1;await this.stop();try{this.L.trace(`${this.y}: Started resetting ${this.resource.toLowerCase()}...`),this.O("syncing");const N=await this.getLastSyncUserData(),O=await this.R(null,N),j=await this.Q(O),M=await this.nb({ref:O.ref,syncData:E},N,j,this.lb(),k.CancellationToken.None),L=[];for(const F of M){const z=await this.pb(F,F.remoteResource,void 0,k.CancellationToken.None),{remoteChange:H}=await this.pb(F,F.previewResource,F.remoteContent,k.CancellationToken.None);L.push([F,{...z,remoteChange:H!==0?H:2}])}await this.qb(O,N,L,!1),this.L.info(`${this.y}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.O("idle")}return!0}async Q(w){const E=await this.j;return!!w.syncData?.machineId&&w.syncData.machineId===E}async R(w,E){if(E){const N=w?w[this.resource]:void 0;if(E.ref===N||N===void 0&&E.syncData===null)return E}return this.getRemoteUserData(E)}async S(w,E,N,O){if(w.syncData&&w.syncData.version>this.mb)throw this.J.publicLog2("sync/incompatible",{source:this.resource}),new v.UserDataSyncError((0,b.localize)(0,null,this.resource,this.mb,w.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.U(w,E,N,O)}catch(j){if(j instanceof v.UserDataSyncError)switch(j.code){case"LocalPreconditionFailed":return this.L.info(`${this.y}: Failed to synchronize ${this.y} as there is a new local version available. Synchronizing again...`),this.S(w,E,N,O);case"Conflict":case"PreconditionFailed":return this.L.info(`${this.y}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),w=await this.getRemoteUserData(null),E=await this.getLastSyncUserData(),this.S(w,E,N,O)}throw j}}async U(w,E,N,O){try{const j=await this.Q(w),M=!j&&E===null&&this.db()!==void 0,L=N&&!M;this.c||(this.c=(0,n.createCancelablePromise)(z=>this.bb(w,E,j,L,O,z)));let F=await this.c;if(N&&M){this.L.info(`${this.y}: Accepting remote because it was synced before and the last sync data is not available.`);for(const z of F.resourcePreviews)F=await this.accept(z.remoteResource)||F}return this.Z(F.resourcePreviews),F.resourcePreviews.some(({mergeState:z})=>z==="conflict")?"hasConflicts":N?await this.X(!1):"syncing"}catch(j){throw this.c=null,j}}async merge(w){return await this.W(w,async E=>{const N=await this.ob(E,k.CancellationToken.None);await this.C.writeFile(E.previewResource,D.VSBuffer.fromString(N?.content||""));const O=N&&!N.hasConflicts?await this.pb(E,E.previewResource,void 0,k.CancellationToken.None):void 0;return E.acceptResult=O,E.mergeState=N.hasConflicts?"conflict":O?"accepted":"preview",E.localChange=O?O.localChange:N.localChange,E.remoteChange=O?O.remoteChange:N.remoteChange,E}),this.c}async accept(w,E){return await this.W(w,async N=>{const O=await this.pb(N,w,E,k.CancellationToken.None);return N.acceptResult=O,N.mergeState="accepted",N.localChange=O.localChange,N.remoteChange=O.remoteChange,N}),this.c}async discard(w){return await this.W(w,async E=>{const N=await this.ob(E,k.CancellationToken.None);return await this.C.writeFile(E.previewResource,D.VSBuffer.fromString(N.content||"")),E.acceptResult=void 0,E.mergeState="preview",E.localChange=N.localChange,E.remoteChange=N.remoteChange,E}),this.c}async W(w,E){if(!this.c)return;let N=await this.c;const O=N.resourcePreviews.findIndex(({localResource:j,remoteResource:M,previewResource:L})=>this.h.isEqual(j,w)||this.h.isEqual(M,w)||this.h.isEqual(L,w));O!==-1&&(this.c=(0,n.createCancelablePromise)(async j=>{const M=[...N.resourcePreviews];return M[O]=await E(M[O]),{...N,resourcePreviews:M}}),N=await this.c,this.Z(N.resourcePreviews),N.resourcePreviews.some(({mergeState:j})=>j==="conflict")?this.O("hasConflicts"):this.O("syncing"))}async X(w){if(!this.c)return"idle";const E=await this.c;return E.resourcePreviews.some(({mergeState:N})=>N==="conflict")?"hasConflicts":E.resourcePreviews.some(({mergeState:N})=>N!=="accepted")?"syncing":(await this.qb(E.remoteUserData,E.lastSyncUserData,E.resourcePreviews.map(N=>[N,N.acceptResult]),w),this.c=null,await this.Y(),"idle")}async Y(){try{await this.C.del(this.g,{recursive:!0})}catch{}}Z(w){const E=w.filter(({mergeState:N})=>N==="conflict");(0,A.equals)(this.m,E,(N,O)=>this.h.isEqual(N.previewResource,O.previewResource))||(this.m=E,this.n.fire(this.conflicts))}async hasPreviouslySynced(){const w=await this.getLastSyncUserData();return!!w&&w.syncData!==null}async ab(w){const E=this.c?await this.c:null;if(E)for(const N of E.resourcePreviews){if(this.h.isEqual(N.acceptedResource,w))return N.acceptResult?N.acceptResult.content:null;if(this.h.isEqual(N.remoteResource,w))return N.remoteContent;if(this.h.isEqual(N.localResource,w))return N.localContent;if(this.h.isEqual(N.baseResource,w))return N.baseContent}return null}async resetLocal(){this.F.remove(this.v,-1);try{await this.C.del(this.u)}catch(w){(0,h.toFileOperationResult)(w)!==1&&this.L.error(w)}}async bb(w,E,N,O,j,M){const L=await this.nb(w,E,N,j,M),F=[];for(const z of L){const H=z.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(z.localChange===0&&z.remoteChange===0)F.push({...z,acceptedResource:H,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const Q=O?await this.ob(z,M):void 0;if(M.isCancellationRequested)break;await this.C.writeFile(z.previewResource,D.VSBuffer.fromString(Q?.content||""));const K=Q&&!Q.hasConflicts?await this.pb(z,z.previewResource,void 0,M):void 0;F.push({...z,acceptResult:K,mergeState:Q?.hasConflicts?"conflict":K?"accepted":"preview",localChange:K?K.localChange:Q?Q.localChange:z.localChange,remoteChange:K?K.remoteChange:Q?Q.remoteChange:z.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:w,lastSyncUserData:E,resourcePreviews:F,isLastSyncFromCurrentMachine:N}}async getLastSyncUserData(){let w=this.db();if(w||(w=await this.gb()),!w)return this.L.info(`${this.y}: Last sync data state does not exist.`),null;const E=JSON.parse(w),N=this.I.getResourceSyncStateVersion(this.resource);if(this.w=!!E.version&&!!N&&E.version!==N,this.w)return this.L.info(`${this.y}: Reset last sync state because last sync state version ${E.version} is not compatible with current sync state version ${N}.`),await this.resetLocal(),null;let O,j=1;for(;O===void 0&&j++<6;)try{const M=await this.eb();M&&(M.ref===E.ref?O=M.syncData:this.L.info(`${this.y}: Last sync data stored locally is not same as the last sync state.`));break}catch(M){if(M instanceof h.FileOperationError&&M.fileOperationResult===1){this.L.info(`${this.y}: Last sync resource does not exist locally.`);break}else{if(M instanceof v.UserDataSyncError)throw M;this.L.error(M,j)}}if(O===void 0)try{const M=await this.G.resolveResourceContent(this.resource,E.ref,this.collection,this.z);O=M===null?null:this.hb(M),await this.fb({ref:E.ref,syncData:O})}catch(M){if(M instanceof v.UserDataSyncError&&M.code==="NotFound")this.L.info(`${this.y}: Last sync resource does not exist remotely.`);else throw M}return O===void 0?null:{...E,syncData:O}}async cb(w,E={}){if(E.ref||E.version)throw new Error("Cannot have core properties as additional");const N=this.I.getResourceSyncStateVersion(this.resource),O={ref:w.ref,version:N,...E};this.F.store(this.v,JSON.stringify(O),-1,1),await this.fb(w)}db(){return this.F.get(this.v,-1)}async eb(){const w=(await this.C.readFile(this.u)).value.toString();try{const E=w?JSON.parse(w):void 0;if(i(E))return E}catch(E){this.L.error(E)}}async fb(w){await this.C.writeFile(this.u,D.VSBuffer.fromString(JSON.stringify(w)))}async gb(){try{const w=await this.C.readFile(this.u),E=JSON.parse(w.value.toString());await this.C.del(this.u),E.ref&&E.content!==void 0&&(this.F.store(this.v,JSON.stringify({...E,content:void 0}),-1,1),await this.fb({ref:E.ref,syncData:E.content===null?null:JSON.parse(E.content)}))}catch(w){w instanceof h.FileOperationError&&w.fileOperationResult===1?this.L.debug(`${this.y}: Migrating last sync user data. Resource does not exist.`):this.L.error(w)}return this.F.get(this.v,-1)}async getRemoteUserData(w){const{ref:E,content:N}=await this.ib(w);let O=null;return N!==null&&(O=this.hb(N)),{ref:E,syncData:O}}hb(w){try{const E=JSON.parse(w);if(r(E))return E}catch(E){this.L.error(E)}throw new v.UserDataSyncError((0,b.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async ib(w){const E=w?{ref:w.ref,content:w.syncData?JSON.stringify(w.syncData):null}:null;return this.G.readResource(this.resource,E,this.collection,this.z)}async jb(w,E){const N=await this.j,O={version:this.mb,machineId:N,content:w};try{return E=await this.G.writeResource(this.resource,JSON.stringify(O),E,this.collection,this.z),{ref:E,syncData:O}}catch(j){throw j instanceof v.UserDataSyncError&&j.code==="TooLarge"&&(j=new v.UserDataSyncError(j.message,j.code,this.resource)),j}}async kb(w){const E={version:this.mb,content:w};return this.H.backup(this.syncResource.profile,this.resource,JSON.stringify(E))}async stop(){this.status!=="idle"&&(this.L.trace(`${this.y}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.Z([]),await this.Y(),this.O("idle"),this.L.info(`${this.y}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}lb(){return this.M.getValue(v.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};s=ye([Y(2,h.IFileService),Y(3,p.IEnvironmentService),Y(4,l.IStorageService),Y(5,v.IUserDataSyncStoreService),Y(6,v.IUserDataSyncBackupStoreService),Y(7,v.IUserDataSyncEnablementService),Y(8,d.ITelemetryService),Y(9,v.IUserDataSyncLogService),Y(10,m.IConfigurationService),Y(11,g.IUriIdentityService)],s),e.AbstractSynchroniser=s;let o=class extends s{constructor(w,E,N,O,j,M,L,F,z,H,Q,K,V){super(E,N,O,j,M,L,F,z,H,Q,K,V),this.i=w,this.B(this.C.watch(this.h.dirname(w))),this.B(this.C.onDidFilesChange(W=>this.tb(W)))}async p(){try{return await this.C.readFile(this.i)}catch{return null}}async r(w,E,N){try{E?await this.C.writeFile(this.i,D.VSBuffer.fromString(w),N?void 0:E):await this.C.createFile(this.i,D.VSBuffer.fromString(w),{overwrite:N})}catch(O){throw O instanceof h.FileOperationError&&O.fileOperationResult===1||O instanceof h.FileOperationError&&O.fileOperationResult===3?new v.UserDataSyncError(O.message,"LocalPreconditionFailed"):O}}async sb(){try{await this.C.del(this.i)}catch(w){if(!(w instanceof h.FileOperationError&&w.fileOperationResult===1))throw w}}tb(w){!w.contains(this.i)||this.triggerLocalChange()}};o=ye([Y(3,h.IFileService),Y(4,p.IEnvironmentService),Y(5,l.IStorageService),Y(6,v.IUserDataSyncStoreService),Y(7,v.IUserDataSyncBackupStoreService),Y(8,v.IUserDataSyncEnablementService),Y(9,d.ITelemetryService),Y(10,v.IUserDataSyncLogService),Y(11,m.IConfigurationService),Y(12,g.IUriIdentityService)],o),e.AbstractFileSynchroniser=o;let c=class extends o{constructor(w,E,N,O,j,M,L,F,z,H,Q,K,V,W){super(w,E,N,O,j,M,L,F,z,H,Q,V,W),this.ub=K,this.wb=void 0}vb(w,E){const N=[],O=(0,R.parse)(w,N,{allowEmptyContent:!0,allowTrailingComma:!0});return N.length>0||!(0,C.isUndefined)(O)&&E!==Array.isArray(O)}xb(){return this.wb||(this.wb=this.ub.resolveFormattingOptions(this.i)),this.wb}};c=ye([Y(3,h.IFileService),Y(4,p.IEnvironmentService),Y(5,l.IStorageService),Y(6,v.IUserDataSyncStoreService),Y(7,v.IUserDataSyncBackupStoreService),Y(8,v.IUserDataSyncEnablementService),Y(9,d.ITelemetryService),Y(10,v.IUserDataSyncLogService),Y(11,v.IUserDataSyncUtilService),Y(12,m.IConfigurationService),Y(13,g.IUriIdentityService)],c),e.AbstractJsonFileSynchroniser=c;let a=class{constructor(w,E,N,O,j,M,L){this.resource=w,this.g=E,this.h=N,this.j=O,this.k=j,this.l=M,this.d=L.extUri,this.f=(0,v.getLastSyncResourceUri)(void 0,this.resource,N,this.d)}async initialize({ref:w,content:E}){if(!E){this.j.info("Remote content does not exist.",this.resource);return}const N=this.m(E);if(!!N)try{await this.doInitialize({ref:w,syncData:N})}catch(O){this.j.error(O)}}m(w){try{const E=JSON.parse(w);if(r(E))return E}catch(E){this.j.error(E)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(w,E={}){if(E.ref||E.version)throw new Error("Cannot have core properties as additional");const N={ref:w.ref,version:void 0,...E};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(N),-1,1),await this.k.writeFile(this.f,D.VSBuffer.fromString(JSON.stringify(w)))}};a=ye([Y(1,I.IUserDataProfilesService),Y(2,p.IEnvironmentService),Y(3,y.ILogService),Y(4,h.IFileService),Y(5,l.IStorageService),Y(6,g.IUriIdentityService)],a),e.AbstractInitializer=a}),define(re[119],ae([0,1,6,23,7,3,43,2,27,16,15,118,30,33,80,13,4,72,9,20,19,29,18,41,253,116,26,62]),function(_,e,A,n,D,k,T,R,P,S,C,b,m,p,h,y,f,l,d,g,v,I,i,r,t,s,o,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.LocalExtensionsProvider=e.ExtensionsSynchroniser=e.stringify=e.parseExtensions=void 0;async function a(j,M){const L=JSON.parse(j.content);if(j.version===1||j.version===2){const F=(await M.getInstalled(0)).filter(z=>z.isBuiltin);for(const z of L)j.version===1&&(z.enabled===!1&&(z.disabled=!0),delete z.enabled),j.version===2&&F.every(H=>!(0,p.areSameExtensions)(H.identifier,z.identifier))&&(z.installed=!0)}return L}function u(j){return JSON.parse(j.content)}e.parseExtensions=u;function w(j,M){return j.sort((L,F)=>!L.identifier.uuid&&F.identifier.uuid?-1:L.identifier.uuid&&!F.identifier.uuid?1:(0,P.compare)(L.identifier.id,F.identifier.id)),M?(0,T.toFormattedString)(j,{}):JSON.stringify(j)}e.stringify=w;let E=class extends r.AbstractSynchroniser{constructor(M,L,F,z,H,Q,K,V,W,G,X,ie,oe,te,U,$,q){super({syncResource:"extensions",profile:M},L,z,F,H,Q,K,ie,oe,G,X,U),this.yb=V,this.zb=W,this.Ab=q,this.mb=5,this.sb=this.h.joinPath(this.g,"extensions.json"),this.tb=this.sb.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"base"}),this.ub=this.sb.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"local"}),this.vb=this.sb.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.wb=this.sb.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.xb=this.Ab.createInstance(N),this.B(k.Event.any(k.Event.filter(this.yb.onDidInstallExtensions,B=>B.some(({local:x})=>!!x)),k.Event.filter(this.yb.onDidUninstallExtension,B=>!B.error),k.Event.filter($.onDidChange,B=>B.valueChanges.some(({profile:x,changes:ee})=>this.syncResource.profile.id===x.id&&ee.some(J=>J.key===m.DISABLED_EXTENSIONS_STORAGE_PATH))),te.onDidChangeExtensionStorageToSync)(()=>this.triggerLocalChange()))}async nb(M,L){const F=M.syncData?await a(M.syncData,this.yb):null,z=L?.skippedExtensions||[],H=L?.builtinExtensions||[],Q=L?.syncData?await a(L.syncData,this.yb):null,{localExtensions:K,ignoredExtensions:V}=await this.xb.getLocalExtensions(this.syncResource.profile);F?this.L.trace(`${this.y}: Merging remote extensions with local extensions...`):this.L.trace(`${this.y}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:W,remote:G}=(0,t.merge)(K,F,Q,z,V,H),X={local:W,remote:G,content:this.Db(K,W.added,W.updated,W.removed),localChange:W.added.length>0||W.removed.length>0||W.updated.length>0?2:0,remoteChange:G!==null?2:0},ie=this.Jb(K,!1);return[{skippedExtensions:z,builtinExtensions:H,baseResource:this.tb,baseContent:Q?this.Jb(Q,!1):ie,localResource:this.ub,localContent:ie,localExtensions:K,remoteResource:this.vb,remoteExtensions:F,remoteContent:F?this.Jb(F,!1):null,previewResource:this.sb,previewResult:X,localChange:X.localChange,remoteChange:X.remoteChange,acceptedResource:this.wb}]}async rb(M){const L=M.syncData?await a(M.syncData,this.yb):null,{localExtensions:F,ignoredExtensions:z}=await this.xb.getLocalExtensions(this.syncResource.profile),{remote:H}=(0,t.merge)(F,L,L,M.skippedExtensions||[],z,M.builtinExtensions||[]);return H!==null}Db(M,L,F,z){const H=[...L,...F],Q=new Set,K=V=>{Q.add(V.id.toLowerCase()),V.uuid&&Q.add(V.uuid)};H.forEach(({identifier:V})=>K(V)),z.forEach(K);for(const V of M)Q.has(V.identifier.id.toLowerCase())||V.identifier.uuid&&Q.has(V.identifier.uuid)||H.push(V);return this.Jb(H,!1)}async ob(M,L){return{...M.previewResult,hasConflicts:!1}}async pb(M,L,F,z){if(this.h.isEqual(L,this.ub))return this.Gb(M);if(this.h.isEqual(L,this.vb))return this.Hb(M);if(this.h.isEqual(L,this.sb))return M.previewResult;throw new Error(`Invalid Resource: ${L.toString()}`)}async Gb(M){const L=await this.yb.getInstalled(void 0,this.syncResource.profile.extensionsResource),F=this.zb.getIgnoredExtensions(L),z=(0,t.merge)(M.localExtensions,null,null,M.skippedExtensions,F,M.builtinExtensions),{local:H,remote:Q}=z;return{content:M.localContent,local:H,remote:Q,localChange:H.added.length>0||H.removed.length>0||H.updated.length>0?2:0,remoteChange:Q!==null?2:0}}async Hb(M){const L=await this.yb.getInstalled(void 0,this.syncResource.profile.extensionsResource),F=this.zb.getIgnoredExtensions(L),z=M.remoteContent?JSON.parse(M.remoteContent):null;if(z!==null){const H=(0,t.merge)(M.localExtensions,z,M.localExtensions,[],F,M.builtinExtensions),{local:Q,remote:K}=H;return{content:M.remoteContent,local:Q,remote:K,localChange:Q.added.length>0||Q.removed.length>0||Q.updated.length>0?2:0,remoteChange:K!==null?2:0}}else return{content:M.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async qb(M,L,F,z){let{skippedExtensions:H,localExtensions:Q}=F[0][0];const{local:K,remote:V,localChange:W,remoteChange:G}=F[0][1];if(W===0&&G===0&&this.L.info(`${this.y}: No changes found during synchronizing extensions.`),W!==0&&(await this.kb(JSON.stringify(Q)),H=await this.xb.updateLocalExtensions(K.added,K.removed,K.updated,H,this.syncResource.profile)),V){this.L.trace(`${this.y}: Updating remote extensions...`);const X=JSON.stringify(V.all);M=await this.jb(X,z?null:M.ref),this.L.info(`${this.y}: Updated remote extensions.${V.added.length?` Added: ${JSON.stringify(V.added.map(ie=>ie.identifier.id))}.`:""}${V.updated.length?` Updated: ${JSON.stringify(V.updated.map(ie=>ie.identifier.id))}.`:""}${V.removed.length?` Removed: ${JSON.stringify(V.removed.map(ie=>ie.identifier.id))}.`:""}`)}if(L?.ref!==M.ref){this.L.trace(`${this.y}: Updating last synchronized extensions...`);const X=Q.filter(ie=>!ie.installed).map(ie=>ie.identifier);await this.cb(M,{skippedExtensions:H,builtinExtensions:X}),this.L.info(`${this.y}: Updated last synchronized extensions.${H.length?` Skipped: ${JSON.stringify(H.map(ie=>ie.identifier.id))}.`:""}`)}}async resolveContent(M){if(this.h.isEqual(this.vb,M)||this.h.isEqual(this.tb,M)||this.h.isEqual(this.ub,M)||this.h.isEqual(this.wb,M)){const L=await this.ab(M);return L&&this.Jb(JSON.parse(L),!0)}return null}Jb(M,L){return w(M,L)}async hasLocalData(){try{const{localExtensions:M}=await this.xb.getLocalExtensions(this.syncResource.profile);if(M.some(L=>L.installed||L.disabled))return!0}catch{}return!1}};E=ye([Y(2,C.IEnvironmentService),Y(3,y.IFileService),Y(4,g.IStorageService),Y(5,o.IUserDataSyncStoreService),Y(6,o.IUserDataSyncBackupStoreService),Y(7,m.IExtensionManagementService),Y(8,s.IIgnoredExtensionsManagementService),Y(9,o.IUserDataSyncLogService),Y(10,S.IConfigurationService),Y(11,o.IUserDataSyncEnablementService),Y(12,v.ITelemetryService),Y(13,h.IExtensionStorageService),Y(14,I.IUriIdentityService),Y(15,c.IUserDataProfileStorageService),Y(16,f.IInstantiationService)],E),e.ExtensionsSynchroniser=E;let N=class{constructor(M,L,F,z,H,Q){this.a=M,this.b=L,this.c=F,this.d=z,this.f=H,this.g=Q}async getLocalExtensions(M){const L=await this.a.getInstalled(void 0,M.extensionsResource),F=this.d.getIgnoredExtensions(L);return{localExtensions:await this.j(M,async(H,Q)=>{const K=H.getDisabledExtensions();return L.map(V=>{const{identifier:W,isBuiltin:G,manifest:X,preRelease:ie}=V,oe={identifier:W,preRelease:ie,version:X.version};K.some(te=>(0,p.areSameExtensions)(te,W))&&(oe.disabled=!0),G||(oe.installed=!0);try{const te=Q.getKeysForSync({id:W.id,version:X.version});if(te){const U=Q.getExtensionState(V,!0)||{};oe.state=Object.keys(U).reduce(($,q)=>(te.includes(q)&&($[q]=U[q]),$),{})}}catch(te){this.g.info(`${(0,r.getSyncResourceLogLabel)("extensions",M)}: Error while parsing extension state`,(0,D.getErrorMessage)(te))}return oe})}),ignoredExtensions:F}}async updateLocalExtensions(M,L,F,z,H){const Q=(0,r.getSyncResourceLogLabel)("extensions",H),K=[],V=[],W=[],G=await this.a.getInstalled(void 0,H.extensionsResource);if((M.length||F.length)&&await this.j(H,async(ie,oe)=>{await A.Promises.settled([...M,...F].map(async te=>{const U=G.find(q=>(0,p.areSameExtensions)(q.identifier,te.identifier));if(U&&U.isBuiltin){te.state&&U.manifest.version===te.version&&this.h(te.state,U,U.manifest.version,oe),ie.getDisabledExtensions().some(B=>(0,p.areSameExtensions)(B,te.identifier))!==!!te.disabled&&(te.disabled?(this.g.trace(`${Q}: Disabling extension...`,te.identifier.id),await ie.disableExtension(te.identifier),this.g.info(`${Q}: Disabled extension`,te.identifier.id)):(this.g.trace(`${Q}: Enabling extension...`,te.identifier.id),await ie.enableExtension(te.identifier),this.g.info(`${Q}: Enabled extension`,te.identifier.id))),V.push(te.identifier);return}const $=(await this.c.getExtensions([{...te.identifier,preRelease:te.preRelease}],n.CancellationToken.None))[0];if(te.state&&(U?U.manifest.version===te.version:!!$)&&this.h(te.state,U||$,U?.manifest.version,oe),$)try{ie.getDisabledExtensions().some(B=>(0,p.areSameExtensions)(B,te.identifier))!==!!te.disabled&&(te.disabled?(this.g.trace(`${Q}: Disabling extension...`,te.identifier.id,$.version),await ie.disableExtension($.identifier),this.g.info(`${Q}: Disabled extension`,te.identifier.id,$.version)):(this.g.trace(`${Q}: Enabling extension...`,te.identifier.id,$.version),await ie.enableExtension($.identifier),this.g.info(`${Q}: Enabled extension`,te.identifier.id,$.version))),(!U||U.preRelease!==te.preRelease)&&(await this.a.canInstall($)?K.push([te,$]):(this.g.info(`${Q}: Skipped synchronizing extension because it cannot be installed.`,$.displayName||$.identifier.id),W.push(te)))}catch(q){W.push(te),this.g.error(q),this.g.info(`${Q}: Skipped synchronizing extension`,$.displayName||$.identifier.id)}else W.push(te),this.g.info(`${Q}: Skipped synchronizing extension because the extension is not found.`,te.identifier.id)}))}),L.length){const ie=G.filter(({identifier:oe,isBuiltin:te})=>!te&&L.some(U=>(0,p.areSameExtensions)(oe,U)));await A.Promises.settled(ie.map(async oe=>{this.g.trace(`${Q}: Uninstalling local extension...`,oe.identifier.id),await this.a.uninstall(oe,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:H.extensionsResource}),this.g.info(`${Q}: Uninstalled local extension.`,oe.identifier.id),V.push(oe.identifier)}))}for(const[ie,oe]of K)try{this.g.trace(`${Q}: Installing extension...`,oe.identifier.id,oe.version),await this.a.installFromGallery(oe,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installPreReleaseVersion:ie.preRelease,profileLocation:H.extensionsResource,context:{[o.EXTENSIONS_SYNC_CONTEXT_KEY]:!0}}),this.g.info(`${Q}: Installed extension.`,oe.identifier.id,oe.version),V.push(oe.identifier)}catch(te){W.push(ie),te instanceof m.ExtensionManagementError&&[m.ExtensionManagementErrorCode.Incompatible,m.ExtensionManagementErrorCode.IncompatiblePreRelease,m.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(te.code)?this.g.info(`${Q}: Skipped synchronizing extension because the compatible extension is not found.`,oe.displayName||oe.identifier.id):(this.g.error(te),this.g.info(`${Q}: Skipped synchronizing extension`,oe.displayName||oe.identifier.id))}const X=[];for(const ie of z)V.some(oe=>(0,p.areSameExtensions)(oe,ie.identifier))||X.push(ie);for(const ie of W)X.some(oe=>(0,p.areSameExtensions)(oe.identifier,ie.identifier))||X.push(ie);return X}h(M,L,F,z){const H=z.getExtensionState(L,!0)||{},Q=F?z.getKeysForSync({id:L.identifier.id,version:F}):void 0;Q?Q.forEach(K=>{H[K]=M[K]}):Object.keys(M).forEach(K=>H[K]=M[K]),z.setExtensionState(L,H,!0)}async j(M,L){return this.b.withProfileScopedStorageService(M,async F=>{const z=new R.DisposableStore,H=this.f.createChild(new l.ServiceCollection([g.IStorageService,F])),Q=z.add(H.createInstance(b.GlobalExtensionEnablementService)),K=z.add(H.createInstance(h.ExtensionStorageService));try{return await L(Q,K)}finally{z.dispose()}})}};N=ye([Y(0,m.IExtensionManagementService),Y(1,c.IUserDataProfileStorageService),Y(2,m.IExtensionGalleryService),Y(3,s.IIgnoredExtensionsManagementService),Y(4,f.IInstantiationService),Y(5,o.IUserDataSyncLogService)],N),e.LocalExtensionsProvider=N;let O=class extends r.AbstractInitializer{constructor(M,L,F,z,H,Q,K,V){super("extensions",z,H,Q,F,K,V),this.o=M,this.p=L}async q(M){return M.syncData?await a(M.syncData,this.o):null}t(M,L){const F=[],z=[],H=[];for(const Q of M){if(this.p.hasToNeverSyncExtension(Q.identifier.id))continue;const K=L.find(V=>(0,p.areSameExtensions)(V.identifier,Q.identifier));K?(F.push(K),Q.disabled&&H.push(Q.identifier)):Q.installed&&(z.push({...Q.identifier,preRelease:!!Q.preRelease}),Q.disabled&&H.push(Q.identifier))}return{installedExtensions:F,newExtensions:z,disabledExtensions:H,remoteExtensions:M}}};O=ye([Y(0,m.IExtensionManagementService),Y(1,s.IIgnoredExtensionsManagementService),Y(2,y.IFileService),Y(3,i.IUserDataProfilesService),Y(4,C.IEnvironmentService),Y(5,d.ILogService),Y(6,g.IStorageService),Y(7,I.IUriIdentityService)],O),e.AbstractExtensionsInitializer=O}),define(re[120],ae([0,1,17,7,3,35,43,5,31,16,15,13,9,45,20,19,29,41,61,257,26,18,62,4]),function(_,e,A,n,D,k,T,R,P,S,C,b,m,p,h,y,f,l,d,g,v,I,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.LocalGlobalStateProvider=e.GlobalStateSynchroniser=e.stringify=void 0;const t="globalState.argv.",s=["locale"];function o(N,O){const j=N.storage?Object.keys(N.storage).sort():[],M={};return j.forEach(L=>M[L]=N.storage[L]),N.storage=M,O?(0,T.toFormattedString)(N,{}):JSON.stringify(N)}e.stringify=o;const c=1;let a=class extends l.AbstractSynchroniser{constructor(O,j,M,L,F,z,H,Q,K,V,W,G,X,ie){super({syncResource:"globalState",profile:O},j,L,Q,G,F,z,K,V,H,W,X),this.wb=M,this.mb=c,this.p=this.h.joinPath(this.g,"globalState.json"),this.r=this.p.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"base"}),this.sb=this.p.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),this.tb=this.p.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.ub=this.p.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.vb=ie.createInstance(u),this.B(L.watch(this.h.dirname(this.D.argvResource))),this.B(D.Event.any(D.Event.filter(L.onDidFilesChange,oe=>oe.contains(this.D.argvResource)),D.Event.filter(M.onDidChange,oe=>!!(oe.targetChanges.some(te=>this.syncResource.profile.id===te.id)||oe.valueChanges.some(({profile:te,changes:U})=>this.syncResource.profile.id===te.id&&U.some($=>$.target===0)))))(()=>this.triggerLocalChange()))}async nb(O,j,M){const L=O.syncData?JSON.parse(O.syncData.content):null;j=j===null&&M?O:j;const F=j&&j.syncData?JSON.parse(j.syncData.content):null,z=await this.vb.getLocalGlobalState(this.syncResource.profile);L?this.L.trace(`${this.y}: Merging remote ui state with local ui state...`):this.L.trace(`${this.y}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const H=await this.Eb(F),{local:Q,remote:K}=(0,g.merge)(z.storage,L?L.storage:null,F?F.storage:null,H,this.L),V={content:null,local:Q,remote:K,localChange:Object.keys(Q.added).length>0||Object.keys(Q.updated).length>0||Q.removed.length>0?2:0,remoteChange:K.all!==null?2:0},W=o(z,!1);return[{baseResource:this.r,baseContent:F?o(F,!1):W,localResource:this.sb,localContent:W,localUserData:z,remoteResource:this.tb,remoteContent:L?o(L,!1):null,previewResource:this.p,previewResult:V,localChange:V.localChange,remoteChange:V.remoteChange,acceptedResource:this.ub,storageKeys:H}]}async rb(O){const j=O.syncData?JSON.parse(O.syncData.content):null;if(j===null)return!0;const M=await this.vb.getLocalGlobalState(this.syncResource.profile),L=await this.Eb(j),{remote:F}=(0,g.merge)(M.storage,j.storage,j.storage,L,this.L);return F.all!==null}async ob(O,j){return{...O.previewResult,hasConflicts:!1}}async pb(O,j,M,L){if(this.h.isEqual(j,this.sb))return this.Bb(O);if(this.h.isEqual(j,this.tb))return this.Cb(O);if(this.h.isEqual(j,this.p))return O.previewResult;throw new Error(`Invalid Resource: ${j.toString()}`)}async Bb(O){return{content:O.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(O.localUserData.storage),removed:[],updated:[],all:O.localUserData.storage},localChange:0,remoteChange:2}}async Cb(O){if(O.remoteContent!==null){const j=JSON.parse(O.remoteContent),{local:M,remote:L}=(0,g.merge)(O.localUserData.storage,j.storage,null,O.storageKeys,this.L);return{content:O.remoteContent,local:M,remote:L,localChange:Object.keys(M.added).length>0||Object.keys(M.updated).length>0||M.removed.length>0?2:0,remoteChange:L!==null?2:0}}else return{content:O.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async qb(O,j,M,L){const{localUserData:F}=M[0][0],{local:z,remote:H,localChange:Q,remoteChange:K}=M[0][1];if(Q===0&&K===0&&this.L.info(`${this.y}: No changes found during synchronizing ui state.`),Q!==0&&(this.L.trace(`${this.y}: Updating local ui state...`),await this.kb(JSON.stringify(F)),await this.vb.writeLocalGlobalState(z,this.syncResource.profile),this.L.info(`${this.y}: Updated local ui state`)),K!==0){this.L.trace(`${this.y}: Updating remote ui state...`);const V=JSON.stringify({storage:H.all});O=await this.jb(V,L?null:O.ref),this.L.info(`${this.y}: Updated remote ui state.${H.added.length?` Added: ${H.added}.`:""}${H.updated.length?` Updated: ${H.updated}.`:""}${H.removed.length?` Removed: ${H.removed}.`:""}`)}j?.ref!==O.ref&&(this.L.trace(`${this.y}: Updating last synchronized ui state...`),await this.cb(O),this.L.info(`${this.y}: Updated last synchronized ui state`))}async resolveContent(O){if(this.h.isEqual(this.tb,O)||this.h.isEqual(this.r,O)||this.h.isEqual(this.sb,O)||this.h.isEqual(this.ub,O)){const j=await this.ab(O);return j&&o(JSON.parse(j),!0)}return null}async hasLocalData(){try{const{storage:O}=await this.vb.getLocalGlobalState(this.syncResource.profile);if(Object.keys(O).length>1||O[`${t}.locale`]?.value!=="en")return!0}catch{}return!1}async Eb(O){const j=await this.wb.readStorageData(this.syncResource.profile),M=[],L=[];for(const[H,Q]of j)Q.target===0?M.push(H):Q.target===1&&L.push(H);const F=[...M,...L],z=O?.storage?Object.keys(O.storage).filter(H=>!H.startsWith(t)&&!F.includes(H)&&j.get(H)!==void 0):[];if(!R.isWeb){const H=[...v.ALL_SYNC_RESOURCES.map(Q=>(0,v.getEnablementKey)(Q)),v.SYNC_SERVICE_URL_TYPE];z.push(...H),L.push(...H)}return{user:M,machine:L,unregistered:z}}};a=ye([Y(2,i.IUserDataProfileStorageService),Y(3,b.IFileService),Y(4,v.IUserDataSyncStoreService),Y(5,v.IUserDataSyncBackupStoreService),Y(6,v.IUserDataSyncLogService),Y(7,C.IEnvironmentService),Y(8,v.IUserDataSyncEnablementService),Y(9,y.ITelemetryService),Y(10,S.IConfigurationService),Y(11,h.IStorageService),Y(12,f.IUriIdentityService),Y(13,r.IInstantiationService)],a),e.GlobalStateSynchroniser=a;let u=class{constructor(O,j,M,L){this.a=O,this.b=j,this.c=M,this.d=L}async getLocalGlobalState(O){const j={};if(O.isDefault){const L=await this.f(),F=(0,k.parse)(L);for(const z of s)F[z]!==void 0&&(j[`${t}${z}`]={version:1,value:F[z]})}const M=await this.c.readStorageData(O);for(const[L,F]of M)F.value&&F.target===0&&(j[L]={version:1,value:F.value});return{storage:j}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const O=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),O.value.toString()}catch(O){this.d.debug((0,n.getErrorMessage)(O))}return"{}"}async writeLocalGlobalState({added:O,removed:j,updated:M},L){const F=(0,l.getSyncResourceLogLabel)("globalState",L),z={},H=new Map,Q=await this.c.readStorageData(L),K=(V,W)=>{for(const G of V){if(G.startsWith(t)){z[G.substring(t.length)]=W?W[G].value:void 0;continue}if(W){const X=W[G];X.value!==Q.get(G)?.value&&H.set(G,X.value)}else Q.get(G)!==void 0&&H.set(G,void 0)}};if(K(Object.keys(O),O),K(Object.keys(M),M),K(j),Object.keys(z).length){this.d.trace(`${F}: Updating locale...`);const V=await this.f();let W=V;for(const G of Object.keys(z))W=(0,d.edit)(W,[G],z[G],{});V!==W&&(this.d.trace(`${F}: Updating locale...`),await this.a.writeFile(this.b.argvResource,A.VSBuffer.fromString(W)),this.d.info(`${F}: Updated locale.`)),this.d.info(`${F}: Updated locale`)}H.size&&(this.d.trace(`${F}: Updating global state...`),await this.c.updateStorageData(L,H,0),this.d.info(`${F}: Updated global state`,[...H.keys()]))}};u=ye([Y(0,b.IFileService),Y(1,C.IEnvironmentService),Y(2,i.IUserDataProfileStorageService),Y(3,v.IUserDataSyncLogService)],u),e.LocalGlobalStateProvider=u;let w=class extends l.AbstractInitializer{constructor(O,j,M,L,F,z){super("globalState",M,L,F,j,O,z)}async doInitialize(O){const j=O.syncData?JSON.parse(O.syncData.content):null;if(!j){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const M={},L={};for(const F of Object.keys(j.storage))F.startsWith(t)?M[F.substring(t.length)]=j.storage[F].value:this.l.get(F,0)===void 0&&(L[F]=j.storage[F].value);if(Object.keys(M).length){let F="{}";try{F=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const z of Object.keys(M))F=(0,d.edit)(F,[z],M[z],{});await this.k.writeFile(this.h.argvResource,A.VSBuffer.fromString(F))}if(Object.keys(L).length)for(const F of Object.keys(L))this.l.store(F,L[F],0,0)}};w=ye([Y(0,h.IStorageService),Y(1,b.IFileService),Y(2,I.IUserDataProfilesService),Y(3,C.IEnvironmentService),Y(4,v.IUserDataSyncLogService),Y(5,f.IUriIdentityService)],w),e.GlobalStateInitializer=w;let E=class{constructor(O,j,M,L,F){this.a=O,this.b=j,this.c=M,this.d=L,this.f=F}getSyncStoreType(O){return this.h(O)?.storage[v.SYNC_SERVICE_URL_TYPE]?.value}async sync(O){const j=(0,v.createSyncHeaders)((0,P.generateUuid)());try{return await this.g(O,j)}catch(M){if(M instanceof v.UserDataSyncError)switch(M.code){case"PreconditionFailed":return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(O,j)}throw M}}async g(O,j){const M=await this.a.readResource("globalState",null,void 0,j),L=this.h(M)||{storage:{}};L.storage[v.SYNC_SERVICE_URL_TYPE]={value:O,version:c};const F=await(0,p.getServiceMachineId)(this.c,this.d,this.b),z={version:c,machineId:F,content:o(L,!1)};await this.a.writeResource("globalState",JSON.stringify(z),M.ref,void 0,j)}h({content:O}){if(!O)return null;const j=JSON.parse(O);if((0,l.isSyncData)(j))return j?JSON.parse(j.content):null;throw new Error("Invalid remote data")}};E=ye([Y(1,h.IStorageService),Y(2,C.IEnvironmentService),Y(3,b.IFileService),Y(4,m.ILogService)],E),e.UserDataSyncStoreTypeSynchronizer=E}),define(re[121],ae([0,1,21,17,3,35,5,14,177,16,15,13,20,19,29,18,41,254,26]),function(_,e,A,n,D,k,T,R,P,S,C,b,m,p,h,y,f,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function g(i,r,t){try{const s=JSON.parse(i);if(!r)return(0,R.isUndefined)(s.all)?null:s.all;switch(T.OS){case 2:return(0,R.isUndefined)(s.mac)?null:s.mac;case 3:return(0,R.isUndefined)(s.linux)?null:s.linux;case 1:return(0,R.isUndefined)(s.windows)?null:s.windows}}catch(s){return t.error(s),null}}e.getKeybindingsContentFromSyncContent=g;let v=class extends f.AbstractJsonFileSynchroniser{constructor(r,t,s,o,c,a,u,w,E,N,O,j,M){super(r.keybindingsResource,{syncResource:"keybindings",profile:r},t,w,E,N,s,o,u,j,c,O,a,M),this.mb=2,this.zb=this.h.joinPath(this.g,"keybindings.json"),this.Ab=this.zb.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),this.Bb=this.zb.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),this.Cb=this.zb.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.Db=this.zb.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.B(D.Event.filter(a.onDidChangeConfiguration,L=>L.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async nb(r,t,s,o){const c=r.syncData?g(r.syncData.content,o.keybindingsPerPlatform??this.Lb(),this.L):null;t=t===null&&s?r:t;const a=t?this.Jb(t):null,u=await this.p(),w=await this.xb();let E=null,N=!1,O=!1,j=!1;if(c){let F=u?u.value.toString():"[]";if(F=F||"[]",this.vb(F,!0))throw new d.UserDataSyncError((0,P.localize)(0,null),"LocalInvalidContent",this.resource);if(!a||a!==F||a!==c){this.L.trace(`${this.y}: Merging remote keybindings with local keybindings...`);const z=await(0,l.merge)(F,c,a,w,this.ub);z.hasChanges&&(E=z.mergeContent,j=z.hasConflicts,N=j||z.mergeContent!==F,O=j||z.mergeContent!==c)}}else u&&(this.L.trace(`${this.y}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),E=u.value.toString(),O=!0);const M={content:j?a:E,localChange:N?u?2:1:0,remoteChange:O?2:0,hasConflicts:j},L=u?u.value.toString():null;return[{fileContent:u,baseResource:this.Ab,baseContent:a,localResource:this.Bb,localContent:L,localChange:M.localChange,remoteResource:this.Cb,remoteContent:c,remoteChange:M.remoteChange,previewResource:this.zb,previewResult:M,acceptedResource:this.Db}]}async rb(r){const t=this.Jb(r);if(t===null)return!0;const s=await this.p(),o=s?s.value.toString():"",c=await this.xb(),a=await(0,l.merge)(o||"[]",t,t,c,this.ub);return a.hasConflicts||a.mergeContent!==t}async ob(r,t){return r.previewResult}async pb(r,t,s,o){if(this.h.isEqual(t,this.Bb))return{content:r.fileContent?r.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(t,this.Cb))return{content:r.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(t,this.zb))return s===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:s,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async qb(r,t,s,o){const{fileContent:c}=s[0][0];let{content:a,localChange:u,remoteChange:w}=s[0][1];if(u===0&&w===0&&this.L.info(`${this.y}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.vb(a,!0)))throw new d.UserDataSyncError((0,P.localize)(1,null),"LocalInvalidContent",this.resource);if(u!==0&&(this.L.trace(`${this.y}: Updating local keybindings...`),c&&await this.kb(this.Kb(c.value.toString())),await this.r(a||"[]",c,o),this.L.info(`${this.y}: Updated local keybindings`)),w!==0){this.L.trace(`${this.y}: Updating remote keybindings...`);const E=this.Kb(a||"[]",r.syncData?.content);r=await this.jb(E,o?null:r.ref),this.L.info(`${this.y}: Updated remote keybindings`)}try{await this.C.del(this.zb)}catch{}t?.ref!==r.ref&&(this.L.trace(`${this.y}: Updating last synchronized keybindings...`),await this.cb(r,{platformSpecific:this.Lb()}),this.L.info(`${this.y}: Updated last synchronized keybindings`))}async hasLocalData(){try{const r=await this.p();if(r){const t=(0,k.parse)(r.value.toString());if((0,A.isNonEmptyArray)(t))return!0}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async resolveContent(r){return this.h.isEqual(this.Cb,r)||this.h.isEqual(this.Ab,r)||this.h.isEqual(this.Bb,r)||this.h.isEqual(this.Db,r)?this.ab(r):null}Jb(r){return!r.syncData||r.platformSpecific!==void 0&&r.platformSpecific!==this.Lb()?null:g(r.syncData.content,this.Lb(),this.L)}Kb(r,t){let s={};try{s=JSON.parse(t||"{}")}catch(o){this.L.error(o)}switch(this.Lb()?delete s.all:s.all=r,T.OS){case 2:s.mac=r;break;case 3:s.linux=r;break;case 1:s.windows=r;break}return JSON.stringify(s)}Lb(){return!!this.M.getValue(d.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM)}};v=ye([Y(2,d.IUserDataSyncStoreService),Y(3,d.IUserDataSyncBackupStoreService),Y(4,d.IUserDataSyncLogService),Y(5,S.IConfigurationService),Y(6,d.IUserDataSyncEnablementService),Y(7,b.IFileService),Y(8,C.IEnvironmentService),Y(9,m.IStorageService),Y(10,d.IUserDataSyncUtilService),Y(11,p.ITelemetryService),Y(12,h.IUriIdentityService)],v),e.KeybindingsSynchroniser=v;let I=class extends f.AbstractInitializer{constructor(r,t,s,o,c,a){super("keybindings",t,s,o,r,c,a)}async doInitialize(r){const t=r.syncData?this.i(r.syncData.content):null;if(!t){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.c()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,n.VSBuffer.fromString(t)),await this.n(r)}async c(){try{const r=await this.k.readFile(this.g.defaultProfile.settingsResource),t=(0,k.parse)(r.value.toString());return!(0,A.isNonEmptyArray)(t)}catch(r){return r.fileOperationResult===1}}i(r){try{return g(r,!0,this.j)}catch(t){return this.j.error(t),null}}};I=ye([Y(0,b.IFileService),Y(1,y.IUserDataProfilesService),Y(2,C.IEnvironmentService),Y(3,d.IUserDataSyncLogService),Y(4,m.IStorageService),Y(5,h.IUriIdentityService)],I),e.KeybindingsInitializer=I}),define(re[122],ae([0,1,17,3,178,16,74,15,30,13,20,19,29,18,41,61,258,26]),function(_,e,A,n,D,k,T,R,P,S,C,b,m,p,h,y,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function d(i){return i&&i.settings&&typeof i.settings=="string"&&Object.keys(i).length===1}function g(i){const r=JSON.parse(i);return d(r)?r:{settings:i}}e.parseSettingsSyncContent=g;let v=class extends h.AbstractJsonFileSynchroniser{constructor(r,t,s,o,c,a,u,w,E,N,O,j,M,L){super(r.settingsResource,{syncResource:"settings",profile:r},t,s,o,c,a,u,O,j,w,E,N,L),this.zb=M,this.mb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.Jb=void 0}async getRemoteUserDataSyncConfiguration(r){const t=await this.getLastSyncUserData(),s=await this.R(r,t),o=this.Gb(s),c=new T.ConfigurationModelParser(l.USER_DATA_SYNC_CONFIGURATION_SCOPE);return o?.settings&&c.parse(o.settings),c.configurationModel.getValue(l.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async nb(r,t,s){const o=await this.p(),c=await this.xb(),a=this.Gb(r);t=t===null&&s?r:t;const u=t?this.Gb(t):null,w=await this.Kb();let E=null,N=!1,O=!1,j=!1;if(a){let z=o?o.value.toString().trim():"{}";z=z||"{}",this.Lb(z),this.L.trace(`${this.y}: Merging remote settings with local settings...`);const H=(0,f.merge)(z,a.settings,u?u.settings:null,w,[],c);E=H.localContent||H.remoteContent,N=H.localContent!==null,O=H.remoteContent!==null,j=H.hasConflicts}else o&&(this.L.trace(`${this.y}: Remote settings does not exist. Synchronizing settings for the first time.`),E=o.value.toString().trim()||"{}",this.Lb(E),O=!0);const M=o?o.value.toString():null,L=u?.settings??null,F={content:j?L:E,localChange:N?2:0,remoteChange:O?2:0,hasConflicts:j};return[{fileContent:o,baseResource:this.baseResource,baseContent:L,localResource:this.localResource,localContent:M,localChange:F.localChange,remoteResource:this.remoteResource,remoteContent:a?a.settings:null,remoteChange:F.remoteChange,previewResource:this.previewResource,previewResult:F,acceptedResource:this.acceptedResource}]}async rb(r){const t=this.Gb(r);if(t===null)return!0;const s=await this.p(),o=s?s.value.toString().trim():"",c=await this.Kb(),a=await this.xb();return(0,f.merge)(o||"{}",t.settings,t.settings,c,[],a).remoteContent!==null}async ob(r,t){const s=await this.xb(),o=await this.Kb();return{...r.previewResult,content:r.previewResult.content?(0,f.updateIgnoredSettings)(r.previewResult.content,"{}",o,s):null}}async pb(r,t,s,o){const c=await this.xb(),a=await this.Kb();if(this.h.isEqual(t,this.localResource))return{content:r.fileContent?(0,f.updateIgnoredSettings)(r.fileContent.value.toString(),"{}",a,c):null,localChange:0,remoteChange:2};if(this.h.isEqual(t,this.remoteResource))return{content:r.remoteContent!==null?(0,f.updateIgnoredSettings)(r.remoteContent,r.fileContent?r.fileContent.value.toString():"{}",a,c):null,localChange:2,remoteChange:0};if(this.h.isEqual(t,this.previewResource))return s===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:s!==null?(0,f.updateIgnoredSettings)(s,r.fileContent?r.fileContent.value.toString():"{}",a,c):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async qb(r,t,s,o){const{fileContent:c}=s[0][0];let{content:a,localChange:u,remoteChange:w}=s[0][1];if(u===0&&w===0&&this.L.info(`${this.y}: No changes found during synchronizing settings.`),a=a?a.trim():"{}",a=a||"{}",this.Lb(a),u!==0&&(this.L.trace(`${this.y}: Updating local settings...`),c&&await this.kb(JSON.stringify(this.Ib(c.value.toString()))),await this.r(a,c,o),await this.M.reloadConfiguration(3),this.L.info(`${this.y}: Updated local settings`)),w!==0){const E=await this.xb(),N=this.Gb(r),O=await this.Kb(a);a=(0,f.updateIgnoredSettings)(a,N?N.settings:"{}",O,E),this.L.trace(`${this.y}: Updating remote settings...`),r=await this.jb(JSON.stringify(this.Ib(a)),o?null:r.ref),this.L.info(`${this.y}: Updated remote settings`)}try{await this.C.del(this.previewResource)}catch{}t?.ref!==r.ref&&(this.L.trace(`${this.y}: Updating last synchronized settings...`),await this.cb(r),this.L.info(`${this.y}: Updated last synchronized settings`))}async hasLocalData(){try{const r=await this.p();if(r){const t=await this.xb(),s=(0,y.edit)(r.value.toString(),[l.CONFIGURATION_SYNC_STORE_KEY],void 0,t);return!(0,f.isEmpty)(s)}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async resolveContent(r){return this.h.isEqual(this.remoteResource,r)||this.h.isEqual(this.localResource,r)||this.h.isEqual(this.acceptedResource,r)||this.h.isEqual(this.baseResource,r)?this.ab(r):null}async ab(r){let t=await super.ab(r);if(t){const s=await this.xb(),o=await this.Kb();t=(0,f.updateIgnoredSettings)(t,"{}",o,s)}return t}Gb(r){return r.syncData?this.Hb(r.syncData.content):null}Hb(r){try{return g(r)}catch(t){this.L.error(t)}return null}Ib(r){return{settings:r}}async Kb(r){if(!this.Jb){this.Jb=this.ub.resolveDefaultIgnoredSettings();const s=n.Event.any(n.Event.filter(this.zb.onDidInstallExtensions,o=>o.some(({local:c})=>!!c)),n.Event.filter(this.zb.onDidUninstallExtension,o=>!o.error))(()=>{s.dispose(),this.Jb=void 0})}const t=await this.Jb;return(0,f.getIgnoredSettings)(t,this.M,r)}Lb(r){if(this.vb(r,!1))throw new l.UserDataSyncError((0,D.localize)(0,null),"LocalInvalidContent",this.resource)}};v=ye([Y(2,S.IFileService),Y(3,R.IEnvironmentService),Y(4,C.IStorageService),Y(5,l.IUserDataSyncStoreService),Y(6,l.IUserDataSyncBackupStoreService),Y(7,l.IUserDataSyncLogService),Y(8,l.IUserDataSyncUtilService),Y(9,k.IConfigurationService),Y(10,l.IUserDataSyncEnablementService),Y(11,b.ITelemetryService),Y(12,P.IExtensionManagementService),Y(13,m.IUriIdentityService)],v),e.SettingsSynchroniser=v;let I=class extends h.AbstractInitializer{constructor(r,t,s,o,c,a){super("settings",t,s,o,r,c,a)}async doInitialize(r){const t=r.syncData?this.i(r.syncData.content):null;if(!t){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.c()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,A.VSBuffer.fromString(t.settings)),await this.n(r)}async c(){try{const r=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,f.isEmpty)(r.value.toString().trim())}catch(r){return r.fileOperationResult===1}}i(r){try{return g(r)}catch(t){this.j.error(t)}return null}};I=ye([Y(0,S.IFileService),Y(1,p.IUserDataProfilesService),Y(2,R.IEnvironmentService),Y(3,l.IUserDataSyncLogService),Y(4,C.IStorageService),Y(5,m.IUriIdentityService)],I),e.SettingsInitializer=I}),define(re[123],ae([0,1,17,3,32,16,15,13,20,19,29,18,41,255,26]),function(_,e,A,n,D,k,T,R,P,S,C,b,m,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=e.parseSnippets=void 0;function y(d){return JSON.parse(d.content)}e.parseSnippets=y;let f=class extends m.AbstractSynchroniser{constructor(g,v,I,i,r,t,s,o,c,a,u,w){super({syncResource:"snippets",profile:g},v,i,I,r,t,s,a,u,o,c,w),this.mb=1,this.p=g.snippetsHome,this.B(this.C.watch(I.userRoamingDataHome)),this.B(this.C.watch(this.p)),this.B(n.Event.filter(this.C.onDidFilesChange,E=>E.affects(this.p))(()=>this.triggerLocalChange()))}async nb(g,v,I){const i=await this.Cb(),r=this.Bb(i),t=g.syncData?this.Ab(g.syncData):null;v=v===null&&I?g:v;const s=v&&v.syncData?this.Ab(v.syncData):null;t?this.L.trace(`${this.y}: Merging remote snippets with local snippets...`):this.L.trace(`${this.y}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const o=(0,p.merge)(r,t,s);return this.wb(o,i,t||{},s||{})}async rb(g){const v=g.syncData?this.Ab(g.syncData):null;if(v===null)return!0;const I=await this.Cb(),i=this.Bb(I),r=(0,p.merge)(i,v,v);return Object.keys(r.remote.added).length>0||Object.keys(r.remote.updated).length>0||r.remote.removed.length>0||r.conflicts.length>0}async ob(g,v){return g.previewResult}async pb(g,v,I,i){if(this.h.isEqualOrParent(v,this.g.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:g.fileContent?g.fileContent.value.toString():null,localChange:0,remoteChange:g.fileContent?g.remoteContent!==null?2:1:3};if(this.h.isEqualOrParent(v,this.g.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:g.remoteContent,localChange:g.remoteContent!==null?g.fileContent?2:1:3,remoteChange:0};if(this.h.isEqualOrParent(v,this.g))return I===void 0?{content:g.previewResult.content,localChange:g.previewResult.localChange,remoteChange:g.previewResult.remoteChange}:{content:I,localChange:I===null?g.fileContent!==null?3:0:2,remoteChange:I===null?g.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${v.toString()}`)}async qb(g,v,I,i){const r=I.map(([t,s])=>({...t,acceptResult:s}));r.every(({localChange:t,remoteChange:s})=>t===0&&s===0)&&this.L.info(`${this.y}: No changes found during synchronizing snippets.`),r.some(({localChange:t})=>t!==0)&&(await this.xb(r),await this.yb(r,i)),r.some(({remoteChange:t})=>t!==0)&&(g=await this.zb(r,g,i)),v?.ref!==g.ref&&(this.L.trace(`${this.y}: Updating last synchronized snippets...`),await this.cb(g),this.L.info(`${this.y}: Updated last synchronized snippets`));for(const{previewResource:t}of r)try{await this.C.del(t)}catch{}}wb(g,v,I,i){const r=new Map;for(const t of Object.keys(g.local.added)){const s={content:g.local.added[t],hasConflicts:!1,localChange:1,remoteChange:0};r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[t],previewResource:this.h.joinPath(this.g,t),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(g.local.updated)){const s={content:g.local.updated[t],hasConflicts:!1,localChange:2,remoteChange:0},o=v[t]?v[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[t],localContent:o,remoteResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[t],previewResource:this.h.joinPath(this.g,t),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of g.local.removed){const s={content:null,hasConflicts:!1,localChange:3,remoteChange:0},o=v[t]?v[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[t],localContent:o,remoteResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,t),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(g.remote.added)){const s={content:g.remote.added[t],hasConflicts:!1,localChange:0,remoteChange:1},o=v[t]?v[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[t],localContent:o,remoteResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,t),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(g.remote.updated)){const s={content:g.remote.updated[t],hasConflicts:!1,localChange:0,remoteChange:2},o=v[t]?v[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[t],localContent:o,remoteResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[t],previewResource:this.h.joinPath(this.g,t),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of g.remote.removed){const s={content:null,hasConflicts:!1,localChange:0,remoteChange:3};r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[t],previewResource:this.h.joinPath(this.g,t),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of g.conflicts){const s={content:i[t]??null,hasConflicts:!0,localChange:v[t]?2:1,remoteChange:I[t]?2:1},o=v[t]?v[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[t]||null,localContent:o,remoteResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[t]||null,previewResource:this.h.joinPath(this.g,t),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(v))if(!r.has(t)){const s={content:v[t]?v[t].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},o=v[t]?v[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:i[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[t]||null,localContent:o,remoteResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[t]||null,previewResource:this.h.joinPath(this.g,t),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...r.values()]}async resolveContent(g){return this.h.isEqualOrParent(g,this.g.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.h.isEqualOrParent(g,this.g.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.h.isEqualOrParent(g,this.g.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}))||this.h.isEqualOrParent(g,this.g.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"}))?this.ab(g):null}async hasLocalData(){try{const g=await this.Cb();if(Object.keys(g).length)return!0}catch{}return!1}async xb(g){const v={};for(const I of g)I.fileContent&&(v[this.h.basename(I.localResource)]=I.fileContent);await this.kb(JSON.stringify(this.Bb(v)))}async yb(g,v){for(const{fileContent:I,acceptResult:i,localResource:r,remoteResource:t,localChange:s}of g)if(s!==0){const o=t?this.h.basename(t):this.h.basename(r),c=this.h.joinPath(this.p,o);s===3?(this.L.trace(`${this.y}: Deleting snippet...`,this.h.basename(c)),await this.C.del(c),this.L.info(`${this.y}: Deleted snippet`,this.h.basename(c))):s===1?(this.L.trace(`${this.y}: Creating snippet...`,this.h.basename(c)),await this.C.createFile(c,A.VSBuffer.fromString(i.content),{overwrite:v}),this.L.info(`${this.y}: Created snippet`,this.h.basename(c))):(this.L.trace(`${this.y}: Updating snippet...`,this.h.basename(c)),await this.C.writeFile(c,A.VSBuffer.fromString(i.content),v?void 0:I),this.L.info(`${this.y}: Updated snippet`,this.h.basename(c)))}}async zb(g,v,I){const i=v.syncData?this.Ab(v.syncData):{},r=(0,D.deepClone)(i);for(const{acceptResult:t,localResource:s,remoteResource:o,remoteChange:c}of g)if(c!==0){const a=s?this.h.basename(s):this.h.basename(o);c===3?delete r[a]:r[a]=t.content}return(0,p.areSame)(i,r)||(this.L.trace(`${this.y}: Updating remote snippets...`),v=await this.jb(JSON.stringify(r),I?null:v.ref),this.L.info(`${this.y}: Updated remote snippets`)),v}Ab(g){return y(g)}Bb(g){const v={};for(const I of Object.keys(g))v[I]=g[I].value.toString();return v}async Cb(){const g={};let v;try{v=await this.C.resolve(this.p)}catch(I){if(I instanceof R.FileOperationError&&I.fileOperationResult===1)return g;throw I}for(const I of v.children||[]){const i=I.resource,r=this.h.extname(i);if(r===".json"||r===".code-snippets"){const t=this.h.relativePath(this.p,i),s=await this.C.readFile(i);g[t]=s}}return g}};f=ye([Y(2,T.IEnvironmentService),Y(3,R.IFileService),Y(4,P.IStorageService),Y(5,h.IUserDataSyncStoreService),Y(6,h.IUserDataSyncBackupStoreService),Y(7,h.IUserDataSyncLogService),Y(8,k.IConfigurationService),Y(9,h.IUserDataSyncEnablementService),Y(10,S.ITelemetryService),Y(11,C.IUriIdentityService)],f),e.SnippetsSynchroniser=f;let l=class extends m.AbstractInitializer{constructor(g,v,I,i,r,t){super("snippets",v,I,i,g,r,t)}async doInitialize(g){const v=g.syncData?JSON.parse(g.syncData.content):null;if(!v){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.c()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const i of Object.keys(v)){const r=v[i];if(r){const t=this.d.joinPath(this.g.defaultProfile.snippetsHome,i);await this.k.createFile(t,A.VSBuffer.fromString(r)),this.j.info("Created snippet",this.d.basename(t))}}await this.n(g)}async c(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(g){return g.fileOperationResult===1}}};l=ye([Y(0,R.IFileService),Y(1,b.IUserDataProfilesService),Y(2,T.IEnvironmentService),Y(3,h.IUserDataSyncLogService),Y(4,P.IStorageService),Y(5,C.IUriIdentityService)],l),e.SnippetsInitializer=l}),define(re[124],ae([0,1,17,16,15,13,20,19,29,18,41,26]),function(_,e,A,n,D,k,T,R,P,S,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=e.getTasksContentFromSyncContent=void 0;function m(f,l){try{return JSON.parse(f).tasks??null}catch(d){return l.error(d),null}}e.getTasksContentFromSyncContent=m;let p=class extends C.AbstractFileSynchroniser{constructor(l,d,g,v,I,i,r,t,s,o,c,a){super(l.tasksResource,{syncResource:"tasks",profile:l},d,t,s,o,g,v,r,c,I,i,a),this.mb=1,this.vb=this.h.joinPath(this.g,"tasks.json"),this.wb=this.vb.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"base"}),this.xb=this.vb.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"local"}),this.yb=this.vb.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.zb=this.vb.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async nb(l,d,g,v){const I=l.syncData?m(l.syncData.content,this.L):null;d=d===null&&g?l:d;const i=d?.syncData?m(d.syncData.content,this.L):null,r=await this.p();let t=null,s=!1,o=!1,c=!1;if(l.syncData){const w=r?r.value.toString():null;if(!i||i!==w||i!==I){this.L.trace(`${this.y}: Merging remote tasks with local tasks...`);const E=y(w,I,i);t=E.content,c=E.hasConflicts,s=E.hasLocalChanged,o=E.hasRemoteChanged}}else r&&(this.L.trace(`${this.y}: Remote tasks does not exist. Synchronizing tasks for the first time.`),t=r.value.toString(),o=!0);const a={content:c?i:t,localChange:s?r?2:1:0,remoteChange:o?2:0,hasConflicts:c},u=r?r.value.toString():null;return[{fileContent:r,baseResource:this.wb,baseContent:i,localResource:this.xb,localContent:u,localChange:a.localChange,remoteResource:this.yb,remoteContent:I,remoteChange:a.remoteChange,previewResource:this.vb,previewResult:a,acceptedResource:this.zb}]}async rb(l){const d=l?.syncData?m(l.syncData.content,this.L):null;if(d===null)return!0;const g=await this.p(),v=g?g.value.toString():null,I=y(v,d,d);return I.hasLocalChanged||I.hasRemoteChanged}async ob(l,d){return l.previewResult}async pb(l,d,g,v){if(this.h.isEqual(d,this.xb))return{content:l.fileContent?l.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(d,this.yb))return{content:l.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(d,this.vb))return g===void 0?{content:l.previewResult.content,localChange:l.previewResult.localChange,remoteChange:l.previewResult.remoteChange}:{content:g,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${d.toString()}`)}async qb(l,d,g,v){const{fileContent:I}=g[0][0],{content:i,localChange:r,remoteChange:t}=g[0][1];if(r===0&&t===0&&this.L.info(`${this.y}: No changes found during synchronizing tasks.`),r!==0&&(this.L.trace(`${this.y}: Updating local tasks...`),I&&await this.kb(JSON.stringify(this.Fb(I.value.toString()))),i?await this.r(i,I,v):await this.sb(),this.L.info(`${this.y}: Updated local tasks`)),t!==0){this.L.trace(`${this.y}: Updating remote tasks...`);const s=JSON.stringify(this.Fb(i));l=await this.jb(s,v?null:l.ref),this.L.info(`${this.y}: Updated remote tasks`)}try{await this.C.del(this.vb)}catch{}d?.ref!==l.ref&&(this.L.trace(`${this.y}: Updating last synchronized tasks...`),await this.cb(l),this.L.info(`${this.y}: Updated last synchronized tasks`))}async hasLocalData(){return this.C.exists(this.i)}async resolveContent(l){return this.h.isEqual(this.yb,l)||this.h.isEqual(this.wb,l)||this.h.isEqual(this.xb,l)||this.h.isEqual(this.zb,l)?this.ab(l):null}Fb(l){return l?{tasks:l}:{}}};p=ye([Y(2,b.IUserDataSyncStoreService),Y(3,b.IUserDataSyncBackupStoreService),Y(4,b.IUserDataSyncLogService),Y(5,n.IConfigurationService),Y(6,b.IUserDataSyncEnablementService),Y(7,k.IFileService),Y(8,D.IEnvironmentService),Y(9,T.IStorageService),Y(10,R.ITelemetryService),Y(11,P.IUriIdentityService)],p),e.TasksSynchroniser=p;let h=class extends C.AbstractInitializer{constructor(l,d,g,v,I,i){super("tasks",d,g,v,l,I,i),this.c=this.g.defaultProfile.tasksResource}async doInitialize(l){const d=l.syncData?m(l.syncData.content,this.j):null;if(!d){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,A.VSBuffer.fromString(d)),await this.n(l)}async i(){return this.k.exists(this.c)}};h=ye([Y(0,k.IFileService),Y(1,S.IUserDataProfilesService),Y(2,D.IEnvironmentService),Y(3,b.IUserDataSyncLogService),Y(4,T.IStorageService),Y(5,P.IUriIdentityService)],h),e.TasksInitializer=h;function y(f,l,d){if(f===null&&l===null&&d===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(f===l)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const g=d!==f,v=d!==l;return!g&&!v?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:g&&!v?{content:f,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:v&&!g?{content:l,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:f,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(re[125],ae([0,1,43,16,15,13,20,19,29,18,41,256,26]),function(_,e,A,n,D,k,T,R,P,S,C,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseUserDataProfilesManifest=e.stringifyLocalProfiles=e.UserDataProfilesManifestSynchroniser=void 0;let p=class extends C.AbstractSynchroniser{constructor(l,d,g,v,I,i,r,t,s,o,c,a,u){super({syncResource:"profiles",profile:l},d,v,I,i,r,t,c,a,s,o,u),this.r=g,this.mb=1,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async getLastSyncedProfiles(){const l=await this.getLastSyncUserData();return l?.syncData?y(l.syncData):null}async getRemoteSyncedProfiles(l){const d=await this.getLastSyncUserData(),g=await this.R(l,d);return g?.syncData?y(g.syncData):null}async nb(l,d,g){if(!this.r.isEnabled())throw new m.UserDataSyncError("Cannot sync profiles because they are disabled","LocalError");const v=l.syncData?y(l.syncData):null,I=d?.syncData?y(d.syncData):null,i=this.zb(),{local:r,remote:t}=(0,b.merge)(i,v,I,[]),s={local:r,remote:t,content:I?this.Ab(I):null,localChange:r.added.length>0||r.removed.length>0||r.updated.length>0?2:0,remoteChange:t!==null?2:0},o=h(i,!1);return[{baseResource:this.baseResource,baseContent:I?this.Ab(I):null,localResource:this.localResource,localContent:o,remoteResource:this.remoteResource,remoteContent:v?this.Ab(v):null,remoteProfiles:v,previewResource:this.previewResource,previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.acceptedResource}]}async rb(l){const d=l?.syncData?y(l.syncData):null,g=this.zb(),{remote:v}=(0,b.merge)(g,d,d,[]);return!!v?.added.length||!!v?.removed.length||!!v?.updated.length}async ob(l,d){return{...l.previewResult,hasConflicts:!1}}async pb(l,d,g,v){if(this.h.isEqual(d,this.localResource))return this.wb(l);if(this.h.isEqual(d,this.remoteResource))return this.xb(l);if(this.h.isEqual(d,this.previewResource))return l.previewResult;throw new Error(`Invalid Resource: ${d.toString()}`)}async wb(l){const d=this.zb(),g=(0,b.merge)(d,null,null,[]),{local:v,remote:I}=g;return{content:l.localContent,local:v,remote:I,localChange:v.added.length>0||v.removed.length>0||v.updated.length>0?2:0,remoteChange:I!==null?2:0}}async xb(l){const d=l.remoteContent?JSON.parse(l.remoteContent):null,g=[],v=[];for(const I of this.zb()){const i=d?.find(r=>r.id===I.id);i&&(g.push({id:I.id,name:I.name,collection:i.collection}),v.push(I))}if(d!==null){const I=(0,b.merge)(v,d,g,[]),{local:i,remote:r}=I;return{content:l.remoteContent,local:i,remote:r,localChange:i.added.length>0||i.removed.length>0||i.updated.length>0?2:0,remoteChange:r!==null?2:0}}else return{content:l.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async qb(l,d,g,v){const{local:I,remote:i,localChange:r,remoteChange:t}=g[0][1];r===0&&t===0&&this.L.info(`${this.y}: No changes found during synchronizing profiles.`);const s=g[0][0].remoteProfiles||[];if(s.length+(i?.added.length??0)-(i?.removed.length??0)>20)throw new m.UserDataSyncError("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(r!==0){await this.kb(h(this.zb(),!1));const o=[];for(const c of I.added)o.push((async()=>{this.L.trace(`${this.y}: Creating '${c.name}' profile...`),await this.r.createProfile(c.id,c.name,{shortName:c.shortName}),this.L.info(`${this.y}: Created profile '${c.name}'.`)})());for(const c of I.removed)o.push((async()=>{this.L.trace(`${this.y}: Removing '${c.name}' profile...`),await this.r.removeProfile(c),this.L.info(`${this.y}: Removed profile '${c.name}'.`)})());for(const c of I.updated){const a=this.r.profiles.find(u=>u.id===c.id);a?o.push((async()=>{this.L.trace(`${this.y}: Updating '${c.name}' profile...`),await this.r.updateProfile(a,{name:c.name,shortName:c.shortName}),this.L.info(`${this.y}: Updated profile '${c.name}'.`)})()):this.L.info(`${this.y}: Could not find profile with id '${c.id}' to update.`)}await Promise.all(o)}if(t!==0){this.L.trace(`${this.y}: Updating remote profiles...`);const o=[],c=s.length+(i?.added.length??0)<=20;if(c)for(const a of i?.added||[]){const u=await this.G.createCollection(this.z);o.push(u),s.push({id:a.id,name:a.name,collection:u,shortName:a.shortName})}else this.L.info(`${this.y}: Could not create remote profiles as there are too many profiles.`);for(const a of i?.removed||[])s.splice(s.findIndex(({id:u})=>a.id===u),1);for(const a of i?.updated||[]){const u=s.find(({id:w})=>a.id===w);u&&s.splice(s.indexOf(u),1,{id:a.id,name:a.name,collection:u.collection,shortName:a.shortName})}try{l=await this.updateRemoteProfiles(s,v?null:l.ref),this.L.info(`${this.y}: Updated remote profiles.${c&&i?.added.length?` Added: ${JSON.stringify(i.added.map(a=>a.name))}.`:""}${i?.updated.length?` Updated: ${JSON.stringify(i.updated.map(a=>a.name))}.`:""}${i?.removed.length?` Removed: ${JSON.stringify(i.removed.map(a=>a.name))}.`:""}`)}catch(a){if(o.length){this.L.info(`${this.y}: Failed to update remote profiles. Cleaning up added collections...`);for(const u of o)await this.G.deleteCollection(u,this.z)}throw a}for(const a of i?.removed||[])await this.G.deleteCollection(a.collection,this.z)}d?.ref!==l.ref&&(this.L.trace(`${this.y}: Updating last synchronized profiles...`),await this.cb(l),this.L.info(`${this.y}: Updated last synchronized profiles.`))}async updateRemoteProfiles(l,d){return this.jb(this.Ab(l),d)}async hasLocalData(){return this.zb().length>0}async resolveContent(l){if(this.h.isEqual(this.remoteResource,l)||this.h.isEqual(this.baseResource,l)||this.h.isEqual(this.localResource,l)||this.h.isEqual(this.acceptedResource,l)){const d=await this.ab(l);return d&&(0,A.toFormattedString)(JSON.parse(d),{})}return null}zb(){return this.r.profiles.filter(l=>!l.isDefault&&!l.isTransient)}Ab(l){return JSON.stringify([...l].sort((d,g)=>d.name.localeCompare(g.name)))}};p=ye([Y(2,S.IUserDataProfilesService),Y(3,k.IFileService),Y(4,D.IEnvironmentService),Y(5,T.IStorageService),Y(6,m.IUserDataSyncStoreService),Y(7,m.IUserDataSyncBackupStoreService),Y(8,m.IUserDataSyncLogService),Y(9,n.IConfigurationService),Y(10,m.IUserDataSyncEnablementService),Y(11,R.ITelemetryService),Y(12,P.IUriIdentityService)],p),e.UserDataProfilesManifestSynchroniser=p;function h(f,l){const d=[...f].sort((g,v)=>g.name.localeCompare(v.name)).map(g=>({id:g.id,name:g.name}));return l?(0,A.toFormattedString)(d,{}):JSON.stringify(d)}e.stringifyLocalProfiles=h;function y(f){return JSON.parse(f.content)}e.parseUserDataProfilesManifest=y}),define(re[272],ae([0,1,6,17,65,2,22,16,15,13,18,26]),function(_,e,A,n,D,k,T,R,P,S,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let m=class extends k.Disposable{constructor(h,y,f,l,d){super(),this.a=h,this.b=y,this.c=f,this.f=l,this.g=d,this.h()}async h(){for(const y of this.g.profiles)for(const f of b.ALL_SYNC_RESOURCES)try{await this.j(this.i(y,f))}catch(l){this.f.error(l)}let h;try{h=await this.b.resolve(this.a.userDataSyncHome)}catch(y){(0,S.toFileOperationResult)(y)!==1&&this.f.error(y);return}if(h.children){for(const y of h.children)if(y.isDirectory&&!this.g.profiles.some(f=>f.id===y.name))try{this.f.info("Deleting non existing profile from backup",y.resource.path),await this.b.del(y.resource,{recursive:!0})}catch(f){this.f.error(f)}}}async getAllRefs(h,y){const f=this.i(h,y),l=await this.b.resolve(f);return l.children?l.children.filter(g=>g.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(g.name)).sort().reverse().map(g=>({ref:g.name,created:this.k(g)})):[]}async resolveContent(h,y,f){const l=this.i(h,y),d=(0,T.joinPath)(l,f);try{return(await this.b.readFile(d)).value.toString()}catch(g){return this.f.error(g),null}}async backup(h,y,f){const l=this.i(h,y),d=(0,T.joinPath)(l,`${(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(d,n.VSBuffer.fromString(f))}catch(g){this.f.error(g)}try{this.j(l)}catch{}}i(h,y){return(0,T.joinPath)(this.a.userDataSyncHome,...h.isDefault?[y]:[h.id,y])}async j(h){try{try{if(!await this.b.exists(h))return}catch{return}const y=await this.b.resolve(h);if(y.children){const f=y.children.filter(v=>v.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(v.name)).sort(),l=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let d=f.filter(v=>Date.now()-this.k(v)>l);const g=f.length-d.length;g<10&&(d=d.slice(10-g)),await A.Promises.settled(d.map(async v=>{this.f.info("Deleting from backup",v.resource.path),await this.b.del(v.resource)}))}}catch(y){this.f.error(y)}}k(h){return h.ctime||new Date(parseInt(h.name.substring(0,4)),parseInt(h.name.substring(4,6))-1,parseInt(h.name.substring(6,8)),parseInt(h.name.substring(9,11)),parseInt(h.name.substring(11,13)),parseInt(h.name.substring(13,15))).getTime()}};m=ye([Y(0,P.IEnvironmentService),Y(1,S.IFileService),Y(2,R.IConfigurationService),Y(3,b.IUserDataSyncLogService),Y(4,C.IUserDataProfilesService)],m),e.UserDataSyncBackupStoreService=m}),define(re[273],ae([0,1,3,2,5,15,20,19,26]),function(_,e,A,n,D,k,T,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const S="sync.enable";let C=class extends n.Disposable{constructor(m,p,h,y){super(),this.c=m,this.f=p,this.g=h,this.h=y,this.a=new A.Emitter,this.onDidChangeEnablement=this.a.event,this.b=new A.Emitter,this.onDidChangeResourceEnablement=this.b.event,this.B(m.onDidChangeValue(f=>this.j(f)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(S,-1,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(m){m&&!this.canToggleEnablement()||(this.f.publicLog2(S,{enabled:m}),this.c.store(S,m,-1,1))}isResourceEnabled(m){return this.c.getBoolean((0,P.getEnablementKey)(m),-1,!0)}setResourceEnablement(m,p){if(this.isResourceEnabled(m)!==p){const h=(0,P.getEnablementKey)(m);this.i(h,p)}}getResourceSyncStateVersion(m){}i(m,p){this.c.store(m,p,-1,D.isWeb?0:1)}j(m){if(m.scope!==-1)return;if(S===m.key){this.a.fire(this.isEnabled());return}const p=P.ALL_SYNC_RESOURCES.filter(h=>(0,P.getEnablementKey)(h)===m.key)[0];if(p){this.b.fire([p,this.isResourceEnabled(p)]);return}}};C=ye([Y(0,T.IStorageService),Y(1,R.ITelemetryService),Y(2,k.IEnvironmentService),Y(3,P.IUserDataSyncStoreManagementService)],C),e.UserDataSyncEnablementService=C}),define(re[81],ae([0,1,3,2,5,27,181,15,13,4,25,45,20,26]),function(_,e,A,n,D,k,T,R,P,S,C,b,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,S.createDecorator)("IUserDataSyncMachinesService");const h="sync.currentMachineName",y="Safari",f="Chrome",l="Edge",d="Firefox",g="Android";function v(r){switch(r){case y:case f:case l:case d:case g:case(0,D.PlatformToString)(0):return!0}return!1}e.isWebPlatform=v;function I(){return D.isSafari?y:D.isChrome?f:D.isEdge?l:D.isFirefox?d:D.isAndroid?g:(0,D.PlatformToString)(D.isWeb?0:D.platform)}let i=class rt extends n.Disposable{constructor(t,s,o,c,a,u){super(),this.h=o,this.i=c,this.j=a,this.k=u,this.c=this.B(new A.Emitter),this.onDidChange=this.c.event,this.g=null,this.f=(0,b.getServiceMachineId)(t,s,o)}async getMachines(t){const s=await this.f;return(await this.m(t)).machines.map(c=>({...c,isCurrent:c.id===s}))}async addCurrentMachine(t){const s=await this.f,o=await this.m(t);o.machines.some(({id:c})=>c===s)||(o.machines.push({id:s,name:this.l(o.machines),platform:I()}),await this.n(o))}async removeCurrentMachine(t){const s=await this.f,o=await this.m(t),c=o.machines.filter(({id:a})=>a!==s);c.length!==o.machines.length&&(o.machines=c,await this.n(o))}async renameMachine(t,s,o){const c=await this.m(o),a=c.machines.find(({id:u})=>u===t);if(a){a.name=s,await this.n(c);const u=await this.f;t===u&&this.h.store(h,s,-1,1)}}async setEnablements(t){const s=await this.m();for(const[o,c]of t){const a=s.machines.find(u=>u.id===o);a&&(a.disabled=c?void 0:!0)}await this.n(s)}l(t){const s=this.h.get(h,-1);if(s)return s;const o=`${this.k.embedderIdentifier?`${this.k.embedderIdentifier} - `:""}${I()} (${this.k.nameShort})`,c=new RegExp(`${(0,k.escapeRegExpCharacters)(o)}\\s#(\\d+)`);let a=0;for(const u of t){const w=c.exec(u.name),E=w?parseInt(w[1]):0;a=E>a?E:a}return`${o} #${a+1}`}async m(t){this.g=await this.p(t);const s=this.r(this.g);if(s.version!==rt.a)throw new Error((0,T.localize)(0,null,this.k.nameLong));return s}async n(t){const s=JSON.stringify(t),o=await this.i.writeResource(rt.b,s,this.g?.ref||null);this.g={ref:o,content:s},this.c.fire()}async p(t){if(this.g){const s=t&&t.latest?t.latest[rt.b]:void 0;if(this.g.ref===s)return this.g;if(s===void 0&&this.g.content===null)return this.g}return this.i.readResource(rt.b,this.g)}r(t){if(t.content!==null)try{return JSON.parse(t.content)}catch(s){this.j.error(s)}return{version:rt.a,machines:[]}}};i.a=1,i.b="machines",i=ye([Y(0,R.IEnvironmentService),Y(1,P.IFileService),Y(2,m.IStorageService),Y(3,p.IUserDataSyncStoreService),Y(4,p.IUserDataSyncLogService),Y(5,C.IProductService)],i),e.UserDataSyncMachinesService=i}),define(re[274],ae([0,1,6,65,38,7,3,2,5,22,8,179,25,20,19,26,78,81]),function(_,e,A,n,D,k,T,R,P,S,C,b,m,p,h,y,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const d="sync.disableMachineEventually",g="sync.sessionId",v="sync.storeUrl",I="sync.productQuality";let i=class extends R.Disposable{get j(){const s=this.z.get(v,-1);return s?C.URI.parse(s):void 0}set j(s){s?this.z.store(v,s.toString(),-1,1):this.z.remove(v,-1)}get l(){return this.z.get(I,-1)}set l(s){s?this.z.store(I,s,-1,1):this.z.remove(I,-1)}constructor(s,o,c,a,u,w,E,N,O,j){super(),this.n=o,this.p=c,this.r=a,this.s=u,this.u=w,this.v=E,this.w=N,this.y=O,this.z=j,this.a=this.B(new R.MutableDisposable),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new T.Emitter),this.onError=this.h.event,this.N=[],this.f=this.B(new A.ThrottledDelayer(this.O())),this.i=this.j,this.j=o.userDataSyncStore?.url,this.k=this.l,this.l=s.quality,this.j&&(this.u.info("Using settings sync service",this.j.toString()),this.B(o.onDidChangeUserDataSyncStore(()=>{(0,S.isEqual)(this.j,o.userDataSyncStore?.url)||(this.i=this.j,this.j=o.userDataSyncStore?.url,this.j&&this.u.info("Using settings sync service",this.j.toString()))})),this.r.isEnabled()?this.u.info("Auto Sync is enabled."):this.u.info("Auto Sync is disabled."),this.C(),this.L()&&this.J(),this.B(E.onDidChangeAccount(()=>this.C())),this.B(c.onDidChangeDonotMakeRequestsUntil(()=>this.C())),this.B(u.onDidChangeLocal(M=>this.triggerSync([M],!1,!1))),this.B(T.Event.filter(this.r.onDidChangeResourceEnablement,([,M])=>M)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.n.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}C(){const{enabled:s,message:o}=this.F();s?this.a.value===void 0&&(this.a.value=new r(this.i,1e3*60*5,this.n,this.p,this.s,this.y,this.u,this.z),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(c=>this.I(c))),this.D()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(o&&this.u.info(o),this.a.clear()):o&&this.r.isEnabled()&&this.u.info(o))}D(){return!0}F(){return this.r.isEnabled()?this.v.account?this.p.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,n.toLocalISOString)(this.p.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.M(),this.i=this.j,this.G(!0)}async turnOff(s,o,c){try{this.v.account&&!c&&await this.y.removeCurrentMachine(),this.G(!1),this.z.remove(g,-1),s?(this.w.publicLog2("sync/turnOffEveryWhere"),await this.s.reset()):await this.s.resetLocal()}catch(a){if(this.u.error(a),o)this.G(!1);else throw a}}G(s){this.r.isEnabled()!==s&&(this.r.setEnablement(s),this.C())}H(){return!!this.k&&!!this.l&&this.k!==this.l}async I(s){if(!s){this.b=0;return}const o=y.UserDataSyncError.toUserDataSyncError(s);o instanceof y.UserDataAutoSyncError&&this.w.publicLog2("autosync/error",{code:o.code,service:this.n.userDataSyncStore.url.toString()}),o.code==="SessionExpired"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because current session is expired")):o.code==="TurnedOff"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):o.code==="LocalTooManyRequests"?(this.g=!0,this.u.info("Auto Sync: Suspended sync because of making too many requests to server"),this.C()):o.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.J(),this.u.info("Auto Sync: Turned off sync because of making too many requests to server")):o.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):o.code==="UpgradeRequired"||o.code==="Gone"?(await this.turnOff(!1,!0,!0),this.J(),this.u.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):o.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.u.info(`Auto Sync: Turned off sync because server has ${o.resource} content with newer version than of client. Requires client upgrade.`)):o.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.u.info(`Auto Sync: Turned off sync because server has ${o.resource} content with older version than of client. Requires server reset.`)):o.code==="ServiceChanged"||o.code==="DefaultServiceChanged"?P.isWeb&&o.code==="DefaultServiceChanged"&&!this.H()?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.u.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.u.error(o),this.b++),this.h.fire(o)}async J(){this.z.store(d,!0,-1,1),await(0,A.timeout)(1e3*60*10),this.L()&&(this.M(),!this.r.isEnabled()&&this.v.account&&await this.y.removeCurrentMachine())}L(){return this.z.getBoolean(d,-1,!1)}M(){this.z.remove(d,-1)}async triggerSync(s,o,c){if(this.a.value===void 0)return this.f.cancel();if(o&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.u.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.N.push(...s),this.f.trigger(async()=>{this.u.trace("activity sources",...this.N);const a=this.v.account?.authenticationProviderId||"";this.w.publicLog2("sync/triggered",{sources:this.N,providerId:a}),this.N=[],this.a.value&&await this.a.value.sync("Activity",c)},this.b?this.O()*1*Math.min(Math.pow(2,this.b),60):this.O())}O(){return 2e3}};i=ye([Y(0,m.IProductService),Y(1,y.IUserDataSyncStoreManagementService),Y(2,y.IUserDataSyncStoreService),Y(3,y.IUserDataSyncEnablementService),Y(4,y.IUserDataSyncService),Y(5,y.IUserDataSyncLogService),Y(6,f.IUserDataSyncAccountService),Y(7,h.ITelemetryService),Y(8,l.IUserDataSyncMachinesService),Y(9,p.IStorageService)],i),e.UserDataAutoSyncService=i;class r extends R.Disposable{constructor(s,o,c,a,u,w,E,N){super(),this.j=s,this.k=o,this.l=c,this.m=a,this.n=u,this.p=w,this.r=E,this.s=N,this.b=this.B(new R.MutableDisposable),this.c=this.B(new T.Emitter),this.onDidStartSync=this.c.event,this.f=this.B(new T.Emitter),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.u())),this.B((0,R.toDisposable)(()=>{this.i&&(this.i.cancel(),this.r.info("Auto sync: Cancelled sync that is in progress"),this.i=void 0),this.h?.stop(),this.r.info("Auto Sync: Stopped")})),this.sync(r.a,!1)}u(){this.b.value=(0,A.disposableTimeout)(()=>this.sync(r.a,!1),this.k)}sync(s,o){const c=(0,A.createCancelablePromise)(async a=>{if(this.i)try{this.r.debug("Auto Sync: Waiting until sync is finished."),await this.i}catch(u){if((0,k.isCancellationError)(u))return}return this.y(s,o,a)});return this.i=c,this.i.finally(()=>this.i=void 0),this.i}v(){return this.j!==void 0&&!(0,S.isEqual)(this.j,this.l.userDataSyncStore?.url)}async w(){const s=await this.l.getPreviousUserDataSyncStore(),o=this.l.userDataSyncStore;return!!o&&!!s&&(!(0,S.isEqual)(o.defaultUrl,s.defaultUrl)||!(0,S.isEqual)(o.insidersUrl,s.insidersUrl)||!(0,S.isEqual)(o.stableUrl,s.stableUrl))}async y(s,o,c){this.r.info(`Auto Sync: Triggered by ${s}`),this.c.fire();let a;try{await this.z(o,c)}catch(u){if(this.r.error(u),a=u,y.UserDataSyncError.toUserDataSyncError(u).code==="MethodNotFound")try{this.r.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.n.cleanUpRemoteData(),this.r.info("Auto Sync: Retrying sync..."),await this.z(o,c),a=void 0}catch(w){this.r.error(w),a=w}}this.f.fire(a)}async z(s,o){if(this.h=await this.n.createSyncTask(this.g,s),o.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.n.hasPreviouslySynced())throw this.v()?await this.w()?new y.UserDataAutoSyncError((0,b.localize)(0,null),"DefaultServiceChanged"):new y.UserDataAutoSyncError((0,b.localize)(1,null),"ServiceChanged"):new y.UserDataAutoSyncError((0,b.localize)(2,null),"TurnedOff");const c=this.s.get(g,-1);if(c&&this.g&&c!==this.g.session)throw this.v()?await this.w()?new y.UserDataAutoSyncError((0,b.localize)(3,null),"DefaultServiceChanged"):new y.UserDataAutoSyncError((0,b.localize)(4,null),"ServiceChanged"):new y.UserDataAutoSyncError((0,b.localize)(5,null),"SessionExpired");const a=await this.p.getMachines(this.g||void 0);if(o.isCancellationRequested)return;const u=a.find(w=>w.isCurrent);if(u?.disabled)throw new y.UserDataAutoSyncError((0,b.localize)(6,null),"TurnedOff");if(await this.h.run(),this.g===null)try{this.g=await this.m.manifest(null)}catch(w){throw new y.UserDataAutoSyncError((0,D.toErrorMessage)(w),w instanceof y.UserDataSyncError?w.code:"Unknown")}this.g&&this.g.session!==c&&this.s.store(g,this.g.session,-1,1),!o.isCancellationRequested&&(u||await this.p.addCurrentMachine(this.g||void 0))}register(s){return super.B(s)}}r.a="Interval"}),define(re[275],ae([0,1,8,182,15,13,45,20,29,26,18,41,123,122,121,16,124,119,120,4,125,43]),function(_,e,A,n,D,k,T,R,P,S,C,b,m,p,h,y,f,l,d,g,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceProviderService=void 0;let i=class Ve{constructor(t,s,o,c,a,u,w,E,N,O){this.e=t,this.f=s,this.g=o,this.h=a,this.i=u,this.j=w,this.k=E,this.l=N,this.m=O,this.d=c.extUri}async getRemoteSyncedProfiles(){const t=await this.e.readResource("profiles",null,void 0);if(t.content){const s=this.K(t.content,"profiles");return(0,v.parseUserDataProfilesManifest)(s)}return[]}async getRemoteSyncResourceHandles(t,s){return(await this.e.getAllResourceRefs(t,s?.collection)).map(({created:c,ref:a})=>({created:c,uri:this.I({remote:!0,syncResource:t,profile:s?.id??this.k.defaultProfile.id,collection:s?.collection,ref:a,node:void 0})}))}async getLocalSyncResourceHandles(t,s){return(await this.f.getAllRefs(s,t)).map(({created:c,ref:a})=>({created:c,uri:this.I({remote:!1,syncResource:t,profile:s.id,collection:void 0,ref:a,node:void 0})}))}resolveUserDataSyncResource({uri:t}){const s=this.J(t),o=s?this.k.profiles.find(c=>c.id===s.profile):void 0;return s&&o?{profile:o,syncResource:s?.syncResource}:void 0}async getAssociatedResources({uri:t}){const s=this.J(t);if(!s)return[];const o=this.k.profiles.find(c=>c.id===s.profile);switch(s.syncResource){case"settings":return this.r(t,o);case"keybindings":return this.t(t,o);case"tasks":return this.v(t,o);case"snippets":return this.x(t,o);case"globalState":return this.C(t,o);case"extensions":return this.z(t,o);case"profiles":return this.F(t,o)}}async getMachineId({uri:t}){const s=this.J(t);if(!!s){if(s.remote){if(s.ref){const{content:o}=await this.L(s.syncResource,s.ref,s.collection);if(o)return this.K(o,s.syncResource)?.machineId}return}return(0,T.getServiceMachineId)(this.h,this.j,this.i)}}async resolveContent(t){const s=this.J(t);if(!s||s.node===Ve.a)return null;if(s.ref){const o=await this.n(s.remote,s.syncResource,s.profile,s.collection,s.ref);return s.node&&o?this.o(s.syncResource,o,s.node):o}return!s.remote&&!s.node?this.q(s.syncResource,s.profile):null}async n(t,s,o,c,a){if(t){const{content:w}=await this.L(s,a,c);return w}const u=this.k.profiles.find(w=>w.id===o);return u?this.f.resolveContent(u,s,a):null}o(t,s,o){const c=this.K(s,t);switch(t){case"settings":return this.s(c,o);case"keybindings":return this.u(c,o);case"tasks":return this.w(c,o);case"snippets":return this.y(c,o);case"globalState":return this.D(c,o);case"extensions":return this.A(c,o);case"profiles":return this.G(c,o)}}async q(t,s){const o=this.k.profiles.find(c=>c.id===s);if(!o)return null;switch(t){case"globalState":return this.E(o);case"extensions":return this.B(o);case"profiles":return this.H(o);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null}}r(t,s){const o=this.d.joinPath(t,"settings.json"),c=s?s.settingsResource:this.d.joinPath(t,Ve.a);return[{resource:o,comparableResource:c}]}s(t,s){switch(s){case"settings.json":return(0,p.parseSettingsSyncContent)(t.content).settings}return null}t(t,s){const o=this.d.joinPath(t,"keybindings.json"),c=s?s.keybindingsResource:this.d.joinPath(t,Ve.a);return[{resource:o,comparableResource:c}]}u(t,s){switch(s){case"keybindings.json":return(0,h.getKeybindingsContentFromSyncContent)(t.content,!!this.l.getValue(S.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM),this.g)}return null}v(t,s){const o=this.d.joinPath(t,"tasks.json"),c=s?s.tasksResource:this.d.joinPath(t,Ve.a);return[{resource:o,comparableResource:c}]}w(t,s){switch(s){case"tasks.json":return(0,f.getTasksContentFromSyncContent)(t.content,this.g)}return null}async x(t,s){const o=await this.resolveContent(t);if(o){const c=this.K(o,"snippets");if(c){const a=(0,m.parseSnippets)(c),u=[];for(const w of Object.keys(a)){const E=this.d.joinPath(t,w),N=s?this.d.joinPath(s.snippetsHome,w):this.d.joinPath(t,Ve.a);u.push({resource:E,comparableResource:N})}return u}}return[]}y(t,s){return(0,m.parseSnippets)(t)[s]||null}z(t,s){const o=this.d.joinPath(t,"extensions.json"),c=s?this.I({remote:!1,syncResource:"extensions",profile:s.id,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,Ve.a);return[{resource:o,comparableResource:c}]}A(t,s){switch(s){case"extensions.json":return(0,l.stringify)((0,l.parseExtensions)(t),!0)}return null}async B(t){const{localExtensions:s}=await this.m.createInstance(l.LocalExtensionsProvider).getLocalExtensions(t);return(0,l.stringify)(s,!0)}C(t,s){const o=this.d.joinPath(t,"globalState.json"),c=s?this.I({remote:!1,syncResource:"globalState",profile:s.id,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,Ve.a);return[{resource:o,comparableResource:c}]}D(t,s){switch(s){case"globalState.json":return(0,d.stringify)(JSON.parse(t.content),!0)}return null}async E(t){const s=await this.m.createInstance(d.LocalGlobalStateProvider).getLocalGlobalState(t);return(0,d.stringify)(s,!0)}F(t,s){const o=this.d.joinPath(t,"profiles.json"),c=this.I({remote:!1,syncResource:"profiles",profile:this.k.defaultProfile.id,collection:void 0,ref:void 0,node:void 0});return[{resource:o,comparableResource:c}]}G(t,s){switch(s){case"profiles.json":return(0,I.toFormattedString)(JSON.parse(t.content),{})}return null}async H(t){return(0,v.stringifyLocalProfiles)(this.k.profiles.filter(s=>!s.isDefault&&!s.isTransient),!0)}I(t){const s=t.remote?Ve.b:Ve.c,o=[t.syncResource,t.profile];return t.collection&&o.push(`collection:${t.collection}`),t.ref&&o.push(`ref:${t.ref}`),t.node&&o.push(t.node),this.d.joinPath(A.URI.from({scheme:S.USER_DATA_SYNC_SCHEME,authority:s,path:"/"}),...o)}J(t){if(t.scheme!==S.USER_DATA_SYNC_SCHEME||t.authority!==Ve.c&&t.authority!==Ve.b)return;const s=[];for(;t.path!=="/";)s.unshift(this.d.basename(t)),t=this.d.dirname(t);if(s.length<2)return;const o=t.authority===Ve.b,c=s.shift(),a=s.shift();let u,w,E;for(;s.length;){const N=s.shift();N.startsWith("collection:")?u=N.substring(11):N.startsWith("ref:")?w=N.substring(4):E=N}return{remote:o,syncResource:c,profile:a,collection:u,ref:w,node:E}}K(t,s){try{const o=JSON.parse(t);if((0,b.isSyncData)(o))return o}catch(o){this.g.error(o)}throw new S.UserDataSyncError((0,n.localize)(0,null),"IncompatibleRemoteContent",s)}async L(t,s,o){const c=await this.e.resolveResourceContent(t,s,o);return{ref:s,content:c}}};i.a="not-existing-resource",i.b="remote-backup",i.c="local-backup",i=ye([Y(0,S.IUserDataSyncStoreService),Y(1,S.IUserDataSyncBackupStoreService),Y(2,S.IUserDataSyncLogService),Y(3,P.IUriIdentityService),Y(4,D.IEnvironmentService),Y(5,R.IStorageService),Y(6,k.IFileService),Y(7,C.IUserDataProfilesService),Y(8,y.IConfigurationService),Y(9,g.IInstantiationService)],i),e.UserDataSyncResourceProviderService=i}),define(re[276],ae([0,1,21,6,23,38,3,2,22,14,31,16,30,4,20,19,18,119,120,121,122,123,124,125,26]),function(_,e,A,n,D,k,T,R,P,S,C,b,m,p,h,y,f,l,d,g,v,I,i,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const s="sync.lastSyncTime";let o=class extends R.Disposable{get status(){return this.f}get conflicts(){return this.i}get lastSyncTime(){return this.m}constructor(E,N,O,j,M,L,F,z,H){super(),this.v=E,this.w=N,this.y=O,this.z=j,this.C=M,this.D=L,this.F=F,this.G=z,this.H=H,this.f="uninitialized",this.g=this.B(new T.Emitter),this.onDidChangeStatus=this.g.event,this.h=this.B(new T.Emitter),this.onDidChangeLocal=this.h.event,this.i=[],this.j=this.B(new T.Emitter),this.onDidChangeConflicts=this.j.event,this.k=[],this.l=this.B(new T.Emitter),this.onSyncErrors=this.l.event,this.m=void 0,this.n=this.B(new T.Emitter),this.onDidChangeLastSyncTime=this.n.event,this.r=this.B(new T.Emitter),this.onDidResetLocal=this.r.event,this.t=this.B(new T.Emitter),this.onDidResetRemote=this.t.event,this.u=new Map,this.f=N.userDataSyncStore?"idle":"uninitialized",this.m=this.D.getNumber(s,-1,void 0),this.B((0,R.toDisposable)(()=>this.W()))}async createSyncTask(E,N){this.X(),this.z.info("Sync started.");const O=new Date().getTime(),j=(0,C.generateUuid)();try{const z=(0,t.createSyncHeaders)(j);N&&(z["Cache-Control"]="no-cache"),E=await this.v.manifest(E,z)}catch(z){const H=t.UserDataSyncError.toUserDataSyncError(z);throw u(H,j,this.w,this.C),H}const M=!1,L=this;let F;return{manifest:E,async run(){if(M)throw new Error("Can run a task only once");F=(0,n.createCancelablePromise)(z=>L.I(E,!1,j,z)),await F.finally(()=>F=void 0),L.z.info(`Sync done. Took ${new Date().getTime()-O}ms`),L.S()},stop(){return F?.cancel(),L.N()}}}async createManualSyncTask(){if(this.X(),this.F.isEnabled())throw new t.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");this.z.info("Sync started.");const E=new Date().getTime(),N=(0,C.generateUuid)(),O=(0,t.createSyncHeaders)(N);let j;try{j=await this.v.manifest(null,O)}catch(F){const z=t.UserDataSyncError.toUserDataSyncError(F);throw u(z,N,this.w,this.C),z}await this.resetLocal();const M=this,L=new D.CancellationTokenSource;return{id:N,async merge(){return M.I(j,!0,N,L.token)},async apply(){try{try{await M.L(j,N,L.token)}catch(F){if(t.UserDataSyncError.toUserDataSyncError(F).code==="MethodNotFound")M.z.info("Client is making invalid requests. Cleaning up data..."),await M.cleanUpRemoteData(),M.z.info("Applying manual sync again..."),await M.L(j,N,L.token);else throw F}}catch(F){throw M.z.error(F),F}M.z.info(`Sync done. Took ${new Date().getTime()-E}ms`),M.S()},async stop(){L.cancel(),await M.N(),await M.resetLocal()}}}async I(E,N,O,j){this.k=[];try{this.status!=="hasConflicts"&&this.Q("syncing");const M=this.getOrCreateActiveProfileSynchronizer(this.G.defaultProfile,void 0);this.k.push(...await this.M(M,E,N,O,j));const L=M.enabled.find(F=>F.resource==="profiles");if(L){const F=await L.getLastSyncedProfiles()||[];if(j.isCancellationRequested)return;await this.J(F,E,N,O,j)}}finally{this.l.fire(this.k)}}async J(E,N,O,j,M){for(const L of E){if(M.isCancellationRequested)return;const F=this.G.profiles.find(H=>H.id===L.id);if(!F){this.z.error(`Profile with id:${L.id} and name: ${L.name} does not exist locally to sync.`);continue}this.z.info("Syncing profile.",L.name);const z=this.getOrCreateActiveProfileSynchronizer(F,L);this.k.push(...await this.M(z,N,O,j,M))}for(const[L,F]of this.u.entries())this.G.profiles.some(z=>z.id===F[0].profile.id)||(F[1].dispose(),this.u.delete(L))}async L(E,N,O){const j=this.U();for(const H of j){if(O.isCancellationRequested)return;await H.apply(N,O)}const M=j.find(H=>H.profile.isDefault);if(!M)return;const L=M.enabled.find(H=>H.resource==="profiles");if(!L)return;const z=(await L.getRemoteSyncedProfiles(E?.latest??null)||[]).filter(H=>j.every(Q=>Q.profile.id!==H.id));z.length&&await this.J(z,E,!1,N,O)}async M(E,N,O,j,M){return(await E.sync(N,O,j,M)).map(([F,z])=>({profile:E.profile,syncResource:F,error:z}))}async N(){this.status!=="idle"&&await Promise.allSettled(this.U().map(E=>E.stop()))}async resolveContent(E){const N=await this.H.resolveContent(E);if(N)return N;for(const O of this.U())for(const j of O.enabled){const M=await j.resolveContent(E);if(M)return M}return null}async replace(E){this.X();const N=this.H.resolveUserDataSyncResource(E);if(!N)return;const O=await this.resolveContent(E.uri);!O||await this.O(N.profile,async j=>{if(N.syncResource===j.resource)return await j.replace(O),!0})}async accept(E,N,O,j){this.X(),await this.O(E.profile,async M=>{if(E.syncResource===M.resource)return await M.accept(N,O),j&&await M.apply((0,S.isBoolean)(j)?!1:j.force,(0,t.createSyncHeaders)((0,C.generateUuid)())),!0})}getRemoteProfiles(){return this.H.getRemoteSyncedProfiles()}getRemoteSyncResourceHandles(E,N){return this.H.getRemoteSyncResourceHandles(E,N)}async getLocalSyncResourceHandles(E,N){return this.H.getLocalSyncResourceHandles(E,N??this.G.defaultProfile)}async getAssociatedResources(E){return this.H.getAssociatedResources(E)}async getMachineId(E){return this.H.getMachineId(E)}async hasLocalData(){return!!await this.O(this.G.defaultProfile,async N=>{if(N.resource!=="globalState"&&await N.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.O(this.G.defaultProfile,async N=>{if(await N.hasPreviouslySynced())return!0})}async reset(){this.X(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.X();try{await this.v.clear(),this.z.info("Cleared data on server")}catch(E){this.z.error(E)}this.t.fire()}async resetLocal(){this.X(),this.m=void 0,this.D.remove(s,-1);for(const[E]of this.u.values())try{await E.resetLocal()}catch(N){this.z.error(N)}this.W(),this.r.fire(),this.z.info("Did reset the local sync state.")}async cleanUpRemoteData(){const E=await this.H.getRemoteSyncedProfiles(),N=E.map(L=>L.collection),O=await this.v.getAllCollections(),j=O.filter(L=>!N.includes(L));j.length&&(this.z.info(`Deleting ${j.length} redundant collections on server`),await Promise.allSettled(j.map(L=>this.v.deleteCollection(L))),this.z.info("Deleted redundant collections on server"));const M=E.filter(L=>O.includes(L.collection));if(M.length!==E.length){this.z.info("Updating remote profiles with invalid collections on server");const L=this.y.createInstance(r.UserDataProfilesManifestSynchroniser,this.G.defaultProfile,void 0);try{await L.updateRemoteProfiles(M,null),this.z.info("Updated remote profiles on server")}finally{L.dispose()}}}async O(E,N){const O=new R.DisposableStore;try{const j=this.u.get(E.id);if(j){const H=await this.P(j[0],N,O);return(0,S.isUndefined)(H)?null:H}if(E.isDefault){const H=O.add(this.y.createInstance(c,E,void 0)),Q=await this.P(H,N,O);return(0,S.isUndefined)(Q)?null:Q}if(this.G.isEnabled())return null;const M=O.add(this.y.createInstance(r.UserDataProfilesManifestSynchroniser,E,void 0)),L=await this.v.manifest(null),z=(await M.getRemoteSyncedProfiles(L?.latest??null)||[]).find(H=>H.id===E.id);if(z){const H=O.add(this.y.createInstance(c,E,z.collection)),Q=await this.P(H,N,O);return(0,S.isUndefined)(Q)?null:Q}return null}finally{O.dispose()}}async P(E,N,O){const j=[...E.enabled,...E.disabled.map(M=>O.add(E.createSynchronizer(M)))];for(const M of j){const L=await N(M);if(!(0,S.isUndefined)(L))return L}}Q(E){const N=this.f;this.f!==E&&(this.f=E,this.g.fire(E),N==="hasConflicts"&&this.S())}R(){const E=this.U().map(N=>N.conflicts).flat();(0,A.equals)(this.i,E,(N,O)=>N.profile.id===O.profile.id&&N.syncResource===O.syncResource&&(0,A.equals)(N.conflicts,O.conflicts,(j,M)=>(0,P.isEqual)(j.previewResource,M.previewResource)))||(this.i=E,this.j.fire(E))}S(){this.status==="idle"&&(this.m=new Date().getTime(),this.D.store(s,this.m,-1,1),this.n.fire(this.m))}getOrCreateActiveProfileSynchronizer(E,N){let O=this.u.get(E.id);if(O&&O[0].collection!==N?.collection&&(this.z.error("Profile synchronizer collection does not match with the remote sync profile collection"),O[1].dispose(),O=void 0,this.u.delete(E.id)),!O){const j=new R.DisposableStore,M=j.add(this.y.createInstance(c,E,N?.collection));j.add(M.onDidChangeStatus(L=>this.Q(L))),j.add(M.onDidChangeConflicts(L=>this.R())),j.add(M.onDidChangeLocal(L=>this.h.fire(L))),this.u.set(E.id,O=[M,j])}return O[0]}U(){const E=[];for(const[N]of this.u.values())E.push(N);return E}W(){this.u.forEach(([,E])=>E.dispose()),this.u.clear()}X(){if(!this.w.userDataSyncStore)throw new Error("Not enabled")}};o=ye([Y(0,t.IUserDataSyncStoreService),Y(1,t.IUserDataSyncStoreManagementService),Y(2,p.IInstantiationService),Y(3,t.IUserDataSyncLogService),Y(4,y.ITelemetryService),Y(5,h.IStorageService),Y(6,t.IUserDataSyncEnablementService),Y(7,f.IUserDataProfilesService),Y(8,t.IUserDataSyncResourceProviderService)],o),e.UserDataSyncService=o;let c=class extends R.Disposable{get enabled(){return this.f.sort((E,N)=>E[1]-N[1]).map(([E])=>E)}get disabled(){return t.ALL_SYNC_RESOURCES.filter(E=>!this.l.isResourceEnabled(E))}get status(){return this.g}get conflicts(){return this.j}constructor(E,N,O,j,M,L,F,z,H,Q){super(),this.profile=E,this.collection=N,this.l=O,this.m=j,this.n=M,this.r=L,this.t=F,this.u=z,this.v=H,this.w=Q,this.f=[],this.g="idle",this.h=this.B(new T.Emitter),this.onDidChangeStatus=this.h.event,this.i=this.B(new T.Emitter),this.onDidChangeLocal=this.i.event,this.j=[],this.k=this.B(new T.Emitter),this.onDidChangeConflicts=this.k.event,this.B(O.onDidChangeResourceEnablement(([K,V])=>this.y(K,V))),this.B((0,R.toDisposable)(()=>this.f.splice(0,this.f.length).forEach(([,,K])=>K.dispose())));for(const K of t.ALL_SYNC_RESOURCES)O.isResourceEnabled(K)&&this.z(K)}y(E,N){N?this.z(E):this.C(E)}z(E){if(this.f.some(([M])=>M.resource===E))return;if(E==="extensions"&&!this.n.isEnabled()){this.u.info("Skipping extensions sync because gallery is not configured");return}if(E==="profiles"&&(!this.profile.isDefault||!this.v.isEnabled()))return;const N=new R.DisposableStore,O=N.add(this.createSynchronizer(E));N.add(O.onDidChangeStatus(()=>this.G())),N.add(O.onDidChangeConflicts(()=>this.H())),N.add(O.onDidChangeLocal(()=>this.i.fire(E)));const j=this.I(E);this.f.push([O,j,N])}C(E){const N=this.f.findIndex(([O])=>O.resource===E);if(N!==-1){const[[O,,j]]=this.f.splice(N,1);j.dispose(),this.G(),Promise.allSettled([O.stop(),O.resetLocal()]).then(null,M=>this.u.error(M))}}createSynchronizer(E){switch(E){case"settings":return this.m.createInstance(v.SettingsSynchroniser,this.profile,this.collection);case"keybindings":return this.m.createInstance(g.KeybindingsSynchroniser,this.profile,this.collection);case"snippets":return this.m.createInstance(I.SnippetsSynchroniser,this.profile,this.collection);case"tasks":return this.m.createInstance(i.TasksSynchroniser,this.profile,this.collection);case"globalState":return this.m.createInstance(d.GlobalStateSynchroniser,this.profile,this.collection);case"extensions":return this.m.createInstance(l.ExtensionsSynchroniser,this.profile,this.collection);case"profiles":return this.m.createInstance(r.UserDataProfilesManifestSynchroniser,this.profile,this.collection)}}async sync(E,N,O,j){if(j.isCancellationRequested)return[];const M=this.enabled;if(!M.length)return[];try{const L=[],F=(0,t.createSyncHeaders)(O),z=(this.collection?E?.collections?.[this.collection]?.latest:E?.latest)??null,H=N?await this.D(z):{};for(const Q of M){if(j.isCancellationRequested)return[];if(!this.l.isResourceEnabled(Q.resource))return[];try{if(N){const K=await Q.preview(z,H,F);if(K)for(const V of K.resourcePreviews)(V.localChange!==0||V.remoteChange!==0)&&V.mergeState==="preview"&&await Q.merge(V.previewResource)}else await Q.sync(z,F)}catch(K){const V=t.UserDataSyncError.toUserDataSyncError(K);if(u(V,O,this.r,this.t),a(K))throw V;this.u.error(K),this.u.error(`${Q.resource}: ${(0,k.toErrorMessage)(K)}`),L.push([Q.resource,V])}}return L}finally{this.G()}}async apply(E,N){const O=(0,t.createSyncHeaders)(E);for(const j of this.enabled){if(N.isCancellationRequested)return;try{await j.apply(!1,O)}catch(M){const L=t.UserDataSyncError.toUserDataSyncError(M);if(u(L,E,this.r,this.t),a(M))throw L;this.u.error(M),this.u.error(`${j.resource}: ${(0,k.toErrorMessage)(M)}`)}}}async stop(){for(const E of this.enabled)try{E.status!=="idle"&&await E.stop()}catch(N){this.u.error(N)}}async resetLocal(){for(const E of this.enabled)try{await E.resetLocal()}catch(N){this.u.error(`${E.resource}: ${(0,k.toErrorMessage)(N)}`),this.u.error(N)}}async D(E){if(!this.profile.isDefault)return{};const N=this.w.getValue(t.USER_DATA_SYNC_CONFIGURATION_SCOPE),O=this.enabled.find(j=>j instanceof v.SettingsSynchroniser);if(O){const j=await O.getRemoteUserDataSyncConfiguration(E);return{...N,...j}}return N}F(E){this.g!==E&&(this.g=E,this.h.fire(E))}G(){return this.H(),this.enabled.some(E=>E.status==="hasConflicts")?this.F("hasConflicts"):this.enabled.some(E=>E.status==="syncing")?this.F("syncing"):this.F("idle")}H(){const E=this.enabled.filter(N=>N.status==="hasConflicts").filter(N=>N.conflicts.conflicts.length>0).map(N=>N.conflicts);(0,A.equals)(this.j,E,(N,O)=>N.syncResource===O.syncResource&&(0,A.equals)(N.conflicts,O.conflicts,(j,M)=>(0,P.isEqual)(j.previewResource,M.previewResource)))||(this.j=E,this.k.fire(E))}I(E){switch(E){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6}}};c=ye([Y(2,t.IUserDataSyncEnablementService),Y(3,p.IInstantiationService),Y(4,m.IExtensionGalleryService),Y(5,t.IUserDataSyncStoreManagementService),Y(6,y.ITelemetryService),Y(7,t.IUserDataSyncLogService),Y(8,f.IUserDataProfilesService),Y(9,b.IConfigurationService)],c);function a(w){if(w instanceof t.UserDataSyncError)switch(w.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function u(w,E,N,O){O.publicLog2("sync/error",{code:w.code,serverCode:w instanceof t.UserDataSyncStoreError?String(w.serverCode):void 0,url:w instanceof t.UserDataSyncStoreError?w.url:void 0,resource:w.resource,executionId:E,service:N.userDataSyncStore.url.toString()})}}),define(re[277],ae([0,1,3,2,8,18,26]),function(_,e,A,n,D,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;function R(m,p){return{...m,profile:(0,k.reviveProfile)(m.profile,p.profilesHome.scheme)}}function P(m){return{created:m.created,uri:D.URI.revive(m.uri)}}class S{constructor(p,h,y){this.c=p,this.d=h,this.f=y,this.a=new Map,this.b=new A.Emitter}listen(p,h){switch(h){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`Event not found: ${h}`)}async call(p,h,y){try{return await this.g(p,h,y)}catch(f){throw this.f.error(f),f}}async g(p,h,y){switch(h){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(D.URI.revive(y[0]));case"accept":return this.c.accept(R(y[0],this.d),D.URI.revive(y[1]),y[2],y[3]);case"getRemoteProfiles":return this.c.getRemoteProfiles();case"getLocalSyncResourceHandles":return this.c.getLocalSyncResourceHandles(y[0],(0,k.reviveProfile)(y[1],this.d.profilesHome.scheme));case"getRemoteSyncResourceHandles":return this.c.getRemoteSyncResourceHandles(y[0],y[1]);case"replace":return this.c.replace(P(y[0]));case"getAssociatedResources":return this.c.getAssociatedResources(P(y[0]));case"getMachineId":return this.c.getMachineId(P(y[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"createManualSyncTask":return this.i()}if(h.startsWith("manualSync/")){const f=h.substring(11),l=y[0],d=this.h(l);switch(y=y.slice(1),f){case"merge":return d.merge();case"apply":return d.apply().then(()=>this.a.delete(this.j(d.id)));case"stop":return d.stop().finally(()=>this.a.delete(this.j(d.id)))}}throw new Error("Invalid call")}h(p){const h=this.a.get(this.j(p));if(!h)throw new Error(`Manual sync taks not found: ${p}`);return h}async i(){const p=await this.c.createManualSyncTask();return this.a.set(this.j(p.id),p),p.id}j(p){return`manualSyncTask-${p}`}}e.UserDataSyncChannel=S;let C=class extends n.Disposable{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(p,h){super(),this.k=h,this.b="uninitialized",this.c=this.B(new A.Emitter),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new A.Emitter),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.i=this.B(new A.Emitter),this.onDidChangeLastSyncTime=this.i.event,this.j=this.B(new A.Emitter),this.onSyncErrors=this.j.event,this.a={call(y,f,l){return p.call(y,f,l).then(null,d=>{throw T.UserDataSyncError.toUserDataSyncError(d)})},listen(y,f){return p.listen(y,f)}},this.a.call("_getInitialData").then(([y,f,l])=>{this.l(y),this.m(f),l&&this.n(l),this.B(this.a.listen("onDidChangeStatus")(d=>this.l(d))),this.B(this.a.listen("onDidChangeLastSyncTime")(d=>this.n(d)))}),this.B(this.a.listen("onDidChangeConflicts")(y=>this.m(y))),this.B(this.a.listen("onSyncErrors")(y=>this.j.fire(y.map(f=>({...f,error:T.UserDataSyncError.toUserDataSyncError(f.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const p=await this.a.call("createManualSyncTask"),h=this;return new b(p,{async call(f,l,d){return h.a.call(`manualSync/${f}`,[p,...Array.isArray(l)?l:[l]],d)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(p,h,y,f){return this.a.call("accept",[p,h,y,f])}resolveContent(p){return this.a.call("resolveContent",[p])}getRemoteProfiles(){return this.a.call("getRemoteProfiles")}async getLocalSyncResourceHandles(p,h){return(await this.a.call("getLocalSyncResourceHandles",[p,h])).map(({created:f,uri:l})=>({created:f,uri:D.URI.revive(l)}))}async getRemoteSyncResourceHandles(p,h){return(await this.a.call("getRemoteSyncResourceHandles",[p,h])).map(({created:f,uri:l})=>({created:f,uri:D.URI.revive(l)}))}async getAssociatedResources(p){return(await this.a.call("getAssociatedResources",[p])).map(({resource:y,comparableResource:f})=>({resource:D.URI.revive(y),comparableResource:D.URI.revive(f)}))}getMachineId(p){return this.a.call("getMachineId",[p])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(p){return this.a.call("replace",[p])}async l(p){this.b=p,this.c.fire(p)}async m(p){this.f=p.map(h=>({syncResource:h.syncResource,profile:(0,k.reviveProfile)(h.profile,this.k.profilesHome.scheme),conflicts:h.conflicts.map(y=>({...y,baseResource:D.URI.revive(y.baseResource),localResource:D.URI.revive(y.localResource),remoteResource:D.URI.revive(y.remoteResource),previewResource:D.URI.revive(y.previewResource)}))})),this.g.fire(this.f)}n(p){this.h!==p&&(this.h=p,this.i.fire(p))}};C=ye([Y(1,k.IUserDataProfilesService)],C),e.UserDataSyncChannelClient=C;class b extends n.Disposable{constructor(p,h){super(),this.id=p,this.a=h}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose")}}}),define(re[278],ae([0,1,6,23,7,3,2,141,5,22,14,8,31,16,15,13,25,60,45,20,26]),function(_,e,A,n,D,k,T,R,P,S,C,b,m,p,h,y,f,l,d,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const I="sync.previous.store",i="sync.donot-make-requests-until",r="sync.user-session-id",t="sync.machine-session-id",s=100,o=1e3*60*5;let c=class extends T.Disposable{get userDataSyncStore(){return this.b}get c(){return this.h.get(v.SYNC_SERVICE_URL_TYPE,-1)}set c(O){this.h.store(v.SYNC_SERVICE_URL_TYPE,O,-1,P.isWeb?0:1)}constructor(O,j,M){super(),this.f=O,this.g=j,this.h=M,this.a=this.B(new k.Emitter),this.onDidChangeUserDataSyncStore=this.a.event,this.i(),this.B(k.Event.filter(M.onDidChangeValue,L=>L.key===v.SYNC_SERVICE_URL_TYPE&&L.scope===-1&&this.c!==this.userDataSyncStore?.type)(()=>this.i()))}i(){this.b=this.j(this.f[v.CONFIGURATION_SYNC_STORE_KEY],this.g.getValue(v.CONFIGURATION_SYNC_STORE_KEY)),this.a.fire()}j(O,j){O=P.isWeb&&O?.web?{...O,...O.web}:O;const M={...O||{},...j||{}};if(M&&(0,C.isString)(M.url)&&(0,C.isObject)(M.authenticationProviders)&&Object.keys(M.authenticationProviders).every(L=>Array.isArray(M.authenticationProviders[L].scopes))){const L=M,F=!!L.canSwitch&&!j?.url,z=L.url===L.insidersUrl?"insiders":"stable",H=(F?this.c:void 0)||z,Q=j?.url||(H==="insiders"?L.insidersUrl:H==="stable"?L.stableUrl:L.url);return{url:b.URI.parse(Q),type:H,defaultType:z,defaultUrl:b.URI.parse(L.url),stableUrl:b.URI.parse(L.stableUrl),insidersUrl:b.URI.parse(L.insidersUrl),canSwitch:F,authenticationProviders:Object.keys(L.authenticationProviders).reduce((K,V)=>(K.push({id:V,scopes:L.authenticationProviders[V].scopes}),K),[])}}}};c=ye([Y(0,f.IProductService),Y(1,p.IConfigurationService),Y(2,g.IStorageService)],c),e.AbstractUserDataSyncStoreManagementService=c;let a=class extends c{constructor(O,j,M){super(O,j,M);const L=this.h.get(I,-1);L&&(this.k=JSON.parse(L));const F=this.f[v.CONFIGURATION_SYNC_STORE_KEY];F?this.h.store(I,JSON.stringify(F),-1,1):this.h.remove(I,-1)}async switch(O){O!==this.c&&(this.c=O,this.i())}async getPreviousUserDataSyncStore(){return this.j(this.k)}};a=ye([Y(0,f.IProductService),Y(1,p.IConfigurationService),Y(2,g.IStorageService)],a),e.UserDataSyncStoreManagementService=a;let u=class extends T.Disposable{get donotMakeRequestsUntil(){return this.i}constructor(O,j,M,L,F,z,H){super(),this.k=M,this.l=L,this.n=H,this.g=this.B(new k.Emitter),this.onTokenFailed=this.g.event,this.h=this.B(new k.Emitter),this.onTokenSucceed=this.h.event,this.i=void 0,this.j=this.B(new k.Emitter),this.onDidChangeDonotMakeRequestsUntil=this.j.event,this.s=void 0,this.p(O),this.c=(0,d.getServiceMachineId)(F,z,H).then(Q=>{const K={"X-Client-Name":`${j.applicationName}${P.isWeb?"-web":""}`,"X-Client-Version":j.version};return j.commit&&(K["X-Client-Commit"]=j.commit),K}),this.f=new E(s,o,this.k,this.l),this.r(),this.B((0,T.toDisposable)(()=>{this.s&&(this.s.cancel(),this.s=void 0)}))}setAuthToken(O,j){this.b={token:O,type:j}}p(O){this.a=O?(0,S.joinPath)(O,"v1"):void 0}r(){const O=this.n.getNumber(i,-1);O&&Date.now()<O&&this.t(new Date(O))}t(O){this.i?.getTime()!==O?.getTime()&&(this.i=O,this.s&&(this.s.cancel(),this.s=void 0),this.i?(this.n.store(i,this.i.getTime(),-1,1),this.s=(0,A.createCancelablePromise)(j=>(0,A.timeout)(this.i.getTime()-Date.now(),j).then(()=>this.t(void 0))),this.s.then(null,j=>null)):this.n.remove(i,-1),this.j.fire())}async getAllCollections(O={}){if(!this.a)throw new Error("No settings sync store url configured.");const j=(0,S.joinPath)(this.a,"collection").toString();O={...O},O["Content-Type"]="application/json";const M=await this.w(j,{type:"GET",headers:O},[],n.CancellationToken.None);return(await(0,l.asJson)(M))?.map(({id:L})=>L)||[]}async createCollection(O={}){if(!this.a)throw new Error("No settings sync store url configured.");const j=(0,S.joinPath)(this.a,"collection").toString();O={...O},O["Content-Type"]=R.Mimes.text;const M=await this.w(j,{type:"POST",headers:O},[],n.CancellationToken.None),L=await(0,l.asTextOrError)(M);if(!L)throw new v.UserDataSyncStoreError("Server did not return the collection id",j,"NoCollection",M.res.statusCode,M.res.headers[v.HEADER_OPERATION_ID]);return L}async deleteCollection(O,j={}){if(!this.a)throw new Error("No settings sync store url configured.");const M=O?(0,S.joinPath)(this.a,"collection",O).toString():(0,S.joinPath)(this.a,"collection").toString();j={...j},await this.w(M,{type:"DELETE",headers:j},[],n.CancellationToken.None)}async getAllResourceRefs(O,j){if(!this.a)throw new Error("No settings sync store url configured.");const M=this.u(this.a,j,O),L={},F=await this.w(M.toString(),{type:"GET",headers:L},[],n.CancellationToken.None);return(await(0,l.asJson)(F)||[]).map(({url:H,created:Q})=>({ref:(0,S.relativePath)(M,M.with({path:H})),created:Q*1e3}))}async resolveResourceContent(O,j,M,L={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,S.joinPath)(this.u(this.a,M,O),j).toString();L={...L},L["Cache-Control"]="no-cache";const z=await this.w(F,{type:"GET",headers:L},[],n.CancellationToken.None);return await(0,l.asTextOrError)(z)}async deleteResource(O,j,M){if(!this.a)throw new Error("No settings sync store url configured.");const L=j!==null?(0,S.joinPath)(this.u(this.a,M,O),j).toString():this.u(this.a,M,O).toString(),F={};await this.w(L,{type:"DELETE",headers:F},[],n.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const O=(0,S.joinPath)(this.a,"resource").toString(),j={"Content-Type":R.Mimes.text};await this.w(O,{type:"DELETE",headers:j},[],n.CancellationToken.None)}async readResource(O,j,M,L={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,S.joinPath)(this.u(this.a,M,O),"latest").toString();L={...L},L["Cache-Control"]="no-cache",j&&(L["If-None-Match"]=j.ref);const z=await this.w(F,{type:"GET",headers:L},[304],n.CancellationToken.None);let H=null;if(z.res.statusCode===304&&(H=j),H===null){const Q=z.res.headers.etag;if(!Q)throw new v.UserDataSyncStoreError("Server did not return the ref",F,"NoRef",z.res.statusCode,z.res.headers[v.HEADER_OPERATION_ID]);const K=await(0,l.asTextOrError)(z);if(!K&&z.res.statusCode===304)throw new v.UserDataSyncStoreError("Empty response",F,"EmptyResponse",z.res.statusCode,z.res.headers[v.HEADER_OPERATION_ID]);H={ref:Q,content:K}}return H}async writeResource(O,j,M,L,F={}){if(!this.a)throw new Error("No settings sync store url configured.");const z=this.u(this.a,L,O).toString();F={...F},F["Content-Type"]=R.Mimes.text,M&&(F["If-Match"]=M);const H=await this.w(z,{type:"POST",data:j,headers:F},[],n.CancellationToken.None),Q=H.res.headers.etag;if(!Q)throw new v.UserDataSyncStoreError("Server did not return the ref",z,"NoRef",H.res.statusCode,H.res.headers[v.HEADER_OPERATION_ID]);return Q}async manifest(O,j={}){if(!this.a)throw new Error("No settings sync store url configured.");const M=(0,S.joinPath)(this.a,"manifest").toString();j={...j},j["Content-Type"]="application/json",O&&(j["If-None-Match"]=O.ref);const L=await this.w(M,{type:"GET",headers:j},[304],n.CancellationToken.None);let F=null;if(L.res.statusCode===304&&(F=O),!F){const H=L.res.headers.etag;if(!H)throw new v.UserDataSyncStoreError("Server did not return the ref",M,"NoRef",L.res.statusCode,L.res.headers[v.HEADER_OPERATION_ID]);const Q=await(0,l.asTextOrError)(L);if(!Q&&L.res.statusCode===304)throw new v.UserDataSyncStoreError("Empty response",M,"EmptyResponse",L.res.statusCode,L.res.headers[v.HEADER_OPERATION_ID]);Q&&(F={...JSON.parse(Q),ref:H})}const z=this.n.get(r,-1);return z&&F&&z!==F.session&&this.v(),F===null&&z&&this.v(),F&&this.n.store(r,F.session,-1,1),F}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.v()}u(O,j,M){return j?(0,S.joinPath)(O,"collection",j,"resource",M):(0,S.joinPath)(O,"resource",M)}v(){this.n.remove(r,-1),this.n.remove(t,-1)}async w(O,j,M,L){if(!this.b)throw new v.UserDataSyncStoreError("No Auth Token Available",O,"Unauthorized",void 0,void 0);if(this.i&&Date.now()<this.i.getTime())throw new v.UserDataSyncStoreError(`${j.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",void 0,void 0);this.t(void 0);const F=await this.c;j.headers={...j.headers||{},...F,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.y(j.headers),this.l.trace("Sending request to server",{url:O,type:j.type,headers:{...j.headers,authorization:void 0}});let z;try{z=await this.f.request(O,j,L)}catch(W){if(!(W instanceof v.UserDataSyncStoreError)){let G="RequestFailed";const X=(0,D.getErrorMessage)(W).toLowerCase();X.includes("xhr timeout")?G="RequestTimeout":X.includes("protocol")&&X.includes("not supported")?G="RequestProtocolNotSupported":X.includes("request path contains unescaped characters")?G="RequestPathNotEscaped":X.includes("headers must be an object")?G="RequestHeadersNotObject":(0,D.isCancellationError)(W)&&(G="RequestCanceled"),W=new v.UserDataSyncStoreError(`Connection refused for the request '${O}'.`,O,G,void 0,void 0)}throw this.l.info("Request failed",O),W}const H=z.res.headers[v.HEADER_OPERATION_ID],Q={url:O,status:z.res.statusCode,"execution-id":j.headers[v.HEADER_EXECUTION_ID],"operation-id":H},K=(0,l.isSuccess)(z)||z.res.statusCode&&M.indexOf(z.res.statusCode)!==-1;let V="";if(K?this.l.trace("Request succeeded",Q):(this.l.info("Request failed",Q),V=await(0,l.asText)(z)||""),z.res.statusCode===401)throw this.b=void 0,this.g.fire(),new v.UserDataSyncStoreError(`Request '${O}' failed because of Unauthorized (401).`,O,"Unauthorized",z.res.statusCode,H);if(this.h.fire(),z.res.statusCode===404)throw new v.UserDataSyncStoreError(`${j.type} request '${O}' failed because the requested resource is not found (404).`,O,"NotFound",z.res.statusCode,H);if(z.res.statusCode===405)throw new v.UserDataSyncStoreError(`${j.type} request '${O}' failed because the requested endpoint is not found (405). ${V}`,O,"MethodNotFound",z.res.statusCode,H);if(z.res.statusCode===409)throw new v.UserDataSyncStoreError(`${j.type} request '${O}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,O,"Conflict",z.res.statusCode,H);if(z.res.statusCode===410)throw new v.UserDataSyncStoreError(`${j.type} request '${O}' failed because the requested resource is not longer available (410).`,O,"Gone",z.res.statusCode,H);if(z.res.statusCode===412)throw new v.UserDataSyncStoreError(`${j.type} request '${O}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,O,"PreconditionFailed",z.res.statusCode,H);if(z.res.statusCode===413)throw new v.UserDataSyncStoreError(`${j.type} request '${O}' failed because of too large payload (413).`,O,"TooLarge",z.res.statusCode,H);if(z.res.statusCode===426)throw new v.UserDataSyncStoreError(`${j.type} request '${O}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,O,"UpgradeRequired",z.res.statusCode,H);if(z.res.statusCode===429){const W=z.res.headers["retry-after"];throw W?(this.t(new Date(Date.now()+parseInt(W)*1e3)),new v.UserDataSyncStoreError(`${j.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",z.res.statusCode,H)):new v.UserDataSyncStoreError(`${j.type} request '${O}' failed because of too many requests (429).`,O,"RemoteTooManyRequests",z.res.statusCode,H)}if(!K)throw new v.UserDataSyncStoreError("Server returned "+z.res.statusCode,O,"Unknown",z.res.statusCode,H);return z}y(O){let j=this.n.get(t,-1);j===void 0&&(j=(0,m.generateUuid)(),this.n.store(t,j,-1,1)),O["X-Machine-Session-Id"]=j;const M=this.n.get(r,-1);M!==void 0&&(O["X-User-Session-Id"]=M)}};u=ye([Y(1,f.IProductService),Y(2,l.IRequestService),Y(3,v.IUserDataSyncLogService),Y(4,h.IEnvironmentService),Y(5,y.IFileService),Y(6,g.IStorageService)],u),e.UserDataSyncStoreClient=u;let w=class extends u{constructor(O,j,M,L,F,z,H){super(O.userDataSyncStore?.url,j,M,L,F,z,H),this.B(O.onDidChangeUserDataSyncStore(()=>this.p(O.userDataSyncStore?.url)))}};w=ye([Y(0,v.IUserDataSyncStoreManagementService),Y(1,f.IProductService),Y(2,l.IRequestService),Y(3,v.IUserDataSyncLogService),Y(4,h.IEnvironmentService),Y(5,y.IFileService),Y(6,g.IStorageService)],w),e.UserDataSyncStoreService=w;class E{constructor(O,j,M,L){this.c=O,this.d=j,this.f=M,this.g=L,this.a=[],this.b=void 0}request(O,j,M){if(this.h()&&this.i(),j.url=O,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new v.UserDataSyncStoreError(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,O,"LocalTooManyRequests",void 0,void 0);return this.b=this.b||new Date,this.a.push(O),this.f.request(j,M)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.RequestsSession=E}),define(re[279],ae([0,1,3,58,25,20,19,274,26,78,81]),function(_,e,A,n,D,k,T,R,P,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let b=class extends R.UserDataAutoSyncService{constructor(p,h,y,f,l,d,g,v,I,i,r){super(p,h,y,f,l,g,v,I,i,r),this.B(A.Event.debounce(A.Event.any(A.Event.map(d.onDidFocusWindow,()=>"windowFocus"),A.Event.map(d.onDidOpenWindow,()=>"windowOpen")),(t,s)=>t?[...t,s]:[s],1e3)(t=>this.triggerSync(t,!0,!1)))}};b=ye([Y(0,D.IProductService),Y(1,P.IUserDataSyncStoreManagementService),Y(2,P.IUserDataSyncStoreService),Y(3,P.IUserDataSyncEnablementService),Y(4,P.IUserDataSyncService),Y(5,n.INativeHostService),Y(6,P.IUserDataSyncLogService),Y(7,S.IUserDataSyncAccountService),Y(8,T.ITelemetryService),Y(9,C.IUserDataSyncMachinesService),Y(10,k.IStorageService)],b),e.UserDataAutoSyncService=b}),define(re[280],ae([0,1,100,24,5,22]),function(_,e,A,n,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function T(S){function C(){let b=S.scheme===n.Schemas.file?(0,k.originalFSPath)(S):S.toString();return D.isLinux||(b=b.toLowerCase()),(0,A.createHash)("md5").update(b).digest("hex")}return{id:C(),configPath:S}}e.getWorkspaceIdentifier=T;function R(S,C){function b(){if(S.scheme!==n.Schemas.file)return(0,A.createHash)("md5").update(S.toString()).digest("hex");if(!C)return;let p;return D.isLinux?p=C.ino:D.isMacintosh?p=C.birthtime.getTime():D.isWindows&&(typeof C.birthtimeMs=="number"?p=Math.floor(C.birthtimeMs):p=C.birthtime.getTime()),(0,A.createHash)("md5").update(S.fsPath).update(p?String(p):"").digest("hex")}const m=b();if(typeof m=="string")return{id:m,uri:S}}e.getSingleFolderWorkspaceIdentifier=R;function P(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=P}),define(re[281],ae([0,1,6,7,2,12,28,15,57,9,58,76,117,280]),function(_,e,A,n,D,k,T,R,P,S,C,b,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UnusedWorkspaceStorageDataCleaner=void 0;let h=class extends D.Disposable{constructor(f,l,d,g){super(),this.a=f,this.b=l,this.c=d,this.f=g,this.B(new A.RunOnceScheduler(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const f=await T.Promises.readdir(this.a.workspaceStorageHome.fsPath),l=new b.StorageClient(this.f.getChannel("storage"));await Promise.all(f.map(async d=>{const g=(0,k.join)(this.a.workspaceStorageHome.fsPath,d);d.length===p.NON_EMPTY_WORKSPACE_ID_LENGTH||d===m.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE.id||(await this.c.getWindows()).some(i=>i.workspace?.id===d)||await l.isUsed(g)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${d} as it seems to be an unused empty workspace.`),await T.Promises.rm(g))}))}catch(f){(0,n.onUnexpectedError)(f)}}};h=ye([Y(0,R.INativeEnvironmentService),Y(1,S.ILogService),Y(2,C.INativeHostService),Y(3,P.IMainProcessService)],h),e.UnusedWorkspaceStorageDataCleaner=h}),define(re[126],ae([0,1,53,6,12,14,28,152,290,291]),function(_,e,A,n,D,k,T,R,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class C extends Error{constructor(i,r){let t=r.message;switch(i){case"CorruptZip":t=`Corrupt ZIP: ${t}`;break}super(t),this.type=i,this.cause=r}}e.ExtractError=C;function b(I){const i=I.externalFileAttributes>>16||33188;return[448,56,7].map(r=>i&r).reduce((r,t)=>r+t,i&61440)}function m(I){if(I instanceof C)return I;let i;return/end of central directory record signature not found/.test(I.message)&&(i="CorruptZip"),new C(i,I)}function p(I,i,r,t,s,o){const c=D.dirname(i),a=D.join(t,c);if(!a.startsWith(t))return Promise.reject(new Error(R.localize(0,null,i)));const u=D.join(t,i);let w;return o.onCancellationRequested(()=>{w?.destroy()}),Promise.resolve(T.Promises.mkdir(a,{recursive:!0})).then(()=>new Promise((E,N)=>{if(!o.isCancellationRequested)try{w=(0,A.createWriteStream)(u,{mode:r}),w.once("close",()=>E()),w.once("error",N),I.once("error",N),I.pipe(w)}catch(O){N(O)}}))}function h(I,i,r,t){let s=(0,n.createCancelablePromise)(()=>Promise.resolve()),o=0;return t.onCancellationRequested(()=>{s.cancel(),I.close()}),new Promise((c,a)=>{const u=new n.Sequencer,w=E=>{E.isCancellationRequested||(o++,I.readEntry())};I.once("error",a),I.once("close",()=>s.then(()=>{t.isCancellationRequested||I.entryCount===o?c():a(new C("Incomplete",new Error(R.localize(1,null,o,I.entryCount))))},a)),I.readEntry(),I.on("entry",E=>{if(t.isCancellationRequested)return;if(!r.sourcePathRegex.test(E.fileName)){w(t);return}const N=E.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(N)){const M=D.join(i,N);s=(0,n.createCancelablePromise)(L=>T.Promises.mkdir(M,{recursive:!0}).then(()=>w(L)).then(void 0,a));return}const O=f(I,E),j=b(E);s=(0,n.createCancelablePromise)(M=>u.queue(()=>O.then(L=>p(L,N,j,i,r,M).then(()=>w(M)))).then(null,a))})})}function y(I,i=!1){return new Promise((r,t)=>{(0,P.open)(I,i?{lazyEntries:!0}:void 0,(s,o)=>{s?t(m(s)):r((0,k.assertIsDefined)(o))})})}function f(I,i){return new Promise((r,t)=>{I.openReadStream(i,(s,o)=>{s?t(m(s)):r((0,k.assertIsDefined)(o))})})}function l(I,i){return new Promise((r,t)=>{const s=new S.ZipFile;i.forEach(c=>{c.contents?s.addBuffer(typeof c.contents=="string"?Buffer.from(c.contents,"utf8"):c.contents,c.path):c.localPath&&s.addFile(c.localPath,c.path)}),s.end();const o=(0,A.createWriteStream)(I);s.outputStream.pipe(o),s.outputStream.once("error",t),o.once("error",t),o.once("finish",()=>r(I))})}e.zip=l;function d(I,i,r={},t){const s=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let o=y(I,!0);return r.overwrite&&(o=o.then(c=>T.Promises.rm(i).then(()=>c))),o.then(c=>h(c,i,{sourcePathRegex:s},t))}e.extract=d;function g(I,i){return y(I).then(r=>new Promise((t,s)=>{r.on("entry",o=>{o.fileName===i&&f(r,o).then(c=>t(c),c=>s(c))}),r.once("close",()=>s(new Error(R.localize(2,null,i))))}))}function v(I,i){return g(I,i).then(r=>new Promise((t,s)=>{const o=[];r.once("error",s),r.on("data",c=>o.push(c)),r.on("end",()=>t(Buffer.concat(o)))}))}e.buffer=v}),define(re[282],ae([0,1,126,162]),function(_,e,A,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function D(k){return(0,A.buffer)(k,"extension/package.json").then(T=>{try{return JSON.parse(T.toString("utf8"))}catch{throw new Error((0,n.localize)(0,null))}})}e.getManifest=D}),define(re[127],ae([0,1,6,23,38,7,3,2,37,24,12,5,22,54,14,8,31,28,126,161,97,15,263,30,33,51,79,234,265,282,218,235,42,70,13,4,9,25,19,29,18]),function(_,e,A,n,D,k,T,R,P,S,C,b,m,p,h,y,f,l,d,g,v,I,i,r,t,s,o,c,a,u,w,E,N,O,j,M,L,F,z,H,Q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,M.refineServiceDecorator)(r.IExtensionManagementService);let K=class extends i.AbstractExtensionManagementService{constructor(U,$,q,B,x,ee,J,Z,se,le,ue,pe){super(U,$,q,le,pe),this.Y=x,this.Z=ee,this.ab=J,this.bb=se,this.cb=ue,this.X=new Map,this.kb=new P.ResourceSet;const we=this.B(Z.createInstance(a.ExtensionsLifecycle));this.S=this.B(Z.createInstance(V,Ee=>we.postUninstall(Ee))),this.U=this.B(new w.ExtensionsManifestCache(B,this)),this.W=this.B(Z.createInstance(c.ExtensionsDownloader));const be=this.B(new E.ExtensionsWatcher(this,this.Y,pe,ee,ue,se,q));this.B(be.onDidChangeExtensionsByAnotherSource(Ee=>this.jb(Ee))),this.lb()}getTargetPlatform(){return this.db||(this.db=(0,t.computeTargetPlatform)(this.bb,this.v)),this.db}async zip(U){this.v.trace("ExtensionManagementService#zip",U.identifier.id);const $=await this.ib(U),q=await(0,d.zip)((0,m.joinPath)(this.W.extensionsDownloadDir,(0,f.generateUuid)()).fsPath,$);return y.URI.file(q)}async unzip(U){return this.v.trace("ExtensionManagementService#unzip",U.toString()),(await this.install(U)).identifier}async getManifest(U){const{location:$,cleanup:q}=await this.eb(U),B=C.resolve($.fsPath);try{return await(0,u.getManifest)(B)}finally{await q()}}getInstalled(U,$){return this.S.scanExtensions(U??null,$)}getAllUserInstalled(){return this.S.scanAllUserExtensions(!1)}async install(U,$={}){this.v.trace("ExtensionManagementService#install",U.toString());const{location:q,cleanup:B}=await this.eb(U);try{const x=await(0,u.getManifest)(C.resolve(q.fsPath));if(x.engines&&x.engines.vscode&&!(0,O.isEngineValid)(x.engines.vscode,this.w.version,this.w.date))throw new Error(g.localize(0,null,(0,t.getGalleryExtensionId)(x.publisher,x.name),this.w.version));return await this.z(x,q,$)}finally{await B()}}async installFromLocation(U,$){this.v.trace("ExtensionManagementService#installFromLocation",U.toString());const q=await this.S.scanUserExtensionAtLocation(U);if(!q)throw new Error(`Cannot find a valid extension from the location ${U.toString()}`);return await this.nb([q],$),this.v.info("Successfully installed extension",q.identifier.id,$.toString()),q}getMetadata(U){return this.Y.scanMetadata(U.location)}async updateMetadata(U,$){this.v.trace("ExtensionManagementService#updateMetadata",U.identifier.id);const q={...$};return $.isPreReleaseVersion&&(q.preRelease=!0),U=await this.S.updateMetadata(U,q),this.U.invalidate(),U}async updateExtensionScope(U,$){return this.v.trace("ExtensionManagementService#updateExtensionScope",U.identifier.id),U=await this.S.updateMetadata(U,{isMachineScoped:$}),this.U.invalidate(),U}async reinstallFromGallery(U){if(this.v.trace("ExtensionManagementService#reinstallFromGallery",U.identifier.id),!this.t.isEnabled())throw new Error(g.localize(1,null));const $=await this.getTargetPlatform(),[q]=await this.t.getExtensions([{...U.identifier,preRelease:U.preRelease}],{targetPlatform:$,compatible:!0},n.CancellationToken.None);if(!q)throw new Error(g.localize(2,null));await this.S.setUninstalled(U);try{await this.S.removeUninstalledExtension(U)}catch(B){throw new Error(g.localize(3,null,(0,D.toErrorMessage)(B)))}return this.installFromGallery(q)}markAsUninstalled(...U){return this.S.setUninstalled(...U)}removeUninstalledExtensions(){return this.S.cleanUp()}async download(U,$){const{location:q}=await this.W.download(U,$);return q}async eb(U){if(U.scheme===S.Schemas.file)return{location:U,async cleanup(){}};this.v.trace("Downloading extension from",U.toString());const $=(0,m.joinPath)(this.W.extensionsDownloadDir,(0,f.generateUuid)());return await this.ab.download(U,$),this.v.info("Downloaded extension to",$.toString()),{location:$,cleanup:async()=>{try{await this.bb.del($)}catch(B){this.v.error(B)}}}}P(){return this.y.defaultProfile.extensionsResource}Q(U,$,q){let B;if(y.URI.isUri($))B=new X(U,$,q,this.t,this.S,this.v);else{const x=t.ExtensionKey.create($).toString();B=this.X.get(x),B||(this.X.set(x,B=new G(U,$,q,this.W,this.S,this.v)),B.waitUntilTaskIsFinished().then(()=>this.X.delete(x)))}return new ie(B,q.profileLocation,this.cb,this.y,this.Y,this.Z)}R(U,$){return new oe(U,$.profileLocation,this.Z)}async ib(U){const $=async B=>{let x=await l.Promises.readdir(B);x=x.map(Z=>C.join(B,Z));const ee=await Promise.all(x.map(Z=>l.Promises.stat(Z)));let J=Promise.resolve([]);return ee.forEach((Z,se)=>{const le=x[se];Z.isFile()&&(J=J.then(ue=>[...ue,le])),Z.isDirectory()&&(J=J.then(ue=>$(le).then(pe=>[...ue,...pe])))}),J};return(await $(U.location.fsPath)).map(B=>({path:`extension/${C.relative(U.location.fsPath,B)}`,localPath:B}))}async jb({added:U,removed:$}){if($)for(const q of $.extensions)this.v.info("Extensions removed from another source",q.id,$.profileLocation.toString()),this.p.fire({identifier:q,profileLocation:$.profileLocation});if(U){const B=(await this.S.scanExtensions(1,U.profileLocation)).filter(x=>U.extensions.some(ee=>(0,t.areSameExtensions)(ee,x.identifier)));this.m.fire(B.map(x=>(this.v.info("Extensions added from another source",x.identifier.id,U.profileLocation.toString()),{identifier:x.identifier,local:x,profileLocation:U.profileLocation,operation:1})))}}async lb(){this.B(this.S.onExtract($=>this.kb.add($)));const U=await this.bb.resolve(this.Y.userExtensionsLocation);for(const $ of U.children??[])$.isDirectory&&this.kb.add($.resource);this.B(this.bb.watch(this.Y.userExtensionsLocation)),this.B(this.bb.onDidFilesChange($=>this.mb($)))}async mb(U){if(!U.affects(this.Y.userExtensionsLocation,1))return;const $=[];for(const q of U.rawAdded){if(this.kb.has(q)||!this.cb.extUri.isEqual(this.cb.extUri.dirname(q),this.Y.userExtensionsLocation)||this.cb.extUri.isEqual(q,this.cb.extUri.joinPath(this.Y.userExtensionsLocation,".obsolete"))||this.cb.extUri.basename(q).startsWith(".")||!(await this.bb.stat(q)).isDirectory)continue;const B=await this.S.scanUserExtensionAtLocation(q);B&&B.installedTimestamp===void 0&&(this.kb.add(q),$.push(B))}$.length&&(await this.nb($,this.y.defaultProfile.extensionsResource),this.v.info("Added extensions to default profile from external source",$.map(q=>q.identifier.id)))}async nb(U,$){await this.Z.addExtensionsToProfile(U.map(q=>[q,void 0]),$),this.m.fire(U.map(q=>({local:q,identifier:q.identifier,operation:1,profileLocation:$})))}};K=ye([Y(0,r.IExtensionGalleryService),Y(1,z.ITelemetryService),Y(2,L.ILogService),Y(3,I.INativeEnvironmentService),Y(4,o.IExtensionsScannerService),Y(5,s.IExtensionsProfileScannerService),Y(6,v.IDownloadService),Y(7,M.IInstantiationService),Y(8,j.IFileService),Y(9,F.IProductService),Y(10,H.IUriIdentityService),Y(11,Q.IUserDataProfilesService)],K),e.ExtensionManagementService=K;let V=class extends R.Disposable{constructor(U,$,q,B){super(),this.j=U,this.k=$,this.l=q,this.m=B,this.h=this.B(new T.Emitter),this.onExtract=this.h.event,this.c=(0,m.joinPath)(this.l.userExtensionsLocation,".obsolete").fsPath,this.g=new A.Queue}async cleanUp(){await this.v()}async scanExtensions(U,$){const q={includeInvalid:!0,profileLocation:$};let B=[];return U===null||U===0?B.push(...await this.l.scanAllExtensions({includeInvalid:!0},q,!1)):U===1&&B.push(...await this.l.scanUserExtensions(q)),B=U!==null?B.filter(x=>x.type===U):B,Promise.all(B.map(x=>this.u(x)))}async scanAllUserExtensions(U){const $=await this.l.scanUserExtensions({includeAllVersions:!U,includeInvalid:!0});return Promise.all($.map(q=>this.u(q)))}async scanUserExtensionAtLocation(U){try{const $=await this.l.scanExistingExtension(U,1,{includeInvalid:!0});if($)return await this.u($)}catch($){this.m.error($)}return null}async extractUserExtension(U,$,q,B){const x=U.toString(),ee=C.join(this.l.userExtensionsLocation.fsPath,`.${(0,f.generateUuid)()}`),J=C.join(this.l.userExtensionsLocation.fsPath,x);try{await l.Promises.rm(J)}catch{throw new r.ExtensionManagementError(g.localize(4,null,J,U.id),r.ExtensionManagementErrorCode.Delete)}await this.p(U,$,ee,B),await this.l.updateMetadata(y.URI.file(ee),q);try{this.h.fire(y.URI.file(J)),await this.s(U,ee,J,Date.now()+2*60*1e3),this.m.info("Renamed to",J)}catch(Z){try{await l.Promises.rm(ee)}catch{}if(Z.code==="ENOTEMPTY")this.m.info("Rename failed because extension was installed by another source. So ignoring renaming.",U.id);else throw this.m.info(`Rename failed because of ${(0,k.getErrorMessage)(Z)}. Deleted from extracted location`,ee),Z}return this.t(y.URI.file(J),1)}async updateMetadata(U,$){return await this.l.updateMetadata(U.location,$),this.t(U.location,U.type)}getUninstalledExtensions(){return this.n()}async setUninstalled(...U){const $=U.map(q=>t.ExtensionKey.create(q));await this.n(q=>$.forEach(B=>{q[B.toString()]=!0,this.m.info("Marked extension as uninstalled",B.toString())}))}async setInstalled(U){await this.n(B=>delete B[U.toString()]);const q=(await this.scanAllUserExtensions(!0)).find(B=>t.ExtensionKey.create(B).equals(U))||null;return q?this.updateMetadata(q,{installedTimestamp:Date.now()}):null}async removeExtension(U,$){this.m.trace(`Deleting ${$} extension from disk`,U.identifier.id,U.location.fsPath),await l.Promises.rm(U.location.fsPath),this.m.info("Deleted from disk",U.identifier.id,U.location.fsPath)}async removeUninstalledExtension(U){await this.removeExtension(U,"uninstalled"),await this.n($=>delete $[t.ExtensionKey.create(U).toString()])}async n(U){return this.g.queue(async()=>{let $;try{$=await l.Promises.readFile(this.c,"utf8")}catch(B){if(B.code!=="ENOENT")throw B}let q={};if($)try{q=JSON.parse($)}catch{}return U&&(U(q),Object.keys(q).length?await l.Promises.writeFile(this.c,JSON.stringify(q)):await l.Promises.rm(this.c)),q})}async p(U,$,q,B){this.m.trace(`Started extracting the extension from ${$} to ${q}`);try{await l.Promises.rm(q)}catch(x){throw new r.ExtensionManagementError(this.w(x).message,r.ExtensionManagementErrorCode.Delete)}try{await(0,d.extract)($,q,{sourcePath:"extension",overwrite:!0},B),this.m.info(`Extracted extension to ${q}:`,U.id)}catch(x){try{await l.Promises.rm(q)}catch{}let ee=r.ExtensionManagementErrorCode.Extract;throw x instanceof d.ExtractError&&(x.type==="CorruptZip"?ee=r.ExtensionManagementErrorCode.CorruptZip:x.type==="Incomplete"&&(ee=r.ExtensionManagementErrorCode.IncompleteZip)),new r.ExtensionManagementError(x.message,ee)}}async s(U,$,q,B){try{await l.Promises.rename($,q)}catch(x){if(b.isWindows&&x&&x.code==="EPERM"&&Date.now()<B)return this.m.info(`Failed renaming ${$} to ${q} with 'EPERM' error. Trying again...`,U.id),this.s(U,$,q,B);throw new r.ExtensionManagementError(x.message||g.localize(5,null,$,q),x.code||r.ExtensionManagementErrorCode.Rename)}}async t(U,$){const q=await this.l.scanExistingExtension(U,$,{includeInvalid:!0});if(q)return this.u(q);throw new Error(g.localize(6,null,U.path))}async u(U){const $=await this.k.resolve(U.location);let q,B;return $.children&&(q=$.children.find(({name:x})=>/^readme(\.txt|\.md|)$/i.test(x))?.resource,B=$.children.find(({name:x})=>/^changelog(\.txt|\.md|)$/i.test(x))?.resource),{identifier:U.identifier,type:U.type,isBuiltin:U.isBuiltin||!!U.metadata?.isBuiltin,location:U.location,manifest:U.manifest,targetPlatform:U.targetPlatform,validations:U.validations,isValid:U.isValid,readmeUrl:q,changelogUrl:B,publisherDisplayName:U.metadata?.publisherDisplayName||null,publisherId:U.metadata?.publisherId||null,isApplicationScoped:!!U.metadata?.isApplicationScoped,isMachineScoped:!!U.metadata?.isMachineScoped,isPreReleaseVersion:!!U.metadata?.isPreReleaseVersion,preRelease:!!U.metadata?.preRelease,installedTimestamp:U.metadata?.installedTimestamp,updated:!!U.metadata?.updated}}async v(){const U=await this.getUninstalledExtensions(),$=await this.l.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),q=new Set;for(const ee of $)U[t.ExtensionKey.create(ee).toString()]||q.add(ee.identifier.id.toLowerCase());const B=(0,t.groupByExtension)($,ee=>ee.identifier);await A.Promises.settled(B.map(async ee=>{const J=ee.sort((Z,se)=>p.rcompare(Z.manifest.version,se.manifest.version))[0];q.has(J.identifier.id.toLowerCase())||await this.j(await this.u(J))}));const x=$.filter(ee=>ee.metadata&&U[t.ExtensionKey.create(ee).toString()]);await A.Promises.settled(x.map(ee=>this.removeUninstalledExtension(ee)))}w(U){const $=Array.isArray(U)?U:[U];return $.length===1?$[0]instanceof Error?$[0]:new Error($[0]):$.reduce((q,B)=>new Error(`${q.message}${q.message?",":""}${B instanceof Error?B.message:B}`),new Error(""))}};V=ye([Y(1,j.IFileService),Y(2,o.IExtensionsScannerService),Y(3,L.ILogService)],V),e.ExtensionsScanner=V;class W extends i.AbstractExtensionTask{get verificationStatus(){return this.j}get operation(){return(0,h.isUndefined)(this.l.operation)?this.k:this.l.operation}constructor(U,$,q,B,x){super(),this.identifier=U,this.source=$,this.l=q,this.m=B,this.n=x,this.j="Unverified",this.k=2}async o(U,$){try{const q=await this.p(U.key);if(q)return this.m.updateMetadata(q,U.metadata)}catch{throw b.isMacintosh?new r.ExtensionManagementError(g.localize(7,null),r.ExtensionManagementErrorCode.Internal):new r.ExtensionManagementError(g.localize(8,null),r.ExtensionManagementErrorCode.Internal)}return this.s(U,$)}async p(U){if(!await this.q(U))return null;this.n.trace("Removing the extension from uninstalled list:",U.id);const q=await this.m.setInstalled(U);return this.n.info("Removed the extension from uninstalled list:",U.id),q}async q(U){return!!(await this.m.getUninstalledExtensions())[U.toString()]}async s({zipPath:U,key:$,metadata:q},B){const x=await this.m.extractUserExtension($,U,q,B);return this.n.info("Extracting completed.",$.id),x}}class G extends W{constructor(U,$,q,B,x,ee){super($.identifier,$,q,x,ee),this.t=U,this.u=$,this.v=B}async h(U){const q=(await this.m.scanExtensions(null,void 0)).find(J=>(0,t.areSameExtensions)(J.identifier,this.u.identifier));q&&(this.k=3);const B={id:this.u.identifier.uuid,publisherId:this.u.publisherId,publisherDisplayName:this.u.publisherDisplayName,targetPlatform:this.u.properties.targetPlatform,isApplicationScoped:(0,N.isApplicationScopedExtension)(this.t),isMachineScoped:this.l.isMachineScoped||q?.isMachineScoped,isBuiltin:this.l.isBuiltin||q?.isBuiltin,isSystem:q?.type===0?!0:void 0,updated:!!q,isPreReleaseVersion:this.u.properties.isPreReleaseVersion,installedTimestamp:Date.now(),preRelease:this.u.properties.isPreReleaseVersion||((0,h.isBoolean)(this.l.installPreReleaseVersion)?this.l.installPreReleaseVersion:q?.preRelease)};if(q?.manifest.version===this.u.version)return{local:await this.m.updateMetadata(q,B),metadata:B};const{location:x,verificationStatus:ee}=await this.v.download(this.u,this.k);try{return this.j=ee,this.x(x.fsPath),{local:await this.o({zipPath:x.fsPath,key:t.ExtensionKey.create(this.u),metadata:B},U),metadata:B}}catch(J){try{await this.v.delete(x)}catch(Z){this.n.warn("Error while deleting the downloaded file",x.toString(),(0,k.getErrorMessage)(Z))}throw J}}async x(U){try{await(0,u.getManifest)(U)}catch($){throw new r.ExtensionManagementError((0,i.joinErrors)($).message,r.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=G;class X extends W{constructor(U,$,q,B,x,ee){super({id:(0,t.getGalleryExtensionId)(U.publisher,U.name)},$,q,x,ee),this.t=U,this.u=$,this.v=B}async h(U){const $=new t.ExtensionKey(this.identifier,this.t.version),B=(await this.m.scanExtensions(1,void 0)).find(J=>(0,t.areSameExtensions)(this.identifier,J.identifier)),x=await this.x(this.identifier.id,this.t.version,U);if(x.isApplicationScoped=(0,N.isApplicationScopedExtension)(this.t),x.isMachineScoped=this.l.isMachineScoped||B?.isMachineScoped,x.isBuiltin=this.l.isBuiltin||B?.isBuiltin,x.installedTimestamp=Date.now(),B)if(this.k=3,$.equals(new t.ExtensionKey(B.identifier,B.manifest.version)))try{await this.m.removeExtension(B,"existing")}catch{throw new Error(g.localize(9,null,this.t.displayName||this.t.name))}else!this.l.profileLocation&&p.gt(B.manifest.version,this.t.version)&&await this.m.setUninstalled(B);else{const J=await this.p($);if(J)try{await this.m.removeExtension(J,"existing")}catch{throw new Error(g.localize(10,null,this.t.displayName||this.t.name))}}return{local:await this.o({zipPath:C.resolve(this.u.fsPath),key:$,metadata:x},U),metadata:x}}async x(U,$,q){try{let[B]=await this.v.getExtensions([{id:U,version:$}],q);if(B||([B]=await this.v.getExtensions([{id:U}],q)),B)return{id:B.identifier.uuid,publisherDisplayName:B.publisherDisplayName,publisherId:B.publisherId,isPreReleaseVersion:B.properties.isPreReleaseVersion,preRelease:B.properties.isPreReleaseVersion||this.l.installPreReleaseVersion}}catch{}return{}}}class ie{get verificationStatus(){return this.d.verificationStatus}constructor(U,$,q,B,x,ee){this.d=U,this.g=$,this.h=q,this.j=B,this.k=x,this.l=ee,this.identifier=this.d.identifier,this.source=this.d.source,this.operation=this.d.operation,this.c=this.m()}async m(){const U=await this.d.waitUntilTaskIsFinished();return this.h.extUri.isEqual(this.j.defaultProfile.extensionsResource,this.g)&&await this.k.initializeDefaultProfileExtensions(),await this.l.addExtensionsToProfile([[U.local,U.metadata]],this.g),U}async run(){return await this.d.run(),this.c}waitUntilTaskIsFinished(){return this.c}cancel(){return this.d.cancel()}}class oe extends i.AbstractExtensionTask{constructor(U,$,q){super(),this.extension=U,this.j=$,this.k=q}async h(U){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(re[283],ae([0,1,2,30,80,233,127,9,20]),function(_,e,A,n,D,k,T,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsContributions=void 0;let S=class extends A.Disposable{constructor(b,m,p,h,y,f){super(),b.removeUninstalledExtensions(),(0,k.migrateUnsupportedExtensions)(b,m,p,h,f),D.ExtensionStorageService.removeOutdatedExtensionVersions(b,y)}};S=ye([Y(0,T.INativeServerExtensionManagementService),Y(1,n.IExtensionGalleryService),Y(2,D.IExtensionStorageService),Y(3,n.IGlobalExtensionEnablementService),Y(4,P.IStorageService),Y(5,R.ILogService)],S),e.ExtensionsContributions=S}),define(re[292],ae([0,1,94,34,38,7,2,24,22,8,39,150,210,211,204,205,281,193,196,16,216,96,231,97,223,15,228,118,267,30,98,195,268,127,99,191,13,207,208,55,4,202,72,203,57,73,237,9,104,58,105,25,60,20,269,110,19,111,112,113,47,240,114,242,248,80,116,26,78,272,259,260,81,273,276,277,278,279,271,62,261,109,230,77,250,220,249,108,227,29,251,5,252,197,214,213,79,266,18,51,209,59,270,225,239,262,232,107,103,275,283,264]),function(_,e,A,n,D,k,T,R,P,S,C,b,m,p,h,y,f,l,d,g,v,I,i,r,t,s,o,c,a,u,w,E,N,O,j,M,L,F,z,H,Q,K,V,W,G,X,ie,oe,te,U,$,q,B,x,ee,J,Z,se,le,ue,pe,we,be,Ee,Te,Ue,Ye,ze,ce,de,ge,Ce,Pe,Ae,De,je,Oe,Fe,Be,ke,Ne,ne,he,fe,me,ve,Ie,Re,He,$e,Le,qe,Ge,et,ot,wt,kt,At,vt,Lt,Tt,St,Ot,Nt,Ut,Mt,Ft,bt,Et,jt,$t,zt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Bt extends T.Disposable{constructor(Se){super(),this.f=Se,this.a=this.B(new b.Server),this.b=void 0,this.c=void 0,this.g()}g(){const Se=async()=>{this.c&&(await this.c.fireOnWillShutdown(),this.c.dispose(),this.c=void 0),this.dispose()};process.once("exit",Se),A.ipcRenderer.once("vscode:electron-main->shared-process=exit",Se);const Me="vscode:electron-main->shared-process=disposeWorker",We=(Je,tt)=>{this.h(tt)};A.ipcRenderer.on(Me,We),this.B((0,T.toDisposable)(()=>A.ipcRenderer.removeListener(Me,We)))}h(Se){this.b?.disposeWorker(Se)}async open(){const Se=await this.i();(0,ze.registerConfiguration)(),Se.invokeFunction(Me=>{const We=Me.get(oe.ILogService);We.trace("sharedProcess configuration",JSON.stringify(this.f)),this.j(Me),this.k(We)}),this.B((0,T.combinedDisposable)(Se.createInstance(m.CodeCacheCleaner,this.f.codeCachePath),Se.createInstance(p.LanguagePackCachedDataCleaner),Se.createInstance(f.UnusedWorkspaceStorageDataCleaner),Se.createInstance(y.LogsDataCleaner),Se.createInstance(h.LocalizationsUpdater),Se.createInstance($t.ExtensionsContributions),Se.createInstance(Mt.UserDataProfilesCleaner)))}async i(){const Se=new V.ServiceCollection,Me={_serviceBrand:void 0,...$.default};Se.set(q.IProductService,Me);const We=new C.StaticRouter(Qe=>Qe==="main"),Je=new W.MessagePortMainProcessService(this.a,We);Se.set(G.IMainProcessService,Je);const tt=this.f.policiesData?new Tt.PolicyChannelClient(this.f.policiesData,Je.getChannel("policy")):new St.NullPolicyService;Se.set(St.IPolicyService,tt);const Ke=new o.SharedProcessEnvironmentService(this.f.args,Me);Se.set(s.INativeEnvironmentService,Ke);const lt=new te.LogLevelChannelClient(this.a.getChannel("logLevel",We)),it=new te.LoggerChannelClient(this.f.logLevel,lt.onDidChangeLogLevel,Je.getChannel("logger"));Se.set(oe.ILoggerService,it);const ht=this.B(new oe.MultiplexLogService([this.B(new oe.ConsoleLogger(this.f.logLevel)),this.B(it.createLogger((0,P.joinPath)(S.URI.file(Ke.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),xe=this.B(new te.FollowerLogService(lt,ht));Se.set(oe.ILogService,xe),this.c=new Et.SharedProcessLifecycleService(xe),Se.set(Et.ISharedProcessLifecycleService,this.c),this.b=new He.SharedProcessWorkerService(xe),Se.set(Re.ISharedProcessWorkerService,this.b);const _e=this.B(new F.FileService(xe));Se.set(L.IFileService,_e);const ft=this.B(new z.DiskFileSystemProvider(xe));_e.registerProvider(R.Schemas.file,ft);const dt=this.B(new Ge.FileUserDataProvider(R.Schemas.file,this.B(new et.DiskFileSystemProviderClient(Je.getChannel(et.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:qe.isLinux})),R.Schemas.vscodeUserData,xe));_e.registerProvider(R.Schemas.vscodeUserData,dt);const nt=this.B(new Ot.UserDataProfilesNativeService(this.f.profiles,Je,Ke));Se.set(vt.IUserDataProfilesService,nt);const Xe=this.B(new v.ConfigurationService(nt.defaultProfile.settingsResource,_e,tt,xe));Se.set(g.IConfigurationService,Xe);const at=new ee.NativeStorageService(void 0,{defaultProfile:nt.defaultProfile,currentProfile:nt.defaultProfile},Je,Ke);Se.set(x.IStorageService,at),this.B((0,T.toDisposable)(()=>at.flush())),await Promise.all([Xe.initialize(),at.initialize()]),Se.set($e.IUriIdentityService,new Le.UriIdentityService(_e)),Se.set(B.IRequestService,new Nt.SharedProcessRequestService(Je,Xe,Me,xe)),Se.set(l.IChecksumService,new H.SyncDescriptor(d.ChecksumService,void 0,!1)),Se.set(wt.IV8InspectProfilingService,new H.SyncDescriptor(ot.InspectProfilingService,void 0,!1));const ut=C.ProxyChannel.toService(Je.getChannel("nativeHost"),{context:this.f.windowId});Se.set(U.INativeHostService,ut),Se.set(r.IDownloadService,new H.SyncDescriptor(t.DownloadService,void 0,!0));const gt=this.B(new Ne.ActiveWindowManager(ut)),mt=new C.StaticRouter(Qe=>gt.getActiveClientId().then(pt=>Qe===pt));Se.set(j.IExtensionRecommendationNotificationService,new M.ExtensionRecommendationNotificationServiceChannelClient(this.a.getChannel("extensionRecommendationNotification",mt)));let st;const ct=[],It=(0,pe.isInternalTelemetry)(Me,Xe);if((0,pe.supportsTelemetry)(Me,Ke)){const Qe=new le.TelemetryLogAppender(it,Ke);ct.push(Qe);const{installSourcePath:pt}=Ke;if(Me.aiConfig?.ariaKey){const Rt=new Ut.OneDataSystemAppender(It,"monacoworkbench",null,Me.aiConfig.ariaKey);this.B((0,T.toDisposable)(()=>Rt.flush())),ct.push(Rt)}st=new ue.TelemetryService({appenders:ct,commonProperties:(0,J.resolveCommonProperties)(_e,(0,n.release)(),(0,n.hostname)(),process.arch,Me.commit,Me.version,this.f.machineId,It,pt),sendErrorTelemetry:!0,piiPaths:(0,pe.getPiiPathsFromEnvironment)(Ke)},Xe,Me)}else{st=pe.NullTelemetryService;const Qe=pe.NullAppender;ct.push(Qe)}this.a.registerChannel("telemetryAppender",new se.TelemetryAppenderChannel(ct)),Se.set(Z.ITelemetryService,st);const Wt=new we.CustomEndpointTelemetryService(Xe,st,it,Ke,Me);Se.set(Z.ICustomEndpointTelemetryService,Wt),Se.set(Lt.IExtensionsProfileScannerService,new H.SyncDescriptor(zt.ExtensionsProfileScannerService,void 0,!0)),Se.set(kt.IExtensionsScannerService,new H.SyncDescriptor(At.ExtensionsScannerService,void 0,!0)),Se.set(w.IExtensionSignatureVerificationService,new H.SyncDescriptor(w.ExtensionSignatureVerificationService,void 0,!0)),Se.set(O.INativeServerExtensionManagementService,new H.SyncDescriptor(O.ExtensionManagementService,void 0,!0)),Se.set(u.IExtensionGalleryService,new H.SyncDescriptor(a.ExtensionGalleryService,void 0,!0)),Se.set(u.IExtensionTipsService,new H.SyncDescriptor(N.ExtensionTipsService,void 0,!1)),Se.set(X.ILanguagePackService,new H.SyncDescriptor(ie.NativeLanguagePackService,void 0,!1)),Se.set(I.IDiagnosticsService,new H.SyncDescriptor(i.DiagnosticsService,void 0,!1)),Se.set(ce.IUserDataSyncAccountService,new H.SyncDescriptor(ce.UserDataSyncAccountService,void 0,!0)),Se.set(ze.IUserDataSyncLogService,new H.SyncDescriptor(Ce.UserDataSyncLogService,void 0,!0)),Se.set(ze.IUserDataSyncUtilService,new ge.UserDataSyncUtilServiceClient(this.a.getChannel("userDataSyncUtil",Qe=>Qe.ctx!=="main"))),Se.set(u.IGlobalExtensionEnablementService,new H.SyncDescriptor(c.GlobalExtensionEnablementService,void 0,!1)),Se.set(Ye.IIgnoredExtensionsManagementService,new H.SyncDescriptor(Ye.IgnoredExtensionsManagementService,void 0,!0)),Se.set(Ue.IExtensionStorageService,new H.SyncDescriptor(Ue.ExtensionStorageService)),Se.set(ze.IUserDataSyncStoreManagementService,new H.SyncDescriptor(Oe.UserDataSyncStoreManagementService,void 0,!0)),Se.set(ze.IUserDataSyncStoreService,new H.SyncDescriptor(Oe.UserDataSyncStoreService,void 0,!0)),Se.set(Pe.IUserDataSyncMachinesService,new H.SyncDescriptor(Pe.UserDataSyncMachinesService,void 0,!0)),Se.set(ze.IUserDataSyncBackupStoreService,new H.SyncDescriptor(de.UserDataSyncBackupStoreService,void 0,!1)),Se.set(ze.IUserDataSyncEnablementService,new H.SyncDescriptor(Ae.UserDataSyncEnablementService,void 0,!0)),Se.set(ze.IUserDataSyncService,new H.SyncDescriptor(De.UserDataSyncService,void 0,!1)),Se.set(ke.IUserDataProfileStorageService,new H.SyncDescriptor(Be.UserDataProfileStorageService,void 0,!0)),Se.set(ze.IUserDataSyncResourceProviderService,new H.SyncDescriptor(jt.UserDataSyncResourceProviderService,void 0,!0));const Pt=new Te.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:Xe.getValue("terminal.integrated.persistentSessionScrollback")??100},Xe,Ke,xe);return Pt.initialize(),Se.set(Ee.ILocalPtyService,this.B(Pt)),Se.set(ne.ISignService,new H.SyncDescriptor(he.SignService,void 0,!1)),Se.set(fe.ISharedTunnelsService,new H.SyncDescriptor(me.SharedTunnelsService)),Se.set(ve.ISharedProcessTunnelService,new H.SyncDescriptor(Ie.SharedProcessTunnelService)),Se.set(bt.IRemoteTunnelService,new H.SyncDescriptor(Ft.RemoteTunnelService)),new K.InstantiationService(Se)}j(Se){const Me=new te.LogLevelChannel(Se.get(oe.ILogService),Se.get(oe.ILoggerService));this.a.registerChannel("logLevel",Me);const We=new E.ExtensionManagementChannel(Se.get(u.IExtensionManagementService),()=>null);this.a.registerChannel("extensions",We);const Je=C.ProxyChannel.fromService(Se.get(X.ILanguagePackService));this.a.registerChannel("languagePacks",Je);const tt=C.ProxyChannel.fromService(Se.get(I.IDiagnosticsService));this.a.registerChannel("diagnostics",tt);const Ke=new E.ExtensionTipsChannel(Se.get(u.IExtensionTipsService));this.a.registerChannel("extensionTipsService",Ke);const lt=C.ProxyChannel.fromService(Se.get(l.IChecksumService));this.a.registerChannel("checksum",lt);const it=C.ProxyChannel.fromService(Se.get(wt.IV8InspectProfilingService));this.a.registerChannel("v8InspectProfiling",it);const ht=new ge.UserDataSyncMachinesServiceChannel(Se.get(Pe.IUserDataSyncMachinesService));this.a.registerChannel("userDataSyncMachines",ht);const xe=C.ProxyChannel.fromService(Se.get(Z.ICustomEndpointTelemetryService));this.a.registerChannel("customEndpointTelemetry",xe);const _e=new ge.UserDataSyncAccountServiceChannel(Se.get(ce.IUserDataSyncAccountService));this.a.registerChannel("userDataSyncAccount",_e);const ft=new ge.UserDataSyncStoreManagementServiceChannel(Se.get(ze.IUserDataSyncStoreManagementService));this.a.registerChannel("userDataSyncStoreManagement",ft);const dt=new je.UserDataSyncChannel(Se.get(ze.IUserDataSyncService),Se.get(vt.IUserDataProfilesService),Se.get(oe.ILogService));this.a.registerChannel("userDataSync",dt);const nt=this.B(Se.get(Q.IInstantiationService).createInstance(Fe.UserDataAutoSyncService)),Xe=new ge.UserDataAutoSyncChannel(nt);this.a.registerChannel("userDataAutoSync",Xe);const at=Se.get(Ee.ILocalPtyService),ut=C.ProxyChannel.fromService(at);this.a.registerChannel(be.TerminalIpcChannels.LocalPty,ut);const gt=C.ProxyChannel.fromService(Se.get(ve.ISharedProcessTunnelService));this.a.registerChannel(ve.ipcSharedProcessTunnelChannelName,gt);const mt=C.ProxyChannel.fromService(Se.get(Re.ISharedProcessWorkerService));this.a.registerChannel(Re.ipcSharedProcessWorkerChannelName,mt);const st=C.ProxyChannel.fromService(Se.get(bt.IRemoteTunnelService));this.a.registerChannel("remoteTunnel",st)}k(Se){window.addEventListener("unhandledrejection",Me=>{(0,k.onUnexpectedError)(Me.reason),Me.preventDefault()}),(0,k.setUnexpectedErrorHandler)(Me=>{const We=(0,D.toErrorMessage)(Me,!0);!We||Se.error(`[uncaught exception in sharedProcess]: ${We}`)})}}async function qt(Ct){const Se=new Bt(Ct);A.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await Se.open(),A.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=qt})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/727d2d32aea02baf7d13fa38787e8ed64dd858d0/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
