/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Y=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/types","vs/base/common/async","vs/base/common/errors","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/platform","vs/platform/files/common/files","vs/base/common/path","vs/base/common/buffer","vs/base/common/network","vs/platform/environment/common/environment","vs/base/common/resources","vs/base/common/arrays","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/uriIdentity/common/uriIdentity","vs/platform/product/common/productService","vs/platform/extensions/common/extensions","vs/base/common/objects","vs/base/common/uuid","vs/base/common/strings","os","vs/base/common/errorMessage","vs/base/common/process","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/policy/common/policy","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/base/common/stream","vs/base/common/marshalling","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/request/common/request","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/json","vs/base/common/processes","vs/base/common/hash","vs/base/common/severity","vs/base/common/ternarySearchTree","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/state","vs/platform/telemetry/common/commonProperties","vs/base/node/zip","vs/base/common/assert","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/node/spdlogLog","vs/platform/policy/common/filePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/stateService","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/policy/node/nativePolicyService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","vs/platform/environment/node/argvHelper","crypto","https","vscode-policy-watcher","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],Q=function(x){for(var e=[],T=0,O=x.length;T<O;T++)e[T]=Y[x[T]];return e};define(Y[49],Q([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function T(N){return(b,f,c)=>{let p=null,v=null;if(typeof c.value=="function"?(p="value",v=c.value):typeof c.get=="function"&&(p="get",v=c.get),!v)throw new Error("not supported");c[p]=N(v,f)}}function O(N,b,f){let c=null,p=null;if(typeof f.value=="function"?(c="value",p=f.value,p.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(c="get",p=f.get),!p)throw new Error("not supported");const v=`$memoize$${b}`;f[c]=function(...g){return this.hasOwnProperty(v)||Object.defineProperty(this,v,{configurable:!1,enumerable:!1,writable:!1,value:p.apply(this,g)}),this[v]}}e.memoize=O;function k(N,b,f){return T((c,p)=>{const v=`$debounce$${p}`,g=`$debounce$result$${p}`;return function(...I){this[g]||(this[g]=f?f():void 0),clearTimeout(this[v]),b&&(this[g]=b(this[g],...I),I=[this[g]]),this[v]=setTimeout(()=>{c.apply(this,I),this[g]=f?f():void 0},N)}})}e.debounce=k;function D(N,b,f){return T((c,p)=>{const v=`$throttle$timer$${p}`,g=`$throttle$result$${p}`,I=`$throttle$lastRun$${p}`,E=`$throttle$pending$${p}`;return function(...L){if(this[g]||(this[g]=f?f():void 0),(this[I]===null||this[I]===void 0)&&(this[I]=-Number.MAX_VALUE),b&&(this[g]=b(this[g],...L)),this[E])return;const d=this[I]+N;d<=Date.now()?(this[I]=Date.now(),c.apply(this,[this[g]]),this[g]=f?f():void 0):(this[E]=!0,this[v]=setTimeout(()=>{this[E]=!1,this[I]=Date.now(),c.apply(this,[this[g]]),this[g]=f?f():void 0},d-Date.now()))}})}e.throttle=D}),define(Y[70],Q([0,1,6]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function O(f,c){if(!f)throw new Error(c?`Assertion failed (${c})`:"Assertion Failed")}e.ok=O;function k(f,c="Unreachable"){throw new Error(c)}e.assertNever=k;function D(f){if(!f)throw new T.BugIndicatingError("Assertion Failed")}e.assert=D;function N(f){if(!f()){debugger;f(),(0,T.onUnexpectedError)(new T.BugIndicatingError("Assertion Failed"))}}e.assertFn=N;function b(f,c){let p=0;for(;p<f.length-1;){const v=f[p],g=f[p+1];if(!c(v,g))return!1;p++}return!0}e.checkAdjacentItems=b}),define(Y[50],Q([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var T;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(T=e.ScanError||(e.ScanError={}));var O;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(O=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var D;(function(t){t.DEFAULT={allowTrailingComma:!0}})(D=e.ParseOptions||(e.ParseOptions={}));function N(t,r=!1){let i=0;const n=t.length;let s="",a=0,o=16,u=0;function w(ne){let ae=0,fe=0;for(;ae<ne;){const re=t.charCodeAt(i);if(re>=48&&re<=57)fe=fe*16+re-48;else if(re>=65&&re<=70)fe=fe*16+re-65+10;else if(re>=97&&re<=102)fe=fe*16+re-97+10;else break;i++,ae++}return ae<ne&&(fe=-1),fe}function A(ne){i=ne,s="",a=0,o=16,u=0}function $(){const ne=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&c(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&c(t.charCodeAt(i)))for(i++;i<t.length&&c(t.charCodeAt(i));)i++;else return u=3,t.substring(ne,i);let ae=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&c(t.charCodeAt(i))){for(i++;i<t.length&&c(t.charCodeAt(i));)i++;ae=i}else u=3;return t.substring(ne,ae)}function Z(){let ne="",ae=i;for(;;){if(i>=n){ne+=t.substring(ae,i),u=2;break}const fe=t.charCodeAt(i);if(fe===34){ne+=t.substring(ae,i),i++;break}if(fe===92){if(ne+=t.substring(ae,i),i++,i>=n){u=2;break}switch(t.charCodeAt(i++)){case 34:ne+='"';break;case 92:ne+="\\";break;case 47:ne+="/";break;case 98:ne+="\b";break;case 102:ne+="\f";break;case 110:ne+=`
`;break;case 114:ne+="\r";break;case 116:ne+="	";break;case 117:{const me=w(4);me>=0?ne+=String.fromCharCode(me):u=4;break}default:u=5}ae=i;continue}if(fe>=0&&fe<=31)if(f(fe)){ne+=t.substring(ae,i),u=2;break}else u=6;i++}return ne}function X(){if(s="",u=0,a=i,i>=n)return a=n,o=17;let ne=t.charCodeAt(i);if(b(ne)){do i++,s+=String.fromCharCode(ne),ne=t.charCodeAt(i);while(b(ne));return o=15}if(f(ne))return i++,s+=String.fromCharCode(ne),ne===13&&t.charCodeAt(i)===10&&(i++,s+=`
`),o=14;switch(ne){case 123:return i++,o=1;case 125:return i++,o=2;case 91:return i++,o=3;case 93:return i++,o=4;case 58:return i++,o=6;case 44:return i++,o=5;case 34:return i++,s=Z(),o=10;case 47:{const ae=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<n&&!f(t.charCodeAt(i));)i++;return s=t.substring(ae,i),o=12}if(t.charCodeAt(i+1)===42){i+=2;const fe=n-1;let re=!1;for(;i<fe;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,re=!0;break}i++}return re||(i++,u=1),s=t.substring(ae,i),o=13}return s+=String.fromCharCode(ne),i++,o=16}case 45:if(s+=String.fromCharCode(ne),i++,i===n||!c(t.charCodeAt(i)))return o=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=$(),o=11;default:for(;i<n&&ee(ne);)i++,ne=t.charCodeAt(i);if(a!==i){switch(s=t.substring(a,i),s){case"true":return o=8;case"false":return o=9;case"null":return o=7}return o=16}return s+=String.fromCharCode(ne),i++,o=16}}function ee(ne){if(b(ne)||f(ne))return!1;switch(ne){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ie(){let ne;do ne=X();while(ne>=12&&ne<=15);return ne}return{setPosition:A,getPosition:()=>i,scan:r?ie:X,getToken:()=>o,getTokenValue:()=>s,getTokenOffset:()=>a,getTokenLength:()=>i-a,getTokenError:()=>u}}e.createScanner=N;function b(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function f(t){return t===10||t===13||t===8232||t===8233}function c(t){return t>=48&&t<=57}var p;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(p||(p={}));function v(t,r){const i=[],n=new Object;let s;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function u(w,A,$,Z){a.value=w,a.offset=A,a.length=$,a.type=Z,a.colonOffset=void 0,s=a}try{S(t,{onObjectBegin:(w,A)=>{if(r<=w)throw n;s=void 0,o=r>w,i.push("")},onObjectProperty:(w,A,$)=>{if(r<A||(u(w,A,$,"property"),i[i.length-1]=w,r<=A+$))throw n},onObjectEnd:(w,A)=>{if(r<=w)throw n;s=void 0,i.pop()},onArrayBegin:(w,A)=>{if(r<=w)throw n;s=void 0,i.push(0)},onArrayEnd:(w,A)=>{if(r<=w)throw n;s=void 0,i.pop()},onLiteralValue:(w,A,$)=>{if(r<A||(u(w,A,$,y(w)),r<=A+$))throw n},onSeparator:(w,A,$)=>{if(r<=A)throw n;if(w===":"&&s&&s.type==="property")s.colonOffset=A,o=!1,s=void 0;else if(w===","){const Z=i[i.length-1];typeof Z=="number"?i[i.length-1]=Z+1:(o=!0,i[i.length-1]=""),s=void 0}}})}catch(w){if(w!==n)throw w}return{path:i,previousNode:s,isAtPropertyKey:o,matches:w=>{let A=0;for(let $=0;A<w.length&&$<i.length;$++)if(w[A]===i[$]||w[A]==="*")A++;else if(w[A]!=="**")return!1;return A===w.length}}}e.getLocation=v;function g(t,r=[],i=D.DEFAULT){let n=null,s=[];const a=[];function o(w){Array.isArray(s)?s.push(w):n!==null&&(s[n]=w)}return S(t,{onObjectBegin:()=>{const w={};o(w),a.push(s),s=w,n=null},onObjectProperty:w=>{n=w},onObjectEnd:()=>{s=a.pop()},onArrayBegin:()=>{const w=[];o(w),a.push(s),s=w,n=null},onArrayEnd:()=>{s=a.pop()},onLiteralValue:o,onError:(w,A,$)=>{r.push({error:w,offset:A,length:$})}},i),s[0]}e.parse=g;function I(t,r=[],i=D.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(w){n.type==="property"&&(n.length=w-n.offset,n=n.parent)}function a(w){return n.children.push(w),w}S(t,{onObjectBegin:w=>{n=a({type:"object",offset:w,length:-1,parent:n,children:[]})},onObjectProperty:(w,A,$)=>{n=a({type:"property",offset:A,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:w,offset:A,length:$,parent:n})},onObjectEnd:(w,A)=>{n.length=w+A-n.offset,n=n.parent,s(w+A)},onArrayBegin:(w,A)=>{n=a({type:"array",offset:w,length:-1,parent:n,children:[]})},onArrayEnd:(w,A)=>{n.length=w+A-n.offset,n=n.parent,s(w+A)},onLiteralValue:(w,A,$)=>{a({type:y(w),offset:A,length:$,parent:n,value:w}),s(A+$)},onSeparator:(w,A,$)=>{n.type==="property"&&(w===":"?n.colonOffset=A:w===","&&s(A))},onError:(w,A,$)=>{r.push({error:w,offset:A,length:$})}},i);const u=n.children[0];return u&&delete u.parent,u}e.parseTree=I;function E(t,r){if(!t)return;let i=t;for(const n of r)if(typeof n=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let s=!1;for(const a of i.children)if(Array.isArray(a.children)&&a.children[0].value===n){i=a.children[1],s=!0;break}if(!s)return}else{const s=n;if(i.type!=="array"||s<0||!Array.isArray(i.children)||s>=i.children.length)return;i=i.children[s]}return i}e.findNodeAtLocation=E;function L(t){if(!t.parent||!t.parent.children)return[];const r=L(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;r.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&r.push(i)}return r}e.getNodePath=L;function d(t){switch(t.type){case"array":return t.children.map(d);case"object":{const r=Object.create(null);for(const i of t.children){const n=i.children[1];n&&(r[i.children[0].value]=d(n))}return r}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=d;function l(t,r,i=!1){return r>=t.offset&&r<t.offset+t.length||i&&r===t.offset+t.length}e.contains=l;function m(t,r,i=!1){if(l(t,r,i)){const n=t.children;if(Array.isArray(n))for(let s=0;s<n.length&&n[s].offset<=r;s++){const a=m(n[s],r,i);if(a)return a}return t}}e.findNodeAtOffset=m;function S(t,r,i=D.DEFAULT){const n=N(t,!1);function s(q){return q?()=>q(n.getTokenOffset(),n.getTokenLength()):()=>!0}function a(q){return q?K=>q(K,n.getTokenOffset(),n.getTokenLength()):()=>!0}const o=s(r.onObjectBegin),u=a(r.onObjectProperty),w=s(r.onObjectEnd),A=s(r.onArrayBegin),$=s(r.onArrayEnd),Z=a(r.onLiteralValue),X=a(r.onSeparator),ee=s(r.onComment),ie=a(r.onError),ne=i&&i.disallowComments,ae=i&&i.allowTrailingComma;function fe(){for(;;){const q=n.scan();switch(n.getTokenError()){case 4:re(14);break;case 5:re(15);break;case 3:re(13);break;case 1:ne||re(11);break;case 2:re(12);break;case 6:re(16);break}switch(q){case 12:case 13:ne?re(10):ee();break;case 16:re(1);break;case 15:case 14:break;default:return q}}}function re(q,K=[],R=[]){if(ie(q),K.length+R.length>0){let P=n.getToken();for(;P!==17;){if(K.indexOf(P)!==-1){fe();break}else if(R.indexOf(P)!==-1)break;P=fe()}}}function me(q){const K=n.getTokenValue();return q?Z(K):u(K),fe(),!0}function z(){switch(n.getToken()){case 11:{let q=0;try{q=JSON.parse(n.getTokenValue()),typeof q!="number"&&(re(2),q=0)}catch{re(2)}Z(q);break}case 7:Z(null);break;case 8:Z(!0);break;case 9:Z(!1);break;default:return!1}return fe(),!0}function j(){return n.getToken()!==10?(re(3,[],[2,5]),!1):(me(!1),n.getToken()===6?(X(":"),fe(),W()||re(4,[],[2,5])):re(5,[],[2,5]),!0)}function M(){o(),fe();let q=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(q||re(4,[],[]),X(","),fe(),n.getToken()===2&&ae)break}else q&&re(6,[],[]);j()||re(4,[],[2,5]),q=!0}return w(),n.getToken()!==2?re(7,[2],[]):fe(),!0}function B(){A(),fe();let q=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(q||re(4,[],[]),X(","),fe(),n.getToken()===4&&ae)break}else q&&re(6,[],[]);W()||re(4,[],[4,5]),q=!0}return $(),n.getToken()!==4?re(8,[4],[]):fe(),!0}function W(){switch(n.getToken()){case 3:return B();case 1:return M();case 10:return me(!0);default:return z()}}return fe(),n.getToken()===17?i.allowEmptyContent?!0:(re(4,[],[]),!1):W()?(n.getToken()!==17&&re(9,[],[]),!0):(re(4,[],[]),!1)}e.visit=S;function h(t,r){const i=N(t),n=[];let s,a=0,o;do switch(o=i.getPosition(),s=i.scan(),s){case 12:case 13:case 17:a!==o&&n.push(t.substring(a,o)),r!==void 0&&n.push(i.getTokenValue().replace(/[^\r\n]/g,r)),a=i.getPosition();break}while(s!==17);return n.join("")}e.stripComments=h;function y(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=y}),define(Y[71],Q([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function T(b,f,c){return Math.min(Math.max(b,f),c)}e.clamp=T;function O(b,f){return(f+b%f)%f}e.rot=O;class k{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=k;class D{constructor(){this.a=1,this.b=0}update(f){return this.b=this.b+(f-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=D;class N{constructor(f){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(f),this.c.fill(0,0,f)}update(f){const c=this.c[this.d];return this.c[this.d]=f,this.d=(this.d+1)%this.c.length,this.e-=c,this.e+=f,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=N}),function(){function x(k){const D=[];typeof k=="number"&&D.push("code/timeOrigin",k);function N(f){D.push(f,Date.now())}function b(){const f=[];for(let c=0;c<D.length;c+=2)f.push({name:D[c],startTime:D[c+1]});return f}return{mark:N,getMarks:b}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?x():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const D=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const N of performance.getEntriesByType("mark"))D.push({name:N.name,startTime:Math.round(k+N.startTime)});return D}};if(typeof process=="object"){const k=Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return x(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),x()}function T(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var O;typeof global=="object"?O=global:typeof self=="object"?O=self:O={},typeof define=="function"?define("vs/base/common/performance",[],function(){return T(O)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=T(O):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),O.perf=T(O))}(),function(x,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var T=e();for(var O in T)(typeof exports=="object"?exports:x)[O]=T[O]}}(typeof self<"u"?self:this,function(){return function(x){var e={};function T(O){if(e[O])return e[O].exports;var k=e[O]={i:O,l:!1,exports:{}};return x[O].call(k.exports,k,k.exports,T),k.l=!0,k.exports}return T.m=x,T.c=e,T.d=function(O,k,D){T.o(O,k)||Object.defineProperty(O,k,{enumerable:!0,get:D})},T.r=function(O){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(O,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(O,"__esModule",{value:!0})},T.t=function(O,k){if(1&k&&(O=T(O)),8&k||4&k&&typeof O=="object"&&O&&O.__esModule)return O;var D=Object.create(null);if(T.r(D),Object.defineProperty(D,"default",{enumerable:!0,value:O}),2&k&&typeof O!="string")for(var N in O)T.d(D,N,function(b){return O[b]}.bind(null,N));return D},T.n=function(O){var k=O&&O.__esModule?function(){return O.default}:function(){return O};return T.d(k,"a",k),k},T.o=function(O,k){return Object.prototype.hasOwnProperty.call(O,k)},T.p="",T(T.s=0)}([function(x,e,T){(function(O){var k;e=x.exports=R,k=typeof O=="object"&&O.env&&O.env.NODE_DEBUG&&/\bsemver\b/i.test(O.env.NODE_DEBUG)?function(){var U=Array.prototype.slice.call(arguments,0);U.unshift("SEMVER"),console.log.apply(console,U)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var D=256,N=Number.MAX_SAFE_INTEGER||9007199254740991,b=e.re=[],f=e.src=[],c=0,p=c++;f[p]="0|[1-9]\\d*";var v=c++;f[v]="[0-9]+";var g=c++;f[g]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var I=c++;f[I]="("+f[p]+")\\.("+f[p]+")\\.("+f[p]+")";var E=c++;f[E]="("+f[v]+")\\.("+f[v]+")\\.("+f[v]+")";var L=c++;f[L]="(?:"+f[p]+"|"+f[g]+")";var d=c++;f[d]="(?:"+f[v]+"|"+f[g]+")";var l=c++;f[l]="(?:-("+f[L]+"(?:\\."+f[L]+")*))";var m=c++;f[m]="(?:-?("+f[d]+"(?:\\."+f[d]+")*))";var S=c++;f[S]="[0-9A-Za-z-]+";var h=c++;f[h]="(?:\\+("+f[S]+"(?:\\."+f[S]+")*))";var y=c++,t="v?"+f[I]+f[l]+"?"+f[h]+"?";f[y]="^"+t+"$";var r="[v=\\s]*"+f[E]+f[m]+"?"+f[h]+"?",i=c++;f[i]="^"+r+"$";var n=c++;f[n]="((?:<|>)?=?)";var s=c++;f[s]=f[v]+"|x|X|\\*";var a=c++;f[a]=f[p]+"|x|X|\\*";var o=c++;f[o]="[v=\\s]*("+f[a]+")(?:\\.("+f[a]+")(?:\\.("+f[a]+")(?:"+f[l]+")?"+f[h]+"?)?)?";var u=c++;f[u]="[v=\\s]*("+f[s]+")(?:\\.("+f[s]+")(?:\\.("+f[s]+")(?:"+f[m]+")?"+f[h]+"?)?)?";var w=c++;f[w]="^"+f[n]+"\\s*"+f[o]+"$";var A=c++;f[A]="^"+f[n]+"\\s*"+f[u]+"$";var $=c++;f[$]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var Z=c++;f[Z]="(?:~>?)";var X=c++;f[X]="(\\s*)"+f[Z]+"\\s+",b[X]=new RegExp(f[X],"g");var ee=c++;f[ee]="^"+f[Z]+f[o]+"$";var ie=c++;f[ie]="^"+f[Z]+f[u]+"$";var ne=c++;f[ne]="(?:\\^)";var ae=c++;f[ae]="(\\s*)"+f[ne]+"\\s+",b[ae]=new RegExp(f[ae],"g");var fe=c++;f[fe]="^"+f[ne]+f[o]+"$";var re=c++;f[re]="^"+f[ne]+f[u]+"$";var me=c++;f[me]="^"+f[n]+"\\s*("+r+")$|^$";var z=c++;f[z]="^"+f[n]+"\\s*("+t+")$|^$";var j=c++;f[j]="(\\s*)"+f[n]+"\\s*("+r+"|"+f[o]+")",b[j]=new RegExp(f[j],"g");var M=c++;f[M]="^\\s*("+f[o]+")\\s+-\\s+("+f[o]+")\\s*$";var B=c++;f[B]="^\\s*("+f[u]+")\\s+-\\s+("+f[u]+")\\s*$";var W=c++;f[W]="(<|>)?=?\\s*\\*";for(var q=0;q<35;q++)k(q,f[q]),b[q]||(b[q]=new RegExp(f[q]));function K(U,H){if(U instanceof R)return U;if(typeof U!="string"||U.length>D||!(H?b[i]:b[y]).test(U))return null;try{return new R(U,H)}catch{return null}}function R(U,H){if(U instanceof R){if(U.loose===H)return U;U=U.version}else if(typeof U!="string")throw new TypeError("Invalid Version: "+U);if(U.length>D)throw new TypeError("version is longer than "+D+" characters");if(!(this instanceof R))return new R(U,H);k("SemVer",U,H),this.loose=H;var J=U.trim().match(H?b[i]:b[y]);if(!J)throw new TypeError("Invalid Version: "+U);if(this.raw=U,this.major=+J[1],this.minor=+J[2],this.patch=+J[3],this.major>N||this.major<0)throw new TypeError("Invalid major version");if(this.minor>N||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>N||this.patch<0)throw new TypeError("Invalid patch version");J[4]?this.prerelease=J[4].split(".").map(function(he){if(/^[0-9]+$/.test(he)){var pe=+he;if(pe>=0&&pe<N)return pe}return he}):this.prerelease=[],this.build=J[5]?J[5].split("."):[],this.format()}e.parse=K,e.valid=function(U,H){var J=K(U,H);return J?J.version:null},e.clean=function(U,H){var J=K(U.trim().replace(/^[=v]+/,""),H);return J?J.version:null},e.SemVer=R,R.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},R.prototype.toString=function(){return this.version},R.prototype.compare=function(U){return k("SemVer.compare",this.version,this.loose,U),U instanceof R||(U=new R(U,this.loose)),this.compareMain(U)||this.comparePre(U)},R.prototype.compareMain=function(U){return U instanceof R||(U=new R(U,this.loose)),C(this.major,U.major)||C(this.minor,U.minor)||C(this.patch,U.patch)},R.prototype.comparePre=function(U){if(U instanceof R||(U=new R(U,this.loose)),this.prerelease.length&&!U.prerelease.length)return-1;if(!this.prerelease.length&&U.prerelease.length)return 1;if(!this.prerelease.length&&!U.prerelease.length)return 0;var H=0;do{var J=this.prerelease[H],he=U.prerelease[H];if(k("prerelease compare",H,J,he),J===void 0&&he===void 0)return 0;if(he===void 0)return 1;if(J===void 0)return-1;if(J!==he)return C(J,he)}while(++H)},R.prototype.inc=function(U,H){switch(U){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",H);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",H);break;case"prepatch":this.prerelease.length=0,this.inc("patch",H),this.inc("pre",H);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",H),this.inc("pre",H);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var J=this.prerelease.length;--J>=0;)typeof this.prerelease[J]=="number"&&(this.prerelease[J]++,J=-2);J===-1&&this.prerelease.push(0)}H&&(this.prerelease[0]===H?isNaN(this.prerelease[1])&&(this.prerelease=[H,0]):this.prerelease=[H,0]);break;default:throw new Error("invalid increment argument: "+U)}return this.format(),this.raw=this.version,this},e.inc=function(U,H,J,he){typeof J=="string"&&(he=J,J=void 0);try{return new R(U,J).inc(H,he).version}catch{return null}},e.diff=function(U,H){if(te(U,H))return null;var J=K(U),he=K(H);if(J.prerelease.length||he.prerelease.length){for(var pe in J)if((pe==="major"||pe==="minor"||pe==="patch")&&J[pe]!==he[pe])return"pre"+pe;return"prerelease"}for(var pe in J)if((pe==="major"||pe==="minor"||pe==="patch")&&J[pe]!==he[pe])return pe},e.compareIdentifiers=C;var P=/^[0-9]+$/;function C(U,H){var J=P.test(U),he=P.test(H);return J&&he&&(U=+U,H=+H),J&&!he?-1:he&&!J?1:U<H?-1:U>H?1:0}function F(U,H,J){return new R(U,J).compare(new R(H,J))}function V(U,H,J){return F(U,H,J)>0}function G(U,H,J){return F(U,H,J)<0}function te(U,H,J){return F(U,H,J)===0}function oe(U,H,J){return F(U,H,J)!==0}function ge(U,H,J){return F(U,H,J)>=0}function ve(U,H,J){return F(U,H,J)<=0}function le(U,H,J,he){var pe;switch(H){case"===":typeof U=="object"&&(U=U.version),typeof J=="object"&&(J=J.version),pe=U===J;break;case"!==":typeof U=="object"&&(U=U.version),typeof J=="object"&&(J=J.version),pe=U!==J;break;case"":case"=":case"==":pe=te(U,J,he);break;case"!=":pe=oe(U,J,he);break;case">":pe=V(U,J,he);break;case">=":pe=ge(U,J,he);break;case"<":pe=G(U,J,he);break;case"<=":pe=ve(U,J,he);break;default:throw new TypeError("Invalid operator: "+H)}return pe}function ce(U,H){if(U instanceof ce){if(U.loose===H)return U;U=U.value}if(!(this instanceof ce))return new ce(U,H);k("comparator",U,H),this.loose=H,this.parse(U),this.semver===we?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(U,H){return C(H,U)},e.major=function(U,H){return new R(U,H).major},e.minor=function(U,H){return new R(U,H).minor},e.patch=function(U,H){return new R(U,H).patch},e.compare=F,e.compareLoose=function(U,H){return F(U,H,!0)},e.rcompare=function(U,H,J){return F(H,U,J)},e.sort=function(U,H){return U.sort(function(J,he){return e.compare(J,he,H)})},e.rsort=function(U,H){return U.sort(function(J,he){return e.rcompare(J,he,H)})},e.gt=V,e.lt=G,e.eq=te,e.neq=oe,e.gte=ge,e.lte=ve,e.cmp=le,e.Comparator=ce;var we={};function se(U,H){if(U instanceof se)return U.loose===H?U:new se(U.raw,H);if(U instanceof ce)return new se(U.value,H);if(!(this instanceof se))return new se(U,H);if(this.loose=H,this.raw=U,this.set=U.split(/\s*\|\|\s*/).map(function(J){return this.parseRange(J.trim())},this).filter(function(J){return J.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+U);this.format()}function ue(U){return!U||U.toLowerCase()==="x"||U==="*"}function be(U,H,J,he,pe,Oe,Se,Le,Pe,De,Fe,Re,Te){return((H=ue(J)?"":ue(he)?">="+J+".0.0":ue(pe)?">="+J+"."+he+".0":">="+H)+" "+(Le=ue(Pe)?"":ue(De)?"<"+(+Pe+1)+".0.0":ue(Fe)?"<"+Pe+"."+(+De+1)+".0":Re?"<="+Pe+"."+De+"."+Fe+"-"+Re:"<="+Le)).trim()}function je(U,H){for(var J=0;J<U.length;J++)if(!U[J].test(H))return!1;if(H.prerelease.length){for(J=0;J<U.length;J++)if(k(U[J].semver),U[J].semver!==we&&U[J].semver.prerelease.length>0){var he=U[J].semver;if(he.major===H.major&&he.minor===H.minor&&he.patch===H.patch)return!0}return!1}return!0}function Ce(U,H,J){try{H=new se(H,J)}catch{return!1}return H.test(U)}function Ne(U,H,J,he){var pe,Oe,Se,Le,Pe;switch(U=new R(U,he),H=new se(H,he),J){case">":pe=V,Oe=ve,Se=G,Le=">",Pe=">=";break;case"<":pe=G,Oe=ge,Se=V,Le="<",Pe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ce(U,H,he))return!1;for(var De=0;De<H.set.length;++De){var Fe=H.set[De],Re=null,Te=null;if(Fe.forEach(function(Me){Me.semver===we&&(Me=new ce(">=0.0.0")),Re=Re||Me,Te=Te||Me,pe(Me.semver,Re.semver,he)?Re=Me:Se(Me.semver,Te.semver,he)&&(Te=Me)}),Re.operator===Le||Re.operator===Pe||(!Te.operator||Te.operator===Le)&&Oe(U,Te.semver)||Te.operator===Pe&&Se(U,Te.semver))return!1}return!0}ce.prototype.parse=function(U){var H=this.loose?b[me]:b[z],J=U.match(H);if(!J)throw new TypeError("Invalid comparator: "+U);this.operator=J[1],this.operator==="="&&(this.operator=""),J[2]?this.semver=new R(J[2],this.loose):this.semver=we},ce.prototype.toString=function(){return this.value},ce.prototype.test=function(U){return k("Comparator.test",U,this.loose),this.semver===we||(typeof U=="string"&&(U=new R(U,this.loose)),le(U,this.operator,this.semver,this.loose))},ce.prototype.intersects=function(U,H){if(!(U instanceof ce))throw new TypeError("a Comparator is required");var J;if(this.operator==="")return J=new se(U.value,H),Ce(this.value,J,H);if(U.operator==="")return J=new se(this.value,H),Ce(U.semver,J,H);var he=!(this.operator!==">="&&this.operator!==">"||U.operator!==">="&&U.operator!==">"),pe=!(this.operator!=="<="&&this.operator!=="<"||U.operator!=="<="&&U.operator!=="<"),Oe=this.semver.version===U.semver.version,Se=!(this.operator!==">="&&this.operator!=="<="||U.operator!==">="&&U.operator!=="<="),Le=le(this.semver,"<",U.semver,H)&&(this.operator===">="||this.operator===">")&&(U.operator==="<="||U.operator==="<"),Pe=le(this.semver,">",U.semver,H)&&(this.operator==="<="||this.operator==="<")&&(U.operator===">="||U.operator===">");return he||pe||Oe&&Se||Le||Pe},e.Range=se,se.prototype.format=function(){return this.range=this.set.map(function(U){return U.join(" ").trim()}).join("||").trim(),this.range},se.prototype.toString=function(){return this.range},se.prototype.parseRange=function(U){var H=this.loose;U=U.trim(),k("range",U,H);var J=H?b[B]:b[M];U=U.replace(J,be),k("hyphen replace",U),U=U.replace(b[j],"$1$2$3"),k("comparator trim",U,b[j]),U=(U=(U=U.replace(b[X],"$1~")).replace(b[ae],"$1^")).split(/\s+/).join(" ");var he=H?b[me]:b[z],pe=U.split(" ").map(function(Oe){return function(Se,Le){return k("comp",Se),Se=function(Pe,De){return Pe.trim().split(/\s+/).map(function(Fe){return function(Re,Te){k("caret",Re,Te);var Me=Te?b[re]:b[fe];return Re.replace(Me,function(Ue,Ee,ye,Ie,ke){var Ae;return k("caret",Re,Ue,Ee,ye,Ie,ke),ue(Ee)?Ae="":ue(ye)?Ae=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":ue(Ie)?Ae=Ee==="0"?">="+Ee+"."+ye+".0 <"+Ee+"."+(+ye+1)+".0":">="+Ee+"."+ye+".0 <"+(+Ee+1)+".0.0":ke?(k("replaceCaret pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),Ae=Ee==="0"?ye==="0"?">="+Ee+"."+ye+"."+Ie+ke+" <"+Ee+"."+ye+"."+(+Ie+1):">="+Ee+"."+ye+"."+Ie+ke+" <"+Ee+"."+(+ye+1)+".0":">="+Ee+"."+ye+"."+Ie+ke+" <"+(+Ee+1)+".0.0"):(k("no pr"),Ae=Ee==="0"?ye==="0"?">="+Ee+"."+ye+"."+Ie+" <"+Ee+"."+ye+"."+(+Ie+1):">="+Ee+"."+ye+"."+Ie+" <"+Ee+"."+(+ye+1)+".0":">="+Ee+"."+ye+"."+Ie+" <"+(+Ee+1)+".0.0"),k("caret return",Ae),Ae})}(Fe,De)}).join(" ")}(Se,Le),k("caret",Se),Se=function(Pe,De){return Pe.trim().split(/\s+/).map(function(Fe){return function(Re,Te){var Me=Te?b[ie]:b[ee];return Re.replace(Me,function(Ue,Ee,ye,Ie,ke){var Ae;return k("tilde",Re,Ue,Ee,ye,Ie,ke),ue(Ee)?Ae="":ue(ye)?Ae=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":ue(Ie)?Ae=">="+Ee+"."+ye+".0 <"+Ee+"."+(+ye+1)+".0":ke?(k("replaceTilde pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),Ae=">="+Ee+"."+ye+"."+Ie+ke+" <"+Ee+"."+(+ye+1)+".0"):Ae=">="+Ee+"."+ye+"."+Ie+" <"+Ee+"."+(+ye+1)+".0",k("tilde return",Ae),Ae})}(Fe,De)}).join(" ")}(Se,Le),k("tildes",Se),Se=function(Pe,De){return k("replaceXRanges",Pe,De),Pe.split(/\s+/).map(function(Fe){return function(Re,Te){Re=Re.trim();var Me=Te?b[A]:b[w];return Re.replace(Me,function(Ue,Ee,ye,Ie,ke,Ae){k("xRange",Re,Ue,Ee,ye,Ie,ke,Ae);var We=ue(ye),ze=We||ue(Ie),Be=ze||ue(ke);return Ee==="="&&Be&&(Ee=""),We?Ue=Ee===">"||Ee==="<"?"<0.0.0":"*":Ee&&Be?(ze&&(Ie=0),Be&&(ke=0),Ee===">"?(Ee=">=",ze?(ye=+ye+1,Ie=0,ke=0):Be&&(Ie=+Ie+1,ke=0)):Ee==="<="&&(Ee="<",ze?ye=+ye+1:Ie=+Ie+1),Ue=Ee+ye+"."+Ie+"."+ke):ze?Ue=">="+ye+".0.0 <"+(+ye+1)+".0.0":Be&&(Ue=">="+ye+"."+Ie+".0 <"+ye+"."+(+Ie+1)+".0"),k("xRange return",Ue),Ue})}(Fe,De)}).join(" ")}(Se,Le),k("xrange",Se),Se=function(Pe,De){return k("replaceStars",Pe,De),Pe.trim().replace(b[W],"")}(Se,Le),k("stars",Se),Se}(Oe,H)}).join(" ").split(/\s+/);return this.loose&&(pe=pe.filter(function(Oe){return!!Oe.match(he)})),pe=pe.map(function(Oe){return new ce(Oe,H)})},se.prototype.intersects=function(U,H){if(!(U instanceof se))throw new TypeError("a Range is required");return this.set.some(function(J){return J.every(function(he){return U.set.some(function(pe){return pe.every(function(Oe){return he.intersects(Oe,H)})})})})},e.toComparators=function(U,H){return new se(U,H).set.map(function(J){return J.map(function(he){return he.value}).join(" ").trim().split(" ")})},se.prototype.test=function(U){if(!U)return!1;typeof U=="string"&&(U=new R(U,this.loose));for(var H=0;H<this.set.length;H++)if(je(this.set[H],U))return!0;return!1},e.satisfies=Ce,e.maxSatisfying=function(U,H,J){var he=null,pe=null;try{var Oe=new se(H,J)}catch{return null}return U.forEach(function(Se){Oe.test(Se)&&(he&&pe.compare(Se)!==-1||(pe=new R(he=Se,J)))}),he},e.minSatisfying=function(U,H,J){var he=null,pe=null;try{var Oe=new se(H,J)}catch{return null}return U.forEach(function(Se){Oe.test(Se)&&(he&&pe.compare(Se)!==1||(pe=new R(he=Se,J)))}),he},e.validRange=function(U,H){try{return new se(U,H).range||"*"}catch{return null}},e.ltr=function(U,H,J){return Ne(U,H,"<",J)},e.gtr=function(U,H,J){return Ne(U,H,">",J)},e.outside=Ne,e.prerelease=function(U,H){var J=K(U,H);return J&&J.prerelease.length?J.prerelease:null},e.intersects=function(U,H,J){return U=new se(U,J),H=new se(H,J),U.intersects(H)},e.coerce=function(U){if(U instanceof R)return U;if(typeof U!="string")return null;var H=U.match(b[$]);return H==null?null:K((H[1]||"0")+"."+(H[2]||"0")+"."+(H[3]||"0"))}}).call(this,T(1))},function(x,e){var T,O,k=x.exports={};function D(){throw new Error("setTimeout has not been defined")}function N(){throw new Error("clearTimeout has not been defined")}function b(d){if(T===setTimeout)return setTimeout(d,0);if((T===D||!T)&&setTimeout)return T=setTimeout,setTimeout(d,0);try{return T(d,0)}catch{try{return T.call(null,d,0)}catch{return T.call(this,d,0)}}}(function(){try{T=typeof setTimeout=="function"?setTimeout:D}catch{T=D}try{O=typeof clearTimeout=="function"?clearTimeout:N}catch{O=N}})();var f,c=[],p=!1,v=-1;function g(){p&&f&&(p=!1,f.length?c=f.concat(c):v=-1,c.length&&I())}function I(){if(!p){var d=b(g);p=!0;for(var l=c.length;l;){for(f=c,c=[];++v<l;)f&&f[v].run();v=-1,l=c.length}f=null,p=!1,function(m){if(O===clearTimeout)return clearTimeout(m);if((O===N||!O)&&clearTimeout)return O=clearTimeout,clearTimeout(m);try{O(m)}catch{try{return O.call(null,m)}catch{return O.call(this,m)}}}(d)}}function E(d,l){this.fun=d,this.array=l}function L(){}k.nextTick=function(d){var l=new Array(arguments.length-1);if(arguments.length>1)for(var m=1;m<arguments.length;m++)l[m-1]=arguments[m];c.push(new E(d,l)),c.length!==1||p||b(I)},E.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=L,k.addListener=L,k.once=L,k.off=L,k.removeListener=L,k.removeAllListeners=L,k.emit=L,k.prependListener=L,k.prependOnceListener=L,k.listeners=function(d){return[]},k.binding=function(d){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(d){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(Y[72],Q([0,1]),function(x,e){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class O{constructor(b,f,c){this.level=b,this.key=f,this.value=c,this.forward=[]}}const k=void 0;class D{constructor(b,f=2**16){this.comparator=b,this[T]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(f)|0),this.e=new O(this.c,k,k)}get size(){return this.f}clear(){this.e=new O(this.c,k,k)}has(b){return Boolean(D.g(this,b,this.comparator))}get(b){return D.g(this,b,this.comparator)?.value}set(b,f){return D.h(this,b,f,this.comparator)&&(this.f+=1),this}delete(b){const f=D.k(this,b,this.comparator);return f&&(this.f-=1),f}forEach(b,f){let c=this.e.forward[0];for(;c;)b.call(f,c.value,c.key,this),c=c.forward[0]}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let b=this.e.forward[0];for(;b;)yield[b.key,b.value],b=b.forward[0]}*keys(){let b=this.e.forward[0];for(;b;)yield b.key,b=b.forward[0]}*values(){let b=this.e.forward[0];for(;b;)yield b.value,b=b.forward[0]}toString(){let b="[SkipList]:",f=this.e.forward[0];for(;f;)b+=`node(${f.key}, ${f.value}, lvl:${f.level})`,f=f.forward[0];return b}static g(b,f,c){let p=b.e;for(let v=b.d-1;v>=0;v--)for(;p.forward[v]&&c(p.forward[v].key,f)<0;)p=p.forward[v];if(p=p.forward[0],p&&c(p.key,f)===0)return p}static h(b,f,c,p){const v=[];let g=b.e;for(let I=b.d-1;I>=0;I--){for(;g.forward[I]&&p(g.forward[I].key,f)<0;)g=g.forward[I];v[I]=g}if(g=g.forward[0],g&&p(g.key,f)===0)return g.value=c,!1;{const I=D.j(b);if(I>b.d){for(let E=b.d;E<I;E++)v[E]=b.e;b.d=I}g=new O(I,f,c);for(let E=0;E<I;E++)g.forward[E]=v[E].forward[E],v[E].forward[E]=g;return!0}}static j(b,f=.5){let c=1;for(;Math.random()<f&&c<b.c;)c+=1;return c}static k(b,f,c){const p=[];let v=b.e;for(let g=b.d-1;g>=0;g--){for(;v.forward[g]&&c(v.forward[g].key,f)<0;)v=v.forward[g];p[g]=v}if(v=v.forward[0],!v||c(v.key,f)!==0)return!1;for(let g=0;g<b.d&&p[g].forward[g]===v;g++)p[g].forward[g]=v.forward[g];for(;b.d>0&&b.e.forward[b.d-1]===k;)b.d-=1;return!0}}e.SkipList=D}),define(Y[43],Q([0,1,6,2]),function(x,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function k(h){const y=h;return y?typeof y.read=="function":!1}e.isReadable=k;function D(h){const y=h;return y?[y.on,y.pause,y.resume,y.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=D;function N(h){const y=h;return y?D(y.stream)&&Array.isArray(y.buffer)&&typeof y.ended=="boolean":!1}e.isReadableBufferedStream=N;function b(h,y){return new f(h,y)}e.newWriteableStream=b;class f{constructor(y,t){this.e=y,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(y){if(!this.a.destroyed){if(this.a.flowing)this.g(y);else if(this.b.data.push(y),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(y){this.a.destroyed||(this.a.flowing?this.h(y):this.b.error.push(y))}end(y){this.a.destroyed||(typeof y<"u"&&this.write(y),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(y){this.c.data.slice(0).forEach(t=>t(y))}h(y){this.c.error.length===0?(0,T.onUnexpectedError)(y):this.c.error.slice(0).forEach(t=>t(y))}i(){this.c.end.slice(0).forEach(y=>y())}on(y,t){if(!this.a.destroyed)switch(y){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(y,t){if(this.a.destroyed)return;let r;switch(y){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const i=r.indexOf(t);i>=0&&r.splice(i,1)}}j(){if(this.b.data.length>0){const y=this.e(this.b.data);this.g(y),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const y of this.b.error)this.h(y);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(h,y){const t=[];let r;for(;(r=h.read())!==null;)t.push(r);return y(t)}e.consumeReadable=c;function p(h,y,t){const r=[];let i;for(;(i=h.read())!==null&&r.length<t;)r.push(i);return i===null&&r.length>0?y(r):{read:()=>{if(r.length>0)return r.shift();if(typeof i<"u"){const n=i;return i=void 0,n}return h.read()}}}e.peekReadable=p;function v(h,y){return new Promise((t,r)=>{const i=[];g(h,{onData:n=>{y&&i.push(n)},onError:n=>{y?r(n):t(void 0)},onEnd:()=>{t(y?y(i):void 0)}})})}e.consumeStream=v;function g(h,y){let t=!1;return h.on("error",r=>{t||y.onError(r)}),h.on("end",()=>{t||y.onEnd()}),h.on("data",r=>{t||y.onData(r)}),(0,O.toDisposable)(()=>t=!0)}e.listenStream=g;function I(h,y){return new Promise((t,r)=>{const i=new O.DisposableStore,n=[],s=u=>{if(n.push(u),n.length>y)return i.dispose(),h.pause(),t({stream:h,buffer:n,ended:!1})},a=u=>r(u),o=()=>t({stream:h,buffer:n,ended:!0});i.add((0,O.toDisposable)(()=>h.removeListener("error",a))),h.on("error",a),i.add((0,O.toDisposable)(()=>h.removeListener("end",o))),h.on("end",o),i.add((0,O.toDisposable)(()=>h.removeListener("data",s))),h.on("data",s)})}e.peekStream=I;function E(h,y){const t=b(y);return t.end(h),t}e.toStream=E;function L(){const h=b(()=>{throw new Error("not supported")});return h.end(),h}e.emptyStream=L;function d(h){let y=!1;return{read:()=>y?null:(y=!0,h)}}e.toReadable=d;function l(h,y,t){const r=b(t);return g(h,{onData:i=>r.write(y.data(i)),onError:i=>r.error(y.error?y.error(i):i),onEnd:()=>r.end()}),r}e.transform=l;function m(h,y,t){let r=!1;return{read:()=>{const i=y.read();return r?i:(r=!0,i!==null?t([h,i]):h)}}}e.prefixedReadable=m;function S(h,y,t){let r=!1;const i=b(t);return g(y,{onData:n=>r?i.write(n):(r=!0,i.write(t([h,n]))),onError:n=>i.error(n),onEnd:()=>{r||(r=!0,i.write(h)),i.end()}}),i}e.prefixedStream=S}),define(Y[15],Q([0,1,43]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const O=typeof Buffer<"u";let k,D;class N{static alloc(u){return O?new N(Buffer.allocUnsafe(u)):new N(new Uint8Array(u))}static wrap(u){return O&&!Buffer.isBuffer(u)&&(u=Buffer.from(u.buffer,u.byteOffset,u.byteLength)),new N(u)}static fromString(u,w){return!(w?.dontUseNodeBuffer||!1)&&O?new N(Buffer.from(u)):(k||(k=new TextEncoder),new N(k.encode(u)))}static fromByteArray(u){const w=N.alloc(u.length);for(let A=0,$=u.length;A<$;A++)w.buffer[A]=u[A];return w}static concat(u,w){if(typeof w>"u"){w=0;for(let Z=0,X=u.length;Z<X;Z++)w+=u[Z].byteLength}const A=N.alloc(w);let $=0;for(let Z=0,X=u.length;Z<X;Z++){const ee=u[Z];A.set(ee,$),$+=ee.byteLength}return A}constructor(u){this.buffer=u,this.byteLength=this.buffer.byteLength}clone(){const u=N.alloc(this.byteLength);return u.set(this),u}toString(){return O?this.buffer.toString():(D||(D=new TextDecoder),D.decode(this.buffer))}slice(u,w){return new N(this.buffer.subarray(u,w))}set(u,w){if(u instanceof N)this.buffer.set(u.buffer,w);else if(u instanceof Uint8Array)this.buffer.set(u,w);else if(u instanceof ArrayBuffer)this.buffer.set(new Uint8Array(u),w);else if(ArrayBuffer.isView(u))this.buffer.set(new Uint8Array(u.buffer,u.byteOffset,u.byteLength),w);else throw new Error("Unknown argument 'array'")}readUInt32BE(u){return c(this.buffer,u)}writeUInt32BE(u,w){p(this.buffer,u,w)}readUInt32LE(u){return v(this.buffer,u)}writeUInt32LE(u,w){g(this.buffer,u,w)}readUInt8(u){return I(this.buffer,u)}writeUInt8(u,w){E(this.buffer,u,w)}}e.VSBuffer=N;function b(o,u){return o[u+0]<<0>>>0|o[u+1]<<8>>>0}e.readUInt16LE=b;function f(o,u,w){o[w+0]=u&255,u=u>>>8,o[w+1]=u&255}e.writeUInt16LE=f;function c(o,u){return o[u]*2**24+o[u+1]*2**16+o[u+2]*2**8+o[u+3]}e.readUInt32BE=c;function p(o,u,w){o[w+3]=u,u=u>>>8,o[w+2]=u,u=u>>>8,o[w+1]=u,u=u>>>8,o[w]=u}e.writeUInt32BE=p;function v(o,u){return o[u+0]<<0>>>0|o[u+1]<<8>>>0|o[u+2]<<16>>>0|o[u+3]<<24>>>0}e.readUInt32LE=v;function g(o,u,w){o[w+0]=u&255,u=u>>>8,o[w+1]=u&255,u=u>>>8,o[w+2]=u&255,u=u>>>8,o[w+3]=u&255}e.writeUInt32LE=g;function I(o,u){return o[u]}e.readUInt8=I;function E(o,u,w){o[w]=u}e.writeUInt8=E;function L(o){return T.consumeReadable(o,u=>N.concat(u))}e.readableToBuffer=L;function d(o){return T.toReadable(o)}e.bufferToReadable=d;function l(o){return T.consumeStream(o,u=>N.concat(u))}e.streamToBuffer=l;async function m(o){return o.ended?N.concat(o.buffer):N.concat([...o.buffer,await l(o.stream)])}e.bufferedStreamToBuffer=m;function S(o){return T.toStream(o,u=>N.concat(u))}e.bufferToStream=S;function h(o){return T.transform(o,{data:u=>typeof u=="string"?N.fromString(u):N.wrap(u)},u=>N.concat(u))}e.streamToBufferReadableStream=h;function y(o){return T.newWriteableStream(u=>N.concat(u),o)}e.newWriteableBufferStream=y;function t(o,u){return T.prefixedReadable(o,u,w=>N.concat(w))}e.prefixedBufferReadable=t;function r(o,u){return T.prefixedStream(o,u,w=>N.concat(w))}e.prefixedBufferStream=r;function i(o){let u=0,w=0,A=0;const $=new Uint8Array(Math.floor(o.length/4*3)),Z=ee=>{switch(w){case 3:$[A++]=u|ee,w=0;break;case 2:$[A++]=u|ee>>>2,u=ee<<6,w=3;break;case 1:$[A++]=u|ee>>>4,u=ee<<4,w=2;break;default:u=ee<<2,w=1}};for(let ee=0;ee<o.length;ee++){const ie=o.charCodeAt(ee);if(ie>=65&&ie<=90)Z(ie-65);else if(ie>=97&&ie<=122)Z(ie-97+26);else if(ie>=48&&ie<=57)Z(ie-48+52);else if(ie===43||ie===45)Z(62);else if(ie===47||ie===95)Z(63);else{if(ie===61)break;throw new SyntaxError(`Unexpected base64 character ${o[ee]}`)}}const X=A;for(;w>0;)Z(0);return N.wrap($).slice(0,X)}e.decodeBase64=i;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function a({buffer:o},u=!0,w=!1){const A=w?s:n;let $="";const Z=o.byteLength%3;let X=0;for(;X<o.byteLength-Z;X+=3){const ee=o[X+0],ie=o[X+1],ne=o[X+2];$+=A[ee>>>2],$+=A[(ee<<4|ie>>>4)&63],$+=A[(ie<<2|ne>>>6)&63],$+=A[ne&63]}if(Z===1){const ee=o[X+0];$+=A[ee>>>2],$+=A[ee<<4&63],u&&($+="==")}else if(Z===2){const ee=o[X+0],ie=o[X+1];$+=A[ee>>>2],$+=A[(ee<<4|ie>>>4)&63],$+=A[ie<<2&63],u&&($+="=")}return $}e.encodeBase64=a}),define(Y[30],Q([0,1,4]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function O(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const m=Array.isArray(l)?[]:{};return Object.entries(l).forEach(([S,h])=>{m[S]=h&&typeof h=="object"?O(h):h}),m}e.deepClone=O;function k(l){if(!l||typeof l!="object")return l;const m=[l];for(;m.length>0;){const S=m.shift();Object.freeze(S);for(const h in S)if(D.call(S,h)){const y=S[h];typeof y=="object"&&!Object.isFrozen(y)&&!(0,T.isTypedArray)(y)&&m.push(y)}}return l}e.deepFreeze=k;const D=Object.prototype.hasOwnProperty;function N(l,m){return b(l,m,new Set)}e.cloneAndChange=N;function b(l,m,S){if((0,T.isUndefinedOrNull)(l))return l;const h=m(l);if(typeof h<"u")return h;if(Array.isArray(l)){const y=[];for(const t of l)y.push(b(t,m,S));return y}if((0,T.isObject)(l)){if(S.has(l))throw new Error("Cannot clone recursive data-structure");S.add(l);const y={};for(const t in l)D.call(l,t)&&(y[t]=b(l[t],m,S));return S.delete(l),y}return l}function f(l,m,S=!0){return(0,T.isObject)(l)?((0,T.isObject)(m)&&Object.keys(m).forEach(h=>{h in l?S&&((0,T.isObject)(l[h])&&(0,T.isObject)(m[h])?f(l[h],m[h],S):l[h]=m[h]):l[h]=m[h]}),l):m}e.mixin=f;function c(l,m){if(l===m)return!0;if(l==null||m===null||m===void 0||typeof l!=typeof m||typeof l!="object"||Array.isArray(l)!==Array.isArray(m))return!1;let S,h;if(Array.isArray(l)){if(l.length!==m.length)return!1;for(S=0;S<l.length;S++)if(!c(l[S],m[S]))return!1}else{const y=[];for(h in l)y.push(h);y.sort();const t=[];for(h in m)t.push(h);if(t.sort(),!c(y,t))return!1;for(S=0;S<y.length;S++)if(!c(l[y[S]],m[y[S]]))return!1}return!0}e.equals=c;function p(l){const m=new Set;return JSON.stringify(l,(S,h)=>{if((0,T.isObject)(h)||Array.isArray(h)){if(m.has(h))return"[Circular]";m.add(h)}return h})}e.safeStringify=p;function v(l,m){const S=Object.create(null);return!l||!m||Object.keys(m).forEach(y=>{const t=l[y],r=m[y];c(t,r)||(S[y]=r)}),S}e.distinct=v;function g(l,m){const S=m.toLowerCase(),h=Object.keys(l).find(y=>y.toLowerCase()===S);return h?l[h]:l[m]}e.getCaseInsensitive=g;function I(l,m){const S=Object.create(null);for(const[h,y]of Object.entries(l))m(h,y)&&(S[h]=y);return S}e.filter=I;function E(l){let m=[],S=Object.getPrototypeOf(l);for(;Object.prototype!==S;)m=m.concat(Object.getOwnPropertyNames(S)),S=Object.getPrototypeOf(S);return m}e.getAllPropertyNames=E;function L(l){const m=[];for(const S of E(l))typeof l[S]=="function"&&m.push(S);return m}e.getAllMethodNames=L;function d(l,m){const S=y=>function(){const t=Array.prototype.slice.call(arguments,0);return m(y,t)},h={};for(const y of l)h[y]=S(y);return h}e.createProxyObject=d}),define(Y[31],Q([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const T=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function O(k){return T.test(k)}e.isUUID=O,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(b){for(let f=0;f<b.length;f++)b[f]=Math.floor(Math.random()*256);return b};const D=new Uint8Array(16),N=[];for(let b=0;b<256;b++)N.push(b.toString(16).padStart(2,"0"));return function(){k(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let f=0,c="";return c+=N[D[f++]],c+=N[D[f++]],c+=N[D[f++]],c+=N[D[f++]],c+="-",c+=N[D[f++]],c+=N[D[f++]],c+="-",c+=N[D[f++]],c+=N[D[f++]],c+="-",c+=N[D[f++]],c+=N[D[f++]],c+="-",c+=N[D[f++]],c+=N[D[f++]],c+=N[D[f++]],c+=N[D[f++]],c+=N[D[f++]],c+=N[D[f++]],c}}()}),define(Y[73],Q([0,1,33]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const O=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(N){const b=N.replace(/\-/g,":").toLowerCase();return!O.has(b)}function D(){const N=(0,T.networkInterfaces)();for(const b in N){const f=N[b];if(f){for(const{mac:c}of f)if(k(c))return c}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=D}),define(Y[74],Q([7,8]),function(x,e){return x.create("vs/base/common/date",e)}),define(Y[75],Q([0,1,74]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const O=60,k=O*60,D=k*24,N=D*7,b=D*30,f=D*365;function c(v,g,I,E){typeof v!="number"&&(v=v.getTime());const L=Math.round((new Date().getTime()-v)/1e3);if(L<-30)return(0,T.localize)(0,null,c(new Date().getTime()+L*1e3,!1));if(!E&&L<30)return(0,T.localize)(1,null);let d;return L<O?(d=L,g?d===1?I?(0,T.localize)(2,null,d):(0,T.localize)(3,null,d):I?(0,T.localize)(4,null,d):(0,T.localize)(5,null,d):d===1?I?(0,T.localize)(6,null,d):(0,T.localize)(7,null,d):I?(0,T.localize)(8,null,d):(0,T.localize)(9,null,d)):L<k?(d=Math.floor(L/O),g?d===1?I?(0,T.localize)(10,null,d):(0,T.localize)(11,null,d):I?(0,T.localize)(12,null,d):(0,T.localize)(13,null,d):d===1?I?(0,T.localize)(14,null,d):(0,T.localize)(15,null,d):I?(0,T.localize)(16,null,d):(0,T.localize)(17,null,d)):L<D?(d=Math.floor(L/k),g?d===1?I?(0,T.localize)(18,null,d):(0,T.localize)(19,null,d):I?(0,T.localize)(20,null,d):(0,T.localize)(21,null,d):d===1?I?(0,T.localize)(22,null,d):(0,T.localize)(23,null,d):I?(0,T.localize)(24,null,d):(0,T.localize)(25,null,d)):L<N?(d=Math.floor(L/D),g?d===1?(0,T.localize)(26,null,d):(0,T.localize)(27,null,d):d===1?(0,T.localize)(28,null,d):(0,T.localize)(29,null,d)):L<b?(d=Math.floor(L/N),g?d===1?I?(0,T.localize)(30,null,d):(0,T.localize)(31,null,d):I?(0,T.localize)(32,null,d):(0,T.localize)(33,null,d):d===1?I?(0,T.localize)(34,null,d):(0,T.localize)(35,null,d):I?(0,T.localize)(36,null,d):(0,T.localize)(37,null,d)):L<f?(d=Math.floor(L/b),g?d===1?I?(0,T.localize)(38,null,d):(0,T.localize)(39,null,d):I?(0,T.localize)(40,null,d):(0,T.localize)(41,null,d):d===1?I?(0,T.localize)(42,null,d):(0,T.localize)(43,null,d):I?(0,T.localize)(44,null,d):(0,T.localize)(45,null,d)):(d=Math.floor(L/f),g?d===1?I?(0,T.localize)(46,null,d):(0,T.localize)(47,null,d):I?(0,T.localize)(48,null,d):(0,T.localize)(49,null,d):d===1?I?(0,T.localize)(50,null,d):(0,T.localize)(51,null,d):I?(0,T.localize)(52,null,d):(0,T.localize)(53,null,d))}e.fromNow=c;function p(v){return v.getFullYear()+"-"+String(v.getMonth()+1).padStart(2,"0")+"-"+String(v.getDate()).padStart(2,"0")+"T"+String(v.getHours()).padStart(2,"0")+":"+String(v.getMinutes()).padStart(2,"0")+":"+String(v.getSeconds()).padStart(2,"0")+"."+(v.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=p}),define(Y[76],Q([7,8]),function(x,e){return x.create("vs/base/common/errorMessage",e)}),define(Y[34],Q([0,1,19,4,76]),function(x,e,T,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function D(v,g){return g&&(v.stack||v.stacktrace)?k.localize(0,null,b(v),N(v.stack)||N(v.stacktrace)):b(v)}function N(v){return Array.isArray(v)?v.join(`
`):v}function b(v){return typeof v.code=="string"&&typeof v.errno=="number"&&typeof v.syscall=="string"?k.localize(1,null,v.message):v.message||k.localize(2,null)}function f(v=null,g=!1){if(!v)return k.localize(3,null);if(Array.isArray(v)){const I=T.coalesce(v),E=f(I[0],g);return I.length>1?k.localize(4,null,E,I.length):E}if(O.isString(v))return v;if(v.detail){const I=v.detail;if(I.error)return D(I.error,g);if(I.exception)return D(I.exception,g)}return v.stack?D(v,g):v.message?v.message:k.localize(5,null)}e.toErrorMessage=f;function c(v){const g=v;return g instanceof Error&&Array.isArray(g.actions)}e.isErrorWithActions=c;function p(v,g){let I;return typeof v=="string"?I=new Error(v):I=v,I.actions=g,I}e.createErrorWithActions=p}),define(Y[77],Q([7,8]),function(x,e){return x.create("vs/base/common/jsonErrorMessages",e)}),define(Y[78],Q([0,1,77]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function O(k){switch(k){case 1:return(0,T.localize)(0,null);case 2:return(0,T.localize)(1,null);case 3:return(0,T.localize)(2,null);case 4:return(0,T.localize)(3,null);case 5:return(0,T.localize)(4,null);case 6:return(0,T.localize)(5,null);case 7:return(0,T.localize)(6,null);case 8:return(0,T.localize)(7,null);case 9:return(0,T.localize)(8,null);default:return""}}e.getParseErrorMessage=O}),define(Y[51],Q([0,1,12]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var O;(function(b){b[b.stdout=0]="stdout",b[b.stderr=1]="stderr"})(O=e.Source||(e.Source={}));var k;(function(b){b[b.Success=0]="Success",b[b.Unknown=1]="Unknown",b[b.AccessDenied=2]="AccessDenied",b[b.ProcessNotFound=3]="ProcessNotFound"})(k=e.TerminateResponseCode||(e.TerminateResponseCode={}));function D(b,...f){const c=f.reduce((g,I)=>(g[I]=!0,g),{}),p=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(b).filter(g=>!c[g]).forEach(g=>{for(let I=0;I<p.length;I++)if(g.search(p[I])!==-1){delete b[g];break}})}e.sanitizeProcessEnvironment=D;function N(b){!b||(delete b.DEBUG,T.isMacintosh&&delete b.DYLD_LIBRARY_PATH,T.isLinux&&delete b.LD_PRELOAD)}e.removeDangerousEnvVariables=N}),define(Y[52],Q([0,1,32]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function O(l){return k(l,0)}e.hash=O;function k(l,m){switch(typeof l){case"object":return l===null?D(349,m):Array.isArray(l)?f(l,m):c(l,m);case"string":return b(l,m);case"boolean":return N(l,m);case"number":return D(l,m);case"undefined":return D(937,m);default:return D(617,m)}}e.doHash=k;function D(l,m){return(m<<5)-m+l|0}e.numberHash=D;function N(l,m){return D(l?433:863,m)}function b(l,m){m=D(149417,m);for(let S=0,h=l.length;S<h;S++)m=D(l.charCodeAt(S),m);return m}e.stringHash=b;function f(l,m){return m=D(104579,m),l.reduce((S,h)=>k(h,S),m)}function c(l,m){return m=D(181387,m),Object.keys(l).sort().reduce((S,h)=>(S=b(h,S),k(l[h],S)),m)}class p{constructor(){this.g=0}get value(){return this.g}hash(m){return this.g=k(m,this.g),this.g}}e.Hasher=p;var v;(function(l){l[l.BLOCK_SIZE=64]="BLOCK_SIZE",l[l.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(v||(v={}));function g(l,m,S=32){const h=S-m,y=~((1<<h)-1);return(l<<m|(y&l)>>>h)>>>0}function I(l,m=0,S=l.byteLength,h=0){for(let y=0;y<S;y++)l[m+y]=h}function E(l,m,S="0"){for(;l.length<m;)l=S+l;return l}function L(l,m=32){return l instanceof ArrayBuffer?Array.from(new Uint8Array(l)).map(S=>S.toString(16).padStart(2,"0")).join(""):E((l>>>0).toString(16),m/4)}e.toHexString=L;class d{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(m){const S=m.length;if(S===0)return;const h=this.p;let y=this.r,t=this.u,r,i;for(t!==0?(r=t,i=-1,t=0):(r=m.charCodeAt(0),i=0);;){let n=r;if(T.isHighSurrogate(r))if(i+1<S){const s=m.charCodeAt(i+1);T.isLowSurrogate(s)?(i++,n=T.computeCodePoint(r,s)):n=65533}else{t=r;break}else T.isLowSurrogate(r)&&(n=65533);if(y=this.w(h,y,n),i++,i<S)r=m.charCodeAt(i);else break}this.r=y,this.u=t}w(m,S,h){return h<128?m[S++]=h:h<2048?(m[S++]=192|(h&1984)>>>6,m[S++]=128|(h&63)>>>0):h<65536?(m[S++]=224|(h&61440)>>>12,m[S++]=128|(h&4032)>>>6,m[S++]=128|(h&63)>>>0):(m[S++]=240|(h&1835008)>>>18,m[S++]=128|(h&258048)>>>12,m[S++]=128|(h&4032)>>>6,m[S++]=128|(h&63)>>>0),S>=64&&(this.y(),S-=64,this.t+=64,m[0]=m[64+0],m[1]=m[64+1],m[2]=m[64+2]),S}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),L(this.h)+L(this.l)+L(this.m)+L(this.n)+L(this.o)}x(){this.p[this.r++]=128,I(this.p,this.r),this.r>56&&(this.y(),I(this.p));const m=8*this.t;this.q.setUint32(56,Math.floor(m/4294967296),!1),this.q.setUint32(60,m%4294967296,!1),this.y()}y(){const m=d.g,S=this.q;for(let o=0;o<64;o+=4)m.setUint32(o,S.getUint32(o,!1),!1);for(let o=64;o<320;o+=4)m.setUint32(o,g(m.getUint32(o-12,!1)^m.getUint32(o-32,!1)^m.getUint32(o-56,!1)^m.getUint32(o-64,!1),1),!1);let h=this.h,y=this.l,t=this.m,r=this.n,i=this.o,n,s,a;for(let o=0;o<80;o++)o<20?(n=y&t|~y&r,s=1518500249):o<40?(n=y^t^r,s=1859775393):o<60?(n=y&t|y&r|t&r,s=2400959708):(n=y^t^r,s=3395469782),a=g(h,5)+n+i+s+m.getUint32(o*4,!1)&4294967295,i=r,r=t,t=g(y,30),y=h,h=a;this.h=this.h+h&4294967295,this.l=this.l+y&4294967295,this.m=this.m+t&4294967295,this.n=this.n+r&4294967295,this.o=this.o+i&4294967295}}e.StringSHA1=d,d.g=new DataView(new ArrayBuffer(320))}),define(Y[53],Q([0,1,32]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var O;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(O||(O={})),function(k){const D="error",N="warning",b="warn",f="info",c="ignore";function p(g){return g?T.equalsIgnoreCase(D,g)?k.Error:T.equalsIgnoreCase(N,g)||T.equalsIgnoreCase(b,g)?k.Warning:T.equalsIgnoreCase(f,g)?k.Info:k.Ignore:k.Ignore}k.fromValue=p;function v(g){switch(g){case k.Error:return D;case k.Warning:return N;case k.Info:return f;default:return c}}k.toString=v}(O||(O={})),e.default=O}),define(Y[79],Q([0,1,11]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function O(c){const p=c;return p&&typeof p.type=="string"&&typeof p.severity=="string"}e.isRemoteConsoleLog=O;function k(c){const p=[];let v;try{const g=JSON.parse(c.arguments),I=g[g.length-1];I&&I.__$stack&&(g.pop(),v=I.__$stack),p.push(...g)}catch{p.push("Unable to log remote console arguments",c.arguments)}return{args:p,stack:v}}e.parse=k;function D(c){if(typeof c!="string")return D(k(c).stack);const p=c;if(p){const v=N(p),g=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(v||"");if(g&&g.length===4)return{uri:T.URI.file(g[1]),line:Number(g[2]),column:Number(g[3])}}}e.getFirstFrame=D;function N(c){if(!c)return c;const p=c.indexOf(`
`);return p===-1?c:c.substring(0,p)}function b(c,p){const{args:v,stack:g}=k(c),I=typeof v[0]=="string"&&v.length===1;let E=N(g);E&&(E=`(${E.trim()})`);let L=[];if(typeof v[0]=="string"?E&&I?L=[`%c[${p}] %c${v[0]} %c${E}`,f("blue"),f(""),f("grey")]:L=[`%c[${p}] %c${v[0]}`,f("blue"),f(""),...v.slice(1)]:L=[`%c[${p}]%`,f("blue"),...v],E&&!I&&L.push(E),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,L)}e.log=b;function f(c){return`color: ${c}`}}),define(Y[44],Q([0,1,15,32,11]),function(x,e,T,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function D(c){return JSON.stringify(c,b)}e.stringify=D;function N(c){let p=JSON.parse(c);return p=f(p),p}e.parse=N;function b(c,p){return p instanceof RegExp?{$mid:2,source:p.source,flags:(0,O.regExpFlags)(p)}:p}function f(c,p=0){if(!c||p>200)return c;if(typeof c=="object"){switch(c.$mid){case 1:return k.URI.revive(c);case 2:return new RegExp(c.source,c.flags);case 16:return new Date(c.source)}if(c instanceof T.VSBuffer||c instanceof Uint8Array)return c;if(Array.isArray(c))for(let v=0;v<c.length;++v)c[v]=f(c[v],p+1);else for(const v in c)Object.hasOwnProperty.call(c,v)&&(c[v]=f(c[v],p+1))}return c}e.revive=f}),define(Y[80],Q([0,1,33,6,54,31,73]),function(x,e,T,O,k,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(p){return this.a||(this.a=k.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(p)}value(){if(this.b===void 0){let p=0,v=0;const g=(0,T.networkInterfaces)();for(const I in g){const E=g[I];if(E)for(const{mac:L,internal:d}of E)d||(v+=1,this.c(L.toUpperCase())&&(p+=1))}this.b=v>0?p/v:0}return this.b}};let b;async function f(){return b||(b=(async()=>await c()||D.generateUuid())()),b}e.getMachineId=f;async function c(){try{const p=await new Promise((g,I)=>{x(["crypto"],g,I)}),v=(0,N.getMac)();return p.createHash("sha256").update(v,"utf8").digest("hex")}catch(p){O.onUnexpectedError(p);return}}}),define(Y[81],Q([0,1,33,14,20]),function(x,e,T,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const D=/^\d+$/,N=/^Microsoft.PowerShell_.*/,b=/^Microsoft.PowerShellPreview_.*/;var f;(function(h){h[h.x64=0]="x64",h[h.x86=1]="x86",h[h.ARM=2]="ARM"})(f||(f={}));let c;switch(process.arch){case"ia32":case"x32":c=1;break;case"arm":case"arm64":c=2;break;default:c=0;break}let p;process.env.PROCESSOR_ARCHITEW6432?p=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?p=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?p=1:p=0;class v{constructor(y,t,r){this.exePath=y,this.displayName=t,this.a=r}async exists(){return this.a===void 0&&(this.a=await k.SymlinkSupport.existsFile(this.exePath)),this.a}}function g({useAlternateBitness:h=!1}={}){return h?c===0?process.env["ProgramFiles(x86)"]||null:p===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function I({useAlternateBitness:h=!1,findPreview:y=!1}={}){const t=g({useAlternateBitness:h});if(!t)return null;const r=O.join(t,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(r))return null;let i=-1,n=null;for(const o of await k.Promises.readdir(r)){let u=-1;if(y){const A=o.indexOf("-");if(A<0)continue;const $=o.substring(0,A);if(!D.test($)||o.substring(A+1)!=="preview")continue;u=parseInt($,10)}else{if(!D.test(o))continue;u=parseInt(o,10)}if(u<=i)continue;const w=O.join(r,o,"pwsh.exe");!await k.SymlinkSupport.existsFile(w)||(n=w,i=u)}if(!n)return null;const s=t.includes("x86")?" (x86)":"",a=y?" Preview":"";return new v(n,`PowerShell${a}${s}`,!0)}async function E({findPreview:h}={}){if(!process.env.LOCALAPPDATA)return null;const y=O.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(y))return null;const{pwshMsixDirRegex:t,pwshMsixName:r}=h?{pwshMsixDirRegex:b,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:N,pwshMsixName:"PowerShell (Store)"};for(const i of await k.Promises.readdir(y))if(t.test(i)){const n=O.join(y,i,"pwsh.exe");return new v(n,r)}return null}function L(){const h=O.join(T.homedir(),".dotnet","tools","pwsh.exe");return new v(h,".NET Core PowerShell Global Tool")}function d(){const h=O.join(process.env.windir,c===1&&p!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new v(h,"Windows PowerShell",!0)}async function*l(){let h=await I();h&&(yield h),h=await I({useAlternateBitness:!0}),h&&(yield h),h=await E(),h&&(yield h),h=L(),h&&(yield h),h=await I({findPreview:!0}),h&&(yield h),h=await E({findPreview:!0}),h&&(yield h),h=await I({useAlternateBitness:!0,findPreview:!0}),h&&(yield h),h=d(),h&&(yield h)}async function*m(){for await(const h of l())await h.exists()&&(yield h)}e.enumeratePowerShellInstallations=m;async function S(){for await(const h of m())return h;return null}e.getFirstAvailablePowerShellInstallation=S}),define(Y[55],Q([0,1,14,12,35,51,4,20]),function(x,e,T,O,k,D,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return D.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return D.TerminateResponseCode}});function f(v=k.env){return v.comspec||"cmd.exe"}e.getWindowsShell=f;function c(v){let g=[],I=!1;const E=function(L){if(I){g.push(L);return}(!v.send(L,l=>{if(l&&console.error(l),I=!1,g.length>0){const m=g.slice(0);g=[],m.forEach(S=>E(S))}})||O.isWindows)&&(I=!0)};return{send:E}}e.createQueuedSender=c;var p;(function(v){async function g(I,E,L){if(T.isAbsolute(I))return I;if(E===void 0&&(E=k.cwd()),T.dirname(I)!=="."||(L===void 0&&N.isString(k.env.PATH)&&(L=k.env.PATH.split(T.delimiter)),L===void 0||L.length===0))return T.join(E,I);async function l(m){if(await b.Promises.exists(m)){let S;try{S=await b.Promises.stat(m)}catch(h){h.message.startsWith("EACCES")&&(S=await b.Promises.lstat(m))}return S?!S.isDirectory():!1}return!1}for(const m of L){let S;if(T.isAbsolute(m)?S=T.join(m,I):S=T.join(E,m,I),await l(S))return S;let h=S+".com";if(await l(h)||(h=S+".exe",await l(h)))return h}return T.join(E,I)}v.findExecutable=g})(p=e.win32||(e.win32={}))}),define(Y[82],Q([0,1,33,12,81,55]),function(x,e,T,O,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function N(v,g){return v===1?O.isWindows?p():D.getWindowsShell(g):f(v,g)}e.getSystemShell=N;let b=null;function f(v,g){if(O.isLinux&&v===2||O.isMacintosh&&v===3)return"/bin/bash";if(!b){let I;if(O.isWindows)I="/bin/bash";else{if(I=g.SHELL,!I)try{I=(0,T.userInfo)().shell}catch{}I||(I="sh"),I==="/bin/false"&&(I="/bin/bash")}b=I}return b}let c=null;async function p(){return c||(c=(await(0,k.getFirstAvailablePowerShellInstallation)()).exePath),c}});var de=this&&this.__decorate||function(x,e,T,O){var k=arguments.length,D=k<3?e:O===null?O=Object.getOwnPropertyDescriptor(e,T):O,N;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")D=Reflect.decorate(x,e,T,O);else for(var b=x.length-1;b>=0;b--)(N=x[b])&&(D=(k<3?N(D):k>3?N(e,T,D):N(e,T))||D);return k>3&&D&&Object.defineProperty(e,T,D),D};define(Y[56],Q([0,1,19,5,15,23,49,6,3,2,44,32,4]),function(x,e,T,O,k,D,N,b,f,c,p,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var I;(function(j){j[j.Promise=100]="Promise",j[j.PromiseCancel=101]="PromiseCancel",j[j.EventListen=102]="EventListen",j[j.EventDispose=103]="EventDispose"})(I||(I={}));function E(j){switch(j){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var L;(function(j){j[j.Initialize=200]="Initialize",j[j.PromiseSuccess=201]="PromiseSuccess",j[j.PromiseError=202]="PromiseError",j[j.PromiseErrorObj=203]="PromiseErrorObj",j[j.EventFire=204]="EventFire"})(L||(L={}));function d(j){switch(j){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var l;(function(j){j[j.Uninitialized=0]="Uninitialized",j[j.Idle=1]="Idle"})(l||(l={}));function m(j){let M=0;for(let B=0;;B+=7){const W=j.read(1);if(M|=(W.buffer[0]&127)<<B,!(W.buffer[0]&128))return M}}const S=i(0);function h(j,M){if(M===0){j.write(S);return}let B=0;for(let q=M;q!==0;q=q>>>7)B++;const W=k.VSBuffer.alloc(B);for(let q=0;M!==0;q++)W.buffer[q]=M&127,M=M>>>7,M>0&&(W.buffer[q]|=128);j.write(W)}class y{constructor(M){this.b=M,this.a=0}read(M){const B=this.b.slice(this.a,this.a+M);return this.a+=B.byteLength,B}}e.BufferReader=y;class t{constructor(){this.a=[]}get buffer(){return k.VSBuffer.concat(this.a)}write(M){this.a.push(M)}}e.BufferWriter=t;var r;(function(j){j[j.Undefined=0]="Undefined",j[j.String=1]="String",j[j.Buffer=2]="Buffer",j[j.VSBuffer=3]="VSBuffer",j[j.Array=4]="Array",j[j.Object=5]="Object",j[j.Int=6]="Int"})(r||(r={}));function i(j){const M=k.VSBuffer.alloc(1);return M.writeUInt8(j,0),M}const n={Undefined:i(r.Undefined),String:i(r.String),Buffer:i(r.Buffer),VSBuffer:i(r.VSBuffer),Array:i(r.Array),Object:i(r.Object),Uint:i(r.Int)},s=typeof Buffer<"u";function a(j,M){if(typeof M>"u")j.write(n.Undefined);else if(typeof M=="string"){const B=k.VSBuffer.fromString(M);j.write(n.String),h(j,B.byteLength),j.write(B)}else if(s&&Buffer.isBuffer(M)){const B=k.VSBuffer.wrap(M);j.write(n.Buffer),h(j,B.byteLength),j.write(B)}else if(M instanceof k.VSBuffer)j.write(n.VSBuffer),h(j,M.byteLength),j.write(M);else if(Array.isArray(M)){j.write(n.Array),h(j,M.length);for(const B of M)a(j,B)}else if(typeof M=="number"&&(M|0)===M)j.write(n.Uint),h(j,M);else{const B=k.VSBuffer.fromString(JSON.stringify(M));j.write(n.Object),h(j,B.byteLength),j.write(B)}}e.serialize=a;function o(j){switch(j.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return j.read(m(j)).toString();case r.Buffer:return j.read(m(j)).buffer;case r.VSBuffer:return j.read(m(j));case r.Array:{const B=m(j),W=[];for(let q=0;q<B;q++)W.push(o(j));return W}case r.Object:return JSON.parse(j.read(m(j)).toString());case r.Int:return m(j)}}e.deserialize=o;class u{constructor(M,B,W=null,q=1e3){this.h=M,this.j=B,this.k=W,this.l=q,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(K=>this.q(K)),this.m({type:200})}registerChannel(M,B){this.b.set(M,B),setTimeout(()=>this.w(M),0)}m(M){switch(M.type){case 200:{const B=this.o([M.type]);this.k?.logOutgoing(B,0,1,d(M.type));return}case 201:case 202:case 204:case 203:{const B=this.o([M.type,M.id],M.data);this.k?.logOutgoing(B,M.id,1,d(M.type),M.data);return}}}o(M,B=void 0){const W=new t;return a(W,M),a(W,B),this.p(W.buffer)}p(M){try{return this.h.send(M),M.byteLength}catch{return 0}}q(M){const B=new y(M),W=o(B),q=o(B),K=W[0];switch(K){case 100:return this.k?.logIncoming(M.byteLength,W[1],1,`${E(K)}: ${W[2]}.${W[3]}`,q),this.s({type:K,id:W[1],channelName:W[2],name:W[3],arg:q});case 102:return this.k?.logIncoming(M.byteLength,W[1],1,`${E(K)}: ${W[2]}.${W[3]}`,q),this.t({type:K,id:W[1],channelName:W[2],name:W[3],arg:q});case 101:return this.k?.logIncoming(M.byteLength,W[1],1,`${E(K)}`),this.u({type:K,id:W[1]});case 103:return this.k?.logIncoming(M.byteLength,W[1],1,`${E(K)}`),this.u({type:K,id:W[1]})}}s(M){const B=this.b.get(M.channelName);if(!B){this.v(M);return}const W=new D.CancellationTokenSource;let q;try{q=B.call(this.j,M.name,M.arg,W.token)}catch(P){q=Promise.reject(P)}const K=M.id;q.then(P=>{this.m({id:K,data:P,type:201}),this.d.delete(M.id)},P=>{P instanceof Error?this.m({id:K,data:{message:P.message,name:P.name,stack:P.stack?P.stack.split?P.stack.split(`
`):P.stack:void 0},type:202}):this.m({id:K,data:P,type:203}),this.d.delete(M.id)});const R=(0,c.toDisposable)(()=>W.cancel());this.d.set(M.id,R)}t(M){const B=this.b.get(M.channelName);if(!B){this.v(M);return}const W=M.id,K=B.listen(this.j,M.name,M.arg)(R=>this.m({id:W,data:R,type:204}));this.d.set(M.id,K)}u(M){const B=this.d.get(M.id);B&&(B.dispose(),this.d.delete(M.id))}v(M){let B=this.g.get(M.channelName);B||(B=[],this.g.set(M.channelName,B));const W=setTimeout(()=>{console.error(`Unknown channel: ${M.channelName}`),M.type===100&&this.m({id:M.id,data:{name:"Unknown channel",message:`Channel name '${M.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);B.push({request:M,timeoutTimer:W})}w(M){const B=this.g.get(M);if(B){for(const W of B)switch(clearTimeout(W.timeoutTimer),W.request.type){case 100:this.s(W.request);break;case 102:this.t(W.request);break}this.g.delete(M)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=u;var w;(function(j){j[j.LocalSide=0]="LocalSide",j[j.OtherSide=1]="OtherSide"})(w=e.RequestInitiator||(e.RequestInitiator={}));class A{constructor(M,B=null){this.l=M,this.a=!1,this.b=l.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new f.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(W=>this.s(W)),this.j=B}getChannel(M){const B=this;return{call(W,q,K){return B.a?Promise.reject(new b.CancellationError):B.m(M,W,q,K)},listen(W,q){return B.a?f.Event.None:B.o(M,W,q)}}}m(M,B,W,q=D.CancellationToken.None){const K=this.g++,P={id:K,type:100,channelName:M,name:B,arg:W};if(q.isCancellationRequested)return Promise.reject(new b.CancellationError);let C;return new Promise((V,G)=>{if(q.isCancellationRequested)return G(new b.CancellationError);const te=()=>{const le=ce=>{switch(ce.type){case 201:this.f.delete(K),V(ce.data);break;case 202:{this.f.delete(K);const we=new Error(ce.data.message);we.stack=Array.isArray(ce.data.stack)?ce.data.stack.join(`
`):ce.data.stack,we.name=ce.data.name,G(we);break}case 203:this.f.delete(K),G(ce.data);break}};this.f.set(K,le),this.p(P)};let oe=null;this.b===l.Idle?te():(oe=(0,O.createCancelablePromise)(le=>this.u()),oe.then(()=>{oe=null,te()}));const ge=()=>{oe?(oe.cancel(),oe=null):this.p({id:K,type:101}),G(new b.CancellationError)},ve=q.onCancellationRequested(ge);C=(0,c.combinedDisposable)((0,c.toDisposable)(ge),ve),this.d.add(C)}).finally(()=>{this.d.delete(C)})}o(M,B,W){const q=this.g++,R={id:q,type:102,channelName:M,name:B,arg:W};let P=null;const C=new f.Emitter({onWillAddFirstListener:()=>{P=(0,O.createCancelablePromise)(V=>this.u()),P.then(()=>{P=null,this.d.add(C),this.p(R)})},onDidRemoveLastListener:()=>{P?(P.cancel(),P=null):(this.d.delete(C),this.p({id:q,type:103}))}}),F=V=>C.fire(V.data);return this.f.set(q,F),C.event}p(M){switch(M.type){case 100:case 102:{const B=this.q([M.type,M.id,M.channelName,M.name],M.arg);this.j?.logOutgoing(B,M.id,0,`${E(M.type)}: ${M.channelName}.${M.name}`,M.arg);return}case 101:case 103:{const B=this.q([M.type,M.id]);this.j?.logOutgoing(B,M.id,0,E(M.type));return}}}q(M,B=void 0){const W=new t;return a(W,M),a(W,B),this.r(W.buffer)}r(M){try{return this.l.send(M),M.byteLength}catch{return 0}}s(M){const B=new y(M),W=o(B),q=o(B),K=W[0];switch(K){case 200:return this.j?.logIncoming(M.byteLength,0,0,d(K)),this.t({type:W[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(M.byteLength,W[1],0,d(K),q),this.t({type:W[0],id:W[1],data:q})}}t(M){if(M.type===200){this.b=l.Idle,this.k.fire();return}this.f.get(M.id)?.(M)}get onDidInitializePromise(){return f.Event.toPromise(this.onDidInitialize)}u(){return this.b===l.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.dispose)(this.d.values()),this.d.clear()}}de([N.memoize],A.prototype,"onDidInitializePromise",null),e.ChannelClient=A;class ${get connections(){const M=[];return this.f.forEach(B=>M.push(B)),M}constructor(M){this.a=new Map,this.f=new Set,this.g=new f.Emitter,this.onDidAddConnection=this.g.event,this.h=new f.Emitter,this.onDidRemoveConnection=this.h.event,M(({protocol:B,onDidClientDisconnect:W})=>{f.Event.once(B.onMessage)(K=>{const R=new y(K),P=o(R),C=new u(B,P),F=new A(B);this.a.forEach((G,te)=>C.registerChannel(te,G));const V={channelServer:C,channelClient:F,ctx:P};this.f.add(V),this.g.fire(V),W(()=>{C.dispose(),F.dispose(),this.f.delete(V),this.h.fire(V)})})})}getChannel(M,B){const W=this;return{call(q,K,R){let P;if((0,g.isFunction)(B)){const F=(0,T.getRandomElement)(W.connections.filter(B));P=F?Promise.resolve(F):f.Event.toPromise(f.Event.filter(W.onDidAddConnection,B))}else P=B.routeCall(W,q,K);const C=P.then(F=>F.channelClient.getChannel(M));return X(C).call(q,K,R)},listen(q,K){if((0,g.isFunction)(B))return W.j(M,B,q,K);const R=B.routeEvent(W,q,K).then(P=>P.channelClient.getChannel(M));return X(R).listen(q,K)}}}j(M,B,W,q){const K=this;let R=new c.DisposableStore;const P=new f.Emitter({onWillAddFirstListener:()=>{R=new c.DisposableStore;const C=new f.EventMultiplexer,F=new Map,V=te=>{const ge=te.channelClient.getChannel(M).listen(W,q),ve=C.add(ge);F.set(te,ve)},G=te=>{const oe=F.get(te);!oe||(oe.dispose(),F.delete(te))};K.connections.filter(B).forEach(V),f.Event.filter(K.onDidAddConnection,B)(V,void 0,R),K.onDidRemoveConnection(G,void 0,R),C.event(P.fire,P,R),R.add(C)},onDidRemoveLastListener:()=>{R.dispose()}});return P.event}registerChannel(M,B){this.a.set(M,B),this.f.forEach(W=>{W.channelServer.registerChannel(M,B)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=$;class Z{constructor(M,B,W=null){const q=new t;a(q,B),M.send(q.buffer),this.a=new A(M,W),this.d=new u(M,B,W)}getChannel(M){return this.a.getChannel(M)}registerChannel(M,B){this.d.registerChannel(M,B)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=Z;function X(j){return{call(M,B,W){return j.then(q=>q.call(M,B,W))},listen(M,B){const W=new f.Relay;return j.then(q=>W.input=q.listen(M,B)),W.event}}}e.getDelayedChannel=X;function ee(j){let M=!1;return{call(B,W,q){return M?j.call(B,W,q):(0,O.timeout)(0).then(()=>M=!0).then(()=>j.call(B,W,q))},listen(B,W){if(M)return j.listen(B,W);const q=new f.Relay;return(0,O.timeout)(0).then(()=>M=!0).then(()=>q.input=j.listen(B,W)),q.event}}}e.getNextTickChannel=ee;class ie{constructor(M){this.a=M}routeCall(M){return this.b(M)}routeEvent(M){return this.b(M)}async b(M){for(const B of M.connections)if(await Promise.resolve(this.a(B.ctx)))return Promise.resolve(B);return await f.Event.toPromise(M.onDidAddConnection),await this.b(M)}}e.StaticRouter=ie;var ne;(function(j){function M(K,R){const P=K,C=R&&R.disableMarshalling,F=new Map;for(const V in P)W(V)&&F.set(V,f.Event.buffer(P[V],!0));return new class{listen(V,G,te){const oe=F.get(G);if(oe)return oe;if(q(G)){const ge=P[G];if(typeof ge=="function")return ge.call(P,te)}throw new Error(`Event not found: ${G}`)}call(V,G,te){const oe=P[G];if(typeof oe=="function"){if(!C&&Array.isArray(te))for(let ge=0;ge<te.length;ge++)te[ge]=(0,p.revive)(te[ge]);return oe.apply(P,te)}throw new Error(`Method not found: ${G}`)}}}j.fromService=M;function B(K,R){const P=R&&R.disableMarshalling;return new Proxy({},{get(C,F){if(typeof F=="string")return R?.properties?.has(F)?R.properties.get(F):q(F)?function(V){return K.listen(F,V)}:W(F)?K.listen(F):async function(...V){let G;R&&!(0,g.isUndefinedOrNull)(R.context)?G=[R.context,...V]:G=V;const te=await K.call(F,G);return P?te:(0,p.revive)(te)};throw new Error(`Property not found: ${String(F)}`)}})}j.toService=B;function W(K){return K[0]==="o"&&K[1]==="n"&&v.isUpperAsciiLetter(K.charCodeAt(2))}function q(K){return/^onDynamic/.test(K)&&v.isUpperAsciiLetter(K.charCodeAt(9))}})(ne=e.ProxyChannel||(e.ProxyChannel={}));const ae=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function fe(j){if(Array.isArray(j))return j;if(j&&typeof j=="object"&&typeof j.toString=="function"){const M=j.toString();if(M!=="[object Object]")return M}return j}function re(j){return Array.isArray(j)?j.map(fe):fe(j)}function me(j,M,B,W,q,K,R){R=re(R);const P=ae[q],C=P[W%P.length];let F=[`%c[${j}]%c[${String(M).padStart(7," ")}]%c[len: ${String(B).padStart(5," ")}]%c${String(W).padStart(5," ")} - ${K}`,"color: darkgreen","color: grey","color: grey",`color: ${C}`];/\($/.test(K)?(F=F.concat(R),F.push(")")):F.push(R),console.log.apply(console,F)}class z{constructor(M,B){this.d=M,this.f=B,this.a=0,this.b=0}logOutgoing(M,B,W,q,K){this.b+=M,me(this.d,this.b,M,B,W,q,K)}logIncoming(M,B,W,q,K){this.a+=M,me(this.f,this.a,M,B,W,q,K)}}e.IPCLogger=z}),define(Y[83],Q([0,1,57,5,15,23,79,6,3,2,30,55,51,56]),function(x,e,T,O,k,D,N,b,f,c,p,v,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class E extends I.ChannelServer{constructor(l){super({send:m=>{try{process.send?.(m.buffer.toString("base64"))}catch{}},onMessage:f.Event.fromNodeEventEmitter(process,"message",m=>k.VSBuffer.wrap(Buffer.from(m,"base64")))},l),process.once("disconnect",()=>this.dispose())}}e.Server=E;class L{constructor(l,m){this.i=l,this.j=m,this.c=new Set,this.g=new Map,this.h=new f.Emitter,this.onDidProcessExit=this.h.event;const S=m&&m.timeout?m.timeout:6e4;this.b=new O.Delayer(S),this.d=null,this.f=null}getChannel(l){const m=this;return{call(S,h,y){return m.k(l,S,h,y)},listen(S,h){return m.l(l,S,h)}}}k(l,m,S,h=D.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(h.isCancellationRequested)return Promise.reject(b.canceled());this.b.cancel();const y=this.n(l),t=(0,O.createCancelablePromise)(n=>y.call(m,S,n)),r=h.onCancellationRequested(()=>t.cancel()),i=(0,c.toDisposable)(()=>t.cancel());return this.c.add(i),t.finally(()=>{r.dispose(),this.c.delete(i),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(l,m,S){if(!this.b)return f.Event.None;this.b.cancel();let h;const y=new f.Emitter({onWillAddFirstListener:()=>{h=this.n(l).listen(m,S)(y.fire,y),this.c.add(h)},onDidRemoveLastListener:()=>{this.c.delete(h),h.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return y.event}get m(){if(!this.f){const l=this.j&&this.j.args?this.j.args:[],m=Object.create(null);m.env={...(0,p.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(m.env={...m.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(m.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),m.execArgv===void 0&&(m.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s))),(0,g.removeDangerousEnvVariables)(m.env),this.d=(0,T.fork)(this.i,l,m);const S=new f.Emitter;f.Event.fromNodeEventEmitter(this.d,"message",s=>s)(s=>{if((0,N.isRemoteConsoleLog)(s)){(0,N.log)(s,`IPC Library: ${this.j.serverName}`);return}S.fire(k.VSBuffer.wrap(Buffer.from(s,"base64")))});const y=this.j.useQueue?(0,v.createQueuedSender)(this.d):this.d,t=s=>this.d&&this.d.connected&&y.send(s.buffer.toString("base64")),r=S.event,i={send:t,onMessage:r};this.f=new I.ChannelClient(i);const n=()=>this.o();process.once("exit",n),this.d.on("error",s=>console.warn('IPC "'+this.j.serverName+'" errored with '+s)),this.d.on("exit",(s,a)=>{process.removeListener("exit",n),this.c.forEach(o=>(0,c.dispose)(o)),this.c.clear(),s!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+s+" and signal "+a),this.b?.cancel(),this.o(),this.h.fire({code:s,signal:a})})}return this.f}n(l){let m=this.g.get(l);return m||(m=this.m.getChannel(l),this.g.set(l,m)),m}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=L}),define(Y[84],Q([0,1,5,3,2,4]),function(x,e,T,O,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var N;(function(v){v[v.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",v[v.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(N=e.StorageHint||(e.StorageHint={}));function b(v){const g=v;return g?.changed instanceof Map||g?.deleted instanceof Set}e.isStorageItemsChangeEvent=b;var f;(function(v){v[v.None=0]="None",v[v.Initialized=1]="Initialized",v[v.Closed=2]="Closed"})(f=e.StorageState||(e.StorageState={}));class c extends k.Disposable{constructor(g,I=Object.create(null)){super(),this.m=g,this.n=I,this.b=this.B(new O.Emitter),this.onDidChangeStorage=this.b.event,this.c=f.None,this.f=new Map,this.g=new T.ThrottledDelayer(c.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(g=>this.r(g)))}r(g){g.changed?.forEach((I,E)=>this.s(E,I)),g.deleted?.forEach(I=>this.s(I,void 0))}s(g,I){if(this.c===f.Closed)return;let E=!1;(0,D.isUndefinedOrNull)(I)?E=this.f.delete(g):this.f.get(g)!==I&&(this.f.set(g,I),E=!0),E&&this.b.fire(g)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===f.None&&(this.c=f.Initialized,this.n.hint!==N.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(g,I){const E=this.f.get(g);return(0,D.isUndefinedOrNull)(E)?I:E}getBoolean(g,I){const E=this.get(g);return(0,D.isUndefinedOrNull)(E)?I:E==="true"}getNumber(g,I){const E=this.get(g);return(0,D.isUndefinedOrNull)(E)?I:parseInt(E,10)}async set(g,I){if(this.c===f.Closed)return;if((0,D.isUndefinedOrNull)(I))return this.delete(g);const E=String(I);if(this.f.get(g)!==E)return this.f.set(g,E),this.j.set(g,E),this.h.delete(g),this.b.fire(g),this.w()}async delete(g){if(!(this.c===f.Closed||!this.f.delete(g)))return this.h.has(g)||this.h.add(g),this.j.delete(g),this.b.fire(g),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=f.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const g={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(g).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(g){if(!!this.u)return this.w(g)}async w(g){return this.g.trigger(()=>this.v(),g)}async whenFlushed(){if(!!this.u)return new Promise(g=>this.l.push(g))}isInMemory(){return this.n.hint===N.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}e.Storage=c,c.a=100;class p{constructor(){this.onDidChangeItemsExternal=O.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(g){g.insert?.forEach((I,E)=>this.a.set(E,I)),g.delete?.forEach(I=>this.a.delete(I))}async close(){}}e.InMemoryStorageDatabase=p}),define(Y[85],Q([7,8]),function(x,e){return x.create("vs/base/node/zip",e)}),define(Y[86],Q([7,8]),function(x,e){return x.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Y[87],Q([7,8]),function(x,e){return x.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(Y[88],Q([7,8]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Y[89],Q([7,8]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(Y[90],Q([7,8]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(Y[91],Q([7,8]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(Y[92],Q([7,8]),function(x,e){return x.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(Y[93],Q([7,8]),function(x,e){return x.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(Y[94],Q([7,8]),function(x,e){return x.create("vs/platform/extensions/common/extensionValidator",e)}),define(Y[95],Q([7,8]),function(x,e){return x.create("vs/platform/files/common/fileService",e)}),define(Y[96],Q([7,8]),function(x,e){return x.create("vs/platform/files/common/io",e)}),define(Y[97],Q([7,8]),function(x,e){return x.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Y[98],Q([7,8]),function(x,e){return x.create("vs/platform/languagePacks/common/languagePacks",e)}),define(Y[99],Q([7,8]),function(x,e){return x.create("vs/platform/request/common/request",e)}),define(Y[100],Q([7,8]),function(x,e){return x.create("vs/platform/shell/node/shellEnv",e)}),define(Y[101],Q([7,8]),function(x,e){return x.create("vs/platform/telemetry/common/telemetryService",e)}),define(Y[102],Q([7,8]),function(x,e){return x.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Y[103],Q([7,8]),function(x,e){return x.create("vs/platform/workspace/common/workspace",e)}),define(Y[104],Q([0,1,75,49,16,14,35,18,11]),function(x,e,T,O,k,D,N,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class c{get appRoot(){return(0,D.dirname)(k.FileAccess.asFileUri("").fsPath)}get userHome(){return f.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return f.URI.file((0,D.join)(this.userDataPath,"User"))}get tmpDir(){return f.URI.file(this.b.tmpDir)}get cacheHome(){return f.URI.file(this.userDataPath)}get stateResource(){return(0,b.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,b.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const E=(0,T.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,D.join)(this.userDataPath,"logs",E)}return this.args.logsPath}get userDataSyncLogResource(){return f.URI.file((0,D.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return f.URI.file((0,D.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,b.joinPath)(f.URI.file((0,D.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,b.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,b.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,b.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const E=N.env.VSCODE_PORTABLE;return E?f.URI.file((0,D.join)(E,"argv.json")):(0,b.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return f.URI.file((0,D.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,D.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const E=this.args["builtin-extensions-dir"];return E?(0,D.resolve)(E):(0,D.normalize)((0,D.join)(k.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const E=this.args["extensions-download-dir"];return E?f.URI.file((0,D.resolve)(E)):f.URI.file((0,D.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const E=this.args["extensions-dir"];if(E)return(0,D.resolve)(E);const L=N.env.VSCODE_EXTENSIONS;if(L)return L;const d=N.env.VSCODE_PORTABLE;return d?(0,D.join)(d,"extensions"):(0,b.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const E=this.args.extensionDevelopmentPath;if(Array.isArray(E))return E.map(L=>/^[^:/?#]+?:\/\//.test(L)?f.URI.parse(L):f.URI.file((0,D.normalize)(L)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(E=>E==="ui"||E==="workspace"||E==="web"?E:"workspace")}get extensionTestsLocationURI(){const E=this.args.extensionTestsPath;if(E)return/^[^:/?#]+?:\/\//.test(E)?f.URI.parse(E):f.URI.file((0,D.normalize)(E))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const E=this.args["disable-extension"];if(E){if(typeof E=="string")return[E];if(Array.isArray(E)&&E.length>0)return E}return!1}get debugExtensionHost(){return p(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!N.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(E=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(E))}get extensionLogLevel(){const E=[];for(const L of this.args.log||[]){const d=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(L);d&&d[1]&&d[2]&&E.push([d[1],d[2]])}return E.length?E:void 0}get serviceMachineIdResource(){return(0,b.joinPath)(f.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return f.URI.file((0,D.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const E=N.env.VSCODE_PORTABLE;return E?f.URI.file((0,D.join)(E,"policy.json")):(0,b.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(E){this.args.continueOn=E}get args(){return this.a}constructor(E,L,d){this.a=E,this.b=L,this.c=d,this.editSessionId=this.args.editSessionId}}de([O.memoize],c.prototype,"appRoot",null),de([O.memoize],c.prototype,"userHome",null),de([O.memoize],c.prototype,"userDataPath",null),de([O.memoize],c.prototype,"appSettingsHome",null),de([O.memoize],c.prototype,"tmpDir",null),de([O.memoize],c.prototype,"cacheHome",null),de([O.memoize],c.prototype,"stateResource",null),de([O.memoize],c.prototype,"userRoamingDataHome",null),de([O.memoize],c.prototype,"userDataSyncHome",null),de([O.memoize],c.prototype,"userDataSyncLogResource",null),de([O.memoize],c.prototype,"editSessionsLogResource",null),de([O.memoize],c.prototype,"sync",null),de([O.memoize],c.prototype,"machineSettingsResource",null),de([O.memoize],c.prototype,"workspaceStorageHome",null),de([O.memoize],c.prototype,"localHistoryHome",null),de([O.memoize],c.prototype,"keyboardLayoutResource",null),de([O.memoize],c.prototype,"argvResource",null),de([O.memoize],c.prototype,"isExtensionDevelopment",null),de([O.memoize],c.prototype,"untitledWorkspacesHome",null),de([O.memoize],c.prototype,"installSourcePath",null),de([O.memoize],c.prototype,"builtinExtensionsPath",null),de([O.memoize],c.prototype,"extensionsPath",null),de([O.memoize],c.prototype,"extensionDevelopmentLocationURI",null),de([O.memoize],c.prototype,"extensionDevelopmentKind",null),de([O.memoize],c.prototype,"extensionTestsLocationURI",null),de([O.memoize],c.prototype,"debugExtensionHost",null),de([O.memoize],c.prototype,"logLevel",null),de([O.memoize],c.prototype,"extensionLogLevel",null),de([O.memoize],c.prototype,"serviceMachineIdResource",null),de([O.memoize],c.prototype,"telemetryLogResource",null),de([O.memoize],c.prototype,"disableWorkspaceTrust",null),de([O.memoize],c.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=c;function p(I,E){return g(I["inspect-extensions"],I["inspect-brk-extensions"],5870,E,I.debugId,I.extensionEnvironment)}e.parseExtensionHostPort=p;function v(I,E){return g(I["inspect-ptyhost"],I["inspect-brk-ptyhost"],5877,E,I.extensionEnvironment)}e.parsePtyHostPort=v;function g(I,E,L,d,l,m){const h=Number(E||I)||(d?null:L),y=h?Boolean(!!E):!1;let t;if(m)try{t=JSON.parse(m)}catch{}return{port:h,break:y,debugId:l,env:t}}}),function(){"use strict";function x(e,T,O){function k(N,b){const f=D(N,b),c=[f];return e.isAbsolute(f)||c.unshift(O),e.resolve(...c)}function D(N,b){process.env.VSCODE_DEV&&(b="code-oss-dev");const f=process.env.VSCODE_PORTABLE;if(f)return e.join(f,"user-data");let c=process.env.VSCODE_APPDATA;if(c)return e.join(c,b);const p=N["user-data-dir"];if(p)return p;switch(process.platform){case"win32":if(c=process.env.APPDATA,!c){const v=process.env.USERPROFILE;if(typeof v!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");c=e.join(v,"AppData","Roaming")}break;case"darwin":c=e.join(T.homedir(),"Library","Application Support");break;case"linux":c=process.env.XDG_CONFIG_HOME||e.join(T.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(c,b)}return{getUserDataPath:k}}if(typeof define=="function")define(Y[105],Q([156,33,35]),function(e,T,O){return x(e,T,O.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),T=require("os");module.exports=x(e,T,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Y[106],Q([0,1,33,104,105]),function(x,e,T,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class D extends O.AbstractNativeEnvironmentService{constructor(b,f){super(b,{homeDir:(0,T.homedir)(),tmpDir:(0,T.tmpdir)(),userDataDir:(0,k.getUserDataPath)(b,f.nameShort)},f)}}e.NativeEnvironmentService=D}),define(Y[107],Q([0,1,4,90]),function(x,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function k(N,b,f){try{D(N,b,f)}catch(c){console.error(c?.message??c)}return N}e.localizeManifest=k;function D(N,b,f){const c=(p,v,g)=>{const I=p[v];if((0,T.isString)(I)){const E=I,L=E.length;if(L>1&&E[0]==="%"&&E[L-1]==="%"){const d=E.substr(1,L-2);let l=b[d];l===void 0&&f&&(l=f[d]);const m=typeof l=="string"?l:l?.message,S=f?.[d],h=typeof S=="string"?S:S?.message;if(!m){h||console.warn(`[${N.name}]: ${(0,O.localize)(0,null,d)}`);return}if(g&&(v==="title"||v==="category")&&h&&h!==m){const y={value:m,original:h};p[v]=y}else p[v]=m}}else if((0,T.isObject)(I))for(const E in I)I.hasOwnProperty(E)&&(E==="commands"?c(I,E,!0):c(I,E,g));else if(Array.isArray(I))for(let E=0;E<I.length;E++)c(I,E,g)};for(const p in N)N.hasOwnProperty(p)&&c(N,p)}}),define(Y[108],Q([0,1,6]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class O{constructor(){this.a=new Map}register(D,N){this.a.set(D,N)}updateManifest(D){if(!(typeof D.main>"u"&&typeof D.browser>"u")&&(D.activationEvents===void 0&&Object.assign(D,{activationEvents:[]}),!(!Array.isArray(D.activationEvents)||!D.contributes)))for(const N in D.contributes){const b=this.a.get(N);if(!b)continue;const f=D.contributes[N],c=Array.isArray(f)?f:[f];try{b(c,D.activationEvents)}catch(p){(0,T.onUnexpectedError)(p)}}}}e.ImplicitActivationEventsImpl=O,e.ImplicitActivationEvents=new O}),define(Y[45],Q([0,1,18,53,94,41]),function(x,e,T,O,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const N=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function f(l){return l=l.trim(),l==="*"||N.test(l)}e.isValidVersionStr=f;function c(l){if(!f(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const m=l.match(N);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}e.parseVersion=c;function p(l){if(!l)return null;const m=l.majorBase,S=l.majorMustEqual,h=l.minorBase;let y=l.minorMustEqual;const t=l.patchBase;let r=l.patchMustEqual;l.hasCaret&&(m===0||(y=!1),r=!1);let i=0;if(l.preRelease){const n=b.exec(l.preRelease);if(n){const[,s,a,o]=n;i=Date.UTC(Number(s),Number(a)-1,Number(o))}}return{majorBase:m,majorMustEqual:S,minorBase:h,minorMustEqual:y,patchBase:t,patchMustEqual:r,isMinimum:l.hasGreaterEquals,notBefore:i}}e.normalizeVersion=p;function v(l,m,S){let h;typeof l=="string"?h=p(c(l)):h=l;let y;m instanceof Date?y=m.getTime():typeof m=="string"&&(y=new Date(m).getTime());let t;if(typeof S=="string"?t=p(c(S)):t=S,!h||!t)return!1;const r=h.majorBase,i=h.minorBase,n=h.patchBase;let s=t.majorBase,a=t.minorBase,o=t.patchBase;const u=t.notBefore;let w=t.majorMustEqual,A=t.minorMustEqual,$=t.patchMustEqual;return t.isMinimum?r>s?!0:r<s?!1:i>a?!0:i<a||y&&y<u?!1:n>=o:(r===1&&s===0&&(!w||!A||!$)&&(s=1,a=0,o=0,w=!0,A=!1,$=!1),r<s?!1:r>s?!w:i<a?!1:i>a?!A:n<o?!1:n>o?!$:!(y&&y<u))}e.isValidVersion=v;function g(l,m,S,h,y){const t=[];if(typeof h.publisher<"u"&&typeof h.publisher!="string")return t.push([O.default.Error,k.localize(0,null)]),t;if(typeof h.name!="string")return t.push([O.default.Error,k.localize(1,null,"name")]),t;if(typeof h.version!="string")return t.push([O.default.Error,k.localize(2,null,"version")]),t;if(!h.engines)return t.push([O.default.Error,k.localize(3,null,"engines")]),t;if(typeof h.engines.vscode!="string")return t.push([O.default.Error,k.localize(4,null,"engines.vscode")]),t;if(typeof h.extensionDependencies<"u"&&!d(h.extensionDependencies))return t.push([O.default.Error,k.localize(5,null,"extensionDependencies")]),t;if(typeof h.activationEvents<"u"){if(!d(h.activationEvents))return t.push([O.default.Error,k.localize(6,null,"activationEvents")]),t;if(typeof h.main>"u"&&typeof h.browser>"u")return t.push([O.default.Error,k.localize(7,null,"activationEvents","main")]),t}if(typeof h.extensionKind<"u"&&typeof h.main>"u"&&t.push([O.default.Warning,k.localize(8,null,"extensionKind")]),typeof h.main<"u"){if(typeof h.main!="string")return t.push([O.default.Error,k.localize(9,null,"main")]),t;{const n=(0,T.joinPath)(S,h.main);(0,T.isEqualOrParent)(n,S)||t.push([O.default.Warning,k.localize(10,null,n.path,S.path)])}if(typeof h.activationEvents>"u")return t.push([O.default.Error,k.localize(11,null,"activationEvents","main")]),t}if(typeof h.browser<"u"){if(typeof h.browser!="string")return t.push([O.default.Error,k.localize(12,null,"browser")]),t;{const n=(0,T.joinPath)(S,h.browser);(0,T.isEqualOrParent)(n,S)||t.push([O.default.Warning,k.localize(13,null,n.path,S.path)])}if(typeof h.activationEvents>"u")return t.push([O.default.Error,k.localize(14,null,"activationEvents","browser")]),t}if(!D.valid(h.version))return t.push([O.default.Error,k.localize(15,null)]),t;const r=[];if(!I(l,m,h,y,r))for(const n of r)t.push([O.default.Error,n]);return t}e.validateExtensionManifest=g;function I(l,m,S,h,y){return h||typeof S.main>"u"&&typeof S.browser>"u"?!0:L(l,m,S.engines.vscode,y)}e.isValidExtensionVersion=I;function E(l,m,S){return l==="*"||L(m,S,l)}e.isEngineValid=E;function L(l,m,S,h=[]){const y=p(c(S));if(!y)return h.push(k.localize(16,null,S)),!1;if(y.majorBase===0){if(!y.majorMustEqual||!y.minorMustEqual)return h.push(k.localize(17,null,S)),!1}else if(!y.majorMustEqual)return h.push(k.localize(18,null,S)),!1;return v(l,m,y)?!0:(h.push(k.localize(19,null,l,S)),!1)}function d(l){if(!Array.isArray(l))return!1;for(let m=0,S=l.length;m<S;m++)if(typeof l[m]!="string")return!1;return!0}}),define(Y[109],Q([0,1,15,31]),function(x,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function k(D,N,b){let f=b&&b.get("storage.serviceMachineId",-1)||null;if(f)return f;try{const p=(await N.readFile(D.serviceMachineIdResource)).value.toString();f=(0,O.isUUID)(p)?p:null}catch{f=null}if(!f){f=(0,O.generateUuid)();try{await N.writeFile(D.serviceMachineIdResource,T.VSBuffer.fromString(f))}catch{}}return b?.store("storage.serviceMachineId",f,-1,1),f}e.getServiceMachineId=k}),define(Y[46],Q([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class T{constructor(k,D=[],N=!1){this.ctor=k,this.staticArguments=D,this.supportsDelayedInstantiation=N}}e.SyncDescriptor=T}),define(Y[110],Q([0,1,46]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const O=[];var k;(function(b){b[b.Eager=0]="Eager",b[b.Delayed=1]="Delayed"})(k=e.InstantiationType||(e.InstantiationType={}));function D(b,f,c){f instanceof T.SyncDescriptor||(f=new T.SyncDescriptor(f,[],Boolean(c))),O.push([b,f])}e.registerSingleton=D;function N(){return O}e.getSingletonServiceDescriptors=N}),define(Y[111],Q([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class T{constructor(D,N){this.key=D,this.data=N,this.incoming=new Map,this.outgoing=new Map}}e.Node=T;class O{constructor(D){this.b=D,this.a=new Map}roots(){const D=[];for(const N of this.a.values())N.outgoing.size===0&&D.push(N);return D}insertEdge(D,N){const b=this.lookupOrInsertNode(D),f=this.lookupOrInsertNode(N);b.outgoing.set(f.key,f),f.incoming.set(b.key,b)}removeNode(D){const N=this.b(D);this.a.delete(N);for(const b of this.a.values())b.outgoing.delete(N),b.incoming.delete(N)}lookupOrInsertNode(D){const N=this.b(D);let b=this.a.get(N);return b||(b=new T(N,D),this.a.set(N,b)),b}lookup(D){return this.a.get(this.b(D))}isEmpty(){return this.a.size===0}toString(){const D=[];for(const[N,b]of this.a)D.push(`${N}
	(-> incoming)[${[...b.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...b.outgoing.keys()].join(",")}]
`);return D.join(`
`)}findCycleSlow(){for(const[D,N]of this.a){const b=new Set([D]),f=this.c(N,b);if(f)return f}}c(D,N){for(const[b,f]of D.outgoing){if(N.has(b))return[...N,b].join(" -> ");N.add(b);const c=this.c(f,N);if(c)return c;N.delete(b)}}}e.Graph=O}),define(Y[21],Q([0,1,4,11,9]),function(x,e,T,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function D(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof O.URI)}e.isConfigurationOverrides=D;function N(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||Array.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof O.URI)}e.isConfigurationUpdateOverrides=N;var b;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.USER=2]="USER",l[l.USER_LOCAL=3]="USER_LOCAL",l[l.USER_REMOTE=4]="USER_REMOTE",l[l.WORKSPACE=5]="WORKSPACE",l[l.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",l[l.DEFAULT=7]="DEFAULT",l[l.MEMORY=8]="MEMORY"})(b=e.ConfigurationTarget||(e.ConfigurationTarget={}));function f(l){switch(l){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=f;function c(l,m){const S=Object.create(null);for(const h in l)p(S,h,l[h],m);return S}e.toValuesTree=c;function p(l,m,S,h){const y=m.split("."),t=y.pop();let r=l;for(let i=0;i<y.length;i++){const n=y[i];let s=r[n];switch(typeof s){case"undefined":s=r[n]=Object.create(null);break;case"object":break;default:h(`Ignoring ${m} as ${y.slice(0,i+1).join(".")} is ${JSON.stringify(s)}`);return}r=s}if(typeof r=="object"&&r!==null)try{r[t]=S}catch{h(`Ignoring ${m} as ${y.join(".")} is ${JSON.stringify(r)}`)}else h(`Ignoring ${m} as ${y.join(".")} is ${JSON.stringify(r)}`)}e.addToValueTree=p;function v(l,m){const S=m.split(".");g(l,S)}e.removeFromValueTree=v;function g(l,m){const S=m.shift();if(m.length===0){delete l[S];return}if(Object.keys(l).indexOf(S)!==-1){const h=l[S];typeof h=="object"&&!Array.isArray(h)&&(g(h,m),Object.keys(h).length===0&&delete l[S])}}function I(l,m,S){function h(r,i){let n=r;for(const s of i){if(typeof n!="object"||n===null)return;n=n[s]}return n}const y=m.split("."),t=h(l,y);return typeof t>"u"?S:t}e.getConfigurationValue=I;function E(l,m,S){Object.keys(m).forEach(h=>{h!=="__proto__"&&(h in l?T.isObject(l[h])&&T.isObject(m[h])?E(l[h],m[h],S):S&&(l[h]=m[h]):l[h]=m[h])})}e.merge=E;function L(l,m,S){const h=l.inspect(m),y=l.inspect(S);return typeof h.userValue<"u"||typeof h.workspaceValue<"u"||typeof h.workspaceFolderValue<"u"?h.value:typeof y.userValue<"u"||typeof y.workspaceValue<"u"||typeof y.workspaceFolderValue<"u"?y.value:h.defaultValue}e.getMigratedSettingValue=L;function d(l){return l.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=d}),define(Y[58],Q([0,1,9]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,T.createDecorator)("downloadService")}),define(Y[17],Q([0,1,9]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,T.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,T.refineServiceDecorator)(e.IEnvironmentService)}),define(Y[24],Q([0,1,88,9]),function(x,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function k(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function D(l){switch(l){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=D;function N(l,m){switch(l){case 3:return m==="x64"?"win32-x64":m==="ia32"?"win32-ia32":m==="arm64"?"win32-arm64":"unknown";case 2:return m==="x64"?"linux-x64":m==="arm64"?"linux-arm64":m==="arm"?"linux-armhf":"unknown";case"alpine":return m==="x64"?"alpine-x64":m==="arm64"?"alpine-arm64":"unknown";case 1:return m==="x64"?"darwin-x64":m==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=N;function b(l,m){return m==="web"&&!l.includes("web")}e.isNotWebExtensionInWebTargetPlatform=b;function f(l,m,S){return b(m,S)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===S?!0:c(S).includes(l)}e.isTargetPlatformCompatible=f;function c(l){switch(l){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=c;function p(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.isIExtensionIdentifier=p;var v;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(v=e.SortBy||(e.SortBy={}));var g;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(g=e.SortOrder||(e.SortOrder={}));var I;(function(l){l.Install="install",l.Uninstall="uninstall"})(I=e.StatisticType||(e.StatisticType={}));var E;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(E=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,O.createDecorator)("extensionGalleryService");var L;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatiblePreRelease="IncompatiblePreRelease",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.Extract="Extract",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Internal="Internal",l.Signature="Signature"})(L=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class d extends Error{constructor(m,S){super(m),this.code=S,this.name=S}}e.ExtensionManagementError=d,e.IExtensionManagementService=(0,O.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,O.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,O.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,T.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,T.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(Y[59],Q([0,1,9]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,T.createDecorator)("IExtensionSignatureVerificationService");class O{b(){return this.a||(this.a=new Promise((D,N)=>x(["node-vsce-sign"],async b=>D(b),N))),this.a}async verify(D,N){let b;try{b=await this.b()}catch{return!1}return b.verify(D,N)}}e.ExtensionSignatureVerificationService=O}),define(Y[60],Q([0,1,15,6,96,13]),function(x,e,T,O,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function N(p,v,g,I,E,L){let d;try{await b(p,v,g,I,E,L)}catch(l){d=l}finally{d&&E.errorTransformer&&(d=E.errorTransformer(d)),typeof d<"u"&&g.error(d),g.end()}}e.readFileIntoStream=N;async function b(p,v,g,I,E,L){f(L);const d=await p.open(v,{create:!1});try{f(L);let l=0,m=0,S=E&&typeof E.length=="number"?E.length:void 0,h=T.VSBuffer.alloc(Math.min(E.bufferSize,typeof S=="number"?S:E.bufferSize)),y=E&&typeof E.position=="number"?E.position:0,t=0;do m=await p.read(d,y,h.buffer,t,h.byteLength-t),y+=m,t+=m,l+=m,typeof S=="number"&&(S-=m),t===h.byteLength&&(await g.write(I(h)),h=T.VSBuffer.alloc(Math.min(E.bufferSize,typeof S=="number"?S:E.bufferSize)),t=0);while(m>0&&(typeof S!="number"||S>0)&&f(L)&&c(l,E));if(t>0){let r=t;typeof S=="number"&&(r=Math.min(t,S)),g.write(I(h.slice(0,r)))}}catch(l){throw(0,D.ensureFileSystemProviderError)(l)}finally{await p.close(d)}}function f(p){if(p.isCancellationRequested)throw(0,O.canceled)();return!0}function c(p,v){if(v?.limits){if(typeof v.limits.memory=="number"&&p>v.limits.memory)throw(0,D.createFileSystemProviderError)((0,k.localize)(0,null),D.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof v.limits.size=="number"&&p>v.limits.size)throw(0,D.createFileSystemProviderError)((0,k.localize)(1,null),D.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Y[112],Q([0,1,3,157,2,12,158]),function(x,e,T,O,k,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class b extends k.Disposable{constructor(){super(...arguments),this.a=this.B(new T.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new T.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=T.Event.None,this.c=new Map,this.f=!1}async watch(c){const p=this.i(c),v=p.filter(I=>{const E=this.c.get(I.path);return E?!(0,O.patternsEquals)(E.request.excludes,I.excludes)||!(0,O.patternsEquals)(E.request.includes,I.includes):!0}),g=Array.from(this.c.values()).filter(({request:I})=>!p.find(E=>E.path===I.path&&(0,O.patternsEquals)(E.excludes,I.excludes)&&(0,O.patternsEquals)(E.includes,I.includes))).map(({request:I})=>I.path);v.length&&this.j(`Request to start watching: ${v.map(I=>`${I.path} (excludes: ${I.excludes.length>0?I.excludes:"<none>"}, includes: ${I.includes&&I.includes.length>0?JSON.stringify(I.includes):"<all>"})`).join(",")}`),g.length&&this.j(`Request to stop watching: ${g.join(",")}`);for(const I of g)this.h(I);for(const I of v)this.g(I)}g(c){const p=new N.NodeJSFileWatcherLibrary(c,g=>this.a.fire(g),g=>this.b.fire(g),this.f),v={request:c,instance:p};this.c.set(c.path,v)}async stop(){for(const[c]of this.c)this.h(c);this.c.clear()}h(c){const p=this.c.get(c);p&&(this.c.delete(c),p.instance.dispose())}i(c){const p=new Map;for(const v of c){const g=D.isLinux?v.path:v.path.toLowerCase();p.set(g,v)}return Array.from(p.values())}async setVerboseLogging(c){this.f=c;for(const[,p]of this.c)p.instance.setVerboseLogging(c)}j(c){this.f&&this.b.fire({type:"trace",message:this.k(c)})}k(c,p){return p?`[File Watcher (node.js)] ${c} (path: ${p.request.path})`:`[File Watcher (node.js)] ${c}`}}e.NodeJSWatcher=b}),define(Y[113],Q([0,1,61,112]),function(x,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class k extends T.AbstractNonRecursiveWatcherClient{constructor(N,b,f){super(N,b,f),this.m()}l(){return new O.NodeJSWatcher}}e.NodeJSWatcherClient=k}),define(Y[114],Q([0,1,16,56,83,61]),function(x,e,T,O,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class N extends D.AbstractUniversalWatcherClient{constructor(f,c,p){super(f,c,p),this.m()}l(f){const c=f.add(new k.Client(T.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return f.add(c.onDidProcessExit(({code:p,signal:v})=>this.n(`terminated by itself with code ${p}, signal: ${v}`))),O.ProxyChannel.toService((0,O.getNextTickChannel)(c.getChannel("watcher")))}}e.UniversalWatcherClient=N}),define(Y[62],Q([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class T{constructor(...k){this.a=new Map;for(const[D,N]of k)this.set(D,N)}set(k,D){const N=this.a.get(k);return this.a.set(k,D),N}has(k){return this.a.has(k)}get(k){return this.a.get(k)}}e.ServiceCollection=T}),define(Y[115],Q([0,1,5,6,2,46,111,9,62,159]),function(x,e,T,O,k,D,N,b,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const p=!1;class v extends Error{constructor(d){super("cyclic dependency between services"),this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class g{constructor(d=new f.ServiceCollection,l=!1,m,S=p){this.f=d,this.g=l,this.h=m,this.i=S,this.o=new Set,this.f.set(b.IInstantiationService,this),this._globalGraph=S?m?._globalGraph??new N.Graph(h=>h):void 0}createChild(d){return new g(d,this.g,this,this.i)}invokeFunction(d,...l){const m=E.traceInvocation(this.i,d);let S=!1;try{return d({get:y=>{if(S)throw(0,O.illegalState)("service accessor is only valid during the invocation of its target method");const t=this.m(y,m);if(!t)throw new Error(`[invokeFunction] unknown service '${y}'`);return t}},...l)}finally{S=!0,m.stop()}}createInstance(d,...l){let m,S;return d instanceof D.SyncDescriptor?(m=E.traceCreation(this.i,d.ctor),S=this.j(d.ctor,d.staticArguments.concat(l),m)):(m=E.traceCreation(this.i,d),S=this.j(d,l,m)),m.stop(),S}j(d,l=[],m){const S=b._util.getServiceDependencies(d).sort((t,r)=>t.index-r.index),h=[];for(const t of S){const r=this.m(t.id,m);r||this.u(`[createInstance] ${d.name} depends on UNKNOWN service ${t.id}.`,!1),h.push(r)}const y=S.length>0?S[0].index:l.length;if(l.length!==y){console.trace(`[createInstance] First service dependency of ${d.name} at position ${y+1} conflicts with ${l.length} static arguments`);const t=y-l.length;t>0?l=l.concat(new Array(t)):l=l.slice(0,y)}return Reflect.construct(d,l.concat(h))}k(d,l){if(this.f.get(d)instanceof D.SyncDescriptor)this.f.set(d,l);else if(this.h)this.h.k(d,l);else throw new Error("illegalState - setting UNKNOWN service instance")}l(d){const l=this.f.get(d);return!l&&this.h?this.h.l(d):l}m(d,l){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(d));const m=this.l(d);return m instanceof D.SyncDescriptor?this.q(d,m,l.branch(d,!0)):(l.branch(d,!1),m)}q(d,l,m){if(this.o.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this.o.add(d);try{return this.r(d,l,m)}finally{this.o.delete(d)}}r(d,l,m){const S=new N.Graph(t=>t.id.toString());let h=0;const y=[{id:d,desc:l,_trace:m}];for(;y.length;){const t=y.pop();if(S.lookupOrInsertNode(t),h++>1e3)throw new v(S);for(const r of b._util.getServiceDependencies(t.desc.ctor)){const i=this.l(r.id);if(i||this.u(`[createInstance] ${d} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(r.id)),i instanceof D.SyncDescriptor){const n={id:r.id,desc:i,_trace:t._trace.branch(r.id,!0)};S.insertEdge(t,n),y.push(n)}}}for(;;){const t=S.roots();if(t.length===0){if(!S.isEmpty())throw new v(S);break}for(const{data:r}of t){if(this.l(r.id)instanceof D.SyncDescriptor){const n=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,n)}S.removeNode(r)}}return this.l(d)}s(d,l,m=[],S,h){if(this.f.get(d)instanceof D.SyncDescriptor)return this.t(d,l,m,S,h);if(this.h)return this.h.s(d,l,m,S,h);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}t(d,l,m=[],S,h){if(S){const y=new g(void 0,this.g,this,this.i);y.c=String(d);const t=new Map,r=new T.IdleValue(()=>{const i=y.j(l,m,h);for(const[n,s]of t){const a=i[n];if(typeof a=="function")for(const o of s)a.apply(i,o)}return t.clear(),i});return new Proxy(Object.create(null),{get(i,n){if(!r.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let o=t.get(n);return o||(o=new c.LinkedList,t.set(n,o)),(w,A,$)=>{const Z=o.push([w,A,$]);return(0,k.toDisposable)(Z)}}if(n in i)return i[n];const s=r.value;let a=s[n];return typeof a!="function"||(a=a.bind(s),i[n]=a),a},set(i,n,s){return r.value[n]=s,!0},getPrototypeOf(i){return l.prototype}})}else return this.j(l,m,h)}u(d,l){if(l&&console.warn(d),this.g)throw new Error(d)}}e.InstantiationService=g;var I;(function(L){L[L.None=0]="None",L[L.Creation=1]="Creation",L[L.Invocation=2]="Invocation",L[L.Branch=3]="Branch"})(I||(I={}));class E{static traceInvocation(d,l){return d?new E(2,l.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):E.c}static traceCreation(d,l){return d?new E(1,l.name):E.c}constructor(d,l){this.type=d,this.name=l,this.g=Date.now(),this.h=[]}branch(d,l){const m=new E(3,d.toString());return this.h.push([d,l,m]),m}stop(){const d=Date.now()-this.g;E.f+=d;let l=!1;function m(h,y){const t=[],r=new Array(h+1).join("	");for(const[i,n,s]of y.h)if(n&&s){l=!0,t.push(`${r}CREATES -> ${i}`);const a=m(h+1,s);a&&t.push(a)}else t.push(`${r}uses -> ${i}`);return t.join(`
`)}const S=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${m(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${E.f.toFixed(2)}ms)`];(d>2||l)&&E.all.add(S.join(`
`))}}e.Trace=E,E.all=new Set,E.c=new class extends E{constructor(){super(0,null)}stop(){}branch(){return this}},E.f=0});var _=this&&this.__param||function(x,e){return function(T,O){e(T,O,x)}};define(Y[63],Q([0,1,23,2,12,98,24,9]),function(x,e,T,O,k,D,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function f(p){return p.tags.find(v=>v.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=f,e.ILanguagePackService=(0,b.createDecorator)("languagePackService");let c=class extends O.Disposable{constructor(v){super(),this.c=v}async getAvailableLanguages(){const v=new T.CancellationTokenSource;setTimeout(()=>v.cancel(),1e3);let g;try{g=await this.c.query({text:'category:"language packs"',pageSize:20},v.token)}catch{return[]}const E=g.firstPage.filter(L=>L.properties.localizedLanguages?.length&&L.tags.some(d=>d.startsWith("lp-"))).map(L=>{const d=L.properties.localizedLanguages?.[0],l=f(L);return{...this.f(l,d,L),extensionId:L.identifier.id,galleryExtension:L}});return E.push({...this.f("en","English"),extensionId:"default"}),E}f(v,g,I){const E=g??v;let L;if(E!==v&&(L=`(${v})`),v.toLowerCase()===k.language.toLowerCase()&&(L??="",L+=(0,D.localize)(0,null)),I?.installCount){L??="";const d=I.installCount;let l;d>1e6?l=`${Math.floor(d/1e5)/10}M`:d>1e3?l=`${Math.floor(d/1e3)}K`:l=String(d),L+=` $(cloud-download) ${l}`}return{id:v,label:E,description:L}}};c=de([_(0,N.IExtensionGalleryService)],c),e.LanguagePackBaseService=c}),define(Y[10],Q([0,1,34,3,2,36,12,11,9]),function(x,e,T,O,k,D,N,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,f.createDecorator)("logService"),e.ILoggerService=(0,f.createDecorator)("loggerService");function c(){return new Date().toISOString()}var p;(function(a){a[a.Off=0]="Off",a[a.Trace=1]="Trace",a[a.Debug=2]="Debug",a[a.Info=3]="Info",a[a.Warning=4]="Warning",a[a.Error=5]="Error"})(p=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=p.Info;function v(a,o,u){switch(o){case p.Trace:a.trace(u);break;case p.Debug:a.debug(u);break;case p.Info:a.info(u);break;case p.Warning:a.warn(u);break;case p.Error:a.error(u);break;case p.Off:break;default:throw new Error(`Invalid log level ${o}`)}}e.log=v;function g(a){let o="";for(let u=0;u<a.length;u++){let w=a[u];if(typeof w=="object")try{w=JSON.stringify(w)}catch{}o+=(u>0?" ":"")+w}return o}e.format=g;class I extends k.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new O.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(o){this.b!==o&&(this.b=o,this.c.fire(this.b))}getLevel(){return this.b}f(o){return this.b!==p.Off&&this.b<=o}}e.AbstractLogger=I;class E extends I{constructor(o){super(),this.h=o}f(o){return this.h||super.f(o)}trace(o,...u){this.f(p.Trace)&&this.g(p.Trace,g([o,...u]))}debug(o,...u){this.f(p.Debug)&&this.g(p.Debug,g([o,...u]))}info(o,...u){this.f(p.Info)&&this.g(p.Info,g([o,...u]))}warn(o,...u){this.f(p.Warning)&&this.g(p.Warning,g([o,...u]))}error(o,...u){if(this.f(p.Error))if(o instanceof Error){const w=Array.prototype.slice.call(arguments);w[0]=o.stack,this.g(p.Error,g(w))}else this.g(p.Error,g([o,...u]))}flush(){}}e.AbstractMessageLogger=E;class L extends I{constructor(o=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(o),this.g=!N.isWindows}trace(o,...u){this.f(p.Trace)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,o,...u):console.log(`[main ${c()}]`,o,...u))}debug(o,...u){this.f(p.Debug)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,o,...u):console.log(`[main ${c()}]`,o,...u))}info(o,...u){this.f(p.Info)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,o,...u):console.log(`[main ${c()}]`,o,...u))}warn(o,...u){this.f(p.Warning)&&(this.g?console.warn(`\x1B[93m[main ${c()}]\x1B[0m`,o,...u):console.warn(`[main ${c()}]`,o,...u))}error(o,...u){this.f(p.Error)&&(this.g?console.error(`\x1B[91m[main ${c()}]\x1B[0m`,o,...u):console.error(`[main ${c()}]`,o,...u))}dispose(){}flush(){}}e.ConsoleMainLogger=L;class d extends I{constructor(o=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(o)}trace(o,...u){this.f(p.Trace)&&console.log("%cTRACE","color: #888",o,...u)}debug(o,...u){this.f(p.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",o,...u)}info(o,...u){this.f(p.Info)&&console.log("%c INFO","color: #33f",o,...u)}warn(o,...u){this.f(p.Warning)&&console.log("%c WARN","color: #993",o,...u)}error(o,...u){this.f(p.Error)&&console.log("%c  ERR","color: #f33",o,...u)}dispose(){}flush(){}}e.ConsoleLogger=d;class l extends I{constructor(o,u=e.DEFAULT_LOG_LEVEL){super(),this.g=o,this.setLevel(u)}trace(o,...u){this.f(p.Trace)&&this.g.log(p.Trace,[this.h(o),...u])}debug(o,...u){this.f(p.Debug)&&this.g.log(p.Debug,[this.h(o),...u])}info(o,...u){this.f(p.Info)&&this.g.log(p.Info,[this.h(o),...u])}warn(o,...u){this.f(p.Warning)&&this.g.log(p.Warning,[this.h(o),...u])}error(o,...u){this.f(p.Error)&&this.g.log(p.Error,[this.h(o),...u])}h(o){return typeof o=="string"?o:(0,T.toErrorMessage)(o,this.f(p.Trace))}dispose(){}flush(){}}e.AdapterLogger=l;class m extends I{constructor(o){super(),this.g=o,o.length&&this.setLevel(o[0].getLevel())}setLevel(o){for(const u of this.g)u.setLevel(o);super.setLevel(o)}trace(o,...u){for(const w of this.g)w.trace(o,...u)}debug(o,...u){for(const w of this.g)w.debug(o,...u)}info(o,...u){for(const w of this.g)w.info(o,...u)}warn(o,...u){for(const w of this.g)w.warn(o,...u)}error(o,...u){for(const w of this.g)w.error(o,...u)}flush(){for(const o of this.g)o.flush()}dispose(){for(const o of this.g)o.dispose()}}e.MultiplexLogService=m;class S extends k.Disposable{constructor(o){super(),this.b=o,this.B(o)}get onDidChangeLogLevel(){return this.b.onDidChangeLogLevel}setLevel(o){this.b.setLevel(o)}getLevel(){return this.b.getLevel()}trace(o,...u){this.b.trace(o,...u)}debug(o,...u){this.b.debug(o,...u)}info(o,...u){this.b.info(o,...u)}warn(o,...u){this.b.warn(o,...u)}error(o,...u){this.b.error(o,...u)}flush(){this.b.flush()}}e.LogService=S;class h extends k.Disposable{constructor(o,u){super(),this.c=o,this.b=new D.ResourceMap,this.B(u(w=>this.setLevel(w)))}getLoggers(){return[...this.b.values()].map(({logger:o})=>o)}getLogger(o){return this.b.get(o)?.logger}createLogger(o,u,w){let A=this.b.get(o)?.logger;return A||(w=u?.always?p.Trace:w,A=this.f(o,w??this.c,u),this.b.set(o,{logger:A,logLevel:w})),A}setLevel(o,u){const w=b.URI.isUri(o)?o:void 0,A=w?u:o;if(w){const $=this.b.get(w);$&&$.logLevel!==A&&($.logLevel=A,$.logger.setLevel(A))}else this.c=A,this.b.forEach(({logLevel:$,logger:Z})=>{$===void 0&&Z.setLevel(this.c)})}getLogLevel(o){return this.b.get(o)?.logLevel}dispose(){this.b.forEach(({logger:o})=>o.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=h;class y{constructor(){this.onDidChangeLogLevel=new O.Emitter().event}setLevel(o){}getLevel(){return p.Info}trace(o,...u){}debug(o,...u){}info(o,...u){}warn(o,...u){}error(o,...u){}critical(o,...u){}dispose(){}flush(){}}e.NullLogger=y;class t extends y{}e.NullLogService=t;class r extends h{constructor(){super(p.Info,O.Event.None)}f(o,u,w){return new y}}e.NullLoggerService=r;function i(a){if(a.verbose)return p.Trace;if(typeof a.logLevel=="string"){const o=s(a.logLevel.toLowerCase());if(o!==void 0)return o}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=i;function n(a){switch(a){case p.Trace:return"trace";case p.Debug:return"debug";case p.Info:return"info";case p.Warning:return"warn";case p.Error:return"error";case p.Off:return"off"}}e.LogLevelToString=n;function s(a){switch(a){case"trace":return p.Trace;case"debug":return p.Debug;case"info":return p.Info;case"warn":return p.Warning;case"error":return p.Error;case"critical":return p.Error;case"off":return p.Off}}e.parseLogLevel=s}),define(Y[116],Q([0,1,19,5,6,3,2,14,61,10]),function(x,e,T,O,k,D,N,b,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class p extends N.Disposable{constructor(g,I){super(),this.a=g,this.b=I,this.c=this.B(new D.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new D.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new O.ThrottledDelayer(0)),this.s=[],this.t=this.B(new O.ThrottledDelayer(0))}watch(g,I){return I.recursive||this.b?.watcher?.forceUniversal?this.l(g,I):this.u(g,I)}l(g,I){const E={path:this.C(g),excludes:I.excludes,includes:I.includes,recursive:I.recursive},L=(0,T.insert)(this.j,E);return this.m(),(0,N.toDisposable)(()=>{L(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(g=>(0,k.onUnexpectedError)(g))}n(){this.h||(this.h=this.B(this.p(I=>this.c.fire((0,f.toFileChanges)(I)),I=>this.z(I),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)})));const g=this.b?.watcher?.recursive?.usePolling;if(g===!0)for(const I of this.j)(0,f.isRecursiveWatchRequest)(I)&&(I.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(g))for(const I of this.j)(0,f.isRecursiveWatchRequest)(I)&&g.includes(I.path)&&(I.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(g,I){const E={path:this.C(g),excludes:I.excludes,includes:I.includes,recursive:!1},L=(0,T.insert)(this.s,E);return this.v(),(0,N.toDisposable)(()=>{L(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(g=>(0,k.onUnexpectedError)(g))}w(){return this.r||(this.r=this.B(this.y(g=>this.c.fire((0,f.toFileChanges)(g)),g=>this.z(g),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)}))),this.r.watch(this.s)}z(g){g.type==="error"&&this.g.fire(g.message),this.a[g.type](g.message)}C(g){return(0,b.normalize)(g.fsPath)}}e.AbstractDiskFileSystemProvider=p}),define(Y[117],Q([0,1,19,5,15,23,3,52,64,2,54,16,118,18,43,95,13,60,10,6]),function(x,e,T,O,k,D,N,b,f,c,p,v,g,I,E,L,d,l,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let h=class extends c.Disposable{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new N.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new N.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new N.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new N.Emitter),this.onDidRunOperation=this.m.event,this.R=this.B(new N.Emitter),this.onDidFilesChange=this.R.event,this.S=this.B(new N.Emitter),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new O.ResourceQueue)}registerProvider(t,r){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,g.mark)(`code/registerFilesystem/${t}`);const i=new c.DisposableStore;return this.h.set(t,r),this.c.fire({added:!0,scheme:t,provider:r}),i.add(r.onDidChangeFile(n=>this.R.fire(new d.FileChangesEvent(n,!this.O(r))))),typeof r.onDidWatchError=="function"&&i.add(r.onDidWatchError(n=>this.S.fire(new Error(n)))),i.add(r.onDidChangeCapabilities(()=>this.g.fire({provider:r,scheme:t}))),(0,c.toDisposable)(()=>{this.c.fire({added:!1,scheme:t,provider:r}),this.h.delete(t),(0,c.dispose)(i)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const r=[];this.f.fire({scheme:t,join(i){r.push(i)}}),!this.h.has(t)&&await O.Promises.settled(r)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,r){const i=this.h.get(t.scheme);return!!(i&&i.capabilities&r)}listCapabilities(){return f.Iterable.map(this.h,([t,r])=>({scheme:t,capabilities:r.capabilities}))}async j(t){if(!(0,I.isAbsolutePath)(t))throw new d.FileOperationError((0,L.localize)(0,null,this.nb(t)),8);await this.activateProvider(t.scheme);const r=this.h.get(t.scheme);if(!r){const i=new S.ErrorNoTelemetry;throw i.message=(0,L.localize)(1,null,t.toString()),i}return r}async k(t){const r=await this.j(t);if((0,d.hasOpenReadWriteCloseCapability)(r)||(0,d.hasReadWriteCapability)(r)||(0,d.hasFileReadStreamCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(t){const r=await this.j(t);if((0,d.hasOpenReadWriteCloseCapability)(r)||(0,d.hasReadWriteCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,r){try{return await this.n(t,r)}catch(i){throw(0,d.toFileSystemProviderErrorCode)(i)===d.FileSystemProviderErrorCode.FileNotFound?new d.FileOperationError((0,L.localize)(2,null,this.nb(t)),1):(0,d.ensureFileSystemProviderError)(i)}}async n(t,r){const i=await this.j(t),n=this.O(i),s=r?.resolveTo,a=r?.resolveSingleChildDescendants,o=r?.resolveMetadata,u=await i.stat(t);let w;return this.p(i,t,u,void 0,!!o,(A,$)=>(w||(w=p.TernarySearchTree.forUris(()=>!n),w.set(t,!0),s&&w.fill(!0,s)),w.get(A.resource)||w.findSuperstr(A.resource.with({query:null,fragment:null}))?!0:A.isDirectory&&a?$===1:!1))}async p(t,r,i,n,s,a){const{providerExtUri:o}=this.N(t),u={resource:r,name:o.basename(r),isFile:(i.type&d.FileType.File)!==0,isDirectory:(i.type&d.FileType.Directory)!==0,isSymbolicLink:(i.type&d.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:Boolean((i.permissions??0)&d.FilePermission.Readonly)||Boolean(t.capabilities&2048),etag:(0,d.etag)({mtime:i.mtime,size:i.size}),children:void 0};if(u.isDirectory&&a(u,n)){try{const w=await t.readdir(r),A=await O.Promises.settled(w.map(async([$,Z])=>{try{const X=o.joinPath(r,$),ee=s?await t.stat(X):{type:Z};return await this.p(t,X,ee,w.length,s,a)}catch(X){return this.b.trace(X),null}}));u.children=(0,T.coalesce)(A)}catch(w){this.b.trace(w),u.children=[]}return u}return u}async resolveAll(t){return O.Promises.settled(t.map(async r=>{try{return{stat:await this.n(r.resource,r.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(t){const r=await this.j(t),i=await r.stat(t);return this.p(r,t,i,void 0,!0,()=>!1)}async exists(t){const r=await this.j(t);try{return!!await r.stat(t)}catch{return!1}}async canCreateFile(t,r){try{await this.r(t,r)}catch(i){return i}return!0}async r(t,r){if(!r?.overwrite&&await this.exists(t))throw new d.FileOperationError((0,L.localize)(3,null,this.nb(t)),3,r)}async createFile(t,r=k.VSBuffer.fromString(""),i){await this.r(t,i);const n=await this.writeFile(t,r);return this.m.fire(new d.FileOperationEvent(t,0,n)),n}async writeFile(t,r,i){const n=this.lb(await this.l(t),t),{providerExtUri:s}=this.N(n);try{await this.s(n,t,i)||await this.P(n,s.dirname(t));let o;if((0,d.hasReadWriteCapability)(n)&&!(r instanceof k.VSBuffer))if((0,E.isReadableStream)(r)){const u=await(0,E.peekStream)(r,3);u.ended?o=k.VSBuffer.concat(u.buffer):o=u}else o=(0,E.peekReadable)(r,u=>k.VSBuffer.concat(u),3);else o=r;!(0,d.hasOpenReadWriteCloseCapability)(n)||(0,d.hasReadWriteCapability)(n)&&o instanceof k.VSBuffer?await this.cb(n,t,i,o):await this.Y(n,t,i,o instanceof k.VSBuffer?(0,k.bufferToReadable)(o):o),this.m.fire(new d.FileOperationEvent(t,4))}catch(a){throw new d.FileOperationError((0,L.localize)(4,null,this.nb(t),(0,d.ensureFileSystemProviderError)(a).toString()),(0,d.toFileOperationResult)(a),i)}return this.resolve(t,{resolveMetadata:!0})}async s(t,r,i){if(!!i?.unlock&&!(t.capabilities&8192))throw new Error((0,L.localize)(5,null,this.nb(r)));let s;try{s=await t.stat(r)}catch{return}if((s.type&d.FileType.Directory)!==0)throw new d.FileOperationError((0,L.localize)(6,null,this.nb(r)),0,i);if(this.mb(r,s),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==d.ETAG_DISABLED&&typeof s.mtime=="number"&&typeof s.size=="number"&&i.mtime<s.mtime&&i.etag!==(0,d.etag)({mtime:i.mtime,size:s.size}))throw new d.FileOperationError((0,L.localize)(7,null),3,i);return s}async readFile(t,r,i){const n=await this.k(t);return r?.atomic?this.t(n,t,r,i):this.u(n,t,r,i)}async t(t,r,i,n){return new Promise((s,a)=>{this.X.queueFor(r,this.N(t).providerExtUri).queue(async()=>{try{const o=await this.u(t,r,i,n);s(o)}catch(o){a(o)}})})}async u(t,r,i,n){const s=await this.v(t,r,{...i,preferUnbuffered:!0},n);return{...s,value:await(0,k.streamToBuffer)(s.value)}}async readFileStream(t,r,i){const n=await this.k(t);return this.v(n,t,r,i)}async v(t,r,i,n){const s=new D.CancellationTokenSource(n),a=this.F(r,i).then(u=>u,u=>{throw s.cancel(),u});let o;try{return typeof i?.etag=="string"&&i.etag!==d.ETAG_DISABLED&&await a,i?.atomic&&(0,d.hasFileAtomicReadCapability)(t)||!((0,d.hasOpenReadWriteCloseCapability)(t)||(0,d.hasFileReadStreamCapability)(t))||(0,d.hasReadWriteCapability)(t)&&i?.preferUnbuffered?o=this.D(t,r,i):(0,d.hasFileReadStreamCapability)(t)?o=this.z(t,r,s.token,i):o=this.C(t,r,s.token,i),{...await a,value:o}}catch(u){throw o&&await(0,E.consumeStream)(o),this.w(u,r,i)}}w(t,r,i){const n=(0,L.localize)(8,null,this.nb(r),(0,d.ensureFileSystemProviderError)(t).toString());return t instanceof d.NotModifiedSinceFileOperationError?new d.NotModifiedSinceFileOperationError(n,t.stat,i):t instanceof d.TooLargeFileOperationError?new d.TooLargeFileOperationError(n,t.fileOperationResult,t.size,t.options):new d.FileOperationError(n,(0,d.toFileOperationResult)(t),i)}z(t,r,i,n=Object.create(null)){const s=t.readFileStream(r,n,i);return(0,E.transform)(s,{data:a=>a instanceof k.VSBuffer?a:k.VSBuffer.wrap(a),error:a=>this.w(a,r,n)},a=>k.VSBuffer.concat(a))}C(t,r,i,n=Object.create(null)){const s=(0,k.newWriteableBufferStream)();return(0,l.readFileIntoStream)(t,r,s,a=>a,{...n,bufferSize:this.a,errorTransformer:a=>this.w(a,r,n)},i),s}D(t,r,i){const n=(0,E.newWriteableStream)(s=>k.VSBuffer.concat(s));return(async()=>{try{let s;i?.atomic&&(0,d.hasFileAtomicReadCapability)(t)?s=await t.readFile(r,{atomic:!0}):s=await t.readFile(r),typeof i?.position=="number"&&(s=s.slice(i.position)),typeof i?.length=="number"&&(s=s.slice(0,i.length)),this.G(r,s.byteLength,i),n.end(k.VSBuffer.wrap(s))}catch(s){n.error(s),n.end()}})(),n}async F(t,r){const i=await this.resolve(t,{resolveMetadata:!0});if(i.isDirectory)throw new d.FileOperationError((0,L.localize)(9,null,this.nb(t)),0,r);if(typeof r?.etag=="string"&&r.etag!==d.ETAG_DISABLED&&r.etag===i.etag)throw new d.NotModifiedSinceFileOperationError((0,L.localize)(10,null),i,r);return this.G(t,i.size,r),i}G(t,r,i){if(i?.limits){let n;if(typeof i.limits.memory=="number"&&r>i.limits.memory&&(n=9),typeof i.limits.size=="number"&&r>i.limits.size&&(n=7),typeof n=="number")throw new d.TooLargeFileOperationError((0,L.localize)(11,null,this.nb(t)),n,r,i)}}async canMove(t,r,i){return this.H(t,r,"move",i)}async canCopy(t,r,i){return this.H(t,r,"copy",i)}async H(t,r,i,n){if(t.toString()!==r.toString())try{const s=i==="move"?this.lb(await this.l(t),t):await this.k(t),a=this.lb(await this.l(r),r);await this.M(s,t,a,r,i,n)}catch(s){return s}return!0}async move(t,r,i){const n=this.lb(await this.l(t),t),s=this.lb(await this.l(r),r),a=await this.I(n,t,s,r,"move",!!i),o=await this.resolve(r,{resolveMetadata:!0});return this.m.fire(new d.FileOperationEvent(t,a==="move"?2:3,o)),o}async copy(t,r,i){const n=await this.k(t),s=this.lb(await this.l(r),r),a=await this.I(n,t,s,r,"copy",!!i),o=await this.resolve(r,{resolveMetadata:!0});return this.m.fire(new d.FileOperationEvent(t,a==="copy"?3:2,o)),o}async I(t,r,i,n,s,a){if(r.toString()===n.toString())return s;const{exists:o,isSameResourceWithDifferentPathCase:u}=await this.M(t,r,i,n,s,a);if(o&&!u&&a&&await this.del(n,{recursive:!0}),await this.P(i,this.N(i).providerExtUri.dirname(n)),s==="copy"){if(t===i&&(0,d.hasFileFolderCopyCapability)(t))await t.copy(r,n,{overwrite:a});else{const w=await this.resolve(r);w.isDirectory?await this.L(t,w,i,n):await this.J(t,r,i,n)}return s}else return t===i?(await t.rename(r,n,{overwrite:a}),s):(await this.I(t,r,i,n,"copy",a),await this.del(r,{recursive:!0}),"copy")}async J(t,r,i,n){if((0,d.hasOpenReadWriteCloseCapability)(t)&&(0,d.hasOpenReadWriteCloseCapability)(i))return this.eb(t,r,i,n);if((0,d.hasOpenReadWriteCloseCapability)(t)&&(0,d.hasReadWriteCapability)(i))return this.kb(t,r,i,n);if((0,d.hasReadWriteCapability)(t)&&(0,d.hasOpenReadWriteCloseCapability)(i))return this.ib(t,r,i,n);if((0,d.hasReadWriteCapability)(t)&&(0,d.hasReadWriteCapability)(i))return this.gb(t,r,i,n)}async L(t,r,i,n){await i.mkdir(n),Array.isArray(r.children)&&await O.Promises.settled(r.children.map(async s=>{const a=this.N(i).providerExtUri.joinPath(n,s.name);return s.isDirectory?this.L(t,await this.resolve(s.resource),i,a):this.J(t,s.resource,i,a)}))}async M(t,r,i,n,s,a){let o=!1;if(t===i){const{providerExtUri:w,isPathCaseSensitive:A}=this.N(t);if(A||(o=w.isEqual(r,n)),o&&s==="copy")throw new Error((0,L.localize)(12,null,this.nb(r),this.nb(n)));if(!o&&w.isEqualOrParent(n,r))throw new Error((0,L.localize)(13,null,this.nb(r),this.nb(n)))}const u=await this.exists(n);if(u&&!o){if(!a)throw new d.FileOperationError((0,L.localize)(14,null,this.nb(r),this.nb(n)),4);if(t===i){const{providerExtUri:w}=this.N(t);if(w.isEqualOrParent(r,n))throw new Error((0,L.localize)(15,null,this.nb(r),this.nb(n)))}}return{exists:u,isSameResourceWithDifferentPathCase:o}}N(t){const r=this.O(t);return{providerExtUri:r?I.extUri:I.extUriIgnorePathCase,isPathCaseSensitive:r}}O(t){return!!(t.capabilities&1024)}async createFolder(t){const r=this.lb(await this.j(t),t);await this.P(r,t);const i=await this.resolve(t,{resolveMetadata:!0});return this.m.fire(new d.FileOperationEvent(t,0,i)),i}async P(t,r){const i=[],{providerExtUri:n}=this.N(t);for(;!n.isEqual(r,n.dirname(r));)try{if(((await t.stat(r)).type&d.FileType.Directory)===0)throw new Error((0,L.localize)(16,null,this.nb(r)));break}catch(s){if((0,d.toFileSystemProviderErrorCode)(s)!==d.FileSystemProviderErrorCode.FileNotFound)throw s;i.push(n.basename(r)),r=n.dirname(r)}for(let s=i.length-1;s>=0;s--){r=n.joinPath(r,i[s]);try{await t.mkdir(r)}catch(a){if((0,d.toFileSystemProviderErrorCode)(a)!==d.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(t,r){try{await this.Q(t,r)}catch(i){return i}return!0}async Q(t,r){const i=this.lb(await this.j(t),t);if(!!r?.useTrash&&!(i.capabilities&4096))throw new Error((0,L.localize)(17,null,this.nb(t)));let s;try{s=await i.stat(t)}catch{}if(s)this.mb(t,s);else throw new d.FileOperationError((0,L.localize)(18,null,this.nb(t)),1);if(!!!r?.recursive){const o=await this.resolve(t);if(o.isDirectory&&Array.isArray(o.children)&&o.children.length>0)throw new Error((0,L.localize)(19,null,this.nb(t)))}return i}async del(t,r){const i=await this.Q(t,r),n=!!r?.useTrash,s=!!r?.recursive;await i.delete(t,{recursive:s,useTrash:n}),this.m.fire(new d.FileOperationEvent(t,1))}async cloneFile(t,r){const i=await this.j(t),n=this.lb(await this.l(r),r);if(i===n&&this.N(i).providerExtUri.isEqual(t,r))return;if(i===n&&(0,d.hasFileCloneCapability)(i))return i.cloneFile(t,r);await this.P(n,this.N(n).providerExtUri.dirname(r));const s=this.X.queueFor(t,this.N(i).providerExtUri);return i===n&&(0,d.hasFileFolderCopyCapability)(i)?s.queue(()=>i.copy(t,r,{overwrite:!0})):s.queue(()=>this.J(i,t,n,r))}watch(t,r={recursive:!1,excludes:[]}){const i=new c.DisposableStore;let n=!1,s=()=>{n=!0};return i.add((0,c.toDisposable)(()=>s())),(async()=>{try{const a=await this.W(t,r);n?(0,c.dispose)(a):s=()=>(0,c.dispose)(a)}catch(a){this.b.error(a)}})(),i}async W(t,r){const i=await this.j(t),n=(0,b.hash)([this.N(i).providerExtUri.getComparisonKey(t),r]);let s=this.U.get(n);return s||(s={count:0,disposable:i.watch(t,r)},this.U.set(n,s)),s.count+=1,(0,c.toDisposable)(()=>{s&&(s.count--,s.count===0&&((0,c.dispose)(s.disposable),this.U.delete(n)))})}dispose(){super.dispose();for(const[,t]of this.U)(0,c.dispose)(t.disposable);this.U.clear()}async Y(t,r,i,n){return this.X.queueFor(r,this.N(t).providerExtUri).queue(async()=>{const s=await t.open(r,{create:!0,unlock:i?.unlock??!1});try{(0,E.isReadableStream)(n)||(0,E.isReadableBufferedStream)(n)?await this.Z(t,s,n):await this.ab(t,s,n)}catch(a){throw(0,d.ensureFileSystemProviderError)(a)}finally{await t.close(s)}})}async Z(t,r,i){let n=0,s;if((0,E.isReadableBufferedStream)(i)){if(i.buffer.length>0){const a=k.VSBuffer.concat(i.buffer);await this.bb(t,r,a,a.byteLength,n,0),n+=a.byteLength}if(i.ended)return;s=i.stream}else s=i;return new Promise((a,o)=>{(0,E.listenStream)(s,{onData:async u=>{s.pause();try{await this.bb(t,r,u,u.byteLength,n,0)}catch(w){return o(w)}n+=u.byteLength,setTimeout(()=>s.resume())},onError:u=>o(u),onEnd:()=>a()})})}async ab(t,r,i){let n=0,s;for(;(s=i.read())!==null;)await this.bb(t,r,s,s.byteLength,n,0),n+=s.byteLength}async bb(t,r,i,n,s,a){let o=0;for(;o<n;)o+=await t.write(r,s+o,i.buffer,a+o,n-o)}async cb(t,r,i,n){return this.X.queueFor(r,this.N(t).providerExtUri).queue(()=>this.db(t,r,i,n))}async db(t,r,i,n){let s;n instanceof k.VSBuffer?s=n:(0,E.isReadableStream)(n)?s=await(0,k.streamToBuffer)(n):(0,E.isReadableBufferedStream)(n)?s=await(0,k.bufferedStreamToBuffer)(n):s=(0,k.readableToBuffer)(n),await t.writeFile(r,s.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1})}async eb(t,r,i,n){return this.X.queueFor(n,this.N(i).providerExtUri).queue(()=>this.fb(t,r,i,n))}async fb(t,r,i,n){let s,a;try{s=await t.open(r,{create:!1}),a=await i.open(n,{create:!0,unlock:!1});const o=k.VSBuffer.alloc(this.a);let u=0,w=0,A=0;do A=await t.read(s,u,o.buffer,w,o.byteLength-w),await this.bb(i,a,o,A,u,w),u+=A,w+=A,w===o.byteLength&&(w=0);while(A>0)}catch(o){throw(0,d.ensureFileSystemProviderError)(o)}finally{await O.Promises.settled([typeof s=="number"?t.close(s):Promise.resolve(),typeof a=="number"?i.close(a):Promise.resolve()])}}async gb(t,r,i,n){return this.X.queueFor(n,this.N(i).providerExtUri).queue(()=>this.hb(t,r,i,n))}async hb(t,r,i,n){return i.writeFile(n,await t.readFile(r),{create:!0,overwrite:!0,unlock:!1})}async ib(t,r,i,n){return this.X.queueFor(n,this.N(i).providerExtUri).queue(()=>this.jb(t,r,i,n))}async jb(t,r,i,n){const s=await i.open(n,{create:!0,unlock:!1});try{const a=await t.readFile(r);await this.bb(i,s,k.VSBuffer.wrap(a),a.byteLength,0,0)}catch(a){throw(0,d.ensureFileSystemProviderError)(a)}finally{await i.close(s)}}async kb(t,r,i,n){const s=await(0,k.streamToBuffer)(this.C(t,r,D.CancellationToken.None));await this.cb(i,n,void 0,s)}lb(t,r){if(t.capabilities&2048)throw new d.FileOperationError((0,L.localize)(20,null,this.nb(r)),6);return t}mb(t,r){if((r.permissions??0)&d.FilePermission.Readonly)throw new d.FileOperationError((0,L.localize)(21,null,this.nb(t)),6)}nb(t){return t.scheme===v.Schemas.file?t.fsPath:t.toString(!0)}};h=de([_(0,m.ILogService)],h),e.FileService=h}),define(Y[119],Q([0,1,120,160,5,36,15,3,161,2,14,12,18,43,20,97,13,60,116,34,114,113]),function(x,e,T,O,k,D,N,b,f,c,p,v,g,I,E,L,d,l,m,S,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,O.gracefulify)(T)}catch(r){console.error(`Error enabling graceful-fs: ${(0,S.toErrorMessage)(r)}`)}})();class t extends m.AbstractDiskFileSystemProvider{constructor(i,n){super(i,n),this.onDidChangeCapabilities=b.Event.None,this.H=new D.ResourceMap(s=>g.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,v.isLinux&&(this.F|=1024)),this.F}async stat(i){try{const{stat:n,symbolicLink:s}=await E.SymlinkSupport.stat(this.C(i));return{type:this.G(n,s),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.Y(n)}}async readdir(i){try{const n=await E.Promises.readdir(this.C(i),{withFileTypes:!0}),s=[];return await Promise.all(n.map(async a=>{try{let o;a.isSymbolicLink()?o=(await this.stat((0,g.joinPath)(i,a.name))).type:o=this.G(a),s.push([a.name,o])}catch(o){this.a.trace(o)}})),s}catch(n){throw this.Y(n)}}G(i,n){let s;return n?.dangling?s=d.FileType.Unknown:i.isFile()?s=d.FileType.File:i.isDirectory()?s=d.FileType.Directory:s=d.FileType.Unknown,n&&(s|=d.FileType.SymbolicLink),s}async I(i){const n=this.C(i);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let s;for(;s=this.H.get(i);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await s.wait();const a=new k.Barrier;return this.H.set(i,a),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,c.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.H.get(i)===a&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.H.delete(i)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),a.open()})}async readFile(i,n){let s;try{n?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.C(i)})`),s=await this.I(i));const a=this.C(i);return await E.Promises.readFile(a)}catch(a){throw this.Y(a)}finally{s?.dispose()}}J(i){t.D&&this.a.trace(i)}readFileStream(i,n,s){const a=(0,I.newWriteableStream)(o=>N.VSBuffer.concat(o.map(u=>N.VSBuffer.wrap(u))).buffer);return(0,l.readFileIntoStream)(this,i,a,o=>o.buffer,{...n,bufferSize:256*1024},s),a}async writeFile(i,n,s){let a;try{const o=this.C(i);if(!s.create||!s.overwrite){if(await E.Promises.exists(o)){if(!s.overwrite)throw(0,d.createFileSystemProviderError)((0,L.localize)(0,null),d.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,d.createFileSystemProviderError)((0,L.localize)(1,null),d.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(i,{create:!0,unlock:s.unlock}),await this.write(a,0,n,0,n.byteLength)}catch(o){throw await this.Z(i,o)}finally{typeof a=="number"&&await this.close(a)}}static configureFlushOnWrite(i){t.O=i}async open(i,n){const s=this.C(i);let a;(0,d.isFileOpenForWriteOptions)(n)&&(a=await this.I(i));let o;try{if((0,d.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:w}=await E.SymlinkSupport.stat(s);w.mode&128||await E.Promises.chmod(s,w.mode|128)}catch(w){this.a.trace(w)}let u;if((0,d.isFileOpenForWriteOptions)(n)){if(v.isWindows)try{await E.Promises.truncate(s,0),u="r+"}catch(w){w.code!=="ENOENT"&&this.a.trace(w)}u||(u="w")}else u="r";o=await E.Promises.open(s,u)}catch(u){throw a?.dispose(),(0,d.isFileOpenForWriteOptions)(n)?await this.Z(i,u):this.Y(u)}if(this.L.set(o,0),(0,d.isFileOpenForWriteOptions)(n)&&this.N.set(o,i),a){const u=this.M.get(o);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${o} (${s})`),this.M.set(o,a),u&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${o} (${s})`),u.dispose())}return o}async close(i){const n=this.M.get(i);try{if(this.L.delete(i),this.N.delete(i)&&t.O)try{await E.Promises.fdatasync(i)}catch(s){t.configureFlushOnWrite(!1),this.a.error(s)}return await E.Promises.close(i)}catch(s){throw this.Y(s)}finally{n&&(this.M.get(i)===n&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.M.delete(i)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),n.dispose())}}async read(i,n,s,a,o){const u=this.P(i,n);let w=null;try{w=(await E.Promises.read(i,s,a,o,u)).bytesRead}catch(A){throw this.Y(A)}finally{this.Q(i,u,w)}return w}P(i,n){return n===this.L.get(i)?null:n}Q(i,n,s){const a=this.L.get(i);typeof a=="number"&&(typeof n=="number"||(typeof s=="number"?this.L.set(i,a+s):this.L.delete(i)))}async write(i,n,s,a,o){return(0,k.retry)(()=>this.R(i,n,s,a,o),100,3)}async R(i,n,s,a,o){const u=this.P(i,n);let w=null;try{w=(await E.Promises.write(i,s,a,o,u)).bytesWritten}catch(A){throw await this.Z(this.N.get(i),A)}finally{this.Q(i,u,w)}return w}async mkdir(i){try{await E.Promises.mkdir(this.C(i))}catch(n){throw this.Y(n)}}async delete(i,n){try{const s=this.C(i);n.recursive?await E.Promises.rm(s,E.RimRafMode.MOVE):await E.Promises.unlink(s)}catch(s){throw this.Y(s)}}async rename(i,n,s){const a=this.C(i),o=this.C(n);if(a!==o)try{await this.S(i,n,"move",s.overwrite),await E.Promises.move(a,o)}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,L.localize)(2,null,(0,p.basename)(a),(0,p.basename)((0,p.dirname)(o)),u.toString()))),this.Y(u)}}async copy(i,n,s){const a=this.C(i),o=this.C(n);if(a!==o)try{await this.S(i,n,"copy",s.overwrite),await E.Promises.copy(a,o,{preserveSymlinks:!0})}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,L.localize)(3,null,(0,p.basename)(a),(0,p.basename)((0,p.dirname)(o)),u.toString()))),this.Y(u)}}async S(i,n,s,a){const o=this.C(i),u=this.C(n);let w=!1;if(!!(this.capabilities&1024)||(w=(0,f.isEqual)(o,u,!0)),w&&s==="copy")throw(0,d.createFileSystemProviderError)((0,L.localize)(4,null),d.FileSystemProviderErrorCode.FileExists);if(!w&&await E.Promises.exists(u)){if(!a)throw(0,d.createFileSystemProviderError)((0,L.localize)(5,null),d.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}async cloneFile(i,n){return this.U(i,n,!1)}async U(i,n,s){const a=this.C(i),o=this.C(n),u=!!(this.capabilities&1024);if((0,f.isEqual)(a,o,!u))return;const w=new c.DisposableStore;try{const[A,$]=await Promise.all([this.I(i),this.I(n)]);w.add(A),w.add($),s&&await E.Promises.mkdir((0,p.dirname)(o),{recursive:!0}),await E.Promises.copyFile(a,o)}catch(A){if(A.code==="ENOENT"&&!s)return this.U(i,n,!0);throw this.Y(A)}finally{w.dispose()}}p(i,n,s){return new h.UniversalWatcherClient(a=>i(a),a=>n(a),s)}y(i,n,s){return new y.NodeJSWatcherClient(a=>i(a),a=>n(a),s)}Y(i){if(i instanceof d.FileSystemProviderError)return i;let n;switch(i.code){case"ENOENT":n=d.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=d.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=d.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=d.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=d.FileSystemProviderErrorCode.NoPermissions;break;default:n=d.FileSystemProviderErrorCode.Unknown}return(0,d.createFileSystemProviderError)(i,n)}async Z(i,n){let s=this.Y(n);if(i&&s.code===d.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await E.SymlinkSupport.stat(this.C(i));a.mode&128||(s=(0,d.createFileSystemProviderError)(n,d.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.a.trace(a)}return s}}e.DiskFileSystemProvider=t,t.D=!1,t.O=!0}),define(Y[121],Q([0,1,13,10]),function(x,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var k;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(k||(k={}));async function D(c,p,v,g,I){try{const E=await new Promise((d,l)=>{x(["spdlog"],d,l)});E.setFlushOn(k.Trace);const L=await E.createAsyncRotatingLogger(c,p,v,g);return I?L.clearFormatters():L.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),L}catch(E){console.error(E)}return null}function N(c,p,v){switch(p){case O.LogLevel.Trace:c.trace(v);break;case O.LogLevel.Debug:c.debug(v);break;case O.LogLevel.Info:c.info(v);break;case O.LogLevel.Warning:c.warn(v);break;case O.LogLevel.Error:c.error(v);break;case O.LogLevel.Off:break;default:throw new Error(`Invalid log level ${p}`)}}function b(c,p){switch(p){case O.LogLevel.Trace:c.setLevel(k.Trace);break;case O.LogLevel.Debug:c.setLevel(k.Debug);break;case O.LogLevel.Info:c.setLevel(k.Info);break;case O.LogLevel.Warning:c.setLevel(k.Warning);break;case O.LogLevel.Error:c.setLevel(k.Error);break;case O.LogLevel.Off:c.setLevel(k.Off);break;default:throw new Error(`Invalid log level ${p}`)}}class f extends O.AbstractMessageLogger{constructor(p,v,g,I,E){super(),this.k=[],this.setLevel(E),this.l=this.n(p,v,g,I),this.B(this.onDidChangeLogLevel(L=>{this.m&&b(this.m,L)}))}async n(p,v,g,I){const E=g?6:1,L=30/E*T.ByteSize.MB,d=await D(p,v,L,E,I);if(d){this.m=d,b(this.m,this.getLevel());for(const{level:l,message:m}of this.k)N(this.m,l,m);this.k=[]}}g(p,v){this.m?N(this.m,p,v):this.getLevel()<=p&&this.k.push({level:p,message:v})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=f}),define(Y[38],Q([0,1,3,64,2,9]),function(x,e,T,O,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,D.createDecorator)("policy");class N extends k.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new T.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(c){const p=Object.keys(this.f).length;return this.f={...c,...this.f},p!==Object.keys(this.f).length&&await this.i(c),O.Iterable.reduce(this.g.entries(),(v,[g,I])=>({...v,[g]:I}),{})}getPolicyValue(c){return this.g.get(c)}serialize(){return O.Iterable.reduce(Object.entries(this.f),(c,[p,v])=>({...c,[p]:{definition:v,value:this.g.get(p)}}),{})}}e.AbstractPolicyService=N;class b{constructor(){this.onDidChange=T.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=b}),define(Y[122],Q([0,1,5,3,64,4,13,10,38]),function(x,e,T,O,k,D,N,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function c(v,g){const I=[];for(const E of new Set(k.Iterable.concat(v.keys(),g.keys())))v.get(E)!==g.get(E)&&I.push(E);return I}let p=class extends f.AbstractPolicyService{constructor(g,I,E){super(),this.j=g,this.k=I,this.l=E,this.c=this.B(new T.ThrottledDelayer(500));const L=O.Event.filter(I.onDidFilesChange,d=>d.affects(g));this.B(I.watch(g)),this.B(L(()=>this.c.trigger(()=>this.p())))}async i(){await this.p()}async n(){const g=new Map;try{const I=await this.k.readFile(this.j),E=JSON.parse(I.value.toString());if(!(0,D.isObject)(E))throw new Error("Policy file isn't a JSON object");for(const L of Object.keys(E))this.f[L]&&g.set(L,E[L])}catch(I){I.fileOperationResult!==1&&this.l.error("[FilePolicyService] Failed to read policies",I)}return g}async p(){const g=await this.n(),I=c(this.g,g);this.g=g,I.length>0&&this.h.fire(I)}};p=de([_(1,N.IFileService),_(2,b.ILogService)],p),e.FilePolicyService=p}),define(Y[28],Q([0,1,9]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,T.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(Y[37],Q([0,1,70,4]),function(x,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.a=new Map}add(N,b){T.ok(O.isString(N)),T.ok(O.isObject(b)),T.ok(!this.a.has(N),"There is already an extension with this id"),this.a.set(N,b)}knows(N){return this.a.has(N)}as(N){return this.a.get(N)||null}}e.Registry=new k}),define(Y[123],Q([0,1,3,37]),function(x,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class D{constructor(){this.b=new T.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(f,c){this.a[k(f)]=c,this.b.fire(f)}notifySchemaChanged(f){this.b.fire(f)}getSchemaContributions(){return{schemas:this.a}}}const N=new D;O.Registry.add(e.Extensions.JSONContribution,N)}),define(Y[42],Q([0,1,19,3,4,86,21,123,37]),function(x,e,T,O,k,D,N,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var c;(function(y){y.Multiline="multilineText",y.Singleline="singlelineText"})(c=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var p;(function(y){y[y.APPLICATION=1]="APPLICATION",y[y.MACHINE=2]="MACHINE",y[y.WINDOW=3]="WINDOW",y[y.RESOURCE=4]="RESOURCE",y[y.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",y[y.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(p=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const v=f.Registry.as(b.Extensions.JSONContribution);class g{constructor(){this.h=new Set,this.i=new O.Emitter,this.onDidSchemaChange=this.i.event,this.j=new O.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:D.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},v.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(t,r=!0){this.registerConfigurations([t],r)}registerConfigurations(t,r=!0){const i=new Set;this.n(t,r,i),v.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}deregisterConfigurations(t){const r=new Set;this.o(t,r),v.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:t,remove:r}){const i=new Set;this.o(r,i),this.n(t,!1,i),v.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}registerDefaultConfigurations(t){const r=new Set;this.k(t,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(t,r){const i=[];for(const{overrides:n,source:s}of t)for(const a in n)if(r.add(a),e.OVERRIDE_PROPERTY_REGEX.test(a)){const o=this.a.get(a),u=o?.valuesSources??new Map;if(s)for(const Z of Object.keys(n[a]))u.set(Z,s);const w={...o?.value||{},...n[a]};this.a.set(a,{source:s,value:w,valuesSources:u});const A=(0,N.getLanguageTagSettingPlainKey)(a),$={type:"object",default:w,description:D.localize(1,null,A),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:w,source:k.isString(s)?void 0:s,defaultValueSource:s};i.push(...L(a)),this.d[a]=$,this.b.properties[a]=$}else{this.a.set(a,{value:n[a],source:s});const o=this.d[a];o&&(this.w(a,o),this.r(a,o))}this.m(i)}deregisterDefaultConfigurations(t){const r=new Set;this.l(t,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(t,r){for(const{overrides:i,source:n}of t)for(const s in i){const a=this.a.get(s),o=k.isString(n)?n:n?.id,u=k.isString(a?.source)?a?.source:a?.source?.id;if(o===u)if(r.add(s),this.a.delete(s),e.OVERRIDE_PROPERTY_REGEX.test(s))delete this.d[s],delete this.b.properties[s];else{const w=this.d[s];w&&(this.w(s,w),this.r(s,w))}}this.u()}deltaConfiguration(t){let r=!1;const i=new Set;t.removedDefaults&&(this.l(t.removedDefaults,i),r=!0),t.addedDefaults&&(this.k(t.addedDefaults,i),r=!0),t.removedConfigurations&&this.o(t.removedConfigurations,i),t.addedConfigurations&&this.n(t.addedConfigurations,!1,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const r of t)this.h.add(r);this.u()}n(t,r,i){t.forEach(n=>{this.p(n,r,n.extensionInfo,n.restrictedProperties,void 0,i),this.c.push(n),this.q(n)})}o(t,r){const i=n=>{if(n.properties)for(const s in n.properties){r.add(s);const a=this.d[s];a?.policy?.name&&this.e.delete(a.policy.name),delete this.d[s],this.s(s,n.properties[s])}n.allOf?.forEach(s=>i(s))};for(const n of t){i(n);const s=this.c.indexOf(n);s!==-1&&this.c.splice(s,1)}}p(t,r=!0,i,n,s=3,a){s=k.isUndefinedOrNull(t.scope)?s:t.scope;const o=t.properties;if(o)for(const w in o){const A=o[w];if(r&&S(w,A)){delete o[w];continue}if(A.source=i,A.defaultDefaultValue=o[w].default,this.w(w,A),e.OVERRIDE_PROPERTY_REGEX.test(w)?A.scope=void 0:(A.scope=k.isUndefinedOrNull(A.scope)?s:A.scope,A.restricted=k.isUndefinedOrNull(A.restricted)?!!n?.includes(w):A.restricted),o[w].hasOwnProperty("included")&&!o[w].included){this.f[w]=o[w],delete o[w];continue}else this.d[w]=o[w],o[w].policy?.name&&this.e.set(o[w].policy.name,w);!o[w].deprecationMessage&&o[w].markdownDeprecationMessage&&(o[w].deprecationMessage=o[w].markdownDeprecationMessage),a.add(w)}const u=t.allOf;if(u)for(const w of u)this.p(w,r,i,n,s,a)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const r=i=>{const n=i.properties;if(n)for(const a in n)this.r(a,n[a]);i.allOf?.forEach(r)};r(t)}r(t,r){switch(e.allSettings.properties[t]=r,r.scope){case 1:e.applicationSettings.properties[t]=r;break;case 2:e.machineSettings.properties[t]=r;break;case 6:e.machineOverridableSettings.properties[t]=r;break;case 3:e.windowSettings.properties[t]=r;break;case 4:e.resourceSettings.properties[t]=r;break;case 5:e.resourceSettings.properties[t]=r,this.g.properties[t]=r;break}}s(t,r){switch(delete e.allSettings.properties[t],r.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const r=`[${t}]`,i={type:"object",description:D.localize(2,null),errorMessage:D.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(r,i),e.allSettings.properties[r]=i,e.applicationSettings.properties[r]=i,e.machineSettings.properties[r]=i,e.machineOverridableSettings.properties[r]=i,e.windowSettings.properties[r]=i,e.resourceSettings.properties[r]=i}}v(){const t={type:"object",description:D.localize(4,null),errorMessage:D.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this.i.fire()}w(t,r){const i=this.a.get(t);let n=i?.value,s=i?.source;k.isUndefined(n)&&(n=r.defaultDefaultValue,s=void 0),k.isUndefined(n)&&(n=l(r.type)),r.default=n,r.defaultValueSource=s}}const I="\\[([^\\]]+)\\]",E=new RegExp(I,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${I})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function L(y){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(y)){let r=E.exec(y);for(;r?.length;){const i=r[1].trim();i&&t.push(i),r=E.exec(y)}}return(0,T.distinct)(t)}e.overrideIdentifiersFromKey=L;function d(y){return y.reduce((t,r)=>`${t}[${r}]`,"")}e.keyFromOverrideIdentifiers=d;function l(y){switch(Array.isArray(y)?y[0]:y){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=l;const m=new g;f.Registry.add(e.Extensions.Configuration,m);function S(y,t){return y.trim()?e.OVERRIDE_PROPERTY_REGEX.test(y)?D.localize(7,null,y):m.getConfigurationProperties()[y]!==void 0?D.localize(8,null,y):t.policy?.name&&m.getPolicyConfigurations().get(t.policy?.name)!==void 0?D.localize(9,null,y,t.policy?.name,m.getPolicyConfigurations().get(t.policy?.name)):null:D.localize(6,null)}e.validateProperty=S;function h(){const y=[],t=m.getConfigurationProperties();for(const r of Object.keys(t))y.push([r,t[r].scope]);return y.push(["launch",4]),y.push(["task",4]),y}e.getScopes=h}),define(Y[65],Q([0,1,19,3,50,2,36,30,4,11,21,42,37]),function(x,e,T,O,k,D,N,b,f,c,p,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class I{constructor(r={},i=[],n=[],s){this.c=r,this.d=i,this.f=n,this.raw=s,this.a=!1,this.b=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const r=this.raw.map(i=>{if(i instanceof I)return i;const n=new E("");return n.parseRaw(i),n.configurationModel});this.g=r.reduce((i,n)=>n===i?n:i.merge(n),r[0])}else this.g=this;return this.g}get contents(){return this.k(this.c)}get overrides(){return this.k(this.f)}get keys(){return this.k(this.d)}isEmpty(){return this.d.length===0&&Object.keys(this.c).length===0&&this.f.length===0}isFrozen(){return this.a}getValue(r){return r?(0,p.getConfigurationValue)(this.contents,r):this.contents}inspect(r,i){const n=this.rawConfiguration.getValue(r),s=i?this.rawConfiguration.getOverrideValue(r,i):void 0,a=i?this.rawConfiguration.override(i).getValue(r):n;return{value:n,override:s,merged:a}}getOverrideValue(r,i){const n=this.l(i);return n?r?(0,p.getConfigurationValue)(n,r):n:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const n of this.overrides)n.identifiers.includes(r)&&i.push(...n.keys);return T.distinct(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return T.distinct(r)}override(r){let i=this.b.get(r);return i||(i=this.h(r),this.b.set(r,i)),i}merge(...r){const i=b.deepClone(this.contents),n=b.deepClone(this.overrides),s=[...this.keys],a=this.raw?.length?[...this.raw]:[this];for(const o of r)if(a.push(...o.raw?.length?o.raw:[o]),!o.isEmpty()){this.j(i,o.contents);for(const u of o.overrides){const[w]=n.filter(A=>T.equals(A.identifiers,u.identifiers));w?(this.j(w.contents,u.contents),w.keys.push(...u.keys),w.keys=T.distinct(w.keys)):n.push(b.deepClone(u))}for(const u of o.keys)s.indexOf(u)===-1&&s.push(u)}return new I(i,s,n,a.every(o=>o instanceof I)?void 0:a)}freeze(){return this.a=!0,this}h(r){const i=this.l(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const n={};for(const s of T.distinct([...Object.keys(this.contents),...Object.keys(i)])){let a=this.contents[s];const o=i[s];o&&(typeof a=="object"&&typeof o=="object"?(a=b.deepClone(a),this.j(a,o)):a=o),n[s]=a}return new I(n,this.keys,this.overrides)}j(r,i){for(const n of Object.keys(i)){if(n in r&&f.isObject(r[n])&&f.isObject(i[n])){this.j(r[n],i[n]);continue}r[n]=b.deepClone(i[n])}}k(r){return this.a&&!Object.isFrozen(r)?b.deepFreeze(r):r}l(r){let i=null,n=null;const s=a=>{a&&(n?this.j(n,a):n=b.deepClone(a))};for(const a of this.overrides)T.equals(a.identifiers,[r])?i=a.contents:a.identifiers.includes(r)&&s(a.contents);return s(i),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,i){this.m(r),(0,p.addToValueTree)(this.contents,r,i,n=>{throw new Error(n)})}removeValue(r){this.n(r)&&(0,p.removeFromValueTree)(this.contents,r)}m(r){let i=this.keys.length;for(let n=0;n<i;n++)r.indexOf(this.keys[n])===0&&(i=n);this.keys.splice(i,1,r)}n(r){const i=this.keys.indexOf(r);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=I;class E{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new I}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,i){if(!f.isUndefinedOrNull(r)){const n=this.g(r);this.parseRaw(n,i)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,i){this.a=r;const{contents:n,keys:s,overrides:a,restricted:o,hasExcludedProperties:u}=this.h(r,i);this.b=new I(n,s,a,u?[r]:void 0),this.c=o||[]}g(r){let i={},n=null,s=[];const a=[],o=[];function u(A){Array.isArray(s)?s.push(A):n!==null&&(s[n]=A)}const w={onObjectBegin:()=>{const A={};u(A),a.push(s),s=A,n=null},onObjectProperty:A=>{n=A},onObjectEnd:()=>{s=a.pop()},onArrayBegin:()=>{const A=[];u(A),a.push(s),s=A,n=null},onArrayEnd:()=>{s=a.pop()},onLiteralValue:u,onError:(A,$,Z)=>{o.push({error:A,offset:$,length:Z})}};if(r)try{k.visit(r,w),i=s[0]||{}}catch(A){console.error(`Error while parsing settings file ${this.f}: ${A}`),this.d=[A]}return i}h(r,i){const n=g.Registry.as(v.Extensions.Configuration).getConfigurationProperties(),s=this.j(r,n,!0,i);r=s.raw;const a=(0,p.toValuesTree)(r,w=>console.error(`Conflict in settings file ${this.f}: ${w}`)),o=Object.keys(r),u=this.l(r,w=>console.error(`Conflict in settings file ${this.f}: ${w}`));return{contents:a,keys:o,overrides:u,restricted:s.restricted,hasExcludedProperties:s.hasExcludedProperties}}j(r,i,n,s){let a=!1;if(!s?.scopes&&!s?.skipRestricted)return{raw:r,restricted:[],hasExcludedProperties:a};const o={},u=[];for(const w in r)if(v.OVERRIDE_PROPERTY_REGEX.test(w)&&n){const A=this.j(r[w],i,!1,s);o[w]=A.raw,a=a||A.hasExcludedProperties,u.push(...A.restricted)}else{const A=i[w],$=A?typeof A.scope<"u"?A.scope:3:void 0;A?.restricted&&u.push(w),($===void 0||s.scopes===void 0||s.scopes.includes($))&&!(s.skipRestricted&&A?.restricted)?o[w]=r[w]:a=!0}return{raw:o,restricted:u,hasExcludedProperties:a}}l(r,i){const n=[];for(const s of Object.keys(r))if(v.OVERRIDE_PROPERTY_REGEX.test(s)){const a={};for(const o in r[s])a[o]=r[s][o];n.push({identifiers:(0,v.overrideIdentifiersFromKey)(s),keys:Object.keys(a),contents:(0,p.toValuesTree)(a,i)})}return n}}e.ConfigurationModelParser=E;class L extends D.Disposable{constructor(r,i,n,s){super(),this.f=r,this.g=i,this.h=s,this.c=this.B(new O.Emitter),this.onDidChange=this.c.event,this.a=new E(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(n.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(O.Event.any(O.Event.filter(this.h.onDidFilesChange,a=>a.contains(this.f)),O.Event.filter(this.h.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&n.isEqual(a.resource,r)))(()=>this.c.fire()))}async loadConfiguration(){try{const r=await this.h.readFile(this.f);return this.a.parse(r.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new I}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=L;class d{constructor(r,i,n,s,a,o,u,w,A,$,Z,X,ee){this.a=r,this.b=i,this.value=n,this.overrideIdentifiers=s,this.c=a,this.d=o,this.f=u,this.g=w,this.h=A,this.j=$,this.k=Z,this.l=X,this.m=ee}get p(){return this.n||(this.n=this.c.inspect(this.a,this.b.overrideIdentifier)),this.n}get defaultValue(){return this.p.merged}get default(){return this.p.value!==void 0||this.p.override!==void 0?{value:this.p.value,override:this.p.override}:void 0}get r(){return this.q===void 0&&(this.q=this.d?this.d.inspect(this.a):null),this.q}get policyValue(){return this.r?.merged}get policy(){return this.r?.value!==void 0?{value:this.r.value}:void 0}get t(){return this.s===void 0&&(this.s=this.f?this.f.inspect(this.a):null),this.s}get applicationValue(){return this.t?.merged}get application(){return this.t?.value!==void 0||this.t?.override!==void 0?{value:this.t.value,override:this.t.override}:void 0}get v(){return this.u||(this.u=this.g.inspect(this.a,this.b.overrideIdentifier)),this.u}get userValue(){return this.v.merged}get user(){return this.v.value!==void 0||this.v.override!==void 0?{value:this.v.value,override:this.v.override}:void 0}get x(){return this.w||(this.w=this.h.inspect(this.a,this.b.overrideIdentifier)),this.w}get userLocalValue(){return this.x.merged}get userLocal(){return this.x.value!==void 0||this.x.override!==void 0?{value:this.x.value,override:this.x.override}:void 0}get z(){return this.y||(this.y=this.j.inspect(this.a,this.b.overrideIdentifier)),this.y}get userRemoteValue(){return this.z.merged}get userRemote(){return this.z.value!==void 0||this.z.override!==void 0?{value:this.z.value,override:this.z.override}:void 0}get B(){return this.A===void 0&&(this.A=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.A}get workspaceValue(){return this.B?.merged}get workspace(){return this.B?.value!==void 0||this.B?.override!==void 0?{value:this.B.value,override:this.B.override}:void 0}get E(){return this.D===void 0&&(this.D=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.D}get workspaceFolderValue(){return this.E?.merged}get workspaceFolder(){return this.E?.value!==void 0||this.E?.override!==void 0?{value:this.E.value,override:this.E.override}:void 0}get memoryValue(){return this.m.merged}get memory(){return this.m.value!==void 0||this.m.override!==void 0?{value:this.m.value,override:this.m.override}:void 0}}class l{constructor(r,i,n,s,a=new I,o=new I,u=new N.ResourceMap,w=new I,A=new N.ResourceMap,$=!0){this.c=r,this.d=i,this.f=n,this.g=s,this.h=a,this.j=o,this.l=u,this.m=w,this.n=A,this.p=$,this.a=null,this.b=new N.ResourceMap,this.q=null}getValue(r,i,n){return this.s(r,i,n).getValue(r)}updateValue(r,i,n={}){let s;n.resource?(s=this.n.get(n.resource),s||(s=new I,this.n.set(n.resource,s))):s=this.m,i===void 0?s.removeValue(r):s.setValue(r,i),n.resource||(this.a=null)}inspect(r,i,n){const s=this.s(r,i,n),a=this.w(i.resource,n),o=i.resource?this.n.get(i.resource)||this.m:this.m,u=new Set;for(const w of s.overrides)for(const A of w.identifiers)s.getOverrideValue(r,A)!==void 0&&u.add(A);return new d(r,i,s.getValue(r),u.size?[...u]:void 0,this.c,this.d.isEmpty()?void 0:this.d.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),n?this.j.freeze():void 0,a?a.freeze():void 0,o.inspect(r,i.overrideIdentifier))}keys(r){const i=this.w(void 0,r);return{default:this.c.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this.j.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.q=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.q=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.j=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,i){this.l.set(r,i),this.b.delete(r)}deleteFolderConfiguration(r){this.r.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,i){const n=[];if(!i){const{added:s,updated:a,removed:o}=h(this.c,r);i=[...s,...a,...o]}for(const s of i)for(const a of(0,v.overrideIdentifiersFromKey)(s)){const o=this.c.getKeysForOverrideIdentifier(a),u=r.getKeysForOverrideIdentifier(a),w=[...u.filter(A=>o.indexOf(A)===-1),...o.filter(A=>u.indexOf(A)===-1),...o.filter(A=>!b.equals(this.c.override(a).getValue(A),r.override(a).getValue(A)))];n.push([a,w])}return this.updateDefaultConfiguration(r),{keys:i,overrides:n}}compareAndUpdatePolicyConfiguration(r){const{added:i,updated:n,removed:s}=h(this.d,r),a=[...i,...n,...s];return a.length&&this.updatePolicyConfiguration(r),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:i,updated:n,removed:s,overrides:a}=h(this.applicationConfiguration,r),o=[...i,...n,...s];return o.length&&this.updateApplicationConfiguration(r),{keys:o,overrides:a}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:n,removed:s,overrides:a}=h(this.localUserConfiguration,r),o=[...i,...n,...s];return o.length&&this.updateLocalUserConfiguration(r),{keys:o,overrides:a}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:n,removed:s,overrides:a}=h(this.remoteUserConfiguration,r),o=[...i,...n,...s];return o.length&&this.updateRemoteUserConfiguration(r),{keys:o,overrides:a}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:n,removed:s,overrides:a}=h(this.workspaceConfiguration,r),o=[...i,...n,...s];return o.length&&this.updateWorkspaceConfiguration(r),{keys:o,overrides:a}}compareAndUpdateFolderConfiguration(r,i){const n=this.r.get(r),{added:s,updated:a,removed:o,overrides:u}=h(n,i),w=[...s,...a,...o];return(w.length||!n)&&this.updateFolderConfiguration(r,i),{keys:w,overrides:u}}compareAndDeleteFolderConfiguration(r){const i=this.r.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:n,updated:s,removed:a,overrides:o}=h(i,void 0);return{keys:[...n,...s,...a],overrides:o}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.q||(this.q=this.h.isEmpty()?this.g:this.g.merge(this.h),this.p&&this.q.freeze()),this.q}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.j}get r(){return this.l}s(r,i,n){let s=this.t(i,n);return i.overrideIdentifier&&(s=s.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(s=s.merge(this.d)),s}t({resource:r},i){let n=this.u();if(i&&r){const s=i.getFolder(r);s&&(n=this.v(s.uri)||n);const a=this.n.get(r);a&&(n=n.merge(a))}return n}u(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.j,this.m),this.p&&(this.j=this.j.freeze())),this.a}v(r){let i=this.b.get(r);if(!i){const n=this.u(),s=this.l.get(r);s?(i=n.merge(s),this.p&&(i=i.freeze()),this.b.set(r,i)):i=n}return i}w(r,i){if(i&&r){const n=i.getFolder(r);if(n)return this.l.get(n.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},folders:[...this.l.keys()].reduce((r,i)=>{const{contents:n,overrides:s,keys:a}=this.l.get(i);return r.push([i,{contents:n,overrides:s,keys:a}]),r},[])}}allKeys(){const r=new Set;return this.c.freeze().keys.forEach(i=>r.add(i)),this.userConfiguration.freeze().keys.forEach(i=>r.add(i)),this.j.freeze().keys.forEach(i=>r.add(i)),this.l.forEach(i=>i.freeze().keys.forEach(n=>r.add(n))),[...r.values()]}x(){const r=new Set;return this.c.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.j.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.l.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(n=>r.add(n))),[...r.values()]}y(r){const i=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this.j.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this.l.forEach(n=>n.getKeysForOverrideIdentifier(r).forEach(s=>i.add(s))),[...i.values()]}static parse(r){const i=this.z(r.defaults),n=this.z(r.policy),s=this.z(r.application),a=this.z(r.user),o=this.z(r.workspace),u=r.folders.reduce((w,A)=>(w.set(c.URI.revive(A[0]),this.z(A[1])),w),new N.ResourceMap);return new l(i,n,s,a,new I,o,u,new I,new N.ResourceMap,!1)}static z(r){return new I(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=l;function m(...t){if(t.length===0)return{keys:[],overrides:[]};if(t.length===1)return t[0];const r=new Set,i=new Map;for(const s of t)s.keys.forEach(a=>r.add(a)),s.overrides.forEach(([a,o])=>{const u=(0,N.getOrSet)(i,a,new Set);o.forEach(w=>u.add(w))});const n=[];return i.forEach((s,a)=>n.push([a,[...s.values()]])),{keys:[...r.values()],overrides:n}}e.mergeChanges=m;class S{constructor(r,i,n,s){this.change=r,this.f=i,this.g=n,this.h=s,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.j=void 0;for(const a of r.keys)this.affectedKeys.add(a);for(const[,a]of r.overrides)for(const o of a)this.affectedKeys.add(o);this.d=this.a;for(const a of this.affectedKeys)this.d+=a+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=l.parse(this.f.data)),this.j}affectsConfiguration(r,i){const n=this.a+r,s=this.d.indexOf(n);if(s<0)return!1;const a=s+n.length;if(a>=this.d.length)return!1;const o=this.d.charCodeAt(a);if(o!==this.b&&o!==this.c)return!1;if(i){const u=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.f?.workspace):void 0,w=this.g.getValue(r,i,this.h);return!b.equals(u,w)}return!0}}e.ConfigurationChangeEvent=S;function h(t,r){const{added:i,removed:n,updated:s}=y(r?.rawConfiguration,t?.rawConfiguration),a=[],o=t?.getAllOverrideIdentifiers()||[],u=r?.getAllOverrideIdentifiers()||[];if(r){const w=u.filter(A=>!o.includes(A));for(const A of w)a.push([A,r.getKeysForOverrideIdentifier(A)])}if(t){const w=o.filter(A=>!u.includes(A));for(const A of w)a.push([A,t.getKeysForOverrideIdentifier(A)])}if(r&&t){for(const w of o)if(u.includes(w)){const A=y({contents:t.getOverrideValue(void 0,w)||{},keys:t.getKeysForOverrideIdentifier(w)},{contents:r.getOverrideValue(void 0,w)||{},keys:r.getKeysForOverrideIdentifier(w)});a.push([w,[...A.added,...A.removed,...A.updated]])}}return{added:i,removed:n,updated:s,overrides:a}}function y(t,r){const i=t?r?t.keys.filter(a=>r.keys.indexOf(a)===-1):[...t.keys]:[],n=r?t?r.keys.filter(a=>t.keys.indexOf(a)===-1):[...r.keys]:[],s=[];if(t&&r){for(const a of r.keys)if(t.keys.indexOf(a)!==-1){const o=(0,p.getConfigurationValue)(r.contents,a),u=(0,p.getConfigurationValue)(t.contents,a);b.equals(o,u)||s.push(a)}}return{added:i,removed:n,updated:s}}}),define(Y[124],Q([0,1,19,3,2,30,4,21,65,42,10,38,37]),function(x,e,T,O,k,D,N,b,f,c,p,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class I extends k.Disposable{constructor(){super(...arguments),this.a=this.B(new O.Emitter),this.onDidChangeConfiguration=this.a.event}get configurationModel(){return this.b||(this.b=new E(this.f())),this.b}async initialize(){return this.b=void 0,this.B(g.Registry.as(c.Extensions.Configuration).onDidUpdateConfiguration(({properties:m,defaultsOverrides:S})=>this.c(Array.from(m),S))),this.configurationModel}reload(){return this.b=void 0,this.configurationModel}c(m,S){this.b=void 0,this.a.fire({defaults:this.configurationModel,properties:m})}f(){return{}}}e.DefaultConfiguration=I;class E extends f.ConfigurationModel{constructor(m={}){const S=g.Registry.as(c.Extensions.Configuration).getConfigurationProperties(),h=Object.keys(S),y=Object.create(null),t=[];for(const r in S){const i=m[r],n=i!==void 0?i:S[r].default;(0,b.addToValueTree)(y,r,n,s=>console.error(`Conflict in default settings: ${s}`))}for(const r of Object.keys(y))c.OVERRIDE_PROPERTY_REGEX.test(r)&&t.push({identifiers:(0,c.overrideIdentifiersFromKey)(r),keys:Object.keys(y[r]),contents:(0,b.toValuesTree)(y[r],i=>console.error(`Conflict in default settings file: ${i}`))});super(y,h,t)}}e.DefaultConfigurationModel=E;class L{constructor(){this.onDidChangeConfiguration=O.Event.None,this.configurationModel=new f.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=L;let d=class extends k.Disposable{get configurationModel(){return this.b}constructor(m,S,h){super(),this.c=m,this.f=S,this.g=h,this.a=this.B(new O.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new f.ConfigurationModel}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(m=>this.i(m))),this.B(this.c.onDidChangeConfiguration(async({properties:m})=>this.j(await this.h(m),!0))),this.b}async h(m){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",m);const S={},h=[],y=g.Registry.as(c.Extensions.Configuration).getConfigurationProperties();for(const t of m){const r=y[t];if(!r){h.push(t);continue}if(r.policy){if(r.type!=="string"&&r.type!=="number"){this.g.warn(`Policy ${r.policy.name} has unsupported type ${r.type}`);continue}h.push(t),S[r.policy.name]={type:r.type}}}return(0,N.isEmptyObject)(S)||await this.f.updatePolicyDefinitions(S),h}i(m){this.g.trace("PolicyConfiguration#onDidChangePolicies",m);const S=g.Registry.as(c.Extensions.Configuration).getPolicyConfigurations(),h=(0,T.coalesce)(m.map(y=>S.get(y)));this.j(h,!0)}j(m,S){this.g.trace("PolicyConfiguration#update",m);const h=g.Registry.as(c.Extensions.Configuration).getConfigurationProperties(),y=[],t=this.b.isEmpty();for(const r of m){const i=h[r]?.policy?.name;if(i){const n=this.f.getPolicyValue(i);(t?n!==void 0:!(0,D.equals)(this.b.getValue(r),n))&&y.push([r,n])}else this.b.getValue(r)!==void 0&&y.push([r,void 0])}if(y.length){this.g.trace("PolicyConfiguration#changed",y);const r=this.b;this.b=new f.ConfigurationModel;for(const i of r.keys)this.b.setValue(i,r.getValue(i));for(const[i,n]of y)n===void 0?this.b.removeValue(i):this.b.setValue(i,n);S&&this.a.fire(this.b)}}};d=de([_(1,v.IPolicyService),_(2,p.ILogService)],d),e.PolicyConfiguration=d}),define(Y[125],Q([0,1,5,3,2,18,21,65,124,38]),function(x,e,T,O,k,D,N,b,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class p extends k.Disposable{constructor(g,I,E,L){super(),this.i=g,this.h=this.B(new O.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new f.DefaultConfiguration),this.c=E instanceof c.NullPolicyService?new f.NullPolicyConfiguration:this.B(new f.PolicyConfiguration(this.b,E,L)),this.f=this.B(new b.UserSettings(this.i,void 0,D.extUriBiasedIgnorePathCase,I)),this.a=new b.Configuration(this.b.configurationModel,this.c.configurationModel,new b.ConfigurationModel,new b.ConfigurationModel),this.g=this.B(new T.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:d,properties:l})=>this.k(d,l))),this.B(this.c.onDidChangeConfiguration(d=>this.l(d))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[g,I,E]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new b.Configuration(g,I,new b.ConfigurationModel,E)}getConfigurationData(){return this.a.toData()}getValue(g,I){const E=typeof g=="string"?g:void 0,L=(0,N.isConfigurationOverrides)(g)?g:(0,N.isConfigurationOverrides)(I)?I:{};return this.a.getValue(E,L,void 0)}updateValue(g,I,E,L){return Promise.reject(new Error("not supported"))}inspect(g){return this.a.inspect(g,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const g=await this.f.loadConfiguration();this.j(g)}j(g){const I=this.a.toData(),E=this.a.compareAndUpdateLocalUserConfiguration(g);this.m(E,I,2)}k(g,I){const E=this.a.toData(),L=this.a.compareAndUpdateDefaultConfiguration(g,I);this.m(L,E,7)}l(g){const I=this.a.toData(),E=this.a.compareAndUpdatePolicyConfiguration(g);this.m(E,I,7)}m(g,I,E){const L=new b.ConfigurationChangeEvent(g,{data:I},this.a);L.source=E,L.sourceConfig=this.n(E),this.h.fire(L)}n(g){switch(g){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=p}),define(Y[66],Q([0,1,16]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function O(c){return c.scheme===T.Schemas.vscodeRemote?c.authority:void 0}e.getRemoteAuthority=O;function k(c){if(!c)return;const p=c.indexOf("+");return p<0?c:c.substr(0,p)}e.getRemoteName=k;function D(c){return`/${c.quality??"oss"}-${c.commit??"dev"}`}e.getRemoteServerRootPath=D;function N(c){const{host:p,port:v}=f(c);if(typeof v>"u")throw new Error("Remote authority doesn't contain a port!");return{host:p,port:v}}e.parseAuthorityWithPort=N;function b(c,p){let{host:v,port:g}=f(c);return typeof g>"u"&&(g=p),{host:v,port:g}}e.parseAuthorityWithOptionalPort=b;function f(c){const p=c.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(p)return{host:p[1],port:parseInt(p[2],10)};const v=c.match(/^(\[[0-9a-z:]+\])$/);if(v)return{host:v[1],port:void 0};const g=c.match(/(.*):(\d+)$/);return g?{host:g[1],port:parseInt(g[2],10)}:{host:c,port:void 0}}}),define(Y[29],Q([0,1,32,9,66]),function(x,e,T,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function D(E){if(typeof E=="object"&&E!==null&&E.supported!==!0)return E.description}e.getWorkspaceSupportTypeMessage=D;function N(E){return E&&typeof E=="object"&&typeof E.id=="string"&&(!E.uuid||typeof E.uuid=="string")}e.isIExtensionIdentifier=N,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var b;(function(E){E[E.System=0]="System",E[E.User=1]="User"})(b=e.ExtensionType||(e.ExtensionType={}));var f;(function(E){E.WIN32_X64="win32-x64",E.WIN32_IA32="win32-ia32",E.WIN32_ARM64="win32-arm64",E.LINUX_X64="linux-x64",E.LINUX_ARM64="linux-arm64",E.LINUX_ARMHF="linux-armhf",E.ALPINE_X64="alpine-x64",E.ALPINE_ARM64="alpine-arm64",E.DARWIN_X64="darwin-x64",E.DARWIN_ARM64="darwin-arm64",E.WEB="web",E.UNIVERSAL="universal",E.UNKNOWN="unknown",E.UNDEFINED="undefined"})(f=e.TargetPlatform||(e.TargetPlatform={}));class c{constructor(L){this.value=L,this.c=L.toLowerCase()}static equals(L,d){if(typeof L>"u"||L===null)return typeof d>"u"||d===null;if(typeof d>"u"||d===null)return!1;if(typeof L=="string"||typeof d=="string"){const l=typeof L=="string"?L:L.value,m=typeof d=="string"?d:d.value;return T.equalsIgnoreCase(l,m)}return L.c===d.c}static toKey(L){return typeof L=="string"?L.toLowerCase():L.c}}e.ExtensionIdentifier=c;function p(E){return v(E)}e.isApplicationScopedExtension=p;function v(E){return E.contributes&&E.contributes.localizations?E.contributes.localizations.length>0:!1}e.isLanguagePackExtension=v;function g(E){return E.contributes&&E.contributes.authentication?E.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=g;function I(E,L){if(L){const d=`onResolveRemoteAuthority:${(0,k.getRemoteName)(L)}`;return E.activationEvents?.indexOf(d)!==-1}return!1}e.isResolverExtension=I,e.IBuiltinExtensionsScannerService=(0,O.createDecorator)("IBuiltinExtensionsScannerService")}),define(Y[126],Q([0,1,2,14,20,29]),function(x,e,T,O,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class N extends T.Disposable{constructor(f,c){super(),this.b=f,this.a=(0,O.join)(this.b.userDataPath,D.MANIFEST_CACHE_FOLDER,D.USER_MANIFEST_CACHE_FILE),this.B(c.onDidInstallExtensions(p=>this.c(p))),this.B(c.onDidUninstallExtension(p=>this.f(p)))}c(f){f.some(c=>!!c.local)&&this.invalidate()}f(f){f.error||this.invalidate()}invalidate(){k.Promises.rm(this.a,k.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=N}),define(Y[47],Q([0,1,15,99,42,9,37]),function(x,e,T,O,k,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,D.createDecorator)("requestService");function b(L){return L.res.statusCode&&L.res.statusCode>=200&&L.res.statusCode<300||L.res.statusCode===1223}e.isSuccess=b;function f(L){return L.res.statusCode===204}async function c(L){return f(L)?null:(await(0,T.streamToBuffer)(L.stream)).toString()}e.asText=c;async function p(L){if(!b(L))throw new Error("Server returned "+L.res.statusCode);return c(L)}e.asTextOrError=p;async function v(L){if(!b(L))throw new Error("Server returned "+L.res.statusCode);if(f(L))return null;const l=(await(0,T.streamToBuffer)(L.stream)).toString();try{return JSON.parse(l)}catch(m){throw m.message+=`:
`+l,m}}e.asJson=v;function g(L){E(L)}e.updateProxyConfigurationsScope=g;let I;function E(L){const d=N.Registry.as(k.Extensions.Configuration),l=I;I={id:"http",order:15,title:(0,O.localize)(0,null),type:"object",scope:L,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,O.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,O.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,O.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,O.localize)(4,null),(0,O.localize)(5,null),(0,O.localize)(6,null),(0,O.localize)(7,null)],default:"override",description:(0,O.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,O.localize)(9,null),restricted:!0}}},d.updateConfigurations({add:[I],remove:l?[l]:[]})}E(2)}),define(Y[127],Q([0,1,23,16,13,47]),function(x,e,T,O,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let N=class{constructor(f,c){this.a=f,this.b=c}async download(f,c,p=T.CancellationToken.None){if(f.scheme===O.Schemas.file||f.scheme===O.Schemas.vscodeRemote){await this.b.copy(f,c);return}const v={type:"GET",url:f.toString(!0)},g=await this.a.request(v,p);if(g.res.statusCode===200)await this.b.writeFile(c,g.stream);else{const I=await(0,D.asTextOrError)(g);throw new Error(`Expected 200, got back ${g.res.statusCode} instead.

${I}`)}}};N=de([_(0,D.IRequestService),_(1,k.IFileService)],N),e.DownloadService=N}),define(Y[128],Q([0,1,129,4]),function(x,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function k(N,b){return N.protocol==="http:"?b.HTTP_PROXY||b.http_proxy||null:N.protocol==="https:"&&(b.HTTPS_PROXY||b.https_proxy||b.HTTP_PROXY||b.http_proxy)||null}async function D(N,b,f={}){const c=(0,T.parse)(N),p=f.proxyUrl||k(c,b);if(!p)return null;const v=(0,T.parse)(p);if(!/^https?:$/.test(v.protocol||""))return null;const g={host:v.hostname||"",port:v.port||(v.protocol==="https"?"443":"80"),auth:v.auth,rejectUnauthorized:(0,O.isBoolean)(f.strictSSL)?f.strictSSL:!0};return c.protocol==="http:"?new(await new Promise((I,E)=>{x(["http-proxy-agent"],I,E)}))(g):new(await new Promise((I,E)=>{x(["https-proxy-agent"],I,E)}))(g)}e.getProxyAgent=D}),define(Y[130],Q([0,1,57,14,100,23,34,6,12,31,82,162,5,71]),function(x,e,T,O,k,D,N,b,f,c,p,v,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let E;async function L(l,m,S,h){return S["force-disable-user-env"]?(m.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):f.isWindows?(m.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,v.isLaunchedFromCli)(h)&&!S["force-user-env"]?(m.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,v.isLaunchedFromCli)(h)?m.trace("resolveShellEnv(): running (--force-user-env)"):m.trace("resolveShellEnv(): running (macOS/Linux)"),E||(E=g.Promises.withAsyncBody(async(y,t)=>{const r=new D.CancellationTokenSource;let i=1e4;const n=l.getValue("application.shellEnvironmentResolutionTimeout");typeof n=="number"&&(i=(0,I.clamp)(n,1,120)*1e3);const s=setTimeout(()=>{r.dispose(!0),t(new Error((0,k.localize)(0,null)))},i);try{y(await d(m,r.token))}catch(a){!(0,b.isCancellationError)(a)&&!r.token.isCancellationRequested?t(new Error((0,k.localize)(1,null,(0,N.toErrorMessage)(a)))):y({})}finally{clearTimeout(s),r.dispose()}})),E)}e.getResolvedShellEnv=L;async function d(l,m){const S=process.env.ELECTRON_RUN_AS_NODE;l.trace("getUnixShellEnvironment#runAsNode",S);const h=process.env.ELECTRON_NO_ATTACH_CONSOLE;l.trace("getUnixShellEnvironment#noAttach",h);const y=(0,c.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(y+"({.*})"+y),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};l.trace("getUnixShellEnvironment#env",r);const i=await(0,p.getSystemShell)(f.OS,r);return l.trace("getUnixShellEnvironment#shell",i),new Promise((n,s)=>{if(m.isCancellationRequested)return s(new b.CancellationError);const a=(0,O.basename)(i);let o,u;const w=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(a)?(o=`& '${process.execPath}' ${w} -p '''${y}'' + JSON.stringify(process.env) + ''${y}'''`,u=["-Login","-Command"]):(o=`'${process.execPath}' ${w} -p '"${y}" + JSON.stringify(process.env) + "${y}"'`,a==="tcsh"||a==="csh"?u=["-ic"]:u=["-i","-l","-c"]),l.trace("getUnixShellEnvironment#spawn",JSON.stringify(u),o);const A=(0,T.spawn)(i,[...u,o],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});m.onCancellationRequested(()=>(A.kill(),s(new b.CancellationError))),A.on("error",X=>{l.error("getUnixShellEnvironment#errorChildProcess",(0,N.toErrorMessage)(X)),s(X)});const $=[];A.stdout.on("data",X=>$.push(X));const Z=[];A.stderr.on("data",X=>Z.push(X)),A.on("close",(X,ee)=>{const ie=Buffer.concat($).toString("utf8");l.trace("getUnixShellEnvironment#raw",ie);const ne=Buffer.concat(Z).toString("utf8");if(ne.trim()&&l.trace("getUnixShellEnvironment#stderr",ne),X||ee)return s(new Error((0,k.localize)(2,null,X,ee)));const ae=t.exec(ie),fe=ae?ae[1]:"{}";try{const re=JSON.parse(fe);S?re.ELECTRON_RUN_AS_NODE=S:delete re.ELECTRON_RUN_AS_NODE,h?re.ELECTRON_NO_ATTACH_CONSOLE=h:delete re.ELECTRON_NO_ATTACH_CONSOLE,delete re.VSCODE_RESOLVING_ENVIRONMENT,delete re.XDG_RUNTIME_DIR,l.trace("getUnixShellEnvironment#result",re),n(re)}catch(re){l.error("getUnixShellEnvironment#errorCaught",(0,N.toErrorMessage)(re)),s(re)}})})}}),define(Y[67],Q([0,1,9]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,T.createDecorator)("stateService")}),define(Y[131],Q([0,1,5,15,4,17,13,10]),function(x,e,T,O,k,D,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class f{constructor(v,g,I){this.f=v,this.g=g,this.h=I,this.a=Object.create(null),this.b="",this.c=new T.ThrottledDelayer(100),this.d=void 0,this.e=void 0}init(){return this.d||(this.d=this.i()),this.d}async i(){try{this.b=(await this.h.readFile(this.f)).value.toString(),this.a=JSON.parse(this.b)}catch(v){v.fileOperationResult!==1&&this.g.error(v)}}getItem(v,g){const I=this.a[v];return(0,k.isUndefinedOrNull)(I)?g:I}setItem(v,g){this.setItems([{key:v,data:g}])}setItems(v){let g=!1;for(const{key:I,data:E}of v)this.a[I]!==E&&((0,k.isUndefinedOrNull)(E)?(0,k.isUndefined)(this.a[I])||(this.a[I]=void 0,g=!0):(this.a[I]=E,g=!0));g&&this.j()}removeItem(v){(0,k.isUndefined)(this.a[v])||(this.a[v]=void 0,this.j())}async j(){if(!this.e)return this.c.trigger(()=>this.k())}async k(){if(!this.d)return;await this.d;const v=JSON.stringify(this.a,null,4);if(v!==this.b)try{await this.h.writeFile(this.f,O.VSBuffer.fromString(v)),this.b=v}catch(g){this.g.error(g)}}async close(){return this.e||(this.e=this.c.trigger(()=>this.k(),0)),this.e}}e.FileStorage=f;let c=class{constructor(v,g,I){this.a=new f(v.stateResource,g,I)}async init(){await this.a.init()}getItem(v,g){return this.a.getItem(v,g)}};c=de([_(0,D.IEnvironmentService),_(1,b.ILogService),_(2,N.IFileService)],c),e.StateService=c}),define(Y[68],Q([0,1,12,35,11,31]),function(x,e,T,O,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function N(c){if(T.platform===2&&/^penguin(\.|$)/i.test(c))return"chromebook"}async function b(c,p,v,g,I,E,L,d,l,m){const S=Object.create(null);S["common.machineId"]=L,S.sessionID=(0,D.generateUuid)()+Date.now(),S.commitHash=I,S.version=E,S["common.platformVersion"]=(p||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),S["common.platform"]=(0,T.PlatformToString)(T.platform),S["common.nodePlatform"]=O.platform,S["common.nodeArch"]=g,S["common.product"]=m||"desktop",d&&(S["common.msftInternal"]=d);let h=0;const y=Date.now();Object.defineProperties(S,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-y,enumerable:!0},"common.sequence":{get:()=>h++,enumerable:!0}}),T.isLinuxSnap&&(S["common.snap"]="true");const t=N(v);t&&(S["common.platformDetail"]=t);try{const r=await c.readFile(k.URI.file(l));S["common.source"]=r.value.toString().slice(0,30)}catch{}return S}e.resolveCommonProperties=b;function f(c){const p=O.env.USERDNSDOMAIN;if(!p)return!1;const v=p.toLowerCase();return c.some(g=>v===g)}e.verifyMicrosoftInternalDomain=f}),define(Y[25],Q([0,1,9]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,T.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,T.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var O;(function(D){D[D.NONE=0]="NONE",D[D.CRASH=1]="CRASH",D[D.ERROR=2]="ERROR",D[D.USAGE=3]="USAGE"})(O=e.TelemetryLevel||(e.TelemetryLevel={}));var k;(function(D){D.OFF="off",D.CRASH="crash",D.ERROR="error",D.ON="all"})(k=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Y[39],Q([0,1,30,4,3,21,66,68,25]),function(x,e,T,O,k,D,N,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class c{constructor(o){this.value=o}}e.TelemetryTrustedValue=c;class p{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(o,u){return Promise.resolve(void 0)}publicLog2(o,u){return this.publicLog(o,u)}publicLogError(o,u){return Promise.resolve(void 0)}publicLogError2(o,u){return this.publicLogError(o,u)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=p,e.NullTelemetryService=new p;class v{async publicLog(o,u,w){}async publicLogError(o,u,w){}}e.NullEndpointTelemetryService=v,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function g(a,o){return k.Event.debounce(o.onDidChangeConfiguration,(w,A)=>{const $=w?new Set([...w.affectedKeys,...A.affectedKeys]):A.affectedKeys;return{...A,affectedKeys:$}},1e3,!0)(w=>{w.source!==7&&a.publicLog2("updateConfiguration",{configurationSource:(0,D.ConfigurationTargetToString)(w.source),configurationKeys:h(w.affectedKeys)})})}e.configurationTelemetry=g;function I(a,o){return!o.isBuilt&&!o.disableTelemetry?!0:!(o.disableTelemetry||!a.enableTelemetry||o.extensionTestsLocationURI)}e.supportsTelemetry=I;function E(a,o){return!(o.isBuilt||o.disableTelemetry||a.enableTelemetry&&a.aiConfig?.ariaKey)}e.isLoggingOnly=E;function L(a){const o=a.getValue(f.TELEMETRY_SETTING_ID),u=a.getValue(f.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(a.getValue(f.TELEMETRY_OLD_SETTING_ID)===!1||u===!1)return 0;switch(o??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=L;function d(a){const o={},u={},w={};S(a,w);for(let A in w){A=A.length>150?A.substr(A.length-149):A;const $=w[A];typeof $=="number"?u[A]=$:typeof $=="boolean"?u[A]=$?1:0:typeof $=="string"?($.length>8192&&console.warn(`Telemetry property: ${A} has been trimmed to 8192, the original length is ${$.length}`),o[A]=$.substring(0,8191)):typeof $<"u"&&$!==null&&(o[A]=$)}return{properties:o,measurements:u}}e.validateTelemetryData=d;const l=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function m(a){if(!a)return"none";const o=(0,N.getRemoteName)(a);return l.has(o)?o:"other"}e.cleanRemoteAuthority=m;function S(a,o,u=0,w){if(!!a)for(const A of Object.getOwnPropertyNames(a)){const $=a[A],Z=w?w+A:A;Array.isArray($)?o[Z]=(0,T.safeStringify)($):$ instanceof Date?o[Z]=$.toISOString():(0,O.isObject)($)?u<2?S($,o,u+1,Z+"."):o[Z]=(0,T.safeStringify)($):o[Z]=$}}function h(a){if(!a)return[];const o=[];return y(o,"",a),o}function y(a,o,u){u&&typeof u=="object"&&!Array.isArray(u)?Object.keys(u).forEach(w=>y(a,o?`${o}.${w}`:w,u[w])):a.push(o)}function t(a,o){const u=a.msftInternalDomains||[],w=o.getValue("telemetry.internalTesting");return(0,b.verifyMicrosoftInternalDomain)(u)||w}e.isInternalTelemetry=t;function r(a){return[a.appRoot,a.extensionsPath,a.userHome.fsPath,a.tmpDir.fsPath,a.userDataPath]}e.getPiiPathsFromEnvironment=r;function i(a,o){if(!a||!a.includes("/")&&!a.includes("\\"))return a;let u=a;const w=[];for(const X of o)for(;;){const ee=X.exec(a);if(!ee)break;w.push([ee.index,X.lastIndex])}const A=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,$=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let Z=0;for(u="";;){const X=$.exec(a);if(!X)break;const ee=w.some(([ie,ne])=>X.index<ne&&ie<$.lastIndex);!A.test(X[0])&&!ee&&(u+=a.substring(Z,X.index)+"<REDACTED: user-file-path>",Z=$.lastIndex)}return Z<a.length&&(u+=a.substr(Z)),u}function n(a){if(!a)return a;const o=a.toLowerCase(),u=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const w of u)if(w.regex.test(o))return`<REDACTED: ${w.label}>`;return a}function s(a,o){return(0,T.cloneAndChange)(a,u=>{if(u instanceof c)return u.value;if(typeof u=="string"){let w=u.replaceAll("%20"," ");w=i(w,o);for(const A of o)w=w.replace(A,"");return w=n(w),w}})}e.cleanData=s}),define(Y[26],Q([0,1,32,24,29,12,11,6,35,39]),function(x,e,T,O,k,D,N,b,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function p(i,n){return i.uuid&&n.uuid?i.uuid===n.uuid:i.id===n.id?!0:(0,T.compareIgnoreCase)(i.id,n.id)===0}e.areSameExtensions=p;const v=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class g{static create(n){const s=n.manifest?n.manifest.version:n.version,a=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new g(n.identifier,s,a)}static parse(n){const s=v.exec(n);return s&&s[1]&&s[2]?new g({id:s[1]},s[2],s[4]||void 0):null}constructor(n,s,a="undefined"){this.version=s,this.targetPlatform=a,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof g?p(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.ExtensionKey=g;const I=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function E(i){const n=I.exec(i);return n&&n[1]?[d(n[1]),n[2]]:[d(i),void 0]}e.getIdAndVersion=E;function L(i,n){return`${i}.${n}`}e.getExtensionId=L;function d(i){return i.toLocaleLowerCase()}e.adoptToGalleryExtensionId=d;function l(i,n){return d(L(i,n))}e.getGalleryExtensionId=l;function m(i,n){const s=[],a=o=>{for(const u of s)if(u.some(w=>p(n(w),n(o))))return u;return null};for(const o of i){const u=a(o);u?u.push(o):s.push([o])}return s}e.groupByExtension=m;function S(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=S;function h(i){return{id:new c.TelemetryTrustedValue(i.identifier.id),name:new c.TelemetryTrustedValue(i.name),galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),isSigned:i.isSigned,...i.telemetryData}}e.getGalleryExtensionTelemetryData=h,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function y(i,n){const s=[],a=n.manifest.extensionDependencies?.slice(0)??[];for(;a.length;){const o=a.shift();if(o&&s.every(u=>!p(u.identifier,{id:o}))){const u=i.filter(w=>p(w.identifier,{id:o}));u.length===1&&(s.push(u[0]),a.push(...u[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}e.getExtensionDependencies=y;async function t(i,n){if(!D.isLinux)return!1;let s;try{s=(await i.readFile(N.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await i.readFile(N.URI.file("/usr/lib/os-release"))).value.toString()}catch(o){n.debug("Error while getting the os-release file.",(0,b.getErrorMessage)(o))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=t;async function r(i,n){const s=await t(i,n),a=(0,O.getTargetPlatform)(s?"alpine":D.platform,f.arch);return n.debug("ComputeTargetPlatform:",a),a}e.computeTargetPlatform=r}),define(Y[132],Q([0,1,23,6,16,18,41,11,89,24,26,29]),function(x,e,T,O,k,D,N,b,f,c,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLI=void 0;const g=d=>(0,f.localize)(0,null,d),I=(0,f.localize)(1,null,"ms-dotnettools.csharp");function E(d,l){return l?`${d.publisher}.${d.name}@${d.version}`:`${d.publisher}.${d.name}`}let L=class{constructor(l,m){this.a=l,this.b=m}get d(){}async listExtensions(l,m,S,h=console){let y=await this.a.getInstalled(1,S);const t=v.EXTENSION_CATEGORIES.map(i=>i.toLowerCase());if(m&&m!==""){if(t.indexOf(m.toLowerCase())<0){h.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}y=y.filter(i=>i.manifest.categories?i.manifest.categories.map(s=>s.toLowerCase()).indexOf(m.toLowerCase())>-1:!1)}else if(m===""){h.log("Possible Categories: "),t.forEach(i=>{h.log(i)});return}this.d&&h.log((0,f.localize)(2,null,this.d)),y=y.sort((i,n)=>i.identifier.id.localeCompare(n.identifier.id));let r;for(const i of y)r!==i.identifier.id&&(r=i.identifier.id,h.log(E(i.manifest,l)))}async installExtensions(l,m,S,h,y=console){const t=[],r=[];l.length&&y.log(this.d?(0,f.localize)(3,null,this.d):(0,f.localize)(4,null));const i=await this.a.getInstalled(1,S.profileLocation),n=(u,w)=>{const A=i.find($=>(0,p.areSameExtensions)($.identifier,{id:u}));if(A){if(!h&&(!w||w==="prerelease"&&A.preRelease))return y.log((0,f.localize)(5,null,u,A.manifest.version,u)),!1;if(w&&A.manifest.version===w)return y.log((0,f.localize)(6,null,`${u}@${w}`)),!1}return!0},s=(u,w,A)=>{o.push({id:u,version:w!=="prerelease"?w:void 0,installOptions:{...S,isBuiltin:A,installPreReleaseVersion:w==="prerelease"||S.installPreReleaseVersion}})},a=[],o=[];for(const u of l)if(u instanceof b.URI)a.push(u);else{const[w,A]=(0,p.getIdAndVersion)(u);n(w,A)&&s(w,A,!1)}for(const u of m){const[w,A]=(0,p.getIdAndVersion)(u);n(w,A)&&s(w,A,!0)}if(a.length&&await Promise.all(a.map(async u=>{try{const w=await this.f(u,{...S,isBuiltin:!1},h,y);w&&r.push(w)}catch(w){y.error(w.message||w.stack||w),t.push(u.toString())}})),o.length){const u=await this.g(o);await Promise.all(o.map(async w=>{const A=u.get(w.id.toLowerCase());if(A)try{const $=await this.h(w,A,i,h,y);$&&r.push($)}catch($){y.error($.message||$.stack||$),t.push(w.id)}else y.error(`${g(w.version?`${w.id}@${w.version}`:w.id)}
${I}`),t.push(w.id)}))}if(t.length)throw new Error((0,f.localize)(7,null,t.join(", ")))}async f(l,m,S,h){const y=await this.a.getManifest(l);if(!y)throw new Error("Invalid vsix");if(await this.k(y,S,m.profileLocation,h))try{return await this.a.install(l,m),h.log((0,f.localize)(8,null,(0,D.basename)(l))),y}catch(r){if((0,O.isCancellationError)(r))return h.log((0,f.localize)(9,null,(0,D.basename)(l))),null;throw r}return null}async g(l){const m=new Map,S=l.some(y=>y.installOptions.installPreReleaseVersion),h=await this.b.getExtensions(l.map(y=>({...y,preRelease:S})),T.CancellationToken.None);for(const y of h)m.set(y.identifier.id.toLowerCase(),y);return m}async h({id:l,version:m,installOptions:S},h,y,t,r){const i=await this.b.getManifest(h,T.CancellationToken.None);if(i&&!this.j(i,r))return null;const n=y.find(s=>(0,p.areSameExtensions)(s.identifier,h.identifier));if(n){if(h.version===n.manifest.version)return r.log((0,f.localize)(10,null,m?`${l}@${m}`:l)),null;r.log((0,f.localize)(11,null,l,h.version))}try{S.isBuiltin?r.log(m?(0,f.localize)(12,null,l,m):(0,f.localize)(13,null,l)):r.log(m?(0,f.localize)(14,null,l,m):(0,f.localize)(15,null,l));const s=await this.a.installFromGallery(h,{...S,installGivenVersion:!!m});return r.log((0,f.localize)(16,null,l,s.manifest.version)),i}catch(s){if((0,O.isCancellationError)(s))return r.log((0,f.localize)(17,null,l)),null;throw s}}j(l,m){return!0}async k(l,m,S,h){const y={id:(0,p.getGalleryExtensionId)(l.publisher,l.name)},r=(await this.a.getInstalled(1,S)).find(i=>(0,p.areSameExtensions)(y,i.identifier)&&(0,N.gt)(i.manifest.version,l.version));return r&&!m?(h.log((0,f.localize)(18,null,r.identifier.id,r.manifest.version,l.version)),!1):this.j(l,h)}async uninstallExtensions(l,m,S,h=console){const y=async r=>{if(r instanceof b.URI){const i=await this.a.getManifest(r);return E(i)}return r},t=[];for(const r of l){const i=await y(r),s=(await this.a.getInstalled(void 0,S)).filter(a=>(0,p.areSameExtensions)(a.identifier,{id:i}));if(!s.length)throw new Error(`${this.l(i)}
${I}`);if(s.some(a=>a.type===0)){h.log((0,f.localize)(19,null,i));return}if(!m&&s.some(a=>a.isBuiltin)){h.log((0,f.localize)(20,null,i));return}h.log((0,f.localize)(21,null,i));for(const a of s)await this.a.uninstall(a,{profileLocation:S}),t.push(a);this.d?h.log((0,f.localize)(22,null,i,this.d)):h.log((0,f.localize)(23,null,i))}}async locateExtension(l,m=console){const S=await this.a.getInstalled();l.forEach(h=>{S.forEach(y=>{if(y.identifier.id===h&&y.location.scheme===k.Schemas.file){m.log(y.location.fsPath);return}})})}l(l){return this.d?(0,f.localize)(24,null,l,this.d):(0,f.localize)(25,null,l)}};L=de([_(0,c.IExtensionManagementService),_(1,c.IExtensionGalleryService)],L),e.ExtensionManagementCLI=L}),define(Y[133],Q([0,1,5,6,2,16,12,18,41,4,31,20,21,17,24,26,59,13,10,28]),function(x,e,T,O,k,D,N,b,f,c,p,v,g,I,E,L,d,l,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let h=class Ve extends k.Disposable{constructor(t,r,i,n,s,a,o){super(),this.h=r,this.i=i,this.j=n,this.k=s,this.l=a,this.m=o,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.v()}async download(t,r){await this.g;const i=(0,b.joinPath)(this.extensionsDownloadDir,this.w(t));try{await this.t(t,i,s=>this.i.download(t,s,r))}catch(s){throw new E.ExtensionManagementError(s.message,E.ExtensionManagementErrorCode.Download)}let n="Unverified";if(await this.n(t)){const s=await this.r(t);try{await this.l.verify(i.fsPath,s.fsPath)&&(n="Verified"),this.m.info(`Extension signature verification: ${t.identifier.id}. Verification status: ${n}.`)}catch(a){const o=a.code;if(o==="UnknownError")n="UnknownError",this.m.warn(`Extension signature verification: ${t.identifier.id}. Verification status: ${n}.`);else throw await this.delete(s),await this.delete(i),new E.ExtensionManagementError(o,E.ExtensionManagementErrorCode.Signature)}}return{location:i,verificationStatus:n}}async n(t){if(!t.isSigned)return!1;const r=this.j.getValue("extensions.verifySignature");return(0,c.isBoolean)(r)?r:this.k.quality!=="stable"}async r(t){await this.g;const r=(0,b.joinPath)(this.extensionsDownloadDir,`${this.w(t)}${Ve.c}`);return await this.t(t,r,i=>this.i.downloadSignatureArchive(t,i)),r}async t(t,r,i){if(await this.h.exists(r))return;if(r.scheme!==D.Schemas.file){await i(r);return}const n=(0,b.joinPath)(this.extensionsDownloadDir,`.${(0,p.generateUuid)()}`);await this.h.exists(n)||await i(n);try{await this.u(n,r,Date.now()+2*60*1e3)}catch(s){try{await this.h.del(n)}catch{}if(s.code==="ENOTEMPTY")this.m.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,r.path);else throw this.m.info(`Rename failed because of ${(0,O.getErrorMessage)(s)}. Deleted the file from downloaded location`,n.path),s}}async delete(t){await this.g,await this.h.del(t)}async u(t,r,i){try{await v.Promises.rename(t.fsPath,r.fsPath)}catch(n){if(N.isWindows&&n&&n.code==="EPERM"&&Date.now()<i)return this.m.info(`Failed renaming ${t} to ${r} with 'EPERM' error. Trying again...`),this.u(t,r,i);throw n}}async v(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.m.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const r=[],i=[],n=[];for(const o of t.children)if(o.name.endsWith(Ve.c))n.push(o.resource);else{const u=L.ExtensionKey.parse(o.name);u&&i.push([u,o])}const s=(0,L.groupByExtension)(i,([o])=>o),a=[];for(const o of s)o.sort((u,w)=>f.rcompare(u[0].version,w[0].version)),r.push(...o.slice(1).map(u=>u[1].resource)),a.push(o[0][1]);a.sort((o,u)=>o.mtime-u.mtime),r.push(...a.slice(0,Math.max(0,a.length-this.f)).map(o=>o.resource)),r.push(...n),await T.Promises.settled(r.map(o=>(this.m.trace("Deleting from cache",o.path),this.h.del(o))))}}catch(t){this.m.error(t)}}w(t){return this.f?L.ExtensionKey.create(t).toString().toLowerCase():(0,p.generateUuid)()}};h.c=".sigzip",h=de([_(0,I.INativeEnvironmentService),_(1,l.IFileService),_(2,E.IExtensionGalleryService),_(3,g.IConfigurationService),_(4,S.IProductService),_(5,d.IExtensionSignatureVerificationService),_(6,m.ILogService)],h),e.ExtensionsDownloader=h}),define(Y[134],Q([0,1,3,2,36,26,29]),function(x,e,T,O,k,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class b extends O.Disposable{constructor(c,p,v,g,I,E,L){super(),this.f=c,this.g=p,this.h=v,this.i=g,this.j=I,this.k=E,this.l=L,this.a=this.B(new T.Emitter),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new O.DisposableMap),this.m().then(null,d=>L.error(d))}async m(){await this.g.initializeDefaultProfileExtensions(),await this.p(this.h.profiles,[]),this.n(),await this.C()}n(){this.B(this.h.onDidChangeProfiles(c=>this.p(c.added,c.removed))),this.B(this.i.onAddExtensions(c=>this.r(c))),this.B(this.i.onDidAddExtensions(c=>this.s(c))),this.B(this.i.onRemoveExtensions(c=>this.t(c))),this.B(this.i.onDidRemoveExtensions(c=>this.u(c))),this.B(this.k.onDidFilesChange(c=>this.v(c)))}async p(c,p){try{await Promise.all(p.map(v=>(this.c.deleteAndDispose(v.id),this.z(v.extensionsResource)))),c.length&&await Promise.all(c.map(v=>(this.c.set(v.id,(0,O.combinedDisposable)(this.k.watch(this.j.extUri.dirname(v.extensionsResource)),this.k.watch(v.extensionsResource))),this.y(v.extensionsResource))))}catch(v){throw this.l.error(v),v}}async r(c){for(const p of c.extensions)this.D(this.G(p.identifier,p.version),c.profileLocation)}async s(c){for(const p of c.extensions){const v=this.G(p.identifier,p.version);c.error?this.F(v,c.profileLocation):this.D(v,c.profileLocation)}}async t(c){for(const p of c.extensions)this.F(this.G(p.identifier,p.version),c.profileLocation)}async u(c){let p=!1;for(const v of c.extensions){const g=this.G(v.identifier,v.version);c.error?this.D(g,c.profileLocation):(this.F(g,c.profileLocation),p=p||!this.b.has(g))}p&&await this.C()}v(c){for(const p of this.h.profiles)c.contains(p.extensionsResource,0,1)&&this.w(p.extensionsResource)}async w(c){const p=[],v=[],g=await this.i.scanProfileExtensions(c),I=new Set,E=new Set;for(const[L,d]of this.b)d.has(c)&&E.add(L);for(const L of g){const d=this.G(L.identifier,L.version);I.add(d),E.has(d)||(p.push(L.identifier),this.D(d,c))}for(const L of E)if(!I.has(L)){const d=this.H(L);d&&(v.push(d.identifier),this.F(L,c))}(p.length||v.length)&&this.a.fire({added:p.length?{extensions:p,profileLocation:c}:void 0,removed:v.length?{extensions:v,profileLocation:c}:void 0})}async y(c){const p=await this.i.scanProfileExtensions(c);for(const v of p)this.D(this.G(v.identifier,v.version),c)}async z(c){for(const p of[...this.b.keys()])this.F(p,c);await this.C()}async C(){const p=(await this.f.getAllUserInstalled()).filter(v=>v.installedTimestamp&&!this.b.has(this.G(v.identifier,v.manifest.version)));p.length&&await this.f.markAsUninstalled(...p)}D(c,p){let v=this.b.get(c);v||this.b.set(c,v=new k.ResourceSet(g=>this.j.extUri.getComparisonKey(g))),v.add(p)}F(c,p){const v=this.b.get(c);v&&v.delete(p),v?.size||this.b.delete(c)}G(c,p){return`${N.ExtensionIdentifier.toKey(c.id)}@${p}`}H(c){const[p,v]=(0,D.getIdAndVersion)(c);return v?{identifier:{id:p},version:v}:void 0}}e.ExtensionsWatcher=b}),define(Y[135],Q([0,1,109,39]),function(x,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function k(D,N,b,f,c,p,v){const g={"X-Market-Client-Id":`VSCode ${D}`,"User-Agent":`VSCode ${D} (${N.nameShort})`};if((0,O.supportsTelemetry)(N,b)&&(0,O.getTelemetryLevel)(f)===3){const I=await(0,T.getServiceMachineId)(b,c,p),{machineId:E}=await v.getTelemetryInfo();g["X-Market-User-Id"]=I,g["VSCode-SessionId"]=E||I}return g}e.resolveMarketplaceHeaders=k}),define(Y[136],Q([0,1,163,19,5,2,16,14,20,17,24,26,10,63,12,11]),function(x,e,T,O,k,D,N,b,f,c,p,v,g,I,E,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let d=class extends I.LanguagePackBaseService{constructor(h,y,t,r){super(t),this.h=h,this.i=r,this.g=this.B(new l(y,r)),this.h.registerParticipant({postInstall:async i=>this.j(i),postUninstall:async i=>this.k(i)})}async getBuiltInExtensionTranslationsUri(h){const t=(await this.g.getLanguagePacks())[E.Language.value()];if(!t){this.i.warn(`No language pack found for ${E.Language.value()}`);return}const r=t.translations[h];return r?L.URI.file(r):void 0}async getInstalledLanguages(){const h=await this.g.getLanguagePacks(),y=Object.keys(h).map(t=>{const r=h[t];return{...this.f(t,r.label),extensionId:r.extensions[0].extensionIdentifier.id}});return y.push({...this.f("en","English"),extensionId:"default"}),y.sort((t,r)=>t.label.localeCompare(r.label)),y}async j(h){h&&h.manifest&&h.manifest.contributes&&h.manifest.contributes.localizations&&h.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",h.identifier.id),await this.update())}async k(h){const y=await this.g.getLanguagePacks();Object.keys(y).some(t=>y[t]&&y[t].extensions.some(r=>(0,v.areSameExtensions)(r.extensionIdentifier,h.identifier)))&&(this.i.info("Removing language packs from the extension",h.identifier.id),await this.update())}async update(){const[h,y]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),t=await this.g.update(y);return!(0,O.equals)(Object.keys(h),Object.keys(t))}};d=de([_(0,p.IExtensionManagementService),_(1,c.INativeEnvironmentService),_(2,p.IExtensionGalleryService),_(3,g.ILogService)],d),e.NativeLanguagePackService=d;let l=class extends D.Disposable{constructor(h,y){super(),this.i=y,this.c={},this.f=(0,b.join)(h.userDataPath,"languagepacks.json"),this.g=new k.Queue}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update(h){return this.m(y=>{Object.keys(y).forEach(t=>delete y[t]),this.j(y,...h)}).then(()=>this.c)}j(h,...y){for(const t of y)t&&t.manifest&&t.manifest.contributes&&t.manifest.contributes.localizations&&t.manifest.contributes.localizations.length&&this.k(h,t);Object.keys(h).forEach(t=>this.l(h[t]))}k(h,y){const t=y.identifier,r=y.manifest.contributes&&y.manifest.contributes.localizations?y.manifest.contributes.localizations:[];for(const i of r)if(y.location.scheme===N.Schemas.file&&m(i)){let n=h[i.languageId];n||(n={hash:"",extensions:[],translations:{},label:i.localizedLanguageName??i.languageName},h[i.languageId]=n);const s=n.extensions.filter(a=>(0,v.areSameExtensions)(a.extensionIdentifier,t))[0];s?s.version=y.manifest.version:n.extensions.push({extensionIdentifier:t,version:y.manifest.version});for(const a of i.translations)n.translations[a.id]=(0,b.join)(y.location.fsPath,a.path)}}l(h){if(h){const y=(0,T.createHash)("md5");for(const t of h.extensions)y.update(t.extensionIdentifier.uuid||t.extensionIdentifier.id).update(t.version);h.hash=y.digest("hex")}}m(h=()=>null){return this.g.queue(()=>{let y=null;return f.Promises.readFile(this.f,"utf8").then(void 0,t=>t.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(t)).then(t=>{try{return JSON.parse(t)}catch{return{}}}).then(t=>(y=h(t),t)).then(t=>{for(const i of Object.keys(t))t[i]||delete t[i];this.c=t,this.h=!0;const r=JSON.stringify(this.c);return this.i.debug("Writing language packs",r),f.Promises.writeFile(this.f,r)}).then(()=>y,t=>this.i.error(t))})}};l=de([_(0,c.INativeEnvironmentService),_(1,g.ILogService)],l);function m(S){if(typeof S.languageId!="string"||!Array.isArray(S.translations)||S.translations.length===0)return!1;for(const h of S.translations)if(typeof h.id!="string"||typeof h.path!="string")return!1;return!(S.languageName&&typeof S.languageName!="string"||S.localizedLanguageName&&typeof S.localizedLanguageName!="string")}}),define(Y[137],Q([0,1,6,30,39]),function(x,e,T,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const D="https://mobile.events.data.microsoft.com/OneCollector/1.0",N="https://mobile.events.data.microsoft.com/ping";async function b(c,p,v){const g=await new Promise((l,m)=>{x(["@microsoft/1ds-core-js"],l,m)}),I=await new Promise((l,m)=>{x(["@microsoft/1ds-post-js"],l,m)}),E=new g.AppInsightsCore,L=new I.PostChannel,d={instrumentationKey:c,endpointUrl:D,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[L]]};if(v){d.extensionConfig={};const l={alwaysUseXhrOverride:!0,httpXHROverride:v};d.extensionConfig[L.identifier]=l}return E.initialize(d,[]),E.addTelemetryInitializer(l=>{p&&(l.ext=l.ext??{},l.ext.utc=l.ext.utc??{},l.ext.utc.flags=8462029)}),E}class f{constructor(p,v,g,I,E){this.e=p,this.f=v,this.g=g,this.h=E,this.c=D,this.d=N,this.g||(this.g={}),typeof I=="function"?this.a=I():this.a=I,this.b=null}i(p){if(!!this.a){if(typeof this.a!="string"){p(this.a);return}this.b||(this.b=b(this.a,this.e,this.h)),this.b.then(v=>{p(v)},v=>{(0,T.onUnexpectedError)(v),console.error(v)})}}log(p,v){if(!this.a)return;v=(0,O.mixin)(v,this.g),v=(0,k.validateTelemetryData)(v);const g=this.f+"/"+p;try{this.i(I=>{I.pluginVersionString=v?.properties.version??"Unknown",I.track({name:g,baseData:{name:g,properties:v?.properties,measurements:v?.measurements}})})}catch{}}flush(){return this.a?new Promise(p=>{this.i(v=>{v.unload(!0,()=>{this.a=void 0,p(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=f}),define(Y[138],Q([0,1,2,30,12,32,101,21,42,139,28,37,25,39]),function(x,e,T,O,k,D,N,b,f,c,p,v,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let E=class{constructor(l,m,S){this.k=m,this.l=S,this.d={},this.i=new T.DisposableStore,this.j=[],this.b=l.appenders,this.c=l.commonProperties||Promise.resolve({}),this.f=l.piiPaths||[],this.g=3,this.h=!!l.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const h of this.f)this.j.push(new RegExp((0,D.escapeRegExpCharacters)(h),"gi")),h.indexOf("\\")>=0&&this.j.push(new RegExp((0,D.escapeRegExpCharacters)(h.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(h=>{(h.affectsConfiguration(g.TELEMETRY_SETTING_ID)||h.affectsConfiguration(g.TELEMETRY_OLD_SETTING_ID)||h.affectsConfiguration(g.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this.m()}))}setExperimentProperty(l,m){this.d[l]=m}m(){let l=(0,I.getTelemetryLevel)(this.k);const m=this.l.enabledTelemetryLevels;if(m){this.h=this.sendErrorTelemetry?m.error:!1;const S=m.usage?3:m.error?2:0;l=Math.min(l,S)}this.g=l}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}async getTelemetryInfo(){const l=await this.c,m=l.sessionID,S=l["common.machineId"],h=l["common.firstSessionDate"],y=l["common.msftInternal"];return{sessionId:m,machineId:S,firstSessionDate:h,msftInternal:y}}dispose(){this.i.dispose()}n(l,m,S){return this.g<m?Promise.resolve(void 0):this.c.then(h=>{S=(0,O.mixin)(S,this.d),S=(0,I.cleanData)(S,this.j),S=(0,O.mixin)(S,h),this.b.forEach(y=>y.log(l,S))},h=>{console.error(h)})}publicLog(l,m){return this.n(l,3,m)}publicLog2(l,m){return this.publicLog(l,m)}publicLogError(l,m){return this.h?this.n(l,2,m):Promise.resolve(void 0)}publicLogError2(l,m){return this.publicLogError(l,m)}};E.IDLE_START_EVENT_NAME="UserIdleStart",E.IDLE_STOP_EVENT_NAME="UserIdleStop",E=de([_(1,b.IConfigurationService),_(2,p.IProductService)],E),e.TelemetryService=E;function L(){const d=(0,N.localize)(0,null,c.default.nameLong),l=c.default.privacyStatementUrl?(0,N.localize)(2,null,"https://aka.ms/vscode-telemetry",c.default.privacyStatementUrl):(0,N.localize)(1,null,"https://aka.ms/vscode-telemetry"),m=k.isWeb?"":(0,N.localize)(3,null),S=(0,N.localize)(4,null),h=(0,N.localize)(5,null),y=(0,N.localize)(6,null),t=(0,N.localize)(7,null),r=`
|       | ${S} | ${h} | ${y} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,N.localize)(8,null);return`
${d} ${l} ${m}

&nbsp;

${t}
${r}

&nbsp;

${i}
`}v.Registry.as(f.Extensions.Configuration).registerConfiguration({id:g.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,N.localize)(9,null),properties:{[g.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,N.localize)(10,null),(0,N.localize)(11,null),(0,N.localize)(12,null),(0,N.localize)(13,null)],markdownDescription:L(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),v.Registry.as(f.Extensions.Configuration).registerConfiguration({id:g.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,N.localize)(14,null),properties:{[g.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,N.localize)(16,null,c.default.nameLong,c.default.privacyStatementUrl):(0,N.localize)(15,null,c.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,N.localize)(17,null,`\`#${g.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Y[140],Q([0,1,164,137]),function(x,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class k extends O.AbstractOneDataSystemAppender{constructor(N,b,f,c){const p={sendPOST:(v,g)=>{const I={method:"POST",headers:{...v.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(v.data)}};try{const E=T.request(v.urlString,I,L=>{L.on("data",function(d){g(L.statusCode??200,L.headers,d.toString())}),L.on("error",function(d){g(0,{})})});E.write(v.data),E.end()}catch{g(0,{})}}};super(N,b,f,c,p)}}e.OneDataSystemAppender=k}),define(Y[141],Q([0,1,14,20]),function(x,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildTelemetryMessage=void 0;async function k(D,N){const b=Object.create(null),f=(p,v)=>{const g=JSON.parse(p);b[v]=g};if(N){const p=[],v=await O.Promises.readdir(N);for(const I of v)try{(await O.Promises.stat((0,T.join)(N,I))).isDirectory()&&p.push(I)}catch{}const g=[];for(const I of p)(await O.Promises.readdir((0,T.join)(N,I))).filter(L=>L==="telemetry.json").length===1&&g.push(I);for(const I of g){const E=(await O.Promises.readFile((0,T.join)(N,I,"telemetry.json"))).toString();f(E,I)}}let c=(await O.Promises.readFile((0,T.join)(D,"telemetry-core.json"))).toString();return f(c,"vscode-core"),c=(await O.Promises.readFile((0,T.join)(D,"telemetry-extensions.json"))).toString(),f(c,"vscode-extensions"),JSON.stringify(b,null,4)}e.buildTelemetryMessage=k}),define(Y[142],Q([0,1,12,80,25]),function(x,e,T,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function D(N){let b=N.getItem(k.machineIdKey);return(typeof b!="string"||T.isMacintosh&&b==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(b=await(0,O.getMachineId)()),b}e.resolveMachineId=D}),define(Y[27],Q([0,1,9]),function(x,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,T.createDecorator)("IUriIdentityService")}),define(Y[143],Q([0,1,27,110,13,18,72,3,2]),function(x,e,T,O,k,D,N,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class c{constructor(g){this.uri=g,this.time=c._clock++}touch(){return this.time=c._clock++,this}}c._clock=0;let p=class{constructor(g){this.g=g,this.c=new f.DisposableStore,this.f=2**16;const I=new Map,E=L=>{let d=I.get(L.scheme);return d===void 0&&(d=g.hasProvider(L)&&!this.g.hasCapability(L,1024),I.set(L.scheme,d)),d};this.c.add(b.Event.any(g.onDidChangeFileSystemProviderRegistrations,g.onDidChangeFileSystemProviderCapabilities)(L=>{I.delete(L.scheme)})),this.extUri=new D.ExtUri(E),this.d=new N.SkipList((L,d)=>this.extUri.compare(L,d,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(g){this.g.hasProvider(g)&&(g=(0,D.normalizePath)(g));const I=this.d.get(g);return I?I.touch().uri.with({fragment:g.fragment}):(this.d.set(g,new c(g)),this.h(),g)}h(){if(this.d.size<this.f)return;const g=[...this.d.entries()].sort((E,L)=>E[1].touch<L[1].touch?1:E[1].touch>L[1].touch?-1:0);c._clock=0,this.d.clear();const I=this.f*.5;for(let E=0;E<I;E++)this.d.set(g[E][0],g[E][1].touch())}};p=de([_(0,k.IFileService)],p),e.UriIdentityService=p,(0,O.registerSingleton)(T.IUriIdentityService,p,1)}),define(Y[144],Q([0,1,103,14,54,18,11,9,16]),function(x,e,T,O,k,D,N,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,b.createDecorator)("contextService");function c(i){const n=i;return typeof n?.id=="string"&&N.URI.isUri(n.uri)}e.isSingleFolderWorkspaceIdentifier=c;function p(i){return typeof i?.id=="string"&&!c(i)&&!g(i)}e.isEmptyWorkspaceIdentifier=p,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function v(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,O.basename)(i)}:n?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const s=i;return s.configuration?{id:s.id,configPath:s.configuration}:s.folders.length===1?{id:s.id,uri:s.folders[0].uri}:{id:s.id}}e.toWorkspaceIdentifier=v;function g(i){const n=i;return typeof n?.id=="string"&&N.URI.isUri(n.configPath)}e.isWorkspaceIdentifier=g;function I(i){const n=i;if(n?.uri)return{id:n.id,uri:N.URI.revive(n.uri)};const s=i;if(s?.configPath)return{id:s.id,configPath:N.URI.revive(s.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=I;var E;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(E=e.WorkbenchState||(e.WorkbenchState={}));function L(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.isWorkspace=L;function d(i){const n=i;return!!(n&&typeof n=="object"&&N.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.isWorkspaceFolder=d;class l{constructor(n,s,a,o,u){this.h=n,this.j=a,this.k=o,this.l=u,this.c=k.TernarySearchTree.forUris(this.l,()=>!0),this.folders=s}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=k.TernarySearchTree.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=l;class m{constructor(n,s){this.raw=s,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,D.joinPath)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=m;function S(i){return new m({uri:i,index:0,name:(0,D.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=S,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,T.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function h(i,n){return D.extUriBiasedIgnorePathCase.isEqualOrParent(i,n.untitledWorkspacesHome)}e.isUntitledWorkspace=h;function y(i){let n;return N.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===f.Schemas.tmp}e.isTemporaryWorkspace=y;function t(i,n){return!h(i,n)&&!y(i)}e.isSavedWorkspace=t;function r(i){return(typeof i=="string"?(0,O.extname)(i):(0,D.extname)(i))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=r}),define(Y[22],Q([0,1,52,3,2,18,11,102,17,13,9,10,144,36,27,5,31,32,4]),function(x,e,T,O,k,D,N,b,f,c,p,v,g,I,E,L,d,l,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function S(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&N.URI.isUri(n.location)&&N.URI.isUri(n.globalStorageHome)&&N.URI.isUri(n.settingsResource)&&N.URI.isUri(n.keybindingsResource)&&N.URI.isUri(n.tasksResource)&&N.URI.isUri(n.snippetsHome)&&N.URI.isUri(n.extensionsResource))}e.isUserDataProfile=S,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,p.createDecorator)("IUserDataProfilesService");function h(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,location:N.URI.revive(i.location).with({scheme:n}),globalStorageHome:N.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:N.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:N.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:N.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:N.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:N.URI.revive(i.extensionsResource)?.with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.reviveProfile=h;function y(i,n,s,a){return{id:i,name:n,location:s,isDefault:!1,shortName:a?.shortName,globalStorageHome:(0,D.joinPath)(s,"globalStorage"),settingsResource:(0,D.joinPath)(s,"settings.json"),keybindingsResource:(0,D.joinPath)(s,"keybindings.json"),tasksResource:(0,D.joinPath)(s,"tasks.json"),snippetsHome:(0,D.joinPath)(s,"snippets"),extensionsResource:(0,D.joinPath)(s,"extensions.json"),useDefaultFlags:a?.useDefaultFlags,isTransient:a?.transient}}e.toUserDataProfile=y;let t=class extends k.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.u.profiles,...this.l.profiles]}constructor(n,s,a,o){super(),this.m=n,this.n=s,this.r=a,this.s=o,this.f=!1,this.g=this.B(new O.Emitter),this.onDidChangeProfiles=this.g.event,this.h=this.B(new O.Emitter),this.onWillCreateProfile=this.h.event,this.i=this.B(new O.Emitter),this.onWillRemoveProfile=this.i.event,this.j=this.B(new O.Emitter),this.onDidResetWorkspaces=this.j.event,this.k=new Map,this.l={profiles:[],workspaces:new I.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,D.joinPath)(this.m.userRoamingDataHome,"profiles")}setEnablement(n){this.f!==n&&(this.t=void 0,this.f=n)}isEnabled(){return this.f}get u(){if(!this.t){const n=[];if(this.f)for(const u of this.G()){if(!u.name||!(0,m.isString)(u.name)||!u.location){this.s.warn("Skipping the invalid stored profile",u.location||u.name);continue}n.push(y((0,D.basename)(u.location),u.name,u.location,{shortName:u.shortName,useDefaultFlags:u.useDefaultFlags}))}const s=new I.ResourceMap,a=new Map,o=y((0,T.hash)(this.m.userRoamingDataHome.path).toString(16),(0,b.localize)(0,null),this.m.userRoamingDataHome);if(n.unshift({...o,extensionsResource:this.L()??o.extensionsResource,isDefault:!0}),n.length){const u=this.I();if(u.workspaces)for(const[w,A]of Object.entries(u.workspaces)){const $=N.URI.parse(w),Z=N.URI.parse(A),X=n.find(ee=>this.r.extUri.isEqual(ee.location,Z));X&&s.set($,X)}if(u.emptyWindows)for(const[w,A]of Object.entries(u.emptyWindows)){const $=N.URI.parse(A),Z=n.find(X=>this.r.extUri.isEqual(X.location,$));Z&&a.set(w,Z)}}this.t={profiles:n,workspaces:s,emptyWindows:a}}return this.t}async createTransientProfile(n){const s="Temp",a=new RegExp(`${(0,l.escapeRegExpCharacters)(s)}\\s(\\d+)`);let o=0;for(const w of this.profiles){const A=a.exec(w.name),$=A?parseInt(A[1]):0;o=$>o?$:o}const u=`${s} ${o+1}`;return this.createProfile((0,T.hash)((0,d.generateUuid)()).toString(16),u,{transient:!0},n)}async createNamedProfile(n,s,a){return this.createProfile((0,T.hash)((0,d.generateUuid)()).toString(16),n,s,a)}async createProfile(n,s,a,o){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const u=await this.v(n,s,a);return o&&await this.setProfileForWorkspace(o,u),u}async v(n,s,a){if(!(0,m.isString)(s)||!s)throw new Error("Name of the profile is mandatory and must be of type `string`");let o=this.k.get(s);return o||(o=(async()=>{try{const u=this.profiles.find($=>$.name===s||$.id===n);if(u)return u;const w=y(n,s,(0,D.joinPath)(this.profilesHome,n),a);await this.n.createFolder(w.location);const A=[];return this.h.fire({profile:w,join($){A.push($)}}),await L.Promises.settled(A),this.z([w],[],[]),w}finally{this.k.delete(s)}})(),this.k.set(s,o)),o}async updateProfile(n,s){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let a=this.profiles.find(o=>o.id===n.id);if(!a)throw new Error(`Profile '${n.name}' does not exist`);return a=y(a.id,s.name??a.name,a.location,{shortName:s.shortName??a.shortName,transient:s.transient??a.isTransient,useDefaultFlags:s.useDefaultFlags??a.useDefaultFlags}),this.z([],[],[a]),a}async removeProfile(n){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(n.isDefault)throw new Error("Cannot remove default profile");const s=this.profiles.find(o=>o.id===n.id);if(!s)throw new Error(`Profile '${n.name}' does not exist`);const a=[];this.i.fire({profile:s,join(o){a.push(o)}});try{await Promise.allSettled(a)}catch(o){this.s.error(o)}for(const o of[...this.u.emptyWindows.keys()])s.id===this.u.emptyWindows.get(o)?.id&&this.u.emptyWindows.delete(o);for(const o of[...this.u.workspaces.keys()])s.id===this.u.workspaces.get(o)?.id&&this.u.workspaces.delete(o);this.F(),this.z([],[s],[]);try{this.profiles.length===1?await this.n.del(this.profilesHome,{recursive:!0}):await this.n.del(s.location,{recursive:!0})}catch(o){this.s.error(o)}}async setProfileForWorkspace(n,s){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const a=this.profiles.find(o=>o.id===s.id);if(!a)throw new Error(`Profile '${s.name}' does not exist`);this.D(n,a)}unsetWorkspace(n,s){if(!this.f)throw new Error(`Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.D(n,void 0,s)}async resetWorkspaces(){this.l.workspaces.clear(),this.l.emptyWindows.clear(),this.u.workspaces.clear(),this.u.emptyWindows.clear(),this.F(),this.j.fire()}async cleanUp(){if(!!this.f&&await this.n.exists(this.profilesHome)){const n=await this.n.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(s=>s.isDirectory&&this.profiles.every(a=>!this.r.extUri.isEqual(a.location,s.resource))).map(s=>this.n.del(s.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.l.profiles.filter(s=>!this.y(s));await Promise.allSettled(n.map(s=>this.removeProfile(s)))}getProfileForWorkspace(n){const s=this.w(n);return N.URI.isUri(s)?this.l.workspaces.get(s)??this.u.workspaces.get(s):this.l.emptyWindows.get(s)??this.u.emptyWindows.get(s)}w(n){return(0,g.isSingleFolderWorkspaceIdentifier)(n)?n.uri:(0,g.isWorkspaceIdentifier)(n)?n.configPath:n.id}y(n){return!!([...this.l.emptyWindows.values()].some(s=>this.r.extUri.isEqual(s.location,n.location))||[...this.l.workspaces.values()].some(s=>this.r.extUri.isEqual(s.location,n.location))||[...this.u.emptyWindows.values()].some(s=>this.r.extUri.isEqual(s.location,n.location))||[...this.u.workspaces.values()].some(s=>this.r.extUri.isEqual(s.location,n.location)))}z(n,s,a){const o=[...this.profiles,...n],u=[];this.l.profiles=[];for(let w of o)w.isDefault||s.some(A=>w.id===A.id)||(w=a.find(A=>w.id===A.id)??w,w.isTransient?this.l.profiles.push(w):u.push({location:w.location,name:w.name,shortName:w.shortName,useDefaultFlags:w.useDefaultFlags}));this.H(u),this.t=void 0,this.C(n,s,a)}C(n,s,a){this.g.fire({added:n,removed:s,updated:a,all:this.profiles})}D(n,s,a){a=s?.isTransient?!0:a,a||this.D(n,void 0,!0);const o=this.w(n),u=a?this.l:this.u;N.URI.isUri(o)?(u.workspaces.delete(o),s&&u.workspaces.set(o,s)):(u.emptyWindows.delete(o),s&&u.emptyWindows.set(o,s)),a||this.F()}F(){const n={};for(const[a,o]of this.u.workspaces.entries())n[a.toString()]=o.location.toString();const s={};for(const[a,o]of this.u.emptyWindows.entries())s[a.toString()]=o.location.toString();this.J({workspaces:n,emptyWindows:s}),this.t=void 0}G(){return[]}H(n){throw new Error("not implemented")}I(){return{}}J(n){throw new Error("not implemented")}L(){}};t.b="userDataProfiles",t.c="profileAssociations",t=de([_(0,f.IEnvironmentService),_(1,c.IFileService),_(2,E.IUriIdentityService),_(3,v.ILogService)],t),e.UserDataProfilesService=t;class r extends t{constructor(){super(...arguments),this.a=[],this.O={}}G(){return this.a}H(n){this.a=n}I(){return this.O}J(n){this.O=n}}e.InMemoryUserDataProfilesService=r}),define(Y[145],Q([0,1,19,5,23,6,3,2,12,11,87,24,26,29,10,28,25,22]),function(x,e,T,O,k,D,N,b,f,c,p,v,g,I,E,L,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=e.ExtensionVerificationStatus=void 0;var m;(function(i){i.Verified="Verified",i.Unverified="Unverified",i.UnknownError="UnknownError"})(m=e.ExtensionVerificationStatus||(e.ExtensionVerificationStatus={}));let S=class extends b.Disposable{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}constructor(n,s,a,o,u){super(),this.t=n,this.u=s,this.v=a,this.w=o,this.y=u,this.h=0,this.j=new Map,this.k=new Map,this.l=this.B(new N.Emitter),this.m=this.B(new N.Emitter),this.n=this.B(new N.Emitter),this.p=this.B(new N.Emitter),this.s=[],this.B((0,b.toDisposable)(()=>{this.j.forEach(({task:w})=>w.cancel()),this.k.forEach(w=>w.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(n){const s=await this.getTargetPlatform();return n.allTargetPlatforms.some(a=>(0,v.isTargetPlatformCompatible)(a,n.allTargetPlatforms,s))}async installFromGallery(n,s={}){try{if(!this.t.isEnabled())throw new v.ExtensionManagementError(p.localize(0,null),v.ExtensionManagementErrorCode.Internal);const a=await this.G(n,!!s.installGivenVersion,!!s.installPreReleaseVersion);return await this.z(a.manifest,a.extension,s)}catch(a){throw t(this.u,"extensionGallery:install",{extensionData:(0,g.getGalleryExtensionTelemetryData)(n),error:a}),this.v.error("Failed to install extension.",n.identifier.id),this.v.error(a),y(a)}}async uninstall(n,s={}){return this.v.trace("ExtensionManagementService#uninstall",n.identifier.id),this.I(n,s)}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.g||n-this.h>1e3*60*5)&&(this.g=this.O(),this.h=n),this.g}registerParticipant(n){this.s.push(n)}async z(n,s,a){const o={...a,installOnlyNewlyAddedFromExtensionPack:c.URI.isUri(s)?a.installOnlyNewlyAddedFromExtensionPack:!0,profileLocation:(0,I.isApplicationScopedExtension)(n)?this.y.defaultProfile.extensionsResource:a.profileLocation??this.P()},u=ee=>`${g.ExtensionKey.create(ee).toString()}${o.profileLocation?`-${o.profileLocation.toString()}`:""}`;if(!c.URI.isUri(s)){const ee=this.j.get(u(s));if(ee){this.v.info("Extensions is already requested to install",s.identifier.id);const{local:ie}=await ee.task.waitUntilTaskIsFinished();return ie}}const w=[],A=[],$=[],Z=this.Q(n,s,o);c.URI.isUri(s)||this.j.set(u(s),{task:Z,waitingTasks:[]}),this.l.fire({identifier:Z.identifier,source:s,profileLocation:o.profileLocation}),this.v.info("Installing extension:",Z.identifier.id),w.push({task:Z,manifest:n});let X=!1;try{if(o.donotIncludePackAndDependencies)this.v.info("Installing the extension without checking dependencies and pack",Z.identifier.id);else try{const ie=await this.F(Z.identifier,n,!!o.installOnlyNewlyAddedFromExtensionPack,!!o.installPreReleaseVersion,o.profileLocation),ne=await this.getInstalled(void 0,o.profileLocation);for(const{gallery:ae,manifest:fe}of(0,T.distinct)(ie,({gallery:re})=>re.identifier.id)){X=X||!!fe.extensionDependencies?.some(z=>(0,g.areSameExtensions)({id:z},Z.identifier));const re=u(ae),me=this.j.get(re);if(me){if(this.C(Z,me.task)){const z=me.task.identifier;this.v.info("Waiting for already requested installing extension",z.id,Z.identifier.id),me.waitingTasks.push(Z),A.push(N.Event.toPromise(N.Event.filter(this.onDidInstallExtensions,j=>j.some(M=>(0,g.areSameExtensions)(M.identifier,z)))).then(j=>{if(this.v.info("Finished waiting for already requested installing extension",z.id,Z.identifier.id),!j.find(B=>(0,g.areSameExtensions)(B.identifier,z))?.local)throw new Error(`Extension ${z.id} is not installed`)}))}}else if(!ne.some(({identifier:z})=>(0,g.areSameExtensions)(z,ae.identifier))){const z=this.Q(fe,ae,{...o,donotIncludePackAndDependencies:!0});this.j.set(re,{task:z,waitingTasks:[Z]}),this.l.fire({identifier:z.identifier,source:ae,profileLocation:o.profileLocation}),this.v.info("Installing extension:",z.identifier.id,Z.identifier.id),w.push({task:z,manifest:fe})}}}catch(ie){if(c.URI.isUri(Z.source))(0,T.isNonEmptyArray)(n.extensionDependencies)&&this.v.warn("Cannot install dependencies of extension:",Z.identifier.id,ie.message),(0,T.isNonEmptyArray)(n.extensionPack)&&this.v.warn("Cannot install packed extensions of extension:",Z.identifier.id,ie.message);else throw this.v.error("Error while preparing to install dependencies and extension packs of the extension:",Z.identifier.id),ie}const ee=w.reduce((ie,{task:ne,manifest:ae})=>(ie.set(ne.identifier.id.toLowerCase(),{task:ne,manifest:ae}),ie),new Map);for(;ee.size;){let ie;const ne=[...ee.values()].filter(({manifest:ae})=>!ae.extensionDependencies?.some(fe=>ee.has(fe.toLowerCase())));ne.length?ie=ee.size===1?ne:ne.filter(({task:ae})=>!(ae===Z&&!X)):(this.v.info("Found extensions with circular dependencies",ne.map(({task:ae})=>ae.identifier.id)),ie=[...ee.values()]),await this.D(ie.map(async({task:ae})=>{const fe=new Date().getTime();try{const{local:re}=await ae.run();if(await this.D(this.s.map(me=>me.postInstall(re,ae.source,o,k.CancellationToken.None))),!c.URI.isUri(ae.source)){const me=ae.operation===3,z=me?void 0:(new Date().getTime()-ae.source.lastUpdated)/1e3;if(t(this.u,me?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,g.getGalleryExtensionTelemetryData)(ae.source),verificationStatus:ae.verificationStatus,duration:new Date().getTime()-fe,durationSinceUpdate:z}),f.isWeb&&ae.operation!==3)try{await this.t.reportStatistic(re.manifest.publisher,re.manifest.name,re.manifest.version,"install")}catch{}}$.push({local:re,identifier:ae.identifier,operation:ae.operation,source:ae.source,context:o.context,profileLocation:o.profileLocation,applicationScoped:re.isApplicationScoped})}catch(re){throw c.URI.isUri(ae.source)||t(this.u,ae.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,g.getGalleryExtensionTelemetryData)(ae.source),verificationStatus:ae.verificationStatus,duration:new Date().getTime()-fe,error:re}),this.v.error("Error while installing the extension:",ae.identifier.id),re}finally{ee.delete(ae.identifier.id.toLowerCase())}}))}return A.length&&await this.D(A),$.forEach(({identifier:ie})=>this.v.info("Extension installed successfully:",ie.id)),this.m.fire($),$.filter(({identifier:ie})=>(0,g.areSameExtensions)(ie,Z.identifier))[0].local}catch(ee){if(w.forEach(({task:ie})=>ie.cancel()),$.length)try{const ie=await Promise.allSettled($.map(({local:ne})=>this.R(ne,{versionOnly:!0,profileLocation:o.profileLocation}).run()));for(let ne=0;ne<ie.length;ne++){const ae=ie[ne],{identifier:fe}=$[ne];ae.status==="fulfilled"?this.v.info("Rollback: Uninstalled extension",fe.id):this.v.warn("Rollback: Error while uninstalling extension",fe.id,(0,D.getErrorMessage)(ae.reason))}}catch(ie){this.v.warn("Error while rolling back extensions",(0,D.getErrorMessage)(ie),$.map(({identifier:ne})=>ne.id))}throw this.m.fire(w.map(({task:ie})=>({identifier:ie.identifier,operation:2,source:ie.source,context:o.context,profileLocation:o.profileLocation}))),ee}finally{for(const{task:ee}of w)ee.source&&!c.URI.isUri(ee.source)&&this.j.delete(u(ee.source))}}C(n,s){for(const[,{task:a,waitingTasks:o}]of this.j.entries())if(a===n&&(o.includes(s)||o.some(u=>this.C(u,s)))||a===s&&o[0]&&!this.C(n,o[0]))return!1;return!0}async D(n){const s=[],a=[],o=await Promise.allSettled(n);for(const u of o)u.status==="fulfilled"?s.push(u.value):a.push(u.reason);if(a.length)throw h(a);return s}async F(n,s,a,o,u){if(!this.t.isEnabled())return[];const w=await this.getInstalled(void 0,u),A=[],$=[],Z=async(X,ee)=>{A.push(X);const ie=ee.extensionDependencies||[],ne=[...ie];if(ee.extensionPack){const ae=a?w.find(fe=>(0,g.areSameExtensions)(fe.identifier,X)):void 0;for(const fe of ee.extensionPack)ae&&ae.manifest.extensionPack&&ae.manifest.extensionPack.some(re=>(0,g.areSameExtensions)({id:re},{id:fe}))||ne.every(re=>!(0,g.areSameExtensions)({id:re},{id:fe}))&&ne.push(fe)}if(ne.length){const ae=ne.filter(fe=>A.every(re=>!(0,g.areSameExtensions)(re,{id:fe})));if(ae.length){const fe=await this.t.getExtensions(ae.map(re=>({id:re,preRelease:o})),k.CancellationToken.None);for(const re of fe){if(A.find(j=>(0,g.areSameExtensions)(j,re.identifier)))continue;const me=ie.some(j=>(0,g.areSameExtensions)({id:j},re.identifier));let z;try{z=await this.G(re,!1,o)}catch(j){if(j instanceof v.ExtensionManagementError&&j.code===v.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!me){this.v.info("Skipping the packed extension as it cannot be installed",re.identifier.id);continue}else throw j}$.push({gallery:z.extension,manifest:z.manifest}),await Z(z.extension.identifier,z.manifest)}}}};return await Z(n,s),$}async G(n,s,a){if((await this.getExtensionsControlManifest()).malicious.some(A=>(0,g.areSameExtensions)(n.identifier,A)))throw new v.ExtensionManagementError(p.localize(1,null,n.identifier.id),v.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(n)){const A=await this.getTargetPlatform();throw new v.ExtensionManagementError(p.localize(2,null,n.identifier.id,this.w.nameLong,(0,v.TargetPlatformToString)(A)),v.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const u=await this.H(n,s,a);if(u){if(a&&!s&&n.hasPreReleaseVersion&&!u.properties.isPreReleaseVersion)throw new v.ExtensionManagementError(p.localize(3,null,n.identifier.id,this.w.nameLong,this.w.version),v.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!a&&n.properties.isPreReleaseVersion&&(await this.t.getExtensions([n.identifier],k.CancellationToken.None))[0]?new v.ExtensionManagementError(p.localize(4,null,n.identifier.id),v.ExtensionManagementErrorCode.ReleaseVersionNotFound):new v.ExtensionManagementError(p.localize(5,null,n.identifier.id,this.w.nameLong,this.w.version),v.ExtensionManagementErrorCode.Incompatible);this.v.info("Getting Manifest...",u.identifier.id);const w=await this.t.getManifest(u,k.CancellationToken.None);if(w===null)throw new v.ExtensionManagementError(`Missing manifest for extension ${n.identifier.id}`,v.ExtensionManagementErrorCode.Invalid);if(w.version!==u.version)throw new v.ExtensionManagementError(`Cannot install '${n.identifier.id}' extension because of version mismatch in Marketplace`,v.ExtensionManagementErrorCode.Invalid);return{extension:u,manifest:w}}async H(n,s,a){const o=await this.getTargetPlatform();let u=null;return!s&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==a&&(u=(await this.t.getExtensions([{...n.identifier,preRelease:a}],{targetPlatform:o,compatible:!0},k.CancellationToken.None))[0]||null),!u&&await this.t.isExtensionCompatible(n,a,o)&&(u=n),u||(s?u=(await this.t.getExtensions([{...n.identifier,version:n.version}],{targetPlatform:o,compatible:!0},k.CancellationToken.None))[0]||null:u=await this.t.getCompatibleExtension(n,a,o)),u}async I(n,s){const a={...s,profileLocation:n.isApplicationScoped?this.y.defaultProfile.extensionsResource:s.profileLocation??this.P()},o=X=>`${X.id.toLowerCase()}${a.versionOnly?`-${n.manifest.version}`:""}${a.profileLocation?`@${a.profileLocation.toString()}`:""}`,u=this.k.get(o(n.identifier));if(u)return this.v.info("Extensions is already requested to uninstall",n.identifier.id),u.waitUntilTaskIsFinished();const w=X=>{const ee=this.R(X,a);return this.k.set(o(ee.extension.identifier),ee),a.profileLocation?this.v.info("Uninstalling extension from the profile:",`${X.identifier.id}@${X.manifest.version}`,a.profileLocation.toString()):this.v.info("Uninstalling extension:",`${X.identifier.id}@${X.manifest.version}`),this.n.fire({identifier:X.identifier,profileLocation:a.profileLocation,applicationScoped:X.isApplicationScoped}),ee},A=(X,ee)=>{ee?a.profileLocation?this.v.error("Failed to uninstall extension from the profile:",`${X.identifier.id}@${X.manifest.version}`,a.profileLocation.toString(),ee.message):this.v.error("Failed to uninstall extension:",`${X.identifier.id}@${X.manifest.version}`,ee.message):a.profileLocation?this.v.info("Successfully uninstalled extension from the profile",`${X.identifier.id}@${X.manifest.version}`,a.profileLocation.toString()):this.v.info("Successfully uninstalled extension:",`${X.identifier.id}@${X.manifest.version}`),t(this.u,"extensionGallery:uninstall",{extensionData:(0,g.getLocalExtensionTelemetryData)(X),error:ee}),this.p.fire({identifier:X.identifier,error:ee?.code,profileLocation:a.profileLocation,applicationScoped:X.isApplicationScoped})},$=[],Z=[];try{$.push(w(n));const X=await this.getInstalled(1,a.profileLocation);if(a.donotIncludePack)this.v.info("Uninstalling the extension without including packed extension",`${n.identifier.id}@${n.manifest.version}`);else{const ee=this.M(n,X);for(const ie of ee)this.k.has(o(ie.identifier))?this.v.info("Extensions is already requested to uninstall",ie.identifier.id):$.push(w(ie))}a.donotCheckDependents?this.v.info("Uninstalling the extension without checking dependents",`${n.identifier.id}@${n.manifest.version}`):this.J($.map(ee=>ee.extension),X,n),await this.D($.map(async ee=>{try{if(await ee.run(),await this.D(this.s.map(ie=>ie.postUninstall(ee.extension,a,k.CancellationToken.None))),ee.extension.identifier.uuid)try{await this.t.reportStatistic(ee.extension.manifest.publisher,ee.extension.manifest.name,ee.extension.manifest.version,"uninstall")}catch{}A(ee.extension)}catch(ie){const ne=ie instanceof v.ExtensionManagementError?ie:new v.ExtensionManagementError((0,D.getErrorMessage)(ie),v.ExtensionManagementErrorCode.Internal);throw A(ee.extension,ne),ne}finally{Z.push(ee)}}))}catch(X){const ee=X instanceof v.ExtensionManagementError?X:new v.ExtensionManagementError((0,D.getErrorMessage)(X),v.ExtensionManagementErrorCode.Internal);for(const ie of $){try{ie.cancel()}catch{}Z.includes(ie)||A(ie.extension,ee)}throw ee}finally{for(const X of $)this.k.delete(o(X.extension.identifier))||this.v.warn("Uninstallation task is not found in the cache",X.extension.identifier.id)}}J(n,s,a){for(const o of n){const u=this.N(o,s);if(u.length){const w=u.filter(A=>!n.some($=>(0,g.areSameExtensions)($.identifier,A.identifier)));if(w.length)throw new Error(this.L(o,w,a))}}}L(n,s,a){return a===n?s.length===1?p.localize(6,null,a.manifest.displayName||a.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?p.localize(7,null,a.manifest.displayName||a.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):p.localize(8,null,a.manifest.displayName||a.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):s.length===1?p.localize(9,null,a.manifest.displayName||a.manifest.name,n.manifest.displayName||n.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?p.localize(10,null,a.manifest.displayName||a.manifest.name,n.manifest.displayName||n.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):p.localize(11,null,a.manifest.displayName||a.manifest.name,n.manifest.displayName||n.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name)}M(n,s,a=[]){if(a.indexOf(n)!==-1)return[];a.push(n);const o=n.manifest.extensionPack?n.manifest.extensionPack:[];if(o.length){const u=s.filter(A=>!A.isBuiltin&&o.some($=>(0,g.areSameExtensions)({id:$},A.identifier))),w=[];for(const A of u)w.push(...this.M(A,s,a));return[...u,...w]}return[]}N(n,s){return s.filter(a=>a.manifest.extensionDependencies&&a.manifest.extensionDependencies.some(o=>(0,g.areSameExtensions)({id:o},n.identifier)))}async O(){try{this.v.trace("ExtensionManagementService.refreshReportedCache");const n=await this.t.getExtensionsControlManifest();return this.v.trace("ExtensionManagementService.refreshControlCache",n),n}catch{return this.v.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};S=de([_(0,v.IExtensionGalleryService),_(1,d.ITelemetryService),_(2,E.ILogService),_(3,L.IProductService),_(4,l.IUserDataProfilesService)],S),e.AbstractExtensionManagementService=S;function h(i){const n=Array.isArray(i)?i:[i];return n.length===1?n[0]instanceof Error?n[0]:new Error(n[0]):n.reduce((s,a)=>new Error(`${s.message}${s.message?",":""}${a instanceof Error?a.message:a}`),new Error(""))}e.joinErrors=h;function y(i){if(i instanceof v.ExtensionManagementError)return i;const n=new v.ExtensionManagementError(i.message,v.ExtensionManagementErrorCode.Internal);return n.stack=i.stack,n}function t(i,n,{extensionData:s,verificationStatus:a,duration:o,error:u,durationSinceUpdate:w}){let A,$;u&&(u instanceof v.ExtensionManagementError?(A=u.code,u.code===v.ExtensionManagementErrorCode.Signature&&($=u.message)):A=v.ExtensionManagementErrorCode.Internal),i.publicLog(n,{...s,verificationStatus:a,success:!u,duration:o,errorcode:A,errorcodeDetail:$,durationSinceUpdate:w})}e.reportTelemetry=t;class r{constructor(){this.d=new O.Barrier}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,O.createCancelablePromise)(n=>this.h(n))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,O.createCancelablePromise)(n=>new Promise((s,a)=>{const o=n.onCancellationRequested(()=>{o.dispose(),a(new D.CancellationError)})})),this.d.open()),this.g.cancel()}}e.AbstractExtensionTask=r}),define(Y[40],Q([0,1,5,15,2,3,36,11,26,29,13,9,10,22,27,4,6,25]),function(x,e,T,O,k,D,N,b,f,c,p,v,g,I,E,L,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var m;(function(r){r.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",r.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(m=e.ExtensionsProfileScanningErrorCode||(e.ExtensionsProfileScanningErrorCode={}));class S extends Error{constructor(i,n){super(i),this.code=n}}e.ExtensionsProfileScanningError=S,e.IExtensionsProfileScannerService=(0,v.createDecorator)("IExtensionsProfileScannerService");let h=class extends k.Disposable{constructor(i,n,s,a,o,u){super(),this.h=i,this.i=n,this.j=s,this.k=a,this.l=o,this.m=u,this.a=this.B(new D.Emitter),this.onAddExtensions=this.a.event,this.b=this.B(new D.Emitter),this.onDidAddExtensions=this.b.event,this.c=this.B(new D.Emitter),this.onRemoveExtensions=this.c.event,this.f=this.B(new D.Emitter),this.onDidRemoveExtensions=this.f.event,this.g=new N.ResourceMap}scanProfileExtensions(i,n){return this.n(i,void 0,n)}async addExtensionsToProfile(i,n){const s=[],a=[];try{return await this.n(n,o=>{const u=[];for(const w of o)i.some(([A])=>(0,f.areSameExtensions)(A.identifier,w.identifier)&&A.manifest.version!==w.version)?s.push(w):u.push(w);for(const[w,A]of i)if(!u.some($=>(0,f.areSameExtensions)($.identifier,w.identifier)&&$.version===w.manifest.version)){const $={identifier:w.identifier,version:w.manifest.version,location:w.location,metadata:A};a.push($),u.push($)}return a.length&&this.a.fire({extensions:a,profileLocation:n}),s.length&&this.c.fire({extensions:s,profileLocation:n}),u}),a.length&&this.b.fire({extensions:a,profileLocation:n}),s.length&&this.f.fire({extensions:s,profileLocation:n}),a}catch(o){throw a.length&&this.b.fire({extensions:a,error:o,profileLocation:n}),s.length&&this.f.fire({extensions:s,error:o,profileLocation:n}),o}}async removeExtensionFromProfile(i,n){const s=[];this.c.fire({extensions:s,profileLocation:n});try{await this.n(n,a=>{const o=[];for(const u of a)(0,f.areSameExtensions)(u.identifier,i.identifier)?s.push(u):o.push(u);return s.length&&this.c.fire({extensions:s,profileLocation:n}),o}),s.length&&this.f.fire({extensions:s,profileLocation:n})}catch(a){throw s.length&&this.f.fire({extensions:s,error:a,profileLocation:n}),a}}async n(i,n,s){return this.v(i).queue(async()=>{let a=[],o;try{const u=await this.i.readFile(i);o=JSON.parse(u.value.toString())}catch(u){if((0,p.toFileOperationResult)(u)!==1)throw u;if(this.k.extUri.isEqual(i,this.j.defaultProfile.extensionsResource)&&(o=await this.u()),!o&&s?.bailOutWhenFileNotFound)throw new S((0,d.getErrorMessage)(u),"ERROR_PROFILE_NOT_FOUND")}if(o){Array.isArray(o)||this.p(i);let u=!1;for(const w of o){y(w)||this.p(i);let A;if((0,L.isString)(w.location))A=this.s(w.location);else{A=b.URI.revive(w.location);const $=this.r(A);$&&(u=!0,w.location=$)}a.push({identifier:w.identifier,location:A,version:w.version,metadata:w.metadata})}u&&await this.i.writeFile(i,O.VSBuffer.fromString(JSON.stringify(o)))}if(n){a=n(a);const u=a.map(w=>({identifier:w.identifier,version:w.version,location:this.r(w.location)??w.location.toJSON(),metadata:w.metadata}));await this.i.writeFile(i,O.VSBuffer.fromString(JSON.stringify(u)))}return a})}p(i){const n=new S(`Invalid extensions content in ${i.toString()}`,"ERROR_INVALID_CONTENT");throw this.l.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}r(i){return this.k.extUri.isEqualOrParent(i,this.h)?this.k.extUri.relativePath(this.h,i):void 0}s(i){return this.k.extUri.joinPath(this.h,i)}async u(){return this.t||(this.t=(async()=>{const i=this.k.extUri.joinPath(this.j.defaultProfile.location,"extensions.json");let n;try{n=(await this.i.readFile(i)).value.toString()}catch(a){if((0,p.toFileOperationResult)(a)===1)return;throw a}this.m.info("Migrating extensions from old default profile location",i.toString());let s;try{const a=JSON.parse(n);Array.isArray(a)&&a.every(o=>y(o))?s=a:this.m.warn("Skipping migrating from old default profile locaiton: Found invalid data",a)}catch(a){this.m.error(a)}if(s)try{await this.i.createFile(this.j.defaultProfile.extensionsResource,O.VSBuffer.fromString(JSON.stringify(s)),{overwrite:!1}),this.m.info("Migrated extensions from old default profile location to new location",i.toString(),this.j.defaultProfile.extensionsResource.toString())}catch(a){if((0,p.toFileOperationResult)(a)===3)this.m.info("Migration from old default profile location to new location is done by another window",i.toString(),this.j.defaultProfile.extensionsResource.toString());else throw a}try{await this.i.del(i)}catch(a){(0,p.toFileOperationResult)(a)!==1&&this.m.error(a)}return s})()),this.t}v(i){let n=this.g.get(i);return n||(n=new T.Queue,this.g.set(i,n)),n}};h=de([_(1,p.IFileService),_(2,I.IUserDataProfilesService),_(3,E.IUriIdentityService),_(4,l.ITelemetryService),_(5,g.ILogService)],h),e.AbstractExtensionsProfileScannerService=h;function y(r){return(0,L.isObject)(r)&&(0,c.isIExtensionIdentifier)(r.identifier)&&(t(r.location)||(0,L.isString)(r.location))&&r.version&&(0,L.isString)(r.version)}function t(r){return r?(0,L.isString)(r.path)&&(0,L.isString)(r.scheme):!1}}),define(Y[48],Q([0,1,19,5,30,15,6,50,78,2,16,14,12,18,41,53,4,11,91,17,26,29,45,13,9,10,28,3,44,40,22,27,107,108]),function(x,e,T,O,k,D,N,b,f,c,p,v,g,I,E,L,d,l,m,S,h,y,t,r,i,n,s,a,o,u,w,A,$,Z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var X;(function(me){function z(j,M){if(j===M)return!0;const B=Object.keys(j),W=new Set;for(const q of Object.keys(M))W.add(q);if(B.length!==W.size)return!1;for(const q of B){if(j[q]!==M[q])return!1;W.delete(q)}return W.size===0}me.equals=z})(X=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let ee=class extends c.Disposable{constructor(z,j,M,B,W,q,K,R,P,C,F,V){super(),this.systemExtensionsLocation=z,this.userExtensionsLocation=j,this.l=M,this.m=B,this.n=W,this.p=q,this.r=K,this.s=R,this.t=P,this.u=C,this.v=F,this.w=V,this.g=this.B(new a.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,I.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.w.createInstance(ae,(0,I.joinPath)(this.m,y.BUILTIN_MANIFEST_CACHE_FILE),this.h)),this.j=this.B(this.w.createInstance(ae,(0,I.joinPath)(this.m,y.USER_MANIFEST_CACHE_FILE),this.h)),this.k=this.B(this.w.createInstance(ne,this.h)),this.z=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.y||(this.y=(0,h.computeTargetPlatform)(this.r,this.s)),this.y}async scanAllExtensions(z,j,M){const[B,W]=await Promise.all([this.scanSystemExtensions(z),this.scanUserExtensions(j)]),q=M?await this.scanExtensionsUnderDevelopment(z,[...B,...W]):[];return this.F(B,W,q,await this.getTargetPlatform(),!0)}async scanSystemExtensions(z){const j=[];j.push(this.G(!!z.useCache,z.language)),j.push(this.H(z.language,!!z.checkControlFile));const[M,B]=await Promise.all(j);return this.D([...M,...B],0,z,!1)}async scanUserExtensions(z){const j=z.profileLocation??this.userExtensionsLocation;this.s.trace("Started scanning user extensions",j);const M=this.v.extUri.isEqual(z.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,B=await this.J(j,!!z.profileLocation,1,!z.includeUninstalled,z.language,!0,M),W=z.useCache&&!B.devMode&&B.excludeObsolete?this.j:this.k;let q;try{q=await W.scanExtensions(B)}catch(K){if(K instanceof u.ExtensionsProfileScanningError&&K.code==="ERROR_PROFILE_NOT_FOUND")await this.C(),q=await W.scanExtensions(B);else throw K}return q=await this.D(q,1,z,!0),this.s.trace("Scanned user extensions:",q.length),q}async scanExtensionsUnderDevelopment(z,j){if(this.t.isExtensionDevelopment&&this.t.extensionDevelopmentLocationURI){const M=(await Promise.all(this.t.extensionDevelopmentLocationURI.filter(B=>B.scheme===p.Schemas.file).map(async B=>{const W=await this.J(B,!1,1,!0,z.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(W)).map(K=>(K.type=j.find(R=>(0,h.areSameExtensions)(R.identifier,K.identifier))?.type??K.type,this.k.validate(K,W)))}))).flat();return this.D(M,"development",z,!0)}return[]}async scanExistingExtension(z,j,M){const B=await this.J(z,!1,j,!0,M.language,!0,void 0),W=await this.k.scanExtension(B);return!W||!M.includeInvalid&&!W.isValid?null:W}async scanOneOrMultipleExtensions(z,j,M){const B=await this.J(z,!1,j,!0,M.language,!0,void 0),W=await this.k.scanOneOrMultipleExtensions(B);return this.D(W,j,M,!0)}async scanMetadata(z){const j=(0,I.joinPath)(z,"package.json"),M=(await this.r.readFile(j)).value.toString();return JSON.parse(M).__metadata}async updateMetadata(z,j){const M=(0,I.joinPath)(z,"package.json"),B=(await this.r.readFile(M)).value.toString(),W=JSON.parse(B);j.isMachineScoped=j.isMachineScoped||void 0,j.isBuiltin=j.isBuiltin||void 0,j.installedTimestamp=j.installedTimestamp||void 0,W.__metadata={...W.__metadata,...j},await this.r.writeFile((0,I.joinPath)(z,"package.json"),D.VSBuffer.fromString(JSON.stringify(W,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.p.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(z){if(z instanceof u.ExtensionsProfileScanningError&&z.code==="ERROR_PROFILE_NOT_FOUND")await this.C();else throw z}}async C(){return this.z||(this.z=(async()=>{try{this.s.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const z=await this.scanUserExtensions({includeInvalid:!0});if(z.length)await this.p.addExtensionsToProfile(z.map(j=>[j,j.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.r.createFile(this.n.defaultProfile.extensionsResource,D.VSBuffer.fromString(JSON.stringify([])))}catch(j){(0,r.toFileOperationResult)(j)!==1&&this.s.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,N.getErrorMessage)(j))}this.s.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(z){this.s.error(z)}finally{this.z=void 0}})()),this.z}async D(z,j,M,B){return M.includeAllVersions||(z=this.F(j===0?z:void 0,j===1?z:void 0,j==="development"?z:void 0,await this.getTargetPlatform(),B)),M.includeInvalid||(z=z.filter(W=>W.isValid)),z.sort((W,q)=>{const K=v.basename(W.location.fsPath),R=v.basename(q.location.fsPath);return K<R?-1:K>R?1:0})}F(z,j,M,B,W){const q=(R,P,C)=>{if(R.isValid&&!P.isValid)return!1;if(R.isValid===P.isValid){if(W&&E.gt(R.manifest.version,P.manifest.version))return this.s.debug(`Skipping extension ${P.location.path} with lower version ${P.manifest.version} in favour of ${R.location.path} with version ${R.manifest.version}`),!1;if(E.eq(R.manifest.version,P.manifest.version)){if(R.type===0)return this.s.debug(`Skipping extension ${P.location.path} in favour of system extension ${R.location.path} with same version`),!1;if(R.targetPlatform===B)return this.s.debug(`Skipping extension ${P.location.path} from different target platform ${P.targetPlatform}`),!1}}return C?this.s.warn(`Overwriting user extension ${R.location.path} with ${P.location.path}.`):this.s.debug(`Overwriting user extension ${R.location.path} with ${P.location.path}.`),!0},K=new Map;return z?.forEach(R=>{const P=y.ExtensionIdentifier.toKey(R.identifier.id),C=K.get(P);(!C||q(C,R,!1))&&K.set(P,R)}),j?.forEach(R=>{const P=y.ExtensionIdentifier.toKey(R.identifier.id),C=K.get(P);if(!C&&z&&R.type===0){this.s.debug(`Skipping obsolete system extension ${R.location.path}.`);return}(!C||q(C,R,!1))&&K.set(P,R)}),M?.forEach(R=>{const P=y.ExtensionIdentifier.toKey(R.identifier.id),C=K.get(P);(!C||q(C,R,!0))&&K.set(P,R),K.set(P,R)}),[...K.values()]}async G(z,j){this.s.trace("Started scanning system extensions");const M=await this.J(this.systemExtensionsLocation,!1,0,!0,j,!0,void 0),W=await(z&&!M.devMode?this.i:this.k).scanExtensions(M);return this.s.trace("Scanned system extensions:",W.length),W}async H(z,j){const M=this.t.isBuilt?[]:this.u.builtInExtensions;if(!M?.length)return[];this.s.trace("Started scanning dev system extensions");const B=j?await this.I():{},W=[],q=l.URI.file(v.normalize(v.join(p.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const R of M){const P=B[R.name]||"marketplace";switch(P){case"disabled":break;case"marketplace":W.push((0,I.joinPath)(q,R.name));break;default:W.push(l.URI.file(P));break}}const K=await Promise.all(W.map(async R=>this.k.scanExtension(await this.J(R,!1,0,!0,z,!0,void 0))));return this.s.trace("Scanned dev system extensions:",K.length),(0,T.coalesce)(K)}async I(){try{const z=await this.r.readFile(this.l);return JSON.parse(z.value.toString())}catch{return{}}}async J(z,j,M,B,W,q,K){const R=await this.f(W??g.language),P=await this.L(z),C=j&&!this.v.extUri.isEqual(z,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,F=C?await this.L(C):void 0;return new ie(z,P,C,F,j,K,M,B,q,this.u.version,this.u.date,this.u.commit,!this.t.isBuilt,W,R)}async L(z){try{const j=await this.r.stat(z);if(typeof j.mtime=="number")return j.mtime}catch{}}};ee=de([_(4,w.IUserDataProfilesService),_(5,u.IExtensionsProfileScannerService),_(6,r.IFileService),_(7,n.ILogService),_(8,S.IEnvironmentService),_(9,s.IProductService),_(10,A.IUriIdentityService),_(11,i.IInstantiationService)],ee),e.AbstractExtensionsScannerService=ee;class ie{constructor(z,j,M,B,W,q,K,R,P,C,F,V,G,te,oe){this.location=z,this.mtime=j,this.applicationExtensionslocation=M,this.applicationExtensionslocationMtime=B,this.profile=W,this.profileScanOptions=q,this.type=K,this.excludeObsolete=R,this.validate=P,this.productVersion=C,this.productDate=F,this.productCommit=V,this.devMode=G,this.language=te,this.translations=oe}static createNlsConfiguration(z){return{language:z.language,pseudo:z.language==="pseudo",devMode:z.devMode,translations:z.translations}}static equals(z,j){return(0,I.isEqual)(z.location,j.location)&&z.mtime===j.mtime&&(0,I.isEqual)(z.applicationExtensionslocation,j.applicationExtensionslocation)&&z.applicationExtensionslocationMtime===j.applicationExtensionslocationMtime&&z.profile===j.profile&&k.equals(z.profileScanOptions,j.profileScanOptions)&&z.type===j.type&&z.excludeObsolete===j.excludeObsolete&&z.validate===j.validate&&z.productVersion===j.productVersion&&z.productDate===j.productDate&&z.productCommit===j.productCommit&&z.devMode===j.devMode&&z.language===j.language&&X.equals(z.translations,j.translations)}}e.ExtensionScannerInput=ie;let ne=class extends c.Disposable{constructor(z,j,M,B,W){super(),this.f=z,this.g=j,this.h=M,this.i=B,this.j=W}async scanExtensions(z){const j=z.profile?await this.l(z):await this.k(z);let M={};if(z.excludeObsolete&&z.type===1)try{const B=(await this.i.readFile(this.f)).value.toString();M=JSON.parse(B)}catch{}return(0,d.isEmptyObject)(M)?j:j.filter(B=>!M[h.ExtensionKey.create(B).toString()])}async k(z){const j=await this.i.resolve(z.location);if(!j.children?.length)return[];const M=await Promise.all(j.children.map(async B=>{if(!B.isDirectory||z.type===1&&(0,I.basename)(B.resource).indexOf(".")===0)return null;const W=new ie(B.resource,z.mtime,z.applicationExtensionslocation,z.applicationExtensionslocationMtime,z.profile,z.profileScanOptions,z.type,z.excludeObsolete,z.validate,z.productVersion,z.productDate,z.productCommit,z.devMode,z.language,z.translations);return this.scanExtension(W)}));return(0,T.coalesce)(M).sort((B,W)=>B.location.path<W.location.path?-1:1)}async l(z){let j=await this.m(z.location,()=>!0,z);if(z.applicationExtensionslocation&&!this.h.extUri.isEqual(z.location,z.applicationExtensionslocation)){j=j.filter(B=>!B.metadata?.isApplicationScoped);const M=await this.m(z.applicationExtensionslocation,B=>!!B.metadata?.isApplicationScoped,z);j.push(...M)}return j}async m(z,j,M){const B=await this.g.scanProfileExtensions(z,M.profileScanOptions);if(!B.length)return[];const W=await Promise.all(B.map(async q=>{if(j(q)){const K=new ie(q.location,M.mtime,M.applicationExtensionslocation,M.applicationExtensionslocationMtime,M.profile,M.profileScanOptions,M.type,M.excludeObsolete,M.validate,M.productVersion,M.productDate,M.productCommit,M.devMode,M.language,M.translations);return this.scanExtension(K,q.metadata)}return null}));return(0,T.coalesce)(W)}async scanOneOrMultipleExtensions(z){try{if(await this.i.exists((0,I.joinPath)(z.location,"package.json"))){const j=await this.scanExtension(z);return j?[j]:[]}else return await this.scanExtensions(z)}catch(j){return this.j.error(`Error scanning extensions at ${z.location.path}:`,(0,N.getErrorMessage)(j)),[]}}async scanExtension(z,j){try{let M=await this.scanExtensionManifest(z.location);if(M){M.publisher||(M.publisher=y.UNDEFINED_PUBLISHER),j=j??M.__metadata,delete M.__metadata;const B=(0,h.getGalleryExtensionId)(M.publisher,M.name),W=j?.id?{id:B,uuid:j.id}:{id:B},q=j?.isSystem?0:z.type,K=q===0||!!j?.isBuiltin;Z.ImplicitActivationEvents.updateManifest(M),M=await this.n(z.location,M,ie.createNlsConfiguration(z));const R={type:q,identifier:W,manifest:M,location:z.location,isBuiltin:K,targetPlatform:j?.targetPlatform??"undefined",metadata:j,isValid:!0,validations:[]};return z.validate?this.validate(R,z):R}}catch(M){z.type!==0&&this.j.error(M)}return null}validate(z,j){let M=!0;const B=(0,t.validateExtensionManifest)(j.productVersion,j.productDate,j.location,z.manifest,z.isBuiltin);for(const[W,q]of B)W===L.default.Error&&(M=!1,this.j.error(this.t(j.location,q)));return z.isValid=M,z.validations=B,z}async scanExtensionManifest(z){const j=(0,I.joinPath)(z,"package.json");let M;try{M=(await this.i.readFile(j)).value.toString()}catch(W){return(0,r.toFileOperationResult)(W)!==1&&this.j.error(this.t(z,(0,m.localize)(0,null,j.path,W.message))),null}let B;try{B=JSON.parse(M)}catch{const q=[];(0,b.parse)(M,q);for(const K of q)this.j.error(this.t(z,(0,m.localize)(1,null,j.path,K.offset,K.length,(0,f.getParseErrorMessage)(K.error))));return null}return(0,b.getNodeType)(B)!=="object"?(this.j.error(this.t(z,(0,m.localize)(2,null,j.path))),null):B}async n(z,j,M){const B=await this.p(z,j,M);if(B)try{const W=[],q=await this.r(B.default,W);if(W.length>0)return W.forEach(R=>{this.j.error(this.t(z,(0,m.localize)(3,null,B.default?.path,(0,f.getParseErrorMessage)(R.error))))}),j;if((0,b.getNodeType)(B)!=="object")return this.j.error(this.t(z,(0,m.localize)(4,null,B.default?.path))),j;const K=B.values||Object.create(null);return(0,$.localizeManifest)(j,K,q)}catch{}return j}async p(z,j,M){const B=(0,I.joinPath)(z,"package.nls.json"),W=(P,C)=>{C.forEach(F=>{this.j.error(this.t(z,(0,m.localize)(5,null,P?.path,(0,f.getParseErrorMessage)(F.error))))})},q=P=>{this.j.error(this.t(z,(0,m.localize)(6,null,P?.path)))},K=`${j.publisher}.${j.name}`,R=M.translations[K];if(R)try{const P=l.URI.file(R),C=(await this.i.readFile(P)).value.toString(),F=[],V=(0,b.parse)(C,F);return F.length>0?(W(P,F),{values:void 0,default:B}):(0,b.getNodeType)(V)!=="object"?(q(P),{values:void 0,default:B}):{values:V.contents?V.contents.package:void 0,default:B}}catch{return{values:void 0,default:B}}else{if(!await this.i.exists(B))return;let C;try{C=await this.s(z,M)}catch{return}if(!C.localized)return{values:void 0,default:C.original};try{const F=(await this.i.readFile(C.localized)).value.toString(),V=[],G=(0,b.parse)(F,V);return V.length>0?(W(C.localized,V),{values:void 0,default:C.original}):(0,b.getNodeType)(G)!=="object"?(q(C.localized),{values:void 0,default:C.original}):{values:G,default:C.original}}catch{return{values:void 0,default:C.original}}}}async r(z,j){if(z)try{const M=(await this.i.readFile(z)).value.toString();return(0,b.parse)(M,j)}catch{}}s(z,j){return new Promise((M,B)=>{const W=q=>{const K=(0,I.joinPath)(z,`package.nls.${q}.json`);this.i.exists(K).then(R=>{R&&M({localized:K,original:(0,I.joinPath)(z,"package.nls.json")});const P=q.lastIndexOf("-");P===-1?M({localized:(0,I.joinPath)(z,"package.nls.json"),original:null}):(q=q.substring(0,P),W(q))})};if(j.devMode||j.pseudo||!j.language)return M({localized:(0,I.joinPath)(z,"package.nls.json"),original:null});W(j.language)})}t(z,j){return`[${z.path}]: ${j}`}};ne=de([_(1,u.IExtensionsProfileScannerService),_(2,A.IUriIdentityService),_(3,r.IFileService),_(4,n.ILogService)],ne);let ae=class extends ne{constructor(z,j,M,B,W,q){super(j,M,B,W,q),this.y=z,this.v=this.B(new O.ThrottledDelayer(3e3)),this.w=this.B(new a.Emitter),this.onDidChangeCache=this.w.event}async scanExtensions(z){const j=await this.z();if(this.u=z,j&&j.input&&ie.equals(j.input,this.u))return this.j.debug("Using cached extensions scan result",z.location.toString()),this.v.trigger(()=>this.D()),j.result.map(B=>(B.location=l.URI.revive(B.location),B));const M=await super.scanExtensions(z);return await this.C({input:z,result:M}),M}async z(){try{const z=await this.i.readFile(this.y),j=JSON.parse(z.value.toString());return{result:j.result,input:(0,o.revive)(j.input)}}catch(z){this.j.debug("Error while reading the extension cache file:",this.y.path,(0,N.getErrorMessage)(z))}return null}async C(z){try{await this.i.writeFile(this.y,D.VSBuffer.fromString(JSON.stringify(z)))}catch(j){this.j.debug("Error while writing the extension cache file:",this.y.path,(0,N.getErrorMessage)(j))}}async D(){if(!this.u)return;const z=await this.z();if(!z)return;const j=z.result,M=JSON.parse(JSON.stringify(await super.scanExtensions(this.u)));if(!k.equals(M,j))try{await this.i.del(this.y),this.w.fire()}catch(B){this.j.error(B)}}};ae=de([_(2,u.IExtensionsProfileScannerService),_(3,A.IUriIdentityService),_(4,r.IFileService),_(5,n.ILogService)],ae);function fe(me,z){const j=(0,h.getExtensionId)(me.manifest.publisher,me.manifest.name);return{id:j,identifier:new y.ExtensionIdentifier(j),isBuiltin:me.type===0,isUserBuiltin:me.type===1&&me.isBuiltin,isUnderDevelopment:z,extensionLocation:me.location,uuid:me.identifier.uuid,targetPlatform:me.targetPlatform,...me.manifest}}e.toExtensionDescription=fe;class re extends ee{constructor(z,j,M,B,W,q,K,R,P,C,F,V){super(z,j,(0,I.joinPath)(M,".vscode-oss-dev","extensions","control.json"),(0,I.joinPath)(B,y.MANIFEST_CACHE_FOLDER),W,q,K,R,P,C,F,V),this.M=(async()=>{if(g.translationsConfigFile)try{const G=await this.r.readFile(l.URI.file(g.translationsConfigFile));return JSON.parse(G.value.toString())}catch{}return Object.create(null)})()}f(z){return this.M}}e.NativeExtensionsScannerService=re}),define(Y[146],Q([0,1,57,5,34,3,2,16,14,20,10,22]),function(x,e,T,O,k,D,N,b,f,c,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let g=class extends N.Disposable{constructor(E,L){super(),this.b=E,this.f=L,this.a=new O.Limiter(5)}async postUninstall(E){const L=this.g(E,"uninstall");return L&&(this.f.info(E.identifier.id,E.manifest.version,"Running post uninstall script"),await this.a.queue(()=>this.h(L.script,"uninstall",L.args,!0,E).then(()=>this.f.info(E.identifier.id,E.manifest.version,"Finished running post uninstall script"),d=>this.f.error(E.identifier.id,E.manifest.version,`Failed to run post uninstall script: ${d}`)))),c.Promises.rm(this.j(E)).then(void 0,d=>this.f.error("Error while removing extension storage path",d))}g(E,L){const d=`vscode:${L}`;if(E.location.scheme===b.Schemas.file&&E.manifest&&E.manifest.scripts&&typeof E.manifest.scripts[d]=="string"){const l=E.manifest.scripts[d].split(" ");return l.length<2||l[0]!=="node"||!l[1]?(this.f.warn(E.identifier.id,E.manifest.version,`${d} should be a node script`),null):{script:(0,f.join)(E.location.fsPath,l[1]),args:l.slice(2)||[]}}return null}h(E,L,d,l,m){return new Promise((S,h)=>{const y=this.i(E,L,d,m);let t;const r=i=>{t&&(clearTimeout(t),t=null),i?h(i):S(void 0)};y.on("error",i=>{r((0,k.toErrorMessage)(i)||"Unknown")}),y.on("exit",(i,n)=>{r(i?`post-${L} process exited with code ${i}`:void 0)}),l&&(t=setTimeout(()=>{t=null,y.kill(),h("timed out")},5e3))})}i(E,L,d,l){const m={silent:!0,execArgv:void 0},S=(0,T.fork)(E,[`--type=extension-post-${L}`,...d],m);S.stdout.setEncoding("utf8"),S.stderr.setEncoding("utf8");const h=D.Event.fromNodeEventEmitter(S.stdout,"data"),y=D.Event.fromNodeEventEmitter(S.stderr,"data");h(i=>this.f.info(l.identifier.id,l.manifest.version,`post-${L}`,i)),y(i=>this.f.error(l.identifier.id,l.manifest.version,`post-${L}`,i));const t=D.Event.any(D.Event.map(h,i=>({data:`%c${i}`,format:[""]})),D.Event.map(y,i=>({data:`%c${i}`,format:["color: red"]})));return D.Event.debounce(t,(i,n)=>i?{data:i.data+n.data,format:[...i.format,...n.format]}:{data:n.data,format:n.format},100)(i=>{console.group(l.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),S}j(E){return(0,f.join)(this.b.defaultProfile.globalStorageHome.fsPath,E.identifier.id.toLowerCase())}};g=de([_(0,v.IUserDataProfilesService),_(1,p.ILogService)],g),e.ExtensionsLifecycle=g}),define(Y[147],Q([0,1,10,22,27,25,40,13,17,11]),function(x,e,T,O,k,D,N,b,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let p=class extends N.AbstractExtensionsProfileScannerService{constructor(g,I,E,L,d,l){super(c.URI.file(g.extensionsPath),I,E,L,d,l)}};p=de([_(0,f.INativeEnvironmentService),_(1,b.IFileService),_(2,O.IUserDataProfilesService),_(3,k.IUriIdentityService),_(4,D.ITelemetryService),_(5,T.ILogService)],p),e.ExtensionsProfileScannerService=p}),define(Y[148],Q([0,1,11,17,40,48,13,9,10,28,27,22]),function(x,e,T,O,k,D,N,b,f,c,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let g=class extends D.NativeExtensionsScannerService{constructor(E,L,d,l,m,S,h,y){super(T.URI.file(m.builtinExtensionsPath),T.URI.file(m.extensionsPath),m.userHome,T.URI.file(m.userDataPath),E,L,d,l,m,S,h,y)}};g=de([_(0,v.IUserDataProfilesService),_(1,k.IExtensionsProfileScannerService),_(2,N.IFileService),_(3,f.ILogService),_(4,O.INativeEnvironmentService),_(5,c.IProductService),_(6,p.IUriIdentityService),_(7,b.IInstantiationService)],g),e.ExtensionsScannerService=g}),define(Y[149],Q([0,1,5,3,2,118,4,84,9,22]),function(x,e,T,O,k,D,N,b,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,f.createDecorator)("storageService");var p;(function(m){m[m.NONE=0]="NONE",m[m.SHUTDOWN=1]="SHUTDOWN"})(p=e.WillSaveStateReason||(e.WillSaveStateReason={}));var v;(function(m){m[m.APPLICATION=-1]="APPLICATION",m[m.PROFILE=0]="PROFILE",m[m.WORKSPACE=1]="WORKSPACE"})(v=e.StorageScope||(e.StorageScope={}));var g;(function(m){m[m.USER=0]="USER",m[m.MACHINE=1]="MACHINE"})(g=e.StorageTarget||(e.StorageTarget={}));function I(m){const S=m.get(e.TARGET_KEY);if(S)try{return JSON.parse(S)}catch{}return Object.create(null)}e.loadKeyTargets=I;class E extends k.Disposable{constructor(S={flushInterval:E.a}){super(),this.j=S,this.b=this.B(new O.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new O.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new O.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new T.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new k.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,T.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,k.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,D.mark)("code/willInitStorage");try{await this.J()}finally{(0,D.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(S,h){if(h===e.TARGET_KEY){switch(S){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:S})}else this.b.fire({scope:S,key:h,target:this.F(S)[h]})}r(S){this.f.fire({reason:S})}get(S,h,y){return this.L(h)?.get(S,y)}getBoolean(S,h,y){return this.L(h)?.getBoolean(S,y)}getNumber(S,h,y){return this.L(h)?.getNumber(S,y)}store(S,h,y,t){if((0,N.isUndefinedOrNull)(h)){this.remove(S,y);return}this.t(()=>{this.u(S,y,t),this.L(y)?.set(S,h)})}remove(S,h){this.t(()=>{this.u(S,h,void 0),this.L(h)?.delete(S)})}t(S){this.b.pause(),this.c.pause();try{S()}finally{this.b.resume(),this.c.resume()}}keys(S,h){const y=[],t=this.F(S);for(const r of Object.keys(t))t[r]===h&&y.push(r);return y}u(S,h,y){const t=this.F(h);typeof y=="number"?t[S]!==y&&(t[S]=y,this.L(h)?.set(e.TARGET_KEY,JSON.stringify(t))):typeof t[S]=="number"&&(delete t[S],this.L(h)?.set(e.TARGET_KEY,JSON.stringify(t)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(S){switch(S){case-1:return this.D;case 0:return this.z;default:return this.w}}G(S){const h=this.L(S);return h?I(h):Object.create(null)}isNew(S){return this.getBoolean(e.IS_NEW_KEY,S)===!0}async flush(S=p.NONE){this.f.fire({reason:S});const h=this.L(-1),y=this.L(0),t=this.L(1);switch(S){case p.NONE:await T.Promises.settled([h?.whenFlushed()??Promise.resolve(),y?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case p.SHUTDOWN:await T.Promises.settled([h?.flush(0)??Promise.resolve(),y?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const S=this.L(-1)?.items??new Map,h=this.L(0)?.items??new Map,y=this.L(1)?.items??new Map;return l(S,h,y,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(S,h){return this.r(p.NONE),(0,c.isUserDataProfile)(S)?this.N(S,h):this.O(S,h)}H(S,h){return!(S.id===h.id||L(h)&&L(S))}I(S,h,y,t){this.t(()=>{if(t)for(const[r,i]of S)h.set(r,i);else{const r=new Set;for(const[i,n]of S)r.add(i),h.get(i)!==n&&this.n(y,i);for(const[i]of h.items)r.has(i)||this.n(y,i)}})}}e.AbstractStorageService=E,E.a=60*1e3;function L(m){return m.isDefault||!!m.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=L;class d extends E{constructor(){super(),this.p=this.B(new b.Storage(new b.InMemoryStorageDatabase,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new b.Storage(new b.InMemoryStorageDatabase,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new b.Storage(new b.InMemoryStorageDatabase,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(S=>this.n(1,S))),this.B(this.P.onDidChangeStorage(S=>this.n(0,S))),this.B(this.p.onDidChangeStorage(S=>this.n(-1,S)))}L(S){switch(S){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(S){switch(S){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(S){return!1}}e.InMemoryStorageService=d;async function l(m,S,h,y,t,r){const i=Z=>{try{return JSON.parse(Z)}catch{return Z}},n=new Map,s=new Map;m.forEach((Z,X)=>{n.set(X,Z),s.set(X,i(Z))});const a=new Map,o=new Map;S.forEach((Z,X)=>{a.set(X,Z),o.set(X,i(Z))});const u=new Map,w=new Map;h.forEach((Z,X)=>{u.set(X,Z),w.set(X,i(Z))}),console.group(y!==t?`Storage: Application (path: ${y})`:`Storage: Application & Profile (path: ${y}, default profile)`);const A=[];if(n.forEach((Z,X)=>{A.push({key:X,value:Z})}),console.table(A),console.groupEnd(),console.log(s),y!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const Z=[];a.forEach((X,ee)=>{Z.push({key:ee,value:X})}),console.table(Z),console.groupEnd(),console.log(o)}console.group(`Storage: Workspace (path: ${r})`);const $=[];u.forEach((Z,X)=>{$.push({key:X,value:Z})}),console.table($),console.groupEnd(),console.log(w)}e.logStorage=l}),define(Y[150],Q([0,1,19,23,6,12,35,4,11,21,17,24,26,45,13,10,28,47,135,149,25]),function(x,e,T,O,k,D,N,b,f,c,p,v,g,I,E,L,d,l,m,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const y=D.isWeb?"web":(0,v.getTargetPlatform)(D.platform,N.arch);var t;(function(R){R[R.None=0]="None",R[R.IncludeVersions=1]="IncludeVersions",R[R.IncludeFiles=2]="IncludeFiles",R[R.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",R[R.IncludeSharedAccounts=8]="IncludeSharedAccounts",R[R.IncludeVersionProperties=16]="IncludeVersionProperties",R[R.ExcludeNonValidated=32]="ExcludeNonValidated",R[R.IncludeInstallationTargets=64]="IncludeInstallationTargets",R[R.IncludeAssetUri=128]="IncludeAssetUri",R[R.IncludeStatistics=256]="IncludeStatistics",R[R.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",R[R.Unpublished=4096]="Unpublished",R[R.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(t||(t={}));function r(...R){return String(R.reduce((P,C)=>P|C,0))}var i;(function(R){R[R.Tag=1]="Tag",R[R.ExtensionId=4]="ExtensionId",R[R.Category=5]="Category",R[R.ExtensionName=7]="ExtensionName",R[R.Target=8]="Target",R[R.Featured=9]="Featured",R[R.SearchText=10]="SearchText",R[R.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const n={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},s={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},o={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:t.None,criteria:[],assetTypes:[]};class u{constructor(P=o){this.d=P}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(P,C=this.d.pageSize){return new u({...this.d,pageNumber:P,pageSize:C})}withFilter(P,...C){const F=[...this.d.criteria,...C.length?C.map(V=>({filterType:P,value:V})):[{filterType:P}]];return new u({...this.d,criteria:F})}withSortBy(P){return new u({...this.d,sortBy:P})}withSortOrder(P){return new u({...this.d,sortOrder:P})}withFlags(...P){return new u({...this.d,flags:P.reduce((C,F)=>C|F,0)})}withAssetTypes(...P){return new u({...this.d,assetTypes:P})}withSource(P){return new u({...this.d,source:P})}get raw(){const{criteria:P,pageNumber:C,pageSize:F,sortBy:V,sortOrder:G,flags:te,assetTypes:oe}=this.d;return{filters:[{criteria:P,pageNumber:C,pageSize:F,sortBy:V,sortOrder:G}],assetTypes:oe,flags:te}}get searchText(){const P=this.d.criteria.filter(C=>C.filterType===i.SearchText)[0];return P&&P.value?P.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(P=>String(P.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function w(R,P){const C=(R||[]).filter(F=>F.statisticName===P)[0];return C?C.value:0}function A(R){const P="Microsoft.VisualStudio.Code.Translation.";return R.files.filter(F=>F.assetType.indexOf(P)===0).reduce((F,V)=>{const G=X(R,V.assetType);return G&&F.push([V.assetType.substring(P.length),G]),F},[])}function $(R){if(R.properties){const P=R.properties.filter(V=>V.key===n.Repository),C=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),F=P.filter(V=>C.test(V.value))[0];return F?{uri:F.value,fallbackUri:F.value}:null}return X(R,n.Repository)}function Z(R){return{uri:`${R.fallbackAssetUri}/${n.VSIX}?redirect=true${R.targetPlatform?`&targetPlatform=${R.targetPlatform}`:""}`,fallbackUri:`${R.fallbackAssetUri}/${n.VSIX}${R.targetPlatform?`?targetPlatform=${R.targetPlatform}`:""}`}}function X(R,P){return R.files.filter(F=>F.assetType===P)[0]?{uri:`${R.assetUri}/${P}${R.targetPlatform?`?targetPlatform=${R.targetPlatform}`:""}`,fallbackUri:`${R.fallbackAssetUri}/${P}${R.targetPlatform?`?targetPlatform=${R.targetPlatform}`:""}`}:null}function ee(R,P){const C=R.properties?R.properties.filter(V=>V.key===P):[],F=C.length>0&&C[0].value;return F?F.split(",").map(V=>(0,g.adoptToGalleryExtensionId)(V)):[]}function ie(R){const P=R.properties?R.properties.filter(C=>C.key===s.Engine):[];return P.length>0&&P[0].value||""}function ne(R){const P=R.properties?R.properties.filter(C=>C.key===s.PreRelease):[];return P.length>0&&P[0].value==="true"}function ae(R){const P=R.properties?R.properties.filter(F=>F.key===s.LocalizedLanguages):[],C=P.length>0&&P[0].value||"";return C?C.split(","):[]}function fe(R){return R.properties?.find(P=>P.key===s.SponsorLink)?.value}function re(R){return R.indexOf("preview")!==-1}function me(R){return R.targetPlatform?(0,v.toTargetPlatform)(R.targetPlatform):"undefined"}function z(R){const P=(0,T.distinct)(R.versions.map(me)),C=!!R.tags?.includes(v.WEB_EXTENSION_TAG),F=P.indexOf("web");return C?F===-1&&P.push("web"):F!==-1&&P.splice(F,1),P}function j(R,P){const C=(0,v.getFallbackTargetPlarforms)(P);for(let F=0;F<R.length;F++){const V=R[F];if(V.version===R[F-1]?.version){let G=F;const te=me(V);if(te===P)for(;G>0&&R[G-1].version===V.version;)G--;else if(C.includes(te))for(;G>0&&R[G-1].version===V.version&&me(R[G-1])!==P;)G--;G!==F&&(R.splice(F,1),R.splice(G,0,V))}}return R}e.sortExtensionVersions=j;function M(R,P,C){R.telemetryData={index:P,querySource:C}}function B(R,P,C){const F=R.versions[0],V={manifest:X(P,n.Manifest),readme:X(P,n.Details),changelog:X(P,n.Changelog),license:X(P,n.License),repository:$(P),download:Z(P),icon:X(P,n.Icon),signature:X(P,n.Signature),coreTranslations:A(P)};return{identifier:{id:(0,g.getGalleryExtensionId)(R.publisher.publisherName,R.extensionName),uuid:R.extensionId},name:R.extensionName,version:P.version,displayName:R.displayName,publisherId:R.publisher.publisherId,publisher:R.publisher.publisherName,publisherDisplayName:R.publisher.displayName,publisherDomain:R.publisher.domain?{link:R.publisher.domain,verified:!!R.publisher.isDomainVerified}:void 0,publisherSponsorLink:fe(F),description:R.shortDescription||"",installCount:w(R.statistics,"install"),rating:w(R.statistics,"averagerating"),ratingCount:w(R.statistics,"ratingcount"),categories:R.categories||[],tags:R.tags||[],releaseDate:Date.parse(R.releaseDate),lastUpdated:Date.parse(R.lastUpdated),allTargetPlatforms:C,assets:V,properties:{dependencies:ee(P,s.Dependency),extensionPack:ee(P,s.ExtensionPack),engine:ie(P),localizedLanguages:ae(P),targetPlatform:me(P),isPreReleaseVersion:ne(P)},hasPreReleaseVersion:ne(F),hasReleaseVersion:!0,preview:re(R.flags),isSigned:!!V.signature}}let W=class{constructor(P,C,F,V,G,te,oe,ge){this.k=C,this.l=F,this.n=V,this.o=G,this.q=te,this.u=oe,this.w=ge;const ve=oe.extensionsGallery,le=ve?.servicePPEUrl&&ge.getValue("_extensionsGallery.enablePPE");this.d=le?ve.servicePPEUrl:ve?.serviceUrl,this.g=le?void 0:ve?.searchUrl,this.h=ve?.controlUrl,this.j=(0,m.resolveMarketplaceHeaders)(oe.version,oe,this.n,this.w,this.q,P,this.o)}x(P=""){return`${this.d}${P}`}isEnabled(){return!!this.d}async getExtensions(P,C,F){const V=O.CancellationToken.isCancellationToken(C)?{}:C,G=O.CancellationToken.isCancellationToken(C)?C:F,te=[],oe=[],ge=[],ve=[];let le=!0;for(const se of P){se.uuid?oe.push(se.uuid):te.push(se.id);const ue=!!(se.version||se.preRelease);ge.push({id:se.id,uuid:se.uuid,includePreRelease:ue}),se.version&&ve.push({id:se.id,uuid:se.uuid,version:se.version}),le=le&&!!se.hasPreRelease&&!ue}if(!oe.length&&!te.length)return[];let ce=new u().withPage(1,P.length);oe.length&&(ce=ce.withFilter(i.ExtensionId,...oe)),te.length&&(ce=ce.withFilter(i.ExtensionName,...te)),(V.queryAllVersions||le)&&(ce=ce.withFlags(ce.flags,t.IncludeVersions)),V.source&&(ce=ce.withSource(V.source));const{extensions:we}=await this.z(ce,{targetPlatform:V.targetPlatform??y,includePreRelease:ge,versions:ve,compatible:!!V.compatible},G);return V.source&&we.forEach((se,ue)=>M(se,ue,V.source)),we}async getCompatibleExtension(P,C,F){if((0,v.isNotWebExtensionInWebTargetPlatform)(P.allTargetPlatforms,F))return null;if(await this.isExtensionCompatible(P,C,F))return P;const V=new u().withFlags(t.IncludeVersions).withPage(1,1).withFilter(i.ExtensionId,P.identifier.uuid),{extensions:G}=await this.z(V,{targetPlatform:F,compatible:!0,includePreRelease:C},O.CancellationToken.None);return G[0]||null}async isExtensionCompatible(P,C,F){if(!(0,v.isTargetPlatformCompatible)(P.properties.targetPlatform,P.allTargetPlatforms,F)||!C&&P.properties.isPreReleaseVersion)return!1;let V=P.properties.engine;if(!V){const G=await this.getManifest(P,O.CancellationToken.None);if(!G)throw new Error("Manifest was not found");V=G.engines.vscode}return(0,I.isEngineValid)(V,this.u.version,this.u.date)}async y(P,C,F,V,G){if(!(0,v.isTargetPlatformCompatible)(me(P),V,G)||C!=="any"&&ne(P)!==(C==="prerelease"))return!1;if(F)try{const te=await this.E(P);if(!(0,I.isEngineValid)(te,this.u.version,this.u.date))return!1}catch(te){return this.l.error(`Error while getting the engine for the version ${P.version}.`,(0,k.getErrorMessage)(te)),!1}return!0}async query(P,C){let F=P.text||"";const V=P.pageSize??50;let G=new u().withPage(1,V);F?(F=F.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(le,ce,we)=>(G=G.withFilter(i.Category,we||ce),"")),F=F.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(le,ce,we)=>(G=G.withFilter(i.Tag,we||ce),"")),F=F.replace(/\bfeatured(\s+|\b|$)/g,()=>(G=G.withFilter(i.Featured),"")),F=F.trim(),F&&(F=F.length<200?F:F.substring(0,200),G=G.withFilter(i.SearchText,F)),G=G.withSortBy(0)):P.ids?G=G.withFilter(i.ExtensionId,...P.ids):P.names?G=G.withFilter(i.ExtensionName,...P.names):G=G.withSortBy(4),typeof P.sortBy=="number"&&(G=G.withSortBy(P.sortBy)),typeof P.sortOrder=="number"&&(G=G.withSortOrder(P.sortOrder)),P.source&&(G=G.withSource(P.source));const te=async(le,ce)=>{const{extensions:we,total:se}=await this.z(le,{targetPlatform:y,compatible:!1,includePreRelease:!!P.includePreRelease},ce);return we.forEach((ue,be)=>M(ue,(le.pageNumber-1)*le.pageSize+be,P.source)),{extensions:we,total:se}},{extensions:oe,total:ge}=await te(G,C),ve=async(le,ce)=>{if(ce.isCancellationRequested)throw new k.CancellationError;const{extensions:we}=await te(G.withPage(le+1),ce);return we};return{firstPage:oe,total:ge,pageSize:G.pageSize,getPage:ve}}async z(P,C,F){const V=P.flags;!!(P.flags&t.IncludeLatestVersionOnly)&&!!(P.flags&t.IncludeVersions)&&(P=P.withFlags(P.flags&~t.IncludeVersions,t.IncludeLatestVersionOnly)),!(P.flags&t.IncludeLatestVersionOnly)&&!(P.flags&t.IncludeVersions)&&(P=P.withFlags(P.flags,t.IncludeLatestVersionOnly)),C.versions?.length&&(P=P.withFlags(P.flags&~t.IncludeLatestVersionOnly,t.IncludeVersions)),P=P.withFlags(P.flags,t.IncludeAssetUri,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeStatistics,t.IncludeVersionProperties);const{galleryExtensions:G,total:te}=await this.B(P,F);if(!(P.flags&t.IncludeLatestVersionOnly)){const le=[];for(const ce of G){const we=await this.A(ce,C);we&&le.push(we)}return{extensions:le,total:te}}const ge=[],ve=new Map;for(let le=0;le<G.length;le++){const ce=G[le],we={id:(0,g.getGalleryExtensionId)(ce.publisher.publisherName,ce.extensionName),uuid:ce.extensionId},se=(0,b.isBoolean)(C.includePreRelease)?C.includePreRelease:!!C.includePreRelease.find(be=>(0,g.areSameExtensions)(be,we))?.includePreRelease;if(C.compatible&&(0,v.isNotWebExtensionInWebTargetPlatform)(z(ce),C.targetPlatform))continue;const ue=await this.A(ce,C);!ue||ue.properties.isPreReleaseVersion&&(!se||!ue.hasReleaseVersion)||!ue.properties.isPreReleaseVersion&&ue.properties.targetPlatform!==C.targetPlatform&&ue.hasPreReleaseVersion?ve.set(ce.extensionId,le):ge.push([le,ue])}if(ve.size){const le=new Date().getTime(),ce=new u().withFlags(V&~t.IncludeLatestVersionOnly,t.IncludeVersions).withPage(1,ve.size).withFilter(i.ExtensionId,...ve.keys()),{extensions:we}=await this.z(ce,C,F);this.o.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-le,count:ve.size});for(const se of we){const ue=ve.get(se.identifier.uuid);ge.push([ue,se])}}return{extensions:ge.sort((le,ce)=>le[0]-ce[0]).map(([,le])=>le),total:te}}async A(P,C){const F={id:(0,g.getGalleryExtensionId)(P.publisher.publisherName,P.extensionName),uuid:P.extensionId},V=C.versions?.find(ge=>(0,g.areSameExtensions)(ge,F))?.version,G=(0,b.isBoolean)(C.includePreRelease)?C.includePreRelease:!!C.includePreRelease.find(ge=>(0,g.areSameExtensions)(ge,F))?.includePreRelease,te=z(P),oe=j(P.versions,C.targetPlatform);if(C.compatible&&(0,v.isNotWebExtensionInWebTargetPlatform)(te,C.targetPlatform))return null;for(let ge=0;ge<oe.length;ge++){const ve=oe[ge];if(!(V&&ve.version!==V)){if(await this.y(ve,G?"any":"release",C.compatible,te,C.targetPlatform))return B(P,ve,te);if(V&&ve.version===V)return null}}return V||C.compatible?null:B(P,P.versions[0],te)}async B(P,C){if(!this.isEnabled())throw new Error("No extension gallery service configured.");P=P.withFlags(P.flags,t.ExcludeNonValidated).withFilter(i.Target,"Microsoft.VisualStudio.Code").withFilter(i.ExcludeWithFlags,r(t.Unpublished));const F=await this.j,V=JSON.stringify(P.raw),G={...F,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(V.length)},te=new Date().getTime();let oe,ge,ve=0;try{if(oe=await this.k.request({type:"POST",url:this.g&&P.criteria.some(ce=>ce.filterType===i.SearchText)?this.g:this.x("/extensionquery"),data:V,headers:G},C),oe.res.statusCode&&oe.res.statusCode>=400&&oe.res.statusCode<500)return{galleryExtensions:[],total:ve};const le=await(0,l.asJson)(oe);if(le){const ce=le.results[0],we=ce.extensions,se=ce.resultMetadata&&ce.resultMetadata.filter(ue=>ue.metadataType==="ResultCount")[0];return ve=se&&se.metadataItems.filter(ue=>ue.name==="TotalCount")[0].count||0,{galleryExtensions:we,total:ve}}return{galleryExtensions:[],total:ve}}catch(le){throw ge=le,le}finally{this.o.publicLog2("galleryService:query",{...P.telemetryData,requestBodySize:String(V.length),duration:new Date().getTime()-te,success:!!oe&&(0,l.isSuccess)(oe),responseBodySize:oe?.res.headers["Content-Length"],statusCode:oe?String(oe.res.statusCode):void 0,errorCode:ge?(0,k.isCancellationError)(ge)?"canceled":(0,k.getErrorMessage)(ge).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ve)})}}async reportStatistic(P,C,F,V){if(!this.isEnabled())return;const G=D.isWeb?this.x(`/itemName/${P}.${C}/version/${F}/statType/${V==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${P}/extensions/${C}/${F}/stats?statType=${V}`),te=D.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ge={...await this.j,Accept:te};try{await this.k.request({type:"POST",url:G,headers:ge},O.CancellationToken.None)}catch{}}async download(P,C,F){this.l.trace("ExtensionGalleryService#download",P.identifier.id);const V=(0,g.getGalleryExtensionTelemetryData)(P),G=new Date().getTime(),te=le=>this.o.publicLog("galleryService:downloadVSIX",{...V,duration:le}),oe=F===2?"install":F===3?"update":"",ge=oe?{uri:`${P.assets.download.uri}${f.URI.parse(P.assets.download.uri).query?"&":"?"}${oe}=true`,fallbackUri:`${P.assets.download.fallbackUri}${f.URI.parse(P.assets.download.fallbackUri).query?"&":"?"}${oe}=true`}:P.assets.download,ve=await this.D(ge);await this.q.writeFile(C,ve.stream),te(new Date().getTime()-G)}async downloadSignatureArchive(P,C){if(!P.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",P.identifier.id);const F=await this.D(P.assets.signature);await this.q.writeFile(C,F.stream)}async getReadme(P,C){if(P.assets.readme){const F=await this.D(P.assets.readme,{},C);return await(0,l.asTextOrError)(F)||""}return""}async getManifest(P,C){if(P.assets.manifest){const F=await this.D(P.assets.manifest,{},C),V=await(0,l.asTextOrError)(F);return V?JSON.parse(V):null}return null}async C(P,C){const F=X(P,n.Manifest);if(!F)throw new Error("Manifest was not found");const V={"Accept-Encoding":"gzip"},G=await this.D(F,{headers:V});return await(0,l.asJson)(G)}async getCoreTranslation(P,C){const F=P.assets.coreTranslations.filter(V=>V[0]===C.toUpperCase())[0];if(F){const V=await this.D(F[1]),G=await(0,l.asTextOrError)(V);return G?JSON.parse(G):null}return null}async getChangelog(P,C){if(P.assets.changelog){const F=await this.D(P.assets.changelog,{},C);return await(0,l.asTextOrError)(F)||""}return""}async getAllCompatibleVersions(P,C,F){let V=new u().withFlags(t.IncludeVersions,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,1);P.identifier.uuid?V=V.withFilter(i.ExtensionId,P.identifier.uuid):V=V.withFilter(i.ExtensionName,P.identifier.id);const{galleryExtensions:G}=await this.B(V,O.CancellationToken.None);if(!G.length)return[];const te=z(G[0]);if((0,v.isNotWebExtensionInWebTargetPlatform)(te,F))return[];const oe=[];await Promise.all(G[0].versions.map(async le=>{try{await this.y(le,C?"any":"release",!0,te,F)&&oe.push(le)}catch{}}));const ge=[],ve=new Set;for(const le of j(oe,F))ve.has(le.version)||(ve.add(le.version),ge.push({version:le.version,date:le.lastUpdated,isPreReleaseVersion:ne(le)}));return ge}async D(P,C={},F=O.CancellationToken.None){const V=await this.j,G={type:"GET"},te={...V,...C.headers||{}};C={...C,...G,headers:te};const oe=P.uri,ge=P.fallbackUri,ve={...C,url:oe};try{const le=await this.k.request(ve,F);if(le.res.statusCode===200)return le;const ce=await(0,l.asTextOrError)(le);throw new Error(`Expected 200, got back ${le.res.statusCode} instead.

${ce}`)}catch(le){if((0,k.isCancellationError)(le))throw le;const ce=(0,k.getErrorMessage)(le);this.o.publicLog2("galleryService:cdnFallback",{url:oe,message:ce});const we={...C,url:ge};return this.k.request(we,F)}}async E(P){let C=ie(P);if(!C){const F=await this.C(P,O.CancellationToken.None);if(!F)throw new Error("Manifest was not found");C=F.engines.vscode}return C}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{}};const P=await this.k.request({type:"GET",url:this.h},O.CancellationToken.None);if(P.res.statusCode!==200)throw new Error("Could not get extensions report.");const C=await(0,l.asJson)(P),F=[],V={};if(C){for(const G of C.malicious)F.push({id:G});if(C.migrateToPreRelease)for(const[G,te]of Object.entries(C.migrateToPreRelease))(!te.engine||(0,I.isEngineValid)(te.engine,this.u.version,this.u.date))&&(V[G.toLowerCase()]={disallowInstall:!0,extension:{id:te.id,displayName:te.displayName,autoMigrate:{storage:!!te.migrateStorage},preRelease:!0}});if(C.deprecated)for(const[G,te]of Object.entries(C.deprecated))te&&(V[G.toLowerCase()]=(0,b.isBoolean)(te)?{}:te)}return{malicious:F,deprecated:V}}};W=de([_(1,l.IRequestService),_(2,L.ILogService),_(3,p.IEnvironmentService),_(4,h.ITelemetryService),_(5,E.IFileService),_(6,d.IProductService),_(7,c.IConfigurationService)],W);let q=class extends W{constructor(P,C,F,V,G,te,oe,ge){super(P,C,F,V,G,te,oe,ge)}};q=de([_(0,S.IStorageService),_(1,l.IRequestService),_(2,L.ILogService),_(3,p.IEnvironmentService),_(4,h.ITelemetryService),_(5,E.IFileService),_(6,d.IProductService),_(7,c.IConfigurationService)],q),e.ExtensionGalleryService=q;let K=class extends W{constructor(P,C,F,V,G,te,oe){super(void 0,P,C,F,V,G,te,oe)}};K=de([_(0,l.IRequestService),_(1,L.ILogService),_(2,p.IEnvironmentService),_(3,h.ITelemetryService),_(4,E.IFileService),_(5,d.IProductService),_(6,c.IConfigurationService)],K),e.ExtensionGalleryServiceWithNoStorageService=K}),define(Y[151],Q([0,1,44,11,17,13,10,67,27,22]),function(x,e,T,O,k,D,N,b,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.ServerUserDataProfilesService=void 0;let p=class extends c.UserDataProfilesService{constructor(I,E,L,d){super(E,L,I,d),this.a=E}L(){return this.r.extUri.joinPath(O.URI.file(this.a.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};p=de([_(0,f.IUriIdentityService),_(1,k.INativeEnvironmentService),_(2,D.IFileService),_(3,N.ILogService)],p),e.ServerUserDataProfilesService=p;let v=class $e extends p{constructor(I,E,L,d,l){super(E,L,d,l),this.N=I}G(){return(0,T.revive)(this.N.getItem($e.b,[]))}I(){return(0,T.revive)(this.N.getItem($e.c,{}))}L(){return this.r.extUri.joinPath(O.URI.file(this.a.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};v=de([_(0,b.IStateService),_(1,f.IUriIdentityService),_(2,k.INativeEnvironmentService),_(3,D.IFileService),_(4,N.ILogService)],v),e.UserDataProfilesService=v}),define(Y[152],Q([0,1,38,5,165,2,10]),function(x,e,T,O,k,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let b=class extends T.AbstractPolicyService{constructor(c,p){super(),this.j=c,this.k=p,this.a=new O.Throttler,this.b=this.B(new D.MutableDisposable)}async i(c){this.j.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(c).length} policy definitions`),await this.a.queue(()=>new Promise((p,v)=>{try{this.b.value=(0,k.createWatcher)(this.k,c,g=>{this.m(g),p()})}catch(g){this.j.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",g),v(g)}}))}m(c){this.j.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(c)}`);for(const p in c){const v=c[p];v===void 0?this.g.delete(p):this.g.set(p,v)}this.h.fire(Object.keys(c))}};b=de([_(0,N.ILogService)],b),e.NativePolicyService=b}),define(Y[69],Q([0,1,120,5,14,4,20,85,166,167]),function(x,e,T,O,k,D,N,b,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class p extends Error{constructor(t,r){let i=r.message;switch(t){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=t,this.cause=r}}e.ExtractError=p;function v(y){const t=y.externalFileAttributes>>16||33188;return[448,56,7].map(r=>t&r).reduce((r,i)=>r+i,t&61440)}function g(y){if(y instanceof p)return y;let t;return/end of central directory record signature not found/.test(y.message)&&(t="CorruptZip"),new p(t,y)}function I(y,t,r,i,n,s){const a=k.dirname(t),o=k.join(i,a);if(!o.startsWith(i))return Promise.reject(new Error(b.localize(0,null,t)));const u=k.join(i,t);let w;return s.onCancellationRequested(()=>{w?.destroy()}),Promise.resolve(N.Promises.mkdir(o,{recursive:!0})).then(()=>new Promise((A,$)=>{if(!s.isCancellationRequested)try{w=(0,T.createWriteStream)(u,{mode:r}),w.once("close",()=>A()),w.once("error",$),y.once("error",$),y.pipe(w)}catch(Z){$(Z)}}))}function E(y,t,r,i){let n=(0,O.createCancelablePromise)(()=>Promise.resolve()),s=0;return i.onCancellationRequested(()=>{n.cancel(),y.close()}),new Promise((a,o)=>{const u=new O.Sequencer,w=A=>{A.isCancellationRequested||(s++,y.readEntry())};y.once("error",o),y.once("close",()=>n.then(()=>{i.isCancellationRequested||y.entryCount===s?a():o(new p("Incomplete",new Error(b.localize(1,null,s,y.entryCount))))},o)),y.readEntry(),y.on("entry",A=>{if(i.isCancellationRequested)return;if(!r.sourcePathRegex.test(A.fileName)){w(i);return}const $=A.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test($)){const ee=k.join(t,$);n=(0,O.createCancelablePromise)(ie=>N.Promises.mkdir(ee,{recursive:!0}).then(()=>w(ie)).then(void 0,o));return}const Z=d(y,A),X=v(A);n=(0,O.createCancelablePromise)(ee=>u.queue(()=>Z.then(ie=>I(ie,$,X,t,r,ee).then(()=>w(ee)))).then(null,o))})})}function L(y,t=!1){return new Promise((r,i)=>{(0,f.open)(y,t?{lazyEntries:!0}:void 0,(n,s)=>{n?i(g(n)):r((0,D.assertIsDefined)(s))})})}function d(y,t){return new Promise((r,i)=>{y.openReadStream(t,(n,s)=>{n?i(g(n)):r((0,D.assertIsDefined)(s))})})}function l(y,t){return new Promise((r,i)=>{const n=new c.ZipFile;t.forEach(a=>{a.contents?n.addBuffer(typeof a.contents=="string"?Buffer.from(a.contents,"utf8"):a.contents,a.path):a.localPath&&n.addFile(a.localPath,a.path)}),n.end();const s=(0,T.createWriteStream)(y);n.outputStream.pipe(s),n.outputStream.once("error",i),s.once("error",i),s.once("finish",()=>r(y))})}e.zip=l;function m(y,t,r={},i){const n=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let s=L(y,!0);return r.overwrite&&(s=s.then(a=>N.Promises.rm(t).then(()=>a))),s.then(a=>E(a,t,{sourcePathRegex:n},i))}e.extract=m;function S(y,t){return L(y).then(r=>new Promise((i,n)=>{r.on("entry",s=>{s.fileName===t&&d(r,s).then(a=>i(a),a=>n(a))}),r.once("close",()=>n(new Error(b.localize(2,null,t))))}))}function h(y,t){return S(y,t).then(r=>new Promise((i,n)=>{const s=[];r.once("error",n),r.on("data",a=>s.push(a)),r.on("end",()=>i(Buffer.concat(s)))}))}e.buffer=h}),define(Y[153],Q([0,1,69,93]),function(x,e,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function k(D){return(0,T.buffer)(D,"extension/package.json").then(N=>{try{return JSON.parse(N.toString("utf8"))}catch{throw new Error((0,O.localize)(0,null))}})}e.getManifest=k}),define(Y[154],Q([0,1,5,23,34,6,3,2,36,16,14,12,18,41,4,11,31,20,69,92,58,17,145,24,26,40,48,133,146,153,126,134,29,45,13,9,10,28,25,27,22]),function(x,e,T,O,k,D,N,b,f,c,p,v,g,I,E,L,d,l,m,S,h,y,t,r,i,n,s,a,o,u,w,A,$,Z,X,ee,ie,ne,ae,fe,re){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,ee.refineServiceDecorator)(r.IExtensionManagementService);let me=class extends t.AbstractExtensionManagementService{constructor(R,P,C,F,V,G,te,oe,ge,ve,le,ce){super(R,P,C,ve,ce),this.Y=V,this.Z=G,this.ab=te,this.bb=ge,this.cb=le,this.X=new Map,this.kb=new f.ResourceSet;const we=this.B(oe.createInstance(o.ExtensionsLifecycle));this.S=this.B(oe.createInstance(z,ue=>we.postUninstall(ue))),this.U=this.B(new w.ExtensionsManifestCache(F,this)),this.W=this.B(oe.createInstance(a.ExtensionsDownloader));const se=this.B(new A.ExtensionsWatcher(this,this.Y,ce,G,le,ge,C));this.B(se.onDidChangeExtensionsByAnotherSource(ue=>this.jb(ue))),this.lb()}getTargetPlatform(){return this.db||(this.db=(0,i.computeTargetPlatform)(this.bb,this.v)),this.db}async zip(R){this.v.trace("ExtensionManagementService#zip",R.identifier.id);const P=await this.ib(R),C=await(0,m.zip)((0,g.joinPath)(this.W.extensionsDownloadDir,(0,d.generateUuid)()).fsPath,P);return L.URI.file(C)}async unzip(R){return this.v.trace("ExtensionManagementService#unzip",R.toString()),(await this.install(R)).identifier}async getManifest(R){const{location:P,cleanup:C}=await this.eb(R),F=p.resolve(P.fsPath);try{return await(0,u.getManifest)(F)}finally{await C()}}getInstalled(R,P){return this.S.scanExtensions(R??null,P)}getAllUserInstalled(){return this.S.scanAllUserExtensions(!1)}async install(R,P={}){this.v.trace("ExtensionManagementService#install",R.toString());const{location:C,cleanup:F}=await this.eb(R);try{const V=await(0,u.getManifest)(p.resolve(C.fsPath));if(V.engines&&V.engines.vscode&&!(0,Z.isEngineValid)(V.engines.vscode,this.w.version,this.w.date))throw new Error(S.localize(0,null,(0,i.getGalleryExtensionId)(V.publisher,V.name),this.w.version));return await this.z(V,C,P)}finally{await F()}}async installFromLocation(R,P){this.v.trace("ExtensionManagementService#installFromLocation",R.toString());const C=await this.S.scanUserExtensionAtLocation(R);if(!C)throw new Error(`Cannot find a valid extension from the location ${R.toString()}`);return await this.nb([C],P),this.v.info("Successfully installed extension",C.identifier.id,P.toString()),C}getMetadata(R){return this.Y.scanMetadata(R.location)}async updateMetadata(R,P){this.v.trace("ExtensionManagementService#updateMetadata",R.identifier.id);const C={...P};return P.isPreReleaseVersion&&(C.preRelease=!0),R=await this.S.updateMetadata(R,C),this.U.invalidate(),R}async updateExtensionScope(R,P){return this.v.trace("ExtensionManagementService#updateExtensionScope",R.identifier.id),R=await this.S.updateMetadata(R,{isMachineScoped:P}),this.U.invalidate(),R}async reinstallFromGallery(R){if(this.v.trace("ExtensionManagementService#reinstallFromGallery",R.identifier.id),!this.t.isEnabled())throw new Error(S.localize(1,null));const P=await this.getTargetPlatform(),[C]=await this.t.getExtensions([{...R.identifier,preRelease:R.preRelease}],{targetPlatform:P,compatible:!0},O.CancellationToken.None);if(!C)throw new Error(S.localize(2,null));await this.S.setUninstalled(R);try{await this.S.removeUninstalledExtension(R)}catch(F){throw new Error(S.localize(3,null,(0,k.toErrorMessage)(F)))}return this.installFromGallery(C)}markAsUninstalled(...R){return this.S.setUninstalled(...R)}removeUninstalledExtensions(){return this.S.cleanUp()}async download(R,P){const{location:C}=await this.W.download(R,P);return C}async eb(R){if(R.scheme===c.Schemas.file)return{location:R,async cleanup(){}};this.v.trace("Downloading extension from",R.toString());const P=(0,g.joinPath)(this.W.extensionsDownloadDir,(0,d.generateUuid)());return await this.ab.download(R,P),this.v.info("Downloaded extension to",P.toString()),{location:P,cleanup:async()=>{try{await this.bb.del(P)}catch(F){this.v.error(F)}}}}P(){return this.y.defaultProfile.extensionsResource}Q(R,P,C){let F;if(L.URI.isUri(P))F=new B(R,P,C,this.t,this.S,this.v);else{const V=i.ExtensionKey.create(P).toString();F=this.X.get(V),F||(this.X.set(V,F=new M(R,P,C,this.W,this.S,this.v)),F.waitUntilTaskIsFinished().then(()=>this.X.delete(V)))}return new W(F,C.profileLocation,this.cb,this.y,this.Y,this.Z)}R(R,P){return new q(R,P.profileLocation,this.Z)}async ib(R){const P=async F=>{let V=await l.Promises.readdir(F);V=V.map(oe=>p.join(F,oe));const G=await Promise.all(V.map(oe=>l.Promises.stat(oe)));let te=Promise.resolve([]);return G.forEach((oe,ge)=>{const ve=V[ge];oe.isFile()&&(te=te.then(le=>[...le,ve])),oe.isDirectory()&&(te=te.then(le=>P(ve).then(ce=>[...le,...ce])))}),te};return(await P(R.location.fsPath)).map(F=>({path:`extension/${p.relative(R.location.fsPath,F)}`,localPath:F}))}async jb({added:R,removed:P}){if(P)for(const C of P.extensions)this.v.info("Extensions removed from another source",C.id,P.profileLocation.toString()),this.p.fire({identifier:C,profileLocation:P.profileLocation});if(R){const F=(await this.S.scanExtensions(1,R.profileLocation)).filter(V=>R.extensions.some(G=>(0,i.areSameExtensions)(G,V.identifier)));this.m.fire(F.map(V=>(this.v.info("Extensions added from another source",V.identifier.id,R.profileLocation.toString()),{identifier:V.identifier,local:V,profileLocation:R.profileLocation,operation:1})))}}async lb(){this.B(this.S.onExtract(P=>this.kb.add(P)));const R=await this.bb.resolve(this.Y.userExtensionsLocation);for(const P of R.children??[])P.isDirectory&&this.kb.add(P.resource);this.B(this.bb.watch(this.Y.userExtensionsLocation)),this.B(this.bb.onDidFilesChange(P=>this.mb(P)))}async mb(R){if(!R.affects(this.Y.userExtensionsLocation,1))return;const P=[];for(const C of R.rawAdded){if(this.kb.has(C)||!this.cb.extUri.isEqual(this.cb.extUri.dirname(C),this.Y.userExtensionsLocation)||this.cb.extUri.isEqual(C,this.cb.extUri.joinPath(this.Y.userExtensionsLocation,".obsolete"))||this.cb.extUri.basename(C).startsWith(".")||!(await this.bb.stat(C)).isDirectory)continue;const F=await this.S.scanUserExtensionAtLocation(C);F&&F.installedTimestamp===void 0&&(this.kb.add(C),P.push(F))}P.length&&(await this.nb(P,this.y.defaultProfile.extensionsResource),this.v.info("Added extensions to default profile from external source",P.map(C=>C.identifier.id)))}async nb(R,P){await this.Z.addExtensionsToProfile(R.map(C=>[C,void 0]),P),this.m.fire(R.map(C=>({local:C,identifier:C.identifier,operation:1,profileLocation:P})))}};me=de([_(0,r.IExtensionGalleryService),_(1,ae.ITelemetryService),_(2,ie.ILogService),_(3,y.INativeEnvironmentService),_(4,s.IExtensionsScannerService),_(5,n.IExtensionsProfileScannerService),_(6,h.IDownloadService),_(7,ee.IInstantiationService),_(8,X.IFileService),_(9,ne.IProductService),_(10,fe.IUriIdentityService),_(11,re.IUserDataProfilesService)],me),e.ExtensionManagementService=me;let z=class extends b.Disposable{constructor(R,P,C,F){super(),this.j=R,this.k=P,this.l=C,this.m=F,this.h=this.B(new N.Emitter),this.onExtract=this.h.event,this.c=(0,g.joinPath)(this.l.userExtensionsLocation,".obsolete").fsPath,this.g=new T.Queue}async cleanUp(){await this.v()}async scanExtensions(R,P){const C={includeInvalid:!0,profileLocation:P};let F=[];return R===null||R===0?F.push(...await this.l.scanAllExtensions({includeInvalid:!0},C,!1)):R===1&&F.push(...await this.l.scanUserExtensions(C)),F=R!==null?F.filter(V=>V.type===R):F,Promise.all(F.map(V=>this.u(V)))}async scanAllUserExtensions(R){const P=await this.l.scanUserExtensions({includeAllVersions:!R,includeInvalid:!0});return Promise.all(P.map(C=>this.u(C)))}async scanUserExtensionAtLocation(R){try{const P=await this.l.scanExistingExtension(R,1,{includeInvalid:!0});if(P)return await this.u(P)}catch(P){this.m.error(P)}return null}async extractUserExtension(R,P,C,F){const V=R.toString(),G=p.join(this.l.userExtensionsLocation.fsPath,`.${(0,d.generateUuid)()}`),te=p.join(this.l.userExtensionsLocation.fsPath,V);try{await l.Promises.rm(te)}catch{throw new r.ExtensionManagementError(S.localize(4,null,te,R.id),r.ExtensionManagementErrorCode.Delete)}await this.p(R,P,G,F),await this.l.updateMetadata(L.URI.file(G),C);try{this.h.fire(L.URI.file(te)),await this.s(R,G,te,Date.now()+2*60*1e3),this.m.info("Renamed to",te)}catch(oe){try{await l.Promises.rm(G)}catch{}if(oe.code==="ENOTEMPTY")this.m.info("Rename failed because extension was installed by another source. So ignoring renaming.",R.id);else throw this.m.info(`Rename failed because of ${(0,D.getErrorMessage)(oe)}. Deleted from extracted location`,G),oe}return this.t(L.URI.file(te),1)}async updateMetadata(R,P){return await this.l.updateMetadata(R.location,P),this.t(R.location,R.type)}getUninstalledExtensions(){return this.n()}async setUninstalled(...R){const P=R.map(C=>i.ExtensionKey.create(C));await this.n(C=>P.forEach(F=>{C[F.toString()]=!0,this.m.info("Marked extension as uninstalled",F.toString())}))}async setInstalled(R){await this.n(F=>delete F[R.toString()]);const C=(await this.scanAllUserExtensions(!0)).find(F=>i.ExtensionKey.create(F).equals(R))||null;return C?this.updateMetadata(C,{installedTimestamp:Date.now()}):null}async removeExtension(R,P){this.m.trace(`Deleting ${P} extension from disk`,R.identifier.id,R.location.fsPath),await l.Promises.rm(R.location.fsPath),this.m.info("Deleted from disk",R.identifier.id,R.location.fsPath)}async removeUninstalledExtension(R){await this.removeExtension(R,"uninstalled"),await this.n(P=>delete P[i.ExtensionKey.create(R).toString()])}async n(R){return this.g.queue(async()=>{let P;try{P=await l.Promises.readFile(this.c,"utf8")}catch(F){if(F.code!=="ENOENT")throw F}let C={};if(P)try{C=JSON.parse(P)}catch{}return R&&(R(C),Object.keys(C).length?await l.Promises.writeFile(this.c,JSON.stringify(C)):await l.Promises.rm(this.c)),C})}async p(R,P,C,F){this.m.trace(`Started extracting the extension from ${P} to ${C}`);try{await l.Promises.rm(C)}catch(V){throw new r.ExtensionManagementError(this.w(V).message,r.ExtensionManagementErrorCode.Delete)}try{await(0,m.extract)(P,C,{sourcePath:"extension",overwrite:!0},F),this.m.info(`Extracted extension to ${C}:`,R.id)}catch(V){try{await l.Promises.rm(C)}catch{}let G=r.ExtensionManagementErrorCode.Extract;throw V instanceof m.ExtractError&&(V.type==="CorruptZip"?G=r.ExtensionManagementErrorCode.CorruptZip:V.type==="Incomplete"&&(G=r.ExtensionManagementErrorCode.IncompleteZip)),new r.ExtensionManagementError(V.message,G)}}async s(R,P,C,F){try{await l.Promises.rename(P,C)}catch(V){if(v.isWindows&&V&&V.code==="EPERM"&&Date.now()<F)return this.m.info(`Failed renaming ${P} to ${C} with 'EPERM' error. Trying again...`,R.id),this.s(R,P,C,F);throw new r.ExtensionManagementError(V.message||S.localize(5,null,P,C),V.code||r.ExtensionManagementErrorCode.Rename)}}async t(R,P){const C=await this.l.scanExistingExtension(R,P,{includeInvalid:!0});if(C)return this.u(C);throw new Error(S.localize(6,null,R.path))}async u(R){const P=await this.k.resolve(R.location);let C,F;return P.children&&(C=P.children.find(({name:V})=>/^readme(\.txt|\.md|)$/i.test(V))?.resource,F=P.children.find(({name:V})=>/^changelog(\.txt|\.md|)$/i.test(V))?.resource),{identifier:R.identifier,type:R.type,isBuiltin:R.isBuiltin||!!R.metadata?.isBuiltin,location:R.location,manifest:R.manifest,targetPlatform:R.targetPlatform,validations:R.validations,isValid:R.isValid,readmeUrl:C,changelogUrl:F,publisherDisplayName:R.metadata?.publisherDisplayName||null,publisherId:R.metadata?.publisherId||null,isApplicationScoped:!!R.metadata?.isApplicationScoped,isMachineScoped:!!R.metadata?.isMachineScoped,isPreReleaseVersion:!!R.metadata?.isPreReleaseVersion,preRelease:!!R.metadata?.preRelease,installedTimestamp:R.metadata?.installedTimestamp,updated:!!R.metadata?.updated}}async v(){const R=await this.getUninstalledExtensions(),P=await this.l.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),C=new Set;for(const G of P)R[i.ExtensionKey.create(G).toString()]||C.add(G.identifier.id.toLowerCase());const F=(0,i.groupByExtension)(P,G=>G.identifier);await T.Promises.settled(F.map(async G=>{const te=G.sort((oe,ge)=>I.rcompare(oe.manifest.version,ge.manifest.version))[0];C.has(te.identifier.id.toLowerCase())||await this.j(await this.u(te))}));const V=P.filter(G=>G.metadata&&R[i.ExtensionKey.create(G).toString()]);await T.Promises.settled(V.map(G=>this.removeUninstalledExtension(G)))}w(R){const P=Array.isArray(R)?R:[R];return P.length===1?P[0]instanceof Error?P[0]:new Error(P[0]):P.reduce((C,F)=>new Error(`${C.message}${C.message?",":""}${F instanceof Error?F.message:F}`),new Error(""))}};z=de([_(1,X.IFileService),_(2,s.IExtensionsScannerService),_(3,ie.ILogService)],z),e.ExtensionsScanner=z;class j extends t.AbstractExtensionTask{get verificationStatus(){return this.j}get operation(){return(0,E.isUndefined)(this.l.operation)?this.k:this.l.operation}constructor(R,P,C,F,V){super(),this.identifier=R,this.source=P,this.l=C,this.m=F,this.n=V,this.j="Unverified",this.k=2}async o(R,P){try{const C=await this.p(R.key);if(C)return this.m.updateMetadata(C,R.metadata)}catch{throw v.isMacintosh?new r.ExtensionManagementError(S.localize(7,null),r.ExtensionManagementErrorCode.Internal):new r.ExtensionManagementError(S.localize(8,null),r.ExtensionManagementErrorCode.Internal)}return this.s(R,P)}async p(R){if(!await this.q(R))return null;this.n.trace("Removing the extension from uninstalled list:",R.id);const C=await this.m.setInstalled(R);return this.n.info("Removed the extension from uninstalled list:",R.id),C}async q(R){return!!(await this.m.getUninstalledExtensions())[R.toString()]}async s({zipPath:R,key:P,metadata:C},F){const V=await this.m.extractUserExtension(P,R,C,F);return this.n.info("Extracting completed.",P.id),V}}class M extends j{constructor(R,P,C,F,V,G){super(P.identifier,P,C,V,G),this.t=R,this.u=P,this.v=F}async h(R){const C=(await this.m.scanExtensions(null,void 0)).find(te=>(0,i.areSameExtensions)(te.identifier,this.u.identifier));C&&(this.k=3);const F={id:this.u.identifier.uuid,publisherId:this.u.publisherId,publisherDisplayName:this.u.publisherDisplayName,targetPlatform:this.u.properties.targetPlatform,isApplicationScoped:(0,$.isApplicationScopedExtension)(this.t),isMachineScoped:this.l.isMachineScoped||C?.isMachineScoped,isBuiltin:this.l.isBuiltin||C?.isBuiltin,isSystem:C?.type===0?!0:void 0,updated:!!C,isPreReleaseVersion:this.u.properties.isPreReleaseVersion,installedTimestamp:Date.now(),preRelease:this.u.properties.isPreReleaseVersion||((0,E.isBoolean)(this.l.installPreReleaseVersion)?this.l.installPreReleaseVersion:C?.preRelease)};if(C?.manifest.version===this.u.version)return{local:await this.m.updateMetadata(C,F),metadata:F};const{location:V,verificationStatus:G}=await this.v.download(this.u,this.k);try{return this.j=G,this.x(V.fsPath),{local:await this.o({zipPath:V.fsPath,key:i.ExtensionKey.create(this.u),metadata:F},R),metadata:F}}catch(te){try{await this.v.delete(V)}catch(oe){this.n.warn("Error while deleting the downloaded file",V.toString(),(0,D.getErrorMessage)(oe))}throw te}}async x(R){try{await(0,u.getManifest)(R)}catch(P){throw new r.ExtensionManagementError((0,t.joinErrors)(P).message,r.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=M;class B extends j{constructor(R,P,C,F,V,G){super({id:(0,i.getGalleryExtensionId)(R.publisher,R.name)},P,C,V,G),this.t=R,this.u=P,this.v=F}async h(R){const P=new i.ExtensionKey(this.identifier,this.t.version),F=(await this.m.scanExtensions(1,void 0)).find(te=>(0,i.areSameExtensions)(this.identifier,te.identifier)),V=await this.x(this.identifier.id,this.t.version,R);if(V.isApplicationScoped=(0,$.isApplicationScopedExtension)(this.t),V.isMachineScoped=this.l.isMachineScoped||F?.isMachineScoped,V.isBuiltin=this.l.isBuiltin||F?.isBuiltin,V.installedTimestamp=Date.now(),F)if(this.k=3,P.equals(new i.ExtensionKey(F.identifier,F.manifest.version)))try{await this.m.removeExtension(F,"existing")}catch{throw new Error(S.localize(9,null,this.t.displayName||this.t.name))}else!this.l.profileLocation&&I.gt(F.manifest.version,this.t.version)&&await this.m.setUninstalled(F);else{const te=await this.p(P);if(te)try{await this.m.removeExtension(te,"existing")}catch{throw new Error(S.localize(10,null,this.t.displayName||this.t.name))}}return{local:await this.o({zipPath:p.resolve(this.u.fsPath),key:P,metadata:V},R),metadata:V}}async x(R,P,C){try{let[F]=await this.v.getExtensions([{id:R,version:P}],C);if(F||([F]=await this.v.getExtensions([{id:R}],C)),F)return{id:F.identifier.uuid,publisherDisplayName:F.publisherDisplayName,publisherId:F.publisherId,isPreReleaseVersion:F.properties.isPreReleaseVersion,preRelease:F.properties.isPreReleaseVersion||this.l.installPreReleaseVersion}}catch{}return{}}}class W{get verificationStatus(){return this.d.verificationStatus}constructor(R,P,C,F,V,G){this.d=R,this.g=P,this.h=C,this.j=F,this.k=V,this.l=G,this.identifier=this.d.identifier,this.source=this.d.source,this.operation=this.d.operation,this.c=this.m()}async m(){const R=await this.d.waitUntilTaskIsFinished();return this.h.extUri.isEqual(this.j.defaultProfile.extensionsResource,this.g)&&await this.k.initializeDefaultProfileExtensions(),await this.l.addExtensionsToProfile([[R.local,R.metadata]],this.g),R}async run(){return await this.d.run(),this.c}waitUntilTaskIsFinished(){return this.c}cancel(){return this.d.cancel()}}class q extends t.AbstractExtensionTask{constructor(R,P,C){super(),this.extension=R,this.j=P,this.k=C}async h(R){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(Y[155],Q([0,1,129,5,15,6,2,4,21,17,130,10,128,168]),function(x,e,T,O,k,D,N,b,f,c,p,v,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let E=class extends N.Disposable{constructor(d,l,m){super(),this.h=d,this.i=l,this.j=m,this.k(),this.B(d.onDidChangeConfiguration(S=>{S.affectsConfiguration("http")&&this.k()}))}k(){const d=this.h.getValue("http");this.a=d?.proxy,this.b=!!d?.proxyStrictSSL,this.f=d?.proxyAuthorization}async request(d,l){this.j.trace("RequestService#request (node) - begin",d.url);const{a:m,b:S}=this;let h;try{h=await(0,p.getResolvedShellEnv)(this.h,this.j,this.i.args,process.env)}catch(r){this.g||(this.g=!0,this.j.error("RequestService#request (node) resolving shell environment failed",r))}const y={...process.env,...h},t=d.agent?d.agent:await(0,g.getProxyAgent)(d.url||"",y,{proxyUrl:m,strictSSL:S});d.agent=t,d.strictSSL=S,this.f&&(d.headers={...d.headers||{},"Proxy-Authorization":this.f});try{const r=await this.m(d,l);return this.j.trace("RequestService#request (node) - success",d.url),r}catch(r){throw this.j.trace("RequestService#request (node) - error",d.url,r),r}}async l(d){return((0,T.parse)(d.url).protocol==="https:"?await new Promise((S,h)=>{x(["https"],S,h)}):await new Promise((S,h)=>{x(["http"],S,h)})).request}m(d,l){return O.Promises.withAsyncBody(async(m,S)=>{const h=(0,T.parse)(d.url),y=d.getRawRequest?d.getRawRequest(d):await this.l(d),t={hostname:h.hostname,port:h.port?parseInt(h.port):h.protocol==="https:"?443:80,protocol:h.protocol,path:h.path,method:d.type||"GET",headers:d.headers,agent:d.agent,rejectUnauthorized:(0,b.isBoolean)(d.strictSSL)?d.strictSSL:!0};d.user&&d.password&&(t.auth=d.user+":"+d.password);const r=y(t,i=>{const n=(0,b.isNumber)(d.followRedirects)?d.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)this.m({...d,url:i.headers.location,followRedirects:n-1},l).then(m,S);else{let s=i;!d.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(s=i.pipe((0,I.createGunzip)())),m({res:i,stream:(0,k.streamToBufferReadableStream)(s)})}});r.on("error",S),d.timeout&&r.setTimeout(d.timeout),d.isChromiumNetwork&&r.removeHeader("Content-Length"),d.data&&typeof d.data=="string"&&r.write(d.data),r.end(),l.onCancellationRequested(()=>{r.abort(),S(new D.CancellationError)})})}async resolveProxy(d){}};E=de([_(0,f.IConfigurationService),_(1,c.INativeEnvironmentService),_(2,v.ILogService)],E),e.RequestService=E}),define(Y[169],Q([0,1,33,5,15,34,6,2,16,14,12,35,11,20,21,125,58,127,17,106,150,24,59,132,40,48,154,148,13,117,119,46,115,62,63,136,10,121,122,38,152,139,28,47,155,67,131,68,25,138,39,140,141,27,143,22,151,142,147]),function(x,e,T,O,k,D,N,b,f,c,p,v,g,I,E,L,d,l,m,S,h,y,t,r,i,n,s,a,o,u,w,A,$,Z,X,ee,ie,ne,ae,fe,re,me,z,j,M,B,W,q,K,R,P,C,F,V,G,te,oe,ge,ve){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class le extends b.Disposable{constructor(se){super(),this.b=se,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[se,ue]=await this.f();return se.invokeFunction(async be=>{const je=be.get(ie.ILogService),Ce=be.get(o.IFileService),Ne=be.get(m.INativeEnvironmentService),U=be.get(te.IUserDataProfilesService);je.info("CLI main",this.b),this.g(je),await this.h(Ne,Ce,U,se),await Promise.all(ue.map(H=>{(0,O.raceTimeout)(H.flush(),1e3)}))})}async f(){const se=new Z.ServiceCollection,ue={_serviceBrand:void 0,...me.default};se.set(z.IProductService,ue);const be=new S.NativeEnvironmentService(this.b,ue);se.set(m.INativeEnvironmentService,be),await Promise.all([be.appSettingsHome.fsPath,be.extensionsPath].map(De=>De?I.Promises.mkdir(De,{recursive:!0}):void 0));const je=(0,ie.getLogLevel)(be),Ce=[];Ce.push(new ne.SpdLogLogger("cli",(0,c.join)(be.logsPath,"cli.log"),!0,!1,je)),je===ie.LogLevel.Trace&&Ce.push(new ie.ConsoleLogger(je));const Ne=this.B(new ie.MultiplexLogService(Ce));se.set(ie.ILogService,Ne);const U=this.B(new u.FileService(Ne));se.set(o.IFileService,U);const H=this.B(new w.DiskFileSystemProvider(Ne));U.registerProvider(f.Schemas.file,H);const J=new W.StateService(be,Ne,U);se.set(B.IStateService,J);const he=new G.UriIdentityService(U);se.set(V.IUriIdentityService,he);const pe=new oe.UserDataProfilesService(J,he,be,U,Ne);se.set(te.IUserDataProfilesService,pe);const Oe=p.isWindows&&ue.win32RegValueName?this.B(new re.NativePolicyService(Ne,ue.win32RegValueName)):be.policyFile?this.B(new ae.FilePolicyService(be.policyFile,U,Ne)):new fe.NullPolicyService;se.set(fe.IPolicyService,Oe);const Se=this.B(new L.ConfigurationService(pe.defaultProfile.settingsResource,U,Oe,Ne));se.set(E.IConfigurationService,Se),await Promise.all([J.init(),Se.initialize()]),pe.setEnablement(ue.quality!=="stable"||Se.getValue(te.PROFILES_ENABLEMENT_CONFIG)),se.set(V.IUriIdentityService,new G.UriIdentityService(U)),se.set(j.IRequestService,new A.SyncDescriptor(M.RequestService,void 0,!0)),se.set(d.IDownloadService,new A.SyncDescriptor(l.DownloadService,void 0,!0)),se.set(i.IExtensionsProfileScannerService,new A.SyncDescriptor(ve.ExtensionsProfileScannerService,void 0,!0)),se.set(n.IExtensionsScannerService,new A.SyncDescriptor(a.ExtensionsScannerService,void 0,!0)),se.set(t.IExtensionSignatureVerificationService,new A.SyncDescriptor(t.ExtensionSignatureVerificationService,void 0,!0)),se.set(s.INativeServerExtensionManagementService,new A.SyncDescriptor(s.ExtensionManagementService,void 0,!0)),se.set(y.IExtensionGalleryService,new A.SyncDescriptor(h.ExtensionGalleryServiceWithNoStorageService,void 0,!0)),se.set(X.ILanguagePackService,new A.SyncDescriptor(ee.NativeLanguagePackService,void 0,!1));const Le=[],Pe=(0,P.isInternalTelemetry)(ue,Se);if((0,P.supportsTelemetry)(ue,be)){ue.aiConfig&&ue.aiConfig.ariaKey&&Le.push(new C.OneDataSystemAppender(Pe,"monacoworkbench",null,ue.aiConfig.ariaKey));const{installSourcePath:De}=be,Fe={appenders:Le,sendErrorTelemetry:!1,commonProperties:(async()=>{let Re;try{Re=await(0,ge.resolveMachineId)(J)}catch(Te){Te.code!=="ENOENT"&&Ne.error(Te)}return(0,q.resolveCommonProperties)(U,(0,T.release)(),(0,T.hostname)(),process.arch,ue.commit,ue.version,Re,Pe,De)})(),piiPaths:(0,P.getPiiPathsFromEnvironment)(be)};se.set(K.ITelemetryService,new A.SyncDescriptor(R.TelemetryService,[Fe],!1))}else se.set(K.ITelemetryService,P.NullTelemetryService);return[new $.InstantiationService(se),Le]}g(se){(0,N.setUnexpectedErrorHandler)(ue=>{const be=(0,D.toErrorMessage)(ue,!0);!be||se.error(`[uncaught exception in CLI]: ${be}`)}),process.on("uncaughtException",ue=>(0,N.onUnexpectedError)(ue)),process.on("unhandledRejection",ue=>(0,N.onUnexpectedError)(ue))}async h(se,ue,be,je){const Ce=(se.args.profile?be.profiles.find(Ne=>Ne.name===se.args.profile)??be.defaultProfile:be.defaultProfile).extensionsResource;if(this.b["install-source"])return this.j(se,ue,this.b["install-source"]);if(this.b["list-extensions"])return je.createInstance(r.ExtensionManagementCLI).listExtensions(!!this.b["show-versions"],this.b.category,Ce);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const Ne={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:Ce};return je.createInstance(r.ExtensionManagementCLI).installExtensions(this.i(this.b["install-extension"]||[]),this.b["install-builtin-extension"]||[],Ne,!!this.b.force)}else{if(this.b["uninstall-extension"])return je.createInstance(r.ExtensionManagementCLI).uninstallExtensions(this.i(this.b["uninstall-extension"]),!!this.b.force,Ce);if(this.b["locate-extension"])return je.createInstance(r.ExtensionManagementCLI).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,F.buildTelemetryMessage)(se.appRoot,se.extensionsPath))}}i(se){return se.map(ue=>/\.vsix$/i.test(ue)?g.URI.file((0,c.isAbsolute)(ue)?ue:(0,c.join)((0,v.cwd)(),ue)):ue)}async j(se,ue,be){await ue.writeFile(g.URI.file(se.installSourcePath),k.VSBuffer.fromString(be.slice(0,30)))}}async function ce(we){const se=new le(we);try{await se.run()}finally{se.dispose()}}e.main=ce})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/727d2d32aea02baf7d13fa38787e8ed64dd858d0/core/vs/code/node/cliProcessMain.js.map
