/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ye=["exports","require","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/errors","vs/base/common/path","vs/base/common/types","vs/base/common/platform","vs/platform/log/common/log","vs/workbench/api/common/extHostTypeConverters","vs/base/common/network","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/workbench/api/common/extHostInitDataService","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/base/node/pfs","vs/base/common/uuid","vs/workbench/services/search/common/search","vs/base/common/extpath","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/editor/common/core/range","vs/base/common/process","vs/base/common/severity","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/stopwatch","vs/platform/registry/common/platform","vs/base/common/errorMessage","child_process","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","vs/editor/common/core/position","vs/platform/configuration/common/configuration","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/base/common/decorators","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/ternarySearchTree","fs","vs/editor/common/languages","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/codicons","vs/base/common/collections","vs/base/common/lazy","vs/base/common/normalization","vs/base/common/mime","vs/base/common/hash","vs/base/common/marshalling","os","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/theme/common/themeService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/stream","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/processes","vs/base/common/filters","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/uriIpc","vs/base/node/extpath","vs/base/node/processes","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.net","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/tunnel/common/tunnel","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/dataTransfer","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/actions","vs/base/common/cache","vs/base/common/iconLabels","vs/editor/common/languageSelector","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/tokenizationRegistry","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/sign/node/signService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/uriTransformer","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","net","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostCLIServer","http","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/node/proxyResolver","vs/workbench/api/node/extHostExtensionService","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","https","tls","vscode-proxy-agent","events","vscode-regexpp","vs/workbench/api/node/extensionHostProcess","minimist"],Ce=function(te){for(var e=[],o=0,t=te.length;o<t;o++)e[o]=ye[te[o]];return e};define(ye[80],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.Codicon=e.getCodiconAriaLabel=void 0;function o(R){return R?R.replace(/\$\((.*?)\)/g,(I,A)=>` ${A} `).trim():""}e.getCodiconAriaLabel=o;class t{constructor(I,A,y){this.id=I,this.definition=A,this.description=y,t.a.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t.a}}e.Codicon=t,t.a=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",t.circleFilled.definition),t.closeDirty=new t("close-dirty",t.circleFilled.definition),t.debugBreakpoint=new t("debug-breakpoint",t.circleFilled.definition),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",t.circleFilled.definition),t.debugHint=new t("debug-hint",t.circleFilled.definition),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circle=new t("circle",{fontCharacter:"\\eabc"}),t.circleOutline=new t("circle-outline",t.circle.definition),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",t.circle.definition),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLarge=new t("circle-large",{fontCharacter:"\\ebb5"}),t.circleLargeOutline=new t("circle-large-outline",t.circleLarge.definition),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.searchFuzzy=new t("search-fuzzy",{fontCharacter:"\\ec0d"}),t.commentDraft=new t("comment-draft",{fontCharacter:"\\ec0e"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);var T;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const I=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function A(L){if(L instanceof t)return["codicon","codicon-"+L.id];const P=I.exec(L.id);if(!P)return A(t.error);const[,v,C]=P,E=["codicon","codicon-"+v];return C&&E.push("codicon-modifier-"+C.substring(1)),E}R.asClassNameArray=A;function y(L){return A(L).join(" ")}R.asClassName=y;function D(L){return"."+A(L).join(".")}R.asCSSSelector=D})(T=e.CSSIcon||(e.CSSIcon={}))}),define(ye[81],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function o(I,A){const y=Object.create(null);for(const D of I){const L=A(D);let P=y[L];P||(P=y[L]=[]),P.push(D)}return y}e.groupBy=o;function t(I,A){const y=[],D=[];for(const L of I)A.has(L)||y.push(L);for(const L of A)I.has(L)||D.push(L);return{removed:y,added:D}}e.diffSets=t;function T(I,A){const y=[],D=[];for(const[L,P]of I)A.has(L)||y.push(P);for(const[L,P]of A)I.has(L)||D.push(P);return{removed:y,added:D}}e.diffMaps=T;class R{constructor(){this.a=new Map}add(A,y){let D=this.a.get(A);D||(D=new Set,this.a.set(A,D)),D.add(y)}delete(A,y){const D=this.a.get(A);!D||(D.delete(y),D.size===0&&this.a.delete(A))}forEach(A,y){const D=this.a.get(A);!D||D.forEach(y)}}e.SetMap=R}),define(ye[60],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function o(I){return(A,y,D)=>{let L=null,P=null;if(typeof D.value=="function"?(L="value",P=D.value):typeof D.get=="function"&&(L="get",P=D.get),!P)throw new Error("not supported");D[L]=I(P,y)}}function t(I,A,y){let D=null,L=null;if(typeof y.value=="function"?(D="value",L=y.value,L.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(D="get",L=y.get),!L)throw new Error("not supported");const P=`$memoize$${A}`;y[D]=function(...v){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:L.apply(this,v)}),this[P]}}e.memoize=t;function T(I,A,y){return o((D,L)=>{const P=`$debounce$${L}`,v=`$debounce$result$${L}`;return function(...C){this[v]||(this[v]=y?y():void 0),clearTimeout(this[P]),A&&(this[v]=A(this[v],...C),C=[this[v]]),this[P]=setTimeout(()=>{D.apply(this,C),this[v]=y?y():void 0},I)}})}e.debounce=T;function R(I,A,y){return o((D,L)=>{const P=`$throttle$timer$${L}`,v=`$throttle$result$${L}`,C=`$throttle$lastRun$${L}`,E=`$throttle$pending$${L}`;return function(...f){if(this[v]||(this[v]=y?y():void 0),(this[C]===null||this[C]===void 0)&&(this[C]=-Number.MAX_VALUE),A&&(this[v]=A(this[v],...f)),this[E])return;const d=this[C]+I;d<=Date.now()?(this[C]=Date.now(),D.apply(this,[this[v]]),this[v]=y?y():void 0):(this[E]=!0,this[P]=setTimeout(()=>{this[E]=!1,this[C]=Date.now(),D.apply(this,[this[v]]),this[v]=y?y():void 0},d-Date.now()))}})}e.throttle=R}),define(ye[9],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class o{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?g.isErrorNoTelemetry(i)?new g(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(s=>{s(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.ErrorHandler=o,e.errorHandler=new o;function t(w){e.errorHandler.setUnexpectedErrorHandler(w)}e.setUnexpectedErrorHandler=t;function T(w){y(w)||e.errorHandler.onUnexpectedError(w)}e.onUnexpectedError=T;function R(w){y(w)||e.errorHandler.onUnexpectedExternalError(w)}e.onUnexpectedExternalError=R;function I(w){if(w instanceof Error){const{name:i,message:s}=w,a=w.stacktrace||w.stack;return{$isError:!0,name:i,message:s,stack:a,noTelemetry:g.isErrorNoTelemetry(w)}}return w}e.transformErrorForSerialization=I;const A="Canceled";function y(w){return w instanceof D?!0:w instanceof Error&&w.name===A&&w.message===A}e.isCancellationError=y;class D extends Error{constructor(){super(A),this.name=this.message}}e.CancellationError=D;function L(){const w=new Error(A);return w.name=w.message,w}e.canceled=L;function P(w){return w?new Error(`Illegal argument: ${w}`):new Error("Illegal argument")}e.illegalArgument=P;function v(w){return w?new Error(`Illegal state: ${w}`):new Error("Illegal state")}e.illegalState=v;function C(w){return w?new Error(`readonly property '${w} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=C;function E(w){const i=new Error(`${w} has been disposed`);return i.name="DISPOSED",i}e.disposed=E;function f(w){return w?w.message?w.message:w.stack?w.stack.split(`
`)[0]:String(w):"Error"}e.getErrorMessage=f;class d extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.NotImplementedError=d;class h extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.NotSupportedError=h;class b extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=b;class g extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof g)return i;const s=new g;return s.message=i.message,s.stack=i.stack,s}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.ErrorNoTelemetry=g;class p extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,p.prototype);debugger}}e.BugIndicatingError=p}),define(ye[18],Ce([1,0,9]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t(oe,ae=0){return oe[oe.length-(1+ae)]}e.tail=t;function T(oe){if(oe.length===0)throw new Error("Invalid tail call");return[oe.slice(0,oe.length-1),oe[oe.length-1]]}e.tail2=T;function R(oe,ae,fe=(ee,le)=>ee===le){if(oe===ae)return!0;if(!oe||!ae||oe.length!==ae.length)return!1;for(let ee=0,le=oe.length;ee<le;ee++)if(!fe(oe[ee],ae[ee]))return!1;return!0}e.equals=R;function I(oe,ae){const fe=oe.length-1;ae<fe&&(oe[ae]=oe[fe]),oe.pop()}e.removeFastWithoutKeepingOrder=I;function A(oe,ae,fe){return y(oe.length,ee=>fe(oe[ee],ae))}e.binarySearch=A;function y(oe,ae){let fe=0,ee=oe-1;for(;fe<=ee;){const le=(fe+ee)/2|0,re=ae(le);if(re<0)fe=le+1;else if(re>0)ee=le-1;else return le}return-(fe+1)}e.binarySearch2=y;function D(oe,ae){let fe=0,ee=oe.length;if(ee===0)return 0;for(;fe<ee;){const le=Math.floor((fe+ee)/2);ae(oe[le])?ee=le:fe=le+1}return fe}e.findFirstInSorted=D;function L(oe,ae,fe){if(oe=oe|0,oe>=ae.length)throw new TypeError("invalid index");const ee=ae[Math.floor(ae.length*Math.random())],le=[],re=[],O=[];for(const H of ae){const x=fe(H,ee);x<0?le.push(H):x>0?re.push(H):O.push(H)}return oe<le.length?L(oe,le,fe):oe<le.length+O.length?O[0]:L(oe-(le.length+O.length),re,fe)}e.quickSelect=L;function P(oe,ae){const fe=[];let ee;for(const le of oe.slice(0).sort(ae))!ee||ae(ee[0],le)!==0?(ee=[le],fe.push(ee)):ee.push(le);return fe}e.groupBy=P;function v(oe,ae,fe){const ee=[];function le(H,x,Q){if(x===0&&Q.length===0)return;const de=ee[ee.length-1];de&&de.start+de.deleteCount===H?(de.deleteCount+=x,de.toInsert.push(...Q)):ee.push({start:H,deleteCount:x,toInsert:Q})}let re=0,O=0;for(;;){if(re===oe.length){le(re,0,ae.slice(O));break}if(O===ae.length){le(re,oe.length-re,[]);break}const H=oe[re],x=ae[O],Q=fe(H,x);Q===0?(re+=1,O+=1):Q<0?(le(re,1,[]),re+=1):Q>0&&(le(re,0,[x]),O+=1)}return ee}e.sortedDiff=v;function C(oe,ae,fe){const ee=v(oe,ae,fe),le=[],re=[];for(const O of ee)le.push(...oe.slice(O.start,O.start+O.deleteCount)),re.push(...O.toInsert);return{removed:le,added:re}}e.delta=C;function E(oe,ae,fe){if(fe===0)return[];const ee=oe.slice(0,fe).sort(ae);return d(oe,ae,ee,fe,oe.length),ee}e.top=E;function f(oe,ae,fe,ee,le){return fe===0?Promise.resolve([]):new Promise((re,O)=>{(async()=>{const H=oe.length,x=oe.slice(0,fe).sort(ae);for(let Q=fe,de=Math.min(fe+ee,H);Q<H;Q=de,de=Math.min(de+ee,H)){if(Q>fe&&await new Promise(we=>setTimeout(we)),le&&le.isCancellationRequested)throw new o.CancellationError;d(oe,ae,x,Q,de)}return x})().then(re,O)})}e.topAsync=f;function d(oe,ae,fe,ee,le){for(const re=fe.length;ee<le;ee++){const O=oe[ee];if(ae(O,fe[re-1])<0){fe.pop();const H=D(fe,x=>ae(O,x)<0);fe.splice(H,0,O)}}}function h(oe){return oe.filter(ae=>!!ae)}e.coalesce=h;function b(oe){let ae=0;for(let fe=0;fe<oe.length;fe++)oe[fe]&&(oe[ae]=oe[fe],ae+=1);oe.length=ae}e.coalesceInPlace=b;function g(oe,ae,fe){oe.splice(fe,0,oe.splice(ae,1)[0])}e.move=g;function p(oe){return!Array.isArray(oe)||oe.length===0}e.isFalsyOrEmpty=p;function w(oe){return Array.isArray(oe)&&oe.length>0}e.isNonEmptyArray=w;function i(oe,ae=fe=>fe){const fe=new Set;return oe.filter(ee=>{const le=ae(ee);return fe.has(le)?!1:(fe.add(le),!0)})}e.distinct=i;function s(oe){const ae=new Set;return fe=>{const ee=oe(fe);return ae.has(ee)?!1:(ae.add(ee),!0)}}e.uniqueFilter=s;function a(oe,ae){const fe=u(oe,ae);if(fe!==-1)return oe[fe]}e.findLast=a;function u(oe,ae){for(let fe=oe.length-1;fe>=0;fe--){const ee=oe[fe];if(ae(ee))return fe}return-1}e.lastIndex=u;function l(oe,ae){return oe.length>0?oe[0]:ae}e.firstOrDefault=l;function c(oe,ae){return oe.length>0?oe[oe.length-1]:ae}e.lastOrDefault=c;function n(oe,ae,fe=(ee,le)=>ee===le){let ee=0;for(let le=0,re=Math.min(oe.length,ae.length);le<re&&fe(oe[le],ae[le]);le++)ee++;return ee}e.commonPrefixLength=n;function r(oe){return[].concat(...oe)}e.flatten=r;function m(oe,ae){let fe=typeof ae=="number"?oe:0;typeof ae=="number"?fe=oe:(fe=0,ae=oe);const ee=[];if(fe<=ae)for(let le=fe;le<ae;le++)ee.push(le);else for(let le=fe;le>ae;le--)ee.push(le);return ee}e.range=m;function S(oe,ae,fe){return oe.reduce((ee,le)=>(ee[ae(le)]=fe?fe(le):le,ee),Object.create(null))}e.index=S;function k(oe,ae){return oe.push(ae),()=>M(oe,ae)}e.insert=k;function M(oe,ae){const fe=oe.indexOf(ae);if(fe>-1)return oe.splice(fe,1),ae}e.remove=M;function q(oe,ae,fe){const ee=oe.slice(0,ae),le=oe.slice(ae);return ee.concat(fe,le)}e.arrayInsert=q;function V(oe,ae){let fe;if(typeof ae=="number"){let ee=ae;fe=()=>{const le=Math.sin(ee++)*179426549;return le-Math.floor(le)}}else fe=Math.random;for(let ee=oe.length-1;ee>0;ee-=1){const le=Math.floor(fe()*(ee+1)),re=oe[ee];oe[ee]=oe[le],oe[le]=re}}e.shuffle=V;function F(oe,ae){const fe=oe.indexOf(ae);fe>-1&&(oe.splice(fe,1),oe.unshift(ae))}e.pushToStart=F;function U(oe,ae){const fe=oe.indexOf(ae);fe>-1&&(oe.splice(fe,1),oe.push(ae))}e.pushToEnd=U;function N(oe,ae){for(const fe of ae)oe.push(fe)}e.pushMany=N;function B(oe,ae){return Array.isArray(oe)?oe.map(ae):ae(oe)}e.mapArrayOrNot=B;function j(oe){return Array.isArray(oe)?oe:[oe]}e.asArray=j;function z(oe){return oe[Math.floor(Math.random()*oe.length)]}e.getRandomElement=z;function ne(oe,ae){for(const fe of oe){const ee=ae(fe);if(ee!==void 0)return ee}}e.mapFind=ne;function _(oe,ae,fe){const ee=J(oe,ae),le=oe.length,re=fe.length;oe.length=le+re;for(let O=le-1;O>=ee;O--)oe[O+re]=oe[O];for(let O=0;O<re;O++)oe[O+ee]=fe[O]}e.insertInto=_;function Y(oe,ae,fe,ee){const le=J(oe,ae),re=oe.splice(le,fe);return _(oe,le,ee),re}e.splice=Y;function J(oe,ae){return ae<0?Math.max(ae+oe.length,0):Math.min(ae,oe.length)}var Z;(function(oe){function ae(le){return le<0}oe.isLessThan=ae;function fe(le){return le>0}oe.isGreaterThan=fe;function ee(le){return le===0}oe.isNeitherLessOrGreaterThan=ee,oe.greaterThan=1,oe.lessThan=-1,oe.neitherLessOrGreaterThan=0})(Z=e.CompareResult||(e.CompareResult={}));function ie(oe,ae){return(fe,ee)=>ae(oe(fe),oe(ee))}e.compareBy=ie;function X(...oe){return(ae,fe)=>{for(const ee of oe){const le=ee(ae,fe);if(!Z.isNeitherLessOrGreaterThan(le))return le}return Z.neitherLessOrGreaterThan}}e.tieBreakComparators=X;const K=(oe,ae)=>oe-ae;e.numberComparator=K;function he(oe,ae){if(oe.length===0)return;let fe=oe[0];for(let ee=1;ee<oe.length;ee++){const le=oe[ee];ae(le,fe)>0&&(fe=le)}return fe}e.findMaxBy=he;function be(oe,ae){if(oe.length===0)return;let fe=oe[0];for(let ee=1;ee<oe.length;ee++){const le=oe[ee];ae(le,fe)>=0&&(fe=le)}return fe}e.findLastMaxBy=be;function Ee(oe,ae){return he(oe,(fe,ee)=>-ae(fe,ee))}e.findMinBy=Ee;class Pe{constructor(ae){this.f=ae,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(ae){let fe=this.c;for(;fe<this.f.length&&ae(this.f[fe]);)fe++;const ee=fe===this.c?null:this.f.slice(this.c,fe);return this.c=fe,ee}takeFromEndWhile(ae){let fe=this.d;for(;fe>=0&&ae(this.f[fe]);)fe--;const ee=fe===this.d?null:this.f.slice(fe+1,this.d+1);return this.d=fe,ee}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const ae=this.f[this.c];return this.c++,ae}removeLast(){const ae=this.f[this.d];return this.d--,ae}takeCount(ae){const fe=this.f.slice(this.c,this.c+ae);return this.c+=ae,fe}}e.ArrayQueue=Pe;class Me{constructor(ae){this.iterate=ae}forEach(ae){this.iterate(fe=>(ae(fe),!0))}toArray(){const ae=[];return this.iterate(fe=>(ae.push(fe),!0)),ae}filter(ae){return new Me(fe=>this.iterate(ee=>ae(ee)?fe(ee):!0))}map(ae){return new Me(fe=>this.iterate(ee=>fe(ae(ee))))}some(ae){let fe=!1;return this.iterate(ee=>(fe=ae(ee),!fe)),fe}findFirst(ae){let fe;return this.iterate(ee=>ae(ee)?(fe=ee,!1):!0),fe}findLast(ae){let fe;return this.iterate(ee=>(ae(ee)&&(fe=ee),!0)),fe}findLastMaxBy(ae){let fe,ee=!0;return this.iterate(le=>((ee||Z.isGreaterThan(ae(le,fe)))&&(ee=!1,fe=le),!0)),fe}}e.CallbackIterable=Me,Me.empty=new Me(oe=>{})}),define(ye[50],Ce([1,0,9]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function t(y,D){if(!y)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=t;function T(y,D="Unreachable"){throw new Error(D)}e.assertNever=T;function R(y){if(!y)throw new o.BugIndicatingError("Assertion Failed")}e.assert=R;function I(y){if(!y()){debugger;y(),(0,o.onUnexpectedError)(new o.BugIndicatingError("Assertion Failed"))}}e.assertFn=I;function A(y,D){let L=0;for(;L<y.length-1;){const P=y[L],v=y[L+1];if(!D(P,v))return!1;L++}return!0}e.checkAdjacentItems=A}),define(ye[61],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function o(t){const T=this;let R=!1,I;return function(){return R||(R=!0,I=t.apply(T,arguments)),I}}e.once=o}),define(ye[100],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class o{constructor(T){this.a=T,this.b=0}nextId(){return this.a+ ++this.b}}e.IdGenerator=o,e.defaultGenerator=new o("id#")}),define(ye[62],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var o;(function(t){function T(p){return p&&typeof p=="object"&&typeof p[Symbol.iterator]=="function"}t.is=T;const R=Object.freeze([]);function I(){return R}t.empty=I;function*A(p){yield p}t.single=A;function y(p){return T(p)?p:A(p)}t.wrap=y;function D(p){return p||R}t.from=D;function L(p){return!p||p[Symbol.iterator]().next().done===!0}t.isEmpty=L;function P(p){return p[Symbol.iterator]().next().value}t.first=P;function v(p,w){for(const i of p)if(w(i))return!0;return!1}t.some=v;function C(p,w){for(const i of p)if(w(i))return i}t.find=C;function*E(p,w){for(const i of p)w(i)&&(yield i)}t.filter=E;function*f(p,w){let i=0;for(const s of p)yield w(s,i++)}t.map=f;function*d(...p){for(const w of p)for(const i of w)yield i}t.concat=d;function h(p,w,i){let s=i;for(const a of p)s=w(s,a);return s}t.reduce=h;function*b(p,w,i=p.length){for(w<0&&(w+=p.length),i<0?i+=p.length:i>p.length&&(i=p.length);w<i;w++)yield p[w]}t.slice=b;function g(p,w=Number.POSITIVE_INFINITY){const i=[];if(w===0)return[i,p];const s=p[Symbol.iterator]();for(let a=0;a<w;a++){const u=s.next();if(u.done)return[i,t.empty()];i.push(u.value)}return[i,{[Symbol.iterator](){return s}}]}t.consume=g})(o=e.Iterable||(e.Iterable={}))}),define(ye[146],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var o;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(o=e.ScanError||(e.ScanError={}));var t;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var T;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(T=e.ParseErrorCode||(e.ParseErrorCode={}));var R;(function(i){i.DEFAULT={allowTrailingComma:!0}})(R=e.ParseOptions||(e.ParseOptions={}));function I(i,s=!1){let a=0;const u=i.length;let l="",c=0,n=16,r=0;function m(U){let N=0,B=0;for(;N<U;){const j=i.charCodeAt(a);if(j>=48&&j<=57)B=B*16+j-48;else if(j>=65&&j<=70)B=B*16+j-65+10;else if(j>=97&&j<=102)B=B*16+j-97+10;else break;a++,N++}return N<U&&(B=-1),B}function S(U){a=U,l="",c=0,n=16,r=0}function k(){const U=a;if(i.charCodeAt(a)===48)a++;else for(a++;a<i.length&&D(i.charCodeAt(a));)a++;if(a<i.length&&i.charCodeAt(a)===46)if(a++,a<i.length&&D(i.charCodeAt(a)))for(a++;a<i.length&&D(i.charCodeAt(a));)a++;else return r=3,i.substring(U,a);let N=a;if(a<i.length&&(i.charCodeAt(a)===69||i.charCodeAt(a)===101))if(a++,(a<i.length&&i.charCodeAt(a)===43||i.charCodeAt(a)===45)&&a++,a<i.length&&D(i.charCodeAt(a))){for(a++;a<i.length&&D(i.charCodeAt(a));)a++;N=a}else r=3;return i.substring(U,N)}function M(){let U="",N=a;for(;;){if(a>=u){U+=i.substring(N,a),r=2;break}const B=i.charCodeAt(a);if(B===34){U+=i.substring(N,a),a++;break}if(B===92){if(U+=i.substring(N,a),a++,a>=u){r=2;break}switch(i.charCodeAt(a++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:{const z=m(4);z>=0?U+=String.fromCharCode(z):r=4;break}default:r=5}N=a;continue}if(B>=0&&B<=31)if(y(B)){U+=i.substring(N,a),r=2;break}else r=6;a++}return U}function q(){if(l="",r=0,c=a,a>=u)return c=u,n=17;let U=i.charCodeAt(a);if(A(U)){do a++,l+=String.fromCharCode(U),U=i.charCodeAt(a);while(A(U));return n=15}if(y(U))return a++,l+=String.fromCharCode(U),U===13&&i.charCodeAt(a)===10&&(a++,l+=`
`),n=14;switch(U){case 123:return a++,n=1;case 125:return a++,n=2;case 91:return a++,n=3;case 93:return a++,n=4;case 58:return a++,n=6;case 44:return a++,n=5;case 34:return a++,l=M(),n=10;case 47:{const N=a-1;if(i.charCodeAt(a+1)===47){for(a+=2;a<u&&!y(i.charCodeAt(a));)a++;return l=i.substring(N,a),n=12}if(i.charCodeAt(a+1)===42){a+=2;const B=u-1;let j=!1;for(;a<B;){if(i.charCodeAt(a)===42&&i.charCodeAt(a+1)===47){a+=2,j=!0;break}a++}return j||(a++,r=1),l=i.substring(N,a),n=13}return l+=String.fromCharCode(U),a++,n=16}case 45:if(l+=String.fromCharCode(U),a++,a===u||!D(i.charCodeAt(a)))return n=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=k(),n=11;default:for(;a<u&&V(U);)a++,U=i.charCodeAt(a);if(c!==a){switch(l=i.substring(c,a),l){case"true":return n=8;case"false":return n=9;case"null":return n=7}return n=16}return l+=String.fromCharCode(U),a++,n=16}}function V(U){if(A(U)||y(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let U;do U=q();while(U>=12&&U<=15);return U}return{setPosition:S,getPosition:()=>a,scan:s?F:q,getToken:()=>n,getTokenValue:()=>l,getTokenOffset:()=>c,getTokenLength:()=>a-c,getTokenError:()=>r}}e.createScanner=I;function A(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function y(i){return i===10||i===13||i===8232||i===8233}function D(i){return i>=48&&i<=57}var L;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(L||(L={}));function P(i,s){const a=[],u=new Object;let l;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let n=!1;function r(m,S,k,M){c.value=m,c.offset=S,c.length=k,c.type=M,c.colonOffset=void 0,l=c}try{g(i,{onObjectBegin:(m,S)=>{if(s<=m)throw u;l=void 0,n=s>m,a.push("")},onObjectProperty:(m,S,k)=>{if(s<S||(r(m,S,k,"property"),a[a.length-1]=m,s<=S+k))throw u},onObjectEnd:(m,S)=>{if(s<=m)throw u;l=void 0,a.pop()},onArrayBegin:(m,S)=>{if(s<=m)throw u;l=void 0,a.push(0)},onArrayEnd:(m,S)=>{if(s<=m)throw u;l=void 0,a.pop()},onLiteralValue:(m,S,k)=>{if(s<S||(r(m,S,k,w(m)),s<=S+k))throw u},onSeparator:(m,S,k)=>{if(s<=S)throw u;if(m===":"&&l&&l.type==="property")l.colonOffset=S,n=!1,l=void 0;else if(m===","){const M=a[a.length-1];typeof M=="number"?a[a.length-1]=M+1:(n=!0,a[a.length-1]=""),l=void 0}}})}catch(m){if(m!==u)throw m}return{path:a,previousNode:l,isAtPropertyKey:n,matches:m=>{let S=0;for(let k=0;S<m.length&&k<a.length;k++)if(m[S]===a[k]||m[S]==="*")S++;else if(m[S]!=="**")return!1;return S===m.length}}}e.getLocation=P;function v(i,s=[],a=R.DEFAULT){let u=null,l=[];const c=[];function n(m){Array.isArray(l)?l.push(m):u!==null&&(l[u]=m)}return g(i,{onObjectBegin:()=>{const m={};n(m),c.push(l),l=m,u=null},onObjectProperty:m=>{u=m},onObjectEnd:()=>{l=c.pop()},onArrayBegin:()=>{const m=[];n(m),c.push(l),l=m,u=null},onArrayEnd:()=>{l=c.pop()},onLiteralValue:n,onError:(m,S,k)=>{s.push({error:m,offset:S,length:k})}},a),l[0]}e.parse=v;function C(i,s=[],a=R.DEFAULT){let u={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(m){u.type==="property"&&(u.length=m-u.offset,u=u.parent)}function c(m){return u.children.push(m),m}g(i,{onObjectBegin:m=>{u=c({type:"object",offset:m,length:-1,parent:u,children:[]})},onObjectProperty:(m,S,k)=>{u=c({type:"property",offset:S,length:-1,parent:u,children:[]}),u.children.push({type:"string",value:m,offset:S,length:k,parent:u})},onObjectEnd:(m,S)=>{u.length=m+S-u.offset,u=u.parent,l(m+S)},onArrayBegin:(m,S)=>{u=c({type:"array",offset:m,length:-1,parent:u,children:[]})},onArrayEnd:(m,S)=>{u.length=m+S-u.offset,u=u.parent,l(m+S)},onLiteralValue:(m,S,k)=>{c({type:w(m),offset:S,length:k,parent:u,value:m}),l(S+k)},onSeparator:(m,S,k)=>{u.type==="property"&&(m===":"?u.colonOffset=S:m===","&&l(S))},onError:(m,S,k)=>{s.push({error:m,offset:S,length:k})}},a);const r=u.children[0];return r&&delete r.parent,r}e.parseTree=C;function E(i,s){if(!i)return;let a=i;for(const u of s)if(typeof u=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let l=!1;for(const c of a.children)if(Array.isArray(c.children)&&c.children[0].value===u){a=c.children[1],l=!0;break}if(!l)return}else{const l=u;if(a.type!=="array"||l<0||!Array.isArray(a.children)||l>=a.children.length)return;a=a.children[l]}return a}e.findNodeAtLocation=E;function f(i){if(!i.parent||!i.parent.children)return[];const s=f(i.parent);if(i.parent.type==="property"){const a=i.parent.children[0].value;s.push(a)}else if(i.parent.type==="array"){const a=i.parent.children.indexOf(i);a!==-1&&s.push(a)}return s}e.getNodePath=f;function d(i){switch(i.type){case"array":return i.children.map(d);case"object":{const s=Object.create(null);for(const a of i.children){const u=a.children[1];u&&(s[a.children[0].value]=d(u))}return s}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=d;function h(i,s,a=!1){return s>=i.offset&&s<i.offset+i.length||a&&s===i.offset+i.length}e.contains=h;function b(i,s,a=!1){if(h(i,s,a)){const u=i.children;if(Array.isArray(u))for(let l=0;l<u.length&&u[l].offset<=s;l++){const c=b(u[l],s,a);if(c)return c}return i}}e.findNodeAtOffset=b;function g(i,s,a=R.DEFAULT){const u=I(i,!1);function l(ie){return ie?()=>ie(u.getTokenOffset(),u.getTokenLength()):()=>!0}function c(ie){return ie?X=>ie(X,u.getTokenOffset(),u.getTokenLength()):()=>!0}const n=l(s.onObjectBegin),r=c(s.onObjectProperty),m=l(s.onObjectEnd),S=l(s.onArrayBegin),k=l(s.onArrayEnd),M=c(s.onLiteralValue),q=c(s.onSeparator),V=l(s.onComment),F=c(s.onError),U=a&&a.disallowComments,N=a&&a.allowTrailingComma;function B(){for(;;){const ie=u.scan();switch(u.getTokenError()){case 4:j(14);break;case 5:j(15);break;case 3:j(13);break;case 1:U||j(11);break;case 2:j(12);break;case 6:j(16);break}switch(ie){case 12:case 13:U?j(10):V();break;case 16:j(1);break;case 15:case 14:break;default:return ie}}}function j(ie,X=[],K=[]){if(F(ie),X.length+K.length>0){let he=u.getToken();for(;he!==17;){if(X.indexOf(he)!==-1){B();break}else if(K.indexOf(he)!==-1)break;he=B()}}}function z(ie){const X=u.getTokenValue();return ie?M(X):r(X),B(),!0}function ne(){switch(u.getToken()){case 11:{let ie=0;try{ie=JSON.parse(u.getTokenValue()),typeof ie!="number"&&(j(2),ie=0)}catch{j(2)}M(ie);break}case 7:M(null);break;case 8:M(!0);break;case 9:M(!1);break;default:return!1}return B(),!0}function _(){return u.getToken()!==10?(j(3,[],[2,5]),!1):(z(!1),u.getToken()===6?(q(":"),B(),Z()||j(4,[],[2,5])):j(5,[],[2,5]),!0)}function Y(){n(),B();let ie=!1;for(;u.getToken()!==2&&u.getToken()!==17;){if(u.getToken()===5){if(ie||j(4,[],[]),q(","),B(),u.getToken()===2&&N)break}else ie&&j(6,[],[]);_()||j(4,[],[2,5]),ie=!0}return m(),u.getToken()!==2?j(7,[2],[]):B(),!0}function J(){S(),B();let ie=!1;for(;u.getToken()!==4&&u.getToken()!==17;){if(u.getToken()===5){if(ie||j(4,[],[]),q(","),B(),u.getToken()===4&&N)break}else ie&&j(6,[],[]);Z()||j(4,[],[4,5]),ie=!0}return k(),u.getToken()!==4?j(8,[4],[]):B(),!0}function Z(){switch(u.getToken()){case 3:return J();case 1:return Y();case 10:return z(!0);default:return ne()}}return B(),u.getToken()===17?a.allowEmptyContent?!0:(j(4,[],[]),!1):Z()?(u.getToken()!==17&&j(9,[],[]),!0):(j(4,[],[]),!1)}e.visit=g;function p(i,s){const a=I(i),u=[];let l,c=0,n;do switch(n=a.getPosition(),l=a.scan(),l){case 12:case 13:case 17:c!==n&&u.push(i.substring(c,n)),s!==void 0&&u.push(a.getTokenValue().replace(/[^\r\n]/g,s)),c=a.getPosition();break}while(l!==17);return u.join("")}e.stripComments=p;function w(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=w}),define(ye[82],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class o{constructor(T){this.d=T,this.a=!1}hasValue(){return this.a}getValue(){if(!this.a)try{this.b=this.d()}catch(T){this.c=T}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}map(T){return new o(()=>T(this.getValue()))}}e.Lazy=o}),define(ye[6],Ce([1,0,61,62]),function(te,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const T=!1;let R=null;function I(c){R=c}if(e.setDisposableTracker=I,T){const c="__is_disposable_tracked__";I(new class{trackDisposable(n){const r=new Error("Potentially leaked disposable").stack;setTimeout(()=>{n[c]||console.log(r)},3e3)}setParent(n,r){if(n&&n!==b.None)try{n[c]=!0}catch{}}markAsDisposed(n){if(n&&n!==b.None)try{n[c]=!0}catch{}}markAsSingleton(n){}})}function A(c){return R?.trackDisposable(c),c}function y(c){R?.markAsDisposed(c)}function D(c,n){R?.setParent(c,n)}function L(c,n){if(!!R)for(const r of c)R.setParent(r,n)}function P(c){return R?.markAsSingleton(c),c}e.markAsSingleton=P;function v(c){return typeof c.dispose=="function"&&c.dispose.length===0}e.isDisposable=v;function C(c){if(t.Iterable.is(c)){const n=[];for(const r of c)if(r)try{r.dispose()}catch(m){n.push(m)}if(n.length===1)throw n[0];if(n.length>1)throw new AggregateError(n,"Encountered errors while disposing of store");return Array.isArray(c)?[]:c}else if(c)return c.dispose(),c}e.dispose=C;function E(c){for(const n of c)v(n)&&n.dispose();return[]}e.disposeIfDisposable=E;function f(...c){const n=d(()=>C(c));return L(c,n),n}e.combinedDisposable=f;function d(c){const n=A({dispose:(0,o.once)(()=>{y(n),c()})});return n}e.toDisposable=d;class h{constructor(){this.c=new Set,this.f=!1,A(this)}dispose(){this.f||(y(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{C(this.c)}finally{this.c.clear()}}add(n){if(!n)return n;if(n===this)throw new Error("Cannot register a disposable on itself!");return D(n,this),this.f?h.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(n),n}}e.DisposableStore=h,h.DISABLE_DISPOSED_WARNING=!1;class b{constructor(){this.q=new h,A(this),D(this.q,this)}dispose(){y(this),this.q.dispose()}B(n){if(n===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(n)}}e.Disposable=b,b.None=Object.freeze({dispose(){}});class g{constructor(){this.b=!1,A(this)}get value(){return this.b?void 0:this.a}set value(n){this.b||n===this.a||(this.a?.dispose(),n&&D(n,this),this.a=n)}clear(){this.value=void 0}dispose(){this.b=!0,y(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const n=this.a;return this.a=void 0,n&&D(n,null),n}}e.MutableDisposable=g;class p{constructor(n){this.b=n,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=p;class w{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,A(this)}set(n){let r=n;return this.unset=()=>r=void 0,this.isset=()=>r!==void 0,this.dispose=()=>{r&&(r(),r=void 0,y(this))},this}}e.SafeDisposable=w;class i{constructor(){this.a=new Map}acquire(n,...r){let m=this.a.get(n);m||(m={counter:0,object:this.b(n,...r)},this.a.set(n,m));const{object:S}=m,k=(0,o.once)(()=>{--m.counter===0&&(this.c(n,m.object),this.a.delete(n))});return m.counter++,{object:S,dispose:k}}}e.ReferenceCollection=i;class s{constructor(n){this.a=n}async acquire(n,...r){const m=this.a.acquire(n,...r);try{return{object:await m.object,dispose:()=>m.dispose()}}catch(S){throw m.dispose(),S}}}e.AsyncReferenceCollection=s;class a{constructor(n){this.object=n}dispose(){}}e.ImmortalReference=a;function u(c){const n=new h;try{c(n)}finally{n.dispose()}}e.disposeOnReturn=u;class l{constructor(){this.a=new Map,this.b=!1,A(this)}dispose(){y(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{C(this.a.values())}finally{this.a.clear()}}has(n){return this.a.has(n)}get(n){return this.a.get(n)}set(n,r,m=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),m||this.a.get(n)?.dispose(),this.a.set(n,r)}deleteAndDispose(n){this.a.get(n)?.dispose(),this.a.delete(n)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=l}),define(ye[63],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class o{constructor(R){this.element=R,this.next=o.Undefined,this.prev=o.Undefined}}o.Undefined=new o(void 0);class t{constructor(){this.a=o.Undefined,this.b=o.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===o.Undefined}clear(){let R=this.a;for(;R!==o.Undefined;){const I=R.next;R.prev=o.Undefined,R.next=o.Undefined,R=I}this.a=o.Undefined,this.b=o.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,I){const A=new o(R);if(this.a===o.Undefined)this.a=A,this.b=A;else if(I){const D=this.b;this.b=A,A.prev=D,D.next=A}else{const D=this.a;this.a=A,A.next=D,D.prev=A}this.c+=1;let y=!1;return()=>{y||(y=!0,this.e(A))}}shift(){if(this.a!==o.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==o.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==o.Undefined&&R.next!==o.Undefined){const I=R.prev;I.next=R.next,R.next.prev=I}else R.prev===o.Undefined&&R.next===o.Undefined?(this.a=o.Undefined,this.b=o.Undefined):R.next===o.Undefined?(this.b=this.b.prev,this.b.next=o.Undefined):R.prev===o.Undefined&&(this.a=this.a.next,this.a.prev=o.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==o.Undefined;)yield R.element,R=R.next}}e.LinkedList=t}),define(ye[28],Ce([1,0]),function(te,e){"use strict";var o,t,T;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function R(E,f,d){let h=E.get(f);return h===void 0&&(h=d,E.set(f,h)),h}e.getOrSet=R;function I(E){const f=[];return E.forEach((d,h)=>{f.push(`${h} => ${d}`)}),`Map(${E.size}) {${f.join(", ")}}`}e.mapToString=I;function A(E){const f=[];return E.forEach(d=>{f.push(d)}),`Set(${E.size}) {${f.join(", ")}}`}e.setToString=A;class y{constructor(f,d){this.uri=f,this.value=d}}class D{constructor(f,d){this[o]="ResourceMap",f instanceof D?(this.b=new Map(f.b),this.c=d??D.a):(this.b=new Map,this.c=f??D.a)}set(f,d){return this.b.set(this.c(f),new y(f,d)),this}get(f){return this.b.get(this.c(f))?.value}has(f){return this.b.has(this.c(f))}get size(){return this.b.size}clear(){this.b.clear()}delete(f){return this.b.delete(this.c(f))}forEach(f,d){typeof d<"u"&&(f=f.bind(d));for(const[h,b]of this.b)f(b.value,b.uri,this)}*values(){for(const f of this.b.values())yield f.value}*keys(){for(const f of this.b.values())yield f.uri}*entries(){for(const f of this.b.values())yield[f.uri,f.value]}*[(o=Symbol.toStringTag,Symbol.iterator)](){for(const[,f]of this.b)yield[f.uri,f.value]}}e.ResourceMap=D,D.a=E=>E.toString();class L{constructor(f,d){this[t]="ResourceSet",!f||typeof f=="function"?this.a=new D(f):(this.a=new D(d),f.forEach(this.add,this))}get size(){return this.a.size}add(f){return this.a.set(f,f),this}clear(){this.a.clear()}delete(f){return this.a.delete(f)}forEach(f,d){this.a.forEach((h,b)=>f.call(d,b,b,this))}has(f){return this.a.has(f)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=L;var P;(function(E){E[E.None=0]="None",E[E.AsOld=1]="AsOld",E[E.AsNew=2]="AsNew"})(P=e.Touch||(e.Touch={}));class v{constructor(){this[T]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(f){return this.a.has(f)}get(f,d=0){const h=this.a.get(f);if(!!h)return d!==0&&this.j(h,d),h.value}set(f,d,h=0){let b=this.a.get(f);if(b)b.value=d,h!==0&&this.j(b,h);else{switch(b={key:f,value:d,next:void 0,previous:void 0},h){case 0:this.h(b);break;case 1:this.g(b);break;case 2:this.h(b);break;default:this.h(b);break}this.a.set(f,b),this.d++}return this}delete(f){return!!this.remove(f)}remove(f){const d=this.a.get(f);if(!!d)return this.a.delete(f),this.i(d),this.d--,d.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const f=this.b;return this.a.delete(f.key),this.i(f),this.d--,f.value}forEach(f,d){const h=this.e;let b=this.b;for(;b;){if(d?f.bind(d)(b.value,b.key,this):f(b.value,b.key,this),this.e!==h)throw new Error("LinkedMap got modified during iteration.");b=b.next}}keys(){const f=this,d=this.e;let h=this.b;const b={[Symbol.iterator](){return b},next(){if(f.e!==d)throw new Error("LinkedMap got modified during iteration.");if(h){const g={value:h.key,done:!1};return h=h.next,g}else return{value:void 0,done:!0}}};return b}values(){const f=this,d=this.e;let h=this.b;const b={[Symbol.iterator](){return b},next(){if(f.e!==d)throw new Error("LinkedMap got modified during iteration.");if(h){const g={value:h.value,done:!1};return h=h.next,g}else return{value:void 0,done:!0}}};return b}entries(){const f=this,d=this.e;let h=this.b;const b={[Symbol.iterator](){return b},next(){if(f.e!==d)throw new Error("LinkedMap got modified during iteration.");if(h){const g={value:[h.key,h.value],done:!1};return h=h.next,g}else return{value:void 0,done:!0}}};return b}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(f){if(f>=this.size)return;if(f===0){this.clear();return}let d=this.b,h=this.size;for(;d&&h>f;)this.a.delete(d.key),d=d.next,h--;this.b=d,this.d=h,d&&(d.previous=void 0),this.e++}g(f){if(!this.b&&!this.c)this.c=f;else if(this.b)f.next=this.b,this.b.previous=f;else throw new Error("Invalid list");this.b=f,this.e++}h(f){if(!this.b&&!this.c)this.b=f;else if(this.c)f.previous=this.c,this.c.next=f;else throw new Error("Invalid list");this.c=f,this.e++}i(f){if(f===this.b&&f===this.c)this.b=void 0,this.c=void 0;else if(f===this.b){if(!f.next)throw new Error("Invalid list");f.next.previous=void 0,this.b=f.next}else if(f===this.c){if(!f.previous)throw new Error("Invalid list");f.previous.next=void 0,this.c=f.previous}else{const d=f.next,h=f.previous;if(!d||!h)throw new Error("Invalid list");d.previous=h,h.next=d}f.next=void 0,f.previous=void 0,this.e++}j(f,d){if(!this.b||!this.c)throw new Error("Invalid list");if(!(d!==1&&d!==2)){if(d===1){if(f===this.b)return;const h=f.next,b=f.previous;f===this.c?(b.next=void 0,this.c=b):(h.previous=b,b.next=h),f.previous=void 0,f.next=this.b,this.b.previous=f,this.b=f,this.e++}else if(d===2){if(f===this.c)return;const h=f.next,b=f.previous;f===this.b?(h.previous=void 0,this.b=h):(h.previous=b,b.next=h),f.next=void 0,f.previous=this.c,this.c.next=f,this.c=f,this.e++}}}toJSON(){const f=[];return this.forEach((d,h)=>{f.push([h,d])}),f}fromJSON(f){this.clear();for(const[d,h]of f)this.set(d,h)}}e.LinkedMap=v;class C extends v{constructor(f,d=1){super(),this.k=f,this.l=Math.min(Math.max(0,d),1)}get limit(){return this.k}set limit(f){this.k=f,this.m()}get ratio(){return this.l}set ratio(f){this.l=Math.min(Math.max(0,f),1),this.m()}get(f,d=2){return super.get(f,d)}peek(f){return super.get(f,0)}set(f,d){return super.set(f,d,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=C}),function(te,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(ye[147],Ce([0]),e):(te=typeof globalThis<"u"?globalThis:te||self,e(te.marked={}))}(this,function(te){"use strict";function e(oe,ae){for(var fe=0;fe<ae.length;fe++){var ee=ae[fe];ee.enumerable=ee.enumerable||!1,ee.configurable=!0,"value"in ee&&(ee.writable=!0),Object.defineProperty(oe,ee.key,ee)}}function o(oe,ae,fe){return ae&&e(oe.prototype,ae),fe&&e(oe,fe),Object.defineProperty(oe,"prototype",{writable:!1}),oe}function t(oe,ae){if(!!oe){if(typeof oe=="string")return T(oe,ae);var fe=Object.prototype.toString.call(oe).slice(8,-1);if(fe==="Object"&&oe.constructor&&(fe=oe.constructor.name),fe==="Map"||fe==="Set")return Array.from(oe);if(fe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(fe))return T(oe,ae)}}function T(oe,ae){(ae==null||ae>oe.length)&&(ae=oe.length);for(var fe=0,ee=new Array(ae);fe<ae;fe++)ee[fe]=oe[fe];return ee}function R(oe,ae){var fe=typeof Symbol<"u"&&oe[Symbol.iterator]||oe["@@iterator"];if(fe)return(fe=fe.call(oe)).next.bind(fe);if(Array.isArray(oe)||(fe=t(oe))||ae&&oe&&typeof oe.length=="number"){fe&&(oe=fe);var ee=0;return function(){return ee>=oe.length?{done:!0}:{done:!1,value:oe[ee++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function I(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}te.defaults=I();function A(oe){te.defaults=oe}var y=/[&<>"']/,D=/[&<>"']/g,L=/[<>"']|&(?!#?\w+;)/,P=/[<>"']|&(?!#?\w+;)/g,v={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},C=function(ae){return v[ae]};function E(oe,ae){if(ae){if(y.test(oe))return oe.replace(D,C)}else if(L.test(oe))return oe.replace(P,C);return oe}var f=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function d(oe){return oe.replace(f,function(ae,fe){return fe=fe.toLowerCase(),fe==="colon"?":":fe.charAt(0)==="#"?fe.charAt(1)==="x"?String.fromCharCode(parseInt(fe.substring(2),16)):String.fromCharCode(+fe.substring(1)):""})}var h=/(^|[^\[])\^/g;function b(oe,ae){oe=typeof oe=="string"?oe:oe.source,ae=ae||"";var fe={replace:function(le,re){return re=re.source||re,re=re.replace(h,"$1"),oe=oe.replace(le,re),fe},getRegex:function(){return new RegExp(oe,ae)}};return fe}var g=/[^\w:]/g,p=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function w(oe,ae,fe){if(oe){var ee;try{ee=decodeURIComponent(d(fe)).replace(g,"").toLowerCase()}catch{return null}if(ee.indexOf("javascript:")===0||ee.indexOf("vbscript:")===0||ee.indexOf("data:")===0)return null}ae&&!p.test(fe)&&(fe=l(ae,fe));try{fe=encodeURI(fe).replace(/%25/g,"%")}catch{return null}return fe}var i={},s=/^[^:]+:\/*[^/]*$/,a=/^([^:]+:)[\s\S]*$/,u=/^([^:]+:\/*[^/]*)[\s\S]*$/;function l(oe,ae){i[" "+oe]||(s.test(oe)?i[" "+oe]=oe+"/":i[" "+oe]=m(oe,"/",!0)),oe=i[" "+oe];var fe=oe.indexOf(":")===-1;return ae.substring(0,2)==="//"?fe?ae:oe.replace(a,"$1")+ae:ae.charAt(0)==="/"?fe?ae:oe.replace(u,"$1")+ae:oe+ae}var c={exec:function(){}};function n(oe){for(var ae=1,fe,ee;ae<arguments.length;ae++){fe=arguments[ae];for(ee in fe)Object.prototype.hasOwnProperty.call(fe,ee)&&(oe[ee]=fe[ee])}return oe}function r(oe,ae){var fe=oe.replace(/\|/g,function(re,O,H){for(var x=!1,Q=O;--Q>=0&&H[Q]==="\\";)x=!x;return x?"|":" |"}),ee=fe.split(/ \|/),le=0;if(ee[0].trim()||ee.shift(),ee.length>0&&!ee[ee.length-1].trim()&&ee.pop(),ee.length>ae)ee.splice(ae);else for(;ee.length<ae;)ee.push("");for(;le<ee.length;le++)ee[le]=ee[le].trim().replace(/\\\|/g,"|");return ee}function m(oe,ae,fe){var ee=oe.length;if(ee===0)return"";for(var le=0;le<ee;){var re=oe.charAt(ee-le-1);if(re===ae&&!fe)le++;else if(re!==ae&&fe)le++;else break}return oe.slice(0,ee-le)}function S(oe,ae){if(oe.indexOf(ae[1])===-1)return-1;for(var fe=oe.length,ee=0,le=0;le<fe;le++)if(oe[le]==="\\")le++;else if(oe[le]===ae[0])ee++;else if(oe[le]===ae[1]&&(ee--,ee<0))return le;return-1}function k(oe){oe&&oe.sanitize&&!oe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function M(oe,ae){if(ae<1)return"";for(var fe="";ae>1;)ae&1&&(fe+=oe),ae>>=1,oe+=oe;return fe+oe}function q(oe,ae,fe,ee){var le=ae.href,re=ae.title?E(ae.title):null,O=oe[1].replace(/\\([\[\]])/g,"$1");if(oe[0].charAt(0)!=="!"){ee.state.inLink=!0;var H={type:"link",raw:fe,href:le,title:re,text:O,tokens:ee.inlineTokens(O)};return ee.state.inLink=!1,H}return{type:"image",raw:fe,href:le,title:re,text:E(O)}}function V(oe,ae){var fe=oe.match(/^(\s+)(?:```)/);if(fe===null)return ae;var ee=fe[1];return ae.split(`
`).map(function(le){var re=le.match(/^\s+/);if(re===null)return le;var O=re[0];return O.length>=ee.length?le.slice(ee.length):le}).join(`
`)}var F=function(){function oe(fe){this.options=fe||te.defaults}var ae=oe.prototype;return ae.space=function(ee){var le=this.rules.block.newline.exec(ee);if(le&&le[0].length>0)return{type:"space",raw:le[0]}},ae.code=function(ee){var le=this.rules.block.code.exec(ee);if(le){var re=le[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:le[0],codeBlockStyle:"indented",text:this.options.pedantic?re:m(re,`
`)}}},ae.fences=function(ee){var le=this.rules.block.fences.exec(ee);if(le){var re=le[0],O=V(re,le[3]||"");return{type:"code",raw:re,lang:le[2]?le[2].trim():le[2],text:O}}},ae.heading=function(ee){var le=this.rules.block.heading.exec(ee);if(le){var re=le[2].trim();if(/#$/.test(re)){var O=m(re,"#");(this.options.pedantic||!O||/ $/.test(O))&&(re=O.trim())}return{type:"heading",raw:le[0],depth:le[1].length,text:re,tokens:this.lexer.inline(re)}}},ae.hr=function(ee){var le=this.rules.block.hr.exec(ee);if(le)return{type:"hr",raw:le[0]}},ae.blockquote=function(ee){var le=this.rules.block.blockquote.exec(ee);if(le){var re=le[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:le[0],tokens:this.lexer.blockTokens(re,[]),text:re}}},ae.list=function(ee){var le=this.rules.block.list.exec(ee);if(le){var re,O,H,x,Q,de,we,Ae,pe,De,ke,je,Ge=le[1].trim(),et=Ge.length>1,_e={type:"list",raw:"",ordered:et,start:et?+Ge.slice(0,-1):"",loose:!1,items:[]};Ge=et?"\\d{1,9}\\"+Ge.slice(-1):"\\"+Ge,this.options.pedantic&&(Ge=et?Ge:"[*+-]");for(var nt=new RegExp("^( {0,3}"+Ge+")((?:[	 ][^\\n]*)?(?:\\n|$))");ee&&(je=!1,!(!(le=nt.exec(ee))||this.rules.block.hr.test(ee)));){if(re=le[0],ee=ee.substring(re.length),Ae=le[2].split(`
`,1)[0],pe=ee.split(`
`,1)[0],this.options.pedantic?(x=2,ke=Ae.trimLeft()):(x=le[2].search(/[^ ]/),x=x>4?1:x,ke=Ae.slice(x),x+=le[1].length),de=!1,!Ae&&/^ *$/.test(pe)&&(re+=pe+`
`,ee=ee.substring(pe.length+1),je=!0),!je)for(var st=new RegExp("^ {0,"+Math.min(3,x-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),ht=new RegExp("^ {0,"+Math.min(3,x-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Fe=new RegExp("^ {0,"+Math.min(3,x-1)+"}(?:```|~~~)"),it=new RegExp("^ {0,"+Math.min(3,x-1)+"}#");ee&&(De=ee.split(`
`,1)[0],Ae=De,this.options.pedantic&&(Ae=Ae.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Fe.test(Ae)||it.test(Ae)||st.test(Ae)||ht.test(ee)));){if(Ae.search(/[^ ]/)>=x||!Ae.trim())ke+=`
`+Ae.slice(x);else if(!de)ke+=`
`+Ae;else break;!de&&!Ae.trim()&&(de=!0),re+=De+`
`,ee=ee.substring(De.length+1)}_e.loose||(we?_e.loose=!0:/\n *\n *$/.test(re)&&(we=!0)),this.options.gfm&&(O=/^\[[ xX]\] /.exec(ke),O&&(H=O[0]!=="[ ] ",ke=ke.replace(/^\[[ xX]\] +/,""))),_e.items.push({type:"list_item",raw:re,task:!!O,checked:H,loose:!1,text:ke}),_e.raw+=re}_e.items[_e.items.length-1].raw=re.trimRight(),_e.items[_e.items.length-1].text=ke.trimRight(),_e.raw=_e.raw.trimRight();var ce=_e.items.length;for(Q=0;Q<ce;Q++){this.lexer.state.top=!1,_e.items[Q].tokens=this.lexer.blockTokens(_e.items[Q].text,[]);var $=_e.items[Q].tokens.filter(function(Ie){return Ie.type==="space"}),ue=$.every(function(Ie){for(var Le=Ie.raw.split(""),Be=0,xe=R(Le),Ze;!(Ze=xe()).done;){var gt=Ze.value;if(gt===`
`&&(Be+=1),Be>1)return!0}return!1});!_e.loose&&$.length&&ue&&(_e.loose=!0,_e.items[Q].loose=!0)}return _e}},ae.html=function(ee){var le=this.rules.block.html.exec(ee);if(le){var re={type:"html",raw:le[0],pre:!this.options.sanitizer&&(le[1]==="pre"||le[1]==="script"||le[1]==="style"),text:le[0]};if(this.options.sanitize){var O=this.options.sanitizer?this.options.sanitizer(le[0]):E(le[0]);re.type="paragraph",re.text=O,re.tokens=this.lexer.inline(O)}return re}},ae.def=function(ee){var le=this.rules.block.def.exec(ee);if(le){le[3]&&(le[3]=le[3].substring(1,le[3].length-1));var re=le[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:re,raw:le[0],href:le[2],title:le[3]}}},ae.table=function(ee){var le=this.rules.block.table.exec(ee);if(le){var re={type:"table",header:r(le[1]).map(function(we){return{text:we}}),align:le[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:le[3]&&le[3].trim()?le[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(re.header.length===re.align.length){re.raw=le[0];var O=re.align.length,H,x,Q,de;for(H=0;H<O;H++)/^ *-+: *$/.test(re.align[H])?re.align[H]="right":/^ *:-+: *$/.test(re.align[H])?re.align[H]="center":/^ *:-+ *$/.test(re.align[H])?re.align[H]="left":re.align[H]=null;for(O=re.rows.length,H=0;H<O;H++)re.rows[H]=r(re.rows[H],re.header.length).map(function(we){return{text:we}});for(O=re.header.length,x=0;x<O;x++)re.header[x].tokens=this.lexer.inline(re.header[x].text);for(O=re.rows.length,x=0;x<O;x++)for(de=re.rows[x],Q=0;Q<de.length;Q++)de[Q].tokens=this.lexer.inline(de[Q].text);return re}}},ae.lheading=function(ee){var le=this.rules.block.lheading.exec(ee);if(le)return{type:"heading",raw:le[0],depth:le[2].charAt(0)==="="?1:2,text:le[1],tokens:this.lexer.inline(le[1])}},ae.paragraph=function(ee){var le=this.rules.block.paragraph.exec(ee);if(le){var re=le[1].charAt(le[1].length-1)===`
`?le[1].slice(0,-1):le[1];return{type:"paragraph",raw:le[0],text:re,tokens:this.lexer.inline(re)}}},ae.text=function(ee){var le=this.rules.block.text.exec(ee);if(le)return{type:"text",raw:le[0],text:le[0],tokens:this.lexer.inline(le[0])}},ae.escape=function(ee){var le=this.rules.inline.escape.exec(ee);if(le)return{type:"escape",raw:le[0],text:E(le[1])}},ae.tag=function(ee){var le=this.rules.inline.tag.exec(ee);if(le)return!this.lexer.state.inLink&&/^<a /i.test(le[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(le[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(le[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(le[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:le[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(le[0]):E(le[0]):le[0]}},ae.link=function(ee){var le=this.rules.inline.link.exec(ee);if(le){var re=le[2].trim();if(!this.options.pedantic&&/^</.test(re)){if(!/>$/.test(re))return;var O=m(re.slice(0,-1),"\\");if((re.length-O.length)%2===0)return}else{var H=S(le[2],"()");if(H>-1){var x=le[0].indexOf("!")===0?5:4,Q=x+le[1].length+H;le[2]=le[2].substring(0,H),le[0]=le[0].substring(0,Q).trim(),le[3]=""}}var de=le[2],we="";if(this.options.pedantic){var Ae=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(de);Ae&&(de=Ae[1],we=Ae[3])}else we=le[3]?le[3].slice(1,-1):"";return de=de.trim(),/^</.test(de)&&(this.options.pedantic&&!/>$/.test(re)?de=de.slice(1):de=de.slice(1,-1)),q(le,{href:de&&de.replace(this.rules.inline._escapes,"$1"),title:we&&we.replace(this.rules.inline._escapes,"$1")},le[0],this.lexer)}},ae.reflink=function(ee,le){var re;if((re=this.rules.inline.reflink.exec(ee))||(re=this.rules.inline.nolink.exec(ee))){var O=(re[2]||re[1]).replace(/\s+/g," ");if(O=le[O.toLowerCase()],!O||!O.href){var H=re[0].charAt(0);return{type:"text",raw:H,text:H}}return q(re,O,re[0],this.lexer)}},ae.emStrong=function(ee,le,re){re===void 0&&(re="");var O=this.rules.inline.emStrong.lDelim.exec(ee);if(!!O&&!(O[3]&&re.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var H=O[1]||O[2]||"";if(!H||H&&(re===""||this.rules.inline.punctuation.exec(re))){var x=O[0].length-1,Q,de,we=x,Ae=0,pe=O[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(pe.lastIndex=0,le=le.slice(-1*ee.length+x);(O=pe.exec(le))!=null;)if(Q=O[1]||O[2]||O[3]||O[4]||O[5]||O[6],!!Q){if(de=Q.length,O[3]||O[4]){we+=de;continue}else if((O[5]||O[6])&&x%3&&!((x+de)%3)){Ae+=de;continue}if(we-=de,!(we>0)){if(de=Math.min(de,de+we+Ae),Math.min(x,de)%2){var De=ee.slice(1,x+O.index+de);return{type:"em",raw:ee.slice(0,x+O.index+de+1),text:De,tokens:this.lexer.inlineTokens(De)}}var ke=ee.slice(2,x+O.index+de-1);return{type:"strong",raw:ee.slice(0,x+O.index+de+1),text:ke,tokens:this.lexer.inlineTokens(ke)}}}}}},ae.codespan=function(ee){var le=this.rules.inline.code.exec(ee);if(le){var re=le[2].replace(/\n/g," "),O=/[^ ]/.test(re),H=/^ /.test(re)&&/ $/.test(re);return O&&H&&(re=re.substring(1,re.length-1)),re=E(re,!0),{type:"codespan",raw:le[0],text:re}}},ae.br=function(ee){var le=this.rules.inline.br.exec(ee);if(le)return{type:"br",raw:le[0]}},ae.del=function(ee){var le=this.rules.inline.del.exec(ee);if(le)return{type:"del",raw:le[0],text:le[2],tokens:this.lexer.inlineTokens(le[2])}},ae.autolink=function(ee,le){var re=this.rules.inline.autolink.exec(ee);if(re){var O,H;return re[2]==="@"?(O=E(this.options.mangle?le(re[1]):re[1]),H="mailto:"+O):(O=E(re[1]),H=O),{type:"link",raw:re[0],text:O,href:H,tokens:[{type:"text",raw:O,text:O}]}}},ae.url=function(ee,le){var re;if(re=this.rules.inline.url.exec(ee)){var O,H;if(re[2]==="@")O=E(this.options.mangle?le(re[0]):re[0]),H="mailto:"+O;else{var x;do x=re[0],re[0]=this.rules.inline._backpedal.exec(re[0])[0];while(x!==re[0]);O=E(re[0]),re[1]==="www."?H="http://"+O:H=O}return{type:"link",raw:re[0],text:O,href:H,tokens:[{type:"text",raw:O,text:O}]}}},ae.inlineText=function(ee,le){var re=this.rules.inline.text.exec(ee);if(re){var O;return this.lexer.state.inRawBlock?O=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(re[0]):E(re[0]):re[0]:O=E(this.options.smartypants?le(re[0]):re[0]),{type:"text",raw:re[0],text:O}}},oe}(),U={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:c,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};U._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,U._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,U.def=b(U.def).replace("label",U._label).replace("title",U._title).getRegex(),U.bullet=/(?:[*+-]|\d{1,9}[.)])/,U.listItemStart=b(/^( *)(bull) */).replace("bull",U.bullet).getRegex(),U.list=b(U.list).replace(/bull/g,U.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+U.def.source+")").getRegex(),U._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",U._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,U.html=b(U.html,"i").replace("comment",U._comment).replace("tag",U._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),U.paragraph=b(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.blockquote=b(U.blockquote).replace("paragraph",U.paragraph).getRegex(),U.normal=n({},U),U.gfm=n({},U.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),U.gfm.table=b(U.gfm.table).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.gfm.paragraph=b(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",U.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.pedantic=n({},U.normal,{html:b(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",U._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:c,paragraph:b(U.normal._paragraph).replace("hr",U.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",U.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var N={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:c,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:c,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};N._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",N.punctuation=b(N.punctuation).replace(/punctuation/g,N._punctuation).getRegex(),N.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,N.escapedEmSt=/\\\*|\\_/g,N._comment=b(U._comment).replace("(?:-->|$)","-->").getRegex(),N.emStrong.lDelim=b(N.emStrong.lDelim).replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimAst=b(N.emStrong.rDelimAst,"g").replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimUnd=b(N.emStrong.rDelimUnd,"g").replace(/punct/g,N._punctuation).getRegex(),N._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,N._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,N._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,N.autolink=b(N.autolink).replace("scheme",N._scheme).replace("email",N._email).getRegex(),N._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,N.tag=b(N.tag).replace("comment",N._comment).replace("attribute",N._attribute).getRegex(),N._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,N._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,N._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,N.link=b(N.link).replace("label",N._label).replace("href",N._href).replace("title",N._title).getRegex(),N.reflink=b(N.reflink).replace("label",N._label).replace("ref",U._label).getRegex(),N.nolink=b(N.nolink).replace("ref",U._label).getRegex(),N.reflinkSearch=b(N.reflinkSearch,"g").replace("reflink",N.reflink).replace("nolink",N.nolink).getRegex(),N.normal=n({},N),N.pedantic=n({},N.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:b(/^!?\[(label)\]\((.*?)\)/).replace("label",N._label).getRegex(),reflink:b(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",N._label).getRegex()}),N.gfm=n({},N.normal,{escape:b(N.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),N.gfm.url=b(N.gfm.url,"i").replace("email",N.gfm._extended_email).getRegex(),N.breaks=n({},N.gfm,{br:b(N.br).replace("{2,}","*").getRegex(),text:b(N.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function B(oe){return oe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function j(oe){var ae="",fe,ee,le=oe.length;for(fe=0;fe<le;fe++)ee=oe.charCodeAt(fe),Math.random()>.5&&(ee="x"+ee.toString(16)),ae+="&#"+ee+";";return ae}var z=function(){function oe(fe){this.tokens=[],this.tokens.links=Object.create(null),this.options=fe||te.defaults,this.options.tokenizer=this.options.tokenizer||new F,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ee={block:U.normal,inline:N.normal};this.options.pedantic?(ee.block=U.pedantic,ee.inline=N.pedantic):this.options.gfm&&(ee.block=U.gfm,this.options.breaks?ee.inline=N.breaks:ee.inline=N.gfm),this.tokenizer.rules=ee}oe.lex=function(ee,le){var re=new oe(le);return re.lex(ee)},oe.lexInline=function(ee,le){var re=new oe(le);return re.inlineTokens(ee)};var ae=oe.prototype;return ae.lex=function(ee){ee=ee.replace(/\r\n|\r/g,`
`),this.blockTokens(ee,this.tokens);for(var le;le=this.inlineQueue.shift();)this.inlineTokens(le.src,le.tokens);return this.tokens},ae.blockTokens=function(ee,le){var re=this;le===void 0&&(le=[]),this.options.pedantic?ee=ee.replace(/\t/g,"    ").replace(/^ +$/gm,""):ee=ee.replace(/^( *)(\t+)/gm,function(we,Ae,pe){return Ae+"    ".repeat(pe.length)});for(var O,H,x,Q;ee;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(we){return(O=we.call({lexer:re},ee,le))?(ee=ee.substring(O.raw.length),le.push(O),!0):!1}))){if(O=this.tokenizer.space(ee)){ee=ee.substring(O.raw.length),O.raw.length===1&&le.length>0?le[le.length-1].raw+=`
`:le.push(O);continue}if(O=this.tokenizer.code(ee)){ee=ee.substring(O.raw.length),H=le[le.length-1],H&&(H.type==="paragraph"||H.type==="text")?(H.raw+=`
`+O.raw,H.text+=`
`+O.text,this.inlineQueue[this.inlineQueue.length-1].src=H.text):le.push(O);continue}if(O=this.tokenizer.fences(ee)){ee=ee.substring(O.raw.length),le.push(O);continue}if(O=this.tokenizer.heading(ee)){ee=ee.substring(O.raw.length),le.push(O);continue}if(O=this.tokenizer.hr(ee)){ee=ee.substring(O.raw.length),le.push(O);continue}if(O=this.tokenizer.blockquote(ee)){ee=ee.substring(O.raw.length),le.push(O);continue}if(O=this.tokenizer.list(ee)){ee=ee.substring(O.raw.length),le.push(O);continue}if(O=this.tokenizer.html(ee)){ee=ee.substring(O.raw.length),le.push(O);continue}if(O=this.tokenizer.def(ee)){ee=ee.substring(O.raw.length),H=le[le.length-1],H&&(H.type==="paragraph"||H.type==="text")?(H.raw+=`
`+O.raw,H.text+=`
`+O.raw,this.inlineQueue[this.inlineQueue.length-1].src=H.text):this.tokens.links[O.tag]||(this.tokens.links[O.tag]={href:O.href,title:O.title});continue}if(O=this.tokenizer.table(ee)){ee=ee.substring(O.raw.length),le.push(O);continue}if(O=this.tokenizer.lheading(ee)){ee=ee.substring(O.raw.length),le.push(O);continue}if(x=ee,this.options.extensions&&this.options.extensions.startBlock&&function(){var we=1/0,Ae=ee.slice(1),pe=void 0;re.options.extensions.startBlock.forEach(function(De){pe=De.call({lexer:this},Ae),typeof pe=="number"&&pe>=0&&(we=Math.min(we,pe))}),we<1/0&&we>=0&&(x=ee.substring(0,we+1))}(),this.state.top&&(O=this.tokenizer.paragraph(x))){H=le[le.length-1],Q&&H.type==="paragraph"?(H.raw+=`
`+O.raw,H.text+=`
`+O.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=H.text):le.push(O),Q=x.length!==ee.length,ee=ee.substring(O.raw.length);continue}if(O=this.tokenizer.text(ee)){ee=ee.substring(O.raw.length),H=le[le.length-1],H&&H.type==="text"?(H.raw+=`
`+O.raw,H.text+=`
`+O.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=H.text):le.push(O);continue}if(ee){var de="Infinite loop on byte: "+ee.charCodeAt(0);if(this.options.silent){console.error(de);break}else throw new Error(de)}}return this.state.top=!0,le},ae.inline=function(ee,le){return le===void 0&&(le=[]),this.inlineQueue.push({src:ee,tokens:le}),le},ae.inlineTokens=function(ee,le){var re=this;le===void 0&&(le=[]);var O,H,x,Q=ee,de,we,Ae;if(this.tokens.links){var pe=Object.keys(this.tokens.links);if(pe.length>0)for(;(de=this.tokenizer.rules.inline.reflinkSearch.exec(Q))!=null;)pe.includes(de[0].slice(de[0].lastIndexOf("[")+1,-1))&&(Q=Q.slice(0,de.index)+"["+M("a",de[0].length-2)+"]"+Q.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(de=this.tokenizer.rules.inline.blockSkip.exec(Q))!=null;)Q=Q.slice(0,de.index)+"["+M("a",de[0].length-2)+"]"+Q.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(de=this.tokenizer.rules.inline.escapedEmSt.exec(Q))!=null;)Q=Q.slice(0,de.index)+"++"+Q.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ee;)if(we||(Ae=""),we=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ke){return(O=ke.call({lexer:re},ee,le))?(ee=ee.substring(O.raw.length),le.push(O),!0):!1}))){if(O=this.tokenizer.escape(ee)){ee=ee.substring(O.raw.length),le.push(O);continue}if(O=this.tokenizer.tag(ee)){ee=ee.substring(O.raw.length),H=le[le.length-1],H&&O.type==="text"&&H.type==="text"?(H.raw+=O.raw,H.text+=O.text):le.push(O);continue}if(O=this.tokenizer.link(ee)){ee=ee.substring(O.raw.length),le.push(O);continue}if(O=this.tokenizer.reflink(ee,this.tokens.links)){ee=ee.substring(O.raw.length),H=le[le.length-1],H&&O.type==="text"&&H.type==="text"?(H.raw+=O.raw,H.text+=O.text):le.push(O);continue}if(O=this.tokenizer.emStrong(ee,Q,Ae)){ee=ee.substring(O.raw.length),le.push(O);continue}if(O=this.tokenizer.codespan(ee)){ee=ee.substring(O.raw.length),le.push(O);continue}if(O=this.tokenizer.br(ee)){ee=ee.substring(O.raw.length),le.push(O);continue}if(O=this.tokenizer.del(ee)){ee=ee.substring(O.raw.length),le.push(O);continue}if(O=this.tokenizer.autolink(ee,j)){ee=ee.substring(O.raw.length),le.push(O);continue}if(!this.state.inLink&&(O=this.tokenizer.url(ee,j))){ee=ee.substring(O.raw.length),le.push(O);continue}if(x=ee,this.options.extensions&&this.options.extensions.startInline&&function(){var ke=1/0,je=ee.slice(1),Ge=void 0;re.options.extensions.startInline.forEach(function(et){Ge=et.call({lexer:this},je),typeof Ge=="number"&&Ge>=0&&(ke=Math.min(ke,Ge))}),ke<1/0&&ke>=0&&(x=ee.substring(0,ke+1))}(),O=this.tokenizer.inlineText(x,B)){ee=ee.substring(O.raw.length),O.raw.slice(-1)!=="_"&&(Ae=O.raw.slice(-1)),we=!0,H=le[le.length-1],H&&H.type==="text"?(H.raw+=O.raw,H.text+=O.text):le.push(O);continue}if(ee){var De="Infinite loop on byte: "+ee.charCodeAt(0);if(this.options.silent){console.error(De);break}else throw new Error(De)}}return le},o(oe,null,[{key:"rules",get:function(){return{block:U,inline:N}}}]),oe}(),ne=function(){function oe(fe){this.options=fe||te.defaults}var ae=oe.prototype;return ae.code=function(ee,le,re){var O=(le||"").match(/\S*/)[0];if(this.options.highlight){var H=this.options.highlight(ee,O);H!=null&&H!==ee&&(re=!0,ee=H)}return ee=ee.replace(/\n$/,"")+`
`,O?'<pre><code class="'+this.options.langPrefix+E(O,!0)+'">'+(re?ee:E(ee,!0))+`</code></pre>
`:"<pre><code>"+(re?ee:E(ee,!0))+`</code></pre>
`},ae.blockquote=function(ee){return`<blockquote>
`+ee+`</blockquote>
`},ae.html=function(ee){return ee},ae.heading=function(ee,le,re,O){if(this.options.headerIds){var H=this.options.headerPrefix+O.slug(re);return"<h"+le+' id="'+H+'">'+ee+"</h"+le+`>
`}return"<h"+le+">"+ee+"</h"+le+`>
`},ae.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ae.list=function(ee,le,re){var O=le?"ol":"ul",H=le&&re!==1?' start="'+re+'"':"";return"<"+O+H+`>
`+ee+"</"+O+`>
`},ae.listitem=function(ee){return"<li>"+ee+`</li>
`},ae.checkbox=function(ee){return"<input "+(ee?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ae.paragraph=function(ee){return"<p>"+ee+`</p>
`},ae.table=function(ee,le){return le&&(le="<tbody>"+le+"</tbody>"),`<table>
<thead>
`+ee+`</thead>
`+le+`</table>
`},ae.tablerow=function(ee){return`<tr>
`+ee+`</tr>
`},ae.tablecell=function(ee,le){var re=le.header?"th":"td",O=le.align?"<"+re+' align="'+le.align+'">':"<"+re+">";return O+ee+("</"+re+`>
`)},ae.strong=function(ee){return"<strong>"+ee+"</strong>"},ae.em=function(ee){return"<em>"+ee+"</em>"},ae.codespan=function(ee){return"<code>"+ee+"</code>"},ae.br=function(){return this.options.xhtml?"<br/>":"<br>"},ae.del=function(ee){return"<del>"+ee+"</del>"},ae.link=function(ee,le,re){if(ee=w(this.options.sanitize,this.options.baseUrl,ee),ee===null)return re;var O='<a href="'+E(ee)+'"';return le&&(O+=' title="'+le+'"'),O+=">"+re+"</a>",O},ae.image=function(ee,le,re){if(ee=w(this.options.sanitize,this.options.baseUrl,ee),ee===null)return re;var O='<img src="'+ee+'" alt="'+re+'"';return le&&(O+=' title="'+le+'"'),O+=this.options.xhtml?"/>":">",O},ae.text=function(ee){return ee},oe}(),_=function(){function oe(){}var ae=oe.prototype;return ae.strong=function(ee){return ee},ae.em=function(ee){return ee},ae.codespan=function(ee){return ee},ae.del=function(ee){return ee},ae.html=function(ee){return ee},ae.text=function(ee){return ee},ae.link=function(ee,le,re){return""+re},ae.image=function(ee,le,re){return""+re},ae.br=function(){return""},oe}(),Y=function(){function oe(){this.seen={}}var ae=oe.prototype;return ae.serialize=function(ee){return ee.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ae.getNextSafeSlug=function(ee,le){var re=ee,O=0;if(this.seen.hasOwnProperty(re)){O=this.seen[ee];do O++,re=ee+"-"+O;while(this.seen.hasOwnProperty(re))}return le||(this.seen[ee]=O,this.seen[re]=0),re},ae.slug=function(ee,le){le===void 0&&(le={});var re=this.serialize(ee);return this.getNextSafeSlug(re,le.dryrun)},oe}(),J=function(){function oe(fe){this.options=fe||te.defaults,this.options.renderer=this.options.renderer||new ne,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new _,this.slugger=new Y}oe.parse=function(ee,le){var re=new oe(le);return re.parse(ee)},oe.parseInline=function(ee,le){var re=new oe(le);return re.parseInline(ee)};var ae=oe.prototype;return ae.parse=function(ee,le){le===void 0&&(le=!0);var re="",O,H,x,Q,de,we,Ae,pe,De,ke,je,Ge,et,_e,nt,st,ht,Fe,it,ce=ee.length;for(O=0;O<ce;O++){if(ke=ee[O],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ke.type]&&(it=this.options.extensions.renderers[ke.type].call({parser:this},ke),it!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ke.type))){re+=it||"";continue}switch(ke.type){case"space":continue;case"hr":{re+=this.renderer.hr();continue}case"heading":{re+=this.renderer.heading(this.parseInline(ke.tokens),ke.depth,d(this.parseInline(ke.tokens,this.textRenderer)),this.slugger);continue}case"code":{re+=this.renderer.code(ke.text,ke.lang,ke.escaped);continue}case"table":{for(pe="",Ae="",Q=ke.header.length,H=0;H<Q;H++)Ae+=this.renderer.tablecell(this.parseInline(ke.header[H].tokens),{header:!0,align:ke.align[H]});for(pe+=this.renderer.tablerow(Ae),De="",Q=ke.rows.length,H=0;H<Q;H++){for(we=ke.rows[H],Ae="",de=we.length,x=0;x<de;x++)Ae+=this.renderer.tablecell(this.parseInline(we[x].tokens),{header:!1,align:ke.align[x]});De+=this.renderer.tablerow(Ae)}re+=this.renderer.table(pe,De);continue}case"blockquote":{De=this.parse(ke.tokens),re+=this.renderer.blockquote(De);continue}case"list":{for(je=ke.ordered,Ge=ke.start,et=ke.loose,Q=ke.items.length,De="",H=0;H<Q;H++)nt=ke.items[H],st=nt.checked,ht=nt.task,_e="",nt.task&&(Fe=this.renderer.checkbox(st),et?nt.tokens.length>0&&nt.tokens[0].type==="paragraph"?(nt.tokens[0].text=Fe+" "+nt.tokens[0].text,nt.tokens[0].tokens&&nt.tokens[0].tokens.length>0&&nt.tokens[0].tokens[0].type==="text"&&(nt.tokens[0].tokens[0].text=Fe+" "+nt.tokens[0].tokens[0].text)):nt.tokens.unshift({type:"text",text:Fe}):_e+=Fe),_e+=this.parse(nt.tokens,et),De+=this.renderer.listitem(_e,ht,st);re+=this.renderer.list(De,je,Ge);continue}case"html":{re+=this.renderer.html(ke.text);continue}case"paragraph":{re+=this.renderer.paragraph(this.parseInline(ke.tokens));continue}case"text":{for(De=ke.tokens?this.parseInline(ke.tokens):ke.text;O+1<ce&&ee[O+1].type==="text";)ke=ee[++O],De+=`
`+(ke.tokens?this.parseInline(ke.tokens):ke.text);re+=le?this.renderer.paragraph(De):De;continue}default:{var $='Token with "'+ke.type+'" type was not found.';if(this.options.silent){console.error($);return}else throw new Error($)}}}return re},ae.parseInline=function(ee,le){le=le||this.renderer;var re="",O,H,x,Q=ee.length;for(O=0;O<Q;O++){if(H=ee[O],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[H.type]&&(x=this.options.extensions.renderers[H.type].call({parser:this},H),x!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(H.type))){re+=x||"";continue}switch(H.type){case"escape":{re+=le.text(H.text);break}case"html":{re+=le.html(H.text);break}case"link":{re+=le.link(H.href,H.title,this.parseInline(H.tokens,le));break}case"image":{re+=le.image(H.href,H.title,H.text);break}case"strong":{re+=le.strong(this.parseInline(H.tokens,le));break}case"em":{re+=le.em(this.parseInline(H.tokens,le));break}case"codespan":{re+=le.codespan(H.text);break}case"br":{re+=le.br();break}case"del":{re+=le.del(this.parseInline(H.tokens,le));break}case"text":{re+=le.text(H.text);break}default:{var de='Token with "'+H.type+'" type was not found.';if(this.options.silent){console.error(de);return}else throw new Error(de)}}}return re},oe}();function Z(oe,ae,fe){if(typeof oe>"u"||oe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof oe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(oe)+", string expected");if(typeof ae=="function"&&(fe=ae,ae=null),ae=n({},Z.defaults,ae||{}),k(ae),fe){var ee=ae.highlight,le;try{le=z.lex(oe,ae)}catch(Q){return fe(Q)}var re=function(de){var we;if(!de)try{ae.walkTokens&&Z.walkTokens(le,ae.walkTokens),we=J.parse(le,ae)}catch(Ae){de=Ae}return ae.highlight=ee,de?fe(de):fe(null,we)};if(!ee||ee.length<3||(delete ae.highlight,!le.length))return re();var O=0;Z.walkTokens(le,function(Q){Q.type==="code"&&(O++,setTimeout(function(){ee(Q.text,Q.lang,function(de,we){if(de)return re(de);we!=null&&we!==Q.text&&(Q.text=we,Q.escaped=!0),O--,O===0&&re()})},0))}),O===0&&re();return}function H(Q){if(Q.message+=`
Please report this to https://github.com/markedjs/marked.`,ae.silent)return"<p>An error occurred:</p><pre>"+E(Q.message+"",!0)+"</pre>";throw Q}try{var x=z.lex(oe,ae);if(ae.walkTokens){if(ae.async)return Promise.all(Z.walkTokens(x,ae.walkTokens)).then(function(){return J.parse(x,ae)}).catch(H);Z.walkTokens(x,ae.walkTokens)}return J.parse(x,ae)}catch(Q){H(Q)}}Z.options=Z.setOptions=function(oe){return n(Z.defaults,oe),A(Z.defaults),Z},Z.getDefaults=I,Z.defaults=te.defaults,Z.use=function(){for(var oe=arguments.length,ae=new Array(oe),fe=0;fe<oe;fe++)ae[fe]=arguments[fe];var ee=n.apply(void 0,[{}].concat(ae)),le=Z.defaults.extensions||{renderers:{},childTokens:{}},re;ae.forEach(function(O){if(O.extensions&&(re=!0,O.extensions.forEach(function(x){if(!x.name)throw new Error("extension name required");if(x.renderer){var Q=le.renderers?le.renderers[x.name]:null;Q?le.renderers[x.name]=function(){for(var de=arguments.length,we=new Array(de),Ae=0;Ae<de;Ae++)we[Ae]=arguments[Ae];var pe=x.renderer.apply(this,we);return pe===!1&&(pe=Q.apply(this,we)),pe}:le.renderers[x.name]=x.renderer}if(x.tokenizer){if(!x.level||x.level!=="block"&&x.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");le[x.level]?le[x.level].unshift(x.tokenizer):le[x.level]=[x.tokenizer],x.start&&(x.level==="block"?le.startBlock?le.startBlock.push(x.start):le.startBlock=[x.start]:x.level==="inline"&&(le.startInline?le.startInline.push(x.start):le.startInline=[x.start]))}x.childTokens&&(le.childTokens[x.name]=x.childTokens)})),O.renderer&&function(){var x=Z.defaults.renderer||new ne,Q=function(Ae){var pe=x[Ae];x[Ae]=function(){for(var De=arguments.length,ke=new Array(De),je=0;je<De;je++)ke[je]=arguments[je];var Ge=O.renderer[Ae].apply(x,ke);return Ge===!1&&(Ge=pe.apply(x,ke)),Ge}};for(var de in O.renderer)Q(de);ee.renderer=x}(),O.tokenizer&&function(){var x=Z.defaults.tokenizer||new F,Q=function(Ae){var pe=x[Ae];x[Ae]=function(){for(var De=arguments.length,ke=new Array(De),je=0;je<De;je++)ke[je]=arguments[je];var Ge=O.tokenizer[Ae].apply(x,ke);return Ge===!1&&(Ge=pe.apply(x,ke)),Ge}};for(var de in O.tokenizer)Q(de);ee.tokenizer=x}(),O.walkTokens){var H=Z.defaults.walkTokens;ee.walkTokens=function(x){var Q=[];return Q.push(O.walkTokens.call(this,x)),H&&(Q=Q.concat(H.call(this,x))),Q}}re&&(ee.extensions=le),Z.setOptions(ee)})},Z.walkTokens=function(oe,ae){for(var fe=[],ee=function(){var H=re.value;switch(fe=fe.concat(ae.call(Z,H)),H.type){case"table":{for(var x=R(H.header),Q;!(Q=x()).done;){var de=Q.value;fe=fe.concat(Z.walkTokens(de.tokens,ae))}for(var we=R(H.rows),Ae;!(Ae=we()).done;)for(var pe=Ae.value,De=R(pe),ke;!(ke=De()).done;){var je=ke.value;fe=fe.concat(Z.walkTokens(je.tokens,ae))}break}case"list":{fe=fe.concat(Z.walkTokens(H.items,ae));break}default:Z.defaults.extensions&&Z.defaults.extensions.childTokens&&Z.defaults.extensions.childTokens[H.type]?Z.defaults.extensions.childTokens[H.type].forEach(function(Ge){fe=fe.concat(Z.walkTokens(H[Ge],ae))}):H.tokens&&(fe=fe.concat(Z.walkTokens(H.tokens,ae)))}},le=R(oe),re;!(re=le()).done;)ee();return fe},Z.parseInline=function(oe,ae){if(typeof oe>"u"||oe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof oe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(oe)+", string expected");ae=n({},Z.defaults,ae||{}),k(ae);try{var fe=z.lexInline(oe,ae);return ae.walkTokens&&Z.walkTokens(fe,ae.walkTokens),J.parseInline(fe,ae)}catch(ee){if(ee.message+=`
Please report this to https://github.com/markedjs/marked.`,ae.silent)return"<p>An error occurred:</p><pre>"+E(ee.message+"",!0)+"</pre>";throw ee}},Z.Parser=J,Z.parser=J.parse,Z.Renderer=ne,Z.TextRenderer=_,Z.Lexer=z,Z.lexer=z.lex,Z.Tokenizer=F,Z.Slugger=Y,Z.parse=Z;var ie=Z.options,X=Z.setOptions,K=Z.use,he=Z.walkTokens,be=Z.parseInline,Ee=Z,Pe=J.parse,Me=z.lex;te.Lexer=z,te.Parser=J,te.Renderer=ne,te.Slugger=Y,te.TextRenderer=_,te.Tokenizer=F,te.getDefaults=I,te.lexer=Me,te.marked=Z,te.options=ie,te.parse=Ee,te.parseInline=be,te.parser=Pe,te.setOptions=X,te.use=K,te.walkTokens=he,Object.defineProperty(te,"__esModule",{value:!0})}),define(ye[83],Ce([1,0,28]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new o.LRUCache(1e4);function T(D){return y(D,"NFC",t)}e.normalizeNFC=T;const R=new o.LRUCache(1e4);function I(D){return y(D,"NFD",R)}e.normalizeNFD=I;const A=/[^\u0000-\u0080]/;function y(D,L,P){if(!D)return D;const v=P.get(D);if(v)return v;let C;return A.test(D)?C=D.normalize(L):C=D,P.set(D,C),C}e.removeAccents=function(){const D=/[\u0300-\u036f]/g;return function(L){return I(L).replace(D,"")}}()}),define(ye[101],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function o(A,y,D){return Math.min(Math.max(A,y),D)}e.clamp=o;function t(A,y){return(y+A%y)%y}e.rot=t;class T{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=T;class R{constructor(){this.a=1,this.b=0}update(y){return this.b=this.b+(y-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=R;class I{constructor(y){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(y),this.c.fill(0,0,y)}update(y){const D=this.c[this.d];return this.c[this.d]=y,this.d=(this.d+1)%this.c.length,this.e-=D,this.e+=y,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=I}),function(){function te(T){const R=[];typeof T=="number"&&R.push("code/timeOrigin",T);function I(y){R.push(y,Date.now())}function A(){const y=[];for(let D=0;D<R.length;D+=2)y.push({name:R[D],startTime:R[D+1]});return y}return{mark:I,getMarks:A}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?te():{mark(T){performance.mark(T)},getMarks(){let T=performance.timeOrigin;typeof T!="number"&&(T=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(T)}];for(const I of performance.getEntriesByType("mark"))R.push({name:I.name,startTime:Math.round(T+I.startTime)});return R}};if(typeof process=="object"){const T=Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return te(T)}else return console.trace("perf-util loaded in UNKNOWN environment"),te()}function o(T){return T.MonacoPerformanceMarks||(T.MonacoPerformanceMarks=e()),T.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return o(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=o(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=o(t))}(),function(te,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var o=e();for(var t in o)(typeof exports=="object"?exports:te)[t]=o[t]}}(typeof self<"u"?self:this,function(){return function(te){var e={};function o(t){if(e[t])return e[t].exports;var T=e[t]={i:t,l:!1,exports:{}};return te[t].call(T.exports,T,T.exports,o),T.l=!0,T.exports}return o.m=te,o.c=e,o.d=function(t,T,R){o.o(t,T)||Object.defineProperty(t,T,{enumerable:!0,get:R})},o.r=function(t){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(t,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(t,"__esModule",{value:!0})},o.t=function(t,T){if(1&T&&(t=o(t)),8&T||4&T&&typeof t=="object"&&t&&t.__esModule)return t;var R=Object.create(null);if(o.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:t}),2&T&&typeof t!="string")for(var I in t)o.d(R,I,function(A){return t[A]}.bind(null,I));return R},o.n=function(t){var T=t&&t.__esModule?function(){return t.default}:function(){return t};return o.d(T,"a",T),T},o.o=function(t,T){return Object.prototype.hasOwnProperty.call(t,T)},o.p="",o(o.s=0)}([function(te,e,o){(function(t){var T;e=te.exports=K,T=typeof t=="object"&&t.env&&t.env.NODE_DEBUG&&/\bsemver\b/i.test(t.env.NODE_DEBUG)?function(){var pe=Array.prototype.slice.call(arguments,0);pe.unshift("SEMVER"),console.log.apply(console,pe)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,I=Number.MAX_SAFE_INTEGER||9007199254740991,A=e.re=[],y=e.src=[],D=0,L=D++;y[L]="0|[1-9]\\d*";var P=D++;y[P]="[0-9]+";var v=D++;y[v]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var C=D++;y[C]="("+y[L]+")\\.("+y[L]+")\\.("+y[L]+")";var E=D++;y[E]="("+y[P]+")\\.("+y[P]+")\\.("+y[P]+")";var f=D++;y[f]="(?:"+y[L]+"|"+y[v]+")";var d=D++;y[d]="(?:"+y[P]+"|"+y[v]+")";var h=D++;y[h]="(?:-("+y[f]+"(?:\\."+y[f]+")*))";var b=D++;y[b]="(?:-?("+y[d]+"(?:\\."+y[d]+")*))";var g=D++;y[g]="[0-9A-Za-z-]+";var p=D++;y[p]="(?:\\+("+y[g]+"(?:\\."+y[g]+")*))";var w=D++,i="v?"+y[C]+y[h]+"?"+y[p]+"?";y[w]="^"+i+"$";var s="[v=\\s]*"+y[E]+y[b]+"?"+y[p]+"?",a=D++;y[a]="^"+s+"$";var u=D++;y[u]="((?:<|>)?=?)";var l=D++;y[l]=y[P]+"|x|X|\\*";var c=D++;y[c]=y[L]+"|x|X|\\*";var n=D++;y[n]="[v=\\s]*("+y[c]+")(?:\\.("+y[c]+")(?:\\.("+y[c]+")(?:"+y[h]+")?"+y[p]+"?)?)?";var r=D++;y[r]="[v=\\s]*("+y[l]+")(?:\\.("+y[l]+")(?:\\.("+y[l]+")(?:"+y[b]+")?"+y[p]+"?)?)?";var m=D++;y[m]="^"+y[u]+"\\s*"+y[n]+"$";var S=D++;y[S]="^"+y[u]+"\\s*"+y[r]+"$";var k=D++;y[k]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var M=D++;y[M]="(?:~>?)";var q=D++;y[q]="(\\s*)"+y[M]+"\\s+",A[q]=new RegExp(y[q],"g");var V=D++;y[V]="^"+y[M]+y[n]+"$";var F=D++;y[F]="^"+y[M]+y[r]+"$";var U=D++;y[U]="(?:\\^)";var N=D++;y[N]="(\\s*)"+y[U]+"\\s+",A[N]=new RegExp(y[N],"g");var B=D++;y[B]="^"+y[U]+y[n]+"$";var j=D++;y[j]="^"+y[U]+y[r]+"$";var z=D++;y[z]="^"+y[u]+"\\s*("+s+")$|^$";var ne=D++;y[ne]="^"+y[u]+"\\s*("+i+")$|^$";var _=D++;y[_]="(\\s*)"+y[u]+"\\s*("+s+"|"+y[n]+")",A[_]=new RegExp(y[_],"g");var Y=D++;y[Y]="^\\s*("+y[n]+")\\s+-\\s+("+y[n]+")\\s*$";var J=D++;y[J]="^\\s*("+y[r]+")\\s+-\\s+("+y[r]+")\\s*$";var Z=D++;y[Z]="(<|>)?=?\\s*\\*";for(var ie=0;ie<35;ie++)T(ie,y[ie]),A[ie]||(A[ie]=new RegExp(y[ie]));function X(pe,De){if(pe instanceof K)return pe;if(typeof pe!="string"||pe.length>R||!(De?A[a]:A[w]).test(pe))return null;try{return new K(pe,De)}catch{return null}}function K(pe,De){if(pe instanceof K){if(pe.loose===De)return pe;pe=pe.version}else if(typeof pe!="string")throw new TypeError("Invalid Version: "+pe);if(pe.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof K))return new K(pe,De);T("SemVer",pe,De),this.loose=De;var ke=pe.trim().match(De?A[a]:A[w]);if(!ke)throw new TypeError("Invalid Version: "+pe);if(this.raw=pe,this.major=+ke[1],this.minor=+ke[2],this.patch=+ke[3],this.major>I||this.major<0)throw new TypeError("Invalid major version");if(this.minor>I||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>I||this.patch<0)throw new TypeError("Invalid patch version");ke[4]?this.prerelease=ke[4].split(".").map(function(je){if(/^[0-9]+$/.test(je)){var Ge=+je;if(Ge>=0&&Ge<I)return Ge}return je}):this.prerelease=[],this.build=ke[5]?ke[5].split("."):[],this.format()}e.parse=X,e.valid=function(pe,De){var ke=X(pe,De);return ke?ke.version:null},e.clean=function(pe,De){var ke=X(pe.trim().replace(/^[=v]+/,""),De);return ke?ke.version:null},e.SemVer=K,K.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},K.prototype.toString=function(){return this.version},K.prototype.compare=function(pe){return T("SemVer.compare",this.version,this.loose,pe),pe instanceof K||(pe=new K(pe,this.loose)),this.compareMain(pe)||this.comparePre(pe)},K.prototype.compareMain=function(pe){return pe instanceof K||(pe=new K(pe,this.loose)),be(this.major,pe.major)||be(this.minor,pe.minor)||be(this.patch,pe.patch)},K.prototype.comparePre=function(pe){if(pe instanceof K||(pe=new K(pe,this.loose)),this.prerelease.length&&!pe.prerelease.length)return-1;if(!this.prerelease.length&&pe.prerelease.length)return 1;if(!this.prerelease.length&&!pe.prerelease.length)return 0;var De=0;do{var ke=this.prerelease[De],je=pe.prerelease[De];if(T("prerelease compare",De,ke,je),ke===void 0&&je===void 0)return 0;if(je===void 0)return 1;if(ke===void 0)return-1;if(ke!==je)return be(ke,je)}while(++De)},K.prototype.inc=function(pe,De){switch(pe){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",De);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",De);break;case"prepatch":this.prerelease.length=0,this.inc("patch",De),this.inc("pre",De);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",De),this.inc("pre",De);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ke=this.prerelease.length;--ke>=0;)typeof this.prerelease[ke]=="number"&&(this.prerelease[ke]++,ke=-2);ke===-1&&this.prerelease.push(0)}De&&(this.prerelease[0]===De?isNaN(this.prerelease[1])&&(this.prerelease=[De,0]):this.prerelease=[De,0]);break;default:throw new Error("invalid increment argument: "+pe)}return this.format(),this.raw=this.version,this},e.inc=function(pe,De,ke,je){typeof ke=="string"&&(je=ke,ke=void 0);try{return new K(pe,ke).inc(De,je).version}catch{return null}},e.diff=function(pe,De){if(oe(pe,De))return null;var ke=X(pe),je=X(De);if(ke.prerelease.length||je.prerelease.length){for(var Ge in ke)if((Ge==="major"||Ge==="minor"||Ge==="patch")&&ke[Ge]!==je[Ge])return"pre"+Ge;return"prerelease"}for(var Ge in ke)if((Ge==="major"||Ge==="minor"||Ge==="patch")&&ke[Ge]!==je[Ge])return Ge},e.compareIdentifiers=be;var he=/^[0-9]+$/;function be(pe,De){var ke=he.test(pe),je=he.test(De);return ke&&je&&(pe=+pe,De=+De),ke&&!je?-1:je&&!ke?1:pe<De?-1:pe>De?1:0}function Ee(pe,De,ke){return new K(pe,ke).compare(new K(De,ke))}function Pe(pe,De,ke){return Ee(pe,De,ke)>0}function Me(pe,De,ke){return Ee(pe,De,ke)<0}function oe(pe,De,ke){return Ee(pe,De,ke)===0}function ae(pe,De,ke){return Ee(pe,De,ke)!==0}function fe(pe,De,ke){return Ee(pe,De,ke)>=0}function ee(pe,De,ke){return Ee(pe,De,ke)<=0}function le(pe,De,ke,je){var Ge;switch(De){case"===":typeof pe=="object"&&(pe=pe.version),typeof ke=="object"&&(ke=ke.version),Ge=pe===ke;break;case"!==":typeof pe=="object"&&(pe=pe.version),typeof ke=="object"&&(ke=ke.version),Ge=pe!==ke;break;case"":case"=":case"==":Ge=oe(pe,ke,je);break;case"!=":Ge=ae(pe,ke,je);break;case">":Ge=Pe(pe,ke,je);break;case">=":Ge=fe(pe,ke,je);break;case"<":Ge=Me(pe,ke,je);break;case"<=":Ge=ee(pe,ke,je);break;default:throw new TypeError("Invalid operator: "+De)}return Ge}function re(pe,De){if(pe instanceof re){if(pe.loose===De)return pe;pe=pe.value}if(!(this instanceof re))return new re(pe,De);T("comparator",pe,De),this.loose=De,this.parse(pe),this.semver===O?this.value="":this.value=this.operator+this.semver.version,T("comp",this)}e.rcompareIdentifiers=function(pe,De){return be(De,pe)},e.major=function(pe,De){return new K(pe,De).major},e.minor=function(pe,De){return new K(pe,De).minor},e.patch=function(pe,De){return new K(pe,De).patch},e.compare=Ee,e.compareLoose=function(pe,De){return Ee(pe,De,!0)},e.rcompare=function(pe,De,ke){return Ee(De,pe,ke)},e.sort=function(pe,De){return pe.sort(function(ke,je){return e.compare(ke,je,De)})},e.rsort=function(pe,De){return pe.sort(function(ke,je){return e.rcompare(ke,je,De)})},e.gt=Pe,e.lt=Me,e.eq=oe,e.neq=ae,e.gte=fe,e.lte=ee,e.cmp=le,e.Comparator=re;var O={};function H(pe,De){if(pe instanceof H)return pe.loose===De?pe:new H(pe.raw,De);if(pe instanceof re)return new H(pe.value,De);if(!(this instanceof H))return new H(pe,De);if(this.loose=De,this.raw=pe,this.set=pe.split(/\s*\|\|\s*/).map(function(ke){return this.parseRange(ke.trim())},this).filter(function(ke){return ke.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+pe);this.format()}function x(pe){return!pe||pe.toLowerCase()==="x"||pe==="*"}function Q(pe,De,ke,je,Ge,et,_e,nt,st,ht,Fe,it,ce){return((De=x(ke)?"":x(je)?">="+ke+".0.0":x(Ge)?">="+ke+"."+je+".0":">="+De)+" "+(nt=x(st)?"":x(ht)?"<"+(+st+1)+".0.0":x(Fe)?"<"+st+"."+(+ht+1)+".0":it?"<="+st+"."+ht+"."+Fe+"-"+it:"<="+nt)).trim()}function de(pe,De){for(var ke=0;ke<pe.length;ke++)if(!pe[ke].test(De))return!1;if(De.prerelease.length){for(ke=0;ke<pe.length;ke++)if(T(pe[ke].semver),pe[ke].semver!==O&&pe[ke].semver.prerelease.length>0){var je=pe[ke].semver;if(je.major===De.major&&je.minor===De.minor&&je.patch===De.patch)return!0}return!1}return!0}function we(pe,De,ke){try{De=new H(De,ke)}catch{return!1}return De.test(pe)}function Ae(pe,De,ke,je){var Ge,et,_e,nt,st;switch(pe=new K(pe,je),De=new H(De,je),ke){case">":Ge=Pe,et=ee,_e=Me,nt=">",st=">=";break;case"<":Ge=Me,et=fe,_e=Pe,nt="<",st="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(we(pe,De,je))return!1;for(var ht=0;ht<De.set.length;++ht){var Fe=De.set[ht],it=null,ce=null;if(Fe.forEach(function($){$.semver===O&&($=new re(">=0.0.0")),it=it||$,ce=ce||$,Ge($.semver,it.semver,je)?it=$:_e($.semver,ce.semver,je)&&(ce=$)}),it.operator===nt||it.operator===st||(!ce.operator||ce.operator===nt)&&et(pe,ce.semver)||ce.operator===st&&_e(pe,ce.semver))return!1}return!0}re.prototype.parse=function(pe){var De=this.loose?A[z]:A[ne],ke=pe.match(De);if(!ke)throw new TypeError("Invalid comparator: "+pe);this.operator=ke[1],this.operator==="="&&(this.operator=""),ke[2]?this.semver=new K(ke[2],this.loose):this.semver=O},re.prototype.toString=function(){return this.value},re.prototype.test=function(pe){return T("Comparator.test",pe,this.loose),this.semver===O||(typeof pe=="string"&&(pe=new K(pe,this.loose)),le(pe,this.operator,this.semver,this.loose))},re.prototype.intersects=function(pe,De){if(!(pe instanceof re))throw new TypeError("a Comparator is required");var ke;if(this.operator==="")return ke=new H(pe.value,De),we(this.value,ke,De);if(pe.operator==="")return ke=new H(this.value,De),we(pe.semver,ke,De);var je=!(this.operator!==">="&&this.operator!==">"||pe.operator!==">="&&pe.operator!==">"),Ge=!(this.operator!=="<="&&this.operator!=="<"||pe.operator!=="<="&&pe.operator!=="<"),et=this.semver.version===pe.semver.version,_e=!(this.operator!==">="&&this.operator!=="<="||pe.operator!==">="&&pe.operator!=="<="),nt=le(this.semver,"<",pe.semver,De)&&(this.operator===">="||this.operator===">")&&(pe.operator==="<="||pe.operator==="<"),st=le(this.semver,">",pe.semver,De)&&(this.operator==="<="||this.operator==="<")&&(pe.operator===">="||pe.operator===">");return je||Ge||et&&_e||nt||st},e.Range=H,H.prototype.format=function(){return this.range=this.set.map(function(pe){return pe.join(" ").trim()}).join("||").trim(),this.range},H.prototype.toString=function(){return this.range},H.prototype.parseRange=function(pe){var De=this.loose;pe=pe.trim(),T("range",pe,De);var ke=De?A[J]:A[Y];pe=pe.replace(ke,Q),T("hyphen replace",pe),pe=pe.replace(A[_],"$1$2$3"),T("comparator trim",pe,A[_]),pe=(pe=(pe=pe.replace(A[q],"$1~")).replace(A[N],"$1^")).split(/\s+/).join(" ");var je=De?A[z]:A[ne],Ge=pe.split(" ").map(function(et){return function(_e,nt){return T("comp",_e),_e=function(st,ht){return st.trim().split(/\s+/).map(function(Fe){return function(it,ce){T("caret",it,ce);var $=ce?A[j]:A[B];return it.replace($,function(ue,Ie,Le,Be,xe){var Ze;return T("caret",it,ue,Ie,Le,Be,xe),x(Ie)?Ze="":x(Le)?Ze=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":x(Be)?Ze=Ie==="0"?">="+Ie+"."+Le+".0 <"+Ie+"."+(+Le+1)+".0":">="+Ie+"."+Le+".0 <"+(+Ie+1)+".0.0":xe?(T("replaceCaret pr",xe),xe.charAt(0)!=="-"&&(xe="-"+xe),Ze=Ie==="0"?Le==="0"?">="+Ie+"."+Le+"."+Be+xe+" <"+Ie+"."+Le+"."+(+Be+1):">="+Ie+"."+Le+"."+Be+xe+" <"+Ie+"."+(+Le+1)+".0":">="+Ie+"."+Le+"."+Be+xe+" <"+(+Ie+1)+".0.0"):(T("no pr"),Ze=Ie==="0"?Le==="0"?">="+Ie+"."+Le+"."+Be+" <"+Ie+"."+Le+"."+(+Be+1):">="+Ie+"."+Le+"."+Be+" <"+Ie+"."+(+Le+1)+".0":">="+Ie+"."+Le+"."+Be+" <"+(+Ie+1)+".0.0"),T("caret return",Ze),Ze})}(Fe,ht)}).join(" ")}(_e,nt),T("caret",_e),_e=function(st,ht){return st.trim().split(/\s+/).map(function(Fe){return function(it,ce){var $=ce?A[F]:A[V];return it.replace($,function(ue,Ie,Le,Be,xe){var Ze;return T("tilde",it,ue,Ie,Le,Be,xe),x(Ie)?Ze="":x(Le)?Ze=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":x(Be)?Ze=">="+Ie+"."+Le+".0 <"+Ie+"."+(+Le+1)+".0":xe?(T("replaceTilde pr",xe),xe.charAt(0)!=="-"&&(xe="-"+xe),Ze=">="+Ie+"."+Le+"."+Be+xe+" <"+Ie+"."+(+Le+1)+".0"):Ze=">="+Ie+"."+Le+"."+Be+" <"+Ie+"."+(+Le+1)+".0",T("tilde return",Ze),Ze})}(Fe,ht)}).join(" ")}(_e,nt),T("tildes",_e),_e=function(st,ht){return T("replaceXRanges",st,ht),st.split(/\s+/).map(function(Fe){return function(it,ce){it=it.trim();var $=ce?A[S]:A[m];return it.replace($,function(ue,Ie,Le,Be,xe,Ze){T("xRange",it,ue,Ie,Le,Be,xe,Ze);var gt=x(Le),mt=gt||x(Be),lt=mt||x(xe);return Ie==="="&&lt&&(Ie=""),gt?ue=Ie===">"||Ie==="<"?"<0.0.0":"*":Ie&&lt?(mt&&(Be=0),lt&&(xe=0),Ie===">"?(Ie=">=",mt?(Le=+Le+1,Be=0,xe=0):lt&&(Be=+Be+1,xe=0)):Ie==="<="&&(Ie="<",mt?Le=+Le+1:Be=+Be+1),ue=Ie+Le+"."+Be+"."+xe):mt?ue=">="+Le+".0.0 <"+(+Le+1)+".0.0":lt&&(ue=">="+Le+"."+Be+".0 <"+Le+"."+(+Be+1)+".0"),T("xRange return",ue),ue})}(Fe,ht)}).join(" ")}(_e,nt),T("xrange",_e),_e=function(st,ht){return T("replaceStars",st,ht),st.trim().replace(A[Z],"")}(_e,nt),T("stars",_e),_e}(et,De)}).join(" ").split(/\s+/);return this.loose&&(Ge=Ge.filter(function(et){return!!et.match(je)})),Ge=Ge.map(function(et){return new re(et,De)})},H.prototype.intersects=function(pe,De){if(!(pe instanceof H))throw new TypeError("a Range is required");return this.set.some(function(ke){return ke.every(function(je){return pe.set.some(function(Ge){return Ge.every(function(et){return je.intersects(et,De)})})})})},e.toComparators=function(pe,De){return new H(pe,De).set.map(function(ke){return ke.map(function(je){return je.value}).join(" ").trim().split(" ")})},H.prototype.test=function(pe){if(!pe)return!1;typeof pe=="string"&&(pe=new K(pe,this.loose));for(var De=0;De<this.set.length;De++)if(de(this.set[De],pe))return!0;return!1},e.satisfies=we,e.maxSatisfying=function(pe,De,ke){var je=null,Ge=null;try{var et=new H(De,ke)}catch{return null}return pe.forEach(function(_e){et.test(_e)&&(je&&Ge.compare(_e)!==-1||(Ge=new K(je=_e,ke)))}),je},e.minSatisfying=function(pe,De,ke){var je=null,Ge=null;try{var et=new H(De,ke)}catch{return null}return pe.forEach(function(_e){et.test(_e)&&(je&&Ge.compare(_e)!==1||(Ge=new K(je=_e,ke)))}),je},e.validRange=function(pe,De){try{return new H(pe,De).range||"*"}catch{return null}},e.ltr=function(pe,De,ke){return Ae(pe,De,"<",ke)},e.gtr=function(pe,De,ke){return Ae(pe,De,">",ke)},e.outside=Ae,e.prerelease=function(pe,De){var ke=X(pe,De);return ke&&ke.prerelease.length?ke.prerelease:null},e.intersects=function(pe,De,ke){return pe=new H(pe,ke),De=new H(De,ke),pe.intersects(De)},e.coerce=function(pe){if(pe instanceof K)return pe;if(typeof pe!="string")return null;var De=pe.match(A[k]);return De==null?null:X((De[1]||"0")+"."+(De[2]||"0")+"."+(De[3]||"0"))}}).call(this,o(1))},function(te,e){var o,t,T=te.exports={};function R(){throw new Error("setTimeout has not been defined")}function I(){throw new Error("clearTimeout has not been defined")}function A(d){if(o===setTimeout)return setTimeout(d,0);if((o===R||!o)&&setTimeout)return o=setTimeout,setTimeout(d,0);try{return o(d,0)}catch{try{return o.call(null,d,0)}catch{return o.call(this,d,0)}}}(function(){try{o=typeof setTimeout=="function"?setTimeout:R}catch{o=R}try{t=typeof clearTimeout=="function"?clearTimeout:I}catch{t=I}})();var y,D=[],L=!1,P=-1;function v(){L&&y&&(L=!1,y.length?D=y.concat(D):P=-1,D.length&&C())}function C(){if(!L){var d=A(v);L=!0;for(var h=D.length;h;){for(y=D,D=[];++P<h;)y&&y[P].run();P=-1,h=D.length}y=null,L=!1,function(b){if(t===clearTimeout)return clearTimeout(b);if((t===I||!t)&&clearTimeout)return t=clearTimeout,clearTimeout(b);try{t(b)}catch{try{return t.call(null,b)}catch{return t.call(this,b)}}}(d)}}function E(d,h){this.fun=d,this.array=h}function f(){}T.nextTick=function(d){var h=new Array(arguments.length-1);if(arguments.length>1)for(var b=1;b<arguments.length;b++)h[b-1]=arguments[b];D.push(new E(d,h)),D.length!==1||L||A(C)},E.prototype.run=function(){this.fun.apply(null,this.array)},T.title="browser",T.browser=!0,T.env={},T.argv=[],T.version="",T.versions={},T.on=f,T.addListener=f,T.once=f,T.off=f,T.removeListener=f,T.removeAllListeners=f,T.emit=f,T.prependListener=f,T.prependOnceListener=f,T.listeners=function(d){return[]},T.binding=function(d){throw new Error("process.binding is not supported")},T.cwd=function(){return"/"},T.chdir=function(d){throw new Error("process.chdir is not supported")},T.umask=function(){return 0}}])}),define(ye[102],Ce([1,0,9,6]),function(te,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function T(p){const w=p;return w?typeof w.read=="function":!1}e.isReadable=T;function R(p){const w=p;return w?[w.on,w.pause,w.resume,w.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=R;function I(p){const w=p;return w?R(w.stream)&&Array.isArray(w.buffer)&&typeof w.ended=="boolean":!1}e.isReadableBufferedStream=I;function A(p,w){return new y(p,w)}e.newWriteableStream=A;class y{constructor(w,i){this.e=w,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(w){if(!this.a.destroyed){if(this.a.flowing)this.g(w);else if(this.b.data.push(w),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(w){this.a.destroyed||(this.a.flowing?this.h(w):this.b.error.push(w))}end(w){this.a.destroyed||(typeof w<"u"&&this.write(w),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(w){this.c.data.slice(0).forEach(i=>i(w))}h(w){this.c.error.length===0?(0,o.onUnexpectedError)(w):this.c.error.slice(0).forEach(i=>i(w))}i(){this.c.end.slice(0).forEach(w=>w())}on(w,i){if(!this.a.destroyed)switch(w){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(w,i){if(this.a.destroyed)return;let s;switch(w){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const a=s.indexOf(i);a>=0&&s.splice(a,1)}}j(){if(this.b.data.length>0){const w=this.e(this.b.data);this.g(w),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const w of this.b.error)this.h(w);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function D(p,w){const i=[];let s;for(;(s=p.read())!==null;)i.push(s);return w(i)}e.consumeReadable=D;function L(p,w,i){const s=[];let a;for(;(a=p.read())!==null&&s.length<i;)s.push(a);return a===null&&s.length>0?w(s):{read:()=>{if(s.length>0)return s.shift();if(typeof a<"u"){const u=a;return a=void 0,u}return p.read()}}}e.peekReadable=L;function P(p,w){return new Promise((i,s)=>{const a=[];v(p,{onData:u=>{w&&a.push(u)},onError:u=>{w?s(u):i(void 0)},onEnd:()=>{i(w?w(a):void 0)}})})}e.consumeStream=P;function v(p,w){let i=!1;return p.on("error",s=>{i||w.onError(s)}),p.on("end",()=>{i||w.onEnd()}),p.on("data",s=>{i||w.onData(s)}),(0,t.toDisposable)(()=>i=!0)}e.listenStream=v;function C(p,w){return new Promise((i,s)=>{const a=new t.DisposableStore,u=[],l=r=>{if(u.push(r),u.length>w)return a.dispose(),p.pause(),i({stream:p,buffer:u,ended:!1})},c=r=>s(r),n=()=>i({stream:p,buffer:u,ended:!0});a.add((0,t.toDisposable)(()=>p.removeListener("error",c))),p.on("error",c),a.add((0,t.toDisposable)(()=>p.removeListener("end",n))),p.on("end",n),a.add((0,t.toDisposable)(()=>p.removeListener("data",l))),p.on("data",l)})}e.peekStream=C;function E(p,w){const i=A(w);return i.end(p),i}e.toStream=E;function f(){const p=A(()=>{throw new Error("not supported")});return p.end(),p}e.emptyStream=f;function d(p){let w=!1;return{read:()=>w?null:(w=!0,p)}}e.toReadable=d;function h(p,w,i){const s=A(i);return v(p,{onData:a=>s.write(w.data(a)),onError:a=>s.error(w.error?w.error(a):a),onEnd:()=>s.end()}),s}e.transform=h;function b(p,w,i){let s=!1;return{read:()=>{const a=w.read();return s?a:(s=!0,a!==null?i([p,a]):p)}}}e.prefixedReadable=b;function g(p,w,i){let s=!1;const a=A(i);return v(w,{onData:u=>s?a.write(u):(s=!0,a.write(i([p,u]))),onError:u=>a.error(u),onEnd:()=>{s||(s=!0,a.write(p)),a.end()}}),a}e.prefixedStream=g}),define(ye[22],Ce([1,0,102]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer<"u";let T,R;class I{static alloc(r){return t?new I(Buffer.allocUnsafe(r)):new I(new Uint8Array(r))}static wrap(r){return t&&!Buffer.isBuffer(r)&&(r=Buffer.from(r.buffer,r.byteOffset,r.byteLength)),new I(r)}static fromString(r,m){return!(m?.dontUseNodeBuffer||!1)&&t?new I(Buffer.from(r)):(T||(T=new TextEncoder),new I(T.encode(r)))}static fromByteArray(r){const m=I.alloc(r.length);for(let S=0,k=r.length;S<k;S++)m.buffer[S]=r[S];return m}static concat(r,m){if(typeof m>"u"){m=0;for(let M=0,q=r.length;M<q;M++)m+=r[M].byteLength}const S=I.alloc(m);let k=0;for(let M=0,q=r.length;M<q;M++){const V=r[M];S.set(V,k),k+=V.byteLength}return S}constructor(r){this.buffer=r,this.byteLength=this.buffer.byteLength}clone(){const r=I.alloc(this.byteLength);return r.set(this),r}toString(){return t?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(r,m){return new I(this.buffer.subarray(r,m))}set(r,m){if(r instanceof I)this.buffer.set(r.buffer,m);else if(r instanceof Uint8Array)this.buffer.set(r,m);else if(r instanceof ArrayBuffer)this.buffer.set(new Uint8Array(r),m);else if(ArrayBuffer.isView(r))this.buffer.set(new Uint8Array(r.buffer,r.byteOffset,r.byteLength),m);else throw new Error("Unknown argument 'array'")}readUInt32BE(r){return D(this.buffer,r)}writeUInt32BE(r,m){L(this.buffer,r,m)}readUInt32LE(r){return P(this.buffer,r)}writeUInt32LE(r,m){v(this.buffer,r,m)}readUInt8(r){return C(this.buffer,r)}writeUInt8(r,m){E(this.buffer,r,m)}}e.VSBuffer=I;function A(n,r){return n[r+0]<<0>>>0|n[r+1]<<8>>>0}e.readUInt16LE=A;function y(n,r,m){n[m+0]=r&255,r=r>>>8,n[m+1]=r&255}e.writeUInt16LE=y;function D(n,r){return n[r]*2**24+n[r+1]*2**16+n[r+2]*2**8+n[r+3]}e.readUInt32BE=D;function L(n,r,m){n[m+3]=r,r=r>>>8,n[m+2]=r,r=r>>>8,n[m+1]=r,r=r>>>8,n[m]=r}e.writeUInt32BE=L;function P(n,r){return n[r+0]<<0>>>0|n[r+1]<<8>>>0|n[r+2]<<16>>>0|n[r+3]<<24>>>0}e.readUInt32LE=P;function v(n,r,m){n[m+0]=r&255,r=r>>>8,n[m+1]=r&255,r=r>>>8,n[m+2]=r&255,r=r>>>8,n[m+3]=r&255}e.writeUInt32LE=v;function C(n,r){return n[r]}e.readUInt8=C;function E(n,r,m){n[m]=r}e.writeUInt8=E;function f(n){return o.consumeReadable(n,r=>I.concat(r))}e.readableToBuffer=f;function d(n){return o.toReadable(n)}e.bufferToReadable=d;function h(n){return o.consumeStream(n,r=>I.concat(r))}e.streamToBuffer=h;async function b(n){return n.ended?I.concat(n.buffer):I.concat([...n.buffer,await h(n.stream)])}e.bufferedStreamToBuffer=b;function g(n){return o.toStream(n,r=>I.concat(r))}e.bufferToStream=g;function p(n){return o.transform(n,{data:r=>typeof r=="string"?I.fromString(r):I.wrap(r)},r=>I.concat(r))}e.streamToBufferReadableStream=p;function w(n){return o.newWriteableStream(r=>I.concat(r),n)}e.newWriteableBufferStream=w;function i(n,r){return o.prefixedReadable(n,r,m=>I.concat(m))}e.prefixedBufferReadable=i;function s(n,r){return o.prefixedStream(n,r,m=>I.concat(m))}e.prefixedBufferStream=s;function a(n){let r=0,m=0,S=0;const k=new Uint8Array(Math.floor(n.length/4*3)),M=V=>{switch(m){case 3:k[S++]=r|V,m=0;break;case 2:k[S++]=r|V>>>2,r=V<<6,m=3;break;case 1:k[S++]=r|V>>>4,r=V<<4,m=2;break;default:r=V<<2,m=1}};for(let V=0;V<n.length;V++){const F=n.charCodeAt(V);if(F>=65&&F<=90)M(F-65);else if(F>=97&&F<=122)M(F-97+26);else if(F>=48&&F<=57)M(F-48+52);else if(F===43||F===45)M(62);else if(F===47||F===95)M(63);else{if(F===61)break;throw new SyntaxError(`Unexpected base64 character ${n[V]}`)}}const q=S;for(;m>0;)M(0);return I.wrap(k).slice(0,q)}e.decodeBase64=a;const u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function c({buffer:n},r=!0,m=!1){const S=m?l:u;let k="";const M=n.byteLength%3;let q=0;for(;q<n.byteLength-M;q+=3){const V=n[q+0],F=n[q+1],U=n[q+2];k+=S[V>>>2],k+=S[(V<<4|F>>>4)&63],k+=S[(F<<2|U>>>6)&63],k+=S[U&63]}if(M===1){const V=n[q+0];k+=S[V>>>2],k+=S[V<<4&63],r&&(k+="==")}else if(M===2){const V=n[q+0],F=n[q+1];k+=S[V>>>2],k+=S[(V<<4|F>>>4)&63],k+=S[F<<2&63],r&&(k+="=")}return k}e.encodeBase64=c}),define(ye[11],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function o(s){return typeof s=="string"}e.isString=o;function t(s){return Array.isArray(s)&&s.every(a=>o(a))}e.isStringArray=t;function T(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}e.isObject=T;function R(s){const a=Object.getPrototypeOf(Uint8Array);return typeof s=="object"&&s instanceof a}e.isTypedArray=R;function I(s){return typeof s=="number"&&!isNaN(s)}e.isNumber=I;function A(s){return!!s&&typeof s[Symbol.iterator]=="function"}e.isIterable=A;function y(s){return s===!0||s===!1}e.isBoolean=y;function D(s){return typeof s>"u"}e.isUndefined=D;function L(s){return!P(s)}e.isDefined=L;function P(s){return D(s)||s===null}e.isUndefinedOrNull=P;function v(s,a){if(!s)throw new Error(a?`Unexpected type, expected '${a}'`:"Unexpected type")}e.assertType=v;function C(s){if(P(s))throw new Error("Assertion Failed: argument is undefined or null");return s}e.assertIsDefined=C;function E(...s){const a=[];for(let u=0;u<s.length;u++){const l=s[u];if(P(l))throw new Error(`Assertion Failed: argument at index ${u} is undefined or null`);a.push(l)}return a}e.assertAllDefined=E;const f=Object.prototype.hasOwnProperty;function d(s){if(!T(s))return!1;for(const a in s)if(f.call(s,a))return!1;return!0}e.isEmptyObject=d;function h(s){return typeof s=="function"}e.isFunction=h;function b(...s){return s.length>0&&s.every(h)}e.areFunctions=b;function g(s,a){const u=Math.min(s.length,a.length);for(let l=0;l<u;l++)p(s[l],a[l])}e.validateConstraints=g;function p(s,a){if(o(a)){if(typeof s!==a)throw new Error(`argument does not match constraint: typeof ${a}`)}else if(h(a)){try{if(s instanceof a)return}catch{}if(!P(s)&&s.constructor===a||a.length===1&&a.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=p;function w(s){return s===null?void 0:s}e.withNullAsUndefined=w;function i(s){return typeof s>"u"?null:s}e.withUndefinedAsNull=i}),define(ye[23],Ce([1,0,11]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const b=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([g,p])=>{b[g]=p&&typeof p=="object"?t(p):p}),b}e.deepClone=t;function T(h){if(!h||typeof h!="object")return h;const b=[h];for(;b.length>0;){const g=b.shift();Object.freeze(g);for(const p in g)if(R.call(g,p)){const w=g[p];typeof w=="object"&&!Object.isFrozen(w)&&!(0,o.isTypedArray)(w)&&b.push(w)}}return h}e.deepFreeze=T;const R=Object.prototype.hasOwnProperty;function I(h,b){return A(h,b,new Set)}e.cloneAndChange=I;function A(h,b,g){if((0,o.isUndefinedOrNull)(h))return h;const p=b(h);if(typeof p<"u")return p;if(Array.isArray(h)){const w=[];for(const i of h)w.push(A(i,b,g));return w}if((0,o.isObject)(h)){if(g.has(h))throw new Error("Cannot clone recursive data-structure");g.add(h);const w={};for(const i in h)R.call(h,i)&&(w[i]=A(h[i],b,g));return g.delete(h),w}return h}function y(h,b,g=!0){return(0,o.isObject)(h)?((0,o.isObject)(b)&&Object.keys(b).forEach(p=>{p in h?g&&((0,o.isObject)(h[p])&&(0,o.isObject)(b[p])?y(h[p],b[p],g):h[p]=b[p]):h[p]=b[p]}),h):b}e.mixin=y;function D(h,b){if(h===b)return!0;if(h==null||b===null||b===void 0||typeof h!=typeof b||typeof h!="object"||Array.isArray(h)!==Array.isArray(b))return!1;let g,p;if(Array.isArray(h)){if(h.length!==b.length)return!1;for(g=0;g<h.length;g++)if(!D(h[g],b[g]))return!1}else{const w=[];for(p in h)w.push(p);w.sort();const i=[];for(p in b)i.push(p);if(i.sort(),!D(w,i))return!1;for(g=0;g<w.length;g++)if(!D(h[w[g]],b[w[g]]))return!1}return!0}e.equals=D;function L(h){const b=new Set;return JSON.stringify(h,(g,p)=>{if((0,o.isObject)(p)||Array.isArray(p)){if(b.has(p))return"[Circular]";b.add(p)}return p})}e.safeStringify=L;function P(h,b){const g=Object.create(null);return!h||!b||Object.keys(b).forEach(w=>{const i=h[w],s=b[w];D(i,s)||(g[w]=s)}),g}e.distinct=P;function v(h,b){const g=b.toLowerCase(),p=Object.keys(h).find(w=>w.toLowerCase()===g);return p?h[p]:h[b]}e.getCaseInsensitive=v;function C(h,b){const g=Object.create(null);for(const[p,w]of Object.entries(h))b(p,w)&&(g[p]=w);return g}e.filter=C;function E(h){let b=[],g=Object.getPrototypeOf(h);for(;Object.prototype!==g;)b=b.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return b}e.getAllPropertyNames=E;function f(h){const b=[];for(const g of E(h))typeof h[g]=="function"&&b.push(g);return b}e.getAllMethodNames=f;function d(h,b){const g=w=>function(){const i=Array.prototype.slice.call(arguments,0);return b(w,i)},p={};for(const w of h)p[w]=g(w);return p}e.createProxyObject=d}),define(ye[103],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var o;(function(R){R[R.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",R[R.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",R[R.MAX_UINT_8=255]="MAX_UINT_8",R[R.MAX_UINT_16=65535]="MAX_UINT_16",R[R.MAX_UINT_32=4294967295]="MAX_UINT_32",R[R.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(o=e.Constants||(e.Constants={}));function t(R){return R<0?0:R>255?255:R|0}e.toUint8=t;function T(R){return R<0?0:R>4294967295?4294967295:R|0}e.toUint32=T}),define(ye[30],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const o=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(T){return o.test(T)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let T;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?T=crypto.getRandomValues.bind(crypto):T=function(A){for(let y=0;y<A.length;y++)A[y]=Math.floor(Math.random()*256);return A};const R=new Uint8Array(16),I=[];for(let A=0;A<256;A++)I.push(A.toString(16).padStart(2,"0"));return function(){T(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let y=0,D="";return D+=I[R[y++]],D+=I[R[y++]],D+=I[R[y++]],D+=I[R[y++]],D+="-",D+=I[R[y++]],D+=I[R[y++]],D+="-",D+=I[R[y++]],D+=I[R[y++]],D+="-",D+=I[R[y++]],D+=I[R[y++]],D+="-",D+=I[R[y++]],D+=I[R[y++]],D+=I[R[y++]],D+=I[R[y++]],D+=I[R[y++]],D+=I[R[y++]],D}}()}),define(ye[148],Ce([1,0,18,30]),function(te,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function T(A){return{id:(0,t.generateUuid)(),asString:async()=>A,asFile:()=>{},value:typeof A=="string"?A:void 0}}e.createStringDataTransferItem=T;function R(A,y,D){return{id:(0,t.generateUuid)(),asString:async()=>"",asFile:()=>({name:A,uri:y,data:D}),value:void 0}}e.createFileDataTransferItem=R;class I{constructor(){this.a=new Map}get size(){return this.a.size}has(y){return this.a.has(this.b(y))}get(y){return this.a.get(this.b(y))?.[0]}append(y,D){const L=this.a.get(y);L?L.push(D):this.a.set(this.b(y),[D])}replace(y,D){this.a.set(this.b(y),[D])}delete(y){this.a.delete(this.b(y))}*entries(){for(const[y,D]of this.a.entries())for(const L of D)yield[y,L]}values(){return Array.from(this.a.values()).flat()}forEach(y){for(const[D,L]of this.entries())y(L,D)}b(y){return y.toLowerCase()}}e.VSDataTransfer=I,e.UriList=Object.freeze({create:A=>(0,o.distinct)(A.map(y=>y.toString())).join(`\r
`),split:A=>A.split(`\r
`),parse:A=>e.UriList.split(A).filter(y=>!y.startsWith("#"))})}),define(ye[104],Ce([1,0,103]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class t{constructor(A){const y=(0,o.toUint8)(A);this.c=y,this.a=t.d(y),this.b=new Map}static d(A){const y=new Uint8Array(256);return y.fill(A),y}set(A,y){const D=(0,o.toUint8)(y);A>=0&&A<256?this.a[A]=D:this.b.set(A,D)}get(A){return A>=0&&A<256?this.a[A]:this.b.get(A)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.CharacterClassifier=t;var T;(function(I){I[I.False=0]="False",I[I.True=1]="True"})(T||(T={}));class R{constructor(){this.a=new t(0)}add(A){this.a.set(A,1)}has(A){return this.a.get(A)===1}clear(){return this.a.clear()}}e.CharacterSet=R}),define(ye[51],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class o{constructor(T,R){this.lineNumber=T,this.column=R}with(T=this.lineNumber,R=this.column){return T===this.lineNumber&&R===this.column?this:new o(T,R)}delta(T=0,R=0){return this.with(this.lineNumber+T,this.column+R)}equals(T){return o.equals(this,T)}static equals(T,R){return!T&&!R?!0:!!T&&!!R&&T.lineNumber===R.lineNumber&&T.column===R.column}isBefore(T){return o.isBefore(this,T)}static isBefore(T,R){return T.lineNumber<R.lineNumber?!0:R.lineNumber<T.lineNumber?!1:T.column<R.column}isBeforeOrEqual(T){return o.isBeforeOrEqual(this,T)}static isBeforeOrEqual(T,R){return T.lineNumber<R.lineNumber?!0:R.lineNumber<T.lineNumber?!1:T.column<=R.column}static compare(T,R){const I=T.lineNumber|0,A=R.lineNumber|0;if(I===A){const y=T.column|0,D=R.column|0;return y-D}return I-A}clone(){return new o(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(T){return new o(T.lineNumber,T.column)}static isIPosition(T){return T&&typeof T.lineNumber=="number"&&typeof T.column=="number"}}e.Position=o}),define(ye[35],Ce([1,0,51]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class t{constructor(R,I,A,y){R>A||R===A&&I>y?(this.startLineNumber=A,this.startColumn=y,this.endLineNumber=R,this.endColumn=I):(this.startLineNumber=R,this.startColumn=I,this.endLineNumber=A,this.endColumn=y)}isEmpty(){return t.isEmpty(this)}static isEmpty(R){return R.startLineNumber===R.endLineNumber&&R.startColumn===R.endColumn}containsPosition(R){return t.containsPosition(this,R)}static containsPosition(R,I){return!(I.lineNumber<R.startLineNumber||I.lineNumber>R.endLineNumber||I.lineNumber===R.startLineNumber&&I.column<R.startColumn||I.lineNumber===R.endLineNumber&&I.column>R.endColumn)}static strictContainsPosition(R,I){return!(I.lineNumber<R.startLineNumber||I.lineNumber>R.endLineNumber||I.lineNumber===R.startLineNumber&&I.column<=R.startColumn||I.lineNumber===R.endLineNumber&&I.column>=R.endColumn)}containsRange(R){return t.containsRange(this,R)}static containsRange(R,I){return!(I.startLineNumber<R.startLineNumber||I.endLineNumber<R.startLineNumber||I.startLineNumber>R.endLineNumber||I.endLineNumber>R.endLineNumber||I.startLineNumber===R.startLineNumber&&I.startColumn<R.startColumn||I.endLineNumber===R.endLineNumber&&I.endColumn>R.endColumn)}strictContainsRange(R){return t.strictContainsRange(this,R)}static strictContainsRange(R,I){return!(I.startLineNumber<R.startLineNumber||I.endLineNumber<R.startLineNumber||I.startLineNumber>R.endLineNumber||I.endLineNumber>R.endLineNumber||I.startLineNumber===R.startLineNumber&&I.startColumn<=R.startColumn||I.endLineNumber===R.endLineNumber&&I.endColumn>=R.endColumn)}plusRange(R){return t.plusRange(this,R)}static plusRange(R,I){let A,y,D,L;return I.startLineNumber<R.startLineNumber?(A=I.startLineNumber,y=I.startColumn):I.startLineNumber===R.startLineNumber?(A=I.startLineNumber,y=Math.min(I.startColumn,R.startColumn)):(A=R.startLineNumber,y=R.startColumn),I.endLineNumber>R.endLineNumber?(D=I.endLineNumber,L=I.endColumn):I.endLineNumber===R.endLineNumber?(D=I.endLineNumber,L=Math.max(I.endColumn,R.endColumn)):(D=R.endLineNumber,L=R.endColumn),new t(A,y,D,L)}intersectRanges(R){return t.intersectRanges(this,R)}static intersectRanges(R,I){let A=R.startLineNumber,y=R.startColumn,D=R.endLineNumber,L=R.endColumn;const P=I.startLineNumber,v=I.startColumn,C=I.endLineNumber,E=I.endColumn;return A<P?(A=P,y=v):A===P&&(y=Math.max(y,v)),D>C?(D=C,L=E):D===C&&(L=Math.min(L,E)),A>D||A===D&&y>L?null:new t(A,y,D,L)}equalsRange(R){return t.equalsRange(this,R)}static equalsRange(R,I){return!R&&!I?!0:!!R&&!!I&&R.startLineNumber===I.startLineNumber&&R.startColumn===I.startColumn&&R.endLineNumber===I.endLineNumber&&R.endColumn===I.endColumn}getEndPosition(){return t.getEndPosition(this)}static getEndPosition(R){return new o.Position(R.endLineNumber,R.endColumn)}getStartPosition(){return t.getStartPosition(this)}static getStartPosition(R){return new o.Position(R.startLineNumber,R.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(R,I){return new t(this.startLineNumber,this.startColumn,R,I)}setStartPosition(R,I){return new t(R,I,this.endLineNumber,this.endColumn)}collapseToStart(){return t.collapseToStart(this)}static collapseToStart(R){return new t(R.startLineNumber,R.startColumn,R.startLineNumber,R.startColumn)}collapseToEnd(){return t.collapseToEnd(this)}static collapseToEnd(R){return new t(R.endLineNumber,R.endColumn,R.endLineNumber,R.endColumn)}delta(R){return new t(this.startLineNumber+R,this.startColumn,this.endLineNumber+R,this.endColumn)}static fromPositions(R,I=R){return new t(R.lineNumber,R.column,I.lineNumber,I.column)}static lift(R){return R?new t(R.startLineNumber,R.startColumn,R.endLineNumber,R.endColumn):null}static isIRange(R){return R&&typeof R.startLineNumber=="number"&&typeof R.startColumn=="number"&&typeof R.endLineNumber=="number"&&typeof R.endColumn=="number"}static areIntersectingOrTouching(R,I){return!(R.endLineNumber<I.startLineNumber||R.endLineNumber===I.startLineNumber&&R.endColumn<I.startColumn||I.endLineNumber<R.startLineNumber||I.endLineNumber===R.startLineNumber&&I.endColumn<R.startColumn)}static areIntersecting(R,I){return!(R.endLineNumber<I.startLineNumber||R.endLineNumber===I.startLineNumber&&R.endColumn<=I.startColumn||I.endLineNumber<R.startLineNumber||I.endLineNumber===R.startLineNumber&&I.endColumn<=R.startColumn)}static compareRangesUsingStarts(R,I){if(R&&I){const D=R.startLineNumber|0,L=I.startLineNumber|0;if(D===L){const P=R.startColumn|0,v=I.startColumn|0;if(P===v){const C=R.endLineNumber|0,E=I.endLineNumber|0;if(C===E){const f=R.endColumn|0,d=I.endColumn|0;return f-d}return C-E}return P-v}return D-L}return(R?1:0)-(I?1:0)}static compareRangesUsingEnds(R,I){return R.endLineNumber===I.endLineNumber?R.endColumn===I.endColumn?R.startLineNumber===I.startLineNumber?R.startColumn-I.startColumn:R.startLineNumber-I.startLineNumber:R.endColumn-I.endColumn:R.endLineNumber-I.endLineNumber}static spansMultipleLines(R){return R.endLineNumber>R.startLineNumber}toJSON(){return this}}e.Range=t}),define(ye[149],Ce([1,0,51,35]),function(te,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var T;(function(I){I[I.LTR=0]="LTR",I[I.RTL=1]="RTL"})(T=e.SelectionDirection||(e.SelectionDirection={}));class R extends t.Range{constructor(A,y,D,L){super(A,y,D,L),this.selectionStartLineNumber=A,this.selectionStartColumn=y,this.positionLineNumber=D,this.positionColumn=L}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(A){return R.selectionsEqual(this,A)}static selectionsEqual(A,y){return A.selectionStartLineNumber===y.selectionStartLineNumber&&A.selectionStartColumn===y.selectionStartColumn&&A.positionLineNumber===y.positionLineNumber&&A.positionColumn===y.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(A,y){return this.getDirection()===0?new R(this.startLineNumber,this.startColumn,A,y):new R(A,y,this.startLineNumber,this.startColumn)}getPosition(){return new o.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new o.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(A,y){return this.getDirection()===0?new R(A,y,this.endLineNumber,this.endColumn):new R(this.endLineNumber,this.endColumn,A,y)}static fromPositions(A,y=A){return new R(A.lineNumber,A.column,y.lineNumber,y.column)}static fromRange(A,y){return y===0?new R(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):new R(A.endLineNumber,A.endColumn,A.startLineNumber,A.startColumn)}static liftSelection(A){return new R(A.selectionStartLineNumber,A.selectionStartColumn,A.positionLineNumber,A.positionColumn)}static selectionsArrEqual(A,y){if(A&&!y||!A&&y)return!1;if(!A&&!y)return!0;if(A.length!==y.length)return!1;for(let D=0,L=A.length;D<L;D++)if(!this.selectionsEqual(A[D],y[D]))return!1;return!0}static isISelection(A){return A&&typeof A.selectionStartLineNumber=="number"&&typeof A.selectionStartColumn=="number"&&typeof A.positionLineNumber=="number"&&typeof A.positionColumn=="number"}static createWithDirection(A,y,D,L,P){return P===0?new R(A,y,D,L):new R(D,L,A,y)}}e.Selection=R}),define(ye[150],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ye[151],Ce([1,0,104]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var t;(function(I){I[I.Regular=0]="Regular",I[I.Whitespace=1]="Whitespace",I[I.WordSeparator=2]="WordSeparator"})(t=e.WordCharacterClass||(e.WordCharacterClass={}));class T extends o.CharacterClassifier{constructor(A){super(0);for(let y=0,D=A.length;y<D;y++)this.set(A.charCodeAt(y),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=T;function R(I){const A={};return y=>(A.hasOwnProperty(y)||(A[y]=I(y)),A[y])}e.getMapForWordSeparators=R(I=>new T(I))}),define(ye[105],Ce([1,0,62,6,63]),function(te,e,o,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.setDefaultGetWordAtTextConfig=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function R(P=""){let v="(-?\\d*\\.\\d\\w*)|([^";for(const C of e.USUAL_WORD_SEPARATORS)P.indexOf(C)>=0||(v+="\\"+C);return v+="\\s]+)",new RegExp(v,"g")}e.DEFAULT_WORD_REGEXP=R();function I(P){let v=e.DEFAULT_WORD_REGEXP;if(P&&P instanceof RegExp)if(P.global)v=P;else{let C="g";P.ignoreCase&&(C+="i"),P.multiline&&(C+="m"),P.unicode&&(C+="u"),v=new RegExp(P.source,C)}return v.lastIndex=0,v}e.ensureValidWordDefinition=I;const A=new T.LinkedList;A.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function y(P){const v=A.unshift(P);return(0,t.toDisposable)(v)}e.setDefaultGetWordAtTextConfig=y;function D(P,v,C,E,f){if(f||(f=o.Iterable.first(A)),C.length>f.maxLen){let p=P-f.maxLen/2;return p<0?p=0:E+=p,C=C.substring(p,P+f.maxLen/2),D(P,v,C,E,f)}const d=Date.now(),h=P-1-E;let b=-1,g=null;for(let p=1;!(Date.now()-d>=f.timeBudget);p++){const w=h-f.windowSize*p;v.lastIndex=Math.max(0,w);const i=L(v,C,h,b);if(!i&&g||(g=i,w<=0))break;b=w}if(g){const p={word:g[0],startColumn:E+1+g.index,endColumn:E+1+g.index+g[0].length};return v.lastIndex=0,p}return null}e.getWordAtText=D;function L(P,v,C,E){let f;for(;f=P.exec(v);){const d=f.index||0;if(d<=C&&P.lastIndex>=C)return f;if(E>0&&d>E)return null}return null}}),define(ye[152],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var o;(function(I){I[I.None=0]="None",I[I.Indent=1]="Indent",I[I.IndentOutdent=2]="IndentOutdent",I[I.Outdent=3]="Outdent"})(o=e.IndentAction||(e.IndentAction={}));class t{constructor(A){if(this.e=null,this.f=!1,this.open=A.open,this.close=A.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(A.notIn))for(let y=0,D=A.notIn.length;y<D;y++)switch(A.notIn[y]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(A){switch(A){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(A,y){if(A.getTokenCount()===0)return!0;const D=A.findTokenIndexAtOffset(y-2),L=A.getStandardTokenType(D);return this.isOK(L)}g(A,y){for(let D=A;D<=y;D++){const L=String.fromCharCode(D);if(!this.open.includes(L)&&!this.close.includes(L))return L}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.StandardAutoClosingPairConditional=t;class T{constructor(A){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of A)R(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),R(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),R(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),R(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&R(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=T;function R(I,A,y){I.has(A)?I.get(A).push(y):I.set(A,[y])}}),define(ye[153],Ce([1,0,104]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.State=void 0;var t;(function(C){C[C.Invalid=0]="Invalid",C[C.Start=1]="Start",C[C.H=2]="H",C[C.HT=3]="HT",C[C.HTT=4]="HTT",C[C.HTTP=5]="HTTP",C[C.F=6]="F",C[C.FI=7]="FI",C[C.FIL=8]="FIL",C[C.BeforeColon=9]="BeforeColon",C[C.AfterColon=10]="AfterColon",C[C.AlmostThere=11]="AlmostThere",C[C.End=12]="End",C[C.Accept=13]="Accept",C[C.LastKnownState=14]="LastKnownState"})(t=e.State||(e.State={}));class T{constructor(E,f,d){const h=new Uint8Array(E*f);for(let b=0,g=E*f;b<g;b++)h[b]=d;this.a=h,this.rows=E,this.cols=f}get(E,f){return this.a[E*this.cols+f]}set(E,f,d){this.a[E*this.cols+f]=d}}class R{constructor(E){let f=0,d=0;for(let b=0,g=E.length;b<g;b++){const[p,w,i]=E[b];w>f&&(f=w),p>d&&(d=p),i>d&&(d=i)}f++,d++;const h=new T(d,f,0);for(let b=0,g=E.length;b<g;b++){const[p,w,i]=E[b];h.set(p,w,i)}this.a=h,this.b=f}nextState(E,f){return f<0||f>=this.b?0:this.a.get(E,f)}}e.StateMachine=R;let I=null;function A(){return I===null&&(I=new R([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),I}var y;(function(C){C[C.None=0]="None",C[C.ForceTermination=1]="ForceTermination",C[C.CannotEndIn=2]="CannotEndIn"})(y||(y={}));let D=null;function L(){if(D===null){D=new o.CharacterClassifier(0);const C=`, 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let f=0;f<C.length;f++)D.set(C.charCodeAt(f),1);const E=".;:";for(let f=0;f<E.length;f++)D.set(E.charCodeAt(f),2)}return D}class P{static a(E,f,d,h,b){let g=b-1;do{const p=f.charCodeAt(g);if(E.get(p)!==2)break;g--}while(g>h);if(h>0){const p=f.charCodeAt(h-1),w=f.charCodeAt(g);(p===40&&w===41||p===91&&w===93||p===123&&w===125)&&g--}return{range:{startLineNumber:d,startColumn:h+1,endLineNumber:d,endColumn:g+2},url:f.substring(h,g+1)}}static computeLinks(E,f=A()){const d=L(),h=[];for(let b=1,g=E.getLineCount();b<=g;b++){const p=E.getLineContent(b),w=p.length;let i=0,s=0,a=0,u=1,l=!1,c=!1,n=!1,r=!1;for(;i<w;){let m=!1;const S=p.charCodeAt(i);if(u===13){let k;switch(S){case 40:l=!0,k=0;break;case 41:k=l?0:1;break;case 91:n=!0,c=!0,k=0;break;case 93:n=!1,k=c?0:1;break;case 123:r=!0,k=0;break;case 125:k=r?0:1;break;case 39:case 34:case 96:a===S?k=1:a===39||a===34||a===96?k=0:k=1;break;case 42:k=a===42?1:0;break;case 124:k=a===124?1:0;break;case 32:k=n?0:1;break;default:k=d.get(S)}k===1&&(h.push(P.a(d,p,b,s,i)),m=!0)}else if(u===12){let k;S===91?(c=!0,k=0):k=d.get(S),k===1?m=!0:u=13}else u=f.nextState(u,S),u===0&&(m=!0);m&&(u=1,l=!1,c=!1,r=!1,s=i+1,a=S),i++}u===13&&h.push(P.a(d,p,b,s,w))}return h}}e.LinkComputer=P;function v(C){return!C||typeof C.getLineCount!="function"||typeof C.getLineContent!="function"?[]:P.computeLinks(C)}e.computeLinks=v}),define(ye[106],Ce([1,0,23]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.isITextSnapshot=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.OverviewRulerLane=void 0;var t;(function(g){g[g.Left=1]="Left",g[g.Center=2]="Center",g[g.Right=4]="Right",g[g.Full=7]="Full"})(t=e.OverviewRulerLane||(e.OverviewRulerLane={}));var T;(function(g){g[g.Inline=1]="Inline",g[g.Gutter=2]="Gutter"})(T=e.MinimapPosition||(e.MinimapPosition={}));var R;(function(g){g[g.Both=0]="Both",g[g.Right=1]="Right",g[g.Left=2]="Left",g[g.None=3]="None"})(R=e.InjectedTextCursorStops||(e.InjectedTextCursorStops={}));var I;(function(g){g[g.TextDefined=0]="TextDefined",g[g.LF=1]="LF",g[g.CRLF=2]="CRLF"})(I=e.EndOfLinePreference||(e.EndOfLinePreference={}));var A;(function(g){g[g.LF=1]="LF",g[g.CRLF=2]="CRLF"})(A=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var y;(function(g){g[g.LF=0]="LF",g[g.CRLF=1]="CRLF"})(y=e.EndOfLineSequence||(e.EndOfLineSequence={}));class D{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(p){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,p.tabSize|0),p.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,p.indentSize|0),this.a=!1),this.insertSpaces=Boolean(p.insertSpaces),this.defaultEOL=p.defaultEOL|0,this.trimAutoWhitespace=Boolean(p.trimAutoWhitespace),this.bracketPairColorizationOptions=p.bracketPairColorizationOptions}equals(p){return this.tabSize===p.tabSize&&this.a===p.a&&this.indentSize===p.indentSize&&this.insertSpaces===p.insertSpaces&&this.defaultEOL===p.defaultEOL&&this.trimAutoWhitespace===p.trimAutoWhitespace&&(0,o.equals)(this.bracketPairColorizationOptions,p.bracketPairColorizationOptions)}createChangeEvent(p){return{tabSize:this.tabSize!==p.tabSize,indentSize:this.indentSize!==p.indentSize,insertSpaces:this.insertSpaces!==p.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==p.trimAutoWhitespace}}}e.TextModelResolvedOptions=D;class L{constructor(p,w){this._findMatchBrand=void 0,this.range=p,this.matches=w}}e.FindMatch=L;var P;(function(g){g[g.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",g[g.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",g[g.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",g[g.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(P=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));function v(g){return g&&typeof g.read=="function"}e.isITextSnapshot=v;var C;(function(g){g[g.Left=0]="Left",g[g.Right=1]="Right",g[g.None=2]="None",g[g.LeftOfInjectedText=3]="LeftOfInjectedText",g[g.RightOfInjectedText=4]="RightOfInjectedText"})(C=e.PositionAffinity||(e.PositionAffinity={}));var E;(function(g){g[g.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(E=e.ModelConstants||(e.ModelConstants={}));class f{constructor(p,w,i,s,a,u){this.identifier=p,this.range=w,this.text=i,this.forceMoveMarkers=s,this.isAutoWhitespaceEdit=a,this._isTracked=u}}e.ValidAnnotatedEditOperation=f;class d{constructor(p,w,i){this.regex=p,this.wordSeparators=w,this.simpleSearch=i}}e.SearchData=d;class h{constructor(p,w,i){this.reverseEdits=p,this.changes=w,this.trimAutoWhitespaceLineNumbers=i}}e.ApplyEditsResult=h;function b(g){return!g.isTooLargeForSyncing()&&!g.isForSimpleWidget}e.shouldSynchronizeModel=b}),define(ye[154],Ce([1,0,18,103]),function(te,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class T{constructor(y){this.a=y,this.b=new Uint32Array(y.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(y,D){y=(0,t.toUint32)(y);const L=this.a,P=this.b,v=D.length;return v===0?!1:(this.a=new Uint32Array(L.length+v),this.a.set(L.subarray(0,y),0),this.a.set(L.subarray(y),y+v),this.a.set(D,y),y-1<this.c[0]&&(this.c[0]=y-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(P.subarray(0,this.c[0]+1)),!0)}setValue(y,D){return y=(0,t.toUint32)(y),D=(0,t.toUint32)(D),this.a[y]===D?!1:(this.a[y]=D,y-1<this.c[0]&&(this.c[0]=y-1),!0)}removeValues(y,D){y=(0,t.toUint32)(y),D=(0,t.toUint32)(D);const L=this.a,P=this.b;if(y>=L.length)return!1;const v=L.length-y;return D>=v&&(D=v),D===0?!1:(this.a=new Uint32Array(L.length-D),this.a.set(L.subarray(0,y),0),this.a.set(L.subarray(y+D),y),this.b=new Uint32Array(this.a.length),y-1<this.c[0]&&(this.c[0]=y-1),this.c[0]>=0&&this.b.set(P.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(y){return y<0?0:(y=(0,t.toUint32)(y),this.d(y))}d(y){if(y<=this.c[0])return this.b[y];let D=this.c[0]+1;D===0&&(this.b[0]=this.a[0],D++),y>=this.a.length&&(y=this.a.length-1);for(let L=D;L<=y;L++)this.b[L]=this.b[L-1]+this.a[L];return this.c[0]=Math.max(this.c[0],y),this.b[y]}getIndexOf(y){y=Math.floor(y),this.getTotalSum();let D=0,L=this.a.length-1,P=0,v=0,C=0;for(;D<=L;)if(P=D+(L-D)/2|0,v=this.b[P],C=v-this.a[P],y<C)L=P-1;else if(y>=v)D=P+1;else break;return new I(P,y-C)}}e.PrefixSumComputer=T;class R{constructor(y){this.a=y,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(y){return this.g(),y===0?0:this.d[y-1]}getIndexOf(y){this.g();const D=this.e[y],L=D>0?this.d[D-1]:0;return new I(D,y-L)}removeValues(y,D){this.a.splice(y,D),this.f(y)}insertValues(y,D){this.a=(0,o.arrayInsert)(this.a,y,D),this.f(y)}f(y){this.b=!1,this.c=Math.min(this.c,y-1)}g(){if(!this.b){for(let y=this.c+1,D=this.a.length;y<D;y++){const L=this.a[y],P=y>0?this.d[y-1]:0;this.d[y]=P+L;for(let v=0;v<L;v++)this.e[P+v]=y}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(y,D){this.a[y]!==D&&(this.a[y]=D,this.f(y))}}e.ConstantTimePrefixSumComputer=R;class I{constructor(y,D){this.index=y,this.remainder=D,this._prefixSumIndexOfResultBrand=void 0,this.index=y,this.remainder=D}}e.PrefixSumIndexOfResult=I}),define(ye[155],Ce([19,20]),function(te,e){return te.create("vs/base/common/actions",e)}),define(ye[156],Ce([19,20]),function(te,e){return te.create("vs/base/common/date",e)}),define(ye[157],Ce([1,0,156]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,T=t*60,R=T*24,I=R*7,A=R*30,y=R*365;function D(P,v,C,E){typeof P!="number"&&(P=P.getTime());const f=Math.round((new Date().getTime()-P)/1e3);if(f<-30)return(0,o.localize)(0,null,D(new Date().getTime()+f*1e3,!1));if(!E&&f<30)return(0,o.localize)(1,null);let d;return f<t?(d=f,v?d===1?C?(0,o.localize)(2,null,d):(0,o.localize)(3,null,d):C?(0,o.localize)(4,null,d):(0,o.localize)(5,null,d):d===1?C?(0,o.localize)(6,null,d):(0,o.localize)(7,null,d):C?(0,o.localize)(8,null,d):(0,o.localize)(9,null,d)):f<T?(d=Math.floor(f/t),v?d===1?C?(0,o.localize)(10,null,d):(0,o.localize)(11,null,d):C?(0,o.localize)(12,null,d):(0,o.localize)(13,null,d):d===1?C?(0,o.localize)(14,null,d):(0,o.localize)(15,null,d):C?(0,o.localize)(16,null,d):(0,o.localize)(17,null,d)):f<R?(d=Math.floor(f/T),v?d===1?C?(0,o.localize)(18,null,d):(0,o.localize)(19,null,d):C?(0,o.localize)(20,null,d):(0,o.localize)(21,null,d):d===1?C?(0,o.localize)(22,null,d):(0,o.localize)(23,null,d):C?(0,o.localize)(24,null,d):(0,o.localize)(25,null,d)):f<I?(d=Math.floor(f/R),v?d===1?(0,o.localize)(26,null,d):(0,o.localize)(27,null,d):d===1?(0,o.localize)(28,null,d):(0,o.localize)(29,null,d)):f<A?(d=Math.floor(f/I),v?d===1?C?(0,o.localize)(30,null,d):(0,o.localize)(31,null,d):C?(0,o.localize)(32,null,d):(0,o.localize)(33,null,d):d===1?C?(0,o.localize)(34,null,d):(0,o.localize)(35,null,d):C?(0,o.localize)(36,null,d):(0,o.localize)(37,null,d)):f<y?(d=Math.floor(f/A),v?d===1?C?(0,o.localize)(38,null,d):(0,o.localize)(39,null,d):C?(0,o.localize)(40,null,d):(0,o.localize)(41,null,d):d===1?C?(0,o.localize)(42,null,d):(0,o.localize)(43,null,d):C?(0,o.localize)(44,null,d):(0,o.localize)(45,null,d)):(d=Math.floor(f/y),v?d===1?C?(0,o.localize)(46,null,d):(0,o.localize)(47,null,d):C?(0,o.localize)(48,null,d):(0,o.localize)(49,null,d):d===1?C?(0,o.localize)(50,null,d):(0,o.localize)(51,null,d):C?(0,o.localize)(52,null,d):(0,o.localize)(53,null,d))}e.fromNow=D;function L(P){return P.getFullYear()+"-"+String(P.getMonth()+1).padStart(2,"0")+"-"+String(P.getDate()).padStart(2,"0")+"T"+String(P.getHours()).padStart(2,"0")+":"+String(P.getMinutes()).padStart(2,"0")+":"+String(P.getSeconds()).padStart(2,"0")+"."+(P.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=L}),define(ye[158],Ce([19,20]),function(te,e){return te.create("vs/base/common/errorMessage",e)}),define(ye[45],Ce([1,0,18,11,158]),function(te,e,o,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function R(P,v){return v&&(P.stack||P.stacktrace)?T.localize(0,null,A(P),I(P.stack)||I(P.stacktrace)):A(P)}function I(P){return Array.isArray(P)?P.join(`
`):P}function A(P){return typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?T.localize(1,null,P.message):P.message||T.localize(2,null)}function y(P=null,v=!1){if(!P)return T.localize(3,null);if(Array.isArray(P)){const C=o.coalesce(P),E=y(C[0],v);return C.length>1?T.localize(4,null,E,C.length):E}if(t.isString(P))return P;if(P.detail){const C=P.detail;if(C.error)return R(C.error,v);if(C.exception)return R(C.exception,v)}return P.stack?R(P,v):P.message?P.message:T.localize(5,null)}e.toErrorMessage=y;function D(P){const v=P;return v instanceof Error&&Array.isArray(v.actions)}e.isErrorWithActions=D;function L(P,v){let C;return typeof P=="string"?C=new Error(P):C=P,C.actions=v,C}e.createErrorWithActions=L}),define(ye[159],Ce([19,20]),function(te,e){return te.create("vs/base/common/platform",e)}),define(ye[12],Ce([1,0,159]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let t=!1,T=!1,R=!1,I=!1,A=!1,y=!1,D=!1,L=!1,P=!1,v=!1,C,E=e.LANGUAGE_DEFAULT,f,d;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?h=e.globals.vscode.process:typeof process<"u"&&(h=process);const b=typeof h?.versions?.electron=="string",g=b&&h?.type==="renderer";if(typeof navigator=="object"&&!g)d=navigator.userAgent,t=d.indexOf("Windows")>=0,T=d.indexOf("Macintosh")>=0,L=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=d.indexOf("Linux")>=0,v=d?.indexOf("Mobi")>=0,y=!0,C=o.getConfiguredDefaultLocale(o.localize(0,null))||e.LANGUAGE_DEFAULT,E=C;else if(typeof h=="object"){t=h.platform==="win32",T=h.platform==="darwin",R=h.platform==="linux",I=R&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,D=b,P=!!h.env.CI||!!h.env.BUILD_ARTIFACTSTAGINGDIRECTORY,C=e.LANGUAGE_DEFAULT,E=e.LANGUAGE_DEFAULT;const n=h.env.VSCODE_NLS_CONFIG;if(n)try{const r=JSON.parse(n),m=r.availableLanguages["*"];C=r.locale,E=m||e.LANGUAGE_DEFAULT,f=r._translationsConfigFile}catch{}A=!0}else console.error("Unable to resolve platform.");var p;(function(n){n[n.Web=0]="Web",n[n.Mac=1]="Mac",n[n.Linux=2]="Linux",n[n.Windows=3]="Windows"})(p=e.Platform||(e.Platform={}));function w(n){switch(n){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=w;let i=0;T?i=1:t?i=3:R&&(i=2),e.isWindows=t,e.isMacintosh=T,e.isLinux=R,e.isLinuxSnap=I,e.isNative=A,e.isElectron=D,e.isWeb=y,e.isWebWorker=y&&typeof e.globals.importScripts=="function",e.isIOS=L,e.isMobile=v,e.isCI=P,e.platform=i,e.userAgent=d,e.language=E;var s;(function(n){function r(){return e.language}n.value=r;function m(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}n.isDefaultVariant=m;function S(){return e.language==="en"}n.isDefault=S})(s=e.Language||(e.Language={})),e.locale=C,e.translationsConfigFile=f,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const n=[];e.globals.addEventListener("message",m=>{if(m.data&&m.data.vscodeScheduleAsyncWork)for(let S=0,k=n.length;S<k;S++){const M=n[S];if(M.id===m.data.vscodeScheduleAsyncWork){n.splice(S,1),M.callback();return}}});let r=0;return m=>{const S=++r;n.push({id:S,callback:m}),e.globals.postMessage({vscodeScheduleAsyncWork:S},"*")}}return n=>setTimeout(n)})();var a;(function(n){n[n.Windows=1]="Windows",n[n.Macintosh=2]="Macintosh",n[n.Linux=3]="Linux"})(a=e.OperatingSystem||(e.OperatingSystem={})),e.OS=T||L?2:t?1:3;let u=!0,l=!1;function c(){if(!l){l=!0;const n=new Uint8Array(2);n[0]=1,n[1]=2,u=new Uint16Array(n.buffer)[0]===(2<<8)+1}return u}e.isLittleEndian=c,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ye[36],Ce([1,0,12]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof o.globals.vscode<"u"&&typeof o.globals.vscode.process<"u"){const T=o.globals.vscode.process;t={get platform(){return T.platform},get arch(){return T.arch},get env(){return T.env},cwd(){return T.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return o.isWindows?"win32":o.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(ye[10],Ce([1,0,36]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,T=97,R=90,I=122,A=46,y=47,D=92,L=58,P=63;class v extends Error{constructor(s,a,u){let l;typeof a=="string"&&a.indexOf("not ")===0?(l="must not be",a=a.replace(/^not /,"")):l="must be";const c=s.indexOf(".")!==-1?"property":"argument";let n=`The "${s}" ${c} ${l} of type ${a}`;n+=`. Received type ${typeof u}`,super(n),this.code="ERR_INVALID_ARG_TYPE"}}function C(i,s){if(i===null||typeof i!="object")throw new v(s,"Object",i)}function E(i,s){if(typeof i!="string")throw new v(s,"string",i)}const f=o.platform==="win32";function d(i){return i===y||i===D}function h(i){return i===y}function b(i){return i>=t&&i<=R||i>=T&&i<=I}function g(i,s,a,u){let l="",c=0,n=-1,r=0,m=0;for(let S=0;S<=i.length;++S){if(S<i.length)m=i.charCodeAt(S);else{if(u(m))break;m=y}if(u(m)){if(!(n===S-1||r===1))if(r===2){if(l.length<2||c!==2||l.charCodeAt(l.length-1)!==A||l.charCodeAt(l.length-2)!==A){if(l.length>2){const k=l.lastIndexOf(a);k===-1?(l="",c=0):(l=l.slice(0,k),c=l.length-1-l.lastIndexOf(a)),n=S,r=0;continue}else if(l.length!==0){l="",c=0,n=S,r=0;continue}}s&&(l+=l.length>0?`${a}..`:"..",c=2)}else l.length>0?l+=`${a}${i.slice(n+1,S)}`:l=i.slice(n+1,S),c=S-n-1;n=S,r=0}else m===A&&r!==-1?++r:r=-1}return l}function p(i,s){C(s,"pathObject");const a=s.dir||s.root,u=s.base||`${s.name||""}${s.ext||""}`;return a?a===s.root?`${a}${u}`:`${a}${i}${u}`:u}e.win32={resolve(...i){let s="",a="",u=!1;for(let l=i.length-1;l>=-1;l--){let c;if(l>=0){if(c=i[l],E(c,"path"),c.length===0)continue}else s.length===0?c=o.cwd():(c=o.env[`=${s}`]||o.cwd(),(c===void 0||c.slice(0,2).toLowerCase()!==s.toLowerCase()&&c.charCodeAt(2)===D)&&(c=`${s}\\`));const n=c.length;let r=0,m="",S=!1;const k=c.charCodeAt(0);if(n===1)d(k)&&(r=1,S=!0);else if(d(k))if(S=!0,d(c.charCodeAt(1))){let M=2,q=M;for(;M<n&&!d(c.charCodeAt(M));)M++;if(M<n&&M!==q){const V=c.slice(q,M);for(q=M;M<n&&d(c.charCodeAt(M));)M++;if(M<n&&M!==q){for(q=M;M<n&&!d(c.charCodeAt(M));)M++;(M===n||M!==q)&&(m=`\\\\${V}\\${c.slice(q,M)}`,r=M)}}}else r=1;else b(k)&&c.charCodeAt(1)===L&&(m=c.slice(0,2),r=2,n>2&&d(c.charCodeAt(2))&&(S=!0,r=3));if(m.length>0)if(s.length>0){if(m.toLowerCase()!==s.toLowerCase())continue}else s=m;if(u){if(s.length>0)break}else if(a=`${c.slice(r)}\\${a}`,u=S,S&&s.length>0)break}return a=g(a,!u,"\\",d),u?`${s}\\${a}`:`${s}${a}`||"."},normalize(i){E(i,"path");const s=i.length;if(s===0)return".";let a=0,u,l=!1;const c=i.charCodeAt(0);if(s===1)return h(c)?"\\":i;if(d(c))if(l=!0,d(i.charCodeAt(1))){let r=2,m=r;for(;r<s&&!d(i.charCodeAt(r));)r++;if(r<s&&r!==m){const S=i.slice(m,r);for(m=r;r<s&&d(i.charCodeAt(r));)r++;if(r<s&&r!==m){for(m=r;r<s&&!d(i.charCodeAt(r));)r++;if(r===s)return`\\\\${S}\\${i.slice(m)}\\`;r!==m&&(u=`\\\\${S}\\${i.slice(m,r)}`,a=r)}}}else a=1;else b(c)&&i.charCodeAt(1)===L&&(u=i.slice(0,2),a=2,s>2&&d(i.charCodeAt(2))&&(l=!0,a=3));let n=a<s?g(i.slice(a),!l,"\\",d):"";return n.length===0&&!l&&(n="."),n.length>0&&d(i.charCodeAt(s-1))&&(n+="\\"),u===void 0?l?`\\${n}`:n:l?`${u}\\${n}`:`${u}${n}`},isAbsolute(i){E(i,"path");const s=i.length;if(s===0)return!1;const a=i.charCodeAt(0);return d(a)||s>2&&b(a)&&i.charCodeAt(1)===L&&d(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let s,a;for(let c=0;c<i.length;++c){const n=i[c];E(n,"path"),n.length>0&&(s===void 0?s=a=n:s+=`\\${n}`)}if(s===void 0)return".";let u=!0,l=0;if(typeof a=="string"&&d(a.charCodeAt(0))){++l;const c=a.length;c>1&&d(a.charCodeAt(1))&&(++l,c>2&&(d(a.charCodeAt(2))?++l:u=!1))}if(u){for(;l<s.length&&d(s.charCodeAt(l));)l++;l>=2&&(s=`\\${s.slice(l)}`)}return e.win32.normalize(s)},relative(i,s){if(E(i,"from"),E(s,"to"),i===s)return"";const a=e.win32.resolve(i),u=e.win32.resolve(s);if(a===u||(i=a.toLowerCase(),s=u.toLowerCase(),i===s))return"";let l=0;for(;l<i.length&&i.charCodeAt(l)===D;)l++;let c=i.length;for(;c-1>l&&i.charCodeAt(c-1)===D;)c--;const n=c-l;let r=0;for(;r<s.length&&s.charCodeAt(r)===D;)r++;let m=s.length;for(;m-1>r&&s.charCodeAt(m-1)===D;)m--;const S=m-r,k=n<S?n:S;let M=-1,q=0;for(;q<k;q++){const F=i.charCodeAt(l+q);if(F!==s.charCodeAt(r+q))break;F===D&&(M=q)}if(q!==k){if(M===-1)return u}else{if(S>k){if(s.charCodeAt(r+q)===D)return u.slice(r+q+1);if(q===2)return u.slice(r+q)}n>k&&(i.charCodeAt(l+q)===D?M=q:q===2&&(M=3)),M===-1&&(M=0)}let V="";for(q=l+M+1;q<=c;++q)(q===c||i.charCodeAt(q)===D)&&(V+=V.length===0?"..":"\\..");return r+=M,V.length>0?`${V}${u.slice(r,m)}`:(u.charCodeAt(r)===D&&++r,u.slice(r,m))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const s=e.win32.resolve(i);if(s.length<=2)return i;if(s.charCodeAt(0)===D){if(s.charCodeAt(1)===D){const a=s.charCodeAt(2);if(a!==P&&a!==A)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(b(s.charCodeAt(0))&&s.charCodeAt(1)===L&&s.charCodeAt(2)===D)return`\\\\?\\${s}`;return i},dirname(i){E(i,"path");const s=i.length;if(s===0)return".";let a=-1,u=0;const l=i.charCodeAt(0);if(s===1)return d(l)?i:".";if(d(l)){if(a=u=1,d(i.charCodeAt(1))){let r=2,m=r;for(;r<s&&!d(i.charCodeAt(r));)r++;if(r<s&&r!==m){for(m=r;r<s&&d(i.charCodeAt(r));)r++;if(r<s&&r!==m){for(m=r;r<s&&!d(i.charCodeAt(r));)r++;if(r===s)return i;r!==m&&(a=u=r+1)}}}}else b(l)&&i.charCodeAt(1)===L&&(a=s>2&&d(i.charCodeAt(2))?3:2,u=a);let c=-1,n=!0;for(let r=s-1;r>=u;--r)if(d(i.charCodeAt(r))){if(!n){c=r;break}}else n=!1;if(c===-1){if(a===-1)return".";c=a}return i.slice(0,c)},basename(i,s){s!==void 0&&E(s,"ext"),E(i,"path");let a=0,u=-1,l=!0,c;if(i.length>=2&&b(i.charCodeAt(0))&&i.charCodeAt(1)===L&&(a=2),s!==void 0&&s.length>0&&s.length<=i.length){if(s===i)return"";let n=s.length-1,r=-1;for(c=i.length-1;c>=a;--c){const m=i.charCodeAt(c);if(d(m)){if(!l){a=c+1;break}}else r===-1&&(l=!1,r=c+1),n>=0&&(m===s.charCodeAt(n)?--n===-1&&(u=c):(n=-1,u=r))}return a===u?u=r:u===-1&&(u=i.length),i.slice(a,u)}for(c=i.length-1;c>=a;--c)if(d(i.charCodeAt(c))){if(!l){a=c+1;break}}else u===-1&&(l=!1,u=c+1);return u===-1?"":i.slice(a,u)},extname(i){E(i,"path");let s=0,a=-1,u=0,l=-1,c=!0,n=0;i.length>=2&&i.charCodeAt(1)===L&&b(i.charCodeAt(0))&&(s=u=2);for(let r=i.length-1;r>=s;--r){const m=i.charCodeAt(r);if(d(m)){if(!c){u=r+1;break}continue}l===-1&&(c=!1,l=r+1),m===A?a===-1?a=r:n!==1&&(n=1):a!==-1&&(n=-1)}return a===-1||l===-1||n===0||n===1&&a===l-1&&a===u+1?"":i.slice(a,l)},format:p.bind(null,"\\"),parse(i){E(i,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return s;const a=i.length;let u=0,l=i.charCodeAt(0);if(a===1)return d(l)?(s.root=s.dir=i,s):(s.base=s.name=i,s);if(d(l)){if(u=1,d(i.charCodeAt(1))){let M=2,q=M;for(;M<a&&!d(i.charCodeAt(M));)M++;if(M<a&&M!==q){for(q=M;M<a&&d(i.charCodeAt(M));)M++;if(M<a&&M!==q){for(q=M;M<a&&!d(i.charCodeAt(M));)M++;M===a?u=M:M!==q&&(u=M+1)}}}}else if(b(l)&&i.charCodeAt(1)===L){if(a<=2)return s.root=s.dir=i,s;if(u=2,d(i.charCodeAt(2))){if(a===3)return s.root=s.dir=i,s;u=3}}u>0&&(s.root=i.slice(0,u));let c=-1,n=u,r=-1,m=!0,S=i.length-1,k=0;for(;S>=u;--S){if(l=i.charCodeAt(S),d(l)){if(!m){n=S+1;break}continue}r===-1&&(m=!1,r=S+1),l===A?c===-1?c=S:k!==1&&(k=1):c!==-1&&(k=-1)}return r!==-1&&(c===-1||k===0||k===1&&c===r-1&&c===n+1?s.base=s.name=i.slice(n,r):(s.name=i.slice(n,c),s.base=i.slice(n,r),s.ext=i.slice(c,r))),n>0&&n!==u?s.dir=i.slice(0,n-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const w=(()=>{if(f){const i=/\\/g;return()=>{const s=o.cwd().replace(i,"/");return s.slice(s.indexOf("/"))}}return()=>o.cwd()})();e.posix={resolve(...i){let s="",a=!1;for(let u=i.length-1;u>=-1&&!a;u--){const l=u>=0?i[u]:w();E(l,"path"),l.length!==0&&(s=`${l}/${s}`,a=l.charCodeAt(0)===y)}return s=g(s,!a,"/",h),a?`/${s}`:s.length>0?s:"."},normalize(i){if(E(i,"path"),i.length===0)return".";const s=i.charCodeAt(0)===y,a=i.charCodeAt(i.length-1)===y;return i=g(i,!s,"/",h),i.length===0?s?"/":a?"./":".":(a&&(i+="/"),s?`/${i}`:i)},isAbsolute(i){return E(i,"path"),i.length>0&&i.charCodeAt(0)===y},join(...i){if(i.length===0)return".";let s;for(let a=0;a<i.length;++a){const u=i[a];E(u,"path"),u.length>0&&(s===void 0?s=u:s+=`/${u}`)}return s===void 0?".":e.posix.normalize(s)},relative(i,s){if(E(i,"from"),E(s,"to"),i===s||(i=e.posix.resolve(i),s=e.posix.resolve(s),i===s))return"";const a=1,u=i.length,l=u-a,c=1,n=s.length-c,r=l<n?l:n;let m=-1,S=0;for(;S<r;S++){const M=i.charCodeAt(a+S);if(M!==s.charCodeAt(c+S))break;M===y&&(m=S)}if(S===r)if(n>r){if(s.charCodeAt(c+S)===y)return s.slice(c+S+1);if(S===0)return s.slice(c+S)}else l>r&&(i.charCodeAt(a+S)===y?m=S:S===0&&(m=0));let k="";for(S=a+m+1;S<=u;++S)(S===u||i.charCodeAt(S)===y)&&(k+=k.length===0?"..":"/..");return`${k}${s.slice(c+m)}`},toNamespacedPath(i){return i},dirname(i){if(E(i,"path"),i.length===0)return".";const s=i.charCodeAt(0)===y;let a=-1,u=!0;for(let l=i.length-1;l>=1;--l)if(i.charCodeAt(l)===y){if(!u){a=l;break}}else u=!1;return a===-1?s?"/":".":s&&a===1?"//":i.slice(0,a)},basename(i,s){s!==void 0&&E(s,"ext"),E(i,"path");let a=0,u=-1,l=!0,c;if(s!==void 0&&s.length>0&&s.length<=i.length){if(s===i)return"";let n=s.length-1,r=-1;for(c=i.length-1;c>=0;--c){const m=i.charCodeAt(c);if(m===y){if(!l){a=c+1;break}}else r===-1&&(l=!1,r=c+1),n>=0&&(m===s.charCodeAt(n)?--n===-1&&(u=c):(n=-1,u=r))}return a===u?u=r:u===-1&&(u=i.length),i.slice(a,u)}for(c=i.length-1;c>=0;--c)if(i.charCodeAt(c)===y){if(!l){a=c+1;break}}else u===-1&&(l=!1,u=c+1);return u===-1?"":i.slice(a,u)},extname(i){E(i,"path");let s=-1,a=0,u=-1,l=!0,c=0;for(let n=i.length-1;n>=0;--n){const r=i.charCodeAt(n);if(r===y){if(!l){a=n+1;break}continue}u===-1&&(l=!1,u=n+1),r===A?s===-1?s=n:c!==1&&(c=1):s!==-1&&(c=-1)}return s===-1||u===-1||c===0||c===1&&s===u-1&&s===a+1?"":i.slice(s,u)},format:p.bind(null,"/"),parse(i){E(i,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return s;const a=i.charCodeAt(0)===y;let u;a?(s.root="/",u=1):u=0;let l=-1,c=0,n=-1,r=!0,m=i.length-1,S=0;for(;m>=u;--m){const k=i.charCodeAt(m);if(k===y){if(!r){c=m+1;break}continue}n===-1&&(r=!1,n=m+1),k===A?l===-1?l=m:S!==1&&(S=1):l!==-1&&(S=-1)}if(n!==-1){const k=c===0&&a?1:c;l===-1||S===0||S===1&&l===n-1&&l===c+1?s.base=s.name=i.slice(k,n):(s.name=i.slice(k,l),s.base=i.slice(k,n),s.ext=i.slice(l,n))}return c>0?s.dir=i.slice(0,c-1):a&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=f?e.win32.normalize:e.posix.normalize,e.isAbsolute=f?e.win32.isAbsolute:e.posix.isAbsolute,e.join=f?e.win32.join:e.posix.join,e.resolve=f?e.win32.resolve:e.posix.resolve,e.relative=f?e.win32.relative:e.posix.relative,e.dirname=f?e.win32.dirname:e.posix.dirname,e.basename=f?e.win32.basename:e.posix.basename,e.extname=f?e.win32.extname:e.posix.extname,e.format=f?e.win32.format:e.posix.format,e.parse=f?e.win32.parse:e.posix.parse,e.toNamespacedPath=f?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=f?e.win32.sep:e.posix.sep,e.delimiter=f?e.win32.delimiter:e.posix.delimiter}),define(ye[84],Ce([1,0,10]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const t={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},T={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function R(L){const P=(0,o.extname)(L),v=t[P.toLowerCase()];return v!==void 0?v:I(L)}e.getMediaOrTextMime=R;function I(L){const P=(0,o.extname)(L);return T[P.toLowerCase()]}e.getMediaMime=I;function A(L){for(const P in T)if(T[P]===L)return P}e.getExtensionForMimeType=A;const y=/^(.+)\/(.+?)(;.+)?$/;function D(L,P){const v=y.exec(L);return v?`${v[1].toLowerCase()}/${v[2].toLowerCase()}${v[3]??""}`:P?void 0:L}e.normalizeMimeType=D}),define(ye[107],Ce([1,0,12]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(A){A[A.stdout=0]="stdout",A[A.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var T;(function(A){A[A.Success=0]="Success",A[A.Unknown=1]="Unknown",A[A.AccessDenied=2]="AccessDenied",A[A.ProcessNotFound=3]="ProcessNotFound"})(T=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(A,...y){const D=y.reduce((v,C)=>(v[C]=!0,v),{}),L=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(A).filter(v=>!D[v]).forEach(v=>{for(let C=0;C<L.length;C++)if(v.search(L[C])!==-1){delete A[v];break}})}e.sanitizeProcessEnvironment=R;function I(A){!A||(delete A.DEBUG,o.isMacintosh&&delete A.DYLD_LIBRARY_PATH,o.isLinux&&delete A.LD_PRELOAD)}e.removeDangerousEnvVariables=I}),define(ye[43],Ce([1,0,12]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=o.globals.performance&&typeof o.globals.performance.now=="function";class T{static create(I=!0){return new T(I)}constructor(I){this.a=t&&I,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?o.globals.performance.now():Date.now()}}e.StopWatch=T}),define(ye[3],Ce([1,0,9,61,6,63,43]),function(te,e,o,t,T,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const A=!1,y=!1;var D;(function(c){c.None=()=>T.Disposable.None;function n(Ee){if(y){const{onDidAddListener:Pe}=Ee,Me=E.create();let oe=0;Ee.onDidAddListener=()=>{++oe===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Me.print()),Pe?.()}}}function r(Ee,Pe){return N(Ee,()=>{},0,void 0,void 0,Pe)}c.defer=r;function m(Ee){return(Pe,Me=null,oe)=>{let ae=!1,fe;return fe=Ee(ee=>{if(!ae)return fe?fe.dispose():ae=!0,Pe.call(Me,ee)},null,oe),ae&&fe.dispose(),fe}}c.once=m;function S(Ee,Pe,Me){return U((oe,ae=null,fe)=>Ee(ee=>oe.call(ae,Pe(ee)),null,fe),Me)}c.map=S;function k(Ee,Pe,Me){return U((oe,ae=null,fe)=>Ee(ee=>{Pe(ee),oe.call(ae,ee)},null,fe),Me)}c.forEach=k;function M(Ee,Pe,Me){return U((oe,ae=null,fe)=>Ee(ee=>Pe(ee)&&oe.call(ae,ee),null,fe),Me)}c.filter=M;function q(Ee){return Ee}c.signal=q;function V(...Ee){return(Pe,Me=null,oe)=>(0,T.combinedDisposable)(...Ee.map(ae=>ae(fe=>Pe.call(Me,fe),null,oe)))}c.any=V;function F(Ee,Pe,Me,oe){let ae=Me;return S(Ee,fe=>(ae=Pe(ae,fe),ae),oe)}c.reduce=F;function U(Ee,Pe){let Me;const oe={onWillAddFirstListener(){Me=Ee(ae.fire,ae)},onDidRemoveLastListener(){Me?.dispose()}};Pe||n(oe);const ae=new d(oe);return Pe?.add(ae),ae.event}function N(Ee,Pe,Me=100,oe=!1,ae,fe){let ee,le,re,O=0;const H={leakWarningThreshold:ae,onWillAddFirstListener(){ee=Ee(Q=>{O++,le=Pe(le,Q),oe&&!re&&(x.fire(le),le=void 0),clearTimeout(re),re=setTimeout(()=>{const de=le;le=void 0,re=void 0,(!oe||O>1)&&x.fire(de),O=0},Me)})},onDidRemoveLastListener(){ee.dispose()}};fe||n(H);const x=new d(H);return fe?.add(x),x.event}c.debounce=N;function B(Ee,Pe=0,Me){return c.debounce(Ee,(oe,ae)=>oe?(oe.push(ae),oe):[ae],Pe,void 0,void 0,Me)}c.accumulate=B;function j(Ee,Pe=(oe,ae)=>oe===ae,Me){let oe=!0,ae;return M(Ee,fe=>{const ee=oe||!Pe(fe,ae);return oe=!1,ae=fe,ee},Me)}c.latch=j;function z(Ee,Pe,Me){return[c.filter(Ee,Pe,Me),c.filter(Ee,oe=>!Pe(oe),Me)]}c.split=z;function ne(Ee,Pe=!1,Me=[]){let oe=Me.slice(),ae=Ee(le=>{oe?oe.push(le):ee.fire(le)});const fe=()=>{oe?.forEach(le=>ee.fire(le)),oe=null},ee=new d({onWillAddFirstListener(){ae||(ae=Ee(le=>ee.fire(le)))},onDidAddFirstListener(){oe&&(Pe?setTimeout(fe):fe())},onDidRemoveLastListener(){ae&&ae.dispose(),ae=null}});return ee.event}c.buffer=ne;class _{constructor(Pe){this.event=Pe,this.c=new T.DisposableStore}map(Pe){return new _(S(this.event,Pe,this.c))}forEach(Pe){return new _(k(this.event,Pe,this.c))}filter(Pe){return new _(M(this.event,Pe,this.c))}reduce(Pe,Me){return new _(F(this.event,Pe,Me,this.c))}latch(){return new _(j(this.event,void 0,this.c))}debounce(Pe,Me=100,oe=!1,ae){return new _(N(this.event,Pe,Me,oe,ae,this.c))}on(Pe,Me,oe){return this.event(Pe,Me,oe)}once(Pe,Me,oe){return m(this.event)(Pe,Me,oe)}dispose(){this.c.dispose()}}function Y(Ee){return new _(Ee)}c.chain=Y;function J(Ee,Pe,Me=oe=>oe){const oe=(...le)=>ee.fire(Me(...le)),ae=()=>Ee.on(Pe,oe),fe=()=>Ee.removeListener(Pe,oe),ee=new d({onWillAddFirstListener:ae,onDidRemoveLastListener:fe});return ee.event}c.fromNodeEventEmitter=J;function Z(Ee,Pe,Me=oe=>oe){const oe=(...le)=>ee.fire(Me(...le)),ae=()=>Ee.addEventListener(Pe,oe),fe=()=>Ee.removeEventListener(Pe,oe),ee=new d({onWillAddFirstListener:ae,onDidRemoveLastListener:fe});return ee.event}c.fromDOMEventEmitter=Z;function ie(Ee){return new Promise(Pe=>m(Ee)(Pe))}c.toPromise=ie;function X(Ee,Pe){return Pe(void 0),Ee(Me=>Pe(Me))}c.runAndSubscribe=X;function K(Ee,Pe){let Me=null;function oe(fe){Me?.dispose(),Me=new T.DisposableStore,Pe(fe,Me)}oe(void 0);const ae=Ee(fe=>oe(fe));return(0,T.toDisposable)(()=>{ae.dispose(),Me?.dispose()})}c.runAndSubscribeWithStore=K;class he{constructor(Pe,Me){this.obs=Pe,this.c=0,this.d=!1;const oe={onWillAddFirstListener:()=>{Pe.addObserver(this)},onDidRemoveLastListener:()=>{Pe.removeObserver(this)}};Me||n(oe),this.emitter=new d(oe),Me&&Me.add(this.emitter)}beginUpdate(Pe){this.c++}handleChange(Pe,Me){this.d=!0}endUpdate(Pe){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function be(Ee,Pe){return new he(Ee,Pe).emitter.event}c.fromObservable=be})(D=e.Event||(e.Event={}));class L{constructor(n){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${n}_${L.c++}`,L.all.add(this)}start(n){this.d=new I.StopWatch(!0),this.listenerCount=n}stop(){if(this.d){const n=this.d.elapsed();this.durations.push(n),this.elapsedOverall+=n,this.invocationCount+=1,this.d=void 0}}}e.EventProfiling=L,L.all=new Set,L.c=0;let P=-1;function v(c){const n=P;return P=c,{dispose(){P=n}}}e.setGlobalLeakWarningThreshold=v;class C{constructor(n,r=Math.random().toString(18).slice(2,5)){this.threshold=n,this.name=r,this.d=0}dispose(){this.c?.clear()}check(n,r){const m=this.threshold;if(m<=0||r<m)return;this.c||(this.c=new Map);const S=this.c.get(n.value)||0;if(this.c.set(n.value,S+1),this.d-=1,this.d<=0){this.d=m*.5;let k,M=0;for(const[q,V]of this.c)(!k||M<V)&&(k=q,M=V);console.warn(`[${this.name}] potential listener LEAK detected, having ${r} listeners already. MOST frequent listener (${M}):`),console.warn(k)}return()=>{const k=this.c.get(n.value)||0;this.c.set(n.value,k-1)}}}class E{static create(){return new E(new Error().stack??"")}constructor(n){this.value=n}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class f{constructor(n,r,m){this.callback=n,this.callbackThis=r,this.stack=m,this.subscription=new T.SafeDisposable}invoke(n){this.callback.call(this.callbackThis,n)}}class d{constructor(n){this.j=!1,this.d=n,this.f=P>0||this.d?.leakWarningThreshold?new C(this.d?.leakWarningThreshold??P):void 0,this.g=this.d?._profName?new L(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(A){const n=Array.from(this.q);queueMicrotask(()=>{for(const r of n)r.subscription.isset()&&(r.subscription.unset(),r.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(n,r,m)=>{if(this.q||(this.q=new R.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),T.Disposable.None;const S=this.q.isEmpty();S&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let k,M;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(M=E.create(),k=this.f.check(M,this.q.size+1)),A&&(M=M??E.create());const q=new f(n,r,M),V=this.q.push(q);S&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,n,r);const F=q.subscription.set(()=>{k?.(),this.j||(V(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return m instanceof T.DisposableStore?m.add(F):Array.isArray(m)&&m.push(F),F}),this.l}fire(n){if(this.q){this.m||(this.m=new b);for(const r of this.q)this.m.push(this,r,n);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=d;class h{constructor(){this.c=new R.LinkedList}get size(){return this.c.size}push(n,r,m){this.c.push(new g(n,r,m))}clear(n){const r=new R.LinkedList;for(const m of this.c)m.emitter!==n&&r.push(m);this.c=r}deliver(){for(;this.c.size>0;){const n=this.c.shift();try{n.listener.invoke(n.event)}catch(r){(0,o.onUnexpectedError)(r)}}}}e.EventDeliveryQueue=h;class b extends h{clear(n){this.c.clear()}}class g{constructor(n,r,m){this.emitter=n,this.listener=r,this.event=m}}class p extends d{async fireAsync(n,r,m){if(!!this.q){this.c||(this.c=new R.LinkedList);for(const S of this.q)this.c.push([S,n]);for(;this.c.size>0&&!r.isCancellationRequested;){const[S,k]=this.c.shift(),M=[],q={...k,token:r,waitUntil:V=>{if(Object.isFrozen(M))throw new Error("waitUntil can NOT be called asynchronous");m&&(V=m(V,S.callback)),M.push(V)}};try{S.invoke(q)}catch(V){(0,o.onUnexpectedError)(V);continue}Object.freeze(M),await Promise.allSettled(M).then(V=>{for(const F of V)F.status==="rejected"&&(0,o.onUnexpectedError)(F.reason)})}}}}e.AsyncEmitter=p;class w extends d{constructor(n){super(n),this.h=0,this.s=new R.LinkedList,this.t=n?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const n=Array.from(this.s);this.s.clear(),super.fire(this.t(n))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(n){this.q&&(this.h!==0?this.s.push(n):super.fire(n))}}e.PauseableEmitter=w;class i extends w{constructor(n){super(n),this.c=n.delay??100}fire(n){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(n)}}e.DebounceEmitter=i;class s extends d{constructor(n){super(n),this.c=[],this.h=n?.merge}fire(n){!this.hasListeners()||(this.c.push(n),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(r=>super.fire(r)),this.c=[]}))}}e.MicrotaskEmitter=s;class a{constructor(){this.d=!1,this.f=[],this.c=new d({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(n){const r={event:n,listener:null};this.f.push(r),this.d&&this.j(r);const m=()=>{this.d&&this.k(r);const S=this.f.indexOf(r);this.f.splice(S,1)};return(0,T.toDisposable)((0,t.once)(m))}g(){this.d=!0,this.f.forEach(n=>this.j(n))}h(){this.d=!1,this.f.forEach(n=>this.k(n))}j(n){n.listener=n.event(r=>this.c.fire(r))}k(n){n.listener&&n.listener.dispose(),n.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=a;class u{constructor(){this.c=[]}wrapEvent(n){return(r,m,S)=>n(k=>{const M=this.c[this.c.length-1];M?M.push(()=>r.call(m,k)):r.call(m,k)},void 0,S)}bufferEvents(n){const r=[];this.c.push(r);const m=n();return this.c.pop(),r.forEach(S=>S()),m}}e.EventBufferer=u;class l{constructor(){this.c=!1,this.d=D.None,this.f=T.Disposable.None,this.g=new d({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(n){this.d=n,this.c&&(this.f.dispose(),this.f=n(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=l}),define(ye[160],Ce([1,0,3,6,155]),function(te,e,o,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class R extends t.Disposable{constructor(v,C="",E="",f=!0,d){super(),this.h=this.B(new o.Emitter),this.onDidChange=this.h.event,this.w=!0,this.j=v,this.m=C,this.u=E,this.w=f,this.C=d}get id(){return this.j}get label(){return this.m}set label(v){this.D(v)}D(v){this.m!==v&&(this.m=v,this.h.fire({label:v}))}get tooltip(){return this.n||""}set tooltip(v){this.F(v)}F(v){this.n!==v&&(this.n=v,this.h.fire({tooltip:v}))}get class(){return this.u}set class(v){this.G(v)}G(v){this.u!==v&&(this.u=v,this.h.fire({class:v}))}get enabled(){return this.w}set enabled(v){this.H(v)}H(v){this.w!==v&&(this.w=v,this.h.fire({enabled:v}))}get checked(){return this.z}set checked(v){this.I(v)}I(v){this.z!==v&&(this.z=v,this.h.fire({checked:v}))}async run(v,C){this.C&&await this.C(v)}}e.Action=R;class I extends t.Disposable{constructor(){super(...arguments),this.f=this.B(new o.Emitter),this.onWillRun=this.f.event,this.h=this.B(new o.Emitter),this.onDidRun=this.h.event}async run(v,C){if(!v.enabled)return;this.f.fire({action:v});let E;try{await this.runAction(v,C)}catch(f){E=f}this.h.fire({action:v,error:E})}async runAction(v,C){await v.run(C)}}e.ActionRunner=I;class A{constructor(){this.id=A.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...v){let C=[];for(const E of v)E.length&&(C.length?C=[...C,new A,...E]:C=E);return C}async run(){}}e.Separator=A,A.ID="vs.actions.separator";class y{get actions(){return this.a}constructor(v,C,E,f){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=v,this.label=C,this.class=f,this.a=E}async run(){}}e.SubmenuAction=y;class D extends R{constructor(){super(D.ID,T.localize(0,null),void 0,!1)}}e.EmptySubmenuAction=D,D.ID="vs.actions.empty";function L(P){return{id:P.id,label:P.label,class:void 0,enabled:P.enabled??!0,checked:P.checked??!1,run:async()=>P.run(),tooltip:P.label}}e.toAction=L}),define(ye[21],Ce([1,0,3]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(A,y){const D=setTimeout(A.bind(y),0);return{dispose(){clearTimeout(D)}}});var T;(function(A){function y(D){return D===A.None||D===A.Cancelled||D instanceof R?!0:!D||typeof D!="object"?!1:typeof D.isCancellationRequested=="boolean"&&typeof D.onCancellationRequested=="function"}A.isCancellationToken=y,A.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:o.Event.None}),A.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(T=e.CancellationToken||(e.CancellationToken={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?t:(this.b||(this.b=new o.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class I{constructor(y){this.a=void 0,this.b=void 0,this.b=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new R),this.a}cancel(){this.a?this.a instanceof R&&this.a.cancel():this.a=T.Cancelled}dispose(y=!1){y&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof R&&this.a.dispose():this.a=T.None}}e.CancellationTokenSource=I}),define(ye[161],Ce([1,0,21]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(A){this.b=A,this.a=null}get(){if(this.a)return this.a;const A=new o.CancellationTokenSource,y=this.b(A.token);return this.a={promise:y,dispose:()=>{this.a=null,A.cancel(),A.dispose()}},this.a}}e.Cache=t;class T{constructor(A){this.c=A,this.a=void 0,this.b=void 0}get(A){const y=JSON.stringify(A);return this.b!==y&&(this.b=y,this.a=this.c(A)),this.a}}e.LRUCachedFunction=T;class R{get cachedValues(){return this.a}constructor(A){this.b=A,this.a=new Map}get(A){if(this.a.has(A))return this.a.get(A);const y=this.b(A);return this.a.set(A,y),y}}e.CachedFunction=R}),define(ye[8],Ce([1,0,161,82]),function(te,e,o,t){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function R($){return!$||typeof $!="string"?!0:$.trim().length===0}e.isFalsyOrWhitespace=R;const I=/{(\d+)}/g;function A($,...ue){return ue.length===0?$:$.replace(I,function(Ie,Le){const Be=parseInt(Le,10);return isNaN(Be)||Be<0||Be>=ue.length?Ie:ue[Be]})}e.format=A;const y=/{([^}]+)}/g;function D($,ue){return $.replace(y,(Ie,Le)=>ue[Le]??Ie)}e.format2=D;function L($){return $.replace(/[<>&]/g,function(ue){switch(ue){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ue}})}e.escape=L;function P($){return $.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=P;function v($,ue){let Ie=0;const Le=ue.charCodeAt(0);for(let Be=$.length-1;Be>=0;Be--)$.charCodeAt(Be)===Le&&Ie++;return Ie}e.count=v;function C($,ue,Ie="\u2026"){return $.length<=ue?$:`${$.substr(0,ue)}${Ie}`}e.truncate=C;function E($,ue=" "){const Ie=f($,ue);return d(Ie,ue)}e.trim=E;function f($,ue){if(!$||!ue)return $;const Ie=ue.length;if(Ie===0||$.length===0)return $;let Le=0;for(;$.indexOf(ue,Le)===Le;)Le=Le+Ie;return $.substring(Le)}e.ltrim=f;function d($,ue){if(!$||!ue)return $;const Ie=ue.length,Le=$.length;if(Ie===0||Le===0)return $;let Be=Le,xe=-1;for(;xe=$.lastIndexOf(ue,Be-1),!(xe===-1||xe+Ie!==Be);){if(xe===0)return"";Be=xe}return $.substring(0,Be)}e.rtrim=d;function h($){return $.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function b($){return $.replace(/\*/g,"")}e.stripWildcards=b;function g($,ue,Ie={}){if(!$)throw new Error("Cannot create regex from empty string");ue||($=P($)),Ie.wholeWord&&(/\B/.test($.charAt(0))||($="\\b"+$),/\B/.test($.charAt($.length-1))||($=$+"\\b"));let Le="";return Ie.global&&(Le+="g"),Ie.matchCase||(Le+="i"),Ie.multiline&&(Le+="m"),Ie.unicode&&(Le+="u"),new RegExp($,Le)}e.createRegExp=g;function p($){return $.source==="^"||$.source==="^$"||$.source==="$"||$.source==="^\\s*$"?!1:!!($.exec("")&&$.lastIndex===0)}e.regExpLeadsToEndlessLoop=p;function w($){return!!$.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=w;function i($){return($.global?"g":"")+($.ignoreCase?"i":"")+($.multiline?"m":"")+($.unicode?"u":"")}e.regExpFlags=i;function s($){return $.split(/\r\n|\r|\n/)}e.splitLines=s;function a($){for(let ue=0,Ie=$.length;ue<Ie;ue++){const Le=$.charCodeAt(ue);if(Le!==32&&Le!==9)return ue}return-1}e.firstNonWhitespaceIndex=a;function u($,ue=0,Ie=$.length){for(let Le=ue;Le<Ie;Le++){const Be=$.charCodeAt(Le);if(Be!==32&&Be!==9)return $.substring(ue,Le)}return $.substring(ue,Ie)}e.getLeadingWhitespace=u;function l($,ue=$.length-1){for(let Ie=ue;Ie>=0;Ie--){const Le=$.charCodeAt(Ie);if(Le!==32&&Le!==9)return Ie}return-1}e.lastNonWhitespaceIndex=l;function c($,ue,Ie){const Le=[];let Be=0;for(const xe of $.matchAll(ue)){if(Le.push($.slice(Be,xe.index)),xe.index===void 0)throw new Error("match.index should be defined");Be=xe.index+xe[0].length,Le.push(Ie(xe[0],...xe.slice(1),xe.index,$,xe.groups))}return Le.push($.slice(Be)),Promise.all(Le).then(xe=>xe.join(""))}e.replaceAsync=c;function n($,ue){return $<ue?-1:$>ue?1:0}e.compare=n;function r($,ue,Ie=0,Le=$.length,Be=0,xe=ue.length){for(;Ie<Le&&Be<xe;Ie++,Be++){const mt=$.charCodeAt(Ie),lt=ue.charCodeAt(Be);if(mt<lt)return-1;if(mt>lt)return 1}const Ze=Le-Ie,gt=xe-Be;return Ze<gt?-1:Ze>gt?1:0}e.compareSubstring=r;function m($,ue){return S($,ue,0,$.length,0,ue.length)}e.compareIgnoreCase=m;function S($,ue,Ie=0,Le=$.length,Be=0,xe=ue.length){for(;Ie<Le&&Be<xe;Ie++,Be++){let mt=$.charCodeAt(Ie),lt=ue.charCodeAt(Be);if(mt===lt)continue;if(mt>=128||lt>=128)return r($.toLowerCase(),ue.toLowerCase(),Ie,Le,Be,xe);M(mt)&&(mt-=32),M(lt)&&(lt-=32);const ot=mt-lt;if(ot!==0)return ot}const Ze=Le-Ie,gt=xe-Be;return Ze<gt?-1:Ze>gt?1:0}e.compareSubstringIgnoreCase=S;function k($){return $>=48&&$<=57}e.isAsciiDigit=k;function M($){return $>=97&&$<=122}e.isLowerAsciiLetter=M;function q($){return $>=65&&$<=90}e.isUpperAsciiLetter=q;function V($,ue){return $.length===ue.length&&S($,ue)===0}e.equalsIgnoreCase=V;function F($,ue){const Ie=ue.length;return ue.length>$.length?!1:S($,ue,0,Ie)===0}e.startsWithIgnoreCase=F;function U($,ue){const Ie=Math.min($.length,ue.length);let Le;for(Le=0;Le<Ie;Le++)if($.charCodeAt(Le)!==ue.charCodeAt(Le))return Le;return Ie}e.commonPrefixLength=U;function N($,ue){const Ie=Math.min($.length,ue.length);let Le;const Be=$.length-1,xe=ue.length-1;for(Le=0;Le<Ie;Le++)if($.charCodeAt(Be-Le)!==ue.charCodeAt(xe-Le))return Le;return Ie}e.commonSuffixLength=N;function B($){return 55296<=$&&$<=56319}e.isHighSurrogate=B;function j($){return 56320<=$&&$<=57343}e.isLowSurrogate=j;function z($,ue){return($-55296<<10)+(ue-56320)+65536}e.computeCodePoint=z;function ne($,ue,Ie){const Le=$.charCodeAt(Ie);if(B(Le)&&Ie+1<ue){const Be=$.charCodeAt(Ie+1);if(j(Be))return z(Le,Be)}return Le}e.getNextCodePoint=ne;function _($,ue){const Ie=$.charCodeAt(ue-1);if(j(Ie)&&ue>1){const Le=$.charCodeAt(ue-2);if(B(Le))return z(Le,Ie)}return Ie}class Y{get offset(){return this.e}constructor(ue,Ie=0){this.c=ue,this.d=ue.length,this.e=Ie}setOffset(ue){this.e=ue}prevCodePoint(){const ue=_(this.c,this.e);return this.e-=ue>=65536?2:1,ue}nextCodePoint(){const ue=ne(this.c,this.d,this.e);return this.e+=ue>=65536?2:1,ue}eol(){return this.e>=this.d}}e.CodePointIterator=Y;class J{get offset(){return this.c.offset}constructor(ue,Ie=0){this.c=new Y(ue,Ie)}nextGraphemeLength(){const ue=et.getInstance(),Ie=this.c,Le=Ie.offset;let Be=ue.getGraphemeBreakType(Ie.nextCodePoint());for(;!Ie.eol();){const xe=Ie.offset,Ze=ue.getGraphemeBreakType(Ie.nextCodePoint());if(je(Be,Ze)){Ie.setOffset(xe);break}Be=Ze}return Ie.offset-Le}prevGraphemeLength(){const ue=et.getInstance(),Ie=this.c,Le=Ie.offset;let Be=ue.getGraphemeBreakType(Ie.prevCodePoint());for(;Ie.offset>0;){const xe=Ie.offset,Ze=ue.getGraphemeBreakType(Ie.prevCodePoint());if(je(Ze,Be)){Ie.setOffset(xe);break}Be=Ze}return Le-Ie.offset}eol(){return this.c.eol()}}e.GraphemeIterator=J;function Z($,ue){return new J($,ue).nextGraphemeLength()}e.nextCharLength=Z;function ie($,ue){return new J($,ue).prevGraphemeLength()}e.prevCharLength=ie;function X($,ue){ue>0&&j($.charCodeAt(ue))&&ue--;const Ie=ue+Z($,ue);return[Ie-ie($,Ie),Ie]}e.getCharContainingOffset=X;function K($){const ue=new J($);let Ie=0;for(;!ue.eol();)Ie++,ue.nextGraphemeLength();return Ie}e.charCount=K;let he;function be(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Ee($){return he||(he=be()),he.test($)}e.containsRTL=Ee;const Pe=/^[\t\n\r\x20-\x7E]*$/;function Me($){return Pe.test($)}e.isBasicASCII=Me,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function oe($){return e.UNUSUAL_LINE_TERMINATORS.test($)}e.containsUnusualLineTerminators=oe;function ae($){return $>=11904&&$<=55215||$>=63744&&$<=64255||$>=65281&&$<=65374}e.isFullWidthCharacter=ae;function fe($){return $>=127462&&$<=127487||$===8986||$===8987||$===9200||$===9203||$>=9728&&$<=10175||$===11088||$===11093||$>=127744&&$<=128591||$>=128640&&$<=128764||$>=128992&&$<=129008||$>=129280&&$<=129535||$>=129648&&$<=129782}e.isEmojiImprecise=fe;function ee($,ue){if($.length<ue)return $;const Ie=/\b/g;let Le=0;for(;Ie.test($)&&!($.length-Ie.lastIndex<ue);)Le=Ie.lastIndex,Ie.lastIndex+=1;return $.substring(Le).replace(/^\s/,"")}e.lcut=ee;const le=/\x1B\x5B[12]?K/g,re=/\x1b\[\d+m/g,O=/\x1b\[0?m/g;function H($){return $&&($=$.replace(le,""),$=$.replace(re,""),$=$.replace(O,"")),$}e.removeAnsiEscapeCodes=H,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function x($){return!!($&&$.length>0&&$.charCodeAt(0)===65279)}e.startsWithUTF8BOM=x;function Q($){return x($)?$.substr(1):$}e.stripUTF8BOM=Q;function de($,ue){if(!$||!ue||$.length<ue.length)return!1;const Ie=ue.length,Le=$.toLowerCase();let Be=0,xe=-1;for(;Be<Ie;){const Ze=Le.indexOf(ue[Be],xe+1);if(Ze<0)return!1;xe=Ze,Be++}return!0}e.fuzzyContains=de;function we($,ue=!1){return $?(ue&&($=$.replace(/\\./g,"")),$.toLowerCase()!==$):!1}e.containsUppercaseCharacter=we;function Ae($){return $.charAt(0).toUpperCase()+$.slice(1)}e.uppercaseFirstLetter=Ae;function pe($,ue=1){if(ue===0)return"";let Ie=-1;do Ie=$.indexOf(`
`,Ie+1),ue--;while(ue>0&&Ie>=0);return Ie===-1?$:($[Ie-1]==="\r"&&Ie--,$.substr(0,Ie))}e.getNLines=pe;function De($){return $=$%(2*26),$<26?String.fromCharCode(97+$):String.fromCharCode(65+$-26)}e.singleLetterHash=De;function ke($){return et.getInstance().getGraphemeBreakType($)}e.getGraphemeBreakType=ke;function je($,ue){return $===0?ue!==5&&ue!==7:$===2&&ue===3?!1:$===4||$===2||$===3||ue===4||ue===2||ue===3?!0:!($===8&&(ue===8||ue===9||ue===11||ue===12)||($===11||$===9)&&(ue===9||ue===10)||($===12||$===10)&&ue===10||ue===5||ue===13||ue===7||$===1||$===13&&ue===14||$===6&&ue===6)}var Ge;(function($){$[$.Other=0]="Other",$[$.Prepend=1]="Prepend",$[$.CR=2]="CR",$[$.LF=3]="LF",$[$.Control=4]="Control",$[$.Extend=5]="Extend",$[$.Regional_Indicator=6]="Regional_Indicator",$[$.SpacingMark=7]="SpacingMark",$[$.L=8]="L",$[$.V=9]="V",$[$.T=10]="T",$[$.LV=11]="LV",$[$.LVT=12]="LVT",$[$.ZWJ=13]="ZWJ",$[$.Extended_Pictographic=14]="Extended_Pictographic"})(Ge=e.GraphemeBreakType||(e.GraphemeBreakType={}));class et{static getInstance(){return et.c||(et.c=new et),et.c}constructor(){this.d=_e()}getGraphemeBreakType(ue){if(ue<32)return ue===10?3:ue===13?2:4;if(ue<127)return 0;const Ie=this.d,Le=Ie.length/3;let Be=1;for(;Be<=Le;)if(ue<Ie[3*Be])Be=2*Be;else if(ue>Ie[3*Be+1])Be=2*Be+1;else return Ie[3*Be+2];return 0}}et.c=null;function _e(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function nt($,ue){if($===0)return 0;const Ie=st($,ue);if(Ie!==void 0)return Ie;const Le=new Y(ue,$);return Le.prevCodePoint(),Le.offset}e.getLeftDeleteOffset=nt;function st($,ue){const Ie=new Y(ue,$);let Le=Ie.prevCodePoint();for(;ht(Le)||Le===65039||Le===8419;){if(Ie.offset===0)return;Le=Ie.prevCodePoint()}if(!fe(Le))return;let Be=Ie.offset;return Be>0&&Ie.prevCodePoint()===8205&&(Be=Ie.offset),Be}function ht($){return 127995<=$&&$<=127999}var Fe;(function($){$[$.zwj=8205]="zwj",$[$.emojiVariantSelector=65039]="emojiVariantSelector",$[$.enclosingKeyCap=8419]="enclosingKeyCap"})(Fe||(Fe={})),e.noBreakWhitespace="\xA0";class it{static getInstance(ue){return it.d.get(Array.from(ue))}static getLocales(){return it.e.getValue()}constructor(ue){this.f=ue}isAmbiguous(ue){return this.f.has(ue)}getPrimaryConfusable(ue){return this.f.get(ue)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.AmbiguousCharacters=it,T=it,it.c=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),it.d=new o.LRUCachedFunction($=>{function ue(lt){const ot=new Map;for(let rt=0;rt<lt.length;rt+=2)ot.set(lt[rt],lt[rt+1]);return ot}function Ie(lt,ot){const rt=new Map(lt);for(const[kt,Tt]of ot)rt.set(kt,Tt);return rt}function Le(lt,ot){if(!lt)return ot;const rt=new Map;for(const[kt,Tt]of lt)ot.has(kt)&&rt.set(kt,Tt);return rt}const Be=T.c.getValue();let xe=$.filter(lt=>!lt.startsWith("_")&&lt in Be);xe.length===0&&(xe=["_default"]);let Ze;for(const lt of xe){const ot=ue(Be[lt]);Ze=Le(Ze,ot)}const gt=ue(Be._common),mt=Ie(gt,Ze);return new it(mt)}),it.e=new t.Lazy(()=>Object.keys(it.c.getValue()).filter($=>!$.startsWith("_")));class ce{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(ce.c())),this.d}static isInvisibleCharacter(ue){return ce.e().has(ue)}static get codePoints(){return ce.e()}}e.InvisibleCharacters=ce,ce.d=void 0}),define(ye[32],Ce([1,0,10,12,8,11]),function(te,e,o,t,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function I(l){return l===47||l===92}e.isPathSeparator=I;function A(l){return l.replace(/[\\/]/g,o.posix.sep)}e.toSlashes=A;function y(l){return l.indexOf("/")===-1&&(l=A(l)),/^[a-zA-Z]:(\/|$)/.test(l)&&(l="/"+l),l}e.toPosixPath=y;function D(l,c=o.posix.sep){if(!l)return"";const n=l.length,r=l.charCodeAt(0);if(I(r)){if(I(l.charCodeAt(1))&&!I(l.charCodeAt(2))){let S=3;const k=S;for(;S<n&&!I(l.charCodeAt(S));S++);if(k!==S&&!I(l.charCodeAt(S+1))){for(S+=1;S<n;S++)if(I(l.charCodeAt(S)))return l.slice(0,S+1).replace(/[\\/]/g,c)}}return c}else if(h(r)&&l.charCodeAt(1)===58)return I(l.charCodeAt(2))?l.slice(0,2)+c:l.slice(0,2);let m=l.indexOf("://");if(m!==-1){for(m+=3;m<n;m++)if(I(l.charCodeAt(m)))return l.slice(0,m+1)}return""}e.getRoot=D;function L(l){if(!t.isWindows||!l||l.length<5)return!1;let c=l.charCodeAt(0);if(c!==92||(c=l.charCodeAt(1),c!==92))return!1;let n=2;const r=n;for(;n<l.length&&(c=l.charCodeAt(n),c!==92);n++);return!(r===n||(c=l.charCodeAt(n+1),isNaN(c)||c===92))}e.isUNC=L;const P=/[\\/:\*\?"<>\|]/g,v=/[\\/]/g,C=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function E(l,c=t.isWindows){const n=c?P:v;return!(!l||l.length===0||/^\s+$/.test(l)||(n.lastIndex=0,n.test(l))||c&&C.test(l)||l==="."||l===".."||c&&l[l.length-1]==="."||c&&l.length!==l.trim().length||l.length>255)}e.isValidBasename=E;function f(l,c,n){const r=l===c;return!n||r?r:!l||!c?!1:(0,T.equalsIgnoreCase)(l,c)}e.isEqual=f;function d(l,c,n,r=o.sep){if(l===c)return!0;if(!l||!c||c.length>l.length)return!1;if(n){if(!(0,T.startsWithIgnoreCase)(l,c))return!1;if(c.length===l.length)return!0;let S=c.length;return c.charAt(c.length-1)===r&&S--,l.charAt(S)===r}return c.charAt(c.length-1)!==r&&(c+=r),l.indexOf(c)===0}e.isEqualOrParent=d;function h(l){return l>=65&&l<=90||l>=97&&l<=122}e.isWindowsDriveLetter=h;function b(l,c){return t.isWindows&&l.endsWith(":")&&(l+=o.sep),(0,o.isAbsolute)(l)||(l=(0,o.join)(c,l)),l=(0,o.normalize)(l),t.isWindows?(l=(0,T.rtrim)(l,o.sep),l.endsWith(":")&&(l+=o.sep)):(l=(0,T.rtrim)(l,o.sep),l||(l=o.sep)),l}e.sanitizeFilePath=b;function g(l){const c=(0,o.normalize)(l);return t.isWindows?l.length>3?!1:p(c)&&(l.length===2||c.charCodeAt(2)===92):c===o.posix.sep}e.isRootOrDriveLetter=g;function p(l,c=t.isWindows){return c?h(l.charCodeAt(0))&&l.charCodeAt(1)===58:!1}e.hasDriveLetter=p;function w(l){return p(l)?l[0]:void 0}e.getDriveLetter=w;function i(l,c,n){return c.length>l.length?-1:l===c?0:(n&&(l=l.toLowerCase(),c=c.toLowerCase()),l.indexOf(c))}e.indexOfPath=i;function s(l){const c=l.split(":");let n,r,m;for(const S of c){const k=Number(S);(0,R.isNumber)(k)?r===void 0?r=k:m===void 0&&(m=k):n=n?[n,S].join(":"):S}if(!n)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:n,line:r!==void 0?r:void 0,column:m!==void 0?m:r!==void 0?1:void 0}}e.parseLineAndColumnAware=s;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function u(l,c,n=8){let r="";for(let S=0;S<n;S++)r+=a.charAt(Math.floor(Math.random()*a.length));let m;return c?m=`${c}-${r}`:m=r,l?(0,o.join)(l,m):m}e.randomPath=u}),define(ye[108],Ce([1,0,28,8]),function(te,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function T(...re){return function(O,H){for(let x=0,Q=re.length;x<Q;x++){const de=re[x](O,H);if(de)return de}return null}}e.or=T,e.matchesStrictPrefix=R.bind(void 0,!1),e.matchesPrefix=R.bind(void 0,!0);function R(re,O,H){if(!H||H.length<O.length)return null;let x;return re?x=t.startsWithIgnoreCase(H,O):x=H.indexOf(O)===0,x?O.length>0?[{start:0,end:O.length}]:[]:null}function I(re,O){const H=O.toLowerCase().indexOf(re.toLowerCase());return H===-1?null:[{start:H,end:H+re.length}]}e.matchesContiguousSubString=I;function A(re,O){return y(re.toLowerCase(),O.toLowerCase(),0,0)}e.matchesSubString=A;function y(re,O,H,x){if(H===re.length)return[];if(x===O.length)return null;if(re[H]===O[x]){let Q=null;return(Q=y(re,O,H+1,x+1))?h({start:x,end:x+1},Q):null}return y(re,O,H,x+1)}function D(re){return 97<=re&&re<=122}function L(re){return 65<=re&&re<=90}e.isUpper=L;function P(re){return 48<=re&&re<=57}function v(re){return re===32||re===9||re===10||re===13}const C=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(re=>C.add(re.charCodeAt(0)));function E(re){return v(re)||C.has(re)}function f(re,O){return re===O||E(re)&&E(O)}function d(re){return D(re)||L(re)||P(re)}function h(re,O){return O.length===0?O=[re]:re.end===O[0].start?O[0].start=re.start:O.unshift(re),O}function b(re,O){for(let H=O;H<re.length;H++){const x=re.charCodeAt(H);if(L(x)||P(x)||H>0&&!d(re.charCodeAt(H-1)))return H}return re.length}function g(re,O,H,x){if(H===re.length)return[];if(x===O.length)return null;if(re[H]!==O[x].toLowerCase())return null;{let Q=null,de=x+1;for(Q=g(re,O,H+1,x+1);!Q&&(de=b(O,de))<O.length;)Q=g(re,O,H+1,de),de++;return Q===null?null:h({start:x,end:x+1},Q)}}function p(re){let O=0,H=0,x=0,Q=0,de=0;for(let ke=0;ke<re.length;ke++)de=re.charCodeAt(ke),L(de)&&O++,D(de)&&H++,d(de)&&x++,P(de)&&Q++;const we=O/re.length,Ae=H/re.length,pe=x/re.length,De=Q/re.length;return{upperPercent:we,lowerPercent:Ae,alphaPercent:pe,numericPercent:De}}function w(re){const{upperPercent:O,lowerPercent:H}=re;return H===0&&O>.6}function i(re){const{upperPercent:O,lowerPercent:H,alphaPercent:x,numericPercent:Q}=re;return H>.2&&O<.8&&x>.6&&Q<.2}function s(re){let O=0,H=0,x=0,Q=0;for(let de=0;de<re.length;de++)x=re.charCodeAt(de),L(x)&&O++,D(x)&&H++,v(x)&&Q++;return(O===0||H===0)&&Q===0?re.length<=30:O<=5}function a(re,O){if(!O||(O=O.trim(),O.length===0)||!s(re)||O.length>60)return null;const H=p(O);if(!i(H)){if(!w(H))return null;O=O.toLowerCase()}let x=null,Q=0;for(re=re.toLowerCase();Q<O.length&&(x=g(re,O,0,Q))===null;)Q=b(O,Q+1);return x}e.matchesCamelCase=a;function u(re,O,H=!1){if(!O||O.length===0)return null;let x=null,Q=0;for(re=re.toLowerCase(),O=O.toLowerCase();Q<O.length&&(x=l(re,O,0,Q,H))===null;)Q=c(O,Q+1);return x}e.matchesWords=u;function l(re,O,H,x,Q){if(H===re.length)return[];if(x===O.length)return null;if(f(re.charCodeAt(H),O.charCodeAt(x))){let de=null,we=x+1;if(de=l(re,O,H+1,x+1,Q),!Q)for(;!de&&(we=c(O,we))<O.length;)de=l(re,O,H+1,we,Q),we++;return de?re.charCodeAt(H)!==O.charCodeAt(x)?de:h({start:x,end:x+1},de):null}else return null}function c(re,O){for(let H=O;H<re.length;H++)if(E(re.charCodeAt(H))||H>0&&E(re.charCodeAt(H-1)))return H;return re.length}const n=T(e.matchesPrefix,a,I),r=T(e.matchesPrefix,a,A),m=new o.LRUCache(1e4);function S(re,O,H=!1){if(typeof re!="string"||typeof O!="string")return null;let x=m.get(re);x||(x=new RegExp(t.convertSimple2RegExpPattern(re),"i"),m.set(re,x));const Q=x.exec(O);return Q?[{start:Q.index,end:Q.index+Q[0].length}]:H?r(re,O):n(re,O)}e.matchesFuzzy=S;function k(re,O){const H=Pe(re,re.toLowerCase(),0,O,O.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return H?q(H):null}e.matchesFuzzy2=k;function M(re,O,H,x,Q,de){const we=Math.min(13,re.length);for(;H<we;H++){const Ae=Pe(re,O,H,x,Q,de,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Ae)return Ae}return[0,de]}e.anyScore=M;function q(re){if(typeof re>"u")return[];const O=[],H=re[1];for(let x=re.length-1;x>1;x--){const Q=re[x]+H,de=O[O.length-1];de&&de.end===Q?de.end=Q+1:O.push({start:Q,end:Q+1})}return O}e.createMatches=q;const V=128;function F(){const re=[],O=[];for(let H=0;H<=V;H++)O[H]=0;for(let H=0;H<=V;H++)re.push(O.slice(0));return re}function U(re){const O=[];for(let H=0;H<=re;H++)O[H]=0;return O}const N=U(2*V),B=U(2*V),j=F(),z=F(),ne=F(),_=!1;function Y(re,O,H,x,Q){function de(Ae,pe,De=" "){for(;Ae.length<pe;)Ae=De+Ae;return Ae}let we=` |   |${x.split("").map(Ae=>de(Ae,3)).join("|")}
`;for(let Ae=0;Ae<=H;Ae++)Ae===0?we+=" |":we+=`${O[Ae-1]}|`,we+=re[Ae].slice(0,Q+1).map(pe=>de(pe.toString(),3)).join("|")+`
`;return we}function J(re,O,H,x){re=re.substr(O),H=H.substr(x),console.log(Y(z,re,re.length,H,H.length)),console.log(Y(ne,re,re.length,H,H.length)),console.log(Y(j,re,re.length,H,H.length))}function Z(re,O){if(O<0||O>=re.length)return!1;const H=re.codePointAt(O);switch(H){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!t.isEmojiImprecise(H)}}function ie(re,O){if(O<0||O>=re.length)return!1;switch(re.charCodeAt(O)){case 32:case 9:return!0;default:return!1}}function X(re,O,H){return O[re]!==H[re]}function K(re,O,H,x,Q,de,we=!1){for(;O<H&&Q<de;)re[O]===x[Q]&&(we&&(N[O]=Q),O+=1),Q+=1;return O===H}e.isPatternInWord=K;var he;(function(re){re[re.Diag=1]="Diag",re[re.Left=2]="Left",re[re.LeftLeft=3]="LeftLeft"})(he||(he={}));var be;(function(re){re.Default=[-100,0];function O(H){return!H||H.length===2&&H[0]===-100&&H[1]===0}re.isDefault=O})(be=e.FuzzyScore||(e.FuzzyScore={}));class Ee{constructor(O,H){this.firstMatchCanBeWeak=O,this.boostFullMatch=H}}e.FuzzyScoreOptions=Ee,Ee.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function Pe(re,O,H,x,Q,de,we=Ee.default){const Ae=re.length>V?V:re.length,pe=x.length>V?V:x.length;if(H>=Ae||de>=pe||Ae-H>pe-de||!K(O,H,Ae,Q,de,pe,!0))return;Me(Ae,pe,H,de,O,Q);let De=1,ke=1,je=H,Ge=de;const et=[!1];for(De=1,je=H;je<Ae;De++,je++){const Fe=N[je],it=B[je],ce=je+1<Ae?B[je+1]:pe;for(ke=Fe-de+1,Ge=Fe;Ge<ce;ke++,Ge++){let $=Number.MIN_SAFE_INTEGER,ue=!1;Ge<=it&&($=oe(re,O,je,H,x,Q,Ge,pe,de,j[De-1][ke-1]===0,et));let Ie=0;$!==Number.MAX_SAFE_INTEGER&&(ue=!0,Ie=$+z[De-1][ke-1]);const Le=Ge>Fe,Be=Le?z[De][ke-1]+(j[De][ke-1]>0?-5:0):0,xe=Ge>Fe+1&&j[De][ke-1]>0,Ze=xe?z[De][ke-2]+(j[De][ke-2]>0?-5:0):0;if(xe&&(!Le||Ze>=Be)&&(!ue||Ze>=Ie))z[De][ke]=Ze,ne[De][ke]=3,j[De][ke]=0;else if(Le&&(!ue||Be>=Ie))z[De][ke]=Be,ne[De][ke]=2,j[De][ke]=0;else if(ue)z[De][ke]=Ie,ne[De][ke]=1,j[De][ke]=j[De-1][ke-1]+1;else throw new Error("not possible")}}if(_&&J(re,H,x,de),!et[0]&&!we.firstMatchCanBeWeak)return;De--,ke--;const _e=[z[De][ke],de];let nt=0,st=0;for(;De>=1;){let Fe=ke;do{const it=ne[De][Fe];if(it===3)Fe=Fe-2;else if(it===2)Fe=Fe-1;else break}while(Fe>=1);nt>1&&O[H+De-1]===Q[de+ke-1]&&!X(Fe+de-1,x,Q)&&nt+1>j[De][Fe]&&(Fe=ke),Fe===ke?nt++:nt=1,st||(st=Fe),De--,ke=Fe-1,_e.push(ke)}pe===Ae&&we.boostFullMatch&&(_e[0]+=2);const ht=st-Ae;return _e[0]-=ht,_e}e.fuzzyScore=Pe;function Me(re,O,H,x,Q,de){let we=re-1,Ae=O-1;for(;we>=H&&Ae>=x;)Q[we]===de[Ae]&&(B[we]=Ae,we--),Ae--}function oe(re,O,H,x,Q,de,we,Ae,pe,De,ke){if(O[H]!==de[we])return Number.MIN_SAFE_INTEGER;let je=1,Ge=!1;return we===H-x?je=re[H]===Q[we]?7:5:X(we,Q,de)&&(we===0||!X(we-1,Q,de))?(je=re[H]===Q[we]?7:5,Ge=!0):Z(de,we)&&(we===0||!Z(de,we-1))?je=5:(Z(de,we-1)||ie(de,we-1))&&(je=5,Ge=!0),je>1&&H===x&&(ke[0]=!0),Ge||(Ge=X(we,Q,de)||Z(de,we-1)||ie(de,we-1)),H===x?we>pe&&(je-=Ge?3:5):De?je+=Ge?2:0:je+=Ge?0:1,we+1===Ae&&(je-=Ge?3:5),je}function ae(re,O,H,x,Q,de,we){return ee(re,O,H,x,Q,de,!0,we)}e.fuzzyScoreGracefulAggressive=ae;function fe(re,O,H,x,Q,de,we){return ee(re,O,H,x,Q,de,!1,we)}e.fuzzyScoreGraceful=fe;function ee(re,O,H,x,Q,de,we,Ae){let pe=Pe(re,O,H,x,Q,de,Ae);if(pe&&!we)return pe;if(re.length>=3){const De=Math.min(7,re.length-1);for(let ke=H+1;ke<De;ke++){const je=le(re,ke);if(je){const Ge=Pe(je,je.toLowerCase(),H,x,Q,de,Ae);Ge&&(Ge[0]-=3,(!pe||Ge[0]>pe[0])&&(pe=Ge))}}}return pe}function le(re,O){if(O+1>=re.length)return;const H=re[O],x=re[O+1];if(H!==x)return re.slice(0,O)+x+H+re.slice(O+2)}}),define(ye[85],Ce([1,0,8]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(h){return T(h,0)}e.hash=t;function T(h,b){switch(typeof h){case"object":return h===null?R(349,b):Array.isArray(h)?y(h,b):D(h,b);case"string":return A(h,b);case"boolean":return I(h,b);case"number":return R(h,b);case"undefined":return R(937,b);default:return R(617,b)}}e.doHash=T;function R(h,b){return(b<<5)-b+h|0}e.numberHash=R;function I(h,b){return R(h?433:863,b)}function A(h,b){b=R(149417,b);for(let g=0,p=h.length;g<p;g++)b=R(h.charCodeAt(g),b);return b}e.stringHash=A;function y(h,b){return b=R(104579,b),h.reduce((g,p)=>T(p,g),b)}function D(h,b){return b=R(181387,b),Object.keys(h).sort().reduce((g,p)=>(g=A(p,g),T(h[p],g)),b)}class L{constructor(){this.g=0}get value(){return this.g}hash(b){return this.g=T(b,this.g),this.g}}e.Hasher=L;var P;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function v(h,b,g=32){const p=g-b,w=~((1<<p)-1);return(h<<b|(w&h)>>>p)>>>0}function C(h,b=0,g=h.byteLength,p=0){for(let w=0;w<g;w++)h[b+w]=p}function E(h,b,g="0"){for(;h.length<b;)h=g+h;return h}function f(h,b=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(g=>g.toString(16).padStart(2,"0")).join(""):E((h>>>0).toString(16),b/4)}e.toHexString=f;class d{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(b){const g=b.length;if(g===0)return;const p=this.p;let w=this.r,i=this.u,s,a;for(i!==0?(s=i,a=-1,i=0):(s=b.charCodeAt(0),a=0);;){let u=s;if(o.isHighSurrogate(s))if(a+1<g){const l=b.charCodeAt(a+1);o.isLowSurrogate(l)?(a++,u=o.computeCodePoint(s,l)):u=65533}else{i=s;break}else o.isLowSurrogate(s)&&(u=65533);if(w=this.w(p,w,u),a++,a<g)s=b.charCodeAt(a);else break}this.r=w,this.u=i}w(b,g,p){return p<128?b[g++]=p:p<2048?(b[g++]=192|(p&1984)>>>6,b[g++]=128|(p&63)>>>0):p<65536?(b[g++]=224|(p&61440)>>>12,b[g++]=128|(p&4032)>>>6,b[g++]=128|(p&63)>>>0):(b[g++]=240|(p&1835008)>>>18,b[g++]=128|(p&258048)>>>12,b[g++]=128|(p&4032)>>>6,b[g++]=128|(p&63)>>>0),g>=64&&(this.y(),g-=64,this.t+=64,b[0]=b[64+0],b[1]=b[64+1],b[2]=b[64+2]),g}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),f(this.h)+f(this.l)+f(this.m)+f(this.n)+f(this.o)}x(){this.p[this.r++]=128,C(this.p,this.r),this.r>56&&(this.y(),C(this.p));const b=8*this.t;this.q.setUint32(56,Math.floor(b/4294967296),!1),this.q.setUint32(60,b%4294967296,!1),this.y()}y(){const b=d.g,g=this.q;for(let n=0;n<64;n+=4)b.setUint32(n,g.getUint32(n,!1),!1);for(let n=64;n<320;n+=4)b.setUint32(n,v(b.getUint32(n-12,!1)^b.getUint32(n-32,!1)^b.getUint32(n-56,!1)^b.getUint32(n-64,!1),1),!1);let p=this.h,w=this.l,i=this.m,s=this.n,a=this.o,u,l,c;for(let n=0;n<80;n++)n<20?(u=w&i|~w&s,l=1518500249):n<40?(u=w^i^s,l=1859775393):n<60?(u=w&i|w&s|i&s,l=2400959708):(u=w^i^s,l=3395469782),c=v(p,5)+u+a+l+b.getUint32(n*4,!1)&4294967295,a=s,s=i,i=v(w,30),w=p,p=c;this.h=this.h+p&4294967295,this.l=this.l+w&4294967295,this.m=this.m+i&4294967295,this.n=this.n+s&4294967295,this.o=this.o+a&4294967295}}e.StringSHA1=d,d.g=new DataView(new ArrayBuffer(320))}),define(ye[162],Ce([1,0,80,108,8]),function(te,e,o,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const R="$(",I=new RegExp(`\\$\\(${o.CSSIcon.iconNameExpression}(?:${o.CSSIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(`(\\\\)?${I.source}`,"g");function y(d){return d.replace(A,(h,b)=>b?h:`\\${h}`)}e.escapeIcons=y;const D=new RegExp(`\\\\${I.source}`,"g");function L(d){return d.replace(D,h=>`\\${h}`)}e.markdownEscapeEscapedIcons=L;const P=new RegExp(`(\\s)?(\\\\)?${I.source}(\\s)?`,"g");function v(d){return d.indexOf(R)===-1?d:d.replace(P,(h,b,g,p)=>g?h:b||p||"")}e.stripIcons=v;const C=new RegExp(`\\$\\(${o.CSSIcon.iconNameCharacter}+\\)`,"g");function E(d){C.lastIndex=0;let h="";const b=[];let g=0;for(;;){const p=C.lastIndex,w=C.exec(d),i=d.substring(p,w?.index);if(i.length>0){h+=i;for(let s=0;s<i.length;s++)b.push(g)}if(!w)break;g+=w[0].length}return{text:h,iconOffsets:b}}e.parseLabelWithIcons=E;function f(d,h,b=!1){const{text:g,iconOffsets:p}=h;if(!p||p.length===0)return(0,t.matchesFuzzy)(d,g,b);const w=(0,T.ltrim)(g," "),i=g.length-w.length,s=(0,t.matchesFuzzy)(d,w,b);if(s)for(const a of s){const u=p[a.start+i]+i;a.start+=u,a.end+=u}return s}e.matchesFuzzyIconAware=f}),define(ye[37],Ce([1,0,8]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(T){T[T.Ignore=0]="Ignore",T[T.Info=1]="Info",T[T.Warning=2]="Warning",T[T.Error=3]="Error"})(t||(t={})),function(T){const R="error",I="warning",A="warn",y="info",D="ignore";function L(v){return v?o.equalsIgnoreCase(R,v)?T.Error:o.equalsIgnoreCase(I,v)||o.equalsIgnoreCase(A,v)?T.Warning:o.equalsIgnoreCase(y,v)?T.Info:T.Ignore:T.Ignore}T.fromValue=L;function P(v){switch(v){case T.Error:return R;case T.Warning:return I;case T.Info:return y;default:return D}}T.toString=P}(t||(t={})),e.default=t}),define(ye[64],Ce([1,0,18,8]),function(te,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class T{constructor(){this.b="",this.c=0}reset(C){return this.b=C,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(C){const E=C.charCodeAt(0),f=this.b.charCodeAt(this.c);return E-f}value(){return this.b[this.c]}}e.StringIterator=T;class R{constructor(C=!0){this.e=C}reset(C){return this.b=C,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let C=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(C)this.c++;else break;else C=!1;return this}cmp(C){return this.e?(0,t.compareSubstring)(C,this.b,0,C.length,this.c,this.d):(0,t.compareSubstringIgnoreCase)(C,this.b,0,C.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=R;class I{constructor(C=!0,E=!0){this.f=C,this.g=E}reset(C){this.d=0,this.e=0,this.b=C,this.c=C.length;for(let E=C.length-1;E>=0;E--,this.c--){const f=this.b.charCodeAt(E);if(!(f===47||this.f&&f===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let C=!0;for(;this.e<this.c;this.e++){const E=this.b.charCodeAt(this.e);if(E===47||this.f&&E===92)if(C)this.d++;else break;else C=!1}return this}cmp(C){return this.g?(0,t.compareSubstring)(C,this.b,0,C.length,this.d,this.e):(0,t.compareSubstringIgnoreCase)(C,this.b,0,C.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=I;var A;(function(v){v[v.Scheme=1]="Scheme",v[v.Authority=2]="Authority",v[v.Path=3]="Path",v[v.Query=4]="Query",v[v.Fragment=5]="Fragment"})(A||(A={}));class y{constructor(C,E){this.f=C,this.g=E,this.d=[],this.e=0}reset(C){return this.c=C,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new I(!1,!this.f(C)),this.b.reset(C.path),this.b.value()&&this.d.push(3)),this.g(C)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(C){if(this.d[this.e]===1)return(0,t.compareIgnoreCase)(C,this.c.scheme);if(this.d[this.e]===2)return(0,t.compareIgnoreCase)(C,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(C);if(this.d[this.e]===4)return(0,t.compare)(C,this.c.query);if(this.d[this.e]===5)return(0,t.compare)(C,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=y;class D{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const C=this.right;return this.right=C.left,C.left=this,this.updateHeight(),C.updateHeight(),C}rotateRight(){const C=this.left;return this.left=C.right,C.right=this,this.updateHeight(),C.updateHeight(),C}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var L;(function(v){v[v.Left=-1]="Left",v[v.Mid=0]="Mid",v[v.Right=1]="Right"})(L||(L={}));class P{static forUris(C=()=>!1,E=()=>!1){return new P(new y(C,E))}static forPaths(C=!1){return new P(new I(void 0,!C))}static forStrings(){return new P(new T)}static forConfigKeys(){return new P(new R)}constructor(C){this.b=C}clear(){this.c=void 0}fill(C,E){if(E){const f=E.slice(0);(0,o.shuffle)(f);for(const d of f)this.set(d,C)}else{const f=C.slice(0);(0,o.shuffle)(f);for(const d of f)this.set(d[0],d[1])}}set(C,E){const f=this.b.reset(C);let d;this.c||(this.c=new D,this.c.segment=f.value());const h=[];for(d=this.c;;){const g=f.cmp(d.segment);if(g>0)d.left||(d.left=new D,d.left.segment=f.value()),h.push([-1,d]),d=d.left;else if(g<0)d.right||(d.right=new D,d.right.segment=f.value()),h.push([1,d]),d=d.right;else if(f.hasNext())f.next(),d.mid||(d.mid=new D,d.mid.segment=f.value()),h.push([0,d]),d=d.mid;else break}const b=d.value;d.value=E,d.key=C;for(let g=h.length-1;g>=0;g--){const p=h[g][1];p.updateHeight();const w=p.balanceFactor();if(w<-1||w>1){const i=h[g][0],s=h[g+1][0];if(i===1&&s===1)h[g][1]=p.rotateLeft();else if(i===-1&&s===-1)h[g][1]=p.rotateRight();else if(i===1&&s===-1)p.right=h[g+1][1]=h[g+1][1].rotateRight(),h[g][1]=p.rotateLeft();else if(i===-1&&s===1)p.left=h[g+1][1]=h[g+1][1].rotateLeft(),h[g][1]=p.rotateRight();else throw new Error;if(g>0)switch(h[g-1][0]){case-1:h[g-1][1].left=h[g][1];break;case 1:h[g-1][1].right=h[g][1];break;case 0:h[g-1][1].mid=h[g][1];break}else this.c=h[0][1]}}return b}get(C){return this.d(C)?.value}d(C){const E=this.b.reset(C);let f=this.c;for(;f;){const d=E.cmp(f.segment);if(d>0)f=f.left;else if(d<0)f=f.right;else if(E.hasNext())E.next(),f=f.mid;else break}return f}has(C){const E=this.d(C);return!(E?.value===void 0&&E?.mid===void 0)}delete(C){return this.e(C,!1)}deleteSuperstr(C){return this.e(C,!0)}e(C,E){const f=this.b.reset(C),d=[];let h=this.c;for(;h;){const b=f.cmp(h.segment);if(b>0)d.push([-1,h]),h=h.left;else if(b<0)d.push([1,h]),h=h.right;else if(f.hasNext())f.next(),d.push([0,h]),h=h.mid;else break}if(!!h){if(E?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const b=this.f(h.right);if(b.key){const{key:g,value:p,segment:w}=b;this.e(b.key,!1),h.key=g,h.value=p,h.segment=w}}else{const b=h.left??h.right;if(d.length>0){const[g,p]=d[d.length-1];switch(g){case-1:p.left=b;break;case 0:p.mid=b;break;case 1:p.right=b;break}}else this.c=b}for(let b=d.length-1;b>=0;b--){const g=d[b][1];g.updateHeight();const p=g.balanceFactor();if(p>1?(g.right.balanceFactor()>=0||(g.right=g.right.rotateRight()),d[b][1]=g.rotateLeft()):p<-1&&(g.left.balanceFactor()<=0||(g.left=g.left.rotateLeft()),d[b][1]=g.rotateRight()),b>0)switch(d[b-1][0]){case-1:d[b-1][1].left=d[b][1];break;case 1:d[b-1][1].right=d[b][1];break;case 0:d[b-1][1].mid=d[b][1];break}else this.c=d[0][1]}}}f(C){for(;C.left;)C=C.left;return C}findSubstr(C){const E=this.b.reset(C);let f=this.c,d;for(;f;){const h=E.cmp(f.segment);if(h>0)f=f.left;else if(h<0)f=f.right;else if(E.hasNext())E.next(),d=f.value||d,f=f.mid;else break}return f&&f.value||d}findSuperstr(C){return this.g(C,!1)}g(C,E){const f=this.b.reset(C);let d=this.c;for(;d;){const h=f.cmp(d.segment);if(h>0)d=d.left;else if(h<0)d=d.right;else if(f.hasNext())f.next(),d=d.mid;else return d.mid?this.h(d.mid):E?d.value:void 0}}hasElementOrSubtree(C){return this.g(C,!0)!==void 0}forEach(C){for(const[E,f]of this)C(f,E)}*[Symbol.iterator](){yield*this.h(this.c)}h(C){const E=[];return this.j(C,E),E[Symbol.iterator]()}j(C,E){!C||(C.left&&this.j(C.left,E),C.value&&E.push([C.key,C.value]),C.mid&&this.j(C.mid,E),C.right&&this.j(C.right,E))}_isBalanced(){const C=E=>{if(!E)return!0;const f=E.balanceFactor();return f<-1||f>1?!1:C(E.left)&&C(E.right)};return C(this.c)}}e.TernarySearchTree=P}),define(ye[2],Ce([1,0,10,12]),function(te,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const T=/^\w[\w\d+.-]*$/,R=/^\//,I=/^\/\//;function A(a,u){if(!a.scheme&&u)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${a.authority}", path: "${a.path}", query: "${a.query}", fragment: "${a.fragment}"}`);if(a.scheme&&!T.test(a.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(a.path){if(a.authority){if(!R.test(a.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(I.test(a.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function y(a,u){return!a&&!u?"file":a}function D(a,u){switch(a){case"https":case"http":case"file":u?u[0]!==P&&(u=P+u):u=P;break}return u}const L="",P="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class C{static isUri(u){return u instanceof C?!0:u?typeof u.authority=="string"&&typeof u.fragment=="string"&&typeof u.path=="string"&&typeof u.query=="string"&&typeof u.scheme=="string"&&typeof u.fsPath=="string"&&typeof u.with=="function"&&typeof u.toString=="function":!1}constructor(u,l,c,n,r,m=!1){typeof u=="object"?(this.scheme=u.scheme||L,this.authority=u.authority||L,this.path=u.path||L,this.query=u.query||L,this.fragment=u.fragment||L):(this.scheme=y(u,m),this.authority=l||L,this.path=D(this.scheme,c||L),this.query=n||L,this.fragment=r||L,A(this,m))}get fsPath(){return g(this,!1)}with(u){if(!u)return this;let{scheme:l,authority:c,path:n,query:r,fragment:m}=u;return l===void 0?l=this.scheme:l===null&&(l=L),c===void 0?c=this.authority:c===null&&(c=L),n===void 0?n=this.path:n===null&&(n=L),r===void 0?r=this.query:r===null&&(r=L),m===void 0?m=this.fragment:m===null&&(m=L),l===this.scheme&&c===this.authority&&n===this.path&&r===this.query&&m===this.fragment?this:new f(l,c,n,r,m)}static parse(u,l=!1){const c=v.exec(u);return c?new f(c[2]||L,s(c[4]||L),s(c[5]||L),s(c[7]||L),s(c[9]||L),l):new f(L,L,L,L,L)}static file(u){let l=L;if(t.isWindows&&(u=u.replace(/\\/g,P)),u[0]===P&&u[1]===P){const c=u.indexOf(P,2);c===-1?(l=u.substring(2),u=P):(l=u.substring(2,c),u=u.substring(c)||P)}return new f("file",l,u,L,L)}static from(u){const l=new f(u.scheme,u.authority,u.path,u.query,u.fragment);return A(l,!0),l}static joinPath(u,...l){if(!u.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return t.isWindows&&u.scheme==="file"?c=C.file(o.win32.join(g(u,!0),...l)).path:c=o.posix.join(u.path,...l),u.with({path:c})}toString(u=!1){return p(this,u)}toJSON(){return this}static revive(u){if(u){if(u instanceof C)return u;{const l=new f(u);return l._formatted=u.external,l._fsPath=u._sep===E?u.fsPath:null,l}}else return u}}e.URI=C;const E=t.isWindows?1:void 0;class f extends C{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=g(this,!1)),this._fsPath}toString(u=!1){return u?p(this,!0):(this._formatted||(this._formatted=p(this,!1)),this._formatted)}toJSON(){const u={$mid:1};return this._fsPath&&(u.fsPath=this._fsPath,u._sep=E),this._formatted&&(u.external=this._formatted),this.path&&(u.path=this.path),this.scheme&&(u.scheme=this.scheme),this.authority&&(u.authority=this.authority),this.query&&(u.query=this.query),this.fragment&&(u.fragment=this.fragment),u}}const d={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function h(a,u,l){let c,n=-1;for(let r=0;r<a.length;r++){const m=a.charCodeAt(r);if(m>=97&&m<=122||m>=65&&m<=90||m>=48&&m<=57||m===45||m===46||m===95||m===126||u&&m===47||l&&m===91||l&&m===93||l&&m===58)n!==-1&&(c+=encodeURIComponent(a.substring(n,r)),n=-1),c!==void 0&&(c+=a.charAt(r));else{c===void 0&&(c=a.substr(0,r));const S=d[m];S!==void 0?(n!==-1&&(c+=encodeURIComponent(a.substring(n,r)),n=-1),c+=S):n===-1&&(n=r)}}return n!==-1&&(c+=encodeURIComponent(a.substring(n))),c!==void 0?c:a}function b(a){let u;for(let l=0;l<a.length;l++){const c=a.charCodeAt(l);c===35||c===63?(u===void 0&&(u=a.substr(0,l)),u+=d[c]):u!==void 0&&(u+=a[l])}return u!==void 0?u:a}function g(a,u){let l;return a.authority&&a.path.length>1&&a.scheme==="file"?l=`//${a.authority}${a.path}`:a.path.charCodeAt(0)===47&&(a.path.charCodeAt(1)>=65&&a.path.charCodeAt(1)<=90||a.path.charCodeAt(1)>=97&&a.path.charCodeAt(1)<=122)&&a.path.charCodeAt(2)===58?u?l=a.path.substr(1):l=a.path[1].toLowerCase()+a.path.substr(2):l=a.path,t.isWindows&&(l=l.replace(/\//g,"\\")),l}e.uriToFsPath=g;function p(a,u){const l=u?b:h;let c="",{scheme:n,authority:r,path:m,query:S,fragment:k}=a;if(n&&(c+=n,c+=":"),(r||n==="file")&&(c+=P,c+=P),r){let M=r.indexOf("@");if(M!==-1){const q=r.substr(0,M);r=r.substr(M+1),M=q.lastIndexOf(":"),M===-1?c+=l(q,!1,!1):(c+=l(q.substr(0,M),!1,!1),c+=":",c+=l(q.substr(M+1),!1,!0)),c+="@"}r=r.toLowerCase(),M=r.lastIndexOf(":"),M===-1?c+=l(r,!1,!0):(c+=l(r.substr(0,M),!1,!0),c+=r.substr(M))}if(m){if(m.length>=3&&m.charCodeAt(0)===47&&m.charCodeAt(2)===58){const M=m.charCodeAt(1);M>=65&&M<=90&&(m=`/${String.fromCharCode(M+32)}:${m.substr(3)}`)}else if(m.length>=2&&m.charCodeAt(1)===58){const M=m.charCodeAt(0);M>=65&&M<=90&&(m=`${String.fromCharCode(M+32)}:${m.substr(2)}`)}c+=l(m,!0,!1)}return S&&(c+="?",c+=l(S,!1,!1)),k&&(c+="#",c+=u?k:h(k,!1,!1)),c}function w(a){try{return decodeURIComponent(a)}catch{return a.length>3?a.substr(0,3)+w(a.substr(3)):a}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(a){return a.match(i)?a.replace(i,u=>w(u)):a}}),define(ye[86],Ce([1,0,22,8,2]),function(te,e,o,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function R(D){return JSON.stringify(D,A)}e.stringify=R;function I(D){let L=JSON.parse(D);return L=y(L),L}e.parse=I;function A(D,L){return L instanceof RegExp?{$mid:2,source:L.source,flags:(0,t.regExpFlags)(L)}:L}function y(D,L=0){if(!D||L>200)return D;if(typeof D=="object"){switch(D.$mid){case 1:return T.URI.revive(D);case 2:return new RegExp(D.source,D.flags);case 16:return new Date(D.source)}if(D instanceof o.VSBuffer||D instanceof Uint8Array)return D;if(Array.isArray(D))for(let P=0;P<D.length;++P)D[P]=y(D[P],L+1);else for(const P in D)Object.hasOwnProperty.call(D,P)&&(D[P]=y(D[P],L+1))}return D}e.revive=y}),define(ye[15],Ce([1,0,9,12,2]),function(te,e,o,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var R;(function(D){D.inMemory="inmemory",D.vscode="vscode",D.internal="private",D.walkThrough="walkThrough",D.walkThroughSnippet="walkThroughSnippet",D.http="http",D.https="https",D.file="file",D.mailto="mailto",D.untitled="untitled",D.data="data",D.command="command",D.vscodeRemote="vscode-remote",D.vscodeRemoteResource="vscode-remote-resource",D.vscodeUserData="vscode-userdata",D.vscodeCustomEditor="vscode-custom-editor",D.vscodeNotebook="vscode-notebook",D.vscodeNotebookCell="vscode-notebook-cell",D.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",D.vscodeNotebookCellOutput="vscode-notebook-cell-output",D.vscodeInteractive="vscode-interactive",D.vscodeInteractiveInput="vscode-interactive-input",D.vscodeSettings="vscode-settings",D.vscodeWorkspaceTrust="vscode-workspace-trust",D.vscodeTerminal="vscode-terminal",D.webviewPanel="webview-panel",D.vscodeWebview="vscode-webview",D.extension="extension",D.vscodeFileResource="vscode-file",D.tmp="tmp",D.vsls="vsls",D.vscodeSourceControl="vscode-scm"})(R=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class I{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(L){this.d=L}setDelegate(L){this.e=L}setServerRootPath(L){this.f=`${L}/${R.vscodeRemoteResource}`}set(L,P,v){this.a[L]=P,this.b[L]=v}setConnectionToken(L,P){this.c[L]=P}getPreferredWebSchema(){return this.d}rewrite(L){if(this.e)try{return this.e(L)}catch(d){return o.onUnexpectedError(d),L}const P=L.authority;let v=this.a[P];v&&v.indexOf(":")!==-1&&v.indexOf("[")===-1&&(v=`[${v}]`);const C=this.b[P],E=this.c[P];let f=`path=${encodeURIComponent(L.path)}`;return typeof E=="string"&&(f+=`&${e.connectionTokenQueryName}=${encodeURIComponent(E)}`),T.URI.from({scheme:t.isWeb?this.d:R.vscodeRemoteResource,authority:`${v}:${C}`,path:this.f,query:f})}}e.RemoteAuthorities=new I,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class A{asBrowserUri(L){const P=this.b(L,te);return this.uriToBrowserUri(P)}uriToBrowserUri(L){return L.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(L):L.scheme===R.file&&(t.isNative||t.isWebWorker&&t.globals.origin===`${R.vscodeFileResource}://${A.a}`)?L.with({scheme:R.vscodeFileResource,authority:L.authority||A.a,query:null,fragment:null}):L}asFileUri(L){const P=this.b(L,te);return this.uriToFileUri(P)}uriToFileUri(L){return L.scheme===R.vscodeFileResource?L.with({scheme:R.file,authority:L.authority!==A.a?L.authority:null,query:null,fragment:null}):L}b(L,P){return T.URI.isUri(L)?L:T.URI.parse(P.toUrl(L))}}A.a="vscode-app",e.FileAccess=new A;var y;(function(D){const L=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);D.CoopAndCoep=Object.freeze(L.get("3"));const P="vscode-coi";function v(E){let f;typeof E=="string"?f=new URL(E).searchParams:E instanceof URL?f=E.searchParams:T.URI.isUri(E)&&(f=new URL(E.toString(!0)).searchParams);const d=f?.get(P);if(!!d)return L.get(d)}D.getHeadersFromQuery=v;function C(E,f,d){if(!globalThis.crossOriginIsolated)return;const h=f&&d?"3":d?"2":"1";E instanceof URLSearchParams?E.set(P,h):E[P]=h}D.addSearchParam=C})(y=e.COI||(e.COI={}))}),define(ye[24],Ce([1,0,32,15,10,12,8,2]),function(te,e,o,t,T,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(C){return(0,A.uriToFsPath)(C,!0)}e.originalFSPath=y;class D{constructor(E){this.a=E}compare(E,f,d=!1){return E===f?0:(0,I.compare)(this.getComparisonKey(E,d),this.getComparisonKey(f,d))}isEqual(E,f,d=!1){return E===f?!0:!E||!f?!1:this.getComparisonKey(E,d)===this.getComparisonKey(f,d)}getComparisonKey(E,f=!1){return E.with({path:this.a(E)?E.path.toLowerCase():void 0,fragment:f?null:void 0}).toString()}ignorePathCasing(E){return this.a(E)}isEqualOrParent(E,f,d=!1){if(E.scheme===f.scheme){if(E.scheme===t.Schemas.file)return o.isEqualOrParent(y(E),y(f),this.a(E))&&E.query===f.query&&(d||E.fragment===f.fragment);if((0,e.isEqualAuthority)(E.authority,f.authority))return o.isEqualOrParent(E.path,f.path,this.a(E),"/")&&E.query===f.query&&(d||E.fragment===f.fragment)}return!1}joinPath(E,...f){return A.URI.joinPath(E,...f)}basenameOrAuthority(E){return(0,e.basename)(E)||E.authority}basename(E){return T.posix.basename(E.path)}extname(E){return T.posix.extname(E.path)}dirname(E){if(E.path.length===0)return E;let f;return E.scheme===t.Schemas.file?f=A.URI.file(T.dirname(y(E))).path:(f=T.posix.dirname(E.path),E.authority&&f.length&&f.charCodeAt(0)!==47&&(console.error(`dirname("${E.toString})) resulted in a relative path`),f="/")),E.with({path:f})}normalizePath(E){if(!E.path.length)return E;let f;return E.scheme===t.Schemas.file?f=A.URI.file(T.normalize(y(E))).path:f=T.posix.normalize(E.path),E.with({path:f})}relativePath(E,f){if(E.scheme!==f.scheme||!(0,e.isEqualAuthority)(E.authority,f.authority))return;if(E.scheme===t.Schemas.file){const b=T.relative(y(E),y(f));return R.isWindows?o.toSlashes(b):b}let d=E.path||"/";const h=f.path||"/";if(this.a(E)){let b=0;for(const g=Math.min(d.length,h.length);b<g&&!(d.charCodeAt(b)!==h.charCodeAt(b)&&d.charAt(b).toLowerCase()!==h.charAt(b).toLowerCase());b++);d=h.substr(0,b)+d.substr(b)}return T.posix.relative(d,h)}resolvePath(E,f){if(E.scheme===t.Schemas.file){const d=A.URI.file(T.resolve(y(E),f));return E.with({authority:d.authority,path:d.path})}return f=o.toPosixPath(f),E.with({path:T.posix.resolve(E.path,f)})}isAbsolutePath(E){return!!E.path&&E.path[0]==="/"}isEqualAuthority(E,f){return E===f||E!==void 0&&f!==void 0&&(0,I.equalsIgnoreCase)(E,f)}hasTrailingPathSeparator(E,f=T.sep){if(E.scheme===t.Schemas.file){const d=y(E);return d.length>o.getRoot(d).length&&d[d.length-1]===f}else{const d=E.path;return d.length>1&&d.charCodeAt(d.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(E.fsPath)}}removeTrailingPathSeparator(E,f=T.sep){return(0,e.hasTrailingPathSeparator)(E,f)?E.with({path:E.path.substr(0,E.path.length-1)}):E}addTrailingPathSeparator(E,f=T.sep){let d=!1;if(E.scheme===t.Schemas.file){const h=y(E);d=h!==void 0&&h.length===o.getRoot(h).length&&h[h.length-1]===f}else{f="/";const h=E.path;d=h.length===1&&h.charCodeAt(h.length-1)===47}return!d&&!(0,e.hasTrailingPathSeparator)(E,f)?E.with({path:E.path+"/"}):E}}e.ExtUri=D,e.extUri=new D(()=>!1),e.extUriBiasedIgnorePathCase=new D(C=>C.scheme===t.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new D(C=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function L(C,E){const f=[];for(let d=0;d<C.length;d++){const h=E(C[d]);C.some((b,g)=>g===d?!1:(0,e.isEqualOrParent)(h,E(b)))||f.push(C[d])}return f}e.distinctParents=L;var P;(function(C){C.META_DATA_LABEL="label",C.META_DATA_DESCRIPTION="description",C.META_DATA_SIZE="size",C.META_DATA_MIME="mime";function E(f){const d=new Map;f.path.substring(f.path.indexOf(";")+1,f.path.lastIndexOf(";")).split(";").forEach(g=>{const[p,w]=g.split(":");p&&w&&d.set(p,w)});const b=f.path.substring(0,f.path.indexOf(";"));return b&&d.set(C.META_DATA_MIME,b),d}C.parseMetaData=E})(P=e.DataUri||(e.DataUri={}));function v(C,E,f){if(E){let d=C.path;return d&&d[0]!==T.posix.sep&&(d=T.posix.sep+d),C.with({scheme:f,authority:E,path:d})}return C.with({scheme:f})}e.toLocalResource=v}),define(ye[16],Ce([1,0,21,9,3,6,24,12]),function(te,e,o,t,T,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function y(X){return!!X&&typeof X.then=="function"}e.isThenable=y;function D(X){const K=new o.CancellationTokenSource,he=X(K.token),be=new Promise((Ee,Pe)=>{const Me=K.token.onCancellationRequested(()=>{Me.dispose(),K.dispose(),Pe(new t.CancellationError)});Promise.resolve(he).then(oe=>{Me.dispose(),K.dispose(),Ee(oe)},oe=>{Me.dispose(),K.dispose(),Pe(oe)})});return new class{cancel(){K.cancel()}then(Ee,Pe){return be.then(Ee,Pe)}catch(Ee){return this.then(void 0,Ee)}finally(Ee){return be.finally(Ee)}}}e.createCancelablePromise=D;function L(X,K,he){return new Promise((be,Ee)=>{const Pe=K.onCancellationRequested(()=>{Pe.dispose(),be(he)});X.then(be,Ee).finally(()=>Pe.dispose())})}e.raceCancellation=L;function P(X,K){return new Promise((he,be)=>{const Ee=K.onCancellationRequested(()=>{Ee.dispose(),be(new t.CancellationError)});X.then(he,be).finally(()=>Ee.dispose())})}e.raceCancellationError=P;async function v(X){let K=-1;const he=X.map((Ee,Pe)=>Ee.then(Me=>(K=Pe,Me))),be=await Promise.race(he);return X.forEach((Ee,Pe)=>{Pe!==K&&Ee.cancel()}),be}e.raceCancellablePromises=v;function C(X,K,he){let be;const Ee=setTimeout(()=>{be?.(void 0),he?.()},K);return Promise.race([X.finally(()=>clearTimeout(Ee)),new Promise(Pe=>be=Pe)])}e.raceTimeout=C;function E(X){return new Promise((K,he)=>{const be=X();y(be)?be.then(K,he):K(be)})}e.asPromise=E;class f{constructor(){this.a=null,this.b=null,this.d=null}queue(K){if(this.a){if(this.d=K,!this.b){const he=()=>{this.b=null;const be=this.queue(this.d);return this.d=null,be};this.b=new Promise(be=>{this.a.then(he,he).then(be)})}return new Promise((he,be)=>{this.b.then(he,be)})}return this.a=K(),new Promise((he,be)=>{this.a.then(Ee=>{this.a=null,he(Ee)},Ee=>{this.a=null,be(Ee)})})}}e.Throttler=f;class d{constructor(){this.a=Promise.resolve(null)}queue(K){return this.a=this.a.then(()=>K(),()=>K())}}e.Sequencer=d;class h{constructor(){this.a=new Map}queue(K,he){const Ee=(this.a.get(K)??Promise.resolve()).catch(()=>{}).then(he).finally(()=>{this.a.get(K)===Ee&&this.a.delete(K)});return this.a.set(K,Ee),Ee}}e.SequencerByKey=h;const b=(X,K)=>{let he=!0;const be=setTimeout(()=>{he=!1,K()},X);return{isTriggered:()=>he,dispose:()=>{clearTimeout(be),he=!1}}},g=X=>{let K=!0;return queueMicrotask(()=>{K&&(K=!1,X())}),{isTriggered:()=>K,dispose:()=>{K=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class p{constructor(K){this.defaultDelay=K,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(K,he=this.defaultDelay){this.g=K,this.h(),this.b||(this.b=new Promise((Ee,Pe)=>{this.d=Ee,this.f=Pe}).then(()=>{if(this.b=null,this.d=null,this.g){const Ee=this.g;return this.g=null,Ee()}}));const be=()=>{this.a=null,this.d?.(null)};return this.a=he===e.MicrotaskDelay?g(be):b(he,be),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new t.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=p;class w{constructor(K){this.a=new p(K),this.b=new f}trigger(K,he){return this.a.trigger(()=>this.b.queue(K),he)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=w;class i{constructor(){this.a=!1,this.b=new Promise((K,he)=>{this.d=K})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=i;class s extends i{constructor(K){super(),this.f=setTimeout(()=>this.open(),K)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=s;function a(X,K){return K?new Promise((he,be)=>{const Ee=setTimeout(()=>{Pe.dispose(),he()},X),Pe=K.onCancellationRequested(()=>{clearTimeout(Ee),Pe.dispose(),be(new t.CancellationError)})}):D(he=>a(X,he))}e.timeout=a;function u(X,K=0){const he=setTimeout(X,K);return(0,R.toDisposable)(()=>clearTimeout(he))}e.disposableTimeout=u;function l(X){const K=[];let he=0;const be=X.length;function Ee(){return he<be?X[he++]():null}function Pe(Me){Me!=null&&K.push(Me);const oe=Ee();return oe?oe.then(Pe):Promise.resolve(K)}return Promise.resolve(null).then(Pe)}e.sequence=l;function c(X,K=be=>!!be,he=null){let be=0;const Ee=X.length,Pe=()=>{if(be>=Ee)return Promise.resolve(he);const Me=X[be++];return Promise.resolve(Me()).then(ae=>K(ae)?Promise.resolve(ae):Pe())};return Pe()}e.first=c;function n(X,K=be=>!!be,he=null){if(X.length===0)return Promise.resolve(he);let be=X.length;const Ee=()=>{be=-1;for(const Pe of X)Pe.cancel?.()};return new Promise((Pe,Me)=>{for(const oe of X)oe.then(ae=>{--be>=0&&K(ae)?(Ee(),Pe(ae)):be===0&&Pe(he)}).catch(ae=>{--be>=0&&(Ee(),Me(ae))})})}e.firstParallel=n;class r{constructor(K){this.a=0,this.d=K,this.f=[],this.b=0,this.g=new T.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(K){return this.a++,new Promise((he,be)=>{this.f.push({factory:K,c:he,e:be}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const K=this.f.shift();this.b++;const he=K.factory();he.then(K.c,K.e),he.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=r;class m extends r{constructor(){super(1)}}e.Queue=m;class S{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const K=new ne;return this.b.add(K),K.p}d(){for(const[,K]of this.a)if(K.size>0)return!1;return!0}queueFor(K,he=I.extUri){const be=he.getComparisonKey(K);let Ee=this.a.get(be);return Ee||(Ee=new m,T.Event.once(Ee.onDrained)(()=>{Ee?.dispose(),this.a.delete(be),this.f()}),this.a.set(be,Ee)),Ee}f(){!this.d()||this.g()}g(){for(const K of this.b)K.complete();this.b.clear()}dispose(){for(const[,K]of this.a)K.dispose();this.a.clear(),this.g()}}e.ResourceQueue=S;class k{constructor(K,he){this.a=-1,typeof K=="function"&&typeof he=="number"&&this.setIfNotSet(K,he)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(K,he){this.cancel(),this.a=setTimeout(()=>{this.a=-1,K()},he)}setIfNotSet(K,he){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,K()},he))}}e.TimeoutTimer=k;class M{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(K,he){this.cancel(),this.a=setInterval(()=>{K()},he)}}e.IntervalTimer=M;class q{constructor(K,he){this.b=-1,this.a=K,this.d=he,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(K=this.d){this.cancel(),this.b=setTimeout(this.f,K)}get delay(){return this.d}set delay(K){this.d=K}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=q;class V{constructor(K,he){he%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${he}ms is not a multiple of 1000ms.`),this.a=K,this.b=he,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(K=this.b){K%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${K}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(K/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=V;class F extends q{constructor(K,he){super(K,he),this.j=[]}work(K){this.j.push(K),this.isScheduled()||this.schedule()}h(){const K=this.j;this.j=[],this.a?.(K)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=F;class U extends R.Disposable{constructor(K,he){super(),this.g=K,this.h=he,this.a=[],this.b=this.B(new R.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(K){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+K.length>this.g.maxBufferedWork)return!1}else if(this.pending+K.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const he of K)this.a.push(he);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new q(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=U,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=X=>{(0,A.setTimeout0)(()=>{if(K)return;const he=Date.now()+15;X(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,he-Date.now())}}))});let K=!1;return{dispose(){K||(K=!0)}}}:e.runWhenIdle=(X,K)=>{const he=requestIdleCallback(X,typeof K=="number"?{timeout:K}:void 0);let be=!1;return{dispose(){be||(be=!0,cancelIdleCallback(he))}}}}();class N{constructor(K){this.d=!1,this.a=()=>{try{this.f=K()}catch(he){this.g=he}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=N;async function B(X,K,he){let be;for(let Ee=0;Ee<he;Ee++)try{return await X()}catch(Pe){be=Pe,await a(K)}throw be}e.retry=B;class j{hasPending(K){return this.a?typeof K=="number"?this.a.taskId===K:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(K,he,be){return this.a={taskId:K,cancel:()=>be?.(),promise:he},he.then(()=>this.d(K),()=>this.d(K)),he}d(K){this.a&&K===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const K=this.b;this.b=void 0,K.run().then(K.promiseResolve,K.promiseReject)}}setNext(K){if(this.b)this.b.run=K;else{let he,be;const Ee=new Promise((Pe,Me)=>{he=Pe,be=Me});this.b={run:K,promise:Ee,promiseResolve:he,promiseReject:be}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=j;class z{constructor(K,he=()=>Date.now()){this.d=K,this.f=he,this.a=0,this.b=0}increment(){const K=this.f();return K-this.a>this.d&&(this.a=K,this.b=0),this.b++,this.b}}e.IntervalCounter=z;class ne{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((K,he)=>{this.a=K,this.b=he})}complete(K){return new Promise(he=>{this.a(K),this.f=!0,he()})}error(K){return new Promise(he=>{this.b(K),this.d=!0,he()})}cancel(){new Promise(K=>{this.b(new t.CancellationError),this.d=!0,K()})}}e.DeferredPromise=ne;var _;(function(X){async function K(be){let Ee;const Pe=await Promise.all(be.map(Me=>Me.then(oe=>oe,oe=>{Ee||(Ee=oe)})));if(typeof Ee<"u")throw Ee;return Pe}X.settled=K;function he(be){return new Promise(async(Ee,Pe)=>{try{await be(Ee,Pe)}catch(Me){Pe(Me)}})}X.withAsyncBody=he})(_=e.Promises||(e.Promises={}));var Y;(function(X){X[X.Initial=0]="Initial",X[X.DoneOK=1]="DoneOK",X[X.DoneError=2]="DoneError"})(Y||(Y={}));class J{static fromArray(K){return new J(he=>{he.emitMany(K)})}static fromPromise(K){return new J(async he=>{he.emitMany(await K)})}static fromPromises(K){return new J(async he=>{await Promise.all(K.map(async be=>he.emitOne(await be)))})}static merge(K){return new J(async he=>{await Promise.all(K.map(async be=>{for await(const Ee of be)he.emitOne(Ee)}))})}constructor(K){this.a=0,this.b=[],this.d=null,this.f=new T.Emitter,queueMicrotask(async()=>{const he={emitOne:be=>this.g(be),emitMany:be=>this.h(be),reject:be=>this.k(be)};try{await Promise.resolve(K(he)),this.j()}catch(be){this.k(be)}finally{he.emitOne=void 0,he.emitMany=void 0,he.reject=void 0}})}[Symbol.asyncIterator](){let K=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(K<this.b.length)return{done:!1,value:this.b[K++]};if(this.a===1)return{done:!0,value:void 0};await T.Event.toPromise(this.f.event)}while(!0)}}}static map(K,he){return new J(async be=>{for await(const Ee of K)be.emitOne(he(Ee))})}map(K){return J.map(this,K)}static filter(K,he){return new J(async be=>{for await(const Ee of K)he(Ee)&&be.emitOne(Ee)})}filter(K){return J.filter(this,K)}static coalesce(K){return J.filter(K,he=>!!he)}coalesce(){return J.coalesce(this)}static async toPromise(K){const he=[];for await(const be of K)he.push(be);return he}toPromise(){return J.toPromise(this)}g(K){this.a===0&&(this.b.push(K),this.f.fire())}h(K){this.a===0&&(this.b=this.b.concat(K),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(K){this.a===0&&(this.a=2,this.d=K,this.f.fire())}}e.AsyncIterableObject=J,J.EMPTY=J.fromArray([]);class Z extends J{constructor(K,he){super(he),this.l=K}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=Z;function ie(X){const K=new o.CancellationTokenSource,he=X(K.token);return new Z(K,async be=>{const Ee=K.token.onCancellationRequested(()=>{Ee.dispose(),K.dispose(),be.reject(new t.CancellationError)});try{for await(const Pe of he){if(K.token.isCancellationRequested)return;be.emitOne(Pe)}Ee.dispose(),K.dispose()}catch(Pe){Ee.dispose(),K.dispose(),be.reject(Pe)}})}e.createCancelableAsyncIterable=ie}),define(ye[109],Ce([1,0,16,10]),function(te,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const T=new o.IdleValue(()=>{const r=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:r,collatorIsNumeric:r.resolvedOptions().numeric}}),R=new o.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),I=new o.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function A(r,m,S=!1){const k=r||"",M=m||"",q=T.value.collator.compare(k,M);return T.value.collatorIsNumeric&&q===0&&k!==M?k<M?-1:1:q}e.compareFileNames=A;function y(r,m){const S=R.value.collator;return r=r||"",m=m||"",p(S,r,m)}e.compareFileNamesDefault=y;function D(r,m){const S=R.value.collator;return r=r||"",m=m||"",a(r,m)||p(S,r,m)}e.compareFileNamesUpper=D;function L(r,m){const S=R.value.collator;return r=r||"",m=m||"",s(r,m)||p(S,r,m)}e.compareFileNamesLower=L;function P(r,m){return r=r||"",m=m||"",r===m?0:r<m?-1:1}e.compareFileNamesUnicode=P;function v(r,m){const[S,k]=b(r),[M,q]=b(m);let V=T.value.collator.compare(k,q);if(V===0){if(T.value.collatorIsNumeric&&k!==q)return k<q?-1:1;if(V=T.value.collator.compare(S,M),T.value.collatorIsNumeric&&V===0&&S!==M)return S<M?-1:1}return V}e.compareFileExtensions=v;function C(r,m){r=r||"",m=m||"";const S=g(r),k=g(m),M=R.value.collator,q=I.value.collator;return p(q,S,k)||p(M,r,m)}e.compareFileExtensionsDefault=C;function E(r,m){r=r||"",m=m||"";const S=g(r),k=g(m),M=R.value.collator,q=I.value.collator;return p(q,S,k)||a(r,m)||p(M,r,m)}e.compareFileExtensionsUpper=E;function f(r,m){r=r||"",m=m||"";const S=g(r),k=g(m),M=R.value.collator,q=I.value.collator;return p(q,S,k)||s(r,m)||p(M,r,m)}e.compareFileExtensionsLower=f;function d(r,m){r=r||"",m=m||"";const S=g(r).toLowerCase(),k=g(m).toLowerCase();return S!==k?S<k?-1:1:r!==m?r<m?-1:1:0}e.compareFileExtensionsUnicode=d;const h=/^(.*?)(\.([^.]*))?$/;function b(r,m=!1){const S=r?h.exec(r):[];let k=[S&&S[1]||"",S&&S[3]||""];return m&&(!k[0]&&k[1]||k[0]&&k[0].charAt(0)===".")&&(k=[k[0]+"."+k[1],""]),k}function g(r){const m=r?h.exec(r):[];return m&&m[1]&&m[1].charAt(0)!=="."&&m[3]||""}function p(r,m,S){const k=r.compare(m,S);return k!==0?k:m.length!==S.length?m.length<S.length?-1:1:0}function w(r){const m=r.charAt(0);return m.toLocaleUpperCase()!==m}function i(r){const m=r.charAt(0);return m.toLocaleLowerCase()!==m}function s(r,m){return w(r)&&i(m)?-1:i(r)&&w(m)?1:0}function a(r,m){return i(r)&&w(m)?-1:w(r)&&i(m)?1:0}function u(r,m,S=!1){return S||(r=r&&r.toLowerCase(),m=m&&m.toLowerCase()),r===m?0:r<m?-1:1}function l(r,m,S=!1){const k=r.split(t.sep),M=m.split(t.sep),q=k.length-1,V=M.length-1;let F,U;for(let N=0;;N++){if(F=q===N,U=V===N,F&&U)return A(k[N],M[N],S);if(F)return-1;if(U)return 1;const B=u(k[N],M[N],S);if(B!==0)return B}}e.comparePaths=l;function c(r,m,S){const k=r.toLowerCase(),M=m.toLowerCase(),q=n(r,m,S);if(q)return q;const V=k.endsWith(S),F=M.endsWith(S);if(V!==F)return V?-1:1;const U=A(k,M);return U!==0?U:k.localeCompare(M)}e.compareAnything=c;function n(r,m,S){const k=r.toLowerCase(),M=m.toLowerCase(),q=k.startsWith(S),V=M.startsWith(S);if(q!==V)return q?-1:1;if(q&&V){if(k.length<M.length)return-1;if(k.length>M.length)return 1}return 0}e.compareByPrefix=n}),define(ye[110],Ce([1,0,109,108,85,10,12,8]),function(te,e,o,t,T,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const y=0,D=[y,[]];function L(j,z,ne,_){if(!j||!z)return D;const Y=j.length,J=z.length;if(Y<J)return D;const Z=j.toLowerCase();return P(z,ne,J,j,Z,Y,_)}e.scoreFuzzy=L;function P(j,z,ne,_,Y,J,Z){const ie=[],X=[];for(let Ee=0;Ee<ne;Ee++){const Pe=Ee*J,Me=Pe-J,oe=Ee>0,ae=j[Ee],fe=z[Ee];for(let ee=0;ee<J;ee++){const le=ee>0,re=Pe+ee,O=re-1,H=Me+ee-1,x=le?ie[O]:0,Q=oe&&le?ie[H]:0,de=oe&&le?X[H]:0;let we;!Q&&oe?we=0:we=v(ae,fe,_,Y,ee,de),we&&Q+we>=x&&(Z||oe||Y.startsWith(z,ee))?(X[re]=de+1,ie[re]=Q+we):(X[re]=y,ie[re]=x)}}const K=[];let he=ne-1,be=J-1;for(;he>=0&&be>=0;){const Ee=he*J+be;X[Ee]===y||(K.push(be),he--),be--}return[ie[ne*J-1],K.reverse()]}function v(j,z,ne,_,Y,J){let Z=0;if(!C(z,_[Y]))return Z;if(Z+=1,J>0&&(Z+=J*5),j===ne[Y]&&(Z+=1),Y===0)Z+=8;else{const ie=E(ne.charCodeAt(Y-1));ie?Z+=ie:(0,t.isUpper)(ne.charCodeAt(Y))&&J===0&&(Z+=2)}return Z}function C(j,z){return j===z?!0:j==="/"||j==="\\"?z==="/"||z==="\\":!1}function E(j){switch(j){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const f=[void 0,[]];function d(j,z,ne=0,_=0){const Y=z;return Y.values&&Y.values.length>1?h(j,Y.values,ne,_):b(j,z,ne,_)}e.scoreFuzzy2=d;function h(j,z,ne,_){let Y=0;const J=[];for(const Z of z){const[ie,X]=b(j,Z,ne,_);if(typeof ie!="number")return f;Y+=ie,J.push(...X)}return[Y,r(J)]}function b(j,z,ne,_){const Y=(0,t.fuzzyScore)(z.original,z.originalLowercase,ne,j,j.toLowerCase(),_,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Y?[Y[0],(0,t.createMatches)(Y)]:f}const g=Object.freeze({score:0}),p=1<<18,w=1<<17,i=1<<16;function s(j,z,ne,_){const Y=_.values?_.values:[_];return(0,T.hash)({[_.normalized]:{values:Y.map(Z=>({value:Z.normalized,expectContiguousMatch:Z.expectContiguousMatch})),label:j,description:z,allowNonContiguousMatches:ne}})}function a(j,z,ne,_,Y){if(!j||!z.normalized)return g;const J=_.getItemLabel(j);if(!J)return g;const Z=_.getItemDescription(j),ie=s(J,Z,ne,z),X=Y[ie];if(X)return X;const K=u(J,Z,_.getItemPath(j),z,ne);return Y[ie]=K,K}e.scoreItemFuzzy=a;function u(j,z,ne,_,Y){const J=!ne||!_.containsPathSeparator;return ne&&(I.isLinux?_.pathNormalized===ne:(0,A.equalsIgnoreCase)(_.pathNormalized,ne))?{score:p,labelMatch:[{start:0,end:j.length}],descriptionMatch:z?[{start:0,end:z.length}]:void 0}:_.values&&_.values.length>1?l(j,z,ne,_.values,J,Y):c(j,z,ne,_,J,Y)}function l(j,z,ne,_,Y,J){let Z=0;const ie=[],X=[];for(const K of _){const{score:he,labelMatch:be,descriptionMatch:Ee}=c(j,z,ne,K,Y,J);if(he===y)return g;Z+=he,be&&ie.push(...be),Ee&&X.push(...Ee)}return{score:Z,labelMatch:r(ie),descriptionMatch:r(X)}}function c(j,z,ne,_,Y,J){if(Y||!z){const[Z,ie]=L(j,_.normalized,_.normalizedLowercase,J&&!_.expectContiguousMatch);if(Z){const X=(0,t.matchesPrefix)(_.normalized,j);let K;return X?(K=w,K+=Math.round(_.normalized.length/j.length*100)):K=i,{score:K+Z,labelMatch:X||n(ie)}}}if(z){let Z=z;ne&&(Z=`${z}${R.sep}`);const ie=Z.length,X=`${Z}${j}`,[K,he]=L(X,_.normalized,_.normalizedLowercase,J&&!_.expectContiguousMatch);if(K){const be=n(he),Ee=[],Pe=[];return be.forEach(Me=>{Me.start<ie&&Me.end>ie?(Ee.push({start:0,end:Me.end-ie}),Pe.push({start:Me.start,end:ie})):Me.start>=ie?Ee.push({start:Me.start-ie,end:Me.end-ie}):Pe.push(Me)}),{score:K,labelMatch:Ee,descriptionMatch:Pe}}}return g}function n(j){const z=[];if(!j)return z;let ne;for(const _ of j)ne&&ne.end===_?ne.end+=1:(ne={start:_,end:_+1},z.push(ne));return z}function r(j){const z=j.sort((Y,J)=>Y.start-J.start),ne=[];let _;for(const Y of z)!_||!m(_,Y)?(_=Y,ne.push(Y)):(_.start=Math.min(_.start,Y.start),_.end=Math.max(_.end,Y.end));return ne}function m(j,z){return!(j.end<z.start||z.end<j.start)}function S(j,z,ne,_,Y,J){const Z=a(j,ne,_,Y,J),ie=a(z,ne,_,Y,J),X=Z.score,K=ie.score;if((X===p||K===p)&&X!==K)return X===p?-1:1;if(X>i||K>i){if(X!==K)return X>K?-1:1;if(X<w&&K<w){const ae=M(Z.labelMatch,ie.labelMatch);if(ae!==0)return ae}const Me=Y.getItemLabel(j)||"",oe=Y.getItemLabel(z)||"";if(Me.length!==oe.length)return Me.length-oe.length}if(X!==K)return X>K?-1:1;const he=Array.isArray(Z.labelMatch)&&Z.labelMatch.length>0,be=Array.isArray(ie.labelMatch)&&ie.labelMatch.length>0;if(he&&!be)return-1;if(be&&!he)return 1;const Ee=k(j,Z,Y),Pe=k(z,ie,Y);return Ee&&Pe&&Ee!==Pe?Pe>Ee?-1:1:q(j,z,ne,Y)}e.compareItemsByFuzzyScore=S;function k(j,z,ne){let _=-1,Y=-1;if(z.descriptionMatch&&z.descriptionMatch.length?_=z.descriptionMatch[0].start:z.labelMatch&&z.labelMatch.length&&(_=z.labelMatch[0].start),z.labelMatch&&z.labelMatch.length){if(Y=z.labelMatch[z.labelMatch.length-1].end,z.descriptionMatch&&z.descriptionMatch.length){const J=ne.getItemDescription(j);J&&(Y+=J.length)}}else z.descriptionMatch&&z.descriptionMatch.length&&(Y=z.descriptionMatch[z.descriptionMatch.length-1].end);return Y-_}function M(j,z){if(!j&&!z||(!j||!j.length)&&(!z||!z.length))return 0;if(!z||!z.length)return-1;if(!j||!j.length)return 1;const ne=j[0].start,Y=j[j.length-1].end-ne,J=z[0].start,ie=z[z.length-1].end-J;return Y===ie?0:ie<Y?1:-1}function q(j,z,ne,_){const Y=_.getItemLabel(j)||"",J=_.getItemLabel(z)||"",Z=_.getItemDescription(j),ie=_.getItemDescription(z),X=Y.length+(Z?Z.length:0),K=J.length+(ie?ie.length:0);if(X!==K)return X-K;const he=_.getItemPath(j),be=_.getItemPath(z);return he&&be&&he.length!==be.length?he.length-be.length:Y!==J?(0,o.compareAnything)(Y,J,ne.normalized):Z&&ie&&Z!==ie?(0,o.compareAnything)(Z,ie,ne.normalized):he&&be&&he!==be?(0,o.compareAnything)(he,be,ne.normalized):0}function V(j){return j.startsWith('"')&&j.endsWith('"')}const F=" ";function U(j){typeof j!="string"&&(j="");const z=j.toLowerCase(),{pathNormalized:ne,normalized:_,normalizedLowercase:Y}=N(j),J=ne.indexOf(R.sep)>=0,Z=V(j);let ie;const X=j.split(F);if(X.length>1)for(const K of X){const he=V(K),{pathNormalized:be,normalized:Ee,normalizedLowercase:Pe}=N(K);Ee&&(ie||(ie=[]),ie.push({original:K,originalLowercase:K.toLowerCase(),pathNormalized:be,normalized:Ee,normalizedLowercase:Pe,expectContiguousMatch:he}))}return{original:j,originalLowercase:z,pathNormalized:ne,normalized:_,normalizedLowercase:Y,values:ie,containsPathSeparator:J,expectContiguousMatch:Z}}e.prepareQuery=U;function N(j){let z;I.isWindows?z=j.replace(/\//g,R.sep):z=j.replace(/\\/g,R.sep);const ne=(0,A.stripWildcards)(z).replace(/\s|"/g,"");return{pathNormalized:z,normalized:ne,normalizedLowercase:ne.toLowerCase()}}function B(j){return Array.isArray(j)?U(j.map(z=>z.original).join(F)):U(j.original)}e.pieceToQuery=B}),define(ye[38],Ce([1,0,18,16,32,28,10,12,8]),function(te,e,o,t,T,R,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function D(){return Object.create(null)}e.getEmptyExpression=D,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const L="[/\\\\]",P="[^/\\\\]",v=/\//g;function C(ne,_){switch(ne){case 0:return"";case 1:return`${P}*?`;default:return`(?:${L}|${P}+${L}${_?`|${L}${P}+`:""})*?`}}function E(ne,_){if(!ne)return[];const Y=[];let J=!1,Z=!1,ie="";for(const X of ne){switch(X){case _:if(!J&&!Z){Y.push(ie),ie="";continue}break;case"{":J=!0;break;case"}":J=!1;break;case"[":Z=!0;break;case"]":Z=!1;break}ie+=X}return ie&&Y.push(ie),Y}e.splitGlobAware=E;function f(ne){if(!ne)return"";let _="";const Y=E(ne,e.GLOB_SPLIT);if(Y.every(J=>J===e.GLOBSTAR))_=".*";else{let J=!1;Y.forEach((Z,ie)=>{if(Z===e.GLOBSTAR){if(J)return;_+=C(2,ie===Y.length-1)}else{let X=!1,K="",he=!1,be="";for(const Ee of Z){if(Ee!=="}"&&X){K+=Ee;continue}if(he&&(Ee!=="]"||!be)){let Pe;Ee==="-"?Pe=Ee:(Ee==="^"||Ee==="!")&&!be?Pe="^":Ee===e.GLOB_SPLIT?Pe="":Pe=(0,y.escapeRegExpCharacters)(Ee),be+=Pe;continue}switch(Ee){case"{":X=!0;continue;case"[":he=!0;continue;case"}":{_+=`(?:${E(K,",").map(oe=>f(oe)).join("|")})`,X=!1,K="";break}case"]":{_+="["+be+"]",he=!1,be="";break}case"?":_+=P;continue;case"*":_+=C(1);continue;default:_+=(0,y.escapeRegExpCharacters)(Ee)}}ie<Y.length-1&&(Y[ie+1]!==e.GLOBSTAR||ie+2<Y.length)&&(_+=L)}J=Z===e.GLOBSTAR})}return _}const d=/^\*\*\/\*\.[\w\.-]+$/,h=/^\*\*\/([\w\.-]+)\/?$/,b=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,g=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,p=/^\*\*((\/[\w\.-]+)+)\/?$/,w=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new R.LRUCache(1e4),s=function(){return!1},a=function(){return null};function u(ne,_){if(!ne)return a;let Y;typeof ne!="string"?Y=ne.pattern:Y=ne,Y=Y.trim();const J=`${Y}_${!!_.trimForExclusions}`;let Z=i.get(J);if(Z)return l(Z,ne);let ie;return d.test(Y)?Z=n(Y.substr(4),Y):(ie=h.exec(c(Y,_)))?Z=r(ie[1],Y):(_.trimForExclusions?g:b).test(Y)?Z=m(Y,_):(ie=p.exec(c(Y,_)))?Z=S(ie[1].substr(1),Y,!0):(ie=w.exec(c(Y,_)))?Z=S(ie[1],Y,!1):Z=k(Y),i.set(J,Z),l(Z,ne)}function l(ne,_){if(typeof _=="string")return ne;const Y=function(J,Z){return(0,T.isEqualOrParent)(J,_.base,!A.isLinux)?ne((0,y.ltrim)(J.substr(_.base.length),I.sep),Z):null};return Y.allBasenames=ne.allBasenames,Y.allPaths=ne.allPaths,Y.basenames=ne.basenames,Y.patterns=ne.patterns,Y}function c(ne,_){return _.trimForExclusions&&ne.endsWith("/**")?ne.substr(0,ne.length-2):ne}function n(ne,_){return function(Y,J){return typeof Y=="string"&&Y.endsWith(ne)?_:null}}function r(ne,_){const Y=`/${ne}`,J=`\\${ne}`,Z=function(X,K){return typeof X!="string"?null:K?K===ne?_:null:X===ne||X.endsWith(Y)||X.endsWith(J)?_:null},ie=[ne];return Z.basenames=ie,Z.patterns=[_],Z.allBasenames=ie,Z}function m(ne,_){const Y=j(ne.slice(1,-1).split(",").map(K=>u(K,_)).filter(K=>K!==a),ne),J=Y.length;if(!J)return a;if(J===1)return Y[0];const Z=function(K,he){for(let be=0,Ee=Y.length;be<Ee;be++)if(Y[be](K,he))return ne;return null},ie=Y.find(K=>!!K.allBasenames);ie&&(Z.allBasenames=ie.allBasenames);const X=Y.reduce((K,he)=>he.allPaths?K.concat(he.allPaths):K,[]);return X.length&&(Z.allPaths=X),Z}function S(ne,_,Y){const J=I.sep===I.posix.sep,Z=J?ne:ne.replace(v,I.sep),ie=I.sep+Z,X=I.posix.sep+ne;let K;return Y?K=function(he,be){return typeof he=="string"&&(he===Z||he.endsWith(ie)||!J&&(he===ne||he.endsWith(X)))?_:null}:K=function(he,be){return typeof he=="string"&&(he===Z||!J&&he===ne)?_:null},K.allPaths=[(Y?"*/":"./")+ne],K}function k(ne){try{const _=new RegExp(`^${f(ne)}$`);return function(Y){return _.lastIndex=0,typeof Y=="string"&&_.test(Y)?ne:null}}catch{return a}}function M(ne,_,Y){return!ne||typeof _!="string"?!1:q(ne)(_,void 0,Y)}e.match=M;function q(ne,_={}){if(!ne)return s;if(typeof ne=="string"||V(ne)){const Y=u(ne,_);if(Y===a)return s;const J=function(Z,ie){return!!Y(Z,ie)};return Y.allBasenames&&(J.allBasenames=Y.allBasenames),Y.allPaths&&(J.allPaths=Y.allPaths),J}return N(ne,_)}e.parse=q;function V(ne){const _=ne;return _?typeof _.base=="string"&&typeof _.pattern=="string":!1}e.isRelativePattern=V;function F(ne){return ne.allBasenames||[]}e.getBasenameTerms=F;function U(ne){return ne.allPaths||[]}e.getPathTerms=U;function N(ne,_){const Y=j(Object.getOwnPropertyNames(ne).map(K=>B(K,ne[K],_)).filter(K=>K!==a)),J=Y.length;if(!J)return a;if(!Y.some(K=>!!K.requiresSiblings)){if(J===1)return Y[0];const K=function(Ee,Pe){let Me;for(let oe=0,ae=Y.length;oe<ae;oe++){const fe=Y[oe](Ee,Pe);if(typeof fe=="string")return fe;(0,t.isThenable)(fe)&&(Me||(Me=[]),Me.push(fe))}return Me?(async()=>{for(const oe of Me){const ae=await oe;if(typeof ae=="string")return ae}return null})():null},he=Y.find(Ee=>!!Ee.allBasenames);he&&(K.allBasenames=he.allBasenames);const be=Y.reduce((Ee,Pe)=>Pe.allPaths?Ee.concat(Pe.allPaths):Ee,[]);return be.length&&(K.allPaths=be),K}const Z=function(K,he,be){let Ee,Pe;for(let Me=0,oe=Y.length;Me<oe;Me++){const ae=Y[Me];ae.requiresSiblings&&be&&(he||(he=(0,I.basename)(K)),Ee||(Ee=he.substr(0,he.length-(0,I.extname)(K).length)));const fe=ae(K,he,Ee,be);if(typeof fe=="string")return fe;(0,t.isThenable)(fe)&&(Pe||(Pe=[]),Pe.push(fe))}return Pe?(async()=>{for(const Me of Pe){const oe=await Me;if(typeof oe=="string")return oe}return null})():null},ie=Y.find(K=>!!K.allBasenames);ie&&(Z.allBasenames=ie.allBasenames);const X=Y.reduce((K,he)=>he.allPaths?K.concat(he.allPaths):K,[]);return X.length&&(Z.allPaths=X),Z}function B(ne,_,Y){if(_===!1)return a;const J=u(ne,Y);if(J===a)return a;if(typeof _=="boolean")return J;if(_){const Z=_.when;if(typeof Z=="string"){const ie=(X,K,he,be)=>{if(!be||!J(X,K))return null;const Ee=Z.replace("$(basename)",()=>he),Pe=be(Ee);return(0,t.isThenable)(Pe)?Pe.then(Me=>Me?ne:null):Pe?ne:null};return ie.requiresSiblings=!0,ie}}return J}function j(ne,_){const Y=ne.filter(K=>!!K.basenames);if(Y.length<2)return ne;const J=Y.reduce((K,he)=>{const be=he.basenames;return be?K.concat(be):K},[]);let Z;if(_){Z=[];for(let K=0,he=J.length;K<he;K++)Z.push(_)}else Z=Y.reduce((K,he)=>{const be=he.patterns;return be?K.concat(be):K},[]);const ie=function(K,he){if(typeof K!="string")return null;if(!he){let Ee;for(Ee=K.length;Ee>0;Ee--){const Pe=K.charCodeAt(Ee-1);if(Pe===47||Pe===92)break}he=K.substr(Ee)}const be=J.indexOf(he);return be!==-1?Z[be]:null};ie.basenames=J,ie.patterns=Z,ie.allBasenames=J;const X=ne.filter(K=>!K.basenames);return X.push(ie),X}function z(ne,_){return(0,o.equals)(ne,_,(Y,J)=>typeof Y=="string"&&typeof J=="string"?Y===J:typeof Y!="string"&&typeof J!="string"?Y.base===J.base&&Y.pattern===J.pattern:!1)}e.patternsEquals=z}),define(ye[111],Ce([1,0,9,162,24,8,2]),function(te,e,o,t,T,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var A;(function(d){d[d.Paragraph=0]="Paragraph",d[d.Break=1]="Break"})(A=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(h="",b=!1){if(this.value=h,typeof this.value!="string")throw(0,o.illegalArgument)("value");typeof b=="boolean"?(this.isTrusted=b,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=b.isTrusted??void 0,this.supportThemeIcons=b.supportThemeIcons??!1,this.supportHtml=b.supportHtml??!1)}appendText(h,b=0){return this.value+=v(this.supportThemeIcons?(0,t.escapeIcons)(h):h).replace(/([ \t]+)/g,(g,p)=>"&nbsp;".repeat(p.length)).replace(/\>/gm,"\\>").replace(/\n/g,b===1?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,b){return this.value+="\n```",this.value+=h,this.value+=`
`,this.value+=b,this.value+="\n```\n",this}appendLink(h,b,g){return this.value+="[",this.value+=this.c(b,"]"),this.value+="](",this.value+=this.c(String(h),")"),g&&(this.value+=` "${this.c(this.c(g,'"'),")")}"`),this.value+=")",this}c(h,b){const g=new RegExp((0,R.escapeRegExpCharacters)(b),"g");return h.replace(g,(p,w)=>h.charAt(w-1)!=="\\"?`\\${p}`:p)}}e.MarkdownString=y;function D(d){return L(d)?!d.value:Array.isArray(d)?d.every(D):!0}e.isEmptyMarkdownString=D;function L(d){return d instanceof y?!0:d&&typeof d=="object"?typeof d.value=="string"&&(typeof d.isTrusted=="boolean"||d.isTrusted===void 0)&&(typeof d.supportThemeIcons=="boolean"||d.supportThemeIcons===void 0):!1}e.isMarkdownString=L;function P(d,h){return d===h?!0:!d||!h?!1:d.value===h.value&&d.isTrusted===h.isTrusted&&d.supportThemeIcons===h.supportThemeIcons&&d.supportHtml===h.supportHtml&&(d.baseUri===h.baseUri||!!d.baseUri&&!!h.baseUri&&(0,T.isEqual)(I.URI.from(d.baseUri),I.URI.from(h.baseUri)))}e.markdownStringEqual=P;function v(d){return d.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=v;function C(d){return d.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=C;function E(d){return d&&d.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=E;function f(d){const h=[],b=d.split("|").map(p=>p.trim());d=b[0];const g=b[1];if(g){const p=/height=(\d+)/.exec(g),w=/width=(\d+)/.exec(g),i=p?p[1]:"",s=w?w[1]:"",a=isFinite(parseInt(s)),u=isFinite(parseInt(i));a&&h.push(`width="${s}"`),u&&h.push(`height="${i}"`)}return{href:d,dimensions:h}}e.parseHrefAndDimensions=f}),define(ye[112],Ce([1,0,18,32,10,12,24,8]),function(te,e,o,t,T,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function y(a,u){const{os:l,tildify:c,relative:n}=u;if(n){const S=D(a,n,l);if(typeof S=="string")return S}let r=a.fsPath;if(l===1&&!R.isWindows?r=r.replace(/\//g,"\\"):l!==1&&R.isWindows&&(r=r.replace(/\\/g,"/")),l!==1&&c?.userHome){const S=c.userHome.fsPath;let k;a.scheme!==c.userHome.scheme&&a.path.startsWith(T.posix.sep)?k=c.userHome.with({path:a.path}).fsPath:k=a.fsPath,r=v(k,S,l)}return(l===1?T.win32:T.posix).normalize(L(r,l===1))}e.getPathLabel=y;function D(a,u,l){const c=l===1?T.win32:T.posix,n=l===3?I.extUri:I.extUriIgnorePathCase,r=u.getWorkspace(),m=(0,o.firstOrDefault)(r.folders);if(!m)return;a.scheme!==m.uri.scheme&&a.path.startsWith(T.posix.sep)&&(a=m.uri.with({path:a.path}));const S=u.getWorkspaceFolder(a);if(!S)return;let k;if(n.isEqual(S.uri,a)?k="":k=n.relativePath(S.uri,a)??"",k&&(k=c.normalize(k)),r.folders.length>1&&!u.noPrefix){const M=S.name?S.name:n.basenameOrAuthority(S.uri);k=k?`${M} \u2022 ${k}`:M}return k}function L(a,u=R.isWindows){return(0,t.hasDriveLetter)(a,u)?a.charAt(0).toUpperCase()+a.slice(1):a}e.normalizeDriveLetter=L;let P=Object.create(null);function v(a,u,l=R.OS){if(l===1||!a||!u)return a;let c=P.original===u?P.normalized:void 0;c||(c=u,R.isWindows&&(c=(0,t.toSlashes)(c)),c=`${(0,A.rtrim)(c,T.posix.sep)}${T.posix.sep}`,P={original:u,normalized:c});let n=a;return R.isWindows&&(n=(0,t.toSlashes)(n)),(l===3?n.startsWith(c):(0,A.startsWithIgnoreCase)(n,c))?`~/${n.substr(c.length)}`:a}e.tildify=v;function C(a,u){return a.replace(/^~($|\/|\\)/,`${u}$1`)}e.untildify=C;const E="\u2026",f="\\\\",d="~";function h(a,u=T.sep){const l=new Array(a.length);let c=!1;for(let n=0;n<a.length;n++){const r=a[n];if(r===""){l[n]=`.${u}`;continue}if(!r){l[n]=r;continue}c=!0;let m="",S=r;S.indexOf(f)===0?(m=S.substr(0,S.indexOf(f)+f.length),S=S.substr(S.indexOf(f)+f.length)):S.indexOf(u)===0?(m=S.substr(0,S.indexOf(u)+u.length),S=S.substr(S.indexOf(u)+u.length)):S.indexOf(d)===0&&(m=S.substr(0,S.indexOf(d)+d.length),S=S.substr(S.indexOf(d)+d.length));const k=S.split(u);for(let M=1;c&&M<=k.length;M++)for(let q=k.length-M;c&&q>=0;q--){c=!1;let V=k.slice(q,q+M).join(u);for(let F=0;!c&&F<a.length;F++)if(F!==n&&a[F]&&a[F].indexOf(V)>-1){const U=q+M===k.length,N=q>0&&a[F].indexOf(u)>-1?u+V:V,B=a[F].endsWith(N);c=!U||B}if(!c){let F="";(k[0].endsWith(":")||m!=="")&&(q===1&&(q=0,M++,V=k[0]+u+V),q>0&&(F=k[0]+u),F=m+F),q>0&&(F=F+E+u),F=F+V,q+M<k.length&&(F=F+u+E),l[n]=F}}c&&(l[n]=r)}return l}e.shorten=h;var b;(function(a){a[a.TEXT=0]="TEXT",a[a.VARIABLE=1]="VARIABLE",a[a.SEPARATOR=2]="SEPARATOR"})(b||(b={}));function g(a,u=Object.create(null)){const l=[];let c=!1,n="";for(const r of a)if(r==="$"||c&&r==="{")n&&l.push({value:n,type:b.TEXT}),n="",c=!0;else if(r==="}"&&c){const m=u[n];if(typeof m=="string")m.length&&l.push({value:m,type:b.VARIABLE});else if(m){const S=l[l.length-1];(!S||S.type!==b.SEPARATOR)&&l.push({value:m.label,type:b.SEPARATOR})}n="",c=!1}else n+=r;return n&&!c&&l.push({value:n,type:b.TEXT}),l.filter((r,m)=>{if(r.type===b.SEPARATOR){const S=l[m-1],k=l[m+1];return[S,k].every(M=>M&&(M.type===b.VARIABLE||M.type===b.TEXT)&&M.value.length>0)}return!0}).map(r=>r.value).join("")}e.template=g;function p(a,u){return R.isMacintosh||u?a.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):a.replace(/&&|&/g,l=>l==="&"?"&&":"&")}e.mnemonicMenuLabel=p;function w(a,u){return R.isMacintosh||u?a.replace(/\(&&\w\)|&&/g,""):R.isWindows?a.replace(/&&|&/g,l=>l==="&"?"&&":"&"):a.replace(/&&/g,"_")}e.mnemonicButtonLabel=w;function i(a){return a.replace(/&/g,"&&")}e.unmnemonicLabel=i;function s(a){const u=a.indexOf("/")!==-1?T.posix:T.win32,l=u.basename(a),c=u.dirname(a);return l.length?{name:l,parentPath:c}:{name:c,parentPath:""}}e.splitName=s}),define(ye[113],Ce([1,0,2]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(L){return L.toJSON()}class T{constructor(P){this.a=P}transformIncoming(P){const v=this.a.transformIncoming(P);return v===P?P:t(o.URI.from(v))}transformOutgoing(P){const v=this.a.transformOutgoing(P);return v===P?P:t(o.URI.from(v))}transformOutgoingURI(P){const v=this.a.transformOutgoing(P);return v===P?P:o.URI.from(v)}transformOutgoingScheme(P){return this.a.transformOutgoingScheme(P)}}e.URITransformer=T,e.DefaultURITransformer=new class{transformIncoming(L){return L}transformOutgoing(L){return L}transformOutgoingURI(L){return L}transformOutgoingScheme(L){return L}};function R(L,P,v){if(!L||v>200)return null;if(typeof L=="object"){if(L instanceof o.URI)return P.transformOutgoing(L);for(const C in L)if(Object.hasOwnProperty.call(L,C)){const E=R(L[C],P,v+1);E!==null&&(L[C]=E)}}return null}function I(L,P){const v=R(L,P,0);return v===null?L:v}e.transformOutgoingURIs=I;function A(L,P,v,C){if(!L||C>200)return null;if(typeof L=="object"){if(L.$mid===1)return v?o.URI.revive(P.transformIncoming(L)):P.transformIncoming(L);for(const E in L)if(Object.hasOwnProperty.call(L,E)){const f=A(L[E],P,v,C+1);f!==null&&(L[E]=f)}}return null}function y(L,P){const v=A(L,P,!1,0);return v===null?L:v}e.transformIncomingURIs=y;function D(L,P){const v=A(L,P,!0,0);return v===null?L:v}e.transformAndReviveIncomingURIs=D}),define(ye[29],Ce([1,0,65,87,311,16,32,83,10,12,24,2]),function(te,e,o,t,T,R,I,A,y,D,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var v;(function(N){N[N.UNLINK=0]="UNLINK",N[N.MOVE=1]="MOVE"})(v=e.RimRafMode||(e.RimRafMode={}));async function C(N,B=v.UNLINK){if((0,I.isRootOrDriveLetter)(N))throw new Error("rimraf - will refuse to recursively delete root");return B===v.UNLINK?f(N):E(N)}async function E(N){try{const B=(0,I.randomPath)((0,t.tmpdir)());try{await o.promises.rename(N,B)}catch(j){return j.code==="ENOENT"?void 0:f(N)}f(B).catch(j=>{})}catch(B){if(B.code!=="ENOENT")throw B}}async function f(N){return(0,T.promisify)(o.rm)(N,{recursive:!0,force:!0,maxRetries:3})}function d(N){if((0,I.isRootOrDriveLetter)(N))throw new Error("rimraf - will refuse to recursively delete root");o.rmSync(N,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=d;async function h(N,B){return p(await(B?b(N):(0,T.promisify)(o.readdir)(N)))}async function b(N){try{return await(0,T.promisify)(o.readdir)(N,{withFileTypes:!0})}catch(z){console.warn("[node.js fs] readdir with filetypes failed with error: ",z)}const B=[],j=await h(N);for(const z of j){let ne=!1,_=!1,Y=!1;try{const J=await e.Promises.lstat((0,y.join)(N,z));ne=J.isFile(),_=J.isDirectory(),Y=J.isSymbolicLink()}catch(J){console.warn("[node.js fs] unexpected error from lstat after readdir: ",J)}B.push({name:z,isFile:()=>ne,isDirectory:()=>_,isSymbolicLink:()=>Y})}return B}function g(N){return p(o.readdirSync(N))}e.readdirSync=g;function p(N){return N.map(B=>typeof B=="string"?D.isMacintosh?(0,A.normalizeNFC)(B):B:(B.name=D.isMacintosh?(0,A.normalizeNFC)(B.name):B.name,B))}async function w(N){const B=await h(N),j=[];for(const z of B)await s.existsDirectory((0,y.join)(N,z))&&j.push(z);return j}function i(N,B=1e3){return new Promise(j=>{let z=!1;const ne=setInterval(()=>{z||(z=!0,o.access(N,_=>{z=!1,_&&(clearInterval(ne),j(void 0))}))},B)})}e.whenDeleted=i;var s;(function(N){async function B(ne){let _;try{if(_=await e.Promises.lstat(ne),!_.isSymbolicLink())return{stat:_}}catch{}try{return{stat:await e.Promises.stat(ne),symbolicLink:_?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Y){if(Y.code==="ENOENT"&&_)return{stat:_,symbolicLink:{dangling:!0}};if(D.isWindows&&Y.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(ne)),symbolicLink:{dangling:!1}}}catch(J){if(J.code==="ENOENT"&&_)return{stat:_,symbolicLink:{dangling:!0}};throw J}throw Y}}N.stat=B;async function j(ne){try{const{stat:_,symbolicLink:Y}=await N.stat(ne);return _.isFile()&&Y?.dangling!==!0}catch{}return!1}N.existsFile=j;async function z(ne){try{const{stat:_,symbolicLink:Y}=await N.stat(ne);return _.isDirectory()&&Y?.dangling!==!0}catch{}return!1}N.existsDirectory=z})(s=e.SymlinkSupport||(e.SymlinkSupport={}));const a=new R.ResourceQueue;function u(N,B,j){return a.queueFor(P.URI.file(N),L.extUriBiasedIgnorePathCase).queue(()=>{const z=m(j);return new Promise((ne,_)=>n(N,B,z,Y=>Y?_(Y):ne()))})}let l=!0;function c(N){l=N}e.configureFlushOnWrite=c;function n(N,B,j,z){if(!l)return o.writeFile(N,B,{mode:j.mode,flag:j.flag},z);o.open(N,j.flag,j.mode,(ne,_)=>{if(ne)return z(ne);o.writeFile(_,B,Y=>{if(Y)return o.close(_,()=>z(Y));o.fdatasync(_,J=>(J&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",J),c(!1)),o.close(_,Z=>z(Z))))})})}function r(N,B,j){const z=m(j);if(!l)return o.writeFileSync(N,B,{mode:z.mode,flag:z.flag});const ne=o.openSync(N,z.flag,z.mode);try{o.writeFileSync(ne,B);try{o.fdatasyncSync(ne)}catch(_){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",_),c(!1)}}finally{o.closeSync(ne)}}e.writeFileSync=r;function m(N){return N?{mode:typeof N.mode=="number"?N.mode:438,flag:typeof N.flag=="string"?N.flag:"w"}:{mode:438,flag:"w"}}async function S(N,B){if(N!==B)try{await e.Promises.rename(N,B)}catch(j){if(N.toLowerCase()!==B.toLowerCase()&&j.code==="EXDEV"||N.endsWith("."))await k(N,B,{preserveSymlinks:!1}),await C(N,v.MOVE);else throw j}}async function k(N,B,j){return q(N,B,{root:{source:N,target:B},options:j,handledSourcePaths:new Set})}const M=511;async function q(N,B,j){if(j.handledSourcePaths.has(N))return;j.handledSourcePaths.add(N);const{stat:z,symbolicLink:ne}=await s.stat(N);if(ne){if(j.options.preserveSymlinks)try{return await U(N,B,j)}catch(_){console.warn("[node.js fs] copy of symlink failed: ",_)}if(ne.dangling)return}return z.isDirectory()?V(N,B,z.mode&M,j):F(N,B,z.mode&M)}async function V(N,B,j,z){await e.Promises.mkdir(B,{recursive:!0,mode:j});const ne=await h(N);for(const _ of ne)await q((0,y.join)(N,_),(0,y.join)(B,_),z)}async function F(N,B,j){await e.Promises.copyFile(N,B),await e.Promises.chmod(B,j)}async function U(N,B,j){let z=await e.Promises.readlink(N);(0,I.isEqualOrParent)(z,j.root.source,!D.isLinux)&&(z=(0,y.join)(j.root.target,z.substr(j.root.source.length+1))),await e.Promises.symlink(z,B)}e.Promises=new class{get access(){return(0,T.promisify)(o.access)}get stat(){return(0,T.promisify)(o.stat)}get lstat(){return(0,T.promisify)(o.lstat)}get utimes(){return(0,T.promisify)(o.utimes)}get read(){return(N,B,j,z,ne)=>new Promise((_,Y)=>{o.read(N,B,j,z,ne,(J,Z,ie)=>J?Y(J):_({bytesRead:Z,buffer:ie}))})}get readFile(){return(0,T.promisify)(o.readFile)}get write(){return(N,B,j,z,ne)=>new Promise((_,Y)=>{o.write(N,B,j,z,ne,(J,Z,ie)=>J?Y(J):_({bytesWritten:Z,buffer:ie}))})}get appendFile(){return(0,T.promisify)(o.appendFile)}get fdatasync(){return(0,T.promisify)(o.fdatasync)}get truncate(){return(0,T.promisify)(o.truncate)}get rename(){return(0,T.promisify)(o.rename)}get copyFile(){return(0,T.promisify)(o.copyFile)}get open(){return(0,T.promisify)(o.open)}get close(){return(0,T.promisify)(o.close)}get symlink(){return(0,T.promisify)(o.symlink)}get readlink(){return(0,T.promisify)(o.readlink)}get chmod(){return(0,T.promisify)(o.chmod)}get mkdir(){return(0,T.promisify)(o.mkdir)}get unlink(){return(0,T.promisify)(o.unlink)}get rmdir(){return(0,T.promisify)(o.rmdir)}get realpath(){return(0,T.promisify)(o.realpath)}async exists(N){try{return await e.Promises.access(N),!0}catch{return!1}}get readdir(){return h}get readDirsInDir(){return w}get writeFile(){return u}get rm(){return C}get move(){return S}get copy(){return k}}}),define(ye[114],Ce([1,0,65,10,12,8,29]),function(te,e,o,t,T,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function A(v){if(T.isLinux)return v;const C=(0,t.dirname)(v);if(v===C)return v;const E=((0,t.basename)(v)||v).toLowerCase();try{const d=(0,I.readdirSync)(C).filter(h=>h.toLowerCase()===E);if(d.length===1){const h=A(C);if(h)return(0,t.join)(h,d[0])}else if(d.length>1){const h=d.indexOf(E);if(h>=0){const b=A(C);if(b)return(0,t.join)(b,d[h])}}}catch{}return null}e.realcaseSync=A;async function y(v){if(T.isLinux)return v;const C=(0,t.dirname)(v);if(v===C)return v;const E=((0,t.basename)(v)||v).toLowerCase();try{const d=(await I.Promises.readdir(C)).filter(h=>h.toLowerCase()===E);if(d.length===1){const h=await y(C);if(h)return(0,t.join)(h,d[0])}else if(d.length>1){const h=d.indexOf(E);if(h>=0){const b=await y(C);if(b)return(0,t.join)(b,d[h])}}}catch{}return null}e.realcase=y;async function D(v){try{return await I.Promises.realpath(v)}catch{const E=P(v);return await I.Promises.access(E,o.constants.R_OK),E}}e.realpath=D;function L(v){try{return o.realpathSync(v)}catch{const E=P(v);return o.accessSync(E,o.constants.R_OK),E}}e.realpathSync=L;function P(v){return(0,R.rtrim)((0,t.normalize)(v),t.sep)}}),define(ye[115],Ce([1,0,10,12,36,107,11,29]),function(te,e,o,t,T,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function y(P=T.env){return P.comspec||"cmd.exe"}e.getWindowsShell=y;function D(P){let v=[],C=!1;const E=function(f){if(C){v.push(f);return}(!P.send(f,h=>{if(h&&console.error(h),C=!1,v.length>0){const b=v.slice(0);v=[],b.forEach(g=>E(g))}})||t.isWindows)&&(C=!0)};return{send:E}}e.createQueuedSender=D;var L;(function(P){async function v(C,E,f){if(o.isAbsolute(C))return C;if(E===void 0&&(E=T.cwd()),o.dirname(C)!=="."||(f===void 0&&I.isString(T.env.PATH)&&(f=T.env.PATH.split(o.delimiter)),f===void 0||f.length===0))return o.join(E,C);async function h(b){if(await A.Promises.exists(b)){let g;try{g=await A.Promises.stat(b)}catch(p){p.message.startsWith("EACCES")&&(g=await A.Promises.lstat(b))}return g?!g.isDirectory():!1}return!1}for(const b of f){let g;if(o.isAbsolute(b)?g=o.join(b,C):g=o.join(E,b,C),await h(g))return g;let p=g+".com";if(await h(p)||(p=g+".exe",await h(p)))return p}return o.join(E,C)}P.findExecutable=v})(L=e.win32||(e.win32={}))});var qe=this&&this.__decorate||function(te,e,o,t){var T=arguments.length,R=T<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,o):t,I;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(te,e,o,t);else for(var A=te.length-1;A>=0;A--)(I=te[A])&&(R=(T<3?I(R):T>3?I(e,o,R):I(e,o))||R);return T>3&&R&&Object.defineProperty(e,o,R),R};define(ye[116],Ce([1,0,18,16,22,21,60,9,3,6,86,8,11]),function(te,e,o,t,T,R,I,A,y,D,L,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var C;(function(_){_[_.Promise=100]="Promise",_[_.PromiseCancel=101]="PromiseCancel",_[_.EventListen=102]="EventListen",_[_.EventDispose=103]="EventDispose"})(C||(C={}));function E(_){switch(_){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var f;(function(_){_[_.Initialize=200]="Initialize",_[_.PromiseSuccess=201]="PromiseSuccess",_[_.PromiseError=202]="PromiseError",_[_.PromiseErrorObj=203]="PromiseErrorObj",_[_.EventFire=204]="EventFire"})(f||(f={}));function d(_){switch(_){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function(_){_[_.Uninitialized=0]="Uninitialized",_[_.Idle=1]="Idle"})(h||(h={}));function b(_){let Y=0;for(let J=0;;J+=7){const Z=_.read(1);if(Y|=(Z.buffer[0]&127)<<J,!(Z.buffer[0]&128))return Y}}const g=a(0);function p(_,Y){if(Y===0){_.write(g);return}let J=0;for(let ie=Y;ie!==0;ie=ie>>>7)J++;const Z=T.VSBuffer.alloc(J);for(let ie=0;Y!==0;ie++)Z.buffer[ie]=Y&127,Y=Y>>>7,Y>0&&(Z.buffer[ie]|=128);_.write(Z)}class w{constructor(Y){this.b=Y,this.a=0}read(Y){const J=this.b.slice(this.a,this.a+Y);return this.a+=J.byteLength,J}}e.BufferReader=w;class i{constructor(){this.a=[]}get buffer(){return T.VSBuffer.concat(this.a)}write(Y){this.a.push(Y)}}e.BufferWriter=i;var s;(function(_){_[_.Undefined=0]="Undefined",_[_.String=1]="String",_[_.Buffer=2]="Buffer",_[_.VSBuffer=3]="VSBuffer",_[_.Array=4]="Array",_[_.Object=5]="Object",_[_.Int=6]="Int"})(s||(s={}));function a(_){const Y=T.VSBuffer.alloc(1);return Y.writeUInt8(_,0),Y}const u={Undefined:a(s.Undefined),String:a(s.String),Buffer:a(s.Buffer),VSBuffer:a(s.VSBuffer),Array:a(s.Array),Object:a(s.Object),Uint:a(s.Int)},l=typeof Buffer<"u";function c(_,Y){if(typeof Y>"u")_.write(u.Undefined);else if(typeof Y=="string"){const J=T.VSBuffer.fromString(Y);_.write(u.String),p(_,J.byteLength),_.write(J)}else if(l&&Buffer.isBuffer(Y)){const J=T.VSBuffer.wrap(Y);_.write(u.Buffer),p(_,J.byteLength),_.write(J)}else if(Y instanceof T.VSBuffer)_.write(u.VSBuffer),p(_,Y.byteLength),_.write(Y);else if(Array.isArray(Y)){_.write(u.Array),p(_,Y.length);for(const J of Y)c(_,J)}else if(typeof Y=="number"&&(Y|0)===Y)_.write(u.Uint),p(_,Y);else{const J=T.VSBuffer.fromString(JSON.stringify(Y));_.write(u.Object),p(_,J.byteLength),_.write(J)}}e.serialize=c;function n(_){switch(_.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return _.read(b(_)).toString();case s.Buffer:return _.read(b(_)).buffer;case s.VSBuffer:return _.read(b(_));case s.Array:{const J=b(_),Z=[];for(let ie=0;ie<J;ie++)Z.push(n(_));return Z}case s.Object:return JSON.parse(_.read(b(_)).toString());case s.Int:return b(_)}}e.deserialize=n;class r{constructor(Y,J,Z=null,ie=1e3){this.h=Y,this.j=J,this.k=Z,this.l=ie,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(X=>this.q(X)),this.m({type:200})}registerChannel(Y,J){this.b.set(Y,J),setTimeout(()=>this.w(Y),0)}m(Y){switch(Y.type){case 200:{const J=this.o([Y.type]);this.k?.logOutgoing(J,0,1,d(Y.type));return}case 201:case 202:case 204:case 203:{const J=this.o([Y.type,Y.id],Y.data);this.k?.logOutgoing(J,Y.id,1,d(Y.type),Y.data);return}}}o(Y,J=void 0){const Z=new i;return c(Z,Y),c(Z,J),this.p(Z.buffer)}p(Y){try{return this.h.send(Y),Y.byteLength}catch{return 0}}q(Y){const J=new w(Y),Z=n(J),ie=n(J),X=Z[0];switch(X){case 100:return this.k?.logIncoming(Y.byteLength,Z[1],1,`${E(X)}: ${Z[2]}.${Z[3]}`,ie),this.s({type:X,id:Z[1],channelName:Z[2],name:Z[3],arg:ie});case 102:return this.k?.logIncoming(Y.byteLength,Z[1],1,`${E(X)}: ${Z[2]}.${Z[3]}`,ie),this.t({type:X,id:Z[1],channelName:Z[2],name:Z[3],arg:ie});case 101:return this.k?.logIncoming(Y.byteLength,Z[1],1,`${E(X)}`),this.u({type:X,id:Z[1]});case 103:return this.k?.logIncoming(Y.byteLength,Z[1],1,`${E(X)}`),this.u({type:X,id:Z[1]})}}s(Y){const J=this.b.get(Y.channelName);if(!J){this.v(Y);return}const Z=new R.CancellationTokenSource;let ie;try{ie=J.call(this.j,Y.name,Y.arg,Z.token)}catch(he){ie=Promise.reject(he)}const X=Y.id;ie.then(he=>{this.m({id:X,data:he,type:201}),this.d.delete(Y.id)},he=>{he instanceof Error?this.m({id:X,data:{message:he.message,name:he.name,stack:he.stack?he.stack.split?he.stack.split(`
`):he.stack:void 0},type:202}):this.m({id:X,data:he,type:203}),this.d.delete(Y.id)});const K=(0,D.toDisposable)(()=>Z.cancel());this.d.set(Y.id,K)}t(Y){const J=this.b.get(Y.channelName);if(!J){this.v(Y);return}const Z=Y.id,X=J.listen(this.j,Y.name,Y.arg)(K=>this.m({id:Z,data:K,type:204}));this.d.set(Y.id,X)}u(Y){const J=this.d.get(Y.id);J&&(J.dispose(),this.d.delete(Y.id))}v(Y){let J=this.g.get(Y.channelName);J||(J=[],this.g.set(Y.channelName,J));const Z=setTimeout(()=>{console.error(`Unknown channel: ${Y.channelName}`),Y.type===100&&this.m({id:Y.id,data:{name:"Unknown channel",message:`Channel name '${Y.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);J.push({request:Y,timeoutTimer:Z})}w(Y){const J=this.g.get(Y);if(J){for(const Z of J)switch(clearTimeout(Z.timeoutTimer),Z.request.type){case 100:this.s(Z.request);break;case 102:this.t(Z.request);break}this.g.delete(Y)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,D.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=r;var m;(function(_){_[_.LocalSide=0]="LocalSide",_[_.OtherSide=1]="OtherSide"})(m=e.RequestInitiator||(e.RequestInitiator={}));class S{constructor(Y,J=null){this.l=Y,this.a=!1,this.b=h.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new y.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(Z=>this.s(Z)),this.j=J}getChannel(Y){const J=this;return{call(Z,ie,X){return J.a?Promise.reject(new A.CancellationError):J.m(Y,Z,ie,X)},listen(Z,ie){return J.a?y.Event.None:J.o(Y,Z,ie)}}}m(Y,J,Z,ie=R.CancellationToken.None){const X=this.g++,he={id:X,type:100,channelName:Y,name:J,arg:Z};if(ie.isCancellationRequested)return Promise.reject(new A.CancellationError);let be;return new Promise((Pe,Me)=>{if(ie.isCancellationRequested)return Me(new A.CancellationError);const oe=()=>{const le=re=>{switch(re.type){case 201:this.f.delete(X),Pe(re.data);break;case 202:{this.f.delete(X);const O=new Error(re.data.message);O.stack=Array.isArray(re.data.stack)?re.data.stack.join(`
`):re.data.stack,O.name=re.data.name,Me(O);break}case 203:this.f.delete(X),Me(re.data);break}};this.f.set(X,le),this.p(he)};let ae=null;this.b===h.Idle?oe():(ae=(0,t.createCancelablePromise)(le=>this.u()),ae.then(()=>{ae=null,oe()}));const fe=()=>{ae?(ae.cancel(),ae=null):this.p({id:X,type:101}),Me(new A.CancellationError)},ee=ie.onCancellationRequested(fe);be=(0,D.combinedDisposable)((0,D.toDisposable)(fe),ee),this.d.add(be)}).finally(()=>{this.d.delete(be)})}o(Y,J,Z){const ie=this.g++,K={id:ie,type:102,channelName:Y,name:J,arg:Z};let he=null;const be=new y.Emitter({onWillAddFirstListener:()=>{he=(0,t.createCancelablePromise)(Pe=>this.u()),he.then(()=>{he=null,this.d.add(be),this.p(K)})},onDidRemoveLastListener:()=>{he?(he.cancel(),he=null):(this.d.delete(be),this.p({id:ie,type:103}))}}),Ee=Pe=>be.fire(Pe.data);return this.f.set(ie,Ee),be.event}p(Y){switch(Y.type){case 100:case 102:{const J=this.q([Y.type,Y.id,Y.channelName,Y.name],Y.arg);this.j?.logOutgoing(J,Y.id,0,`${E(Y.type)}: ${Y.channelName}.${Y.name}`,Y.arg);return}case 101:case 103:{const J=this.q([Y.type,Y.id]);this.j?.logOutgoing(J,Y.id,0,E(Y.type));return}}}q(Y,J=void 0){const Z=new i;return c(Z,Y),c(Z,J),this.r(Z.buffer)}r(Y){try{return this.l.send(Y),Y.byteLength}catch{return 0}}s(Y){const J=new w(Y),Z=n(J),ie=n(J),X=Z[0];switch(X){case 200:return this.j?.logIncoming(Y.byteLength,0,0,d(X)),this.t({type:Z[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(Y.byteLength,Z[1],0,d(X),ie),this.t({type:Z[0],id:Z[1],data:ie})}}t(Y){if(Y.type===200){this.b=h.Idle,this.k.fire();return}this.f.get(Y.id)?.(Y)}get onDidInitializePromise(){return y.Event.toPromise(this.onDidInitialize)}u(){return this.b===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,D.dispose)(this.d.values()),this.d.clear()}}qe([I.memoize],S.prototype,"onDidInitializePromise",null),e.ChannelClient=S;class k{get connections(){const Y=[];return this.f.forEach(J=>Y.push(J)),Y}constructor(Y){this.a=new Map,this.f=new Set,this.g=new y.Emitter,this.onDidAddConnection=this.g.event,this.h=new y.Emitter,this.onDidRemoveConnection=this.h.event,Y(({protocol:J,onDidClientDisconnect:Z})=>{y.Event.once(J.onMessage)(X=>{const K=new w(X),he=n(K),be=new r(J,he),Ee=new S(J);this.a.forEach((Me,oe)=>be.registerChannel(oe,Me));const Pe={channelServer:be,channelClient:Ee,ctx:he};this.f.add(Pe),this.g.fire(Pe),Z(()=>{be.dispose(),Ee.dispose(),this.f.delete(Pe),this.h.fire(Pe)})})})}getChannel(Y,J){const Z=this;return{call(ie,X,K){let he;if((0,v.isFunction)(J)){const Ee=(0,o.getRandomElement)(Z.connections.filter(J));he=Ee?Promise.resolve(Ee):y.Event.toPromise(y.Event.filter(Z.onDidAddConnection,J))}else he=J.routeCall(Z,ie,X);const be=he.then(Ee=>Ee.channelClient.getChannel(Y));return q(be).call(ie,X,K)},listen(ie,X){if((0,v.isFunction)(J))return Z.j(Y,J,ie,X);const K=J.routeEvent(Z,ie,X).then(he=>he.channelClient.getChannel(Y));return q(K).listen(ie,X)}}}j(Y,J,Z,ie){const X=this;let K=new D.DisposableStore;const he=new y.Emitter({onWillAddFirstListener:()=>{K=new D.DisposableStore;const be=new y.EventMultiplexer,Ee=new Map,Pe=oe=>{const fe=oe.channelClient.getChannel(Y).listen(Z,ie),ee=be.add(fe);Ee.set(oe,ee)},Me=oe=>{const ae=Ee.get(oe);!ae||(ae.dispose(),Ee.delete(oe))};X.connections.filter(J).forEach(Pe),y.Event.filter(X.onDidAddConnection,J)(Pe,void 0,K),X.onDidRemoveConnection(Me,void 0,K),be.event(he.fire,he,K),K.add(be)},onDidRemoveLastListener:()=>{K.dispose()}});return he.event}registerChannel(Y,J){this.a.set(Y,J),this.f.forEach(Z=>{Z.channelServer.registerChannel(Y,J)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=k;class M{constructor(Y,J,Z=null){const ie=new i;c(ie,J),Y.send(ie.buffer),this.a=new S(Y,Z),this.d=new r(Y,J,Z)}getChannel(Y){return this.a.getChannel(Y)}registerChannel(Y,J){this.d.registerChannel(Y,J)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=M;function q(_){return{call(Y,J,Z){return _.then(ie=>ie.call(Y,J,Z))},listen(Y,J){const Z=new y.Relay;return _.then(ie=>Z.input=ie.listen(Y,J)),Z.event}}}e.getDelayedChannel=q;function V(_){let Y=!1;return{call(J,Z,ie){return Y?_.call(J,Z,ie):(0,t.timeout)(0).then(()=>Y=!0).then(()=>_.call(J,Z,ie))},listen(J,Z){if(Y)return _.listen(J,Z);const ie=new y.Relay;return(0,t.timeout)(0).then(()=>Y=!0).then(()=>ie.input=_.listen(J,Z)),ie.event}}}e.getNextTickChannel=V;class F{constructor(Y){this.a=Y}routeCall(Y){return this.b(Y)}routeEvent(Y){return this.b(Y)}async b(Y){for(const J of Y.connections)if(await Promise.resolve(this.a(J.ctx)))return Promise.resolve(J);return await y.Event.toPromise(Y.onDidAddConnection),await this.b(Y)}}e.StaticRouter=F;var U;(function(_){function Y(X,K){const he=X,be=K&&K.disableMarshalling,Ee=new Map;for(const Pe in he)Z(Pe)&&Ee.set(Pe,y.Event.buffer(he[Pe],!0));return new class{listen(Pe,Me,oe){const ae=Ee.get(Me);if(ae)return ae;if(ie(Me)){const fe=he[Me];if(typeof fe=="function")return fe.call(he,oe)}throw new Error(`Event not found: ${Me}`)}call(Pe,Me,oe){const ae=he[Me];if(typeof ae=="function"){if(!be&&Array.isArray(oe))for(let fe=0;fe<oe.length;fe++)oe[fe]=(0,L.revive)(oe[fe]);return ae.apply(he,oe)}throw new Error(`Method not found: ${Me}`)}}}_.fromService=Y;function J(X,K){const he=K&&K.disableMarshalling;return new Proxy({},{get(be,Ee){if(typeof Ee=="string")return K?.properties?.has(Ee)?K.properties.get(Ee):ie(Ee)?function(Pe){return X.listen(Ee,Pe)}:Z(Ee)?X.listen(Ee):async function(...Pe){let Me;K&&!(0,v.isUndefinedOrNull)(K.context)?Me=[K.context,...Pe]:Me=Pe;const oe=await X.call(Ee,Me);return he?oe:(0,L.revive)(oe)};throw new Error(`Property not found: ${String(Ee)}`)}})}_.toService=J;function Z(X){return X[0]==="o"&&X[1]==="n"&&P.isUpperAsciiLetter(X.charCodeAt(2))}function ie(X){return/^onDynamic/.test(X)&&P.isUpperAsciiLetter(X.charCodeAt(9))}})(U=e.ProxyChannel||(e.ProxyChannel={}));const N=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function B(_){if(Array.isArray(_))return _;if(_&&typeof _=="object"&&typeof _.toString=="function"){const Y=_.toString();if(Y!=="[object Object]")return Y}return _}function j(_){return Array.isArray(_)?_.map(B):B(_)}function z(_,Y,J,Z,ie,X,K){K=j(K);const he=N[ie],be=he[Z%he.length];let Ee=[`%c[${_}]%c[${String(Y).padStart(7," ")}]%c[len: ${String(J).padStart(5," ")}]%c${String(Z).padStart(5," ")} - ${X}`,"color: darkgreen","color: grey","color: grey",`color: ${be}`];/\($/.test(X)?(Ee=Ee.concat(K),Ee.push(")")):Ee.push(K),console.log.apply(console,Ee)}class ne{constructor(Y,J){this.d=Y,this.f=J,this.a=0,this.b=0}logOutgoing(Y,J,Z,ie,X){this.b+=Y,z(this.d,this.b,Y,J,Z,ie,X)}logIncoming(Y,J,Z,ie,X){this.a+=Y,z(this.f,this.a,Y,J,Z,ie,X)}}e.IPCLogger=ne}),define(ye[117],Ce([1,0,16,22,3,6,116]),function(te,e,o,t,T,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(S){S.Created="created",S.Read="read",S.Write="write",S.Open="open",S.Error="error",S.Close="close",S.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",S.NodeEndReceived="nodeEndReceived",S.NodeEndSent="nodeEndSent",S.NodeDrainBegin="nodeDrainBegin",S.NodeDrainEnd="nodeDrainEnd",S.zlibInflateError="zlibInflateError",S.zlibInflateData="zlibInflateData",S.zlibInflateInitialWrite="zlibInflateInitialWrite",S.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",S.zlibInflateWrite="zlibInflateWrite",S.zlibInflateFlushFired="zlibInflateFlushFired",S.zlibDeflateError="zlibDeflateError",S.zlibDeflateData="zlibDeflateData",S.zlibDeflateWrite="zlibDeflateWrite",S.zlibDeflateFlushFired="zlibDeflateFlushFired",S.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",S.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",S.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",S.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",S.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",S.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",S.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",S.ProtocolHeaderRead="protocolHeaderRead",S.ProtocolMessageRead="protocolMessageRead",S.ProtocolHeaderWrite="protocolHeaderWrite",S.ProtocolMessageWrite="protocolMessageWrite",S.ProtocolWrite="protocolWrite"})(A=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var y;(function(S){S.enableDiagnostics=!1,S.records=[];const k=new WeakMap;let M=0;function q(F,U){if(!k.has(F)){const N=String(++M);k.set(F,N)}return k.get(F)}function V(F,U,N,B){if(!S.enableDiagnostics)return;const j=q(F,U);if(B instanceof t.VSBuffer||B instanceof Uint8Array||B instanceof ArrayBuffer||ArrayBuffer.isView(B)){const z=t.VSBuffer.alloc(B.byteLength);z.set(B),S.records.push({timestamp:Date.now(),id:j,label:U,type:N,buff:z})}else S.records.push({timestamp:Date.now(),id:j,label:U,type:N,data:B})}S.traceSocketEvent=V})(y=e.SocketDiagnostics||(e.SocketDiagnostics={}));var D;(function(S){S[S.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",S[S.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(D=e.SocketCloseEventType||(e.SocketCloseEventType={}));let L=null;function P(){return L||(L=t.VSBuffer.alloc(0)),L}class v{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(k){this.a.push(k),this.b+=k.byteLength}read(k){return this.c(k,!0)}peek(k){return this.c(k,!1)}c(k,M){if(k===0)return P();if(k>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===k){const U=this.a[0];return M&&(this.a.shift(),this.b-=k),U}if(this.a[0].byteLength>k){const U=this.a[0].slice(0,k);return M&&(this.a[0]=this.a[0].slice(k),this.b-=k),U}const q=t.VSBuffer.alloc(k);let V=0,F=0;for(;k>0;){const U=this.a[F];if(U.byteLength>k){const N=U.slice(0,k);q.set(N,V),V+=k,M&&(this.a[F]=U.slice(k),this.b-=k),k-=k}else q.set(U,V),V+=U.byteLength,M?(this.a.shift(),this.b-=U.byteLength):F++,k-=U.byteLength}return q}}e.ChunkStream=v;var C;(function(S){S[S.None=0]="None",S[S.Regular=1]="Regular",S[S.Control=2]="Control",S[S.Ack=3]="Ack",S[S.Disconnect=5]="Disconnect",S[S.ReplayRequest=6]="ReplayRequest",S[S.Pause=7]="Pause",S[S.Resume=8]="Resume",S[S.KeepAlive=9]="KeepAlive",S[S.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",S[S.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(C||(C={}));function E(S){switch(S){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var f;(function(S){S[S.HeaderLength=13]="HeaderLength",S[S.AcknowledgeTime=2e3]="AcknowledgeTime",S[S.TimeoutTime=2e4]="TimeoutTime",S[S.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",S[S.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",S[S.KeepAliveSendTime=5e3]="KeepAliveSendTime",S[S.LatencySampleTime=6e4]="LatencySampleTime",S[S.LatencySampleCount=5]="LatencySampleCount",S[S.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",S[S.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(f=e.ProtocolConstants||(e.ProtocolConstants={}));class d{constructor(k,M,q,V){this.type=k,this.id=M,this.ack=q,this.data=V,this.writtenTime=0}get size(){return this.data.byteLength}}class h extends R.Disposable{constructor(k){super(),this.f=this.B(new T.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=k,this.b=!1,this.c=new v,this.B(this.a.onData(M=>this.acceptChunk(M))),this.lastReadTime=Date.now()}acceptChunk(k){if(!(!k||k.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(k);this.c.byteLength>=this.g.readLen;){const M=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=M.readUInt32BE(9),this.g.messageType=M.readUInt8(0),this.g.id=M.readUInt32BE(1),this.g.ack=M.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:E(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const q=this.g.messageType,V=this.g.id,F=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",M),this.f.fire(new d(q,V,F,M)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class b{constructor(k){this.k=null,this.a=!1,this.b=!1,this.c=k,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(k){if(this.a)return;k.writtenTime=Date.now(),this.lastWriteTime=Date.now();const M=t.VSBuffer.alloc(13);M.writeUInt8(k.type,0),M.writeUInt32BE(k.id,1),M.writeUInt32BE(k.ack,5),M.writeUInt32BE(k.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:E(k.type),id:k.id,ack:k.ack,messageSize:k.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",k.data),this.j(M,k.data)}g(k,M){const q=this.f===0;return this.d.push(k,M),this.f+=k.byteLength+M.byteLength,q}h(){const k=t.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,k}j(k,M){this.g(k,M)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const k=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:k.byteLength}),this.c.write(k)}}class g extends R.Disposable{constructor(k){super(),this.f=new T.Emitter,this.onMessage=this.f.event,this.g=new T.Emitter,this.onDidDispose=this.g.event,this.a=k,this.b=this.B(new b(this.a)),this.c=this.B(new h(this.a)),this.B(this.c.onMessage(M=>{M.type===1&&this.f.fire(M.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(k){this.b.write(new d(1,0,0,k))}}e.Protocol=g;class p extends I.IPCClient{static fromSocket(k,M){return new p(new g(k),M)}get onDidDispose(){return this.b.onDidDispose}constructor(k,M,q=null){super(k,M,q),this.b=k}dispose(){super.dispose();const k=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),k.end()}}e.Client=p;class w{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new T.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(k){this.b?this.d.length>0?this.d.push(k):this.a.fire(k):this.d.push(k)}flushBuffer(){this.d=[]}}e.BufferedEmitter=w;class i{constructor(k){this.data=k,this.next=null}}class s{constructor(){this.a=null,this.b=null}length(){let k=0,M=this.a;for(;M;)M=M.next,k++;return k}peek(){return this.a?this.a.data:null}toArray(){const k=[];let M=0,q=this.a;for(;q;)k[M++]=q.data,q=q.next;return k}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(k){const M=new i(k);if(!this.a){this.a=M,this.b=M;return}this.b.next=M,this.b=M}}class a{static getInstance(){return a.b||(a.b=new a),a.b}constructor(){this.c=[];const k=Date.now();for(let M=0;M<a.a;M++)this.c[M]=k-1e3*M;setInterval(()=>{for(let M=a.a;M>=1;M--)this.c[M]=this.c[M-1];this.c[0]=Date.now()},1e3)}d(){const k=Date.now(),M=(1+a.a)*1e3;let q=0;for(let V=0;V<a.a;V++)k-this.c[V]<=M&&q++;return 1-q/a.a}hasHighLoad(){return this.d()>=.5}}a.a=10,a.b=null;var u;(function(S){S[S.Good=0]="Good",S[S.Poor=1]="Poor"})(u=e.ConnectionHealth||(e.ConnectionHealth={}));function l(S){switch(S){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=l;class c{constructor(k){this.connectionHealth=k}}e.ConnectionHealthChangedEvent=c;class n{constructor(k,M){this.roundTripTime=k,this.recentHighRoundTripCount=M}}e.HighRoundTripTimeEvent=n;class r{get unacknowledgedCount(){return this.c-this.d}constructor(k){this.x=new w,this.onControlMessage=this.x.event,this.y=new w,this.onMessage=this.y.event,this.z=new w,this.onDidDispose=this.z.event,this.A=new w,this.onSocketClose=this.A.event,this.B=new w,this.onSocketTimeout=this.B.event,this.C=new w,this.onHighRoundTripTime=this.C.event,this.D=new w,this.onDidChangeConnectionHealth=this.D.event,this.u=k.loadEstimator??a.getInstance(),this.v=k.measureRoundTripTime??!1,this.w=k.sendKeepAlive??!0,this.a=!1,this.b=new s,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.t=new R.DisposableStore,this.o=k.socket,this.p=this.t.add(new b(this.o)),this.q=this.t.add(new h(this.o)),this.t.add(this.q.onMessage(M=>this.E(M))),this.t.add(this.o.onClose(M=>this.A.fire(M))),this.r=this.t.add(new m),this.t.add(this.r.onSendLatencyRequest(M=>this.J(M))),this.t.add(this.r.onHighRoundTripTime(M=>this.C.fire(M))),this.t.add(this.r.onDidChangeConnectionHealth(M=>this.D.fire(M))),this.v&&this.r.start(),k.initialChunk&&this.q.acceptChunk(k.initialChunk),this.w?this.l=setInterval(()=>{this.I()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.t.dispose()}drain(){return this.p.drain()}sendDisconnect(){const k=new d(5,0,0,P());this.p.write(k),this.p.flush()}sendPause(){const k=new d(7,0,0,P());this.p.write(k)}sendResume(){const k=new d(8,0,0,P());this.p.write(k)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(k,M){this.a=!0,this.t.dispose(),this.t=new R.DisposableStore,this.x.flushBuffer(),this.A.flushBuffer(),this.B.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=k,this.p=this.t.add(new b(this.o)),this.q=this.t.add(new h(this.o)),this.t.add(this.q.onMessage(q=>this.E(q))),this.t.add(this.o.onClose(q=>this.A.fire(q))),this.r=this.t.add(new m),this.t.add(this.r.onSendLatencyRequest(q=>this.J(q))),this.t.add(this.r.onHighRoundTripTime(q=>this.C.fire(q))),this.t.add(this.r.onDidChangeConnectionHealth(q=>this.D.fire(q))),this.q.acceptChunk(M)}endAcceptReconnection(){this.a=!1,this.v&&this.r.start(),this.h=this.g;const k=new d(3,0,this.h,P());this.p.write(k);const M=this.b.toArray();for(let q=0,V=M.length;q<V;q++)this.p.write(M[q]);this.G()}acceptDisconnect(){this.z.fire()}E(k){if(k.ack>this.d){this.d=k.ack;do{const M=this.b.peek();if(M&&M.id<=k.ack)this.b.pop();else break}while(!0)}switch(k.type){case 0:break;case 1:{if(k.id>this.g)if(k.id!==this.g+1){const M=Date.now();M-this.m>1e4&&(this.m=M,this.p.write(new d(6,0,0,P())))}else this.g=k.id,this.j=Date.now(),this.F(),this.y.fire(k.data);break}case 2:{this.x.fire(k.data);break}case 3:break;case 5:{this.z.fire();break}case 6:{const M=this.b.toArray();for(let q=0,V=M.length;q<V;q++)this.p.write(M[q]);this.G();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break;case 10:{this.K(k.data);break}case 11:{this.r.handleResponse(k.data);break}}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(k){const M=++this.c;this.h=this.g;const q=new d(1,M,this.h,k);this.b.push(q),this.a||(this.p.write(q),this.G())}sendControl(k){const M=new d(2,0,0,k);this.p.write(M)}F(){if(this.g<=this.h||this.k)return;const k=Date.now()-this.j;if(k>=2e3){this.H();return}this.k=setTimeout(()=>{this.k=null,this.F()},2e3-k+5)}G(){if(this.c<=this.d||this.f||this.a)return;const k=this.b.peek(),M=Date.now()-k.writtenTime,q=Date.now()-this.q.lastReadTime,V=Date.now()-this.n;if(M>=2e4&&q>=2e4&&V>=2e4&&!this.u.hasHighLoad()){this.n=Date.now(),this.B.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:M,timeSinceLastReceivedSomeData:q});return}const F=Math.max(2e4-M,2e4-q,2e4-V,500);this.f=setTimeout(()=>{this.f=null,this.G()},F)}H(){if(this.g<=this.h)return;this.h=this.g;const k=new d(3,0,this.h,P());this.p.write(k)}I(){this.h=this.g;const k=new d(9,0,this.h,P());this.p.write(k)}J(k){this.h=this.g;const M=new d(10,0,this.h,k);this.p.write(M)}K(k){this.h=this.g;const M=new d(11,0,this.h,k);this.p.write(M)}}e.PersistentProtocol=r;class m extends R.Disposable{constructor(){super(),this.a=this.B(new T.Emitter),this.onSendLatencyRequest=this.a.event,this.b=this.B(new T.Emitter),this.onHighRoundTripTime=this.b.event,this.c=this.B(new T.Emitter),this.onDidChangeConnectionHealth=this.c.event,this.f=this.B(new o.IntervalTimer),this.g=-1,this.h=0,this.j=Array.from({length:5},k=>0),this.k=0,this.l=0}start(){this.f.cancelAndSet(()=>{this.g=Date.now();const k=++this.h,M=t.VSBuffer.alloc(4);M.writeUInt32BE(k,0),this.a.fire(M)},6e4)}handleResponse(k){if(k.byteLength!==4)return;const M=k.readUInt32BE(0);if(this.g<=0||M!==this.h)return;const q=Date.now()-this.g,V=this.k++;this.j[V%this.j.length]=q;const F=this.l,U=this.j.filter(N=>N>=1e3).length;this.l=U>=3?1:0,q>1e3&&this.b.fire(new n(q,U)),F!==this.l&&this.c.fire(this.l)}}}),define(ye[118],Ce([1,0,22,9,3,6,10,12,30,116,117]),function(te,e,o,t,T,R,I,A,y,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function P(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class v{traceSocketEvent(n,r){L.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,n,r)}constructor(n,r=""){this.f=!0,this.debugLabel=r,this.socket=n,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=m=>{if(this.traceSocketEvent("error",{code:m?.code,message:m?.message}),m){if(m.code==="EPIPE")return;(0,t.onUnexpectedError)(m)}},this.socket.on("error",this.a),this.b=m=>{this.traceSocketEvent("close",{hadError:m}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(n){const r=m=>{this.traceSocketEvent("read",m),n(o.VSBuffer.wrap(m))};return this.socket.on("data",r),{dispose:()=>this.socket.off("data",r)}}onClose(n){const r=m=>{n({type:0,hadError:m,error:void 0})};return this.socket.on("close",r),{dispose:()=>this.socket.off("close",r)}}onEnd(n){const r=()=>{n()};return this.socket.on("end",r),{dispose:()=>this.socket.off("end",r)}}write(n){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",n),this.socket.write(n.buffer,r=>{if(r){if(r.code==="EPIPE")return;(0,t.onUnexpectedError)(r)}})}catch(r){if(r.code==="EPIPE")return;(0,t.onUnexpectedError)(r)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((n,r)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),n();return}const m=()=>{this.socket.off("close",m),this.socket.off("end",m),this.socket.off("error",m),this.socket.off("timeout",m),this.socket.off("drain",m),this.traceSocketEvent("nodeDrainEnd"),n()};this.socket.on("close",m),this.socket.on("end",m),this.socket.on("error",m),this.socket.on("timeout",m),this.socket.on("drain",m)})}}e.NodeSocket=v;var C;(function(c){c[c.MinHeaderByteSize=2]="MinHeaderByteSize"})(C||(C={}));var E;(function(c){c[c.PeekHeader=1]="PeekHeader",c[c.ReadHeader=2]="ReadHeader",c[c.ReadBody=3]="ReadBody",c[c.Fin=4]="Fin"})(E||(E={}));class f extends R.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(n,r){this.socket.traceSocketEvent(n,r)}constructor(n,r,m,S){super(),this.f=this.B(new T.Emitter),this.g=this.B(new T.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=n,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:r,inflateBytesLength:m?.byteLength||0,recordInflateBytes:S}),this.a=this.B(new d(this,r,m,S,this.f,(k,M)=>this.k(k,M))),this.B(this.a.onError(k=>{console.error(k),(0,t.onUnexpectedError)(k),this.g.fire({type:0,hadError:!0,error:k})})),this.b=new L.ChunkStream,this.B(this.socket.onData(k=>this.l(k))),this.B(this.socket.onClose(k=>this.g.fire(k)))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(n){return this.f.event(n)}onClose(n){return this.g.event(n)}onEnd(n){return this.socket.onEnd(n)}write(n){this.a.writeMessage(n)}k(n,r){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",n);let m=2;n.byteLength<126?m+=0:n.byteLength<2**16?m+=2:m+=8;const S=o.VSBuffer.alloc(m);if(r?S.writeUInt8(194,0):S.writeUInt8(130,0),n.byteLength<126)S.writeUInt8(n.byteLength,1);else if(n.byteLength<2**16){S.writeUInt8(126,1);let k=1;S.writeUInt8(n.byteLength>>>8&255,++k),S.writeUInt8(n.byteLength>>>0&255,++k)}else{S.writeUInt8(127,1);let k=1;S.writeUInt8(0,++k),S.writeUInt8(0,++k),S.writeUInt8(0,++k),S.writeUInt8(0,++k),S.writeUInt8(n.byteLength>>>24&255,++k),S.writeUInt8(n.byteLength>>>16&255,++k),S.writeUInt8(n.byteLength>>>8&255,++k),S.writeUInt8(n.byteLength>>>0&255,++k)}this.socket.write(o.VSBuffer.concat([S,n]))}end(){this.h=!0,this.socket.end()}l(n){if(n.byteLength!==0){for(this.b.acceptChunk(n);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const r=this.b.peek(this.j.readLen),m=r.readUInt8(0),S=(m&128)>>>7,k=(m&64)>>>6,M=r.readUInt8(1),q=(M&128)>>>7,V=M&127;this.j.state=2,this.j.readLen=2+(q?4:0)+(V===126?2:0)+(V===127?8:0),this.j.fin=S,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(k)),this.j.firstFrameOfMessage=Boolean(S),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const r=this.b.read(this.j.readLen),m=r.readUInt8(1),S=(m&128)>>>7;let k=m&127,M=1;k===126?k=r.readUInt8(++M)*2**8+r.readUInt8(++M):k===127&&(k=r.readUInt8(++M)*0+r.readUInt8(++M)*0+r.readUInt8(++M)*0+r.readUInt8(++M)*0+r.readUInt8(++M)*2**24+r.readUInt8(++M)*2**16+r.readUInt8(++M)*2**8+r.readUInt8(++M));let q=0;S&&(q=r.readUInt8(++M)*2**24+r.readUInt8(++M)*2**16+r.readUInt8(++M)*2**8+r.readUInt8(++M)),this.j.state=3,this.j.readLen=k,this.j.mask=q,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const r=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",r),g(r,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",r),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(r,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await T.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=f;class d extends R.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:o.VSBuffer.alloc(0)}constructor(n,r,m,S,k,M){super(),this.k=n,this.l=k,this.m=M,this.a=this.B(new T.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new T.Emitter),this.onDidFinishProcessingWriteQueue=this.j.event,this.n=!1,this.s=!1,r?(this.b=this.B(new h(this.k,S,m,{windowBits:15})),this.f=this.B(new b(this.k,{windowBits:15})),this.B(this.b.onError(q=>this.a.fire(q))),this.B(this.f.onError(q=>this.a.fire(q)))):(this.b=null,this.f=null)}writeMessage(n){this.g.push(n),this.p()}async p(){if(!this.n){for(this.n=!0;this.g.length>0;){const n=this.g.shift();if(this.f){const r=await this.r(this.f,n);this.m(r,!0)}else this.m(n,!1)}this.n=!1,this.j.fire()}}isProcessingWriteQueue(){return this.n}r(n,r){return new Promise((m,S)=>{n.write(r),n.flush(k=>m(k))})}acceptFrame(n,r,m){this.h.push({data:n,isCompressed:r,isLastFrameOfMessage:m}),this.t()}async t(){if(!this.s){for(this.s=!0;this.h.length>0;){const n=this.h.shift();if(this.b&&n.isCompressed){const r=await this.u(this.b,n.data,n.isLastFrameOfMessage);this.l.fire(r)}else this.l.fire(n.data)}this.s=!1}}u(n,r,m){return new Promise((S,k)=>{n.write(r),m&&n.write(o.VSBuffer.fromByteArray([0,0,255,255])),n.flush(M=>S(M))})}}class h extends R.Disposable{get recordedInflateBytes(){return this.j?o.VSBuffer.concat(this.f):o.VSBuffer.alloc(0)}constructor(n,r,m,S){super(),this.h=n,this.j=r,this.a=this.B(new T.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=P().zlib.createInflateRaw(S),this.b.on("error",k=>{this.h.traceSocketEvent("zlibInflateError",{message:k?.message,code:k?.code}),this.a.fire(k)}),this.b.on("data",k=>{this.h.traceSocketEvent("zlibInflateData",k),this.g.push(o.VSBuffer.wrap(k))}),m&&(this.h.traceSocketEvent("zlibInflateInitialWrite",m.buffer),this.b.write(m.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(n){this.j&&this.f.push(n.clone()),this.h.traceSocketEvent("zlibInflateWrite",n),this.b.write(n.buffer)}flush(n){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const r=o.VSBuffer.concat(this.g);this.g.length=0,n(r)})}}class b extends R.Disposable{constructor(n,r){super(),this.g=n,this.a=this.B(new T.Emitter),this.onError=this.a.event,this.f=[],this.b=P().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",m=>{this.g.traceSocketEvent("zlibDeflateError",{message:m?.message,code:m?.code}),this.a.fire(m)}),this.b.on("data",m=>{this.g.traceSocketEvent("zlibDeflateData",m),this.f.push(o.VSBuffer.wrap(m))})}write(n){this.g.traceSocketEvent("zlibDeflateWrite",n.buffer),this.b.write(n.buffer)}flush(n){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let r=o.VSBuffer.concat(this.f);this.f.length=0,r=r.slice(0,r.byteLength-4),n(r)})}}function g(c,n){if(n===0)return;const r=c.byteLength>>>2;for(let V=0;V<r;V++){const F=c.readUInt32BE(V*4);c.writeUInt32BE(F^n,V*4)}const m=r*4,S=c.byteLength-m,k=n>>>24&255,M=n>>>16&255,q=n>>>8&255;S>=1&&c.writeUInt8(c.readUInt8(m)^k,m),S>=2&&c.writeUInt8(c.readUInt8(m+1)^M,m+1),S>=3&&c.writeUInt8(c.readUInt8(m+2)^q,m+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const p={[2]:107,[1]:103};function w(){const c=(0,y.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${c}-sock`;let n;return e.XDG_RUNTIME_DIR?n=(0,I.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${c}.sock`):n=(0,I.join)(P().os.tmpdir(),`vscode-ipc-${c}.sock`),s(n),n}e.createRandomIPCHandle=w;function i(c,n,r){const m=P().crypto.createHash("md5").update(c).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${m}-${r}-${n}-sock`;let S;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?S=(0,I.join)(e.XDG_RUNTIME_DIR,`vscode-${m.substr(0,8)}-${r}-${n}.sock`):S=(0,I.join)(c,`${r}-${n}.sock`),s(S),S}e.createStaticIPCHandle=i;function s(c){const n=p[A.platform];typeof n=="number"&&c.length>=n&&console.warn(`WARNING: IPC handle "${c}" is longer than ${n} chars, try a shorter --user-data-dir`)}class a extends D.IPCServer{static b(n){const r=T.Event.fromNodeEventEmitter(n,"connection");return T.Event.map(r,m=>({protocol:new L.Protocol(new v(m,"ipc-server-connection")),onDidClientDisconnect:T.Event.once(T.Event.fromNodeEventEmitter(m,"close"))}))}constructor(n){super(a.b(n)),this.d=n}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=a;function u(c){return new Promise((n,r)=>{const m=P().net.createServer();m.on("error",r),m.listen(c,()=>{m.removeListener("error",r),n(new a(m))})})}e.serve=u;function l(c,n){return new Promise((r,m)=>{const S=P().net.createConnection(c,()=>{S.removeListener("error",m),r(L.Client.fromSocket(new v(S,`ipc-client${n}`),n))});S.once("error",m)})}e.connect=l}),define(ye[163],Ce([1,0,38,10]),function(te,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function T(R,I,A,y,D,L){if(Array.isArray(R)){let P=0;for(const v of R){const C=T(v,I,A,y,D,L);if(C===10)return C;C>P&&(P=C)}return P}else{if(typeof R=="string")return y?R==="*"?5:R===A?10:0:0;if(R){const{language:P,pattern:v,scheme:C,hasAccessToAllModels:E,notebookType:f}=R;if(!y&&!E)return 0;f&&D&&(I=D);let d=0;if(C)if(C===I.scheme)d=10;else if(C==="*")d=5;else return 0;if(P)if(P===A)d=10;else if(P==="*")d=Math.max(d,5);else return 0;if(f)if(f===L)d=10;else if(f==="*"&&L!==void 0)d=Math.max(d,5);else return 0;if(v){let h;if(typeof v=="string"?h=v:h={...v,base:(0,t.normalize)(v.base)},h===I.fsPath||(0,o.match)(h,I.fsPath))d=10;else return 0}return d}else return 0}}e.score=T}),define(ye[164],Ce([1,0,8,51,154]),function(te,e,o,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class R{constructor(A,y,D,L){this.c=A,this.d=y,this.f=D,this.g=L,this.h=null,this.j=null}dispose(){this.d.length=0}get version(){return this.g}getText(){return this.j===null&&(this.j=this.d.join(this.f)),this.j}onEvents(A){A.eol&&A.eol!==this.f&&(this.f=A.eol,this.h=null);const y=A.changes;for(const D of y)this.n(D.range),this.o(new t.Position(D.range.startLineNumber,D.range.startColumn),D.text);this.g=A.versionId,this.j=null}k(){if(!this.h){const A=this.f.length,y=this.d.length,D=new Uint32Array(y);for(let L=0;L<y;L++)D[L]=this.d[L].length+A;this.h=new T.PrefixSumComputer(D)}}l(A,y){this.d[A]=y,this.h&&this.h.setValue(A,this.d[A].length+this.f.length)}n(A){if(A.startLineNumber===A.endLineNumber){if(A.startColumn===A.endColumn)return;this.l(A.startLineNumber-1,this.d[A.startLineNumber-1].substring(0,A.startColumn-1)+this.d[A.startLineNumber-1].substring(A.endColumn-1));return}this.l(A.startLineNumber-1,this.d[A.startLineNumber-1].substring(0,A.startColumn-1)+this.d[A.endLineNumber-1].substring(A.endColumn-1)),this.d.splice(A.startLineNumber,A.endLineNumber-A.startLineNumber),this.h&&this.h.removeValues(A.startLineNumber,A.endLineNumber-A.startLineNumber)}o(A,y){if(y.length===0)return;const D=(0,o.splitLines)(y);if(D.length===1){this.l(A.lineNumber-1,this.d[A.lineNumber-1].substring(0,A.column-1)+D[0]+this.d[A.lineNumber-1].substring(A.column-1));return}D[D.length-1]+=this.d[A.lineNumber-1].substring(A.column-1),this.l(A.lineNumber-1,this.d[A.lineNumber-1].substring(0,A.column-1)+D[0]);const L=new Uint32Array(D.length-1);for(let P=1;P<D.length;P++)this.d.splice(A.lineNumber+P-1,0,D[P]),L[P-1]=D[P].length+this.f.length;this.h&&this.h.insertValues(A.lineNumber,L)}}e.MirrorTextModel=R}),define(ye[165],Ce([1,0,8,151,51,35,106]),function(te,e,o,t,T,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const A=999;class y{constructor(b,g,p,w){this.searchString=b,this.isRegex=g,this.matchCase=p,this.wordSeparators=w}parseSearchRequest(){if(this.searchString==="")return null;let b;this.isRegex?b=D(this.searchString):b=this.searchString.indexOf(`
`)>=0;let g=null;try{g=o.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:b,global:!0,unicode:!0})}catch{return null}if(!g)return null;let p=!this.isRegex&&!b;return p&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(p=this.matchCase),new I.SearchData(g,this.wordSeparators?(0,t.getMapForWordSeparators)(this.wordSeparators):null,p?this.searchString:null)}}e.SearchParams=y;function D(h){if(!h||h.length===0)return!1;for(let b=0,g=h.length;b<g;b++){const p=h.charCodeAt(b);if(p===10)return!0;if(p===92){if(b++,b>=g)break;const w=h.charCodeAt(b);if(w===110||w===114||w===87)return!0}}return!1}e.isMultilineRegexSource=D;function L(h,b,g){if(!g)return new I.FindMatch(h,null);const p=[];for(let w=0,i=b.length;w<i;w++)p[w]=b[w];return new I.FindMatch(h,p)}e.createFindMatch=L;class P{constructor(b){const g=[];let p=0;for(let w=0,i=b.length;w<i;w++)b.charCodeAt(w)===10&&(g[p++]=w);this.a=g}findLineFeedCountBeforeOffset(b){const g=this.a;let p=0,w=g.length-1;if(w===-1||b<=g[0])return 0;for(;p<w;){const i=p+((w-p)/2>>0);g[i]>=b?w=i-1:g[i+1]>=b?(p=i,w=i):p=i+1}return p+1}}class v{static findMatches(b,g,p,w,i){const s=g.parseSearchRequest();return s?s.regex.multiline?this.b(b,p,new d(s.wordSeparators,s.regex),w,i):this.c(b,p,s,w,i):[]}static a(b,g,p,w,i,s){let a,u=0;w?(u=w.findLineFeedCountBeforeOffset(i),a=g+i+u):a=g+i;let l;if(w){const m=w.findLineFeedCountBeforeOffset(i+s.length)-u;l=a+s.length+m}else l=a+s.length;const c=b.getPositionAt(a),n=b.getPositionAt(l);return new R.Range(c.lineNumber,c.column,n.lineNumber,n.column)}static b(b,g,p,w,i){const s=b.getOffsetAt(g.getStartPosition()),a=b.getValueInRange(g,1),u=b.getEOL()===`\r
`?new P(a):null,l=[];let c=0,n;for(p.reset(0);n=p.next(a);)if(l[c++]=L(this.a(b,s,a,u,n.index,n[0]),n,w),c>=i)return l;return l}static c(b,g,p,w,i){const s=[];let a=0;if(g.startLineNumber===g.endLineNumber){const l=b.getLineContent(g.startLineNumber).substring(g.startColumn-1,g.endColumn-1);return a=this.d(p,l,g.startLineNumber,g.startColumn-1,a,s,w,i),s}const u=b.getLineContent(g.startLineNumber).substring(g.startColumn-1);a=this.d(p,u,g.startLineNumber,g.startColumn-1,a,s,w,i);for(let l=g.startLineNumber+1;l<g.endLineNumber&&a<i;l++)a=this.d(p,b.getLineContent(l),l,0,a,s,w,i);if(a<i){const l=b.getLineContent(g.endLineNumber).substring(0,g.endColumn-1);a=this.d(p,l,g.endLineNumber,0,a,s,w,i)}return s}static d(b,g,p,w,i,s,a,u){const l=b.wordSeparators;if(!a&&b.simpleSearch){const r=b.simpleSearch,m=r.length,S=g.length;let k=-m;for(;(k=g.indexOf(r,k+m))!==-1;)if((!l||f(l,g,S,k,m))&&(s[i++]=new I.FindMatch(new R.Range(p,k+1+w,p,k+1+m+w),null),i>=u))return i;return i}const c=new d(b.wordSeparators,b.regex);let n;c.reset(0);do if(n=c.next(g),n&&(s[i++]=L(new R.Range(p,n.index+1+w,p,n.index+1+n[0].length+w),n,a),i>=u))return i;while(n);return i}static findNextMatch(b,g,p,w){const i=g.parseSearchRequest();if(!i)return null;const s=new d(i.wordSeparators,i.regex);return i.regex.multiline?this.e(b,p,s,w):this.f(b,p,s,w)}static e(b,g,p,w){const i=new T.Position(g.lineNumber,1),s=b.getOffsetAt(i),a=b.getLineCount(),u=b.getValueInRange(new R.Range(i.lineNumber,i.column,a,b.getLineMaxColumn(a)),1),l=b.getEOL()===`\r
`?new P(u):null;p.reset(g.column-1);const c=p.next(u);return c?L(this.a(b,s,u,l,c.index,c[0]),c,w):g.lineNumber!==1||g.column!==1?this.e(b,new T.Position(1,1),p,w):null}static f(b,g,p,w){const i=b.getLineCount(),s=g.lineNumber,a=b.getLineContent(s),u=this.g(p,a,s,g.column,w);if(u)return u;for(let l=1;l<=i;l++){const c=(s+l-1)%i,n=b.getLineContent(c+1),r=this.g(p,n,c+1,1,w);if(r)return r}return null}static g(b,g,p,w,i){b.reset(w-1);const s=b.next(g);return s?L(new R.Range(p,s.index+1,p,s.index+1+s[0].length),s,i):null}static findPreviousMatch(b,g,p,w){const i=g.parseSearchRequest();if(!i)return null;const s=new d(i.wordSeparators,i.regex);return i.regex.multiline?this.h(b,p,s,w):this.j(b,p,s,w)}static h(b,g,p,w){const i=this.b(b,new R.Range(1,1,g.lineNumber,g.column),p,w,10*A);if(i.length>0)return i[i.length-1];const s=b.getLineCount();return g.lineNumber!==s||g.column!==b.getLineMaxColumn(s)?this.h(b,new T.Position(s,b.getLineMaxColumn(s)),p,w):null}static j(b,g,p,w){const i=b.getLineCount(),s=g.lineNumber,a=b.getLineContent(s).substring(0,g.column-1),u=this.k(p,a,s,w);if(u)return u;for(let l=1;l<=i;l++){const c=(i+s-l-1)%i,n=b.getLineContent(c+1),r=this.k(p,n,c+1,w);if(r)return r}return null}static k(b,g,p,w){let i=null,s;for(b.reset(0);s=b.next(g);)i=L(new R.Range(p,s.index+1,p,s.index+1+s[0].length),s,w);return i}}e.TextModelSearch=v;function C(h,b,g,p,w){if(p===0)return!0;const i=b.charCodeAt(p-1);if(h.get(i)!==0||i===13||i===10)return!0;if(w>0){const s=b.charCodeAt(p);if(h.get(s)!==0)return!0}return!1}function E(h,b,g,p,w){if(p+w===g)return!0;const i=b.charCodeAt(p+w);if(h.get(i)!==0||i===13||i===10)return!0;if(w>0){const s=b.charCodeAt(p+w-1);if(h.get(s)!==0)return!0}return!1}function f(h,b,g,p,w){return C(h,b,g,p,w)&&E(h,b,g,p,w)}e.isValidMatch=f;class d{constructor(b,g){this._wordSeparators=b,this.a=g,this.b=-1,this.c=0}reset(b){this.a.lastIndex=b,this.b=-1,this.c=0}next(b){const g=b.length;let p;do{if(this.b+this.c===g||(p=this.a.exec(b),!p))return null;const w=p.index,i=p[0].length;if(w===this.b&&i===this.c){if(i===0){o.getNextCodePoint(b,g,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=w,this.c=i,!this._wordSeparators||f(this._wordSeparators,b,g,w,i))return p}while(p);return null}}e.Searcher=d}),define(ye[119],Ce([1,0,22,12]),function(te,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var T;(function(P){P[P.Full=1]="Full",P[P.Delta=2]="Delta"})(T||(T={}));function R(P){for(let v=0,C=P.length;v<C;v+=4){const E=P[v+0],f=P[v+1],d=P[v+2],h=P[v+3];P[v+0]=h,P[v+1]=d,P[v+2]=f,P[v+3]=E}}function I(P){const v=new Uint8Array(P.buffer,P.byteOffset,P.length*4);return t.isLittleEndian()||R(v),o.VSBuffer.wrap(v)}function A(P){const v=P.buffer;if(t.isLittleEndian()||R(v),v.byteOffset%4===0)return new Uint32Array(v.buffer,v.byteOffset,v.length/4);{const C=new Uint8Array(v.byteLength);return C.set(v),new Uint32Array(C.buffer,C.byteOffset,C.length/4)}}function y(P){const v=new Uint32Array(D(P));let C=0;if(v[C++]=P.id,P.type==="full")v[C++]=1,v[C++]=P.data.length,v.set(P.data,C),C+=P.data.length;else{v[C++]=2,v[C++]=P.deltas.length;for(const E of P.deltas)v[C++]=E.start,v[C++]=E.deleteCount,E.data?(v[C++]=E.data.length,v.set(E.data,C),C+=E.data.length):v[C++]=0}return I(v)}e.encodeSemanticTokensDto=y;function D(P){let v=0;if(v+=1+1,P.type==="full")v+=1+P.data.length;else{v+=1,v+=(1+1+1)*P.deltas.length;for(const C of P.deltas)C.data&&(v+=C.data.length)}return v}function L(P){const v=A(P);let C=0;const E=v[C++];if(v[C++]===1){const b=v[C++],g=v.subarray(C,C+b);return C+=b,{id:E,type:"full",data:g}}const d=v[C++],h=[];for(let b=0;b<d;b++){const g=v[C++],p=v[C++],w=v[C++];let i;w>0&&(i=v.subarray(C,C+w),C+=w),h[b]={start:g,deleteCount:p,data:i}}return{id:E,type:"delta",deltas:h}}e.decodeSemanticTokensDto=L}),define(ye[166],Ce([1,0,3,6]),function(te,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class T{constructor(){this.a=new Map,this.b=new Map,this.c=new o.Emitter,this.onDidChange=this.c.event,this.d=null}fire(A){this.c.fire({changedLanguages:A,changedColorMap:!1})}register(A,y){return this.a.set(A,y),this.fire([A]),(0,t.toDisposable)(()=>{this.a.get(A)===y&&(this.a.delete(A),this.fire([A]))})}registerFactory(A,y){this.b.get(A)?.dispose();const D=new R(this,A,y);return this.b.set(A,D),(0,t.toDisposable)(()=>{const L=this.b.get(A);!L||L!==D||(this.b.delete(A),L.dispose())})}async getOrCreate(A){const y=this.get(A);if(y)return y;const D=this.b.get(A);return!D||D.isResolved?null:(await D.resolve(),this.get(A))}get(A){return this.a.get(A)||null}isResolved(A){if(this.get(A))return!0;const D=this.b.get(A);return!!(!D||D.isResolved)}setColorMap(A){this.d=A,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.TokenizationRegistry=T;class R extends t.Disposable{get isResolved(){return this.c}constructor(A,y,D){super(),this.f=A,this.g=y,this.h=D,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.i()),this.b}async i(){const A=await Promise.resolve(this.h.createTokenizationSupport());this.c=!0,A&&!this.a&&this.B(this.f.register(this.g,A))}}}),define(ye[66],Ce([1,0,80,2,35,166]),function(te,e,o,t,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class I{constructor(m,S,k){this._tokenBrand=void 0,this.offset=m,this.type=S,this.language=k}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=I;class A{constructor(m,S){this._tokenizationResultBrand=void 0,this.tokens=m,this.endState=S}}e.TokenizationResult=A;class y{constructor(m,S){this._encodedTokenizationResultBrand=void 0,this.tokens=m,this.endState=S}}e.EncodedTokenizationResult=y;var D;(function(r){r[r.Method=0]="Method",r[r.Function=1]="Function",r[r.Constructor=2]="Constructor",r[r.Field=3]="Field",r[r.Variable=4]="Variable",r[r.Class=5]="Class",r[r.Struct=6]="Struct",r[r.Interface=7]="Interface",r[r.Module=8]="Module",r[r.Property=9]="Property",r[r.Event=10]="Event",r[r.Operator=11]="Operator",r[r.Unit=12]="Unit",r[r.Value=13]="Value",r[r.Constant=14]="Constant",r[r.Enum=15]="Enum",r[r.EnumMember=16]="EnumMember",r[r.Keyword=17]="Keyword",r[r.Text=18]="Text",r[r.Color=19]="Color",r[r.File=20]="File",r[r.Reference=21]="Reference",r[r.Customcolor=22]="Customcolor",r[r.Folder=23]="Folder",r[r.TypeParameter=24]="TypeParameter",r[r.User=25]="User",r[r.Issue=26]="Issue",r[r.Snippet=27]="Snippet"})(D=e.CompletionItemKind||(e.CompletionItemKind={}));var L;(function(r){const m=new Map;m.set(0,o.Codicon.symbolMethod),m.set(1,o.Codicon.symbolFunction),m.set(2,o.Codicon.symbolConstructor),m.set(3,o.Codicon.symbolField),m.set(4,o.Codicon.symbolVariable),m.set(5,o.Codicon.symbolClass),m.set(6,o.Codicon.symbolStruct),m.set(7,o.Codicon.symbolInterface),m.set(8,o.Codicon.symbolModule),m.set(9,o.Codicon.symbolProperty),m.set(10,o.Codicon.symbolEvent),m.set(11,o.Codicon.symbolOperator),m.set(12,o.Codicon.symbolUnit),m.set(13,o.Codicon.symbolValue),m.set(15,o.Codicon.symbolEnum),m.set(14,o.Codicon.symbolConstant),m.set(15,o.Codicon.symbolEnum),m.set(16,o.Codicon.symbolEnumMember),m.set(17,o.Codicon.symbolKeyword),m.set(27,o.Codicon.symbolSnippet),m.set(18,o.Codicon.symbolText),m.set(19,o.Codicon.symbolColor),m.set(20,o.Codicon.symbolFile),m.set(21,o.Codicon.symbolReference),m.set(22,o.Codicon.symbolCustomColor),m.set(23,o.Codicon.symbolFolder),m.set(24,o.Codicon.symbolTypeParameter),m.set(25,o.Codicon.account),m.set(26,o.Codicon.issues);function S(q){let V=m.get(q);return V||(console.info("No codicon found for CompletionItemKind "+q),V=o.Codicon.symbolProperty),V}r.toIcon=S;const k=new Map;k.set("method",0),k.set("function",1),k.set("constructor",2),k.set("field",3),k.set("variable",4),k.set("class",5),k.set("struct",6),k.set("interface",7),k.set("module",8),k.set("property",9),k.set("event",10),k.set("operator",11),k.set("unit",12),k.set("value",13),k.set("constant",14),k.set("enum",15),k.set("enum-member",16),k.set("enumMember",16),k.set("keyword",17),k.set("snippet",27),k.set("text",18),k.set("color",19),k.set("file",20),k.set("reference",21),k.set("customcolor",22),k.set("folder",23),k.set("type-parameter",24),k.set("typeParameter",24),k.set("account",25),k.set("issue",26);function M(q,V){let F=k.get(q);return typeof F>"u"&&!V&&(F=9),F}r.fromString=M})(L=e.CompletionItemKinds||(e.CompletionItemKinds={}));var P;(function(r){r[r.Deprecated=1]="Deprecated"})(P=e.CompletionItemTag||(e.CompletionItemTag={}));var v;(function(r){r[r.None=0]="None",r[r.KeepWhitespace=1]="KeepWhitespace",r[r.InsertAsSnippet=4]="InsertAsSnippet"})(v=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var C;(function(r){r[r.Invoke=0]="Invoke",r[r.TriggerCharacter=1]="TriggerCharacter",r[r.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(C=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var E;(function(r){r[r.Automatic=0]="Automatic",r[r.Explicit=1]="Explicit"})(E=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var f;(function(r){r[r.Invoke=1]="Invoke",r[r.Auto=2]="Auto"})(f=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var d;(function(r){r[r.Invoke=1]="Invoke",r[r.TriggerCharacter=2]="TriggerCharacter",r[r.ContentChange=3]="ContentChange"})(d=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var h;(function(r){r[r.Text=0]="Text",r[r.Read=1]="Read",r[r.Write=2]="Write"})(h=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function b(r){return r&&t.URI.isUri(r.uri)&&T.Range.isIRange(r.range)&&(T.Range.isIRange(r.originSelectionRange)||T.Range.isIRange(r.targetSelectionRange))}e.isLocationLink=b;var g;(function(r){r[r.File=0]="File",r[r.Module=1]="Module",r[r.Namespace=2]="Namespace",r[r.Package=3]="Package",r[r.Class=4]="Class",r[r.Method=5]="Method",r[r.Property=6]="Property",r[r.Field=7]="Field",r[r.Constructor=8]="Constructor",r[r.Enum=9]="Enum",r[r.Interface=10]="Interface",r[r.Function=11]="Function",r[r.Variable=12]="Variable",r[r.Constant=13]="Constant",r[r.String=14]="String",r[r.Number=15]="Number",r[r.Boolean=16]="Boolean",r[r.Array=17]="Array",r[r.Object=18]="Object",r[r.Key=19]="Key",r[r.Null=20]="Null",r[r.EnumMember=21]="EnumMember",r[r.Struct=22]="Struct",r[r.Event=23]="Event",r[r.Operator=24]="Operator",r[r.TypeParameter=25]="TypeParameter"})(g=e.SymbolKind||(e.SymbolKind={}));var p;(function(r){r[r.Deprecated=1]="Deprecated"})(p=e.SymbolTag||(e.SymbolTag={}));var w;(function(r){const m=new Map;m.set(0,o.Codicon.symbolFile),m.set(1,o.Codicon.symbolModule),m.set(2,o.Codicon.symbolNamespace),m.set(3,o.Codicon.symbolPackage),m.set(4,o.Codicon.symbolClass),m.set(5,o.Codicon.symbolMethod),m.set(6,o.Codicon.symbolProperty),m.set(7,o.Codicon.symbolField),m.set(8,o.Codicon.symbolConstructor),m.set(9,o.Codicon.symbolEnum),m.set(10,o.Codicon.symbolInterface),m.set(11,o.Codicon.symbolFunction),m.set(12,o.Codicon.symbolVariable),m.set(13,o.Codicon.symbolConstant),m.set(14,o.Codicon.symbolString),m.set(15,o.Codicon.symbolNumber),m.set(16,o.Codicon.symbolBoolean),m.set(17,o.Codicon.symbolArray),m.set(18,o.Codicon.symbolObject),m.set(19,o.Codicon.symbolKey),m.set(20,o.Codicon.symbolNull),m.set(21,o.Codicon.symbolEnumMember),m.set(22,o.Codicon.symbolStruct),m.set(23,o.Codicon.symbolEvent),m.set(24,o.Codicon.symbolOperator),m.set(25,o.Codicon.symbolTypeParameter);function S(k){let M=m.get(k);return M||(console.info("No codicon found for SymbolKind "+k),M=o.Codicon.symbolProperty),M}r.toIcon=S})(w=e.SymbolKinds||(e.SymbolKinds={}));class i{constructor(m){this.value=m}}e.FoldingRangeKind=i,i.Comment=new i("comment"),i.Imports=new i("imports"),i.Region=new i("region");var s;(function(r){function m(S){return!S||typeof S!="object"?!1:typeof S.id=="string"&&typeof S.title=="string"}r.is=m})(s=e.Command||(e.Command={}));var a;(function(r){r[r.Collapsed=0]="Collapsed",r[r.Expanded=1]="Expanded"})(a=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var u;(function(r){r[r.Unresolved=0]="Unresolved",r[r.Resolved=1]="Resolved"})(u=e.CommentThreadState||(e.CommentThreadState={}));var l;(function(r){r[r.Editing=0]="Editing",r[r.Preview=1]="Preview"})(l=e.CommentMode||(e.CommentMode={}));var c;(function(r){r[r.Type=1]="Type",r[r.Parameter=2]="Parameter"})(c=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new R.TokenizationRegistry;var n;(function(r){r[r.None=0]="None",r[r.Option=1]="Option",r[r.Default=2]="Default",r[r.Preferred=3]="Preferred"})(n=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ye[167],Ce([19,20]),function(te,e){return te.create("vs/editor/common/config/editorOptions",e)}),define(ye[120],Ce([1,0,167,12,105,18,23,150]),function(te,e,o,t,T,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var y;(function(ce){ce[ce.None=0]="None",ce[ce.Keep=1]="Keep",ce[ce.Brackets=2]="Brackets",ce[ce.Advanced=3]="Advanced",ce[ce.Full=4]="Full"})(y=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class D{constructor($){this.c=$}hasChanged($){return this.c[$]}}e.ConfigurationChangedEvent=D;class L{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=L;class P{constructor($,ue,Ie,Le){this.id=$,this.name=ue,this.defaultValue=Ie,this.schema=Le}applyUpdate($,ue){return C($,ue)}compute($,ue,Ie){return Ie}}class v{constructor($,ue){this.newValue=$,this.didChange=ue}}e.ApplyUpdateResult=v;function C(ce,$){if(typeof ce!="object"||typeof $!="object"||!ce||!$)return new v($,ce!==$);if(Array.isArray(ce)||Array.isArray($)){const Ie=Array.isArray(ce)&&Array.isArray($)&&R.equals(ce,$);return new v($,!Ie)}let ue=!1;for(const Ie in $)if($.hasOwnProperty(Ie)){const Le=C(ce[Ie],$[Ie]);Le.didChange&&(ce[Ie]=Le.newValue,ue=!0)}return new v(ce,ue)}class E{constructor($){this.schema=void 0,this.id=$,this.name="_never_",this.defaultValue=void 0}applyUpdate($,ue){return C($,ue)}validate($){return this.defaultValue}}class f{constructor($,ue,Ie,Le){this.id=$,this.name=ue,this.defaultValue=Ie,this.schema=Le}applyUpdate($,ue){return C($,ue)}validate($){return typeof $>"u"?this.defaultValue:$}compute($,ue,Ie){return Ie}}function d(ce,$){return typeof ce>"u"?$:ce==="false"?!1:Boolean(ce)}e.boolean=d;class h extends f{constructor($,ue,Ie,Le=void 0){typeof Le<"u"&&(Le.type="boolean",Le.default=Ie),super($,ue,Ie,Le)}validate($){return d($,this.defaultValue)}}function b(ce,$,ue,Ie){if(typeof ce>"u")return $;let Le=parseInt(ce,10);return isNaN(Le)?$:(Le=Math.max(ue,Le),Le=Math.min(Ie,Le),Le|0)}e.clampedInt=b;class g extends f{static clampedInt($,ue,Ie,Le){return b($,ue,Ie,Le)}constructor($,ue,Ie,Le,Be,xe=void 0){typeof xe<"u"&&(xe.type="integer",xe.default=Ie,xe.minimum=Le,xe.maximum=Be),super($,ue,Ie,xe),this.minimum=Le,this.maximum=Be}validate($){return g.clampedInt($,this.defaultValue,this.minimum,this.maximum)}}class p extends f{static clamp($,ue,Ie){return $<ue?ue:$>Ie?Ie:$}static float($,ue){if(typeof $=="number")return $;if(typeof $>"u")return ue;const Ie=parseFloat($);return isNaN(Ie)?ue:Ie}constructor($,ue,Ie,Le,Be){typeof Be<"u"&&(Be.type="number",Be.default=Ie),super($,ue,Ie,Be),this.validationFn=Le}validate($){return this.validationFn(p.float($,this.defaultValue))}}class w extends f{static string($,ue){return typeof $!="string"?ue:$}constructor($,ue,Ie,Le=void 0){typeof Le<"u"&&(Le.type="string",Le.default=Ie),super($,ue,Ie,Le)}validate($){return w.string($,this.defaultValue)}}function i(ce,$,ue){return typeof ce!="string"||ue.indexOf(ce)===-1?$:ce}e.stringSet=i;class s extends f{constructor($,ue,Ie,Le,Be=void 0){typeof Be<"u"&&(Be.type="string",Be.enum=Le,Be.default=Ie),super($,ue,Ie,Be),this.c=Le}validate($){return i($,this.defaultValue,this.c)}}class a extends P{constructor($,ue,Ie,Le,Be,xe,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.enum=Be,Ze.default=Le),super($,ue,Ie,Ze),this.c=Be,this.d=xe}validate($){return typeof $!="string"?this.defaultValue:this.c.indexOf($)===-1?this.defaultValue:this.d($)}}function u(ce){switch(ce){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class l extends P{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[o.localize(0,null),o.localize(1,null),o.localize(2,null)],default:"auto",tags:["accessibility"],description:o.localize(3,null)})}validate($){switch($){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute($,ue,Ie){return Ie===0?$.accessibilitySupport:Ie}}class c extends P{constructor(){const $={insertSpace:!0,ignoreEmptyLines:!0};super(20,"comments",$,{"editor.comments.insertSpace":{type:"boolean",default:$.insertSpace,description:o.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:$.ignoreEmptyLines,description:o.localize(5,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ue=$;return{insertSpace:d(ue.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:d(ue.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function(ce){ce[ce.Hidden=0]="Hidden",ce[ce.Blink=1]="Blink",ce[ce.Smooth=2]="Smooth",ce[ce.Phase=3]="Phase",ce[ce.Expand=4]="Expand",ce[ce.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function r(ce){switch(ce){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var m;(function(ce){ce[ce.Line=1]="Line",ce[ce.Block=2]="Block",ce[ce.Underline=3]="Underline",ce[ce.LineThin=4]="LineThin",ce[ce.BlockOutline=5]="BlockOutline",ce[ce.UnderlineThin=6]="UnderlineThin"})(m=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function S(ce){switch(ce){case m.Line:return"line";case m.Block:return"block";case m.Underline:return"underline";case m.LineThin:return"line-thin";case m.BlockOutline:return"block-outline";case m.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=S;function k(ce){switch(ce){case"line":return m.Line;case"block":return m.Block;case"underline":return m.Underline;case"line-thin":return m.LineThin;case"block-outline":return m.BlockOutline;case"underline-thin":return m.UnderlineThin}}class M extends E{constructor(){super(135)}compute($,ue,Ie){const Le=["monaco-editor"];return ue.get(36)&&Le.push(ue.get(36)),$.extraEditorClassName&&Le.push($.extraEditorClassName),ue.get(70)==="default"?Le.push("mouse-default"):ue.get(70)==="copy"&&Le.push("mouse-copy"),ue.get(105)&&Le.push("showUnused"),ue.get(133)&&Le.push("showDeprecated"),Le.join(" ")}}class q extends h{constructor(){super(34,"emptySelectionClipboard",!0,{description:o.localize(6,null)})}compute($,ue,Ie){return Ie&&$.emptySelectionClipboard}}class V extends P{constructor(){const $={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(38,"find",$,{"editor.find.cursorMoveOnType":{type:"boolean",default:$.cursorMoveOnType,description:o.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:$.seedSearchStringFromSelection,enumDescriptions:[o.localize(8,null),o.localize(9,null),o.localize(10,null)],description:o.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:$.autoFindInSelection,enumDescriptions:[o.localize(12,null),o.localize(13,null),o.localize(14,null)],description:o.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:$.globalFindClipboard,description:o.localize(16,null),included:t.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:$.addExtraSpaceOnTop,description:o.localize(17,null)},"editor.find.loop":{type:"boolean",default:$.loop,description:o.localize(18,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ue=$;return{cursorMoveOnType:d(ue.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof $.seedSearchStringFromSelection=="boolean"?$.seedSearchStringFromSelection?"always":"never":i(ue.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof $.autoFindInSelection=="boolean"?$.autoFindInSelection?"always":"never":i(ue.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:d(ue.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:d(ue.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:d(ue.loop,this.defaultValue.loop)}}}class F extends P{constructor(){super(48,"fontLigatures",F.OFF,{anyOf:[{type:"boolean",description:o.localize(19,null)},{type:"string",description:o.localize(20,null)}],description:o.localize(21,null),default:!1})}validate($){return typeof $>"u"?this.defaultValue:typeof $=="string"?$==="false"?F.OFF:$==="true"?F.ON:$:Boolean($)?F.ON:F.OFF}}e.EditorFontLigatures=F,F.OFF='"liga" off, "calt" off',F.ON='"liga" on, "calt" on';class U extends P{constructor(){super(51,"fontVariations",U.OFF,{anyOf:[{type:"boolean",description:o.localize(22,null)},{type:"string",description:o.localize(23,null)}],description:o.localize(24,null),default:!1})}validate($){return typeof $>"u"?this.defaultValue:typeof $=="string"?$==="false"?U.OFF:$==="true"?U.TRANSLATE:$:Boolean($)?U.TRANSLATE:U.OFF}compute($,ue,Ie){return $.fontInfo.fontVariationSettings}}e.EditorFontVariations=U,U.OFF="normal",U.TRANSLATE="translate";class N extends E{constructor(){super(47)}compute($,ue,Ie){return $.fontInfo}}class B extends f{constructor(){super(49,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:o.localize(25,null)})}validate($){const ue=p.float($,this.defaultValue);return ue===0?e.EDITOR_FONT_DEFAULTS.fontSize:p.clamp(ue,6,100)}compute($,ue,Ie){return $.fontInfo.fontSize}}class j extends P{constructor(){super(50,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:j.d,maximum:j.e,errorMessage:o.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:j.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:o.localize(27,null)})}validate($){return $==="normal"||$==="bold"?$:String(g.clampedInt($,e.EDITOR_FONT_DEFAULTS.fontWeight,j.d,j.e))}}j.c=["normal","bold","100","200","300","400","500","600","700","800","900"],j.d=1,j.e=1e3;class z extends P{constructor(){const $={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ue={type:"string",enum:["peek","gotoAndPeek","goto"],default:$.multiple,enumDescriptions:[o.localize(28,null),o.localize(29,null),o.localize(30,null)]},Ie=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(55,"gotoLocation",$,{"editor.gotoLocation.multiple":{deprecationMessage:o.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:o.localize(32,null),...ue},"editor.gotoLocation.multipleTypeDefinitions":{description:o.localize(33,null),...ue},"editor.gotoLocation.multipleDeclarations":{description:o.localize(34,null),...ue},"editor.gotoLocation.multipleImplementations":{description:o.localize(35,null),...ue},"editor.gotoLocation.multipleReferences":{description:o.localize(36,null),...ue},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:$.alternativeDefinitionCommand,enum:Ie,description:o.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:$.alternativeTypeDefinitionCommand,enum:Ie,description:o.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:$.alternativeDeclarationCommand,enum:Ie,description:o.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:$.alternativeImplementationCommand,enum:Ie,description:o.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:$.alternativeReferenceCommand,enum:Ie,description:o.localize(41,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ue=$;return{multiple:i(ue.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ue.multipleDefinitions??i(ue.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ue.multipleTypeDefinitions??i(ue.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ue.multipleDeclarations??i(ue.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ue.multipleImplementations??i(ue.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ue.multipleReferences??i(ue.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:w.string(ue.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:w.string(ue.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:w.string(ue.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:w.string(ue.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:w.string(ue.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ne extends P{constructor(){const $={enabled:!0,delay:300,sticky:!0,above:!0};super(57,"hover",$,{"editor.hover.enabled":{type:"boolean",default:$.enabled,description:o.localize(42,null)},"editor.hover.delay":{type:"number",default:$.delay,minimum:0,maximum:1e4,description:o.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:$.sticky,description:o.localize(44,null)},"editor.hover.above":{type:"boolean",default:$.above,description:o.localize(45,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ue=$;return{enabled:d(ue.enabled,this.defaultValue.enabled),delay:g.clampedInt(ue.delay,this.defaultValue.delay,0,1e4),sticky:d(ue.sticky,this.defaultValue.sticky),above:d(ue.above,this.defaultValue.above)}}}var _;(function(ce){ce[ce.None=0]="None",ce[ce.Text=1]="Text",ce[ce.Blocks=2]="Blocks"})(_=e.RenderMinimap||(e.RenderMinimap={}));class Y extends E{constructor(){super(138)}compute($,ue,Ie){return Y.computeLayout(ue,{memory:$.memory,outerWidth:$.outerWidth,outerHeight:$.outerHeight,isDominatedByLongLines:$.isDominatedByLongLines,lineHeight:$.fontInfo.lineHeight,viewLineCount:$.viewLineCount,lineNumbersDigitCount:$.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:$.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:$.fontInfo.maxDigitWidth,pixelRatio:$.pixelRatio})}static computeContainedMinimapLineCount($){const ue=$.height/$.lineHeight,Ie=Math.floor($.paddingTop/$.lineHeight);let Le=Math.floor($.paddingBottom/$.lineHeight);$.scrollBeyondLastLine&&(Le=Math.max(Le,ue-1));const Be=(Ie+$.viewLineCount+Le)/($.pixelRatio*$.height),xe=Math.floor($.viewLineCount/Be);return{typicalViewportLineCount:ue,extraLinesBeforeFirstLine:Ie,extraLinesBeyondLastLine:Le,desiredRatio:Be,minimapLineCount:xe}}static c($,ue){const Ie=$.outerWidth,Le=$.outerHeight,Be=$.pixelRatio;if(!$.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Be*Le),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Le};const xe=ue.stableMinimapLayoutInput,Ze=xe&&$.outerHeight===xe.outerHeight&&$.lineHeight===xe.lineHeight&&$.typicalHalfwidthCharacterWidth===xe.typicalHalfwidthCharacterWidth&&$.pixelRatio===xe.pixelRatio&&$.scrollBeyondLastLine===xe.scrollBeyondLastLine&&$.paddingTop===xe.paddingTop&&$.paddingBottom===xe.paddingBottom&&$.minimap.enabled===xe.minimap.enabled&&$.minimap.side===xe.minimap.side&&$.minimap.size===xe.minimap.size&&$.minimap.showSlider===xe.minimap.showSlider&&$.minimap.renderCharacters===xe.minimap.renderCharacters&&$.minimap.maxColumn===xe.minimap.maxColumn&&$.minimap.scale===xe.minimap.scale&&$.verticalScrollbarWidth===xe.verticalScrollbarWidth&&$.isViewportWrapping===xe.isViewportWrapping,gt=$.lineHeight,mt=$.typicalHalfwidthCharacterWidth,lt=$.scrollBeyondLastLine,ot=$.minimap.renderCharacters;let rt=Be>=2?Math.round($.minimap.scale*2):$.minimap.scale;const kt=$.minimap.maxColumn,Tt=$.minimap.size,Nt=$.minimap.side,pt=$.verticalScrollbarWidth,Dt=$.viewLineCount,zt=$.remainingWidth,Ft=$.isViewportWrapping,Xe=ot?2:3;let Mt=Math.floor(Be*Le);const Ut=Mt/Be;let Bt=!1,wt=!1,Pt=Xe*rt,Re=rt/Be,Oe=1;if(Tt==="fill"||Tt==="fit"){const{typicalViewportLineCount:tt,extraLinesBeforeFirstLine:St,extraLinesBeyondLastLine:Et,desiredRatio:Lt,minimapLineCount:vt}=Y.computeContainedMinimapLineCount({viewLineCount:Dt,scrollBeyondLastLine:lt,paddingTop:$.paddingTop,paddingBottom:$.paddingBottom,height:Le,lineHeight:gt,pixelRatio:Be});if(Dt/vt>1)Bt=!0,wt=!0,rt=1,Pt=1,Re=rt/Be;else{let ft=!1,Gt=rt+1;if(Tt==="fit"){const jt=Math.ceil((St+Dt+Et)*Pt);Ft&&Ze&&zt<=ue.stableFitRemainingWidth?(ft=!0,Gt=ue.stableFitMaxMinimapScale):ft=jt>Mt}if(Tt==="fill"||ft){Bt=!0;const jt=rt;Pt=Math.min(gt*Be,Math.max(1,Math.floor(1/Lt))),Ft&&Ze&&zt<=ue.stableFitRemainingWidth&&(Gt=ue.stableFitMaxMinimapScale),rt=Math.min(Gt,Math.max(1,Math.floor(Pt/Xe))),rt>jt&&(Oe=Math.min(2,rt/jt)),Re=rt/Be/Oe,Mt=Math.ceil(Math.max(tt,St+Dt+Et)*Pt),Ft?(ue.stableMinimapLayoutInput=$,ue.stableFitRemainingWidth=zt,ue.stableFitMaxMinimapScale=rt):(ue.stableMinimapLayoutInput=null,ue.stableFitRemainingWidth=0)}}}const Se=Math.floor(kt*Re),se=Math.min(Se,Math.max(0,Math.floor((zt-pt-2)*Re/(mt+Re)))+e.MINIMAP_GUTTER_WIDTH);let Ne=Math.floor(Be*se);const $e=Ne/Be;Ne=Math.floor(Ne*Oe);const Qe=ot?1:2,Ve=Nt==="left"?0:Ie-se-pt;return{renderMinimap:Qe,minimapLeft:Ve,minimapWidth:se,minimapHeightIsEditorHeight:Bt,minimapIsSampling:wt,minimapScale:rt,minimapLineHeight:Pt,minimapCanvasInnerWidth:Ne,minimapCanvasInnerHeight:Mt,minimapCanvasOuterWidth:$e,minimapCanvasOuterHeight:Ut}}static computeLayout($,ue){const Ie=ue.outerWidth|0,Le=ue.outerHeight|0,Be=ue.lineHeight|0,xe=ue.lineNumbersDigitCount|0,Ze=ue.typicalHalfwidthCharacterWidth,gt=ue.maxDigitWidth,mt=ue.pixelRatio,lt=ue.viewLineCount,ot=$.get(130),rt=ot==="inherit"?$.get(129):ot,kt=rt==="inherit"?$.get(125):rt,Tt=$.get(128),Nt=ue.isDominatedByLongLines,pt=$.get(54),Dt=$.get(64).renderType!==0,zt=$.get(65),Ft=$.get(99),Xe=$.get(80),Mt=$.get(69),Ut=$.get(97),Bt=Ut.verticalScrollbarSize,wt=Ut.verticalHasArrows,Pt=Ut.arrowSize,Re=Ut.horizontalScrollbarSize,Oe=$.get(40),Se=$.get(104)!=="never";let se=$.get(62);Oe&&Se&&(se+=16);let Ne=0;if(Dt){const _t=Math.max(xe,zt);Ne=Math.round(_t*gt)}let $e=0;pt&&($e=Be);let Qe=0,Ve=Qe+$e,tt=Ve+Ne,St=tt+se;const Et=Ie-$e-Ne-se;let Lt=!1,vt=!1,It=-1;rt==="inherit"&&Nt?(Lt=!0,vt=!0):kt==="on"||kt==="bounded"?vt=!0:kt==="wordWrapColumn"&&(It=Tt);const ft=Y.c({outerWidth:Ie,outerHeight:Le,lineHeight:Be,typicalHalfwidthCharacterWidth:Ze,pixelRatio:mt,scrollBeyondLastLine:Ft,paddingTop:Xe.top,paddingBottom:Xe.bottom,minimap:Mt,verticalScrollbarWidth:Bt,viewLineCount:lt,remainingWidth:Et,isViewportWrapping:vt},ue.memory||new L);ft.renderMinimap!==0&&ft.minimapLeft===0&&(Qe+=ft.minimapWidth,Ve+=ft.minimapWidth,tt+=ft.minimapWidth,St+=ft.minimapWidth);const Gt=Et-ft.minimapWidth,jt=Math.max(1,Math.floor((Gt-Bt-2)/Ze)),yt=wt?Pt:0;return vt&&(It=Math.max(1,jt),kt==="bounded"&&(It=Math.min(It,Tt))),{width:Ie,height:Le,glyphMarginLeft:Qe,glyphMarginWidth:$e,lineNumbersLeft:Ve,lineNumbersWidth:Ne,decorationsLeft:tt,decorationsWidth:se,contentLeft:St,contentWidth:Gt,minimap:ft,viewportColumn:jt,isWordWrapMinified:Lt,isViewportWrapping:vt,wrappingColumn:It,verticalScrollbarWidth:Bt,horizontalScrollbarHeight:Re,overviewRuler:{top:yt,width:Bt,height:Le-2*yt,right:0}}}}e.EditorLayoutInfoComputer=Y;class J extends P{constructor(){super(132,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[o.localize(46,null),o.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:o.localize(48,null)}})}validate($){return i($,"simple",["simple","advanced"])}compute($,ue,Ie){return ue.get(2)===2?"advanced":Ie}}class Z extends P{constructor(){const $={enabled:!0};super(61,"lightbulb",$,{"editor.lightbulb.enabled":{type:"boolean",default:$.enabled,description:o.localize(49,null)}})}validate($){return!$||typeof $!="object"?this.defaultValue:{enabled:d($.enabled,this.defaultValue.enabled)}}}class ie extends P{constructor(){const $={enabled:!1,maxLineCount:5};super(109,"stickyScroll",$,{"editor.stickyScroll.enabled":{type:"boolean",default:$.enabled,description:o.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:$.maxLineCount,minimum:1,maximum:10,description:o.localize(51,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ue=$;return{enabled:d(ue.enabled,this.defaultValue.enabled),maxLineCount:g.clampedInt(ue.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class X extends P{constructor(){const $={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(134,"inlayHints",$,{"editor.inlayHints.enabled":{type:"string",default:$.enabled,description:o.localize(52,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[o.localize(53,null),o.localize(54,null,t.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),o.localize(55,null,t.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),o.localize(56,null)]},"editor.inlayHints.fontSize":{type:"number",default:$.fontSize,markdownDescription:o.localize(57,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:$.fontFamily,markdownDescription:o.localize(58,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:$.padding,description:o.localize(59,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ue=$;return typeof ue.enabled=="boolean"&&(ue.enabled=ue.enabled?"on":"off"),{enabled:i(ue.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:g.clampedInt(ue.fontSize,this.defaultValue.fontSize,0,100),fontFamily:w.string(ue.fontFamily,this.defaultValue.fontFamily),padding:d(ue.padding,this.defaultValue.padding)}}}class K extends P{constructor(){super(62,"lineDecorationsWidth",10)}validate($){return typeof $=="string"&&/^\d+(\.\d+)?ch$/.test($)?-parseFloat($.substring(0,$.length-2)):g.clampedInt($,this.defaultValue,0,1e3)}compute($,ue,Ie){return Ie<0?g.clampedInt(-Ie*$.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ie}}class he extends p{constructor(){super(63,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,$=>p.clamp($,0,150),{markdownDescription:o.localize(60,null)})}compute($,ue,Ie){return $.fontInfo.lineHeight}}class be extends P{constructor(){const $={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(69,"minimap",$,{"editor.minimap.enabled":{type:"boolean",default:$.enabled,description:o.localize(61,null)},"editor.minimap.autohide":{type:"boolean",default:$.autohide,description:o.localize(62,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[o.localize(63,null),o.localize(64,null),o.localize(65,null)],default:$.size,description:o.localize(66,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:$.side,description:o.localize(67,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:$.showSlider,description:o.localize(68,null)},"editor.minimap.scale":{type:"number",default:$.scale,minimum:1,maximum:3,enum:[1,2,3],description:o.localize(69,null)},"editor.minimap.renderCharacters":{type:"boolean",default:$.renderCharacters,description:o.localize(70,null)},"editor.minimap.maxColumn":{type:"number",default:$.maxColumn,description:o.localize(71,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ue=$;return{enabled:d(ue.enabled,this.defaultValue.enabled),autohide:d(ue.autohide,this.defaultValue.autohide),size:i(ue.size,this.defaultValue.size,["proportional","fill","fit"]),side:i(ue.side,this.defaultValue.side,["right","left"]),showSlider:i(ue.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:d(ue.renderCharacters,this.defaultValue.renderCharacters),scale:g.clampedInt(ue.scale,1,1,3),maxColumn:g.clampedInt(ue.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Ee(ce){return ce==="ctrlCmd"?t.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Pe extends P{constructor(){super(80,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:o.localize(72,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:o.localize(73,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ue=$;return{top:g.clampedInt(ue.top,0,0,1e3),bottom:g.clampedInt(ue.bottom,0,0,1e3)}}}class Me extends P{constructor(){const $={enabled:!0,cycle:!0};super(81,"parameterHints",$,{"editor.parameterHints.enabled":{type:"boolean",default:$.enabled,description:o.localize(74,null)},"editor.parameterHints.cycle":{type:"boolean",default:$.cycle,description:o.localize(75,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ue=$;return{enabled:d(ue.enabled,this.defaultValue.enabled),cycle:d(ue.cycle,this.defaultValue.cycle)}}}class oe extends E{constructor(){super(136)}compute($,ue,Ie){return $.pixelRatio}}class ae extends P{constructor(){const $={other:"on",comments:"off",strings:"off"},ue=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[o.localize(76,null),o.localize(77,null),o.localize(78,null)]}];super(84,"quickSuggestions",$,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ue,default:$.strings,description:o.localize(79,null)},comments:{anyOf:ue,default:$.comments,description:o.localize(80,null)},other:{anyOf:ue,default:$.other,description:o.localize(81,null)}},default:$,markdownDescription:o.localize(82,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=$}validate($){if(typeof $=="boolean"){const mt=$?"on":"off";return{comments:mt,strings:mt,other:mt}}if(!$||typeof $!="object")return this.defaultValue;const{other:ue,comments:Ie,strings:Le}=$,Be=["on","inline","off"];let xe,Ze,gt;return typeof ue=="boolean"?xe=ue?"on":"off":xe=i(ue,this.defaultValue.other,Be),typeof Ie=="boolean"?Ze=Ie?"on":"off":Ze=i(Ie,this.defaultValue.comments,Be),typeof Le=="boolean"?gt=Le?"on":"off":gt=i(Le,this.defaultValue.strings,Be),{other:xe,comments:Ze,strings:gt}}}var fe;(function(ce){ce[ce.Off=0]="Off",ce[ce.On=1]="On",ce[ce.Relative=2]="Relative",ce[ce.Interval=3]="Interval",ce[ce.Custom=4]="Custom"})(fe=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class ee extends P{constructor(){super(64,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[o.localize(83,null),o.localize(84,null),o.localize(85,null),o.localize(86,null)],default:"on",description:o.localize(87,null)})}validate($){let ue=this.defaultValue.renderType,Ie=this.defaultValue.renderFn;return typeof $<"u"&&(typeof $=="function"?(ue=4,Ie=$):$==="interval"?ue=3:$==="relative"?ue=2:$==="on"?ue=1:ue=0),{renderType:ue,renderFn:Ie}}}function le(ce){const $=ce.get(92);return $==="editable"?ce.get(86):$!=="on"}e.filterValidationDecorations=le;class re extends P{constructor(){const $=[],ue={type:"number",description:o.localize(88,null)};super(96,"rulers",$,{type:"array",items:{anyOf:[ue,{type:["object"],properties:{column:ue,color:{type:"string",description:o.localize(89,null),format:"color-hex"}}}]},default:$,description:o.localize(90,null)})}validate($){if(Array.isArray($)){const ue=[];for(const Ie of $)if(typeof Ie=="number")ue.push({column:g.clampedInt(Ie,0,0,1e4),color:null});else if(Ie&&typeof Ie=="object"){const Le=Ie;ue.push({column:g.clampedInt(Le.column,0,0,1e4),color:Le.color})}return ue.sort((Ie,Le)=>Ie.column-Le.column),ue}return this.defaultValue}}function O(ce,$){if(typeof ce!="string")return $;switch(ce){case"hidden":return 2;case"visible":return 3;default:return 1}}class H extends P{constructor(){const $={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(97,"scrollbar",$,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[o.localize(91,null),o.localize(92,null),o.localize(93,null)],default:"auto",description:o.localize(94,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[o.localize(95,null),o.localize(96,null),o.localize(97,null)],default:"auto",description:o.localize(98,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:$.verticalScrollbarSize,description:o.localize(99,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:$.horizontalScrollbarSize,description:o.localize(100,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:$.scrollByPage,description:o.localize(101,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ue=$,Ie=g.clampedInt(ue.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Le=g.clampedInt(ue.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:g.clampedInt(ue.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:O(ue.vertical,this.defaultValue.vertical),horizontal:O(ue.horizontal,this.defaultValue.horizontal),useShadows:d(ue.useShadows,this.defaultValue.useShadows),verticalHasArrows:d(ue.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:d(ue.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:d(ue.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:d(ue.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ie,horizontalSliderSize:g.clampedInt(ue.horizontalSliderSize,Ie,0,1e3),verticalScrollbarSize:Le,verticalSliderSize:g.clampedInt(ue.verticalSliderSize,Le,0,1e3),scrollByPage:d(ue.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class x extends P{constructor(){const $={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(119,"unicodeHighlight",$,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:$.nonBasicASCII,description:o.localize(102,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:$.invisibleCharacters,description:o.localize(103,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:$.ambiguousCharacters,description:o.localize(104,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:$.includeComments,description:o.localize(105,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:$.includeStrings,description:o.localize(106,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:$.allowedCharacters,description:o.localize(107,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:$.allowedLocales,description:o.localize(108,null)}})}applyUpdate($,ue){let Ie=!1;ue.allowedCharacters&&$&&(I.equals($.allowedCharacters,ue.allowedCharacters)||($={...$,allowedCharacters:ue.allowedCharacters},Ie=!0)),ue.allowedLocales&&$&&(I.equals($.allowedLocales,ue.allowedLocales)||($={...$,allowedLocales:ue.allowedLocales},Ie=!0));const Le=super.applyUpdate($,ue);return Ie?new v(Le.newValue,!0):Le}validate($){if(!$||typeof $!="object")return this.defaultValue;const ue=$;return{nonBasicASCII:Ae(ue.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:d(ue.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:d(ue.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Ae(ue.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Ae(ue.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c($.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c($.allowedLocales,this.defaultValue.allowedLocales)}}c($,ue){if(typeof $!="object"||!$)return ue;const Ie={};for(const[Le,Be]of Object.entries($))Be===!0&&(Ie[Le]=!0);return Ie}}class Q extends P{constructor(){const $={enabled:!0,mode:"subwordSmart"};super(59,"inlineSuggest",$,{"editor.inlineSuggest.enabled":{type:"boolean",default:$.enabled,description:o.localize(109,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ue=$;return{enabled:d(ue.enabled,this.defaultValue.enabled),mode:i(ue.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class de extends P{constructor(){const $={enabled:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",$,{"editor.bracketPairColorization.enabled":{type:"boolean",default:$.enabled,markdownDescription:o.localize(110,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:$.independentColorPoolPerBracketType,description:o.localize(111,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ue=$;return{enabled:d(ue.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:d(ue.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class we extends P{constructor(){const $={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",$,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[o.localize(112,null),o.localize(113,null),o.localize(114,null)],default:$.bracketPairs,description:o.localize(115,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[o.localize(116,null),o.localize(117,null),o.localize(118,null)],default:$.bracketPairsHorizontal,description:o.localize(119,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:$.highlightActiveBracketPair,description:o.localize(120,null)},"editor.guides.indentation":{type:"boolean",default:$.indentation,description:o.localize(121,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[o.localize(122,null),o.localize(123,null),o.localize(124,null)],default:$.highlightActiveIndentation,description:o.localize(125,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ue=$;return{bracketPairs:Ae(ue.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Ae(ue.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:d(ue.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:d(ue.indentation,this.defaultValue.indentation),highlightActiveIndentation:Ae(ue.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Ae(ce,$,ue){const Ie=ue.indexOf(ce);return Ie===-1?$:ue[Ie]}class pe extends P{constructor(){const $={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(112,"suggest",$,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[o.localize(126,null),o.localize(127,null)],default:$.insertMode,description:o.localize(128,null)},"editor.suggest.filterGraceful":{type:"boolean",default:$.filterGraceful,description:o.localize(129,null)},"editor.suggest.localityBonus":{type:"boolean",default:$.localityBonus,description:o.localize(130,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:$.shareSuggestSelections,markdownDescription:o.localize(131,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[o.localize(132,null),o.localize(133,null),o.localize(134,null),o.localize(135,null)],default:$.selectionMode,markdownDescription:o.localize(136,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:$.snippetsPreventQuickSuggestions,description:o.localize(137,null)},"editor.suggest.showIcons":{type:"boolean",default:$.showIcons,description:o.localize(138,null)},"editor.suggest.showStatusBar":{type:"boolean",default:$.showStatusBar,description:o.localize(139,null)},"editor.suggest.preview":{type:"boolean",default:$.preview,description:o.localize(140,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:$.showInlineDetails,description:o.localize(141,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:o.localize(142,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:o.localize(143,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:o.localize(144,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:o.localize(145,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:o.localize(146,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:o.localize(147,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:o.localize(148,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:o.localize(149,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:o.localize(150,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:o.localize(151,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:o.localize(152,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:o.localize(153,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:o.localize(154,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:o.localize(155,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:o.localize(156,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:o.localize(157,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:o.localize(158,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:o.localize(159,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:o.localize(160,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:o.localize(161,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:o.localize(162,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:o.localize(163,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:o.localize(164,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:o.localize(165,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:o.localize(166,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:o.localize(167,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:o.localize(168,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:o.localize(169,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:o.localize(170,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:o.localize(171,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:o.localize(172,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:o.localize(173,null)}})}validate($){if(!$||typeof $!="object")return this.defaultValue;const ue=$;return{insertMode:i(ue.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:d(ue.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:d(ue.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:d(ue.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:d(ue.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:i(ue.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:d(ue.showIcons,this.defaultValue.showIcons),showStatusBar:d(ue.showStatusBar,this.defaultValue.showStatusBar),preview:d(ue.preview,this.defaultValue.preview),previewMode:i(ue.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:d(ue.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:d(ue.showMethods,this.defaultValue.showMethods),showFunctions:d(ue.showFunctions,this.defaultValue.showFunctions),showConstructors:d(ue.showConstructors,this.defaultValue.showConstructors),showDeprecated:d(ue.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:d(ue.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:d(ue.showFields,this.defaultValue.showFields),showVariables:d(ue.showVariables,this.defaultValue.showVariables),showClasses:d(ue.showClasses,this.defaultValue.showClasses),showStructs:d(ue.showStructs,this.defaultValue.showStructs),showInterfaces:d(ue.showInterfaces,this.defaultValue.showInterfaces),showModules:d(ue.showModules,this.defaultValue.showModules),showProperties:d(ue.showProperties,this.defaultValue.showProperties),showEvents:d(ue.showEvents,this.defaultValue.showEvents),showOperators:d(ue.showOperators,this.defaultValue.showOperators),showUnits:d(ue.showUnits,this.defaultValue.showUnits),showValues:d(ue.showValues,this.defaultValue.showValues),showConstants:d(ue.showConstants,this.defaultValue.showConstants),showEnums:d(ue.showEnums,this.defaultValue.showEnums),showEnumMembers:d(ue.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:d(ue.showKeywords,this.defaultValue.showKeywords),showWords:d(ue.showWords,this.defaultValue.showWords),showColors:d(ue.showColors,this.defaultValue.showColors),showFiles:d(ue.showFiles,this.defaultValue.showFiles),showReferences:d(ue.showReferences,this.defaultValue.showReferences),showFolders:d(ue.showFolders,this.defaultValue.showFolders),showTypeParameters:d(ue.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:d(ue.showSnippets,this.defaultValue.showSnippets),showUsers:d(ue.showUsers,this.defaultValue.showUsers),showIssues:d(ue.showIssues,this.defaultValue.showIssues)}}}class De extends P{constructor(){super(107,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:o.localize(174,null),default:!0,type:"boolean"}})}validate($){return!$||typeof $!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:d($.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ke extends E{constructor(){super(137)}compute($,ue,Ie){return ue.get(86)?!0:$.tabFocusMode}}var je;(function(ce){ce[ce.None=0]="None",ce[ce.Same=1]="Same",ce[ce.Indent=2]="Indent",ce[ce.DeepIndent=3]="DeepIndent"})(je=e.WrappingIndent||(e.WrappingIndent={}));class Ge extends P{constructor(){super(131,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[o.localize(175,null),o.localize(176,null),o.localize(177,null),o.localize(178,null)],description:o.localize(179,null),default:"same"}})}validate($){switch($){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute($,ue,Ie){return ue.get(2)===2?0:Ie}}class et extends E{constructor(){super(139)}compute($,ue,Ie){const Le=ue.get(138);return{isDominatedByLongLines:$.isDominatedByLongLines,isWordWrapMinified:Le.isWordWrapMinified,isViewportWrapping:Le.isViewportWrapping,wrappingColumn:Le.wrappingColumn}}}class _e extends P{constructor(){const $={enabled:!0};super(33,"dropIntoEditor",$,{"editor.dropIntoEditor.enabled":{type:"boolean",default:$.enabled,markdownDescription:o.localize(180,null)}})}validate($){return!$||typeof $!="object"?this.defaultValue:{enabled:d($.enabled,this.defaultValue.enabled)}}}const nt="Consolas, 'Courier New', monospace",st="Menlo, Monaco, 'Courier New', monospace",ht="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:t.isMacintosh?st:t.isLinux?ht:nt,fontWeight:"normal",fontSize:t.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Fe(ce){return e.editorOptionsRegistry[ce.id]=ce,ce}var it;(function(ce){ce[ce.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ce[ce.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ce[ce.accessibilitySupport=2]="accessibilitySupport",ce[ce.accessibilityPageSize=3]="accessibilityPageSize",ce[ce.ariaLabel=4]="ariaLabel",ce[ce.autoClosingBrackets=5]="autoClosingBrackets",ce[ce.autoClosingDelete=6]="autoClosingDelete",ce[ce.autoClosingOvertype=7]="autoClosingOvertype",ce[ce.autoClosingQuotes=8]="autoClosingQuotes",ce[ce.autoIndent=9]="autoIndent",ce[ce.automaticLayout=10]="automaticLayout",ce[ce.autoSurround=11]="autoSurround",ce[ce.bracketPairColorization=12]="bracketPairColorization",ce[ce.guides=13]="guides",ce[ce.codeLens=14]="codeLens",ce[ce.codeLensFontFamily=15]="codeLensFontFamily",ce[ce.codeLensFontSize=16]="codeLensFontSize",ce[ce.colorDecorators=17]="colorDecorators",ce[ce.colorDecoratorsLimit=18]="colorDecoratorsLimit",ce[ce.columnSelection=19]="columnSelection",ce[ce.comments=20]="comments",ce[ce.contextmenu=21]="contextmenu",ce[ce.copyWithSyntaxHighlighting=22]="copyWithSyntaxHighlighting",ce[ce.cursorBlinking=23]="cursorBlinking",ce[ce.cursorSmoothCaretAnimation=24]="cursorSmoothCaretAnimation",ce[ce.cursorStyle=25]="cursorStyle",ce[ce.cursorSurroundingLines=26]="cursorSurroundingLines",ce[ce.cursorSurroundingLinesStyle=27]="cursorSurroundingLinesStyle",ce[ce.cursorWidth=28]="cursorWidth",ce[ce.disableLayerHinting=29]="disableLayerHinting",ce[ce.disableMonospaceOptimizations=30]="disableMonospaceOptimizations",ce[ce.domReadOnly=31]="domReadOnly",ce[ce.dragAndDrop=32]="dragAndDrop",ce[ce.dropIntoEditor=33]="dropIntoEditor",ce[ce.emptySelectionClipboard=34]="emptySelectionClipboard",ce[ce.experimentalWhitespaceRendering=35]="experimentalWhitespaceRendering",ce[ce.extraEditorClassName=36]="extraEditorClassName",ce[ce.fastScrollSensitivity=37]="fastScrollSensitivity",ce[ce.find=38]="find",ce[ce.fixedOverflowWidgets=39]="fixedOverflowWidgets",ce[ce.folding=40]="folding",ce[ce.foldingStrategy=41]="foldingStrategy",ce[ce.foldingHighlight=42]="foldingHighlight",ce[ce.foldingImportsByDefault=43]="foldingImportsByDefault",ce[ce.foldingMaximumRegions=44]="foldingMaximumRegions",ce[ce.unfoldOnClickAfterEndOfLine=45]="unfoldOnClickAfterEndOfLine",ce[ce.fontFamily=46]="fontFamily",ce[ce.fontInfo=47]="fontInfo",ce[ce.fontLigatures=48]="fontLigatures",ce[ce.fontSize=49]="fontSize",ce[ce.fontWeight=50]="fontWeight",ce[ce.fontVariations=51]="fontVariations",ce[ce.formatOnPaste=52]="formatOnPaste",ce[ce.formatOnType=53]="formatOnType",ce[ce.glyphMargin=54]="glyphMargin",ce[ce.gotoLocation=55]="gotoLocation",ce[ce.hideCursorInOverviewRuler=56]="hideCursorInOverviewRuler",ce[ce.hover=57]="hover",ce[ce.inDiffEditor=58]="inDiffEditor",ce[ce.inlineSuggest=59]="inlineSuggest",ce[ce.letterSpacing=60]="letterSpacing",ce[ce.lightbulb=61]="lightbulb",ce[ce.lineDecorationsWidth=62]="lineDecorationsWidth",ce[ce.lineHeight=63]="lineHeight",ce[ce.lineNumbers=64]="lineNumbers",ce[ce.lineNumbersMinChars=65]="lineNumbersMinChars",ce[ce.linkedEditing=66]="linkedEditing",ce[ce.links=67]="links",ce[ce.matchBrackets=68]="matchBrackets",ce[ce.minimap=69]="minimap",ce[ce.mouseStyle=70]="mouseStyle",ce[ce.mouseWheelScrollSensitivity=71]="mouseWheelScrollSensitivity",ce[ce.mouseWheelZoom=72]="mouseWheelZoom",ce[ce.multiCursorMergeOverlapping=73]="multiCursorMergeOverlapping",ce[ce.multiCursorModifier=74]="multiCursorModifier",ce[ce.multiCursorPaste=75]="multiCursorPaste",ce[ce.multiCursorLimit=76]="multiCursorLimit",ce[ce.occurrencesHighlight=77]="occurrencesHighlight",ce[ce.overviewRulerBorder=78]="overviewRulerBorder",ce[ce.overviewRulerLanes=79]="overviewRulerLanes",ce[ce.padding=80]="padding",ce[ce.parameterHints=81]="parameterHints",ce[ce.peekWidgetDefaultFocus=82]="peekWidgetDefaultFocus",ce[ce.definitionLinkOpensInPeek=83]="definitionLinkOpensInPeek",ce[ce.quickSuggestions=84]="quickSuggestions",ce[ce.quickSuggestionsDelay=85]="quickSuggestionsDelay",ce[ce.readOnly=86]="readOnly",ce[ce.renameOnType=87]="renameOnType",ce[ce.renderControlCharacters=88]="renderControlCharacters",ce[ce.renderFinalNewline=89]="renderFinalNewline",ce[ce.renderLineHighlight=90]="renderLineHighlight",ce[ce.renderLineHighlightOnlyWhenFocus=91]="renderLineHighlightOnlyWhenFocus",ce[ce.renderValidationDecorations=92]="renderValidationDecorations",ce[ce.renderWhitespace=93]="renderWhitespace",ce[ce.revealHorizontalRightPadding=94]="revealHorizontalRightPadding",ce[ce.roundedSelection=95]="roundedSelection",ce[ce.rulers=96]="rulers",ce[ce.scrollbar=97]="scrollbar",ce[ce.scrollBeyondLastColumn=98]="scrollBeyondLastColumn",ce[ce.scrollBeyondLastLine=99]="scrollBeyondLastLine",ce[ce.scrollPredominantAxis=100]="scrollPredominantAxis",ce[ce.selectionClipboard=101]="selectionClipboard",ce[ce.selectionHighlight=102]="selectionHighlight",ce[ce.selectOnLineNumbers=103]="selectOnLineNumbers",ce[ce.showFoldingControls=104]="showFoldingControls",ce[ce.showUnused=105]="showUnused",ce[ce.snippetSuggestions=106]="snippetSuggestions",ce[ce.smartSelect=107]="smartSelect",ce[ce.smoothScrolling=108]="smoothScrolling",ce[ce.stickyScroll=109]="stickyScroll",ce[ce.stickyTabStops=110]="stickyTabStops",ce[ce.stopRenderingLineAfter=111]="stopRenderingLineAfter",ce[ce.suggest=112]="suggest",ce[ce.suggestFontSize=113]="suggestFontSize",ce[ce.suggestLineHeight=114]="suggestLineHeight",ce[ce.suggestOnTriggerCharacters=115]="suggestOnTriggerCharacters",ce[ce.suggestSelection=116]="suggestSelection",ce[ce.tabCompletion=117]="tabCompletion",ce[ce.tabIndex=118]="tabIndex",ce[ce.unicodeHighlighting=119]="unicodeHighlighting",ce[ce.unusualLineTerminators=120]="unusualLineTerminators",ce[ce.useShadowDOM=121]="useShadowDOM",ce[ce.useTabStops=122]="useTabStops",ce[ce.wordBreak=123]="wordBreak",ce[ce.wordSeparators=124]="wordSeparators",ce[ce.wordWrap=125]="wordWrap",ce[ce.wordWrapBreakAfterCharacters=126]="wordWrapBreakAfterCharacters",ce[ce.wordWrapBreakBeforeCharacters=127]="wordWrapBreakBeforeCharacters",ce[ce.wordWrapColumn=128]="wordWrapColumn",ce[ce.wordWrapOverride1=129]="wordWrapOverride1",ce[ce.wordWrapOverride2=130]="wordWrapOverride2",ce[ce.wrappingIndent=131]="wrappingIndent",ce[ce.wrappingStrategy=132]="wrappingStrategy",ce[ce.showDeprecated=133]="showDeprecated",ce[ce.inlayHints=134]="inlayHints",ce[ce.editorClassName=135]="editorClassName",ce[ce.pixelRatio=136]="pixelRatio",ce[ce.tabFocusMode=137]="tabFocusMode",ce[ce.layoutInfo=138]="layoutInfo",ce[ce.wrappingInfo=139]="wrappingInfo"})(it=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Fe(new h(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:o.localize(181,null)})),acceptSuggestionOnEnter:Fe(new s(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",o.localize(182,null),""],markdownDescription:o.localize(183,null)})),accessibilitySupport:Fe(new l),accessibilityPageSize:Fe(new g(3,"accessibilityPageSize",10,1,1073741824,{description:o.localize(184,null),tags:["accessibility"]})),ariaLabel:Fe(new w(4,"ariaLabel",o.localize(185,null))),autoClosingBrackets:Fe(new s(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",o.localize(186,null),o.localize(187,null),""],description:o.localize(188,null)})),autoClosingDelete:Fe(new s(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",o.localize(189,null),""],description:o.localize(190,null)})),autoClosingOvertype:Fe(new s(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",o.localize(191,null),""],description:o.localize(192,null)})),autoClosingQuotes:Fe(new s(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",o.localize(193,null),o.localize(194,null),""],description:o.localize(195,null)})),autoIndent:Fe(new a(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],u,{enumDescriptions:[o.localize(196,null),o.localize(197,null),o.localize(198,null),o.localize(199,null),o.localize(200,null)],description:o.localize(201,null)})),automaticLayout:Fe(new h(10,"automaticLayout",!1)),autoSurround:Fe(new s(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[o.localize(202,null),o.localize(203,null),o.localize(204,null),""],description:o.localize(205,null)})),bracketPairColorization:Fe(new de),bracketPairGuides:Fe(new we),stickyTabStops:Fe(new h(110,"stickyTabStops",!1,{description:o.localize(206,null)})),codeLens:Fe(new h(14,"codeLens",!0,{description:o.localize(207,null)})),codeLensFontFamily:Fe(new w(15,"codeLensFontFamily","",{description:o.localize(208,null)})),codeLensFontSize:Fe(new g(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:o.localize(209,null)})),colorDecorators:Fe(new h(17,"colorDecorators",!0,{description:o.localize(210,null)})),colorDecoratorsLimit:Fe(new g(18,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:o.localize(211,null)})),columnSelection:Fe(new h(19,"columnSelection",!1,{description:o.localize(212,null)})),comments:Fe(new c),contextmenu:Fe(new h(21,"contextmenu",!0)),copyWithSyntaxHighlighting:Fe(new h(22,"copyWithSyntaxHighlighting",!0,{description:o.localize(213,null)})),cursorBlinking:Fe(new a(23,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],r,{description:o.localize(214,null)})),cursorSmoothCaretAnimation:Fe(new s(24,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[o.localize(215,null),o.localize(216,null),o.localize(217,null)],description:o.localize(218,null)})),cursorStyle:Fe(new a(25,"cursorStyle",m.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],k,{description:o.localize(219,null)})),cursorSurroundingLines:Fe(new g(26,"cursorSurroundingLines",0,0,1073741824,{description:o.localize(220,null)})),cursorSurroundingLinesStyle:Fe(new s(27,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[o.localize(221,null),o.localize(222,null)],description:o.localize(223,null)})),cursorWidth:Fe(new g(28,"cursorWidth",0,0,1073741824,{markdownDescription:o.localize(224,null)})),disableLayerHinting:Fe(new h(29,"disableLayerHinting",!1)),disableMonospaceOptimizations:Fe(new h(30,"disableMonospaceOptimizations",!1)),domReadOnly:Fe(new h(31,"domReadOnly",!1)),dragAndDrop:Fe(new h(32,"dragAndDrop",!0,{description:o.localize(225,null)})),emptySelectionClipboard:Fe(new q),dropIntoEditor:Fe(new _e),stickyScroll:Fe(new ie),experimentalWhitespaceRendering:Fe(new s(35,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[o.localize(226,null),o.localize(227,null),o.localize(228,null)],description:o.localize(229,null)})),extraEditorClassName:Fe(new w(36,"extraEditorClassName","")),fastScrollSensitivity:Fe(new p(37,"fastScrollSensitivity",5,ce=>ce<=0?5:ce,{markdownDescription:o.localize(230,null)})),find:Fe(new V),fixedOverflowWidgets:Fe(new h(39,"fixedOverflowWidgets",!1)),folding:Fe(new h(40,"folding",!0,{description:o.localize(231,null)})),foldingStrategy:Fe(new s(41,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[o.localize(232,null),o.localize(233,null)],description:o.localize(234,null)})),foldingHighlight:Fe(new h(42,"foldingHighlight",!0,{description:o.localize(235,null)})),foldingImportsByDefault:Fe(new h(43,"foldingImportsByDefault",!1,{description:o.localize(236,null)})),foldingMaximumRegions:Fe(new g(44,"foldingMaximumRegions",5e3,10,65e3,{description:o.localize(237,null)})),unfoldOnClickAfterEndOfLine:Fe(new h(45,"unfoldOnClickAfterEndOfLine",!1,{description:o.localize(238,null)})),fontFamily:Fe(new w(46,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:o.localize(239,null)})),fontInfo:Fe(new N),fontLigatures2:Fe(new F),fontSize:Fe(new B),fontWeight:Fe(new j),fontVariations:Fe(new U),formatOnPaste:Fe(new h(52,"formatOnPaste",!1,{description:o.localize(240,null)})),formatOnType:Fe(new h(53,"formatOnType",!1,{description:o.localize(241,null)})),glyphMargin:Fe(new h(54,"glyphMargin",!0,{description:o.localize(242,null)})),gotoLocation:Fe(new z),hideCursorInOverviewRuler:Fe(new h(56,"hideCursorInOverviewRuler",!1,{description:o.localize(243,null)})),hover:Fe(new ne),inDiffEditor:Fe(new h(58,"inDiffEditor",!1)),letterSpacing:Fe(new p(60,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ce=>p.clamp(ce,-5,20),{description:o.localize(244,null)})),lightbulb:Fe(new Z),lineDecorationsWidth:Fe(new K),lineHeight:Fe(new he),lineNumbers:Fe(new ee),lineNumbersMinChars:Fe(new g(65,"lineNumbersMinChars",5,1,300)),linkedEditing:Fe(new h(66,"linkedEditing",!1,{description:o.localize(245,null)})),links:Fe(new h(67,"links",!0,{description:o.localize(246,null)})),matchBrackets:Fe(new s(68,"matchBrackets","always",["always","near","never"],{description:o.localize(247,null)})),minimap:Fe(new be),mouseStyle:Fe(new s(70,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Fe(new p(71,"mouseWheelScrollSensitivity",1,ce=>ce===0?1:ce,{markdownDescription:o.localize(248,null)})),mouseWheelZoom:Fe(new h(72,"mouseWheelZoom",!1,{markdownDescription:o.localize(249,null)})),multiCursorMergeOverlapping:Fe(new h(73,"multiCursorMergeOverlapping",!0,{description:o.localize(250,null)})),multiCursorModifier:Fe(new a(74,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Ee,{markdownEnumDescriptions:[o.localize(251,null),o.localize(252,null)],markdownDescription:o.localize(253,null)})),multiCursorPaste:Fe(new s(75,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[o.localize(254,null),o.localize(255,null)],markdownDescription:o.localize(256,null)})),multiCursorLimit:Fe(new g(76,"multiCursorLimit",1e4,1,1e5,{markdownDescription:o.localize(257,null)})),occurrencesHighlight:Fe(new h(77,"occurrencesHighlight",!0,{description:o.localize(258,null)})),overviewRulerBorder:Fe(new h(78,"overviewRulerBorder",!0,{description:o.localize(259,null)})),overviewRulerLanes:Fe(new g(79,"overviewRulerLanes",3,0,3)),padding:Fe(new Pe),parameterHints:Fe(new Me),peekWidgetDefaultFocus:Fe(new s(82,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[o.localize(260,null),o.localize(261,null)],description:o.localize(262,null)})),definitionLinkOpensInPeek:Fe(new h(83,"definitionLinkOpensInPeek",!1,{description:o.localize(263,null)})),quickSuggestions:Fe(new ae),quickSuggestionsDelay:Fe(new g(85,"quickSuggestionsDelay",10,0,1073741824,{description:o.localize(264,null)})),readOnly:Fe(new h(86,"readOnly",!1)),renameOnType:Fe(new h(87,"renameOnType",!1,{description:o.localize(265,null),markdownDeprecationMessage:o.localize(266,null)})),renderControlCharacters:Fe(new h(88,"renderControlCharacters",!0,{description:o.localize(267,null),restricted:!0})),renderFinalNewline:Fe(new s(89,"renderFinalNewline",t.isLinux?"dimmed":"on",["off","on","dimmed"],{description:o.localize(268,null)})),renderLineHighlight:Fe(new s(90,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",o.localize(269,null)],description:o.localize(270,null)})),renderLineHighlightOnlyWhenFocus:Fe(new h(91,"renderLineHighlightOnlyWhenFocus",!1,{description:o.localize(271,null)})),renderValidationDecorations:Fe(new s(92,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Fe(new s(93,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",o.localize(272,null),o.localize(273,null),o.localize(274,null),""],description:o.localize(275,null)})),revealHorizontalRightPadding:Fe(new g(94,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Fe(new h(95,"roundedSelection",!0,{description:o.localize(276,null)})),rulers:Fe(new re),scrollbar:Fe(new H),scrollBeyondLastColumn:Fe(new g(98,"scrollBeyondLastColumn",4,0,1073741824,{description:o.localize(277,null)})),scrollBeyondLastLine:Fe(new h(99,"scrollBeyondLastLine",!0,{description:o.localize(278,null)})),scrollPredominantAxis:Fe(new h(100,"scrollPredominantAxis",!0,{description:o.localize(279,null)})),selectionClipboard:Fe(new h(101,"selectionClipboard",!0,{description:o.localize(280,null),included:t.isLinux})),selectionHighlight:Fe(new h(102,"selectionHighlight",!0,{description:o.localize(281,null)})),selectOnLineNumbers:Fe(new h(103,"selectOnLineNumbers",!0)),showFoldingControls:Fe(new s(104,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[o.localize(282,null),o.localize(283,null),o.localize(284,null)],description:o.localize(285,null)})),showUnused:Fe(new h(105,"showUnused",!0,{description:o.localize(286,null)})),showDeprecated:Fe(new h(133,"showDeprecated",!0,{description:o.localize(287,null)})),inlayHints:Fe(new X),snippetSuggestions:Fe(new s(106,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[o.localize(288,null),o.localize(289,null),o.localize(290,null),o.localize(291,null)],description:o.localize(292,null)})),smartSelect:Fe(new De),smoothScrolling:Fe(new h(108,"smoothScrolling",!1,{description:o.localize(293,null)})),stopRenderingLineAfter:Fe(new g(111,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Fe(new pe),inlineSuggest:Fe(new Q),suggestFontSize:Fe(new g(113,"suggestFontSize",0,0,1e3,{markdownDescription:o.localize(294,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Fe(new g(114,"suggestLineHeight",0,0,1e3,{markdownDescription:o.localize(295,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Fe(new h(115,"suggestOnTriggerCharacters",!0,{description:o.localize(296,null)})),suggestSelection:Fe(new s(116,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[o.localize(297,null),o.localize(298,null),o.localize(299,null)],description:o.localize(300,null)})),tabCompletion:Fe(new s(117,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[o.localize(301,null),o.localize(302,null),o.localize(303,null)],description:o.localize(304,null)})),tabIndex:Fe(new g(118,"tabIndex",0,-1,1073741824)),unicodeHighlight:Fe(new x),unusualLineTerminators:Fe(new s(120,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[o.localize(305,null),o.localize(306,null),o.localize(307,null)],description:o.localize(308,null)})),useShadowDOM:Fe(new h(121,"useShadowDOM",!0)),useTabStops:Fe(new h(122,"useTabStops",!0,{description:o.localize(309,null)})),wordBreak:Fe(new s(123,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[o.localize(310,null),o.localize(311,null)],description:o.localize(312,null)})),wordSeparators:Fe(new w(124,"wordSeparators",T.USUAL_WORD_SEPARATORS,{description:o.localize(313,null)})),wordWrap:Fe(new s(125,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[o.localize(314,null),o.localize(315,null),o.localize(316,null),o.localize(317,null)],description:o.localize(318,null)})),wordWrapBreakAfterCharacters:Fe(new w(126,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Fe(new w(127,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Fe(new g(128,"wordWrapColumn",80,1,1073741824,{markdownDescription:o.localize(319,null)})),wordWrapOverride1:Fe(new s(129,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Fe(new s(130,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Fe(new M),pixelRatio:Fe(new oe),tabFocusMode:Fe(new ke),layoutInfo:Fe(new Y),wrappingInfo:Fe(new et),wrappingIndent:Fe(new Ge),wrappingStrategy:Fe(new J)}}),define(ye[168],Ce([19,20]),function(te,e){return te.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ye[169],Ce([19,20]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ye[170],Ce([19,20]),function(te,e){return te.create("vs/platform/extensions/common/extensionValidator",e)}),define(ye[171],Ce([19,20]),function(te,e){return te.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ye[172],Ce([19,20]),function(te,e){return te.create("vs/platform/files/common/files",e)}),define(ye[173],Ce([19,20]),function(te,e){return te.create("vs/platform/markers/common/markers",e)}),define(ye[174],Ce([19,20]),function(te,e){return te.create("vs/platform/workspace/common/workspace",e)}),define(ye[175],Ce([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ye[176],Ce([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ye[177],Ce([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostProgress",e)}),define(ye[178],Ce([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ye[179],Ce([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ye[180],Ce([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ye[181],Ce([19,20]),function(te,e){return te.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ye[182],Ce([19,20]),function(te,e){return te.create("vs/workbench/api/node/extHostDebugService",e)}),define(ye[183],Ce([19,20]),function(te,e){return te.create("vs/workbench/api/node/extHostTunnelService",e)}),define(ye[184],Ce([19,20]),function(te,e){return te.create("vs/workbench/common/editor",e)}),define(ye[185],Ce([19,20]),function(te,e){return te.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ye[186],Ce([19,20]),function(te,e){return te.create("vs/workbench/contrib/debug/common/debug",e)}),define(ye[187],Ce([19,20]),function(te,e){return te.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ye[188],Ce([19,20]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(ye[189],Ce([19,20]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(ye[190],Ce([19,20]),function(te,e){return te.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ye[191],Ce([19,20]),function(te,e){return te.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ye[192],Ce([19,20]),function(te,e){return te.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ye[193],Ce([1,0,9]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class t{constructor(){this.a=new Map}register(R,I){this.a.set(R,I)}updateManifest(R){if(!(typeof R.main>"u"&&typeof R.browser>"u")&&(R.activationEvents===void 0&&Object.assign(R,{activationEvents:[]}),!(!Array.isArray(R.activationEvents)||!R.contributes)))for(const I in R.contributes){const A=this.a.get(I);if(!A)continue;const y=R.contributes[I],D=Array.isArray(y)?y:[y];try{A(D,R.activationEvents)}catch(L){(0,o.onUnexpectedError)(L)}}}}e.ImplicitActivationEventsImpl=t,e.ImplicitActivationEvents=new t}),define(ye[194],Ce([1,0,24,37,170,312]),function(te,e,o,t,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const I=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,A=/^-(\d{4})(\d{2})(\d{2})$/;function y(h){return h=h.trim(),h==="*"||I.test(h)}e.isValidVersionStr=y;function D(h){if(!y(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const b=h.match(I);return b?{hasCaret:b[1]==="^",hasGreaterEquals:b[1]===">=",majorBase:b[2]==="x"?0:parseInt(b[2],10),majorMustEqual:b[2]!=="x",minorBase:b[4]==="x"?0:parseInt(b[4],10),minorMustEqual:b[4]!=="x",patchBase:b[6]==="x"?0:parseInt(b[6],10),patchMustEqual:b[6]!=="x",preRelease:b[8]||null}:null}e.parseVersion=D;function L(h){if(!h)return null;const b=h.majorBase,g=h.majorMustEqual,p=h.minorBase;let w=h.minorMustEqual;const i=h.patchBase;let s=h.patchMustEqual;h.hasCaret&&(b===0||(w=!1),s=!1);let a=0;if(h.preRelease){const u=A.exec(h.preRelease);if(u){const[,l,c,n]=u;a=Date.UTC(Number(l),Number(c)-1,Number(n))}}return{majorBase:b,majorMustEqual:g,minorBase:p,minorMustEqual:w,patchBase:i,patchMustEqual:s,isMinimum:h.hasGreaterEquals,notBefore:a}}e.normalizeVersion=L;function P(h,b,g){let p;typeof h=="string"?p=L(D(h)):p=h;let w;b instanceof Date?w=b.getTime():typeof b=="string"&&(w=new Date(b).getTime());let i;if(typeof g=="string"?i=L(D(g)):i=g,!p||!i)return!1;const s=p.majorBase,a=p.minorBase,u=p.patchBase;let l=i.majorBase,c=i.minorBase,n=i.patchBase;const r=i.notBefore;let m=i.majorMustEqual,S=i.minorMustEqual,k=i.patchMustEqual;return i.isMinimum?s>l?!0:s<l?!1:a>c?!0:a<c||w&&w<r?!1:u>=n:(s===1&&l===0&&(!m||!S||!k)&&(l=1,c=0,n=0,m=!0,S=!1,k=!1),s<l?!1:s>l?!m:a<c?!1:a>c?!S:u<n?!1:u>n?!k:!(w&&w<r))}e.isValidVersion=P;function v(h,b,g,p,w){const i=[];if(typeof p.publisher<"u"&&typeof p.publisher!="string")return i.push([t.default.Error,T.localize(0,null)]),i;if(typeof p.name!="string")return i.push([t.default.Error,T.localize(1,null,"name")]),i;if(typeof p.version!="string")return i.push([t.default.Error,T.localize(2,null,"version")]),i;if(!p.engines)return i.push([t.default.Error,T.localize(3,null,"engines")]),i;if(typeof p.engines.vscode!="string")return i.push([t.default.Error,T.localize(4,null,"engines.vscode")]),i;if(typeof p.extensionDependencies<"u"&&!d(p.extensionDependencies))return i.push([t.default.Error,T.localize(5,null,"extensionDependencies")]),i;if(typeof p.activationEvents<"u"){if(!d(p.activationEvents))return i.push([t.default.Error,T.localize(6,null,"activationEvents")]),i;if(typeof p.main>"u"&&typeof p.browser>"u")return i.push([t.default.Error,T.localize(7,null,"activationEvents","main")]),i}if(typeof p.extensionKind<"u"&&typeof p.main>"u"&&i.push([t.default.Warning,T.localize(8,null,"extensionKind")]),typeof p.main<"u"){if(typeof p.main!="string")return i.push([t.default.Error,T.localize(9,null,"main")]),i;{const u=(0,o.joinPath)(g,p.main);(0,o.isEqualOrParent)(u,g)||i.push([t.default.Warning,T.localize(10,null,u.path,g.path)])}if(typeof p.activationEvents>"u")return i.push([t.default.Error,T.localize(11,null,"activationEvents","main")]),i}if(typeof p.browser<"u"){if(typeof p.browser!="string")return i.push([t.default.Error,T.localize(12,null,"browser")]),i;{const u=(0,o.joinPath)(g,p.browser);(0,o.isEqualOrParent)(u,g)||i.push([t.default.Warning,T.localize(13,null,u.path,g.path)])}if(typeof p.activationEvents>"u")return i.push([t.default.Error,T.localize(14,null,"activationEvents","browser")]),i}if(!R.valid(p.version))return i.push([t.default.Error,T.localize(15,null)]),i;const s=[];if(!C(h,b,p,w,s))for(const u of s)i.push([t.default.Error,u]);return i}e.validateExtensionManifest=v;function C(h,b,g,p,w){return p||typeof g.main>"u"&&typeof g.browser>"u"?!0:f(h,b,g.engines.vscode,w)}e.isValidExtensionVersion=C;function E(h,b,g){return h==="*"||f(b,g,h)}e.isEngineValid=E;function f(h,b,g,p=[]){const w=L(D(g));if(!w)return p.push(T.localize(16,null,g)),!1;if(w.majorBase===0){if(!w.majorMustEqual||!w.minorMustEqual)return p.push(T.localize(17,null,g)),!1}else if(!w.majorMustEqual)return p.push(T.localize(18,null,g)),!1;return P(h,b,w)?!0:(p.push(T.localize(19,null,h,g)),!1)}function d(h){if(!Array.isArray(h))return!1;for(let b=0,g=h.length;b<g;b++)if(typeof h[b]!="string")return!1;return!0}}),define(ye[121],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class o{constructor(T,R=[],I=!1){this.ctor=T,this.staticArguments=R,this.supportsDelayedInstantiation=I}}e.SyncDescriptor=o}),define(ye[88],Ce([1,0,121]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const t=[];var T;(function(A){A[A.Eager=0]="Eager",A[A.Delayed=1]="Delayed"})(T=e.InstantiationType||(e.InstantiationType={}));function R(A,y,D){y instanceof o.SyncDescriptor||(y=new o.SyncDescriptor(y,[],Boolean(D))),t.push([A,y])}e.registerSingleton=R;function I(){return t}e.getSingletonServiceDescriptors=I}),define(ye[195],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class o{constructor(R,I){this.key=R,this.data=I,this.incoming=new Map,this.outgoing=new Map}}e.Node=o;class t{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const I of this.a.values())I.outgoing.size===0&&R.push(I);return R}insertEdge(R,I){const A=this.lookupOrInsertNode(R),y=this.lookupOrInsertNode(I);A.outgoing.set(y.key,y),y.incoming.set(A.key,A)}removeNode(R){const I=this.b(R);this.a.delete(I);for(const A of this.a.values())A.outgoing.delete(I),A.incoming.delete(I)}lookupOrInsertNode(R){const I=this.b(R);let A=this.a.get(I);return A||(A=new o(I,R),this.a.set(I,A)),A}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[I,A]of this.a)R.push(`${I}
	(-> incoming)[${[...A.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...A.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,I]of this.a){const A=new Set([R]),y=this.c(I,A);if(y)return y}}c(R,I){for(const[A,y]of R.outgoing){if(I.has(A))return[...I,A].join(" -> ");I.add(A);const D=this.c(y,I);if(D)return D;I.delete(A)}}}e.Graph=t}),define(ye[4],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var o;(function(I){I.serviceIds=new Map,I.DI_TARGET="$di$target",I.DI_DEPENDENCIES="$di$dependencies";function A(y){return y[I.DI_DEPENDENCIES]||[]}I.getServiceDependencies=A})(o=e._util||(e._util={})),e.IInstantiationService=T("instantiationService");function t(I,A,y){A[o.DI_TARGET]===A?A[o.DI_DEPENDENCIES].push({id:I,index:y}):(A[o.DI_DEPENDENCIES]=[{id:I,index:y}],A[o.DI_TARGET]=A)}function T(I){if(o.serviceIds.has(I))return o.serviceIds.get(I);const A=function(y,D,L){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(A,y,L)};return A.toString=()=>I,o.serviceIds.set(I,A),A}e.createDecorator=T;function R(I){return I}e.refineServiceDecorator=R}),define(ye[52],Ce([1,0,11,2,4]),function(te,e,o,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,T.createDecorator)("configurationService");function R(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof t.URI)}e.isConfigurationOverrides=R;function I(h){return h&&typeof h=="object"&&(!h.overrideIdentifiers||Array.isArray(h.overrideIdentifiers))&&!h.overrideIdentifier&&(!h.resource||h.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=I;var A;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.USER=2]="USER",h[h.USER_LOCAL=3]="USER_LOCAL",h[h.USER_REMOTE=4]="USER_REMOTE",h[h.WORKSPACE=5]="WORKSPACE",h[h.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",h[h.DEFAULT=7]="DEFAULT",h[h.MEMORY=8]="MEMORY"})(A=e.ConfigurationTarget||(e.ConfigurationTarget={}));function y(h){switch(h){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=y;function D(h,b){const g=Object.create(null);for(const p in h)L(g,p,h[p],b);return g}e.toValuesTree=D;function L(h,b,g,p){const w=b.split("."),i=w.pop();let s=h;for(let a=0;a<w.length;a++){const u=w[a];let l=s[u];switch(typeof l){case"undefined":l=s[u]=Object.create(null);break;case"object":break;default:p(`Ignoring ${b} as ${w.slice(0,a+1).join(".")} is ${JSON.stringify(l)}`);return}s=l}if(typeof s=="object"&&s!==null)try{s[i]=g}catch{p(`Ignoring ${b} as ${w.join(".")} is ${JSON.stringify(s)}`)}else p(`Ignoring ${b} as ${w.join(".")} is ${JSON.stringify(s)}`)}e.addToValueTree=L;function P(h,b){const g=b.split(".");v(h,g)}e.removeFromValueTree=P;function v(h,b){const g=b.shift();if(b.length===0){delete h[g];return}if(Object.keys(h).indexOf(g)!==-1){const p=h[g];typeof p=="object"&&!Array.isArray(p)&&(v(p,b),Object.keys(p).length===0&&delete h[g])}}function C(h,b,g){function p(s,a){let u=s;for(const l of a){if(typeof u!="object"||u===null)return;u=u[l]}return u}const w=b.split("."),i=p(h,w);return typeof i>"u"?g:i}e.getConfigurationValue=C;function E(h,b,g){Object.keys(b).forEach(p=>{p!=="__proto__"&&(p in h?o.isObject(h[p])&&o.isObject(b[p])?E(h[p],b[p],g):g&&(h[p]=b[p]):h[p]=b[p])})}e.merge=E;function f(h,b,g){const p=h.inspect(b),w=h.inspect(g);return typeof p.userValue<"u"||typeof p.workspaceValue<"u"||typeof p.workspaceFolderValue<"u"?p.value:typeof w.userValue<"u"||typeof w.workspaceValue<"u"||typeof w.workspaceFolderValue<"u"?w.value:p.defaultValue}e.getMigratedSettingValue=f;function d(h){return h.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=d}),define(ye[53],Ce([1,0,12,8,4]),function(te,e,o,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const R=new Map;R.set("false",!1),R.set("true",!0),R.set("isMac",o.isMacintosh),R.set("isLinux",o.isLinux),R.set("isWindows",o.isWindows),R.set("isWeb",o.isWeb),R.set("isMacNative",o.isMacintosh&&!o.isWeb),R.set("isEdge",o.isEdge),R.set("isFirefox",o.isFirefox),R.set("isChrome",o.isChrome),R.set("isSafari",o.isSafari);const I=Object.prototype.hasOwnProperty;var A;(function(V){V[V.False=0]="False",V[V.True=1]="True",V[V.Defined=2]="Defined",V[V.Not=3]="Not",V[V.Equals=4]="Equals",V[V.NotEquals=5]="NotEquals",V[V.And=6]="And",V[V.Regex=7]="Regex",V[V.NotRegex=8]="NotRegex",V[V.Or=9]="Or",V[V.In=10]="In",V[V.NotIn=11]="NotIn",V[V.Greater=12]="Greater",V[V.GreaterEquals=13]="GreaterEquals",V[V.Smaller=14]="Smaller",V[V.SmallerEquals=15]="SmallerEquals"})(A=e.ContextKeyExprType||(e.ContextKeyExprType={}));class y{static false(){return P.INSTANCE}static true(){return v.INSTANCE}static has(F){return C.create(F)}static equals(F,U){return E.create(F,U)}static notEquals(F,U){return h.create(F,U)}static regex(F,U){return a.create(F,U)}static in(F,U){return f.create(F,U)}static notIn(F,U){return d.create(F,U)}static not(F){return b.create(F)}static and(...F){return c.create(F,null,!0)}static or(...F){return n.create(F,null,!0)}static greater(F,U){return p.create(F,U)}static greaterEquals(F,U){return w.create(F,U)}static smaller(F,U){return i.create(F,U)}static smallerEquals(F,U){return s.create(F,U)}static deserialize(F,U=!1){if(!!F)return this.c(F,U)}static c(F,U){const N=F.split("||");return n.create(N.map(B=>this.d(B,U)),null,!0)}static d(F,U){const N=F.split("&&");return c.create(N.map(B=>this.f(B,U)),null,!0)}static f(F,U){if(F=F.trim(),F.indexOf("!=")>=0){const N=F.split("!=");return h.create(N[0].trim(),this.g(N[1],U))}if(F.indexOf("==")>=0){const N=F.split("==");return E.create(N[0].trim(),this.g(N[1],U))}if(F.indexOf("=~")>=0){const N=F.split("=~");return a.create(N[0].trim(),this.h(N[1],U))}if(F.indexOf(" not in ")>=0){const N=F.split(" not in ");return d.create(N[0].trim(),this.g(N[1],U))}if(F.indexOf(" in ")>=0){const N=F.split(" in ");return f.create(N[0].trim(),this.g(N[1],U))}if(/^[^<=>]+>=[^<=>]+$/.test(F)){const N=F.split(">=");return w.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(F)){const N=F.split(">");return p.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(F)){const N=F.split("<=");return s.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(F)){const N=F.split("<");return i.create(N[0].trim(),N[1].trim())}return/^\!\s*/.test(F)?b.create(F.substr(1).trim()):C.create(F)}static g(F,U){if(F=F.trim(),F==="true")return!0;if(F==="false")return!1;const N=/^'([^']*)'$/.exec(F);return N?N[1].trim():F}static h(F,U){if((0,t.isFalsyOrWhitespace)(F)){if(U)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const N=F.indexOf("/"),B=F.lastIndexOf("/");if(N===B||N<0){if(U)throw new Error(`bad regexp-value '${F}', missing /-enclosure`);return console.warn(`bad regexp-value '${F}', missing /-enclosure`),null}const j=F.slice(N+1,B),z=F[B+1]==="i"?"i":"";try{return new RegExp(j,z)}catch(ne){if(U)throw new Error(`bad regexp-value '${F}', parse error: ${ne}`);return console.warn(`bad regexp-value '${F}', parse error: ${ne}`),null}}}e.ContextKeyExpr=y;function D(V,F){const U=V?V.substituteConstants():void 0,N=F?F.substituteConstants():void 0;return!U&&!N?!0:!U||!N?!1:U.equals(N)}e.expressionsAreEqualWithConstantSubstitution=D;function L(V,F){return V.cmp(F)}class P{constructor(){this.type=0}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!1}serialize(){return"false"}keys(){return[]}map(F){return this}negate(){return v.INSTANCE}}e.ContextKeyFalseExpr=P,P.INSTANCE=new P;class v{constructor(){this.type=1}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!0}serialize(){return"true"}keys(){return[]}map(F){return this}negate(){return P.INSTANCE}}e.ContextKeyTrueExpr=v,v.INSTANCE=new v;class C{static create(F,U=null){const N=R.get(F);return typeof N=="boolean"?N?v.INSTANCE:P.INSTANCE:new C(F,U)}constructor(F,U){this.key=F,this.c=U,this.type=2}cmp(F){return F.type!==this.type?this.type-F.type:m(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=R.get(this.key);return typeof F=="boolean"?F?v.INSTANCE:P.INSTANCE:this}evaluate(F){return!!F.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(F){return F.mapDefined(this.key)}negate(){return this.c||(this.c=b.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=C;class E{static create(F,U,N=null){if(typeof U=="boolean")return U?C.create(F,N):b.create(F,N);const B=R.get(F);return typeof B=="boolean"?U===(B?"true":"false")?v.INSTANCE:P.INSTANCE:new E(F,U,N)}constructor(F,U,N){this.c=F,this.d=U,this.f=N,this.type=4}cmp(F){return F.type!==this.type?this.type-F.type:S(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){const F=R.get(this.c);if(typeof F=="boolean"){const U=F?"true":"false";return this.d===U?v.INSTANCE:P.INSTANCE}return this}evaluate(F){return F.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(F){return F.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=h.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=E;class f{static create(F,U){return new f(F,U)}constructor(F,U){this.d=F,this.f=U,this.type=10,this.c=null}cmp(F){return F.type!==this.type?this.type-F.type:S(this.d,this.f,F.d,F.f)}equals(F){return F.type===this.type?this.d===F.d&&this.f===F.f:!1}substituteConstants(){return this}evaluate(F){const U=F.getValue(this.f),N=F.getValue(this.d);return Array.isArray(U)?U.includes(N):typeof N=="string"&&typeof U=="object"&&U!==null?I.call(U,N):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(F){return F.mapIn(this.d,this.f)}negate(){return this.c||(this.c=d.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=f;class d{static create(F,U){return new d(F,U)}constructor(F,U){this.d=F,this.f=U,this.type=11,this.c=f.create(F,U)}cmp(F){return F.type!==this.type?this.type-F.type:this.c.cmp(F.c)}equals(F){return F.type===this.type?this.c.equals(F.c):!1}substituteConstants(){return this}evaluate(F){return!this.c.evaluate(F)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(F){return F.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=d;class h{static create(F,U,N=null){if(typeof U=="boolean")return U?b.create(F,N):C.create(F,N);const B=R.get(F);return typeof B=="boolean"?U===(B?"true":"false")?P.INSTANCE:v.INSTANCE:new h(F,U,N)}constructor(F,U,N){this.c=F,this.d=U,this.f=N,this.type=5}cmp(F){return F.type!==this.type?this.type-F.type:S(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){const F=R.get(this.c);if(typeof F=="boolean"){const U=F?"true":"false";return this.d===U?P.INSTANCE:v.INSTANCE}return this}evaluate(F){return F.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(F){return F.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=E.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=h;class b{static create(F,U=null){const N=R.get(F);return typeof N=="boolean"?N?P.INSTANCE:v.INSTANCE:new b(F,U)}constructor(F,U){this.c=F,this.d=U,this.type=3}cmp(F){return F.type!==this.type?this.type-F.type:m(this.c,F.c)}equals(F){return F.type===this.type?this.c===F.c:!1}substituteConstants(){const F=R.get(this.c);return typeof F=="boolean"?F?P.INSTANCE:v.INSTANCE:this}evaluate(F){return!F.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(F){return F.mapNot(this.c)}negate(){return this.d||(this.d=C.create(this.c,this)),this.d}}e.ContextKeyNotExpr=b;function g(V,F){if(typeof V=="string"){const U=parseFloat(V);isNaN(U)||(V=U)}return typeof V=="string"||typeof V=="number"?F(V):P.INSTANCE}class p{static create(F,U,N=null){return g(U,B=>new p(F,B,N))}constructor(F,U,N){this.c=F,this.d=U,this.f=N,this.type=12}cmp(F){return F.type!==this.type?this.type-F.type:S(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(F){return F.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=s.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=p;class w{static create(F,U,N=null){return g(U,B=>new w(F,B,N))}constructor(F,U,N){this.c=F,this.d=U,this.f=N,this.type=13}cmp(F){return F.type!==this.type?this.type-F.type:S(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(F){return F.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=i.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=w;class i{static create(F,U,N=null){return g(U,B=>new i(F,B,N))}constructor(F,U,N){this.c=F,this.d=U,this.f=N,this.type=14}cmp(F){return F.type!==this.type?this.type-F.type:S(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(F){return F.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=w.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=i;class s{static create(F,U,N=null){return g(U,B=>new s(F,B,N))}constructor(F,U,N){this.c=F,this.d=U,this.f=N,this.type=15}cmp(F){return F.type!==this.type?this.type-F.type:S(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(F){return F.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=p.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=s;class a{static create(F,U){return new a(F,U)}constructor(F,U){this.d=F,this.f=U,this.type=7,this.c=null}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.d<F.d)return-1;if(this.d>F.d)return 1;const U=this.f?this.f.source:"",N=F.f?F.f.source:"";return U<N?-1:U>N?1:0}equals(F){if(F.type===this.type){const U=this.f?this.f.source:"",N=F.f?F.f.source:"";return this.d===F.d&&U===N}return!1}substituteConstants(){return this}evaluate(F){const U=F.getValue(this.d);return this.f?this.f.test(U):!1}serialize(){const F=this.f?`/${this.f.source}/${this.f.ignoreCase?"i":""}`:"/invalid/";return`${this.d} =~ ${F}`}keys(){return[this.d]}map(F){return F.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=u.create(this)),this.c}}e.ContextKeyRegexExpr=a;class u{static create(F){return new u(F)}constructor(F){this.c=F,this.type=8}cmp(F){return F.type!==this.type?this.type-F.type:this.c.cmp(F.c)}equals(F){return F.type===this.type?this.c.equals(F.c):!1}substituteConstants(){return this}evaluate(F){return!this.c.evaluate(F)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(F){return new u(this.c.map(F))}negate(){return this.c}}e.ContextKeyNotRegexExpr=u;function l(V){let F=null;for(let U=0,N=V.length;U<N;U++){const B=V[U].substituteConstants();if(V[U]!==B&&F===null){F=[];for(let j=0;j<U;j++)F[j]=V[j]}F!==null&&(F[U]=B)}return F===null?V:F}class c{static create(F,U,N){return c.d(F,U,N)}constructor(F,U){this.expr=F,this.c=U,this.type=6}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let U=0,N=this.expr.length;U<N;U++){const B=L(this.expr[U],F.expr[U]);if(B!==0)return B}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let U=0,N=this.expr.length;U<N;U++)if(!this.expr[U].equals(F.expr[U]))return!1;return!0}return!1}substituteConstants(){const F=l(this.expr);return F===this.expr?this:c.create(F,this.c,!1)}evaluate(F){for(let U=0,N=this.expr.length;U<N;U++)if(!this.expr[U].evaluate(F))return!1;return!0}static d(F,U,N){const B=[];let j=!1;for(const z of F)if(!!z){if(z.type===1){j=!0;continue}if(z.type===0)return P.INSTANCE;if(z.type===6){B.push(...z.expr);continue}B.push(z)}if(B.length===0&&j)return v.INSTANCE;if(B.length!==0){if(B.length===1)return B[0];B.sort(L);for(let z=1;z<B.length;z++)B[z-1].equals(B[z])&&(B.splice(z,1),z--);if(B.length===1)return B[0];for(;B.length>1;){const z=B[B.length-1];if(z.type!==9)break;B.pop();const ne=B.pop(),_=B.length===0,Y=n.create(z.expr.map(J=>c.create([J,ne],null,N)),null,_);Y&&(B.push(Y),B.sort(L))}if(B.length===1)return B[0];if(N){for(let z=0;z<B.length;z++)for(let ne=z+1;ne<B.length;ne++)if(B[z].negate().equals(B[ne]))return P.INSTANCE;if(B.length===1)return B[0]}return new c(B,U)}}serialize(){return this.expr.map(F=>F.serialize()).join(" && ")}keys(){const F=[];for(const U of this.expr)F.push(...U.keys());return F}map(F){return new c(this.expr.map(U=>U.map(F)),null)}negate(){if(!this.c){const F=[];for(const U of this.expr)F.push(U.negate());this.c=n.create(F,this,!0)}return this.c}}class n{static create(F,U,N){return n.d(F,U,N)}constructor(F,U){this.expr=F,this.c=U,this.type=9}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let U=0,N=this.expr.length;U<N;U++){const B=L(this.expr[U],F.expr[U]);if(B!==0)return B}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let U=0,N=this.expr.length;U<N;U++)if(!this.expr[U].equals(F.expr[U]))return!1;return!0}return!1}substituteConstants(){const F=l(this.expr);return F===this.expr?this:n.create(F,this.c,!1)}evaluate(F){for(let U=0,N=this.expr.length;U<N;U++)if(this.expr[U].evaluate(F))return!0;return!1}static d(F,U,N){let B=[],j=!1;if(F){for(let z=0,ne=F.length;z<ne;z++){const _=F[z];if(!!_){if(_.type===0){j=!0;continue}if(_.type===1)return v.INSTANCE;if(_.type===9){B=B.concat(_.expr);continue}B.push(_)}}if(B.length===0&&j)return P.INSTANCE;B.sort(L)}if(B.length!==0){if(B.length===1)return B[0];for(let z=1;z<B.length;z++)B[z-1].equals(B[z])&&(B.splice(z,1),z--);if(B.length===1)return B[0];if(N){for(let z=0;z<B.length;z++)for(let ne=z+1;ne<B.length;ne++)if(B[z].negate().equals(B[ne]))return v.INSTANCE;if(B.length===1)return B[0]}return new n(B,U)}}serialize(){return this.expr.map(F=>F.serialize()).join(" || ")}keys(){const F=[];for(const U of this.expr)F.push(...U.keys());return F}map(F){return new n(this.expr.map(U=>U.map(F)),null)}negate(){if(!this.c){const F=[];for(const U of this.expr)F.push(U.negate());for(;F.length>1;){const U=F.shift(),N=F.shift(),B=[];for(const j of q(U))for(const z of q(N))B.push(c.create([j,z],null,!1));F.unshift(n.create(B,null,!1))}this.c=n.create(F,this,!0)}return this.c}}class r extends C{static all(){return r.d.values()}constructor(F,U,N){super(F,null),this.f=U,typeof N=="object"?r.d.push({...N,key:F}):N!==!0&&r.d.push({key:F,description:N,type:U!=null?typeof U:void 0})}bindTo(F){return F.createKey(this.key,this.f)}getValue(F){return F.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(F){return E.create(this.key,F)}notEqualsTo(F){return h.create(this.key,F)}}e.RawContextKey=r,r.d=[],e.IContextKeyService=(0,T.createDecorator)("contextKeyService");function m(V,F){return V<F?-1:V>F?1:0}function S(V,F,U,N){return V<U?-1:V>U?1:F<N?-1:F>N?1:0}function k(V,F){if(V.type===0||F.type===1)return!0;if(V.type===9)return F.type===9?M(V.expr,F.expr):!1;if(F.type===9){for(const U of F.expr)if(k(V,U))return!0;return!1}if(V.type===6){if(F.type===6)return M(F.expr,V.expr);for(const U of V.expr)if(k(U,F))return!0;return!1}return V.equals(F)}e.implies=k;function M(V,F){let U=0,N=0;for(;U<V.length&&N<F.length;){const B=V[U].cmp(F[N]);if(B<0)return!1;B===0&&U++,N++}return U===V.length}function q(V){return V.type===9?V.expr:[V]}}),define(ye[196],Ce([1,0,4]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,o.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,o.refineServiceDecorator)(e.IEnvironmentService)}),define(ye[122],Ce([1,0,169,4]),function(te,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function T(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=T;function R(h){switch(h){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function I(h,b){switch(h){case 3:return b==="x64"?"win32-x64":b==="ia32"?"win32-ia32":b==="arm64"?"win32-arm64":"unknown";case 2:return b==="x64"?"linux-x64":b==="arm64"?"linux-arm64":b==="arm"?"linux-armhf":"unknown";case"alpine":return b==="x64"?"alpine-x64":b==="arm64"?"alpine-arm64":"unknown";case 1:return b==="x64"?"darwin-x64":b==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=I;function A(h,b){return b==="web"&&!h.includes("web")}e.isNotWebExtensionInWebTargetPlatform=A;function y(h,b,g){return A(b,g)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===g?!0:D(g).includes(h)}e.isTargetPlatformCompatible=y;function D(h){switch(h){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=D;function L(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=L;var P;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(P=e.SortBy||(e.SortBy={}));var v;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(v=e.SortOrder||(e.SortOrder={}));var C;(function(h){h.Install="install",h.Uninstall="uninstall"})(C=e.StatisticType||(e.StatisticType={}));var E;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(E=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var f;(function(h){h.Unsupported="Unsupported",h.Deprecated="Deprecated",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatiblePreRelease="IncompatiblePreRelease",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.Extract="Extract",h.Delete="Delete",h.Rename="Rename",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Internal="Internal",h.Signature="Signature"})(f=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class d extends Error{constructor(b,g){super(b),this.code=g,this.name=g}}e.ExtensionManagementError=d,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,o.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,o.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(ye[197],Ce([1,0,4]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,o.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,o.createDecorator)("externalTerminal")}),define(ye[198],Ce([1,0,46,15,10,12,107,29,115,171,197]),function(te,e,o,t,T,R,I,A,y,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const P=D.localize(0,null);class v{async getDefaultTerminalForPlatforms(){return{windows:C.getDefaultTerminalWindows(),linux:await f.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class C extends v{openTerminal(p,w){return this.spawnTerminal(o,p,y.getWindowsShell(),w)}spawnTerminal(p,w,i,s){const a=w.windowsExec||C.getDefaultTerminalWindows();s&&s[1]===":"&&(s=s[0].toUpperCase()+s.substr(1));const u=T.basename(a).toLowerCase();if(u==="cmder"||u==="cmder.exe")return p.spawn(a,s?[s]:void 0),Promise.resolve(void 0);const l=["/c","start","/wait"];return a.indexOf(" ")>=0&&l.push('""'),l.push(a),(u==="wt"||u==="wt.exe")&&l.push("-d ."),new Promise((c,n)=>{const r=d(process),m=p.spawn(i,l,{cwd:s,env:r});m.on("error",n),m.on("exit",()=>c())})}runInTerminal(p,w,i,s,a){const u="windowsExec"in a&&a.windowsExec?a.windowsExec:C.getDefaultTerminalWindows();return new Promise((l,c)=>{const n=`"${w} - ${P}"`,r=`""${i.join('" "')}" & pause"`,m=["/c","start",n,"/wait",u,"/c",r],S=Object.assign({},d(process),s);Object.keys(S).filter(q=>S[q]===null).forEach(q=>delete S[q]);const k={cwd:w,env:S,windowsVerbatimArguments:!0};o.spawn(C.b,m,k).on("error",q=>{c(h(q))}),l(void 0)})}static getDefaultTerminalWindows(){if(!C.d){const p=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");C.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${p?"Sysnative":"System32"}\\cmd.exe`}return C.d}}e.WindowsExternalTerminalService=C,C.b="cmd.exe";class E extends v{openTerminal(p,w){return this.spawnTerminal(o,p,w)}runInTerminal(p,w,i,s,a){const u=a.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((l,c)=>{if(u===L.DEFAULT_TERMINAL_OSX||u==="iTerm.app"){const n=u===L.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",m=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${n}.scpt`).fsPath,"-t",p||P,"-w",w];for(const M of i)m.push("-a"),m.push(M);if(s){const M=Object.assign({},d(process),s);for(const q in M){const V=M[q];V===null?(m.push("-u"),m.push(q)):(m.push("-e"),m.push(`${q}=${V}`))}}let S="";const k=o.spawn(E.b,m);k.on("error",M=>{c(h(M))}),k.stderr.on("data",M=>{S+=M.toString()}),k.on("exit",M=>{if(M===0)l(void 0);else if(S){const q=S.split(`
`,1);c(new Error(q[0]))}else c(new Error(D.localize(1,null,n,M)))})}else c(new Error(D.localize(2,null,u)))})}spawnTerminal(p,w,i){const s=w.osxExec||L.DEFAULT_TERMINAL_OSX;return new Promise((a,u)=>{const l=["-a",s];i&&l.push(i);const c=d(process),n=p.spawn("/usr/bin/open",l,{cwd:i,env:c});n.on("error",u),n.on("exit",()=>a())})}}e.MacExternalTerminalService=E,E.b="/usr/bin/osascript";class f extends v{openTerminal(p,w){return this.spawnTerminal(o,p,w)}runInTerminal(p,w,i,s,a){const u=a.linuxExec?Promise.resolve(a.linuxExec):f.getDefaultTerminalLinuxReady();return new Promise((l,c)=>{const n=[];u.then(r=>{r.indexOf("gnome-terminal")>=0?n.push("-x"):n.push("-e"),n.push("bash"),n.push("-c");const m=`${b(i)}; echo; read -p "${f.b}" -n1;`;n.push(`''${m}''`);const S=Object.assign({},d(process),s);Object.keys(S).filter(V=>S[V]===null).forEach(V=>delete S[V]);const k={cwd:w,env:S};let M="";const q=o.spawn(r,n,k);q.on("error",V=>{c(h(V))}),q.stderr.on("data",V=>{M+=V.toString()}),q.on("exit",V=>{if(V===0)l(void 0);else if(M){const F=M.split(`
`,1);c(new Error(F[0]))}else c(new Error(D.localize(4,null,r,V)))})})})}static async getDefaultTerminalLinuxReady(){if(!f.d)if(!R.isLinux)f.d=Promise.resolve("xterm");else{const p=await A.Promises.exists("/etc/debian_version");f.d=new Promise(w=>{p?w("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?w("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?w("konsole"):process.env.COLORTERM?w(process.env.COLORTERM):process.env.TERM?w(process.env.TERM):w("xterm")})}return f.d}spawnTerminal(p,w,i){const s=w.linuxExec?Promise.resolve(w.linuxExec):f.getDefaultTerminalLinuxReady();return new Promise((a,u)=>{s.then(l=>{const c=d(process),n=p.spawn(l,[],{cwd:i,env:c});n.on("error",u),n.on("exit",()=>a())})})}}e.LinuxExternalTerminalService=f,f.b=D.localize(3,null);function d(g){const p={...g.env};return(0,I.sanitizeProcessEnvironment)(p),p}function h(g){return"errno"in g&&g.errno==="ENOENT"&&"path"in g&&typeof g.path=="string"?new Error(D.localize(5,null,g.path)):g}function b(g){let p="";for(const w of g)w.indexOf(" ")>=0?p+='"'+w+'"':p+=w,p+=" ";return p}}),define(ye[39],Ce([1,0,64,10,8,11,2,172,4]),function(te,e,o,t,T,R,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function D(z){return z.create===!0}e.isFileOpenForWriteOptions=D;var L;(function(z){z[z.Unknown=0]="Unknown",z[z.File=1]="File",z[z.Directory=2]="Directory",z[z.SymbolicLink=64]="SymbolicLink"})(L=e.FileType||(e.FileType={}));var P;(function(z){z[z.Readonly=1]="Readonly"})(P=e.FilePermission||(e.FilePermission={}));var v;(function(z){z[z.None=0]="None",z[z.FileReadWrite=2]="FileReadWrite",z[z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",z[z.FileReadStream=16]="FileReadStream",z[z.FileFolderCopy=8]="FileFolderCopy",z[z.PathCaseSensitive=1024]="PathCaseSensitive",z[z.Readonly=2048]="Readonly",z[z.Trash=4096]="Trash",z[z.FileWriteUnlock=8192]="FileWriteUnlock",z[z.FileAtomicRead=16384]="FileAtomicRead",z[z.FileClone=32768]="FileClone"})(v=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function C(z){return!!(z.capabilities&2)}e.hasReadWriteCapability=C;function E(z){return!!(z.capabilities&8)}e.hasFileFolderCopyCapability=E;function f(z){return!!(z.capabilities&32768)}e.hasFileCloneCapability=f;function d(z){return!!(z.capabilities&4)}e.hasOpenReadWriteCloseCapability=d;function h(z){return!!(z.capabilities&16)}e.hasFileReadStreamCapability=h;function b(z){return C(z)?!!(z.capabilities&16384):!1}e.hasFileAtomicReadCapability=b;var g;(function(z){z.FileExists="EntryExists",z.FileNotFound="EntryNotFound",z.FileNotADirectory="EntryNotADirectory",z.FileIsADirectory="EntryIsADirectory",z.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",z.FileTooLarge="EntryTooLarge",z.FileWriteLocked="EntryWriteLocked",z.NoPermissions="NoPermissions",z.Unavailable="Unavailable",z.Unknown="Unknown"})(g=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class p extends Error{constructor(ne,_){super(ne),this.code=_}}e.FileSystemProviderError=p;function w(z,ne){const _=new p(z.toString(),ne);return s(_,ne),_}e.createFileSystemProviderError=w;function i(z){return z||w((0,A.localize)(0,null),g.Unknown)}e.ensureFileSystemProviderError=i;function s(z,ne){return z.name=ne?`${ne} (FileSystemError)`:"FileSystemError",z}e.markAsFileSystemProviderError=s;function a(z){if(!z)return g.Unknown;if(z instanceof p)return z.code;const ne=/^(.+) \(FileSystemError\)$/.exec(z.name);if(!ne)return g.Unknown;switch(ne[1]){case g.FileExists:return g.FileExists;case g.FileIsADirectory:return g.FileIsADirectory;case g.FileNotADirectory:return g.FileNotADirectory;case g.FileNotFound:return g.FileNotFound;case g.FileExceedsMemoryLimit:return g.FileExceedsMemoryLimit;case g.FileTooLarge:return g.FileTooLarge;case g.FileWriteLocked:return g.FileWriteLocked;case g.NoPermissions:return g.NoPermissions;case g.Unavailable:return g.Unavailable}return g.Unknown}e.toFileSystemProviderErrorCode=a;function u(z){if(z instanceof S)return z.fileOperationResult;switch(a(z)){case g.FileNotFound:return 1;case g.FileIsADirectory:return 0;case g.FileNotADirectory:return 10;case g.FileWriteLocked:return 5;case g.NoPermissions:return 6;case g.FileExists:return 4;case g.FileExceedsMemoryLimit:return 9;case g.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=u;var l;(function(z){z[z.CREATE=0]="CREATE",z[z.DELETE=1]="DELETE",z[z.MOVE=2]="MOVE",z[z.COPY=3]="COPY",z[z.WRITE=4]="WRITE"})(l=e.FileOperation||(e.FileOperation={}));class c{constructor(ne,_,Y){this.resource=ne,this.operation=_,this.target=Y}isOperation(ne){return this.operation===ne}}e.FileOperationEvent=c;var n;(function(z){z[z.UPDATED=0]="UPDATED",z[z.ADDED=1]="ADDED",z[z.DELETED=2]="DELETED"})(n=e.FileChangeType||(e.FileChangeType={}));class r{constructor(ne,_){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const Y=new Map;for(const J of ne){const Z=Y.get(J.type);switch(Z?Z.push([J.resource,J]):Y.set(J.type,[[J.resource,J]]),J.type){case 1:this.rawAdded.push(J.resource);break;case 0:this.rawUpdated.push(J.resource);break;case 2:this.rawDeleted.push(J.resource);break}}for(const[J,Z]of Y)switch(J){case 1:this.a=o.TernarySearchTree.forUris(()=>_),this.a.fill(Z);break;case 0:this.b=o.TernarySearchTree.forUris(()=>_),this.b.fill(Z);break;case 2:this.c=o.TernarySearchTree.forUris(()=>_),this.c.fill(Z);break}}contains(ne,..._){return this.d(ne,{includeChildren:!1},..._)}affects(ne,..._){return this.d(ne,{includeChildren:!0},..._)}d(ne,_,...Y){if(!ne)return!1;const J=Y.length>0;return!!((!J||Y.includes(1))&&(this.a?.get(ne)||_.includeChildren&&this.a?.findSuperstr(ne))||(!J||Y.includes(0))&&(this.b?.get(ne)||_.includeChildren&&this.b?.findSuperstr(ne))||(!J||Y.includes(2))&&(this.c?.findSubstr(ne)||_.includeChildren&&this.c?.findSuperstr(ne)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=r;function m(z,ne,_){return!z||!ne||z===ne||ne.length>z.length?!1:(ne.charAt(ne.length-1)!==t.sep&&(ne+=t.sep),_?(0,T.startsWithIgnoreCase)(z,ne):z.indexOf(ne)===0)}e.isParent=m;class S extends Error{constructor(ne,_,Y){super(ne),this.fileOperationResult=_,this.options=Y}}e.FileOperationError=S;class k extends S{constructor(ne,_,Y,J){super(ne,_,J),this.fileOperationResult=_,this.size=Y}}e.TooLargeFileOperationError=k;class M extends S{constructor(ne,_,Y){super(ne,2,Y),this.stat=_}}e.NotModifiedSinceFileOperationError=M;var q;(function(z){z[z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",z[z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",z[z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",z[z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",z[z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",z[z.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",z[z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",z[z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",z[z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",z[z.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",z[z.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",z[z.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(q=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var V;(function(z){z[z.FILE=0]="FILE",z[z.FOLDER=1]="FOLDER",z[z.ROOT_FOLDER=2]="ROOT_FOLDER"})(V=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function F(z){if(!(typeof z.size!="number"||typeof z.mtime!="number"))return z.mtime.toString(29)+z.size.toString(31)}e.etag=F;async function U(z,ne){if(!ne.hasProvider(I.URI.from({scheme:z.scheme})))return new Promise(_=>{const Y=ne.onDidChangeFileSystemProviderRegistrations(J=>{J.scheme===z.scheme&&J.added&&(Y.dispose(),_())})})}e.whenProviderRegistered=U,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class N{static formatSize(ne){return(0,R.isNumber)(ne)||(ne=0),ne<N.KB?(0,A.localize)(1,null,ne.toFixed(0)):ne<N.MB?(0,A.localize)(2,null,(ne/N.KB).toFixed(2)):ne<N.GB?(0,A.localize)(3,null,(ne/N.MB).toFixed(2)):ne<N.TB?(0,A.localize)(4,null,(ne/N.GB).toFixed(2)):(0,A.localize)(5,null,(ne/N.TB).toFixed(2))}}e.ByteSize=N,N.KB=1024,N.MB=N.KB*N.KB,N.GB=N.MB*N.KB,N.TB=N.GB*N.KB;var B;(function(z){z[z.IA32=0]="IA32",z[z.OTHER=1]="OTHER"})(B=e.Arch||(e.Arch={}));function j(z){return{maxFileSize:z===0?300*N.MB:16*N.GB,maxHeapSize:z===0?700*N.MB:2*700*N.MB}}e.getPlatformLimits=j}),define(ye[89],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class o{constructor(...T){this.a=new Map;for(const[R,I]of T)this.set(R,I)}set(T,R){const I=this.a.get(T);return this.a.set(T,R),I}has(T){return this.a.has(T)}get(T){return this.a.get(T)}}e.ServiceCollection=o}),define(ye[199],Ce([1,0,16,9,6,121,195,4,89,63]),function(te,e,o,t,T,R,I,A,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const L=!1;class P extends Error{constructor(d){super("cyclic dependency between services"),this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class v{constructor(d=new y.ServiceCollection,h=!1,b,g=L){this.f=d,this.g=h,this.h=b,this.i=g,this.o=new Set,this.f.set(A.IInstantiationService,this),this._globalGraph=g?b?._globalGraph??new I.Graph(p=>p):void 0}createChild(d){return new v(d,this.g,this,this.i)}invokeFunction(d,...h){const b=E.traceInvocation(this.i,d);let g=!1;try{return d({get:w=>{if(g)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const i=this.m(w,b);if(!i)throw new Error(`[invokeFunction] unknown service '${w}'`);return i}},...h)}finally{g=!0,b.stop()}}createInstance(d,...h){let b,g;return d instanceof R.SyncDescriptor?(b=E.traceCreation(this.i,d.ctor),g=this.j(d.ctor,d.staticArguments.concat(h),b)):(b=E.traceCreation(this.i,d),g=this.j(d,h,b)),b.stop(),g}j(d,h=[],b){const g=A._util.getServiceDependencies(d).sort((i,s)=>i.index-s.index),p=[];for(const i of g){const s=this.m(i.id,b);s||this.u(`[createInstance] ${d.name} depends on UNKNOWN service ${i.id}.`,!1),p.push(s)}const w=g.length>0?g[0].index:h.length;if(h.length!==w){console.trace(`[createInstance] First service dependency of ${d.name} at position ${w+1} conflicts with ${h.length} static arguments`);const i=w-h.length;i>0?h=h.concat(new Array(i)):h=h.slice(0,w)}return Reflect.construct(d,h.concat(p))}k(d,h){if(this.f.get(d)instanceof R.SyncDescriptor)this.f.set(d,h);else if(this.h)this.h.k(d,h);else throw new Error("illegalState - setting UNKNOWN service instance")}l(d){const h=this.f.get(d);return!h&&this.h?this.h.l(d):h}m(d,h){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(d));const b=this.l(d);return b instanceof R.SyncDescriptor?this.q(d,b,h.branch(d,!0)):(h.branch(d,!1),b)}q(d,h,b){if(this.o.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this.o.add(d);try{return this.r(d,h,b)}finally{this.o.delete(d)}}r(d,h,b){const g=new I.Graph(i=>i.id.toString());let p=0;const w=[{id:d,desc:h,_trace:b}];for(;w.length;){const i=w.pop();if(g.lookupOrInsertNode(i),p++>1e3)throw new P(g);for(const s of A._util.getServiceDependencies(i.desc.ctor)){const a=this.l(s.id);if(a||this.u(`[createInstance] ${d} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(s.id)),a instanceof R.SyncDescriptor){const u={id:s.id,desc:a,_trace:i._trace.branch(s.id,!0)};g.insertEdge(i,u),w.push(u)}}}for(;;){const i=g.roots();if(i.length===0){if(!g.isEmpty())throw new P(g);break}for(const{data:s}of i){if(this.l(s.id)instanceof R.SyncDescriptor){const u=this.s(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.k(s.id,u)}g.removeNode(s)}}return this.l(d)}s(d,h,b=[],g,p){if(this.f.get(d)instanceof R.SyncDescriptor)return this.t(d,h,b,g,p);if(this.h)return this.h.s(d,h,b,g,p);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}t(d,h,b=[],g,p){if(g){const w=new v(void 0,this.g,this,this.i);w.c=String(d);const i=new Map,s=new o.IdleValue(()=>{const a=w.j(h,b,p);for(const[u,l]of i){const c=a[u];if(typeof c=="function")for(const n of l)c.apply(a,n)}return i.clear(),a});return new Proxy(Object.create(null),{get(a,u){if(!s.isInitialized&&typeof u=="string"&&(u.startsWith("onDid")||u.startsWith("onWill"))){let n=i.get(u);return n||(n=new D.LinkedList,i.set(u,n)),(m,S,k)=>{const M=n.push([m,S,k]);return(0,T.toDisposable)(M)}}if(u in a)return a[u];const l=s.value;let c=l[u];return typeof c!="function"||(c=c.bind(l),a[u]=c),c},set(a,u,l){return s.value[u]=l,!0},getPrototypeOf(a){return h.prototype}})}else return this.j(h,b,p)}u(d,h){if(h&&console.warn(d),this.g)throw new Error(d)}}e.InstantiationService=v;var C;(function(f){f[f.None=0]="None",f[f.Creation=1]="Creation",f[f.Invocation=2]="Invocation",f[f.Branch=3]="Branch"})(C||(C={}));class E{static traceInvocation(d,h){return d?new E(2,h.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):E.c}static traceCreation(d,h){return d?new E(1,h.name):E.c}constructor(d,h){this.type=d,this.name=h,this.g=Date.now(),this.h=[]}branch(d,h){const b=new E(3,d.toString());return this.h.push([d,h,b]),b}stop(){const d=Date.now()-this.g;E.f+=d;let h=!1;function b(p,w){const i=[],s=new Array(p+1).join("	");for(const[a,u,l]of w.h)if(u&&l){h=!0,i.push(`${s}CREATES -> ${a}`);const c=b(p+1,l);c&&i.push(c)}else i.push(`${s}uses -> ${a}`);return i.join(`
`)}const g=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${b(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${E.f.toFixed(2)}ms)`];(d>2||h)&&E.all.add(g.join(`
`))}}e.Trace=E,E.all=new Set,E.c=new class extends E{constructor(){super(0,null)}stop(){}branch(){return this}},E.f=0}),define(ye[13],Ce([1,0,45,3,6,28,12,2,4]),function(te,e,o,t,T,R,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,y.createDecorator)("logService"),e.ILoggerService=(0,y.createDecorator)("loggerService");function D(){return new Date().toISOString()}var L;(function(c){c[c.Off=0]="Off",c[c.Trace=1]="Trace",c[c.Debug=2]="Debug",c[c.Info=3]="Info",c[c.Warning=4]="Warning",c[c.Error=5]="Error"})(L=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=L.Info;function P(c,n,r){switch(n){case L.Trace:c.trace(r);break;case L.Debug:c.debug(r);break;case L.Info:c.info(r);break;case L.Warning:c.warn(r);break;case L.Error:c.error(r);break;case L.Off:break;default:throw new Error(`Invalid log level ${n}`)}}e.log=P;function v(c){let n="";for(let r=0;r<c.length;r++){let m=c[r];if(typeof m=="object")try{m=JSON.stringify(m)}catch{}n+=(r>0?" ":"")+m}return n}e.format=v;class C extends T.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new t.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(n){this.b!==n&&(this.b=n,this.c.fire(this.b))}getLevel(){return this.b}f(n){return this.b!==L.Off&&this.b<=n}}e.AbstractLogger=C;class E extends C{constructor(n){super(),this.h=n}f(n){return this.h||super.f(n)}trace(n,...r){this.f(L.Trace)&&this.g(L.Trace,v([n,...r]))}debug(n,...r){this.f(L.Debug)&&this.g(L.Debug,v([n,...r]))}info(n,...r){this.f(L.Info)&&this.g(L.Info,v([n,...r]))}warn(n,...r){this.f(L.Warning)&&this.g(L.Warning,v([n,...r]))}error(n,...r){if(this.f(L.Error))if(n instanceof Error){const m=Array.prototype.slice.call(arguments);m[0]=n.stack,this.g(L.Error,v(m))}else this.g(L.Error,v([n,...r]))}flush(){}}e.AbstractMessageLogger=E;class f extends C{constructor(n=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(n),this.g=!I.isWindows}trace(n,...r){this.f(L.Trace)&&(this.g?console.log(`\x1B[90m[main ${D()}]\x1B[0m`,n,...r):console.log(`[main ${D()}]`,n,...r))}debug(n,...r){this.f(L.Debug)&&(this.g?console.log(`\x1B[90m[main ${D()}]\x1B[0m`,n,...r):console.log(`[main ${D()}]`,n,...r))}info(n,...r){this.f(L.Info)&&(this.g?console.log(`\x1B[90m[main ${D()}]\x1B[0m`,n,...r):console.log(`[main ${D()}]`,n,...r))}warn(n,...r){this.f(L.Warning)&&(this.g?console.warn(`\x1B[93m[main ${D()}]\x1B[0m`,n,...r):console.warn(`[main ${D()}]`,n,...r))}error(n,...r){this.f(L.Error)&&(this.g?console.error(`\x1B[91m[main ${D()}]\x1B[0m`,n,...r):console.error(`[main ${D()}]`,n,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=f;class d extends C{constructor(n=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(n)}trace(n,...r){this.f(L.Trace)&&console.log("%cTRACE","color: #888",n,...r)}debug(n,...r){this.f(L.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",n,...r)}info(n,...r){this.f(L.Info)&&console.log("%c INFO","color: #33f",n,...r)}warn(n,...r){this.f(L.Warning)&&console.log("%c WARN","color: #993",n,...r)}error(n,...r){this.f(L.Error)&&console.log("%c  ERR","color: #f33",n,...r)}dispose(){}flush(){}}e.ConsoleLogger=d;class h extends C{constructor(n,r=e.DEFAULT_LOG_LEVEL){super(),this.g=n,this.setLevel(r)}trace(n,...r){this.f(L.Trace)&&this.g.log(L.Trace,[this.h(n),...r])}debug(n,...r){this.f(L.Debug)&&this.g.log(L.Debug,[this.h(n),...r])}info(n,...r){this.f(L.Info)&&this.g.log(L.Info,[this.h(n),...r])}warn(n,...r){this.f(L.Warning)&&this.g.log(L.Warning,[this.h(n),...r])}error(n,...r){this.f(L.Error)&&this.g.log(L.Error,[this.h(n),...r])}h(n){return typeof n=="string"?n:(0,o.toErrorMessage)(n,this.f(L.Trace))}dispose(){}flush(){}}e.AdapterLogger=h;class b extends C{constructor(n){super(),this.g=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const r of this.g)r.setLevel(n);super.setLevel(n)}trace(n,...r){for(const m of this.g)m.trace(n,...r)}debug(n,...r){for(const m of this.g)m.debug(n,...r)}info(n,...r){for(const m of this.g)m.info(n,...r)}warn(n,...r){for(const m of this.g)m.warn(n,...r)}error(n,...r){for(const m of this.g)m.error(n,...r)}flush(){for(const n of this.g)n.flush()}dispose(){for(const n of this.g)n.dispose()}}e.MultiplexLogService=b;class g extends T.Disposable{constructor(n){super(),this.b=n,this.B(n)}get onDidChangeLogLevel(){return this.b.onDidChangeLogLevel}setLevel(n){this.b.setLevel(n)}getLevel(){return this.b.getLevel()}trace(n,...r){this.b.trace(n,...r)}debug(n,...r){this.b.debug(n,...r)}info(n,...r){this.b.info(n,...r)}warn(n,...r){this.b.warn(n,...r)}error(n,...r){this.b.error(n,...r)}flush(){this.b.flush()}}e.LogService=g;class p extends T.Disposable{constructor(n,r){super(),this.c=n,this.b=new R.ResourceMap,this.B(r(m=>this.setLevel(m)))}getLoggers(){return[...this.b.values()].map(({logger:n})=>n)}getLogger(n){return this.b.get(n)?.logger}createLogger(n,r,m){let S=this.b.get(n)?.logger;return S||(m=r?.always?L.Trace:m,S=this.f(n,m??this.c,r),this.b.set(n,{logger:S,logLevel:m})),S}setLevel(n,r){const m=A.URI.isUri(n)?n:void 0,S=m?r:n;if(m){const k=this.b.get(m);k&&k.logLevel!==S&&(k.logLevel=S,k.logger.setLevel(S))}else this.c=S,this.b.forEach(({logLevel:k,logger:M})=>{k===void 0&&M.setLevel(this.c)})}getLogLevel(n){return this.b.get(n)?.logLevel}dispose(){this.b.forEach(({logger:n})=>n.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=p;class w{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(n){}getLevel(){return L.Info}trace(n,...r){}debug(n,...r){}info(n,...r){}warn(n,...r){}error(n,...r){}critical(n,...r){}dispose(){}flush(){}}e.NullLogger=w;class i extends w{}e.NullLogService=i;class s extends p{constructor(){super(L.Info,t.Event.None)}f(n,r,m){return new w}}e.NullLoggerService=s;function a(c){if(c.verbose)return L.Trace;if(typeof c.logLevel=="string"){const n=l(c.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=a;function u(c){switch(c){case L.Trace:return"trace";case L.Debug:return"debug";case L.Info:return"info";case L.Warning:return"warn";case L.Error:return"error";case L.Off:return"off"}}e.LogLevelToString=u;function l(c){switch(c){case"trace":return L.Trace;case"debug":return L.Debug;case"info":return L.Info;case"warn":return L.Warning;case"error":return L.Error;case"critical":return L.Error;case"off":return L.Off}}e.parseLogLevel=l}),define(ye[200],Ce([1,0,39,13]),function(te,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var T;(function(D){D[D.Trace=0]="Trace",D[D.Debug=1]="Debug",D[D.Info=2]="Info",D[D.Warning=3]="Warning",D[D.Error=4]="Error",D[D.Critical=5]="Critical",D[D.Off=6]="Off"})(T||(T={}));async function R(D,L,P,v,C){try{const E=await new Promise((d,h)=>{te(["spdlog"],d,h)});E.setFlushOn(T.Trace);const f=await E.createAsyncRotatingLogger(D,L,P,v);return C?f.clearFormatters():f.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),f}catch(E){console.error(E)}return null}function I(D,L,P){switch(L){case t.LogLevel.Trace:D.trace(P);break;case t.LogLevel.Debug:D.debug(P);break;case t.LogLevel.Info:D.info(P);break;case t.LogLevel.Warning:D.warn(P);break;case t.LogLevel.Error:D.error(P);break;case t.LogLevel.Off:break;default:throw new Error(`Invalid log level ${L}`)}}function A(D,L){switch(L){case t.LogLevel.Trace:D.setLevel(T.Trace);break;case t.LogLevel.Debug:D.setLevel(T.Debug);break;case t.LogLevel.Info:D.setLevel(T.Info);break;case t.LogLevel.Warning:D.setLevel(T.Warning);break;case t.LogLevel.Error:D.setLevel(T.Error);break;case t.LogLevel.Off:D.setLevel(T.Off);break;default:throw new Error(`Invalid log level ${L}`)}}class y extends t.AbstractMessageLogger{constructor(L,P,v,C,E){super(),this.k=[],this.setLevel(E),this.l=this.n(L,P,v,C),this.B(this.onDidChangeLogLevel(f=>{this.m&&A(this.m,f)}))}async n(L,P,v,C){const E=v?6:1,f=30/E*o.ByteSize.MB,d=await R(L,P,f,E,C);if(d){this.m=d,A(this.m,this.getLevel());for(const{level:h,message:b}of this.k)I(this.m,h,b);this.k=[]}}g(L,P){this.m?I(this.m,L,P):this.getLevel()<=L&&this.k.push({level:L,message:P})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=y}),define(ye[123],Ce([1,0,37,173,4]),function(te,e,o,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var R;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(R=e.MarkerTag||(e.MarkerTag={}));var I;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(I=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function D(E,f){return f-E}y.compare=D;const L=Object.create(null);L[y.Error]=(0,t.localize)(0,null),L[y.Warning]=(0,t.localize)(1,null),L[y.Info]=(0,t.localize)(2,null);function P(E){return L[E]||""}y.toString=P;function v(E){switch(E){case o.default.Error:return y.Error;case o.default.Warning:return y.Warning;case o.default.Info:return y.Info;case o.default.Ignore:return y.Hint}}y.fromSeverity=v;function C(E){switch(E){case y.Error:return o.default.Error;case y.Warning:return o.default.Warning;case y.Info:return o.default.Info;case y.Hint:return o.default.Ignore}}y.toSeverity=C}(I=e.MarkerSeverity||(e.MarkerSeverity={}));var A;(function(y){const D="";function L(v){return P(v,!0)}y.makeKey=L;function P(v,C){const E=[D];return v.source?E.push(v.source.replace("\xA6","\\\xA6")):E.push(D),v.code?typeof v.code=="string"?E.push(v.code.replace("\xA6","\\\xA6")):E.push(v.code.value.replace("\xA6","\\\xA6")):E.push(D),v.severity!==void 0&&v.severity!==null?E.push(I.toString(v.severity)):E.push(D),v.message&&C?E.push(v.message.replace("\xA6","\\\xA6")):E.push(D),v.startLineNumber!==void 0&&v.startLineNumber!==null?E.push(v.startLineNumber.toString()):E.push(D),v.startColumn!==void 0&&v.startColumn!==null?E.push(v.startColumn.toString()):E.push(D),v.endLineNumber!==void 0&&v.endLineNumber!==null?E.push(v.endLineNumber.toString()):E.push(D),v.endColumn!==void 0&&v.endColumn!==null?E.push(v.endColumn.toString()):E.push(D),E.push(D),E.join("\xA6")}y.makeKeyOptionalMessage=P})(A=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,T.createDecorator)("markerService")}),define(ye[201],Ce([1,0,3,37,4]),function(te,e,o,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=t.default,e.INotificationService=(0,T.createDecorator)("notificationService");var R;(function(D){D[D.WORKSPACE=0]="WORKSPACE",D[D.PROFILE=1]="PROFILE",D[D.APPLICATION=2]="APPLICATION"})(R=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var I;(function(D){D[D.OFF=0]="OFF",D[D.SILENT=1]="SILENT",D[D.ERROR=2]="ERROR"})(I=e.NotificationsFilter||(e.NotificationsFilter={}));class A{constructor(){this.progress=new y,this.onDidClose=o.Event.None,this.onDidChangeVisibility=o.Event.None}updateSeverity(L){}updateMessage(L){}updateActions(L){}close(){}}e.NoOpNotification=A;class y{infinite(){}done(){}total(L){}worked(L){}}e.NoOpProgress=y}),define(ye[124],Ce([1,0,8,2,4]),function(te,e,o,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,T.createDecorator)("openerService");function R(D,L){return t.URI.isUri(D)?(0,o.equalsIgnoreCase)(D.scheme,L):(0,o.startsWithIgnoreCase)(D,L+":")}e.matchesScheme=R;function I(D,...L){return L.some(P=>R(D,P))}e.matchesSomeScheme=I;function A(D,L){return D.with({fragment:`${L.startLineNumber},${L.startColumn}${L.endLineNumber?`-${L.endLineNumber}${L.endColumn?`,${L.endColumn}`:""}`:""}`})}e.withSelection=A;function y(D){let L;const P=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(D.fragment);return P&&(L={startLineNumber:parseInt(P[1]),startColumn:P[2]?parseInt(P[2]):1,endLineNumber:P[4]?parseInt(P[4]):void 0,endColumn:P[4]?P[5]?parseInt(P[5]):1:void 0},D=D.with({fragment:""})),{selection:L,uri:D}}e.extractSelection=y}),define(ye[202],Ce([1,0,12,36]),function(te,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let T;if(typeof o.globals.vscode<"u"&&typeof o.globals.vscode.context<"u"){const R=o.globals.vscode.context.configuration();if(R)T=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(T=globalThis._VSCODE_PRODUCT_JSON,t.env.VSCODE_DEV&&Object.assign(T,{nameShort:`${T.nameShort} Dev`,nameLong:`${T.nameLong} Dev`,dataFolderName:`${T.dataFolderName}-dev`,serverDataFolderName:T.serverDataFolderName?`${T.serverDataFolderName}-dev`:void 0}),!T.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(T,{version:R.version})}}else T={},Object.keys(T).length===0&&Object.assign(T,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=T}),define(ye[203],Ce([1,0,4]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,o.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var We=this&&this.__param||function(te,e){return function(o,t){e(o,t,te)}};define(ye[125],Ce([1,0,16,21,6,4]),function(te,e,o,t,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,R.createDecorator)("progressService");var I;(function(L){L[L.Explorer=1]="Explorer",L[L.Scm=3]="Scm",L[L.Extensions=5]="Extensions",L[L.Window=10]="Window",L[L.Notification=15]="Notification",L[L.Dialog=20]="Dialog"})(I=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class A{get value(){return this.a}constructor(P){this.b=P}report(P){this.a=P,this.b(this.a)}}e.Progress=A,A.None=Object.freeze({report(){}});let y=class extends T.Disposable{constructor(P,v){super(),this.a=new o.DeferredPromise,v.withProgress(P,C=>(this.b=C,this.c&&C.report(this.c),this.a.p)),this.B((0,T.toDisposable)(()=>this.a.complete()))}report(P){this.b?this.b.report(P):this.c=P}};y=qe([We(1,e.IProgressService)],y),e.UnmanagedProgress=y;class D extends T.Disposable{constructor(P){super(),this.g=P,this.a=0,this.b=this.B(new T.DisposableStore)}start(P){this.stop();const v=++this.a,C=new t.CancellationTokenSource;return this.f=setTimeout(()=>{v===this.a&&(this.c=this.g.show(!0))},P),this.b.add((0,T.toDisposable)(()=>clearTimeout(this.f))),this.b.add((0,T.toDisposable)(()=>C.cancel())),this.b.add((0,T.toDisposable)(()=>this.c?this.c.done():void 0)),{id:v,token:C.token,stop:()=>this.h(v),isCurrent:()=>this.a===v}}stop(){this.h(this.a)}h(P){this.a===P&&this.b.clear()}}e.LongRunningOperation=D,e.IEditorProgressService=(0,R.createDecorator)("editorProgressService")}),define(ye[44],Ce([1,0,50,11]),function(te,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class T{constructor(){this.a=new Map}add(I,A){o.ok(t.isString(I)),o.ok(t.isObject(A)),o.ok(!this.a.has(I),"There is already an extension with this id"),this.a.set(I,A)}knows(I){return this.a.has(I)}as(I){return this.a.get(I)||null}}e.Registry=new T}),define(ye[126],Ce([1,0,3,44]),function(te,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function T(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class R{constructor(){this.b=new o.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(y,D){this.a[T(y)]=D,this.b.fire(y)}notifySchemaChanged(y){this.b.fire(y)}getSchemaContributions(){return{schemas:this.a}}}const I=new R;t.Registry.add(e.Extensions.JSONContribution,I)}),define(ye[127],Ce([1,0,18,3,11,168,52,126,44]),function(te,e,o,t,T,R,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var D;(function(w){w.Multiline="multilineText",w.Singleline="singlelineText"})(D=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var L;(function(w){w[w.APPLICATION=1]="APPLICATION",w[w.MACHINE=2]="MACHINE",w[w.WINDOW=3]="WINDOW",w[w.RESOURCE=4]="RESOURCE",w[w.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",w[w.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(L=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const P=y.Registry.as(A.Extensions.JSONContribution);class v{constructor(){this.h=new Set,this.i=new t.Emitter,this.onDidSchemaChange=this.i.event,this.j=new t.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(i,s=!0){this.registerConfigurations([i],s)}registerConfigurations(i,s=!0){const a=new Set;this.n(i,s,a),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:a})}deregisterConfigurations(i){const s=new Set;this.o(i,s),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:i,remove:s}){const a=new Set;this.o(s,a),this.n(i,!1,a),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:a})}registerDefaultConfigurations(i){const s=new Set;this.k(i,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}k(i,s){const a=[];for(const{overrides:u,source:l}of i)for(const c in u)if(s.add(c),e.OVERRIDE_PROPERTY_REGEX.test(c)){const n=this.a.get(c),r=n?.valuesSources??new Map;if(l)for(const M of Object.keys(u[c]))r.set(M,l);const m={...n?.value||{},...u[c]};this.a.set(c,{source:l,value:m,valuesSources:r});const S=(0,I.getLanguageTagSettingPlainKey)(c),k={type:"object",default:m,description:R.localize(1,null,S),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:m,source:T.isString(l)?void 0:l,defaultValueSource:l};a.push(...f(c)),this.d[c]=k,this.b.properties[c]=k}else{this.a.set(c,{value:u[c],source:l});const n=this.d[c];n&&(this.w(c,n),this.r(c,n))}this.m(a)}deregisterDefaultConfigurations(i){const s=new Set;this.l(i,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}l(i,s){for(const{overrides:a,source:u}of i)for(const l in a){const c=this.a.get(l),n=T.isString(u)?u:u?.id,r=T.isString(c?.source)?c?.source:c?.source?.id;if(n===r)if(s.add(l),this.a.delete(l),e.OVERRIDE_PROPERTY_REGEX.test(l))delete this.d[l],delete this.b.properties[l];else{const m=this.d[l];m&&(this.w(l,m),this.r(l,m))}}this.u()}deltaConfiguration(i){let s=!1;const a=new Set;i.removedDefaults&&(this.l(i.removedDefaults,a),s=!0),i.addedDefaults&&(this.k(i.addedDefaults,a),s=!0),i.removedConfigurations&&this.o(i.removedConfigurations,a),i.addedConfigurations&&this.n(i.addedConfigurations,!1,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const s of i)this.h.add(s);this.u()}n(i,s,a){i.forEach(u=>{this.p(u,s,u.extensionInfo,u.restrictedProperties,void 0,a),this.c.push(u),this.q(u)})}o(i,s){const a=u=>{if(u.properties)for(const l in u.properties){s.add(l);const c=this.d[l];c?.policy?.name&&this.e.delete(c.policy.name),delete this.d[l],this.s(l,u.properties[l])}u.allOf?.forEach(l=>a(l))};for(const u of i){a(u);const l=this.c.indexOf(u);l!==-1&&this.c.splice(l,1)}}p(i,s=!0,a,u,l=3,c){l=T.isUndefinedOrNull(i.scope)?l:i.scope;const n=i.properties;if(n)for(const m in n){const S=n[m];if(s&&g(m,S)){delete n[m];continue}if(S.source=a,S.defaultDefaultValue=n[m].default,this.w(m,S),e.OVERRIDE_PROPERTY_REGEX.test(m)?S.scope=void 0:(S.scope=T.isUndefinedOrNull(S.scope)?l:S.scope,S.restricted=T.isUndefinedOrNull(S.restricted)?!!u?.includes(m):S.restricted),n[m].hasOwnProperty("included")&&!n[m].included){this.f[m]=n[m],delete n[m];continue}else this.d[m]=n[m],n[m].policy?.name&&this.e.set(n[m].policy.name,m);!n[m].deprecationMessage&&n[m].markdownDeprecationMessage&&(n[m].deprecationMessage=n[m].markdownDeprecationMessage),c.add(m)}const r=i.allOf;if(r)for(const m of r)this.p(m,s,a,u,l,c)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const s=a=>{const u=a.properties;if(u)for(const c in u)this.r(c,u[c]);a.allOf?.forEach(s)};s(i)}r(i,s){switch(e.allSettings.properties[i]=s,s.scope){case 1:e.applicationSettings.properties[i]=s;break;case 2:e.machineSettings.properties[i]=s;break;case 6:e.machineOverridableSettings.properties[i]=s;break;case 3:e.windowSettings.properties[i]=s;break;case 4:e.resourceSettings.properties[i]=s;break;case 5:e.resourceSettings.properties[i]=s,this.g.properties[i]=s;break}}s(i,s){switch(delete e.allSettings.properties[i],s.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const s=`[${i}]`,a={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(s,a),e.allSettings.properties[s]=a,e.applicationSettings.properties[s]=a,e.machineSettings.properties[s]=a,e.machineOverridableSettings.properties[s]=a,e.windowSettings.properties[s]=a,e.resourceSettings.properties[s]=a}}v(){const i={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this.i.fire()}w(i,s){const a=this.a.get(i);let u=a?.value,l=a?.source;T.isUndefined(u)&&(u=s.defaultDefaultValue,l=void 0),T.isUndefined(u)&&(u=h(s.type)),s.default=u,s.defaultValueSource=l}}const C="\\[([^\\]]+)\\]",E=new RegExp(C,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${C})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function f(w){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(w)){let s=E.exec(w);for(;s?.length;){const a=s[1].trim();a&&i.push(a),s=E.exec(w)}}return(0,o.distinct)(i)}e.overrideIdentifiersFromKey=f;function d(w){return w.reduce((i,s)=>`${i}[${s}]`,"")}e.keyFromOverrideIdentifiers=d;function h(w){switch(Array.isArray(w)?w[0]:w){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const b=new v;y.Registry.add(e.Extensions.Configuration,b);function g(w,i){return w.trim()?e.OVERRIDE_PROPERTY_REGEX.test(w)?R.localize(7,null,w):b.getConfigurationProperties()[w]!==void 0?R.localize(8,null,w):i.policy?.name&&b.getPolicyConfigurations().get(i.policy?.name)!==void 0?R.localize(9,null,w,i.policy?.name,b.getPolicyConfigurations().get(i.policy?.name)):null:R.localize(6,null)}e.validateProperty=g;function p(){const w=[],i=b.getConfigurationProperties();for(const s of Object.keys(i))w.push([s,i[s].scope]);return w.push(["launch",4]),w.push(["task",4]),w}e.getScopes=p}),define(ye[204],Ce([1,0,18,3,146,6,28,23,11,2,52,127,44]),function(te,e,o,t,T,R,I,A,y,D,L,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class C{constructor(s={},a=[],u=[],l){this.c=s,this.d=a,this.f=u,this.raw=l,this.a=!1,this.b=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const s=this.raw.map(a=>{if(a instanceof C)return a;const u=new E("");return u.parseRaw(a),u.configurationModel});this.g=s.reduce((a,u)=>u===a?u:a.merge(u),s[0])}else this.g=this;return this.g}get contents(){return this.k(this.c)}get overrides(){return this.k(this.f)}get keys(){return this.k(this.d)}isEmpty(){return this.d.length===0&&Object.keys(this.c).length===0&&this.f.length===0}isFrozen(){return this.a}getValue(s){return s?(0,L.getConfigurationValue)(this.contents,s):this.contents}inspect(s,a){const u=this.rawConfiguration.getValue(s),l=a?this.rawConfiguration.getOverrideValue(s,a):void 0,c=a?this.rawConfiguration.override(a).getValue(s):u;return{value:u,override:l,merged:c}}getOverrideValue(s,a){const u=this.l(a);return u?s?(0,L.getConfigurationValue)(u,s):u:void 0}getKeysForOverrideIdentifier(s){const a=[];for(const u of this.overrides)u.identifiers.includes(s)&&a.push(...u.keys);return o.distinct(a)}getAllOverrideIdentifiers(){const s=[];for(const a of this.overrides)s.push(...a.identifiers);return o.distinct(s)}override(s){let a=this.b.get(s);return a||(a=this.h(s),this.b.set(s,a)),a}merge(...s){const a=A.deepClone(this.contents),u=A.deepClone(this.overrides),l=[...this.keys],c=this.raw?.length?[...this.raw]:[this];for(const n of s)if(c.push(...n.raw?.length?n.raw:[n]),!n.isEmpty()){this.j(a,n.contents);for(const r of n.overrides){const[m]=u.filter(S=>o.equals(S.identifiers,r.identifiers));m?(this.j(m.contents,r.contents),m.keys.push(...r.keys),m.keys=o.distinct(m.keys)):u.push(A.deepClone(r))}for(const r of n.keys)l.indexOf(r)===-1&&l.push(r)}return new C(a,l,u,c.every(n=>n instanceof C)?void 0:c)}freeze(){return this.a=!0,this}h(s){const a=this.l(s);if(!a||typeof a!="object"||!Object.keys(a).length)return this;const u={};for(const l of o.distinct([...Object.keys(this.contents),...Object.keys(a)])){let c=this.contents[l];const n=a[l];n&&(typeof c=="object"&&typeof n=="object"?(c=A.deepClone(c),this.j(c,n)):c=n),u[l]=c}return new C(u,this.keys,this.overrides)}j(s,a){for(const u of Object.keys(a)){if(u in s&&y.isObject(s[u])&&y.isObject(a[u])){this.j(s[u],a[u]);continue}s[u]=A.deepClone(a[u])}}k(s){return this.a&&!Object.isFrozen(s)?A.deepFreeze(s):s}l(s){let a=null,u=null;const l=c=>{c&&(u?this.j(u,c):u=A.deepClone(c))};for(const c of this.overrides)o.equals(c.identifiers,[s])?a=c.contents:c.identifiers.includes(s)&&l(c.contents);return l(a),u}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(s,a){this.m(s),(0,L.addToValueTree)(this.contents,s,a,u=>{throw new Error(u)})}removeValue(s){this.n(s)&&(0,L.removeFromValueTree)(this.contents,s)}m(s){let a=this.keys.length;for(let u=0;u<a;u++)s.indexOf(this.keys[u])===0&&(a=u);this.keys.splice(a,1,s)}n(s){const a=this.keys.indexOf(s);return a!==-1?(this.keys.splice(a,1),!0):!1}}e.ConfigurationModel=C;class E{constructor(s){this.f=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new C}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,a){if(!y.isUndefinedOrNull(s)){const u=this.g(s);this.parseRaw(u,a)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,a){this.a=s;const{contents:u,keys:l,overrides:c,restricted:n,hasExcludedProperties:r}=this.h(s,a);this.b=new C(u,l,c,r?[s]:void 0),this.c=n||[]}g(s){let a={},u=null,l=[];const c=[],n=[];function r(S){Array.isArray(l)?l.push(S):u!==null&&(l[u]=S)}const m={onObjectBegin:()=>{const S={};r(S),c.push(l),l=S,u=null},onObjectProperty:S=>{u=S},onObjectEnd:()=>{l=c.pop()},onArrayBegin:()=>{const S=[];r(S),c.push(l),l=S,u=null},onArrayEnd:()=>{l=c.pop()},onLiteralValue:r,onError:(S,k,M)=>{n.push({error:S,offset:k,length:M})}};if(s)try{T.visit(s,m),a=l[0]||{}}catch(S){console.error(`Error while parsing settings file ${this.f}: ${S}`),this.d=[S]}return a}h(s,a){const u=v.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),l=this.j(s,u,!0,a);s=l.raw;const c=(0,L.toValuesTree)(s,m=>console.error(`Conflict in settings file ${this.f}: ${m}`)),n=Object.keys(s),r=this.l(s,m=>console.error(`Conflict in settings file ${this.f}: ${m}`));return{contents:c,keys:n,overrides:r,restricted:l.restricted,hasExcludedProperties:l.hasExcludedProperties}}j(s,a,u,l){let c=!1;if(!l?.scopes&&!l?.skipRestricted)return{raw:s,restricted:[],hasExcludedProperties:c};const n={},r=[];for(const m in s)if(P.OVERRIDE_PROPERTY_REGEX.test(m)&&u){const S=this.j(s[m],a,!1,l);n[m]=S.raw,c=c||S.hasExcludedProperties,r.push(...S.restricted)}else{const S=a[m],k=S?typeof S.scope<"u"?S.scope:3:void 0;S?.restricted&&r.push(m),(k===void 0||l.scopes===void 0||l.scopes.includes(k))&&!(l.skipRestricted&&S?.restricted)?n[m]=s[m]:c=!0}return{raw:n,restricted:r,hasExcludedProperties:c}}l(s,a){const u=[];for(const l of Object.keys(s))if(P.OVERRIDE_PROPERTY_REGEX.test(l)){const c={};for(const n in s[l])c[n]=s[l][n];u.push({identifiers:(0,P.overrideIdentifiersFromKey)(l),keys:Object.keys(c),contents:(0,L.toValuesTree)(c,a)})}return u}}e.ConfigurationModelParser=E;class f extends R.Disposable{constructor(s,a,u,l){super(),this.f=s,this.g=a,this.h=l,this.c=this.B(new t.Emitter),this.onDidChange=this.c.event,this.a=new E(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(u.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(t.Event.any(t.Event.filter(this.h.onDidFilesChange,c=>c.contains(this.f)),t.Event.filter(this.h.onDidRunOperation,c=>(c.isOperation(0)||c.isOperation(3)||c.isOperation(1)||c.isOperation(4))&&u.isEqual(c.resource,s)))(()=>this.c.fire()))}async loadConfiguration(){try{const s=await this.h.readFile(this.f);return this.a.parse(s.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new C}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=f;class d{constructor(s,a,u,l,c,n,r,m,S,k,M,q,V){this.a=s,this.b=a,this.value=u,this.overrideIdentifiers=l,this.c=c,this.d=n,this.f=r,this.g=m,this.h=S,this.j=k,this.k=M,this.l=q,this.m=V}get p(){return this.n||(this.n=this.c.inspect(this.a,this.b.overrideIdentifier)),this.n}get defaultValue(){return this.p.merged}get default(){return this.p.value!==void 0||this.p.override!==void 0?{value:this.p.value,override:this.p.override}:void 0}get r(){return this.q===void 0&&(this.q=this.d?this.d.inspect(this.a):null),this.q}get policyValue(){return this.r?.merged}get policy(){return this.r?.value!==void 0?{value:this.r.value}:void 0}get t(){return this.s===void 0&&(this.s=this.f?this.f.inspect(this.a):null),this.s}get applicationValue(){return this.t?.merged}get application(){return this.t?.value!==void 0||this.t?.override!==void 0?{value:this.t.value,override:this.t.override}:void 0}get v(){return this.u||(this.u=this.g.inspect(this.a,this.b.overrideIdentifier)),this.u}get userValue(){return this.v.merged}get user(){return this.v.value!==void 0||this.v.override!==void 0?{value:this.v.value,override:this.v.override}:void 0}get x(){return this.w||(this.w=this.h.inspect(this.a,this.b.overrideIdentifier)),this.w}get userLocalValue(){return this.x.merged}get userLocal(){return this.x.value!==void 0||this.x.override!==void 0?{value:this.x.value,override:this.x.override}:void 0}get z(){return this.y||(this.y=this.j.inspect(this.a,this.b.overrideIdentifier)),this.y}get userRemoteValue(){return this.z.merged}get userRemote(){return this.z.value!==void 0||this.z.override!==void 0?{value:this.z.value,override:this.z.override}:void 0}get B(){return this.A===void 0&&(this.A=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.A}get workspaceValue(){return this.B?.merged}get workspace(){return this.B?.value!==void 0||this.B?.override!==void 0?{value:this.B.value,override:this.B.override}:void 0}get E(){return this.D===void 0&&(this.D=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.D}get workspaceFolderValue(){return this.E?.merged}get workspaceFolder(){return this.E?.value!==void 0||this.E?.override!==void 0?{value:this.E.value,override:this.E.override}:void 0}get memoryValue(){return this.m.merged}get memory(){return this.m.value!==void 0||this.m.override!==void 0?{value:this.m.value,override:this.m.override}:void 0}}class h{constructor(s,a,u,l,c=new C,n=new C,r=new I.ResourceMap,m=new C,S=new I.ResourceMap,k=!0){this.c=s,this.d=a,this.f=u,this.g=l,this.h=c,this.j=n,this.l=r,this.m=m,this.n=S,this.p=k,this.a=null,this.b=new I.ResourceMap,this.q=null}getValue(s,a,u){return this.s(s,a,u).getValue(s)}updateValue(s,a,u={}){let l;u.resource?(l=this.n.get(u.resource),l||(l=new C,this.n.set(u.resource,l))):l=this.m,a===void 0?l.removeValue(s):l.setValue(s,a),u.resource||(this.a=null)}inspect(s,a,u){const l=this.s(s,a,u),c=this.w(a.resource,u),n=a.resource?this.n.get(a.resource)||this.m:this.m,r=new Set;for(const m of l.overrides)for(const S of m.identifiers)l.getOverrideValue(s,S)!==void 0&&r.add(S);return new d(s,a,l.getValue(s),r.size?[...r]:void 0,this.c,this.d.isEmpty()?void 0:this.d.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),u?this.j.freeze():void 0,c?c.freeze():void 0,n.inspect(s,a.overrideIdentifier))}keys(s){const a=this.w(void 0,s);return{default:this.c.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this.j.freeze().keys,workspaceFolder:a?a.freeze().keys:[]}}updateDefaultConfiguration(s){this.c=s,this.a=null,this.b.clear()}updatePolicyConfiguration(s){this.d=s}updateApplicationConfiguration(s){this.f=s,this.a=null,this.b.clear()}updateLocalUserConfiguration(s){this.g=s,this.q=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(s){this.h=s,this.q=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(s){this.j=s,this.a=null,this.b.clear()}updateFolderConfiguration(s,a){this.l.set(s,a),this.b.delete(s)}deleteFolderConfiguration(s){this.r.delete(s),this.b.delete(s)}compareAndUpdateDefaultConfiguration(s,a){const u=[];if(!a){const{added:l,updated:c,removed:n}=p(this.c,s);a=[...l,...c,...n]}for(const l of a)for(const c of(0,P.overrideIdentifiersFromKey)(l)){const n=this.c.getKeysForOverrideIdentifier(c),r=s.getKeysForOverrideIdentifier(c),m=[...r.filter(S=>n.indexOf(S)===-1),...n.filter(S=>r.indexOf(S)===-1),...n.filter(S=>!A.equals(this.c.override(c).getValue(S),s.override(c).getValue(S)))];u.push([c,m])}return this.updateDefaultConfiguration(s),{keys:a,overrides:u}}compareAndUpdatePolicyConfiguration(s){const{added:a,updated:u,removed:l}=p(this.d,s),c=[...a,...u,...l];return c.length&&this.updatePolicyConfiguration(s),{keys:c,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:a,updated:u,removed:l,overrides:c}=p(this.applicationConfiguration,s),n=[...a,...u,...l];return n.length&&this.updateApplicationConfiguration(s),{keys:n,overrides:c}}compareAndUpdateLocalUserConfiguration(s){const{added:a,updated:u,removed:l,overrides:c}=p(this.localUserConfiguration,s),n=[...a,...u,...l];return n.length&&this.updateLocalUserConfiguration(s),{keys:n,overrides:c}}compareAndUpdateRemoteUserConfiguration(s){const{added:a,updated:u,removed:l,overrides:c}=p(this.remoteUserConfiguration,s),n=[...a,...u,...l];return n.length&&this.updateRemoteUserConfiguration(s),{keys:n,overrides:c}}compareAndUpdateWorkspaceConfiguration(s){const{added:a,updated:u,removed:l,overrides:c}=p(this.workspaceConfiguration,s),n=[...a,...u,...l];return n.length&&this.updateWorkspaceConfiguration(s),{keys:n,overrides:c}}compareAndUpdateFolderConfiguration(s,a){const u=this.r.get(s),{added:l,updated:c,removed:n,overrides:r}=p(u,a),m=[...l,...c,...n];return(m.length||!u)&&this.updateFolderConfiguration(s,a),{keys:m,overrides:r}}compareAndDeleteFolderConfiguration(s){const a=this.r.get(s);if(!a)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:u,updated:l,removed:c,overrides:n}=p(a,void 0);return{keys:[...u,...l,...c],overrides:n}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.q||(this.q=this.h.isEmpty()?this.g:this.g.merge(this.h),this.p&&this.q.freeze()),this.q}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.j}get r(){return this.l}s(s,a,u){let l=this.t(a,u);return a.overrideIdentifier&&(l=l.override(a.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(s)!==void 0&&(l=l.merge(this.d)),l}t({resource:s},a){let u=this.u();if(a&&s){const l=a.getFolder(s);l&&(u=this.v(l.uri)||u);const c=this.n.get(s);c&&(u=u.merge(c))}return u}u(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.j,this.m),this.p&&(this.j=this.j.freeze())),this.a}v(s){let a=this.b.get(s);if(!a){const u=this.u(),l=this.l.get(s);l?(a=u.merge(l),this.p&&(a=a.freeze()),this.b.set(s,a)):a=u}return a}w(s,a){if(a&&s){const u=a.getFolder(s);if(u)return this.l.get(u.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},folders:[...this.l.keys()].reduce((s,a)=>{const{contents:u,overrides:l,keys:c}=this.l.get(a);return s.push([a,{contents:u,overrides:l,keys:c}]),s},[])}}allKeys(){const s=new Set;return this.c.freeze().keys.forEach(a=>s.add(a)),this.userConfiguration.freeze().keys.forEach(a=>s.add(a)),this.j.freeze().keys.forEach(a=>s.add(a)),this.l.forEach(a=>a.freeze().keys.forEach(u=>s.add(u))),[...s.values()]}x(){const s=new Set;return this.c.freeze().getAllOverrideIdentifiers().forEach(a=>s.add(a)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(a=>s.add(a)),this.j.freeze().getAllOverrideIdentifiers().forEach(a=>s.add(a)),this.l.forEach(a=>a.freeze().getAllOverrideIdentifiers().forEach(u=>s.add(u))),[...s.values()]}y(s){const a=new Set;return this.c.getKeysForOverrideIdentifier(s).forEach(u=>a.add(u)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(u=>a.add(u)),this.j.getKeysForOverrideIdentifier(s).forEach(u=>a.add(u)),this.l.forEach(u=>u.getKeysForOverrideIdentifier(s).forEach(l=>a.add(l))),[...a.values()]}static parse(s){const a=this.z(s.defaults),u=this.z(s.policy),l=this.z(s.application),c=this.z(s.user),n=this.z(s.workspace),r=s.folders.reduce((m,S)=>(m.set(D.URI.revive(S[0]),this.z(S[1])),m),new I.ResourceMap);return new h(a,u,l,c,new C,n,r,new C,new I.ResourceMap,!1)}static z(s){return new C(s.contents,s.keys,s.overrides).freeze()}}e.Configuration=h;function b(...i){if(i.length===0)return{keys:[],overrides:[]};if(i.length===1)return i[0];const s=new Set,a=new Map;for(const l of i)l.keys.forEach(c=>s.add(c)),l.overrides.forEach(([c,n])=>{const r=(0,I.getOrSet)(a,c,new Set);n.forEach(m=>r.add(m))});const u=[];return a.forEach((l,c)=>u.push([c,[...l.values()]])),{keys:[...s.values()],overrides:u}}e.mergeChanges=b;class g{constructor(s,a,u,l){this.change=s,this.f=a,this.g=u,this.h=l,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.j=void 0;for(const c of s.keys)this.affectedKeys.add(c);for(const[,c]of s.overrides)for(const n of c)this.affectedKeys.add(n);this.d=this.a;for(const c of this.affectedKeys)this.d+=c+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=h.parse(this.f.data)),this.j}affectsConfiguration(s,a){const u=this.a+s,l=this.d.indexOf(u);if(l<0)return!1;const c=l+u.length;if(c>=this.d.length)return!1;const n=this.d.charCodeAt(c);if(n!==this.b&&n!==this.c)return!1;if(a){const r=this.previousConfiguration?this.previousConfiguration.getValue(s,a,this.f?.workspace):void 0,m=this.g.getValue(s,a,this.h);return!A.equals(r,m)}return!0}}e.ConfigurationChangeEvent=g;function p(i,s){const{added:a,removed:u,updated:l}=w(s?.rawConfiguration,i?.rawConfiguration),c=[],n=i?.getAllOverrideIdentifiers()||[],r=s?.getAllOverrideIdentifiers()||[];if(s){const m=r.filter(S=>!n.includes(S));for(const S of m)c.push([S,s.getKeysForOverrideIdentifier(S)])}if(i){const m=n.filter(S=>!r.includes(S));for(const S of m)c.push([S,i.getKeysForOverrideIdentifier(S)])}if(s&&i){for(const m of n)if(r.includes(m)){const S=w({contents:i.getOverrideValue(void 0,m)||{},keys:i.getKeysForOverrideIdentifier(m)},{contents:s.getOverrideValue(void 0,m)||{},keys:s.getKeysForOverrideIdentifier(m)});c.push([m,[...S.added,...S.removed,...S.updated]])}}return{added:a,removed:u,updated:l,overrides:c}}function w(i,s){const a=i?s?i.keys.filter(c=>s.keys.indexOf(c)===-1):[...i.keys]:[],u=s?i?s.keys.filter(c=>i.keys.indexOf(c)===-1):[...s.keys]:[],l=[];if(i&&s){for(const c of s.keys)if(i.keys.indexOf(c)!==-1){const n=(0,L.getConfigurationValue)(s.contents,c),r=(0,L.getConfigurationValue)(i.contents,c);A.equals(n,r)||l.push(c)}}return{added:a,removed:u,updated:l}}}),define(ye[128],Ce([1,0,9,4]),function(te,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var T;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(T=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class R extends o.ErrorNoTelemetry{static isNotAvailable(y){return y instanceof R&&y._code===T.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof R&&y._code===T.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof R&&y._code===T.NoResolverFound}static isHandled(y){return y instanceof R&&y.isHandled}constructor(y,D=T.Unknown,L){super(y),this._message=y,this._code=D,this._detail=L,this.isHandled=D===T.NotAvailable&&L===!0,Object.setPrototypeOf(this,R.prototype)}}e.RemoteAuthorityResolverError=R;function I(A){const y=A.indexOf("+");return y===-1?A:A.substring(0,y)}e.getRemoteAuthorityPrefix=I}),define(ye[67],Ce([1,0,15]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(D){return D.scheme===o.Schemas.vscodeRemote?D.authority:void 0}e.getRemoteAuthority=t;function T(D){if(!D)return;const L=D.indexOf("+");return L<0?D:D.substr(0,L)}e.getRemoteName=T;function R(D){return`/${D.quality??"oss"}-${D.commit??"dev"}`}e.getRemoteServerRootPath=R;function I(D){const{host:L,port:P}=y(D);if(typeof P>"u")throw new Error("Remote authority doesn't contain a port!");return{host:L,port:P}}e.parseAuthorityWithPort=I;function A(D,L){let{host:P,port:v}=y(D);return typeof v>"u"&&(v=L),{host:P,port:v}}e.parseAuthorityWithOptionalPort=A;function y(D){const L=D.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(L)return{host:L[1],port:parseInt(L[2],10)};const P=D.match(/^(\[[0-9a-z:]+\])$/);if(P)return{host:P[1],port:void 0};const v=D.match(/(.*):(\d+)$/);return v?{host:v[1],port:parseInt(v[2],10)}:{host:D,port:void 0}}}),define(ye[26],Ce([1,0,8,4,67]),function(te,e,o,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(E){if(typeof E=="object"&&E!==null&&E.supported!==!0)return E.description}e.getWorkspaceSupportTypeMessage=R;function I(E){return E&&typeof E=="object"&&typeof E.id=="string"&&(!E.uuid||typeof E.uuid=="string")}e.isIExtensionIdentifier=I,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(E){E[E.System=0]="System",E[E.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));var y;(function(E){E.WIN32_X64="win32-x64",E.WIN32_IA32="win32-ia32",E.WIN32_ARM64="win32-arm64",E.LINUX_X64="linux-x64",E.LINUX_ARM64="linux-arm64",E.LINUX_ARMHF="linux-armhf",E.ALPINE_X64="alpine-x64",E.ALPINE_ARM64="alpine-arm64",E.DARWIN_X64="darwin-x64",E.DARWIN_ARM64="darwin-arm64",E.WEB="web",E.UNIVERSAL="universal",E.UNKNOWN="unknown",E.UNDEFINED="undefined"})(y=e.TargetPlatform||(e.TargetPlatform={}));class D{constructor(f){this.value=f,this.c=f.toLowerCase()}static equals(f,d){if(typeof f>"u"||f===null)return typeof d>"u"||d===null;if(typeof d>"u"||d===null)return!1;if(typeof f=="string"||typeof d=="string"){const h=typeof f=="string"?f:f.value,b=typeof d=="string"?d:d.value;return o.equalsIgnoreCase(h,b)}return f.c===d.c}static toKey(f){return typeof f=="string"?f.toLowerCase():f.c}}e.ExtensionIdentifier=D;function L(E){return P(E)}e.isApplicationScopedExtension=L;function P(E){return E.contributes&&E.contributes.localizations?E.contributes.localizations.length>0:!1}e.isLanguagePackExtension=P;function v(E){return E.contributes&&E.contributes.authentication?E.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=v;function C(E,f){if(f){const d=`onResolveRemoteAuthority:${(0,T.getRemoteName)(f)}`;return E.activationEvents?.indexOf(d)!==-1}return!1}e.isResolverExtension=C,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(ye[205],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class o{constructor(){this.b=new Map}c(){return new Promise((T,R)=>te(["vsda"],T,R))}async createNewMessage(T){try{const R=await this.c(),I=new R.validator;if(I){const A=String(o.a++);return this.b.set(A,I),{id:A,data:I.createNewMessage(T)}}}catch{}return{id:"",data:T}}async validate(T,R){if(!T.id)return!0;const I=this.b.get(T.id);if(!I)return!1;this.b.delete(T.id);try{return I.validate(R)==="ok"}catch{return!1}}async sign(T){try{const R=await this.c(),I=new R.signer;if(I)return I.sign(T)}catch{}return T}}e.SignService=o,o.a=1}),define(ye[206],Ce([1,0,12,36,2,30]),function(te,e,o,t,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function I(D){if(o.platform===2&&/^penguin(\.|$)/i.test(D))return"chromebook"}async function A(D,L,P,v,C,E,f,d,h,b){const g=Object.create(null);g["common.machineId"]=f,g.sessionID=(0,R.generateUuid)()+Date.now(),g.commitHash=C,g.version=E,g["common.platformVersion"]=(L||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),g["common.platform"]=(0,o.PlatformToString)(o.platform),g["common.nodePlatform"]=t.platform,g["common.nodeArch"]=v,g["common.product"]=b||"desktop",d&&(g["common.msftInternal"]=d);let p=0;const w=Date.now();Object.defineProperties(g,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-w,enumerable:!0},"common.sequence":{get:()=>p++,enumerable:!0}}),o.isLinuxSnap&&(g["common.snap"]="true");const i=I(P);i&&(g["common.platformDetail"]=i);try{const s=await D.readFile(T.URI.file(h));g["common.source"]=s.value.toString().slice(0,30)}catch{}return g}e.resolveCommonProperties=A;function y(D){const L=t.env.USERDNSDOMAIN;if(!L)return!1;const P=L.toLowerCase();return D.some(v=>P===v)}e.verifyMicrosoftInternalDomain=y}),define(ye[207],Ce([1,0,4]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,o.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,o.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var T;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(T=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ye[68],Ce([1,0,23,11,3,52,67,206,207]),function(te,e,o,t,T,R,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class D{constructor(n){this.value=n}}e.TelemetryTrustedValue=D;class L{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(n,r){return Promise.resolve(void 0)}publicLog2(n,r){return this.publicLog(n,r)}publicLogError(n,r){return Promise.resolve(void 0)}publicLogError2(n,r){return this.publicLogError(n,r)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=L,e.NullTelemetryService=new L;class P{async publicLog(n,r,m){}async publicLogError(n,r,m){}}e.NullEndpointTelemetryService=P,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function v(c,n){return T.Event.debounce(n.onDidChangeConfiguration,(m,S)=>{const k=m?new Set([...m.affectedKeys,...S.affectedKeys]):S.affectedKeys;return{...S,affectedKeys:k}},1e3,!0)(m=>{m.source!==7&&c.publicLog2("updateConfiguration",{configurationSource:(0,R.ConfigurationTargetToString)(m.source),configurationKeys:p(m.affectedKeys)})})}e.configurationTelemetry=v;function C(c,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!c.enableTelemetry||n.extensionTestsLocationURI)}e.supportsTelemetry=C;function E(c,n){return!(n.isBuilt||n.disableTelemetry||c.enableTelemetry&&c.aiConfig?.ariaKey)}e.isLoggingOnly=E;function f(c){const n=c.getValue(y.TELEMETRY_SETTING_ID),r=c.getValue(y.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(c.getValue(y.TELEMETRY_OLD_SETTING_ID)===!1||r===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=f;function d(c){const n={},r={},m={};g(c,m);for(let S in m){S=S.length>150?S.substr(S.length-149):S;const k=m[S];typeof k=="number"?r[S]=k:typeof k=="boolean"?r[S]=k?1:0:typeof k=="string"?(k.length>8192&&console.warn(`Telemetry property: ${S} has been trimmed to 8192, the original length is ${k.length}`),n[S]=k.substring(0,8191)):typeof k<"u"&&k!==null&&(n[S]=k)}return{properties:n,measurements:r}}e.validateTelemetryData=d;const h=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function b(c){if(!c)return"none";const n=(0,I.getRemoteName)(c);return h.has(n)?n:"other"}e.cleanRemoteAuthority=b;function g(c,n,r=0,m){if(!!c)for(const S of Object.getOwnPropertyNames(c)){const k=c[S],M=m?m+S:S;Array.isArray(k)?n[M]=(0,o.safeStringify)(k):k instanceof Date?n[M]=k.toISOString():(0,t.isObject)(k)?r<2?g(k,n,r+1,M+"."):n[M]=(0,o.safeStringify)(k):n[M]=k}}function p(c){if(!c)return[];const n=[];return w(n,"",c),n}function w(c,n,r){r&&typeof r=="object"&&!Array.isArray(r)?Object.keys(r).forEach(m=>w(c,n?`${n}.${m}`:m,r[m])):c.push(n)}function i(c,n){const r=c.msftInternalDomains||[],m=n.getValue("telemetry.internalTesting");return(0,A.verifyMicrosoftInternalDomain)(r)||m}e.isInternalTelemetry=i;function s(c){return[c.appRoot,c.extensionsPath,c.userHome.fsPath,c.tmpDir.fsPath,c.userDataPath]}e.getPiiPathsFromEnvironment=s;function a(c,n){if(!c||!c.includes("/")&&!c.includes("\\"))return c;let r=c;const m=[];for(const q of n)for(;;){const V=q.exec(c);if(!V)break;m.push([V.index,q.lastIndex])}const S=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,k=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let M=0;for(r="";;){const q=k.exec(c);if(!q)break;const V=m.some(([F,U])=>q.index<U&&F<k.lastIndex);!S.test(q[0])&&!V&&(r+=c.substring(M,q.index)+"<REDACTED: user-file-path>",M=k.lastIndex)}return M<c.length&&(r+=c.substr(M)),r}function u(c){if(!c)return c;const n=c.toLowerCase(),r=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const m of r)if(m.regex.test(n))return`<REDACTED: ${m.label}>`;return c}function l(c,n){return(0,o.cloneAndChange)(c,r=>{if(r instanceof D)return r.value;if(typeof r=="string"){let m=r.replaceAll("%20"," ");m=a(m,n);for(const S of n)m=m.replace(S,"");return m=u(m),m}})}e.cleanData=l}),define(ye[208],Ce([1,0,8,122,26,12,2,9,36,68]),function(te,e,o,t,T,R,I,A,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function L(a,u){return a.uuid&&u.uuid?a.uuid===u.uuid:a.id===u.id?!0:(0,o.compareIgnoreCase)(a.id,u.id)===0}e.areSameExtensions=L;const P=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class v{static create(u){const l=u.manifest?u.manifest.version:u.version,c=u.manifest?u.targetPlatform:u.properties.targetPlatform;return new v(u.identifier,l,c)}static parse(u){const l=P.exec(u);return l&&l[1]&&l[2]?new v({id:l[1]},l[2],l[4]||void 0):null}constructor(u,l,c="undefined"){this.version=l,this.targetPlatform=c,this.id=u.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(u){return u instanceof v?L(this,u)&&this.version===u.version&&this.targetPlatform===u.targetPlatform:!1}}e.ExtensionKey=v;const C=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function E(a){const u=C.exec(a);return u&&u[1]?[d(u[1]),u[2]]:[d(a),void 0]}e.getIdAndVersion=E;function f(a,u){return`${a}.${u}`}e.getExtensionId=f;function d(a){return a.toLocaleLowerCase()}e.adoptToGalleryExtensionId=d;function h(a,u){return d(f(a,u))}e.getGalleryExtensionId=h;function b(a,u){const l=[],c=n=>{for(const r of l)if(r.some(m=>L(u(m),u(n))))return r;return null};for(const n of a){const r=c(n);r?r.push(n):l.push([n])}return l}e.groupByExtension=b;function g(a){return{id:a.identifier.id,name:a.manifest.name,galleryId:null,publisherId:a.publisherId,publisherName:a.manifest.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:a.manifest.extensionDependencies&&a.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=g;function p(a){return{id:new D.TelemetryTrustedValue(a.identifier.id),name:new D.TelemetryTrustedValue(a.name),galleryId:a.identifier.uuid,publisherId:a.publisherId,publisherName:a.publisher,publisherDisplayName:a.publisherDisplayName,isPreReleaseVersion:a.properties.isPreReleaseVersion,dependencies:!!(a.properties.dependencies&&a.properties.dependencies.length>0),isSigned:a.isSigned,...a.telemetryData}}e.getGalleryExtensionTelemetryData=p,e.BetterMergeId=new T.ExtensionIdentifier("pprice.better-merge");function w(a,u){const l=[],c=u.manifest.extensionDependencies?.slice(0)??[];for(;c.length;){const n=c.shift();if(n&&l.every(r=>!L(r.identifier,{id:n}))){const r=a.filter(m=>L(m.identifier,{id:n}));r.length===1&&(l.push(r[0]),c.push(...r[0].manifest.extensionDependencies?.slice(0)??[]))}}return l}e.getExtensionDependencies=w;async function i(a,u){if(!R.isLinux)return!1;let l;try{l=(await a.readFile(I.URI.file("/etc/os-release"))).value.toString()}catch{try{l=(await a.readFile(I.URI.file("/usr/lib/os-release"))).value.toString()}catch(n){u.debug("Error while getting the os-release file.",(0,A.getErrorMessage)(n))}}return!!l&&(l.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=i;async function s(a,u){const l=await i(a,u),c=(0,t.getTargetPlatform)(l?"alpine":R.platform,y.arch);return u.debug("ComputeTargetPlatform:",c),c}e.computeTargetPlatform=s}),define(ye[209],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class o{constructor(T){this.b=T,this.a=new Map}dispose(){for(const T of this.a.values())T.dispose()}startBuffering(T,R,I=5){const A=R(y=>{const D=typeof y=="string"?y:y.data;let L=this.a.get(T);if(L){L.data.push(D);return}const P=setTimeout(()=>this.flushBuffer(T),I);L={data:[D],timeoutId:P,dispose:()=>{clearTimeout(P),this.flushBuffer(T),A.dispose()}},this.a.set(T,L)});return A}stopBuffering(T){this.a.get(T)?.dispose()}flushBuffer(T){const R=this.a.get(T);R&&(this.a.delete(T),this.b(T,R.data.join("")))}}e.TerminalDataBufferer=o}),define(ye[210],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var o;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST_DARK="hcDark",R.HIGH_CONTRAST_LIGHT="hcLight"})(o=e.ColorScheme||(e.ColorScheme={}));function t(R){return R===o.HIGH_CONTRAST_DARK||R===o.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function T(R){return R===o.DARK||R===o.HIGH_CONTRAST_DARK}e.isDark=T}),define(ye[90],Ce([1,0,80,3,6,4,44,210]),function(te,e,o,t,T,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,R.createDecorator)("themeService");var y;(function(d){function h(b){return b&&typeof b=="object"&&typeof b.id=="string"}d.isThemeColor=h})(y=e.ThemeColor||(e.ThemeColor={}));function D(d){return{id:d}}e.themeColorFromId=D;var L;(function(d){function h(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(typeof u.color>"u"||y.isThemeColor(u.color))}d.isThemeIcon=h;const b=new RegExp(`^\\$\\((${o.CSSIcon.iconNameExpression}(?:${o.CSSIcon.iconModifierExpression})?)\\)$`);function g(u){const l=b.exec(u);if(!l)return;const[,c]=l;return{id:c}}d.fromString=g;function p(u){return{id:u}}d.fromId=p;function w(u,l){let c=u.id;const n=c.lastIndexOf("~");return n!==-1&&(c=c.substring(0,n)),l&&(c=`${c}~${l}`),{id:c}}d.modify=w;function i(u){const l=u.id.lastIndexOf("~");if(l!==-1)return u.id.substring(l+1)}d.getModifier=i;function s(u,l){return u.id===l.id&&u.color?.id===l.color?.id}d.isEqual=s;function a(u,l){return{id:u.id,color:l?D(l):void 0}}d.asThemeIcon=a,d.asClassNameArray=o.CSSIcon.asClassNameArray,d.asClassName=o.CSSIcon.asClassName,d.asCSSSelector=o.CSSIcon.asCSSSelector})(L=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=o.Codicon.file,e.FolderThemeIcon=o.Codicon.folder;function P(d){switch(d){case A.ColorScheme.DARK:return"vs-dark";case A.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case A.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=P,e.Extensions={ThemingContribution:"base.contributions.theming"};class v{constructor(){this.a=[],this.a=[],this.b=new t.Emitter}onColorThemeChange(h){return this.a.push(h),this.b.fire(h),(0,T.toDisposable)(()=>{const b=this.a.indexOf(h);this.a.splice(b,1)})}get onThemingParticipantAdded(){return this.b.event}getThemingParticipants(){return this.a}}const C=new v;I.Registry.add(e.Extensions.ThemingContribution,C);function E(d){return C.onColorThemeChange(d)}e.registerThemingParticipant=E;class f extends T.Disposable{constructor(h){super(),this.k=h,this.h=h.getColorTheme(),this.B(this.k.onDidColorThemeChange(b=>this.n(b)))}n(h){this.h=h,this.updateStyles()}updateStyles(){}w(h,b){let g=this.h.getColor(h);return g&&b&&(g=b(g,this.h)),g?g.toString():null}}e.Themable=f}),define(ye[129],Ce([1,0,3,52,4,13]),function(te,e,o,t,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,T.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,T.createDecorator)("sharedTunnelsService");var I;(function(f){f.Http="http",f.Https="https"})(I=e.TunnelProtocol||(e.TunnelProtocol={}));var A;(function(f){f.ConstantPrivate="constantPrivate",f.Private="private",f.Public="public"})(A=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var y;(function(f){f[f.Notify=1]="Notify",f[f.OpenBrowser=2]="OpenBrowser",f[f.OpenPreview=3]="OpenPreview",f[f.Silent=4]="Silent",f[f.Ignore=5]="Ignore",f[f.OpenBrowserOnce=6]="OpenBrowserOnce"})(y=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function D(f){if(f.scheme!=="http"&&f.scheme!=="https")return;const d=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(f.authority);if(!!d)return{address:d[1],port:+d[2]}}e.extractLocalHostUriMetaDataForPortMapping=D,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function L(f){return e.LOCALHOST_ADDRESSES.indexOf(f)>=0}e.isLocalhost=L,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function P(f){return e.ALL_INTERFACES_ADDRESSES.indexOf(f)>=0}e.isAllInterfaces=P;function v(f,d,h,b){if(h===1)return!1;if(h===2&&P(d)){const g=/(\d+)\.(\d+)\.(\d+)/g.exec(b);if(g?.length===4&&parseInt(g[1])>=18)return!1}return f<1024}e.isPortPrivileged=v;class C{constructor(d,h,b){this.remoteAddress=d,this.localAddress=h,this.b=b,this.a=new o.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=C;let E=class{constructor(d,h){this.i=d,this.j=h,this.a=new o.Emitter,this.onTunnelOpened=this.a.event,this.b=new o.Emitter,this.onTunnelClosed=this.b.event,this.c=new o.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const d=this.j.getValue("remote.localPortHost");return!d||d==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(d){return this.e=d,d?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(d){this.f=d.elevation,this.g=d.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const d=[],h=Array.from(this.d.values());for(const b of h){const g=Array.from(b.values());for(const p of g){const w=await p.value;w&&d.push(w)}}return d}async dispose(){for(const d of this.d.values()){for(const{value:h}of d.values())await h.then(b=>b?.dispose());d.clear()}this.d.clear()}setEnvironmentTunnel(d,h,b,g,p){this.o(d,h,Promise.resolve({tunnelRemoteHost:d,tunnelRemotePort:h,localAddress:b,privacy:g,protocol:p,dispose:()=>Promise.resolve()}))}async getExistingTunnel(d,h){(P(d)||L(d))&&(d=e.LOCALHOST_ADDRESSES[0]);const b=this.q(d,h);if(b)return++b.refcount,b.value}openTunnel(d,h,b,g,p=!1,w,i){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${h}:${b} on local port ${g}.`),!d)return;if(h||(h="localhost"),this.e&&this.h.has(b)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const s=this.r(d,h,b,g,p,w,i);return s?s.then(a=>{if(!a){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(h,b);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const u=this.m(a);return(a.tunnelRemoteHost!==h||a.tunnelRemotePort!==b)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(u),u}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),s)}m(d){return{tunnelRemotePort:d.tunnelRemotePort,tunnelRemoteHost:d.tunnelRemoteHost,tunnelLocalPort:d.tunnelLocalPort,localAddress:d.localAddress,privacy:d.privacy,protocol:d.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${d.tunnelRemoteHost}:${d.tunnelRemotePort} `);const h=this.d.get(d.tunnelRemoteHost);if(h){const b=h.get(d.tunnelRemotePort);b&&(b.refcount--,await this.n(d.tunnelRemoteHost,d.tunnelRemotePort,b))}}}}async n(d,h,b){if(b.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${d}:${h}.`);const g=b.value.then(async p=>{p&&(await p.dispose(!0),this.b.fire({host:p.tunnelRemoteHost,port:p.tunnelRemotePort}))});return this.d.has(d)&&this.d.get(d).delete(h),g}}async closeTunnel(d,h){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${d}:${h} `);const b=this.d.get(d);if(b&&b.has(h)){const g=b.get(h);g.refcount=0,await this.n(d,h,g)}}o(d,h,b){this.d.has(d)||this.d.set(d,new Map),this.d.get(d).set(h,{refcount:1,value:b})}async p(d,h){const b=this.d.get(d);b&&(await b.get(h)||b.delete(h),b.size===0&&this.d.delete(d))}q(d,h){const b=[d];L(d)?(b.push(...e.LOCALHOST_ADDRESSES),b.push(...e.ALL_INTERFACES_ADDRESSES)):P(d)&&b.push(...e.ALL_INTERFACES_ADDRESSES);const g=b.map(p=>this.d.get(p));for(const p of g){const w=p?.get(h);if(w)return w}}canTunnel(d){return!!D(d)}s(d,h,b,g,p,w,i){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${h}:${b} on local port ${g}.`);const s=b;this.h.add(s);const a=g===void 0?b:g,u={elevationRequired:p?this.isPortPrivileged(a):!1},l={remoteAddress:{host:h,port:b},localAddressPort:g,privacy:w,public:w?w!==A.Private:void 0,protocol:i},c=d.forwardPort(l,u);return c?(this.o(h,b,c),c.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(s)})):this.h.delete(s),c}};E=qe([We(0,R.ILogService),We(1,t.IConfigurationService)],E),e.AbstractTunnelService=E}),define(ye[211],Ce([1,0,4]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,o.createDecorator)("editSessionIdentityService");var t;(function(T){T[T.Complete=100]="Complete",T[T.Partial=50]="Partial",T[T.None=0]="None"})(t=e.EditSessionIdentityMatch||(e.EditSessionIdentityMatch={}))}),define(ye[212],Ce([1,0,15]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function t(y){return y.scheme!==o.Schemas.file&&y.scheme!==o.Schemas.vscodeRemote}e.isVirtualResource=t;function T(y){if(y.folders.length)return y.folders.every(D=>t(D.uri))?y.folders[0].uri:void 0;if(y.configuration&&t(y.configuration))return y.configuration}e.getVirtualWorkspaceLocation=T;function R(y){return T(y)?.scheme}e.getVirtualWorkspaceScheme=R;function I(y){return T(y)?.authority}e.getVirtualWorkspaceAuthority=I;function A(y){return T(y)!==void 0}e.isVirtualWorkspace=A}),define(ye[47],Ce([1,0,174,10,64,24,2,4,15]),function(te,e,o,t,T,R,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");function D(a){const u=a;return typeof u?.id=="string"&&I.URI.isUri(u.uri)}e.isSingleFolderWorkspaceIdentifier=D;function L(a){return typeof a?.id=="string"&&!D(a)&&!v(a)}e.isEmptyWorkspaceIdentifier=L,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function P(a,u){if(typeof a=="string"||typeof a>"u")return typeof a=="string"?{id:(0,t.basename)(a)}:u?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const l=a;return l.configuration?{id:l.id,configPath:l.configuration}:l.folders.length===1?{id:l.id,uri:l.folders[0].uri}:{id:l.id}}e.toWorkspaceIdentifier=P;function v(a){const u=a;return typeof u?.id=="string"&&I.URI.isUri(u.configPath)}e.isWorkspaceIdentifier=v;function C(a){const u=a;if(u?.uri)return{id:u.id,uri:I.URI.revive(u.uri)};const l=a;if(l?.configPath)return{id:l.id,configPath:I.URI.revive(l.configPath)};if(a?.id)return{id:a.id}}e.reviveIdentifier=C;var E;(function(a){a[a.EMPTY=1]="EMPTY",a[a.FOLDER=2]="FOLDER",a[a.WORKSPACE=3]="WORKSPACE"})(E=e.WorkbenchState||(e.WorkbenchState={}));function f(a){const u=a;return!!(u&&typeof u=="object"&&typeof u.id=="string"&&Array.isArray(u.folders))}e.isWorkspace=f;function d(a){const u=a;return!!(u&&typeof u=="object"&&I.URI.isUri(u.uri)&&typeof u.name=="string"&&typeof u.toResource=="function")}e.isWorkspaceFolder=d;class h{constructor(u,l,c,n,r){this.h=u,this.j=c,this.k=n,this.l=r,this.c=T.TernarySearchTree.forUris(this.l,()=>!0),this.folders=l}update(u){this.h=u.id,this.k=u.configuration,this.j=u.transient,this.l=u.l,this.folders=u.folders}get folders(){return this.g}set folders(u){this.g=u,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(u){this.k=u}getFolder(u){return u&&this.c.findSubstr(u)||null}n(){this.c=T.TernarySearchTree.forUris(this.l,()=>!0);for(const u of this.folders)this.c.set(u.uri,u)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=h;class b{constructor(u,l){this.raw=l,this.uri=u.uri,this.index=u.index,this.name=u.name}toResource(u){return(0,R.joinPath)(this.uri,u)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=b;function g(a){return new b({uri:a,index:0,name:(0,R.basenameOrAuthority)(a)},{uri:a.toString()})}e.toWorkspaceFolder=g,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,o.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function p(a,u){return R.extUriBiasedIgnorePathCase.isEqualOrParent(a,u.untitledWorkspacesHome)}e.isUntitledWorkspace=p;function w(a){let u;return I.URI.isUri(a)?u=a:u=a.configuration,u?.scheme===y.Schemas.tmp}e.isTemporaryWorkspace=w;function i(a,u){return!p(a,u)&&!w(a)}e.isSavedWorkspace=i;function s(a){return(typeof a=="string"?(0,t.extname)(a):(0,R.extname)(a))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=s}),define(ye[69],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class o{constructor(T){this.d=T,this.b=new Map,this.c=1}add(T){const R=this.c++;return this.b.set(R,T),this.e(),R}get(T,R){return this.b.has(T)?this.b.get(T)[R]:void 0}delete(T){this.b.delete(T),this.e()}e(){!o.a||console.log(`${this.d} cache size - ${this.b.size}`)}}e.Cache=o,o.a=!1}),define(ye[48],Ce([1,0,15,24,4]),function(te,e,o,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class R{constructor(){this.a=new Set(Object.keys(o.Schemas)),this.b=new Map,this.extUri=new t.ExtUri(A=>{const y=this.b.get(A.scheme);return!(y===void 0||y&1024)})}$acceptProviderInfos(A,y){y===null?this.b.delete(A.scheme):this.b.set(A.scheme,y)}isFreeScheme(A){return!this.b.has(A)&&!this.a.has(A)}getCapabilities(A){return this.b.get(A)}}e.ExtHostFileSystemInfo=R,e.IExtHostFileSystemInfo=(0,T.createDecorator)("IExtHostFileSystemInfo")}),define(ye[25],Ce([1,0,4]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,o.createDecorator)("IExtHostInitDataService")}),define(ye[213],Ce([1,0,16]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class t{constructor(I,A,y){this.h=new Map,this.a=I,this.b=A,this.c=y,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(D=>(this.f=D,this)),this.g=this.c.onDidChangeStorage(D=>{D.shared===this.b&&D.key===this.a&&(this.f=D.value)}),this.i=new o.RunOnceScheduler(()=>{const D=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const L of D.values())L.complete()}catch(L){for(const P of D.values())P.error(L)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,I])=>I!==void 0).map(([I])=>I)}get whenReady(){return this.d}get(I,A){let y=this.f[I];return typeof y>"u"&&(y=A),y}update(I,A){this.f[I]=A;const y=this.h.get(I);if(y!==void 0)return y.p;const D=new o.DeferredPromise;return this.h.set(I,D),this.i.isScheduled()||this.i.schedule(),D.p}dispose(){this.g.dispose()}}e.ExtensionMemento=t;class T extends t{setKeysForSync(I){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},I)}constructor(I,A){super(I.identifier.value,!0,A),this.j=I}}e.ExtensionGlobalMemento=T}),define(ye[214],Ce([1,0,3,2]),function(te,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class T{constructor(I){this.c=I,this.a=new o.Emitter,this.onDidSaveNotebookDocument=this.a.event,this.b=new o.Emitter,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(I,A,y,D){const P=this.c.getNotebookDocument(t.URI.revive(I)).acceptModelChanged(A.value,y,D);this.b.fire(P)}$acceptDirtyStateChanged(I,A){this.c.getNotebookDocument(t.URI.revive(I)).acceptDirty(A)}$acceptModelSaved(I){const A=this.c.getNotebookDocument(t.URI.revive(I));this.a.fire(A.apiNotebook)}}e.ExtHostNotebookDocuments=T}),define(ye[17],Ce([1,0,4]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,o.createDecorator)("IExtHostRpcService");class t{constructor(R){this.getProxy=R.getProxy.bind(R),this.set=R.set.bind(R),this.dispose=R.dispose.bind(R),this.assertRegistered=R.assertRegistered.bind(R),this.drain=R.drain.bind(R)}}e.ExtHostRpcService=t});var Je=this&&this.__classPrivateFieldSet||function(te,e,o,t,T){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?T.call(te,o):T?T.value=o:e.set(te,o),o},Ue=this&&this.__classPrivateFieldGet||function(te,e,o,t){if(o==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?t:o==="a"?t.call(te):t?t.value:e.get(te)};define(ye[215],Ce([1,0,26,3]),function(te,e,o,t){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class R{constructor(A,y){T.set(this,void 0),this.b=new t.Emitter,this.onDidChange=this.b.event,this.a=o.ExtensionIdentifier.toKey(A.identifier),Je(this,T,y,"f"),Ue(this,T,"f").onDidChangePassword(D=>{D.extensionId===this.a&&this.b.fire({key:D.key})})}get(A){return Ue(this,T,"f").get(this.a,A)}store(A,y){return Ue(this,T,"f").store(this.a,A,y)}delete(A){return Ue(this,T,"f").delete(this.a,A)}}e.ExtensionSecrets=R,T=new WeakMap}),define(ye[54],Ce([1,0,4,129,3,17]),function(te,e,o,t,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var I;(function(y){function D(P){return{remoteAddress:P.remoteAddress,localAddress:P.localAddress,public:!!P.public,privacy:P.privacy??(P.public?t.TunnelPrivacyId.Public:t.TunnelPrivacyId.Private),protocol:P.protocol}}y.fromApiTunnel=D;function L(P){return{remoteAddress:{host:P.tunnelRemoteHost,port:P.tunnelRemotePort},localAddress:P.localAddress,public:P.privacy!==t.TunnelPrivacyId.ConstantPrivate&&P.privacy!==t.TunnelPrivacyId.ConstantPrivate,privacy:P.privacy,protocol:P.protocol}}y.fromServiceTunnel=L})(I=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,o.createDecorator)("IExtHostTunnelService");let A=class{constructor(D){this.onDidChangeTunnels=new T.Emitter().event}async $applyCandidateFilter(D){return D}async openTunnel(D,L){}async getTunnels(){return[]}async setTunnelFactory(D){return{dispose:()=>{}}}registerPortsAttributesProvider(D,L){return{dispose:()=>{}}}async $providePortAttributes(D,L,P,v,C){return[]}async $forwardPort(D,L){}async $closeTunnel(D){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};A=qe([We(0,R.IExtHostRpcService)],A),e.ExtHostTunnelService=A}),define(ye[55],Ce([1,0,4]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,o.createDecorator)("IURITransformerService");class t{constructor(R){R?(this.transformIncoming=R.transformIncoming.bind(R),this.transformOutgoing=R.transformOutgoing.bind(R),this.transformOutgoingURI=R.transformOutgoingURI.bind(R),this.transformOutgoingScheme=R.transformOutgoingScheme.bind(R)):(this.transformIncoming=I=>I,this.transformOutgoing=I=>I,this.transformOutgoingURI=I=>I,this.transformOutgoingScheme=I=>I)}}e.URITransformerService=t}),define(ye[216],Ce([1,0,22]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class t{constructor(){this.buffers=[]}add(y){let D=this.buffers.indexOf(y);return D<0&&(D=this.buffers.length,this.buffers.push(y)),D}}function T(A,y){if(y.serializeBuffersForPostMessage){const D=new t,L=(C,E)=>{if(E instanceof ArrayBuffer){const f=D.add(E);return{$$vscode_array_buffer_reference$$:!0,index:f}}else if(ArrayBuffer.isView(E)){const f=R(E);if(f){const d=D.add(E.buffer);return{$$vscode_array_buffer_reference$$:!0,index:d,view:{type:f,byteLength:E.byteLength,byteOffset:E.byteOffset}}}}return E},P=JSON.stringify(A,L),v=D.buffers.map(C=>{const E=new Uint8Array(C);return o.VSBuffer.wrap(E)});return{message:P,buffers:v}}else return{message:JSON.stringify(A),buffers:[]}}e.serializeWebviewMessage=T;function R(A){switch(A.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function I(A,y){const D=y.map(v=>{const C=new ArrayBuffer(v.byteLength);return new Uint8Array(C).set(v.buffer),C}),L=y.length?(v,C)=>{if(C&&typeof C=="object"&&C.$$vscode_array_buffer_reference$$){const E=C,{index:f}=E,d=D[f];if(E.view)switch(E.view.type){case 1:return new Int8Array(d,E.view.byteOffset,E.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(d,E.view.byteOffset,E.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(d,E.view.byteOffset,E.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(d,E.view.byteOffset,E.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(d,E.view.byteOffset,E.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(d,E.view.byteOffset,E.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(d,E.view.byteOffset,E.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(d,E.view.byteOffset,E.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(d,E.view.byteOffset,E.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(d,E.view.byteOffset,E.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(d,E.view.byteOffset,E.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return d}return C}:void 0;return{message:JSON.parse(A,L),arrayBuffers:D}}e.deserializeWebviewMessage=I}),define(ye[217],Ce([1,0,113]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function t(R){return{transformIncoming:I=>I.scheme==="vscode-remote"?{scheme:"file",path:I.path,query:I.query,fragment:I.fragment}:I.scheme==="file"?{scheme:"vscode-local",path:I.path,query:I.query,fragment:I.fragment}:I,transformOutgoing:I=>I.scheme==="file"?{scheme:"vscode-remote",authority:R,path:I.path,query:I.query,fragment:I.fragment}:I.scheme==="vscode-local"?{scheme:"file",path:I.path,query:I.query,fragment:I.fragment}:I,transformOutgoingScheme:I=>I==="file"?"vscode-remote":I==="vscode-local"?"file":I}}function T(R){return new o.URITransformer(t(R))}e.createURITransformer=T}),define(ye[130],Ce([1,0,184,11,2,6,4,44,39,15,45,160,37]),function(te,e,o,t,T,R,I,A,y,D,L,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,o.localize)(0,null),providerDisplayName:(0,o.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var C;(function(X){X[X.PROGRAMMATIC=1]="PROGRAMMATIC",X[X.USER=2]="USER",X[X.EDIT=3]="EDIT",X[X.NAVIGATION=4]="NAVIGATION",X[X.JUMP=5]="JUMP"})(C=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var E;(function(X){X[X.IDENTICAL=1]="IDENTICAL",X[X.SIMILAR=2]="SIMILAR",X[X.DIFFERENT=3]="DIFFERENT"})(E=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function f(X){const K=X;return!!K&&typeof K.getSelection=="function"&&!!K.onDidChangeSelection}e.isEditorPaneWithSelection=f;function d(X,K,he){for(const be of he.visibleEditorPanes)if(be.group.id===K&&X.matches(be.input))return be.getViewState()}e.findViewStateForEditor=d;function h(X){if(r(X))return!1;const K=X;return T.URI.isUri(K?.resource)}e.isResourceEditorInput=h;function b(X){if(r(X))return!1;const K=X;return K?.original!==void 0&&K.modified!==void 0}e.isResourceDiffEditorInput=b;function g(X){if(r(X)||b(X))return!1;const K=X;return K?.primary!==void 0&&K.secondary!==void 0}e.isResourceSideBySideEditorInput=g;function p(X){if(r(X))return!1;const K=X;return K?K.resource===void 0||K.resource.scheme===D.Schemas.untitled||K.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=p;const w=/Untitled-\d+/;function i(X){return X.scheme===D.Schemas.untitled&&X.path.length>1&&!w.test(X.path)}e.isUntitledWithAssociatedResource=i;function s(X){if(r(X))return!1;const K=X;return T.URI.isUri(K?.base?.resource)&&T.URI.isUri(K?.input1?.resource)&&T.URI.isUri(K?.input2?.resource)&&T.URI.isUri(K?.result?.resource)}e.isResourceMergeEditorInput=s;var a;(function(X){X[X.SHORT=0]="SHORT",X[X.MEDIUM=1]="MEDIUM",X[X.LONG=2]="LONG"})(a=e.Verbosity||(e.Verbosity={}));var u;(function(X){X[X.EXPLICIT=1]="EXPLICIT",X[X.AUTO=2]="AUTO",X[X.FOCUS_CHANGE=3]="FOCUS_CHANGE",X[X.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(u=e.SaveReason||(e.SaveReason={}));class l{constructor(){this.a=new Map}registerSource(K,he){let be=this.a.get(K);return be||(be={source:K,label:he},this.a.set(K,be)),be.source}getSourceLabel(K){return this.a.get(K)?.label??K}}e.SaveSourceRegistry=new l;var c;(function(X){X[X.None=0]="None",X[X.Readonly=2]="Readonly",X[X.Untitled=4]="Untitled",X[X.Singleton=8]="Singleton",X[X.RequiresTrust=16]="RequiresTrust",X[X.CanSplitInGroup=32]="CanSplitInGroup",X[X.ForceDescription=64]="ForceDescription",X[X.CanDropIntoEditor=128]="CanDropIntoEditor",X[X.MultipleEditors=256]="MultipleEditors"})(c=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class n extends R.Disposable{}e.AbstractEditorInput=n;function r(X){return X instanceof n}e.isEditorInput=r;function m(X){const K=X;return T.URI.isUri(K?.preferredResource)}function S(X){const K=X;return r(K?.primary)&&r(K?.secondary)}e.isSideBySideEditorInput=S;function k(X){const K=X;return r(K?.modified)&&r(K?.original)}e.isDiffEditorInput=k;function M(X,K,he,be,Ee){return ie(be,[(0,P.toAction)({id:"workbench.action.openLargeFile",label:(0,o.localize)(2,null),run:()=>{const Pe={...he,limits:{size:Number.MAX_VALUE}};X.openEditor(K,Pe)}}),(0,P.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,o.localize)(3,null),run:()=>Ee.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:v.default.Warning})}e.createTooLargeFileError=M;function q(X){return r(X?.editor)}e.isEditorInputWithOptions=q;function V(X){const K=X;return q(X)&&K?.group!==void 0}e.isEditorInputWithOptionsAndGroup=V;function F(X){const K=X;return typeof K?.groupId=="number"&&r(K.editor)}e.isEditorIdentifier=F;var U;(function(X){X[X.UNKNOWN=0]="UNKNOWN",X[X.REPLACE=1]="REPLACE",X[X.MOVE=2]="MOVE",X[X.UNPIN=3]="UNPIN"})(U=e.EditorCloseContext||(e.EditorCloseContext={}));var N;(function(X){X[X.GROUP_ACTIVE=0]="GROUP_ACTIVE",X[X.GROUP_INDEX=1]="GROUP_INDEX",X[X.GROUP_LOCKED=2]="GROUP_LOCKED",X[X.EDITOR_OPEN=3]="EDITOR_OPEN",X[X.EDITOR_CLOSE=4]="EDITOR_CLOSE",X[X.EDITOR_MOVE=5]="EDITOR_MOVE",X[X.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",X[X.EDITOR_LABEL=7]="EDITOR_LABEL",X[X.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",X[X.EDITOR_PIN=9]="EDITOR_PIN",X[X.EDITOR_STICKY=10]="EDITOR_STICKY",X[X.EDITOR_DIRTY=11]="EDITOR_DIRTY",X[X.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(N=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var B;(function(X){X[X.PRIMARY=1]="PRIMARY",X[X.SECONDARY=2]="SECONDARY",X[X.BOTH=3]="BOTH",X[X.ANY=4]="ANY"})(B=e.SideBySideEditor||(e.SideBySideEditor={}));class j{getOriginalUri(K,he){if(!K)return;if(s(K))return e.EditorResourceAccessor.getOriginalUri(K.result,he);if(he?.supportSideBySide){const{primary:Ee,secondary:Pe}=this.a(K);if(Ee&&Pe){if(he?.supportSideBySide===B.BOTH)return{primary:this.getOriginalUri(Ee,{filterByScheme:he.filterByScheme}),secondary:this.getOriginalUri(Pe,{filterByScheme:he.filterByScheme})};if(he?.supportSideBySide===B.ANY)return this.getOriginalUri(Ee,{filterByScheme:he.filterByScheme})??this.getOriginalUri(Pe,{filterByScheme:he.filterByScheme});K=he.supportSideBySide===B.PRIMARY?Ee:Pe}}if(b(K)||g(K)||s(K))return;const be=m(K)?K.preferredResource:K.resource;return!be||!he||!he.filterByScheme?be:this.b(be,he.filterByScheme)}a(K){return S(K)||g(K)?{primary:K.primary,secondary:K.secondary}:k(K)||b(K)?{primary:K.modified,secondary:K.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(K,he){if(!K)return;if(s(K))return e.EditorResourceAccessor.getCanonicalUri(K.result,he);if(he?.supportSideBySide){const{primary:Ee,secondary:Pe}=this.a(K);if(Ee&&Pe){if(he?.supportSideBySide===B.BOTH)return{primary:this.getCanonicalUri(Ee,{filterByScheme:he.filterByScheme}),secondary:this.getCanonicalUri(Pe,{filterByScheme:he.filterByScheme})};if(he?.supportSideBySide===B.ANY)return this.getCanonicalUri(Ee,{filterByScheme:he.filterByScheme})??this.getCanonicalUri(Pe,{filterByScheme:he.filterByScheme});K=he.supportSideBySide===B.PRIMARY?Ee:Pe}}if(b(K)||g(K)||s(K))return;const be=K.resource;return!be||!he||!he.filterByScheme?be:this.b(be,he.filterByScheme)}b(K,he){if(Array.isArray(he)){if(he.some(be=>K.scheme===be))return K}else if(he===K.scheme)return K}}e.EditorResourceAccessor=new j;var z;(function(X){X[X.LEFT=0]="LEFT",X[X.RIGHT=1]="RIGHT"})(z=e.CloseDirection||(e.CloseDirection={}));class ne{constructor(){this.c=new Map,this.d=new Map}start(K){const he=this.a=K.get(I.IInstantiationService);for(const[be,Ee]of this.c)this.e(be,Ee,he);this.c.clear()}e(K,he,be){const Ee=be.createInstance(he);this.d.set(K,Ee)}registerFileEditorFactory(K){if(this.b)throw new Error("Can only register one file editor factory.");this.b=K}getFileEditorFactory(){return(0,t.assertIsDefined)(this.b)}registerEditorSerializer(K,he){if(this.c.has(K)||this.d.has(K))throw new Error(`A editor serializer with type ID '${K}' was already registered.`);return this.a?this.e(K,he,this.a):this.c.set(K,he),(0,R.toDisposable)(()=>{this.c.delete(K),this.d.delete(K)})}getEditorSerializer(K){return this.d.get(typeof K=="string"?K:K.typeId)}}A.Registry.add(e.EditorExtensions.EditorFactory,new ne);async function _(X,K,he){return!X||!X.length?[]:await Promise.all(X.map(async be=>{const Ee=T.URI.revive(be.fileUri);if(!Ee){he.info("Cannot resolve the path because it is not valid.",be);return}if(!await K.canHandleResource(Ee)){he.info("Cannot resolve the path because it cannot be handled",be);return}let Me=be.exists,oe=be.type;if(typeof Me!="boolean"||typeof oe!="number")try{oe=(await K.stat(Ee)).isDirectory?y.FileType.Directory:y.FileType.Unknown,Me=!0}catch(fe){he.error(fe),Me=!1}if(!Me&&be.openOnlyIfExists){he.info("Cannot resolve the path because it does not exist",be);return}if(oe===y.FileType.Directory){he.info("Cannot resolve the path because it is a directory",be);return}const ae={...be.options,pinned:!0};return Me?{resource:Ee,options:ae}:{resource:Ee,options:ae,forceUntitled:!0}}))}e.pathsToEditors=_;var Y;(function(X){X[X.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",X[X.SEQUENTIAL=1]="SEQUENTIAL"})(Y=e.EditorsOrder||(e.EditorsOrder={}));function J(X){const K=X;if(!K)return!1;const he=K;if(he.modified)return J(he.modified);const be=K;return!!(be.contributionsState&&be.viewState&&Array.isArray(be.cursorState))}e.isTextEditorViewState=J;function Z(X){return(0,L.isErrorWithActions)(X)}e.isEditorOpenError=Z;function ie(X,K,he){const be=(0,L.createErrorWithActions)(X,K);return be.forceMessage=he?.forceMessage,be.forceSeverity=he?.forceSeverity,be.allowDialog=he?.allowDialog,be}e.createEditorOpenError=ie}),define(ye[131],Ce([1,0,3,16,185]),function(te,e,o,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class R{constructor(){this.f=new Map,this.k=[],this.m=new o.Emitter,this.n=new o.Emitter,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(A){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=A}onEvent(A){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=A}onRequest(A){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=A}sendResponse(A){A.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${A.command}`)):this.s("response",A)}sendRequest(A,y,D,L){const P={command:A};if(y&&Object.keys(y).length>0&&(P.arguments=y),this.s("request",P),typeof L=="number"){const v=setTimeout(()=>{clearTimeout(v);const C=this.f.get(P.seq);if(C){this.f.delete(P.seq);const E={type:"response",seq:0,request_seq:P.seq,success:!1,command:A,message:(0,T.localize)(0,null,L,A)};C(E)}},L)}return D&&this.f.set(P.seq,D),P.seq}acceptMessage(A){this.j?this.j(A):(this.k.push(A),this.k.length===1&&this.q())}o(A,y){return A.type!=="event"||y.type!=="event"}async q(){let A;for(;this.k.length;){if((!A||this.o(this.k[0],A))&&await(0,t.timeout)(0),A=this.k.shift(),!A)return;switch(A.type){case"event":this.i?.(A);break;case"request":this.g?.(A);break;case"response":{const y=A,D=this.f.get(y.request_seq);D&&(this.f.delete(y.request_seq),D(y));break}}}}s(A,y){y.type=A,y.seq=this.d++,this.sendMessage(y)}async u(){if(this.f.size===0)return Promise.resolve();const A=new Map;this.f.forEach((y,D)=>A.set(D,y)),await(0,t.timeout)(500),A.forEach((y,D)=>{y({type:"response",seq:0,request_seq:D,success:!1,command:"canceled",message:"canceled"}),this.f.delete(D)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.AbstractDebugAdapter=R}),define(ye[218],Ce([1,0,186,53,4]),function(te,e,o,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new t.RawContextKey("debugType",void 0,{type:"string",description:o.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new t.RawContextKey("debugConfigurationType",void 0,{type:"string",description:o.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new t.RawContextKey("debugState","inactive",{type:"string",description:o.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new t.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:o.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new t.RawContextKey("hasDebugged",!1,{type:"boolean",description:o.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new t.RawContextKey("inDebugMode",!1,{type:"boolean",description:o.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new t.RawContextKey("inDebugRepl",!1,{type:"boolean",description:o.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new t.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:o.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new t.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:o.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new t.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:o.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new t.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:o.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new t.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:o.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new t.RawContextKey("variablesFocused",!0,{type:"boolean",description:o.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new t.RawContextKey("expressionSelected",!1,{type:"boolean",description:o.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new t.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:o.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new t.RawContextKey("callStackItemType",void 0,{type:"string",description:o.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new t.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:o.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new t.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:o.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new t.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:o.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new t.RawContextKey("watchItemType",void 0,{type:"string",description:o.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new t.RawContextKey("canViewMemory",void 0,{type:"boolean",description:o.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new t.RawContextKey("breakpointItemType",void 0,{type:"string",description:o.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new t.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:o.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new t.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:o.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new t.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:o.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new t.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:o.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new t.RawContextKey("stepBackSupported",!1,{type:"boolean",description:o.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new t.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:o.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new t.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:o.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new t.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:o.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new t.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:o.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new t.RawContextKey("breakpointsExist",!1,{type:"boolean",description:o.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new t.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:o.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new t.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:o.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new t.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:o.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new t.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:o.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new t.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:o.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new t.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:o.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new t.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:o.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new t.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:o.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new t.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:o.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new t.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:o.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new t.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:o.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new t.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:o.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new t.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:o.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new t.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:o.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new t.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:o.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new t.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:o.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new t.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:o.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new t.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:o.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new t.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:o.localize(50,null)});const R=v=>o.localize(51,null,v);e.debuggerDisabledMessage=R,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:o.localize(52,null)};var I;(function(v){v[v.Inactive=0]="Inactive",v[v.Initializing=1]="Initializing",v[v.Stopped=2]="Stopped",v[v.Running=3]="Running"})(I=e.State||(e.State={}));function A(v){switch(v){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=A;var y;(function(v){v[v.Valid=0]="Valid",v[v.Unreadable=1]="Unreadable",v[v.Error=2]="Error"})(y=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var D;(function(v){v[v.Initial=1]="Initial",v[v.Dynamic=2]="Dynamic"})(D=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var L;(function(v){v.UnverifiedBreakpoints="unverifiedBreakpoints"})(L=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,T.createDecorator)("debugService");var P;(function(v){v[v.CONDITION=0]="CONDITION",v[v.HIT_COUNT=1]="HIT_COUNT",v[v.LOG_MESSAGE=2]="LOG_MESSAGE"})(P=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(ye[219],Ce([1,0,8,2,10,23,15]),function(te,e,o,t,T,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const A=/{([^}]+)}/g;function y(a,u,l){return a.replace(A,function(c,n){return u&&n.length>0&&n[0]!=="_"?c:l&&l.hasOwnProperty(n)?l[n]:c})}e.formatPII=y;function D(a){const u={};for(const l of Object.keys(a))l.startsWith("!")||(u[l]=a[l]);return u}e.filterExceptionsFromTelemetry=D;function L(a){return a.configuration.request==="attach"&&!P(a)&&(!a.parentSession||L(a.parentSession))}e.isSessionAttach=L;function P(a){let u=a.configuration.type;if(!!u)return u==="vslsShare"&&(u=a.configuration.adapterProxy.configuration.type),(0,o.equalsIgnoreCase)(u,"extensionhost")||(0,o.equalsIgnoreCase)(u,"pwa-extensionhost")?a:a.parentSession?P(a.parentSession):void 0}e.getExtensionHostDebugSession=P;function v(a){return a.type&&(a.label||a.program||a.runtime)}e.isDebuggerMainContribution=v;function C(a,u,l){let c,n=0;const r=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let m=null;for(;m=r.exec(a);){const S=m.index+1,k=S+m[0].length;if(S<=u&&k>=l){c=m[0],n=S;break}}if(c){const S=/\w+/g;let k=null;for(;(k=S.exec(c))&&!(k.index+1+n+k[0].length>=l););k&&(c=c.substring(0,S.lastIndex))}return c?{start:n,end:n+c.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=C;const E=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function f(a){return!!(a&&a.match(E))}e.isUri=f;function d(a){if(typeof a.path=="string"&&!(typeof a.sourceReference=="number"&&a.sourceReference>0)){if(f(a.path))return t.URI.parse(a.path);if((0,T.isAbsolute)(a.path))return t.URI.file(a.path)}return a.path}function h(a){if(typeof a.path=="object"){const u=t.URI.revive(a.path);if(u)return u.scheme===I.Schemas.file?u.fsPath:u.toString()}return a.path}function b(a,u){const l=u?d:h,c=(0,R.deepClone)(a);return p(c,(n,r)=>{n&&r&&(r.path=l(r))}),c}e.convertToDAPaths=b;function g(a,u){const l=u?d:h,c=(0,R.deepClone)(a);return p(c,(n,r)=>{!n&&r&&(r.path=l(r))}),c}e.convertToVSCPaths=g;function p(a,u){switch(a.type){case"event":{const l=a;switch(l.event){case"output":u(!1,l.body.source);break;case"loadedSource":u(!1,l.body.source);break;case"breakpoint":u(!1,l.body.breakpoint.source);break;default:break}break}case"request":{const l=a;switch(l.command){case"setBreakpoints":u(!0,l.arguments.source);break;case"breakpointLocations":u(!0,l.arguments.source);break;case"source":u(!0,l.arguments.source);break;case"gotoTargets":u(!0,l.arguments.source);break;case"launchVSCode":l.arguments.args.forEach(c=>u(!1,c));break;default:break}break}case"response":{const l=a;if(l.success&&l.body)switch(l.command){case"stackTrace":l.body.stackFrames.forEach(c=>u(!1,c.source));break;case"loadedSources":l.body.sources.forEach(c=>u(!1,c));break;case"scopes":l.body.scopes.forEach(c=>u(!1,c.source));break;case"setFunctionBreakpoints":l.body.breakpoints.forEach(c=>u(!1,c.source));break;case"setBreakpoints":l.body.breakpoints.forEach(c=>u(!1,c.source));break;case"disassemble":l.body?.instructions.forEach(n=>u(!1,n.location));break;default:break}break}}}function w(a){return a.filter(u=>!u.presentation?.hidden).sort((u,l)=>u.presentation?l.presentation?u.presentation.group?l.presentation.group?u.presentation.group!==l.presentation.group?u.presentation.group.localeCompare(l.presentation.group):i(u.presentation.order,l.presentation.order):-1:l.presentation.group?1:i(u.presentation.order,l.presentation.order):-1:l.presentation?1:0)}e.getVisibleAndSorted=w;function i(a,u){return typeof a!="number"?typeof u!="number"?0:1:typeof u!="number"?-1:a-u}async function s(a,u){const l=a.getValue("debug.saveBeforeStart",{overrideIdentifier:u.activeTextEditorLanguageId});if(l!=="none"&&(await u.saveAll(),l==="allEditorsInActiveGroup")){const c=u.activeEditorPane;c&&c.input.resource?.scheme===I.Schemas.untitled&&await u.save({editor:c.input,groupId:c.group.id})}await a.reloadConfiguration()}e.saveAllBeforeDebugStart=s}),define(ye[220],Ce([1,0,46,221,23,10,12,8,29,187,131]),function(te,e,o,t,T,R,I,A,y,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class P extends L.AbstractDebugAdapter{constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(h,b){this.p=b,this.r=Buffer.allocUnsafe(0),this.t=-1,h.on("data",g=>this.w(g))}sendMessage(h){if(this.p){const b=JSON.stringify(h);this.p.write(`Content-Length: ${Buffer.byteLength(b,"utf8")}${P.a}${b}`,"utf8")}}w(h){for(this.r=Buffer.concat([this.r,h]);;){if(this.t>=0){if(this.r.length>=this.t){const b=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,b.length>0)try{this.acceptMessage(JSON.parse(b))}catch(g){this.m.fire(new Error((g.message||g)+`
`+b))}continue}}else{const b=this.r.indexOf(P.a);if(b!==-1){const p=this.r.toString("utf8",0,b).split(P.b);for(const w of p){const i=w.split(P.l);i[0]==="Content-Length"&&(this.t=Number(i[1]))}this.r=this.r.slice(b+P.a.length);continue}}break}}}e.StreamDebugAdapter=P,P.a=`\r
\r
`,P.b=/\r?\n/,P.l=/: */;class v extends P{startSession(){return new Promise((h,b)=>{let g=!1;this.x=this.y(()=>{this.v(this.x,this.x),h(),g=!0}),this.x.on("close",()=>{g?this.m.fire(new Error("connection closed")):b(new Error("connection closed"))}),this.x.on("error",p=>{g?this.m.fire(p):b(p)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.NetworkDebugAdapter=v;class C extends v{constructor(h){super(),this.z=h}y(h){return t.createConnection(this.z.port,this.z.host||"127.0.0.1",h)}}e.SocketDebugAdapter=C;class E extends v{constructor(h){super(),this.z=h}y(h){return t.createConnection(this.z.path,h)}}e.NamedPipeDebugAdapter=E;class f extends P{constructor(h,b){super(),this.y=h,this.z=b}async startSession(){const h=this.y.command,b=this.y.args,g=this.y.options||{};try{if(h)if(R.isAbsolute(h)){if(!await y.Promises.exists(h))throw new Error(D.localize(0,null,h))}else h.indexOf("/")<0&&h.indexOf("\\")<0;else throw new Error(D.localize(1,null,this.z));let p=process.env;if(g.env&&Object.keys(g.env).length>0&&(p=T.mixin(T.deepClone(process.env),g.env)),h==="node")if(Array.isArray(b)&&b.length>0){const w=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,i={env:p,execArgv:w?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};g.cwd&&(i.cwd=g.cwd);const s=o.fork(b[0],b.slice(1),i);if(!s.pid)throw new Error(D.localize(2,null,b[0]));this.x=s}else throw new Error(D.localize(3,null));else{const w={env:p};g.cwd&&(w.cwd=g.cwd),this.x=o.spawn(h,b,w)}this.x.on("error",w=>{this.m.fire(w)}),this.x.on("exit",(w,i)=>{this.n.fire(w)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",w=>{this.m.fire(w)}),this.x.stdin.on("error",w=>{this.m.fire(w)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(p){this.m.fire(p)}}async stopSession(){return this.x?(await this.u(),I.isWindows?new Promise((h,b)=>{const g=o.exec(`taskkill /F /T /PID ${this.x.pid}`,function(p,w,i){if(p)return b(p)});g.on("exit",h),g.on("error",b)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(h,b){if(!h)return;const g=Object.create(null);h.runtime&&(h.runtime.indexOf("./")===0?g.runtime=R.join(b,h.runtime):g.runtime=h.runtime),h.runtimeArgs&&(g.runtimeArgs=h.runtimeArgs),h.program&&(R.isAbsolute(h.program)?g.program=h.program:g.program=R.join(b,h.program)),h.args&&(g.args=h.args);const p=h;return p.win&&(g.win=f.A(p.win,b)),p.winx86&&(g.winx86=f.A(p.winx86,b)),p.windows&&(g.windows=f.A(p.windows,b)),p.osx&&(g.osx=f.A(p.osx,b)),p.linux&&(g.linux=f.A(p.linux,b)),g}static platformAdapterExecutable(h,b){let g=Object.create(null);b=b.toLowerCase();for(const u of h)if(u.contributes){const l=u.contributes.debuggers;l&&l.length>0&&l.filter(c=>typeof c.type=="string"&&A.equalsIgnoreCase(c.type,b)).forEach(c=>{const n=f.A(c,u.extensionLocation.fsPath);g=T.mixin(g,n,u.isBuiltin)})}let p;I.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?p=g.winx86||g.win||g.windows:I.isWindows?p=g.win||g.windows:I.isMacintosh?p=g.osx:I.isLinux&&(p=g.linux),p=p||g;const w=p.program||g.program,i=p.args||g.args,s=p.runtime||g.runtime,a=p.runtimeArgs||g.runtimeArgs;if(s)return{type:"executable",command:s,args:(a||[]).concat(typeof w=="string"?[w]:[]).concat(i||[])};if(w)return{type:"executable",command:w,args:i||[]}}}e.ExecutableDebugAdapter=f}),define(ye[222],Ce([1,0,46,32,12]),function(te,e,o,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function R(D,L){return new Promise((P,v)=>{let C="";const E=o.spawn(D,L);E.pid&&E.stdout.on("data",f=>{C+=f.toString()}),E.on("error",f=>{v(f)}),E.on("close",f=>{P(C)})})}async function I(D){if(D)if(T.isWindows){const L=await new Promise((P,v)=>{te(["windows-process-tree"],P,v)});return new Promise(P=>{L.getProcessTree(D,v=>{P(!!v&&v.children.length>0)})})}else return R("/usr/bin/pgrep",["-lP",String(D)]).then(L=>{const P=L.trim();return!(P.length===0||P.indexOf(" tmux")>=0)},L=>!0);return Promise.resolve(!0)}e.hasChildProcesses=I;var A;(function(D){D[D.cmd=0]="cmd",D[D.powershell=1]="powershell",D[D.bash=2]="bash"})(A||(A={}));function y(D,L,P,v,C){D=D.trim().toLowerCase();let E;D.indexOf("powershell")>=0||D.indexOf("pwsh")>=0?E=1:D.indexOf("cmd.exe")>=0?E=0:D.indexOf("bash")>=0?E=2:T.isWindows?E=0:E=2;let f,d=" ";switch(E){case 1:if(f=h=>(h=h.replace(/\'/g,"''"),h.length>0&&h.charAt(h.length-1)==="\\"?`'${h}\\'`:`'${h}'`),v){const h=(0,t.getDriveLetter)(v);h&&(d+=`${h}:; `),d+=`cd ${f(v)}; `}if(C)for(const h in C){const b=C[h];b===null?d+=`Remove-Item env:${h}; `:d+=`\${env:${h}}='${b}'; `}if(L.length>0){const h=L.shift(),b=P?h:f(h);d+=b[0]==="'"?`& ${b} `:`${b} `;for(const g of L)d+=g==="<"||g===">"||P?g:f(g),d+=" "}break;case 0:if(f=h=>(h=h.replace(/\"/g,'""'),h=h.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(b=>h.includes(b))||h.length===0?`"${h}"`:h),v){const h=(0,t.getDriveLetter)(v);h&&(d+=`${h}: && `),d+=`cd ${f(v)} && `}if(C){d+='cmd /C "';for(const h in C){let b=C[h];b===null?d+=`set "${h}=" && `:(b=b.replace(/[&^|<>]/g,g=>`^${g}`),d+=`set "${h}=${b}" && `)}}for(const h of L)d+=h==="<"||h===">"||P?h:f(h),d+=" ";C&&(d+='"');break;case 2:{f=b=>(b=b.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),b.length===0?'""':b);const h=b=>/[^\w@%\/+=,.:^-]/.test(b)?`'${b.replace(/'/g,"'\\''")}'`:b;if(v&&(d+=`cd ${f(v)} ; `),C){d+="/usr/bin/env";for(const b in C){const g=C[b];g===null?d+=` -u ${h(b)}`:d+=` ${h(`${b}=${g}`)}`}d+=" "}for(const b of L)d+=b==="<"||b===">"||P?b:f(b),d+=" ";break}}return d}e.prepareCommand=y}),define(ye[91],Ce([1,0,22,38,62,84,15,10,12,53]),function(te,e,o,t,T,R,I,A,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var L;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(L=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",R.Mimes.latex,R.Mimes.markdown,"image/png","image/jpeg",R.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[R.Mimes.latex,R.Mimes.markdown,"application/json",R.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var P;(function(B){B[B.Running=1]="Running",B[B.Idle=2]="Idle"})(P=e.NotebookRunState||(e.NotebookRunState={}));var v;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(v=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var C;(function(B){B[B.WithHardKernelDependency=0]="WithHardKernelDependency",B[B.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",B[B.Pure=2]="Pure",B[B.Never=3]="Never"})(C=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var E;(function(B){B.Always="always",B.Never="never",B.Optional="optional"})(E=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var f;(function(B){B[B.ModelChange=1]="ModelChange",B[B.Move=2]="Move",B[B.ChangeCellLanguage=5]="ChangeCellLanguage",B[B.Initialize=6]="Initialize",B[B.ChangeCellMetadata=7]="ChangeCellMetadata",B[B.Output=8]="Output",B[B.OutputItem=9]="OutputItem",B[B.ChangeCellContent=10]="ChangeCellContent",B[B.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",B[B.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",B[B.ChangeCellMime=13]="ChangeCellMime",B[B.Unknown=100]="Unknown"})(f=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var d;(function(B){B[B.Handle=0]="Handle",B[B.Index=1]="Index"})(d=e.SelectionStateType||(e.SelectionStateType={}));var h;(function(B){B[B.Replace=1]="Replace",B[B.Output=2]="Output",B[B.Metadata=3]="Metadata",B[B.CellLanguage=4]="CellLanguage",B[B.DocumentMetadata=5]="DocumentMetadata",B[B.Move=6]="Move",B[B.OutputItems=7]="OutputItems",B[B.PartialMetadata=8]="PartialMetadata",B[B.PartialInternalMetadata=9]="PartialInternalMetadata"})(h=e.CellEditType||(e.CellEditType={}));var b;(function(B){B.scheme=I.Schemas.vscodeNotebookCell;const j=["W","X","Y","Z","a","b","c","d","e","f"],z=new RegExp(`^[${j.join("")}]+`),ne=7;function _(K,he){const be=he.toString(ne),Pe=`${be.length<j.length?j[be.length-1]:"z"}${be}s${(0,o.encodeBase64)(o.VSBuffer.fromString(K.scheme),!0,!0)}`;return K.with({scheme:B.scheme,fragment:Pe})}B.generate=_;function Y(K){if(K.scheme!==B.scheme)return;const he=K.fragment.indexOf("s");if(he<0)return;const be=parseInt(K.fragment.substring(0,he).replace(z,""),ne),Ee=(0,o.decodeBase64)(K.fragment.substring(he+1)).toString();if(!isNaN(be))return{handle:be,notebook:K.with({scheme:Ee,fragment:null})}}B.parse=Y;function J(K,he){return K.with({scheme:I.Schemas.vscodeNotebookCellOutput,fragment:`op${he??""},${K.scheme!==I.Schemas.file?K.scheme:""}`})}B.generateCellOutputUri=J;function Z(K){if(K.scheme!==I.Schemas.vscodeNotebookCellOutput)return;const he=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(K.fragment);if(!he)return;const be=he[1]&&he[1]!==""?he[1]:void 0,Ee=he[2];return{outputId:be,notebook:K.with({scheme:Ee||I.Schemas.file,fragment:null})}}B.parseCellOutputUri=Z;function ie(K,he,be){return B.generate(K,he).with({scheme:be})}B.generateCellPropertyUri=ie;function X(K,he){if(K.scheme===he)return B.parse(K.with({scheme:B.scheme}))}B.parseCellPropertyUri=X})(b=e.CellUri||(e.CellUri={}));const g=B=>y.isWindows?B.replace(/\//g,"\\"):B;class p{constructor(j=[],z=e.NOTEBOOK_DISPLAY_ORDER){this.e=z,this.d=[...new Set(j)].map(ne=>({pattern:ne,matches:t.parse(g(ne))}))}sort(j){const z=new Map(T.Iterable.map(j,_=>[_,g(_)]));let ne=[];for(const{matches:_}of this.d)for(const[Y,J]of z)if(_(J)){ne.push(Y),z.delete(Y);break}return z.size&&(ne=ne.concat([...z.keys()].sort((_,Y)=>this.e.indexOf(_)-this.e.indexOf(Y)))),ne}prioritize(j,z){const ne=this.f(j);if(ne===-1){this.d.unshift({pattern:j,matches:t.parse(g(j))});return}const _=new Set(z.map(J=>this.f(J,ne)));_.delete(-1);const Y=Array.from(_).sort();this.d.splice(ne+1,0,...Y.map(J=>this.d[J]));for(let J=Y.length-1;J>=0;J--)this.d.splice(Y[J],1)}toArray(){return this.d.map(j=>j.pattern)}f(j,z=this.d.length){const ne=g(j);for(let _=0;_<z;_++)if(this.d[_].matches(ne))return _;return-1}}e.MimeTypeDisplayOrder=p;function w(B,j,z,ne=(_,Y)=>_===Y){const _=[];function Y(ie,X,K){if(X===0&&K.length===0)return;const he=_[_.length-1];he&&he.start+he.deleteCount===ie?(he.deleteCount+=X,he.toInsert.push(...K)):_.push({start:ie,deleteCount:X,toInsert:K})}let J=0,Z=0;for(;;){if(J===B.length){Y(J,0,j.slice(Z));break}if(Z===j.length){Y(J,B.length-J,[]);break}const ie=B[J],X=j[Z];if(ne(ie,X)){J+=1,Z+=1;continue}z(X)?(Y(J,1,[]),J+=1):(Y(J,0,[X]),Z+=1)}return _}e.diff=w,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new D.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(B){B.default="default",B.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function s(B){const j=B;return!!((typeof j.include=="string"||t.isRelativePattern(j.include))&&(typeof j.exclude=="string"||t.isRelativePattern(j.exclude)))}e.isDocumentExcludePattern=s;function a(B,j,z){if(Array.isArray(B.viewType)&&B.viewType.indexOf(j)>=0||B.viewType===j)return!0;if(B.filenamePattern){const ne=s(B.filenamePattern)?B.filenamePattern.include:B.filenamePattern,_=s(B.filenamePattern)?B.filenamePattern.exclude:void 0;if(t.match(ne,(0,A.basename)(z.fsPath).toLowerCase()))return!(_&&t.match(_,(0,A.basename)(z.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=a,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily",kernelPickerType:"notebook.kernelPicker.type",outputScrolling:"notebook.experimental.outputScrolling"};var u;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(u=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class l{static create(j){return`${l.d}${j}`}static parse(j){if(j.startsWith(l.d))return j.substring(l.d.length)}}e.NotebookWorkingCopyTypeIdentifier=l,l.d="notebook/";function c(B){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(B)}e.isTextStreamMime=c;const n=new TextDecoder;function r(B){const j=[];let z=!1;for(const ne of B)(j.length===0||z)&&(j.push(ne),z=!0);return M(j),N(o.VSBuffer.concat(j.map(ne=>o.VSBuffer.wrap(ne))))}e.compressOutputItemStreams=r;const m=`${String.fromCharCode(27)}[A`,S=m.split("").map(B=>B.charCodeAt(0)),k=10;function M(B){B.forEach((j,z)=>{if(z===0||j.length<m.length)return;const ne=B[z-1],_=j.subarray(0,m.length);if(_[0]===S[0]&&_[1]===S[1]&&_[2]===S[2]){const Y=ne.lastIndexOf(k);if(Y===-1)return;B[z-1]=ne.subarray(0,Y),B[z]=j.subarray(m.length)}})}function q(B){let j=B;do B=j,j=B.replace(/[^\n]\x08/gm,"");while(j.length<B.length);return B}function V(B){for(B=B.replace(/\r+\n/gm,`
`);B.search(/\r[^$]/g)>-1;){const j=B.match(/^(.*)\r+/m)[1];let z=B.match(/\r+(.*)$/m)[1];z=z+j.slice(z.length,j.length),B=B.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,z)}return B}const F="\b".charCodeAt(0),U="\r".charCodeAt(0);function N(B){return!B.buffer.includes(F)&&!B.buffer.includes(U)?B:o.VSBuffer.fromString(V(q(n.decode(B.buffer))))}}),define(ye[223],Ce([1,0,4]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var t;(function(T){T[T.Output=1]="Output",T[T.OutputItems=2]="OutputItems",T[T.ExecutionState=3]="ExecutionState"})(t=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,o.createDecorator)("INotebookExecutionService")}),define(ye[224],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function o(I){return[...I.entries()]}e.serializeEnvironmentVariableCollection=o;function t(I){return new Map(I)}e.deserializeEnvironmentVariableCollection=t;function T(I){return Array.from(I.entries()).map(A=>[A[0],o(A[1].map)])}e.serializeEnvironmentVariableCollections=T;function R(I){return new Map(I.map(A=>[A[0],{map:t(A[1])}]))}e.deserializeEnvironmentVariableCollections=R}),define(ye[56],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var o;(function(R){R.Delimiter="\0"})(o=e.TestIdPathParts||(e.TestIdPathParts={}));var t;(function(R){R[R.IsSame=0]="IsSame",R[R.Disconnected=1]="Disconnected",R[R.IsChild=2]="IsChild",R[R.IsParent=3]="IsParent"})(t=e.TestPosition||(e.TestPosition={}));class T{static fromExtHostTestItem(I,A,y=I.parent){if(I._isRoot)return new T([A]);const D=[I.id];for(let L=y;L&&L.id!==A;L=L.parent)D.push(L.id);return D.push(A),new T(D.reverse())}static isRoot(I){return!I.includes("\0")}static root(I){const A=I.indexOf("\0");return A===-1?I:I.slice(0,A)}static fromString(I){return new T(I.split("\0"))}static join(I,A){return new T([...I.path,A])}static joinToString(I,A){return I.toString()+"\0"+A}static parentId(I){const A=I.lastIndexOf("\0");return A===-1?void 0:I.slice(0,A)}static localId(I){const A=I.lastIndexOf("\0");return A===-1?I:I.slice(A+1)}static compare(I,A){return I===A?0:A.startsWith(I+"\0")?2:I.startsWith(A+"\0")?3:1}constructor(I,A=I.length){if(this.path=I,this.d=A,I.length===0||A<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new T(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let I=1;I<=this.d;I++)yield new T(this.path,I)}*idsToRoot(){for(let I=this.d;I>0;I--)yield new T(this.path,I)}compare(I){if(typeof I=="string")return T.compare(this.toString(),I);for(let A=0;A<I.d&&A<this.d;A++)if(I.path[A]!==this.path[A])return 1;return I.d>this.d?2:I.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let I=1;I<this.d;I++)this.c+="\0",this.c+=this.path[I]}return this.c}}e.TestId=T}),define(ye[70],Ce([1,0,2,35,56]),function(te,e,o,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var R;(function(c){c[c.Unset=0]="Unset",c[c.Queued=1]="Queued",c[c.Running=2]="Running",c[c.Passed=3]="Passed",c[c.Failed=4]="Failed",c[c.Skipped=5]="Skipped",c[c.Errored=6]="Errored"})(R=e.TestResultState||(e.TestResultState={}));var I;(function(c){c[c.Run=2]="Run",c[c.Debug=4]="Debug",c[c.Coverage=8]="Coverage",c[c.HasNonDefaultProfile=16]="HasNonDefaultProfile",c[c.HasConfigurable=32]="HasConfigurable"})(I=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var A;(function(c){c.serialize=n=>({range:n.range.toJSON(),uri:n.uri.toJSON()}),c.deserialize=n=>({range:t.Range.lift(n.range),uri:o.URI.revive(n.uri)})})(A=e.IRichLocation||(e.IRichLocation={}));var y;(function(c){c[c.Error=0]="Error",c[c.Output=1]="Output"})(y=e.TestMessageType||(e.TestMessageType={}));var D;(function(c){c.serialize=n=>({message:n.message,type:0,expected:n.expected,actual:n.actual,location:n.location&&A.serialize(n.location)}),c.deserialize=n=>({message:n.message,type:0,expected:n.expected,actual:n.actual,location:n.location&&A.deserialize(n.location)})})(D=e.ITestErrorMessage||(e.ITestErrorMessage={}));const L=(c,n)=>`${n?"s":"e"}${c}`;e.getMarkId=L;var P;(function(c){c.serialize=n=>({message:n.message,type:1,offset:n.offset,length:n.length,location:n.location&&A.serialize(n.location)}),c.deserialize=n=>({message:n.message,type:1,offset:n.offset,length:n.length,location:n.location&&A.deserialize(n.location)})})(P=e.ITestOutputMessage||(e.ITestOutputMessage={}));var v;(function(c){c.serialize=n=>n.type===0?D.serialize(n):P.serialize(n),c.deserialize=n=>n.type===0?D.deserialize(n):P.deserialize(n)})(v=e.ITestMessage||(e.ITestMessage={}));var C;(function(c){c.serializeWithoutMessages=n=>({state:n.state,duration:n.duration,messages:[]}),c.serialize=n=>({state:n.state,duration:n.duration,messages:n.messages.map(v.serialize)}),c.deserialize=n=>({state:n.state,duration:n.duration,messages:n.messages.map(v.deserialize)})})(C=e.ITestTaskState||(e.ITestTaskState={}));const E="\0",f=(c,n)=>c+E+n;e.namespaceTestTag=f;const d=c=>{const n=c.indexOf(E);return{ctrlId:c.slice(0,n),tagId:c.slice(n+1)}};e.denamespaceTestTag=d;var h;(function(c){c.serialize=n=>({extId:n.extId,label:n.label,tags:n.tags,busy:n.busy,children:void 0,uri:n.uri?.toJSON(),range:n.range?.toJSON()||null,description:n.description,error:n.error,sortText:n.sortText}),c.deserialize=n=>({extId:n.extId,label:n.label,tags:n.tags,busy:n.busy,children:void 0,uri:n.uri?o.URI.revive(n.uri):void 0,range:n.range?t.Range.lift(n.range):null,description:n.description,error:n.error,sortText:n.sortText})})(h=e.ITestItem||(e.ITestItem={}));var b;(function(c){c[c.NotExpandable=0]="NotExpandable",c[c.Expandable=1]="Expandable",c[c.BusyExpanding=2]="BusyExpanding",c[c.Expanded=3]="Expanded"})(b=e.TestItemExpandState||(e.TestItemExpandState={}));var g;(function(c){c.serialize=n=>({expand:n.expand,item:h.serialize(n.item)}),c.deserialize=n=>({controllerId:T.TestId.root(n.item.extId),expand:n.expand,item:h.deserialize(n.item)})})(g=e.InternalTestItem||(e.InternalTestItem={}));var p;(function(c){c.serialize=n=>{let r;return n.item&&(r={},n.item.label!==void 0&&(r.label=n.item.label),n.item.tags!==void 0&&(r.tags=n.item.tags),n.item.busy!==void 0&&(r.busy=n.item.busy),n.item.uri!==void 0&&(r.uri=n.item.uri?.toJSON()),n.item.range!==void 0&&(r.range=n.item.range?.toJSON()),n.item.description!==void 0&&(r.description=n.item.description),n.item.error!==void 0&&(r.error=n.item.error),n.item.sortText!==void 0&&(r.sortText=n.item.sortText)),{extId:n.extId,expand:n.expand,item:r}},c.deserialize=n=>{let r;return n.item&&(r={},n.item.label!==void 0&&(r.label=n.item.label),n.item.tags!==void 0&&(r.tags=n.item.tags),n.item.busy!==void 0&&(r.busy=n.item.busy),n.item.range!==void 0&&(r.range=n.item.range?t.Range.lift(n.item.range):null),n.item.description!==void 0&&(r.description=n.item.description),n.item.error!==void 0&&(r.error=n.item.error),n.item.sortText!==void 0&&(r.sortText=n.item.sortText)),{extId:n.extId,expand:n.expand,item:r}}})(p=e.ITestItemUpdate||(e.ITestItemUpdate={}));const w=(c,n)=>{n.expand!==void 0&&(c.expand=n.expand),n.item!==void 0&&(c.item=c.item?Object.assign(c.item,n.item):n.item)};e.applyTestItemUpdate=w;var i;(function(c){c.serializeWithoutMessages=n=>({...g.serialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(C.serializeWithoutMessages),retired:n.retired}),c.serialize=n=>({...g.serialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(C.serialize),retired:n.retired}),c.deserialize=n=>({...g.deserialize(n),ownComputedState:n.ownComputedState,computedState:n.computedState,tasks:n.tasks.map(C.deserialize),retired:!0})})(i=e.TestResultItem||(e.TestResultItem={}));var s;(function(c){c[c.Function=0]="Function",c[c.Statement=1]="Statement"})(s=e.DetailType||(e.DetailType={}));var a;(function(c){c[c.Add=0]="Add",c[c.Update=1]="Update",c[c.DocumentSynced=2]="DocumentSynced",c[c.Remove=3]="Remove",c[c.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",c[c.Retire=5]="Retire",c[c.AddTag=6]="AddTag",c[c.RemoveTag=7]="RemoveTag"})(a=e.TestDiffOpType||(e.TestDiffOpType={}));var u;(function(c){c.deserialize=n=>n.op===0?{op:n.op,item:g.deserialize(n.item)}:n.op===1?{op:n.op,item:p.deserialize(n.item)}:n.op===2?{op:n.op,uri:o.URI.revive(n.uri),docv:n.docv}:n,c.serialize=n=>n.op===0?{op:n.op,item:g.serialize(n.item)}:n.op===1?{op:n.op,item:p.serialize(n.item)}:n})(u=e.TestsDiffOp||(e.TestsDiffOp={}));class l{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(n){const r=this.o();for(const m of n)switch(m.op){case 0:this.j(g.deserialize(m.item),r);break;case 1:this.k(p.deserialize(m.item),r);break;case 3:this.l(m.itemId,r);break;case 5:this.m(m.itemId);break;case 4:this.updatePendingRoots(m.amount);break;case 6:this.c.set(m.tag.id,m.tag);break;case 7:this.c.delete(m.id);break}r.complete?.()}j(n,r){const m=T.TestId.parentId(n.item.extId)?.toString();let S;if(!m)S=this.p(n),this.f.add(S),this.d.set(n.item.extId,S);else if(this.d.has(m)){const k=this.d.get(m);k.children.add(n.item.extId),S=this.p(n,k),this.d.set(n.item.extId,S)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(n)}`);return}return r.add?.(S),n.expand===2&&this.g++,S}k(n,r){const m=this.d.get(n.extId);if(!!m)return n.expand!==void 0&&(m.expand===2&&this.g--,n.expand===2&&this.g++),(0,e.applyTestItemUpdate)(m,n),r.update?.(m),m}l(n,r){const m=this.d.get(n);if(!m)return;const S=T.TestId.parentId(m.item.extId)?.toString();S?this.d.get(S).children.delete(m.item.extId):this.f.delete(m);const k=[[n]];for(;k.length;)for(const M of k.pop()){const q=this.d.get(M);q&&(k.push(q.children),this.d.delete(M),r.remove?.(q,q!==m),q.expand===2&&this.g--)}}m(n){}updatePendingRoots(n){this.h+=n}o(){return{}}}e.AbstractIncrementalTestCollection=l}),define(ye[92],Ce([1,0,16,3,6,50,70,56]),function(te,e,o,t,T,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var y;(function(b){b[b.Upsert=0]="Upsert",b[b.SetTags=1]="SetTags",b[b.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",b[b.RemoveChild=3]="RemoveChild",b[b.SetProp=4]="SetProp",b[b.Bulk=5]="Bulk",b[b.DocumentSynced=6]="DocumentSynced"})(y=e.TestItemEventOp||(e.TestItemEventOp={}));const D=(b,g)=>b===g,P=Object.entries({range:(b,g)=>b===g?!0:!b||!g?!1:b.equalsRange(g),busy:D,label:D,description:D,error:D,sortText:D,tags:(b,g)=>!(b.length!==g.length||b.some(p=>!g.includes(p)))}),v=(b,g)=>{let p;for(const[w,i]of P)i(b[w],g[w])||(p?p[w]=g[w]:p={[w]:g[w]});return p};class C extends T.Disposable{get root(){return this.m.root}constructor(g){super(),this.m=g,this.f=this.B(new o.RunOnceScheduler(()=>this.flushDiff(),200)),this.g=this.B(new t.Emitter),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(g){this.h=g;for(const p of this.tree.values())this.G(p)}collectDiff(){const g=this.k;return this.k=[],g}pushDiff(g){switch(g.op){case 2:{for(const p of this.k)if(p.op===2&&p.uri===g.uri){p.docv=g.docv;return}break}case 1:{const p=this.k[this.k.length-1];if(p){if(p.op===1&&p.item.extId===g.item.extId){(0,I.applyTestItemUpdate)(p.item,g.item);return}if(p.op===0&&p.item.item.extId===g.item.extId){(0,I.applyTestItemUpdate)(p.item,g.item);return}}break}}this.k.push(g),this.f.isScheduled()||this.f.schedule()}expand(g,p){const w=this.tree.get(g);if(!!w){if((w.expandLevels===void 0||p>w.expandLevels)&&(w.expandLevels=p),w.expand===1){const i=this.I(w);return i.isOpen()?this.H(w,p-1):i.wait().then(()=>this.H(w,p-1))}else if(w.expand===3)return w.resolveBarrier?.isOpen()===!1?w.resolveBarrier.wait().then(()=>this.H(w,p-1)):this.H(w,p-1)}}dispose(){for(const g of this.tree.values())this.m.getApiFor(g.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(g,p){switch(p.op){case 3:this.L(A.TestId.joinToString(g.fullId,p.id));break;case 0:this.u(p.item,g);break;case 5:for(const w of p.ops)this.p(g,w);break;case 1:this.w(p.new,p.old,g.fullId.toString());break;case 2:this.G(g);break;case 4:this.pushDiff({op:1,item:{extId:g.fullId.toString(),item:p.update}});break;case 6:this.s(g.actual.uri);break;default:(0,R.assertNever)(p)}}s(g){g&&this.pushDiff({op:2,uri:g,docv:this.m.getDocumentVersion(g)})}u(g,p){const w=A.TestId.fromExtHostTestItem(g,this.root.id,p?.actual),i=this.m.getApiFor(g);i.parent&&i.parent!==p?.actual&&this.m.getChildren(i.parent).delete(g.id);let s=this.tree.get(w.toString());if(!s){s={fullId:w,actual:g,expandLevels:p?.expandLevels?p.expandLevels-1:void 0,expand:0},g.tags.forEach(this.y,this),this.tree.set(s.fullId.toString(),s),this.C(g,p),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:s.expand,item:this.m.toITestItem(g)}}),this.F(g,s,p);return}if(s.actual===g){this.D(g,s,p);return}if(s.actual.uri?.toString()!==g.uri?.toString())return this.L(w.toString()),this.u(g,p);const a=this.m.getChildren(s.actual),u=s.actual,l=v(this.m.toITestItem(u),this.m.toITestItem(g));this.m.getApiFor(u).listener=void 0,s.actual=g,s.expand=0,l&&(l.hasOwnProperty("tags")&&(this.w(g.tags,u.tags,w.toString()),delete l.tags),this.p(s,{op:4,update:l})),this.F(g,s,p);for(const[c,n]of a)this.m.getChildren(g).get(n.id)||this.L(A.TestId.joinToString(w,n.id));this.s(s.actual.uri)}w(g,p,w){const i=new Set(p.map(s=>s.id));for(const s of g)i.delete(s.id)||this.y(s);this.pushDiff({op:1,item:{extId:w,item:{tags:g.map(s=>(0,I.namespaceTestTag)(this.m.controllerId,s.id))}}}),i.forEach(this.z,this)}y(g){const p=this.j.get(g.id);p?p.refCount++:(this.j.set(g.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,I.namespaceTestTag)(this.m.controllerId,g.id)}}))}z(g){const p=this.j.get(g);p&&!--p.refCount&&(this.j.delete(g),this.pushDiff({op:7,id:(0,I.namespaceTestTag)(this.m.controllerId,g)}))}C(g,p){this.m.getApiFor(g).parent=p&&p.actual!==this.root?p.actual:void 0}D(g,p,w){this.C(g,w);const i=this.m.getApiFor(g);i.parent=w?.actual,i.listener=s=>this.p(p,s),this.G(p)}F(g,p,w){this.D(g,p,w);for(const[i,s]of this.m.getChildren(g))this.u(s,p)}G(g){let p;this.h?g.resolveBarrier?p=g.resolveBarrier.isOpen()?3:2:p=g.actual.canResolveChildren?1:0:p=0,p!==g.expand&&(g.expand=p,this.pushDiff({op:1,item:{extId:g.fullId.toString(),expand:p}}),p===1&&g.expandLevels!==void 0&&this.I(g))}H(g,p){if(p<0)return;const w=[];for(const[i,s]of this.m.getChildren(g.actual)){const a=this.expand(A.TestId.joinToString(g.fullId,s.id),p);(0,o.isThenable)(a)&&w.push(a)}if(w.length)return Promise.all(w).then(()=>{})}I(g){if(g.resolveBarrier)return g.resolveBarrier;if(!this.h){const s=new o.Barrier;return s.open(),s}g.expand=2,this.J(g);const p=g.resolveBarrier=new o.Barrier,w=s=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,s)};let i;try{i=this.h(g.actual===this.root?void 0:g.actual)}catch(s){w(s)}return(0,o.isThenable)(i)?i.catch(w).then(()=>{p.open(),this.G(g)}):(p.open(),this.G(g)),g.resolveBarrier}J(g){this.pushDiff({op:1,item:{extId:g.fullId.toString(),expand:g.expand}})}L(g){const p=this.tree.get(g);if(!p)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:g});const w=[p];for(;w.length;){const i=w.pop();if(!!i){this.m.getApiFor(i.actual).listener=void 0;for(const s of i.actual.tags)this.z(s.id);this.tree.delete(i.fullId.toString());for(const[s,a]of this.m.getChildren(i.actual))w.push(this.tree.get(A.TestId.joinToString(i.fullId,a.id)))}}}flushDiff(){const g=this.collectDiff();g.length&&this.g.fire(g)}}e.TestItemCollection=C;class E extends Error{constructor(g){super(`Attempted to insert a duplicate test item ID ${g}`)}}e.DuplicateTestItemError=E;class f extends Error{constructor(g){super(`TestItem with ID "${g}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=f;class d extends Error{constructor(g,p,w){super(`TestItem with ID "${g}" is from controller "${p}" and cannot be added as a child of an item from controller "${w}".`)}}e.MixedTestItemController=d;const h=(b,g,p)=>{let w=new Map;return{get size(){return w.size},forEach(i,s){for(const a of w.values())i.call(s,a,this)},[Symbol.iterator](){return w.entries()},replace(i){const s=new Map,a=new Set(w.keys()),u={op:5,ops:[]};for(const l of i){if(!(l instanceof p))throw new f(l.id);const c=g(l).controllerId;if(c!==b.controllerId)throw new d(l.id,c,b.controllerId);if(s.has(l.id))throw new E(l.id);s.set(l.id,l),a.delete(l.id),u.ops.push({op:0,item:l})}for(const l of a.keys())u.ops.push({op:3,id:l});b.listener?.(u),w=s},add(i){if(!(i instanceof p))throw new f(i.id);w.set(i.id,i),b.listener?.({op:0,item:i})},delete(i){w.delete(i)&&b.listener?.({op:3,id:i})},get(i){return w.get(i)},toJSON(){return Array.from(w.values())}}};e.createTestItemChildren=h}),define(ye[132],Ce([1,0,92]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const t=new WeakMap,T=(I,A)=>{const y={controllerId:A};return t.set(I,y),y};e.createPrivateApiFor=T;const R=I=>{const A=t.get(I);if(!A)throw new o.InvalidTestItemError(I?.id||"<unknown>");return A};e.getPrivateApiFor=R}),define(ye[93],Ce([1,0,15,2]),function(te,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function T(A,y){return A.scheme===o.Schemas.http||A.scheme===o.Schemas.https?A:(y&&y.authority&&y.isRemote&&A.scheme===o.Schemas.file&&(A=t.URI.from({scheme:o.Schemas.vscodeRemote,authority:y.authority,path:A.path})),t.URI.from({scheme:o.Schemas.https,authority:`${A.scheme}+${R(A.authority)}.${e.webviewRootResourceAuthority}`,path:A.path,fragment:A.fragment,query:A.query}))}e.asWebviewUri=T;function R(A){return A.replace(/./g,y=>{const D=y.charCodeAt(0);return D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57?y:"-"+D.toString(16).padStart(4,"0")})}function I(A){return A.replace(/-([0-9a-f]{4})/g,(y,D)=>String.fromCharCode(parseInt(D,16)))}e.decodeAuthority=I}),define(ye[225],Ce([1,0,3,6,93]),function(te,e,o,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class R{constructor(A,y,D){this.d=A,this.e=y,this.f=D,this.a=0,this.b=new t.DisposableStore,this.c=new Map,this.b.add(y.onDidChangeVisibleTextEditors(()=>{const L=y.getVisibleTextEditors();for(const P of this.c.values())L.indexOf(P.editor)<0&&P.inset.dispose()}))}dispose(){this.c.forEach(A=>A.inset.dispose()),this.b.dispose()}createWebviewEditorInset(A,y,D,L,P){let v;for(const g of this.e.getVisibleTextEditors(!0))if(g.value===A){v=g;break}if(!v)throw new Error("not a visible editor");const C=this,E=this.a++,f=new o.Emitter,d=new o.Emitter,h=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(g){return(0,T.asWebviewUri)(g,C.f)}get cspSource(){return T.webviewGenericCspSource}set options(g){this.b=g,C.d.$setOptions(E,g)}get options(){return this.b}set html(g){this.a=g,C.d.$setHtml(E,g)}get html(){return this.a}get onDidReceiveMessage(){return f.event}postMessage(g){return C.d.$postMessage(E,g)}},b=new class{constructor(){this.editor=A,this.line=y,this.height=D,this.webview=h,this.onDidDispose=d.event}dispose(){C.c.has(E)&&(C.c.delete(E),C.d.$disposeEditorInset(E),d.fire(),d.dispose(),f.dispose())}};return this.d.$createEditorInset(E,v.id,v.value.document.uri,y+1,D,L||{},P.identifier,P.extensionLocation),this.c.set(E,{editor:A,inset:b,onDidReceiveMessage:f}),b}$onDidDispose(A){const y=this.c.get(A);y&&y.inset.dispose()}$onDidReceiveMessage(A,y){this.c.get(A)?.onDidReceiveMessage.fire(y)}}e.ExtHostEditorInsets=R}),define(ye[226],Ce([1,0,4]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,o.createDecorator)("configurationResolverService");var t;(function(R){R.Unknown="unknown",R.Env="env",R.Config="config",R.Command="command",R.Input="input",R.ExtensionInstallFolder="extensionInstallFolder",R.WorkspaceFolder="workspaceFolder",R.Cwd="cwd",R.WorkspaceFolderBasename="workspaceFolderBasename",R.UserHome="userHome",R.LineNumber="lineNumber",R.SelectedText="selectedText",R.File="file",R.FileWorkspaceFolder="fileWorkspaceFolder",R.RelativeFile="relativeFile",R.RelativeFileDirname="relativeFileDirname",R.FileDirname="fileDirname",R.FileExtname="fileExtname",R.FileBasename="fileBasename",R.FileBasenameNoExtension="fileBasenameNoExtension",R.FileDirnameBasename="fileDirnameBasename",R.ExecPath="execPath",R.ExecInstallFolder="execInstallFolder",R.PathSeparator="pathSeparator"})(t=e.VariableKind||(e.VariableKind={}));class T extends Error{constructor(I,A){super(A),this.variable=I}}e.VariableError=T}),define(ye[227],Ce([1,0,10,36,11,23,12,112,190,226,8]),function(te,e,o,t,T,R,I,A,y,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class P{constructor(C,E,f,d){this.g=new Map,this.a=C,this.b=E,this.d=f,d&&(this.c=d.then(h=>this.h(h)))}h(C){if(I.isWindows){const E=Object.create(null);return Object.keys(C).forEach(f=>{E[f.toLowerCase()]=C[f]}),E}return C}resolveWithEnvironment(C,E,f){return this.j({env:this.h(C),userHome:void 0},E?E.uri:void 0,f)}async resolveAsync(C,E){const f={env:await this.c,userHome:await this.d};return this.j(f,C?C.uri:void 0,E)}async i(C,E,f,d){const h=R.deepClone(E);I.isWindows&&h.windows?Object.keys(h.windows).forEach(g=>h[g]=h.windows[g]):I.isMacintosh&&h.osx?Object.keys(h.osx).forEach(g=>h[g]=h.osx[g]):I.isLinux&&h.linux&&Object.keys(h.linux).forEach(g=>h[g]=h.linux[g]),delete h.windows,delete h.osx,delete h.linux;const b={env:await this.c,userHome:await this.d};return this.j(b,C?C.uri:void 0,h,f,d)}async resolveAnyAsync(C,E,f){return this.i(C,E,f)}async resolveAnyMap(C,E,f){const d=new Map;return{newConfig:await this.i(C,E,f,d),resolvedVariables:d}}resolveWithInteractionReplace(C,E,f,d){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(C,E,f,d){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(C,E){if(this.g.has(C))throw new Error("Variable "+C+" is contributed twice.");this.g.set(C,E)}async j(C,E,f,d,h){if(T.isString(f))return this.l(C,E,f,d,h);if(Array.isArray(f))return Promise.all(f.map(b=>this.j(C,E,b,d,h)));if(T.isObject(f)){const b=Object.create(null),g=await Promise.all(Object.keys(f).map(async p=>[await this.l(C,E,p,d,h),await this.j(C,E,f[p],d,h)]));for(const[p,w]of g)b[p]=w;return b}return f}l(C,E,f,d,h){return(0,L.replaceAsync)(f,P.VARIABLE_REGEXP,async(b,g)=>{if(g.includes(P.VARIABLE_LHS))return b;let p=await this.n(C,b,g,E,d);return h?.set(g,p),p!==b&&T.isString(p)&&p.match(P.VARIABLE_REGEXP)&&(p=await this.l(C,E,p,d,h)),p})}m(C){return this.b?this.b.getUriLabel(C,{noPrefix:!0}):C.fsPath}async n(C,E,f,d,h){let b;const g=f.split(":");g.length>1&&(f=g[0],b=g[1]);const p=s=>{const a=this.a.getFilePath();if(a)return(0,A.normalizeDriveLetter)(a);throw new D.VariableError(s,(0,y.localize)(0,null,E))},w=s=>{const a=p(s);if(this.a.getWorkspaceFolderPathForFile){const u=this.a.getWorkspaceFolderPathForFile();if(u)return(0,A.normalizeDriveLetter)(u)}throw new D.VariableError(s,(0,y.localize)(1,null,E,o.basename(a)))},i=s=>{if(b){const a=this.a.getFolderUri(b);if(a)return a;throw new D.VariableError(s,(0,y.localize)(2,null,E,b))}if(d)return d;throw this.a.getWorkspaceFolderCount()>1?new D.VariableError(s,(0,y.localize)(3,null,E)):new D.VariableError(s,(0,y.localize)(4,null,E))};switch(f){case"env":if(b){if(C.env){const s=C.env[I.isWindows?b.toLowerCase():b];if(T.isString(s))return s}return""}throw new D.VariableError(D.VariableKind.Env,(0,y.localize)(5,null,E));case"config":if(b){const s=this.a.getConfigurationValue(d,b);if(T.isUndefinedOrNull(s))throw new D.VariableError(D.VariableKind.Config,(0,y.localize)(6,null,E,b));if(T.isObject(s))throw new D.VariableError(D.VariableKind.Config,(0,y.localize)(7,null,E,b));return s}throw new D.VariableError(D.VariableKind.Config,(0,y.localize)(8,null,E));case"command":return this.o(D.VariableKind.Command,E,b,h,"command");case"input":return this.o(D.VariableKind.Input,E,b,h,"input");case"extensionInstallFolder":if(b){const s=await this.a.getExtension(b);if(!s)throw new D.VariableError(D.VariableKind.ExtensionInstallFolder,(0,y.localize)(9,null,E,b));return this.m(s.extensionLocation)}throw new D.VariableError(D.VariableKind.ExtensionInstallFolder,(0,y.localize)(10,null,E));default:switch(f){case"workspaceRoot":case"workspaceFolder":return(0,A.normalizeDriveLetter)(this.m(i(D.VariableKind.WorkspaceFolder)));case"cwd":return d||b?(0,A.normalizeDriveLetter)(this.m(i(D.VariableKind.Cwd))):t.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,A.normalizeDriveLetter)(o.basename(this.m(i(D.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(C.userHome)return C.userHome;throw new D.VariableError(D.VariableKind.UserHome,(0,y.localize)(11,null,E))}case"lineNumber":{const s=this.a.getLineNumber();if(s)return s;throw new D.VariableError(D.VariableKind.LineNumber,(0,y.localize)(12,null,E))}case"selectedText":{const s=this.a.getSelectedText();if(s)return s;throw new D.VariableError(D.VariableKind.SelectedText,(0,y.localize)(13,null,E))}case"file":return p(D.VariableKind.File);case"fileWorkspaceFolder":return w(D.VariableKind.FileWorkspaceFolder);case"relativeFile":return d||b?o.relative(this.m(i(D.VariableKind.RelativeFile)),p(D.VariableKind.RelativeFile)):p(D.VariableKind.RelativeFile);case"relativeFileDirname":{const s=o.dirname(p(D.VariableKind.RelativeFileDirname));if(d||b){const a=o.relative(this.m(i(D.VariableKind.RelativeFileDirname)),s);return a.length===0?".":a}return s}case"fileDirname":return o.dirname(p(D.VariableKind.FileDirname));case"fileExtname":return o.extname(p(D.VariableKind.FileExtname));case"fileBasename":return o.basename(p(D.VariableKind.FileBasename));case"fileBasenameNoExtension":{const s=o.basename(p(D.VariableKind.FileBasenameNoExtension));return s.slice(0,s.length-o.extname(s).length)}case"fileDirnameBasename":return o.basename(o.dirname(p(D.VariableKind.FileDirnameBasename)));case"execPath":{const s=this.a.getExecPath();return s||E}case"execInstallFolder":{const s=this.a.getAppRoot();return s||E}case"pathSeparator":return o.sep;default:try{const s=b?`${f}:${b}`:f;return this.o(D.VariableKind.Unknown,E,s,h,void 0)}catch{return E}}}}o(C,E,f,d,h){if(f&&d){const b=h===void 0?d[f]:d[h+":"+f];if(typeof b=="string")return b;throw new D.VariableError(C,(0,y.localize)(14,null,E))}return E}}e.AbstractVariableResolverService=P,P.VARIABLE_LHS="${",P.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ye[133],Ce([1,0,4,130]),function(te,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,o.createDecorator)("editorGroupsService");var T;(function(E){E[E.UP=0]="UP",E[E.DOWN=1]="DOWN",E[E.LEFT=2]="LEFT",E[E.RIGHT=3]="RIGHT"})(T=e.GroupDirection||(e.GroupDirection={}));var R;(function(E){E[E.HORIZONTAL=0]="HORIZONTAL",E[E.VERTICAL=1]="VERTICAL"})(R=e.GroupOrientation||(e.GroupOrientation={}));var I;(function(E){E[E.FIRST=0]="FIRST",E[E.LAST=1]="LAST",E[E.NEXT=2]="NEXT",E[E.PREVIOUS=3]="PREVIOUS"})(I=e.GroupLocation||(e.GroupLocation={}));var A;(function(E){E[E.MAXIMIZE=0]="MAXIMIZE",E[E.EVEN=1]="EVEN",E[E.TOGGLE=2]="TOGGLE"})(A=e.GroupsArrangement||(e.GroupsArrangement={}));var y;(function(E){E[E.COPY_EDITORS=0]="COPY_EDITORS",E[E.MOVE_EDITORS=1]="MOVE_EDITORS"})(y=e.MergeGroupMode||(e.MergeGroupMode={}));function D(E){const f=E;return(0,t.isEditorInput)(f?.editor)&&(0,t.isEditorInput)(f?.replacement)}e.isEditorReplacement=D;var L;(function(E){E[E.CREATION_TIME=0]="CREATION_TIME",E[E.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",E[E.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(L=e.GroupsOrder||(e.GroupsOrder={}));var P;(function(E){E[E.NEW_EDITOR=1]="NEW_EDITOR",E[E.MOVE_EDITOR=2]="MOVE_EDITOR",E[E.COPY_EDITOR=3]="COPY_EDITOR"})(P=e.OpenEditorContext||(e.OpenEditorContext={}));function v(E){const f=E;return!!f&&typeof f.id=="number"&&Array.isArray(f.editors)}e.isEditorGroup=v;function C(E){return E.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=C}),define(ye[228],Ce([1,0,4,133]),function(te,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,o.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function T(R){const I=R;return typeof R=="number"||(0,t.isEditorGroup)(I)}e.isPreferredGroup=T}),define(ye[229],Ce([1,0,4,196]),function(te,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,o.refineServiceDecorator)(t.IEnvironmentService)}),define(ye[134],Ce([1,0,26,3,10]),function(te,e,o,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class R{constructor(P){this.removedDueToLooping=P}}e.DeltaExtensionsResult=R;class I{static isHostExtension(P,v,C){if(v.getExtensionDescription(P))return!1;const E=C.getExtensionDescription(P);return E?!!((E.main||E.browser)&&E.api==="none"):!1}constructor(P){this.c=new t.Emitter,this.onDidChange=this.c.event,this.d=P,this.h()}h(){this.d.sort(y),this.e=new Map,this.f=[],this.g=new Map;for(const P of this.d){if(this.e.has(o.ExtensionIdentifier.toKey(P.identifier))){console.error("Extension `"+P.identifier.value+"` is already registered");continue}if(this.e.set(o.ExtensionIdentifier.toKey(P.identifier),P),this.f.push(P),Array.isArray(P.activationEvents))for(let v of P.activationEvents)v==="onUri"&&(v=`onUri:${o.ExtensionIdentifier.toKey(P.identifier)}`),this.g.has(v)||this.g.set(v,[]),this.g.get(v).push(P)}}set(P){this.d=P,this.h(),this.c.fire(void 0)}deltaExtensions(P,v){this.d=D(this.d,v),this.d=this.d.concat(P);const C=I.j(this.d);return this.d=D(this.d,C.map(E=>E.identifier)),this.h(),this.c.fire(void 0),new R(C)}static j(P){const v=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(h){this.d.has(h)||(this.d.add(h),this.e.push(h))}addArc(h,b){this.addNode(h),this.addNode(b),this.c.has(h)?this.c.get(h).push(b):this.c.set(h,[b])}getArcs(h){return this.c.has(h)?this.c.get(h):[]}hasOnlyGoodArcs(h,b){const g=v.getArcs(h);for(let p=0;p<g.length;p++)if(!b.has(g[p]))return!1;return!0}getNodes(){return this.e}},C=new Map;for(const h of P){const b=o.ExtensionIdentifier.toKey(h.identifier);if(C.set(b,h),h.extensionDependencies)for(const g of h.extensionDependencies){const p=o.ExtensionIdentifier.toKey(g);v.addArc(b,p)}}const E=new Set;v.getNodes().filter(h=>v.getArcs(h).length===0).forEach(h=>E.add(h));const f=v.getNodes().filter(h=>!E.has(h));let d;do{d=!1;for(let h=0;h<f.length;h++){const b=f[h];v.hasOnlyGoodArcs(b,E)&&(f.splice(h,1),h--,E.add(b),d=!0)}}while(d);return f.map(h=>C.get(h))}containsActivationEvent(P){return this.g.has(P)}containsExtension(P){return this.e.has(o.ExtensionIdentifier.toKey(P))}getExtensionDescriptionsForActivationEvent(P){const v=this.g.get(P);return v?v.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(P){const v=this.e.get(o.ExtensionIdentifier.toKey(P));return v||void 0}getExtensionDescriptionByUUID(P){for(const v of this.f)if(v.uuid===P)return v}getExtensionDescriptionByIdOrUUID(P,v){return this.getExtensionDescription(P)??(v?this.getExtensionDescriptionByUUID(v):void 0)}}e.ExtensionDescriptionRegistry=I;var A;(function(L){L[L.Builtin=0]="Builtin",L[L.User=1]="User",L[L.Dev=2]="Dev"})(A||(A={}));function y(L,P){const v=L.isBuiltin?0:L.isUnderDevelopment?2:1,C=P.isBuiltin?0:P.isUnderDevelopment?2:1;if(v!==C)return v-C;const E=T.posix.basename(L.extensionLocation.path),f=T.posix.basename(P.extensionLocation.path);return E<f?-1:E>f?1:0}function D(L,P){const v=new Set;return P.forEach(C=>v.add(o.ExtensionIdentifier.toKey(C))),L.filter(C=>!v.has(o.ExtensionIdentifier.toKey(C.identifier)))}}),define(ye[230],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var o;(function(L){L[L.IPC=1]="IPC",L[L.Socket=2]="Socket",L[L.MessagePort=3]="MessagePort"})(o=e.ExtHostConnectionType||(e.ExtHostConnectionType={}));class t{constructor(P){this.pipeName=P,this.type=1}serialize(P){P[t.ENV_KEY]=this.pipeName}}e.IPCExtHostConnection=t,t.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class T{constructor(){this.type=2}serialize(P){P[T.ENV_KEY]="1"}}e.SocketExtHostConnection=T,T.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class R{constructor(){this.type=3}serialize(P){P[R.ENV_KEY]="1"}}e.MessagePortExtHostConnection=R,R.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function I(L){delete L[t.ENV_KEY],delete L[T.ENV_KEY],delete L[R.ENV_KEY]}function A(L,P){I(P),L.serialize(P)}e.writeExtHostConnection=A;function y(L){if(L[t.ENV_KEY])return D(L,new t(L[t.ENV_KEY]));if(L[T.ENV_KEY])return D(L,new T);if(L[R.ENV_KEY])return D(L,new R);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=y;function D(L,P){return I(L),P}}),define(ye[94],Ce([1,0,22]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var t;(function(D){D[D.Desktop=1]="Desktop",D[D.Web=2]="Web"})(t=e.UIKind||(e.UIKind={}));var T;(function(D){D[D.VersionMismatch=55]="VersionMismatch",D[D.UnexpectedError=81]="UnexpectedError"})(T=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var R;(function(D){D[D.Initialized=0]="Initialized",D[D.Ready=1]="Ready",D[D.Terminate=2]="Terminate"})(R=e.MessageType||(e.MessageType={}));function I(D){const L=o.VSBuffer.alloc(1);switch(D){case 0:L.writeUInt8(1,0);break;case 1:L.writeUInt8(2,0);break;case 2:L.writeUInt8(3,0);break}return L}e.createMessageOfType=I;function A(D,L){if(D.byteLength!==1)return!1;switch(D.readUInt8(0)){case 1:return L===0;case 2:return L===1;case 3:return L===2;default:return!1}}e.isMessageOfType=A;var y;(function(D){D.Start="START_NATIVE_LOG",D.End="END_NATIVE_LOG"})(y=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(ye[95],Ce([1,0,4,3,13,25,94,67,68,23,2]),function(te,e,o,t,T,R,I,A,y,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let P=class{constructor(f,d){this.i=f,this.a=new t.Emitter,this.onDidChangeTelemetryEnabled=this.a.event,this.b=new t.Emitter,this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.d=0,this.f=!1,this.h=new Map,this.g=d.createLogger(L.URI.revive(this.i.environment.extensionTelemetryLogResource)),this.g.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.g.info("===========================================================")}getTelemetryConfiguration(){return this.d===3}getTelemetryDetails(){return{isCrashEnabled:this.d>=1,isErrorsEnabled:this.c.error?this.d>=2:!1,isUsageEnabled:this.c.usage?this.d>=3:!1}}instantiateLogger(f,d,h){const b=this.getTelemetryDetails(),g=new v(d,h,f,this.g,this.f,this.getBuiltInCommonProperties(f),{isUsageEnabled:b.isUsageEnabled,isErrorsEnabled:b.isErrorsEnabled});return this.h.set(f.identifier.value,g),g.apiTelemetryLogger}$initializeTelemetryLevel(f,d,h){this.d=f,this.f=d,this.c=h??{usage:!0,error:!0}}getBuiltInCommonProperties(f){const d={};switch(d["common.extname"]=f.name,d["common.extversion"]=f.version,d["common.vscodemachineid"]=this.i.telemetryInfo.machineId,d["common.vscodesessionid"]=this.i.telemetryInfo.sessionId,d["common.vscodeversion"]=this.i.version,d["common.isnewappinstall"]=C(this.i.telemetryInfo.firstSessionDate),d["common.product"]=this.i.environment.appHost,this.i.uiKind){case I.UIKind.Web:d["common.uikind"]="web";break;case I.UIKind.Desktop:d["common.uikind"]="desktop";break;default:d["common.uikind"]="unknown"}return d["common.remotename"]=(0,A.getRemoteName)((0,y.cleanRemoteAuthority)(this.i.remote.authority)),d}$onDidChangeTelemetryLevel(f){this.e=this.getTelemetryConfiguration(),this.d=f;const d=this.getTelemetryDetails();this.h.forEach(h=>{h.updateTelemetryEnablements(d.isUsageEnabled,d.isErrorsEnabled)}),this.e!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails())}onExtensionError(f,d){const h=this.h.get(f.value);return!h||h.ignoreUnhandledExtHostErrors?!1:(h.logError(d),!0)}};P=qe([We(0,R.IExtHostInitDataService),We(1,T.ILoggerService)],P),e.ExtHostTelemetry=P;class v{constructor(f,d,h,b,g,p,w){this.g=h,this.h=b,this.i=g,this.j=p,this.b=new t.Emitter,this.ignoreUnhandledExtHostErrors=d?.ignoreUnhandledErrors??!1,this.e=d?.ignoreBuiltInCommonProperties??!1,this.f=d?.additionalCommonProperties,this.a=f,this.c={isUsageEnabled:w.isUsageEnabled,isErrorsEnabled:w.isErrorsEnabled}}updateTelemetryEnablements(f,d){this.d&&(this.c={isUsageEnabled:f,isErrorsEnabled:d},this.b.fire(this.d))}mixInCommonPropsAndCleanData(f){let d=f.properties??f;return d=(0,y.cleanData)(d,[]),this.f&&(d=(0,D.mixin)(d,this.f)),this.e||(d=(0,D.mixin)(d,this.j)),f.properties?f.properties=d:f=d,f}k(f,d){this.g.publisher==="vscode"?f=this.g.name+"/"+f:f=this.g.identifier.value+"/"+f,d=this.mixInCommonPropsAndCleanData(d||{}),this.i||this.a.sendEventData(f,d),this.h.trace(f,d)}logUsage(f,d){!this.c.isUsageEnabled||this.k(f,d)}logError(f,d){!this.c.isErrorsEnabled||(typeof f=="string"?this.k(f,d):this.a.sendErrorData(f,d))}get apiTelemetryLogger(){if(!this.d){const f=this,d={logUsage:f.logUsage.bind(f),get isUsageEnabled(){return f.c.isUsageEnabled},get isErrorsEnabled(){return f.c.isErrorsEnabled},logError:f.logError.bind(f),dispose:f.dispose.bind(f),onDidChangeEnableStates:f.b.event.bind(f)};this.d=Object.freeze(d)}return this.d}dispose(){this.a?.flush&&this.a.flush()}}e.ExtHostTelemetryLogger=v;function C(E){const f=Date.now()-new Date(E).getTime();return isNaN(f)?!1:f<1e3*60*60*24}e.isNewAppInstall=C,e.IExtHostTelemetry=(0,o.createDecorator)("IExtHostTelemetry")}),define(ye[27],Ce([1,0,3,2,4,26,208]),function(te,e,o,t,T,R,I){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.webWorkerExtHostLog=e.remoteExtHostLog=e.localExtHostLog=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new R.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:t.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,T.createDecorator)("extensionService");class y{constructor(c){this.affinity=c,this.kind=1}equals(c){return this.kind===c.kind&&this.affinity===c.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=y;class D{constructor(c){this.affinity=c,this.kind=2}equals(c){return this.kind===c.kind&&this.affinity===c.affinity}asString(){return this.affinity===0?"LocalWebWorker":`LocalWebWorker${this.affinity}`}}e.LocalWebWorkerRunningLocation=D;class L{constructor(){this.kind=3,this.affinity=0}equals(c){return this.kind===c.kind}asString(){return"Remote"}}e.RemoteRunningLocation=L;class P{constructor(c){this.dependency=c}}e.MissingExtensionDependency=P;var v;(function(l){l[l.LocalProcess=1]="LocalProcess",l[l.LocalWebWorker=2]="LocalWebWorker",l[l.Remote=3]="Remote"})(v=e.ExtensionHostKind||(e.ExtensionHostKind={}));function C(l){if(l===null)return"None";switch(l){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=C;class E{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,myToRemove:[],myToAdd:this.d}}set(c,n){const r=[],m=[],S=[],k=[],M=h(this.c),q=h(c),V=(B,j)=>B.extensionLocation.toString()===j.extensionLocation.toString()||B.isBuiltin===j.isBuiltin||B.isUserBuiltin===j.isUserBuiltin||B.isUnderDevelopment===j.isUnderDevelopment;for(const B of this.c){const j=q.get(R.ExtensionIdentifier.toKey(B.identifier));if(!j){r.push(B.identifier),M.delete(R.ExtensionIdentifier.toKey(B.identifier));continue}if(!V(B,j)){r.push(B.identifier),M.delete(R.ExtensionIdentifier.toKey(B.identifier));continue}}for(const B of c){const j=M.get(R.ExtensionIdentifier.toKey(B.identifier));if(!j){m.push(B);continue}if(!V(j,B)){r.push(j.identifier),M.delete(R.ExtensionIdentifier.toKey(j.identifier));continue}}const F=d(this.d),U=d(n);for(const B of this.d)U.has(R.ExtensionIdentifier.toKey(B))||S.push(B);for(const B of n)F.has(R.ExtensionIdentifier.toKey(B))||k.push(B);const N={toRemove:r,toAdd:m,myToRemove:S,myToAdd:k};return this.delta(N),N}delta(c){const{toRemove:n,toAdd:r,myToRemove:m,myToAdd:S}=c,k=d(n),M=d(m);for(let q=0;q<this.c.length;q++)k.has(R.ExtensionIdentifier.toKey(this.c[q].identifier))&&(this.c.splice(q,1),q--);for(let q=0;q<this.d.length;q++)M.has(R.ExtensionIdentifier.toKey(this.d[q]))&&(this.d.splice(q,1),q--);for(const q of r)this.c.push(q);for(const q of S)this.d.push(q)}containsExtension(c){for(const n of this.d)if(R.ExtensionIdentifier.equals(n,c))return!0;return!1}}e.ExtensionHostExtensions=E;class f{constructor(c){if(this[A]="ExtensionIdentifierSet",this.c=new Map,this.d=R.ExtensionIdentifier.toKey,c)for(const n of c)this.add(n)}get size(){return this.c.size}add(c){return this.c.set(this.d(c),c),this}clear(){this.c.clear()}delete(c){return this.c.delete(this.d(c))}has(c){return this.c.has(this.d(c))}forEach(c,n){this.c.forEach(r=>c.call(n,r,r,this))}*entries(){for(const[c,n]of this.c)yield[n,n]}keys(){return this.c.values()}values(){return this.c.values()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.c.values()}}e.ExtensionIdentifierSet=f;function d(l){const c=new Set;for(const n of l)c.add(R.ExtensionIdentifier.toKey(n));return c}e.extensionIdentifiersArrayToSet=d;function h(l){const c=new Map;for(const n of l)c.set(R.ExtensionIdentifier.toKey(n.identifier),n);return c}function b(l,c){return l.enabledApiProposals?l.enabledApiProposals.includes(c):!1}e.isProposedApiEnabled=b;function g(l,c){if(!b(l,c))throw new Error(`Extension '${l.identifier.value}' CANNOT use API proposal: ${c}.
Its package.json#enabledApiProposals-property declares: ${l.enabledApiProposals?.join(", ")??"[]"} but NOT ${c}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${l.identifier.value}`)}e.checkProposedApiEnabled=g;class p{constructor(c,n,r,m){this.codeLoadingTime=c,this.activateCallTime=n,this.activateResolvedTime=r,this.activationReason=m}}e.ActivationTimes=p;class w{constructor(c,n){this.description=c,this.value=n}}e.ExtensionPointContribution=w,e.ExtensionHostLogFileName="exthost",e.localExtHostLog="extHostLog",e.remoteExtHostLog="remoteExtHostLog",e.webWorkerExtHostLog="webWorkerExtHostLog";var i;(function(l){l[l.Normal=0]="Normal",l[l.Immediate=1]="Immediate"})(i=e.ActivationKind||(e.ActivationKind={}));function s(l){return{type:l.isBuiltin?0:1,isBuiltin:l.isBuiltin||l.isUserBuiltin,identifier:{id:(0,I.getGalleryExtensionId)(l.publisher,l.name),uuid:l.uuid},manifest:l,location:l.extensionLocation,targetPlatform:l.targetPlatform,validations:[],isValid:!0}}e.toExtension=s;function a(l,c){return{identifier:new R.ExtensionIdentifier((0,I.getExtensionId)(l.manifest.publisher,l.manifest.name)),isBuiltin:l.type===0,isUserBuiltin:l.type===1&&l.isBuiltin,isUnderDevelopment:!!c,extensionLocation:l.location,...l.manifest,uuid:l.identifier.uuid,targetPlatform:l.targetPlatform,browserNlsBundleUris:l.browserNlsBundleUris}}e.toExtensionDescription=a;class u{constructor(){this.onDidRegisterExtensions=o.Event.None,this.onDidChangeExtensionsStatus=o.Event.None,this.onDidChangeExtensions=o.Event.None,this.onWillActivateByEvent=o.Event.None,this.onDidChangeResponsiveChange=o.Event.None,this.extensions=[]}activateByEvent(c){return Promise.resolve(void 0)}activationEventIsDone(c){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(c){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(c,n){return Promise.resolve(0)}getInspectPorts(c,n){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(c){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=u}),define(ye[231],Ce([1,0,9,134,26,27,13,16]),function(te,e,o,t,T,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class y{constructor(h,b,g,p){this.startup=h,this.codeLoadingTime=b,this.activateCallTime=g,this.activateResolvedTime=p}}e.ExtensionActivationTimes=y,y.NONE=new y(!1,-1,-1,-1);class D{constructor(h){this.a=h,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(h,b){return h===-1||b===-1?-1:b-h}build(){return new y(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.ExtensionActivationTimesBuilder=D;class L{constructor(h,b,g,p,w,i){this.activationFailed=h,this.activationFailedError=b,this.activationTimes=g,this.module=p,this.exports=w,this.subscriptions=i}}e.ActivatedExtension=L;class P extends L{constructor(h){super(!1,null,h,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=P;class v extends L{constructor(){super(!1,null,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=v;class C extends L{constructor(h){super(!0,h,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let E=class{constructor(h,b,g,p){this.g=p,this.a=h,this.b=b,this.c=g,this.d=new Map,this.f=Object.create(null)}dispose(){for(const[h,b]of this.d)b.dispose()}isActivated(h){const b=this.d.get(T.ExtensionIdentifier.toKey(h));return Boolean(b&&b.value)}getActivatedExtension(h){const b=this.d.get(T.ExtensionIdentifier.toKey(h));if(!b||!b.value)throw new Error(`Extension '${h.value}' is not known or not activated`);return b.value}async activateByEvent(h,b){if(this.f[h])return;const g=this.a.getExtensionDescriptionsForActivationEvent(h);await this.h(g.map(p=>({id:p.identifier,reason:{startup:b,extensionId:p.identifier,activationEvent:h}}))),this.f[h]=!0}activateById(h,b){const g=this.a.getExtensionDescription(h);if(!g)throw new Error(`Extension '${h}' is not known`);return this.h([{id:g.identifier,reason:b}])}async h(h){const b=h.filter(g=>!this.isActivated(g.id)).map(g=>this.j(g));await Promise.all(b.map(g=>g.wait()))}j(h){if(this.d.has(T.ExtensionIdentifier.toKey(h.id)))return this.d.get(T.ExtensionIdentifier.toKey(h.id));if(this.l(h.id))return this.k(h,null,[],null);const b=this.a.getExtensionDescription(h.id);if(!b){const w=new Error(`Cannot activate unknown extension '${h.id.value}'`),i=this.k(h,null,[],new C(w));return this.c.onExtensionActivationError(h.id,w,new R.MissingExtensionDependency(h.id.value)),i}const g=[],p=typeof b.extensionDependencies>"u"?[]:b.extensionDependencies;for(const w of p){if(this.m(w))continue;const i=this.d.get(T.ExtensionIdentifier.toKey(w));if(i){g.push(i);continue}if(this.l(w)){g.push(this.j({id:this.b.getExtensionDescription(w).identifier,reason:h.reason}));continue}const s=this.a.getExtensionDescription(w);if(s){if(!s.main&&!s.browser)continue;g.push(this.j({id:s.identifier,reason:h.reason}));continue}const a=b.displayName||b.identifier.value,u=new Error(`Cannot activate the '${a}' extension because it depends on unknown extension '${w}'`),l=this.k(h,b.displayName,[],new C(u));return this.c.onExtensionActivationError(b.identifier,u,new R.MissingExtensionDependency(w)),l}return this.k(h,b.displayName,g,null)}k(h,b,g,p){const w=new f(h.id,b,h.reason,g,p,this.c,this.g);return this.d.set(T.ExtensionIdentifier.toKey(h.id),w),w}l(h){return t.ExtensionDescriptionRegistry.isHostExtension(h,this.a,this.b)}m(h){const b=this.b.getExtensionDescription(h);return b?!b.main&&!b.browser:!1}};E=qe([We(3,I.ILogService)],E),e.ExtensionsActivator=E;let f=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(h,b,g,p,w,i,s){this.c=h,this.d=b,this.f=g,this.g=p,this.h=w,this.j=i,this.k=s,this.a=new A.Barrier,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let h=0;h<this.g.length;h++){const b=this.g[h];if(b.value&&!b.value.activationFailed){this.g.splice(h,1),h--;continue}if(b.value&&b.value.activationFailed){const g=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${b.friendlyName}' failed to activate`);g.detail=b.value.activationFailedError,this.h=new C(g),this.j.onExtensionActivationError(this.c,g,null);return}}this.g.length>0&&await Promise.race(this.g.map(h=>h.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(h){const b=new Error;if(h&&h.name&&(b.name=h.name),h&&h.message?b.message=`Activating extension '${this.c.value}' failed: ${h.message}.`:b.message=`Activating extension '${this.c.value}' failed: ${h}.`,h&&h.stack&&(b.stack=h.stack),this.h=new C(b),this.b&&o.isCancellationError(h))return;this.j.onExtensionActivationError(this.c,b,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(h)}}};f=qe([We(6,I.ILogService)],f)}),define(ye[232],Ce([1,0,13,25,27]),function(te,e,o,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let R=class extends o.LogService{constructor(A,y){super(A.createLogger(y.logFile,{name:T.ExtensionHostLogFileName}))}};R=qe([We(0,o.ILoggerService),We(1,t.IExtHostInitDataService)],R),e.ExtHostLogService=R});var Je=this&&this.__classPrivateFieldSet||function(te,e,o,t,T){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?T.call(te,o):T?T.value=o:e.set(te,o),o},Ue=this&&this.__classPrivateFieldGet||function(te,e,o,t){if(o==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?t:o==="a"?t.call(te):t?t.value:e.get(te)};define(ye[7],Ce([1,0,18,9,111,28,84,8,11,2,30,39,128,91,27]),function(te,e,o,t,T,R,I,A,y,D,L,P,v,C,E){"use strict";var f,d,h,b,g,p,w,i,s,a,u,l,c,n,r,m,S,k,M,q,V,F,U;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function N(G){return Object.assign(G,{apply:function(){const me=arguments.length===1?[]:arguments[1];return Reflect.construct(G,me,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(G,[]);{const[me,...Te]=arguments;return Reflect.construct(G,Te,me.constructor)}}})}var B;(function(G){G[G.Top=0]="Top",G[G.Bottom=1]="Bottom"})(B=e.TerminalOutputAnchor||(e.TerminalOutputAnchor={}));var j;(function(G){G[G.Command=0]="Command",G[G.Opener=1]="Opener"})(j=e.TerminalQuickFixType||(e.TerminalQuickFixType={}));let z=p=class{static from(...W){let me=W;return new p(function(){if(me){for(const Te of me)Te&&typeof Te.dispose=="function"&&Te.dispose();me=void 0}})}constructor(W){f.set(this,void 0),Je(this,f,W,"f")}dispose(){typeof Ue(this,f,"f")=="function"&&(Ue(this,f,"f").call(this),Je(this,f,void 0,"f"))}};f=new WeakMap,z=p=qe([N],z),e.Disposable=z;let ne=w=class{static Min(...W){if(W.length===0)throw new TypeError;let me=W[0];for(let Te=1;Te<W.length;Te++){const Ke=W[Te];Ke.isBefore(me)&&(me=Ke)}return me}static Max(...W){if(W.length===0)throw new TypeError;let me=W[0];for(let Te=1;Te<W.length;Te++){const Ke=W[Te];Ke.isAfter(me)&&(me=Ke)}return me}static isPosition(W){if(!W)return!1;if(W instanceof w)return!0;const{line:me,character:Te}=W;return typeof me=="number"&&typeof Te=="number"}static of(W){if(W instanceof w)return W;if(this.isPosition(W))return new w(W.line,W.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(W,me){if(W<0)throw(0,t.illegalArgument)("line must be non-negative");if(me<0)throw(0,t.illegalArgument)("character must be non-negative");this.c=W,this.e=me}isBefore(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<W.e}isBeforeOrEqual(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<=W.e}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this.c===W.c&&this.e===W.e}compareTo(W){return this.c<W.c?-1:this.c>W.line?1:this.e<W.e?-1:this.e>W.e?1:0}translate(W,me=0){if(W===null||me===null)throw(0,t.illegalArgument)();let Te;return typeof W>"u"?Te=0:typeof W=="number"?Te=W:(Te=typeof W.lineDelta=="number"?W.lineDelta:0,me=typeof W.characterDelta=="number"?W.characterDelta:0),Te===0&&me===0?this:new w(this.line+Te,this.character+me)}with(W,me=this.character){if(W===null||me===null)throw(0,t.illegalArgument)();let Te;return typeof W>"u"?Te=this.line:typeof W=="number"?Te=W:(Te=typeof W.line=="number"?W.line:this.line,me=typeof W.character=="number"?W.character:this.character),Te===this.line&&me===this.character?this:new w(Te,me)}toJSON(){return{line:this.line,character:this.character}}};ne=w=qe([N],ne),e.Position=ne;let _=i=class{static isRange(W){return W instanceof i?!0:W?ne.isPosition(W.start)&&ne.isPosition(W.end):!1}static of(W){if(W instanceof i)return W;if(this.isRange(W))return new i(W.start,W.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(W,me,Te,Ke){let Ye,ct;if(typeof W=="number"&&typeof me=="number"&&typeof Te=="number"&&typeof Ke=="number"?(Ye=new ne(W,me),ct=new ne(Te,Ke)):ne.isPosition(W)&&ne.isPosition(me)&&(Ye=ne.of(W),ct=ne.of(me)),!Ye||!ct)throw new Error("Invalid arguments");Ye.isBefore(ct)?(this.c=Ye,this.e=ct):(this.c=ct,this.e=Ye)}contains(W){return i.isRange(W)?this.contains(W.start)&&this.contains(W.end):ne.isPosition(W)?!(ne.of(W).isBefore(this.c)||this.e.isBefore(W)):!1}isEqual(W){return this.c.isEqual(W.c)&&this.e.isEqual(W.e)}intersection(W){const me=ne.Max(W.start,this.c),Te=ne.Min(W.end,this.e);if(!me.isAfter(Te))return new i(me,Te)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const me=ne.Min(W.start,this.c),Te=ne.Max(W.end,this.end);return new i(me,Te)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(W,me=this.end){if(W===null||me===null)throw(0,t.illegalArgument)();let Te;return W?ne.isPosition(W)?Te=W:(Te=W.start||this.start,me=W.end||this.end):Te=this.start,Te.isEqual(this.c)&&me.isEqual(this.end)?this:new i(Te,me)}toJSON(){return[this.start,this.end]}};_=i=qe([N],_),e.Range=_;let Y=s=class extends _{static isSelection(W){return W instanceof s?!0:W?_.isRange(W)&&ne.isPosition(W.anchor)&&ne.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(W,me,Te,Ke){let Ye,ct;if(typeof W=="number"&&typeof me=="number"&&typeof Te=="number"&&typeof Ke=="number"?(Ye=new ne(W,me),ct=new ne(Te,Ke)):ne.isPosition(W)&&ne.isPosition(me)&&(Ye=ne.of(W),ct=ne.of(me)),!Ye||!ct)throw new Error("Invalid arguments");super(Ye,ct),this.f=Ye,this.g=ct}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};Y=s=qe([N],Y),e.Selection=Y;class J{constructor(W,me,Te){if(typeof W!="string"||W.length===0)throw(0,t.illegalArgument)("host");if(typeof me!="number"||me===0||Math.round(me)!==me)throw(0,t.illegalArgument)("port");if(typeof Te<"u"&&(typeof Te!="string"||Te.length===0||!/^[0-9A-Za-z_\-]+$/.test(Te)))throw(0,t.illegalArgument)("connectionToken");this.host=W,this.port=Math.round(me),this.connectionToken=Te}}e.ResolvedAuthority=J;class Z extends Error{static NotAvailable(W,me){return new Z(W,v.RemoteAuthorityResolverErrorCode.NotAvailable,me)}static TemporarilyNotAvailable(W){return new Z(W,v.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(W,me=v.RemoteAuthorityResolverErrorCode.Unknown,Te){super(W),this._message=W,this._code=me,this._detail=Te,Object.setPrototypeOf(this,Z.prototype)}}e.RemoteAuthorityResolverError=Z;var ie;(function(G){G[G.LF=1]="LF",G[G.CRLF=2]="CRLF"})(ie=e.EndOfLine||(e.EndOfLine={}));var X;(function(G){G[G.Replace=1]="Replace",G[G.Append=2]="Append",G[G.Prepend=3]="Prepend"})(X=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let K=a=class{static isTextEdit(W){return W instanceof a?!0:W?_.isRange(W)&&typeof W.newText=="string":!1}static replace(W,me){return new a(W,me)}static insert(W,me){return a.replace(new _(W,W),me)}static delete(W){return a.replace(W,"")}static setEndOfLine(W){const me=new a(new _(new ne(0,0),new ne(0,0)),"");return me.newEol=W,me}get range(){return this.c}set range(W){if(W&&!_.isRange(W))throw(0,t.illegalArgument)("range");this.c=W}get newText(){return this.e||""}set newText(W){if(W&&typeof W!="string")throw(0,t.illegalArgument)("newText");this.e=W}get newEol(){return this.f}set newEol(W){if(W&&typeof W!="number")throw(0,t.illegalArgument)("newEol");this.f=W}constructor(W,me){this.c=W,this.e=me}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};K=a=qe([N],K),e.TextEdit=K;let he=u=class{static isNotebookCellEdit(W){return W instanceof u?!0:W?xt.isNotebookRange(W)&&Array.isArray(W.newCells):!1}static replaceCells(W,me){return new u(W,me)}static insertCells(W,me){return new u(new xt(W,W),me)}static deleteCells(W){return new u(W,[])}static updateCellMetadata(W,me){const Te=new u(new xt(W,W),[]);return Te.newCellMetadata=me,Te}static updateNotebookMetadata(W){const me=new u(new xt(0,0),[]);return me.newNotebookMetadata=W,me}constructor(W,me){this.range=W,this.newCells=me}};he=u=qe([N],he),e.NotebookEdit=he;class be{static isSnippetTextEdit(W){return W instanceof be?!0:W?_.isRange(W.range)&&Me.isSnippetString(W.snippet):!1}static replace(W,me){return new be(W,me)}static insert(W,me){return be.replace(new _(W,W),me)}constructor(W,me){this.range=W,this.snippet=me}}e.SnippetTextEdit=be;var Ee;(function(G){G[G.File=1]="File",G[G.Text=2]="Text",G[G.Cell=3]="Cell",G[G.CellReplace=5]="CellReplace",G[G.Snippet=6]="Snippet"})(Ee=e.FileEditType||(e.FileEditType={}));let Pe=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(W,me,Te,Ke){this.c.push({_type:1,from:W,to:me,options:Te,metadata:Ke})}createFile(W,me,Te){this.c.push({_type:1,from:void 0,to:W,options:me,metadata:Te})}deleteFile(W,me,Te){this.c.push({_type:1,from:W,to:void 0,options:me,metadata:Te})}e(W,me,Te){this.c.push({_type:3,metadata:Te,uri:W,edit:{editType:5,metadata:me},notebookMetadata:me})}f(W,me,Te,Ke){const Ye=me.start,ct=me.end;(Ye!==ct||Te.length>0)&&this.c.push({_type:5,uri:W,index:Ye,count:ct-Ye,cells:Te,metadata:Ke})}g(W,me,Te,Ke){this.c.push({_type:3,metadata:Ke,uri:W,edit:{editType:8,index:me,metadata:Te}})}replace(W,me,Te,Ke){this.c.push({_type:2,uri:W,edit:new K(me,Te),metadata:Ke})}insert(W,me,Te,Ke){this.replace(W,new _(me,me),Te,Ke)}delete(W,me,Te){this.replace(W,me,"",Te)}has(W){return this.c.some(me=>me._type===2&&me.uri.toString()===W.toString())}set(W,me){if(me)for(const Te of me){if(!Te)continue;let Ke,Ye;if(Array.isArray(Te)?(Ke=Te[0],Ye=Te[1]):Ke=Te,he.isNotebookCellEdit(Ke)){if(W.scheme===C.CellUri.scheme)throw new Error("set must be called with a notebook document URI, not a cell URI.");Ke.newCellMetadata?this.g(W,Ke.range.start,Ke.newCellMetadata,Ye):Ke.newNotebookMetadata?this.e(W,Ke.newNotebookMetadata,Ye):this.f(W,Ke.range,Ke.newCells,Ye)}else be.isSnippetTextEdit(Ke)?this.c.push({_type:6,uri:W,range:Ke.range,edit:Ke.snippet,metadata:Ye}):this.c.push({_type:2,uri:W,edit:Ke,metadata:Ye})}else{for(let Te=0;Te<this.c.length;Te++){const Ke=this.c[Te];switch(Ke._type){case 2:case 6:case 3:case 5:Ke.uri.toString()===W.toString()&&(this.c[Te]=void 0);break}}(0,o.coalesceInPlace)(this.c)}}get(W){const me=[];for(const Te of this.c)Te._type===2&&Te.uri.toString()===W.toString()&&me.push(Te.edit);return me}entries(){const W=new R.ResourceMap;for(const me of this.c)if(me._type===2){let Te=W.get(me.uri);Te||(Te=[me.uri,[]],W.set(me.uri,Te)),Te[1].push(me.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Pe=qe([N],Pe),e.WorkspaceEdit=Pe;let Me=l=class{static isSnippetString(W){return W instanceof l?!0:W?typeof W.value=="string":!1}static c(W){return W.replace(/\$|}|\\/g,"\\$&")}constructor(W){this.e=1,this.value=W||""}appendText(W){return this.value+=l.c(W),this}appendTabstop(W=this.e++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,me=this.e++){if(typeof W=="function"){const Te=new l;Te.e=this.e,W(Te),this.e=Te.e,W=Te.value}else W=l.c(W);return this.value+="${",this.value+=me,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,me=this.e++){const Te=W.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=me,this.value+="|",this.value+=Te,this.value+="|}",this}appendVariable(W,me){if(typeof me=="function"){const Te=new l;Te.e=this.e,me(Te),this.e=Te.e,me=Te.value}else typeof me=="string"&&(me=me.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,me&&(this.value+=":",this.value+=me),this.value+="}",this}};Me=l=qe([N],Me),e.SnippetString=Me;var oe;(function(G){G[G.Unnecessary=1]="Unnecessary",G[G.Deprecated=2]="Deprecated"})(oe=e.DiagnosticTag||(e.DiagnosticTag={}));var ae;(function(G){G[G.Hint=3]="Hint",G[G.Information=2]="Information",G[G.Warning=1]="Warning",G[G.Error=0]="Error"})(ae=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let fe=c=class{static isLocation(W){return W instanceof c?!0:W?_.isRange(W.range)&&D.URI.isUri(W.uri):!1}constructor(W,me){if(this.uri=W,me)if(_.isRange(me))this.range=_.of(me);else if(ne.isPosition(me))this.range=new _(me,me);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};fe=c=qe([N],fe),e.Location=fe;let ee=class{static is(W){return W?typeof W.message=="string"&&W.location&&_.isRange(W.location.range)&&D.URI.isUri(W.location.uri):!1}constructor(W,me){this.location=W,this.message=me}static isEqual(W,me){return W===me?!0:!W||!me?!1:W.message===me.message&&W.location.range.isEqual(me.location.range)&&W.location.uri.toString()===me.location.uri.toString()}};ee=qe([N],ee),e.DiagnosticRelatedInformation=ee;let le=class{constructor(W,me,Te=ae.Error){if(!_.isRange(W))throw new TypeError("range must be set");if(!me)throw new TypeError("message must be set");this.range=W,this.message=me,this.severity=Te}toJSON(){return{severity:ae[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,me){return W===me?!0:!W||!me?!1:W.message===me.message&&W.severity===me.severity&&W.code===me.code&&W.severity===me.severity&&W.source===me.source&&W.range.isEqual(me.range)&&(0,o.equals)(W.tags,me.tags)&&(0,o.equals)(W.relatedInformation,me.relatedInformation,ee.isEqual)}};le=qe([N],le),e.Diagnostic=le;let re=class{constructor(W,me){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:this.contents=[W],this.range=me}};re=qe([N],re),e.Hover=re;var O;(function(G){G[G.Text=0]="Text",G[G.Read=1]="Read",G[G.Write=2]="Write"})(O=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let H=class{constructor(W,me=O.Text){this.range=W,this.kind=me}toJSON(){return{range:this.range,kind:O[this.kind]}}};H=qe([N],H),e.DocumentHighlight=H;var x;(function(G){G[G.File=0]="File",G[G.Module=1]="Module",G[G.Namespace=2]="Namespace",G[G.Package=3]="Package",G[G.Class=4]="Class",G[G.Method=5]="Method",G[G.Property=6]="Property",G[G.Field=7]="Field",G[G.Constructor=8]="Constructor",G[G.Enum=9]="Enum",G[G.Interface=10]="Interface",G[G.Function=11]="Function",G[G.Variable=12]="Variable",G[G.Constant=13]="Constant",G[G.String=14]="String",G[G.Number=15]="Number",G[G.Boolean=16]="Boolean",G[G.Array=17]="Array",G[G.Object=18]="Object",G[G.Key=19]="Key",G[G.Null=20]="Null",G[G.EnumMember=21]="EnumMember",G[G.Struct=22]="Struct",G[G.Event=23]="Event",G[G.Operator=24]="Operator",G[G.TypeParameter=25]="TypeParameter"})(x=e.SymbolKind||(e.SymbolKind={}));var Q;(function(G){G[G.Deprecated=1]="Deprecated"})(Q=e.SymbolTag||(e.SymbolTag={}));let de=n=class{static validate(W){if(!W.name)throw new Error("name must not be falsy")}constructor(W,me,Te,Ke,Ye){this.name=W,this.kind=me,this.containerName=Ye,typeof Te=="string"&&(this.containerName=Te),Ke instanceof fe?this.location=Ke:Te instanceof _&&(this.location=new fe(Ke,Te)),n.validate(this)}toJSON(){return{name:this.name,kind:x[this.kind],location:this.location,containerName:this.containerName}}};de=n=qe([N],de),e.SymbolInformation=de;let we=r=class{static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children?.forEach(r.validate)}constructor(W,me,Te,Ke,Ye){this.name=W,this.detail=me,this.kind=Te,this.range=Ke,this.selectionRange=Ye,this.children=[],r.validate(this)}};we=r=qe([N],we),e.DocumentSymbol=we;var Ae;(function(G){G[G.Invoke=1]="Invoke",G[G.Automatic=2]="Automatic"})(Ae=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let pe=class{constructor(W,me){this.title=W,this.kind=me}};pe=qe([N],pe),e.CodeAction=pe;let De=m=class{constructor(W){this.value=W}append(W){return new m(this.value?this.value+m.c+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+m.c)}};De.c=".",De=m=qe([N],De),e.CodeActionKind=De,De.Empty=new De(""),De.QuickFix=De.Empty.append("quickfix"),De.Refactor=De.Empty.append("refactor"),De.RefactorExtract=De.Refactor.append("extract"),De.RefactorInline=De.Refactor.append("inline"),De.RefactorMove=De.Refactor.append("move"),De.RefactorRewrite=De.Refactor.append("rewrite"),De.Source=De.Empty.append("source"),De.SourceOrganizeImports=De.Source.append("organizeImports"),De.SourceFixAll=De.Source.append("fixAll");let ke=class{constructor(W,me){if(this.range=W,this.parent=me,me&&!me.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ke=qe([N],ke),e.SelectionRange=ke;class je{constructor(W,me,Te,Ke,Ye,ct){this.kind=W,this.name=me,this.detail=Te,this.uri=Ke,this.range=Ye,this.selectionRange=ct}}e.CallHierarchyItem=je;class Ge{constructor(W,me){this.fromRanges=me,this.from=W}}e.CallHierarchyIncomingCall=Ge;class et{constructor(W,me){this.fromRanges=me,this.to=W}}e.CallHierarchyOutgoingCall=et;var _e;(function(G){G[G.Information=0]="Information",G[G.Warning=1]="Warning",G[G.Error=2]="Error"})(_e=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let nt=class{constructor(W,me){this.range=W,this.command=me}get isResolved(){return!!this.command}};nt=qe([N],nt),e.CodeLens=nt;let st=S=class{static isMarkdownString(W){return W instanceof S?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}constructor(W,me=!1){d.set(this,void 0),Je(this,d,new T.MarkdownString(W,{supportThemeIcons:me}),"f")}get value(){return Ue(this,d,"f").value}set value(W){Ue(this,d,"f").value=W}get isTrusted(){return Ue(this,d,"f").isTrusted}set isTrusted(W){Ue(this,d,"f").isTrusted=W}get supportThemeIcons(){return Ue(this,d,"f").supportThemeIcons}set supportThemeIcons(W){Ue(this,d,"f").supportThemeIcons=W}get supportHtml(){return Ue(this,d,"f").supportHtml}set supportHtml(W){Ue(this,d,"f").supportHtml=W}get baseUri(){return Ue(this,d,"f").baseUri}set baseUri(W){Ue(this,d,"f").baseUri=W}appendText(W){return Ue(this,d,"f").appendText(W),this}appendMarkdown(W){return Ue(this,d,"f").appendMarkdown(W),this}appendCodeblock(W,me){return Ue(this,d,"f").appendCodeblock(me??"",W),this}};d=new WeakMap,st=S=qe([N],st),e.MarkdownString=st;let ht=class{constructor(W,me){this.label=W,this.documentation=me}};ht=qe([N],ht),e.ParameterInformation=ht;let Fe=class{constructor(W,me){this.label=W,this.documentation=me,this.parameters=[]}};Fe=qe([N],Fe),e.SignatureInformation=Fe;let it=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};it=qe([N],it),e.SignatureHelp=it;var ce;(function(G){G[G.Invoke=1]="Invoke",G[G.TriggerCharacter=2]="TriggerCharacter",G[G.ContentChange=3]="ContentChange"})(ce=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var $;(function(G){G[G.Type=1]="Type",G[G.Parameter=2]="Parameter"})($=e.InlayHintKind||(e.InlayHintKind={}));let ue=class{constructor(W){this.value=W}};ue=qe([N],ue),e.InlayHintLabelPart=ue;let Ie=class{constructor(W,me,Te){this.position=W,this.label=me,this.kind=Te}};Ie=qe([N],Ie),e.InlayHint=Ie;var Le;(function(G){G[G.Invoke=0]="Invoke",G[G.TriggerCharacter=1]="TriggerCharacter",G[G.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Le=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Be;(function(G){G[G.Text=0]="Text",G[G.Method=1]="Method",G[G.Function=2]="Function",G[G.Constructor=3]="Constructor",G[G.Field=4]="Field",G[G.Variable=5]="Variable",G[G.Class=6]="Class",G[G.Interface=7]="Interface",G[G.Module=8]="Module",G[G.Property=9]="Property",G[G.Unit=10]="Unit",G[G.Value=11]="Value",G[G.Enum=12]="Enum",G[G.Keyword=13]="Keyword",G[G.Snippet=14]="Snippet",G[G.Color=15]="Color",G[G.File=16]="File",G[G.Reference=17]="Reference",G[G.Folder=18]="Folder",G[G.EnumMember=19]="EnumMember",G[G.Constant=20]="Constant",G[G.Struct=21]="Struct",G[G.Event=22]="Event",G[G.Operator=23]="Operator",G[G.TypeParameter=24]="TypeParameter",G[G.User=25]="User",G[G.Issue=26]="Issue"})(Be=e.CompletionItemKind||(e.CompletionItemKind={}));var xe;(function(G){G[G.Deprecated=1]="Deprecated"})(xe=e.CompletionItemTag||(e.CompletionItemTag={}));let Ze=class{constructor(W,me){this.label=W,this.kind=me}toJSON(){return{label:this.label,kind:this.kind&&Be[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ze=qe([N],Ze),e.CompletionItem=Ze;let gt=class{constructor(W=[],me=!1){this.items=W,this.isIncomplete=me}};gt=qe([N],gt),e.CompletionList=gt;let mt=class{constructor(W,me,Te){this.insertText=W,this.range=me,this.command=Te}};mt=qe([N],mt),e.InlineSuggestion=mt;let lt=class{constructor(W){this.commands=void 0,this.items=W}};lt=qe([N],lt),e.InlineSuggestionList=lt;var ot;(function(G){G[G.Active=-1]="Active",G[G.Beside=-2]="Beside",G[G.One=1]="One",G[G.Two=2]="Two",G[G.Three=3]="Three",G[G.Four=4]="Four",G[G.Five=5]="Five",G[G.Six=6]="Six",G[G.Seven=7]="Seven",G[G.Eight=8]="Eight",G[G.Nine=9]="Nine"})(ot=e.ViewColumn||(e.ViewColumn={}));var rt;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(rt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var kt;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative"})(kt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Tt;(function(G){G[G.Manual=1]="Manual",G[G.AfterDelay=2]="AfterDelay",G[G.FocusOut=3]="FocusOut"})(Tt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Nt;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(Nt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var pt;(function(G){G[G.Keyboard=1]="Keyboard",G[G.Mouse=2]="Mouse",G[G.Command=3]="Command"})(pt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Dt;(function(G){G[G.Undo=1]="Undo",G[G.Redo=2]="Redo"})(Dt=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var zt;(function(G){G[G.OpenOpen=0]="OpenOpen",G[G.ClosedClosed=1]="ClosedClosed",G[G.OpenClosed=2]="OpenClosed",G[G.ClosedOpen=3]="ClosedOpen"})(zt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(G){function W(me){switch(me){case"keyboard":return G.Keyboard;case"mouse":return G.Mouse;case"api":return G.Command}}G.fromValue=W}(pt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ft=class{constructor(W,me){if(me&&!D.URI.isUri(me))throw(0,t.illegalArgument)("target");if(!_.isRange(W)||W.isEmpty)throw(0,t.illegalArgument)("range");this.range=W,this.target=me}};Ft=qe([N],Ft),e.DocumentLink=Ft;let Xe=class{constructor(W,me,Te,Ke){this.red=W,this.green=me,this.blue=Te,this.alpha=Ke}};Xe=qe([N],Xe),e.Color=Xe;let Mt=class{constructor(W,me){if(me&&!(me instanceof Xe))throw(0,t.illegalArgument)("color");if(!_.isRange(W)||W.isEmpty)throw(0,t.illegalArgument)("range");this.range=W,this.color=me}};Mt=qe([N],Mt),e.ColorInformation=Mt;let Ut=class{constructor(W){if(!W||typeof W!="string")throw(0,t.illegalArgument)("label");this.label=W}};Ut=qe([N],Ut),e.ColorPresentation=Ut;var Bt;(function(G){G[G.RGB=0]="RGB",G[G.HEX=1]="HEX",G[G.HSL=2]="HSL"})(Bt=e.ColorFormat||(e.ColorFormat={}));var wt;(function(G){G[G.Error=0]="Error",G[G.Warning=1]="Warning",G[G.Information=2]="Information"})(wt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var Pt;(function(G){G[G.Unknown=0]="Unknown",G[G.Shutdown=1]="Shutdown",G[G.Process=2]="Process",G[G.User=3]="User",G[G.Extension=4]="Extension"})(Pt=e.TerminalExitReason||(e.TerminalExitReason={}));class Re{constructor(W,me,Te){if(this.startIndex=W,this.length=me,this.tooltip=Te,typeof W!="number"||W<0)throw(0,t.illegalArgument)("startIndex");if(typeof me!="number"||me<1)throw(0,t.illegalArgument)("length");if(Te!==void 0&&typeof Te!="string")throw(0,t.illegalArgument)("tooltip")}}e.TerminalLink=Re;class Oe{constructor(W){this.uri=W}}e.TerminalQuickFixOpener=Oe;class Se{constructor(W){this.terminalCommand=W}}e.TerminalQuickFixCommand=Se;var se;(function(G){G[G.Panel=1]="Panel",G[G.Editor=2]="Editor"})(se=e.TerminalLocation||(e.TerminalLocation={}));class Ne{constructor(W){if(this.options=W,typeof W!="object")throw(0,t.illegalArgument)("options")}}e.TerminalProfile=Ne;var $e;(function(G){G[G.Always=1]="Always",G[G.Silent=2]="Silent",G[G.Never=3]="Never"})($e=e.TaskRevealKind||(e.TaskRevealKind={}));var Qe;(function(G){G[G.Shared=1]="Shared",G[G.Dedicated=2]="Dedicated",G[G.New=3]="New"})(Qe=e.TaskPanelKind||(e.TaskPanelKind={}));let Ve=k=class{static from(W){switch(W){case"clean":return k.Clean;case"build":return k.Build;case"rebuild":return k.Rebuild;case"test":return k.Test;default:return}}constructor(W,me){if(this.label=me,typeof W!="string"||typeof me!="string")throw(0,t.illegalArgument)("name");this.c=W}get id(){return this.c}};Ve.Clean=new k("clean","Clean"),Ve.Build=new k("build","Build"),Ve.Rebuild=new k("rebuild","Rebuild"),Ve.Test=new k("test","Test"),Ve=k=qe([N],Ve),e.TaskGroup=Ve;function tt(G){let W="";for(let me=0;me<G.length;me++)W+=G[me].replace(/,/g,",,")+",";return W}let St=class{constructor(W,me,Te){if(typeof W!="string")throw(0,t.illegalArgument)("process");this.e=[],this.c=W,me!==void 0&&(Array.isArray(me)?(this.e=me,this.f=Te):this.f=me)}get process(){return this.c}set process(W){if(typeof W!="string")throw(0,t.illegalArgument)("process");this.c=W}get args(){return this.e}set args(W){Array.isArray(W)||(W=[]),this.e=W}get options(){return this.f}set options(W){this.f=W}computeId(){const W=[];if(W.push("process"),this.c!==void 0&&W.push(this.c),this.e&&this.e.length>0)for(const me of this.e)W.push(me);return tt(W)}};St=qe([N],St),e.ProcessExecution=St;let Et=class{constructor(W,me,Te){if(this.f=[],Array.isArray(me)){if(!W)throw(0,t.illegalArgument)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,t.illegalArgument)("command");this.e=W,this.f=me,this.g=Te}else{if(typeof W!="string")throw(0,t.illegalArgument)("commandLine");this.c=W,this.g=me}}get commandLine(){return this.c}set commandLine(W){if(typeof W!="string")throw(0,t.illegalArgument)("commandLine");this.c=W}get command(){return this.e?this.e:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,t.illegalArgument)("command");this.e=W}get args(){return this.f}set args(W){this.f=W||[]}get options(){return this.g}set options(W){this.g=W}computeId(){const W=[];if(W.push("shell"),this.c!==void 0&&W.push(this.c),this.e!==void 0&&W.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const me of this.f)W.push(typeof me=="string"?me:me.value);return tt(W)}};Et=qe([N],Et),e.ShellExecution=Et;var Lt;(function(G){G[G.Escape=1]="Escape",G[G.Strong=2]="Strong",G[G.Weak=3]="Weak"})(Lt=e.ShellQuoting||(e.ShellQuoting={}));var vt;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace"})(vt=e.TaskScope||(e.TaskScope={}));class It{constructor(W){this.c=W}computeId(){return"customExecution"+(0,L.generateUuid)()}set callback(W){this.c=W}get callback(){return this.c}}e.CustomExecution=It;let ft=M=class{constructor(W,me,Te,Ke,Ye,ct){this.j=!1,this.k=this.definition=W;let dt;typeof me=="string"?(this.m=this.name=me,this.t=this.source=Te,this.execution=Ke,dt=Ye,this.j=!0):me===vt.Global||me===vt.Workspace?(this.target=me,this.m=this.name=Te,this.t=this.source=Ke,this.execution=Ye,dt=ct):(this.target=me,this.m=this.name=Te,this.t=this.source=Ke,this.execution=Ye,dt=ct),typeof dt=="string"?(this.o=[dt],this.q=!0):Array.isArray(dt)?(this.o=dt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(W){this.h=W}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof St?this.k={type:M.e,id:this.n.computeId()}:this.n instanceof Et?this.k={type:M.f,id:this.n.computeId()}:this.n instanceof It?this.k={type:M.c,id:this.n.computeId()}:this.k={type:M.g,id:(0,L.generateUuid)()}}get definition(){return this.k}set definition(W){if(W==null)throw(0,t.illegalArgument)("Kind can't be undefined or null");this.y(),this.k=W}get scope(){return this.l}set target(W){this.y(),this.l=W}get name(){return this.m}set name(W){if(typeof W!="string")throw(0,t.illegalArgument)("name");this.y(),this.m=W}get execution(){return this.n}set execution(W){W===null&&(W=void 0),this.y(),this.n=W;const me=this.k.type;(M.g===me||M.e===me||M.f===me||M.c===me)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(W){if(Array.isArray(W))this.y(),this.o=W,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.y(),this.r=W}get source(){return this.t}set source(W){if(typeof W!="string"||W.length===0)throw(0,t.illegalArgument)("source must be a string of length > 0");this.y(),this.t=W}get group(){return this.u}set group(W){W===null&&(W=void 0),this.y(),this.u=W}get detail(){return this.x}set detail(W){W===null&&(W=void 0),this.x=W}get presentationOptions(){return this.v}set presentationOptions(W){W==null&&(W=Object.create(null)),this.y(),this.v=W}get runOptions(){return this.w}set runOptions(W){W==null&&(W=Object.create(null)),this.y(),this.w=W}};ft.c="customExecution",ft.e="process",ft.f="shell",ft.g="$empty",ft=M=qe([N],ft),e.Task=ft;var Gt;(function(G){G[G.SourceControl=1]="SourceControl",G[G.Window=10]="Window",G[G.Notification=15]="Notification"})(Gt=e.ProgressLocation||(e.ProgressLocation={}));var jt;(function(G){function W(me){const Te=me;return(0,y.isNumber)(Te.value)?Te.tooltip&&!(0,y.isString)(Te.tooltip)?(console.log("INVALID view badge, invalid tooltip",Te.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Te.value),!1)}G.isViewBadge=W})(jt=e.ViewBadge||(e.ViewBadge={}));let yt=q=class{static isTreeItem(W,me){if(W instanceof q)return!0;const Te=W;if(Te.label!==void 0&&!(0,y.isString)(Te.label)&&!Te.label?.label)return console.log("INVALID tree item, invalid label",Te.label),!1;if(Te.id!==void 0&&!(0,y.isString)(Te.id))return console.log("INVALID tree item, invalid id",Te.id),!1;if(Te.iconPath!==void 0&&!(0,y.isString)(Te.iconPath)&&!D.URI.isUri(Te.iconPath)&&(!Te.iconPath||!(0,y.isString)(Te.iconPath.id))){const Ke=Te.iconPath;if(!Ke||!(0,y.isString)(Ke.light)&&!D.URI.isUri(Ke.light)&&!(0,y.isString)(Ke.dark)&&!D.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",Te.iconPath),!1}if(Te.description!==void 0&&!(0,y.isString)(Te.description)&&typeof Te.description!="boolean")return console.log("INVALID tree item, invalid description",Te.description),!1;if(Te.resourceUri!==void 0&&!D.URI.isUri(Te.resourceUri))return console.log("INVALID tree item, invalid resourceUri",Te.resourceUri),!1;if(Te.tooltip!==void 0&&!(0,y.isString)(Te.tooltip)&&!(Te.tooltip instanceof st))return console.log("INVALID tree item, invalid tooltip",Te.tooltip),!1;if(Te.command!==void 0&&!Te.command.command)return console.log("INVALID tree item, invalid command",Te.command),!1;if(Te.collapsibleState!==void 0&&Te.collapsibleState<_t.None&&Te.collapsibleState>_t.Expanded)return console.log("INVALID tree item, invalid collapsibleState",Te.collapsibleState),!1;if(Te.contextValue!==void 0&&!(0,y.isString)(Te.contextValue))return console.log("INVALID tree item, invalid contextValue",Te.contextValue),!1;if(Te.accessibilityInformation!==void 0&&!Te.accessibilityInformation?.label)return console.log("INVALID tree item, invalid accessibilityInformation",Te.accessibilityInformation),!1;if(Te.checkboxState!==void 0){(0,E.checkProposedApiEnabled)(me,"treeItemCheckbox");const Ke=(0,y.isNumber)(Te.checkboxState)?Te.checkboxState:(0,y.isObject)(Te.checkboxState)&&(0,y.isNumber)(Te.checkboxState.state)?Te.checkboxState.state:void 0,Ye=!(0,y.isNumber)(Te.checkboxState)&&(0,y.isObject)(Te.checkboxState)?Te.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==sn.Checked&&Ke!==sn.Unchecked||Ye!==void 0&&!(0,y.isString)(Ye))return console.log("INVALID tree item, invalid checkboxState",Te.checkboxState),!1}return!0}constructor(W,me=_t.None){this.collapsibleState=me,D.URI.isUri(W)?this.resourceUri=W:this.label=W}};yt=q=qe([N],yt),e.TreeItem=yt;var _t;(function(G){G[G.None=0]="None",G[G.Collapsed=1]="Collapsed",G[G.Expanded=2]="Expanded"})(_t=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var sn;(function(G){G[G.Unchecked=0]="Unchecked",G[G.Checked=1]="Checked"})(sn=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let en=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(W,me){this.value=W,this.id=me??(0,L.generateUuid)()}};en=qe([N],en),e.DataTransferItem=en;let vn=class{constructor(W){h.set(this,new Map);for(const[me,Te]of W??[]){const Ke=Ue(this,h,"f").get(me);Ke?Ke.push(Te):Ue(this,h,"f").set(me,[Te])}}get(W){return Ue(this,h,"f").get(W)?.[0]}set(W,me){Ue(this,h,"f").set(W,[me])}forEach(W,me){for(const[Te,Ke]of Ue(this,h,"f"))for(const Ye of Ke)W.call(me,Ye,Te,this)}*[(h=new WeakMap,Symbol.iterator)](){for(const[W,me]of Ue(this,h,"f"))for(const Te of me)yield[W,Te]}};vn=qe([N],vn),e.DataTransfer=vn;let At=class{constructor(W){this.insertText=W}};At=qe([N],At),e.DocumentDropEdit=At;let on=class{constructor(W){this.insertText=W}};on=qe([N],on),e.DocumentPasteEdit=on;let Vt=class{constructor(W,me){this.id=W,this.color=me}static isThemeIcon(W){return typeof W.id!="string"?(console.log("INVALID ThemeIcon, invalid id",W.id),!1):!0}};Vt=qe([N],Vt),e.ThemeIcon=Vt,Vt.File=new Vt("file"),Vt.Folder=new Vt("folder");let tn=class{constructor(W){this.id=W}};tn=qe([N],tn),e.ThemeColor=tn;var an;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace",G[G.WorkspaceFolder=3]="WorkspaceFolder"})(an=e.ConfigurationTarget||(e.ConfigurationTarget={}));let ut=class{get base(){return this.c}set base(W){this.c=W,this.e=D.URI.file(W)}get baseUri(){return this.e}set baseUri(W){this.e=W,this.c=W.fsPath}constructor(W,me){if(typeof W!="string"&&(!W||!D.URI.isUri(W)&&!D.URI.isUri(W.uri)))throw(0,t.illegalArgument)("base");if(typeof me!="string")throw(0,t.illegalArgument)("pattern");typeof W=="string"?this.baseUri=D.URI.file(W):D.URI.isUri(W)?this.baseUri=W:this.baseUri=W.uri,this.pattern=me}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};ut=qe([N],ut),e.RelativePattern=ut;const On=new WeakMap;function Qt(G,W){On.set(G,W)}e.setBreakpointId=Qt;let Wt=class{constructor(W,me,Te,Ke){this.enabled=typeof W=="boolean"?W:!0,typeof me=="string"&&(this.condition=me),typeof Te=="string"&&(this.hitCondition=Te),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this.c||(this.c=On.get(this)??(0,L.generateUuid)()),this.c}};Wt=qe([N],Wt),e.Breakpoint=Wt;let cn=class extends Wt{constructor(W,me,Te,Ke,Ye){if(super(me,Te,Ke,Ye),W===null)throw(0,t.illegalArgument)("location");this.location=W}};cn=qe([N],cn),e.SourceBreakpoint=cn;let En=class extends Wt{constructor(W,me,Te,Ke,Ye){super(me,Te,Ke,Ye),this.functionName=W}};En=qe([N],En),e.FunctionBreakpoint=En;let ln=class extends Wt{constructor(W,me,Te,Ke,Ye,ct,dt){if(super(Ke,Ye,ct,dt),!me)throw(0,t.illegalArgument)("dataId");this.label=W,this.dataId=me,this.canPersist=Te}};ln=qe([N],ln),e.DataBreakpoint=ln;let Sn=class{constructor(W,me,Te){this.command=W,this.args=me||[],this.options=Te}};Sn=qe([N],Sn),e.DebugAdapterExecutable=Sn;let un=class{constructor(W,me){this.port=W,this.host=me}};un=qe([N],un),e.DebugAdapterServer=un;let nn=class{constructor(W){this.path=W}};nn=qe([N],nn),e.DebugAdapterNamedPipeServer=nn;let yn=class{constructor(W){this.implementation=W}};yn=qe([N],yn),e.DebugAdapterInlineImplementation=yn;let rn=class{constructor(W,me){this.range=W,this.expression=me}};rn=qe([N],rn),e.EvaluatableExpression=rn;var Cn;(function(G){G[G.Invoke=0]="Invoke",G[G.Automatic=1]="Automatic"})(Cn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Dn=class{constructor(W,me){this.range=W,this.text=me}};Dn=qe([N],Dn),e.InlineValueText=Dn;let In=class{constructor(W,me,Te=!0){this.range=W,this.variableName=me,this.caseSensitiveLookup=Te}};In=qe([N],In),e.InlineValueVariableLookup=In;let Yt=class{constructor(W,me){this.range=W,this.expression=me}};Yt=qe([N],Yt),e.InlineValueEvaluatableExpression=Yt;let kn=class{constructor(W,me){this.frameId=W,this.stoppedLocation=me}};kn=qe([N],kn),e.InlineValueContext=kn;var zn;(function(G){G[G.Changed=1]="Changed",G[G.Created=2]="Created",G[G.Deleted=3]="Deleted"})(zn=e.FileChangeType||(e.FileChangeType={}));let Tn=V=class extends Error{static FileExists(W){return new V(W,P.FileSystemProviderErrorCode.FileExists,V.FileExists)}static FileNotFound(W){return new V(W,P.FileSystemProviderErrorCode.FileNotFound,V.FileNotFound)}static FileNotADirectory(W){return new V(W,P.FileSystemProviderErrorCode.FileNotADirectory,V.FileNotADirectory)}static FileIsADirectory(W){return new V(W,P.FileSystemProviderErrorCode.FileIsADirectory,V.FileIsADirectory)}static NoPermissions(W){return new V(W,P.FileSystemProviderErrorCode.NoPermissions,V.NoPermissions)}static Unavailable(W){return new V(W,P.FileSystemProviderErrorCode.Unavailable,V.Unavailable)}constructor(W,me=P.FileSystemProviderErrorCode.Unknown,Te){super(D.URI.isUri(W)?W.toString(!0):W),this.code=Te?.name??"Unknown",(0,P.markAsFileSystemProviderError)(this,me),Object.setPrototypeOf(this,V.prototype),typeof Error.captureStackTrace=="function"&&typeof Te=="function"&&Error.captureStackTrace(this,Te)}};Tn=V=qe([N],Tn),e.FileSystemError=Tn;let Pn=class{constructor(W,me,Te){this.start=W,this.end=me,this.kind=Te}};Pn=qe([N],Pn),e.FoldingRange=Pn;var $n;(function(G){G[G.Comment=1]="Comment",G[G.Imports=2]="Imports",G[G.Region=3]="Region"})($n=e.FoldingRangeKind||(e.FoldingRangeKind={}));var An;(function(G){G[G.Collapsed=0]="Collapsed",G[G.Expanded=1]="Expanded"})(An=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Nn;(function(G){G[G.Editing=0]="Editing",G[G.Preview=1]="Preview"})(Nn=e.CommentMode||(e.CommentMode={}));var Fn;(function(G){G[G.Unresolved=0]="Unresolved",G[G.Resolved=1]="Resolved"})(Fn=e.CommentThreadState||(e.CommentThreadState={}));class He{constructor(W,me=[]){this.tokenTypes=W,this.tokenModifiers=me}}e.SemanticTokensLegend=He;function Kt(G){return typeof G>"u"||(0,y.isStringArray)(G)}class dn{constructor(W){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,W){this.l=!0;for(let me=0,Te=W.tokenTypes.length;me<Te;me++)this.j.set(W.tokenTypes[me],me);for(let me=0,Te=W.tokenModifiers.length;me<Te;me++)this.k.set(W.tokenModifiers[me],me)}}push(W,me,Te,Ke,Ye){if(typeof W=="number"&&typeof me=="number"&&typeof Te=="number"&&typeof Ke=="number"&&(typeof Ye=="number"||typeof Ye>"u"))return typeof Ye>"u"&&(Ye=0),this.n(W,me,Te,Ke,Ye);if(_.isRange(W)&&typeof me=="string"&&Kt(Te))return this.m(W,me,Te);throw(0,t.illegalArgument)()}m(W,me,Te){if(!this.l)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(me))throw new Error("`tokenType` is not in the provided legend");const Ke=W.start.line,Ye=W.start.character,ct=W.end.character-W.start.character,dt=this.j.get(me);let Ot=0;if(Te)for(const Ht of Te){if(!this.k.has(Ht))throw new Error("`tokenModifier` is not in the provided legend");const qt=this.k.get(Ht);Ot|=1<<qt>>>0}this.n(Ke,Ye,ct,dt,Ot)}n(W,me,Te,Ke,Ye){if(this.f&&(W<this.c||W===this.c&&me<this.e)){this.f=!1;const Ot=this.g.length/5|0;let Ht=0,qt=0;for(let Xt=0;Xt<Ot;Xt++){let Jt=this.g[5*Xt],Rn=this.g[5*Xt+1];Jt===0?(Jt=Ht,Rn+=qt):Jt+=Ht,this.g[5*Xt]=Jt,this.g[5*Xt+1]=Rn,Ht=Jt,qt=Rn}}let ct=W,dt=me;this.f&&this.h>0&&(ct-=this.c,ct===0&&(dt-=this.e)),this.g[this.h++]=ct,this.g[this.h++]=dt,this.g[this.h++]=Te,this.g[this.h++]=Ke,this.g[this.h++]=Ye,this.c=W,this.e=me}static o(W){const me=[],Te=W.length/5|0;for(let dt=0;dt<Te;dt++)me[dt]=dt;me.sort((dt,Ot)=>{const Ht=W[5*dt],qt=W[5*Ot];if(Ht===qt){const Xt=W[5*dt+1],Jt=W[5*Ot+1];return Xt-Jt}return Ht-qt});const Ke=new Uint32Array(W.length);let Ye=0,ct=0;for(let dt=0;dt<Te;dt++){const Ot=5*me[dt],Ht=W[Ot+0],qt=W[Ot+1],Xt=W[Ot+2],Jt=W[Ot+3],Rn=W[Ot+4],ni=Ht-Ye,Ai=ni===0?qt-ct:qt,Ln=5*dt;Ke[Ln+0]=ni,Ke[Ln+1]=Ai,Ke[Ln+2]=Xt,Ke[Ln+3]=Jt,Ke[Ln+4]=Rn,Ye=Ht,ct=qt}return Ke}build(W){return this.f?new bt(new Uint32Array(this.g),W):new bt(dn.o(this.g),W)}}e.SemanticTokensBuilder=dn;class bt{constructor(W,me){this.resultId=me,this.data=W}}e.SemanticTokens=bt;class Wn{constructor(W,me,Te){this.start=W,this.deleteCount=me,this.data=Te}}e.SemanticTokensEdit=Wn;class Hn{constructor(W,me){this.resultId=me,this.edits=W}}e.SemanticTokensEdits=Hn;var Mn;(function(G){G[G.Separate=0]="Separate",G[G.MergeWithParent=1]="MergeWithParent"})(Mn=e.DebugConsoleMode||(e.DebugConsoleMode={}));let hn=class{constructor(){}};hn.Back={iconPath:new Vt("arrow-left")},hn=qe([N],hn),e.QuickInputButtons=hn;var fn;(function(G){G[G.Separator=-1]="Separator",G[G.Default=0]="Default"})(fn=e.QuickPickItemKind||(e.QuickPickItemKind={}));var jn;(function(G){G[G.Info=1]="Info",G[G.Warning=2]="Warning",G[G.Error=3]="Error"})(jn=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var Vn;(function(G){G[G.UI=1]="UI",G[G.Workspace=2]="Workspace"})(Vn=e.ExtensionKind||(e.ExtensionKind={}));class qn{static validate(W){if(typeof W.badge=="string"){let me=(0,A.nextCharLength)(W.badge,0);if(me<W.badge.length&&(me+=(0,A.nextCharLength)(W.badge,me)),W.badge.length>me)throw new Error("The 'badge'-property must be undefined or a short character")}else if(W.badge&&!Vt.isThemeIcon(W.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty");return!0}constructor(W,me,Te){this.badge=W,this.tooltip=me,this.color=Te}}e.FileDecoration=qn;let mn=class{constructor(W){this.kind=W}};mn=qe([N],mn),e.ColorTheme=mn;var Gn;(function(G){G[G.Light=1]="Light",G[G.Dark=2]="Dark",G[G.HighContrast=3]="HighContrast",G[G.HighContrastLight=4]="HighContrastLight"})(Gn=e.ColorThemeKind||(e.ColorThemeKind={}));class xt{static isNotebookRange(W){return W instanceof xt?!0:W?typeof W.start=="number"&&typeof W.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(W,me){if(W<0)throw(0,t.illegalArgument)("start must be positive");if(me<0)throw(0,t.illegalArgument)("end must be positive");W<=me?(this.c=W,this.e=me):(this.c=me,this.e=W)}with(W){let me=this.c,Te=this.e;return W.start!==void 0&&(me=W.start),W.end!==void 0&&(Te=W.end),me===this.c&&Te===this.e?this:new xt(me,Te)}}e.NotebookRange=xt;class gn{static validate(W){if(typeof W.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof W.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof W.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(W){return Array.isArray(W)&&W.every(me=>gn.isNotebookCellData(me))}static isNotebookCellData(W){return!0}constructor(W,me,Te,Ke,Ye,ct,dt){this.kind=W,this.value=me,this.languageId=Te,this.mime=Ke,this.outputs=Ye??[],this.metadata=ct,this.executionSummary=dt,gn.validate(this)}}e.NotebookCellData=gn;class Kn{constructor(W){this.cells=W}}e.NotebookData=Kn;class $t{static isNotebookCellOutputItem(W){return W instanceof $t?!0:W?typeof W.mime=="string"&&W.data instanceof Uint8Array:!1}static error(W){const me={name:W.name,message:W.message,stack:W.stack};return $t.json(me,"application/vnd.code.notebook.error")}static stdout(W){return $t.text(W,"application/vnd.code.notebook.stdout")}static stderr(W){return $t.text(W,"application/vnd.code.notebook.stderr")}static bytes(W,me="application/octet-stream"){return new $t(W,me)}static text(W,me=I.Mimes.text){const Te=Ue($t,b,"f",g).encode(String(W));return new $t(Te,me)}static json(W,me="text/x-json"){const Te=JSON.stringify(W,void 0,"	");return $t.text(Te,me)}constructor(W,me){this.data=W,this.mime=me;const Te=(0,I.normalizeMimeType)(me,!0);if(!Te)throw new Error(`INVALID mime type: ${me}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Te}}e.NotebookCellOutputItem=$t,b=$t,g={value:new TextEncoder};class pn{static isNotebookCellOutput(W){return W instanceof pn?!0:!W||typeof W!="object"?!1:typeof W.id=="string"&&Array.isArray(W.items)}static ensureUniqueMimeTypes(W,me=!1){const Te=new Set,Ke=new Set;for(let Ye=0;Ye<W.length;Ye++){const ct=W[Ye],dt=(0,I.normalizeMimeType)(ct.mime);if(!Te.has(dt)||(0,C.isTextStreamMime)(dt)){Te.add(dt);continue}Ke.add(Ye),me&&console.warn(`DUPLICATED mime type '${ct.mime}' will be dropped`)}return Ke.size===0?W:W.filter((Ye,ct)=>!Ke.has(ct))}constructor(W,me,Te){this.items=pn.ensureUniqueMimeTypes(W,!0),typeof me=="string"?(this.id=me,this.metadata=Te):(this.id=(0,L.generateUuid)(),this.metadata=me??Te)}}e.NotebookCellOutput=pn;var ge;(function(G){G[G.Markup=1]="Markup",G[G.Code=2]="Code"})(ge=e.NotebookCellKind||(e.NotebookCellKind={}));var ve;(function(G){G[G.Idle=1]="Idle",G[G.Pending=2]="Pending",G[G.Executing=3]="Executing"})(ve=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var ze;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(ze=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var at;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(at=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Ct{constructor(W,me){this.text=W,this.alignment=me}}e.NotebookCellStatusBarItem=Ct;var Rt;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred"})(Rt=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var oi;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred",G[G.Hidden=-1]="Hidden"})(oi=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class ai{constructor(W,me=[]){this.uri=W,this.provides=(0,o.asArray)(me)}}e.NotebookRendererScript=ai;class ci{constructor(W){this.label=W}}e.NotebookKernelSourceAction=ci;let xn=class{constructor(W,me){this.label=W,this.timestamp=me}};xn=qe([N],xn),e.TimelineItem=xn;var li;(function(G){G[G.Production=1]="Production",G[G.Development=2]="Development",G[G.Test=3]="Test"})(li=e.ExtensionMode||(e.ExtensionMode={}));var ui;(function(G){G[G.Node=1]="Node",G[G.Webworker=2]="Webworker"})(ui=e.ExtensionRuntime||(e.ExtensionRuntime={}));var di;(function(G){G[G.Other=0]="Other",G[G.Comment=1]="Comment",G[G.String=2]="String",G[G.RegEx=3]="RegEx"})(di=e.StandardTokenType||(e.StandardTokenType={}));class hi{constructor(W,me){this.ranges=W,this.wordPattern=me}}e.LinkedEditingRanges=hi;class fi{constructor(W,me){this.c=W,this.e=me}get port(){return this.c}get autoForwardAction(){return this.e}}e.PortAttributes=fi;var mi;(function(G){G[G.Queued=1]="Queued",G[G.Running=2]="Running",G[G.Passed=3]="Passed",G[G.Failed=4]="Failed",G[G.Skipped=5]="Skipped",G[G.Errored=6]="Errored"})(mi=e.TestResultState||(e.TestResultState={}));var gi;(function(G){G[G.Run=1]="Run",G[G.Debug=2]="Debug",G[G.Coverage=3]="Coverage"})(gi=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Xn=class{constructor(W=void 0,me=void 0,Te=void 0){this.include=W,this.exclude=me,this.profile=Te}};Xn=qe([N],Xn),e.TestRunRequest=Xn;let _n=F=class{static diff(W,me,Te){const Ke=new F(W);return Ke.expectedOutput=me,Ke.actualOutput=Te,Ke}constructor(W){this.message=W}};_n=F=qe([N],_n),e.TestMessage=_n;let Qn=class{constructor(W){this.id=W}};Qn=qe([N],Qn),e.TestTag=Qn;let bn=class{constructor(W,me){this.covered=W,this.total=me}};bn=qe([N],bn),e.CoveredCount=bn;let Yn=U=class{static fromDetails(W,me){const Te=new bn(0,0),Ke=new bn(0,0),Ye=new bn(0,0);for(const dt of me)if("branches"in dt){Te.total+=1,Te.covered+=dt.executionCount>0?1:0;for(const Ot of dt.branches)Ke.total+=1,Ke.covered+=Ot.executionCount>0?1:0}else Ye.total+=1,Ye.covered+=dt.executionCount>0?1:0;const ct=new U(W,Te,Ke.total>0?Ke:void 0,Ye.total>0?Ye:void 0);return ct.detailedCoverage=me,ct}constructor(W,me,Te,Ke){this.uri=W,this.statementCoverage=me,this.branchCoverage=Te,this.functionCoverage=Ke}};Yn=U=qe([N],Yn),e.FileCoverage=Yn;let Jn=class{constructor(W,me,Te=[]){this.executionCount=W,this.location=me,this.branches=Te}};Jn=qe([N],Jn),e.StatementCoverage=Jn;let Zn=class{constructor(W,me){this.executionCount=W,this.location=me}};Zn=qe([N],Zn),e.BranchCoverage=Zn;let ei=class{constructor(W,me){this.executionCount=W,this.location=me}};ei=qe([N],ei),e.FunctionCoverage=ei;var pi;(function(G){G[G.None=0]="None",G[G.Option=1]="Option",G[G.Default=2]="Default",G[G.Preferred=3]="Preferred"})(pi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var bi;(function(G){G[G.Untrusted=0]="Untrusted",G[G.Trusted=1]="Trusted",G[G.Unspecified=2]="Unspecified"})(bi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var wi;(function(G){G[G.Notify=1]="Notify",G[G.OpenBrowser=2]="OpenBrowser",G[G.OpenPreview=3]="OpenPreview",G[G.Silent=4]="Silent",G[G.Ignore=5]="Ignore",G[G.OpenBrowserOnce=6]="OpenBrowserOnce"})(wi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class vi{constructor(W,me,Te,Ke,Ye,ct){this.kind=W,this.name=me,this.detail=Te,this.uri=Ke,this.range=Ye,this.selectionRange=ct}}e.TypeHierarchyItem=vi;class Ei{constructor(W){this.uri=W}}e.TextTabInput=Ei;class Si{constructor(W,me){this.original=W,this.modified=me}}e.TextDiffTabInput=Si;class yi{constructor(W,me,Te,Ke){this.base=W,this.input1=me,this.input2=Te,this.result=Ke}}e.TextMergeTabInput=yi;class Ci{constructor(W,me){this.uri=W,this.viewType=me}}e.CustomEditorTabInput=Ci;class Di{constructor(W){this.viewType=W}}e.WebviewEditorTabInput=Di;class Ii{constructor(W,me){this.uri=W,this.notebookType=me}}e.NotebookEditorTabInput=Ii;class ki{constructor(W,me,Te){this.original=W,this.modified=me,this.notebookType=Te}}e.NotebookDiffEditorTabInput=ki;class Ti{constructor(){}}e.TerminalEditorTabInput=Ti;class Pi{constructor(W,me){this.uri=W,this.inputBoxUri=me}}e.InteractiveWindowInput=Pi}),define(ye[135],Ce([1,0,50,15,8,164,105,7,18]),function(te,e,o,t,T,R,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const D=new Map;function L(E,f){f?D.set(E,f):D.delete(E)}e.setWordDefinitionFor=L;function P(E){return D.get(E)}class v extends R.MirrorTextModel{constructor(f,d,h,b,g,p,w,i){super(d,h,b,g),this.m=f,this.p=p,this.q=w,this.notebook=i,this.b=!1}dispose(){(0,o.ok)(!this.b),this.b=!0,this.q=!1}equalLines(f){return(0,y.equals)(this.d,f)}get document(){if(!this.a){const f=this;this.a={get uri(){return f.c},get fileName(){return f.c.fsPath},get isUntitled(){return f.c.scheme===t.Schemas.untitled},get languageId(){return f.p},get version(){return f.g},get isClosed(){return f.b},get isDirty(){return f.q},save(){return f.r()},getText(d){return d?f.s(d):f.getText()},get eol(){return f.f===`
`?A.EndOfLine.LF:A.EndOfLine.CRLF},get lineCount(){return f.d.length},lineAt(d){return f.t(d)},offsetAt(d){return f.u(d)},positionAt(d){return f.v(d)},validateRange(d){return f.w(d)},validatePosition(d){return f.x(d)},getWordRangeAtPosition(d,h){return f.y(d,h)}}}return Object.freeze(this.a)}_acceptLanguageId(f){(0,o.ok)(!this.b),this.p=f}_acceptIsDirty(f){(0,o.ok)(!this.b),this.q=f}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.m.$trySaveDocument(this.c)}s(f){const d=this.w(f);if(d.isEmpty)return"";if(d.isSingleLine)return this.d[d.start.line].substring(d.start.character,d.end.character);const h=this.f,b=d.start.line,g=d.end.line,p=[];p.push(this.d[b].substring(d.start.character));for(let w=b+1;w<g;w++)p.push(this.d[w]);return p.push(this.d[g].substring(0,d.end.character)),p.join(h)}t(f){let d;if(f instanceof A.Position?d=f.line:typeof f=="number"&&(d=f),typeof d!="number"||d<0||d>=this.d.length||Math.floor(d)!==d)throw new Error("Illegal value for `line`");return new C(d,this.d[d],d===this.d.length-1)}u(f){return f=this.x(f),this.k(),this.h.getPrefixSum(f.line-1)+f.character}v(f){f=Math.floor(f),f=Math.max(0,f),this.k();const d=this.h.getIndexOf(f),h=this.d[d.index].length;return new A.Position(d.index,Math.min(d.remainder,h))}w(f){if(!(f instanceof A.Range))throw new Error("Invalid argument");const d=this.x(f.start),h=this.x(f.end);return d===f.start&&h===f.end?f:new A.Range(d.line,d.character,h.line,h.character)}x(f){if(!(f instanceof A.Position))throw new Error("Invalid argument");if(this.d.length===0)return f.with(0,0);let{line:d,character:h}=f,b=!1;if(d<0)d=0,h=0,b=!0;else if(d>=this.d.length)d=this.d.length-1,h=this.d[d].length,b=!0;else{const g=this.d[d].length;h<0?(h=0,b=!0):h>g&&(h=g,b=!0)}return b?new A.Position(d,h):f}y(f,d){const h=this.x(f);if(!d)d=P(this.p);else if((0,T.regExpLeadsToEndlessLoop)(d))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${d.source}' because it matches the empty string.`);const b=(0,I.getWordAtText)(h.character+1,(0,I.ensureValidWordDefinition)(d),this.d[h.line],0);if(b)return new A.Range(h.line,b.startColumn-1,h.line,b.endColumn-1)}}e.ExtHostDocumentData=v;class C{constructor(f,d,h){this.a=f,this.b=d,this.c=h}get lineNumber(){return this.a}get text(){return this.b}get range(){return new A.Range(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new A.Range(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.ExtHostDocumentLine=C}),define(ye[233],Ce([1,0,7,17,3]),function(te,e,o,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let R=class{constructor(A){this.a=new o.ColorTheme(o.ColorThemeKind.Dark),this.b=new T.Emitter}get activeColorTheme(){return this.a}$onColorThemeChange(A){let y;switch(A){case"light":y=o.ColorThemeKind.Light;break;case"hcDark":y=o.ColorThemeKind.HighContrast;break;case"hcLight":y=o.ColorThemeKind.HighContrastLight;break;default:y=o.ColorThemeKind.Dark}this.a=new o.ColorTheme(y),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};R=qe([We(0,t.IExtHostRpcService)],R),e.ExtHostTheming=R}),define(ye[14],Ce([1,0,18,22,148,61,111,28,147,86,84,23,11,2,35,66,123,132,130,91,56,70,228,7]),function(te,e,o,t,T,R,I,A,y,D,L,P,v,C,E,f,d,h,b,g,p,w,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var a;(function(Re){function Oe(se){const{selectionStartLineNumber:Ne,selectionStartColumn:$e,positionLineNumber:Qe,positionColumn:Ve}=se,tt=new s.Position(Ne-1,$e-1),St=new s.Position(Qe-1,Ve-1);return new s.Selection(tt,St)}Re.to=Oe;function Se(se){const{anchor:Ne,active:$e}=se;return{selectionStartLineNumber:Ne.line+1,selectionStartColumn:Ne.character+1,positionLineNumber:$e.line+1,positionColumn:$e.character+1}}Re.from=Se})(a=e.Selection||(e.Selection={}));var u;(function(Re){function Oe(se){if(!se)return;const{start:Ne,end:$e}=se;return{startLineNumber:Ne.line+1,startColumn:Ne.character+1,endLineNumber:$e.line+1,endColumn:$e.character+1}}Re.from=Oe;function Se(se){if(!se)return;const{startLineNumber:Ne,startColumn:$e,endLineNumber:Qe,endColumn:Ve}=se;return new s.Range(Ne-1,$e-1,Qe-1,Ve-1)}Re.to=Se})(u=e.Range||(e.Range={}));var l;(function(Re){function Oe(Se){switch(Se){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}Re.to=Oe})(l=e.TokenType||(e.TokenType={}));var c;(function(Re){function Oe(se){return new s.Position(se.lineNumber-1,se.column-1)}Re.to=Oe;function Se(se){return{lineNumber:se.line+1,column:se.character+1}}Re.from=Se})(c=e.Position||(e.Position={}));var n;(function(Re){function Oe(Ne,$e){return(0,o.coalesce)((0,o.asArray)(Ne).map(Qe=>Se(Qe,$e)))}Re.from=Oe;function Se(Ne,$e){if(typeof Ne=="string")return{$serialized:!0,language:Ne};if(Ne)return{$serialized:!0,language:Ne.language,scheme:se(Ne.scheme,$e),pattern:$.from(Ne.pattern)??void 0,exclusive:Ne.exclusive,notebookType:Ne.notebookType}}function se(Ne,$e){return $e&&typeof Ne=="string"?$e.transformOutgoingScheme(Ne):Ne}})(n=e.DocumentSelector||(e.DocumentSelector={}));var r;(function(Re){function Oe(se){switch(se){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}Re.from=Oe;function Se(se){switch(se){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}Re.to=Se})(r=e.DiagnosticTag||(e.DiagnosticTag={}));var m;(function(Re){function Oe(se){let Ne;return se.code&&((0,v.isString)(se.code)||(0,v.isNumber)(se.code)?Ne=String(se.code):Ne={value:String(se.code.value),target:se.code.target}),{...u.from(se.range),message:se.message,source:se.source,code:Ne,severity:k.from(se.severity),relatedInformation:se.relatedInformation&&se.relatedInformation.map(S.from),tags:Array.isArray(se.tags)?(0,o.coalesce)(se.tags.map(r.from)):void 0}}Re.from=Oe;function Se(se){const Ne=new s.Diagnostic(u.to(se),se.message,k.to(se.severity));return Ne.source=se.source,Ne.code=(0,v.isString)(se.code)?se.code:se.code?.value,Ne.relatedInformation=se.relatedInformation&&se.relatedInformation.map(S.to),Ne.tags=se.tags&&(0,o.coalesce)(se.tags.map(r.to)),Ne}Re.to=Se})(m=e.Diagnostic||(e.Diagnostic={}));var S;(function(Re){function Oe(se){return{...u.from(se.location.range),message:se.message,resource:se.location.uri}}Re.from=Oe;function Se(se){return new s.DiagnosticRelatedInformation(new s.Location(se.resource,u.to(se)),se.message)}Re.to=Se})(S=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var k;(function(Re){function Oe(se){switch(se){case s.DiagnosticSeverity.Error:return d.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return d.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return d.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return d.MarkerSeverity.Hint}return d.MarkerSeverity.Error}Re.from=Oe;function Se(se){switch(se){case d.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case d.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case d.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case d.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}Re.to=Se})(k=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var M;(function(Re){function Oe(se){return typeof se=="number"&&se>=s.ViewColumn.One?se-1:se===s.ViewColumn.Beside?i.SIDE_GROUP:i.ACTIVE_GROUP}Re.from=Oe;function Se(se){if(typeof se=="number"&&se>=0)return se+1;throw new Error("invalid 'EditorGroupColumn'")}Re.to=Se})(M=e.ViewColumn||(e.ViewColumn={}));function q(Re){return typeof Re.range<"u"}function V(Re){return Re.length===0?!0:!!q(Re[0])}e.isDecorationOptionsArr=V;var F;(function(Re){function Oe(Ve){return Ve.map(Re.from)}Re.fromMany=Oe;function Se(Ve){return Ve&&typeof Ve=="object"&&typeof Ve.language=="string"&&typeof Ve.value=="string"}function se(Ve){let tt;if(Se(Ve)){const{language:vt,value:It}=Ve;tt={value:"```"+vt+`
`+It+"\n```\n"}}else s.MarkdownString.isMarkdownString(Ve)?tt={value:Ve.value,isTrusted:Ve.isTrusted,supportThemeIcons:Ve.supportThemeIcons,supportHtml:Ve.supportHtml,baseUri:Ve.baseUri}:typeof Ve=="string"?tt={value:Ve}:tt={value:""};const St=Object.create(null);tt.uris=St;const Et=vt=>{try{let It=C.URI.parse(vt,!0);It=It.with({query:Ne(It.query,St)}),St[vt]=It}catch{}return""},Lt=new y.marked.Renderer;return Lt.link=Et,Lt.image=vt=>typeof vt=="string"?Et(I.parseHrefAndDimensions(vt).href):"",(0,y.marked)(tt.value,{renderer:Lt}),tt}Re.from=se;function Ne(Ve,tt){if(!Ve)return Ve;let St;try{St=(0,D.parse)(Ve)}catch{}if(!St)return Ve;let Et=!1;return St=(0,P.cloneAndChange)(St,Lt=>{if(C.URI.isUri(Lt)){const vt=`__uri_${Math.random().toString(16).slice(2,8)}`;return tt[vt]=Lt,Et=!0,vt}else return}),Et?JSON.stringify(St):Ve}function $e(Ve){const tt=new s.MarkdownString(Ve.value,Ve.supportThemeIcons);return tt.isTrusted=Ve.isTrusted,tt.supportHtml=Ve.supportHtml,tt.baseUri=Ve.baseUri?C.URI.from(Ve.baseUri):void 0,tt}Re.to=$e;function Qe(Ve){if(!!Ve)return typeof Ve=="string"?Ve:Re.from(Ve)}Re.fromStrict=Qe})(F=e.MarkdownString||(e.MarkdownString={}));function U(Re){return V(Re)?Re.map(Oe=>({range:u.from(Oe.range),hoverMessage:Array.isArray(Oe.hoverMessage)?F.fromMany(Oe.hoverMessage):Oe.hoverMessage?F.from(Oe.hoverMessage):void 0,renderOptions:Oe.renderOptions})):Re.map(Oe=>({range:u.from(Oe)}))}e.fromRangeOrRangeWithMessage=U;function N(Re){return typeof Re>"u"?Re:typeof Re=="string"?C.URI.file(Re):Re}e.pathOrURIToURI=N;var B;(function(Re){function Oe(Se){return typeof Se>"u"?Se:{contentText:Se.contentText,contentIconPath:Se.contentIconPath?N(Se.contentIconPath):void 0,border:Se.border,borderColor:Se.borderColor,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,color:Se.color,backgroundColor:Se.backgroundColor,margin:Se.margin,width:Se.width,height:Se.height}}Re.from=Oe})(B=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var j;(function(Re){function Oe(Se){return typeof Se>"u"?Se:{backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?N(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?B.from(Se.before):void 0,after:Se.after?B.from(Se.after):void 0}}Re.from=Oe})(j=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var z;(function(Re){function Oe(Se){if(typeof Se>"u")return Se;switch(Se){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}Re.from=Oe})(z=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var ne;(function(Re){function Oe(Se){return{isWholeLine:Se.isWholeLine,rangeBehavior:Se.rangeBehavior?z.from(Se.rangeBehavior):void 0,overviewRulerLane:Se.overviewRulerLane,light:Se.light?j.from(Se.light):void 0,dark:Se.dark?j.from(Se.dark):void 0,backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?N(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?B.from(Se.before):void 0,after:Se.after?B.from(Se.after):void 0}}Re.from=Oe})(ne=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var _;(function(Re){function Oe(se){return{text:se.newText,eol:se.newEol&&st.from(se.newEol),range:u.from(se.range)}}Re.from=Oe;function Se(se){const Ne=new s.TextEdit(u.to(se.range),se.text);return Ne.newEol=typeof se.eol>"u"?void 0:st.to(se.eol),Ne}Re.to=Se})(_=e.TextEdit||(e.TextEdit={}));var Y;(function(Re){function Oe(se,Ne){const $e={edits:[]};if(se instanceof s.WorkspaceEdit){const Qe=new A.ResourceSet;for(const Ve of se._allEntries())Ve._type===1&&C.URI.isUri(Ve.to)&&Ve.from===void 0&&Qe.add(Ve.to);for(const Ve of se._allEntries())Ve._type===1?$e.edits.push({oldResource:Ve.from,newResource:Ve.to,options:{...Ve.options,contentsBase64:Ve.options?.contents&&(0,t.encodeBase64)(t.VSBuffer.wrap(Ve.options.contents))},metadata:Ve.metadata}):Ve._type===2?$e.edits.push({resource:Ve.uri,textEdit:_.from(Ve.edit),versionId:Qe.has(Ve.uri)?void 0:Ne?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===6?$e.edits.push({resource:Ve.uri,textEdit:{range:u.from(Ve.range),text:Ve.edit.value,insertAsSnippet:!0},versionId:Qe.has(Ve.uri)?void 0:Ne?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===3?$e.edits.push({metadata:Ve.metadata,resource:Ve.uri,cellEdit:Ve.edit,notebookMetadata:Ve.notebookMetadata,notebookVersionId:Ne?.getNotebookDocumentVersion(Ve.uri)}):Ve._type===5&&$e.edits.push({metadata:Ve.metadata,resource:Ve.uri,notebookVersionId:Ne?.getNotebookDocumentVersion(Ve.uri),cellEdit:{editType:1,index:Ve.index,count:Ve.count,cells:Ve.cells.map(gt.from)}})}return $e}Re.from=Oe;function Se(se){const Ne=new s.WorkspaceEdit;for(const $e of se.edits)$e.textEdit?Ne.replace(C.URI.revive($e.resource),u.to($e.textEdit.range),$e.textEdit.text):Ne.renameFile(C.URI.revive($e.oldResource),C.URI.revive($e.newResource),$e.options);return Ne}Re.to=Se})(Y=e.WorkspaceEdit||(e.WorkspaceEdit={}));var J;(function(Re){const Oe=Object.create(null);Oe[s.SymbolKind.File]=0,Oe[s.SymbolKind.Module]=1,Oe[s.SymbolKind.Namespace]=2,Oe[s.SymbolKind.Package]=3,Oe[s.SymbolKind.Class]=4,Oe[s.SymbolKind.Method]=5,Oe[s.SymbolKind.Property]=6,Oe[s.SymbolKind.Field]=7,Oe[s.SymbolKind.Constructor]=8,Oe[s.SymbolKind.Enum]=9,Oe[s.SymbolKind.Interface]=10,Oe[s.SymbolKind.Function]=11,Oe[s.SymbolKind.Variable]=12,Oe[s.SymbolKind.Constant]=13,Oe[s.SymbolKind.String]=14,Oe[s.SymbolKind.Number]=15,Oe[s.SymbolKind.Boolean]=16,Oe[s.SymbolKind.Array]=17,Oe[s.SymbolKind.Object]=18,Oe[s.SymbolKind.Key]=19,Oe[s.SymbolKind.Null]=20,Oe[s.SymbolKind.EnumMember]=21,Oe[s.SymbolKind.Struct]=22,Oe[s.SymbolKind.Event]=23,Oe[s.SymbolKind.Operator]=24,Oe[s.SymbolKind.TypeParameter]=25;function Se(Ne){return typeof Oe[Ne]=="number"?Oe[Ne]:6}Re.from=Se;function se(Ne){for(const $e in Oe)if(Oe[$e]===Ne)return Number($e);return s.SymbolKind.Property}Re.to=se})(J=e.SymbolKind||(e.SymbolKind={}));var Z;(function(Re){function Oe(se){switch(se){case s.SymbolTag.Deprecated:return 1}}Re.from=Oe;function Se(se){switch(se){case 1:return s.SymbolTag.Deprecated}}Re.to=Se})(Z=e.SymbolTag||(e.SymbolTag={}));var ie;(function(Re){function Oe(se){return{name:se.name,kind:J.from(se.kind),tags:se.tags&&se.tags.map(Z.from),containerName:se.containerName,location:Ee.from(se.location)}}Re.from=Oe;function Se(se){const Ne=new s.SymbolInformation(se.name,J.to(se.kind),se.containerName,Ee.to(se.location));return Ne.tags=se.tags&&se.tags.map(Z.to),Ne}Re.to=Se})(ie=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var X;(function(Re){function Oe(se){const Ne={name:se.name||"!!MISSING: name!!",detail:se.detail,range:u.from(se.range),selectionRange:u.from(se.selectionRange),kind:J.from(se.kind),tags:se.tags?.map(Z.from)??[]};return se.children&&(Ne.children=se.children.map(Oe)),Ne}Re.from=Oe;function Se(se){const Ne=new s.DocumentSymbol(se.name,se.detail,J.to(se.kind),u.to(se.range),u.to(se.selectionRange));return(0,o.isNonEmptyArray)(se.tags)&&(Ne.tags=se.tags.map(Z.to)),se.children&&(Ne.children=se.children.map(Se)),Ne}Re.to=Se})(X=e.DocumentSymbol||(e.DocumentSymbol={}));var K;(function(Re){function Oe(se){const Ne=new s.CallHierarchyItem(J.to(se.kind),se.name,se.detail||"",C.URI.revive(se.uri),u.to(se.range),u.to(se.selectionRange));return Ne._sessionId=se._sessionId,Ne._itemId=se._itemId,Ne}Re.to=Oe;function Se(se,Ne,$e){if(Ne=Ne??se._sessionId,$e=$e??se._itemId,Ne===void 0||$e===void 0)throw new Error("invalid item");return{_sessionId:Ne,_itemId:$e,name:se.name,detail:se.detail,kind:J.from(se.kind),uri:se.uri,range:u.from(se.range),selectionRange:u.from(se.selectionRange),tags:se.tags?.map(Z.from)}}Re.from=Se})(K=e.CallHierarchyItem||(e.CallHierarchyItem={}));var he;(function(Re){function Oe(Se){return new s.CallHierarchyIncomingCall(K.to(Se.from),Se.fromRanges.map(se=>u.to(se)))}Re.to=Oe})(he=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var be;(function(Re){function Oe(Se){return new s.CallHierarchyOutgoingCall(K.to(Se.to),Se.fromRanges.map(se=>u.to(se)))}Re.to=Oe})(be=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var Ee;(function(Re){function Oe(se){return{range:se.range&&u.from(se.range),uri:se.uri}}Re.from=Oe;function Se(se){return new s.Location(C.URI.revive(se.uri),u.to(se.range))}Re.to=Se})(Ee=e.location||(e.location={}));var Pe;(function(Re){function Oe(se){const Ne=se,$e=se;return{originSelectionRange:Ne.originSelectionRange?u.from(Ne.originSelectionRange):void 0,uri:Ne.targetUri?Ne.targetUri:$e.uri,range:u.from(Ne.targetRange?Ne.targetRange:$e.range),targetSelectionRange:Ne.targetSelectionRange?u.from(Ne.targetSelectionRange):void 0}}Re.from=Oe;function Se(se){return{targetUri:C.URI.revive(se.uri),targetRange:u.to(se.range),targetSelectionRange:se.targetSelectionRange?u.to(se.targetSelectionRange):void 0,originSelectionRange:se.originSelectionRange?u.to(se.originSelectionRange):void 0}}Re.to=Se})(Pe=e.DefinitionLink||(e.DefinitionLink={}));var Me;(function(Re){function Oe(se){return{range:u.from(se.range),contents:F.fromMany(se.contents)}}Re.from=Oe;function Se(se){return new s.Hover(se.contents.map(F.to),u.to(se.range))}Re.to=Se})(Me=e.Hover||(e.Hover={}));var oe;(function(Re){function Oe(se){return{range:u.from(se.range),expression:se.expression}}Re.from=Oe;function Se(se){return new s.EvaluatableExpression(u.to(se.range),se.expression)}Re.to=Se})(oe=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ae;(function(Re){function Oe(se){if(se instanceof s.InlineValueText)return{type:"text",range:u.from(se.range),text:se.text};if(se instanceof s.InlineValueVariableLookup)return{type:"variable",range:u.from(se.range),variableName:se.variableName,caseSensitiveLookup:se.caseSensitiveLookup};if(se instanceof s.InlineValueEvaluatableExpression)return{type:"expression",range:u.from(se.range),expression:se.expression};throw new Error("Unknown 'InlineValue' type")}Re.from=Oe;function Se(se){switch(se.type){case"text":return{range:u.to(se.range),text:se.text};case"variable":return{range:u.to(se.range),variableName:se.variableName,caseSensitiveLookup:se.caseSensitiveLookup};case"expression":return{range:u.to(se.range),expression:se.expression}}}Re.to=Se})(ae=e.InlineValue||(e.InlineValue={}));var fe;(function(Re){function Oe(se){return{frameId:se.frameId,stoppedLocation:u.from(se.stoppedLocation)}}Re.from=Oe;function Se(se){return new s.InlineValueContext(se.frameId,u.to(se.stoppedLocation))}Re.to=Se})(fe=e.InlineValueContext||(e.InlineValueContext={}));var ee;(function(Re){function Oe(se){return{range:u.from(se.range),kind:se.kind}}Re.from=Oe;function Se(se){return new s.DocumentHighlight(u.to(se.range),se.kind)}Re.to=Se})(ee=e.DocumentHighlight||(e.DocumentHighlight={}));var le;(function(Re){function Oe(Se){switch(Se){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}Re.to=Oe})(le=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var re;(function(Re){function Oe(Se){return{triggerKind:le.to(Se.triggerKind),triggerCharacter:Se.triggerCharacter}}Re.to=Oe})(re=e.CompletionContext||(e.CompletionContext={}));var O;(function(Re){function Oe(se){switch(se){case s.CompletionItemTag.Deprecated:return 1}}Re.from=Oe;function Se(se){switch(se){case 1:return s.CompletionItemTag.Deprecated}}Re.to=Se})(O=e.CompletionItemTag||(e.CompletionItemTag={}));var H;(function(Re){const Oe=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function Se($e){return Oe.get($e)??9}Re.from=Se;const se=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Ne($e){return se.get($e)??s.CompletionItemKind.Property}Re.to=Ne})(H=e.CompletionItemKind||(e.CompletionItemKind={}));var x;(function(Re){function Oe(Se,se){const Ne=new s.CompletionItem(Se.label);return Ne.insertText=Se.insertText,Ne.kind=H.to(Se.kind),Ne.tags=Se.tags?.map(O.to),Ne.detail=Se.detail,Ne.documentation=I.isMarkdownString(Se.documentation)?F.to(Se.documentation):Se.documentation,Ne.sortText=Se.sortText,Ne.filterText=Se.filterText,Ne.preselect=Se.preselect,Ne.commitCharacters=Se.commitCharacters,E.Range.isIRange(Se.range)?Ne.range=u.to(Se.range):typeof Se.range=="object"&&(Ne.range={inserting:u.to(Se.range.insert),replacing:u.to(Se.range.replace)}),Ne.keepWhitespace=typeof Se.insertTextRules>"u"?!1:Boolean(Se.insertTextRules&1),typeof Se.insertTextRules<"u"&&Se.insertTextRules&4?Ne.insertText=new s.SnippetString(Se.insertText):(Ne.insertText=Se.insertText,Ne.textEdit=Ne.range instanceof s.Range?new s.TextEdit(Ne.range,Ne.insertText):void 0),Se.additionalTextEdits&&Se.additionalTextEdits.length>0&&(Ne.additionalTextEdits=Se.additionalTextEdits.map($e=>_.to($e))),Ne.command=se&&Se.command?se.fromInternal(Se.command):void 0,Ne}Re.to=Oe})(x=e.CompletionItem||(e.CompletionItem={}));var Q;(function(Re){function Oe(se){if(typeof se.label!="string"&&!Array.isArray(se.label))throw new TypeError("Invalid label");return{label:se.label,documentation:F.fromStrict(se.documentation)}}Re.from=Oe;function Se(se){return{label:se.label,documentation:I.isMarkdownString(se.documentation)?F.to(se.documentation):se.documentation}}Re.to=Se})(Q=e.ParameterInformation||(e.ParameterInformation={}));var de;(function(Re){function Oe(se){return{label:se.label,documentation:F.fromStrict(se.documentation),parameters:Array.isArray(se.parameters)?se.parameters.map(Q.from):[],activeParameter:se.activeParameter}}Re.from=Oe;function Se(se){return{label:se.label,documentation:I.isMarkdownString(se.documentation)?F.to(se.documentation):se.documentation,parameters:Array.isArray(se.parameters)?se.parameters.map(Q.to):[],activeParameter:se.activeParameter}}Re.to=Se})(de=e.SignatureInformation||(e.SignatureInformation={}));var we;(function(Re){function Oe(se){return{activeSignature:se.activeSignature,activeParameter:se.activeParameter,signatures:Array.isArray(se.signatures)?se.signatures.map(de.from):[]}}Re.from=Oe;function Se(se){return{activeSignature:se.activeSignature,activeParameter:se.activeParameter,signatures:Array.isArray(se.signatures)?se.signatures.map(de.to):[]}}Re.to=Se})(we=e.SignatureHelp||(e.SignatureHelp={}));var Ae;(function(Re){function Oe(Se,se){const Ne=new s.InlayHint(c.to(se.position),typeof se.label=="string"?se.label:se.label.map(pe.to.bind(void 0,Se)),se.kind&&De.to(se.kind));return Ne.textEdits=se.textEdits&&se.textEdits.map(_.to),Ne.tooltip=I.isMarkdownString(se.tooltip)?F.to(se.tooltip):se.tooltip,Ne.paddingLeft=se.paddingLeft,Ne.paddingRight=se.paddingRight,Ne}Re.to=Oe})(Ae=e.InlayHint||(e.InlayHint={}));var pe;(function(Re){function Oe(Se,se){const Ne=new s.InlayHintLabelPart(se.label);return Ne.tooltip=I.isMarkdownString(se.tooltip)?F.to(se.tooltip):se.tooltip,f.Command.is(se.command)&&(Ne.command=Se.fromInternal(se.command)),se.location&&(Ne.location=Ee.to(se.location)),Ne}Re.to=Oe})(pe=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var De;(function(Re){function Oe(se){return se}Re.from=Oe;function Se(se){return se}Re.to=Se})(De=e.InlayHintKind||(e.InlayHintKind={}));var ke;(function(Re){function Oe(se){return{range:u.from(se.range),url:se.target,tooltip:se.tooltip}}Re.from=Oe;function Se(se){let Ne;if(se.url)try{Ne=typeof se.url=="string"?C.URI.parse(se.url,!0):C.URI.revive(se.url)}catch{}return new s.DocumentLink(u.to(se.range),Ne)}Re.to=Se})(ke=e.DocumentLink||(e.DocumentLink={}));var je;(function(Re){function Oe(se){const Ne=new s.ColorPresentation(se.label);return se.textEdit&&(Ne.textEdit=_.to(se.textEdit)),se.additionalTextEdits&&(Ne.additionalTextEdits=se.additionalTextEdits.map($e=>_.to($e))),Ne}Re.to=Oe;function Se(se){return{label:se.label,textEdit:se.textEdit?_.from(se.textEdit):void 0,additionalTextEdits:se.additionalTextEdits?se.additionalTextEdits.map(Ne=>_.from(Ne)):void 0}}Re.from=Se})(je=e.ColorPresentation||(e.ColorPresentation={}));var Ge;(function(Re){function Oe(se){return new s.Color(se[0],se[1],se[2],se[3])}Re.to=Oe;function Se(se){return[se.red,se.green,se.blue,se.alpha]}Re.from=Se})(Ge=e.Color||(e.Color={}));var et;(function(Re){function Oe(se){return{range:u.from(se.range)}}Re.from=Oe;function Se(se){return new s.SelectionRange(u.to(se.range))}Re.to=Se})(et=e.SelectionRange||(e.SelectionRange={}));var _e;(function(Re){function Oe(Se){switch(Se){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}Re.to=Oe})(_e=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var nt;(function(Re){function Oe(se){switch(se){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.On:default:return 1}}Re.from=Oe;function Se(se){switch(se){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 1:default:return s.TextEditorLineNumbersStyle.On}}Re.to=Se})(nt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var st;(function(Re){function Oe(se){if(se===s.EndOfLine.CRLF)return 1;if(se===s.EndOfLine.LF)return 0}Re.from=Oe;function Se(se){if(se===1)return s.EndOfLine.CRLF;if(se===0)return s.EndOfLine.LF}Re.to=Se})(st=e.EndOfLine||(e.EndOfLine={}));var ht;(function(Re){function Oe(Se){if(typeof Se=="object")return Se.viewId;switch(Se){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Re.from=Oe})(ht=e.ProgressLocation||(e.ProgressLocation={}));var Fe;(function(Re){function Oe(Se){const se={start:Se.start+1,end:Se.end+1};return Se.kind&&(se.kind=it.from(Se.kind)),se}Re.from=Oe})(Fe=e.FoldingRange||(e.FoldingRange={}));var it;(function(Re){function Oe(Se){if(Se)switch(Se){case s.FoldingRangeKind.Comment:return f.FoldingRangeKind.Comment;case s.FoldingRangeKind.Imports:return f.FoldingRangeKind.Imports;case s.FoldingRangeKind.Region:return f.FoldingRangeKind.Region}}Re.from=Oe})(it=e.FoldingRangeKind||(e.FoldingRangeKind={}));var ce;(function(Re){function Oe(Se){if(Se)return{pinned:typeof Se.preview=="boolean"?!Se.preview:void 0,inactive:Se.background,preserveFocus:Se.preserveFocus,selection:typeof Se.selection=="object"?u.from(Se.selection):void 0,override:typeof Se.override=="boolean"?b.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Re.from=Oe})(ce=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var $;(function(Re){function Oe($e){return $e instanceof s.RelativePattern?$e.toJSON():typeof $e=="string"?$e:Se($e)||se($e)?new s.RelativePattern($e.baseUri??$e.base,$e.pattern).toJSON():$e}Re.from=Oe;function Se($e){const Qe=$e;return Qe?C.URI.isUri(Qe.baseUri)&&typeof Qe.pattern=="string":!1}function se($e){const Qe=$e;return Qe?typeof Qe.base=="string"&&typeof Qe.pattern=="string":!1}function Ne($e){return typeof $e=="string"?$e:new s.RelativePattern(C.URI.revive($e.baseUri),$e.pattern)}Re.to=Ne})($=e.GlobPattern||(e.GlobPattern={}));var ue;(function(Re){function Oe(Se){if(Se){if(Array.isArray(Se))return Se.map(Oe);if(typeof Se=="string")return Se;{const se=Se;return{language:se.language,scheme:se.scheme,pattern:$.from(se.pattern),exclusive:se.exclusive,notebookType:se.notebookType}}}else return}Re.from=Oe})(ue=e.LanguageSelector||(e.LanguageSelector={}));var Ie;(function(Re){function Oe(se){return{start:se.start,end:se.end}}Re.from=Oe;function Se(se){return new s.NotebookRange(se.start,se.end)}Re.to=Se})(Ie=e.NotebookRange||(e.NotebookRange={}));var Le;(function(Re){function Oe(se){return{timing:typeof se.runStartTime=="number"&&typeof se.runEndTime=="number"?{startTime:se.runStartTime,endTime:se.runEndTime}:void 0,executionOrder:se.executionOrder,success:se.lastRunSuccess}}Re.to=Oe;function Se(se){return{lastRunSuccess:se.success,runStartTime:se.timing?.startTime,runEndTime:se.timing?.endTime,executionOrder:se.executionOrder}}Re.from=Se})(Le=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Be;(function(Re){function Oe(Se){if(Se===g.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if(Se===g.NotebookCellExecutionState.Pending)return;if(Se===g.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Se}`)}Re.to=Oe})(Be=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var xe;(function(Re){function Oe(se){switch(se){case s.NotebookCellKind.Markup:return g.CellKind.Markup;case s.NotebookCellKind.Code:default:return g.CellKind.Code}}Re.from=Oe;function Se(se){switch(se){case g.CellKind.Markup:return s.NotebookCellKind.Markup;case g.CellKind.Code:default:return s.NotebookCellKind.Code}}Re.to=Se})(xe=e.NotebookCellKind||(e.NotebookCellKind={}));var Ze;(function(Re){function Oe(se){const Ne={metadata:se.metadata??Object.create(null),cells:[]};for(const $e of se.cells)s.NotebookCellData.validate($e),Ne.cells.push(gt.from($e));return Ne}Re.from=Oe;function Se(se){const Ne=new s.NotebookData(se.cells.map(gt.to));return(0,v.isEmptyObject)(se.metadata)||(Ne.metadata=se.metadata),Ne}Re.to=Se})(Ze=e.NotebookData||(e.NotebookData={}));var gt;(function(Re){function Oe(se){return{cellKind:xe.from(se.kind),language:se.languageId,mime:se.mime,source:se.value,metadata:se.metadata,internalMetadata:Le.from(se.executionSummary??{}),outputs:se.outputs?se.outputs.map(lt.from):[]}}Re.from=Oe;function Se(se){return new s.NotebookCellData(xe.to(se.cellKind),se.source,se.language,se.mime,se.outputs?se.outputs.map(lt.to):void 0,se.metadata,se.internalMetadata?Le.to(se.internalMetadata):void 0)}Re.to=Se})(gt=e.NotebookCellData||(e.NotebookCellData={}));var mt;(function(Re){function Oe(se){return{mime:se.mime,valueBytes:t.VSBuffer.wrap(se.data)}}Re.from=Oe;function Se(se){return new s.NotebookCellOutputItem(se.valueBytes.buffer,se.mime)}Re.to=Se})(mt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var lt;(function(Re){function Oe(se){return{outputId:se.id,items:se.items.map(mt.from),metadata:se.metadata}}Re.from=Oe;function Se(se){const Ne=se.items.map(mt.to);return new s.NotebookCellOutput(Ne,se.outputId,se.metadata)}Re.to=Se})(lt=e.NotebookCellOutput||(e.NotebookCellOutput={}));var ot;(function(Re){function Oe(Ne){return se(Ne)?{include:(0,v.withNullAsUndefined)($.from(Ne.include)),exclude:(0,v.withNullAsUndefined)($.from(Ne.exclude))}:(0,v.withNullAsUndefined)($.from(Ne))}Re.from=Oe;function Se(Ne){return se(Ne)?{include:$.to(Ne.include),exclude:$.to(Ne.exclude)}:$.to(Ne)}Re.to=Se;function se(Ne){const $e=Ne;return $e?!(0,v.isUndefinedOrNull)($e.include)&&!(0,v.isUndefinedOrNull)($e.exclude):!1}})(ot=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var rt;(function(Re){function Oe(Se,se,Ne){const $e=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{alignment:Se.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:se.toInternal($e,Ne),text:Se.text,tooltip:Se.tooltip,accessibilityInformation:Se.accessibilityInformation,priority:Se.priority}}Re.from=Oe})(rt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var kt;(function(Re){function Oe(Se,se,Ne){const $e=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{command:se.toInternal($e,Ne),label:Se.label,description:Se.description,detail:Se.detail}}Re.from=Oe})(kt=e.NotebookKernelSourceAction||(e.NotebookKernelSourceAction={}));var Tt;(function(Re){function Oe(Se){return{transientOutputs:Se?.transientOutputs??!1,transientCellMetadata:Se?.transientCellMetadata??{},transientDocumentMetadata:Se?.transientDocumentMetadata??{},cellContentMetadata:Se?.cellContentMetadata??{}}}Re.from=Oe})(Tt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Nt;(function(Re){function Oe(se){return{uri:se.uri,provides:se.provides}}Re.from=Oe;function Se(se){return new s.NotebookRendererScript(C.URI.revive(se.uri),se.provides)}Re.to=Se})(Nt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var pt;(function(Re){function Oe(se){return{message:F.fromStrict(se.message)||"",type:0,expected:se.expectedOutput,actual:se.actualOutput,location:se.location&&{range:u.from(se.location.range),uri:se.location.uri}}}Re.from=Oe;function Se(se){const Ne=new s.TestMessage(typeof se.message=="string"?se.message:F.to(se.message));return Ne.actualOutput=se.actual,Ne.expectedOutput=se.expected,Ne.location=se.location?Ee.to(se.location):void 0,Ne}Re.to=Se})(pt=e.TestMessage||(e.TestMessage={}));var Dt;(function(Re){Re.namespace=w.namespaceTestTag,Re.denamespace=w.denamespaceTestTag})(Dt=e.TestTag||(e.TestTag={}));var zt;(function(Re){function Oe(se){const Ne=(0,h.getPrivateApiFor)(se).controllerId;return{extId:p.TestId.fromExtHostTestItem(se,Ne).toString(),label:se.label,uri:C.URI.revive(se.uri),busy:se.busy,tags:se.tags.map($e=>Dt.namespace(Ne,$e.id)),range:E.Range.lift(u.from(se.range)),description:se.description||null,sortText:se.sortText||null,error:se.error&&F.fromStrict(se.error)||null}}Re.from=Oe;function Se(se){return{parent:void 0,error:void 0,id:p.TestId.fromString(se.extId).localId,label:se.label,uri:C.URI.revive(se.uri),tags:(se.tags||[]).map(Ne=>{const{tagId:$e}=Dt.denamespace(Ne);return new s.TestTag($e)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:u.to(se.range||void 0),canResolveChildren:!1,busy:se.busy,description:se.description||void 0,sortText:se.sortText||void 0}}Re.toPlain=Se})(zt=e.TestItem||(e.TestItem={})),function(Re){function Oe(se){return{id:se.id}}Re.from=Oe;function Se(se){return new s.TestTag(se.id)}Re.to=Se}(Dt=e.TestTag||(e.TestTag={}));var Ft;(function(Re){const Oe=(se,Ne)=>{const $e=[];for(const[Ve,tt]of Ne)p.TestId.compare(tt.item.extId,Ve)===2&&(Ne.delete(Ve),$e.push(tt));const Qe={...zt.toPlain(se.item),parent:void 0,taskStates:se.tasks.map(Ve=>({state:Ve.state,duration:Ve.duration,messages:Ve.messages.filter(tt=>tt.type===0).map(pt.to)})),children:$e.map(Ve=>Oe(Ve,Ne))};for(const Ve of Qe.children)Ve.parent=Qe;return Qe};function Se(se){const Ne=[],$e=new Map;for(const Qe of se.items){$e.set(Qe.item.extId,Qe);const Ve=p.TestId.root(Qe.item.extId);se.request.targets.some(tt=>tt.controllerId===Ve&&tt.testIds.includes(Qe.item.extId))&&Ne.push(Qe)}return{completedAt:se.completedAt,results:Ne.map(Qe=>Oe(Qe,$e))}}Re.to=Se})(Ft=e.TestResults||(e.TestResults={}));var Xe;(function(Re){function Oe($e){return{covered:$e.covered,total:$e.covered}}function Se($e){return"line"in $e?c.from($e):u.from($e)}function se($e){return"branches"in $e?{count:$e.executionCount,location:Se($e.location),type:1,branches:$e.branches.length?$e.branches.map(Qe=>({count:Qe.executionCount,location:Qe.location&&Se(Qe.location)})):void 0}:{type:0,count:$e.executionCount,location:Se($e.location)}}Re.fromDetailed=se;function Ne($e){return{uri:$e.uri,statement:Oe($e.statementCoverage),branch:$e.branchCoverage&&Oe($e.branchCoverage),function:$e.functionCoverage&&Oe($e.functionCoverage),details:$e.detailedCoverage?.map(se)}}Re.fromFile=Ne})(Xe=e.TestCoverage||(e.TestCoverage={}));var Mt;(function(Re){function Oe(Se){switch(Se){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}Re.to=Oe})(Mt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Ut;(function(Re){function Oe(se){const Ne=new s.TypeHierarchyItem(J.to(se.kind),se.name,se.detail||"",C.URI.revive(se.uri),u.to(se.range),u.to(se.selectionRange));return Ne._sessionId=se._sessionId,Ne._itemId=se._itemId,Ne}Re.to=Oe;function Se(se,Ne,$e){if(Ne=Ne??se._sessionId,$e=$e??se._itemId,Ne===void 0||$e===void 0)throw new Error("invalid item");return{_sessionId:Ne,_itemId:$e,kind:J.from(se.kind),name:se.name,detail:se.detail??"",uri:se.uri,range:u.from(se.range),selectionRange:u.from(se.selectionRange),tags:se.tags?.map(Z.from)}}Re.from=Se})(Ut=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Bt;(function(Re){function Oe(Se){if(!!Se)return{value:Se.value,tooltip:Se.tooltip}}Re.from=Oe})(Bt=e.ViewBadge||(e.ViewBadge={}));var wt;(function(Re){function Oe($e,Qe,Ve){const tt=Qe.fileData;return tt?new class extends s.DataTransferItem{asFile(){return{name:tt.name,uri:C.URI.revive(tt.uri),data:(0,R.once)(()=>Ve())}}}("",Qe.id):$e===L.Mimes.uriList&&Qe.uriListData?new s.DataTransferItem(Ne(Qe.uriListData)):new s.DataTransferItem(Qe.asString)}Re.to=Oe;async function Se($e,Qe){const Ve=await Qe.asString();if($e===L.Mimes.uriList)return{id:Qe.id,asString:"",fileData:void 0,uriListData:se(Ve)};const tt=Qe.asFile();return{id:Qe.id,asString:Ve,fileData:tt?{name:tt.name,uri:tt.uri}:void 0}}Re.from=Se;function se($e){return T.UriList.split($e).map(Qe=>{if(Qe.startsWith("#"))return Qe;try{return C.URI.parse(Qe)}catch{}return Qe})}function Ne($e){return T.UriList.create($e.map(Qe=>typeof Qe=="string"?Qe:C.URI.revive(Qe)))}})(wt=e.DataTransferItem||(e.DataTransferItem={}));var Pt;(function(Re){function Oe(se,Ne){const $e=se.items.map(([Qe,Ve])=>[Qe,wt.to(Qe,Ve,()=>Ne(Ve.id))]);return new s.DataTransfer($e)}Re.toDataTransfer=Oe;async function Se(se){const Ne={items:[]},$e=[];return se.forEach((Qe,Ve)=>{$e.push((async()=>{Ne.items.push([Ve,await wt.from(Ve,Qe)])})())}),await Promise.all($e),Ne}Re.toDataTransferDTO=Se})(Pt=e.DataTransfer||(e.DataTransfer={}))}),define(ye[234],Ce([1,0,2,9,7,14,63]),function(te,e,o,t,T,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class A{constructor(D,L,P,v={timeout:1500,errors:3}){this.c=D,this.d=L,this.f=P,this.g=v,this.a=new I.LinkedList,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(D){return(L,P,v)=>{const E={dispose:this.a.push([L,P,D])};return Array.isArray(v)&&v.push(E),E}}async $participateInSave(D,L){const P=o.URI.revive(D);let v=!1;const C=setTimeout(()=>v=!0,this.g.timeout),E=[];try{for(const f of[...this.a]){if(v)break;const d=this.d.getDocument(P),h=await this.h(f,{document:d,reason:R.TextDocumentSaveReason.to(L)});E.push(h)}}finally{clearTimeout(C)}return E}h([D,L,P],v){const C=this.b.get(D);return typeof C=="number"&&C>this.g.errors?Promise.resolve(!1):this.i(P,D,L,v).then(()=>!0,E=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' threw ERROR`),this.c.error(E),!(E instanceof Error)||E.message!=="concurrent_edits"){const f=this.b.get(D);this.b.set(D,f?f+1:1),typeof f=="number"&&f>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(D,L,P,v){const C=[],E=Date.now(),{document:f,reason:d}=v,{version:h}=f,b=Object.freeze({document:f,reason:d,waitUntil(g){if(Object.isFrozen(C))throw(0,t.illegalState)("waitUntil can not be called async");C.push(Promise.resolve(g))}});try{L.apply(P,[b])}catch(g){return Promise.reject(g)}return Object.freeze(C),new Promise((g,p)=>{const w=setTimeout(()=>p(new Error("timeout")),this.g.timeout);return Promise.all(C).then(i=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' finished after ${Date.now()-E}ms`),clearTimeout(w),g(i)}).catch(i=>{clearTimeout(w),p(i)})}).then(g=>{const p={edits:[]};for(const w of g)if(Array.isArray(w)&&w.every(i=>i instanceof T.TextEdit))for(const{newText:i,newEol:s,range:a}of w)p.edits.push({resource:f.uri,versionId:void 0,textEdit:{range:a&&R.Range.from(a),text:i,eol:s&&R.EndOfLine.from(s)}});if(p.edits.length!==0)return h===f.version?this.f.$tryApplyWorkspaceEdit(p):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=A}),define(ye[235],Ce([1,0,15,2,14,7,91]),function(te,e,o,t,T,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class A{constructor(P,v,C,E){this.start=P,this.deletedCount=v,this.deletedItems=C,this.items=E}asApiEvent(){return{range:new R.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(P=>P.apiCell),removedCells:this.deletedItems}}}class y{static asModelAddData(P,v){return{EOL:v.eol,lines:v.source,languageId:v.language,uri:v.uri,isDirty:!1,versionId:1,notebook:P}}constructor(P,v,C){this.notebook=P,this.h=v,this.j=C,this.handle=C.handle,this.uri=t.URI.revive(C.uri),this.cellKind=C.cellKind,this.a=C.outputs.map(T.NotebookCellOutput.to),this.e=C.internalMetadata??{},this.b=Object.freeze(C.metadata??{}),this.d=Object.freeze(T.NotebookCellExecutionSummary.to(C.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const P=this,v=this.h.getDocument(this.uri);if(!v)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const C={get index(){return P.notebook.getCellIndex(P)},notebook:P.notebook.apiNotebook,kind:T.NotebookCellKind.to(this.j.cellKind),document:v.document,get mime(){return P.g},set mime(E){P.g=E},get outputs(){return P.a.slice(0)},get metadata(){return P.b},get executionSummary(){return P.d}};this.f=Object.freeze(C)}return this.f}setOutputs(P){this.a=P.map(T.NotebookCellOutput.to)}setOutputItems(P,v,C){const E=C.map(T.NotebookCellOutputItem.to),f=this.a.find(d=>d.id===P);if(f&&(v||(f.items.length=0),f.items.push(...E),f.items.length>1&&f.items.every(d=>I.isTextStreamMime(d.mime)))){const d=new Map,h=[];f.items.forEach(b=>{let g;d.has(b.mime)?g=d.get(b.mime):(g=[],d.set(b.mime,g),h.push(b.mime)),g.push(b.data)}),f.items.length=0,h.forEach(b=>{const g=I.compressOutputItemStreams(d.get(b));f.items.push({mime:b,data:g.buffer})})}}setMetadata(P){this.b=Object.freeze(P)}setInternalMetadata(P){this.e=P,this.d=Object.freeze(T.NotebookCellExecutionSummary.to(P))}setMime(P){}}e.ExtHostCell=y;class D{constructor(P,v,C,E,f){this.k=P,this.l=v,this.m=C,this.uri=E,this.handle=D.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=f.viewType,this.f=Object.freeze(f.metadata??Object.create(null)),this.r([[0,0,f.cells]],!0,void 0),this.g=f.versionId}dispose(){this.j=!0}get apiNotebook(){if(!this.e){const P=this,v={get uri(){return P.uri},get version(){return P.g},get notebookType(){return P.d},get isDirty(){return P.h},get isUntitled(){return P.uri.scheme===o.Schemas.untitled},get isClosed(){return P.j},get metadata(){return P.f},get cellCount(){return P.b.length},cellAt(C){return C=P.n(C),P.b[C].apiCell},getCells(C){return(C?P.p(C):P.b).map(f=>f.apiCell)},save(){return P.q()}};this.e=Object.freeze(v)}return this.e}acceptDocumentPropertiesChanged(P){P.metadata&&(this.f=Object.freeze({...this.f,...P.metadata}))}acceptDirty(P){this.h=P}acceptModelChanged(P,v,C){this.g=P.versionId,this.h=v,this.acceptDocumentPropertiesChanged({metadata:C});const E={notebook:this.apiNotebook,metadata:C,cellChanges:[],contentChanges:[]},f=[];for(const h of P.rawEvents)h.kind===I.NotebookCellsChangeType.ModelChange?this.r(h.changes,!1,E.contentChanges):h.kind===I.NotebookCellsChangeType.Move?this.s(h.index,h.length,h.newIdx,E.contentChanges):h.kind===I.NotebookCellsChangeType.Output?(this.t(h.index,h.outputs),f.push({cell:this.b[h.index].apiCell,outputs:this.b[h.index].apiCell.outputs})):h.kind===I.NotebookCellsChangeType.OutputItem?(this.u(h.index,h.outputId,h.append,h.outputItems),f.push({cell:this.b[h.index].apiCell,outputs:this.b[h.index].apiCell.outputs})):h.kind===I.NotebookCellsChangeType.ChangeCellLanguage?(this.v(h.index,h.language),f.push({cell:this.b[h.index].apiCell,document:this.b[h.index].apiCell.document})):h.kind===I.NotebookCellsChangeType.ChangeCellContent?f.push({cell:this.b[h.index].apiCell,document:this.b[h.index].apiCell.document}):h.kind===I.NotebookCellsChangeType.ChangeCellMime?this.w(h.index,h.mime):h.kind===I.NotebookCellsChangeType.ChangeCellMetadata?(this.x(h.index,h.metadata),f.push({cell:this.b[h.index].apiCell,metadata:this.b[h.index].apiCell.metadata})):h.kind===I.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(h.index,h.internalMetadata),f.push({cell:this.b[h.index].apiCell,executionSummary:this.b[h.index].apiCell.executionSummary}));const d=new Map;for(let h=0;h<f.length;h++){const b=f[h],g=d.get(b.cell);if(g===void 0){const p=E.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...b});d.set(b.cell,p-1)}else E.cellChanges[g]={...E.cellChanges[g],...b}}return Object.freeze(E),Object.freeze(E.cellChanges),Object.freeze(E.contentChanges),E}n(P){return P=P|0,P<0?0:P>=this.b.length?this.b.length-1:P}o(P){let v=P.start|0,C=P.end|0;return v<0&&(v=0),C>this.b.length&&(C=this.b.length),P.with({start:v,end:C})}p(P){P=this.o(P);const v=[];for(let C=P.start;C<P.end;C++)v.push(this.b[C]);return v}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(P,v,C){if(this.j)return;const E=[],f=[],d=[];if(P.reverse().forEach(h=>{const g=h[2].map(i=>{const s=new y(this,this.l,i);return v||f.push(y.asModelAddData(this.apiNotebook,i)),s}),p=new A(h[0],h[1],[],g),w=this.b.splice(h[0],h[1],...g);for(const i of w)d.push(i.uri),p.deletedItems.push(i.apiCell);E.push(p)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:f,removedDocuments:d}),C)for(const h of E)C.push(h.asApiEvent())}s(P,v,C,E){const f=this.b.splice(P,v);this.b.splice(C,0,...f);const d=[new A(P,v,f.map(h=>h.apiCell),[]),new A(C,0,[],f)];for(const h of d)E.push(h.asApiEvent())}t(P,v){this.b[P].setOutputs(v)}u(P,v,C,E){this.b[P].setOutputItems(v,C,E)}v(P,v){const C=this.b[P];C.apiCell.document.languageId!==v&&this.m.$acceptModelLanguageChanged(C.uri,v)}w(P,v){const C=this.b[P];C.apiCell.mime=v}x(P,v){this.b[P].setMetadata(v)}y(P,v){this.b[P].setInternalMetadata(v)}getCellFromApiCell(P){return this.b.find(v=>v.apiCell===P)}getCellFromIndex(P){return this.b[P]}getCell(P){return this.b.find(v=>v.handle===P)}getCellIndex(P){return this.b.indexOf(P)}}e.ExtHostNotebookDocument=D,D.a=0}),define(ye[136],Ce([1,0,9,14,7]),function(te,e,o,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class R{constructor(A,y,D,L,P,v){this.id=A,this.f=y,this.notebookData=D,this.a=[],this.b=[],this.d=!1,this.a=P,this.b=L,this.c=v}get apiEditor(){if(!this.e){const A=this;this.e={get notebook(){return A.notebookData.apiNotebook},get selection(){return A.a[0]},set selection(y){this.selections=[y]},get selections(){return A.a},set selections(y){if(!Array.isArray(y)||!y.every(T.NotebookRange.isNotebookRange))throw(0,o.illegalArgument)("selections");A.a=y,A.g(y)},get visibleRanges(){return A.b},revealRange(y,D){A.f.$tryRevealRange(A.id,t.NotebookRange.from(y),D??T.NotebookEditorRevealType.Default)},get viewColumn(){return A.c}},R.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(A){this.d=A}_acceptVisibleRanges(A){this.b=A}_acceptSelections(A){this.a=A}g(A){this.f.$trySetSelections(this.id,A.map(t.NotebookRange.from))}_acceptViewColumn(A){this.c=A}}e.ExtHostNotebookEditor=R,R.apiEditorsToExtHost=new WeakMap}),define(ye[236],Ce([1,0,3,13,14]),function(te,e,o,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let R=class{constructor(A,y){this.c=A,this.d=y,this.a=new o.Emitter,this.b=new o.Emitter,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(A,y){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",A,y);const D=this.d.getEditorById(A);y.visibleRanges&&D._acceptVisibleRanges(y.visibleRanges.ranges.map(T.NotebookRange.to)),y.selections&&D._acceptSelections(y.selections.selections.map(T.NotebookRange.to)),y.visibleRanges&&this.b.fire({notebookEditor:D.apiEditor,visibleRanges:D.apiEditor.visibleRanges}),y.selections&&this.a.fire(Object.freeze({notebookEditor:D.apiEditor,selections:D.apiEditor.selections}))}$acceptEditorViewColumns(A){for(const y in A)this.d.getEditorById(y)._acceptViewColumn(T.ViewColumn.to(A[y]))}};R=qe([We(0,t.ILogService)],R),e.ExtHostNotebookEditors=R}),define(ye[237],Ce([1,0,14,125,177,21,60,9]),function(te,e,o,t,T,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class y{constructor(v){this.b=0,this.c=new Map,this.a=v}async withProgress(v,C,E){const f=this.b++,{title:d,location:h,cancellable:b}=C,g={label:(0,T.localize)(0,null,v.displayName||v.name),id:v.identifier.value};return this.a.$startProgress(f,{location:o.ProgressLocation.from(h),title:d,source:g,cancellable:b},v.isUnderDevelopment?void 0:v.identifier.value).catch(A.onUnexpectedExternalError),this.d(f,E,!!b)}d(v,C,E){let f;E&&(f=new R.CancellationTokenSource,this.c.set(v,f));const d=b=>{this.a.$progressEnd(b),this.c.delete(b),f?.dispose()};let h;try{h=C(new L(this.a,v),E&&f?f.token:R.CancellationToken.None)}catch(b){throw d(v),b}return h.then(b=>d(v),b=>d(v)),h}$acceptProgressCanceled(v){const C=this.c.get(v);C&&(C.cancel(),this.c.delete(v))}}e.ExtHostProgress=y;function D(P,v){return P.message=v.message,typeof v.increment=="number"&&(typeof P.increment=="number"?P.increment+=v.increment:P.increment=v.increment),P}class L extends t.Progress{constructor(v,C){super(E=>this.throttledReport(E)),this.c=v,this.d=C}throttledReport(v){this.c.$progressReport(this.d,v)}}qe([(0,I.throttle)(100,(P,v)=>D(P,v),()=>Object.create(null))],L.prototype,"throttledReport",null)}),define(ye[137],Ce([1,0,35,132,56,92,70,14,2]),function(te,e,o,t,T,R,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const D=(g,p,w,i)=>{let s=p;return{enumerable:!0,configurable:!1,get(){return s},set(a){if(!w(s,a)){const u=s;s=a,g.listener?.(i(a,u))}}}},L=(g,p)=>g===p,P={range:(g,p)=>g===p?!0:!g||!p?!1:g.isEqual(p),label:L,description:L,sortText:L,busy:L,error:L,canResolveChildren:L,tags:(g,p)=>!(g.length!==p.length||g.some(w=>!p.find(i=>w.id===i.id)))},v=g=>p=>({op:4,update:g(p)}),C=(g,p)=>({range:(()=>{let w;const i=v(s=>({range:o.Range.lift(A.Range.from(s))}));return{enumerable:!0,configurable:!1,get(){return w},set(s){g.listener?.({op:6}),P.range(w,s)||(w=s,g.listener?.(i(s)))}}})(),label:D(g,p,P.label,v(w=>({label:w}))),description:D(g,void 0,P.description,v(w=>({description:w}))),sortText:D(g,void 0,P.sortText,v(w=>({sortText:w}))),canResolveChildren:D(g,!1,P.canResolveChildren,w=>({op:2,state:w})),busy:D(g,!1,P.busy,v(w=>({busy:w}))),error:D(g,void 0,P.error,v(w=>({error:A.MarkdownString.fromStrict(w)||null}))),tags:D(g,[],P.tags,(w,i)=>({op:1,new:w.map(A.TestTag.from),old:i.map(A.TestTag.from)}))}),E=g=>{const p=T.TestId.fromString(g.extId),w=new d(p.controllerId,p.localId,g.label,y.URI.revive(g.uri)||void 0);return w.range=A.Range.to(g.range||void 0),w.description=g.description||void 0,w.sortText=g.sortText||void 0,w.tags=g.tags.map(i=>A.TestTag.to({id:(0,I.denamespaceTestTag)(i).tagId})),w},f=g=>{let p;for(const w of g.tests){const i=E(w.item);(0,t.getPrivateApiFor)(i).parent=p,p=i}return p};e.toItemFromContext=f;class d{constructor(p,w,i,s){if(w.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(w)} symbol`);const a=(0,t.createPrivateApiFor)(this,p);Object.defineProperties(this,{id:{value:w,enumerable:!0,writable:!1},uri:{value:s,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return a.parent instanceof h?void 0:a.parent}},children:{value:(0,R.createTestItemChildren)(a,t.getPrivateApiFor,d),enumerable:!0,writable:!1},...C(a,i)})}}e.TestItemImpl=d;class h extends d{constructor(p,w){super(p,p,w,void 0),this._isRoot=!0}}e.TestItemRootImpl=h;class b extends R.TestItemCollection{constructor(p,w,i){super({controllerId:p,getDocumentVersion:s=>s&&i.getDocument(s)?.version,getApiFor:t.getPrivateApiFor,getChildren:s=>s.children,root:new h(p,w),toITestItem:A.TestItem.from})}}e.ExtHostTestItemCollection=b}),define(ye[138],Ce([1,0,50,9,100,14,7]),function(te,e,o,t,T,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class A{constructor(v,C,E){const f=A.c.nextId();v.$registerTextEditorDecorationType(C.identifier,f,R.DecorationRenderOptions.from(E)),this.value=Object.freeze({key:f,dispose(){v.$removeTextEditorDecorationType(f)}})}}e.TextEditorDecorationType=A,A.c=new T.IdGenerator("TextEditorDecorationType");class y{constructor(v,C){this.g=[],this.h=void 0,this.j=!1,this.c=v,this.d=v.version,this.e=C.undoStopBefore,this.f=C.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(v,C){this.k();let E=null;if(v instanceof I.Position)E=new I.Range(v,v);else if(v instanceof I.Range)E=v;else throw new Error("Unrecognized location");this.l(E,C,!1)}insert(v,C){this.k(),this.l(new I.Range(v,v),C,!0)}delete(v){this.k();let C=null;if(v instanceof I.Range)C=v;else throw new Error("Unrecognized location");this.l(C,null,!0)}l(v,C,E){const f=this.c.validateRange(v);this.g.push({range:f,text:C,forceMoveMarkers:E})}setEndOfLine(v){if(this.k(),v!==I.EndOfLine.LF&&v!==I.EndOfLine.CRLF)throw(0,t.illegalArgument)("endOfLine");this.h=v}}class D{constructor(v,C,E,f){this.c=v,this.d=C,this._accept(E),this.e=f;const d=this;this.value={get tabSize(){return d.f},set tabSize(h){d.m(h)},get indentSize(){return d.g},set indentSize(h){d.o(h)},get insertSpaces(){return d.h},set insertSpaces(h){d.q(h)},get cursorStyle(){return d.j},set cursorStyle(h){d.s(h)},get lineNumbers(){return d.k},set lineNumbers(h){d.t(h)}}}_accept(v){this.f=v.tabSize,this.g=v.indentSize,this.h=v.insertSpaces,this.j=v.cursorStyle,this.k=R.TextEditorLineNumbersStyle.to(v.lineNumbers)}l(v){if(v==="auto")return"auto";if(typeof v=="number"){const C=Math.floor(v);return C>0?C:null}if(typeof v=="string"){const C=parseInt(v,10);return isNaN(C)?null:C>0?C:null}return null}m(v){const C=this.l(v);if(C!==null){if(typeof C=="number"){if(this.f===C)return;this.f=C}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:C}))}}n(v){if(v==="tabSize")return"tabSize";if(typeof v=="number"){const C=Math.floor(v);return C>0?C:null}if(typeof v=="string"){const C=parseInt(v,10);return isNaN(C)?null:C>0?C:null}return null}o(v){const C=this.n(v);if(C!==null){if(typeof C=="number"){if(this.g===C)return;this.g=C}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:C}))}}p(v){return v==="auto"?"auto":v==="false"?!1:Boolean(v)}q(v){const C=this.p(v);if(typeof C=="boolean"){if(this.h===C)return;this.h=C}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:C}))}s(v){this.j!==v&&(this.j=v,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:v})))}t(v){this.k!==v&&(this.k=v,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:R.TextEditorLineNumbersStyle.from(v)})))}assign(v){const C={};let E=!1;if(typeof v.tabSize<"u"){const f=this.l(v.tabSize);f==="auto"?(E=!0,C.tabSize=f):typeof f=="number"&&this.f!==f&&(this.f=f,E=!0,C.tabSize=f)}if(typeof v.indentSize<"u"){const f=this.n(v.indentSize);f==="tabSize"?(E=!0,C.indentSize=f):typeof f=="number"&&this.g!==f&&(this.g=f,E=!0,C.indentSize=f)}if(typeof v.insertSpaces<"u"){const f=this.p(v.insertSpaces);f==="auto"?(E=!0,C.insertSpaces=f):this.h!==f&&(this.h=f,E=!0,C.insertSpaces=f)}typeof v.cursorStyle<"u"&&this.j!==v.cursorStyle&&(this.j=v.cursorStyle,E=!0,C.cursorStyle=v.cursorStyle),typeof v.lineNumbers<"u"&&this.k!==v.lineNumbers&&(this.k=v.lineNumbers,E=!0,C.lineNumbers=R.TextEditorLineNumbersStyle.from(v.lineNumbers)),E&&this.u("setOptions",this.c.$trySetOptions(this.d,C))}u(v,C){C.catch(E=>{this.e.warn(`ExtHostTextEditorOptions '${v}' failed:'`),this.e.warn(E)})}}e.ExtHostTextEditorOptions=D;class L{constructor(v,C,E,f,d,h,b,g){this.id=v,this.j=C,this.k=E,this.g=!1,this.h=new Set,this.c=d,this.d=new D(this.j,this.id,h,E),this.e=b,this.f=g;const p=this;this.value=Object.freeze({get document(){return f.getValue()},set document(w){throw(0,t.readonly)("document")},get selection(){return p.c&&p.c[0]},set selection(w){if(!(w instanceof I.Selection))throw(0,t.illegalArgument)("selection");p.c=[w],p.l()},get selections(){return p.c},set selections(w){if(!Array.isArray(w)||w.some(i=>!(i instanceof I.Selection)))throw(0,t.illegalArgument)("selections");p.c=w,p.l()},get visibleRanges(){return p.e},set visibleRanges(w){throw(0,t.readonly)("visibleRanges")},get options(){return p.d.value},set options(w){p.g||p.d.assign(w)},get viewColumn(){return p.f},set viewColumn(w){throw(0,t.readonly)("viewColumn")},edit(w,i={undoStopBefore:!0,undoStopAfter:!0}){if(p.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const s=new y(f.getValue(),i);return w(s),p.m(s)},insertSnippet(w,i,s={undoStopBefore:!0,undoStopAfter:!0}){if(p.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let a;if(!i||Array.isArray(i)&&i.length===0)a=p.c.map(u=>R.Range.from(u));else if(i instanceof I.Position){const{lineNumber:u,column:l}=R.Position.from(i);a=[{startLineNumber:u,startColumn:l,endLineNumber:u,endColumn:l}]}else if(i instanceof I.Range)a=[R.Range.from(i)];else{a=[];for(const u of i)if(u instanceof I.Range)a.push(R.Range.from(u));else{const{lineNumber:l,column:c}=R.Position.from(u);a.push({startLineNumber:l,startColumn:c,endLineNumber:l,endColumn:c})}}return C.$tryInsertSnippet(v,f.getValue().version,w.value,a,s)},setDecorations(w,i){const s=i.length===0;s&&!p.h.has(w.key)||(s?p.h.delete(w.key):p.h.add(w.key),p.n(()=>{if(R.isDecorationOptionsArr(i))return C.$trySetDecorations(v,w.key,R.fromRangeOrRangeWithMessage(i));{const a=new Array(4*i.length);for(let u=0,l=i.length;u<l;u++){const c=i[u];a[4*u]=c.start.line+1,a[4*u+1]=c.start.character+1,a[4*u+2]=c.end.line+1,a[4*u+3]=c.end.character+1}return C.$trySetDecorationsFast(v,w.key,a)}}))},revealRange(w,i){p.n(()=>C.$tryRevealRange(v,R.Range.from(w),i||I.TextEditorRevealType.Default))},show(w){C.$tryShowEditor(v,R.ViewColumn.from(w))},hide(){C.$tryHideEditor(v)}})}dispose(){(0,o.ok)(!this.g),this.g=!0}_acceptOptions(v){(0,o.ok)(!this.g),this.d._accept(v)}_acceptVisibleRanges(v){(0,o.ok)(!this.g),this.e=v}_acceptViewColumn(v){(0,o.ok)(!this.g),this.f=v}_acceptSelections(v){(0,o.ok)(!this.g),this.c=v}async l(){const v=this.c.map(R.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,v)),this.value}m(v){const C=v.finalize();if(C.edits.length===0&&!C.setEndOfLine)return Promise.resolve(!0);const E=C.edits.map(d=>d.range);E.sort((d,h)=>d.end.line===h.end.line?d.end.character===h.end.character?d.start.line===h.start.line?d.start.character-h.start.character:d.start.line-h.start.line:d.end.character-h.end.character:d.end.line-h.end.line);for(let d=0,h=E.length-1;d<h;d++){const b=E[d].end;if(E[d+1].start.isBefore(b))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const f=C.edits.map(d=>({range:R.Range.from(d.range),text:d.text,forceMoveMarkers:d.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,C.documentVersionId,f,{setEndOfLine:typeof C.setEndOfLine=="number"?R.EndOfLine.from(C.setEndOfLine):void 0,undoStopBefore:C.undoStopBefore,undoStopAfter:C.undoStopAfter})}n(v){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):v().then(()=>this,C=>(C instanceof Error&&C.name==="DISPOSED"||this.k.warn(C),null))}}e.ExtHostTextEditor=L}),define(ye[238],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsResolvedState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsResolvedState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",telemetryLogger:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetryLogger.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(ye[239],Ce([1,0,191,9,37,122,126,44,26,238,203,193]),function(te,e,o,t,T,R,I,A,y,D,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const v=A.Registry.as(I.Extensions.JSONContribution);class C{constructor(w,i,s){this.a=w,this.b=i,this.c=s}d(w,i){this.a({type:w,message:i,extensionId:this.b.identifier,extensionPointId:this.c})}error(w){this.d(T.default.Error,w)}warn(w){this.d(T.default.Warning,w)}info(w){this.d(T.default.Info,w)}}e.ExtensionMessageCollector=C;class E{static a(w){const i=new Set;for(let s=0,a=w.length;s<a;s++)i.add(y.ExtensionIdentifier.toKey(w[s].description.identifier));return i}static compute(w,i){if(!w||!w.length)return new E(i,[]);if(!i||!i.length)return new E([],w);const s=this.a(w),a=this.a(i),u=i.filter(c=>!s.has(y.ExtensionIdentifier.toKey(c.description.identifier))),l=w.filter(c=>!a.has(y.ExtensionIdentifier.toKey(c.description.identifier)));return new E(u,l)}constructor(w,i){this.added=w,this.removed=i}}e.ExtensionPointUserDelta=E;class f{constructor(w,i){this.name=w,this.defaultExtensionKind=i,this.a=null,this.b=null,this.c=null}setHandler(w){if(this.a!==null)throw new Error("Handler already set!");this.a=w,this.d()}acceptUsers(w){this.c=E.compute(this.b,w),this.b=w,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(w){(0,t.onUnexpectedError)(w)}}}e.ExtensionPoint=f;const d={type:"string",enum:["ui","workspace"],enumDescriptions:[o.localize(0,null),o.localize(1,null)]},h="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:o.localize(2,null),properties:{vscode:{type:"string",description:o.localize(3,null),default:"^1.22.0"}}},publisher:{description:o.localize(4,null),type:"string"},displayName:{description:o.localize(5,null),type:"string"},categories:{description:o.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:y.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:o.localize(7,null)}]}},galleryBanner:{type:"object",description:o.localize(8,null),properties:{color:{description:o.localize(9,null),type:"string"},theme:{description:o.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:o.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:o.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:o.localize(13,null)},enabledApiProposals:{markdownDescription:o.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(D.allApiProposals),markdownEnumDescriptions:Object.values(D.allApiProposals)}},api:{markdownDescription:o.localize(15,null),type:"string",enum:["none"],enumDescriptions:[o.localize(16,null)]},activationEvents:{description:o.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:o.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:o.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:o.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:o.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:o.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:o.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:o.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:o.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:o.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:o.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:o.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:o.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:o.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:o.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:o.localize(32,null)},{label:"onUri",body:"onUri",description:o.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:o.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:o.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:o.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:o.localize(37,null)},{label:"onRenderer",description:o.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:o.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:o.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:o.localize(41,null)},{label:"*",description:o.localize(42,null),body:"*"}]}},badges:{type:"array",description:o.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:o.localize(44,null)},href:{type:"string",description:o.localize(45,null)},description:{type:"string",description:o.localize(46,null)}}}},markdown:{type:"string",description:o.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:o.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:o.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:o.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:o.localize(51,null),type:"array",items:d,default:["workspace"],defaultSnippets:[{body:["ui"],description:o.localize(52,null)},{body:["workspace"],description:o.localize(53,null)},{body:["ui","workspace"],description:o.localize(54,null)},{body:["workspace","ui"],description:o.localize(55,null)},{body:[],description:o.localize(56,null)}]},capabilities:{description:o.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:o.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:o.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[o.localize(60,null),o.localize(61,null),o.localize(62,null)]},description:{type:"string",markdownDescription:o.localize(63,null)}}},untrustedWorkspaces:{description:o.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:o.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[o.localize(66,null),o.localize(67,null),o.localize(68,null)]},restrictedConfigurations:{description:o.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:o.localize(70,null)}}}}},sponsor:{description:o.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:o.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:o.localize(73,null),type:"string"},"vscode:uninstall":{description:o.localize(74,null),type:"string"}}},icon:{type:"string",description:o.localize(75,null)},l10n:{type:"string",description:o.localize(76,null)}}};class b{constructor(){this.a=new Map}registerExtensionPoint(w){if(this.a.has(w.extensionPoint))throw new Error("Duplicate extension point: "+w.extensionPoint);const i=new f(w.extensionPoint,w.defaultExtensionKind);return this.a.set(w.extensionPoint,i),w.activationEventsGenerator&&P.ImplicitActivationEvents.register(w.extensionPoint,w.activationEventsGenerator),e.schema.properties.contributes.properties[w.extensionPoint]=w.jsonSchema,v.registerSchema(h,e.schema),i}getExtensionPoints(){return Array.from(this.a.values())}}e.ExtensionsRegistryImpl=b;const g={ExtensionsRegistry:"ExtensionsRegistry"};A.Registry.add(g.ExtensionsRegistry,new b),e.ExtensionsRegistry=A.Registry.as(g.ExtensionsRegistry),v.registerSchema(h,e.schema),v.registerSchema(L.productSchemaId,{properties:{extensionEnabledApiProposals:{description:o.localize(77,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(D.allApiProposals),markdownEnumDescriptions:Object.values(D.allApiProposals)}}]}}}})}),define(ye[240],Ce([1,0,188,11,23,239,53,3]),function(te,e,o,t,T,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const y={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:o.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:o.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:o.localize(2,null),default:""}}};var D;(function(v){function C(E,f,d){if(!E)return;const h=t.isString(E.type)?E.type:void 0;if(!h||h.length===0){d.error(o.localize(3,null));return}const b=[];if(Array.isArray(E.required))for(const g of E.required)t.isString(g)&&b.push(g);return{extensionId:f.value,taskType:h,required:b,properties:E.properties?T.deepClone(E.properties):{},when:E.when?I.ContextKeyExpr.deserialize(E.when):void 0}}v.from=C})(D||(D={}));const L=R.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:o.localize(4,null),type:"array",items:y}});class P{constructor(){this.d=new A.Emitter,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((C,E)=>{L.setHandler((f,d)=>{this.c=void 0;try{for(const h of d.removed){const b=h.value;for(const g of b)this.a&&g.type&&this.a[g.type]&&delete this.a[g.type]}for(const h of d.added){const b=h.value;for(const g of b){const p=D.from(g,h.description.identifier,h.collector);p&&(this.a[p.taskType]=p)}}(d.removed.length>0||d.added.length>0)&&this.d.fire()}catch{}C(void 0)})})}onReady(){return this.b}get(C){return this.a[C]}all(){return Object.keys(this.a).map(C=>this.a[C])}getJsonSchema(){if(this.c===void 0){const C=[];for(const E of this.all()){const f={type:"object",additionalProperties:!1};E.required.length>0&&(f.required=E.required.slice(0)),E.properties!==void 0?f.properties=T.deepClone(E.properties):f.properties=Object.create(null),f.properties.type={type:"string",enum:[E.taskType]},C.push(f)}this.c={oneOf:C}}return this.c}}e.TaskDefinitionRegistry=new P}),define(ye[241],Ce([1,0,189,11,24,23,53,240]),function(te,e,o,t,T,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new I.RawContextKey("taskRunning",!1,o.localize(0,null)),e.TASKS_CATEGORY={value:o.localize(1,null),original:"Tasks"};var y;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(y=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(N){function B(j){if(!j)return N.Strong;switch(j.toLowerCase()){case"escape":return N.Escape;case"strong":return N.Strong;case"weak":return N.Weak;default:return N.Strong}}N.from=B}(y=e.ShellQuoting||(e.ShellQuoting={}));var D;(function(N){N.defaults={cwd:"${workspaceFolder}"}})(D=e.CommandOptions||(e.CommandOptions={}));var L;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(L=e.RevealKind||(e.RevealKind={})),function(N){function B(j){switch(j.toLowerCase()){case"always":return N.Always;case"silent":return N.Silent;case"never":return N.Never;default:return N.Always}}N.fromString=B}(L=e.RevealKind||(e.RevealKind={}));var P;(function(N){N[N.Never=1]="Never",N[N.OnProblem=2]="OnProblem",N[N.Always=3]="Always"})(P=e.RevealProblemKind||(e.RevealProblemKind={})),function(N){function B(j){switch(j.toLowerCase()){case"always":return N.Always;case"never":return N.Never;case"onproblem":return N.OnProblem;default:return N.OnProblem}}N.fromString=B}(P=e.RevealProblemKind||(e.RevealProblemKind={}));var v;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(v=e.PanelKind||(e.PanelKind={})),function(N){function B(j){switch(j.toLowerCase()){case"shared":return N.Shared;case"dedicated":return N.Dedicated;case"new":return N.New;default:return N.Shared}}N.fromString=B}(v=e.PanelKind||(e.PanelKind={}));var C;(function(N){N.defaults={echo:!0,reveal:L.Always,revealProblems:P.Never,focus:!1,panel:v.Shared,showReuseMessage:!0,clear:!1}})(C=e.PresentationOptions||(e.PresentationOptions={}));var E;(function(N){N[N.Shell=1]="Shell",N[N.Process=2]="Process",N[N.CustomExecution=3]="CustomExecution"})(E=e.RuntimeType||(e.RuntimeType={})),function(N){function B(z){switch(z.toLowerCase()){case"shell":return N.Shell;case"process":return N.Process;case"customExecution":return N.CustomExecution;default:return N.Process}}N.fromString=B;function j(z){switch(z){case N.Shell:return"shell";case N.Process:return"process";case N.CustomExecution:return"customExecution";default:return"process"}}N.toString=j}(E=e.RuntimeType||(e.RuntimeType={}));var f;(function(N){function B(j){return t.isString(j)?j:j.value}N.value=B})(f=e.CommandString||(e.CommandString={}));var d;(function(N){N.Clean={_id:"clean",isDefault:!1},N.Build={_id:"build",isDefault:!1},N.Rebuild={_id:"rebuild",isDefault:!1},N.Test={_id:"test",isDefault:!1};function B(z){return z===N.Clean._id||z===N.Build._id||z===N.Rebuild._id||z===N.Test._id}N.is=B;function j(z){if(z!==void 0)return t.isString(z)?B(z)?{_id:z,isDefault:!1}:void 0:z}N.from=j})(d=e.TaskGroup||(e.TaskGroup={}));var h;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.Folder=3]="Folder"})(h=e.TaskScope||(e.TaskScope={}));var b;(function(N){N.Workspace="workspace",N.Extension="extension",N.InMemory="inMemory",N.WorkspaceFile="workspaceFile",N.User="user";function B(j){switch(j){case N.User:return 2;case N.WorkspaceFile:return 5;default:return 6}}N.toConfigurationTarget=B})(b=e.TaskSourceKind||(e.TaskSourceKind={}));var g;(function(N){N.parallel="parallel",N.sequence="sequence"})(g=e.DependsOrder||(e.DependsOrder={}));var p;(function(N){N[N.default=1]="default",N[N.folderOpen=2]="folderOpen"})(p=e.RunOnOptions||(e.RunOnOptions={}));var w;(function(N){N.defaults={reevaluateOnRerun:!0,runOn:p.default,instanceLimit:1}})(w=e.RunOptions||(e.RunOptions={}));class i{constructor(B,j,z,ne,_,Y){this._label="",this._id=B,j&&(this._label=j),z&&(this.type=z),this.runOptions=ne,this.configurationProperties=_,this._source=Y}getDefinition(B){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const B={folder:this.d(),id:this._id};return JSON.stringify(B)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(B,j=!1){if(B===void 0)return!1;if(t.isString(B))return B===this._label||B===this.configurationProperties.identifier||j&&B===this._id;const z=this.getDefinition(!0);return z!==void 0&&z._key===B._key}getQualifiedLabel(){const B=this.getWorkspaceFolder();return B?`${this._label} (${B.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(B){this.c===void 0&&(this.c=[]),B&&(this.c=this.c.concat(B))}get taskLoadMessages(){return this.c}}e.CommonTask=i;class s extends i{constructor(B,j,z,ne,_,Y,J,Z){super(B,z,void 0,J,Z,j),this.command={},this._source=j,this.hasDefinedMatchers=Y,_&&(this.command=_)}clone(){return new s(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(B=!1){if(B&&this._source.customizes!==void 0)return this._source.customizes;{let j;switch(this.command?this.command.runtime:void 0){case E.Shell:j="shell";break;case E.Process:j="process";break;case E.CustomExecution:j="customExecution";break;case void 0:j="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:j,_key:this._id,id:this._id}}}static is(B){return B instanceof s}getMapKey(){const B=this._source.config.workspaceFolder;return B?`${B.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===b.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const B=this.d();if(!B)return;let j=this.configurationProperties.identifier;this._source.kind!==b.Workspace&&(j+=this._source.kind);const z={type:e.CUSTOMIZED_TASK_TYPE,folder:B,id:j};return JSON.stringify(z)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?T.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(B){return new s(B._id,B._source,B._label,B.type,B.command,B.hasDefinedMatchers,B.runOptions,B.configurationProperties)}}e.CustomTask=s;class a extends i{constructor(B,j,z,ne,_,Y,J){super(B,z,ne,Y,J,j),this._source=j,this.configures=_}static is(B){return B instanceof a}f(B){return B}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?T.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===b.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const B=this.d();if(!B)return;let j=this.configurationProperties.identifier;this._source.kind!==b.Workspace&&(j+=this._source.kind);const z={type:e.CUSTOMIZED_TASK_TYPE,folder:B,id:j};return JSON.stringify(z)}}e.ConfiguringTask=a;class u extends i{constructor(B,j,z,ne,_,Y,J,Z,ie){super(B,z,ne,Z,ie,j),this.defines=_,this.hasDefinedMatchers=J,this.command=Y,this.icon=ie.icon,this.hide=ie.hide}clone(){return new u(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(B){return B instanceof u}getMapKey(){const B=this._source.workspaceFolder;return B?`${this._source.scope.toString()}|${B.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const B={type:"contributed",scope:this._source.scope,id:this._id};return B.folder=this.d(),JSON.stringify(B)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(B){return new u(B._id,B._source,B._label,B.type,B.defines,B.command,B.hasDefinedMatchers,B.runOptions,B.configurationProperties)}}e.ContributedTask=u;class l extends i{constructor(B,j,z,ne,_,Y){super(B,z,ne,_,Y,j),this._source=j}clone(){return new l(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(B){return B instanceof l}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(B){return new l(B._id,B._source,B._label,B.type,B.runOptions,B.configurationProperties)}}e.InMemoryTask=l;var c;(function(N){N[N.Process=1]="Process",N[N.Terminal=2]="Terminal"})(c=e.ExecutionEngine||(e.ExecutionEngine={})),function(N){N._default=N.Terminal}(c=e.ExecutionEngine||(e.ExecutionEngine={}));var n;(function(N){N[N.V0_1_0=1]="V0_1_0",N[N.V2_0_0=2]="V2_0_0"})(n=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class r{constructor(B){this.c=new Map;for(let j=0;j<B.length;j++)this.c.set(B[j].uri.toString(),j)}compare(B,j){const z=B.getWorkspaceFolder(),ne=j.getWorkspaceFolder();if(z&&ne){let _=this.c.get(z.uri.toString());_=_===void 0?0:_+1;let Y=this.c.get(ne.uri.toString());return Y=Y===void 0?0:Y+1,_===Y?B._label.localeCompare(j._label):_-Y}else return!z&&ne?-1:z&&!ne?1:0}}e.TaskSorter=r;var m;(function(N){N.DependsOnStarted="dependsOnStarted",N.AcquiredInput="acquiredInput",N.Start="start",N.ProcessStarted="processStarted",N.Active="active",N.Inactive="inactive",N.Changed="changed",N.Terminated="terminated",N.ProcessEnded="processEnded",N.End="end"})(m=e.TaskEventKind||(e.TaskEventKind={}));var S;(function(N){N.SingleRun="singleRun",N.Background="background"})(S=e.TaskRunType||(e.TaskRunType={}));var k;(function(N){N[N.System=0]="System",N[N.User=1]="User",N[N.FolderOpen=2]="FolderOpen",N[N.ConfigurationChange=3]="ConfigurationChange",N[N.Reconnect=4]="Reconnect"})(k=e.TaskRunSource||(e.TaskRunSource={}));var M;(function(N){function B(j,z,ne,_){if(z){const Y={kind:j,taskId:z._id,taskName:z.configurationProperties.name,runType:z.configurationProperties.isBackground?"background":"singleRun",group:z.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:ne,__task:z};return j==="start"?Y.resolvedVariables=_:j==="processStarted"?Y.processId=_:j==="processEnded"&&(Y.exitCode=_),Object.freeze(Y)}else return Object.freeze({kind:"changed"})}N.create=B})(M=e.TaskEvent||(e.TaskEvent={}));var q;(function(N){function B(z){const ne=Object.keys(z).sort();let _="";for(const Y of ne){let J=z[Y];J instanceof Object?J=B(J):typeof J=="string"&&(J=J.replace(/,/g,",,")),_+=Y+","+J+","}return _}function j(z){const _={_key:B(z),type:z.taskType};return Object.assign(_,z),_}N.create=j})(q=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var V;(function(N){N.AutoDetect="task.autoDetect",N.SaveBeforeRun="task.saveBeforeRun",N.ShowDecorations="task.showDecorations",N.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",N.SlowProviderWarning="task.slowProviderWarning",N.QuickOpenHistory="task.quickOpen.history",N.QuickOpenDetail="task.quickOpen.detail",N.QuickOpenSkip="task.quickOpen.skip",N.QuickOpenShowAll="task.quickOpen.showAll",N.AllowAutomaticTasks="task.allowAutomaticTasks",N.Reconnection="task.reconnection"})(V=e.TaskSettingId||(e.TaskSettingId={}));var F;(function(N){N.Tasks="tasks",N.SuppressTaskName="tasks.suppressTaskName",N.Windows="tasks.windows",N.Osx="tasks.osx",N.Linux="tasks.linux",N.ShowOutput="tasks.showOutput",N.IsShellCommand="tasks.isShellCommand",N.ServiceTestSetting="tasks.service.testSetting"})(F=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var U;(function(N){function B(j,z){const ne=A.TaskDefinitionRegistry.get(j.type);if(ne===void 0){const Z=R.deepClone(j);return delete Z._key,q.create(Z)}const _=Object.create(null);_.type=ne.taskType;const Y=new Set;ne.required.forEach(Z=>Y.add(Z));const J=ne.properties;for(const Z of Object.keys(J)){const ie=j[Z];if(ie!=null)_[Z]=ie;else if(Y.has(Z)){const X=J[Z];if(X.default!==void 0)_[Z]=R.deepClone(X.default);else switch(X.type){case"boolean":_[Z]=!1;break;case"number":case"integer":_[Z]=0;break;case"string":_[Z]="";break;default:z.error(o.localize(2,null,JSON.stringify(j,void 0,0),Z));return}}}return q.create(_)}N.createTaskIdentifier=B})(U=e.TaskDefinition||(e.TaskDefinition={}))}),define(ye[242],Ce([1,0,9]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class t{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((I,A)=>{this.b=I,this.d=A,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(I){this.f||this.h||(this.f=!0,this.g=I,this.a&&this.b(I))}resolveErr(I){this.f||this.h||(this.h=!0,this.i=I,this.a?this.d(I):(0,o.onUnexpectedError)(I))}then(I,A){return this.j().then(I,A)}catch(I){return this.j().then(void 0,I)}finally(I){return this.j().finally(I)}}e.LazyPromise=t;class T extends t{constructor(){super(),this.h=!0,this.i=new o.CancellationError}}e.CanceledLazyPromise=T}),define(ye[57],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class o{constructor(y){this._proxyIdentifierBrand=void 0,this.sid=y,this.nid=++o.count}}e.ProxyIdentifier=o,o.count=0;const t=[];function T(A){const y=new o(A);return t[y.nid]=y,y}e.createProxyIdentifier=T;function R(A){return t[A].sid}e.getStringIdentifierForProxy=R;class I{constructor(y){this.value=y}}e.SerializableObjectWithBuffers=I}),define(ye[5],Ce([1,0,57]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var t;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(t=e.TextEditorRevealType||(e.TextEditorRevealType={}));var T;(function(f){f[f.UnknownInput=0]="UnknownInput",f[f.TextInput=1]="TextInput",f[f.TextDiffInput=2]="TextDiffInput",f[f.TextMergeInput=3]="TextMergeInput",f[f.NotebookInput=4]="NotebookInput",f[f.NotebookDiffInput=5]="NotebookDiffInput",f[f.CustomEditorInput=6]="CustomEditorInput",f[f.WebviewEditorInput=7]="WebviewEditorInput",f[f.TerminalEditorInput=8]="TerminalEditorInput",f[f.InteractiveEditorInput=9]="InteractiveEditorInput"})(T=e.TabInputKind||(e.TabInputKind={}));var R;(function(f){f[f.TAB_OPEN=0]="TAB_OPEN",f[f.TAB_CLOSE=1]="TAB_CLOSE",f[f.TAB_UPDATE=2]="TAB_UPDATE",f[f.TAB_MOVE=3]="TAB_MOVE"})(R=e.TabModelOperationKind||(e.TabModelOperationKind={}));var I;(function(f){f[f.Editable=0]="Editable",f[f.SupportsHotExit=1]="SupportsHotExit"})(I=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var A;(function(f){f[f.Int8Array=1]="Int8Array",f[f.Uint8Array=2]="Uint8Array",f[f.Uint8ClampedArray=3]="Uint8ClampedArray",f[f.Int16Array=4]="Int16Array",f[f.Uint16Array=5]="Uint16Array",f[f.Int32Array=6]="Int32Array",f[f.Uint32Array=7]="Uint32Array",f[f.Float32Array=8]="Float32Array",f[f.Float64Array=9]="Float64Array",f[f.BigInt64Array=10]="BigInt64Array",f[f.BigUint64Array=11]="BigUint64Array"})(A=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var y;(function(f){f[f.Text=1]="Text",f[f.Error=2]="Error",f[f.Rich=3]="Rich"})(y=e.CellOutputKind||(e.CellOutputKind={}));var D;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(D=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var L;(function(f){f[f.None=0]="None",f[f.Process=1]="Process",f[f.Output=2]="Output"})(L=e.CandidatePortSource||(e.CandidatePortSource={}));class P{static mixin(d){return d._id=P.a++,d}}e.IdObject=P,P.a=0;var v;(function(f){f.label="a",f.kind="b",f.detail="c",f.documentation="d",f.sortText="e",f.filterText="f",f.preselect="g",f.insertText="h",f.insertTextRules="i",f.range="j",f.commitCharacters="k",f.additionalTextEdits="l",f.kindModifier="m",f.commandIdent="n",f.commandId="o",f.commandArguments="p"})(v=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var C;(function(f){f.defaultRanges="a",f.completions="b",f.isIncomplete="c",f.duration="d"})(C=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var E;(function(f){f[f.Workspace=0]="Workspace",f[f.TextDocument=1]="TextDocument"})(E=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,o.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,o.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,o.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,o.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,o.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,o.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,o.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,o.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,o.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,o.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,o.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,o.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,o.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,o.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,o.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,o.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,o.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,o.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,o.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,o.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,o.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,o.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,o.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,o.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,o.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,o.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,o.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,o.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,o.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,o.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,o.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,o.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,o.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,o.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,o.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,o.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,o.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,o.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,o.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,o.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,o.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,o.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,o.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,o.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,o.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,o.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,o.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,o.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,o.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,o.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,o.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,o.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,o.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,o.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,o.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,o.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,o.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,o.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,o.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,o.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,o.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,o.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,o.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,o.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,o.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,o.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,o.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,o.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,o.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,o.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,o.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,o.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,o.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,o.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,o.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,o.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,o.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,o.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,o.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,o.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,o.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,o.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,o.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,o.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,o.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,o.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,o.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,o.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,o.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,o.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,o.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,o.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,o.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,o.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,o.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,o.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,o.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,o.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,o.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,o.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,o.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,o.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,o.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,o.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,o.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,o.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,o.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,o.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,o.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,o.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,o.createProxyIdentifier)("ExtHostLocalization")}}),define(ye[71],Ce([1,0,4,13,5,17]),function(te,e,o,t,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,o.createDecorator)("IExtHostApiDeprecationService");let I=class{constructor(y,D){this.c=D,this.a=new Set,this.b=y.getProxy(T.MainContext.MainThreadTelemetry)}report(y,D,L){const P=this.d(y,D);this.a.has(P)||(this.a.add(P),D.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${y}' is deprecated. ${L}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:D.identifier.value,apiId:y}))}d(y,D){return`${y}-${D.identifier.value}`}};I=qe([We(0,R.IExtHostRpcService),We(1,t.ILogService)],I),e.ExtHostApiDeprecationService=I,e.NullApiDeprecationService=Object.freeze(new class{report(A,y,D){}})}),define(ye[243],Ce([1,0,3,5,7,26]),function(te,e,o,t,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class I{constructor(y){this.b=new Map,this.c=[],this.d=new o.Emitter,this.onDidChangeSessions=this.d.event,this.f=new Map,this.a=y.getProxy(t.MainContext.MainThreadAuthentication)}$setProviders(y){return this.c=y,Promise.resolve()}async getSession(y,D,L,P={}){const v=R.ExtensionIdentifier.toKey(y.identifier),C=this.f.get(v)||[],E=[...L].sort().join(" ");let f=C.find(d=>d.providerId===D&&d.scopes===E);if(f)return f.result;{const d=this.g(y,v,D,L,P);f={providerId:D,scopes:E,result:d},C.push(f),this.f.set(v,C);try{await d}finally{const h=C.findIndex(b=>b.providerId===D&&b.scopes===E);h>-1&&(C.splice(h),this.f.set(v,C))}return d}}async g(y,D,L,P,v={}){await this.a.$ensureProvider(L);const C=y.displayName||y.name;return this.a.$getSession(L,P,D,C,v)}async removeSession(y,D){const L=this.b.get(y);return L?L.provider.removeSession(D):this.a.$removeSession(y,D)}registerAuthenticationProvider(y,D,L,P){if(this.b.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this.b.set(y,{label:D,provider:L,options:P??{supportsMultipleAccounts:!1}}),this.c.find(C=>C.id===y)||this.c.push({id:y,label:D});const v=L.onDidChangeSessions(C=>{this.a.$sendDidChangeSessions(y,{added:C.added??[],changed:C.changed??[],removed:C.removed??[]})});return this.a.$registerAuthenticationProvider(y,D,P?.supportsMultipleAccounts??!1),new T.Disposable(()=>{v.dispose(),this.b.delete(y);const C=this.c.findIndex(E=>E.id===y);C>-1&&this.c.splice(C),this.a.$unregisterAuthenticationProvider(y)})}$createSession(y,D){const L=this.b.get(y);if(L)return Promise.resolve(L.provider.createSession(D));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,D){const L=this.b.get(y);if(L)return Promise.resolve(L.provider.removeSession(D));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,D){const L=this.b.get(y);if(L)return Promise.resolve(L.provider.getSessions(D));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,D){return this.d.fire({provider:{id:y,label:D}}),Promise.resolve()}}e.ExtHostAuthentication=I}),define(ye[244],Ce([1,0,5,17,14]),function(te,e,o,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let R=class{constructor(A,y){this.a=A.getProxy(o.MainContext.MainThreadBulkEdits),this.b={getTextDocumentVersion:D=>y.getDocument(D)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(A,y,D){const L=T.WorkspaceEdit.from(A,this.b);return this.a.$tryApplyWorkspaceEdit(L,void 0,D?.isRefactoring??!1)}};R=qe([We(0,t.IExtHostRpcService)],R),e.ExtHostBulkEdits=R}),define(ye[245],Ce([1,0,5]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class t{constructor(R){const I=R.getProxy(o.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return I.$readText()},writeText(A){return I.$writeText(A)}})}}e.ExtHostClipboard=t});var Je=this&&this.__classPrivateFieldSet||function(te,e,o,t,T){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?T.call(te,o):T?T.value=o:e.set(te,o),o},Ue=this&&this.__classPrivateFieldGet||function(te,e,o,t){if(o==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?t:o==="a"?t.call(te):t?t.value:e.get(te)};define(ye[40],Ce([1,0,11,7,14,23,5,18,13,86,35,51,2,6,4,17,137,22,57,45,43,68]),function(te,e,o,t,T,R,I,A,y,D,L,P,v,C,E,f,d,h,b,g,p,w){"use strict";var i,s;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let a=class{constructor(m,S){i.set(this,void 0),this.b=new Map,this.c=new Map,s.set(this,void 0),Je(this,i,m.getProxy(I.MainContext.MainThreadCommands),"f"),this.d=S,Je(this,s,m.getProxy(I.MainContext.MainThreadTelemetry),"f"),this.converter=new u(this,k=>{const M=this.c.get(k);return M?.result===c.Void?M:void 0},S),this.f=[{processArgument(k){return(0,D.revive)(k)}},{processArgument(k){return(0,R.cloneAndChange)(k,function(M){if(L.Range.isIRange(M))return T.Range.to(M);if(P.Position.isIPosition(M))return T.Position.to(M);if(L.Range.isIRange(M.range)&&v.URI.isUri(M.uri))return T.location.to(M);if(M instanceof h.VSBuffer)return M.buffer.buffer;if(!Array.isArray(M))return M})}}]}registerArgumentProcessor(m){this.f.push(m)}registerApiCommand(m){const S=this.registerCommand(!1,m.id,async(...k)=>{const M=m.args.map((V,F)=>{if(!V.validate(k[F]))throw new Error(`Invalid argument '${V.name}' when running '${m.id}', received: ${k[F]}`);return V.convert(k[F])}),q=await this.executeCommand(m.internalId,...M);return m.result.convert(q,k,this.converter)},void 0,{description:m.description,args:m.args,returns:m.result.description});return this.c.set(m.id,m),new t.Disposable(()=>{S.dispose(),this.c.delete(m.id)})}registerCommand(m,S,k,M,q,V){if(this.d.trace("ExtHostCommands#registerCommand",S),!S.trim().length)throw new Error("invalid id");if(this.b.has(S))throw new Error(`command '${S}' already exists`);return this.b.set(S,{callback:k,thisArg:M,description:q,extension:V}),m&&Ue(this,i,"f").$registerCommand(S),new t.Disposable(()=>{this.b.delete(S)&&m&&Ue(this,i,"f").$unregisterCommand(S)})}executeCommand(m,...S){return this.d.trace("ExtHostCommands#executeCommand",m),this.g(m,S,!0)}async g(m,S,k){if(this.b.has(m))return Ue(this,i,"f").$fireCommandActivationEvent(m),this.h(m,S,!1);{let M=!1;const q=(0,R.cloneAndChange)(S,function(V){if(V instanceof t.Position)return T.Position.from(V);if(V instanceof t.Range)return T.Range.from(V);if(V instanceof t.Location)return T.location.from(V);if(t.NotebookRange.isNotebookRange(V))return T.NotebookRange.from(V);if(V instanceof ArrayBuffer)return M=!0,h.VSBuffer.wrap(new Uint8Array(V));if(V instanceof Uint8Array)return M=!0,h.VSBuffer.wrap(V);if(V instanceof h.VSBuffer)return M=!0,V;if(!Array.isArray(V))return V});try{const V=await Ue(this,i,"f").$executeCommand(m,M?new b.SerializableObjectWithBuffers(q):q,k);return(0,D.revive)(V)}catch(V){if(V instanceof Error&&V.message==="$executeCommand:retry")return this.g(m,S,!1);throw V}}}async h(m,S,k){const M=this.b.get(m);if(!M)throw new Error("Unknown command");const{callback:q,thisArg:V,description:F}=M;if(F)for(let N=0;N<F.args.length;N++)try{(0,o.validateConstraint)(S[N],F.args[N].constraint)}catch{throw new Error(`Running the contributed command: '${m}' failed. Illegal argument '${F.args[N].name}' - ${F.args[N].description}`)}const U=p.StopWatch.create();try{return await q.apply(V,S)}catch(N){if(m===this.converter.delegatingCommandId){const B=this.converter.getActualCommand(...S);B&&(m=B.command)}throw this.d.error(N,m,M.extension?.identifier),k?new class extends Error{constructor(){super((0,g.toErrorMessage)(N)),this.id=m,this.source=M.extension?.displayName??M.extension?.name}}:N}finally{this.j(M,m,U.elapsed())}}j(m,S,k){!m.extension||Ue(this,s,"f").$publicLog2("Extension:ActionExecuted",{extensionId:m.extension.identifier.value,id:new w.TelemetryTrustedValue(S),duration:k})}$executeContributedCommand(m,...S){this.d.trace("ExtHostCommands#$executeContributedCommand",m);const k=this.b.get(m);return k?(S=S.map(M=>this.f.reduce((q,V)=>V.processArgument(q,k.extension?.identifier),M)),this.h(m,S,!0)):Promise.reject(new Error(`Contributed command '${m}' does not exist.`))}getCommands(m=!1){return this.d.trace("ExtHostCommands#getCommands",m),Ue(this,i,"f").$getCommands().then(S=>(m&&(S=S.filter(k=>k[0]!=="_")),S))}$getContributedCommandHandlerDescriptions(){const m=Object.create(null);for(const[S,k]of this.b){const{description:M}=k;M&&(m[S]=M)}return Promise.resolve(m)}};i=new WeakMap,s=new WeakMap,a=qe([We(0,f.IExtHostRpcService),We(1,y.ILogService)],a),e.ExtHostCommands=a,e.IExtHostCommands=(0,E.createDecorator)("IExtHostCommands");class u{constructor(m,S,k){this.d=m,this.f=S,this.g=k,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(m,S){if(!m)return;const k={$ident:void 0,id:m.command,title:m.title,tooltip:m.tooltip};if(!m.command)return k;const M=this.f(m.command);if(M)k.id=M.internalId,k.arguments=M.args.map((q,V)=>q.convert(m.arguments&&m.arguments[V]));else if((0,A.isNonEmptyArray)(m.arguments)){const q=`${m.command}/${++this.c}`;this.b.set(q,m),S.add((0,C.toDisposable)(()=>{this.b.delete(q),this.g.trace("CommandsConverter#DISPOSE",q)})),k.$ident=q,k.id=this.delegatingCommandId,k.arguments=[q],this.g.trace("CommandsConverter#CREATE",m.command,q)}return k}fromInternal(m){return typeof m.$ident=="string"?this.b.get(m.$ident):{command:m.id,title:m.title,arguments:m.arguments}}getActualCommand(...m){return this.b.get(m[0])}h(...m){const S=this.getActualCommand(...m);return this.g.trace("CommandsConverter#EXECUTE",m[0],S?S.command:"MISSING"),S?this.d.executeCommand(S.command,...S.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${m[0]}`)}}e.CommandsConverter=u;class l{constructor(m,S,k,M){this.name=m,this.description=S,this.validate=k,this.convert=M}optional(){return new l(this.name,`(optional) ${this.description}`,m=>m==null||this.validate(m),m=>m===void 0?void 0:m===null?null:this.convert(m))}with(m,S){return new l(m??this.name,S??this.description,this.validate,this.convert)}}e.ApiCommandArgument=l,l.Uri=new l("uri","Uri of a text document",r=>v.URI.isUri(r),r=>r),l.Position=new l("position","A position in a text document",r=>t.Position.isPosition(r),T.Position.from),l.Range=new l("range","A range in a text document",r=>t.Range.isRange(r),T.Range.from),l.Selection=new l("selection","A selection in a text document",r=>t.Selection.isSelection(r),T.Selection.from),l.Number=new l("number","",r=>typeof r=="number",r=>r),l.String=new l("string","",r=>typeof r=="string",r=>r),l.CallHierarchyItem=new l("item","A call hierarchy item",r=>r instanceof t.CallHierarchyItem,T.CallHierarchyItem.from),l.TypeHierarchyItem=new l("item","A type hierarchy item",r=>r instanceof t.TypeHierarchyItem,T.TypeHierarchyItem.from),l.TestItem=new l("testItem","A VS Code TestItem",r=>r instanceof d.TestItemImpl,T.TestItem.from);class c{constructor(m,S){this.description=m,this.convert=S}}e.ApiCommandResult=c,c.Void=new c("no result",r=>r);class n{constructor(m,S,k,M,q){this.id=m,this.internalId=S,this.description=k,this.args=M,this.result=q}}e.ApiCommand=n}),define(ye[246],Ce([1,0,2,14,7,66,40,18,119,124,15]),function(te,e,o,t,T,R,I,A,y,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const P=[new I.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",C(t.DocumentHighlight.to))),new I.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(f,d)=>{if((0,A.isFalsyOrEmpty)(f))return;class h extends T.SymbolInformation{static to(g){const p=new h(g.name,t.SymbolKind.to(g.kind),g.containerName||"",new T.Location(d[0],t.Range.to(g.range)));return p.detail=g.detail,p.range=p.location.range,p.selectionRange=t.Range.to(g.selectionRange),p.children=g.children?g.children.map(h.to):[],p}}return f.map(h.to)})),new I.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[I.ApiCommandArgument.Uri,new I.ApiCommandArgument("options","Formatting options",f=>!0,f=>f)],new I.ApiCommandResult("A promise that resolves to an array of TextEdits.",C(t.TextEdit.to))),new I.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range,new I.ApiCommandArgument("options","Formatting options",f=>!0,f=>f)],new I.ApiCommandResult("A promise that resolves to an array of TextEdits.",C(t.TextEdit.to))),new I.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position,new I.ApiCommandArgument("ch","Trigger character",f=>typeof f=="string",f=>f),new I.ApiCommandArgument("options","Formatting options",f=>!0,f=>f)],new I.ApiCommandResult("A promise that resolves to an array of TextEdits.",C(t.TextEdit.to))),new I.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new I.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new I.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new I.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",E)),new I.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location-instances.",C(t.location.to))),new I.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Hover-instances.",C(t.Hover.to))),new I.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[I.ApiCommandArgument.Uri,new I.ApiCommandArgument("position","A position in a text document",f=>Array.isArray(f)&&f.every(d=>T.Position.isPosition(d)),f=>f.map(t.Position.from))],new I.ApiCommandResult("A promise that resolves to an array of ranges.",f=>f.map(d=>{let h;for(const b of d.reverse())h=new T.SelectionRange(t.Range.to(b),h);return h}))),new I.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[I.ApiCommandArgument.String.with("query","Search string")],new I.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",f=>f.map(t.WorkspaceSymbol.to))),new I.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",f=>f.map(t.CallHierarchyItem.to))),new I.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[I.ApiCommandArgument.CallHierarchyItem],new I.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",f=>f.map(t.CallHierarchyIncomingCall.to))),new I.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[I.ApiCommandArgument.CallHierarchyItem],new I.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",f=>f.map(t.CallHierarchyOutgoingCall.to))),new I.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to a range and placeholder text.",f=>{if(!!f)return{range:t.Range.to(f.range),placeholder:f.text}})),new I.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position,I.ApiCommandArgument.String.with("newName","The new symbol name")],new I.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",f=>{if(!!f){if(f.rejectReason)throw new Error(f.rejectReason);return t.WorkspaceEdit.to(f)}})),new I.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new I.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",f=>f.map(t.DocumentLink.to))),new I.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",f=>{if(!!f)return new T.SemanticTokensLegend(f.tokenTypes,f.tokenModifiers)})),new I.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to SemanticTokens.",f=>{if(!f)return;const d=(0,y.decodeSemanticTokensDto)(f);if(d.type==="full")return new T.SemanticTokens(d.data,void 0)})),new I.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range.optional()],new I.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",f=>{if(!!f)return new T.SemanticTokensLegend(f.tokenTypes,f.tokenModifiers)})),new I.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range],new I.ApiCommandResult("A promise that resolves to SemanticTokens.",f=>{if(!f)return;const d=(0,y.decodeSemanticTokensDto)(f);if(d.type==="full")return new T.SemanticTokens(d.data,void 0)})),new I.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position,I.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),I.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new I.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(f,d,h)=>{if(!f)return new T.CompletionList([]);const b=f.suggestions.map(g=>t.CompletionItem.to(g,h));return new T.CompletionList(b,f.incomplete)})),new I.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position,I.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new I.ApiCommandResult("A promise that resolves to SignatureHelp.",f=>{if(f)return t.SignatureHelp.to(f)})),new I.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new I.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(f,d,h)=>C(b=>new T.CodeLens(t.Range.to(b.range),b.command&&h.fromInternal(b.command)))(f))),new I.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[I.ApiCommandArgument.Uri,new I.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",f=>T.Range.isRange(f),f=>T.Selection.isSelection(f)?t.Selection.from(f):t.Range.from(f)),I.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),I.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new I.ApiCommandResult("A promise that resolves to an array of Command-instances.",(f,d,h)=>C(b=>{if(b._isSynthetic){if(!b.command)throw new Error("Synthetic code actions must have a command");return h.fromInternal(b.command)}else{const g=new T.CodeAction(b.title,b.kind?new T.CodeActionKind(b.kind):void 0);return b.edit&&(g.edit=t.WorkspaceEdit.to(b.edit)),b.command&&(g.command=h.fromInternal(b.command)),g.isPreferred=b.isPreferred,g}})(f))),new I.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",f=>f?f.map(d=>new T.ColorInformation(t.Range.to(d.range),t.Color.to(d.color))):[])),new I.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new I.ApiCommandArgument("color","The color to show and insert",f=>f instanceof T.Color,t.Color.from),new I.ApiCommandArgument("context","Context object with uri and range",f=>!0,f=>({uri:f.uri,range:t.Range.from(f.range)}))],new I.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",f=>f?f.map(t.ColorPresentation.to):[])),new I.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range],new I.ApiCommandResult("A promise that resolves to an array of Inlay objects",(f,d,h)=>f.map(t.InlayHint.to.bind(void 0,h)))),new I.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new I.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",C(f=>({viewType:f.viewType,displayName:f.displayName,options:{transientOutputs:f.options.transientOutputs,transientCellMetadata:f.options.transientCellMetadata,transientDocumentMetadata:f.options.transientDocumentMetadata},filenamePattern:f.filenamePattern.map(d=>t.NotebookExclusiveDocumentPattern.to(d))})))),new I.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range],new I.ApiCommandResult("A promise that resolves to an array of InlineValue objects",f=>f.map(t.InlineValue.to))),new I.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new I.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",f=>o.URI.isUri(f)||typeof f=="string"&&(0,D.matchesSomeScheme)(f,L.Schemas.http,L.Schemas.https),f=>f),new I.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",f=>f===void 0||typeof f=="number"||typeof f=="object",f=>f&&(typeof f=="number"?[t.ViewColumn.from(f),void 0]:[t.ViewColumn.from(f.viewColumn),t.TextEditorOpenOptions.from(f)])).optional(),I.ApiCommandArgument.String.with("label","").optional()],I.ApiCommandResult.Void),new I.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[I.ApiCommandArgument.Uri.with("resource","Resource to open"),I.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new I.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",f=>f===void 0||typeof f=="number"||typeof f=="object",f=>f&&(typeof f=="number"?[t.ViewColumn.from(f),void 0]:[t.ViewColumn.from(f.viewColumn),t.TextEditorOpenOptions.from(f)])).optional()],I.ApiCommandResult.Void),new I.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[I.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),I.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),I.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new I.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",f=>f===void 0||typeof f=="object",f=>f&&[t.ViewColumn.from(f.viewColumn),t.TextEditorOpenOptions.from(f)]).optional()],I.ApiCommandResult.Void),new I.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",f=>f.map(t.TypeHierarchyItem.to))),new I.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[I.ApiCommandArgument.TypeHierarchyItem],new I.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",f=>f.map(t.TypeHierarchyItem.to))),new I.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[I.ApiCommandArgument.TypeHierarchyItem],new I.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",f=>f.map(t.TypeHierarchyItem.to))),new I.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[I.ApiCommandArgument.TestItem],I.ApiCommandResult.Void),new I.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[I.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],I.ApiCommandResult.Void),new I.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[I.ApiCommandArgument.String.with("name","The context key name"),new I.ApiCommandArgument("value","The context key value",()=>!0,f=>f)],I.ApiCommandResult.Void)];class v{static register(d){P.forEach(d.registerApiCommand,d)}}e.ExtHostApiCommands=v;function C(f){return d=>{if(Array.isArray(d))return d.map(f)}}function E(f){if(!Array.isArray(f))return;const d=[];for(const h of f)R.isLocationLink(h)?d.push(t.DefinitionLink.to(h)):d.push(t.location.to(h));return d}}),define(ye[247],Ce([1,0,16,60,3,6,2,66,26,14,7,27,5]),function(te,e,o,t,T,R,I,A,y,D,L,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function C(E,f,d){const h=E.getProxy(v.MainContext.MainThreadComments);class b{constructor(){this.b=new Map,this.c=new Map,f.registerArgumentProcessor({processArgument:c=>{if(c&&c.$mid===6){const n=this.b.get(c.handle);return n?n.value:c}else if(c&&c.$mid===7){const n=this.b.get(c.commentControlHandle);if(!n)return c;const r=n.getCommentThread(c.commentThreadHandle);return r?r.value:c}else if(c&&(c.$mid===9||c.$mid===8)){const n=this.b.get(c.thread.commentControlHandle);if(!n)return c;const r=n.getCommentThread(c.thread.commentThreadHandle);return r?c.$mid===8?r.value:{thread:r.value,text:c.text}:c}else if(c&&c.$mid===10){const n=this.b.get(c.thread.commentControlHandle);if(!n)return c;const r=n.getCommentThread(c.thread.commentThreadHandle);if(!r)return c;const m=c.commentUniqueId,S=r.getCommentByUniqueId(m);return S||c}else if(c&&c.$mid===11){const n=this.b.get(c.thread.commentControlHandle);if(!n)return c;const r=n.getCommentThread(c.thread.commentThreadHandle);if(!r)return c;const m=c.text,S=c.commentUniqueId,k=r.getCommentByUniqueId(S);return k?(typeof k.body=="string"?k.body=m:k.body=new L.MarkdownString(m),k):c}return c}})}createCommentController(c,n,r){const m=b.a++,S=new p(c,m,n,r);this.b.set(S.handle,S);const k=this.c.get(y.ExtensionIdentifier.toKey(c.identifier))||[];return k.push(S),this.c.set(y.ExtensionIdentifier.toKey(c.identifier),k),S.value}$createCommentThreadTemplate(c,n,r){const m=this.b.get(c);!m||m.$createCommentThreadTemplate(n,r)}async $updateCommentThreadTemplate(c,n,r){const m=this.b.get(c);!m||m.$updateCommentThreadTemplate(n,r)}$deleteCommentThread(c,n){this.b.get(c)?.$deleteCommentThread(n)}$provideCommentingRanges(c,n,r){const m=this.b.get(c);if(!m||!m.commentingRangeProvider)return Promise.resolve(void 0);const S=d.getDocument(I.URI.revive(n));return(0,o.asPromise)(()=>m.commentingRangeProvider.provideCommentingRanges(S,r)).then(k=>k?k.map(M=>D.Range.from(M)):void 0)}$toggleReaction(c,n,r,m,S){const k=this.b.get(c);return!k||!k.reactionHandler?Promise.resolve(void 0):(0,o.asPromise)(()=>{const M=k.getCommentThread(n);if(M){const q=M.getCommentByUniqueId(m.uniqueIdInThread);if(k!==void 0&&q&&k.reactionHandler)return k.reactionHandler(q,s(S))}return Promise.resolve(void 0)})}dispose(){}}b.a=0;class g{set threadId(c){this.n=c}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(c){c.isEqual(this.p)||(this.p=c,this.b.range=c,this.c.fire())}get range(){return this.p}set canReply(c){this.d!==c&&(this.d=c,this.b.canReply=c,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(c){this.e=c,this.b.label=c,this.c.fire()}get contextValue(){return this.f}set contextValue(c){this.f=c,this.b.contextValue=c,this.c.fire()}get comments(){return this.q}set comments(c){this.q=c,this.b.comments=c,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(c){this.g=c,this.b.collapsibleState=c,this.c.fire()}get state(){return(0,P.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this.h}set state(c){(0,P.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this.h=c,this.b.state=c,this.c.fire()}get isDisposed(){return this.j}constructor(c,n,r,m,S,k,M,q){this.m=n,this.n=r,this.o=m,this.p=S,this.q=k,this.extensionDescription=M,this.r=q,this.handle=g.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new T.Emitter,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new R.MutableDisposable,this.l.value=new R.DisposableStore,this.n===void 0&&(this.n=`${c}.${this.handle}`),h.$createCommentThread(n,this.handle,this.n,this.o,D.Range.from(this.p),M.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=k,this.i.push({dispose:()=>{h.$deleteCommentThread(n,this.handle)}});const V=this;this.value={get uri(){return V.uri},get range(){return V.range},set range(F){V.range=F},get comments(){return V.comments},set comments(F){V.comments=F},get collapsibleState(){return V.collapsibleState},set collapsibleState(F){V.collapsibleState=F},get canReply(){return V.canReply},set canReply(F){V.canReply=F},get contextValue(){return V.contextValue},set contextValue(F){V.contextValue=F},get label(){return V.label},set label(F){V.label=F},get state(){return V.state},set state(F){V.state=F},dispose:()=>{V.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new R.DisposableStore);const c=r=>Object.prototype.hasOwnProperty.call(this.b,r),n={};c("range")&&(n.range=D.Range.from(this.p)),c("label")&&(n.label=this.label),c("contextValue")&&(n.contextValue=this.contextValue??null),c("comments")&&(n.comments=this.q.map(r=>w(this,r,this.k))),c("collapsibleState")&&(n.collapseState=a(this.g)),c("canReply")&&(n.canReply=this.canReply),c("state")&&(n.state=u(this.h)),c("isTemplate")&&(n.isTemplate=this.r),this.b={},h.$updateCommentThread(this.m,this.handle,this.n,this.o,n)}getCommentByUniqueId(c){for(const n of this.k){const r=n[0],m=n[1];if(c===m)return r}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(c=>c.dispose())}}g.a=0,qe([(0,t.debounce)(100)],g.prototype,"eventuallyUpdateCommentThread",null);class p{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(c){this.b=c,h.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(c){this.c=c,h.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!c})}get options(){return this.d}set options(c){this.d=c,h.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(c,n,r,m){this.f=c,this.g=n,this.h=r,this.i=m,this.a=new Map,h.$registerCommentController(this.handle,r,m);const S=this;this.value=Object.freeze({id:S.id,label:S.label,get options(){return S.options},set options(k){S.options=k},get commentingRangeProvider(){return S.commentingRangeProvider},set commentingRangeProvider(k){S.commentingRangeProvider=k},get reactionHandler(){return S.reactionHandler},set reactionHandler(k){S.reactionHandler=k},createCommentThread(k,M,q){return S.createCommentThread(k,M,q).value},dispose:()=>{S.dispose()}}),this.e=[],this.e.push({dispose:()=>{h.$unregisterCommentController(this.handle)}})}createCommentThread(c,n,r,m){if(typeof c=="string"){const S=new g(this.id,this.handle,c,n,r,m,this.f,!1);return this.a.set(S.handle,S),S}else{const S=new g(this.id,this.handle,void 0,c,n,r,this.f,!1);return this.a.set(S.handle,S),S}}$createCommentThreadTemplate(c,n){const r=new g(this.id,this.handle,void 0,I.URI.revive(c),D.Range.to(n),[],this.f,!0);return r.collapsibleState=A.CommentThreadCollapsibleState.Expanded,this.a.set(r.handle,r),r}$updateCommentThreadTemplate(c,n){const r=this.a.get(c);r&&(r.range=D.Range.to(n))}$deleteCommentThread(c){this.a.get(c)?.dispose(),this.a.delete(c)}getCommentThread(c){return this.a.get(c)}dispose(){this.a.forEach(c=>{c.dispose()}),this.e.forEach(c=>c.dispose())}}function w(l,c,n){let r=n.get(c);r||(r=++l.commentHandle,n.set(c,r));const m=c.author&&c.author.iconPath?c.author.iconPath.toString():void 0;return{mode:c.mode,contextValue:c.contextValue,uniqueIdInThread:r,body:typeof c.body=="string"?c.body:D.MarkdownString.from(c.body),userName:c.author.name,userIconPath:m,label:c.label,commentReactions:c.reactions?c.reactions.map(S=>i(S)):void 0,timestamp:c.timestamp?.toJSON()}}function i(l){return{label:l.label,iconPath:l.iconPath?D.pathOrURIToURI(l.iconPath):void 0,count:l.count,hasReacted:l.authorHasReacted}}function s(l){return{label:l.label||"",count:l.count||0,iconPath:l.iconPath?I.URI.revive(l.iconPath):"",authorHasReacted:l.hasReacted||!1}}function a(l){if(l!==void 0)switch(l){case L.CommentThreadCollapsibleState.Expanded:return A.CommentThreadCollapsibleState.Expanded;case L.CommentThreadCollapsibleState.Collapsed:return A.CommentThreadCollapsibleState.Collapsed}return A.CommentThreadCollapsibleState.Collapsed}function u(l){if(l!==void 0)switch(l){case L.CommentThreadState.Unresolved:return A.CommentThreadState.Unresolved;case L.CommentThreadState.Resolved:return A.CommentThreadState.Resolved}return A.CommentThreadState.Unresolved}return new b}e.createExtHostComments=C}),define(ye[248],Ce([1,0,23,5,25,17]),function(te,e,o,t,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let I=class{constructor(L,P){this.a=L.getProxy(t.MainContext.MainThreadConsole),this.b=P.consoleForward.includeStack,this.c=P.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(L,P){const v=this,C=console[L];Object.defineProperty(console,L,{set:()=>{},get:()=>function(){v.e(L,P,C,arguments)}})}e(L,P,v,C){this.a.$logExtensionHostMessage({type:"__$console",severity:P,arguments:y(C,this.b)}),this.c&&this.f(L,v,C)}};I=qe([We(0,R.IExtHostRpcService),We(1,T.IExtHostInitDataService)],I),e.AbstractExtHostConsoleForwarder=I;const A=1e5;function y(D,L){const P=[];if(D.length)for(let v=0;v<D.length;v++){let C=D[v];if(typeof C>"u")C="undefined";else if(C instanceof Error){const E=C;E.stack?C=E.stack:C=E.toString()}P.push(C)}if(L){const v=new Error().stack;v&&P.push({__$stack:v.split(`
`).slice(3).join(`
`)})}try{const v=(0,o.safeStringify)(P);return v.length>A?"Output omitted for a large object that exceeds the limits":v}catch(v){return`Output omitted for an object that cannot be inspected ('${v.toString()}')`}}}),define(ye[139],Ce([1,0,2,5,7,4,17,13,18,8,10,27]),function(te,e,o,t,T,R,I,A,y,D,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let v=class Un{constructor(E,f){this.h=f,this.f=new Map,this.g=E.getProxy(t.MainContext.MainThreadDecorations)}registerFileDecorationProvider(E,f){const d=Un.c++;this.f.set(d,{provider:E,extensionDescription:f}),this.g.$registerDecorationProvider(d,f.identifier.value);const h=E.onDidChangeFileDecorations&&E.onDidChangeFileDecorations(b=>{if(!b){this.g.$onDidChange(d,null);return}const g=(0,y.asArray)(b);if(g.length<=Un.d){this.g.$onDidChange(d,g);return}this.h.warn("[Decorations] CAPPING events from decorations provider",f.identifier.value,g.length);const p=g.map(s=>({uri:s,rank:(0,D.count)(s.path,"/")})),w=(0,y.groupBy)(p,(s,a)=>s.rank-a.rank||(0,D.compare)(s.uri.path,a.uri.path)),i=[];e:for(const s of w){let a;for(const u of s){const l=(0,L.dirname)(u.uri.path);if(a!==l&&(a=l,i.push(u.uri)>=Un.d))break e}}this.g.$onDidChange(d,i)});return new T.Disposable(()=>{h?.dispose(),this.g.$unregisterDecorationProvider(d),this.f.delete(d)})}async $provideDecorations(E,f,d){if(!this.f.has(E))return Object.create(null);const h=Object.create(null),{provider:b,extensionDescription:g}=this.f.get(E);return await Promise.all(f.map(async p=>{try{const{uri:w,id:i}=p,s=await Promise.resolve(b.provideFileDecoration(o.URI.revive(w),d));if(!s)return;try{T.FileDecoration.validate(s),s.badge&&typeof s.badge!="string"&&(0,P.checkProposedApiEnabled)(g,"codiconDecoration"),h[i]=[s.propagate,s.tooltip,s.badge,s.color]}catch(a){this.h.warn(`INVALID decoration from extension '${g}': ${a}`)}}catch(w){this.h.error(w)}})),h}};v.c=0,v.d=250,v=qe([We(0,I.IExtHostRpcService),We(1,A.ILogService)],v),e.ExtHostDecorations=v,e.IExtHostDecorations=(0,R.createDecorator)("IExtHostDecorations")});var Je=this&&this.__classPrivateFieldSet||function(te,e,o,t,T){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?T.call(te,o):T?T.value=o:e.set(te,o),o},Ue=this&&this.__classPrivateFieldGet||function(te,e,o,t){if(o==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?t:o==="a"?t.call(te):t?t.value:e.get(te)};define(ye[249],Ce([1,0,175,123,2,5,7,14,3,13,28,48]),function(te,e,o,t,T,R,I,A,y,D,L,P){"use strict";var v,C,E;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class f{constructor(b,g,p,w,i,s,a){this.d=b,this.e=g,this.f=p,this.g=w,v.set(this,void 0),C.set(this,void 0),E.set(this,void 0),this.c=!1,Je(this,E,new L.ResourceMap(u=>i.getComparisonKey(u)),"f"),Je(this,v,s,"f"),Je(this,C,a,"f")}dispose(){this.c||(Ue(this,C,"f").fire([...Ue(this,E,"f").keys()]),Ue(this,v,"f")?.$clear(this.e),Ue(this,E,"f").clear(),this.c=!0)}get name(){return this.h(),this.d}set(b,g){if(!b){this.clear();return}this.h();let p=[];if(T.URI.isUri(b)){if(!g){this.delete(b);return}Ue(this,E,"f").set(b,g.slice()),p=[b]}else if(Array.isArray(b)){p=[];let i;b=[...b].sort(f.j);for(const s of b){const[a,u]=s;if((!i||a.toString()!==i.toString())&&(i&&Ue(this,E,"f").get(i).length===0&&Ue(this,E,"f").delete(i),i=a,p.push(a),Ue(this,E,"f").set(a,[])),u)Ue(this,E,"f").get(a)?.push(...u);else{const l=Ue(this,E,"f").get(a);l&&(l.length=0)}}}if(Ue(this,C,"f").fire(p),!Ue(this,v,"f"))return;const w=[];for(const i of p){let s=[];const a=Ue(this,E,"f").get(i);if(a)if(a.length>this.f){s=[];const u=[I.DiagnosticSeverity.Error,I.DiagnosticSeverity.Warning,I.DiagnosticSeverity.Information,I.DiagnosticSeverity.Hint];e:for(let l=0;l<4;l++)for(const c of a)if(c.severity===u[l]&&s.push({...A.Diagnostic.from(c),modelVersionId:this.g(i)})===this.f)break e;s.push({severity:t.MarkerSeverity.Info,message:(0,o.localize)(0,null,a.length-this.f),startLineNumber:s[s.length-1].startLineNumber,startColumn:s[s.length-1].startColumn,endLineNumber:s[s.length-1].endLineNumber,endColumn:s[s.length-1].endColumn})}else s=a.map(u=>({...A.Diagnostic.from(u),modelVersionId:this.g(i)}));w.push([i,s])}Ue(this,v,"f").$changeMany(this.e,w)}delete(b){this.h(),Ue(this,C,"f").fire([b]),Ue(this,E,"f").delete(b),Ue(this,v,"f")?.$changeMany(this.e,[[b,void 0]])}clear(){this.h(),Ue(this,C,"f").fire([...Ue(this,E,"f").keys()]),Ue(this,E,"f").clear(),Ue(this,v,"f")?.$clear(this.e)}forEach(b,g){this.h();for(const[p,w]of this)b.call(g,p,w,this)}*[(v=new WeakMap,C=new WeakMap,E=new WeakMap,Symbol.iterator)](){this.h();for(const b of Ue(this,E,"f").keys())yield[b,this.get(b)]}get(b){this.h();const g=Ue(this,E,"f").get(b);return Array.isArray(g)?Object.freeze(g.slice(0)):[]}has(b){return this.h(),Array.isArray(Ue(this,E,"f").get(b))}h(){if(this.c)throw new Error("illegal state - object is disposed")}static j(b,g){return b[0].toString()<g[0].toString()?-1:b[0].toString()>g[0].toString()?1:0}}e.DiagnosticCollection=f;let d=class wn{static _mapper(b){const g=new L.ResourceMap;for(const p of b)g.set(p,p);return{uris:Object.freeze(Array.from(g.values()))}}constructor(b,g,p,w){this.h=g,this.j=p,this.k=w,this.f=new Map,this.g=new y.DebounceEmitter({merge:i=>i.flat(),delay:50}),this.onDidChangeDiagnostics=y.Event.map(this.g.event,wn._mapper),this.e=b.getProxy(R.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(b,g){const{f:p,e:w,g:i,h:s,j:a,k:u}=this,l=new class{$changeMany(r,m){w.$changeMany(r,m),s.trace("[DiagnosticCollection] change many (extension, owner, uris)",b.value,r,m.length===0?"CLEARING":m)}$clear(r){w.$clear(r),s.trace("[DiagnosticCollection] remove all (extension, owner)",b.value,r)}dispose(){w.dispose()}};let c;if(!g)g="_generated_diagnostic_collection_name_#"+wn.c++,c=g;else if(!p.has(g))c=g;else{this.h.warn(`DiagnosticCollection with name '${g}' does already exist.`);do c=g+wn.c++;while(p.has(c))}return new class extends f{constructor(){super(g,c,wn.d,r=>u.getDocument(r)?.version,a.extUri,l,i),p.set(c,this)}dispose(){super.dispose(),p.delete(c)}}}getDiagnostics(b){if(b)return this.l(b);{const g=new Map,p=[];for(const w of this.f.values())w.forEach((i,s)=>{let a=g.get(i.toString());typeof a>"u"&&(a=p.length,g.set(i.toString(),a),p.push([i,[]])),p[a][1]=p[a][1].concat(...s)});return p}}l(b){let g=[];for(const p of this.f.values())p.has(b)&&(g=g.concat(p.get(b)));return g}$acceptMarkersChange(b){if(!this.m){const g="_generated_mirror",p=new f(g,g,wn.d,w=>{},this.j.extUri,void 0,this.g);this.f.set(g,p),this.m=p}for(const[g,p]of b)this.m.set(T.URI.revive(g),p.map(A.Diagnostic.to))}};d.c=0,d.d=1e3,d=qe([We(1,D.ILogService),We(2,P.IExtHostFileSystemInfo)],d),e.ExtHostDiagnostics=d}),define(ye[250],Ce([1,0,2,5]),function(te,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class T{constructor(I){this.a=I.getProxy(t.MainContext.MainThreadDialogs)}showOpenDialog(I){return this.a.$showOpenDialog(I).then(A=>A?A.map(y=>o.URI.revive(y)):void 0)}showSaveDialog(I){return this.a.$showSaveDialog(I).then(A=>A?o.URI.revive(A):void 0)}}e.ExtHostDialogs=T}),define(ye[251],Ce([1,0,9,2,7,5,15,21,8]),function(te,e,o,t,T,R,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class D{constructor(P,v,C){this.d=v,this.e=C,this.b=new Map,this.c=P.getProxy(R.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(P,v){if(Object.keys(I.Schemas).indexOf(P)>=0)throw new Error(`scheme '${P}' already registered`);const C=D.a++;this.b.set(C,v),this.c.$registerTextContentProvider(C,P);let E;return typeof v.onDidChange=="function"&&(E=v.onDidChange(f=>{if(f.scheme!==P){this.e.warn(`Provider for scheme '${P}' is firing event for schema '${f.scheme}' which will be IGNORED`);return}this.d.getDocument(f)&&this.$provideTextDocumentContent(C,f).then(d=>{if(!d&&typeof d!="string")return;const h=this.d.getDocument(f);if(!h)return;const b=(0,y.splitLines)(d);if(!h.equalLines(b))return this.c.$onVirtualDocumentChange(f,d)},o.onUnexpectedError)})),new T.Disposable(()=>{this.b.delete(C)&&this.c.$unregisterTextContentProvider(C),E&&(E.dispose(),E=void 0)})}$provideTextDocumentContent(P,v){const C=this.b.get(P);return C?Promise.resolve(C.provideTextDocumentContent(t.URI.revive(v),A.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${v.scheme}`))}}e.ExtHostDocumentContentProvider=D,D.a=0}),define(ye[252],Ce([1,0,3,6,2,5,135,14,11,23,7]),function(te,e,o,t,T,R,I,A,y,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class P{constructor(C,E){this.a=new o.Emitter,this.b=new o.Emitter,this.c=new o.Emitter,this.d=new o.Emitter,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new t.DisposableStore,this.h=new Map,this.f=C.getProxy(R.MainContext.MainThreadDocuments),this.g=E,this.g.onDidRemoveDocuments(f=>{for(const d of f)this.b.fire(d.document)},void 0,this.e),this.g.onDidAddDocuments(f=>{for(const d of f)this.a.fire(d.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(C){if(!C)return;const E=this.g.getDocument(C);if(E)return E}getDocument(C){const E=this.getDocumentData(C);if(!E?.document)throw new Error(`Unable to retrieve document from URI '${C}'`);return E.document}ensureDocumentData(C){const E=this.g.getDocument(C);if(E)return Promise.resolve(E);let f=this.h.get(C.toString());return f||(f=this.f.$tryOpenDocument(C).then(d=>{this.h.delete(C.toString());const h=T.URI.revive(d);return(0,y.assertIsDefined)(this.g.getDocument(h))},d=>(this.h.delete(C.toString()),Promise.reject(d))),this.h.set(C.toString(),f)),f}createDocumentData(C){return this.f.$tryCreateDocument(C).then(E=>T.URI.revive(E))}$acceptModelLanguageChanged(C,E){const f=T.URI.revive(C),d=this.g.getDocument(f);if(!d)throw new Error("unknown document");this.b.fire(d.document),d._acceptLanguageId(E),this.a.fire(d.document)}$acceptModelSaved(C){const E=T.URI.revive(C),f=this.g.getDocument(E);if(!f)throw new Error("unknown document");this.$acceptDirtyStateChanged(C,!1),this.d.fire(f.document)}$acceptDirtyStateChanged(C,E){const f=T.URI.revive(C),d=this.g.getDocument(f);if(!d)throw new Error("unknown document");d._acceptIsDirty(E),this.c.fire({document:d.document,contentChanges:[],reason:void 0})}$acceptModelChanged(C,E,f){const d=T.URI.revive(C),h=this.g.getDocument(d);if(!h)throw new Error("unknown document");h._acceptIsDirty(f),h.onEvents(E);let b;E.isUndoing?b=L.TextDocumentChangeReason.Undo:E.isRedoing&&(b=L.TextDocumentChangeReason.Redo),this.c.fire((0,D.deepFreeze)({document:h.document,contentChanges:E.changes.map(g=>({range:A.Range.to(g.range),rangeOffset:g.rangeOffset,rangeLength:g.rangeLength,text:g.text})),reason:b}))}setWordDefinitionFor(C,E){(0,I.setWordDefinitionFor)(C,E)}}e.ExtHostDocuments=P}),define(ye[58],Ce([1,0,50,3,6,2,4,5,135,17,138,14,13,28,15,62,82]),function(te,e,o,t,T,R,I,A,y,D,L,P,v,C,E,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class h{constructor(p){this.value=p,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let b=class{constructor(p,w){this.h=p,this.i=w,this.a=null,this.b=new Map,this.c=new C.ResourceMap,this.d=new t.Emitter,this.e=new t.Emitter,this.f=new t.Emitter,this.g=new t.Emitter,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(p){this.acceptDocumentsAndEditorsDelta(p)}acceptDocumentsAndEditorsDelta(p){const w=[],i=[],s=[];if(p.removedDocuments)for(const a of p.removedDocuments){const u=R.URI.revive(a),l=this.c.get(u);l?.unref()&&(this.c.delete(u),w.push(l.value))}if(p.addedDocuments)for(const a of p.addedDocuments){const u=R.URI.revive(a.uri);let l=this.c.get(u);if(l&&u.scheme!==E.Schemas.vscodeNotebookCell&&u.scheme!==E.Schemas.vscodeInteractiveInput)throw new Error(`document '${u} already exists!'`);l||(l=new h(new y.ExtHostDocumentData(this.h.getProxy(A.MainContext.MainThreadDocuments),u,a.lines,a.EOL,a.versionId,a.languageId,a.isDirty,a.notebook)),this.c.set(u,l),i.push(l.value)),l.ref()}if(p.removedEditors)for(const a of p.removedEditors){const u=this.b.get(a);this.b.delete(a),u&&s.push(u)}if(p.addedEditors)for(const a of p.addedEditors){const u=R.URI.revive(a.documentUri);o.ok(this.c.has(u),`document '${u}' does not exist`),o.ok(!this.b.has(a.id),`editor '${a.id}' already exists!`);const l=this.c.get(u).value,c=new L.ExtHostTextEditor(a.id,this.h.getProxy(A.MainContext.MainThreadTextEditors),this.i,new d.Lazy(()=>l.document),a.selections.map(P.Selection.to),a.options,a.visibleRanges.map(n=>P.Range.to(n)),typeof a.editorPosition=="number"?P.ViewColumn.to(a.editorPosition):void 0);this.b.set(a.id,c)}p.newActiveEditor!==void 0&&(o.ok(p.newActiveEditor===null||this.b.has(p.newActiveEditor),`active editor '${p.newActiveEditor}' does not exist`),this.a=p.newActiveEditor),(0,T.dispose)(w),(0,T.dispose)(s),p.removedDocuments&&this.e.fire(w),p.addedDocuments&&this.d.fire(i),(p.removedEditors||p.addedEditors)&&this.f.fire(this.allEditors().map(a=>a.value)),p.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(p){return this.c.get(p)?.value}allDocuments(){return f.Iterable.map(this.c.values(),p=>p.value)}getEditor(p){return this.b.get(p)}activeEditor(p){if(!this.a)return;const w=this.b.get(this.a);return p?w:w?.value}allEditors(){return[...this.b.values()]}};b=qe([We(0,D.IExtHostRpcService),We(1,v.ILogService)],b),e.ExtHostDocumentsAndEditors=b,e.IExtHostDocumentsAndEditors=(0,I.createDecorator)("IExtHostDocumentsAndEditors")}),define(ye[59],Ce([1,0,14,5,2,3,4,7,17,11,81]),function(te,e,o,t,T,R,I,A,y,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,I.createDecorator)("IExtHostEditorTabs");class P{constructor(d,h,b){this.e=b,this.d=h,this.acceptDtoUpdate(d)}get apiObject(){if(!this.a){const d=this,h={get isActive(){return d.b.id===d.e()},get label(){return d.b.label},get input(){return d.c},get isDirty(){return d.b.isDirty},get isPinned(){return d.b.isPinned},get isPreview(){return d.b.isPreview},get group(){return d.d.apiObject}};this.a=Object.freeze(h)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(d){this.b=d,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new A.TextTabInput(T.URI.revive(this.b.input.uri));case 2:return new A.TextDiffTabInput(T.URI.revive(this.b.input.original),T.URI.revive(this.b.input.modified));case 3:return new A.TextMergeTabInput(T.URI.revive(this.b.input.base),T.URI.revive(this.b.input.input1),T.URI.revive(this.b.input.input2),T.URI.revive(this.b.input.result));case 6:return new A.CustomEditorTabInput(T.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new A.WebviewEditorTabInput(this.b.input.viewType);case 4:return new A.NotebookEditorTabInput(T.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new A.NotebookDiffEditorTabInput(T.URI.revive(this.b.input.original),T.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new A.TerminalEditorTabInput;case 9:return new A.InteractiveWindowInput(T.URI.revive(this.b.input.uri),T.URI.revive(this.b.input.inputBoxUri));default:return}}}class v{constructor(d,h){this.c=[],this.d="",this.b=d,this.e=h;for(const b of d.tabs)b.isActive&&(this.d=b.id),this.c.push(new P(b,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const d=this,h={get isActive(){return d.b.groupId===d.e()},get viewColumn(){return o.ViewColumn.to(d.b.viewColumn)},get activeTab(){return d.c.find(b=>b.tabId===d.d)?.apiObject},get tabs(){return Object.freeze(d.c.map(b=>b.apiObject))}};this.a=Object.freeze(h)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(d){this.b=d}acceptTabOperation(d){if(d.kind===0){const b=new P(d.tabDto,this,()=>this.activeTabId());return this.c.splice(d.index,0,b),d.tabDto.isActive&&(this.d=b.tabId),b}else if(d.kind===1){const b=this.c.splice(d.index,1)[0];if(!b)throw new Error(`Tab close updated received for index ${d.index} which does not exist`);return b.tabId===this.d&&(this.d=""),b}else if(d.kind===3){if(d.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const b=this.c.splice(d.oldIndex,1)[0];if(!b)throw new Error(`Tab move updated received for index ${d.oldIndex} which does not exist`);return this.c.splice(d.index,0,b),b}const h=this.c.find(b=>b.tabId===d.tabDto.id);if(!h)throw new Error("INVALID tab");return d.tabDto.isActive?this.d=d.tabDto.id:this.d===d.tabDto.id&&!d.tabDto.isActive&&(this.d=""),h.acceptDtoUpdate(d.tabDto),h}activeTabId(){return this.d}}let C=class{constructor(d){this.b=new R.Emitter,this.c=new R.Emitter,this.e=[],this.a=d.getProxy(t.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const d=this,h={onDidChangeTabGroups:d.c.event,onDidChangeTabs:d.b.event,get all(){return Object.freeze(d.e.map(b=>b.apiObject))},get activeTabGroup(){const b=d.d;return(0,D.assertIsDefined)(d.e.find(p=>p.groupId===b)?.apiObject)},close:async(b,g)=>{const p=Array.isArray(b)?b:[b];return p.length?E(p[0])?this.j(p,g):this.i(p,g):!0}};this.f=Object.freeze(h)}return this.f}$acceptEditorTabModel(d){const h=new Set(this.e.map(a=>a.groupId)),b=new Set(d.map(a=>a.groupId)),g=(0,L.diffSets)(h,b),p=this.e.filter(a=>g.removed.includes(a.groupId)).map(a=>a.apiObject),w=[],i=[];this.e=d.map(a=>{const u=new v(a,()=>this.d);return g.added.includes(u.groupId)?w.push(u.apiObject):i.push(u.apiObject),u});const s=(0,D.assertIsDefined)(d.find(a=>a.isActive===!0)?.groupId);s!==void 0&&this.d!==s&&(this.d=s),this.c.fire(Object.freeze({opened:w,closed:p,changed:i}))}$acceptTabGroupUpdate(d){const h=this.e.find(b=>b.groupId===d.groupId);if(!h)throw new Error("Update Group IPC call received before group creation.");h.acceptGroupDtoUpdate(d),d.isActive&&(this.d=d.groupId),this.c.fire(Object.freeze({changed:[h.apiObject],opened:[],closed:[]}))}$acceptTabOperation(d){const h=this.e.find(g=>g.groupId===d.groupId);if(!h)throw new Error("Update Tabs IPC call received before group creation.");const b=h.acceptTabOperation(d);switch(d.kind){case 0:this.b.fire(Object.freeze({opened:[b.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[b.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[b.apiObject]}));return}}g(d){for(const h of this.e)for(const b of h.tabs)if(b.apiObject===d)return b}h(d){return this.e.find(h=>h.apiObject===d)}async i(d,h){const b=[];for(const g of d){const p=this.g(g);if(!p)throw new Error("Tab close: Invalid tab not found!");b.push(p.tabId)}return this.a.$closeTab(b,h)}async j(d,h){const b=[];for(const g of d){const p=this.h(g);if(!p)throw new Error("Group close: Invalid group not found!");b.push(p.groupId)}return this.a.$closeGroup(b,h)}};C=qe([We(0,y.IExtHostRpcService)],C),e.ExtHostEditorTabs=C;function E(f){return f.tabs!==void 0}}),define(ye[253],Ce([1,0,2,5,6,7,14,153,8,22,27]),function(te,e,o,t,T,R,I,A,y,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class P{constructor(){this.a=[]}add(E){this.b=void 0,this.a.push(E)}delete(E){const f=this.a.indexOf(E);f>=0&&(this.a.splice(f,1),this.b=void 0)}c(){if(!this.b){const E=this.a.sort(),f=[];let d,h,b=14,g=14;for(const p of E){let w=d?(0,y.commonPrefixLength)(d,p):0;for(w===0?h=1:h=g;w<p.length;w++)w+1===p.length?(b=g,g=9):g+=1,f.push([h,p.toUpperCase().charCodeAt(w),g]),f.push([h,p.toLowerCase().charCodeAt(w),g]),h=g;d=p,g=b}f.push([9,58,10]),f.push([10,47,12]),this.b=new A.StateMachine(f)}}provideDocumentLinks(E){this.c();const f=[],d=A.LinkComputer.computeLinks({getLineContent(h){return E.lineAt(h-1).text},getLineCount(){return E.lineCount}},this.b);for(const h of d){const b=I.DocumentLink.to(h);b.target&&f.push(b)}return f}}class v{constructor(E,f){this.i=f,this.b=new P,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=E.getProxy(t.MainContext.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(E,f,d,h={}){if(this.d.has(f))throw new Error(`a provider for the scheme '${f}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(E,"*",this.b));const b=this.h++;this.b.add(f),this.d.add(f),this.c.set(b,d);let g=2;h.isCaseSensitive&&(g+=1024),h.isReadonly&&(g+=2048),typeof d.copy=="function"&&(g+=8),typeof d.open=="function"&&typeof d.close=="function"&&typeof d.read=="function"&&typeof d.write=="function"&&((0,L.checkProposedApiEnabled)(E,"fsChunks"),g+=4),this.a.$registerFileSystemProvider(b,f,g).catch(w=>{console.error(`FAILED to register filesystem provider of ${E.identifier.value}-extension for the scheme ${f}`),console.error(w)});const p=d.onDidChangeFile(w=>{const i=[];for(const s of w){const{uri:a,type:u}=s;if(a.scheme!==f)continue;let l;switch(u){case R.FileChangeType.Changed:l=0;break;case R.FileChangeType.Created:l=1;break;case R.FileChangeType.Deleted:l=2;break;default:throw new Error("Unknown FileChangeType")}i.push({resource:a,type:l})}this.a.$onFileSystemChange(b,i)});return(0,T.toDisposable)(()=>{p.dispose(),this.b.delete(f),this.d.delete(f),this.c.delete(b),this.a.$unregisterProvider(b)})}static j(E){const{type:f,ctime:d,mtime:h,size:b,permissions:g}=E;return{type:f,ctime:d,mtime:h,size:b,permissions:g}}$stat(E,f){return Promise.resolve(this.k(E).stat(o.URI.revive(f))).then(d=>v.j(d))}$readdir(E,f){return Promise.resolve(this.k(E).readDirectory(o.URI.revive(f)))}$readFile(E,f){return Promise.resolve(this.k(E).readFile(o.URI.revive(f))).then(d=>D.VSBuffer.wrap(d))}$writeFile(E,f,d,h){return Promise.resolve(this.k(E).writeFile(o.URI.revive(f),d.buffer,h))}$delete(E,f,d){return Promise.resolve(this.k(E).delete(o.URI.revive(f),d))}$rename(E,f,d,h){return Promise.resolve(this.k(E).rename(o.URI.revive(f),o.URI.revive(d),h))}$copy(E,f,d,h){const b=this.k(E);if(!b.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(b.copy(o.URI.revive(f),o.URI.revive(d),h))}$mkdir(E,f){return Promise.resolve(this.k(E).createDirectory(o.URI.revive(f)))}$watch(E,f,d,h){const b=this.k(E).watch(o.URI.revive(d),h);this.f.set(f,b)}$unwatch(E,f){const d=this.f.get(f);d&&(d.dispose(),this.f.delete(f))}$open(E,f,d){const h=this.k(E);if(!h.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(h.open(o.URI.revive(f),d))}$close(E,f){const d=this.k(E);if(!d.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(d.close(f))}$read(E,f,d,h){const b=this.k(E);if(!b.read)throw new Error('FileSystemProvider does not implement "read"');const g=D.VSBuffer.alloc(h);return Promise.resolve(b.read(f,d,g.buffer,0,h)).then(p=>g.slice(0,p))}$write(E,f,d,h){const b=this.k(E);if(!b.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(b.write(f,d,h.buffer,0,h.byteLength))}k(E){const f=this.c.get(E);if(!f){const d=new Error;throw d.name="ENOPRO",d.message="no provider",d}return f}}e.ExtHostFileSystem=v}),define(ye[72],Ce([1,0,5,39,7,22,4,17,48,6]),function(te,e,o,t,T,R,I,A,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let L=class Zt{constructor(v,C){this.b=new Map,this.a=v.getProxy(o.MainContext.MainThreadFileSystem);const E=this;this.value=Object.freeze({async stat(f){try{const d=E.b.get(f.scheme);if(!d)return await E.a.$stat(f);await E.a.$ensureActivation(f.scheme);const h=await d.stat(f);return{type:h.type,ctime:h.ctime,mtime:h.mtime,size:h.size,permissions:h.permissions}}catch(d){Zt.c(d)}},async readDirectory(f){try{const d=E.b.get(f.scheme);return d?(await E.a.$ensureActivation(f.scheme),(await d.readDirectory(f)).slice()):await E.a.$readdir(f)}catch(d){return Zt.c(d)}},async createDirectory(f){try{return await E.a.$mkdir(f)}catch(d){return Zt.c(d)}},async readFile(f){try{const d=E.b.get(f.scheme);return d?(await E.a.$ensureActivation(f.scheme),(await d.readFile(f)).slice()):(await E.a.$readFile(f)).buffer}catch(d){return Zt.c(d)}},async writeFile(f,d){try{return await E.a.$writeFile(f,R.VSBuffer.wrap(d))}catch(h){return Zt.c(h)}},async delete(f,d){try{const h=E.b.get(f.scheme);return h?(await E.a.$ensureActivation(f.scheme),await h.delete(f,{recursive:!1,...d})):await E.a.$delete(f,{recursive:!1,useTrash:!1,...d})}catch(h){return Zt.c(h)}},async rename(f,d,h){try{return await E.a.$rename(f,d,{overwrite:!1,...h})}catch(b){return Zt.c(b)}},async copy(f,d,h){try{return await E.a.$copy(f,d,{overwrite:!1,...h})}catch(b){return Zt.c(b)}},isWritableFileSystem(f){const d=C.getCapabilities(f);if(typeof d=="number")return!(d&2048)}})}static c(v){if(v instanceof T.FileSystemError)throw v;if(!(v instanceof Error))throw new T.FileSystemError(String(v));if(v.name==="ENOPRO"||v.message.includes("ENOPRO"))throw T.FileSystemError.Unavailable(v.message);switch(v.name){case t.FileSystemProviderErrorCode.FileExists:throw T.FileSystemError.FileExists(v.message);case t.FileSystemProviderErrorCode.FileNotFound:throw T.FileSystemError.FileNotFound(v.message);case t.FileSystemProviderErrorCode.FileNotADirectory:throw T.FileSystemError.FileNotADirectory(v.message);case t.FileSystemProviderErrorCode.FileIsADirectory:throw T.FileSystemError.FileIsADirectory(v.message);case t.FileSystemProviderErrorCode.NoPermissions:throw T.FileSystemError.NoPermissions(v.message);case t.FileSystemProviderErrorCode.Unavailable:throw T.FileSystemError.Unavailable(v.message);default:throw new T.FileSystemError(v.message,v.name)}}addFileSystemProvider(v,C){return this.b.set(v,C),(0,D.toDisposable)(()=>this.b.delete(v))}};L=qe([We(0,A.IExtHostRpcService),We(1,y.IExtHostFileSystemInfo)],L),e.ExtHostConsumerFileSystem=L,e.IExtHostConsumerFileSystem=(0,I.createDecorator)("IExtHostConsumerFileSystem")}),define(ye[254],Ce([1,0,3,38,2,5,14,7]),function(te,e,o,t,T,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{get ignoreCreateEvents(){return Boolean(this.g&1)}get ignoreChangeEvents(){return Boolean(this.g&2)}get ignoreDeleteEvents(){return Boolean(this.g&4)}constructor(P,v,C,E,f,d,h,b){this.a=new o.Emitter,this.b=new o.Emitter,this.c=new o.Emitter;const g=this.h(P,C,f);this.g=0,d&&(this.g+=1),h&&(this.g+=2),b&&(this.g+=4);const p=(0,t.parse)(f),w=typeof f=="string",i=E(s=>{if(!d)for(const a of s.created){const u=T.URI.revive(a);p(u.fsPath)&&(!w||v.getWorkspaceFolder(u))&&this.a.fire(u)}if(!h)for(const a of s.changed){const u=T.URI.revive(a);p(u.fsPath)&&(!w||v.getWorkspaceFolder(u))&&this.b.fire(u)}if(!b)for(const a of s.deleted){const u=T.URI.revive(a);p(u.fsPath)&&(!w||v.getWorkspaceFolder(u))&&this.c.fire(u)}});this.d=A.Disposable.from(g,this.a,this.b,this.c,i)}h(P,v,C){const E=A.Disposable.from();if(typeof C=="string")return E;const f=P.getProxy(R.MainContext.MainThreadFileSystem);let d=!1;(C.pattern.includes(t.GLOBSTAR)||C.pattern.includes(t.GLOB_SPLIT))&&(d=!0);const h=Math.random();return f.$watch(v.identifier.value,h,C.baseUri,{recursive:d,excludes:[]}),A.Disposable.from({dispose:()=>f.$unwatch(h)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class D{constructor(P,v,C){this.j=P,this.k=v,this.l=C,this.a=new o.Emitter,this.b=new o.Emitter,this.c=new o.Emitter,this.d=new o.Emitter,this.g=new o.AsyncEmitter,this.h=new o.AsyncEmitter,this.i=new o.AsyncEmitter,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(P,v,C,E,f,d){return new y(this.j,P,v,this.a.event,I.GlobPattern.from(C),E,f,d)}$onFileEvent(P){this.a.fire(P)}$onDidRunFileOperation(P,v){switch(P){case 2:this.b.fire(Object.freeze({files:v.map(C=>({oldUri:T.URI.revive(C.source),newUri:T.URI.revive(C.target)}))}));break;case 1:this.d.fire(Object.freeze({files:v.map(C=>T.URI.revive(C.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:v.map(C=>T.URI.revive(C.target))}));break;default:}}getOnWillRenameFileEvent(P){return this.m(P,this.g)}getOnWillCreateFileEvent(P){return this.m(P,this.h)}getOnWillDeleteFileEvent(P){return this.m(P,this.i)}m(P,v){return(C,E,f)=>{const d=function(b){C.call(E,b)};return d.extension=P,v.event(d,void 0,f)}}async $onWillRunFileOperation(P,v,C,E){switch(P){case 2:return await this.n(this.g,{files:v.map(f=>({oldUri:T.URI.revive(f.source),newUri:T.URI.revive(f.target)}))},C,E);case 1:return await this.n(this.i,{files:v.map(f=>T.URI.revive(f.target))},C,E);case 0:case 3:return await this.n(this.h,{files:v.map(f=>T.URI.revive(f.target))},C,E)}}async n(P,v,C,E){const f=new Set,d=[];if(await P.fireAsync(v,E,async(b,g)=>{const p=Date.now(),w=await Promise.resolve(b);w instanceof A.WorkspaceEdit&&(d.push([g.extension,w]),f.add(g.extension.displayName??g.extension.identifier.value)),Date.now()-p>C&&this.k.warn("SLOW file-participant",g.extension.identifier)}),E.isCancellationRequested||d.length===0)return;const h={edits:[]};for(const[,b]of d){const{edits:g}=I.WorkspaceEdit.from(b,{getTextDocumentVersion:p=>this.l.getDocument(p)?.version,getNotebookDocumentVersion:()=>{}});h.edits=h.edits.concat(g)}return{edit:h,extensionNames:Array.from(f)}}}e.ExtHostFileSystemEventService=D}),define(ye[255],Ce([1,0,2,40]),function(te,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class T{constructor(I,A,y,D,L){this.a=A,this.b=y,this.c=D;const P=new t.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new t.ApiCommandArgument("showOptions","Show Options",v=>!0,v=>v),new t.ApiCommandArgument("resource","Interactive resource Uri",v=>!0,v=>v),new t.ApiCommandArgument("controllerId","Notebook controller Id",v=>!0,v=>v),new t.ApiCommandArgument("title","Interactive editor title",v=>!0,v=>v)],new t.ApiCommandResult("Notebook and input URI",v=>{if(L.debug("[ExtHostInteractive] open iw with notebook editor id",v.notebookEditorId),v.notebookEditorId!==void 0){const C=this.a.getEditorById(v.notebookEditorId);return L.debug("[ExtHostInteractive] notebook editor found",C.id),{notebookUri:o.URI.revive(v.notebookUri),inputUri:o.URI.revive(v.inputUri),notebookEditor:C.apiEditor}}return L.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",v.notebookUri,v.inputUri),{notebookUri:o.URI.revive(v.notebookUri),inputUri:o.URI.revive(v.inputUri)}}));this.c.registerApiCommand(P)}$willAddInteractiveDocument(I,A,y,D){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:A,lines:[""],languageId:y,uri:I,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(o.URI.revive(D))?.apiNotebook}]})}$willRemoveInteractiveDocument(I,A){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[I]})}}e.ExtHostInteractive=T}),define(ye[256],Ce([1,0,6,5]),function(te,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class T{constructor(I){this.b=0,this.a=I.getProxy(t.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(I){const A=this.b++;return this.a.$registerResourceLabelFormatter(A,I),(0,o.toDisposable)(()=>{this.a.$unregisterResourceLabelFormatter(A)})}}e.ExtHostLabelService=T}),define(ye[257],Ce([1,0,2,23,14,7,66,5,8,35,18,11,149,21,6,119,100,69,43,9,16,27]),function(te,e,o,t,T,R,I,A,y,D,L,P,v,C,E,f,d,h,b,g,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class i{constructor(O,H){this.d=O,this.e=H}async provideDocumentSymbols(O,H){const x=this.d.getDocument(O),Q=await this.e.provideDocumentSymbols(x,H);if(!(0,L.isFalsyOrEmpty)(Q))return Q[0]instanceof R.DocumentSymbol?Q.map(T.DocumentSymbol.from):i.f(Q)}static f(O){O=O.slice(0).sort((Q,de)=>{let we=Q.location.range.start.compareTo(de.location.range.start);return we===0&&(we=de.location.range.end.compareTo(Q.location.range.end)),we});const H=[],x=[];for(const Q of O){const de={name:Q.name||"!!MISSING: name!!",kind:T.SymbolKind.from(Q.kind),tags:Q.tags?.map(T.SymbolTag.from)||[],detail:"",containerName:Q.containerName,range:T.Range.from(Q.location.range),selectionRange:T.Range.from(Q.location.range),children:[]};for(;;){if(x.length===0){x.push(de),H.push(de);break}const we=x[x.length-1];if(D.Range.containsRange(we.range,de.range)&&!D.Range.equalsRange(we.range,de.range)){we.children?.push(de),x.push(de);break}x.pop()}}return H}}class s{constructor(O,H,x){this.g=O,this.h=H,this.j=x,this.e=new h.Cache("CodeLens"),this.f=new Map}async provideCodeLenses(O,H){const x=this.g.getDocument(O),Q=await this.j.provideCodeLenses(x,H);if(!Q||H.isCancellationRequested)return;const de=this.e.add(Q),we=new E.DisposableStore;this.f.set(de,we);const Ae={cacheId:de,lenses:[]};for(let pe=0;pe<Q.length;pe++)Ae.lenses.push({cacheId:[de,pe],range:T.Range.from(Q[pe].range),command:this.h.toInternal(Q[pe].command,we)});return Ae}async resolveCodeLens(O,H){const x=O.cacheId&&this.e.get(...O.cacheId);if(!x)return;let Q;if(typeof this.j.resolveCodeLens!="function"||x.isResolved?Q=x:Q=await this.j.resolveCodeLens(x,H),Q||(Q=x),H.isCancellationRequested)return;const de=O.cacheId&&this.f.get(O.cacheId[0]);if(!!de)return O.command=this.h.toInternal(Q.command??s.d,de),O}releaseCodeLenses(O){this.f.get(O)?.dispose(),this.f.delete(O),this.e.delete(O)}}s.d={command:"missing",title:"!!MISSING: command!!"};function a(re){return Array.isArray(re)?re.map(T.DefinitionLink.from):re?[T.DefinitionLink.from(re)]:[]}class u{constructor(O,H){this.d=O,this.e=H}async provideDefinition(O,H,x){const Q=this.d.getDocument(O),de=T.Position.to(H),we=await this.e.provideDefinition(Q,de,x);return a(we)}}class l{constructor(O,H){this.d=O,this.e=H}async provideDeclaration(O,H,x){const Q=this.d.getDocument(O),de=T.Position.to(H),we=await this.e.provideDeclaration(Q,de,x);return a(we)}}class c{constructor(O,H){this.d=O,this.e=H}async provideImplementation(O,H,x){const Q=this.d.getDocument(O),de=T.Position.to(H),we=await this.e.provideImplementation(Q,de,x);return a(we)}}class n{constructor(O,H){this.d=O,this.e=H}async provideTypeDefinition(O,H,x){const Q=this.d.getDocument(O),de=T.Position.to(H),we=await this.e.provideTypeDefinition(Q,de,x);return a(we)}}class r{constructor(O,H){this.d=O,this.e=H}async provideHover(O,H,x){const Q=this.d.getDocument(O),de=T.Position.to(H),we=await this.e.provideHover(Q,de,x);if(!(!we||(0,L.isFalsyOrEmpty)(we.contents)))return we.range||(we.range=Q.getWordRangeAtPosition(de)),we.range||(we.range=new R.Range(de,de)),T.Hover.from(we)}}class m{constructor(O,H){this.d=O,this.e=H}async provideEvaluatableExpression(O,H,x){const Q=this.d.getDocument(O),de=T.Position.to(H),we=await this.e.provideEvaluatableExpression(Q,de,x);if(we)return T.EvaluatableExpression.from(we)}}class S{constructor(O,H){this.d=O,this.e=H}async provideInlineValues(O,H,x,Q){const de=this.d.getDocument(O),we=await this.e.provideInlineValues(de,T.Range.to(H),T.InlineValueContext.to(x),Q);if(Array.isArray(we))return we.map(Ae=>T.InlineValue.from(Ae))}}class k{constructor(O,H){this.d=O,this.e=H}async provideDocumentHighlights(O,H,x){const Q=this.d.getDocument(O),de=T.Position.to(H),we=await this.e.provideDocumentHighlights(Q,de,x);if(Array.isArray(we))return we.map(T.DocumentHighlight.from)}}class M{constructor(O,H){this.d=O,this.e=H}async provideLinkedEditingRanges(O,H,x){const Q=this.d.getDocument(O),de=T.Position.to(H),we=await this.e.provideLinkedEditingRanges(Q,de,x);if(we&&Array.isArray(we.ranges))return{ranges:(0,L.coalesce)(we.ranges.map(T.Range.from)),wordPattern:we.wordPattern}}}class q{constructor(O,H){this.d=O,this.e=H}async provideReferences(O,H,x,Q){const de=this.d.getDocument(O),we=T.Position.to(H),Ae=await this.e.provideReferences(de,we,x,Q);if(Array.isArray(Ae))return Ae.map(T.location.from)}}class V{constructor(O,H,x,Q,de,we,Ae){this.g=O,this.h=H,this.j=x,this.k=Q,this.l=de,this.m=we,this.n=Ae,this.e=new h.Cache("CodeAction"),this.f=new Map}async provideCodeActions(O,H,x,Q){const de=this.g.getDocument(O),we=v.Selection.isISelection(H)?T.Selection.to(H):T.Range.to(H),Ae=[];for(const et of this.j.getDiagnostics(O))if(we.intersection(et.range)&&Ae.push(et)>V.d)break;const pe={diagnostics:Ae,only:x.only?new R.CodeActionKind(x.only):void 0,triggerKind:T.CodeActionTriggerKind.to(x.trigger)},De=await this.k.provideCodeActions(de,we,pe,Q);if(!(0,L.isNonEmptyArray)(De)||Q.isCancellationRequested)return;const ke=this.e.add(De),je=new E.DisposableStore;this.f.set(ke,je);const Ge=[];for(let et=0;et<De.length;et++){const _e=De[et];!_e||(V.o(_e)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),Ge.push({_isSynthetic:!0,title:_e.title,command:this.h.toInternal(_e,je)})):(pe.only&&(_e.kind?pe.only.contains(_e.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${pe.only.value} 'requested but returned code action is of kind '${_e.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${pe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ge.push({cacheId:[ke,et],title:_e.title,command:_e.command&&this.h.toInternal(_e.command,je),diagnostics:_e.diagnostics&&_e.diagnostics.map(T.Diagnostic.from),edit:_e.edit&&T.WorkspaceEdit.from(_e.edit,void 0),kind:_e.kind&&_e.kind.value,isPreferred:_e.isPreferred,disabled:_e.disabled?.reason})))}return{cacheId:ke,actions:Ge}}async resolveCodeAction(O,H){const[x,Q]=O,de=this.e.get(x,Q);if(!de||V.o(de)||!this.k.resolveCodeAction)return;const we=await this.k.resolveCodeAction(de,H)??de;return we?.edit?T.WorkspaceEdit.from(we.edit,void 0):void 0}releaseCodeActions(O){this.f.get(O)?.dispose(),this.f.delete(O),this.e.delete(O)}static o(O){return typeof O.command=="string"&&typeof O.title=="string"}}V.d=1e3;class F{constructor(O,H,x,Q){this.d=O,this.e=H,this.f=x,this.g=Q}async prepareDocumentPaste(O,H,x,Q){if(!this.f.prepareDocumentPaste)return;const de=this.e.getDocument(O),we=H.map(pe=>T.Range.to(pe)),Ae=T.DataTransfer.toDataTransfer(x,()=>{throw new g.NotImplementedError});return await this.f.prepareDocumentPaste(de,we,Ae,Q),T.DataTransfer.toDataTransferDTO(Ae)}async providePasteEdits(O,H,x,Q,de){const we=this.e.getDocument(H),Ae=x.map(ke=>T.Range.to(ke)),pe=T.DataTransfer.toDataTransfer(Q,async ke=>(await this.d.$resolvePasteFileData(this.g,O,ke)).buffer),De=await this.f.provideDocumentPasteEdits(we,Ae,pe,de);if(!!De)return{insertText:typeof De.insertText=="string"?De.insertText:{snippet:De.insertText.value},additionalEdit:De.additionalEdit?T.WorkspaceEdit.from(De.additionalEdit,void 0):void 0}}}class U{constructor(O,H){this.d=O,this.e=H}async provideDocumentFormattingEdits(O,H,x){const Q=this.d.getDocument(O),de=await this.e.provideDocumentFormattingEdits(Q,H,x);if(Array.isArray(de))return de.map(T.TextEdit.from)}}class N{constructor(O,H){this.d=O,this.e=H}async provideDocumentRangeFormattingEdits(O,H,x,Q){const de=this.d.getDocument(O),we=T.Range.to(H),Ae=await this.e.provideDocumentRangeFormattingEdits(de,we,x,Q);if(Array.isArray(Ae))return Ae.map(T.TextEdit.from)}}class B{constructor(O,H){this.d=O,this.e=H,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(O,H,x,Q,de){const we=this.d.getDocument(O),Ae=T.Position.to(H),pe=await this.e.provideOnTypeFormattingEdits(we,Ae,x,Q,de);if(Array.isArray(pe))return pe.map(T.TextEdit.from)}}class j{constructor(O,H){this.e=O,this.f=H,this.d=new h.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(O,H){const x=await this.e.provideWorkspaceSymbols(O,H);if(!(0,L.isNonEmptyArray)(x))return{symbols:[]};const Q=this.d.add(x),de={cacheId:Q,symbols:[]};for(let we=0;we<x.length;we++){const Ae=x[we];if(!Ae||!Ae.name){this.f.warn("INVALID SymbolInformation",Ae);continue}de.symbols.push({...T.WorkspaceSymbol.from(Ae),cacheId:[Q,we]})}return de}async resolveWorkspaceSymbol(O,H){if(typeof this.e.resolveWorkspaceSymbol!="function"||!O.cacheId)return O;const x=this.d.get(...O.cacheId);if(x){const Q=await this.e.resolveWorkspaceSymbol(x,H);return Q&&(0,t.mixin)(O,T.WorkspaceSymbol.from(Q),!0)}}releaseWorkspaceSymbols(O){this.d.delete(O)}}class z{static supportsResolving(O){return typeof O.prepareRename=="function"}constructor(O,H,x){this.d=O,this.e=H,this.f=x}async provideRenameEdits(O,H,x,Q){const de=this.d.getDocument(O),we=T.Position.to(H);try{const Ae=await this.e.provideRenameEdits(de,we,x,Q);return Ae?T.WorkspaceEdit.from(Ae):void 0}catch(Ae){const pe=z.g(Ae);return pe?{rejectReason:pe,edits:void 0}:Promise.reject(Ae)}}async resolveRenameLocation(O,H,x){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const Q=this.d.getDocument(O),de=T.Position.to(H);try{const we=await this.e.prepareRename(Q,de,x);let Ae,pe;if(R.Range.isRange(we)?(Ae=we,pe=Q.getText(we)):(0,P.isObject)(we)&&(Ae=we.range,pe=we.placeholder),!Ae||!pe)return;if(Ae.start.line>de.line||Ae.end.line<de.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:T.Range.from(Ae),text:pe}}catch(we){const Ae=z.g(we);return Ae?{rejectReason:Ae,range:void 0,text:void 0}:Promise.reject(we)}}static g(O){return typeof O=="string"?O:O instanceof Error&&typeof O.message=="string"?O.message:void 0}}class ne{constructor(O,H){this.resultId=O,this.tokens=H}}class _{constructor(O,H){this.f=O,this.g=H,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(O,H,x){const Q=this.f.getDocument(O),de=H!==0?this.d.get(H):null;let we=typeof de?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(Q,de.resultId,x):await this.g.provideDocumentSemanticTokens(Q,x);return de&&this.d.delete(H),we?(we=_.h(we),this.o(_.n(de,we),we)):null}async releaseDocumentSemanticColoring(O){this.d.delete(O)}static h(O){return _.j(O)?_.k(O)?O:new R.SemanticTokens(new Uint32Array(O.data),O.resultId):_.l(O)?_.m(O)?O:new R.SemanticTokensEdits(O.edits.map(H=>new R.SemanticTokensEdit(H.start,H.deleteCount,H.data?new Uint32Array(H.data):H.data)),O.resultId):O}static j(O){return O&&!!O.data}static k(O){return O.data instanceof Uint32Array}static l(O){return O&&Array.isArray(O.edits)}static m(O){for(const H of O.edits)if(!(H.data instanceof Uint32Array))return!1;return!0}static n(O,H){if(!_.j(H)||!O||!O.tokens)return H;const x=O.tokens,Q=x.length,de=H.data,we=de.length;let Ae=0;const pe=Math.min(Q,we);for(;Ae<pe&&x[Ae]===de[Ae];)Ae++;if(Ae===Q&&Ae===we)return new R.SemanticTokensEdits([],H.resultId);let De=0;const ke=pe-Ae;for(;De<ke&&x[Q-De-1]===de[we-De-1];)De++;return new R.SemanticTokensEdits([{start:Ae,deleteCount:Q-Ae-De,data:de.subarray(Ae,we-De)}],H.resultId)}o(O,H){if(_.j(O)){const x=this.e++;return this.d.set(x,new ne(O.resultId,O.data)),(0,f.encodeSemanticTokensDto)({id:x,type:"full",data:O.data})}if(_.l(O)){const x=this.e++;return _.j(H)?this.d.set(x,new ne(H.resultId,H.data)):this.d.set(x,new ne(O.resultId)),(0,f.encodeSemanticTokensDto)({id:x,type:"delta",deltas:(O.edits||[]).map(Q=>({start:Q.start,deleteCount:Q.deleteCount,data:Q.data}))})}return null}}class Y{constructor(O,H){this.d=O,this.e=H}async provideDocumentRangeSemanticTokens(O,H,x){const Q=this.d.getDocument(O),de=await this.e.provideDocumentRangeSemanticTokens(Q,T.Range.to(H),x);return de?this.f(de):null}f(O){return(0,f.encodeSemanticTokensDto)({id:0,type:"full",data:O.data})}}class J{static supportsResolving(O){return typeof O.resolveCompletionItem=="function"}constructor(O,H,x,Q,de){this.f=O,this.g=H,this.h=x,this.j=Q,this.k=de,this.d=new h.Cache("CompletionItem"),this.e=new Map}async provideCompletionItems(O,H,x,Q){const de=this.f.getDocument(O),we=T.Position.to(H),Ae=de.getWordRangeAtPosition(we)||new R.Range(we,we),pe=Ae.with({end:we}),De=new b.StopWatch(!0),ke=await this.h.provideCompletionItems(de,we,Q,T.CompletionContext.to(x));if(!ke||Q.isCancellationRequested)return;const je=Array.isArray(ke)?new R.CompletionList(ke):ke,Ge=J.supportsResolving(this.h)?this.d.add(je.items):this.d.add([]),et=new E.DisposableStore;this.e.set(Ge,et);const _e=[],nt={x:Ge,b:_e,a:{replace:T.Range.from(Ae),insert:T.Range.from(pe)},c:je.isIncomplete||void 0,d:De.elapsed()};for(let st=0;st<je.items.length;st++){const ht=je.items[st],Fe=this.l(ht,[Ge,st],pe,Ae);_e.push(Fe)}return nt}async resolveCompletionItem(O,H){if(typeof this.h.resolveCompletionItem!="function")return;const x=this.d.get(...O);if(!x)return;const Q=await this.h.resolveCompletionItem(x,H);if(!!Q)return this.l(Q,O)}releaseCompletionItems(O){this.e.get(O)?.dispose(),this.e.delete(O),this.d.delete(O)}l(O,H,x,Q){const de=this.e.get(H[0]);if(!de)throw Error("DisposableStore is missing...");const we=this.g.toInternal(O.command,de),Ae={x:H,a:O.label,b:O.kind!==void 0?T.CompletionItemKind.from(O.kind):void 0,m:O.tags&&O.tags.map(T.CompletionItemTag.from),c:O.detail,d:typeof O.documentation>"u"?void 0:T.MarkdownString.fromStrict(O.documentation),e:O.sortText!==O.label?O.sortText:void 0,f:O.filterText!==O.label?O.filterText:void 0,g:O.preselect||void 0,i:O.keepWhitespace?1:0,k:O.commitCharacters?.join(""),l:O.additionalTextEdits&&O.additionalTextEdits.map(T.TextEdit.from),n:we?.$ident,o:we?.id,p:we?.$ident?void 0:we?.arguments};O.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ae.h=O.textEdit.newText):typeof O.insertText=="string"?Ae.h=O.insertText:O.insertText instanceof R.SnippetString&&(Ae.h=O.insertText.value,Ae.i|=4);let pe;return O.textEdit?pe=O.textEdit.range:O.range&&(pe=O.range),R.Range.isRange(pe)?Ae.j=T.Range.from(pe):pe&&(!x?.isEqual(pe.inserting)||!Q?.isEqual(pe.replacing))&&(Ae.j={insert:T.Range.from(pe.inserting),replace:T.Range.from(pe.replacing)}),Ae}}class Z{async provideInlineCompletions(O,H,x,Q){}disposeCompletions(O){}handleDidShowCompletionItem(O,H){}}class ie extends Z{constructor(O,H,x,Q){super(),this.f=O,this.g=H,this.h=x,this.j=Q,this.d=new X,this.e=(0,w.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions"),this.k={[I.InlineCompletionTriggerKind.Automatic]:R.InlineCompletionTriggerKind.Automatic,[I.InlineCompletionTriggerKind.Explicit]:R.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,w.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions")&&typeof this.h.handleDidShowCompletionItem=="function"}async provideInlineCompletions(O,H,x,Q){const de=this.g.getDocument(O),we=T.Position.to(H),Ae=await this.h.provideInlineCompletionItems(de,we,{selectedCompletionInfo:x.selectedSuggestionInfo?{range:T.Range.to(x.selectedSuggestionInfo.range),text:x.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[x.triggerKind]},Q);if(!Ae||Q.isCancellationRequested)return;const pe=Array.isArray(Ae)?Ae:Ae.items,De=this.e?Array.isArray(Ae)?[]:Ae.commands||[]:[];let ke;return{pid:this.d.createReferenceId({dispose(){ke?.dispose()},items:pe}),items:pe.map((Ge,et)=>{let _e;Ge.command&&(ke||(ke=new E.DisposableStore),_e=this.j.toInternal(Ge.command,ke));const nt=Ge.insertText;return{insertText:typeof nt=="string"?nt:{snippet:nt.value},filterText:Ge.filterText,range:Ge.range?T.Range.from(Ge.range):void 0,command:_e,idx:et,completeBracketPairs:this.e?Ge.completeBracketPairs:!1}}),commands:De.map(Ge=>(ke||(ke=new E.DisposableStore),this.j.toInternal(Ge,ke)))}}disposeCompletions(O){this.d.disposeReferenceId(O)?.dispose()}handleDidShowCompletionItem(O,H){const x=this.d.get(O)?.items[H];x&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(x)}}class X{constructor(){this.d=new Map,this.e=1}createReferenceId(O){const H=this.e++;return this.d.set(H,O),H}disposeReferenceId(O){const H=this.d.get(O);return this.d.delete(O),H}get(O){return this.d.get(O)}}class K{constructor(O,H){this.e=O,this.f=H,this.d=new h.Cache("SignatureHelp")}async provideSignatureHelp(O,H,x,Q){const de=this.e.getDocument(O),we=T.Position.to(H),Ae=this.g(x),pe=await this.f.provideSignatureHelp(de,we,Q,Ae);if(pe){const De=this.d.add([pe]);return{...T.SignatureHelp.from(pe),id:De}}}g(O){let H;if(O.activeSignatureHelp){const x=T.SignatureHelp.to(O.activeSignatureHelp),Q=this.d.get(O.activeSignatureHelp.id,0);Q?(H=Q,H.activeSignature=x.activeSignature,H.activeParameter=x.activeParameter):H=x}return{...O,activeSignatureHelp:H}}releaseSignatureHelp(O){this.d.delete(O)}}class he{constructor(O,H,x,Q,de){this.f=O,this.g=H,this.h=x,this.j=Q,this.k=de,this.d=new h.Cache("InlayHints"),this.e=new Map}async provideInlayHints(O,H,x){const Q=this.f.getDocument(O),de=T.Range.to(H),we=await this.h.provideInlayHints(Q,de,x);if(!Array.isArray(we)||we.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${H}`);return}if(x.isCancellationRequested)return;const Ae=this.d.add(we);this.e.set(Ae,new E.DisposableStore);const pe={hints:[],cacheId:Ae};for(let De=0;De<we.length;De++)this.l(we[De],de)&&pe.hints.push(this.m(we[De],[Ae,De]));return this.j.trace(`[InlayHints] ${pe.hints.length} inlay hints from '${this.k.identifier.value}' for ${H}`),pe}async resolveInlayHint(O,H){if(typeof this.h.resolveInlayHint!="function")return;const x=this.d.get(...O);if(!x)return;const Q=await this.h.resolveInlayHint(x,H);if(!!Q&&!!this.l(Q))return this.m(Q,O)}releaseHints(O){this.e.get(O)?.dispose(),this.e.delete(O),this.d.delete(O)}l(O,H){return O.label.length===0||Array.isArray(O.label)&&O.label.every(x=>x.value.length===0)?(console.log("INVALID inlay hint, empty label",O),!1):!(H&&!H.contains(O.position))}m(O,H){const x=this.e.get(H[0]);if(!x)throw Error("DisposableStore is missing...");const Q={label:"",cacheId:H,tooltip:T.MarkdownString.fromStrict(O.tooltip),position:T.Position.from(O.position),textEdits:O.textEdits&&O.textEdits.map(T.TextEdit.from),kind:O.kind&&T.InlayHintKind.from(O.kind),paddingLeft:O.paddingLeft,paddingRight:O.paddingRight};return typeof O.label=="string"?Q.label=O.label:Q.label=O.label.map(de=>{const we={label:de.value};return we.tooltip=T.MarkdownString.fromStrict(de.tooltip),R.Location.isLocation(de.location)&&(we.location=T.location.from(de.location)),de.command&&(we.command=this.g.toInternal(de.command,x)),we}),Q}}class be{constructor(O,H){this.e=O,this.f=H,this.d=new h.Cache("DocumentLink")}async provideLinks(O,H){const x=this.e.getDocument(O),Q=await this.f.provideDocumentLinks(x,H);if(!(!Array.isArray(Q)||Q.length===0)&&!H.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:Q.filter(be.g).map(T.DocumentLink.from)};{const de=this.d.add(Q),we={links:[],cacheId:de};for(let Ae=0;Ae<Q.length;Ae++){if(!be.g(Q[Ae]))continue;const pe=T.DocumentLink.from(Q[Ae]);pe.cacheId=[de,Ae],we.links.push(pe)}return we}}}static g(O){return O.target&&O.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(O,H){if(typeof this.f.resolveDocumentLink!="function")return;const x=this.d.get(...O);if(!x)return;const Q=await this.f.resolveDocumentLink(x,H);if(!(!Q||!be.g(Q)))return T.DocumentLink.from(Q)}releaseLinks(O){this.d.delete(O)}}class Ee{constructor(O,H){this.d=O,this.e=H}async provideColors(O,H){const x=this.d.getDocument(O),Q=await this.e.provideDocumentColors(x,H);return Array.isArray(Q)?Q.map(we=>({color:T.Color.from(we.color),range:T.Range.from(we.range)})):[]}async provideColorPresentations(O,H,x){const Q=this.d.getDocument(O),de=T.Range.to(H.range),we=T.Color.to(H.color),Ae=await this.e.provideColorPresentations(we,{document:Q,range:de},x);if(!!Array.isArray(Ae))return Ae.map(T.ColorPresentation.from)}}class Pe{constructor(O,H){this.d=O,this.e=H}async provideFoldingRanges(O,H,x){const Q=this.d.getDocument(O),de=await this.e.provideFoldingRanges(Q,H,x);if(!!Array.isArray(de))return de.map(T.FoldingRange.from)}}class Me{constructor(O,H,x){this.d=O,this.e=H,this.f=x}async provideSelectionRanges(O,H,x){const Q=this.d.getDocument(O),de=H.map(T.Position.to),we=await this.e.provideSelectionRanges(Q,de,x);if(!(0,L.isNonEmptyArray)(we))return[];if(we.length!==de.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ae=[];for(let pe=0;pe<de.length;pe++){const De=[];Ae.push(De);let ke=de[pe],je=we[pe];for(;;){if(!je.range.contains(ke))throw new Error("INVALID selection range, must contain the previous range");if(De.push(T.SelectionRange.from(je)),!je.parent)break;ke=je.range,je=je.parent}}return Ae}}class oe{constructor(O,H){this.f=O,this.g=H,this.d=new d.IdGenerator(""),this.e=new Map}async prepareSession(O,H,x){const Q=this.f.getDocument(O),de=T.Position.to(H),we=await this.g.prepareCallHierarchy(Q,de,x);if(!we)return;const Ae=this.d.nextId();return this.e.set(Ae,new Map),Array.isArray(we)?we.map(pe=>this.h(Ae,pe)):[this.h(Ae,we)]}async provideCallsTo(O,H,x){const Q=this.j(O,H);if(!Q)throw new Error("missing call hierarchy item");const de=await this.g.provideCallHierarchyIncomingCalls(Q,x);if(!!de)return de.map(we=>({from:this.h(O,we.from),fromRanges:we.fromRanges.map(Ae=>T.Range.from(Ae))}))}async provideCallsFrom(O,H,x){const Q=this.j(O,H);if(!Q)throw new Error("missing call hierarchy item");const de=await this.g.provideCallHierarchyOutgoingCalls(Q,x);if(!!de)return de.map(we=>({to:this.h(O,we.to),fromRanges:we.fromRanges.map(Ae=>T.Range.from(Ae))}))}releaseSession(O){this.e.delete(O)}h(O,H){const x=this.e.get(O),Q=T.CallHierarchyItem.from(H,O,x.size.toString(36));return x.set(Q._itemId,H),Q}j(O,H){return this.e.get(O)?.get(H)}}class ae{constructor(O,H){this.f=O,this.g=H,this.d=new d.IdGenerator(""),this.e=new Map}async prepareSession(O,H,x){const Q=this.f.getDocument(O),de=T.Position.to(H),we=await this.g.prepareTypeHierarchy(Q,de,x);if(!we)return;const Ae=this.d.nextId();return this.e.set(Ae,new Map),Array.isArray(we)?we.map(pe=>this.h(Ae,pe)):[this.h(Ae,we)]}async provideSupertypes(O,H,x){const Q=this.j(O,H);if(!Q)throw new Error("missing type hierarchy item");const de=await this.g.provideTypeHierarchySupertypes(Q,x);if(!!de)return de.map(we=>this.h(O,we))}async provideSubtypes(O,H,x){const Q=this.j(O,H);if(!Q)throw new Error("missing type hierarchy item");const de=await this.g.provideTypeHierarchySubtypes(Q,x);if(!!de)return de.map(we=>this.h(O,we))}releaseSession(O){this.e.delete(O)}h(O,H){const x=this.e.get(O),Q=T.TypeHierarchyItem.from(H,O,x.size.toString(36));return x.set(Q._itemId,H),Q}j(O,H){return this.e.get(O)?.get(H)}}class fe{constructor(O,H,x,Q){this.d=O,this.e=H,this.f=x,this.g=Q}async provideDocumentOnDropEdits(O,H,x,Q,de){const we=this.e.getDocument(H),Ae=T.Position.to(x),pe=T.DataTransfer.toDataTransfer(Q,async ke=>(await this.d.$resolveDocumentOnDropFileData(this.g,O,ke)).buffer),De=await this.f.provideDocumentDropEdits(we,Ae,pe,de);if(!!De)return{insertText:typeof De.insertText=="string"?De.insertText:{snippet:De.insertText.value},additionalEdit:De.additionalEdit?T.WorkspaceEdit.from(De.additionalEdit,void 0):void 0}}}class ee{constructor(O,H){this.adapter=O,this.extension=H}}class le{constructor(O,H,x,Q,de,we,Ae,pe){this.g=H,this.h=x,this.j=Q,this.k=de,this.l=we,this.m=Ae,this.n=pe,this.f=new Map,this.e=O.getProxy(A.MainContext.MainThreadLanguageFeatures)}o(O){return T.DocumentSelector.from(O,this.g)}p(O){return new R.Disposable(()=>{this.f.delete(O),this.e.$unregister(O)})}q(){return le.d++}async s(O,H,x,Q,de,we=!1){const Ae=this.f.get(O);if(!Ae||!(Ae.adapter instanceof H))return Q;const pe=Date.now();we||this.l.trace(`[${Ae.extension.identifier.value}] INVOKE provider '${x.toString().replace(/[\r\n]/g,"")}'`);const De=x(Ae.adapter,Ae.extension);return Promise.resolve(De).catch(ke=>{(0,g.isCancellationError)(ke)||(this.l.error(`[${Ae.extension.identifier.value}] provider FAILED`),this.l.error(ke),this.n.onExtensionError(Ae.extension.identifier,ke))}).finally(()=>{we||this.l.trace(`[${Ae.extension.identifier.value}] provider DONE after ${Date.now()-pe}ms`)}),C.CancellationToken.isCancellationToken(de)?(0,p.raceCancellationError)(De,de):De}t(O,H){const x=this.q();return this.f.set(x,new ee(O,H)),x}static u(O){return O.displayName||O.name}registerDocumentSymbolProvider(O,H,x,Q){const de=this.t(new i(this.h,x),O),we=Q&&Q.label||le.u(O);return this.e.$registerDocumentSymbolProvider(de,this.o(H),we),this.p(de)}$provideDocumentSymbols(O,H,x){return this.s(O,i,Q=>Q.provideDocumentSymbols(o.URI.revive(H),x),void 0,x)}registerCodeLensProvider(O,H,x){const Q=this.q(),de=typeof x.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(Q,new ee(new s(this.h,this.j.converter,x),O)),this.e.$registerCodeLensSupport(Q,this.o(H),de);let we=this.p(Q);if(de!==void 0){const Ae=x.onDidChangeCodeLenses(pe=>this.e.$emitCodeLensEvent(de));we=R.Disposable.from(we,Ae)}return we}$provideCodeLenses(O,H,x){return this.s(O,s,Q=>Q.provideCodeLenses(o.URI.revive(H),x),void 0,x)}$resolveCodeLens(O,H,x){return this.s(O,s,Q=>Q.resolveCodeLens(H,x),void 0,void 0)}$releaseCodeLenses(O,H){this.s(O,s,x=>Promise.resolve(x.releaseCodeLenses(H)),void 0,void 0)}registerDefinitionProvider(O,H,x){const Q=this.t(new u(this.h,x),O);return this.e.$registerDefinitionSupport(Q,this.o(H)),this.p(Q)}$provideDefinition(O,H,x,Q){return this.s(O,u,de=>de.provideDefinition(o.URI.revive(H),x,Q),[],Q)}registerDeclarationProvider(O,H,x){const Q=this.t(new l(this.h,x),O);return this.e.$registerDeclarationSupport(Q,this.o(H)),this.p(Q)}$provideDeclaration(O,H,x,Q){return this.s(O,l,de=>de.provideDeclaration(o.URI.revive(H),x,Q),[],Q)}registerImplementationProvider(O,H,x){const Q=this.t(new c(this.h,x),O);return this.e.$registerImplementationSupport(Q,this.o(H)),this.p(Q)}$provideImplementation(O,H,x,Q){return this.s(O,c,de=>de.provideImplementation(o.URI.revive(H),x,Q),[],Q)}registerTypeDefinitionProvider(O,H,x){const Q=this.t(new n(this.h,x),O);return this.e.$registerTypeDefinitionSupport(Q,this.o(H)),this.p(Q)}$provideTypeDefinition(O,H,x,Q){return this.s(O,n,de=>de.provideTypeDefinition(o.URI.revive(H),x,Q),[],Q)}registerHoverProvider(O,H,x,Q){const de=this.t(new r(this.h,x),O);return this.e.$registerHoverProvider(de,this.o(H)),this.p(de)}$provideHover(O,H,x,Q){return this.s(O,r,de=>de.provideHover(o.URI.revive(H),x,Q),void 0,Q)}registerEvaluatableExpressionProvider(O,H,x,Q){const de=this.t(new m(this.h,x),O);return this.e.$registerEvaluatableExpressionProvider(de,this.o(H)),this.p(de)}$provideEvaluatableExpression(O,H,x,Q){return this.s(O,m,de=>de.provideEvaluatableExpression(o.URI.revive(H),x,Q),void 0,Q)}registerInlineValuesProvider(O,H,x,Q){const de=typeof x.onDidChangeInlineValues=="function"?this.q():void 0,we=this.t(new S(this.h,x),O);this.e.$registerInlineValuesProvider(we,this.o(H),de);let Ae=this.p(we);if(de!==void 0){const pe=x.onDidChangeInlineValues(De=>this.e.$emitInlineValuesEvent(de));Ae=R.Disposable.from(Ae,pe)}return Ae}$provideInlineValues(O,H,x,Q,de){return this.s(O,S,we=>we.provideInlineValues(o.URI.revive(H),x,Q,de),void 0,de)}registerDocumentHighlightProvider(O,H,x){const Q=this.t(new k(this.h,x),O);return this.e.$registerDocumentHighlightProvider(Q,this.o(H)),this.p(Q)}$provideDocumentHighlights(O,H,x,Q){return this.s(O,k,de=>de.provideDocumentHighlights(o.URI.revive(H),x,Q),void 0,Q)}registerLinkedEditingRangeProvider(O,H,x){const Q=this.t(new M(this.h,x),O);return this.e.$registerLinkedEditingRangeProvider(Q,this.o(H)),this.p(Q)}$provideLinkedEditingRanges(O,H,x,Q){return this.s(O,M,async de=>{const we=await de.provideLinkedEditingRanges(o.URI.revive(H),x,Q);if(we)return{ranges:we.ranges,wordPattern:we.wordPattern?le.w(we.wordPattern):void 0}},void 0,Q)}registerReferenceProvider(O,H,x){const Q=this.t(new q(this.h,x),O);return this.e.$registerReferenceSupport(Q,this.o(H)),this.p(Q)}$provideReferences(O,H,x,Q,de){return this.s(O,q,we=>we.provideReferences(o.URI.revive(H),x,Q,de),void 0,de)}registerCodeActionProvider(O,H,x,Q){const de=new E.DisposableStore,we=this.t(new V(this.h,this.j.converter,this.k,x,this.l,O,this.m),O);return this.e.$registerQuickFixSupport(we,this.o(H),{providedKinds:Q?.providedCodeActionKinds?.map(Ae=>Ae.value),documentation:Q?.documentation?.map(Ae=>({kind:Ae.kind.value,command:this.j.converter.toInternal(Ae.command,de)}))},le.u(O),Boolean(x.resolveCodeAction)),de.add(this.p(we)),de}$provideCodeActions(O,H,x,Q,de){return this.s(O,V,we=>we.provideCodeActions(o.URI.revive(H),x,Q,de),void 0,de)}$resolveCodeAction(O,H,x){return this.s(O,V,Q=>Q.resolveCodeAction(H,x),void 0,void 0)}$releaseCodeActions(O,H){this.s(O,V,x=>Promise.resolve(x.releaseCodeActions(H)),void 0,void 0)}registerDocumentFormattingEditProvider(O,H,x){const Q=this.t(new U(this.h,x),O);return this.e.$registerDocumentFormattingSupport(Q,this.o(H),O.identifier,O.displayName||O.name),this.p(Q)}$provideDocumentFormattingEdits(O,H,x,Q){return this.s(O,U,de=>de.provideDocumentFormattingEdits(o.URI.revive(H),x,Q),void 0,Q)}registerDocumentRangeFormattingEditProvider(O,H,x){const Q=this.t(new N(this.h,x),O);return this.e.$registerRangeFormattingSupport(Q,this.o(H),O.identifier,O.displayName||O.name),this.p(Q)}$provideDocumentRangeFormattingEdits(O,H,x,Q,de){return this.s(O,N,we=>we.provideDocumentRangeFormattingEdits(o.URI.revive(H),x,Q,de),void 0,de)}registerOnTypeFormattingEditProvider(O,H,x,Q){const de=this.t(new B(this.h,x),O);return this.e.$registerOnTypeFormattingSupport(de,this.o(H),Q,O.identifier),this.p(de)}$provideOnTypeFormattingEdits(O,H,x,Q,de,we){return this.s(O,B,Ae=>Ae.provideOnTypeFormattingEdits(o.URI.revive(H),x,Q,de,we),void 0,we)}registerWorkspaceSymbolProvider(O,H){const x=this.t(new j(H,this.l),O);return this.e.$registerNavigateTypeSupport(x,typeof H.resolveWorkspaceSymbol=="function"),this.p(x)}$provideWorkspaceSymbols(O,H,x){return this.s(O,j,Q=>Q.provideWorkspaceSymbols(H,x),{symbols:[]},x)}$resolveWorkspaceSymbol(O,H,x){return this.s(O,j,Q=>Q.resolveWorkspaceSymbol(H,x),void 0,void 0)}$releaseWorkspaceSymbols(O,H){this.s(O,j,x=>x.releaseWorkspaceSymbols(H),void 0,void 0)}registerRenameProvider(O,H,x){const Q=this.t(new z(this.h,x,this.l),O);return this.e.$registerRenameSupport(Q,this.o(H),z.supportsResolving(x)),this.p(Q)}$provideRenameEdits(O,H,x,Q,de){return this.s(O,z,we=>we.provideRenameEdits(o.URI.revive(H),x,Q,de),void 0,de)}$resolveRenameLocation(O,H,x,Q){return this.s(O,z,de=>de.resolveRenameLocation(o.URI.revive(H),x,Q),void 0,Q)}registerDocumentSemanticTokensProvider(O,H,x,Q){const de=this.t(new _(this.h,x),O),we=typeof x.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(de,this.o(H),Q,we);let Ae=this.p(de);if(we){const pe=x.onDidChangeSemanticTokens(De=>this.e.$emitDocumentSemanticTokensEvent(we));Ae=R.Disposable.from(Ae,pe)}return Ae}$provideDocumentSemanticTokens(O,H,x,Q){return this.s(O,_,de=>de.provideDocumentSemanticTokens(o.URI.revive(H),x,Q),null,Q)}$releaseDocumentSemanticTokens(O,H){this.s(O,_,x=>x.releaseDocumentSemanticColoring(H),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(O,H,x,Q){const de=this.t(new Y(this.h,x),O);return this.e.$registerDocumentRangeSemanticTokensProvider(de,this.o(H),Q),this.p(de)}$provideDocumentRangeSemanticTokens(O,H,x,Q){return this.s(O,Y,de=>de.provideDocumentRangeSemanticTokens(o.URI.revive(H),x,Q),null,Q)}registerCompletionItemProvider(O,H,x,Q){const de=this.t(new J(this.h,this.j.converter,x,this.m,O),O);return this.e.$registerCompletionsProvider(de,this.o(H),Q,J.supportsResolving(x),`${O.identifier.value}(${Q.join("")})`),this.p(de)}$provideCompletionItems(O,H,x,Q,de){return this.s(O,J,we=>we.provideCompletionItems(o.URI.revive(H),x,Q,de),void 0,de)}$resolveCompletionItem(O,H,x){return this.s(O,J,Q=>Q.resolveCompletionItem(H,x),void 0,x)}$releaseCompletionItems(O,H){this.s(O,J,x=>x.releaseCompletionItems(H),void 0,void 0)}registerInlineCompletionsProvider(O,H,x){const Q=new ie(O,this.h,x,this.j.converter),de=this.t(Q,O);return this.e.$registerInlineCompletionsSupport(de,this.o(H),Q.supportsHandleDidShowCompletionItem),this.p(de)}$provideInlineCompletions(O,H,x,Q,de){return this.s(O,Z,we=>we.provideInlineCompletions(o.URI.revive(H),x,Q,de),void 0,de)}$handleInlineCompletionDidShow(O,H,x){this.s(O,Z,async Q=>{Q.handleDidShowCompletionItem(H,x)},void 0,void 0)}$freeInlineCompletionsList(O,H){this.s(O,Z,async x=>{x.disposeCompletions(H)},void 0,void 0)}registerSignatureHelpProvider(O,H,x,Q){const de=Array.isArray(Q)?{triggerCharacters:Q,retriggerCharacters:[]}:Q,we=this.t(new K(this.h,x),O);return this.e.$registerSignatureHelpProvider(we,this.o(H),de),this.p(we)}$provideSignatureHelp(O,H,x,Q,de){return this.s(O,K,we=>we.provideSignatureHelp(o.URI.revive(H),x,Q,de),void 0,de)}$releaseSignatureHelp(O,H){this.s(O,K,x=>x.releaseSignatureHelp(H),void 0,void 0)}registerInlayHintsProvider(O,H,x){const Q=typeof x.onDidChangeInlayHints=="function"?this.q():void 0,de=this.t(new he(this.h,this.j.converter,x,this.l,O),O);this.e.$registerInlayHintsProvider(de,this.o(H),typeof x.resolveInlayHint=="function",Q,le.u(O));let we=this.p(de);if(Q!==void 0){const Ae=x.onDidChangeInlayHints(pe=>this.e.$emitInlayHintsEvent(Q));we=R.Disposable.from(we,Ae)}return we}$provideInlayHints(O,H,x,Q){return this.s(O,he,de=>de.provideInlayHints(o.URI.revive(H),x,Q),void 0,Q)}$resolveInlayHint(O,H,x){return this.s(O,he,Q=>Q.resolveInlayHint(H,x),void 0,x)}$releaseInlayHints(O,H){this.s(O,he,x=>x.releaseHints(H),void 0,void 0)}registerDocumentLinkProvider(O,H,x){const Q=this.t(new be(this.h,x),O);return this.e.$registerDocumentLinkProvider(Q,this.o(H),typeof x.resolveDocumentLink=="function"),this.p(Q)}$provideDocumentLinks(O,H,x){return this.s(O,be,Q=>Q.provideLinks(o.URI.revive(H),x),void 0,x,H.scheme==="output")}$resolveDocumentLink(O,H,x){return this.s(O,be,Q=>Q.resolveLink(H,x),void 0,void 0,!0)}$releaseDocumentLinks(O,H){this.s(O,be,x=>x.releaseLinks(H),void 0,void 0,!0)}registerColorProvider(O,H,x){const Q=this.t(new Ee(this.h,x),O);return this.e.$registerDocumentColorProvider(Q,this.o(H)),this.p(Q)}$provideDocumentColors(O,H,x){return this.s(O,Ee,Q=>Q.provideColors(o.URI.revive(H),x),[],x)}$provideColorPresentations(O,H,x,Q){return this.s(O,Ee,de=>de.provideColorPresentations(o.URI.revive(H),x,Q),void 0,Q)}registerFoldingRangeProvider(O,H,x){const Q=this.q(),de=typeof x.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(Q,new ee(new Pe(this.h,x),O)),this.e.$registerFoldingRangeProvider(Q,this.o(H),O.identifier,de);let we=this.p(Q);if(de!==void 0){const Ae=x.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(de));we=R.Disposable.from(we,Ae)}return we}$provideFoldingRanges(O,H,x,Q){return this.s(O,Pe,de=>de.provideFoldingRanges(o.URI.revive(H),x,Q),void 0,Q)}registerSelectionRangeProvider(O,H,x){const Q=this.t(new Me(this.h,x,this.l),O);return this.e.$registerSelectionRangeProvider(Q,this.o(H)),this.p(Q)}$provideSelectionRanges(O,H,x,Q){return this.s(O,Me,de=>de.provideSelectionRanges(o.URI.revive(H),x,Q),[],Q)}registerCallHierarchyProvider(O,H,x){const Q=this.t(new oe(this.h,x),O);return this.e.$registerCallHierarchyProvider(Q,this.o(H)),this.p(Q)}$prepareCallHierarchy(O,H,x,Q){return this.s(O,oe,de=>Promise.resolve(de.prepareSession(o.URI.revive(H),x,Q)),void 0,Q)}$provideCallHierarchyIncomingCalls(O,H,x,Q){return this.s(O,oe,de=>de.provideCallsTo(H,x,Q),void 0,Q)}$provideCallHierarchyOutgoingCalls(O,H,x,Q){return this.s(O,oe,de=>de.provideCallsFrom(H,x,Q),void 0,Q)}$releaseCallHierarchy(O,H){this.s(O,oe,x=>Promise.resolve(x.releaseSession(H)),void 0,void 0)}registerTypeHierarchyProvider(O,H,x){const Q=this.t(new ae(this.h,x),O);return this.e.$registerTypeHierarchyProvider(Q,this.o(H)),this.p(Q)}$prepareTypeHierarchy(O,H,x,Q){return this.s(O,ae,de=>Promise.resolve(de.prepareSession(o.URI.revive(H),x,Q)),void 0,Q)}$provideTypeHierarchySupertypes(O,H,x,Q){return this.s(O,ae,de=>de.provideSupertypes(H,x,Q),void 0,Q)}$provideTypeHierarchySubtypes(O,H,x,Q){return this.s(O,ae,de=>de.provideSubtypes(H,x,Q),void 0,Q)}$releaseTypeHierarchy(O,H){this.s(O,ae,x=>Promise.resolve(x.releaseSession(H)),void 0,void 0)}registerDocumentOnDropEditProvider(O,H,x){const Q=this.q();return this.f.set(Q,new ee(new fe(this.e,this.h,x,Q),O)),this.e.$registerDocumentOnDropEditProvider(Q,this.o(H)),this.p(Q)}$provideDocumentOnDropEdits(O,H,x,Q,de,we){return this.s(O,fe,Ae=>Promise.resolve(Ae.provideDocumentOnDropEdits(H,o.URI.revive(x),Q,de,we)),void 0,void 0)}registerDocumentPasteEditProvider(O,H,x,Q){const de=this.q();return this.f.set(de,new ee(new F(this.e,this.h,x,de),O)),this.e.$registerPasteEditProvider(de,this.o(H),!!x.prepareDocumentPaste,Q.pasteMimeTypes),this.p(de)}$prepareDocumentPaste(O,H,x,Q,de){return this.s(O,F,we=>we.prepareDocumentPaste(o.URI.revive(H),x,Q,de),void 0,de)}$providePasteEdits(O,H,x,Q,de,we){return this.s(O,F,Ae=>Ae.providePasteEdits(H,o.URI.revive(x),Q,de,we),void 0,we)}static w(O){return{pattern:O.source,flags:(0,y.regExpFlags)(O)}}static y(O){return{decreaseIndentPattern:le.w(O.decreaseIndentPattern),increaseIndentPattern:le.w(O.increaseIndentPattern),indentNextLinePattern:O.indentNextLinePattern?le.w(O.indentNextLinePattern):void 0,unIndentedLinePattern:O.unIndentedLinePattern?le.w(O.unIndentedLinePattern):void 0}}static z(O){return{beforeText:le.w(O.beforeText),afterText:O.afterText?le.w(O.afterText):void 0,previousLineText:O.previousLineText?le.w(O.previousLineText):void 0,action:O.action}}static B(O){return O.map(le.z)}setLanguageConfiguration(O,H,x){const{wordPattern:Q}=x;if(Q&&(0,y.regExpLeadsToEndlessLoop)(Q))throw new Error(`Invalid language configuration: wordPattern '${Q}' is not allowed to match the empty string.`);Q?this.h.setWordDefinitionFor(H,Q):this.h.setWordDefinitionFor(H,void 0),x.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",O,"Do not use."),x.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",O,"Do not use.");const de=this.q(),we={comments:x.comments,brackets:x.brackets,wordPattern:x.wordPattern?le.w(x.wordPattern):void 0,indentationRules:x.indentationRules?le.y(x.indentationRules):void 0,onEnterRules:x.onEnterRules?le.B(x.onEnterRules):void 0,__electricCharacterSupport:x.__electricCharacterSupport,__characterPairSupport:x.__characterPairSupport};return this.e.$setLanguageConfiguration(de,H,we),this.p(de)}$setWordDefinitions(O){for(const H of O)this.h.setWordDefinitionFor(H.languageId,new RegExp(H.regexSource,H.regexFlags))}}e.ExtHostLanguageFeatures=le,le.d=0}),define(ye[258],Ce([1,0,5,14,7,37,16,6]),function(te,e,o,t,T,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(L,P,v,C){this.c=P,this.d=v,this.e=C,this.b=[],this.f=0,this.g=new Set,this.a=L.getProxy(o.MainContext.MainThreadLanguages)}$acceptLanguageIds(L){this.b=L}async getLanguages(){return this.b.slice(0)}async changeLanguage(L,P){await this.a.$changeLanguage(L,P);const v=this.c.getDocumentData(L);if(!v)throw new Error(`document '${L.toString()}' NOT found`);return v.document}async tokenAtPosition(L,P){const v=L.version,C=t.Position.from(P),E=await this.a.$tokensAtPosition(L.uri,C),f={type:T.StandardTokenType.Other,range:L.getWordRangeAtPosition(P)??new T.Range(P.line,P.character,P.line,P.character)};if(!E)return f;const d={range:t.Range.to(E.range),type:t.TokenType.to(E.type)};return!d.range.contains(P)||v!==L.version?f:d}createLanguageStatusItem(L,P,v){const C=this.f++,E=this.a,f=this.g,d=`${L.identifier.value}/${P}`;if(f.has(d))throw new Error(`LanguageStatusItem with id '${P}' ALREADY exists`);f.add(d);const h={selector:v,id:P,name:L.displayName??L.name,severity:T.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let b;const g=new A.DisposableStore,p=()=>{b?.dispose(),b=(0,I.disposableTimeout)(()=>{g.clear(),this.a.$setLanguageStatus(C,{id:d,name:h.name??L.displayName??L.name,source:L.displayName??L.name,selector:t.DocumentSelector.from(h.selector,this.e),label:h.text,detail:h.detail??"",severity:h.severity===T.LanguageStatusSeverity.Error?R.default.Error:h.severity===T.LanguageStatusSeverity.Warning?R.default.Warning:R.default.Info,command:h.command&&this.d.toInternal(h.command,g),accessibilityInfo:h.accessibilityInformation,busy:h.busy})},0)},w={dispose(){g.dispose(),b?.dispose(),E.$removeLanguageStatus(C),f.delete(d)},get id(){return h.id},get name(){return h.name},set name(i){h.name=i,p()},get selector(){return h.selector},set selector(i){h.selector=i,p()},get text(){return h.text},set text(i){h.text=i,p()},get detail(){return h.detail},set detail(i){h.detail=i,p()},get severity(){return h.severity},set severity(i){h.severity=i,p()},get accessibilityInformation(){return h.accessibilityInformation},set accessibilityInformation(i){h.accessibilityInformation=i,p()},get command(){return h.command},set command(i){h.command=i,p()},get busy(){return h.busy},set busy(i){h.busy=i,p()}};return p(),w}}e.ExtHostLanguages=y}),define(ye[96],Ce([1,0,12,8,2,4,13,5,25,17]),function(te,e,o,t,T,R,I,A,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let L=class{constructor(v,C,E){this.f=E,this.d=new Map,this.a=C.getProxy(A.MainContext.MainThreadLocalization),this.b=v.environment.appLanguage,this.c=this.b===o.LANGUAGE_DEFAULT}getMessage(v,C){const{message:E,args:f,comment:d}=C;if(this.c)return(0,t.format2)(E,f??{});let h=E;d&&d.length>0&&(h+=`/${Array.isArray(d)?d.join():d}`);const b=this.d.get(v)?.contents[h];return b||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${h}`),(0,t.format2)(b??E,f??{})}getBundle(v){return this.d.get(v)?.contents}getBundleUri(v){return this.d.get(v)?.uri}async initializeLocalizedMessages(v){if(this.c||!v.l10n&&!v.isBuiltin||this.d.has(v.identifier.value))return;let C;const E=await this.g(v);if(!E){this.f.error(`No bundle location found for extension ${v.identifier.value}`);return}try{const f=await this.a.$fetchBundleContents(E),d=JSON.parse(f);C=v.isBuiltin?d.contents?.bundle:d}catch(f){this.f.error(`Failed to load translations for ${v.identifier.value} from ${E}: ${f.message}`);return}C&&this.d.set(v.identifier.value,{contents:C,uri:E})}async g(v){if(v.isBuiltin){const C=await this.a.$fetchBuiltInBundleUri(v.identifier.value);return T.URI.revive(C)}return v.l10n?T.URI.joinPath(v.extensionLocation,v.l10n,`bundle.l10n.${this.b}.json`):void 0}};L=qe([We(0,y.IExtHostInitDataService),We(1,D.IExtHostRpcService),We(2,I.ILogService)],L),e.ExtHostLocalizationService=L,e.IExtHostLocalizationService=(0,R.createDecorator)("IExtHostLocalizationService")}),define(ye[140],Ce([1,0,13,5,25,17,2,3,11]),function(te,e,o,t,T,R,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let D=class extends o.AbstractLoggerService{constructor(v,C){super(C.logLevel,A.Event.None),this.g=v.getProxy(t.MainContext.MainThreadLogger)}$setLevel(v,C){C?this.setLevel(I.URI.revive(C),v):(0,y.isUndefined)(v)||this.setLevel(v)}f(v,C,E){return new L(this.g,v,C,E)}};D=qe([We(0,R.IExtHostRpcService),We(1,T.IExtHostInitDataService)],D),e.ExtHostLoggerService=D;class L extends o.AbstractMessageLogger{constructor(v,C,E,f){super(f?.always),this.m=v,this.n=C,this.k=!1,this.l=[],this.setLevel(E),this.m.$createLogger(C,f).then(()=>{this.r(this.l),this.k=!0})}g(v,C){const E=[[v,C]];this.k?this.r(E):this.l.push(...E)}r(v){this.m.$log(this.n,v)}}}),define(ye[259],Ce([1,0,5,13,27]),function(te,e,o,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function R(A){return A&&A.title}let I=class{constructor(y,D){this.b=D,this.a=y.getProxy(o.MainContext.MainThreadMessageService)}showMessage(y,D,L,P,v){const C={source:{identifier:y.identifier,label:y.displayName||y.name}};let E;typeof P=="string"||R(P)?E=[P,...v]:(C.modal=P?.modal,C.useCustom=P?.useCustom,C.detail=P?.detail,E=v),C.useCustom&&(0,T.checkProposedApiEnabled)(y,"resolvers");const f=[];for(let d=0;d<E.length;d++){const h=E[d];if(typeof h=="string")f.push({title:h,handle:d,isCloseAffordance:!1});else if(typeof h=="object"){const{title:b,isCloseAffordance:g}=h;f.push({title:b,isCloseAffordance:!!g,handle:d})}else this.b.warn("Invalid message item:",h)}return this.a.$showMessage(D,L,C,f).then(d=>{if(typeof d=="number")return E[d]})}};I=qe([We(1,t.ILogService)],I),e.ExtHostMessageService=I}),define(ye[260],Ce([1,0,22,3,6,28,8,11,2,69,5,40,14,7,57,235,136]),function(te,e,o,t,T,R,I,A,y,D,L,P,v,C,E,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class h{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(g=>g.apiEditor)}constructor(g,p,w,i){this.q=w,this.r=i,this.f=new Map,this.g=new R.ResourceMap,this.h=new Map,this.j=new t.Emitter,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new t.Emitter,this.onDidOpenNotebookDocument=this.m.event,this.n=new t.Emitter,this.onDidCloseNotebookDocument=this.n.event,this.o=new t.Emitter,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new D.Cache("NotebookCellStatusBarCache"),this.t=0,this.u=new Map,this.b=g.getProxy(L.MainContext.MainThreadNotebook),this.c=g.getProxy(L.MainContext.MainThreadNotebookDocuments),this.d=g.getProxy(L.MainContext.MainThreadNotebookEditors),this.i=p.converter,p.registerArgumentProcessor({processArgument:s=>{if(s&&s.$mid===13){const a=s.notebookEditor?.notebookUri,u=s.cell.handle,c=this.g.get(a)?.getCell(u);if(c)return c.apiCell}if(s&&s.$mid===14){const a=s.uri,u=this.g.get(a);if(u)return u.apiNotebook}return s}}),h.x(p)}getEditorById(g){const p=this.h.get(g);if(!p)throw new Error(`unknown text editor: ${g}. known editors: ${[...this.h.keys()]} `);return p}getIdByEditor(g){for(const[p,w]of this.h)if(w.apiEditor===g)return p}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(g,p){const w=this.g.get(g);if(!w&&!p)throw new Error(`NO notebook document for '${g}'`);return w}static s(g,p){if(!p)return;const w=p.filenamePattern.map(i=>v.NotebookExclusiveDocumentPattern.from(i)).filter(i=>i!==void 0);if(p.filenamePattern&&!w){console.warn(`Notebook content provider view options file name pattern is invalid ${p.filenamePattern}`);return}return{extension:g.identifier,providerDisplayName:g.displayName||g.name,displayName:p.displayName,filenamePattern:w,exclusive:p.exclusive||!1}}registerNotebookCellStatusBarItemProvider(g,p,w){const i=h.a++,s=typeof w.onDidChangeCellStatusBarItems=="function"?h.a++:void 0;this.f.set(i,w),this.b.$registerNotebookCellStatusBarItemProvider(i,s,p);let a;return s!==void 0&&(a=w.onDidChangeCellStatusBarItems(u=>this.b.$emitCellStatusBarEvent(s))),new C.Disposable(()=>{this.f.delete(i),this.b.$unregisterNotebookCellStatusBarItemProvider(i,s),a?.dispose()})}async createNotebookDocument(g){const p=await this.c.$tryCreateNotebook({viewType:g.viewType,content:g.content&&v.NotebookData.from(g.content)});return y.URI.revive(p)}async openNotebookDocument(g){const p=this.g.get(g);if(p)return p.apiNotebook;const w=await this.c.$tryOpenNotebook(g),i=this.g.get(y.URI.revive(w));return(0,A.assertIsDefined)(i?.apiNotebook)}async showNotebookDocument(g,p){y.URI.isUri(g)&&(g=await this.openNotebookDocument(g));let w;typeof p=="object"?w={position:v.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus,selections:p.selections&&p.selections.map(v.NotebookRange.from),pinned:typeof p.preview=="boolean"?!p.preview:void 0}:w={preserveFocus:!1};const i=await this.d.$tryShowNotebookDocument(g.uri,g.notebookType,w),s=i&&this.h.get(i)?.apiEditor;if(s)return s;throw i?new Error(`Could NOT open editor for "${g.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${g.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(g,p,w,i){const s=this.f.get(g),a=y.URI.revive(p),u=this.g.get(a);if(!u||!s)return;const l=u.getCellFromIndex(w);if(!l)return;const c=await s.provideCellStatusBarItems(l.apiCell,i);if(!c)return;const n=new T.DisposableStore,r=this.p.add([n]),S=(Array.isArray(c)?c:[c]).map(k=>v.NotebookStatusBarItem.from(k,this.i,n));return{cacheId:r,items:S}}$releaseNotebookCellStatusBarItems(g){this.p.delete(g)}registerNotebookSerializer(g,p,w,i,s){if((0,I.isFalsyOrWhitespace)(p))throw new Error("viewType cannot be empty or just whitespace");const a=this.t++;return this.u.set(a,w),this.b.$registerNotebookSerializer(a,{id:g.identifier,location:g.extensionLocation},p,v.NotebookDocumentContentOptions.from(i),h.s(g,s)),(0,T.toDisposable)(()=>{this.b.$unregisterNotebookSerializer(a)})}async $dataToNotebook(g,p,w){const i=this.u.get(g);if(!i)throw new Error("NO serializer found");const s=await i.deserializeNotebook(p.buffer,w);return new E.SerializableObjectWithBuffers(v.NotebookData.from(s))}async $notebookToData(g,p,w){const i=this.u.get(g);if(!i)throw new Error("NO serializer found");const s=await i.serializeNotebook(v.NotebookData.to(p.value),w);return o.VSBuffer.wrap(s)}w(g,p,w){if(this.h.has(p))throw new Error(`editor with id ALREADY EXSIST: ${p}`);const i=new d.ExtHostNotebookEditor(p,this.d,g,w.visibleRanges.map(v.NotebookRange.to),w.selections.map(v.NotebookRange.to),typeof w.viewColumn=="number"?v.ViewColumn.to(w.viewColumn):void 0);this.h.set(p,i)}$acceptDocumentAndEditorsDelta(g){if(g.value.removedDocuments)for(const w of g.value.removedDocuments){const i=y.URI.revive(w),s=this.g.get(i);s&&(s.dispose(),this.g.delete(i),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:s.apiNotebook.getCells().map(a=>a.document.uri)}),this.n.fire(s.apiNotebook));for(const a of this.h.values())a.notebookData.uri.toString()===i.toString()&&this.h.delete(a.id)}if(g.value.addedDocuments){const w=[];for(const i of g.value.addedDocuments){const s=y.URI.revive(i.uri);if(this.g.has(s))throw new Error(`adding EXISTING notebook ${s} `);const a=new f.ExtHostNotebookDocument(this.c,this.q,this.r,s,i);w.push(...i.cells.map(u=>f.ExtHostCell.asModelAddData(a.apiNotebook,u))),this.g.get(s)?.dispose(),this.g.set(s,a),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:w}),this.m.fire(a.apiNotebook)}}if(g.value.addedEditors)for(const w of g.value.addedEditors){if(this.h.has(w.id))return;const i=y.URI.revive(w.documentUri),s=this.g.get(i);s&&this.w(s,w.id,w)}const p=[];if(g.value.removedEditors)for(const w of g.value.removedEditors){const i=this.h.get(w);i&&(this.h.delete(w),this.k?.id===i.id&&(this.k=void 0),p.push(i))}if(g.value.visibleEditors){this.l=g.value.visibleEditors.map(i=>this.h.get(i)).filter(i=>!!i);const w=new Set;this.l.forEach(i=>w.add(i.id));for(const i of this.h.values()){const s=w.has(i.id);i._acceptVisibility(s)}this.l=[...this.h.values()].map(i=>i).filter(i=>i.visible),this.o.fire(this.visibleNotebookEditors)}g.value.newActiveEditor===null?this.k=void 0:g.value.newActiveEditor&&(this.k=this.h.get(g.value.newActiveEditor)),g.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static x(g){const p=P.ApiCommandArgument.String.with("notebookType","A notebook type"),w=new P.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[p,new P.ApiCommandArgument("data","Bytes to convert to data",s=>s instanceof Uint8Array,s=>o.VSBuffer.wrap(s))],new P.ApiCommandResult("Notebook Data",s=>v.NotebookData.to(s.value))),i=new P.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[p,new P.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",s=>!0,s=>new E.SerializableObjectWithBuffers(v.NotebookData.from(s)))],new P.ApiCommandResult("Bytes",s=>s.buffer));g.registerApiCommand(w),g.registerApiCommand(i)}}e.ExtHostNotebookController=h,h.a=0}),define(ye[261],Ce([1,0,18,16,21,3,6,28,2,26,13,69,5,40,14,7,93,223,27,57]),function(te,e,o,t,T,R,I,A,y,D,L,P,v,C,E,f,d,h,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let p=class{constructor(l,c,n,r,m){this.k=c,this.l=n,this.m=r,this.n=m,this.b=new A.ResourceMap,this.c=new Map,this.d=0,this.e=new Map,this.f=0,this.g=new P.Cache("NotebookKernelSourceActionProviderCache"),this.h=new Map,this.i=0,this.j=new R.Emitter,this.onDidChangeNotebookCellExecutionState=this.j.event,this.a=l.getProxy(v.MainContext.MainThreadNotebookKernels);const S=new C.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new C.ApiCommandArgument("options","Select kernel options",k=>!0,k=>{if(k&&"notebookEditor"in k&&"id"in k){const M=this.l.getIdByEditor(k.notebookEditor);return{id:k.id,extension:k.extension,notebookEditorId:M}}else if(k&&"notebookEditor"in k){const M=this.l.getIdByEditor(k.notebookEditor);if(M===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${k.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:M}}return k})],C.ApiCommandResult.Void);this.m.registerApiCommand(S)}createNotebookController(l,c,n,r,m,S){for(const Z of this.h.values())if(Z.controller.id===c&&D.ExtensionIdentifier.equals(l.identifier,Z.extensionId))throw new Error(`notebook controller with id '${c}' ALREADY exist`);const k=this.i++,M=this;this.n.trace(`NotebookController[${k}], CREATED by ${l.identifier.value}, ${c}`);const q=()=>console.warn(`NO execute handler from notebook controller '${B.id}' of extension: '${l.identifier}'`);let V=!1;const F=new I.DisposableStore,U=new R.Emitter,N=new R.Emitter,B={id:a(l.identifier,c),notebookType:n,extensionId:l.identifier,extensionLocation:l.extensionLocation,label:r||l.identifier.value,preloads:S?S.map(E.NotebookRendererScript.from):[]};let j=m??q,z;this.a.$addKernel(k,B).catch(Z=>{console.log(Z),V=!0});let ne=0;const _=()=>{if(V)return;const Z=++ne;Promise.resolve().then(()=>{Z===ne&&this.a.$updateKernel(k,B)})},Y=new A.ResourceMap,J={get id(){return c},get notebookType(){return B.notebookType},onDidChangeSelectedNotebooks:U.event,get label(){return B.label},set label(Z){B.label=Z??l.displayName??l.name,_()},get detail(){return B.detail??""},set detail(Z){B.detail=Z,_()},get description(){return B.description??""},set description(Z){B.description=Z,_()},get kind(){return(0,b.checkProposedApiEnabled)(l,"notebookControllerKind"),B.kind??""},set kind(Z){(0,b.checkProposedApiEnabled)(l,"notebookControllerKind"),B.kind=Z,_()},get supportedLanguages(){return B.supportedLanguages},set supportedLanguages(Z){B.supportedLanguages=Z,_()},get supportsExecutionOrder(){return B.supportsExecutionOrder??!1},set supportsExecutionOrder(Z){B.supportsExecutionOrder=Z,_()},get rendererScripts(){return B.preloads?B.preloads.map(E.NotebookRendererScript.to):[]},get executeHandler(){return j},set executeHandler(Z){j=Z??q},get interruptHandler(){return z},set interruptHandler(Z){z=Z,B.supportsInterrupt=Boolean(Z),_()},createNotebookCellExecution(Z){if(V)throw new Error("notebook controller is DISPOSED");if(!Y.has(Z.notebook.uri))throw M.n.trace(`NotebookController[${k}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Y.keys()).map(ie=>ie.toString())),new Error(`notebook controller is NOT associated to notebook: ${Z.notebook.uri.toString()}`);return M._createNotebookCellExecution(Z,a(l.identifier,this.id))},dispose:()=>{V||(this.n.trace(`NotebookController[${k}], DISPOSED`),V=!0,this.h.delete(k),F.dispose(),U.dispose(),N.dispose(),this.a.$removeKernel(k))},updateNotebookAffinity(Z,ie){ie===f.NotebookControllerAffinity2.Hidden&&(0,b.checkProposedApiEnabled)(l,"notebookControllerAffinityHidden"),M.a.$updateNotebookPriority(k,Z.uri,ie)},onDidReceiveMessage:N.event,postMessage(Z,ie){return(0,b.checkProposedApiEnabled)(l,"notebookMessaging"),M.a.$postMessage(k,ie&&M.l.getIdByEditor(ie),Z)},asWebviewUri(Z){return(0,b.checkProposedApiEnabled)(l,"notebookMessaging"),(0,d.asWebviewUri)(Z,M.k.remote)}};return this.h.set(k,{extensionId:l.identifier,controller:J,onDidReceiveMessage:N,onDidChangeSelection:U,associatedNotebooks:Y}),J}getIdByController(l){for(const[c,n]of this.h)if(n.controller===l)return a(n.extensionId,l.id);return null}createNotebookControllerDetectionTask(l,c){const n=this.d++,r=this;this.n.trace(`NotebookControllerDetectionTask[${n}], CREATED by ${l.identifier.value}`),this.a.$addKernelDetectionTask(n,c);const m={dispose:()=>{this.c.delete(n),r.a.$removeKernelDetectionTask(n)}};return this.c.set(n,m),m}registerKernelSourceActionProvider(l,c,n){const r=this.f++,m=this;return this.e.set(r,n),this.n.trace(`NotebookKernelSourceActionProvider[${r}], CREATED by ${l.identifier.value}`),this.a.$addKernelSourceActionProvider(r,c),{dispose:()=>{this.e.delete(r),m.a.$removeKernelSourceActionProvider(r)}}}async $provideKernelSourceActions(l,c){const n=this.e.get(l);if(n){const r=new I.DisposableStore;return this.g.add([r]),(await n.provideNotebookKernelSourceActions(c)??[]).map(S=>E.NotebookKernelSourceAction.from(S,this.m.converter,r))}return[]}$acceptNotebookAssociation(l,c,n){const r=this.h.get(l);if(r){const m=this.l.getNotebookDocument(y.URI.revive(c));n?r.associatedNotebooks.set(m.uri,!0):r.associatedNotebooks.delete(m.uri),this.n.trace(`NotebookController[${l}] ASSOCIATE notebook`,m.uri.toString(),n),r.onDidChangeSelection.fire({selected:n,notebook:m.apiNotebook})}}async $executeCells(l,c,n){const r=this.h.get(l);if(!r)return;const m=this.l.getNotebookDocument(y.URI.revive(c)),S=[];for(const k of n){const M=m.getCell(k);M&&S.push(M.apiCell)}try{this.n.trace(`NotebookController[${l}] EXECUTE cells`,m.uri.toString(),S.length),await r.controller.executeHandler.call(r.controller,S,m.apiNotebook,r.controller)}catch(k){this.n.error(`NotebookController[${l}] execute cells FAILED`,k),console.error(k)}}async $cancelCells(l,c,n){const r=this.h.get(l);if(!r)return;const m=this.l.getNotebookDocument(y.URI.revive(c));if(r.controller.interruptHandler)await r.controller.interruptHandler.call(r.controller,m.apiNotebook);else for(const S of n){const k=m.getCell(S);k&&this.b.get(k.uri)?.cancel()}}$acceptKernelMessageFromRenderer(l,c,n){const r=this.h.get(l);if(!r)return;const m=this.l.getEditorById(c);r.onDidReceiveMessage.fire(Object.freeze({editor:m.apiEditor,message:n}))}$cellExecutionChanged(l,c,n){const m=this.l.getNotebookDocument(y.URI.revive(l)).getCell(c);if(m){const S=n?E.NotebookCellExecutionState.to(n):f.NotebookCellExecutionState.Idle;S!==void 0&&this.j.fire({cell:m.apiCell,state:S})}}_createNotebookCellExecution(l,c){if(l.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const r=this.l.getNotebookDocument(l.notebook.uri).getCellFromApiCell(l);if(!r)throw new Error("invalid cell");if(this.b.has(r.uri))throw new Error(`duplicate execution for ${r.uri}`);const m=new i(c,r,this.a);this.b.set(r.uri,m);const S=m.onDidChangeState(()=>{m.state===w.Resolved&&(m.dispose(),S.dispose(),this.b.delete(r.uri))});return m.asApiObject()}};p=qe([We(4,L.ILogService)],p),e.ExtHostNotebookKernels=p;var w;(function(u){u[u.Init=0]="Init",u[u.Started=1]="Started",u[u.Resolved=2]="Resolved"})(w||(w={}));class i extends I.Disposable{get state(){return this.f}constructor(l,c,n){super(),this.j=c,this.k=n,this.b=i.a++,this.c=new R.Emitter,this.onDidChangeState=this.c.event,this.f=w.Init,this.g=this.B(new T.CancellationTokenSource),this.h=new s(10,r=>this.m(r)),this.i=c.internalMetadata.executionOrder,this.k.$createExecution(this.b,l,this.j.notebook.uri,this.j.handle)}cancel(){this.g.cancel()}async l(l){await this.h.addItem(l)}async m(l){const c=Array.isArray(l)?l:[l];return this.k.$updateExecution(this.b,new g.SerializableObjectWithBuffers(c))}n(){if(this.f===w.Init)throw new Error("Must call start before modifying cell output");if(this.f===w.Resolved)throw new Error("Cannot modify cell output after calling resolve")}r(l){let c=this.j;if(l&&(c=this.j.notebook.getCellFromApiCell(l)),!c)throw new Error("INVALID cell");return c.handle}s(l){return l.map(c=>{const n=f.NotebookCellOutput.ensureUniqueMimeTypes(c.items,!0);return n===c.items?E.NotebookCellOutput.from(c):E.NotebookCellOutput.from({items:n,id:c.id,metadata:c.metadata})})}async t(l,c,n){const r=this.r(c),m=this.s((0,o.asArray)(l));return this.l({editType:h.CellExecutionUpdateType.Output,cellHandle:r,append:n,outputs:m})}async w(l,c,n){return l=f.NotebookCellOutput.ensureUniqueMimeTypes((0,o.asArray)(l),!0),this.l({editType:h.CellExecutionUpdateType.OutputItems,items:l.map(E.NotebookCellOutputItem.from),outputId:c.id,append:n})}asApiObject(){const l=this;return Object.freeze({get token(){return l.g.token},get cell(){return l.j.apiCell},get executionOrder(){return l.i},set executionOrder(n){l.i=n,l.m([{editType:h.CellExecutionUpdateType.ExecutionState,executionOrder:l.i}])},start(n){if(l.f===w.Resolved||l.f===w.Started)throw new Error("Cannot call start again");l.f=w.Started,l.c.fire(),l.m({editType:h.CellExecutionUpdateType.ExecutionState,runStartTime:n})},end(n,r){if(l.f===w.Resolved)throw new Error("Cannot call resolve twice");l.f=w.Resolved,l.c.fire(),l.h.flush(),l.k.$completeExecution(l.b,new g.SerializableObjectWithBuffers({runEndTime:r,lastRunSuccess:n}))},clearOutput(n){return l.n(),l.t([],n,!1)},appendOutput(n,r){return l.n(),l.t(n,r,!0)},replaceOutput(n,r){return l.n(),l.t(n,r,!1)},appendOutputItems(n,r){return l.n(),l.w(n,r,!0)},replaceOutputItems(n,r){return l.n(),l.w(n,r,!1)}})}}i.a=0;class s{constructor(l,c){this.d=l,this.e=c,this.a=[],this.b=Date.now()}addItem(l){return this.a.push(l),this.c||(this.c=new t.DeferredPromise,this.b=Date.now(),(0,t.timeout)(this.d).then(()=>this.flush())),Date.now()-this.b>this.d?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const l=this.c;this.c=void 0;const c=this.a;return this.a=[],this.e(c).finally(()=>l.complete())}}function a(u,l){return`${u.value}/${l}`}e.createKernelId=a}),define(ye[262],Ce([1,0,3,5,136]),function(te,e,o,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class R{constructor(A,y){this.c=y,this.a=new Map,this.b=A.getProxy(t.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(A,y,D){const L=this.c.getEditorById(A);this.a.get(y)?.fire({editor:L.apiEditor,message:D})}createRendererMessaging(A,y){if(!A.contributes?.notebookRenderer?.some(L=>L.id===y))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${y})`);return{onDidReceiveMessage:(L,P,v)=>this.d(y).event(L,P,v),postMessage:(L,P)=>{T.ExtHostNotebookEditor.apiEditorsToExtHost.has(L)&&([L,P]=[P,L]);const v=P&&T.ExtHostNotebookEditor.apiEditorsToExtHost.get(P);return this.b.$postMessage(v?.id,y,L)}}}d(A){let y=this.a.get(A);return y||(y=new o.Emitter({onDidRemoveLastListener:()=>{y?.dispose(),this.a.delete(A)}}),this.a.set(A,y),y)}}e.ExtHostNotebookRenderers=R}),define(ye[263],Ce([1,0,6,11,2,27,5]),function(te,e,o,t,T,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class A{constructor(D){this.b=new Map,this.a=D.getProxy(I.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(D,L,P){if((0,R.checkProposedApiEnabled)(D,"profileContentHandlers"),this.b.has(L))throw new Error(`Handler with id '${L}' already registered`);return this.b.set(L,P),this.a.$registerProfileContentHandler(L,P.name,P.description,D.identifier.value),(0,o.toDisposable)(()=>{this.b.delete(L),this.a.$unregisterProfileContentHandler(L)})}async $saveProfile(D,L,P,v){const C=this.b.get(D);if(!C)throw new Error(`Unknown handler with id: ${D}`);return C.saveProfile(L,P,v)}async $readProfile(D,L,P){const v=this.b.get(D);if(!v)throw new Error(`Unknown handler with id: ${D}`);return v.readProfile((0,t.isString)(L)?L:T.URI.revive(L),P)}}e.ExtHostProfileContentHandlers=A}),define(ye[264],Ce([1,0,21,3,6,5,2,7,9,18,37,90]),function(te,e,o,t,T,R,I,A,y,D,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function v(C,E,f){const d=C.getProxy(R.MainContext.MainThreadQuickOpen);class h{constructor(l,c){this.e=new Map,this.f=0,this.a=l,this.b=c}showQuickPick(l,c,n=o.CancellationToken.None){this.c=void 0;const r=Promise.resolve(l),m=++this.f,S=d.$show(m,{title:c?.title,placeHolder:c?.placeHolder,matchOnDescription:c?.matchOnDescription,matchOnDetail:c?.matchOnDetail,ignoreFocusLost:c?.ignoreFocusOut,canPickMany:c?.canPickMany},n),k={},M=S.then(()=>k);return Promise.race([M,r]).then(q=>{if(q!==k)return r.then(V=>{const F=[];for(let U=0;U<V.length;U++){const N=V[U];typeof N=="string"?F.push({label:N,handle:U}):N.kind===A.QuickPickItemKind.Separator?F.push({type:"separator",label:N.label}):F.push({label:N.label,description:N.description,detail:N.detail,picked:N.picked,alwaysShow:N.alwaysShow,handle:U})}return c&&typeof c.onDidSelectItem=="function"&&(this.c=U=>{c.onDidSelectItem(V[U])}),d.$setItems(m,F),S.then(U=>{if(typeof U=="number")return V[U];if(Array.isArray(U))return U.map(N=>V[N])})})}).then(void 0,q=>{if(!(0,y.isCancellationError)(q))return d.$setError(m,q),Promise.reject(q)})}$onItemSelected(l){this.c?.(l)}showInput(l,c=o.CancellationToken.None){return this.d=l?.validateInput,d.$input(l,typeof this.d=="function",c).then(void 0,n=>{if(!(0,y.isCancellationError)(n))return Promise.reject(n)})}async $validateInput(l){if(!this.d)return;const c=await this.d(l);if(!c||typeof c=="string")return c;let n;switch(c.severity){case A.InputBoxValidationSeverity.Info:n=L.default.Info;break;case A.InputBoxValidationSeverity.Warning:n=L.default.Warning;break;case A.InputBoxValidationSeverity.Error:n=L.default.Error;break;default:n=c.message?L.default.Error:L.default.Ignore;break}return{content:c.message,severity:n}}async showWorkspaceFolderPick(l,c=o.CancellationToken.None){const n=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[l]);if(!n)return;const r=await this.a.getWorkspaceFolders2();if(!!r)return r.find(m=>m.uri.toString()===n.uri.toString())}createQuickPick(l){const c=new s(l,()=>this.e.delete(c._id));return this.e.set(c._id,c),c}createInputBox(l){const c=new a(l,()=>this.e.delete(c._id));return this.e.set(c._id,c),c}$onDidChangeValue(l,c){this.e.get(l)?._fireDidChangeValue(c)}$onDidAccept(l){this.e.get(l)?._fireDidAccept()}$onDidChangeActive(l,c){const n=this.e.get(l);n instanceof s&&n._fireDidChangeActive(c)}$onDidChangeSelection(l,c){const n=this.e.get(l);n instanceof s&&n._fireDidChangeSelection(c)}$onDidTriggerButton(l,c){this.e.get(l)?._fireDidTriggerButton(c)}$onDidTriggerItemButton(l,c,n){const r=this.e.get(l);r instanceof s&&r._fireDidTriggerItemButton(c,n)}$onDidHide(l){this.e.get(l)?._fireDidHide()}}class b{constructor(l,c){this.x=l,this.y=c,this._id=s.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new t.Emitter,this.q=new t.Emitter,this.r=new t.Emitter,this.s=new t.Emitter,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(l){this.b=l,this.z({title:l})}get step(){return this.c}set step(l){this.c=l,this.z({step:l})}get totalSteps(){return this.d}set totalSteps(l){this.d=l,this.z({totalSteps:l})}get enabled(){return this.g}set enabled(l){this.g=l,this.z({enabled:l})}get busy(){return this.j}set busy(l){this.j=l,this.z({busy:l})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(l){this.k=l,this.z({ignoreFocusOut:l})}get value(){return this.l}set value(l){this.l=l,this.z({value:l})}get placeholder(){return this.m}set placeholder(l){this.m=l,this.z({placeholder:l})}get buttons(){return this.n}set buttons(l){this.n=l.slice(),this.o.clear(),l.forEach((c,n)=>{const r=c===A.QuickInputButtons.Back?-1:n;this.o.set(r,c)}),this.z({buttons:l.map((c,n)=>({...i(c),tooltip:c.tooltip,handle:c===A.QuickInputButtons.Back?-1:n}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(l){this.l=l,this.q.fire(l)}_fireDidTriggerButton(l){const c=this.o.get(l);c&&this.r.fire(c)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,T.dispose)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),d.$dispose(this._id))}z(l){if(!this.v){for(const c of Object.keys(l)){const n=l[c];this.u[c]=n===void 0?null:n}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){d.$createOrUpdate(this.u),this.u={id:this._id}}}b.a=1;function g(u){if(u instanceof A.ThemeIcon)return{id:u.id};const l=w(u),c=p(u);return{dark:typeof l=="string"?I.URI.file(l):l,light:typeof c=="string"?I.URI.file(c):c}}function p(u){return typeof u=="object"&&"light"in u?u.light:u}function w(u){return typeof u=="object"&&"dark"in u?u.dark:u}function i(u){const l=g(u.iconPath);let c,n;return"id"in l?n=P.ThemeIcon.asClassName(l):c=l,{iconPath:c,iconClass:n}}class s extends b{constructor(l,c){super(l.identifier,c),this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new t.Emitter,this.L=[],this.M=new t.Emitter,this.N=new t.Emitter,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(l){this.B=l.slice(),this.C.clear(),this.D.clear(),l.forEach((n,r)=>{this.C.set(r,n),this.D.set(n,r)});const c=[];for(let n=0;n<l.length;n++){const r=l[n];r.kind===A.QuickPickItemKind.Separator?c.push({type:"separator",label:r.label}):c.push({handle:n,label:r.label,description:r.description,detail:r.detail,picked:r.picked,alwaysShow:r.alwaysShow,buttons:r.buttons?.map((m,S)=>({...i(m),tooltip:m.tooltip,handle:S}))})}this.z({items:c})}get canSelectMany(){return this.E}set canSelectMany(l){this.E=l,this.z({canSelectMany:l})}get matchOnDescription(){return this.F}set matchOnDescription(l){this.F=l,this.z({matchOnDescription:l})}get matchOnDetail(){return this.G}set matchOnDetail(l){this.G=l,this.z({matchOnDetail:l})}get sortByLabel(){return this.H}set sortByLabel(l){this.H=l,this.z({sortByLabel:l})}get keepScrollPosition(){return this.I}set keepScrollPosition(l){this.I=l,this.z({keepScrollPosition:l})}get activeItems(){return this.J}set activeItems(l){this.J=l.filter(c=>this.D.has(c)),this.z({activeItems:this.J.map(c=>this.D.get(c))})}get selectedItems(){return this.L}set selectedItems(l){this.L=l.filter(c=>this.D.has(c)),this.z({selectedItems:this.L.map(c=>this.D.get(c))})}_fireDidChangeActive(l){const c=(0,D.coalesce)(l.map(n=>this.C.get(n)));this.J=c,this.K.fire(c)}_fireDidChangeSelection(l){const c=(0,D.coalesce)(l.map(n=>this.C.get(n)));this.L=c,this.M.fire(c)}_fireDidTriggerItemButton(l,c){const n=this.C.get(l);if(!n||!n.buttons||!n.buttons.length)return;const r=n.buttons[c];r&&this.N.fire({button:r,item:n})}}class a extends b{constructor(l,c){super(l.identifier,c),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(l){this.B=l,this.z({password:l})}get prompt(){return this.C}set prompt(l){this.C=l,this.z({prompt:l})}get valueSelection(){return this.D}set valueSelection(l){this.D=l,this.z({valueSelection:l})}get validationMessage(){return this.E}set validationMessage(l){this.E=l,l?typeof l=="string"?this.z({validationMessage:l,severity:L.default.Error}):this.z({validationMessage:l.message,severity:l.severity??L.default.Error}):this.z({validationMessage:void 0,severity:L.default.Ignore})}}return new h(E,f)}e.createExtHostQuickOpen=v});var Ue=this&&this.__classPrivateFieldGet||function(te,e,o,t){if(o==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?t:o==="a"?t.call(te):t?t.value:e.get(te)},Je=this&&this.__classPrivateFieldSet||function(te,e,o,t,T){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?T.call(te,o):T?T.value=o:e.set(te,o),o};define(ye[265],Ce([1,0,2,3,60,6,16,5,18,109,13,26,90,14,27]),function(te,e,o,t,T,R,I,A,y,D,L,P,v,C,E){"use strict";var f,d;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function h(r){if(r)return typeof r.iconPath=="string"?o.URI.file(r.iconPath):o.URI.isUri(r.iconPath)||v.ThemeIcon.isThemeIcon(r.iconPath)?r.iconPath:void 0}function b(r,m){if(!r.iconPath&&!m.iconPath)return 0;if(r.iconPath){if(!m.iconPath)return 1}else return-1;const S=typeof r.iconPath=="string"?r.iconPath:o.URI.isUri(r.iconPath)?r.iconPath.fsPath:r.iconPath.id,k=typeof m.iconPath=="string"?m.iconPath:o.URI.isUri(m.iconPath)?m.iconPath.fsPath:m.iconPath.id;return(0,D.comparePaths)(S,k)}function g(r,m){let S=0;if(r.strikeThrough!==m.strikeThrough)return r.strikeThrough?1:-1;if(r.faded!==m.faded)return r.faded?1:-1;if(r.tooltip!==m.tooltip)return(r.tooltip||"").localeCompare(m.tooltip||"");if(S=b(r,m),S!==0)return S;if(r.light&&m.light)S=b(r.light,m.light);else{if(r.light)return 1;if(m.light)return-1}if(S!==0)return S;if(r.dark&&m.dark)S=b(r.dark,m.dark);else{if(r.dark)return 1;if(m.dark)return-1}return S}function p(r,m){if(r.command!==m.command)return r.command<m.command?-1:1;if(r.title!==m.title)return r.title<m.title?-1:1;if(r.tooltip!==m.tooltip){if(r.tooltip!==void 0&&m.tooltip!==void 0)return r.tooltip<m.tooltip?-1:1;if(r.tooltip!==void 0)return 1;if(m.tooltip!==void 0)return-1}if(r.arguments===m.arguments)return 0;if(r.arguments)if(m.arguments){if(r.arguments.length!==m.arguments.length)return r.arguments.length-m.arguments.length}else return 1;else return-1;for(let S=0;S<r.arguments.length;S++){const k=r.arguments[S],M=m.arguments[S];if(k!==M)return k<M?-1:1}return 0}function w(r,m){let S=(0,D.comparePaths)(r.resourceUri.fsPath,m.resourceUri.fsPath,!0);if(S!==0)return S;if(r.command&&m.command)S=p(r.command,m.command);else{if(r.command)return 1;if(m.command)return-1}if(S!==0)return S;if(r.decorations&&m.decorations)S=g(r.decorations,m.decorations);else{if(r.decorations)return 1;if(m.decorations)return-1}return S}function i(r,m){for(let S=0;S<r.length;S++)if(r[S]!==m[S])return!1;return!0}function s(r,m){return r.command===m.command&&r.title===m.title&&r.tooltip===m.tooltip&&(r.arguments&&m.arguments?i(r.arguments,m.arguments):r.arguments===m.arguments)}function a(r,m){return(0,y.equals)(r,m,s)}class u{get value(){return this.d}set value(m){m=m??"",Ue(this,f,"f").$setInputBoxValue(this.l,m),this.m(m)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(m){Ue(this,f,"f").$setInputBoxPlaceholder(this.l,m),this.f=m}get validateInput(){return(0,E.checkProposedApiEnabled)(this.k,"scmValidation"),this.g}set validateInput(m){if((0,E.checkProposedApiEnabled)(this.k,"scmValidation"),m&&typeof m!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=m,Ue(this,f,"f").$setValidationProviderIsEnabled(this.l,!!m)}get enabled(){return this.h}set enabled(m){m=!!m,this.h!==m&&(this.h=m,Ue(this,f,"f").$setInputBoxEnablement(this.l,m))}get visible(){return this.j}set visible(m){m=!!m,this.j!==m&&(this.j=m,Ue(this,f,"f").$setInputBoxVisibility(this.l,m))}constructor(m,S,k){this.k=m,this.l=k,f.set(this,void 0),this.d="",this.e=new t.Emitter,this.f="",this.h=!0,this.j=!0,Je(this,f,S,"f")}showValidationMessage(m,S){(0,E.checkProposedApiEnabled)(this.k,"scmValidation"),Ue(this,f,"f").$showValidationMessage(this.l,m,S)}$onInputBoxValueChange(m){this.m(m)}m(m){this.d=m,this.e.fire(m)}}e.ExtHostSCMInputBox=u,f=new WeakMap;class l{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(m){this.v=m,this.q.$updateGroupLabel(this.t,this.handle,m)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(m){this.p=m,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(m){this.f=[...m],this.k.fire()}constructor(m,S,k,M,q){this.q=m,this.s=S,this.t=k,this.u=M,this.v=q,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new t.Emitter,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new t.Emitter,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=l.d++}getResourceState(m){return this.g.get(m)}$executeResourceCommand(m,S){const k=this.h.get(m);return k?(0,I.asPromise)(()=>this.s.executeCommand(k.command,...k.arguments||[],S)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const m=[...this.f].sort(w),k=(0,y.sortedDiff)(this.o,m,w).map(V=>{const F=V.toInsert.map(U=>{const N=this.e++;this.g.set(N,U);const B=U.resourceUri;let j;if(U.command)if(U.command.command==="vscode.open"||U.command.command==="vscode.diff"){const he=new R.DisposableStore;j=this.s.converter.toInternal(U.command,he),this.j.set(N,he)}else this.h.set(N,U.command);const z=h(U.decorations),ne=U.decorations&&h(U.decorations.light)||z,_=U.decorations&&h(U.decorations.dark)||z,Y=[ne,_],J=U.decorations&&U.decorations.tooltip||"",Z=U.decorations&&!!U.decorations.strikeThrough,ie=U.decorations&&!!U.decorations.faded,X=U.contextValue||"";return{rawResource:[N,B,Y,J,Z,ie,X,j],handle:N}});return{start:V.start,deleteCount:V.deleteCount,toInsert:F}}),M=k.map(({start:V,deleteCount:F,toInsert:U})=>[V,F,U.map(N=>N.rawResource)]),q=k.reverse();for(const{start:V,deleteCount:F,toInsert:U}of q){const N=U.map(j=>j.handle),B=this.n.splice(V,F,...N);for(const j of B)this.g.delete(j),this.h.delete(j),this.j.get(j)?.dispose(),this.j.delete(j)}return this.o=m,M}dispose(){this.l=!0,this.m.fire()}}l.d=0;class c{get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(m){this.g!==m&&(this.g=m,Ue(this,d,"f").$updateSourceControl(this.t,{count:m}))}get quickDiffProvider(){return this.h}set quickDiffProvider(m){this.h=m,Ue(this,d,"f").$updateSourceControl(this.t,{hasQuickDiffProvider:!!m})}get commitTemplate(){return this.j}set commitTemplate(m){m!==this.j&&(this.j=m,Ue(this,d,"f").$updateSourceControl(this.t,{commitTemplate:m}))}get acceptInputCommand(){return this.l}set acceptInputCommand(m){this.k.value=new R.DisposableStore,this.l=m;const S=this.v.converter.toInternal(m,this.k.value);Ue(this,d,"f").$updateSourceControl(this.t,{acceptInputCommand:S})}get actionButton(){return(0,E.checkProposedApiEnabled)(this.u,"scmActionButton"),this.n}set actionButton(m){(0,E.checkProposedApiEnabled)(this.u,"scmActionButton"),this.m.value=new R.DisposableStore,this.n=m;const S=m!==void 0?{command:this.v.converter.toInternal(m.command,this.m.value),secondaryCommands:m.secondaryCommands?.map(k=>k.map(M=>this.v.converter.toInternal(M,this.m.value))),description:m.description,enabled:m.enabled}:void 0;Ue(this,d,"f").$updateSourceControl(this.t,{actionButton:S??null})}get statusBarCommands(){return this.p}set statusBarCommands(m){if(this.p&&m&&a(this.p,m))return;this.o.value=new R.DisposableStore,this.p=m;const S=(m||[]).map(k=>this.v.converter.toInternal(k,this.o.value));Ue(this,d,"f").$updateSourceControl(this.t,{statusBarCommands:S})}get selected(){return this.q}constructor(m,S,k,M,q,V){this.u=m,this.v=k,this.w=M,this.x=q,this.y=V,d.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new R.MutableDisposable,this.l=void 0,this.m=new R.MutableDisposable,this.o=new R.MutableDisposable,this.p=void 0,this.q=!1,this.s=new t.Emitter,this.onDidChangeSelection=this.s.event,this.t=c.d++,this.z=new Map,this.A=new Set,Je(this,d,S,"f"),this.f=new u(m,Ue(this,d,"f"),this.t),Ue(this,d,"f").$registerSourceControl(this.t,M,q,V)}createResourceGroup(m,S){const k=new l(Ue(this,d,"f"),this.v,this.t,m,S),M=t.Event.once(k.onDidDispose)(()=>this.z.delete(k));return this.z.set(k,M),this.eventuallyAddResourceGroups(),k}eventuallyAddResourceGroups(){const m=[],S=[];for(const[k,M]of this.z){M.dispose();const q=k.onDidUpdateResourceStates(()=>{this.A.add(k),this.eventuallyUpdateResourceStates()});t.Event.once(k.onDidDispose)(()=>{this.A.delete(k),q.dispose(),this.e.delete(k.handle),Ue(this,d,"f").$unregisterGroup(this.t,k.handle)}),m.push([k.handle,k.id,k.label,k.features]);const V=k._takeResourceStateSnapshot();V.length>0&&S.push([k.handle,V]),this.e.set(k.handle,k)}Ue(this,d,"f").$registerGroups(this.t,m,S),this.z.clear()}eventuallyUpdateResourceStates(){const m=[];this.A.forEach(S=>{const k=S._takeResourceStateSnapshot();k.length!==0&&m.push([S.handle,k])}),m.length>0&&Ue(this,d,"f").$spliceResourceStates(this.t,m),this.A.clear()}getResourceGroup(m){return this.e.get(m)}setSelectionState(m){this.q=m,this.s.fire(m)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(m=>m.dispose()),Ue(this,d,"f").$unregisterSourceControl(this.t)}}d=new WeakMap,c.d=0,qe([(0,T.debounce)(100)],c.prototype,"eventuallyAddResourceGroups",null),qe([(0,T.debounce)(100)],c.prototype,"eventuallyUpdateResourceStates",null);let n=class ii{get onDidChangeActiveProvider(){return this.j.event}constructor(m,S,k){this.l=S,this.m=k,this.g=new Map,this.h=new Map,this.j=new t.Emitter,this.e=m.getProxy(A.MainContext.MainThreadSCM),this.f=m.getProxy(A.MainContext.MainThreadTelemetry),S.registerArgumentProcessor({processArgument:M=>{if(M&&M.$mid===3){const q=this.g.get(M.sourceControlHandle);if(!q)return M;const V=q.getResourceGroup(M.groupHandle);return V?V.getResourceState(M.handle):M}else if(M&&M.$mid===4){const q=this.g.get(M.sourceControlHandle);return q?q.getResourceGroup(M.groupHandle):M}else if(M&&M.$mid===5){const q=this.g.get(M.handle);return q||M}return M}})}createSourceControl(m,S,k,M){this.m.trace("ExtHostSCM#createSourceControl",m.identifier.value,S,k,M),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:m.identifier.value});const q=ii.d++,V=new c(m,this.e,this.l,S,k,M);this.g.set(q,V);const F=this.h.get(P.ExtensionIdentifier.toKey(m.identifier))||[];return F.push(V),this.h.set(P.ExtensionIdentifier.toKey(m.identifier),F),V}getLastInputBox(m){this.m.trace("ExtHostSCM#getLastInputBox",m.identifier.value);const S=this.h.get(P.ExtensionIdentifier.toKey(m.identifier)),k=S&&S[S.length-1];return k&&k.inputBox}$provideOriginalResource(m,S,k){const M=o.URI.revive(S);this.m.trace("ExtHostSCM#$provideOriginalResource",m,M.toString());const q=this.g.get(m);return!q||!q.quickDiffProvider||!q.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,I.asPromise)(()=>q.quickDiffProvider.provideOriginalResource(M,k)).then(V=>V||null)}$onInputBoxValueChange(m,S){this.m.trace("ExtHostSCM#$onInputBoxValueChange",m);const k=this.g.get(m);return k&&k.inputBox.$onInputBoxValueChange(S),Promise.resolve(void 0)}$executeResourceCommand(m,S,k,M){this.m.trace("ExtHostSCM#$executeResourceCommand",m,S,k);const q=this.g.get(m);if(!q)return Promise.resolve(void 0);const V=q.getResourceGroup(S);return V?V.$executeResourceCommand(k,M):Promise.resolve(void 0)}$validateInput(m,S,k){this.m.trace("ExtHostSCM#$validateInput",m);const M=this.g.get(m);return!M||!M.inputBox.validateInput?Promise.resolve(void 0):(0,I.asPromise)(()=>M.inputBox.validateInput(S,k)).then(q=>{if(!q)return Promise.resolve(void 0);const V=C.MarkdownString.fromStrict(q.message);return V?Promise.resolve([V,q.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(m){return this.m.trace("ExtHostSCM#$setSelectedSourceControl",m),m!==void 0&&this.g.get(m)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=m,Promise.resolve(void 0)}};n.d=0,n=qe([We(2,L.ILogService)],n),e.ExtHostSCM=n}),define(ye[97],Ce([1,0,5,3,4]),function(te,e,o,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class R{constructor(A){this.b=new t.Emitter,this.onDidChangePassword=this.b.event,this.a=A.getProxy(o.MainContext.MainThreadSecretState)}async $onDidChangePassword(A){this.b.fire(A)}get(A,y){return this.a.$getPassword(A,y)}store(A,y,D){return this.a.$setPassword(A,y,D)}delete(A,y){return this.a.$deletePassword(A,y)}}e.ExtHostSecretState=R,e.IExtHostSecretState=(0,T.createDecorator)("IExtHostSecretState")});var Je=this&&this.__classPrivateFieldSet||function(te,e,o,t,T){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?T.call(te,o):T?T.value=o:e.set(te,o),o},Ue=this&&this.__classPrivateFieldGet||function(te,e,o,t){if(o==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?t:o==="a"?t.call(te):t?t.value:e.get(te)};define(ye[266],Ce([1,0,7,5,178,6,14,11]),function(te,e,o,t,T,R,I,A){"use strict";var y,D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class L{constructor(E,f,d,h,b=o.StatusBarAlignment.Left,g){y.set(this,void 0),D.set(this,void 0),this.i=!1,this.j=!1,this.k="",this.q=new R.DisposableStore,Je(this,y,E,"f"),Je(this,D,f,"f"),this.c=L.a++,this.e=d,this.f=h,this.g=b,this.h=this.u(g)}u(E){if(!!(0,A.isNumber)(E))return E===Number.POSITIVE_INFINITY?Number.MAX_VALUE:E===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:E}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(E){this.k=E,this.v()}set name(E){this.m=E,this.v()}set tooltip(E){this.l=E,this.v()}set color(E){this.n=E,this.v()}set backgroundColor(E){E&&!L.b.has(E.id)&&(E=void 0),this.o=E,this.v()}set command(E){this.r?.fromApi!==E&&(this.p&&this.q.add(this.p),this.p=new R.DisposableStore,typeof E=="string"?this.r={fromApi:E,internal:Ue(this,D,"f").toInternal({title:"",command:E},this.p)}:E?this.r={fromApi:E,internal:Ue(this,D,"f").toInternal(E,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(E){this.t=E,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,Ue(this,y,"f").$dispose(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let E;this.e?this.f?E=`${this.e.identifier.value}.${this.f}`:E=this.e.identifier.value:E=this.f;let f;this.m?f=this.m:f=(0,T.localize)(0,null,this.e.displayName||this.e.name);let d=this.n;this.o&&(d=L.b.get(this.o.id));const h=I.MarkdownString.fromStrict(this.l);Ue(this,y,"f").$setEntry(this.c,E,f,this.k,h,this.r?.internal,d,this.o,this.g===o.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.ExtHostStatusBarEntry=L,y=new WeakMap,D=new WeakMap,L.a=0,L.b=new Map([["statusBarItem.errorBackground",new o.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new o.ThemeColor("statusBarItem.warningForeground")]]);class P{constructor(E){this.b=[],this.a=E.createStatusBarEntry(void 0,"status.extensionMessage",o.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,T.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(E){const f={message:E};return this.b.unshift(f),this.c(),new o.Disposable(()=>{const d=this.b.indexOf(f);d>=0&&(this.b.splice(d,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class v{constructor(E,f){this.a=E.getProxy(t.MainContext.MainThreadStatusBar),this.b=f,this.c=new P(this)}createStatusBarEntry(E,f,d,h){return new L(this.a,this.b,E,f,d,h)}setStatusBarMessage(E,f){const d=this.c.setMessage(E);let h;return typeof f=="number"?h=setTimeout(()=>d.dispose(),f):typeof f<"u"&&f.then(()=>d.dispose(),()=>d.dispose()),new o.Disposable(()=>{d.dispose(),clearTimeout(h)})}}e.ExtHostStatusBar=v}),define(ye[98],Ce([1,0,5,3,4]),function(te,e,o,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class R{constructor(A,y){this.c=y,this.b=new t.Emitter,this.onDidChangeStorage=this.b.event,this.a=A.getProxy(o.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(A,y){this.a.$registerExtensionStorageKeysToSync(A,y)}async initializeExtensionStorage(A,y,D){const L=await this.a.$initializeExtensionStorage(A,y);let P;return L&&(P=this.d(A,y,L)),P||D}setValue(A,y,D){return this.a.$setValue(A,y,D)}$acceptValue(A,y,D){const L=this.d(A,y,D);L&&this.b.fire({shared:A,key:y,value:L})}d(A,y,D){try{return JSON.parse(D)}catch(L){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${y}, global: ${A}): ${L}`)}}}e.ExtHostStorage=R,e.IExtHostStorage=(0,T.createDecorator)("IExtHostStorage")}),define(ye[73],Ce([1,0,4,25,13,72,2]),function(te,e,o,t,T,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,o.createDecorator)("IExtensionStoragePaths");let A=class{constructor(D,L,P){this.d=L,this.f=P,this.a=D.workspace??void 0,this.b=D.environment,this.whenReady=this.h().then(v=>this.c=v)}async g(D){return I.URI.joinPath(this.b.workspaceStorageHome,D)}async h(){if(!this.a)return Promise.resolve(void 0);const D=this.a.id,L=await this.g(D);try{return await this.f.value.stat(L),this.d.trace("[ExtHostStorage] storage dir already exists",L),L}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",L),await this.f.value.createDirectory(L),await this.f.value.writeFile(I.URI.joinPath(L,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:I.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),L}catch(P){this.d.error("[ExtHostStorage]",P);return}}workspaceValue(D){if(this.c)return I.URI.joinPath(this.c,D.identifier.value)}globalValue(D){return I.URI.joinPath(this.b.globalStorageHome,D.identifier.value.toLowerCase())}onWillDeactivateAll(){}};A=qe([We(0,t.IExtHostInitDataService),We(1,T.ILogService),We(2,R.IExtHostConsumerFileSystem)],A),e.ExtensionStoragePaths=A}),define(ye[41],Ce([1,0,3,5,4,2,17,6,7,179,9,224,21,30,209,90,11,16,14]),function(te,e,o,t,T,R,I,A,y,D,L,P,v,C,E,f,d,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,T.createDecorator)("IExtHostTerminalService");class g{constructor(n,r,m,S){this.k=n,this._id=r,this.l=m,this.m=S,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(M=>this.f=M);const k=this;this.value={get name(){return k.m||""},get processId(){return k.b},get creationOptions(){return k.l},get exitStatus(){return k.h},get state(){return k.j},sendText(M,q=!0){k.o(),k.k.$sendText(k._id,M,q)},show(M){k.o(),k.k.$show(k._id,M)},hide(){k.o(),k.k.$hide(k._id)},dispose(){k.a||(k.a=!0,k.k.$dispose(k._id))},get dimensions(){if(!(k.d===void 0||k.g===void 0))return{columns:k.d,rows:k.g}}}}async create(n,r){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:n.name,shellPath:(0,d.withNullAsUndefined)(n.shellPath),shellArgs:(0,d.withNullAsUndefined)(n.shellArgs),cwd:(0,d.withNullAsUndefined)(n.cwd),env:(0,d.withNullAsUndefined)(n.env),icon:(0,d.withNullAsUndefined)(u(n.iconPath)),color:f.ThemeColor.isThemeColor(n.color)?n.color.id:void 0,initialText:(0,d.withNullAsUndefined)(n.message),strictEnv:(0,d.withNullAsUndefined)(n.strictEnv),hideFromUser:(0,d.withNullAsUndefined)(n.hideFromUser),isFeatureTerminal:(0,d.withNullAsUndefined)(r?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,d.withNullAsUndefined)(r?.useShellEnvironment),location:r?.location||this.n(n.location,r?.resolvedExtHostIdentifier),isTransient:(0,d.withNullAsUndefined)(n.isTransient)})}async createExtensionTerminal(n,r,m,S){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:m,color:f.ThemeColor.isThemeColor(S)?S.id:void 0,location:this.n(n,r),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(n,r){return typeof n=="object"?"parentTerminal"in n&&n.parentTerminal&&r?{parentTerminal:r}:"viewColumn"in n?{viewColumn:b.ViewColumn.from(n.viewColumn),preserveFocus:n.preserveFocus}:void 0:n}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(n){this.m=n}setExitStatus(n,r){this.h=Object.freeze({code:n,reason:r})}setDimensions(n,r){return n===this.d&&r===this.g||n===0||r===0?!1:(this.d=n,this.g=r,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}_setProcessId(n){this.f?(this.f(n),this.f=void 0):this.b.then(r=>{r!==n&&(this.b=Promise.resolve(n))})}}e.ExtHostTerminal=g;class p{get onProcessReady(){return this.b.event}constructor(n){this.g=n,this.id=0,this.shouldPersist=!1,this.a=new o.Emitter,this.onProcessData=this.a.event,this.b=new o.Emitter,this.d=new o.Emitter,this.onDidChangeProperty=this.d.event,this.f=new o.Emitter,this.onProcessExit=this.f.event}refreshProperty(n){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${n}`)}updateProperty(n,r){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${n}, value: ${r}`)}async start(){}shutdown(){this.g.close()}input(n){this.g.handleInput?.(n)}resize(n,r){this.g.setDimensions?.({columns:n,rows:r})}async processBinary(n){}acknowledgeDataEvent(n){}async setUnicodeVersion(n){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(n){this.g.onDidWrite(r=>this.a.fire(r)),this.g.onDidClose?.((r=void 0)=>{this.f.fire(r===void 0?void 0:r)}),this.g.onDidOverrideDimensions?.(r=>{r&&this.d.fire({type:"overrideDimensions",value:{cols:r.columns,rows:r.rows}})}),this.g.onDidChangeName?.(r=>{this.d.fire({type:"title",value:r})}),this.g.open(n||void 0),n&&this.g.setDimensions?.(n),this.b.fire({pid:-1,cwd:""})}}let w=1,i=class extends A.Disposable{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(n=>n.value)}get onDidWriteTerminalData(){return this.I.event}constructor(n,r){super(),this.f=[],this.g=new Map,this.h={},this.j={},this.k={},this.l=new Map,this.u=new Set,this.v=new Map,this.w=new Map,this.y=new Map,this.z=new Map,this.C=new o.Emitter,this.onDidCloseTerminal=this.C.event,this.D=new o.Emitter,this.onDidOpenTerminal=this.D.event,this.F=new o.Emitter,this.onDidChangeActiveTerminal=this.F.event,this.G=new o.Emitter,this.onDidChangeTerminalDimensions=this.G.event,this.H=new o.Emitter,this.onDidChangeTerminalState=this.H.event,this.J=new o.Emitter,this.onDidChangeShell=this.J.event,this.a=r.getProxy(t.MainContext.MainThreadTerminalService),this.s=new E.TerminalDataBufferer(this.a.$sendProcessData),this.I=new o.Emitter({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.a.$registerProcessSupport(n),this.B({dispose:()=>{for(const[m,S]of this.g)S.shutdown(!0)}})}getDefaultShell(n){return(n?this.n:this.m)?.path||""}getDefaultShellArgs(n){return(n?this.n:this.m)?.args||[]}createExtensionTerminal(n,r){const m=new g(this.a,(0,C.generateUuid)(),n,n.name),S=new p(n.pty);return m.createExtensionTerminal(n.location,this.L(n,r).resolvedExtHostIdentifier,u(n.iconPath),l(n.color)).then(k=>{const M=this.M(k,S);this.h[k]=M}),this.f.push(m),m.value}L(n,r){if(r=r||{},n.location&&typeof n.location=="object"&&"parentTerminal"in n.location){const m=n.location.parentTerminal;if(m){const S=this.f.find(k=>k.value===m);S&&(r.resolvedExtHostIdentifier=S._id)}}else n.location&&typeof n.location!="object"?r.location=n.location:r.location&&typeof r.location=="object"&&"splitActiveTerminal"in r.location&&(r.location={splitActiveTerminal:!0});return r}attachPtyToTerminal(n,r){if(!this.O(n))throw new Error(`Cannot resolve terminal with id ${n} for virtual process`);const S=new p(r),k=this.M(n,S);this.h[n]=k}async $acceptActiveTerminalChanged(n){const r=this.b;if(n===null){this.b=void 0,r!==this.b&&this.F.fire(this.b);return}const m=this.O(n);m&&(this.b=m,r!==this.b&&this.F.fire(this.b.value))}async $acceptTerminalProcessData(n,r){const m=this.O(n);m&&this.I.fire({terminal:m.value,data:r})}async $acceptTerminalDimensions(n,r,m){const S=this.O(n);S&&S.setDimensions(r,m)&&this.G.fire({terminal:S.value,dimensions:S.value.dimensions})}async $acceptTerminalMaximumDimensions(n,r,m){this.g.get(n)?.resize(r,m)}async $acceptTerminalTitleChange(n,r){const m=this.O(n);m&&(m.name=r)}async $acceptTerminalClosed(n,r,m){const S=this.Q(this.f,n);if(S!==null){const k=this.f.splice(S,1)[0];k.setExitStatus(r,m),this.C.fire(k.value)}}$acceptTerminalOpened(n,r,m,S){if(r){const q=this.Q(this.f,r);if(q!==null){this.f[q]._id=n,this.D.fire(this.terminals[q]),this.f[q].isOpen=!0;return}}const k={name:S.name,shellPath:S.executable,shellArgs:S.args,cwd:typeof S.cwd=="string"?S.cwd:R.URI.revive(S.cwd),env:S.env,hideFromUser:S.hideFromUser},M=new g(this.a,n,k,m);this.f.push(M),this.D.fire(M.value),M.isOpen=!0}async $acceptTerminalProcessId(n,r){this.O(n)?._setProcessId(r)}async $startExtensionTerminal(n,r){const m=this.O(n);if(!m)return{message:(0,D.localize)(0,null,n)};m.isOpen||await new Promise(k=>{const M=this.onDidOpenTerminal(async q=>{q===m.value&&(M.dispose(),k())})});const S=this.g.get(n);S?S.startSendingEvents(r):this.j[n]={initialDimensions:r}}M(n,r){const m=new A.DisposableStore;m.add(r.onProcessReady(k=>this.a.$sendProcessReady(n,k.pid,k.cwd))),m.add(r.onDidChangeProperty(k=>this.a.$sendProcessProperty(n,k))),this.s.startBuffering(n,r.onProcessData),m.add(r.onProcessExit(k=>this.N(n,k))),this.g.set(n,r);const S=this.j[n];return S&&r instanceof p&&(r.startSendingEvents(S.initialDimensions),delete this.j[n]),m}$acceptProcessAckDataEvent(n,r){this.g.get(n)?.acknowledgeDataEvent(r)}$acceptProcessInput(n,r){this.g.get(n)?.input(r)}$acceptTerminalInteraction(n){const r=this.O(n);r?.setInteractedWith()&&this.H.fire(r.value)}$acceptProcessResize(n,r,m){try{this.g.get(n)?.resize(r,m)}catch(S){if(S.code!=="EPIPE"&&S.code!=="ERR_IPC_CHANNEL_CLOSED")throw S}}$acceptProcessShutdown(n,r){this.g.get(n)?.shutdown(r)}$acceptProcessRequestInitialCwd(n){this.g.get(n)?.getInitialCwd().then(r=>this.a.$sendProcessProperty(n,{type:"initialCwd",value:r}))}$acceptProcessRequestCwd(n){this.g.get(n)?.getCwd().then(r=>this.a.$sendProcessProperty(n,{type:"cwd",value:r}))}$acceptProcessRequestLatency(n){return Promise.resolve(n)}registerLinkProvider(n){return this.u.add(n),this.u.size===1&&this.a.$startLinkProvider(),new y.Disposable(()=>{this.u.delete(n),this.u.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(n,r,m){if(this.v.has(r))throw new Error(`Terminal profile provider "${r}" already registered`);return this.v.set(r,m),this.a.$registerProfileProvider(r,n.identifier.value),new y.Disposable(()=>{this.v.delete(r),this.a.$unregisterProfileProvider(r)})}registerTerminalQuickFixProvider(n,r,m){if(this.w.has(n))throw new Error(`Terminal quick fix provider "${n}" is already registered`);return this.w.set(n,m),this.a.$registerQuickFixProvider(n,r),new y.Disposable(()=>{this.w.delete(n),this.a.$unregisterQuickFixProvider(n)})}async $provideTerminalQuickFixes(n,r){const m=new v.CancellationTokenSource().token;if(m.isCancellationRequested)return;const S=this.w.get(n);if(!S)return;const k=await S.provideTerminalQuickFixes(r,m);if(k!==null)return k}async $createContributedProfileTerminal(n,r){const m=new v.CancellationTokenSource().token;let S=await this.v.get(n)?.provideTerminalProfile(m);if(!m.isCancellationRequested){if(S&&!("options"in S)&&(S={options:S}),!S||!("options"in S))throw new Error(`No terminal profile options provided for id "${n}"`);if("pty"in S.options){this.createExtensionTerminal(S.options,r);return}this.createTerminalFromOptions(S.options,r)}}async $provideLinks(n,r){const m=this.O(n);if(!m)return[];this.y.delete(n),this.z.get(n)?.dispose(!0);const k=new v.CancellationTokenSource;this.z.set(n,k);const M=[],q={terminal:m.value,line:r},V=[];for(const N of this.u)V.push(h.Promises.withAsyncBody(async B=>{k.token.onCancellationRequested(()=>B({provider:N,links:[]}));const j=await N.provideTerminalLinks(q,k.token)||[];k.token.isCancellationRequested||B({provider:N,links:j})}));const F=await Promise.all(V);if(k.token.isCancellationRequested)return[];const U=new Map;for(const N of F)N&&N.links.length>0&&M.push(...N.links.map(B=>{const j={id:w++,startIndex:B.startIndex,length:B.length,label:B.tooltip};return U.set(j.id,{provider:N.provider,link:B}),j}));return this.y.set(n,U),M}$activateLink(n,r){const m=this.y.get(n)?.get(r);!m||m.provider.handleTerminalLink(m.link)}N(n,r){this.s.stopBuffering(n),this.g.delete(n),delete this.j[n];const m=this.h[n];m&&(m.dispose(),delete this.h[n]),this.a.$sendProcessExit(n,r)}O(n){return this.P(this.f,n)}P(n,r){const m=this.Q(n,r);return m!==null?n[m]:null}Q(n,r){let m=null;return n.some((S,k)=>S._id===r?(m=k,!0):!1),m}getEnvironmentVariableCollection(n){let r=this.l.get(n.identifier.value);return r||(r=new s,this.S(n.identifier.value,r)),r}R(n,r){const m=(0,P.serializeEnvironmentVariableCollection)(r.map);this.a.$setEnvironmentVariableCollection(n,r.persistent,m.length===0?void 0:m)}$initEnvironmentVariableCollections(n){n.forEach(r=>{const m=r[0],S=new s(r[1]);this.S(m,S)})}$acceptDefaultProfile(n,r){const m=this.m;this.m=n,this.n=r,m?.path!==n.path&&this.J.fire(n.path)}S(n,r){this.l.set(n,r),r.onDidChangeCollection(()=>{this.R(n,r)})}};i=qe([We(1,I.IExtHostRpcService)],i),e.BaseExtHostTerminalService=i;class s{get persistent(){return this.a}set persistent(n){this.a=n,this.b.fire()}get onDidChangeCollection(){return this.b&&this.b.event}constructor(n){this.map=new Map,this.a=!0,this.b=new o.Emitter,this.map=new Map(n)}get size(){return this.map.size}replace(n,r){this.d(n,{value:r,type:y.EnvironmentVariableMutatorType.Replace})}append(n,r){this.d(n,{value:r,type:y.EnvironmentVariableMutatorType.Append})}prepend(n,r){this.d(n,{value:r,type:y.EnvironmentVariableMutatorType.Prepend})}d(n,r){const m=this.map.get(n);(!m||m.value!==r.value||m.type!==r.type)&&(this.map.set(n,r),this.b.fire())}get(n){return this.map.get(n)}forEach(n,r){this.map.forEach((m,S)=>n.call(r,S,m,this))}[Symbol.iterator](){return this.map.entries()}delete(n){this.map.delete(n),this.b.fire()}clear(){this.map.clear(),this.b.fire()}}let a=class extends i{constructor(n){super(!1,n)}createTerminal(n,r,m){throw new L.NotSupportedError}createTerminalFromOptions(n,r){throw new L.NotSupportedError}};a=qe([We(0,I.IExtHostRpcService)],a),e.WorkerExtHostTerminalService=a;function u(c){if(!(!c||typeof c=="string"))return"id"in c?{id:c.id,color:c.color}:c}function l(c){return f.ThemeColor.isThemeColor(c)?c:void 0}});var Ue=this&&this.__classPrivateFieldGet||function(te,e,o,t){if(o==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?t:o==="a"?t.call(te):t?t.value:e.get(te)},Je=this&&this.__classPrivateFieldSet||function(te,e,o,t,T){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?T.call(te,o):T?T.value=o:e.set(te,o),o};define(ye[267],Ce([1,0,18,16,22,21,3,61,85,6,23,11,30,5,17,137,14,7,56,92,70]),function(te,e,o,t,T,R,I,A,y,D,L,P,v,C,E,f,d,h,b,g,p){"use strict";var w,i;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let s=class{constructor(U,N,B){this.j=B,this.c=new I.Emitter,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=U.getProxy(C.MainContext.MainThreadTesting),this.h=new M(this.f),this.g=new c(this.f),N.registerArgumentProcessor({processArgument:j=>{if(j?.$mid!==15)return j;const z=j,ne=z.tests[z.tests.length-1].item.extId;return this.d.get(b.TestId.root(ne))?.collection.tree.get(ne)?.actual??(0,f.toItemFromContext)(j)}})}createTestController(U,N,B){if(this.d.has(U))throw new Error(`Attempt to insert a duplicate controller with ID "${U}"`);const j=new D.DisposableStore,z=j.add(new f.ExtHostTestItemCollection(U,N,this.j));z.root.label=N;const ne=new Map,_=this.f,Y={items:z.root.children,get label(){return N},set label(Z){N=Z,z.root.label=Z,_.$updateController(U,{label:N})},get refreshHandler(){return B},set refreshHandler(Z){B=Z,_.$updateController(U,{canRefresh:!!Z})},get id(){return U},createRunProfile:(Z,ie,X,K,he)=>{let be=(0,y.hash)(Z);for(;ne.has(be);)be++;return new q(this.f,ne,U,be,Z,ie,X,K,he)},createTestItem(Z,ie,X){return new f.TestItemImpl(U,Z,ie,X)},createTestRun:(Z,ie,X=!0)=>this.g.createTestRun(U,z,Z,ie,X),set resolveHandler(Z){z.resolveHandler=Z},get resolveHandler(){return z.resolveHandler},dispose:()=>{j.dispose()}};_.$registerTestController(U,N,!!B),j.add((0,D.toDisposable)(()=>_.$unregisterTestController(U)));const J={controller:Y,collection:z,profiles:ne};return this.d.set(U,J),j.add((0,D.toDisposable)(()=>this.d.delete(U))),j.add(z.onDidGenerateDiff(Z=>_.$publishDiff(U,Z.map(p.TestsDiffOp.serialize)))),Y}createTestObserver(){return this.h.checkout()}async runTests(U,N=R.CancellationToken.None){const B=n(U);if(!B)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const j=this.d.get(B.controllerId);if(!j)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:U.include?.map(z=>b.TestId.fromExtHostTestItem(z,j.collection.root.id).toString())??[j.collection.root.id],profileGroup:V[B.kind],profileId:B.profileId,controllerId:B.controllerId}],exclude:U.exclude?.map(z=>z.id)},N)}$syncTests(){for(const{collection:U}of this.d.values())U.flushDiff();return Promise.resolve()}$provideFileCoverage(U,N,B){return(0,o.mapFind)(this.g.trackers,z=>z.id===U?z.getCoverage(N):void 0)?.provideFileCoverage(B)??Promise.resolve([])}$resolveFileCoverage(U,N,B,j){return(0,o.mapFind)(this.g.trackers,ne=>ne.id===U?ne.getCoverage(N):void 0)?.resolveFileCoverage(B,j)??Promise.resolve([])}$configureRunProfile(U,N){this.d.get(U)?.profiles.get(N)?.configureHandler?.()}async $refreshTests(U,N){await this.d.get(U)?.controller.refreshHandler?.(N)}$publishTestResults(U){this.results=Object.freeze(U.map(N=>(0,L.deepFreeze)(d.TestResults.to(N))).concat(this.results).sort((N,B)=>B.completedAt-N.completedAt).slice(0,32)),this.c.fire()}async $expandTest(U,N){const B=this.d.get(b.TestId.fromString(U).controllerId)?.collection;B&&(await B.expand(U,N<0?1/0:N),B.flushDiff())}$acceptDiff(U){this.h.applyDiff(U.map(p.TestsDiffOp.deserialize))}async $runControllerTests(U,N){return Promise.all(U.map(B=>this.runControllerTestRequest(B,N)))}async runControllerTestRequest(U,N){const B=this.d.get(U.controllerId);if(!B)return{};const{collection:j,profiles:z}=B,ne=z.get(U.profileId);if(!ne)return{};const _=U.testIds.map(ie=>j.tree.get(ie)).filter(P.isDefined),Y=U.excludeExtIds.map(ie=>B.collection.tree.get(ie)).filter(P.isDefined).filter(ie=>_.some(X=>X.fullId.compare(ie.fullId)===2));if(!_.length)return{};const J=new h.TestRunRequest(_.some(ie=>ie.actual instanceof f.TestItemRootImpl)?void 0:_.map(ie=>ie.actual),Y.map(ie=>ie.actual),ne),Z=this.g.prepareForMainThreadTestRun(J,r.fromInternal(U,B.collection),N);try{return await ne.runHandler(J,N),{}}catch(ie){return{error:String(ie)}}finally{Z.hasRunningTasks&&!N.isCancellationRequested&&await I.Event.toPromise(Z.onEnd),Z.dispose()}}$cancelExtensionTestRun(U){U===void 0?this.g.cancelAllRuns():this.g.cancelRunById(U)}};s=qe([We(0,E.IExtHostRpcService)],s),e.ExtHostTesting=s;const a=1e4;var u;(function(F){F[F.Running=0]="Running",F[F.Cancelling=1]="Cancelling",F[F.Ended=2]="Ended"})(u||(u={}));class l extends D.Disposable{get hasRunningTasks(){return this.f.size>0}get id(){return this.k.id}constructor(U,N,B){super(),this.k=U,this.l=N,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new I.Emitter),this.onEnd=this.j.event,this.h=this.B(new R.CancellationTokenSource(B));const j=this.B(new t.RunOnceScheduler(()=>this.m(),a));this.B(this.h.token.onCancellationRequested(()=>j.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.m()}getCoverage(U){return this.f.get(U)?.coverage}createRun(U){const N=this.k.id,B=this.k.controllerId,j=(0,v.generateUuid)(),z=new m(this.l,N,j),ne=Z=>(ie,...X)=>{if(Y){console.warn(`Setting the state of test "${ie.id}" is a no-op after the run ends.`);return}!this.k.isIncluded(ie)||(this.s(ie),Z(ie,...X))},_=(Z,ie)=>{const X=ie instanceof Array?ie.map(d.TestMessage.from):[d.TestMessage.from(ie)];if(Z.uri&&Z.range){const K={range:d.Range.from(Z.range),uri:Z.uri};for(const he of X)he.location=he.location||K}this.l.$appendTestMessagesInRun(N,j,b.TestId.fromExtHostTestItem(Z,B).toString(),X)};let Y=!1;const J={isPersisted:this.k.isPersisted,token:this.h.token,name:U,get coverageProvider(){return z.coverageProvider},set coverageProvider(Z){z.coverageProvider=Z},enqueued:ne(Z=>{this.l.$updateTestStateInRun(N,j,b.TestId.fromExtHostTestItem(Z,B).toString(),1)}),skipped:ne(Z=>{this.l.$updateTestStateInRun(N,j,b.TestId.fromExtHostTestItem(Z,B).toString(),5)}),started:ne(Z=>{this.l.$updateTestStateInRun(N,j,b.TestId.fromExtHostTestItem(Z,B).toString(),2)}),errored:ne((Z,ie,X)=>{_(Z,ie),this.l.$updateTestStateInRun(N,j,b.TestId.fromExtHostTestItem(Z,B).toString(),6,X)}),failed:ne((Z,ie,X)=>{_(Z,ie),this.l.$updateTestStateInRun(N,j,b.TestId.fromExtHostTestItem(Z,B).toString(),4,X)}),passed:ne((Z,ie)=>{this.l.$updateTestStateInRun(N,j,b.TestId.fromExtHostTestItem(Z,this.k.controllerId).toString(),3,ie)}),appendOutput:(Z,ie,X)=>{Y||(X&&(this.k.isIncluded(X)?this.s(X):X=void 0),this.l.$appendOutputToRun(N,j,T.VSBuffer.fromString(Z),ie&&d.location.from(ie),X&&b.TestId.fromExtHostTestItem(X,B).toString()))},end:()=>{Y||(Y=!0,this.l.$finishedTestRunTask(N,j),this.f.delete(j),this.f.size||this.p())}};return this.f.set(j,{run:J,coverage:z}),this.l.$startedTestRunTask(N,{id:j,name:U,running:!0}),J}m(){for(const{run:U}of this.f.values())U.end()}p(){this.c!==2&&(this.c=2,this.j.fire())}s(U){if(!(U instanceof f.TestItemImpl))throw new g.InvalidTestItemError(U.id);if(this.g.has(b.TestId.fromExtHostTestItem(U,this.k.controllerId).toString()))return;const N=[],B=this.k.colllection.root;for(;;){const j=d.TestItem.from(U);if(N.unshift(j),this.g.has(j.extId)||(this.g.add(j.extId),U===B))break;U=U.parent||B}this.l.$addTestsToRun(this.k.controllerId,this.k.id,N)}}class c{get trackers(){return this.c.values()}constructor(U){this.d=U,this.c=new Map}prepareForMainThreadTestRun(U,N,B){return this.f(U,N,B)}cancelRunById(U){for(const N of this.c.values())if(N.id===U){N.cancel();return}}cancelAllRuns(){for(const U of this.c.values())U.cancel()}createTestRun(U,N,B,j,z){const ne=this.c.get(B);if(ne)return ne.createRun(j);const _=r.fromPublic(U,N,B,z),Y=n(B);this.d.$startedExtensionTestRun({controllerId:U,profile:Y&&{group:V[Y.kind],id:Y.profileId},exclude:B.exclude?.map(Z=>b.TestId.fromExtHostTestItem(Z,N.root.id).toString())??[],id:_.id,include:B.include?.map(Z=>b.TestId.fromExtHostTestItem(Z,N.root.id).toString())??[N.root.id],persist:z});const J=this.f(B,_);return J.onEnd(()=>{this.d.$finishedExtensionTestRun(_.id),J.dispose()}),J.createRun(j)}f(U,N,B){const j=new l(N,this.d,B);return this.c.set(U,j),j.onEnd(()=>this.c.delete(U)),j}}e.TestRunCoordinator=c;const n=F=>{if(!!F.profile){if(!(F.profile instanceof q))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return F.profile}};class r{static fromPublic(U,N,B,j){return new r(U,(0,v.generateUuid)(),B.include?.map(z=>b.TestId.fromExtHostTestItem(z,U).toString())??[U],B.exclude?.map(z=>b.TestId.fromExtHostTestItem(z,U).toString())??[],j,N)}static fromInternal(U,N){return new r(U.controllerId,U.runId,U.testIds,U.excludeExtIds,!0,N)}constructor(U,N,B,j,z,ne){this.controllerId=U,this.id=N,this.isPersisted=z,this.colllection=ne,this.c=B.map(_=>_+"\0"),this.d=j.map(_=>_+"\0")}isIncluded(U){const N=b.TestId.fromExtHostTestItem(U,this.controllerId).toString()+"\0";for(const B of this.d)if(N===B||N.startsWith(B))return!1;for(const B of this.c)if(N===B||N.startsWith(B))return!0;return!1}}e.TestRunDto=r;class m{set coverageProvider(U){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!U||(this.c=U,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(U,N,B){this.f=U,this.g=N,this.h=B}async provideFileCoverage(U){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(U))());try{return(await this.d)?.map(d.TestCoverage.fromFile)??[]}catch(N){throw this.d=void 0,N}}async resolveFileCoverage(U,N){const B=await this.d;let j=B?.[U];return!this.c||!B||!j?[]:(j.detailedCoverage||(j=B[U]=await this.c.resolveFileCoverage?.(j,N)??j),j.detailedCoverage?.map(d.TestCoverage.fromDetailed)??[])}}class S{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(U){this.h=U,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(U){this.c.add(U)}update(U){Object.assign(U.revived,d.TestItem.toPlain(U.item)),this.c.has(U)||this.d.add(U)}remove(U){if(this.c.has(U)){this.c.delete(U);return}this.d.delete(U);const N=b.TestId.parentId(U.item.extId);if(N&&this.g.has(N.toString())){this.g.add(U.item.extId);return}this.f.add(U)}getChangeEvent(){const{c:U,d:N,f:B}=this;return{get added(){return[...U].map(j=>j.revived)},get updated(){return[...N].map(j=>j.revived)},get removed(){return[...B].map(j=>j.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class k extends p.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.q=new I.Emitter,this.onDidChangeTests=this.q.event}get rootTests(){return super.f}getMirroredTestDataById(U){return this.d.get(U)}getMirroredTestDataByReference(U){return this.d.get(U.id)}p(U,N){return{...U,revived:d.TestItem.toPlain(U.item),depth:N?N.depth+1:0,children:new Set}}o(){return new S(this.q)}}e.MirroredTestCollection=k;class M{constructor(U){this.d=U}checkout(){this.c||(this.c=this.f());const U=this.c;return U.observers++,{onDidChangeTest:U.tests.onDidChangeTests,get tests(){return[...U.tests.rootTests].map(N=>N.revived)},dispose:(0,A.once)(()=>{--U.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(U){return this.c?.tests.getMirroredTestDataByReference(U)}applyDiff(U){this.c?.tests.apply(U)}f(){const U=new k;return this.d.$subscribeToDiffs(),{observers:0,tests:U}}}class q{get label(){return this.d}set label(U){U!==this.d&&(this.d=U,Ue(this,w,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:U}))}get isDefault(){return this.f}set isDefault(U){U!==this.f&&(this.f=U,Ue(this,w,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:U}))}get tag(){return this._tag}set tag(U){U?.id!==this._tag?.id&&(this._tag=U,Ue(this,w,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:U?d.TestTag.namespace(this.controllerId,U.id):null}))}get configureHandler(){return this.c}set configureHandler(U){U!==this.c&&(this.c=U,Ue(this,w,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!U}))}constructor(U,N,B,j,z,ne,_,Y=!1,J=void 0){this.controllerId=B,this.profileId=j,this.d=z,this.kind=ne,this.runHandler=_,this.f=Y,this._tag=J,w.set(this,void 0),i.set(this,void 0),Je(this,w,U,"f"),Je(this,i,N,"f"),N.set(j,this);const Z=V[ne];if(typeof Z!="number")throw new Error(`Unknown TestRunProfile.group ${ne}`);Ue(this,w,"f").$publishTestRunProfile({profileId:j,controllerId:B,tag:J?d.TestTag.namespace(this.controllerId,J.id):null,label:z,group:Z,isDefault:Y,hasConfigurationHandler:!1})}dispose(){Ue(this,i,"f")?.delete(this.profileId)&&(Je(this,i,void 0,"f"),Ue(this,w,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=q,w=new WeakMap,i=new WeakMap;const V={[h.TestRunProfileKind.Coverage]:8,[h.TestRunProfileKind.Debug]:4,[h.TestRunProfileKind.Run]:2}}),define(ye[268],Ce([1,0,18,3,5,138,14,7]),function(te,e,o,t,T,R,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class y{constructor(L,P){this.i=P,this.a=new t.Emitter,this.b=new t.Emitter,this.c=new t.Emitter,this.d=new t.Emitter,this.f=new t.Emitter,this.g=new t.Emitter,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=L.getProxy(T.MainContext.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(v=>this.g.fire(v)),this.i.onDidChangeActiveTextEditor(v=>this.f.fire(v))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(L){const P=this.i.allEditors();return L?P:P.map(v=>v.value)}async showTextDocument(L,P,v){let C;typeof P=="number"?C={position:I.ViewColumn.from(P),preserveFocus:v}:typeof P=="object"?C={position:I.ViewColumn.from(P.viewColumn),preserveFocus:P.preserveFocus,selection:typeof P.selection=="object"?I.Range.from(P.selection):void 0,pinned:typeof P.preview=="boolean"?!P.preview:void 0}:C={preserveFocus:!1};const E=await this.h.$tryShowTextDocument(L.uri,C),f=E&&this.i.getEditor(E);if(f)return f.value;throw E?new Error(`Could NOT open editor for "${L.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${L.uri.toString()}".`)}createTextEditorDecorationType(L,P){return new R.TextEditorDecorationType(this.h,L,P).value}$acceptEditorPropertiesChanged(L,P){const v=this.i.getEditor(L);if(!v)throw new Error("unknown text editor");if(P.options&&v._acceptOptions(P.options),P.selections){const C=P.selections.selections.map(I.Selection.to);v._acceptSelections(C)}if(P.visibleRanges){const C=o.coalesce(P.visibleRanges.map(I.Range.to));v._acceptVisibleRanges(C)}if(P.options&&this.b.fire({textEditor:v.value,options:{...P.options,lineNumbers:I.TextEditorLineNumbersStyle.to(P.options.lineNumbers)}}),P.selections){const C=A.TextEditorSelectionChangeKind.fromValue(P.selections.source),E=P.selections.selections.map(I.Selection.to);this.a.fire({textEditor:v.value,selections:E,kind:C})}if(P.visibleRanges){const C=o.coalesce(P.visibleRanges.map(I.Range.to));this.c.fire({textEditor:v.value,visibleRanges:C})}}$acceptEditorPositionData(L){for(const P in L){const v=this.i.getEditor(P);if(!v)throw new Error("Unknown text editor");const C=I.ViewColumn.to(L[P]);v.value.viewColumn!==C&&(v._acceptViewColumn(C),this.d.fire({textEditor:v.value,viewColumn:C}))}}getDiffInformation(L){return Promise.resolve(this.h.$getDiffInformation(L))}}e.ExtHostEditors=y}),define(ye[269],Ce([1,0,2,4,5,6,7,14,26,11]),function(te,e,o,t,T,R,I,A,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,t.createDecorator)("IExtHostTimeline");class L{constructor(C,E){this.b=new Map,this.c=new Map,this.a=C.getProxy(T.MainContext.MainThreadTimeline),E.registerArgumentProcessor({processArgument:(f,d)=>{if(f&&f.$mid===12)if(this.b.get(f.source)&&y.ExtensionIdentifier.equals(d,this.b.get(f.source)?.extension)){const h=f.uri===void 0?void 0:o.URI.revive(f.uri);return this.c.get(f.source)?.get(P(h))?.get(f.handle)}else return;return f}})}async $getTimeline(C,E,f,d){return this.b.get(C)?.provider.provideTimeline(o.URI.revive(E),f,d)}registerTimelineProvider(C,E,f,d){const h=new R.DisposableStore,b=this.d(E.id,d,h).bind(this);let g;E.onDidChange&&(g=E.onDidChange(w=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...w,id:E.id}),this));const p=this.c;return this.f({...E,scheme:C,onDidChange:void 0,async provideTimeline(w,i,s){i?.resetCache&&(h.clear(),p.get(E.id)?.clear());const a=await E.provideTimeline(w,i,s);if(a==null)return;const u=b(w,i);return{...a,source:E.id,items:a.items.map(u)}},dispose(){for(const w of p.values())w.get(E.id)?.clear();g?.dispose(),h.dispose()}},f)}d(C,E,f){return(d,h)=>{let b;if(h?.cacheResults){let g=this.c.get(C);g===void 0&&(g=new Map,this.c.set(C,g));const p=P(d);b=g.get(p),b===void 0&&(b=new Map,g.set(p,b))}return g=>{const{iconPath:p,...w}=g,i=`${C}|${g.id??g.timestamp}`;b?.set(i,g);let s,a,u;g.iconPath&&(p instanceof I.ThemeIcon?u={id:p.id,color:p.color}:o.URI.isUri(p)?(s=p,a=p):{light:s,dark:a}=p);let l;return I.MarkdownString.isMarkdownString(w.tooltip)?l=A.MarkdownString.from(w.tooltip):(0,D.isString)(w.tooltip)?l=w.tooltip:I.MarkdownString.isMarkdownString(w.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),l=A.MarkdownString.from(w.detail)):(0,D.isString)(w.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),l=w.detail),{...w,id:w.id??void 0,handle:i,source:C,command:g.command?E.toInternal(g.command,f):void 0,icon:s,iconDark:a,themeIcon:u,tooltip:l,accessibilityInformation:g.accessibilityInformation}}}}f(C,E){if(this.b.get(C.id))throw new Error(`Timeline Provider ${C.id} already exists.`);return this.a.$registerTimelineProvider({id:C.id,label:C.label,scheme:C.scheme}),this.b.set(C.id,{provider:C,extension:E}),(0,R.toDisposable)(()=>{for(const d of this.c.values())d.get(C.id)?.clear();this.b.delete(C.id),this.a.$unregisterTimelineProvider(C.id),C.dispose()})}}e.ExtHostTimeline=L;function P(v){return v?.toString()}}),define(ye[270],Ce([1,0,6,15,2,5]),function(te,e,o,t,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class I{constructor(y){this.c=new Map,this.b=y.getProxy(R.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,D,L,P){if(this.c.has(D))throw new Error(`Opener with id '${D}' already registered`);const v=P.schemes.find(C=>!I.a.has(C));if(v)throw new Error(`Scheme '${v}' is not supported. Only http and https are currently supported.`);return this.c.set(D,L),this.b.$registerUriOpener(D,P.schemes,y,P.label),(0,o.toDisposable)(()=>{this.c.delete(D),this.b.$unregisterUriOpener(D)})}async $canOpenUri(y,D,L){const P=this.c.get(y);if(!P)throw new Error(`Unknown opener with id: ${y}`);const v=T.URI.revive(D);return P.canOpenExternalUri(v,L)}async $openUri(y,D,L){const P=this.c.get(y);if(!P)throw new Error(`Unknown opener id: '${y}'`);return P.openExternalUri(T.URI.revive(D.resolvedUri),{sourceUri:T.URI.revive(D.sourceUri)},L)}}e.ExtHostUriOpeners=I,I.a=new Set([t.Schemas.http,t.Schemas.https])}),define(ye[271],Ce([1,0,5,2,6,9,26]),function(te,e,o,t,T,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class A{constructor(D){this.c=new Set,this.d=new Map,this.b=D.getProxy(o.MainContext.MainThreadUrls)}registerUriHandler(D,L){if(this.c.has(I.ExtensionIdentifier.toKey(D)))throw new Error(`Protocol handler already registered for extension ${D}`);const P=A.a++;return this.c.add(I.ExtensionIdentifier.toKey(D)),this.d.set(P,L),this.b.$registerUriHandler(P,D),(0,T.toDisposable)(()=>{this.c.delete(I.ExtensionIdentifier.toKey(D)),this.d.delete(P),this.b.$unregisterUriHandler(P)})}$handleExternalUri(D,L){const P=this.d.get(D);if(!P)return Promise.resolve(void 0);try{P.handleUri(t.URI.revive(L))}catch(v){(0,R.onUnexpectedError)(v)}return Promise.resolve(void 0)}async createAppUri(D){return t.URI.revive(await this.b.$createAppUri(D))}}e.ExtHostUrls=A,A.a=0});var Je=this&&this.__classPrivateFieldSet||function(te,e,o,t,T){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?T.call(te,o):T?T.value=o:e.set(te,o),o},Ue=this&&this.__classPrivateFieldGet||function(te,e,o,t){if(o==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?t:o==="a"?t.call(te):t?t.value:e.get(te)};define(ye[74],Ce([1,0,3,15,23,2,194,216,93,5]),function(te,e,o,t,T,R,I,A,y,D){"use strict";var L,P,v,C,E,f,d,h,b,g,p,w,i;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class s{constructor(k,M,q,V,F,U,N){L.set(this,void 0),P.set(this,void 0),v.set(this,void 0),C.set(this,void 0),E.set(this,void 0),f.set(this,void 0),d.set(this,""),h.set(this,void 0),b.set(this,!1),g.set(this,!1),p.set(this,void 0),w.set(this,void 0),this._onMessageEmitter=new o.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,i.set(this,new o.Emitter),this._onDidDispose=Ue(this,i,"f").event,Je(this,L,k,"f"),Je(this,P,M,"f"),Je(this,h,q,"f"),Je(this,C,V,"f"),Je(this,E,F,"f"),Je(this,f,U,"f"),Je(this,p,a(U),"f"),Je(this,w,u(U),"f"),Je(this,v,N,"f")}dispose(){Je(this,b,!0,"f"),Ue(this,i,"f").fire(),Ue(this,i,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(k){return Je(this,g,!0,"f"),(0,y.asWebviewUri)(k,Ue(this,C,"f"))}get cspSource(){const k=Ue(this,f,"f").extensionLocation;if(k.scheme===t.Schemas.https||k.scheme===t.Schemas.http){let M=k.toString();return M.endsWith("/")||(M+="/"),M+" "+y.webviewGenericCspSource}return y.webviewGenericCspSource}get html(){return this.a(),Ue(this,d,"f")}set html(k){this.a(),Ue(this,d,"f")!==k&&(Je(this,d,k,"f"),Ue(this,w,"f")&&!Ue(this,g,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(k)&&(Je(this,g,!0,"f"),Ue(this,v,"f").report("Webview vscode-resource: uris",Ue(this,f,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ue(this,P,"f").$setHtml(Ue(this,L,"f"),this.b(k)))}get options(){return this.a(),Ue(this,h,"f")}set options(k){this.a(),T.equals(Ue(this,h,"f"),k)||Ue(this,P,"f").$setOptions(Ue(this,L,"f"),n(Ue(this,f,"f"),Ue(this,E,"f"),k)),Je(this,h,k,"f")}async postMessage(k){if(Ue(this,b,"f"))return!1;const M=(0,A.serializeWebviewMessage)(k,{serializeBuffersForPostMessage:Ue(this,p,"f")});return Ue(this,P,"f").$postMessage(Ue(this,L,"f"),M.message,...M.buffers)}a(){if(Ue(this,b,"f"))throw new Error("Webview is disposed")}b(k){if(!Ue(this,w,"f"))return k;const M=Ue(this,f,"f").extensionLocation?.scheme===t.Schemas.vscodeRemote,q=Ue(this,f,"f").extensionLocation.scheme===t.Schemas.vscodeRemote?Ue(this,f,"f").extensionLocation.authority:void 0;return k.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(V,F,U,N,B,j)=>{const z=R.URI.from({scheme:N||"file",path:decodeURIComponent(B)}),ne=(0,y.asWebviewUri)(z,{isRemote:M,authority:q}).toString();return`${F}${ne}${j}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(V,F,U,N,B,j)=>{const z=R.URI.from({scheme:N||"file",path:decodeURIComponent(B)}),ne=(0,y.asWebviewUri)(z,{isRemote:M,authority:q}).toString();return`${F}${ne}${j}`})}}e.ExtHostWebview=s,L=new WeakMap,P=new WeakMap,v=new WeakMap,C=new WeakMap,E=new WeakMap,f=new WeakMap,d=new WeakMap,h=new WeakMap,b=new WeakMap,g=new WeakMap,p=new WeakMap,w=new WeakMap,i=new WeakMap;function a(S){try{const k=(0,I.normalizeVersion)((0,I.parseVersion)(S.engines.vscode));return!!k&&k.majorBase>=1&&k.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=a;function u(S){try{const k=(0,I.normalizeVersion)((0,I.parseVersion)(S.engines.vscode));return k?k.majorBase<1||k.majorBase===1&&k.minorBase<60:!1}catch{return!1}}class l{constructor(k,M,q,V,F){this.c=M,this.d=q,this.e=V,this.f=F,this.b=new Map,this.a=k.getProxy(D.MainContext.MainThreadWebviews)}$onMessage(k,M,q){const V=this.g(k);if(V){const{message:F}=(0,A.deserializeWebviewMessage)(M,q.value);V._onMessageEmitter.fire(F)}}$onMissingCsp(k,M){this.e.warn(`${M} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(k,M,q){const V=new s(k,this.a,r(M),this.c,this.d,q,this.f);return this.b.set(k,V),V._onDidDispose(()=>{this.b.delete(k)}),V}deleteWebview(k){this.b.delete(k)}g(k){return this.b.get(k)}}e.ExtHostWebviews=l;function c(S){return{id:S.identifier,location:S.extensionLocation}}e.toExtensionData=c;function n(S,k,M){return{enableCommandUris:M.enableCommandUris,enableScripts:M.enableScripts,enableForms:M.enableForms,portMapping:M.portMapping,localResourceRoots:M.localResourceRoots||m(S,k)}}e.serializeWebviewOptions=n;function r(S){return{enableCommandUris:S.enableCommandUris,enableScripts:S.enableScripts,enableForms:S.enableForms,portMapping:S.portMapping,localResourceRoots:S.localResourceRoots?.map(k=>R.URI.from(k))}}function m(S,k){return[...(k?.getWorkspaceFolders()||[]).map(M=>M.uri),S.extensionLocation]}}),define(ye[272],Ce([1,0,21,85,6,15,24,2,14,74,69,5,7]),function(te,e,o,t,T,R,I,A,y,D,L,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class C{constructor(s,a){this.document=s,this.b=a,this.a=1,this.c=new L.Cache("custom documents")}addEdit(s){return this.c.add([s])}async undo(s,a){await this.f(s).undo(),a||this.disposeBackup()}async redo(s,a){await this.f(s).redo(),a||this.disposeBackup()}disposeEdits(s){for(const a of s)this.c.delete(a)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const s=w(this.document.uri)+this.a++;return(0,I.joinPath)(this.b,s)}updateBackup(s){this.d?.delete(),this.d=s}disposeBackup(){this.d?.delete(),this.d=void 0}f(s){const a=this.c.get(s,0);if(!a)throw new Error("No edit found");return a}}class E{constructor(){this.a=new Map}get(s,a){return this.a.get(this.b(s,a))}add(s,a,u){const l=this.b(s,a.uri);if(this.a.has(l))throw new Error(`Document already exists for viewType:${s} resource:${a.uri}`);const c=new C(a,u);return this.a.set(l,c),c}delete(s,a){const u=this.b(s,a.uri);this.a.delete(u)}b(s,a){return`${s}@@@${a}`}}var f;(function(i){i[i.Text=0]="Text",i[i.Custom=1]="Custom"})(f||(f={}));class d{constructor(){this.a=new Map}addTextProvider(s,a,u){return this.b(0,s,a,u)}addCustomProvider(s,a,u){return this.b(1,s,a,u)}get(s){return this.a.get(s)}b(s,a,u,l){if(this.a.has(a))throw new Error(`Provider for viewType:${a} already registered`);return this.a.set(a,{type:s,extension:u,provider:l}),new v.Disposable(()=>this.a.delete(a))}}class h{constructor(s,a,u,l,c){this.d=a,this.f=u,this.g=l,this.h=c,this.b=new d,this.c=new E,this.a=s.getProxy(P.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(s,a,u,l){const c=new T.DisposableStore;return g(u)?(c.add(this.b.addTextProvider(a,s,u)),this.a.$registerTextEditorProvider((0,D.toExtensionData)(s),a,l.webviewOptions||{},{supportsMove:!!u.moveCustomTextEditor},(0,D.shouldSerializeBuffersForPostMessage)(s))):(c.add(this.b.addCustomProvider(a,s,u)),b(u)&&c.add(u.onDidChangeCustomDocument(n=>{const r=this.i(a,n.document.uri);if(p(n)){const m=r.addEdit(n);this.a.$onDidEdit(n.document.uri,a,m,n.label)}else this.a.$onContentChange(n.document.uri,a)})),this.a.$registerCustomEditorProvider((0,D.toExtensionData)(s),a,l.webviewOptions||{},!!l.supportsMultipleEditorsPerDocument,(0,D.shouldSerializeBuffersForPostMessage)(s))),v.Disposable.from(c,new v.Disposable(()=>{this.a.$unregisterEditorProvider(a)}))}async $createCustomDocument(s,a,u,l,c){const n=this.b.get(a);if(!n)throw new Error(`No provider found for '${a}'`);if(n.type!==1)throw new Error(`Invalid provide type for '${a}'`);const r=A.URI.revive(s),m=await n.provider.openCustomDocument(r,{backupId:u,untitledDocumentData:l?.buffer},c);let S;return b(n.provider)&&this.f&&(S=this.f.workspaceValue(n.extension)??this.f.globalValue(n.extension)),this.c.add(a,m,S),{editable:b(n.provider)}}async $disposeCustomDocument(s,a){const u=this.b.get(a);if(!u)throw new Error(`No provider found for '${a}'`);if(u.type!==1)throw new Error(`Invalid provider type for '${a}'`);const l=A.URI.revive(s),{document:c}=this.i(a,l);this.c.delete(a,c),c.dispose()}async $resolveCustomEditor(s,a,u,l,c,n){console.log("xxxx");const r=this.b.get(u);if(!r)throw new Error(`No provider found for '${u}'`);const m=y.ViewColumn.to(c),S=this.g.createNewWebview(a,l.contentOptions,r.extension),k=this.h.createNewWebviewPanel(a,u,l.title,m,l.options,S,!0),M=A.URI.revive(s);switch(r.type){case 1:{const{document:q}=this.i(u,M);return r.provider.resolveCustomEditor(q,k,n)}case 0:{const q=this.d.getDocument(M);return r.provider.resolveCustomTextEditor(q,k,n)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(s,a,u){this.i(a,s).disposeEdits(u)}async $onMoveCustomEditor(s,a,u){const l=this.b.get(u);if(!l)throw new Error(`No provider found for '${u}'`);if(!l.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${u}'`);const c=this.h.getWebviewPanel(s);if(!c)throw new Error("No webview found");const n=A.URI.revive(a),r=this.d.getDocument(n);await l.provider.moveCustomTextEditor(r,c,o.CancellationToken.None)}async $undo(s,a,u,l){return this.i(a,s).undo(u,l)}async $redo(s,a,u,l){return this.i(a,s).redo(u,l)}async $revert(s,a,u){const l=this.i(a,s);await this.j(a).revertCustomDocument(l.document,u),l.disposeBackup()}async $onSave(s,a,u){const l=this.i(a,s);await this.j(a).saveCustomDocument(l.document,u),l.disposeBackup()}async $onSaveAs(s,a,u,l){const c=this.i(a,s);return this.j(a).saveCustomDocumentAs(c.document,A.URI.revive(u),l)}async $backup(s,a,u){const l=this.i(a,s),n=await this.j(a).backupCustomDocument(l.document,{destination:l.getNewBackupUri()},u);return l.updateBackup(n),n.id}i(s,a){const u=this.c.get(s,A.URI.revive(a));if(!u)throw new Error("No custom document found");return u}j(s){const u=this.b.get(s)?.provider;if(!u||!b(u))throw new Error("Custom document is not editable");return u}}e.ExtHostCustomEditors=h;function b(i){return!!i.onDidChangeCustomDocument}function g(i){return typeof i.resolveCustomTextEditor=="function"}function p(i){return typeof i.undo=="function"&&typeof i.redo=="function"}function w(i){const s=i.scheme===R.Schemas.file||i.scheme===R.Schemas.untitled?i.fsPath:i.toString();return(0,t.hash)(s)+""}});var Je=this&&this.__classPrivateFieldSet||function(te,e,o,t,T){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?T.call(te,o):T?T.value=o:e.set(te,o),o},Ue=this&&this.__classPrivateFieldGet||function(te,e,o,t){if(o==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?t:o==="a"?t.call(te):t?t.value:e.get(te)};define(ye[273],Ce([1,0,3,6,2,30,14,74,5,7]),function(te,e,o,t,T,R,I,A,y,D){"use strict";var L,P,v,C,E,f,d,h,b,g,p,w,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class s extends t.Disposable{constructor(c,n,r,m){super(),L.set(this,void 0),P.set(this,void 0),v.set(this,void 0),C.set(this,void 0),E.set(this,void 0),f.set(this,void 0),d.set(this,void 0),h.set(this,void 0),b.set(this,!0),g.set(this,void 0),p.set(this,!1),w.set(this,this.B(new o.Emitter)),this.onDidDispose=Ue(this,w,"f").event,i.set(this,this.B(new o.Emitter)),this.onDidChangeViewState=Ue(this,i,"f").event,Je(this,L,c,"f"),Je(this,P,n,"f"),Je(this,C,r,"f"),Je(this,v,m.viewType,"f"),Je(this,E,m.panelOptions,"f"),Je(this,h,m.viewColumn,"f"),Je(this,f,m.title,"f"),Je(this,g,m.active,"f")}dispose(){Ue(this,p,"f")||(Je(this,p,!0,"f"),Ue(this,w,"f").fire(),Ue(this,P,"f").$disposeWebview(Ue(this,L,"f")),Ue(this,C,"f").dispose(),super.dispose())}get webview(){return this.c(),Ue(this,C,"f")}get viewType(){return this.c(),Ue(this,v,"f")}get title(){return this.c(),Ue(this,f,"f")}set title(c){this.c(),Ue(this,f,"f")!==c&&(Je(this,f,c,"f"),Ue(this,P,"f").$setTitle(Ue(this,L,"f"),c))}get iconPath(){return this.c(),Ue(this,d,"f")}set iconPath(c){this.c(),Ue(this,d,"f")!==c&&(Je(this,d,c,"f"),Ue(this,P,"f").$setIconPath(Ue(this,L,"f"),T.URI.isUri(c)?{light:c,dark:c}:c))}get options(){return Ue(this,E,"f")}get viewColumn(){if(this.c(),!(typeof Ue(this,h,"f")=="number"&&Ue(this,h,"f")<0))return Ue(this,h,"f")}get active(){return this.c(),Ue(this,g,"f")}get visible(){return this.c(),Ue(this,b,"f")}_updateViewState(c){Ue(this,p,"f")||(this.active!==c.active||this.visible!==c.visible||this.viewColumn!==c.viewColumn)&&(Je(this,g,c.active,"f"),Je(this,b,c.visible,"f"),Je(this,h,c.viewColumn,"f"),Ue(this,i,"f").fire({webviewPanel:this}))}reveal(c,n){this.c(),Ue(this,P,"f").$reveal(Ue(this,L,"f"),{viewColumn:typeof c>"u"?void 0:I.ViewColumn.from(c),preserveFocus:!!n})}c(){if(Ue(this,p,"f"))throw new Error("Webview is disposed")}}L=new WeakMap,P=new WeakMap,v=new WeakMap,C=new WeakMap,E=new WeakMap,f=new WeakMap,d=new WeakMap,h=new WeakMap,b=new WeakMap,g=new WeakMap,p=new WeakMap,w=new WeakMap,i=new WeakMap;class a{static c(){return(0,R.generateUuid)()}constructor(c,n,r){this.g=n,this.h=r,this.e=new Map,this.f=new Map,this.d=c.getProxy(y.MainContext.MainThreadWebviewPanels)}createWebviewPanel(c,n,r,m,S={}){const k=typeof m=="object"?m.viewColumn:m,M={viewColumn:I.ViewColumn.from(k),preserveFocus:typeof m=="object"&&!!m.preserveFocus},q=(0,A.shouldSerializeBuffersForPostMessage)(c),V=a.c();this.d.$createWebviewPanel((0,A.toExtensionData)(c),V,n,{title:r,panelOptions:u(S),webviewOptions:(0,A.serializeWebviewOptions)(c,this.h,S),serializeBuffersForPostMessage:q},M);const F=this.g.createNewWebview(V,S,c);return this.createNewWebviewPanel(V,n,r,k,S,F,!0)}$onDidChangeWebviewPanelViewStates(c){const n=Object.keys(c);n.sort((r,m)=>{const S=c[r],k=c[m];return S.active?1:k.active?-1:+S.visible-+k.visible});for(const r of n){const m=this.getWebviewPanel(r);if(!m)continue;const S=c[r];m._updateViewState({active:S.active,visible:S.visible,viewColumn:I.ViewColumn.to(S.position)})}}async $onDidDisposeWebviewPanel(c){this.getWebviewPanel(c)?.dispose(),this.e.delete(c),this.g.deleteWebview(c)}registerWebviewPanelSerializer(c,n,r){if(this.f.has(n))throw new Error(`Serializer for '${n}' already registered`);return this.f.set(n,{serializer:r,extension:c}),this.d.$registerSerializer(n,{serializeBuffersForPostMessage:(0,A.shouldSerializeBuffersForPostMessage)(c)}),new D.Disposable(()=>{this.f.delete(n),this.d.$unregisterSerializer(n)})}async $deserializeWebviewPanel(c,n,r,m){const S=this.f.get(n);if(!S)throw new Error(`No serializer found for '${n}'`);const{serializer:k,extension:M}=S,q=this.g.createNewWebview(c,r.webviewOptions,M),V=this.createNewWebviewPanel(c,n,r.title,m,r.panelOptions,q,r.active);await k.deserializeWebviewPanel(V,r.state)}createNewWebviewPanel(c,n,r,m,S,k,M){const q=new s(c,this.d,k,{viewType:n,title:r,viewColumn:m,panelOptions:S,active:M});return this.e.set(c,q),q}getWebviewPanel(c){return this.e.get(c)}}e.ExtHostWebviewPanels=a;function u(l){return{enableFindWidget:l.enableFindWidget,retainContextWhenHidden:l.retainContextWhenHidden}}});var Je=this&&this.__classPrivateFieldSet||function(te,e,o,t,T){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?T.call(te,o):T?T.value=o:e.set(te,o),o},Ue=this&&this.__classPrivateFieldGet||function(te,e,o,t){if(o==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?t:o==="a"?t.call(te):t?t.value:e.get(te)};define(ye[274],Ce([1,0,3,6,74,14,5,7]),function(te,e,o,t,T,R,I,A){"use strict";var y,D,L,P,v,C,E,f,d,h,b;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class g extends t.Disposable{constructor(i,s,a,u,l,c){super(),y.set(this,void 0),D.set(this,void 0),L.set(this,void 0),P.set(this,void 0),v.set(this,!1),C.set(this,void 0),E.set(this,void 0),f.set(this,void 0),d.set(this,void 0),h.set(this,this.B(new o.Emitter)),this.onDidChangeVisibility=Ue(this,h,"f").event,b.set(this,this.B(new o.Emitter)),this.onDidDispose=Ue(this,b,"f").event,Je(this,L,a,"f"),Je(this,E,u,"f"),Je(this,y,i,"f"),Je(this,D,s,"f"),Je(this,P,l,"f"),Je(this,C,c,"f")}dispose(){Ue(this,v,"f")||(Je(this,v,!0,"f"),Ue(this,b,"f").fire(),Ue(this,P,"f").dispose(),super.dispose())}get title(){return this.a(),Ue(this,E,"f")}set title(i){this.a(),Ue(this,E,"f")!==i&&(Je(this,E,i,"f"),Ue(this,D,"f").$setWebviewViewTitle(Ue(this,y,"f"),i))}get description(){return this.a(),Ue(this,f,"f")}set description(i){this.a(),Ue(this,f,"f")!==i&&(Je(this,f,i,"f"),Ue(this,D,"f").$setWebviewViewDescription(Ue(this,y,"f"),i))}get visible(){return Ue(this,C,"f")}get webview(){return Ue(this,P,"f")}get viewType(){return Ue(this,L,"f")}_setVisible(i){i===Ue(this,C,"f")||Ue(this,v,"f")||(Je(this,C,i,"f"),Ue(this,h,"f").fire())}get badge(){return this.a(),Ue(this,d,"f")}set badge(i){this.a(),!(i?.value===Ue(this,d,"f")?.value&&i?.tooltip===Ue(this,d,"f")?.tooltip)&&(Je(this,d,R.ViewBadge.from(i),"f"),Ue(this,D,"f").$setWebviewViewBadge(Ue(this,y,"f"),i))}show(i){this.a(),Ue(this,D,"f").$show(Ue(this,y,"f"),!!i)}a(){if(Ue(this,v,"f"))throw new Error("Webview is disposed")}}y=new WeakMap,D=new WeakMap,L=new WeakMap,P=new WeakMap,v=new WeakMap,C=new WeakMap,E=new WeakMap,f=new WeakMap,d=new WeakMap,h=new WeakMap,b=new WeakMap;class p{constructor(i,s){this.d=s,this.b=new Map,this.c=new Map,this.a=i.getProxy(I.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(i,s,a,u){if(this.b.has(s))throw new Error(`View provider for '${s}' already registered`);return this.b.set(s,{provider:a,extension:i}),this.a.$registerWebviewViewProvider((0,T.toExtensionData)(i),s,{retainContextWhenHidden:u?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,T.shouldSerializeBuffersForPostMessage)(i)}),new A.Disposable(()=>{this.b.delete(s),this.a.$unregisterWebviewViewProvider(s)})}async $resolveWebviewView(i,s,a,u,l){const c=this.b.get(s);if(!c)throw new Error(`No view provider found for '${s}'`);const{provider:n,extension:r}=c,m=this.d.createNewWebview(i,{},r),S=new g(i,this.a,s,a,m,!0);this.c.set(i,S),await n.resolveWebviewView(S,{state:u},l)}async $onDidChangeWebviewViewVisibility(i,s){this.e(i)._setVisible(s)}async $disposeWebviewView(i){const s=this.e(i);this.c.delete(i),s.dispose(),this.d.deleteWebview(i)}e(i){const s=this.c.get(i);if(!s)throw new Error("No webview found");return s}}e.ExtHostWebviewViews=p}),define(ye[141],Ce([1,0,3,5,2,15,8,4,17]),function(te,e,o,t,T,R,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let D=class ri{get state(){return this.d}constructor(P){this.c=new o.Emitter,this.onDidChangeWindowState=this.c.event,this.d=ri.a,this.b=P.getProxy(t.MainContext.MainThreadWindow),this.b.$getWindowVisibility().then(v=>this.$onDidChangeWindowFocus(v))}$onDidChangeWindowFocus(P){P!==this.d.focused&&(this.d={...this.d,focused:P},this.c.fire(this.d))}openUri(P,v){let C;if(typeof P=="string"){C=P;try{P=T.URI.parse(P)}catch{return Promise.reject(`Invalid uri - '${P}'`)}}return(0,I.isFalsyOrWhitespace)(P.scheme)?Promise.reject("Invalid scheme - cannot be empty"):P.scheme===R.Schemas.command?Promise.reject(`Invalid scheme '${P.scheme}'`):this.b.$openUri(P,C,v)}async asExternalUri(P,v){if((0,I.isFalsyOrWhitespace)(P.scheme))return Promise.reject("Invalid scheme - cannot be empty");const C=await this.b.$asExternalUri(P,v);return T.URI.from(C)}};D.a={focused:!0},D=qe([We(0,y.IExtHostRpcService)],D),e.ExtHostWindow=D,e.IExtHostWindow=(0,A.createDecorator)("IExtHostWindow")}),define(ye[275],Ce([1,0,118,276,65,40,2,13,47]),function(te,e,o,t,T,R,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class D{constructor(v,C,E){this.b=v,this.c=C,this.f=E,this.a=t.createServer((f,d)=>this.h(f,d)),this.g().catch(f=>(C.error(f),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",v=>this.c.error(v))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(v,C){const E=(d,h)=>{C.writeHead(d,{"content-type":"application/json"}),C.end(JSON.stringify(h||null),b=>b&&this.c.error(b))},f=[];v.setEncoding("utf8"),v.on("data",d=>f.push(d)),v.on("end",async()=>{try{const d=JSON.parse(f.join(""));let h;switch(d.type){case"open":h=await this.i(d);break;case"openExternal":h=await this.j(d);break;case"status":h=await this.l(d);break;case"extensionManagement":h=await this.k(d);break;default:E(404,`Unknown message type: ${d.type}`);break}E(200,h)}catch(d){const h=d instanceof Error?d.message:JSON.stringify(d);E(500,h),this.c.error("Error while processing pipe request",d)}})}async i(v){const{fileURIs:C,folderURIs:E,forceNewWindow:f,diffMode:d,mergeMode:h,addMode:b,forceReuseWindow:g,gotoLineMode:p,waitMarkerFilePath:w,remoteAuthority:i}=v,s=[];if(Array.isArray(E))for(const c of E)try{s.push({folderUri:I.URI.parse(c)})}catch{}if(Array.isArray(C))for(const c of C)try{(0,y.hasWorkspaceFileExtension)(c)?s.push({workspaceUri:I.URI.parse(c)}):s.push({fileUri:I.URI.parse(c)})}catch{}const a=w?I.URI.file(w):void 0,l={forceNewWindow:f,diffMode:d,mergeMode:h,addMode:b,gotoLineMode:p,forceReuseWindow:g,preferNewWindow:!g&&!a&&!b,waitMarkerFileURI:a,remoteAuthority:i};return this.b.executeCommand("_remoteCLI.windowOpen",s,l),""}async j(v){for(const C of v.uris){const E=I.URI.parse(C),f=E.scheme==="file"?E:C;await this.b.executeCommand("_remoteCLI.openExternal",f)}}async k(v){const C=f=>f?.map(d=>/\.vsix$/i.test(d)?I.URI.parse(d):d),E={list:v.list,install:C(v.install),uninstall:C(v.uninstall),force:v.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",E)}async l(v){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&T.existsSync(this.f)&&T.unlinkSync(this.f)}}e.CLIServerBase=D;let L=class extends D{constructor(v,C){super(v,C,(0,o.createRandomIPCHandle)())}};L=qe([We(0,R.IExtHostCommands),We(1,A.ILogService)],L),e.CLIServer=L}),define(ye[277],Ce([1,0,248,25,17]),function(te,e,o,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;const R=1024*1024;let I=class extends o.AbstractExtHostConsoleForwarder{constructor(y,D){super(y,D),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(y,D,L){const P=y==="error"||y==="warn"?process.stderr:process.stdout;this.g=!0,P.write(`
START_NATIVE_LOG
`),D.apply(console,L),P.write(`
END_NATIVE_LOG
`),this.g=!1}j(y,D){const L=process[y],P=L.write;let v="";Object.defineProperty(L,"write",{set:()=>{},get:()=>(C,E,f)=>{if(!this.g){v+=C.toString(E);const d=v.length>R?v.length:v.lastIndexOf(`
`);d!==-1&&(console[D](v.slice(0,d)),v=v.slice(d+1))}P.call(L,C,E,f)}})}};I=qe([We(0,T.IExtHostRpcService),We(1,t.IExtHostInitDataService)],I),e.ExtHostConsoleForwarder=I}),define(ye[278],Ce([1,0,10,87,30,40,6,5,2,17]),function(te,e,o,t,T,R,I,A,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let L=class extends I.Disposable{constructor(v,C){super();const E=v.getProxy(A.MainContext.MainThreadDownloadService);C.registerCommand(!1,"_workbench.downloadResource",async f=>{const d=y.URI.file((0,o.join)((0,t.tmpdir)(),(0,T.generateUuid)()));return await E.$download(f,d),d})}};L=qe([We(0,D.IExtHostRpcService),We(1,R.IExtHostCommands)],L),e.ExtHostDownloadService=L}),define(ye[279],Ce([1,0,140,15,200,30]),function(te,e,o,t,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class I extends o.ExtHostLoggerService{f(y,D,L){return y.scheme===t.Schemas.file?new T.SpdLogLogger(L?.name||(0,R.generateUuid)(),y.fsPath,!L?.donotRotate,!!L?.donotUseFormatters,D):super.f(y,D,L)}}e.ExtHostLoggerService=I}),define(ye[280],Ce([1,0,65,10,2,73,6,15,16,29]),function(te,e,o,t,T,R,I,A,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class L extends R.ExtensionStoragePaths{constructor(){super(...arguments),this.i=null}async g(i){const s=await super.g(i);if(s.scheme!==A.Schemas.file)return s;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${s.fsPath}.`),s;const a=s.fsPath;let u=0;do{let l;u===0?l=a:l=/[/\\]$/.test(a)?`${a.substr(0,a.length-1)}-${u}`:`${a}-${u}`,await P(l);const c=t.join(l,"vscode.lock"),n=await f(this.d,c,!1);if(n)return this.i=n,process.on("exit",()=>{n.dispose()}),T.URI.file(l);u++}while(u<10);return s}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.ExtensionStoragePaths=L;async function P(w){try{await D.Promises.stat(w);return}catch{}try{await D.Promises.mkdir(w,{recursive:!0})}catch{}}const v=1e3,C=10*60*1e3;class E extends I.Disposable{constructor(i,s){super(),this.b=i,this.c=s,this.a=this.B(new y.IntervalTimer),this.a.cancelAndSet(async()=>{const a=await d(i,s);(!a||a.pid!==process.pid)&&(i.info(`Lock '${s}': The lock was lost unexpectedly.`),this.a.cancel());try{await D.Promises.utimes(s,new Date,new Date)}catch(u){i.error(u),i.info(`Lock '${s}': Could not update mtime.`)}},v)}dispose(){super.dispose();try{o.unlinkSync(this.c)}catch{}}async setWillRelease(i){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${i} ms.`);try{const s={pid:process.pid,willReleaseAt:Date.now()+i};await D.Promises.writeFile(this.c,JSON.stringify(s),{flag:"w"})}catch(s){this.b.error(s)}}}async function f(w,i,s){try{const u={pid:process.pid,willReleaseAt:0};await D.Promises.writeFile(i,JSON.stringify(u),{flag:"wx"})}catch(u){w.error(u)}const a=await d(w,i);return!a||a.pid!==process.pid?s?(w.info(`Lock '${i}': Could not acquire lock, giving up.`),null):(w.info(`Lock '${i}': Could not acquire lock, checking if the file is stale.`),g(w,i)):(w.info(`Lock '${i}': Lock acquired.`),new E(w,i))}async function d(w,i){let s;try{s=await D.Promises.readFile(i)}catch(a){return w.error(a),null}try{return JSON.parse(String(s))}catch(a){return w.error(a),null}}async function h(w,i){let s;try{s=await D.Promises.stat(i)}catch(a){return w.error(a),0}return s.mtime.getTime()}function b(w){try{return process.kill(w,0),!0}catch{return!1}}async function g(w,i){const s=await d(w,i);if(!s)return w.info(`Lock '${i}': Could not read pid of lock holder.`),p(w,i);if(s.willReleaseAt){let n=s.willReleaseAt-Date.now();if(n<5e3){for(n>0?w.info(`Lock '${i}': The lockfile is scheduled to be released in ${n} ms.`):w.info(`Lock '${i}': The lockfile is scheduled to have been released.`);n>0;){if(await(0,y.timeout)(Math.min(100,n)),await h(w,i)===0)return p(w,i);n=s.willReleaseAt-Date.now()}return p(w,i)}}if(!b(s.pid))return w.info(`Lock '${i}': The pid ${s.pid} appears to be gone.`),p(w,i);const a=await h(w,i),u=Date.now()-a;if(u<=C)return w.info(`Lock '${i}': The lock does not look stale, elapsed: ${u} ms, giving up.`),null;w.info(`Lock '${i}': The lock looks stale, waiting for 2s.`),await(0,y.timeout)(2e3);const l=await h(w,i),c=Date.now()-l;return c<=C?(w.info(`Lock '${i}': The lock does not look stale, elapsed: ${c} ms, giving up.`),null):(w.info(`Lock '${i}': The lock looks stale even after waiting for 2s.`),p(w,i))}async function p(w,i){w.info(`Lock '${i}': Deleting a stale lock.`);try{await D.Promises.unlink(i)}catch{}return f(w,i,!0)}}),define(ye[281],Ce([1,0,30,17,41]),function(te,e,o,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let R=class extends T.BaseExtHostTerminalService{constructor(A){super(!0,A)}createTerminal(A,y,D){return this.createTerminalFromOptions({name:A,shellPath:y,shellArgs:D})}createTerminalFromOptions(A,y){const D=new T.ExtHostTerminal(this.a,(0,o.generateUuid)(),A,A.name);return this.f.push(D),D.create(A,this.L(A,y)),D.value}};R=qe([We(0,t.IExtHostRpcService)],R),e.ExtHostTerminalService=R}),define(ye[282],Ce([1,0,5,17,183,6,25,2,46,24,29,7,12,54,3,129,101,13]),function(te,e,o,t,T,R,I,A,y,D,L,P,v,C,E,f,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.loadListeningPorts=e.getSockets=void 0;class b extends f.DisposableTunnel{}function g(n){const r=n.trim().split(`
`),m=[];return r.forEach(k=>{const M=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(k);M&&M.length>=3&&m.push({pid:parseInt(M[1],10),socket:parseInt(M[2],10)})}),m.reduce((k,M)=>(k[M.socket]=M,k),{})}e.getSockets=g;function p(...n){const r=[].concat(...n.map(i));return[...new Map(r.filter(m=>m.st==="0A").map(m=>{const S=m.local_address.split(":");return{socket:parseInt(m.inode,10),ip:w(S[0]),port:parseInt(S[1],16)}}).map(m=>[m.ip+":"+m.port,m])).values()]}e.loadListeningPorts=p;function w(n){let r="";if(n.length===8)for(let m=n.length-2;m>=0;m-=2)r+=parseInt(n.substr(m,2),16),m!==0&&(r+=".");else for(let m=n.length-4;m>=0;m-=4)r+=parseInt(n.substr(m,4),16).toString(16),m!==0&&(r+=":");return r}function i(n){const r=n.trim().split(`
`),m=r.shift().trim().split(/\s+/).filter(k=>k!=="rx_queue"&&k!=="tm->when");return r.map(k=>k.trim().split(/\s+/).reduce((M,q,V)=>(M[m[V]||V]=q,M),{}))}e.loadConnectionTable=i;function s(n){return!!n.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||n.indexOf("out/server-main.js")!==-1||n.indexOf("_productName=VSCode")!==-1}function a(n){const r=n.trim().split(`
`),m=[];return r.forEach(S=>{const k=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(S);k&&k.length>=4&&m.push({pid:parseInt(k[1],10),ppid:parseInt(k[2]),cmd:k[3]})}),m}e.getRootProcesses=a;async function u(n,r,m){const S=m.reduce((M,q)=>(M[q.pid]=q,M),{}),k=[];return n.forEach(({socket:M,ip:q,port:V})=>{const F=r[M]?r[M].pid:void 0,U=F?S[F]?.cmd:void 0;F&&U&&!s(U)&&k.push({host:q,port:V,detail:U,pid:F})}),k}e.findPorts=u;function l(n,r,m){const S=new Map,k=a(r);for(const M of n){const q=m.get(M.port);if(q){S.set(M.port,q);continue}const V=k.find(F=>F.cmd.includes(`${M.port}`));if(V){let F=V,U;do U=k.find(N=>N.ppid===F.pid),U&&(F=U);while(U);S.set(M.port,{host:M.ip,port:M.port,pid:F.pid,detail:F.cmd,ppid:F.ppid})}else S.set(M.port,{host:M.ip,port:M.port,ppid:Number.MAX_VALUE})}return S}e.tryFindRootPorts=l;let c=class extends R.Disposable{constructor(r,m,S){super(),this.n=S,this.c=()=>Promise.resolve(!0),this.f=new Map,this.g=new E.Emitter,this.onDidChangeTunnels=this.g.event,this.h=!1,this.j=new Map,this.k=0,this.l=new Map,this.a=r.getProxy(o.MainContext.MainThreadTunnelService),v.isLinux&&m.remote.isRemote&&m.remote.authority&&this.a.$setRemoteTunnelService(process.pid)}async openTunnel(r,m){this.n.trace(`ForwardedPorts: (ExtHostTunnelService) ${r.identifier.value} called openTunnel API for ${m.remoteAddress.host}:${m.remoteAddress.port}.`);const S=await this.a.$openTunnel(m,r.displayName);if(S){const k=new b(S.remoteAddress,S.localAddress,()=>this.a.$closeTunnel(S.remoteAddress));return this.B(k),k}}async getTunnels(){return this.a.$getTunnels()}p(r){return Math.max(r*20,2e3)}r(){return this.k++}registerPortsAttributesProvider(r,m){const S=this.r();return this.l.set(S,{selector:r,provider:m}),this.a.$registerPortsAttributesProvider(r,S),new P.Disposable(()=>{this.l.delete(S),this.a.$unregisterPortsAttributesProvider(S)})}async $providePortAttributes(r,m,S,k,M){const q=[];for(const F of r){const U=this.l.get(F);if(!U)return[];q.push(...await Promise.all(m.map(async N=>U.provider.providePortAttributes(N,S,k,M))))}const V=q.filter(F=>!!F);return V.length>0?V.map(F=>({autoForwardAction:F.autoForwardAction,port:F.port})):[]}async $registerCandidateFinder(r){if(r&&this.h)return;this.h=r;const m=new d.MovingAverage;let S;for(;this.h;){const k=new Date().getTime(),M=(await this.findCandidatePorts()).filter(V=>(0,f.isLocalhost)(V.host)||(0,f.isAllInterfaces)(V.host));this.n.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${M.map(V=>V.port).join(", ")}`);const q=new Date().getTime()-k;m.update(q),(!S||JSON.stringify(S)!==JSON.stringify(M))&&(S=M,await this.a.$onFoundNewCandidates(S)),await new Promise(V=>setTimeout(()=>V(),this.p(m.value)))}}async setTunnelFactory(r){if(r){if(r.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(r.candidatePortSource),r.showCandidatePort&&(this.c=r.showCandidatePort,this.a.$setCandidateFilter()),r.tunnelFactory){this.b=r.tunnelFactory;let m=r.tunnelFeatures?.privacyOptions??[];r.tunnelFeatures?.public&&m.length===0&&(m=[{id:"private",label:T.localize(0,null),themeIcon:"lock"},{id:"public",label:T.localize(1,null),themeIcon:"eye"}]);const S=r.tunnelFeatures?{elevation:!!r.tunnelFeatures?.elevation,public:!!r.tunnelFeatures?.public,privacyOptions:m}:void 0;this.a.$setTunnelProvider(S)}}else this.b=void 0;return(0,R.toDisposable)(()=>{this.b=void 0})}async $closeTunnel(r,m){if(this.f.has(r.host)){const S=this.f.get(r.host);S.has(r.port)&&(m&&S.get(r.port).disposeListener.dispose(),await S.get(r.port).tunnel.dispose(),S.delete(r.port))}}async $onDidTunnelsChange(){this.g.fire()}async $forwardPort(r,m){if(this.b)try{this.n.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const S=this.b(r,m);if(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),S!==void 0){const k=await S;this.n.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this.f.has(r.remoteAddress.host)||this.f.set(r.remoteAddress.host,new Map);const M=this.B(k.onDidDispose(()=>(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(k.remoteAddress))));return this.f.get(r.remoteAddress.host).set(r.remoteAddress.port,{tunnel:k,disposeListener:M}),C.TunnelDtoConverter.fromApiTunnel(k)}else this.n.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.n.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(r){const m=await Promise.all(r.map(k=>this.c(k.host,k.port,k.detail??""))),S=r.filter((k,M)=>m[M]);return this.n.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${r.map(k=>k.port).join(", ")} to ${S.map(k=>k.port).join(", ")}`),S}async findCandidatePorts(){let r="",m="";try{r=await L.Promises.readFile("/proc/net/tcp","utf8"),m=await L.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const S=p(r,m),k=await new Promise(j=>{(0,y.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(z,ne,_)=>{j(ne)})}),M=g(k),q=await L.Promises.readdir("/proc"),V=[];for(const j of q)try{const z=Number(j),ne=D.joinPath(A.URI.file("/proc"),j);if((await L.Promises.stat(ne.fsPath)).isDirectory()&&!isNaN(z)){const Y=await L.Promises.readlink(D.joinPath(ne,"cwd").fsPath),J=await L.Promises.readFile(D.joinPath(ne,"cmdline").fsPath,"utf8");V.push({pid:z,cwd:Y,cmd:J})}}catch{}const F=[],U=S.filter(j=>{const z=M[j.socket];return z||F.push(j),z}),N=u(U,M,V);let B;if(this.n.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${F.length}`),F.length>0){const j=await new Promise(z=>{(0,y.exec)("ps -F -A -l | grep root",(ne,_,Y)=>{z(_)})});this.j=l(F,j,this.j),B=Array.from(this.j.values()),this.n.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${B.map(z=>z.port).join(", ")}`)}return N.then(j=>B?j.concat(B):j)}};c=qe([We(0,t.IExtHostRpcService),We(1,I.IExtHostInitDataService),We(2,h.ILogService)],c),e.ExtHostTunnelService=c}),define(ye[283],Ce([1,0,16,22,21,9,3,6,113,242,57]),function(te,e,o,t,T,R,I,A,y,D,L){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function v(S,k){try{return JSON.stringify(S,k)}catch{return"null"}}const C="$$ref$$",E={[C]:-1};class f{constructor(k,M){this.jsonString=k,this.referencedBuffers=M}}function d(S,k=null,M=!1){const q=[];return{jsonString:(M?v:JSON.stringify)(S,(F,U)=>{if(typeof U>"u")return E;if(typeof U=="object"){if(U instanceof t.VSBuffer){const N=q.push(U)-1;return{[C]:N}}if(k)return k(F,U)}return U}),referencedBuffers:q}}e.stringifyJsonWithBufferRefs=d;function h(S,k,M){return JSON.parse(S,(q,V)=>{if(V){const F=V[C];if(typeof F=="number")return k[F];if(M&&V.$mid===1)return M.transformIncoming(V)}return V})}e.parseJsonAndRestoreBufferRefs=h;function b(S,k){return JSON.stringify(S,k)}function g(S){return S?(k,M)=>M&&M.$mid===1?S.transformOutgoing(M):M:null}var p;(function(S){S[S.LocalSide=0]="LocalSide",S[S.OtherSide=1]="OtherSide"})(p=e.RequestInitiator||(e.RequestInitiator={}));var w;(function(S){S[S.Responsive=0]="Responsive",S[S.Unresponsive=1]="Unresponsive"})(w=e.ResponsiveState||(e.ResponsiveState={}));const i=()=>{},s=Symbol.for("rpcProtocol"),a=Symbol.for("rpcProxy");class u extends A.Disposable{constructor(k,M=null,q=null){super(),this[P]=!0,this.b=this.B(new I.Emitter),this.onDidChangeResponsiveState=this.b.event,this.c=k,this.f=M,this.g=q,this.h=g(this.g),this.j=!1,this.k=[],this.l=[];for(let V=0,F=L.ProxyIdentifier.count;V<F;V++)this.k[V]=null,this.l[V]=null;this.m=0,this.p=Object.create(null),this.s={},this.t=0,this.u=0,this.v=0,this.w=this.B(new o.RunOnceScheduler(()=>this.C(),1e3)),this.c.onMessage(V=>this.G(V))}dispose(){this.j=!0,Object.keys(this.s).forEach(k=>{this.s[k].resolveErr(R.canceled())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}y(k){this.u===0&&(this.v=Date.now()+u.a),this.u++,this.w.isScheduled()||this.w.schedule()}z(k){this.v=Date.now()+u.a,this.u--,this.u===0&&this.w.cancel(),this.D(0)}C(){this.u!==0&&(Date.now()>this.v?this.D(1):this.w.schedule())}D(k){this.t!==k&&(this.t=k,this.b.fire(this.t))}get responsiveState(){return this.t}transformIncomingURIs(k){return this.g?(0,y.transformIncomingURIs)(k,this.g):k}getProxy(k){const{nid:M,sid:q}=k;return this.l[M]||(this.l[M]=this.F(M,q)),this.l[M]}F(k,M){const q={get:(V,F)=>(typeof F=="string"&&!V[F]&&F.charCodeAt(0)===36&&(V[F]=(...U)=>this.O(k,F,U)),F===a?M:V[F])};return new Proxy(Object.create(null),q)}set(k,M){return this.k[k.nid]=M,M}assertRegistered(k){for(let M=0,q=k.length;M<q;M++){const V=k[M];if(!this.k[V.nid])throw new Error(`Missing proxy instance ${V.sid}`)}}G(k){if(this.j)return;const M=k.byteLength,q=l.read(k,0),V=q.readUInt8(),F=q.readUInt32();switch(V){case 1:case 2:{let{rpcId:U,method:N,args:B}=n.deserializeRequestJSONArgs(q);this.g&&(B=(0,y.transformIncomingURIs)(B,this.g)),this.H(M,F,U,N,B,V===2);break}case 3:case 4:{let{rpcId:U,method:N,args:B}=n.deserializeRequestMixedArgs(q);this.g&&(B=(0,y.transformIncomingURIs)(B,this.g)),this.H(M,F,U,N,B,V===4);break}case 5:{this.f?.logIncoming(M,F,0,"ack"),this.z(F);break}case 6:{this.I(M,F);break}case 7:{this.J(M,F,void 0);break}case 9:{let U=n.deserializeReplyOKJSON(q);this.g&&(U=(0,y.transformIncomingURIs)(U,this.g)),this.J(M,F,U);break}case 10:{const U=n.deserializeReplyOKJSONWithBuffers(q,this.g);this.J(M,F,U);break}case 8:{const U=n.deserializeReplyOKVSBuffer(q);this.J(M,F,U);break}case 11:{let U=n.deserializeReplyErrError(q);this.g&&(U=(0,y.transformIncomingURIs)(U,this.g)),this.L(M,F,U);break}case 12:{this.L(M,F,void 0);break}default:console.error("received unexpected message"),console.error(k)}}H(k,M,q,V,F,U){this.f?.logIncoming(k,M,1,`receiveRequest ${(0,L.getStringIdentifierForProxy)(q)}.${V}(`,F);const N=String(M);let B,j;if(U){const ne=new T.CancellationTokenSource;F.push(ne.token),B=this.M(q,V,F),j=()=>ne.cancel()}else B=this.M(q,V,F),j=i;this.p[N]=j;const z=n.serializeAcknowledged(M);this.f?.logOutgoing(z.byteLength,M,1,"ack"),this.c.send(z),B.then(ne=>{delete this.p[N];const _=n.serializeReplyOK(M,ne,this.h);this.f?.logOutgoing(_.byteLength,M,1,"reply:",ne),this.c.send(_)},ne=>{delete this.p[N];const _=n.serializeReplyErr(M,ne);this.f?.logOutgoing(_.byteLength,M,1,"replyErr:",ne),this.c.send(_)})}I(k,M){this.f?.logIncoming(k,M,1,"receiveCancel");const q=String(M);this.p[q]?.()}J(k,M,q){this.f?.logIncoming(k,M,0,"receiveReply:",q);const V=String(M);if(!this.s.hasOwnProperty(V))return;const F=this.s[V];delete this.s[V],F.resolveOk(q)}L(k,M,q){this.f?.logIncoming(k,M,0,"receiveReplyErr:",q);const V=String(M);if(!this.s.hasOwnProperty(V))return;const F=this.s[V];delete this.s[V];let U;q&&(q.$isError?(U=new Error,U.name=q.name,U.message=q.message,U.stack=q.stack):U=q),F.resolveErr(U)}M(k,M,q){try{return Promise.resolve(this.N(k,M,q))}catch(V){return Promise.reject(V)}}N(k,M,q){const V=this.k[k];if(!V)throw new Error("Unknown actor "+(0,L.getStringIdentifierForProxy)(k));const F=V[M];if(typeof F!="function")throw new Error("Unknown method "+M+" on actor "+(0,L.getStringIdentifierForProxy)(k));return F.apply(V,q)}O(k,M,q){if(this.j)return new D.CanceledLazyPromise;let V=null;if(q.length>0&&T.CancellationToken.isCancellationToken(q[q.length-1])&&(V=q.pop()),V&&V.isCancellationRequested)return Promise.reject(R.canceled());const F=n.serializeRequestArguments(q,this.h),U=++this.m,N=String(U),B=new D.LazyPromise;V&&V.onCancellationRequested(()=>{const z=n.serializeCancel(U);this.f?.logOutgoing(z.byteLength,U,0,"cancel"),this.c.send(n.serializeCancel(U))}),this.s[N]=B,this.y(U);const j=n.serializeRequest(U,k,M,F,!!V);return this.f?.logOutgoing(j.byteLength,U,0,`request: ${(0,L.getStringIdentifierForProxy)(k)}.${M}(`,q),this.c.send(j),B}}e.RPCProtocol=u,P=s,u.a=3*1e3;class l{static alloc(k,M,q){const V=new l(t.VSBuffer.alloc(q+1+4),0);return V.writeUInt8(k),V.writeUInt32(M),V}static read(k,M){return new l(k,M)}get buffer(){return this.a}constructor(k,M){this.a=k,this.b=M}static sizeUInt8(){return 1}writeUInt8(k){this.a.writeUInt8(k,this.b),this.b+=1}readUInt8(){const k=this.a.readUInt8(this.b);return this.b+=1,k}writeUInt32(k){this.a.writeUInt32BE(k,this.b),this.b+=4}readUInt32(){const k=this.a.readUInt32BE(this.b);return this.b+=4,k}static sizeShortString(k){return 1+k.byteLength}writeShortString(k){this.a.writeUInt8(k.byteLength,this.b),this.b+=1,this.a.set(k,this.b),this.b+=k.byteLength}readShortString(){const k=this.a.readUInt8(this.b);this.b+=1;const q=this.a.slice(this.b,this.b+k).toString();return this.b+=k,q}static sizeLongString(k){return 4+k.byteLength}writeLongString(k){this.a.writeUInt32BE(k.byteLength,this.b),this.b+=4,this.a.set(k,this.b),this.b+=k.byteLength}readLongString(){const k=this.a.readUInt32BE(this.b);this.b+=4;const q=this.a.slice(this.b,this.b+k).toString();return this.b+=k,q}writeBuffer(k){this.a.writeUInt32BE(k.byteLength,this.b),this.b+=4,this.a.set(k,this.b),this.b+=k.byteLength}static sizeVSBuffer(k){return 4+k.byteLength}writeVSBuffer(k){this.a.writeUInt32BE(k.byteLength,this.b),this.b+=4,this.a.set(k,this.b),this.b+=k.byteLength}readVSBuffer(){const k=this.a.readUInt32BE(this.b);this.b+=4;const M=this.a.slice(this.b,this.b+k);return this.b+=k,M}static sizeMixedArray(k){let M=0;M+=1;for(let q=0,V=k.length;q<V;q++){const F=k[q];switch(M+=1,F.type){case 1:M+=this.sizeLongString(F.value);break;case 2:M+=this.sizeVSBuffer(F.value);break;case 3:M+=this.sizeUInt32,M+=this.sizeLongString(F.value);for(let U=0;U<F.buffers.length;++U)M+=this.sizeVSBuffer(F.buffers[U]);break;case 4:break}}return M}writeMixedArray(k){this.a.writeUInt8(k.length,this.b),this.b+=1;for(let M=0,q=k.length;M<q;M++){const V=k[M];switch(V.type){case 1:this.writeUInt8(1),this.writeLongString(V.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(V.value);break;case 3:this.writeUInt8(3),this.writeUInt32(V.buffers.length),this.writeLongString(V.value);for(let F=0;F<V.buffers.length;++F)this.writeBuffer(V.buffers[F]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const k=this.a.readUInt8(this.b);this.b+=1;const M=new Array(k);for(let q=0;q<k;q++)switch(this.readUInt8()){case 1:M[q]=this.readLongString();break;case 2:M[q]=this.readVSBuffer();break;case 3:{const F=this.readUInt32(),U=this.readLongString(),N=[];for(let B=0;B<F;++B)N.push(this.readVSBuffer());M[q]=new L.SerializableObjectWithBuffers(h(U,N,null));break}case 4:M[q]=void 0;break}return M}}l.sizeUInt32=4;var c;(function(S){S[S.Simple=0]="Simple",S[S.Mixed=1]="Mixed"})(c||(c={}));class n{static a(k){for(let M=0,q=k.length;M<q;M++)if(k[M]instanceof t.VSBuffer||k[M]instanceof L.SerializableObjectWithBuffers||typeof k[M]>"u")return!0;return!1}static serializeRequestArguments(k,M){if(this.a(k)){const q=[];for(let V=0,F=k.length;V<F;V++){const U=k[V];if(U instanceof t.VSBuffer)q[V]={type:2,value:U};else if(typeof U>"u")q[V]={type:4};else if(U instanceof L.SerializableObjectWithBuffers){const{jsonString:N,referencedBuffers:B}=d(U.value,M);q[V]={type:3,value:t.VSBuffer.fromString(N),buffers:B}}else q[V]={type:1,value:t.VSBuffer.fromString(b(U,M))}}return{type:1,args:q}}return{type:0,args:b(k,M)}}static serializeRequest(k,M,q,V,F){switch(V.type){case 0:return this.b(k,M,q,V.args,F);case 1:return this.c(k,M,q,V.args,F)}}static b(k,M,q,V,F){const U=t.VSBuffer.fromString(q),N=t.VSBuffer.fromString(V);let B=0;B+=l.sizeUInt8(),B+=l.sizeShortString(U),B+=l.sizeLongString(N);const j=l.alloc(F?2:1,k,B);return j.writeUInt8(M),j.writeShortString(U),j.writeLongString(N),j.buffer}static deserializeRequestJSONArgs(k){const M=k.readUInt8(),q=k.readShortString(),V=k.readLongString();return{rpcId:M,method:q,args:JSON.parse(V)}}static c(k,M,q,V,F){const U=t.VSBuffer.fromString(q);let N=0;N+=l.sizeUInt8(),N+=l.sizeShortString(U),N+=l.sizeMixedArray(V);const B=l.alloc(F?4:3,k,N);return B.writeUInt8(M),B.writeShortString(U),B.writeMixedArray(V),B.buffer}static deserializeRequestMixedArgs(k){const M=k.readUInt8(),q=k.readShortString(),V=k.readMixedArray(),F=new Array(V.length);for(let U=0,N=V.length;U<N;U++){const B=V[U];typeof B=="string"?F[U]=JSON.parse(B):F[U]=B}return{rpcId:M,method:q,args:F}}static serializeAcknowledged(k){return l.alloc(5,k,0).buffer}static serializeCancel(k){return l.alloc(6,k,0).buffer}static serializeReplyOK(k,M,q){if(typeof M>"u")return this.d(k);if(M instanceof t.VSBuffer)return this.e(k,M);if(M instanceof L.SerializableObjectWithBuffers){const{jsonString:V,referencedBuffers:F}=d(M.value,q,!0);return this.g(k,V,F)}else return this.f(k,v(M,q))}static d(k){return l.alloc(7,k,0).buffer}static e(k,M){let q=0;q+=l.sizeVSBuffer(M);const V=l.alloc(8,k,q);return V.writeVSBuffer(M),V.buffer}static deserializeReplyOKVSBuffer(k){return k.readVSBuffer()}static f(k,M){const q=t.VSBuffer.fromString(M);let V=0;V+=l.sizeLongString(q);const F=l.alloc(9,k,V);return F.writeLongString(q),F.buffer}static g(k,M,q){const V=t.VSBuffer.fromString(M);let F=0;F+=l.sizeUInt32,F+=l.sizeLongString(V);for(const N of q)F+=l.sizeVSBuffer(N);const U=l.alloc(10,k,F);U.writeUInt32(q.length),U.writeLongString(V);for(const N of q)U.writeBuffer(N);return U.buffer}static deserializeReplyOKJSON(k){const M=k.readLongString();return JSON.parse(M)}static deserializeReplyOKJSONWithBuffers(k,M){const q=k.readUInt32(),V=k.readLongString(),F=[];for(let U=0;U<q;++U)F.push(k.readVSBuffer());return new L.SerializableObjectWithBuffers(h(V,F,M))}static serializeReplyErr(k,M){const q=M?v(R.transformErrorForSerialization(M),null):void 0;if(typeof q!="string")return this.h(k);const V=t.VSBuffer.fromString(q);let F=0;F+=l.sizeLongString(V);const U=l.alloc(11,k,F);return U.writeLongString(V),U.buffer}static deserializeReplyErrError(k){const M=k.readLongString();return JSON.parse(M)}static h(k){return l.alloc(12,k,0).buffer}}var r;(function(S){S[S.RequestJSONArgs=1]="RequestJSONArgs",S[S.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",S[S.RequestMixedArgs=3]="RequestMixedArgs",S[S.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",S[S.Acknowledged=5]="Acknowledged",S[S.Cancel=6]="Cancel",S[S.ReplyOKEmpty=7]="ReplyOKEmpty",S[S.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",S[S.ReplyOKJSON=9]="ReplyOKJSON",S[S.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",S[S.ReplyErrError=11]="ReplyErrError",S[S.ReplyErrEmpty=12]="ReplyErrEmpty"})(r||(r={}));var m;(function(S){S[S.String=1]="String",S[S.VSBuffer=2]="VSBuffer",S[S.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",S[S.Undefined=4]="Undefined"})(m||(m={}))}),define(ye[284],Ce([1,0,3,44,53,4,39,9,16]),function(te,e,o,t,T,R,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new T.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new T.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new T.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,R.createDecorator)(e.OUTPUT_SERVICE_ID);var D;(function(C){C[C.Append=1]="Append",C[C.Replace=2]="Replace",C[C.Clear=3]="Clear"})(D=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class L{constructor(){this.a=new Map,this.b=new o.Emitter,this.onDidRegisterChannel=this.b.event,this.c=new o.Emitter,this.onDidRemoveChannel=this.c.event}registerChannel(E){this.a.has(E.id)||(this.a.set(E.id,E),this.b.fire(E.id))}getChannels(){const E=[];return this.a.forEach(f=>E.push(f)),E}getChannel(E){return this.a.get(E)}removeChannel(E){this.a.delete(E),this.c.fire(E)}}t.Registry.add(e.Extensions.OutputChannels,new L);function P(C,E,f,d,h){return(0,y.createCancelablePromise)(async b=>{await(0,I.whenProviderRegistered)(f,d);const g=t.Registry.as(e.Extensions.OutputChannels);try{await v(f,1,d,h,b),g.registerChannel({id:C,label:E,file:f,log:!0})}catch(p){(0,A.isCancellationError)(p)||h.error("Error while registering log channel",f.toString(),(0,A.getErrorMessage)(p))}})}e.registerLogChannel=P;async function v(C,E,f,d,h){if(!await f.exists(C)){if(h.isCancellationRequested)throw new A.CancellationError;if(E>10)throw new Error("Timed out while waiting for file to be created");d.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",C.toString()),await(0,y.timeout)(1e3,h),await v(C,E+1,f,d,h)}}e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new T.RawContextKey("activeOutputChannel","")}),define(ye[142],Ce([1,0,5,4,17,26,13,284,72,25,48,157,22,11,39,3,6]),function(te,e,o,t,T,R,I,A,y,D,L,P,v,C,E,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class h extends I.AbstractMessageLogger{get disposed(){return this.l}constructor(w,i,s,a,u){super(),this.id=w,this.name=i,this.m=s,this.n=a,this.extension=u,this.k=0,this.l=!1,this.visible=!1,this.setLevel(s.getLevel()),this.B(s.onDidChangeLogLevel(l=>this.setLevel(l)))}get logLevel(){return this.getLevel()}appendLine(w){this.append(w+`
`)}append(w){this.info(w)}clear(){const w=this.k;this.m.flush(),this.n.$update(this.id,A.OutputChannelUpdateMode.Clear,w)}replace(w){const i=this.k;this.info(w),this.n.$update(this.id,A.OutputChannelUpdateMode.Replace,i),this.visible&&this.m.flush()}show(w,i){this.m.flush(),this.n.$reveal(this.id,!!(typeof w=="boolean"?w:i))}hide(){this.n.$close(this.id)}g(w,i){this.k+=v.VSBuffer.fromString(i).byteLength,(0,I.log)(this.m,w,i),this.visible&&(this.m.flush(),this.n.$update(this.id,A.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.l||(this.n.$dispose(this.id),this.l=!0)}}class b extends h{appendLine(w){this.append(w)}}let g=class{constructor(w,i,s,a,u,l){this.i=i,this.j=s,this.k=a,this.l=u,this.m=l,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=w.getProxy(o.MainContext.MainThreadOutputService),this.b=this.k.extUri.joinPath(i.logsLocation,`output_logging_${(0,P.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(w){this.h=w;for(const[i,s]of this.g)s.visible=i===this.h}createOutputChannel(w,i,s){if(w=w.trim(),!w)throw new Error("illegal argument `name`. must not be falsy");const a=typeof i=="object"&&i.log,u=(0,C.isString)(i)?i:void 0;if((0,C.isString)(u)&&!u.trim())throw new Error("illegal argument `languageId`. must not be empty");let l;const c=this.i.environment.extensionLogLevel?.find(([r])=>R.ExtensionIdentifier.equals(s.identifier,r))?.[1];c&&(l=(0,I.parseLogLevel)(c));const n=a?this.o(w,l,s):this.n(w,u,s);return n.then(r=>{this.g.set(r.id,r),r.visible=r.id===this.h}),a?this.r(w,l??this.m.getLevel(),n):this.q(w,n)}async n(w,i,s){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const a=await this.c,u=this.k.extUri.joinPath(a,`${this.f++}-${w.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),l=this.l.createLogger(u,{always:!0,donotRotate:!0,donotUseFormatters:!0}),c=await this.a.$register(w,u,!1,i,s.identifier.value);return new h(c,w,l,this.a,s)}async o(w,i,s){const a=await this.p(s),u=this.k.extUri.joinPath(a,`${w.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),l=this.l.createLogger(u,{name:w},i),c=await this.a.$register(w,u,!0,void 0,s.identifier.value);return new b(c,w,l,this.a,s)}p(w){let i=this.d.get(w.identifier.value);if(!i){const s=this.k.extUri.joinPath(this.i.logsLocation,w.identifier.value);this.d.set(w.identifier.value,i=(async()=>{try{await this.j.value.createDirectory(s)}catch(a){if((0,E.toFileSystemProviderErrorCode)(a)!==E.FileSystemProviderErrorCode.FileExists)throw a}return s})())}return i}q(w,i){let s=!1;const a=()=>{if(s)throw new Error("Channel has been closed")};return{get name(){return w},append(u){a(),i.then(l=>l.append(u))},appendLine(u){a(),i.then(l=>l.appendLine(u))},clear(){a(),i.then(u=>u.clear())},replace(u){a(),i.then(l=>l.replace(u))},show(u,l){a(),i.then(c=>c.show(u,l))},hide(){a(),i.then(u=>u.hide())},dispose(){s=!0,i.then(u=>u.dispose())}}}r(w,i,s){const a=new d.DisposableStore,u=()=>{if(a.isDisposed)throw new Error("Channel has been closed")},l=a.add(new f.Emitter);return s.then(c=>{a.add(c),a.add(c.onDidChangeLogLevel(n=>{i=n,l.fire(n)}))}),{...this.q(w,s),get logLevel(){return i},onDidChangeLogLevel:l.event,trace(c,...n){u(),s.then(r=>r.trace(c,...n))},debug(c,...n){u(),s.then(r=>r.debug(c,...n))},info(c,...n){u(),s.then(r=>r.info(c,...n))},warn(c,...n){u(),s.then(r=>r.warn(c,...n))},error(c,...n){u(),s.then(r=>r.error(c,...n))},dispose(){a.dispose()}}}};g=qe([We(0,T.IExtHostRpcService),We(1,D.IExtHostInitDataService),We(2,y.IExtHostConsumerFileSystem),We(3,L.IExtHostFileSystemInfo),We(4,I.ILoggerService),We(5,I.ILogService)],g),e.ExtHostOutputService=g,e.IExtHostOutputService=(0,t.createDecorator)("IExtHostOutputService")}),define(ye[285],Ce([1,0,4]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,o.createDecorator)("remoteAgentService")}),define(ye[286],Ce([1,0,32,15,10,12,24,2,4,212,47,229,285]),function(te,e,o,t,T,R,I,A,y,D,L,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let C=class si{constructor(f,d,h,b){this.d=f,this.e=d,this.f=h,this.g=b,this.a=(async()=>(await this.e.getEnvironment())?.os||R.OS)(),this.b=(async()=>{const g=await this.e.getEnvironment();return this.c=g?.userHome??f})()}hasValidBasename(f,d,h){return typeof d=="string"||typeof d>"u"?this.a.then(b=>this.h(f,b,d)):this.h(f,d,h)}h(f,d,h){return f.scheme===t.Schemas.file||f.scheme===t.Schemas.vscodeRemote?(0,o.isValidBasename)(h??(0,I.basename)(f),d===1):!0}get defaultUriScheme(){return si.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(f,d){if(f.remoteAuthority)return t.Schemas.vscodeRemote;const h=(0,D.getVirtualWorkspaceScheme)(d.getWorkspace());if(h)return h;const b=d.getWorkspace().folders[0];if(b)return b.uri.scheme;const g=d.getWorkspace().configuration;return g?g.scheme:t.Schemas.file}userHome(f){return f?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(f=>f===1?T.win32:T.posix)}async fileURI(f){let d="";if(await this.a===1&&(f=f.replace(/\\/g,"/")),f[0]==="/"&&f[1]==="/"){const b=f.indexOf("/",2);b===-1?(d=f.substring(2),f="/"):(d=f.substring(2,b),f=f.substring(b)||"/")}return A.URI.from({scheme:t.Schemas.file,authority:d,path:f,query:"",fragment:""})}};C=qe([We(1,v.IRemoteAgentService),We(2,P.IWorkbenchEnvironmentService),We(3,L.IWorkspaceContextService)],C),e.AbstractPathService=C}),define(ye[75],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class o{constructor(I,A){this.line=I,this.character=A}isBefore(I){return!1}isBeforeOrEqual(I){return!1}isAfter(I){return!1}isAfterOrEqual(I){return!1}isEqual(I){return!1}compareTo(I){return 0}translate(I,A){return new o(0,0)}with(I){return new o(0,0)}}e.Position=o;class t{constructor(I,A,y,D){this.isEmpty=!1,this.isSingleLine=!1,this.start=new o(I,A),this.end=new o(y,D)}contains(I){return!1}isEqual(I){return!1}intersection(I){}union(I){return new t(0,0,0,0)}with(I){return new t(0,0,0,0)}}e.Range=t;var T;(function(R){R[R.Information=1]="Information",R[R.Warning=2]="Warning"})(T=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(ye[31],Ce([1,0,18,38,23,32,8,4,10,9,75,16]),function(te,e,o,t,T,R,I,A,y,D,L,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return L.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const v="\u27EA ",C=" characters skipped \u27EB",E=(v.length+C.length+5)*2;e.ISearchService=(0,A.createDecorator)("searchService");var f;(function(J){J[J.file=0]="file",J[J.text=1]="text"})(f=e.SearchProviderType||(e.SearchProviderType={}));var d;(function(J){J[J.File=1]="File",J[J.Text=2]="Text"})(d=e.QueryType||(e.QueryType={}));function h(J){return!!J.preview}e.resultIsMatch=h;function b(J){return!!J.resource}e.isFileMatch=b;function g(J){return!!J.message}e.isProgressMessage=g;var p;(function(J){J[J.Normal=0]="Normal",J[J.NewSearchStarted=1]="NewSearchStarted"})(p=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class w{constructor(Z){this.resource=Z,this.results=[]}}e.FileMatch=w;class i{constructor(Z,ie,X){this.ranges=ie;const K=Array.isArray(ie)?ie:[ie];if(X&&X.matchLines===1&&s(K)){Z=(0,I.getNLines)(Z,X.matchLines);let he="",be=0,Ee=0;const Pe=Math.floor(X.charsPerLine/5),Me=[];for(const oe of K){const ae=Math.max(oe.startColumn-Pe,0),fe=oe.startColumn+X.charsPerLine;if(ae>Ee+Pe+E){const ee=v+(ae-Ee)+C;he+=ee+Z.slice(ae,fe),be+=ae-(Ee+ee.length)}else he+=Z.slice(Ee,fe);Me.push(new u(0,oe.startColumn-be,oe.endColumn-be)),Ee=fe}this.preview={text:he,matches:Array.isArray(this.ranges)?Me:Me[0]}}else{const he=Array.isArray(ie)?ie[0].startLineNumber:ie.startLineNumber;this.preview={text:Z,matches:(0,o.mapArrayOrNot)(ie,be=>new a(be.startLineNumber-he,be.startColumn,be.endLineNumber-he,be.endColumn))}}}}e.TextSearchMatch=i;function s(J){const Z=J[0].startLineNumber;for(const ie of J)if(ie.startLineNumber!==Z||ie.endLineNumber!==Z)return!1;return!0}class a{constructor(Z,ie,X,K){this.startLineNumber=Z,this.startColumn=ie,this.endLineNumber=X,this.endColumn=K}}e.SearchRange=a;class u extends a{constructor(Z,ie,X){super(Z,ie,Z,X)}}e.OneLineRange=u;var l;(function(J){J.List="list",J.Tree="tree"})(l=e.ViewMode||(e.ViewMode={}));var c;(function(J){J.Default="default",J.FileNames="fileNames",J.Type="type",J.Modified="modified",J.CountDescending="countDescending",J.CountAscending="countAscending"})(c=e.SearchSortOrder||(e.SearchSortOrder={}));function n(J,Z=!0){const ie=J&&J.files&&J.files.exclude,X=Z&&J&&J.search&&J.search.exclude;if(!ie&&!X)return;if(!ie||!X)return ie||X;let K=Object.create(null);return K=T.mixin(K,T.deepClone(ie)),K=T.mixin(K,T.deepClone(X),!0),K}e.getExcludes=n;function r(J,Z){return J.excludePattern&&t.match(J.excludePattern,Z)?!1:J.includePattern||J.usingSearchPaths?J.includePattern&&t.match(J.includePattern,Z)?!0:J.usingSearchPaths?!!J.folderQueries&&J.folderQueries.some(ie=>{const X=ie.folder.fsPath;if(R.isEqualOrParent(Z,X)){const K=y.relative(X,Z);return!ie.includePattern||!!t.match(ie.includePattern,K)}else return!1}):!1:!0}e.pathIncludedInQuery=r;var m;(function(J){J[J.unknownEncoding=1]="unknownEncoding",J[J.regexParseError=2]="regexParseError",J[J.globParseError=3]="globParseError",J[J.invalidLiteral=4]="invalidLiteral",J[J.rgProcessError=5]="rgProcessError",J[J.other=6]="other",J[J.canceled=7]="canceled"})(m=e.SearchErrorCode||(e.SearchErrorCode={}));class S extends Error{constructor(Z,ie){super(Z),this.code=ie}}e.SearchError=S;function k(J){const Z=J.message;if((0,D.isCancellationError)(J))return new S(Z,m.canceled);try{const ie=JSON.parse(Z);return new S(ie.message,ie.code)}catch{return new S(Z,m.other)}}e.deserializeSearchError=k;function M(J){const Z={message:J.message,code:J.code};return new Error(JSON.stringify(Z))}e.serializeSearchError=M;function q(J){return J.type==="error"?!0:J.type==="success"}e.isSerializedSearchComplete=q;function V(J){return J.type==="success"}e.isSerializedSearchSuccess=V;function F(J){return!!J.path}e.isSerializedFileMatch=F;function U(J,Z){const ie=J.searchPath?J.searchPath:J.relativePath;return(0,I.fuzzyContains)(ie,Z)}e.isFilePatternMatch=U;class N{constructor(Z){this.path=Z,this.results=[]}addMatch(Z){this.results.push(Z)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=N;function B(J,Z){const ie={...J||{},...Z||{}};return Object.keys(ie).filter(X=>{const K=ie[X];return typeof K=="boolean"&&K})}e.resolvePatternsForProvider=B;class j{constructor(Z,ie){this.c=null,this.a={...Z.excludePattern||{},...ie.excludePattern||{}},this.b=t.parse(this.a);let X=Z.includePattern;ie.includePattern&&(X?X={...X,...ie.includePattern}:X=ie.includePattern),X&&(this.c=t.parse(X))}matchesExcludesSync(Z,ie,X){return!!(this.b&&this.b(Z,ie,X))}includedInQuerySync(Z,ie,X){return!(this.b&&this.b(Z,ie,X)||this.c&&!this.c(Z,ie,X))}includedInQuery(Z,ie,X){const K=this.b(Z,ie,X),he=()=>this.c?!!this.c(Z,ie,X):!0;return(0,P.isThenable)(K)?K.then(be=>be?!1:he()):he()}hasSiblingExcludeClauses(){return z(this.a)}}e.QueryGlobTester=j;function z(J){for(const Z in J)if(typeof J[Z]!="boolean")return!0;return!1}function ne(J){if(!J)return;let Z;return ie=>(Z||(Z=(J()||Promise.resolve([])).then(X=>X?Y(X):{})),Z.then(X=>!!X[ie]))}e.hasSiblingPromiseFn=ne;function _(J){if(!J)return;let Z;return ie=>{if(!Z){const X=J();Z=X?Y(X):{}}return!!Z[ie]}}e.hasSiblingFn=_;function Y(J){const Z={};for(const ie of J)Z[ie]=!0;return Z}}),define(ye[33],Ce([1,0,18,16,21,3,6,64,15,101,24,8,11,2,181,4,13,201,47,48,25,17,14,7,55,31,5]),function(te,e,o,t,T,R,I,A,y,D,L,P,v,C,E,f,d,h,b,g,p,w,i,s,a,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function c(V,F,U){return new L.ExtUri(N=>S(N,U)).isEqual(V,F)}function n(V,F,U){return c(V.uri,F.uri,U)?0:(0,P.compare)(V.uri.toString(),F.uri.toString())}function r(V,F,U){return V.index!==F.index?V.index<F.index?-1:1:c(V.uri,F.uri,U)?(0,P.compare)(V.name,F.name):(0,P.compare)(V.uri.toString(),F.uri.toString())}function m(V,F,U,N){const B=V.slice(0).sort((z,ne)=>U(z,ne,N)),j=F.slice(0).sort((z,ne)=>U(z,ne,N));return(0,o.delta)(B,j,(z,ne)=>U(z,ne,N))}function S(V,F){const U=F.getCapabilities(V.scheme);return!(U&&U&1024)}class k extends b.Workspace{static toExtHostWorkspace(F,U,N,B){if(!F)return{workspace:null,added:[],removed:[]};const{id:j,name:z,folders:ne,configuration:_,transient:Y,isUntitled:J}=F,Z=[],ie=U;U?ne.forEach((be,Ee)=>{const Pe=C.URI.revive(be.uri),Me=k.e(N||U,Pe,B);Me?(Me.name=be.name,Me.index=be.index,Z.push(Me)):Z.push({uri:Pe,name:be.name,index:Ee})}):Z.push(...ne.map(({uri:be,name:Ee,index:Pe})=>({uri:C.URI.revive(be),name:Ee,index:Pe}))),Z.sort((be,Ee)=>be.index<Ee.index?-1:1);const X=new k(j,z,Z,!!Y,_?C.URI.revive(_):null,!!J,be=>S(be,B)),{added:K,removed:he}=m(ie?ie.workspaceFolders:[],X.workspaceFolders,n,B);return{workspace:X,added:K,removed:he}}static e(F,U,N){for(let B=0;B<F.folders.length;B++){const j=F.workspaceFolders[B];if(c(j.uri,U,N))return j}}constructor(F,U,N,B,j,z,ne){super(F,N.map(_=>new b.WorkspaceFolder(_)),B,j,ne),this.s=U,this.t=z,this.o=[],this.q=A.TernarySearchTree.forUris(ne),N.forEach(_=>{this.o.push(_),this.q.set(_.uri,_)})}get name(){return this.s}get isUntitled(){return this.t}get workspaceFolders(){return this.o.slice(0)}getWorkspaceFolder(F,U){return U&&this.q.get(F)&&(F=(0,L.dirname)(F)),this.q.findSubstr(F)}resolveWorkspaceFolder(F){return this.q.get(F)}}let M=class{constructor(F,U,N,B,j){this.c=new R.Emitter,this.onDidChangeWorkspace=this.c.event,this.e=new R.Emitter,this.onDidGrantWorkspaceTrust=this.e.event,this.t=[],this.u=!1,this.v=new Map,this.y=0,this.g=B,this.q=N,this.s=j,this.h=new D.Counter,this.j=new t.Barrier,this.n=F.getProxy(l.MainContext.MainThreadWorkspace),this.o=F.getProxy(l.MainContext.MainThreadMessageService);const z=U.workspace;this.k=z?new k(z.id,z.name,[],!!z.transient,z.configuration?C.URI.revive(z.configuration):null,!!z.isUntitled,ne=>S(ne,N)):void 0}$initializeWorkspace(F,U){this.u=U,this.$acceptWorkspaceData(F),this.j.open()}waitForInitializeCall(){return this.j.wait()}get workspace(){return this.w}get name(){return this.w?this.w.name:void 0}get workspaceFile(){if(this.w&&this.w.configuration)return this.w.isUntitled?C.URI.from({scheme:y.Schemas.untitled,path:(0,L.basename)((0,L.dirname)(this.w.configuration))}):this.w.configuration}get w(){return this.l||this.k}getWorkspaceFolders(){if(!!this.w)return this.w.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.j.wait(),!!this.w)return this.w.workspaceFolders.slice(0)}updateWorkspaceFolders(F,U,N,...B){const j=[];if(Array.isArray(B)&&B.forEach(J=>{C.URI.isUri(J.uri)&&!j.some(Z=>c(Z.uri,J.uri,this.q))&&j.push({uri:J.uri,name:J.name||(0,L.basenameOrAuthority)(J.uri)})}),this.l||[U,N].some(J=>typeof J!="number"||J<0)||N===0&&j.length===0)return!1;const z=this.w?this.w.workspaceFolders:[];if(U+N>z.length)return!1;const ne=z.slice(0);ne.splice(U,N,...j.map(J=>({uri:J.uri,name:J.name||(0,L.basenameOrAuthority)(J.uri),index:void 0})));for(let J=0;J<ne.length;J++){const Z=ne[J];if(ne.some((ie,X)=>X!==J&&c(Z.uri,ie.uri,this.q)))return!1}ne.forEach((J,Z)=>J.index=Z);const{added:_,removed:Y}=m(z,ne,r,this.q);if(_.length===0&&Y.length===0)return!1;if(this.n){const J=F.displayName||F.name;this.n.$updateWorkspaceFolders(J,U,N,j).then(void 0,Z=>{this.l=void 0;const ie={source:{identifier:F.identifier,label:F.displayName||F.name}};this.o.$showMessage(h.Severity.Error,(0,E.localize)(0,null,J,Z.toString()),ie,[])})}return this.x(ne),!0}getWorkspaceFolder(F,U){if(!!this.w)return this.w.getWorkspaceFolder(F,U)}async getWorkspaceFolder2(F,U){if(await this.j.wait(),!!this.w)return this.w.getWorkspaceFolder(F,U)}async resolveWorkspaceFolder(F){if(await this.j.wait(),!!this.w)return this.w.resolveWorkspaceFolder(F)}getPath(){if(!this.w)return;const{folders:F}=this.w;if(F.length!==0)return F[0].uri.fsPath}getRelativePath(F,U){let N,B="";if(typeof F=="string"?(N=C.URI.file(F),B=F):typeof F<"u"&&(N=F,B=F.fsPath),!N)return B;const j=this.getWorkspaceFolder(N,!0);if(!j)return B;typeof U>"u"&&this.w&&(U=this.w.folders.length>1);let z=(0,L.relativePath)(j.uri,N);return U&&j.name&&(z=`${j.name}/${z}`),z}x(F){this.w&&(this.l=k.toExtHostWorkspace({id:this.w.id,name:this.w.name,configuration:this.w.configuration,folders:F,isUntitled:this.w.isUntitled},this.w,void 0,this.q).workspace||void 0)}$acceptWorkspaceData(F){const{workspace:U,added:N,removed:B}=k.toExtHostWorkspace(F,this.k,this.l,this.q);this.k=U||void 0,this.l=void 0,this.c.fire(Object.freeze({added:N,removed:B}))}findFiles(F,U,N,B,j=T.CancellationToken.None){this.g.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${B.value}, entryPoint: findFiles`);let z;if(U===null?z=!1:U&&(typeof U=="string"?z=U:z=U.pattern),j&&j.isCancellationRequested)return Promise.resolve([]);const{includePattern:ne,folder:_}=q(i.GlobPattern.from(F));return this.n.$startFileSearch((0,v.withUndefinedAsNull)(ne),(0,v.withUndefinedAsNull)(_),(0,v.withUndefinedAsNull)(z),(0,v.withUndefinedAsNull)(N),j).then(Y=>Array.isArray(Y)?Y.map(J=>C.URI.revive(J)):[])}async findTextInFiles(F,U,N,B,j=T.CancellationToken.None){this.g.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${B.value}, entryPoint: findTextInFiles`);const z=this.h.getNext(),ne=typeof U.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:U.previewOptions,{includePattern:_,folder:Y}=q(i.GlobPattern.from(U.include)),J=typeof U.exclude=="string"?U.exclude:U.exclude?U.exclude.pattern:void 0,Z={ignoreSymlinks:typeof U.followSymlinks=="boolean"?!U.followSymlinks:void 0,disregardIgnoreFiles:typeof U.useIgnoreFiles=="boolean"?!U.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof U.useGlobalIgnoreFiles=="boolean"?!U.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof U.useParentIgnoreFiles=="boolean"?!U.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof U.useDefaultExcludes=="boolean"?!U.useDefaultExcludes:!0,fileEncoding:U.encoding,maxResults:U.maxResults,previewOptions:ne,afterContext:U.afterContext,beforeContext:U.beforeContext,includePattern:_,excludePattern:J},ie=!1;if(this.t[z]=X=>{if(ie)return;const K=C.URI.revive(X.resource);X.results.forEach(he=>{(0,u.resultIsMatch)(he)?N({uri:K,preview:{text:he.preview.text,matches:(0,o.mapArrayOrNot)(he.preview.matches,be=>new s.Range(be.startLineNumber,be.startColumn,be.endLineNumber,be.endColumn))},ranges:(0,o.mapArrayOrNot)(he.ranges,be=>new s.Range(be.startLineNumber,be.startColumn,be.endLineNumber,be.endColumn))}):N({uri:K,text:he.text,lineNumber:he.lineNumber})})},j.isCancellationRequested)return{};try{const X=await this.n.$startTextSearch(F,(0,v.withUndefinedAsNull)(Y),Z,z,j);return delete this.t[z],X||{}}catch(X){throw delete this.t[z],X}}$handleTextSearchResult(F,U){this.t[U]?.(F)}saveAll(F){return this.n.$saveAll(F)}resolveProxy(F){return this.n.$resolveProxy(F)}get trusted(){return this.u}requestWorkspaceTrust(F){return this.n.$requestWorkspaceTrust(F)}$onDidGrantWorkspaceTrust(){this.u||(this.u=!0,this.e.fire())}registerEditSessionIdentityProvider(F,U){if(this.v.has(F))throw new Error(`A provider has already been registered for scheme ${F}`);this.v.set(F,U);const N=this.s.transformOutgoingScheme(F),B=this.y++;return this.n.$registerEditSessionIdentityProvider(B,N),(0,I.toDisposable)(()=>{this.v.delete(F),this.n.$unregisterEditSessionIdentityProvider(B)})}async $getEditSessionIdentifier(F,U){this.g.info("Getting edit session identifier for workspaceFolder",F);const N=await this.resolveWorkspaceFolder(C.URI.revive(F));if(!N){this.g.warn("Unable to resolve workspace folder");return}this.g.info("Invoking #provideEditSessionIdentity for workspaceFolder",N);const B=this.v.get(N.uri.scheme);if(this.g.info(`Provider for scheme ${N.uri.scheme} is defined: `,!!B),!B)return;const j=await B.provideEditSessionIdentity(N,U);if(this.g.info("Provider returned edit session identifier: ",j),!!j)return j}async $provideEditSessionIdentityMatch(F,U,N,B){this.g.info("Getting edit session identifier for workspaceFolder",F);const j=await this.resolveWorkspaceFolder(C.URI.revive(F));if(!j){this.g.warn("Unable to resolve workspace folder");return}this.g.info("Invoking #provideEditSessionIdentity for workspaceFolder",j);const z=this.v.get(j.uri.scheme);if(this.g.info(`Provider for scheme ${j.uri.scheme} is defined: `,!!z),!z)return;const ne=await z.provideEditSessionIdentityMatch?.(U,N,B);if(this.g.info("Provider returned edit session identifier match result: ",ne),!!ne)return ne}};M=qe([We(0,w.IExtHostRpcService),We(1,p.IExtHostInitDataService),We(2,g.IExtHostFileSystemInfo),We(3,d.ILogService),We(4,a.IURITransformerService)],M),e.ExtHostWorkspace=M,e.IExtHostWorkspace=(0,f.createDecorator)("IExtHostWorkspace");function q(V){let F,U;return V&&(typeof V=="string"?F=V:(F=V.pattern,U=C.URI.revive(V.baseUri))),{includePattern:F,folder:U}}}),define(ye[34],Ce([1,0,23,3,33,5,7,204,127,11,16,4,17,13,2]),function(te,e,o,t,T,R,I,A,y,D,L,P,v,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function f(s,a){if(a){const u=a.split(".");let l=s;for(let c=0;l&&c<u.length;c++)l=l[u[c]];return l}}function d(s){return s instanceof E.URI}function h(s){return s&&s.uri instanceof E.URI&&s.languageId&&typeof s.languageId=="string"}function b(s){return s&&!s.uri&&s.languageId&&typeof s.languageId=="string"}function g(s){return s&&s.uri instanceof E.URI&&(!s.name||typeof s.name=="string")&&(!s.index||typeof s.index=="number")}function p(s){if(d(s))return{resource:s};if(h(s))return{resource:s.uri,overrideIdentifier:s.languageId};if(b(s))return{overrideIdentifier:s.languageId};if(g(s))return{resource:s.uri};if(s===null)return{resource:null}}let w=class{constructor(a,u,l){this.a=a.getProxy(R.MainContext.MainThreadConfiguration),this.c=u,this.b=l,this.d=new L.Barrier,this.e=null}getConfigProvider(){return this.d.wait().then(a=>this.e)}$initializeConfiguration(a){this.e=new i(this.a,this.c,a,this.b),this.d.open()}$acceptConfigurationChanged(a,u){this.getConfigProvider().then(l=>l.$acceptConfigurationChanged(a,u))}};w=qe([We(0,v.IExtHostRpcService),We(1,T.IExtHostWorkspace),We(2,C.ILogService)],w),e.ExtHostConfiguration=w;class i{constructor(a,u,l,c){this.a=new t.Emitter,this.b=a,this.f=c,this.c=u,this.e=A.Configuration.parse(l),this.d=this.k(l.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(a,u){const l={data:this.e.toData(),workspace:this.c.workspace};this.e=A.Configuration.parse(a),this.d=this.k(a.configurationScopes),this.a.fire(this.j(u,l))}getConfiguration(a,u,l){const c=p(u)||{},n=this.g(a?f(this.e.getValue(void 0,c,this.c.workspace),a):this.e.getValue(void 0,c,this.c.workspace));a&&this.h(a,c,l?.identifier);function r(S){if(S==null)return null;if(typeof S=="boolean")return S?2:5;switch(S){case I.ConfigurationTarget.Global:return 2;case I.ConfigurationTarget.Workspace:return 5;case I.ConfigurationTarget.WorkspaceFolder:return 6}}const m={has(S){return typeof f(n,S)<"u"},get:(S,k)=>{this.h(a?`${a}.${S}`:S,c,l?.identifier);let M=f(n,S);if(typeof M>"u")M=k;else{let q;const V=(F,U)=>{let N;const B=()=>{q=q||(0,o.deepClone)(n),N=N||f(q,U)};return(0,D.isObject)(F)?new Proxy(F,{get:(j,z)=>{if(typeof z=="string"&&z.toLowerCase()==="tojson")return B(),()=>N;if(q)return N=N||f(q,U),N[z];const ne=j[z];return typeof z=="string"?V(ne,`${U}.${z}`):ne},set:(j,z,ne)=>(B(),N&&(N[z]=ne),!0),deleteProperty:(j,z)=>(B(),N&&delete N[z],!0),defineProperty:(j,z,ne)=>(B(),N&&Object.defineProperty(N,z,ne),!0)}):F};M=V(M,S)}return M},update:(S,k,M,q)=>{S=a?`${a}.${S}`:S;const V=r(M);return k!==void 0?this.b.$updateConfigurationOption(V,S,k,c,q):this.b.$removeConfigurationOption(V,S,c,q)},inspect:S=>{S=a?`${a}.${S}`:S;const k=this.e.inspect(S,c,this.c.workspace);if(k)return{key:S,defaultValue:(0,o.deepClone)(k.policy?.value??k.default?.value),globalValue:(0,o.deepClone)(k.user?.value??k.application?.value),workspaceValue:(0,o.deepClone)(k.workspace?.value),workspaceFolderValue:(0,o.deepClone)(k.workspaceFolder?.value),defaultLanguageValue:(0,o.deepClone)(k.default?.override),globalLanguageValue:(0,o.deepClone)(k.user?.override??k.application?.override),workspaceLanguageValue:(0,o.deepClone)(k.workspace?.override),workspaceFolderLanguageValue:(0,o.deepClone)(k.workspaceFolder?.override),languageIds:(0,o.deepClone)(k.overrideIdentifiers)}}};return typeof n=="object"&&(0,o.mixin)(m,n,!1),Object.freeze(m)}g(a){const u=l=>(0,D.isObject)(l)?new Proxy(l,{get:(c,n)=>u(c[n]),set:(c,n,r)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(n)}' of object`)},deleteProperty:(c,n)=>{throw new Error(`TypeError: Cannot delete read only property '${String(n)}' of object`)},defineProperty:(c,n)=>{throw new Error(`TypeError: Cannot define property '${String(n)}' for a readonly object`)},setPrototypeOf:c=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):l;return u(a)}h(a,u,l){const c=y.OVERRIDE_PROPERTY_REGEX.test(a)?4:this.d.get(a),n=l?`[${l.value}] `:"";if(c===4){typeof u?.resource>"u"&&this.f.warn(`${n}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${a}', provide the URI of a resource or 'null' for any resource.`);return}if(c===3){u?.resource&&this.f.warn(`${n}Accessing a window scoped configuration for a resource is not expected. To associate '${a}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(a,u){const l=new A.ConfigurationChangeEvent(a,u,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(c,n)=>l.affectsConfiguration(c,p(n))})}k(a){return a.reduce((u,l)=>(u.set(l[0],l[1]),u),new Map)}}e.ExtHostConfigProvider=i,e.IExtHostConfiguration=(0,P.createDecorator)("IExtHostConfiguration")});var Je=this&&this.__classPrivateFieldSet||function(te,e,o,t,T){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?T.call(te,o):T?T.value=o:e.set(te,o),o},Ue=this&&this.__classPrivateFieldGet||function(te,e,o,t){if(o==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?t:o==="a"?t.call(te):t?t.value:e.get(te)};define(ye[76],Ce([1,0,2,16,3,5,7,33,58,34,21,41,17,25,4,15,12,13,71,241,9]),function(te,e,o,t,T,R,I,A,y,D,L,P,v,C,E,f,d,h,b,g,p){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var i;(function(F){function U(B){if(B!=null)return B}F.from=U;function N(B){if(B!=null)return B}F.to=N})(i||(i={}));var s;(function(F){function U(B){if(B!=null)return B}F.from=U;function N(B){if(B!=null)return B}F.to=N})(s||(s={}));var a;(function(F){function U(B){if(B!=null)return B}F.from=U;function N(B){if(B!=null)return B}F.to=N})(a||(a={}));var u;(function(F){function U(j){if(j){const z=j;return z&&!!z.process}else return!1}F.is=U;function N(j){if(j==null)return;const z={process:j.process,args:j.args};return j.options&&(z.options=a.from(j.options)),z}F.from=N;function B(j){if(j!=null)return new I.ProcessExecution(j.process,j.args,j.options)}F.to=B})(u||(u={}));var l;(function(F){function U(B){if(B!=null)return B}F.from=U;function N(B){if(B!=null)return B}F.to=N})(l||(l={}));var c;(function(F){function U(j){if(j){const z=j;return z&&(!!z.commandLine||!!z.command)}else return!1}F.is=U;function N(j){if(j==null)return;const z={};return j.commandLine!==void 0?z.commandLine=j.commandLine:(z.command=j.command,z.args=j.args),j.options&&(z.options=l.from(j.options)),z}F.from=N;function B(j){if(!(j==null||j.command===void 0&&j.commandLine===void 0))return j.commandLine?new I.ShellExecution(j.commandLine,j.options):new I.ShellExecution(j.command,j.args?j.args:[],j.options)}F.to=B})(c||(c={}));var n;(function(F){function U(j){if(j){const z=j;return z&&z.customExecution==="customExecution"}else return!1}F.is=U;function N(j){return{customExecution:"customExecution"}}F.from=N;function B(j,z){return z.get(j)}F.to=B})(n=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var r;(function(F){function U(N,B){let j;return N.scope!==void 0&&typeof N.scope!="number"?j=N.scope.uri:N.scope!==void 0&&typeof N.scope=="number"&&(N.scope===I.TaskScope.Workspace&&B&&B.workspaceFile?j=B.workspaceFile:j=g.USER_TASKS_GROUP_KEY),{id:N._id,workspaceFolder:j}}F.from=U})(r=e.TaskHandleDTO||(e.TaskHandleDTO={}));var m;(function(F){function U(N){if(N!=null)return{_id:N.id,isDefault:N.isDefault}}F.from=U})(m||(m={}));var S;(function(F){function U(j,z){if(j==null)return[];const ne=[];for(const _ of j){const Y=N(_,z);Y&&ne.push(Y)}return ne}F.fromMany=U;function N(j,z){if(j==null)return;let ne;j.execution instanceof I.ProcessExecution?ne=u.from(j.execution):j.execution instanceof I.ShellExecution?ne=c.from(j.execution):j.execution&&j.execution instanceof I.CustomExecution&&(ne=n.from(j.execution));const _=i.from(j.definition);let Y;return j.scope?typeof j.scope=="number"?Y=j.scope:Y=j.scope.uri:Y=I.TaskScope.Workspace,!_||!Y?void 0:{_id:j._id,definition:_,name:j.name,source:{extensionId:z.identifier.value,label:j.source,scope:Y},execution:ne,isBackground:j.isBackground,group:m.from(j.group),presentationOptions:s.from(j.presentationOptions),problemMatchers:j.problemMatchers,hasDefinedMatchers:j.hasDefinedMatchers,runOptions:j.runOptions?j.runOptions:{reevaluateOnRerun:!0},detail:j.detail}}F.from=N;async function B(j,z,ne){if(j==null)return;let _;u.is(j.execution)?_=u.to(j.execution):c.is(j.execution)?_=c.to(j.execution):n.is(j.execution)&&(_=n.to(j._id,ne));const Y=i.to(j.definition);let J;if(j.source&&(j.source.scope!==void 0?typeof j.source.scope=="number"?J=j.source.scope:J=await z.resolveWorkspaceFolder(o.URI.revive(j.source.scope)):J=I.TaskScope.Workspace),!Y||!J)return;const Z=new I.Task(Y,J,j.name,j.source.label,_,j.problemMatchers);return j.isBackground!==void 0&&(Z.isBackground=j.isBackground),j.group!==void 0&&(Z.group=I.TaskGroup.from(j.group._id),Z.group&&j.group.isDefault&&(Z.group=new I.TaskGroup(Z.group.id,Z.group.label),j.group.isDefault===!0&&(Z.group.isDefault=j.group.isDefault))),j.presentationOptions&&(Z.presentationOptions=s.to(j.presentationOptions)),j._id&&(Z._id=j._id),j.detail&&(Z.detail=j.detail),Z}F.to=B})(S=e.TaskDTO||(e.TaskDTO={}));var k;(function(F){function U(B){return B}F.from=U;function N(B){if(!!B)return Object.assign(Object.create(null),B)}F.to=N})(k||(k={}));class M{constructor(U,N,B){this._id=N,this.a=B,w.set(this,void 0),Je(this,w,U,"f")}get task(){return this.a}terminate(){Ue(this,w,"f").terminateTask(this)}fireDidStartProcess(U){}fireDidEndProcess(U){}}w=new WeakMap;let q=class{constructor(U,N,B,j,z,ne,_,Y){this.q=new T.Emitter,this.r=new T.Emitter,this.s=new T.Emitter,this.t=new T.Emitter,this.a=U.getProxy(R.MainContext.MainThreadTask),this.b=B,this.c=j,this.d=z,this.e=ne,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=_,this.g=Y,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(U,N,B){if(!B)return new I.Disposable(()=>{});const j=this.w();return this.j.set(j,{type:N,provider:B,extension:U}),this.a.$registerTaskProvider(j,N),new I.Disposable(()=>{this.j.delete(j),this.a.$unregisterTaskProvider(j)})}registerTaskSystem(U,N){this.a.$registerTaskSystem(U,N)}fetchTasks(U){return this.a.$fetchTasks(k.from(U)).then(async N=>{const B=[];for(const j of N){const z=await S.to(j,this.b,this.m);z&&B.push(z)}return B})}get taskExecutions(){const U=[];return this.k.forEach(N=>U.push(N)),U}terminateTask(U){if(!(U instanceof M))throw new Error("No valid task execution provided");return this.a.$terminateTask(U._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(U,N,B){const j=this.m.get(U.id);j&&(this.o.set(U.id,j),this.e.attachPtyToTerminal(N,await j.callback(B))),this.p=U.id,this.q.fire({execution:await this.y(U)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(U){const N=await this.y(U);this.l.delete(U.id),this.k.delete(U.id),this.A(U),this.r.fire({execution:N})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(U){const N=await this.y(U.id);this.s.fire({execution:N,processId:U.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(U){const N=await this.y(U.id);this.t.fire({execution:N,exitCode:U.exitCode})}$provideTasks(U,N){const B=this.j.get(U);if(!B)return Promise.reject(new Error("no handler found"));const j=[],z=(0,t.asPromise)(()=>B.provider.provideTasks(L.CancellationToken.None)).then(ne=>this.u(N,j,B,ne));return new Promise(ne=>{z.then(_=>{Promise.all(j).then(()=>{ne(_)})})})}async $resolveTask(U,N){const B=this.j.get(U);if(!B)return Promise.reject(new Error("no handler found"));if(N.definition.type!==B.type)throw new Error(`Unexpected: Task of type [${N.definition.type}] cannot be resolved by provider of type [${B.type}].`);const j=await S.to(N,this.b,this.m);if(!j)throw new Error("Unexpected: Task cannot be resolved.");const z=await B.provider.resolveTask(j,L.CancellationToken.None);if(!z)return;this.z(z,B);const ne=S.from(z,B.extension);if(!ne)throw new Error("Unexpected: Task cannot be resolved.");if(z.definition!==j.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return n.is(ne.execution)&&await this.x(ne,z,!0),await this.v(ne)}w(){return this.h++}async x(U,N,B){const j=await this.a.$createTaskId(U);!B&&!this.m.has(j)&&(this.n.add(j),this.o.set(j,N.execution)),this.m.set(j,N.execution)}async y(U,N){if(typeof U=="string"){const z=this.l.get(U);if(!z)throw new p.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return z}const B=this.l.get(U.id);if(B)return B;const j=new Promise((z,ne)=>{function _(Y,J,Z){Z?z(new M(Y,J.id,Z)):ne("Unexpected: Task does not exist.")}N?_(this,U,N):S.to(U.task,this.b,this.m).then(Y=>_(this,U,Y))});return this.l.set(U.id,j),j.then(z=>(this.k.set(U.id,z),z),z=>Promise.reject(z))}z(U,N){U._deprecated&&this.g.report("Task.constructor",N.extension,"Use the Task constructor that takes a `scope` instead.")}A(U){this.o.get(U.id)&&this.o.delete(U.id),this.n.has(U.id)&&this.p!==U.id&&(this.m.delete(U.id),this.n.delete(U.id));const B=this.n.values();let j=B.next();for(;!j.done;)!this.o.has(j.value)&&this.p!==j.value&&(this.m.delete(j.value),this.n.delete(j.value)),j=B.next()}};q=qe([We(0,v.IExtHostRpcService),We(1,C.IExtHostInitDataService),We(2,A.IExtHostWorkspace),We(3,y.IExtHostDocumentsAndEditors),We(4,D.IExtHostConfiguration),We(5,P.IExtHostTerminalService),We(6,h.ILogService),We(7,b.IExtHostApiDeprecationService)],q),e.ExtHostTaskBase=q;let V=class extends q{constructor(U,N,B,j,z,ne,_,Y){super(U,N,B,j,z,ne,_,Y),this.registerTaskSystem(f.Schemas.vscodeRemote,{scheme:f.Schemas.vscodeRemote,authority:"",platform:d.PlatformToString(0)})}async executeTask(U,N){if(!N.execution)throw new Error("Tasks to execute must include an execution");const B=S.from(N,U);if(B===void 0)throw new Error("Task is not valid");if(n.is(B.execution))await this.x(B,N,!1);else throw new p.NotSupportedError;const j=await this.y(await this.a.$getTaskExecution(B),N);return this.a.$executeTask(B).catch(z=>{throw new Error(z)}),j}u(U,N,B,j){const z=[];if(j)for(const ne of j){this.z(ne,B),(!ne.definition||!U[ne.definition.type])&&this.f.warn(`The task [${ne.source}, ${ne.name}] uses an undefined task type. The task will be ignored in the future.`);const _=S.from(ne,B.extension);_&&n.is(_.execution)?(z.push(_),N.push(this.x(_,ne,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:z,extension:B.extension}}async v(U){if(n.is(U.execution))return U;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(U,N){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(U,N,B){}};V=qe([We(0,v.IExtHostRpcService),We(1,C.IExtHostInitDataService),We(2,A.IExtHostWorkspace),We(3,y.IExtHostDocumentsAndEditors),We(4,D.IExtHostConfiguration),We(5,P.IExtHostTerminalService),We(6,h.ILogService),We(7,b.IExtHostApiDeprecationService)],V),e.WorkerExtHostTask=V,e.IExtHostTask=(0,E.createDecorator)("IExtHostTask")}),define(ye[287],Ce([1,0,10,21,45,38,24,43,31]),function(te,e,o,t,T,R,I,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class D{constructor(v,C,E){this.k=v,this.l=C,this.o=E,this.e=!1,this.f=0,this.g=!1,this.a=v.filePattern,this.b=v.includePattern&&R.parse(v.includePattern),this.c=v.maxResults||void 0,this.d=v.exists,this.h=new Set,this.j=v.excludePattern&&R.parse(v.excludePattern)}cancel(){this.g=!0,this.h.forEach(v=>v.cancel()),this.h=new Set}search(v){const C=this.k.folderQueries||[];return new Promise((E,f)=>{const d=h=>{this.f++,v(h)};if(this.g)return E({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(h=>{const b=h.toString(),g=o.basename(b);this.j&&this.j(b,g)||this.v(d,{base:h,basename:g})}),Promise.all(C.map(h=>this.p(h,d))).then(h=>{E({limitHit:this.e,stats:h[0]||void 0})},h=>{f(new Error((0,T.toErrorMessage)(h)))})})}async p(v,C){const E=new t.CancellationTokenSource,f=this.q(v),d=this.r(),h=new y.QueryGlobTester(this.k,v),b=!h.hasSiblingExcludeClauses();let g;try{this.h.add(E),g=A.StopWatch.create();const p=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},f,E.token),w=g.elapsed(),i=A.StopWatch.create();return this.g&&!this.e||(p&&p.forEach(s=>{const a=o.posix.relative(v.folder.path,s.path);if(b){const u=o.basename(s.path);this.v(C,{base:v.folder,relativePath:a,basename:u});return}this.s(d,v.folder,a,C)}),this.g&&!this.e)?null:(this.u(d,h,C),{providerTime:w,postProcessTime:i.elapsed()})}finally{E.dispose(),this.h.delete(E)}}q(v){const C=(0,y.resolvePatternsForProvider)(this.k.includePattern,v.includePattern),E=(0,y.resolvePatternsForProvider)(this.k.excludePattern,v.excludePattern);return{folder:v.folder,excludes:E,includes:C,useIgnoreFiles:!v.disregardIgnoreFiles,useGlobalIgnoreFiles:!v.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!v.disregardParentIgnoreFiles,followSymlinks:!v.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const v={rootEntries:[],pathToEntries:Object.create(null)};return v.pathToEntries["."]=v.rootEntries,v}s({pathToEntries:v},C,E,f){if(E===this.a){const h=o.basename(this.a);this.v(f,{base:C,relativePath:this.a,basename:h})}function d(h){const b=o.basename(h),g=o.dirname(h);let p=v[g];p||(p=v[g]=[],d(g)),p.push({base:C,relativePath:h,basename:b})}d(E)}u({rootEntries:v,pathToEntries:C},E,f){const d=this,h=this.a;function b(g){const p=(0,y.hasSiblingFn)(()=>g.map(w=>w.basename));for(let w=0,i=g.length;w<i;w++){const s=g[w],{relativePath:a,basename:u}=s;if(E.matchesExcludesSync(a,u,h!==u?p:void 0))continue;const l=C[a];if(l)b(l);else{if(a===h)continue;d.v(f,s)}if(d.e)break}}b(v)}v(v,C){(!this.b||C.relativePath&&this.b(C.relativePath,C.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||v(C))}}class L{constructor(){this.b=new Map}fileSearch(v,C,E,f){const d=this.c(v.cacheKey),h=new D(v,C,d&&d.token);let b=0;const g=p=>{b+=p.length,E(p.map(w=>this.d(w)))};return this.e(h,L.a,g,f).then(p=>({limitHit:p.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:b,detailStats:p.stats}}))}clearCache(v){this.c(v)?.cancel()}c(v){if(!!v)return this.b.has(v)||this.b.set(v,new t.CancellationTokenSource),this.b.get(v)}d(v){return v.relativePath?{resource:I.joinPath(v.base,v.relativePath)}:{resource:v.base}}e(v,C,E,f){f.onCancellationRequested(()=>{v.cancel()});const d=b=>{b&&(h.push(b),C>0&&h.length>=C&&(E(h),h=[]))};let h=[];return v.search(d).then(b=>(h.length&&E(h),b),b=>(h.length&&E(h),Promise.reject(b)))}}e.FileSearchManager=L,L.a=512}),define(ye[288],Ce([1,0,18,81,38,112,28,15,10,24,8,11,2,165,192,52,13,47,133,286,31]),function(te,e,o,t,T,R,I,A,y,D,L,P,v,C,E,f,d,h,b,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let w=class{constructor(m,S,k,M,q){this.a=m,this.b=S,this.c=k,this.d=M,this.e=q}text(m,S,k={}){m=this.f(m,k);const M=this.a.getValue(),q=S&&S.some(F=>!this.a.getValue({resource:F}).search.useRipgrep);return{...this.h(S?.map(h.toWorkspaceFolder),k),type:2,contentPattern:m,previewOptions:k.previewOptions,maxFileSize:k.maxFileSize,usePCRE2:M.search.usePCRE2||q||!1,beforeContext:k.beforeContext,afterContext:k.afterContext,userDisabledExcludesAndIgnoreFiles:k.disregardExcludeSettings&&k.disregardIgnoreFiles}}f(m,S){const k=this.a.getValue();m.isRegExp&&(m.pattern=m.pattern.replace(/\r?\n/g,"\\n"));const M={...m,wordSeparators:k.editor.wordSeparators};return this.j(m,S)&&(M.isCaseSensitive=!0),this.k(m)&&(M.isMultiline=!0),M}file(m,S={}){return{...this.h(m,S),type:1,filePattern:S.filePattern?S.filePattern.trim():S.filePattern,exists:S.exists,sortByScore:S.sortByScore,cacheKey:S.cacheKey}}g(m,S){return m?(m=Array.isArray(m)?m.map(l):l(m),S?this.parseSearchPaths(m):{pattern:s(...Array.isArray(m)?m:[m])}):{}}h(m=[],S={}){const k=this.g(S.includePattern,S.expandPatterns),M=this.g(S.excludePattern,S.expandPatterns),q=m.length>1,V=(k.searchPaths&&k.searchPaths.length?k.searchPaths.map(N=>this.q(N,S,M)):m.map(N=>this.r(N,S,M,q))).filter(N=>!!N),F={_reason:S._reason,folderQueries:V,usingSearchPaths:!!(k.searchPaths&&k.searchPaths.length),extraFileResources:S.extraFileResources,excludePattern:M.pattern,includePattern:k.pattern,onlyOpenEditors:S.onlyOpenEditors,maxResults:S.maxResults};if(S.onlyOpenEditors){const N=o.coalesce(o.flatten(this.c.groups.map(z=>z.editors.map(ne=>ne.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(N));const B=N.filter(z=>(0,p.pathIncludedInQuery)(F,z.fsPath)),j=this.i(B);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(j)),{...F,...j}}const U=S.extraFileResources&&S.extraFileResources.filter(N=>(0,p.pathIncludedInQuery)(F,N.fsPath));return F.extraFileResources=U&&U.length?U:void 0,F}i(m){const S=[],k=new I.ResourceMap,M={};let q=!1;return m.forEach(V=>{if(V.scheme===A.Schemas.walkThrough)return;if((0,D.isAbsolutePath)(V)){const U=this.b.getWorkspaceFolder(V)?.uri??V.with({path:y.dirname(V.fsPath)});let N=k.get(U);N||(q=!0,N={folder:U,includePattern:{}},S.push(N),k.set(U,N));const B=y.relative(U.fsPath,V.fsPath);(0,P.assertIsDefined)(N.includePattern)[B.replace(/\\/g,"/")]=!0}else V.fsPath&&(q=!0,M[V.fsPath]=!0)}),{folderQueries:S,includePattern:M,usingSearchPaths:!0,excludePattern:q?void 0:{"**/*":!0}}}j(m,S){if(S.isSmartCase){if(m.isRegExp){if(L.containsUppercaseCharacter(m.pattern,!0))return!0}else if(L.containsUppercaseCharacter(m.pattern))return!0}return!!m.isCaseSensitive}k(m){return m.isMultiline||m.isRegExp&&(0,C.isMultilineRegexSource)(m.pattern)||m.pattern.indexOf(`
`)>=0?!0:!!m.isMultiline}parseSearchPaths(m){const S=j=>y.isAbsolute(j)||/^\.\.?([\/\\]|$)/.test(j),M=(Array.isArray(m)?m:a(m)).map(j=>{const z=this.e.resolvedUserHome;return z?(0,R.untildify)(j,z.scheme===A.Schemas.file?z.fsPath:z.path):j}),q=t.groupBy(M,j=>S(j)?"searchPaths":"exprSegments"),V=(q.exprSegments||[]).map(j=>L.rtrim(j,"/")).map(j=>L.rtrim(j,"\\")).map(j=>(j[0]==="."&&(j="*"+j),u(j))),F={},U=this.m(q.searchPaths||[]);U&&U.length&&(F.searchPaths=U);const N=o.flatten(V),B=s(...N);return B&&(F.pattern=B),F}l(m,S){return S.disregardExcludeSettings?void 0:(0,p.getExcludes)(m,!S.disregardSearchExcludeSettings)}m(m){if(!m||!m.length)return[];const S=m.flatMap(M=>{let{pathPortion:q,globPortion:V}=i(M);return V&&(V=c(V)),this.n(q).flatMap(U=>this.o(U,V))}),k=new Map;return S.forEach(M=>{const q=M.searchPath.toString(),V=k.get(q);V?M.pattern&&(V.pattern=V.pattern||{},V.pattern[M.pattern]=!0):k.set(q,{searchPath:M.searchPath,pattern:M.pattern?s(M.pattern):void 0})}),Array.from(k.values())}n(m){if(y.isAbsolute(m)){const S=this.b.getWorkspace().folders;return S[0]&&S[0].uri.scheme!==A.Schemas.file?[{searchPath:S[0].uri.with({path:m})}]:[{searchPath:v.URI.file(y.normalize(m))}]}if(this.b.getWorkbenchState()===2){const S=this.b.getWorkspace().folders[0].uri;if(m=l(m),m.startsWith("../")||m===".."){const M=y.posix.resolve(S.path,m);return[{searchPath:S.with({path:M})}]}const k=c(m);return[{searchPath:S,pattern:k}]}else{if(m==="./"||m===".\\")return[];{const S=m.replace(/^\.[\/\\]/,""),M=this.b.getWorkspace().folders.map(q=>{const V=S.match(new RegExp(`^${L.escapeRegExpCharacters(q.name)}(?:/(.*)|$)`));return V?{match:V,folder:q}:null}).filter(P.isDefined);if(M.length)return M.map(q=>{const V=q.match[1];return{searchPath:q.folder.uri,pattern:V&&c(V)}});{const q=m.match(/\.[\/\\](.+)[\/\\]?/),V=q?q[1]:m,F=E.localize(0,null,V);throw new Error(F)}}}}o(m,S){const k=m.pattern&&S?`${m.pattern}/${S}`:m.pattern||S,M=[{searchPath:m.searchPath,pattern:k}];return k&&!k.endsWith("**")&&M.push({searchPath:m.searchPath,pattern:k+"/**"}),M}q(m,S,k){const M=this.r((0,h.toWorkspaceFolder)(m.searchPath),S,k,!1);return M?{...M,includePattern:m.pattern}:null}r(m,S,k,M){let q;const V=v.URI.isUri(m)?m:m.uri;if(k.searchPaths){const j=k.searchPaths.filter(z=>(0,D.isEqual)(z.searchPath,V))[0];if(j&&!j.pattern)return null;j&&(q=j.pattern)}const F=this.a.getValue({resource:V}),N={...this.l(F,S)||{},...q||{}},B=v.URI.isUri(m)?(0,D.basename)(m):m.name;return{folder:V,folderName:M?B:void 0,excludePattern:Object.keys(N).length>0?N:void 0,fileEncoding:F.files&&F.files.encoding,disregardIgnoreFiles:typeof S.disregardIgnoreFiles=="boolean"?S.disregardIgnoreFiles:!F.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof S.disregardGlobalIgnoreFiles=="boolean"?S.disregardGlobalIgnoreFiles:!F.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof S.disregardParentIgnoreFiles=="boolean"?S.disregardParentIgnoreFiles:!F.search.useParentIgnoreFiles,ignoreSymlinks:typeof S.ignoreSymlinks=="boolean"?S.ignoreSymlinks:!F.search.followSymlinks}}};w=qe([We(0,f.IConfigurationService),We(1,h.IWorkspaceContextService),We(2,b.IEditorGroupsService),We(3,d.ILogService),We(4,g.IPathService)],w),e.QueryBuilder=w;function i(r){const m=r.match(/[\*\{\}\(\)\[\]\?]/);if(m){const S=m.index,k=r.substr(0,S).match(/[/|\\][^/\\]*$/);if(k){let M=r.substr(0,k.index);return M.match(/[/\\]/)||(M+="/"),{pathPortion:M,globPortion:r.substr((k.index||0)+1)}}}return{pathPortion:r}}function s(...r){return r.length?r.reduce((m,S)=>(m[S]=!0,m),Object.create(null)):void 0}function a(r){return T.splitGlobAware(r,",").map(m=>m.trim()).filter(m=>!!m.length)}function u(r){return[`**/${r}/**`,`**/${r}`].map(S=>S.replace(/\*\*\/\*\*/g,"**"))}function l(r){return r.replace(/\\/g,"/")}function c(r){return l(r).replace(/^\.\//,"").replace(/\/+$/g,"")}function n(r,m){r=o.distinct(r,M=>M.toString());const S=[],k=m.getWorkspace();return r&&r.forEach(M=>{let q;if(m.getWorkbenchState()===2)q=(0,D.relativePath)(k.folders[0].uri,M),q&&q!=="."&&(q="./"+q);else{const V=m.getWorkspaceFolder(M);if(V){const F=V.name;if(k.folders.filter(N=>N.name===F).length===1){const N=(0,D.relativePath)(V.uri,M);N===""?q=`./${V.name}`:q=`./${V.name}/${N}`}else q=M.fsPath}}q&&S.push(q)}),S}e.resolveResourcesForSearchIncludes=n}),define(ye[289],Ce([1,0,24,2,21,9,4,288,31,47]),function(te,e,o,t,T,R,I,A,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const L=7e3;function P(f,d){const h=d.activationEvents;if(!h)return Promise.resolve(void 0);const b=[],g=[];for(const u of h)if(/^workspaceContains:/.test(u)){const l=u.substr(18);l.indexOf("*")>=0||l.indexOf("?")>=0||f.forceUsingSearch?g.push(l):b.push(l)}if(b.length===0&&g.length===0)return Promise.resolve(void 0);let p;const w=new Promise((u,l)=>{p=u}),i=u=>p({activationEvent:u}),s=Promise.all(b.map(u=>v(f,u,i))).then(()=>{}),a=C(f,d.identifier,g,i);return Promise.all([s,a]).then(()=>{p(void 0)}),w}e.checkActivateWorkspaceContainsExtension=P;async function v(f,d,h){for(const b of f.folders)if(await f.exists(o.joinPath(t.URI.revive(b),d))){h(`workspaceContains:${d}`);return}}async function C(f,d,h,b){if(h.length===0)return Promise.resolve(void 0);const g=new T.CancellationTokenSource,p=f.checkExists(f.folders,h,g.token),w=setTimeout(async()=>{g.cancel(),f.logService.info(`Not activating extension '${d.value}': Timed out while searching for 'workspaceContains' pattern ${h.join(",")}`)},L);let i=!1;try{i=await p}catch(s){R.isCancellationError(s)||R.onUnexpectedError(s)}g.dispose(),clearTimeout(w),i&&b(`workspaceContains:${h.join(",")}`)}function E(f,d,h,b){const g=f.get(I.IInstantiationService),p=f.get(y.ISearchService),i=g.createInstance(A.QueryBuilder).file(d.map(s=>(0,D.toWorkspaceFolder)(t.URI.revive(s))),{_reason:"checkExists",includePattern:h,exists:!0});return p.fileSearch(i,b).then(s=>!!s.limitHit,s=>R.isCancellationError(s)?!1:Promise.reject(s))}e.checkGlobFileExists=E});var Je=this&&this.__classPrivateFieldSet||function(te,e,o,t,T){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!T)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!T:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?T.call(te,o):T?T.value=o:e.set(te,o),o},Ue=this&&this.__classPrivateFieldGet||function(te,e,o,t){if(o==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!t:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?t:o==="a"?t.call(te):t?t.value:e.get(te)};define(ye[42],Ce([1,0,176,10,77,24,16,6,64,2,13,5,34,231,98,33,27,134,9,26,22,213,7,128,4,25,73,17,89,54,41,3,289,97,215,15,96,43]),function(te,e,o,t,T,R,I,A,y,D,L,P,v,C,E,f,d,h,b,g,p,w,i,s,a,u,l,c,n,r,m,S,k,M,q,V,F,U){"use strict";var N,B,j;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,a.createDecorator)("IHostUtils");let z=class Bn extends A.Disposable{constructor(ie,X,K,he,be,Ee,Pe,Me,oe,ae,fe){super(),this.a=this.B(new S.Emitter),this.onDidChangeRemoteConnectionData=this.a.event,this.O=!1,this.c=X,this.g=K,this.f=Pe,this.j=he,this.k=be,this.l=Ee,this.m=oe,this.p=ae,this.s=fe,this.t=this.g.getProxy(P.MainContext.MainThreadWorkspace),this.u=this.g.getProxy(P.MainContext.MainThreadTelemetry),this.v=this.g.getProxy(P.MainContext.MainThreadExtensionService),this.w=new I.Barrier,this.y=new I.Barrier,this.z=new I.Barrier,this.C=new I.Barrier,this.F=new h.ExtensionDescriptionRegistry(this.f.allExtensions);const ee=(0,d.extensionIdentifiersArrayToSet)(this.f.myExtensions);this.D=new h.ExtensionDescriptionRegistry(Y(this.F,ee)),this.G=new E.ExtHostStorage(this.g,this.l),this.H=new M.ExtHostSecretState(this.g),this.I=Me,this.h=ie.createChild(new n.ServiceCollection([E.IExtHostStorage,this.G],[M.IExtHostSecretState,this.H])),this.J=this.B(new C.ExtensionsActivator(this.D,this.F,{onExtensionActivationError:(le,re,O)=>{this.v.$onExtensionActivationError(le,b.transformErrorForSerialization(re),O)},actualActivateExtension:async(le,re)=>{if(h.ExtensionDescriptionRegistry.isHostExtension(le,this.D,this.F))return await this.v.$activateExtension(le,re),new C.HostExtension;const O=this.D.getExtensionDescription(le);return this.Y(O,re)}},this.l)),this.L=null,this.M=Object.create(null),this.N=!1,this.P=this.f.remote.connectionData}getRemoteConnectionData(){return this.P}async initialize(){try{await this.nb(),this.w.open(),await this.j.waitForInitializeCall(),T.mark("code/extHost/ready"),this.y.open(),this.f.autoStart&&this.kb()}catch(ie){b.onUnexpectedError(ie)}}async Q(){this.I.onWillDeactivateAll();let ie=[];try{ie=this.D.getAllExtensionDescriptions().map(be=>be.identifier).filter(be=>this.isActivated(be)).map(be=>this.X(be))}catch{}await Promise.all(ie)}terminate(ie,X=0){if(this.O)return;this.O=!0,this.l.info(`Extension host terminating: ${ie}`),this.l.flush(),this.p.dispose(),this.J.dispose(),b.setUnexpectedErrorHandler(he=>{this.l.error(he)}),this.g.dispose();const K=this.Q();Promise.race([(0,I.timeout)(5e3),K]).finally(()=>{this.c.pid?this.l.info(`Extension host with pid ${this.c.pid} exiting with code ${X}`):this.l.info(`Extension host exiting with code ${X}`),this.l.flush(),this.l.dispose(),this.c.exit(X)})}isActivated(ie){return this.z.isOpen()?this.J.isActivated(ie):!1}async getExtension(ie){const X=await this.v.$getExtension(ie);let K;if(X?.browserNlsBundleUris){K={};for(const he of Object.keys(X.browserNlsBundleUris))K[he]=D.URI.revive(X.browserNlsBundleUris[he])}return X&&{...X,identifier:new g.ExtensionIdentifier(X.identifier.value),extensionLocation:D.URI.revive(X.extensionLocation),browserNlsBundleUris:K}}R(ie,X){return this.J.activateByEvent(ie,X)}S(ie,X){return this.J.activateById(ie,X)}activateByIdWithErrors(ie,X){return this.S(ie,X).then(()=>{const K=this.J.getActivatedExtension(ie);if(K.activationFailed)return Promise.reject(K.activationFailedError)})}getExtensionRegistry(){return this.z.wait().then(ie=>this.D)}getExtensionExports(ie){return this.z.isOpen()?this.J.getActivatedExtension(ie).exports:null}async U(ie){if(ie.scheme!==V.Schemas.file)return ie;const X=await this.c.realpath(ie.fsPath);return D.URI.file(X)}async getExtensionPathIndex(){return this.L||(this.L=this.W(this.D.getAllExtensionDescriptions()).then(ie=>new J(ie))),this.L}async W(ie){const X=y.TernarySearchTree.forUris(K=>R.extUriBiasedIgnorePathCase.ignorePathCasing(K));return await Promise.all(ie.map(async K=>{if(this.ob(K)){const he=await this.U(K.extensionLocation);X.set(he,K)}})),X}X(ie){let X=Promise.resolve(void 0);if(!this.z.isOpen()||!this.J.isActivated(ie))return X;const K=this.J.getActivatedExtension(ie);if(!K)return X;try{typeof K.module.deactivate=="function"&&(X=Promise.resolve(K.module.deactivate()).then(void 0,he=>(this.l.error(he),Promise.resolve(void 0))))}catch(he){this.l.error(`An error occurred when deactivating the extension '${ie.value}':`),this.l.error(he)}try{(0,A.dispose)(K.subscriptions)}catch(he){this.l.error(`An error occurred when deactivating the subscriptions for extension '${ie.value}':`),this.l.error(he)}return X}async Y(ie,X){return this.f.remote.isRemote?this.v.$onWillActivateExtension(ie.identifier):await this.v.$onWillActivateExtension(ie.identifier),this.ab(ie,X).then(K=>{const he=K.activationTimes;return this.v.$onDidActivateExtension(ie.identifier,he.codeLoadingTime,he.activateCallTime,he.activateResolvedTime,X),this.Z(ie,X,"success",he),K},K=>{throw this.Z(ie,X,"failure"),K})}Z(ie,X,K,he){const be=ne(ie,X);this.u.$publicLog2("extensionActivationTimes",{...be,...he||{},outcome:K})}ab(ie,X){const K=ne(ie,X);this.u.$publicLog2("activatePlugin",K);const he=this.ob(ie);if(!he)return Promise.resolve(new C.EmptyExtension(C.ExtensionActivationTimes.NONE));this.l.info(`ExtensionService#_doActivateExtension ${ie.identifier.value}, startup: ${X.startup}, activationEvent: '${X.activationEvent}'${ie.identifier.value!==X.extensionId.value?`, root cause: ${X.extensionId.value}`:""}`),this.l.flush();const be=new C.ExtensionActivationTimesBuilder(X.startup);return Promise.all([this.pb(ie,(0,R.joinPath)(ie.extensionLocation,he),be),this.bb(ie)]).then(Ee=>(T.mark(`code/extHost/willActivateExtension/${ie.identifier.value}`),Bn.cb(this.l,ie.identifier,Ee[0],Ee[1],be))).then(Ee=>(T.mark(`code/extHost/didActivateExtension/${ie.identifier.value}`),Ee))}bb(ie){const X=new w.ExtensionGlobalMemento(ie,this.G),K=new w.ExtensionMemento(ie.identifier.value,!1,this.G),he=new q.ExtensionSecrets(ie,this.H),be=ie.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,Ee=this.f.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this.l.trace(`ExtensionService#loadExtensionContext ${ie.identifier.value}`),Promise.all([X.whenReady,K.whenReady,this.I.whenReady]).then(()=>{const Pe=this;let Me,oe;const ae=(0,d.isProposedApiEnabled)(ie,"ipc")?this.f.messagePorts?.get(g.ExtensionIdentifier.toKey(ie.identifier)):void 0;return Object.freeze({globalState:X,workspaceState:K,secrets:he,subscriptions:[],get extensionUri(){return ie.extensionLocation},get extensionPath(){return ie.extensionLocation.fsPath},asAbsolutePath(fe){return t.join(ie.extensionLocation.fsPath,fe)},get storagePath(){return Pe.I.workspaceValue(ie)?.fsPath},get globalStoragePath(){return Pe.I.globalValue(ie).fsPath},get logPath(){return t.join(Pe.f.logsLocation.fsPath,ie.identifier.value)},get logUri(){return D.URI.joinPath(Pe.f.logsLocation,ie.identifier.value)},get storageUri(){return Pe.I.workspaceValue(ie)},get globalStorageUri(){return Pe.I.globalValue(ie)},get extensionMode(){return be},get extension(){return Me===void 0&&(Me=new _(Pe,ie.identifier,ie,Ee,!1)),Me},get extensionRuntime(){return(0,d.checkProposedApiEnabled)(ie,"extensionRuntime"),Pe.extensionRuntime},get environmentVariableCollection(){return Pe.p.getEnvironmentVariableCollection(ie)},get messagePassingProtocol(){if(!oe){if(!ae)return;const fe=S.Event.buffer(S.Event.fromDOMEventEmitter(ae,"message",ee=>ee.data));ae.start(),oe={onDidReceiveMessage:fe,postMessage:ae.postMessage.bind(ae)}}return oe}})})}static cb(ie,X,K,he,be){return K=K||{activate:void 0,deactivate:void 0},this.db(ie,X,K,he,be).then(Ee=>new C.ActivatedExtension(!1,null,be.build(),K,Ee,he.subscriptions))}static db(ie,X,K,he,be){if(typeof K.activate=="function")try{be.activateCallStart(),ie.trace(`ExtensionService#_callActivateOptional ${X.value}`);const Ee=typeof global=="object"?global:self,Pe=K.activate.apply(Ee,[he]);return be.activateCallStop(),be.activateResolveStart(),Promise.resolve(Pe).then(Me=>(be.activateResolveStop(),Me))}catch(Ee){return Promise.reject(Ee)}else return Promise.resolve(K)}eb(ie,X){this.S(ie.identifier,{startup:!1,extensionId:ie.identifier,activationEvent:X}).then(void 0,K=>{this.l.error(K)})}fb(){this.v.$setPerformanceMarks(T.getMarks());for(const ie of this.D.getAllExtensionDescriptions())if(ie.activationEvents)for(const X of ie.activationEvents)X==="onStartupFinished"&&this.eb(ie,X)}gb(){const ie=this.R("*",!0).then(void 0,be=>{this.l.error(be)});this.B(this.j.onDidChangeWorkspace(be=>this.hb(be.added)));const X=this.j.workspace?this.j.workspace.folders:[],K=this.hb(X),he=Promise.all([ie,K]).then(()=>{});return Promise.race([he,(0,I.timeout)(1e4)]).then(()=>{this.fb()}),he}hb(ie){return ie.length===0?Promise.resolve(void 0):Promise.all(this.D.getAllExtensionDescriptions().map(X=>this.ib(ie,X))).then(()=>{})}async ib(ie,X){if(this.isActivated(X.identifier))return;const K=!this.f.remote.isRemote&&!!this.f.remote.authority,he={logService:this.l,folders:ie.map(Ee=>Ee.uri),forceUsingSearch:K,exists:Ee=>this.c.exists(Ee.fsPath),checkExists:(Ee,Pe,Me)=>this.t.$checkExists(Ee,Pe,Me)},be=await(0,k.checkActivateWorkspaceContainsExtension)(he,X);if(!!be)return this.S(X.identifier,{startup:!0,extensionId:X.identifier,activationEvent:be.activationEvent}).then(void 0,Ee=>this.l.error(Ee))}async $extensionTestsExecute(){await this.C.wait();try{return await this.jb()}catch(ie){throw console.error(ie),ie}}async jb(){const{extensionDevelopmentLocationURI:ie,extensionTestsLocationURI:X}=this.f.environment;if(!ie||!X)throw new Error(o.localize(0,null));const K=await this.pb(null,X,new C.ExtensionActivationTimesBuilder(!1));if(!K||typeof K.run!="function")throw new Error(o.localize(1,null,X.toString()));return new Promise((he,be)=>{const Ee=(oe,ae)=>{oe?be(oe):he(typeof ae=="number"&&ae>0?1:0)},Pe=(0,R.originalFSPath)(X),Me=K.run(Pe,Ee);Me&&Me.then&&Me.then(()=>{he(0)}).catch(oe=>{be(oe instanceof Error&&oe.stack?oe.stack:String(oe))})})}kb(){if(this.N)throw new Error("Extension host is already started!");return this.N=!0,this.y.wait().then(()=>this.z.open()).then(()=>this.gb()).then(()=>{this.C.open(),this.l.info("Eager extensions activated")})}registerRemoteAuthorityResolver(ie,X){return this.M[ie]=X,(0,A.toDisposable)(()=>{delete this.M[ie]})}async lb(ie){const X=ie.indexOf("+");if(X===-1)throw new Error("Not an authority that can be resolved!");const K=ie.substr(0,X);return await this.w.wait(),await this.R(`onResolveRemoteAuthority:${K}`,!1),{authorityPrefix:K,resolver:this.M[K]}}async $resolveAuthority(ie,X){const K=U.StopWatch.create(!1),he=()=>`[resolveAuthority(${(0,s.getRemoteAuthorityPrefix)(ie)},${X})][${K.elapsed()}ms] `,be=ae=>this.l.info(`${he()}${ae}`),Ee=(ae,fe=void 0)=>this.l.error(`${he()}${ae}`,fe);be("activating resolver...");const{authorityPrefix:Pe,resolver:Me}=await this.lb(ie);if(!Me)return Ee("no resolver"),{type:"error",error:{code:s.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${Pe}.`,detail:void 0}};const oe=new I.IntervalTimer;try{be("setting tunnel factory..."),this.B(await this.m.setTunnelFactory(Me)),oe.cancelAndSet(()=>be("waiting..."),1e3),be("invoking resolve()..."),T.mark(`code/extHost/willResolveAuthority/${Pe}`);const ae=await Me.resolve(ie,{resolveAttempt:X});T.mark(`code/extHost/didResolveAuthorityOK/${Pe}`),oe.dispose(),be(`returned ${ae.host}:${ae.port}`);const fe={authority:ie,host:ae.host,port:ae.port,connectionToken:ae.connectionToken},ee={extensionHostEnv:ae.extensionHostEnv,isTrusted:ae.isTrusted,authenticationSession:ae.authenticationSessionForInitializingExtensions?{id:ae.authenticationSessionForInitializingExtensions.id,providerId:ae.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:fe,options:ee,tunnelInformation:{environmentTunnels:ae.environmentTunnels,features:ae.tunnelFeatures}}}}catch(ae){if(T.mark(`code/extHost/didResolveAuthorityError/${Pe}`),oe.dispose(),Ee("returned an error",ae),ae instanceof i.RemoteAuthorityResolverError)return{type:"error",error:{code:ae._code,message:ae._message,detail:ae._detail}};throw ae}}async $getCanonicalURI(ie,X){this.l.info(`$getCanonicalURI invoked for authority (${(0,s.getRemoteAuthorityPrefix)(ie)})`);const{resolver:K}=await this.lb(ie);if(!K)return null;const he=D.URI.revive(X);if(typeof K.getCanonicalURI>"u")return he;const be=await(0,I.asPromise)(()=>K.getCanonicalURI(he));return be||he}static mb(ie,X,K){const he=new h.ExtensionDescriptionRegistry(ie.getAllExtensionDescriptions());he.deltaExtensions(K.toAdd,K.toRemove);const be=(0,d.extensionIdentifiersArrayToSet)(X.getAllExtensionDescriptions().map(Pe=>Pe.identifier));for(const Pe of K.myToRemove)be.delete(g.ExtensionIdentifier.toKey(Pe));for(const Pe of K.myToAdd)be.add(g.ExtensionIdentifier.toKey(Pe));const Ee=Y(he,be);return{globalRegistry:he,myExtensions:Ee}}$startExtensionHost(ie){ie.toAdd.forEach(he=>he.extensionLocation=D.URI.revive(he.extensionLocation));const{globalRegistry:X,myExtensions:K}=Bn.mb(this.F,this.D,ie);return this.F.set(X.getAllExtensionDescriptions()),this.D.set(K),this.kb()}$activateByEvent(ie,X){return X===1?this.R(ie,!1):this.z.wait().then(K=>this.R(ie,!1))}async $activate(ie,X){return await this.z.wait(),this.D.getExtensionDescription(ie)?(await this.S(ie,X),!0):!1}async $deltaExtensions(ie){ie.toAdd.forEach(Ee=>Ee.extensionLocation=D.URI.revive(Ee.extensionLocation));const{globalRegistry:X,myExtensions:K}=Bn.mb(this.F,this.D,ie),he=await this.W(K);return(await this.getExtensionPathIndex()).setSearchTree(he),this.F.set(X.getAllExtensionDescriptions()),this.D.set(K),Promise.resolve(void 0)}async $test_latency(ie){return ie}async $test_up(ie){return ie.byteLength}async $test_down(ie){const X=p.VSBuffer.alloc(ie),K=Math.random()%256;for(let he=0;he<ie;he++)X.writeUInt8(K,he);return X}async $updateRemoteConnectionData(ie){this.P=ie,this.a.fire()}};z=qe([We(0,a.IInstantiationService),We(1,e.IHostUtils),We(2,c.IExtHostRpcService),We(3,f.IExtHostWorkspace),We(4,v.IExtHostConfiguration),We(5,L.ILogService),We(6,u.IExtHostInitDataService),We(7,l.IExtensionStoragePaths),We(8,r.IExtHostTunnelService),We(9,m.IExtHostTerminalService),We(10,F.IExtHostLocalizationService)],z),e.AbstractExtHostExtensionService=z;function ne(Z,ie){return{id:Z.identifier.value,name:Z.name,extensionVersion:Z.version,publisherDisplayName:Z.publisher,activationEvents:Z.activationEvents?Z.activationEvents.join(","):null,isBuiltin:Z.isBuiltin,reason:ie.activationEvent,reasonId:ie.extensionId.value}}e.IExtHostExtensionService=(0,a.createDecorator)("IExtHostExtensionService");class _{constructor(ie,X,K,he,be){N.set(this,void 0),B.set(this,void 0),j.set(this,void 0),Je(this,N,ie,"f"),Je(this,B,X,"f"),Je(this,j,K.identifier,"f"),this.id=K.identifier.value,this.extensionUri=K.extensionLocation,this.extensionPath=t.normalize((0,R.originalFSPath)(K.extensionLocation)),this.packageJSON=K,this.extensionKind=he,this.isFromDifferentExtensionHost=be}get isActive(){return Ue(this,N,"f").isActivated(Ue(this,j,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Ue(this,N,"f").getExtensionExports(Ue(this,j,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Ue(this,N,"f").activateByIdWithErrors(Ue(this,j,"f"),{startup:!1,extensionId:Ue(this,B,"f"),activationEvent:"api"}),this.exports}}e.Extension=_,N=new WeakMap,B=new WeakMap,j=new WeakMap;function Y(Z,ie){return Z.getAllExtensionDescriptions().filter(X=>ie.has(g.ExtensionIdentifier.toKey(X.identifier)))}class J{constructor(ie){this.a=ie}setSearchTree(ie){this.a=ie}findSubstr(ie){return this.a.findSubstr(ie)}forEach(ie){return this.a.forEach(ie)}}e.ExtensionPaths=J}),define(ye[290],Ce([1,0,77,2,5,34,27,26,17,25,4,42,36,13,8]),function(te,e,o,t,T,R,I,A,y,D,L,P,v,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let f=class{constructor(w,i,s,a,u,l,c){this.c=w,this.d=i,this.e=s,this.f=a,this.g=u,this.h=l,this.i=c,this.a=new Map,this.b=[]}async install(){this.j(),o.mark("code/extHost/willWaitForConfig");const w=await this.f.getConfigProvider();o.mark("code/extHost/didWaitForConfig");const i=await this.g.getExtensionPathIndex();this.register(new h(this.c,i,this.d,w,this.i)),this.register(this.e.createInstance(b,i)),this.register(this.e.createInstance(d)),this.h.remote.isRemote&&this.register(this.e.createInstance(g,i,this.h.environment.appUriScheme))}register(w){if("nodeModuleName"in w)if(Array.isArray(w.nodeModuleName))for(const i of w.nodeModuleName)this.a.set(i,w);else this.a.set(w.nodeModuleName,w);typeof w.alternativeModuleName=="function"&&this.b.push(i=>w.alternativeModuleName(i))}};f=qe([We(2,L.IInstantiationService),We(3,R.IExtHostConfiguration),We(4,P.IExtHostExtensionService),We(5,D.IExtHostInitDataService),We(6,C.ILogService)],f),e.RequireInterceptor=f;let d=class ti{constructor(w){if(w.environment.appRoot&&ti.a.size){const i=(0,E.escapeRegExpCharacters)(this.c(w.environment.appRoot.fsPath)),s="[a-z0-9_.-]",a=`@${s}+\\/${s}+|${s}+`,u="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${i}/${u}\\/)(${a})(.*)$`,"i")}}alternativeModuleName(w){if(!this.b)return;const i=this.b.exec(this.c(w));if(!i)return;const[,s,a,u]=i,l=ti.a.get(a);if(l!==void 0)return console.warn(`${a} as been renamed to ${l}, please update your imports`),s+l+u}c(w){return w.replace(/\\/g,"/")}};d.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),d=qe([We(0,D.IExtHostInitDataService)],d);class h{constructor(w,i,s,a,u){this.c=w,this.d=i,this.e=s,this.f=a,this.g=u,this.nodeModuleName="vscode",this.a=new Map}load(w,i){const s=this.d.findSubstr(i);if(s){let a=this.a.get(A.ExtensionIdentifier.toKey(s.identifier));return a||(a=this.c(s,this.e,this.f),this.a.set(A.ExtensionIdentifier.toKey(s.identifier),a)),a}if(!this.b){let a="";this.d.forEach((u,l)=>a+=`	${l} -> ${u.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${i}. These are the extension path mappings: 
${a}`),this.b=this.c(I.nullExtensionDescription,this.e,this.f)}return this.b}}let b=class{constructor(w,i,s){this.d=w,this.nodeModuleName="keytar",this.a=i.getProxy(T.MainContext.MainThreadTelemetry);const{environment:a}=s,u=i.getProxy(T.MainContext.MainThreadKeytar);if(a.appRoot){let l=a.appRoot.fsPath;v.platform==="win32"&&(l=l.replace(/\\/g,"/")),l[l.length-1]==="/"&&(l=l.substr(0,l.length-1)),this.b=new Set,this.b.add(`${l}/node_modules.asar/keytar`),this.b.add(`${l}/node_modules/keytar`)}this.c={getPassword:(l,c)=>u.$getPassword(l,c),setPassword:(l,c,n)=>u.$setPassword(l,c,n),deletePassword:(l,c)=>u.$deletePassword(l,c),findPassword:l=>u.$findPassword(l),findCredentials(l){return u.$findCredentials(l)}}}load(w,i){const s=this.d.findSubstr(i);return this.a.$publicLog2("shimming.keytar",{extension:s?.identifier.value??"unknown_extension"}),this.c}alternativeModuleName(w){const i=w.length;if(i<=7||!this.b)return;const s=i-7;if((w.charAt(s)==="/"||w.charAt(s)==="\\")&&w.endsWith("keytar")&&(w=w.replace(/\\/g,"/"),this.b.has(w)))return"keytar"}};b=qe([We(1,y.IExtHostRpcService),We(2,D.IExtHostInitDataService)],b);let g=class{constructor(w,i,s){this.e=w,this.f=i,this.nodeModuleName=["open","opn"],this.d=s.getProxy(T.MainContext.MainThreadTelemetry);const a=s.getProxy(T.MainContext.MainThreadWindow);this.c=(u,l)=>{const c=t.URI.parse(u);return l?this.g(u,l):c.scheme==="http"||c.scheme==="https"?a.$openUri(c,u,{allowTunneling:!0}):c.scheme==="mailto"||c.scheme===this.f?a.$openUri(c,u,{}):this.g(u,l)}}load(w,i,s){const a=this.e.findSubstr(i);return a&&(this.a=a.identifier.value,this.h()),this.b=s(w),this.c}g(w,i){return this.i(),this.b(w,i)}h(){!this.a||this.d.$publicLog2("shimming.open",{extension:this.a})}i(){!this.a||this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};g=qe([We(2,y.IExtHostRpcService)],g)}),define(ye[49],Ce([1,0,82,6,10,36,4,58,59,42,7,33,227,34]),function(te,e,o,t,T,R,I,A,y,D,L,P,v,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,I.createDecorator)("IExtHostVariableResolverProvider");class E extends v.AbstractVariableResolverService{constructor(h,b,g,p,w,i,s){function a(){if(g){const u=g.activeEditor();if(u)return u.document.uri;const l=p.tabGroups.all.find(c=>c.isActive)?.activeTab;if(l!==void 0){if(l.input instanceof L.TextDiffTabInput||l.input instanceof L.NotebookDiffEditorTabInput)return l.input.modified;if(l.input instanceof L.TextTabInput||l.input instanceof L.NotebookEditorTabInput||l.input instanceof L.CustomEditorTabInput)return l.input.uri}}}super({getFolderUri:u=>{const l=i.folders.filter(c=>c.name===u);if(l&&l.length>0)return l[0].uri},getWorkspaceFolderCount:()=>i.folders.length,getConfigurationValue:(u,l)=>w.getConfiguration(void 0,u).get(l),getAppRoot:()=>R.cwd(),getExecPath:()=>R.env.VSCODE_EXEC_PATH,getFilePath:()=>{const u=a();if(u)return T.normalize(u.fsPath)},getWorkspaceFolderPathForFile:()=>{if(b){const u=a();if(u){const l=b.getWorkspaceFolder(u);if(l)return T.normalize(l.uri.fsPath)}}},getSelectedText:()=>{if(g){const u=g.activeEditor();if(u&&!u.selection.isEmpty)return u.document.getText(u.selection)}},getLineNumber:()=>{if(g){const u=g.activeEditor();if(u)return String(u.selection.end.line+1)}},getExtension:u=>h.getExtension(u)},void 0,s?Promise.resolve(s):void 0,Promise.resolve(R.env))}}let f=class extends t.Disposable{constructor(h,b,g,p,w){super(),this.b=h,this.c=b,this.g=g,this.h=p,this.i=w,this.a=new o.Lazy(async()=>{const i=await this.h.getConfigProvider(),a={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async u=>{a.folders=await this.c.getWorkspaceFolders2()||[]})),new E(this.b,this.c,this.g,this.i,i,a,this.j())})}getResolver(){return this.a.getValue()}j(){}};f=qe([We(0,D.IExtHostExtensionService),We(1,P.IExtHostWorkspace),We(2,A.IExtHostDocumentsAndEditors),We(3,C.IExtHostConfiguration),We(4,y.IExtHostEditorTabs)],f),e.ExtHostVariableResolverProviderService=f}),define(ye[78],Ce([1,0,16,3,11,2,4,5,59,42,17,7,33,131,219,34,49]),function(te,e,o,t,T,R,I,A,y,D,L,P,v,C,E,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,I.createDecorator)("IExtHostDebugService");let h=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(a,u,l,c,n,r){this.D=u,this.E=l,this.F=c,this.G=n,this.H=r,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.A=new Map,this.B=new Map,this.m=new t.Emitter,this.n=new t.Emitter,this.o=new t.Emitter,this.u=new t.Emitter,this.k=a.getProxy(A.MainContext.MainThreadDebugService),this.z=new t.Emitter({onWillAddFirstListener:()=>{this.T()}}),this.v=new g(this.k),this.w=new Map,this.y=!1,this.E.getExtensionRegistry().then(m=>{m.onDidChange(S=>{this.I(m)}),this.I(m)})}asDebugSourceUri(a,u){const l=a;if(typeof l.sourceReference=="number"&&l.sourceReference>0){let c=`debug:${encodeURIComponent(l.path||"")}`,n="?";return u&&(c+=`${n}session=${encodeURIComponent(u.id)}`,n="&"),c+=`${n}ref=${l.sourceReference}`,R.URI.parse(c)}else{if(l.path)return R.URI.file(l.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}I(a){const u=[];for(const l of a.getAllExtensionDescriptions())if(l.contributes){const c=l.contributes.debuggers;if(c&&c.length>0)for(const n of c)(0,E.isDebuggerMainContribution)(n)&&u.push(n.type)}this.k.$registerDebugTypes(u)}get onDidChangeBreakpoints(){return this.z.event}get breakpoints(){this.T();const a=[];return this.w.forEach(u=>a.push(u)),a}addBreakpoints(a){this.T();const u=a.filter(n=>{const r=n.id;return this.w.has(r)?!1:(this.w.set(r,n),!0)});this.U(u,[],[]);const l=[],c=new Map;for(const n of u)if(n instanceof P.SourceBreakpoint){let r=c.get(n.location.uri.toString());r||(r={type:"sourceMulti",uri:n.location.uri,lines:[]},c.set(n.location.uri.toString(),r),l.push(r)),r.lines.push({id:n.id,enabled:n.enabled,condition:n.condition,hitCondition:n.hitCondition,logMessage:n.logMessage,line:n.location.range.start.line,character:n.location.range.start.character})}else n instanceof P.FunctionBreakpoint&&l.push({type:"function",id:n.id,enabled:n.enabled,hitCondition:n.hitCondition,logMessage:n.logMessage,condition:n.condition,functionName:n.functionName});return this.k.$registerBreakpoints(l)}removeBreakpoints(a){this.T();const u=a.filter(r=>this.w.delete(r.id));this.U([],u,[]);const l=u.filter(r=>r instanceof P.SourceBreakpoint).map(r=>r.id),c=u.filter(r=>r instanceof P.FunctionBreakpoint).map(r=>r.id),n=u.filter(r=>r instanceof P.DataBreakpoint).map(r=>r.id);return this.k.$unregisterBreakpoints(l,c,n)}startDebugging(a,u,l){return this.k.$startDebugging(a?a.uri:void 0,u,{parentSessionID:l.parentSession?l.parentSession.id:void 0,lifecycleManagedByParent:l.lifecycleManagedByParent,repl:l.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:l.noDebug,compact:l.compact,suppressSaveBeforeStart:l.suppressSaveBeforeStart,suppressDebugStatusbar:l.suppressDebugStatusbar??l.debugUI?.simple,suppressDebugToolbar:l.suppressDebugToolbar??l.debugUI?.simple,suppressDebugView:l.suppressDebugView??l.debugUI?.simple})}stopDebugging(a){return this.k.$stopDebugging(a?a.id:void 0)}registerDebugConfigurationProvider(a,u,l){if(!u)return new P.Disposable(()=>{});const c=this.d++;return this.f.push({type:a,handle:c,provider:u}),this.k.$registerDebugConfigurationProvider(a,l,!!u.provideDebugConfigurations,!!u.resolveDebugConfiguration,!!u.resolveDebugConfigurationWithSubstitutedVariables,c),new P.Disposable(()=>{this.f=this.f.filter(n=>n.provider!==u),this.k.$unregisterDebugConfigurationProvider(c)})}registerDebugAdapterDescriptorFactory(a,u,l){if(!l)return new P.Disposable(()=>{});if(!this.P(a,u))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${u}' debugger.`);if(this.M(u))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const c=this.g++;return this.h.push({type:u,handle:c,factory:l}),this.k.$registerDebugAdapterDescriptorFactory(u,c),new P.Disposable(()=>{this.h=this.h.filter(n=>n.factory!==l),this.k.$unregisterDebugAdapterDescriptorFactory(c)})}registerDebugAdapterTrackerFactory(a,u){if(!u)return new P.Disposable(()=>{});const l=this.i++;return this.j.push({type:a,handle:l,factory:u}),new P.Disposable(()=>{this.j=this.j.filter(c=>c.factory!==u)})}async $runInTerminal(a,u){return Promise.resolve(void 0)}async $substituteVariables(a,u){let l;const c=await this.W(a);return c&&(l={uri:c.uri,name:c.name,index:c.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.H.getResolver()).resolveAnyAsync(l,u)}J(a,u){if(a.type==="implementation")return new w(a.implementation)}K(){}async $startDASession(a,u){const l=this,c=await this.V(u);return this.R(this.M(c.type),c).then(n=>{if(!n)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${c.type}' (extension might have failed to activate)`);const r=this.L(n),m=this.J(r,c);if(!m)throw new Error(`Couldn't create a debug adapter for type '${c.type}'.`);const S=m;return this.A.set(a,S),this.Q(c).then(k=>(k&&this.B.set(a,k),S.onMessage(async M=>{if(M.type==="request"&&M.command==="handshake"){const q=M,V={type:"response",seq:0,command:q.command,request_seq:q.seq,success:!0};this.C||(this.C=this.K());try{if(this.C){const F=await this.C.sign(q.arguments.value);V.body={signature:F},S.sendResponse(V)}else throw new Error("no signer")}catch(F){V.success=!1,V.message=F.message,S.sendResponse(V)}}else k&&k.onDidSendMessage&&k.onDidSendMessage(M),M=(0,E.convertToVSCPaths)(M,!0),l.k.$acceptDAMessage(a,M)}),S.onError(M=>{k&&k.onError&&k.onError(M),this.k.$acceptDAError(a,M.name,M.message,M.stack)}),S.onExit(M=>{k&&k.onExit&&k.onExit((0,T.withNullAsUndefined)(M),void 0),this.k.$acceptDAExit(a,(0,T.withNullAsUndefined)(M),void 0)}),k&&k.onWillStartSession&&k.onWillStartSession(),S.startSession()))})}$sendDAMessage(a,u){u=(0,E.convertToDAPaths)(u,!1);const l=this.B.get(a);l&&l.onWillReceiveMessage&&l.onWillReceiveMessage(u),this.A.get(a)?.sendMessage(u)}$stopDASession(a){const u=this.B.get(a);this.B.delete(a),u&&u.onWillStopSession&&u.onWillStopSession();const l=this.A.get(a);return this.A.delete(a),l?l.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(a){const u=[],l=[],c=[];if(a.added)for(const n of a.added){const r=n.id;if(r&&!this.w.has(r)){let m;if(n.type==="function")m=new P.FunctionBreakpoint(n.functionName,n.enabled,n.condition,n.hitCondition,n.logMessage);else if(n.type==="data")m=new P.DataBreakpoint(n.label,n.dataId,n.canPersist,n.enabled,n.hitCondition,n.condition,n.logMessage);else{const S=R.URI.revive(n.uri);m=new P.SourceBreakpoint(new P.Location(S,new P.Position(n.line,n.character)),n.enabled,n.condition,n.hitCondition,n.logMessage)}(0,P.setBreakpointId)(m,r),this.w.set(r,m),u.push(m)}}if(a.removed)for(const n of a.removed){const r=this.w.get(n);r&&(this.w.delete(n),l.push(r))}if(a.changed){for(const n of a.changed)if(n.id){const r=this.w.get(n.id);if(r){if(r instanceof P.FunctionBreakpoint&&n.type==="function"){const m=r;m.enabled=n.enabled,m.condition=n.condition,m.hitCondition=n.hitCondition,m.logMessage=n.logMessage,m.functionName=n.functionName}else if(r instanceof P.SourceBreakpoint&&n.type==="source"){const m=r;m.enabled=n.enabled,m.condition=n.condition,m.hitCondition=n.hitCondition,m.logMessage=n.logMessage,m.location=new P.Location(R.URI.revive(n.uri),new P.Position(n.line,n.character))}c.push(r)}}}this.U(u,l,c)}$provideDebugConfigurations(a,u,l){return(0,o.asPromise)(async()=>{const c=this.O(a);if(!c)throw new Error("no DebugConfigurationProvider found");if(!c.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const n=await this.W(u);return c.provideDebugConfigurations(n,l)}).then(c=>{if(!c)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return c})}$resolveDebugConfiguration(a,u,l,c){return(0,o.asPromise)(async()=>{const n=this.O(a);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const r=await this.W(u);return n.resolveDebugConfiguration(r,l,c)})}$resolveDebugConfigurationWithSubstitutedVariables(a,u,l,c){return(0,o.asPromise)(async()=>{const n=this.O(a);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const r=await this.W(u);return n.resolveDebugConfigurationWithSubstitutedVariables(r,l,c)})}async $provideDebugAdapter(a,u){const l=this.N(a);if(!l)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const c=await this.V(u);return this.R(l,c).then(n=>{if(!n)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${c.type}'`);return this.L(n)})}async $acceptDebugSessionStarted(a){const u=await this.V(a);this.m.fire(u)}async $acceptDebugSessionTerminated(a){const u=await this.V(a);u&&(this.n.fire(u),this.l.delete(u.id))}async $acceptDebugSessionActiveChanged(a){this.q=a?await this.V(a):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(a,u){(await this.V(a))?._acceptNameChanged(u)}async $acceptDebugSessionCustomEvent(a,u){const c={session:await this.V(a),event:u.event,body:u.body};this.u.fire(c)}L(a){if(a instanceof P.DebugAdapterExecutable)return{type:"executable",command:a.command,args:a.args,options:a.options};if(a instanceof P.DebugAdapterServer)return{type:"server",port:a.port,host:a.host};if(a instanceof P.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:a.path};if(a instanceof P.DebugAdapterInlineImplementation)return{type:"implementation",implementation:a.implementation};throw new Error("convertToDto unexpected type")}M(a){const u=this.h.filter(l=>l.type===a);if(u.length>0)return u[0].factory}N(a){const u=this.h.filter(l=>l.handle===a);if(u.length>0)return u[0].factory}O(a){const u=this.f.filter(l=>l.handle===a);if(u.length>0)return u[0].provider}P(a,u){if(a.contributes){const l=a.contributes.debuggers;if(l&&l.length>0){for(const c of l)if(c.label&&c.type&&c.type===u)return!0}}return!1}Q(a){const l=a.configuration.type,c=this.j.filter(n=>n.type===l||n.type==="*").map(n=>(0,o.asPromise)(()=>n.factory.createDebugAdapterTracker(a)).then(r=>r,r=>null));return Promise.race([Promise.all(c).then(n=>{const r=n.filter(m=>!!m);if(r.length>0)return new p(r)}),new Promise(n=>setTimeout(()=>n(void 0),1e3))]).catch(n=>{})}async R(a,u){const l=u.configuration.debugServer;if(typeof l=="number")return Promise.resolve(new P.DebugAdapterServer(l));if(a){const n=await this.E.getExtensionRegistry();return(0,o.asPromise)(()=>a.createDebugAdapterDescriptor(u,this.S(u,n))).then(r=>{if(r)return r})}const c=await this.E.getExtensionRegistry();return Promise.resolve(this.S(u,c))}S(a,u){}T(){this.y||(this.y=!0,this.k.$startBreakpointEvents())}U(a,u,l){(a.length>0||u.length>0||l.length>0)&&this.z.fire(Object.freeze({added:a,removed:u,changed:l}))}async V(a){if(a)if(typeof a=="string"){const u=this.l.get(a);if(u)return u}else{let u=this.l.get(a.id);if(!u){const l=await this.W(a.folderUri),c=a.parent?this.l.get(a.parent):void 0;u=new b(this.k,a.id,a.type,a.name,l,a.configuration,c),this.l.set(u.id,u),this.k.$sessionCached(u.id)}return u}throw new Error("cannot find session")}W(a){if(a){const u=R.URI.revive(a);return this.D.resolveWorkspaceFolder(u)}return Promise.resolve(void 0)}};h=qe([We(0,L.IExtHostRpcService),We(1,v.IExtHostWorkspace),We(2,D.IExtHostExtensionService),We(3,f.IExtHostConfiguration),We(4,y.IExtHostEditorTabs),We(5,d.IExtHostVariableResolverProvider)],h),e.ExtHostDebugServiceBase=h;class b{constructor(a,u,l,c,n,r,m){this.d=a,this.f=u,this.g=l,this.h=c,this.i=n,this.j=r,this.k=m}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(a){this.h=a,this.d.$setDebugSessionName(this.f,a)}get parentSession(){return this.k}_acceptNameChanged(a){this.h=a}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(a,u){return this.d.$customDebugAdapterRequest(this.f,a,u)}getDebugProtocolBreakpoint(a){return this.d.$getDebugProtocolBreakpoint(this.f,a.id)}}e.ExtHostDebugSession=b;class g{constructor(a){this.value=Object.freeze({append(u){a.$appendDebugConsole(u)},appendLine(u){this.append(u+`
`)}})}}e.ExtHostDebugConsole=g;class p{constructor(a){this.d=a}onWillStartSession(){this.d.forEach(a=>a.onWillStartSession?a.onWillStartSession():void 0)}onWillReceiveMessage(a){this.d.forEach(u=>u.onWillReceiveMessage?u.onWillReceiveMessage(a):void 0)}onDidSendMessage(a){this.d.forEach(u=>u.onDidSendMessage?u.onDidSendMessage(a):void 0)}onWillStopSession(){this.d.forEach(a=>a.onWillStopSession?a.onWillStopSession():void 0)}onError(a){this.d.forEach(u=>u.onError?u.onError(a):void 0)}onExit(a,u){this.d.forEach(l=>l.onExit?l.onExit(a,u):void 0)}}class w extends C.AbstractDebugAdapter{constructor(a){super(),this.h=a,a.onDidSendMessage(u=>{this.acceptMessage(u)})}startSession(){return Promise.resolve(void 0)}sendMessage(a){this.h.handleMessage(a)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let i=class extends h{constructor(a,u,l,c,n,r){super(a,u,l,c,n,r)}};i=qe([We(0,L.IExtHostRpcService),We(1,v.IExtHostWorkspace),We(2,D.IExtHostExtensionService),We(3,f.IExtHostConfiguration),We(4,y.IExtHostEditorTabs),We(5,d.IExtHostVariableResolverProvider)],i),e.WorkerExtHostDebugService=i}),define(ye[291],Ce([1,0,9,77,2,5,283,13,88,89,25,199,17,55,42,95]),function(te,e,o,t,T,R,I,A,y,D,L,P,v,C,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class d{static async installEarlyHandler(g){const p=g.get(A.ILogService),i=g.get(v.IExtHostRpcService).getProxy(R.MainContext.MainThreadErrors);o.setUnexpectedErrorHandler(s=>{p.error(s);const a=o.transformErrorForSerialization(s);i.$onUnexpectedError(a)})}static async installFullHandler(g){const p=g.get(A.ILogService),w=g.get(v.IExtHostRpcService),i=g.get(E.IExtHostExtensionService),s=g.get(f.IExtHostTelemetry),a=w.getProxy(R.MainContext.MainThreadExtensionService),u=w.getProxy(R.MainContext.MainThreadErrors),l=await i.getExtensionPathIndex(),c=new WeakMap;Error.prepareStackTrace=(n,r)=>{let m="",S,k;for(const M of r)m+=`
	at ${M.toString()}`,k=M.getFileName(),!S&&k&&(S=l.findSubstr(T.URI.file(k)));return c.set(n,S?.identifier),`${n.name||"Error"}: ${n.message||""}${m}`},o.setUnexpectedErrorHandler(n=>{p.error(n);const r=o.transformErrorForSerialization(n),m=c.get(n);if(!m){u.$onUnexpectedError(r);return}a.$onExtensionRuntimeError(m,r);const S=s.onExtensionError(m,n);p.trace("forwarded error to extension?",S,m)})}}Error.stackTraceLimit=100;class h{constructor(g,p,w,i,s){this.a=w,this.b=new I.RPCProtocol(g,null,i),p=h.e(p,this.b);const a=new D.ServiceCollection(...(0,y.getSingletonServiceDescriptors)());a.set(L.IExtHostInitDataService,{_serviceBrand:void 0,...p,messagePorts:s}),a.set(v.IExtHostRpcService,new v.ExtHostRpcService(this.b)),a.set(C.IURITransformerService,new C.URITransformerService(i)),a.set(E.IHostUtils,w);const u=new P.InstantiationService(a,!0);u.invokeFunction(d.installEarlyHandler),this.d=u.invokeFunction(l=>l.get(A.ILogService)),t.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",p),this.c=u.invokeFunction(l=>l.get(E.IExtHostExtensionService)),this.c.initialize(),u.invokeFunction(d.installFullHandler)}async asBrowserUri(g){const p=this.b.getProxy(R.MainContext.MainThreadExtensionService);return T.URI.revive(await p.$asBrowserUri(g))}terminate(g){this.c.terminate(g)}static e(g,p){g.allExtensions.forEach(i=>{i.extensionLocation=T.URI.revive(p.transformIncomingURIs(i.extensionLocation));const s={};i.browserNlsBundleUris&&(Object.keys(i.browserNlsBundleUris).forEach(a=>s[a]=T.URI.revive(p.transformIncomingURIs(i.browserNlsBundleUris[a]))),i.browserNlsBundleUris=s)}),g.environment.appRoot=T.URI.revive(p.transformIncomingURIs(g.environment.appRoot));const w=g.environment.extensionDevelopmentLocationURI;return w&&(g.environment.extensionDevelopmentLocationURI=w.map(i=>T.URI.revive(p.transformIncomingURIs(i)))),g.environment.extensionTestsLocationURI=T.URI.revive(p.transformIncomingURIs(g.environment.extensionTestsLocationURI)),g.environment.globalStorageHome=T.URI.revive(p.transformIncomingURIs(g.environment.globalStorageHome)),g.environment.workspaceStorageHome=T.URI.revive(p.transformIncomingURIs(g.environment.workspaceStorageHome)),g.environment.extensionTelemetryLogResource=T.URI.revive(p.transformIncomingURIs(g.environment.extensionTelemetryLogResource)),g.nlsBaseUrl=T.URI.revive(p.transformIncomingURIs(g.nlsBaseUrl)),g.logsLocation=T.URI.revive(p.transformIncomingURIs(g.logsLocation)),g.logFile=T.URI.revive(p.transformIncomingURIs(g.logFile)),g.workspace=p.transformIncomingURIs(g.workspace),g}}e.ExtensionHostMain=h}),define(ye[292],Ce([1,0,16,12,182,198,205,78,59,42,17,41,7,49,33,220,222,34]),function(te,e,o,t,T,R,I,A,y,D,L,P,v,C,E,f,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let b=class extends A.ExtHostDebugServiceBase{constructor(s,a,u,l,c,n,r){super(s,a,u,l,n,r),this.Z=c,this.X=new w}J(s,a){switch(s.type){case"server":return new f.SocketDebugAdapter(s);case"pipeServer":return new f.NamedPipeDebugAdapter(s);case"executable":return new f.ExecutableDebugAdapter(s,a.type)}return super.J(s,a)}S(s,a){const u=f.ExecutableDebugAdapter.platformAdapterExecutable(a.getAllExtensionDescriptions(),s.type);if(u)return new v.DebugAdapterExecutable(u.command,u.args,u.options)}K(){return new I.SignService}async $runInTerminal(s,a){if(s.kind==="integrated"){this.Y||(this.Y=this.Z.onDidCloseTerminal(F=>{this.X.onTerminalClosed(F)}));const u=await this.F.getConfigProvider(),l=this.Z.getDefaultShell(!0),c=this.Z.getDefaultShellArgs(!0),n=s.title||T.localize(0,null),r=JSON.stringify({shell:l,shellArgs:c});let m=await this.X.checkout(r,n),S,k=!1;if(m)S=s.cwd;else{const F={shellPath:l,shellArgs:c,cwd:s.cwd,name:n,iconPath:new v.ThemeIcon("debug")};k=!0,m=this.Z.createTerminalFromOptions(F,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.X.insert(m,r)}m.show(!0);const M=await m.processId;k?await new Promise(F=>setTimeout(F,1e3)):u.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(l.indexOf("powershell")>=0||l.indexOf("pwsh")>=0||l.indexOf("cmd.exe")>=0?m.sendText("cls"):l.indexOf("bash")>=0?m.sendText("clear"):t.isWindows?m.sendText("cls"):m.sendText("clear"));const q=(0,d.prepareCommand)(l,s.args,!!s.argsCanBeInterpretedByShell,S,s.env);m.sendText(q);const V=this.onDidTerminateDebugSession(F=>{F.id===a&&(this.X.free(m),V.dispose())});return M}else if(s.kind==="external")return p(s,await this.F.getConfigProvider());return super.$runInTerminal(s,a)}};b=qe([We(0,L.IExtHostRpcService),We(1,E.IExtHostWorkspace),We(2,D.IExtHostExtensionService),We(3,h.IExtHostConfiguration),We(4,P.IExtHostTerminalService),We(5,y.IExtHostEditorTabs),We(6,C.IExtHostVariableResolverProvider)],b),e.ExtHostDebugService=b;let g;function p(i,s){if(!g)if(t.isWindows)g=new R.WindowsExternalTerminalService;else if(t.isMacintosh)g=new R.MacExternalTerminalService;else if(t.isLinux)g=new R.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const a=s.getConfiguration("terminal");return g.runInTerminal(i.title,i.cwd,i.args,i.env||{},a.external||{})}class w{constructor(){this.b=new Map}async checkout(s,a){const l=[...this.b.entries()].map(([c,n])=>(0,o.createCancelablePromise)(async r=>{if(c.name!==a||n.lastUsedAt!==-1&&await(0,d.hasChildProcesses)(await c.processId))return null;const m=Date.now();return n.lastUsedAt+w.a>m||r.isCancellationRequested||n.config!==s?null:(n.lastUsedAt=m,c)}));return await(0,o.firstParallel)(l,c=>!!c)}insert(s,a){this.b.set(s,{lastUsedAt:Date.now(),config:a})}free(s){const a=this.b.get(s);a&&(a.lastUsedAt=-1)}onTerminalClosed(s){this.b.delete(s)}}w.a=1e3}),define(ye[293],Ce([1,0,10,2,115,33,58,34,47,41,17,25,76,15,13,71,24,87,49]),function(te,e,o,t,T,R,I,A,y,D,L,P,v,C,E,f,d,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let g=class extends v.ExtHostTaskBase{constructor(w,i,s,a,u,l,c,n,r){super(w,i,s,a,u,l,c,n),this.B=s,this.C=r,i.remote.isRemote&&i.remote.authority?this.registerTaskSystem(C.Schemas.vscodeRemote,{scheme:C.Schemas.vscodeRemote,authority:i.remote.authority,platform:process.platform}):this.registerTaskSystem(C.Schemas.file,{scheme:C.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(w,i){const s=i;if(!i.execution&&s._id===void 0)throw new Error("Tasks to execute must include an execution");if(s._id!==void 0){const a=v.TaskHandleDTO.from(s,this.B),u=await this.a.$getTaskExecution(a);if(u.task===void 0)throw new Error("Task from execution DTO is undefined");const l=await this.y(u,i);return this.a.$executeTask(a).catch(()=>{}),l}else{const a=v.TaskDTO.from(i,w);if(a===void 0)return Promise.reject(new Error("Task is not valid"));v.CustomExecutionDTO.is(a.execution)&&await this.x(a,i,!1);const u=await this.y(await this.a.$getTaskExecution(a),i);return this.a.$executeTask(a).catch(()=>{}),u}}u(w,i,s,a){const u=[];if(a)for(const l of a){this.z(l,s),(!l.definition||!w[l.definition.type])&&this.f.warn(`The task [${l.source}, ${l.name}] uses an undefined task type. The task will be ignored in the future.`);const c=v.TaskDTO.from(l,s.extension);c&&(u.push(c),v.CustomExecutionDTO.is(c.execution)&&i.push(this.x(c,l,!0)))}return{tasks:u,extension:s.extension}}async v(w){return w}async F(w){let i=w&&w.length>0?w[0]:void 0;if(!i){const s=t.URI.file((0,h.homedir)());i=new y.WorkspaceFolder({uri:s,name:d.basename(s),index:0})}return{uri:i.uri,name:i.name,index:i.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(w,i){const s=t.URI.revive(w),a={process:void 0,variables:Object.create(null)},u=await this.b.resolveWorkspaceFolder(s),l=await this.b.getWorkspaceFolders2()??[],c=await this.C.getResolver(),n=u?{uri:u.uri,name:u.name,index:u.index,toResource:()=>{throw new Error("Not implemented")}}:await this.F(l);for(const r of i.variables)a.variables[r]=await c.resolveAsync(n,r);if(i.process!==void 0){let r;if(i.process.path!==void 0){r=i.process.path.split(o.delimiter);for(let m=0;m<r.length;m++)r[m]=await c.resolveAsync(n,r[m])}a.process=await T.win32.findExecutable(await c.resolveAsync(n,i.process.name),i.process.cwd!==void 0?await c.resolveAsync(n,i.process.cwd):void 0,r)}return a}async $jsonTasksSupported(){return!0}async $findExecutable(w,i,s){return T.win32.findExecutable(w,i,s)}};g=qe([We(0,L.IExtHostRpcService),We(1,P.IExtHostInitDataService),We(2,R.IExtHostWorkspace),We(3,I.IExtHostDocumentsAndEditors),We(4,A.IExtHostConfiguration),We(5,D.IExtHostTerminalService),We(6,E.ILogService),We(7,f.IExtHostApiDeprecationService),We(8,b.IExtHostVariableResolverProvider)],g),e.ExtHostTask=g}),define(ye[294],Ce([1,0,87,49]),function(te,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class T extends t.ExtHostVariableResolverProviderService{j(){return(0,o.homedir)()}}e.NodeExtHostVariableResolverProviderService=T}),define(ye[143],Ce([1,0,18,16,21,45,15,10,24,2,31]),function(te,e,o,t,T,R,I,A,y,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class P{constructor(b,g,p,w){this.d=b,this.e=g,this.f=p,this.g=w,this.a=null,this.b=!1,this.c=0}search(b,g){const p=this.d.folderQueries||[],w=new T.CancellationTokenSource;return g.onCancellationRequested(()=>w.cancel()),new Promise((i,s)=>{this.a=new C(b);let a=!1;const u=(l,c)=>{if(!a&&!this.b){const n=this.h(l);f(l)&&typeof this.d.maxResults=="number"&&this.c+n>this.d.maxResults&&(this.b=!0,a=!0,w.cancel(),l=this.j(l,this.d.maxResults-this.c));const r=this.h(l);this.c+=r,(r>0||!f(l))&&this.a.add(l,c)}};Promise.all(p.map((l,c)=>this.k(l,n=>u(n,c),w.token))).then(l=>{w.dispose(),this.a.flush();const c=l.some(n=>!!n&&!!n.limitHit);i({limitHit:this.b||c,messages:(0,o.flatten)(l.map(n=>n?.message?Array.isArray(n.message)?n.message:[n.message]:[])),stats:{type:this.g}})},l=>{w.dispose();const c=(0,R.toErrorMessage)(l);s(new Error(c))})})}h(b){return f(b)?Array.isArray(b.ranges)?b.ranges.length:1:0}j(b,g){const p=Array.isArray(b.ranges)?b.ranges:[b.ranges],w=Array.isArray(b.preview.matches)?b.preview.matches:[b.preview.matches];return{ranges:p.slice(0,g),preview:{matches:w.slice(0,g),text:b.preview.text},uri:b.uri}}async k(b,g,p){const w=new L.QueryGlobTester(this.d,b),i=[],s={report:l=>{if(!this.l(l))return;const c=b.folder.scheme===I.Schemas.file?(0,L.hasSiblingPromiseFn)(()=>this.f.readdir(y.dirname(l.uri))):void 0,n=y.relativePath(b.folder,l.uri);if(n){const r=w.includedInQuery(n,A.basename(n),c);(0,t.isThenable)(r)?i.push(r.then(m=>{m&&g(l)})):r&&g(l)}}},a=this.n(b),u=await this.e.provideTextSearchResults(v(this.d.contentPattern),a,s,p);return i.length&&await Promise.all(i),u}l(b){if(f(b)){if(Array.isArray(b.ranges)){if(!Array.isArray(b.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(b.preview.matches.length!==b.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(b.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(b){const g=(0,L.resolvePatternsForProvider)(this.d.includePattern,b.includePattern),p=(0,L.resolvePatternsForProvider)(this.d.excludePattern,b.excludePattern),w={folder:D.URI.from(b.folder),excludes:p,includes:g,useIgnoreFiles:!b.disregardIgnoreFiles,useGlobalIgnoreFiles:!b.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!b.disregardParentIgnoreFiles,followSymlinks:!b.ignoreSymlinks,encoding:b.fileEncoding&&this.f.toCanonicalName(b.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return w.usePCRE2=this.d.usePCRE2,w}}e.TextSearchManager=P;function v(h){return{isCaseSensitive:h.isCaseSensitive||!1,isRegExp:h.isRegExp||!1,isWordMatch:h.isWordMatch||!1,isMultiline:h.isMultiline||!1,pattern:h.pattern}}class C{constructor(b){this.e=b,this.b=-1,this.d=null,this.a=new d(512,g=>this.g(g))}add(b,g){this.d&&(this.b!==g||!y.isEqual(this.c,b.uri))&&(this.f(),this.d=null),this.d||(this.b=g,this.d={resource:b.uri,results:[]}),this.d.results.push(E(b))}f(){const b=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,b)}flush(){this.f(),this.a.flush()}g(b){this.e(b)}}e.TextSearchResultsCollector=C;function E(h){return f(h)?{preview:{matches:(0,o.mapArrayOrNot)(h.preview.matches,b=>({startLineNumber:b.start.line,startColumn:b.start.character,endLineNumber:b.end.line,endColumn:b.end.character})),text:h.preview.text},ranges:(0,o.mapArrayOrNot)(h.ranges,b=>({startLineNumber:b.start.line,startColumn:b.start.character,endLineNumber:b.end.line,endColumn:b.end.character}))}:{text:h.text,lineNumber:h.lineNumber}}function f(h){return!!h.preview}e.extensionResultIsMatch=f;class d{constructor(b,g){this.g=b,this.h=g,this.c=0,this.d=[],this.e=0}addItem(b,g){!b||this.j(b,g)}addItems(b,g){!b||this.k(b,g)}j(b,g){this.d.push(b),this.e+=g,this.l()}k(b,g){this.d=this.d.concat(b),this.e+=g,this.l()}l(){this.c<d.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},d.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.BatchedCollector=d,d.a=4e3,d.b=50}),define(ye[79],Ce([1,0,6,5,4,287,17,55,13,2,143]),function(te,e,o,t,T,R,I,A,y,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,T.createDecorator)("IExtHostSearch");let P=class{constructor(f,d,h){this.k=f,this.l=d,this.n=h,this.c=this.k.getProxy(t.MainContext.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new R.FileSearchManager}o(f){return this.l.transformOutgoingScheme(f)}registerTextSearchProvider(f,d){if(this.g.has(f))throw new Error(`a text search provider for the scheme '${f}' is already registered`);this.g.add(f);const h=this.d++;return this.e.set(h,d),this.c.$registerTextSearchProvider(h,this.o(f)),(0,o.toDisposable)(()=>{this.g.delete(f),this.e.delete(h),this.c.$unregisterProvider(h)})}registerFileSearchProvider(f,d){if(this.i.has(f))throw new Error(`a file search provider for the scheme '${f}' is already registered`);this.i.add(f);const h=this.d++;return this.h.set(h,d),this.c.$registerFileSearchProvider(h,this.o(f)),(0,o.toDisposable)(()=>{this.i.delete(f),this.h.delete(h),this.c.$unregisterProvider(h)})}$provideFileSearchResults(f,d,h,b){const g=v(h),p=this.h.get(f);if(p)return this.j.fileSearch(g,p,w=>{this.c.$handleFileMatch(f,d,w.map(i=>i.resource))},b);throw new Error("unknown provider: "+f)}$clearCache(f){return this.j.clearCache(f),Promise.resolve(void 0)}$provideTextSearchResults(f,d,h,b){const g=this.e.get(f);if(!g||!g.provideTextSearchResults)throw new Error(`Unknown provider ${f}`);const p=v(h);return this.q(p,g).search(i=>this.c.$handleTextMatch(f,d,i),b)}$enableExtensionHostSearch(){}q(f,d){return new L.TextSearchManager(f,d,{readdir:h=>Promise.resolve([]),toCanonicalName:h=>h},"textSearchProvider")}};P=qe([We(0,I.IExtHostRpcService),We(1,A.IURITransformerService),We(2,y.ILogService)],P),e.ExtHostSearch=P;function v(E){return{...E,folderQueries:E.folderQueries&&E.folderQueries.map(C),extraFileResources:E.extraFileResources&&E.extraFileResources.map(f=>D.URI.revive(f))}}e.reviveQuery=v;function C(E){return{...E,folder:D.URI.revive(E.folder)}}}),define(ye[295],Ce([1,0,88,142,33,139,34,40,58,41,76,78,79,98,54,71,141,72,48,97,95,59,140,13,232,49,96]),function(te,e,o,t,T,R,I,A,y,D,L,P,v,C,E,f,d,h,b,g,p,w,i,s,a,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,o.registerSingleton)(l.IExtHostLocalizationService,l.ExtHostLocalizationService,1),(0,o.registerSingleton)(s.ILoggerService,i.ExtHostLoggerService,1),(0,o.registerSingleton)(s.ILogService,a.ExtHostLogService,1),(0,o.registerSingleton)(f.IExtHostApiDeprecationService,f.ExtHostApiDeprecationService,1),(0,o.registerSingleton)(A.IExtHostCommands,A.ExtHostCommands,0),(0,o.registerSingleton)(I.IExtHostConfiguration,I.ExtHostConfiguration,0),(0,o.registerSingleton)(h.IExtHostConsumerFileSystem,h.ExtHostConsumerFileSystem,0),(0,o.registerSingleton)(P.IExtHostDebugService,P.WorkerExtHostDebugService,0),(0,o.registerSingleton)(R.IExtHostDecorations,R.ExtHostDecorations,0),(0,o.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors,0),(0,o.registerSingleton)(b.IExtHostFileSystemInfo,b.ExtHostFileSystemInfo,0),(0,o.registerSingleton)(t.IExtHostOutputService,t.ExtHostOutputService,1),(0,o.registerSingleton)(v.IExtHostSearch,v.ExtHostSearch,0),(0,o.registerSingleton)(C.IExtHostStorage,C.ExtHostStorage,0),(0,o.registerSingleton)(L.IExtHostTask,L.WorkerExtHostTask,0),(0,o.registerSingleton)(D.IExtHostTerminalService,D.WorkerExtHostTerminalService,0),(0,o.registerSingleton)(E.IExtHostTunnelService,E.ExtHostTunnelService,0),(0,o.registerSingleton)(d.IExtHostWindow,d.ExtHostWindow,0),(0,o.registerSingleton)(T.IExtHostWorkspace,T.ExtHostWorkspace,0),(0,o.registerSingleton)(g.IExtHostSecretState,g.ExtHostSecretState,0),(0,o.registerSingleton)(p.IExtHostTelemetry,p.ExtHostTelemetry,0),(0,o.registerSingleton)(w.IExtHostEditorTabs,w.ExtHostEditorTabs,0),(0,o.registerSingleton)(u.IExtHostVariableResolverProvider,u.ExtHostVariableResolverProviderService,0)}),define(ye[99],Ce([1,0,18,13,31,75]),function(te,e,o,t,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function I(P){return P.startsWith("**")||P.startsWith("/")?P:`/${P}`}e.anchorGlob=I;function A(P,v,C,E){const f=(0,o.mapArrayOrNot)(C,y),d=new T.TextSearchMatch(v,f,E),h=d.preview.matches;return{ranges:(0,o.mapArrayOrNot)(f,D),uri:P,preview:{text:d.preview.text,matches:(0,o.mapArrayOrNot)(h,D)}}}e.createTextSearchResult=A;function y(P){return new T.SearchRange(P.start.line,P.start.character,P.end.line,P.end.character)}function D(P){return new R.Range(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn)}let L=class{constructor(v,C){this.a=v,this.b=C}appendLine(v){this.b.debug(`${this.a}#search`,v)}};L=qe([We(1,t.ILogService)],L),e.OutputChannel=L}),define(ye[296],Ce([1,0,46,10,83,32,12,8,99,297]),function(te,e,o,t,T,R,I,A,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.spawnRipgrepCmd=void 0;const L=D.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function P(g,p,w,i){const s=v(g,p,w,i),a=p.folder.fsPath;return{cmd:o.spawn(L,s.args,{cwd:a}),rgDiskPath:L,siblingClauses:s.siblingClauses,rgArgs:s,cwd:a}}e.spawnRipgrepCmd=P;function v(g,p,w,i){const s=["--files","--hidden","--case-sensitive"];E([p],w,!1).forEach(u=>{const l=(0,y.anchorGlob)(u);if(s.push("-g",l),I.isMacintosh){const c=(0,T.normalizeNFD)(l);c!==l&&s.push("-g",c)}});const a=C([p],i,void 0,!1);return a.globArgs.forEach(u=>{const l=`!${(0,y.anchorGlob)(u)}`;if(s.push("-g",l),I.isMacintosh){const c=(0,T.normalizeNFD)(l);c!==l&&s.push("-g",c)}}),p.disregardIgnoreFiles!==!1?s.push("--no-ignore"):p.disregardParentIgnoreFiles!==!1&&s.push("--no-ignore-parent"),p.ignoreSymlinks||s.push("--follow"),g.exists&&s.push("--quiet"),s.push("--no-config"),p.disregardGlobalIgnoreFiles&&s.push("--no-ignore-global"),{args:s,siblingClauses:a.siblingClauses}}function C(g,p,w,i=!0){const s=[];let a={};return g.forEach(u=>{const l=Object.assign({},u.excludePattern||{},p||{}),c=f(l,i?u.folder.fsPath:void 0,w);s.push(...c.globArgs),c.siblingClauses&&(a=Object.assign(a,c.siblingClauses))}),{globArgs:s,siblingClauses:a}}function E(g,p,w=!0){const i=[];return g.forEach(s=>{const a=Object.assign({},p||{},s.includePattern||{}),u=f(a,w?s.folder.fsPath:void 0);i.push(...u.globArgs)}),i}function f(g,p,w){const i=[],s={};return Object.keys(g).forEach(a=>{if(w&&w.has(a)||!a)return;const u=g[a];a=h(p?d(p,a):a),a.startsWith("\\\\")?a="\\\\"+a.substr(2).replace(/\\/g,"/"):a=a.replace(/\\/g,"/"),typeof u=="boolean"&&u?(a.startsWith("\\\\")&&(a+="**"),i.push(b(a))):u&&u.when&&(s[a]=u)}),{globArgs:i,siblingClauses:s}}function d(g,p){return t.isAbsolute(p)?p:t.join(g,p)}e.getAbsoluteGlob=d;function h(g){return g=A.rtrim(g,"\\"),A.rtrim(g,"/")}function b(g){return R.getRoot(g).toLowerCase()==="c:/"?g.replace(/^c:[/\\]/i,"/"):g}e.fixDriveC=b}),define(ye[298],Ce([1,0,46,65,10,299,18,45,38,83,32,12,43,8,11,29,31,296,110]),function(te,e,o,t,T,R,I,A,y,D,L,P,v,C,E,f,d,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Engine=e.FileWalker=void 0;const g=new Set;process.on("exit",()=>{g.forEach(a=>a())});class p{constructor(u){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=u,this.b=u.filePattern||"",this.d=u.includePattern&&y.parse(u.includePattern),this.f=u.maxResults||null,this.g=!!u.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,b.prepareQuery)(this.b).normalizedLowercase),this.u=u.excludePattern&&y.parse(u.excludePattern),this.t=new Map,u.folderQueries.forEach(l=>{const c=Object.assign({},l.excludePattern||{},this.a.excludePattern||{}),n=l.folder.fsPath;u.folderQueries.map(r=>r.folder.fsPath).filter(r=>r!==n).forEach(r=>{(0,L.isEqualOrParent)(r,n)&&(c[T.relative(n,r)]=!0)}),this.t.set(n,new i(c,n))})}cancel(){this.l=!0,g.forEach(u=>u())}walk(u,l,c,n,r){if(this.m=v.StopWatch.create(!1),this.l)return r(null,this.j);l.forEach(m=>{const S=T.basename(m.fsPath);this.u&&this.u(m.fsPath,S)||this.J(c,{relativePath:m.fsPath,searchPath:void 0})}),this.r=v.StopWatch.create(!1),this.w(u,(m,S)=>{this.x(this.y,this,m,c,n,k=>{if(k){const M=(0,A.toErrorMessage)(k);console.error(M),this.q.push(M),S(k,void 0)}else S(null,void 0)})},(m,S)=>{this.m.stop();const k=m?I.coalesce(m)[0]:null;r(k,this.j)})}w(u,l,c){const n=new Array(u.length),r=new Array(u.length);let m=!1,S=0;if(u.length===0)return c(null,[]);u.forEach((k,M)=>{l(k,(q,V)=>{if(q?(m=!0,n[M]=null,r[M]=q):(n[M]=V,r[M]=null),++S===u.length)return c(m?r:null,n)})})}x(u,l,...c){try{u.apply(l,c)}catch(n){c[c.length-1](n)}}y(u,l,c,n){const r=u.folder.fsPath,m=P.isMacintosh,S=()=>F&&F.kill();g.add(S);let k=j=>{g.delete(S),k=()=>{},n(j)},M="";const q=this.D(),V=(0,h.spawnRipgrepCmd)(this.a,u,this.a.includePattern,this.t.get(u.folder.fsPath).expression),F=V.cmd,U=!Object.keys(V.siblingClauses).length,N=V.rgArgs.args.map(j=>j.match(/^-/)?j:`'${j}'`).join(" ");let B=`${V.rgDiskPath} ${N}
 - cwd: ${V.cwd}`;V.rgArgs.siblingClauses&&(B+=`
 - Sibling clauses: ${JSON.stringify(V.rgArgs.siblingClauses)}`),c({message:B}),this.s=0,this.z(F,"utf8",c,(j,z,ne)=>{if(j){k(j);return}if(this.j){k();return}const Y=(M+(m?D.normalizeNFC(z||""):z)).split(`
`);if(ne){const J=Y.length;Y[J-1]=Y[J-1].trim(),Y[J-1]||Y.pop()}else M=Y.pop()||"";if(Y.length&&Y[0].indexOf(`
`)!==-1){k(new Error("Splitting up files failed"));return}if(this.s+=Y.length,U){for(const J of Y)if(this.J(l,{base:r,relativePath:J,searchPath:this.N(u,J)}),this.j){S();break}(ne||this.j)&&k();return}this.G(u,q,r,Y,l),ne&&(this.H(q,r,l),k())})}spawnFindCmd(u){const l=this.t.get(u.folder.fsPath),c=l.getBasenameTerms(),n=l.getPathTerms(),r=["-L","."];if(c.length||n.length){r.push("-not","(","(");for(const m of c)r.push("-name",m),r.push("-o");for(const m of n)r.push("-path",m),r.push("-o");r.pop(),r.push(")","-prune",")")}return r.push("-type","f"),o.spawn("find",r,{cwd:u.folder.fsPath})}readStdout(u,l,c){let n="";this.z(u,l,()=>{},(r,m,S)=>{if(r){c(r);return}n+=m,S&&c(null,n)})}z(u,l,c,n){let r=(k,M,q)=>{(k||q)&&(r=()=>{},this.r?.stop()),n(k,M,q)},m=!1;u.stdout?(this.A(u.stdout,l,r),u.stdout.once("data",()=>m=!0)):c({message:"stdout is null"});let S;u.stderr?S=this.B(u.stderr):c({message:"stderr is null"}),u.on("error",k=>{r(k)}),u.on("close",k=>{let M;!m&&(M=this.C(S,l))&&s(M)?r(new Error(`command failed with error code ${k}: ${this.C(S,l)}`)):(this.g&&k===0&&(this.j=!0),r(null,"",!0))})}A(u,l,c){const n=new R.StringDecoder(l);return u.on("data",r=>{c(null,n.write(r))}),n}B(u){const l=[];return u.on("data",c=>{l.push(c)}),l}C(u,l){const c=new R.StringDecoder(l);return u.map(n=>c.write(n)).join("")}D(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}G(u,{pathToEntries:l},c,n,r){n.indexOf(this.b)!==-1&&this.J(r,{base:c,relativePath:this.b,searchPath:this.N(u,this.b)});const m=S=>{const k=T.basename(S),M=T.dirname(S);let q=l[M];q||(q=l[M]=[],m(M)),q.push({base:c,relativePath:S,basename:k,searchPath:this.N(u,S)})};n.forEach(m)}H({rootEntries:u,pathToEntries:l},c,n){const r=this,m=this.t.get(c),S=this.b;function k(M){r.o++;const q=(0,d.hasSiblingFn)(()=>M.map(V=>V.basename));for(let V=0,F=M.length;V<F;V++){const U=M[V],{relativePath:N,basename:B}=U;if(m.test(N,B,S!==B?q:void 0))continue;const j=l[N];if(j)k(j);else{if(r.p++,N===S)continue;r.J(n,U)}if(r.j)break}}k(u)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(u,l,c,n,r){const m=u.folder,S=(0,d.hasSiblingFn)(()=>c);this.w(c,(k,M)=>{if(this.l||this.j)return M(null);const q=l?[l,k].join(T.sep):k;if(this.t.get(u.folder.fsPath).test(q,k,this.a.filePattern!==k?S:void 0))return M(null);const V=[m.fsPath,q].join(T.sep);t.lstat(V,(F,U)=>{if(F||this.l||this.j)return M(null);this.L(V,U,(N,B)=>N||this.l||this.j?M(null):B.isDirectory()?(this.o++,this.M(V,U,(j,z)=>j||this.l||this.j||(z=z||"",this.v[z])?M(null):(this.v[z]=!0,f.Promises.readdir(V).then(ne=>{if(this.l||this.j)return M(null);this.I(u,q,ne,n,_=>M(_||null))},ne=>{M(null)})))):(this.p++,q===this.b||this.h&&E.isNumber(B.size)&&B.size>this.h||this.J(n,{base:m.fsPath,relativePath:q,searchPath:this.N(u,q)}),M(null,void 0)))})},k=>{const M=k&&I.coalesce(k);return r(M&&M.length>0?M[0]:void 0)})}J(u,l){this.K(l)&&(!this.d||this.d(l.relativePath,T.basename(l.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||u(l))}K(u){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,d.isFilePatternMatch)(u,this.c)}return!0}L(u,l,c){return l.isSymbolicLink()?t.stat(u,c):c(null,l)}M(u,l,c){return l.isSymbolicLink()?t.realpath(u,(n,r)=>n?c(n):c(null,r)):c(null,u)}N(u,l){return u.folderName?T.join(u.folderName,l):l}}e.FileWalker=p;class w{constructor(u){this.a=u.folderQueries,this.b=u.extraFileResources||[],this.c=new p(u)}search(u,l,c){this.c.walk(this.a,this.b,u,l,(n,r)=>{c(n,{limitHit:r,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.Engine=w;class i{constructor(u,l){this.expression=u,this.c=l,this.d(u)}d(u){let l,c;Object.keys(u).filter(n=>u[n]).forEach(n=>{T.isAbsolute(n)?(l=l||y.getEmptyExpression(),l[n]=u[n]):(c=c||y.getEmptyExpression(),c[n]=u[n])}),this.a=l&&y.parse(l,{trimForExclusions:!0}),this.b=c&&y.parse(c,{trimForExclusions:!0})}test(u,l,c){return this.b&&this.b(u,l,c)||this.a&&this.a(T.join(this.c,u),l,c)}getBasenameTerms(){const u=[];return this.a&&u.push(...y.getBasenameTerms(this.a)),this.b&&u.push(...y.getBasenameTerms(this.b)),u}getPathTerms(){const u=[];return this.a&&u.push(...y.getPathTerms(this.a)),this.b&&u.push(...y.getPathTerms(this.b)),u}}function s(a){const u=a.trim().split(`
`),l=u[0].trim();if(l.startsWith("Error parsing regex"))return l;if(l.startsWith("regex parse error"))return C.uppercaseFirstLetter(u[u.length-1].trim());if(l.startsWith("error parsing glob")||l.startsWith("unsupported encoding"))return l.charAt(0).toUpperCase()+l.substr(1);if(l==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(l.startsWith("Literal "))return l}}),define(ye[300],Ce([1,0,102,22]),function(te,e,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function T(a){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(u=>u===a)}e.isUTFEncoding=T,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const R=512,I=512,A=512*8,y=512*128;var D;(function(a){a[a.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(D=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class L extends Error{constructor(u,l){super(u),this.decodeStreamErrorKind=l}}e.DecodeStreamError=L;class P{static async create(u){let l;if(u!==e.UTF8)l=(await new Promise((n,r)=>{te(["@vscode/iconv-lite-umd"],n,r)})).getDecoder(f(u));else{const c=new TextDecoder;l={write(n){return c.decode(n,{stream:!0})},end(){return c.decode()}}}return new P(l)}constructor(u){this.a=u}write(u){return this.a.write(u)}end(){return this.a.end()}}function v(a,u){const l=u.minBytesRequiredForDetection??u.guessEncoding?A:I;return new Promise((c,n)=>{const r=(0,o.newWriteableStream)(V=>V.join("")),m=[];let S=0,k,M;const q=async()=>{try{const V=await s({buffer:t.VSBuffer.concat(m),bytesRead:S},u.guessEncoding);if(V.seemsBinary&&u.acceptTextOnly)throw new L("Stream is binary but only text is accepted for decoding",1);V.encoding=await u.overwriteEncoding(V.encoding),k=await P.create(V.encoding);const F=k.write(t.VSBuffer.concat(m).buffer);r.write(F),m.length=0,S=0,c({stream:r,detected:V})}catch(V){M?.dispose(),r.destroy(),n(V)}};M=(0,o.listenStream)(a,{onData:async V=>{k?r.write(k.write(V.buffer)):(m.push(V),S+=V.byteLength,S>=l&&(a.pause(),await q(),setTimeout(()=>a.resume())))},onError:V=>r.error(V),onEnd:async()=>{k||await q(),r.end(k?.end())}})})}e.toDecodeStream=v;async function C(a,u,l){const n=(await new Promise((S,k)=>{te(["@vscode/iconv-lite-umd"],S,k)})).getEncoder(f(u),l);let r=!1,m=!1;return{read(){if(m)return null;const S=a.read();if(typeof S!="string"){if(m=!0,!r&&l?.addBOM)switch(u){case e.UTF8:case e.UTF8_with_bom:return t.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return t.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const k=n.end();return k&&k.length>0?(r=!0,t.VSBuffer.wrap(k)):null}return r=!0,t.VSBuffer.wrap(n.write(S))}}}e.toEncodeReadable=C;async function E(a){return(await new Promise((l,c)=>{te(["@vscode/iconv-lite-umd"],l,c)})).encodingExists(f(a))}e.encodingExists=E;function f(a){return a===e.UTF8_with_bom||a===null?e.UTF8:a}e.toNodeEncoding=f;function d(a,u){if(!a||u<e.UTF16be_BOM.length)return null;const l=a.readUInt8(0),c=a.readUInt8(1);if(l===e.UTF16be_BOM[0]&&c===e.UTF16be_BOM[1])return e.UTF16be;if(l===e.UTF16le_BOM[0]&&c===e.UTF16le_BOM[1])return e.UTF16le;if(u<e.UTF8_BOM.length)return null;const n=a.readUInt8(2);return l===e.UTF8_BOM[0]&&c===e.UTF8_BOM[1]&&n===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=d;const h=["ascii","utf-16","utf-32"];async function b(a){const u=await new Promise((m,S)=>{te(["jschardet"],m,S)}),l=a.slice(0,y),c=w(l.buffer),n=u.detect(c);if(!n||!n.encoding)return null;const r=n.encoding.toLowerCase();return 0<=h.indexOf(r)?null:p(n.encoding)}const g={ibm866:"cp866",big5:"cp950"};function p(a){const u=a.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return g[u]||u}function w(a){let u="";for(let l=0;l<a.length;l++)u+=String.fromCharCode(a[l]);return u}function i(a){switch(a){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const u=a.match(/windows(\d+)/);return u?"windows-"+u[1]:a}}}e.toCanonicalName=i;function s({buffer:a,bytesRead:u},l){let c=d(a,u),n=!1;if(c!==e.UTF16be&&c!==e.UTF16le&&a){let r=!0,m=!0,S=!1;for(let k=0;k<u&&k<R;k++){const M=k%2===1,q=a.readUInt8(k)===0;if(q&&(S=!0),r&&(M&&!q||!M&&q)&&(r=!1),m&&(M&&q||!M&&!q)&&(m=!1),q&&!r&&!m)break}S&&(r?c=e.UTF16le:m?c=e.UTF16be:n=!0)}return l&&!n&&!c&&a?b(a.slice(0,u)).then(r=>({seemsBinary:!1,encoding:r})):{seemsBinary:n,encoding:c}}e.detectEncodingFromBuffer=s,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ye[144],Ce([1,0,300,29,143]),function(te,e,o,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class R extends T.TextSearchManager{constructor(A,y,D=t,L="searchProcess"){super(A,y,{readdir:P=>D.Promises.readdir(P.fsPath),toCanonicalName:P=>(0,o.toCanonicalName)(P)},L)}}e.NativeTextSearchManager=R}),define(ye[301],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class o{constructor(){this.a=new Map,this.b=new Map}removeDragOperationTransfer(T){if(T&&this.a.has(T)){const R=this.a.get(T);return this.a.delete(T),R}}addDragOperationTransfer(T,R){this.a.set(T,R)}getRenderedTreeElement(T){if(this.b.has(T))return this.b.get(T)}addRenderedTreeItemElement(T,R){this.b.set(T,R)}removeRenderedTreeItemElement(T){this.b.has(T)&&this.b.delete(T)}}e.TreeviewsService=o}),define(ye[302],Ce([1,0,180,7,24,2,3,6,16,7,11,18,14,21,301,27]),function(te,e,o,t,T,R,I,A,y,D,L,P,v,C,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function d(g,p){if((0,L.isString)(g))return{label:g};if(g&&typeof g=="object"&&typeof g.label=="string"){let w;return Array.isArray(g.highlights)&&(w=g.highlights.filter(i=>i.length===2&&typeof i[0]=="number"&&typeof i[1]=="number"),w=w.length?w:void 0),{label:g.label,highlights:w}}}class h{constructor(p,w,i){this.d=p,this.e=w,this.f=i,this.a=new Map,this.b=new E.TreeviewsService;function s(a){return a&&a.$treeViewId&&(a.$treeItemHandle||a.$selectedTreeItems||a.$focusedTreeItem)}w.registerArgumentProcessor({processArgument:a=>s(a)?this.i(a):Array.isArray(a)&&a.length>0?a.map(u=>s(u)?this.i(u):u):a})}registerTreeDataProvider(p,w,i){const s=this.createTreeView(p,{treeDataProvider:w},i);return{dispose:()=>s.dispose()}}createTreeView(p,w,i){if(!w||!w.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const s=w.dragAndDropController?.dropMimeTypes??[],a=w.dragAndDropController?.dragMimeTypes??[],u=!!w.dragAndDropController?.handleDrag,l=!!w.dragAndDropController?.handleDrop,c=this.h(p,w,i),n=this.d.$registerTreeViewDataProvider(p,{showCollapseAll:!!w.showCollapseAll,canSelectMany:!!w.canSelectMany,dropMimeTypes:s,dragMimeTypes:a,hasHandleDrag:u,hasHandleDrop:l});return{get onDidCollapseElement(){return c.onDidCollapseElement},get onDidExpandElement(){return c.onDidExpandElement},get selection(){return c.selectedElements},get onDidChangeSelection(){return c.onDidChangeSelection},get visible(){return c.visible},get onDidChangeVisibility(){return c.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,f.checkProposedApiEnabled)(i,"treeItemCheckbox"),c.onDidChangeCheckboxState},get message(){return c.message},set message(r){c.message=r},get title(){return c.title},set title(r){c.title=r},get description(){return c.description},set description(r){c.description=r},get badge(){return c.badge},set badge(r){r!==void 0&&D.ViewBadge.isViewBadge(r)?c.badge={value:Math.floor(Math.abs(r.value)),tooltip:r.tooltip}:r===void 0&&(c.badge=void 0)},reveal:(r,m)=>c.reveal(r,m),dispose:async()=>{await n,this.a.delete(p),c.dispose()}}}$getChildren(p,w){const i=this.a.get(p);return i?i.getChildren(w):Promise.reject(new Error((0,o.localize)(0,null,p)))}async $handleDrop(p,w,i,s,a,u,l,c){const n=this.a.get(p);if(!n)return Promise.reject(new Error((0,o.localize)(1,null,p)));const r=v.DataTransfer.toDataTransfer(i,async m=>(await this.d.$resolveDropFileData(p,w,m)).buffer);return l===p&&c&&await this.g(r,n,c,a,u),n.onDrop(r,s,a)}async g(p,w,i,s,a){const u=this.b.removeDragOperationTransfer(a);if(u)(await u)?.forEach((l,c)=>{l&&p.set(c,l)});else if(a&&w.handleDrag){const l=w.handleDrag(i,p,s);this.b.addDragOperationTransfer(a,l),await l}return p}async $handleDrag(p,w,i,s){const a=this.a.get(p);if(!a)return Promise.reject(new Error((0,o.localize)(2,null,p)));const u=await this.g(new t.DataTransfer,a,w,s,i);if(!!u)return v.DataTransfer.toDataTransferDTO(u)}async $hasResolve(p){const w=this.a.get(p);if(!w)throw new Error((0,o.localize)(3,null,p));return w.hasResolve}$resolve(p,w,i){const s=this.a.get(p);if(!s)throw new Error((0,o.localize)(4,null,p));return s.resolveTreeItem(w,i)}$setExpanded(p,w,i){const s=this.a.get(p);if(!s)throw new Error((0,o.localize)(5,null,p));s.setExpanded(w,i)}$setSelection(p,w){const i=this.a.get(p);if(!i)throw new Error((0,o.localize)(6,null,p));i.setSelection(w)}$setFocus(p,w){const i=this.a.get(p);if(!i)throw new Error((0,o.localize)(7,null,p));i.setFocus(w)}$setVisible(p,w){const i=this.a.get(p);if(!i)throw new Error((0,o.localize)(8,null,p));i.setVisible(w)}$changeCheckboxState(p,w){const i=this.a.get(p);if(!i)throw new Error((0,o.localize)(9,null,p));i.setCheckboxState(w)}h(p,w,i){const s=new b(p,w,this.d,this.e.converter,this.f,i);return this.a.set(p,s),s}i(p){const w=this.a.get(p.$treeViewId);return w&&"$treeItemHandle"in p?w.getExtensionElement(p.$treeItemHandle):w&&"$focusedTreeItem"in p&&p.$focusedTreeItem?w.focusedElement:null}}e.ExtHostTreeViews=h;class b extends A.Disposable{get visible(){return this.k}get selectedElements(){return this.l.map(p=>this.getExtensionElement(p)).filter(p=>!(0,L.isUndefinedOrNull)(p))}get focusedElement(){return this.m?this.getExtensionElement(this.m):void 0}constructor(p,w,i,s,a,u){if(super(),this.C=p,this.D=i,this.F=s,this.G=a,this.H=u,this.h=void 0,this.i=new Map,this.j=new Map,this.k=!1,this.l=[],this.m=void 0,this.r=this.B(new I.Emitter),this.onDidExpandElement=this.r.event,this.s=this.B(new I.Emitter),this.onDidCollapseElement=this.s.event,this.t=this.B(new I.Emitter),this.onDidChangeSelection=this.t.event,this.u=this.B(new I.Emitter),this.onDidChangeVisibility=this.u.event,this.v=this.B(new I.Emitter),this.onDidChangeCheckboxState=this.v.event,this.w=this.B(new I.Emitter),this.y=Promise.resolve(),this.z=Promise.resolve(),this.I="",this.J="",this.S=new C.CancellationTokenSource,u.contributes&&u.contributes.views)for(const n in u.contributes.views)for(const r of u.contributes.views[n])r.id===p&&(this.J=r.name);this.f=w.treeDataProvider,this.g=w.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(n=>this.w.fire({message:!1,element:n})));let l,c;this.B(I.Event.debounce(this.w.event,(n,r)=>(n||(n={message:!1,elements:[]}),r.element!==!1&&(l||(l=new Promise(m=>c=m),this.y=this.y.then(()=>l)),Array.isArray(r.element)?n.elements.push(...r.element):n.elements.push(r.element)),r.message&&(n.message=!0),n),200,!0)(({message:n,elements:r})=>{r.length&&(this.z=this.z.then(()=>{const m=c;return l=null,this.U(r).then(()=>m())})),n&&this.D.$setMessage(this.C,this.I)}))}async getChildren(p){const w=p?this.getExtensionElement(p):void 0;if(p&&!w)return this.G.error(`No tree item with id '${p}' found.`),Promise.resolve([]);let i=this.Q(p);return i||(i=await this.R(w)),i?i.map(s=>s.item):void 0}getExtensionElement(p){return this.i.get(p)}reveal(p,w){w=w||{select:!0,focus:!1};const i=(0,L.isUndefinedOrNull)(w.select)?!0:w.select,s=(0,L.isUndefinedOrNull)(w.focus)?!1:w.focus,a=(0,L.isUndefinedOrNull)(w.expand)?!1:w.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):p?this.y.then(()=>this.N(p)).then(u=>this.P(p,u[u.length-1]).then(l=>this.D.$reveal(this.C,{item:l.item,parentChain:u.map(c=>c.item)},{select:i,focus:s,expand:a})),u=>this.G.error(u)):this.D.$reveal(this.C,void 0,{select:i,focus:s,expand:a})}get message(){return this.I}set message(p){this.I=p,this.w.fire({message:!0,element:!1})}get title(){return this.J}set title(p){this.J=p,this.D.$setTitle(this.C,p,this.L)}get description(){return this.L}set description(p){this.L=p,this.D.$setTitle(this.C,this.J,p)}get badge(){return this.M}set badge(p){this.M?.value===p?.value&&this.M?.tooltip===p?.tooltip||(this.M=v.ViewBadge.from(p),this.D.$setBadge(this.C,p))}setExpanded(p,w){const i=this.getExtensionElement(p);i&&(w?this.r.fire(Object.freeze({element:i})):this.s.fire(Object.freeze({element:i})))}setSelection(p){(0,P.equals)(this.l,p)||(this.l=p,this.t.fire(Object.freeze({selection:this.selectedElements})))}setFocus(p){this.m=p}setVisible(p){p!==this.k&&(this.k=p,this.u.fire(Object.freeze({visible:this.k})))}async setCheckboxState(p){const w=(await Promise.all(p.map(async i=>{const s=this.getExtensionElement(i.treeItemHandle);return s?{extensionItem:s,treeItem:await this.f.getTreeItem(s),newState:i.newState?D.TreeItemCheckboxState.Checked:D.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(i=>i!==void 0);w.forEach(i=>{i.treeItem.checkboxState=i.newState?D.TreeItemCheckboxState.Checked:D.TreeItemCheckboxState.Unchecked}),this.v.fire({items:w.map(i=>[i.extensionItem,i.newState])})}async handleDrag(p,w,i){const s=[];for(const a of p){const u=this.getExtensionElement(a);u&&s.push(u)}if(!(!this.g?.handleDrag||s.length===0))return await this.g.handleDrag(s,w,i),w}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(p,w,i){const s=w?this.getExtensionElement(w):void 0;if(!(!s&&w||!this.g?.handleDrop))return(0,y.asPromise)(()=>this.g?.handleDrop?this.g.handleDrop(s,p,i):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(p,w){if(!this.f.resolveTreeItem)return;const i=this.i.get(p);if(i){const s=this.j.get(i);if(s){const a=await this.f.resolveTreeItem(s.extensionItem,i,w)??s.extensionItem;return this.db(a),s.item.tooltip=this.ab(a.tooltip),s.item.command=this.bb(s.disposableStore,a.command),s.item}}}N(p){return this.O(p).then(w=>w?this.N(w).then(i=>this.P(w,i[i.length-1]).then(s=>(i.push(s),i))):Promise.resolve([]))}O(p){const w=this.j.get(p);return w?Promise.resolve(w.parent?this.i.get(w.parent.item.handle):void 0):(0,y.asPromise)(()=>this.f.getParent(p))}P(p,w){const i=this.j.get(p);return i?Promise.resolve(i):(0,y.asPromise)(()=>this.f.getTreeItem(p)).then(s=>this.gb(p,s,w,!0)).then(s=>this.getChildren(w?w.item.handle:void 0).then(()=>{const a=this.getExtensionElement(s);if(a){const u=this.j.get(a);if(u)return Promise.resolve(u)}throw new Error(`Cannot resolve tree item for element ${s}`)}))}Q(p){if(p){let w;if(typeof p=="string"){const i=this.getExtensionElement(p);w=i?this.j.get(i):void 0}else w=p;return w&&w.children||void 0}return this.h}async R(p){this.nb(p);const w=new C.CancellationTokenSource(this.S.token);try{const i=p?this.j.get(p):void 0,s=await this.f.getChildren(p);if(w.token.isCancellationRequested)return;const a=await Promise.all((0,P.coalesce)(s||[]).map(async u=>{const l=await this.f.getTreeItem(u);return l&&!w.token.isCancellationRequested?this.Z(u,l,i):null}));return w.token.isCancellationRequested?void 0:(0,P.coalesce)(a)}finally{w.dispose()}}U(p){if(p.some(i=>!i))return this.S.dispose(!0),this.S=new C.CancellationTokenSource,this.pb(),this.D.$refresh(this.C);{const i=this.W(p);if(i.length)return this.X(i)}return Promise.resolve(void 0)}W(p){const w=new Set,i=p.map(a=>this.j.get(a));for(const a of i)if(a&&!w.has(a.item.handle)){let u=a;for(;u&&u.parent&&i.findIndex(l=>u&&u.parent&&l&&l.item.handle===u.parent.item.handle)===-1;){const l=this.i.get(u.parent.item.handle);u=l?this.j.get(l):void 0}u&&!u.parent&&w.add(a.item.handle)}const s=[];return w.forEach(a=>{const u=this.i.get(a);if(u){const l=this.j.get(u);l&&(!l.parent||!w.has(l.parent.item.handle))&&s.push(a)}}),s}X(p){const w={};return Promise.all(p.map(i=>this.Y(i).then(s=>{s&&(w[i]=s.item)}))).then(()=>Object.keys(w).length?this.D.$refresh(this.C,w):void 0)}Y(p){const w=this.getExtensionElement(p);if(w){const i=this.j.get(w);if(i)return this.nb(w),(0,y.asPromise)(()=>this.f.getTreeItem(w)).then(s=>{if(s){const a=this.eb(w,s,i.parent);return this.lb(w,a,i,i.parent),i.dispose(),a}return null})}return Promise.resolve(null)}Z(p,w,i){const s=this.eb(p,w,i);if(w.id&&this.i.has(s.item.handle))throw new Error((0,o.localize)(10,null,w.id));return this.kb(p,s),this.mb(s,i),s}ab(p){return D.MarkdownString.isMarkdownString(p)?v.MarkdownString.from(p):p}bb(p,w){return w?{...this.F.toInternal(w,p),originalId:w.command}:void 0}cb(p){if(!p.checkboxState)return;let w,i;return typeof p.checkboxState=="number"?w=p.checkboxState:(w=p.checkboxState.state,i=p.checkboxState.tooltip),{isChecked:w===D.TreeItemCheckboxState.Checked,tooltip:i}}db(p){if(!D.TreeItem.isTreeItem(p,this.H))throw new Error(`Extension ${this.H.identifier.value} has provided an invalid tree item.`)}eb(p,w,i){this.db(w);const s=new A.DisposableStore,a=this.gb(p,w,i),u=this.hb(w);return{item:{handle:a,parentHandle:i?i.item.handle:void 0,label:d(w.label,this.H),description:w.description,resourceUri:w.resourceUri,tooltip:this.ab(w.tooltip),command:this.bb(s,w.command),contextValue:w.contextValue,icon:u,iconDark:this.ib(w)||u,themeIcon:this.fb(w),collapsibleState:(0,L.isUndefinedOrNull)(w.collapsibleState)?D.TreeItemCollapsibleState.None:w.collapsibleState,accessibilityInformation:w.accessibilityInformation,checkbox:this.cb(w)},extensionItem:w,parent:i,children:void 0,disposableStore:s,dispose(){s.dispose()}}}fb(p){return p.iconPath instanceof D.ThemeIcon?p.iconPath:void 0}gb(p,{id:w,label:i,resourceUri:s},a,u){if(w)return`${b.b}/${w}`;const l=d(i,this.H),c=a?a.item.handle:b.a;let n=l?l.label:s?(0,T.basename)(s):"";n=n.indexOf("/")!==-1?n.replace("/","//"):n;const r=this.j.has(p)?this.j.get(p).item.handle:void 0,m=this.Q(a)||[];let S,k=0;do{if(S=`${c}/${k}:${n}`,u||!this.i.has(S)||r===S)break;k++}while(k<=m.length);return S}hb(p){if(p.iconPath&&!(p.iconPath instanceof D.ThemeIcon))return typeof p.iconPath=="string"||R.URI.isUri(p.iconPath)?this.jb(p.iconPath):this.jb(p.iconPath.light)}ib(p){if(p.iconPath&&!(p.iconPath instanceof D.ThemeIcon)&&p.iconPath.dark)return this.jb(p.iconPath.dark)}jb(p){return R.URI.isUri(p)?p:R.URI.file(p)}kb(p,w){this.i.set(w.item.handle,p),this.j.set(p,w)}lb(p,w,i,s){this.i.delete(w.item.handle),this.j.delete(p),w.item.handle!==i.item.handle&&this.i.delete(i.item.handle),this.kb(p,w);const a=this.Q(s)||[],u=a.filter(l=>l.item.handle===i.item.handle)[0];u&&a.splice(a.indexOf(u),1,w)}mb(p,w){w?(w.children||(w.children=[]),w.children.push(p)):(this.h||(this.h=[]),this.h.push(p))}nb(p){if(p){const w=this.j.get(p);if(w){if(w.children)for(const i of w.children){const s=this.i.get(i.item.handle);s&&this.ob(s)}w.children=void 0}}else this.pb()}ob(p){const w=this.j.get(p);if(w){if(w.children)for(const i of w.children){const s=this.i.get(i.item.handle);s&&this.ob(s)}this.j.delete(p),this.i.delete(w.item.handle),w.dispose()}}pb(){this.h=void 0,this.i.clear(),this.j.forEach(p=>p.dispose()),this.j.clear()}dispose(){this.S.dispose(),this.pb(),this.D.$disposeTree(this.C)}}b.a="0",b.b="1"}),define(ye[303],Ce([1,0,21,9,3,37,2,120,106,152,163,39,5,94,246,245,40,247,34,249,250,251,234,252,58,42,253,254,257,258,259,142,237,264,265,266,98,41,268,302,14,7,68,271,74,141,33,225,256,67,139,76,78,79,13,55,17,25,260,233,54,71,243,269,73,72,274,272,273,244,48,267,270,97,59,95,261,75,262,15,124,236,214,255,6,27,218,96,211,263]),function(te,e,o,t,T,R,I,A,y,D,L,P,v,C,E,f,d,h,b,g,p,w,i,s,a,u,l,c,n,r,m,S,k,M,q,V,F,U,N,B,j,z,ne,_,Y,J,Z,ie,X,K,he,be,Ee,Pe,Me,oe,ae,fe,ee,le,re,O,H,x,Q,de,we,Ae,pe,De,ke,je,Ge,et,_e,nt,st,ht,Fe,it,ce,$,ue,Ie,Le,Be,xe,Ze,gt,mt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function lt(ot){const rt=ot.get(fe.IExtHostInitDataService),kt=ot.get(ke.IExtHostFileSystemInfo),Tt=ot.get(de.IExtHostConsumerFileSystem),Nt=ot.get(u.IExtHostExtensionService),pt=ot.get(Z.IExtHostWorkspace),Dt=ot.get(nt.IExtHostTelemetry),zt=ot.get(b.IExtHostConfiguration),Ft=ot.get(oe.IURITransformerService),Xe=ot.get(ae.IExtHostRpcService),Mt=ot.get(F.IExtHostStorage),Ut=ot.get(Q.IExtensionStoragePaths),Bt=ot.get(Me.ILoggerService),wt=ot.get(Me.ILogService),Pt=ot.get(re.IExtHostTunnelService),Re=ot.get(O.IExtHostApiDeprecationService),Oe=ot.get(J.IExtHostWindow),Se=ot.get(et.IExtHostSecretState),se=ot.get(_e.IExtHostEditorTabs);Xe.set(v.ExtHostContext.ExtHostFileSystemInfo,kt),Xe.set(v.ExtHostContext.ExtHostLogLevelServiceShape,Bt),Xe.set(v.ExtHostContext.ExtHostWorkspace,pt),Xe.set(v.ExtHostContext.ExtHostConfiguration,zt),Xe.set(v.ExtHostContext.ExtHostExtensionService,Nt),Xe.set(v.ExtHostContext.ExtHostStorage,Mt),Xe.set(v.ExtHostContext.ExtHostTunnelService,Pt),Xe.set(v.ExtHostContext.ExtHostWindow,Oe),Xe.set(v.ExtHostContext.ExtHostSecretState,Se),Xe.set(v.ExtHostContext.ExtHostTelemetry,Dt),Xe.set(v.ExtHostContext.ExtHostEditorTabs,se);const Ne=Xe.set(v.ExtHostContext.ExtHostDecorations,ot.get(he.IExtHostDecorations)),$e=Xe.set(v.ExtHostContext.ExtHostDocumentsAndEditors,ot.get(a.IExtHostDocumentsAndEditors)),Qe=Xe.set(v.ExtHostContext.ExtHostCommands,ot.get(d.IExtHostCommands)),Ve=Xe.set(v.ExtHostContext.ExtHostTerminalService,ot.get(U.IExtHostTerminalService)),tt=Xe.set(v.ExtHostContext.ExtHostDebugService,ot.get(Ee.IExtHostDebugService)),St=Xe.set(v.ExtHostContext.ExtHostSearch,ot.get(Pe.IExtHostSearch)),Et=Xe.set(v.ExtHostContext.ExtHostTask,ot.get(be.IExtHostTask)),Lt=Xe.set(v.ExtHostContext.ExtHostOutputService,ot.get(S.IExtHostOutputService)),vt=Xe.set(v.ExtHostContext.ExtHostLocalization,ot.get(Ze.IExtHostLocalizationService)),It=Xe.set(v.ExtHostContext.ExtHostUrls,new _.ExtHostUrls(Xe)),ft=Xe.set(v.ExtHostContext.ExtHostDocuments,new s.ExtHostDocuments(Xe,$e)),Gt=Xe.set(v.ExtHostContext.ExtHostDocumentContentProviders,new w.ExtHostDocumentContentProvider(Xe,$e,wt)),jt=Xe.set(v.ExtHostContext.ExtHostDocumentSaveParticipant,new i.ExtHostDocumentSaveParticipant(wt,ft,Xe.getProxy(v.MainContext.MainThreadBulkEdits))),yt=Xe.set(v.ExtHostContext.ExtHostNotebook,new ee.ExtHostNotebookController(Xe,Qe,$e,ft)),_t=Xe.set(v.ExtHostContext.ExtHostNotebookDocuments,new ue.ExtHostNotebookDocuments(yt)),sn=Xe.set(v.ExtHostContext.ExtHostNotebookEditors,new $.ExtHostNotebookEditors(wt,yt)),en=Xe.set(v.ExtHostContext.ExtHostNotebookKernels,new st.ExtHostNotebookKernels(Xe,rt,yt,Qe,wt)),vn=Xe.set(v.ExtHostContext.ExtHostNotebookRenderers,new Fe.ExtHostNotebookRenderers(Xe,yt)),At=Xe.set(v.ExtHostContext.ExtHostEditors,new N.ExtHostEditors(Xe,$e)),on=Xe.set(v.ExtHostContext.ExtHostTreeViews,new B.ExtHostTreeViews(Xe.getProxy(v.MainContext.MainThreadTreeViews),Qe,wt)),Vt=Xe.set(v.ExtHostContext.ExtHostEditorInsets,new ie.ExtHostEditorInsets(Xe.getProxy(v.MainContext.MainThreadEditorInsets),At,rt.remote)),tn=Xe.set(v.ExtHostContext.ExtHostDiagnostics,new g.ExtHostDiagnostics(Xe,wt,kt,$e)),an=Xe.set(v.ExtHostContext.ExtHostLanguages,new r.ExtHostLanguages(Xe,ft,Qe.converter,Ft)),ut=Xe.set(v.ExtHostContext.ExtHostLanguageFeatures,new n.ExtHostLanguageFeatures(Xe,Ft,ft,Qe,tn,wt,Re,Dt)),On=Xe.set(v.ExtHostContext.ExtHostFileSystem,new l.ExtHostFileSystem(Xe,ut)),Qt=Xe.set(v.ExtHostContext.ExtHostFileSystemEventService,new c.ExtHostFileSystemEventService(Xe,wt,$e)),Wt=Xe.set(v.ExtHostContext.ExtHostQuickOpen,(0,M.createExtHostQuickOpen)(Xe,pt,Qe)),cn=Xe.set(v.ExtHostContext.ExtHostSCM,new q.ExtHostSCM(Xe,Qe,wt)),En=Xe.set(v.ExtHostContext.ExtHostComments,(0,h.createExtHostComments)(Xe,Qe,ft)),ln=Xe.set(v.ExtHostContext.ExtHostProgress,new k.ExtHostProgress(Xe.getProxy(v.MainContext.MainThreadProgress))),Sn=Xe.set(v.ExtHostContext.ExtHosLabelService,new X.ExtHostLabelService(Xe)),un=Xe.set(v.ExtHostContext.ExtHostTheming,new le.ExtHostTheming(Xe)),nn=Xe.set(v.ExtHostContext.ExtHostAuthentication,new H.ExtHostAuthentication(Xe)),yn=Xe.set(v.ExtHostContext.ExtHostTimeline,new x.ExtHostTimeline(Xe,Qe)),rn=Xe.set(v.ExtHostContext.ExtHostWebviews,new Y.ExtHostWebviews(Xe,rt.remote,pt,wt,Re)),Cn=Xe.set(v.ExtHostContext.ExtHostWebviewPanels,new pe.ExtHostWebviewPanels(Xe,rn,pt)),Dn=Xe.set(v.ExtHostContext.ExtHostCustomEditors,new Ae.ExtHostCustomEditors(Xe,ft,Ut,rn,Cn)),In=Xe.set(v.ExtHostContext.ExtHostWebviewViews,new we.ExtHostWebviewViews(Xe,rn)),Yt=Xe.set(v.ExtHostContext.ExtHostTesting,new je.ExtHostTesting(Xe,Qe,$e)),kn=Xe.set(v.ExtHostContext.ExtHostUriOpeners,new Ge.ExtHostUriOpeners(Xe)),zn=Xe.set(v.ExtHostContext.ExtHostProfileContentHandlers,new mt.ExtHostProfileContentHandlers(Xe));Xe.set(v.ExtHostContext.ExtHostInteractive,new Ie.ExtHostInteractive(Xe,yt,$e,Qe,wt));const Tn=Object.values(v.ExtHostContext);Xe.assertRegistered(Tn);const Pn=new De.ExtHostBulkEdits(Xe,$e),$n=new f.ExtHostClipboard(Xe),An=new m.ExtHostMessageService(Xe,wt),Nn=new p.ExtHostDialogs(Xe),Fn=new V.ExtHostStatusBar(Xe,Qe.converter);return E.ExtHostApiCommands.register(Qe),function(He,Kt,dn){const bt=function(){let ge=!He.isUnderDevelopment;function ve(){ge||(wt.info(`Extension '${He.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ge=!0)}return function ze(at){if(Array.isArray(at))at.forEach(ze);else if(typeof at=="string")ve();else{const Ct=at;typeof Ct.scheme>"u"&&ve(),typeof Ct.exclusive=="boolean"&&(0,Be.checkProposedApiEnabled)(He,"documentFiltersExclusive")}return at}}(),Wn={getSession(ge,ve,ze){return nn.getSession(He,ge,ve,ze)},async hasSession(ge,ve){return(0,Be.checkProposedApiEnabled)(He,"authSession"),!!await nn.getSession(He,ge,ve,{silent:!0})},get onDidChangeSessions(){return nn.onDidChangeSessions},registerAuthenticationProvider(ge,ve,ze,at){return nn.registerAuthenticationProvider(ge,ve,ze,at)}},Hn={registerCommand(ge,ve,ze){return Qe.registerCommand(!0,ge,ve,ze,void 0,He)},registerTextEditorCommand(ge,ve,ze){return Qe.registerCommand(!0,ge,(...at)=>{const Ct=At.getActiveTextEditor();if(!Ct){wt.warn("Cannot execute "+ge+" because there is no active text editor.");return}return Ct.edit(Rt=>{ve.apply(ze,[Ct,Rt,...at])}).then(Rt=>{Rt||wt.warn("Edits from command "+ge+" were not applied.")},Rt=>{wt.warn("An error occurred while running command "+ge,Rt)})},void 0,void 0,He)},registerDiffInformationCommand:(ge,ve,ze)=>((0,Be.checkProposedApiEnabled)(He,"diffCommand"),Qe.registerCommand(!0,ge,async(...at)=>{const Ct=$e.activeEditor(!0);if(!Ct){wt.warn("Cannot execute "+ge+" because there is no active text editor.");return}const Rt=await At.getDiffInformation(Ct.id);ve.apply(ze,[Rt,...at])},void 0,void 0,He)),executeCommand(ge,...ve){return Qe.executeCommand(ge,...ve)},getCommands(ge=!1){return Qe.getCommands(ge)}},Mn={get machineId(){return rt.telemetryInfo.machineId},get sessionId(){return rt.telemetryInfo.sessionId},get language(){return rt.environment.appLanguage},get appName(){return rt.environment.appName},get appRoot(){return rt.environment.appRoot?.fsPath??""},get appHost(){return rt.environment.appHost},get uriScheme(){return rt.environment.appUriScheme},get clipboard(){return $n.value},get shell(){return Ve.getDefaultShell(!1)},get onDidChangeShell(){return(0,Be.checkProposedApiEnabled)(He,"envShellEvent"),Ve.onDidChangeShell},get isTelemetryEnabled(){return Dt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Dt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Be.checkProposedApiEnabled)(He,"telemetry"),Dt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Be.checkProposedApiEnabled)(He,"telemetry"),Dt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,nt.isNewAppInstall)(rt.telemetryInfo.firstSessionDate)},createTelemetryLogger(ge){return(0,Be.checkProposedApiEnabled)(He,"telemetryLogger"),Dt.instantiateLogger(He,ge)},openExternal(ge,ve){return Oe.openUri(ge,{allowTunneling:!!rt.remote.authority,allowContributedOpeners:ve?.allowContributedOpeners})},async asExternalUri(ge){if(ge.scheme===rt.environment.appUriScheme)return It.createAppUri(ge);try{return await Oe.asExternalUri(ge,{allowTunneling:!!rt.remote.authority})}catch(ve){if((0,ce.matchesScheme)(ge,it.Schemas.http)||(0,ce.matchesScheme)(ge,it.Schemas.https))return ge;throw ve}},get remoteName(){return(0,K.getRemoteName)(rt.remote.authority)},get remoteAuthority(){return(0,Be.checkProposedApiEnabled)(He,"resolvers"),rt.remote.authority},get uiKind(){return rt.uiKind},get logLevel(){return wt.getLevel()},get onDidChangeLogLevel(){return wt.onDidChangeLogLevel}};rt.environment.extensionTestsLocationURI||Object.freeze(Mn);const hn={createTestController(ge,ve,ze){return Yt.createTestController(ge,ve,ze)},createTestObserver(){return(0,Be.checkProposedApiEnabled)(He,"testObserver"),Yt.createTestObserver()},runTests(ge){return(0,Be.checkProposedApiEnabled)(He,"testObserver"),Yt.runTests(ge)},get onDidChangeTestResults(){return(0,Be.checkProposedApiEnabled)(He,"testObserver"),Yt.onResultsChanged},get testResults(){return(0,Be.checkProposedApiEnabled)(He,"testObserver"),Yt.results}},fn=rt.remote.isRemote?z.ExtensionKind.Workspace:z.ExtensionKind.UI,jn={getExtension(ge,ve){(0,Be.isProposedApiEnabled)(He,"extensionsAny")||(ve=!1);const ze=Kt.mine.getExtensionDescription(ge);if(ze)return new u.Extension(Nt,He.identifier,ze,fn,!1);if(ve){const at=Kt.all.getExtensionDescription(ge);if(at)return new u.Extension(Nt,He.identifier,at,fn,!0)}},get all(){const ge=[];for(const ve of Kt.mine.getAllExtensionDescriptions())ge.push(new u.Extension(Nt,He.identifier,ve,fn,!1));return ge},get allAcrossExtensionHosts(){(0,Be.checkProposedApiEnabled)(He,"extensionsAny");const ge=new Be.ExtensionIdentifierSet(Kt.mine.getAllExtensionDescriptions().map(ze=>ze.identifier)),ve=[];for(const ze of Kt.all.getAllExtensionDescriptions()){const at=!ge.has(ze.identifier);ve.push(new u.Extension(Nt,He.identifier,ze,fn,at))}return ve},get onDidChange(){return(0,Be.isProposedApiEnabled)(He,"extensionsAny")?T.Event.any(Kt.mine.onDidChange,Kt.all.onDidChange):Kt.mine.onDidChange}},Vn={createDiagnosticCollection(ge){return tn.createDiagnosticCollection(He.identifier,ge)},get onDidChangeDiagnostics(){return tn.onDidChangeDiagnostics},getDiagnostics:ge=>tn.getDiagnostics(ge),getLanguages(){return an.getLanguages()},setTextDocumentLanguage(ge,ve){return an.changeLanguage(ge.uri,ve)},match(ge,ve){const ze=ft.getDocumentData(ve.uri)?.notebook;return(0,L.score)(j.LanguageSelector.from(ge),ve.uri,ve.languageId,!0,ze?.uri,ze?.notebookType)},registerCodeActionsProvider(ge,ve,ze){return ut.registerCodeActionProvider(He,bt(ge),ve,ze)},registerDocumentPasteEditProvider(ge,ve,ze){return(0,Be.checkProposedApiEnabled)(He,"documentPaste"),ut.registerDocumentPasteEditProvider(He,bt(ge),ve,ze)},registerCodeLensProvider(ge,ve){return ut.registerCodeLensProvider(He,bt(ge),ve)},registerDefinitionProvider(ge,ve){return ut.registerDefinitionProvider(He,bt(ge),ve)},registerDeclarationProvider(ge,ve){return ut.registerDeclarationProvider(He,bt(ge),ve)},registerImplementationProvider(ge,ve){return ut.registerImplementationProvider(He,bt(ge),ve)},registerTypeDefinitionProvider(ge,ve){return ut.registerTypeDefinitionProvider(He,bt(ge),ve)},registerHoverProvider(ge,ve){return ut.registerHoverProvider(He,bt(ge),ve,He.identifier)},registerEvaluatableExpressionProvider(ge,ve){return ut.registerEvaluatableExpressionProvider(He,bt(ge),ve,He.identifier)},registerInlineValuesProvider(ge,ve){return ut.registerInlineValuesProvider(He,bt(ge),ve,He.identifier)},registerDocumentHighlightProvider(ge,ve){return ut.registerDocumentHighlightProvider(He,bt(ge),ve)},registerLinkedEditingRangeProvider(ge,ve){return ut.registerLinkedEditingRangeProvider(He,bt(ge),ve)},registerReferenceProvider(ge,ve){return ut.registerReferenceProvider(He,bt(ge),ve)},registerRenameProvider(ge,ve){return ut.registerRenameProvider(He,bt(ge),ve)},registerDocumentSymbolProvider(ge,ve,ze){return ut.registerDocumentSymbolProvider(He,bt(ge),ve,ze)},registerWorkspaceSymbolProvider(ge){return ut.registerWorkspaceSymbolProvider(He,ge)},registerDocumentFormattingEditProvider(ge,ve){return ut.registerDocumentFormattingEditProvider(He,bt(ge),ve)},registerDocumentRangeFormattingEditProvider(ge,ve){return ut.registerDocumentRangeFormattingEditProvider(He,bt(ge),ve)},registerOnTypeFormattingEditProvider(ge,ve,ze,...at){return ut.registerOnTypeFormattingEditProvider(He,bt(ge),ve,[ze].concat(at))},registerDocumentSemanticTokensProvider(ge,ve,ze){return ut.registerDocumentSemanticTokensProvider(He,bt(ge),ve,ze)},registerDocumentRangeSemanticTokensProvider(ge,ve,ze){return ut.registerDocumentRangeSemanticTokensProvider(He,bt(ge),ve,ze)},registerSignatureHelpProvider(ge,ve,ze,...at){return typeof ze=="object"?ut.registerSignatureHelpProvider(He,bt(ge),ve,ze):ut.registerSignatureHelpProvider(He,bt(ge),ve,typeof ze>"u"?[]:[ze,...at])},registerCompletionItemProvider(ge,ve,...ze){return ut.registerCompletionItemProvider(He,bt(ge),ve,ze)},registerInlineCompletionItemProvider(ge,ve){return ve.handleDidShowCompletionItem&&(0,Be.checkProposedApiEnabled)(He,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(He,bt(ge),ve)},registerDocumentLinkProvider(ge,ve){return ut.registerDocumentLinkProvider(He,bt(ge),ve)},registerColorProvider(ge,ve){return ut.registerColorProvider(He,bt(ge),ve)},registerFoldingRangeProvider(ge,ve){return ut.registerFoldingRangeProvider(He,bt(ge),ve)},registerSelectionRangeProvider(ge,ve){return ut.registerSelectionRangeProvider(He,ge,ve)},registerCallHierarchyProvider(ge,ve){return ut.registerCallHierarchyProvider(He,ge,ve)},registerTypeHierarchyProvider(ge,ve){return ut.registerTypeHierarchyProvider(He,ge,ve)},setLanguageConfiguration:(ge,ve)=>ut.setLanguageConfiguration(He,ge,ve),getTokenInformationAtPosition(ge,ve){return(0,Be.checkProposedApiEnabled)(He,"tokenInformation"),an.tokenAtPosition(ge,ve)},registerInlayHintsProvider(ge,ve){return ut.registerInlayHintsProvider(He,ge,ve)},createLanguageStatusItem(ge,ve){return an.createLanguageStatusItem(He,ge,ve)},registerDocumentDropEditProvider(ge,ve){return ut.registerDocumentOnDropEditProvider(He,ge,ve)}},qn={get activeTextEditor(){return At.getActiveTextEditor()},get visibleTextEditors(){return At.getVisibleTextEditors()},get activeTerminal(){return Ve.activeTerminal},get terminals(){return Ve.terminals},async showTextDocument(ge,ve,ze){const at=await(I.URI.isUri(ge)?Promise.resolve(mn.openTextDocument(ge)):Promise.resolve(ge));return At.showTextDocument(at,ve,ze)},createTextEditorDecorationType(ge){return At.createTextEditorDecorationType(He,ge)},onDidChangeActiveTextEditor(ge,ve,ze){return At.onDidChangeActiveTextEditor(ge,ve,ze)},onDidChangeVisibleTextEditors(ge,ve,ze){return At.onDidChangeVisibleTextEditors(ge,ve,ze)},onDidChangeTextEditorSelection(ge,ve,ze){return At.onDidChangeTextEditorSelection(ge,ve,ze)},onDidChangeTextEditorOptions(ge,ve,ze){return At.onDidChangeTextEditorOptions(ge,ve,ze)},onDidChangeTextEditorVisibleRanges(ge,ve,ze){return At.onDidChangeTextEditorVisibleRanges(ge,ve,ze)},onDidChangeTextEditorViewColumn(ge,ve,ze){return At.onDidChangeTextEditorViewColumn(ge,ve,ze)},onDidCloseTerminal(ge,ve,ze){return Ve.onDidCloseTerminal(ge,ve,ze)},onDidOpenTerminal(ge,ve,ze){return Ve.onDidOpenTerminal(ge,ve,ze)},onDidChangeActiveTerminal(ge,ve,ze){return Ve.onDidChangeActiveTerminal(ge,ve,ze)},onDidChangeTerminalDimensions(ge,ve,ze){return(0,Be.checkProposedApiEnabled)(He,"terminalDimensions"),Ve.onDidChangeTerminalDimensions(ge,ve,ze)},onDidChangeTerminalState(ge,ve,ze){return Ve.onDidChangeTerminalState(ge,ve,ze)},onDidWriteTerminalData(ge,ve,ze){return(0,Be.checkProposedApiEnabled)(He,"terminalDataWriteEvent"),Ve.onDidWriteTerminalData(ge,ve,ze)},get state(){return Oe.state},onDidChangeWindowState(ge,ve,ze){return Oe.onDidChangeWindowState(ge,ve,ze)},showInformationMessage(ge,...ve){return An.showMessage(He,R.default.Info,ge,ve[0],ve.slice(1))},showWarningMessage(ge,...ve){return An.showMessage(He,R.default.Warning,ge,ve[0],ve.slice(1))},showErrorMessage(ge,...ve){return An.showMessage(He,R.default.Error,ge,ve[0],ve.slice(1))},showQuickPick(ge,ve,ze){return Wt.showQuickPick(ge,ve,ze)},showWorkspaceFolderPick(ge){return Wt.showWorkspaceFolderPick(ge)},showInputBox(ge,ve){return Wt.showInput(ge,ve)},showOpenDialog(ge){return Nn.showOpenDialog(ge)},showSaveDialog(ge){return Nn.showSaveDialog(ge)},createStatusBarItem(ge,ve,ze){let at,Ct,Rt;return typeof ge=="string"?(at=ge,Ct=ve,Rt=ze):(Ct=ge,Rt=ve),Fn.createStatusBarEntry(He,at,Ct,Rt)},setStatusBarMessage(ge,ve){return Fn.setStatusBarMessage(ge,ve)},withScmProgress(ge){return Re.report("window.withScmProgress",He,"Use 'withProgress' instead."),ln.withProgress(He,{location:z.ProgressLocation.SourceControl},(ve,ze)=>ge({report(at){}}))},withProgress(ge,ve){return ln.withProgress(He,ge,ve)},createOutputChannel(ge,ve){return Lt.createOutputChannel(ge,ve,He)},createWebviewPanel(ge,ve,ze,at){return Cn.createWebviewPanel(He,ge,ve,ze,at)},createWebviewTextEditorInset(ge,ve,ze,at){return(0,Be.checkProposedApiEnabled)(He,"editorInsets"),Vt.createWebviewEditorInset(ge,ve,ze,at,He)},createTerminal(ge,ve,ze){return typeof ge=="object"?"pty"in ge?Ve.createExtensionTerminal(ge):Ve.createTerminalFromOptions(ge):Ve.createTerminal(ge,ve,ze)},registerTerminalLinkProvider(ge){return Ve.registerLinkProvider(ge)},registerTerminalProfileProvider(ge,ve){return Ve.registerProfileProvider(He,ge,ve)},registerTerminalQuickFixProvider(ge,ve){return(0,Be.checkProposedApiEnabled)(He,"terminalQuickFixProvider"),Ve.registerTerminalQuickFixProvider(ge,He.identifier.value,ve)},registerTreeDataProvider(ge,ve){return on.registerTreeDataProvider(ge,ve,He)},createTreeView(ge,ve){return on.createTreeView(ge,ve,He)},registerWebviewPanelSerializer:(ge,ve)=>Cn.registerWebviewPanelSerializer(He,ge,ve),registerCustomEditorProvider:(ge,ve,ze={})=>Dn.registerCustomEditorProvider(He,ge,ve,ze),registerFileDecorationProvider(ge){return Ne.registerFileDecorationProvider(ge,He)},registerUriHandler(ge){return It.registerUriHandler(He.identifier,ge)},createQuickPick(){return Wt.createQuickPick(He)},createInputBox(){return Wt.createInputBox(He)},get activeColorTheme(){return un.activeColorTheme},onDidChangeActiveColorTheme(ge,ve,ze){return un.onDidChangeActiveColorTheme(ge,ve,ze)},registerWebviewViewProvider(ge,ve,ze){return In.registerWebviewViewProvider(He,ge,ve,ze?.webviewOptions)},get activeNotebookEditor(){return yt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ge,ve,ze){return yt.onDidChangeActiveNotebookEditor(ge,ve,ze)},get visibleNotebookEditors(){return yt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return yt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ge,ve,ze){return sn.onDidChangeNotebookEditorSelection(ge,ve,ze)},onDidChangeNotebookEditorVisibleRanges(ge,ve,ze){return sn.onDidChangeNotebookEditorVisibleRanges(ge,ve,ze)},showNotebookDocument(ge,ve){return yt.showNotebookDocument(ge,ve)},registerExternalUriOpener(ge,ve,ze){return(0,Be.checkProposedApiEnabled)(He,"externalUriOpener"),kn.registerExternalUriOpener(He.identifier,ge,ve,ze)},registerProfileContentHandler(ge,ve){return(0,Be.checkProposedApiEnabled)(He,"profileContentHandlers"),zn.registrProfileContentHandler(He,ge,ve)},get tabGroups(){return se.tabGroups}},mn={get rootPath(){return Re.report("workspace.rootPath",He,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),pt.getPath()},set rootPath(ge){throw t.readonly()},getWorkspaceFolder(ge){return pt.getWorkspaceFolder(ge)},get workspaceFolders(){return pt.getWorkspaceFolders()},get name(){return pt.name},set name(ge){throw t.readonly()},get workspaceFile(){return pt.workspaceFile},set workspaceFile(ge){throw t.readonly()},updateWorkspaceFolders:(ge,ve,...ze)=>pt.updateWorkspaceFolders(He,ge,ve||0,...ze),onDidChangeWorkspaceFolders:function(ge,ve,ze){return pt.onDidChangeWorkspace(ge,ve,ze)},asRelativePath:(ge,ve)=>pt.getRelativePath(ge,ve),findFiles:(ge,ve,ze,at)=>pt.findFiles(ge,ve,ze,He.identifier,at),findTextInFiles:(ge,ve,ze,at)=>{(0,Be.checkProposedApiEnabled)(He,"findTextInFiles");let Ct,Rt;return typeof ve=="object"?(Ct=ve,Rt=ze):(Ct={},Rt=ve,at=ze),pt.findTextInFiles(ge,Ct||{},Rt,He.identifier,at)},saveAll:ge=>pt.saveAll(ge),applyEdit(ge,ve){return Pn.applyWorkspaceEdit(ge,He,ve)},createFileSystemWatcher:(ge,ve,ze,at)=>Qt.createFileSystemWatcher(pt,He,ge,ve,ze,at),get textDocuments(){return ft.getAllDocumentData().map(ge=>ge.document)},set textDocuments(ge){throw t.readonly()},openTextDocument(ge){let ve;const ze=ge;if(typeof ge=="string")ve=Promise.resolve(I.URI.file(ge));else if(I.URI.isUri(ge))ve=Promise.resolve(ge);else if(!ze||typeof ze=="object")ve=ft.createDocumentData(ze);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ve.then(at=>ft.ensureDocumentData(at).then(Ct=>Ct.document))},onDidOpenTextDocument:(ge,ve,ze)=>ft.onDidAddDocument(ge,ve,ze),onDidCloseTextDocument:(ge,ve,ze)=>ft.onDidRemoveDocument(ge,ve,ze),onDidChangeTextDocument:(ge,ve,ze)=>ft.onDidChangeDocument(ge,ve,ze),onDidSaveTextDocument:(ge,ve,ze)=>ft.onDidSaveDocument(ge,ve,ze),onWillSaveTextDocument:(ge,ve,ze)=>jt.getOnWillSaveTextDocumentEvent(He)(ge,ve,ze),get notebookDocuments(){return yt.notebookDocuments.map(ge=>ge.apiNotebook)},async openNotebookDocument(ge,ve){let ze;if(I.URI.isUri(ge))ze=ge,await yt.openNotebookDocument(ge);else if(typeof ge=="string")ze=I.URI.revive(await yt.createNotebookDocument({viewType:ge,content:ve}));else throw new Error("Invalid arguments");return yt.getNotebookDocument(ze).apiNotebook},onDidSaveNotebookDocument(ge,ve,ze){return _t.onDidSaveNotebookDocument(ge,ve,ze)},onDidChangeNotebookDocument(ge,ve,ze){return _t.onDidChangeNotebookDocument(ge,ve,ze)},get onDidOpenNotebookDocument(){return yt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return yt.onDidCloseNotebookDocument},registerNotebookSerializer(ge,ve,ze,at){return yt.registerNotebookSerializer(He,ge,ve,ze,(0,Be.isProposedApiEnabled)(He,"notebookLiveShare")?at:void 0)},onDidChangeConfiguration:(ge,ve,ze)=>dn.onDidChangeConfiguration(ge,ve,ze),getConfiguration(ge,ve){return ve=arguments.length===1?void 0:ve,dn.getConfiguration(ge,ve,He)},registerTextDocumentContentProvider(ge,ve){return Gt.registerTextDocumentContentProvider(ge,ve)},registerTaskProvider:(ge,ve)=>(Re.report("window.registerTaskProvider",He,"Use the corresponding function on the 'tasks' namespace instead"),Et.registerTaskProvider(He,ge,ve)),registerFileSystemProvider(ge,ve,ze){return(0,Le.combinedDisposable)(On.registerFileSystemProvider(He,ge,ve,ze),Tt.addFileSystemProvider(ge,ve))},get fs(){return Tt.value},registerFileSearchProvider:(ge,ve)=>((0,Be.checkProposedApiEnabled)(He,"fileSearchProvider"),St.registerFileSearchProvider(ge,ve)),registerTextSearchProvider:(ge,ve)=>((0,Be.checkProposedApiEnabled)(He,"textSearchProvider"),St.registerTextSearchProvider(ge,ve)),registerRemoteAuthorityResolver:(ge,ve)=>((0,Be.checkProposedApiEnabled)(He,"resolvers"),Nt.registerRemoteAuthorityResolver(ge,ve)),registerResourceLabelFormatter:ge=>((0,Be.checkProposedApiEnabled)(He,"resolvers"),Sn.$registerResourceLabelFormatter(ge)),onDidCreateFiles:(ge,ve,ze)=>Qt.onDidCreateFile(ge,ve,ze),onDidDeleteFiles:(ge,ve,ze)=>Qt.onDidDeleteFile(ge,ve,ze),onDidRenameFiles:(ge,ve,ze)=>Qt.onDidRenameFile(ge,ve,ze),onWillCreateFiles:(ge,ve,ze)=>Qt.getOnWillCreateFileEvent(He)(ge,ve,ze),onWillDeleteFiles:(ge,ve,ze)=>Qt.getOnWillDeleteFileEvent(He)(ge,ve,ze),onWillRenameFiles:(ge,ve,ze)=>Qt.getOnWillRenameFileEvent(He)(ge,ve,ze),openTunnel:ge=>((0,Be.checkProposedApiEnabled)(He,"tunnels"),Pt.openTunnel(He,ge).then(ve=>{if(!ve)throw new Error("cannot open tunnel");return ve})),get tunnels(){return(0,Be.checkProposedApiEnabled)(He,"tunnels"),Pt.getTunnels()},onDidChangeTunnels:(ge,ve,ze)=>((0,Be.checkProposedApiEnabled)(He,"tunnels"),Pt.onDidChangeTunnels(ge,ve,ze)),registerPortAttributesProvider:(ge,ve)=>((0,Be.checkProposedApiEnabled)(He,"portsAttributes"),Pt.registerPortsAttributesProvider(ge,ve)),registerTimelineProvider:(ge,ve)=>((0,Be.checkProposedApiEnabled)(He,"timeline"),yn.registerTimelineProvider(ge,ve,He.identifier,Qe.converter)),get isTrusted(){return pt.trusted},requestWorkspaceTrust:ge=>((0,Be.checkProposedApiEnabled)(He,"workspaceTrust"),pt.requestWorkspaceTrust(ge)),onDidGrantWorkspaceTrust:(ge,ve,ze)=>pt.onDidGrantWorkspaceTrust(ge,ve,ze),registerEditSessionIdentityProvider:(ge,ve)=>((0,Be.checkProposedApiEnabled)(He,"editSessionIdentityProvider"),pt.registerEditSessionIdentityProvider(ge,ve))},Gn={get inputBox(){return Re.report("scm.inputBox",He,"Use 'SourceControl.inputBox' instead"),cn.getLastInputBox(He)},createSourceControl(ge,ve,ze){return cn.createSourceControl(He,ge,ve,ze)}},xt={createCommentController(ge,ve){return En.createCommentController(He,ge,ve)}},gn={get activeDebugSession(){return tt.activeDebugSession},get activeDebugConsole(){return tt.activeDebugConsole},get breakpoints(){return tt.breakpoints},onDidStartDebugSession(ge,ve,ze){return tt.onDidStartDebugSession(ge,ve,ze)},onDidTerminateDebugSession(ge,ve,ze){return tt.onDidTerminateDebugSession(ge,ve,ze)},onDidChangeActiveDebugSession(ge,ve,ze){return tt.onDidChangeActiveDebugSession(ge,ve,ze)},onDidReceiveDebugSessionCustomEvent(ge,ve,ze){return tt.onDidReceiveDebugSessionCustomEvent(ge,ve,ze)},onDidChangeBreakpoints(ge,ve,ze){return tt.onDidChangeBreakpoints(ge,ve,ze)},registerDebugConfigurationProvider(ge,ve,ze){return tt.registerDebugConfigurationProvider(ge,ve,ze||xe.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ge,ve){return tt.registerDebugAdapterDescriptorFactory(He,ge,ve)},registerDebugAdapterTrackerFactory(ge,ve){return tt.registerDebugAdapterTrackerFactory(ge,ve)},startDebugging(ge,ve,ze){return!ze||typeof ze=="object"&&"configuration"in ze?tt.startDebugging(ge,ve,{parentSession:ze}):tt.startDebugging(ge,ve,ze||{})},stopDebugging(ge){return tt.stopDebugging(ge)},addBreakpoints(ge){return tt.addBreakpoints(ge)},removeBreakpoints(ge){return tt.removeBreakpoints(ge)},asDebugSourceUri(ge,ve){return tt.asDebugSourceUri(ge,ve)}},Kn={registerTaskProvider:(ge,ve)=>Et.registerTaskProvider(He,ge,ve),fetchTasks:ge=>Et.fetchTasks(ge),executeTask:ge=>Et.executeTask(He,ge),get taskExecutions(){return Et.taskExecutions},onDidStartTask:(ge,ve,ze)=>Et.onDidStartTask(ge,ve,ze),onDidEndTask:(ge,ve,ze)=>Et.onDidEndTask(ge,ve,ze),onDidStartTaskProcess:(ge,ve,ze)=>Et.onDidStartTaskProcess(ge,ve,ze),onDidEndTaskProcess:(ge,ve,ze)=>Et.onDidEndTaskProcess(ge,ve,ze)},$t={createNotebookController(ge,ve,ze,at,Ct){return en.createNotebookController(He,ge,ve,ze,at,(0,Be.isProposedApiEnabled)(He,"notebookMessaging")?Ct:void 0)},registerNotebookCellStatusBarItemProvider:(ge,ve)=>yt.registerNotebookCellStatusBarItemProvider(He,ge,ve),createRendererMessaging(ge){return vn.createRendererMessaging(He,ge)},createNotebookControllerDetectionTask(ge){return(0,Be.checkProposedApiEnabled)(He,"notebookKernelSource"),en.createNotebookControllerDetectionTask(He,ge)},registerKernelSourceActionProvider(ge,ve){return(0,Be.checkProposedApiEnabled)(He,"notebookKernelSource"),en.registerKernelSourceActionProvider(He,ge,ve)},onDidChangeNotebookCellExecutionState(ge,ve,ze){return(0,Be.checkProposedApiEnabled)(He,"notebookCellExecutionState"),en.onDidChangeNotebookCellExecutionState(ge,ve,ze)}},pn={t(...ge){if(typeof ge[0]=="string"){const ve=ge.shift(),ze=!ge||typeof ge[0]!="object"?ge:ge[0];return vt.getMessage(He.identifier.value,{message:ve,args:ze})}return vt.getMessage(He.identifier.value,ge[0])},get bundle(){return vt.getBundle(He.identifier.value)},get uri(){return vt.getBundleUri(He.identifier.value)}};return{version:rt.version,authentication:Wn,commands:Hn,comments:xt,debug:gn,env:Mn,extensions:jn,l10n:pn,languages:Vn,notebooks:$t,scm:Gn,tasks:Kn,tests:hn,window:qn,workspace:mn,Breakpoint:z.Breakpoint,TerminalOutputAnchor:z.TerminalOutputAnchor,CallHierarchyIncomingCall:z.CallHierarchyIncomingCall,CallHierarchyItem:z.CallHierarchyItem,CallHierarchyOutgoingCall:z.CallHierarchyOutgoingCall,CancellationError:t.CancellationError,CancellationTokenSource:o.CancellationTokenSource,CandidatePortSource:v.CandidatePortSource,CodeAction:z.CodeAction,CodeActionKind:z.CodeActionKind,CodeActionTriggerKind:z.CodeActionTriggerKind,CodeLens:z.CodeLens,Color:z.Color,ColorInformation:z.ColorInformation,ColorPresentation:z.ColorPresentation,ColorThemeKind:z.ColorThemeKind,CommentMode:z.CommentMode,CommentThreadCollapsibleState:z.CommentThreadCollapsibleState,CommentThreadState:z.CommentThreadState,CompletionItem:z.CompletionItem,CompletionItemKind:z.CompletionItemKind,CompletionItemTag:z.CompletionItemTag,CompletionList:z.CompletionList,CompletionTriggerKind:z.CompletionTriggerKind,ConfigurationTarget:z.ConfigurationTarget,CustomExecution:z.CustomExecution,DebugAdapterExecutable:z.DebugAdapterExecutable,DebugAdapterInlineImplementation:z.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:z.DebugAdapterNamedPipeServer,DebugAdapterServer:z.DebugAdapterServer,DebugConfigurationProviderTriggerKind:xe.DebugConfigurationProviderTriggerKind,DebugConsoleMode:z.DebugConsoleMode,DecorationRangeBehavior:z.DecorationRangeBehavior,Diagnostic:z.Diagnostic,DiagnosticRelatedInformation:z.DiagnosticRelatedInformation,DiagnosticSeverity:z.DiagnosticSeverity,DiagnosticTag:z.DiagnosticTag,Disposable:z.Disposable,DocumentHighlight:z.DocumentHighlight,DocumentHighlightKind:z.DocumentHighlightKind,DocumentLink:z.DocumentLink,DocumentSymbol:z.DocumentSymbol,EndOfLine:z.EndOfLine,EnvironmentVariableMutatorType:z.EnvironmentVariableMutatorType,EvaluatableExpression:z.EvaluatableExpression,InlineValueText:z.InlineValueText,InlineValueVariableLookup:z.InlineValueVariableLookup,InlineValueEvaluatableExpression:z.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:z.InlineCompletionTriggerKind,EventEmitter:T.Emitter,ExtensionKind:z.ExtensionKind,ExtensionMode:z.ExtensionMode,ExternalUriOpenerPriority:z.ExternalUriOpenerPriority,FileChangeType:z.FileChangeType,FileDecoration:z.FileDecoration,FileDecoration2:z.FileDecoration,FileSystemError:z.FileSystemError,FileType:P.FileType,FilePermission:P.FilePermission,FoldingRange:z.FoldingRange,FoldingRangeKind:z.FoldingRangeKind,FunctionBreakpoint:z.FunctionBreakpoint,InlineCompletionItem:z.InlineSuggestion,InlineCompletionList:z.InlineSuggestionList,Hover:z.Hover,IndentAction:D.IndentAction,Location:z.Location,MarkdownString:z.MarkdownString,OverviewRulerLane:y.OverviewRulerLane,ParameterInformation:z.ParameterInformation,PortAutoForwardAction:z.PortAutoForwardAction,Position:z.Position,ProcessExecution:z.ProcessExecution,ProgressLocation:z.ProgressLocation,QuickInputButtons:z.QuickInputButtons,Range:z.Range,RelativePattern:z.RelativePattern,Selection:z.Selection,SelectionRange:z.SelectionRange,SemanticTokens:z.SemanticTokens,SemanticTokensBuilder:z.SemanticTokensBuilder,SemanticTokensEdit:z.SemanticTokensEdit,SemanticTokensEdits:z.SemanticTokensEdits,SemanticTokensLegend:z.SemanticTokensLegend,ShellExecution:z.ShellExecution,ShellQuoting:z.ShellQuoting,SignatureHelp:z.SignatureHelp,SignatureHelpTriggerKind:z.SignatureHelpTriggerKind,SignatureInformation:z.SignatureInformation,SnippetString:z.SnippetString,SourceBreakpoint:z.SourceBreakpoint,StandardTokenType:z.StandardTokenType,StatusBarAlignment:z.StatusBarAlignment,SymbolInformation:z.SymbolInformation,SymbolKind:z.SymbolKind,SymbolTag:z.SymbolTag,Task:z.Task,TaskGroup:z.TaskGroup,TaskPanelKind:z.TaskPanelKind,TaskRevealKind:z.TaskRevealKind,TaskScope:z.TaskScope,TerminalLink:z.TerminalLink,TerminalQuickFixCommand:z.TerminalQuickFixCommand,TerminalQuickFixOpener:z.TerminalQuickFixOpener,TerminalLocation:z.TerminalLocation,TerminalProfile:z.TerminalProfile,TerminalExitReason:z.TerminalExitReason,TerminalQuickFixType:z.TerminalQuickFixType,TextDocumentSaveReason:z.TextDocumentSaveReason,TextEdit:z.TextEdit,SnippetTextEdit:z.SnippetTextEdit,TextEditorCursorStyle:A.TextEditorCursorStyle,TextEditorLineNumbersStyle:z.TextEditorLineNumbersStyle,TextEditorRevealType:z.TextEditorRevealType,TextEditorSelectionChangeKind:z.TextEditorSelectionChangeKind,TextDocumentChangeReason:z.TextDocumentChangeReason,ThemeColor:z.ThemeColor,ThemeIcon:z.ThemeIcon,TreeItem:z.TreeItem,TreeItem2:z.TreeItem,TreeItemCheckboxState:z.TreeItemCheckboxState,TreeItemCollapsibleState:z.TreeItemCollapsibleState,TypeHierarchyItem:z.TypeHierarchyItem,UIKind:C.UIKind,Uri:I.URI,ViewColumn:z.ViewColumn,WorkspaceEdit:z.WorkspaceEdit,DocumentDropEdit:z.DocumentDropEdit,DocumentPasteEdit:z.DocumentPasteEdit,InlayHint:z.InlayHint,InlayHintLabelPart:z.InlayHintLabelPart,InlayHintKind:z.InlayHintKind,RemoteAuthorityResolverError:z.RemoteAuthorityResolverError,ResolvedAuthority:z.ResolvedAuthority,SourceControlInputBoxValidationType:z.SourceControlInputBoxValidationType,ExtensionRuntime:z.ExtensionRuntime,TimelineItem:z.TimelineItem,NotebookRange:z.NotebookRange,NotebookCellKind:z.NotebookCellKind,NotebookCellExecutionState:z.NotebookCellExecutionState,NotebookCellData:z.NotebookCellData,NotebookData:z.NotebookData,NotebookRendererScript:z.NotebookRendererScript,NotebookCellStatusBarAlignment:z.NotebookCellStatusBarAlignment,NotebookEditorRevealType:z.NotebookEditorRevealType,NotebookCellOutput:z.NotebookCellOutput,NotebookCellOutputItem:z.NotebookCellOutputItem,NotebookCellStatusBarItem:z.NotebookCellStatusBarItem,NotebookControllerAffinity:z.NotebookControllerAffinity,NotebookControllerAffinity2:z.NotebookControllerAffinity2,NotebookEdit:z.NotebookEdit,NotebookKernelSourceAction:z.NotebookKernelSourceAction,PortAttributes:z.PortAttributes,LinkedEditingRanges:z.LinkedEditingRanges,TestResultState:z.TestResultState,TestRunRequest:z.TestRunRequest,TestMessage:z.TestMessage,TestTag:z.TestTag,TestRunProfileKind:z.TestRunProfileKind,TextSearchCompleteMessageType:ht.TextSearchCompleteMessageType,DataTransfer:z.DataTransfer,DataTransferItem:z.DataTransferItem,CoveredCount:z.CoveredCount,FileCoverage:z.FileCoverage,StatementCoverage:z.StatementCoverage,BranchCoverage:z.BranchCoverage,FunctionCoverage:z.FunctionCoverage,WorkspaceTrustState:z.WorkspaceTrustState,LanguageStatusSeverity:z.LanguageStatusSeverity,QuickPickItemKind:z.QuickPickItemKind,InputBoxValidationSeverity:z.InputBoxValidationSeverity,TabInputText:z.TextTabInput,TabInputTextDiff:z.TextDiffTabInput,TabInputTextMerge:z.TextMergeTabInput,TabInputCustom:z.CustomEditorTabInput,TabInputNotebook:z.NotebookEditorTabInput,TabInputNotebookDiff:z.NotebookDiffEditorTabInput,TabInputWebview:z.WebviewEditorTabInput,TabInputTerminal:z.TerminalEditorTabInput,TabInputInteractiveWindow:z.InteractiveWindowInput,TelemetryTrustedValue:ne.TelemetryTrustedValue,LogLevel:Me.LogLevel,EditSessionIdentityMatch:gt.EditSessionIdentityMatch}}}e.createApiFactoryAndRegisterActors=lt}),define(ye[304],Ce([1,0,276,313,314,2,315]),function(te,e,o,t,T,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function A(P,v,C,E,f,d){const h=d.environment.useHostProxy,b=typeof h=="boolean"?h:!d.remote.isRemote,g=(0,I.createProxyResolver)({resolveProxy:w=>P.resolveProxy(w),getHttpProxySetting:()=>v.getConfiguration("http").get("proxy"),log:(w,i,...s)=>{switch(w){case I.LogLevel.Trace:E.trace(i,...s);break;case I.LogLevel.Debug:E.debug(i,...s);break;case I.LogLevel.Info:E.info(i,...s);break;case I.LogLevel.Warning:E.warn(i,...s);break;case I.LogLevel.Error:E.error(i,...s);break;case I.LogLevel.Critical:E.error(i,...s);break;case I.LogLevel.Off:break;default:a(w,i,s);break}function a(u,l,...c){E.error("Unknown log level",u),E.error(l,...c)}},getLogLevel:()=>E.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:b,env:process.env}),p=y(v,g);return L(C,p)}e.connectProxyResolver=A;function y(P,v){const C={config:P.getConfiguration("http").get("proxySupport")||"off"};P.onDidChangeConfiguration(f=>{C.config=P.getConfiguration("http").get("proxySupport")||"off"});const E={config:!!P.getConfiguration("http").get("systemCertificates")};return P.onDidChangeConfiguration(f=>{E.config=!!P.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},o,(0,I.createHttpPatch)(o,v,{config:"off"},E,!0)),on:Object.assign({},o,(0,I.createHttpPatch)(o,v,{config:"on"},E,!0)),override:Object.assign({},o,(0,I.createHttpPatch)(o,v,{config:"override"},E,!0)),onRequest:Object.assign({},o,(0,I.createHttpPatch)(o,v,C,E,!0)),default:Object.assign(o,(0,I.createHttpPatch)(o,v,C,E,!1))},https:{off:Object.assign({},t,(0,I.createHttpPatch)(t,v,{config:"off"},E,!0)),on:Object.assign({},t,(0,I.createHttpPatch)(t,v,{config:"on"},E,!0)),override:Object.assign({},t,(0,I.createHttpPatch)(t,v,{config:"override"},E,!0)),onRequest:Object.assign({},t,(0,I.createHttpPatch)(t,v,C,E,!0)),default:Object.assign(t,(0,I.createHttpPatch)(t,v,C,E,!1))},tls:Object.assign(T,(0,I.createTlsPatch)(T))}}const D=new Map;function L(P,v){return P.getExtensionPathIndex().then(C=>{const E=globalThis._VSCODE_NODE_MODULES.module,f=E._load;E._load=function(h,b,g){if(h==="tls")return v.tls;if(h!=="http"&&h!=="https")return f.apply(this,arguments);const p=v[h],w=C.findSubstr(R.URI.file(b.filename));let i=D.get(w);if(i||D.set(w,i={}),!i[h]){const s=p.default;i[h]={...s}}return i[h]}})}}),define(ye[305],Ce([1,0,77,303,290,304,42,278,2,15,7,275,114,277]),function(te,e,o,t,T,R,I,A,y,D,L,P,v,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class E extends T.RequireInterceptor{j(){const h=this,b=globalThis._VSCODE_NODE_MODULES.module,g=b._load;b._load=function(s,a,u){return s=w(s),h.a.has(s)?h.a.get(s).load(s,y.URI.file((0,v.realpathSync)(a.filename)),l=>g.apply(this,[l,a,u])):g.apply(this,arguments)};const p=b._resolveLookupPaths;b._resolveLookupPaths=(i,s)=>p.call(this,w(i),s);const w=i=>{for(const s of h.b){const a=s(i);if(a){i=a;break}}return i}}}class f extends I.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=L.ExtensionRuntime.Node}async nb(){this.h.createInstance(C.ExtHostConsoleForwarder);const h=this.h.invokeFunction(t.createApiFactoryAndRegisterActors);if(this.h.createInstance(A.ExtHostDownloadService),this.f.remote.isRemote&&this.f.remote.authority){const p=this.h.createInstance(P.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=p.ipcHandlePath}await this.h.createInstance(E,h,{mine:this.D,all:this.F}).install(),o.mark("code/extHost/didInitAPI");const g=await this.k.getConfigProvider();await(0,R.connectProxyResolver)(this.j,g,this,this.l,this.u,this.f),o.mark("code/extHost/didInitProxyResolver")}ob(h){return h.main}async pb(h,b,g){if(b.scheme!==D.Schemas.file)throw new Error(`Cannot load URI: '${b}', must be of file-scheme`);let p=null;g.codeLoadingStart(),this.l.trace(`ExtensionService#loadCommonJSModule ${b.toString(!0)}`),this.l.flush();const w=h?.identifier.value;h&&await this.s.initializeLocalizedMessages(h);try{w&&o.mark(`code/extHost/willLoadExtensionCode/${w}`),p=te.__$__nodeRequire(b.fsPath)}finally{w&&o.mark(`code/extHost/didLoadExtensionCode/${w}`),g.codeLoadingStop()}return p}async $setRemoteEnvironment(h){if(!!this.f.remote.isRemote)for(const b in h){const g=h[b];g===null?delete process.env[b]:process.env[b]=g}}}e.ExtHostExtensionService=f}),define(ye[145],Ce([1,0,46,316,299,18,81,38,10,8,2,31,75,317,297,99]),function(te,e,o,t,T,R,I,A,y,D,L,P,v,C,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.RipgrepParser=e.RipgrepTextSearchEngine=void 0;const d=E.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class h{constructor(m){this.a=m}provideTextSearchResults(m,S,k,M){return this.a.appendLine(`provideTextSearchResults ${m.pattern}, ${JSON.stringify({...S,folder:S.folder.toString()})}`),new Promise((q,V)=>{M.onCancellationRequested(()=>_());const F=s(m,S),U=S.folder.fsPath,N=F.map(X=>X.match(/^-/)?X:`'${X}'`).join(" ");this.a.appendLine(`${d} ${N}
 - cwd: ${U}`);let B=o.spawn(d,F,{cwd:U});B.on("error",X=>{console.error(X),this.a.appendLine("Error: "+(X&&X.message)),V((0,P.serializeSearchError)(new P.SearchError(X&&X.message,P.SearchErrorCode.rgProcessError)))});let j=!1;const z=new p(S.maxResults,U,S.previewOptions);z.on("result",X=>{j=!0,J="",k.report(X)});let ne=!1;const _=()=>{ne=!0,B?.kill(),z?.cancel()};let Y=!1;z.on("hitLimit",()=>{Y=!0,_()});let J="";B.stdout.on("data",X=>{z.handleData(X),j||(J+=X)});let Z=!1;B.stdout.once("data",()=>Z=!0);let ie="";B.stderr.on("data",X=>{const K=X.toString();this.a.appendLine(K),ie.length+K.length<1e6&&(ie+=K)}),B.on("close",()=>{if(this.a.appendLine(Z?"Got data from stdout":"No data from stdout"),this.a.appendLine(j?"Got result from parser":"No result from parser"),J&&this.a.appendLine(`Got data without result: ${J}`),this.a.appendLine(""),ne)q({limitHit:Y});else{z.flush(),B=null;let X;ie&&!Z&&(X=b(ie))?V((0,P.serializeSearchError)(new P.SearchError(X.message,X.code))):q({limitHit:Y})}})})}}e.RipgrepTextSearchEngine=h;function b(r){const m=r.split(`
`),S=m[0].trim();if(m.some(M=>M.startsWith("regex parse error")))return new P.SearchError(g(m),P.SearchErrorCode.regexParseError);const k=S.match(/grep config error: unknown encoding: (.*)/);if(k)return new P.SearchError(`Unknown encoding: ${k[1]}`,P.SearchErrorCode.unknownEncoding);if(S.startsWith("error parsing glob"))return new P.SearchError(S.charAt(0).toUpperCase()+S.substr(1),P.SearchErrorCode.globParseError);if(S.startsWith("the literal"))return new P.SearchError(S.charAt(0).toUpperCase()+S.substr(1),P.SearchErrorCode.invalidLiteral);if(S.startsWith("PCRE2: error compiling pattern"))return new P.SearchError(S,P.SearchErrorCode.regexParseError)}function g(r){const m=["Regex parse error"],S=r.filter(k=>k.startsWith("PCRE2:"));if(S.length>=1){const k=S[0].replace("PCRE2:","");if(k.indexOf(":")!==-1&&k.split(":").length>=2){const M=k.split(":")[1];m.push(":"+M)}}return m.join("")}class p extends t.EventEmitter{constructor(m,S,k){super(),this.g=m,this.h=S,this.j=k,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new T.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(m,S){return super.on(m,S),this}handleData(m){if(this.b)return;const S=typeof m=="string"?m:this.d.write(m);this.k(S)}k(m){let S=m.indexOf(`
`);const k=this.a+m;if(S>=0)S+=this.a.length;else{this.a=k;return}let M=0;for(;S>=0;)this.m(k.substring(M,S).trim()),M=S+1,S=k.indexOf(`
`,M);this.a=k.substring(M)}m(m){if(this.b||!m)return;let S;try{S=JSON.parse(m)}catch{throw new Error(`malformed line from rg: ${m}`)}if(S.type==="match"){const k=w(S.data.path),M=L.URI.file(y.join(this.h,k)),q=this.n(S.data,M);this.p(q),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(S.type==="context"){const k=w(S.data.path),M=L.URI.file(y.join(this.h,k));this.o(S.data,M).forEach(V=>this.p(V))}}n(m,S){const k=m.line_number-1,M=w(m.lines),q=Buffer.from(M);let V=0,F=0,U=k;m.submatches.length===0&&m.submatches.push(M.length?{start:0,end:1,match:{text:M[0]}}:{start:0,end:0,match:{text:""}});const N=(0,R.coalesce)(m.submatches.map((B,j)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const z=w(B.match),ne=q.slice(V,B.start).toString(),_=i(ne),Y=_.numLines>0?_.lastLineLength:_.lastLineLength+F,J=i(z),Z=_.numLines+U,ie=J.numLines+Z,X=J.numLines>0?J.lastLineLength:J.lastLineLength+Y;return V=B.end,F=X,U=ie,new v.Range(Z,Y,ie,X)}));return(0,f.createTextSearchResult)(S,M,N,this.j)}o(m,S){const k=w(m.lines),M=m.line_number;return k.replace(/\r?\n$/,"").split(`
`).map((q,V)=>({text:q,uri:S,lineNumber:M+V}))}p(m){this.emit("result",m)}}e.RipgrepParser=p;function w(r){return r.bytes?Buffer.from(r.bytes,"base64").toString():r.text}function i(r){const m=/\n/g;let S=0,k=-1,M;for(;M=m.exec(r);)S++,k=M.index;const q=k>=0?r.length-k-1:r.length;return{numLines:S,lastLineLength:q}}function s(r,m){const S=["--hidden"];S.push(r.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:k,otherIncludes:M}=(0,I.groupBy)(m.includes,V=>V.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(M&&M.length){const V=new Set;M.forEach(F=>{V.add(F)}),S.push("-g","!*"),V.forEach(F=>{a(F).map(f.anchorGlob).forEach(U=>{S.push("-g",U)})})}k&&k.length&&k.forEach(V=>{S.push("-g",V)}),m.excludes.map(f.anchorGlob).forEach(V=>S.push("-g",`!${V}`)),m.maxFileSize&&S.push("--max-filesize",m.maxFileSize+""),m.useIgnoreFiles?m.useParentIgnoreFiles||S.push("--no-ignore-parent"):S.push("--no-ignore"),m.followSymlinks&&S.push("--follow"),m.encoding&&m.encoding!=="utf8"&&S.push("--encoding",m.encoding),r.pattern==="--"&&(r.isRegExp=!0,r.pattern="\\-\\-"),r.isMultiline&&!r.isRegExp&&(r.pattern=(0,D.escapeRegExpCharacters)(r.pattern),r.isRegExp=!0),m.usePCRE2&&S.push("--pcre2"),S.push("--crlf"),r.isRegExp&&(r.pattern=u(r.pattern),S.push("--engine","auto"));let q;if(r.isWordMatch){const F=(0,D.createRegExp)(r.pattern,!!r.isRegExp,{wholeWord:r.isWordMatch}).source.replace(/\\\//g,"/");S.push("--regexp",F)}else if(r.isRegExp){let V=c(r.pattern);V=n(V),S.push("--regexp",V)}else q=r.pattern,S.push("--fixed-strings");return S.push("--no-config"),m.useGlobalIgnoreFiles||S.push("--no-ignore-global"),S.push("--json"),r.isMultiline&&S.push("--multiline"),m.beforeContext&&S.push("--before-context",m.beforeContext+""),m.afterContext&&S.push("--after-context",m.afterContext+""),S.push("--"),q&&S.push(q),S.push("."),S}function a(r){const m=(0,A.splitGlobAware)(r,"/");return m.map((S,k)=>m.slice(0,k+1).join("/"))}function u(r){const m=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;r.match(m);)r=r.replace(m,"$1\\x{$2}");const S=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;r.match(S);)r=r.replace(S,"$1\\x{$2}");return r}e.unicodeEscapesToPCRE2=u;const l=r=>r.type==="Assertion"&&r.kind==="lookbehind";function c(r){let m;try{m=new C.RegExpParser().parsePattern(r)}catch{return r}let S="",k=0;const M=(F,U,N)=>{S+=r.slice(k,F)+N,k=U},q=[];return new C.RegExpVisitor({onCharacterEnter(F){if(F.raw!=="\\n")return;const U=q[0];if(!U)M(F.start,F.end,"\\r?\\n");else if(!q.some(l))if(U.type==="CharacterClass")if(U.negate){const N=r.slice(U.start+2,F.start)+r.slice(F.end,U.end-1);U.parent?.type==="Quantifier"?M(U.start,U.end,N?`[^${N}]`:"."):M(U.start,U.end,"(?!\\r?\\n"+(N?`|[${N}]`:"")+")")}else{const N=r.slice(U.start+1,F.start)+r.slice(F.end,U.end-1);M(U.start,U.end,N===""?"\\r?\\n":`(?:[${N}]|\\r?\\n)`)}else U.type==="Quantifier"&&M(F.start,F.end,"(?:\\r?\\n)")},onQuantifierEnter(F){q.unshift(F)},onQuantifierLeave(){q.shift()},onCharacterClassRangeEnter(F){q.unshift(F)},onCharacterClassRangeLeave(){q.shift()},onCharacterClassEnter(F){q.unshift(F)},onCharacterClassLeave(){q.shift()},onAssertionEnter(F){l(F)&&q.push(F)},onAssertionLeave(F){q[0]===F&&q.shift()}}).visit(m),S+=r.slice(k),S}e.fixRegexNewline=c;function n(r){return r.replace(/\n/g,"\\r?\\n")}e.fixNewline=n}),define(ye[306],Ce([1,0,21,145,125,15]),function(te,e,o,t,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class I{constructor(D){this.b=D,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(D,L,P,v){const C=new t.RipgrepTextSearchEngine(this.b);if(L.folder.scheme===R.Schemas.vscodeUserData){const E={...L,folder:L.folder.with({scheme:R.Schemas.file})},f=new T.Progress(d=>P.report({...d,uri:d.uri.with({scheme:L.folder.scheme})}));return this.c(v,d=>C.provideTextSearchResults(D,E,f,d))}else return this.c(v,E=>C.provideTextSearchResults(D,L,P,E))}async c(D,L){const P=A(D);this.a.add(P);const v=await L(P.token);return this.a.delete(P),v}d(){this.a.forEach(D=>D.cancel())}}e.RipgrepSearchProvider=I;function A(y){const D=new o.CancellationTokenSource;return y.onCancellationRequested(()=>D.cancel()),D}}),define(ye[307],Ce([1,0,29,145,144]),function(te,e,o,t,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class R{constructor(y){this.a=y}search(y,D,L){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const P={appendLine(C){L({message:C})}},v=new T.NativeTextSearchManager(this.a,new t.RipgrepTextSearchEngine(P),o);return new Promise((C,E)=>v.search(f=>{D(f.map(I))},y).then(f=>C({limitHit:f.limitHit,type:"success",stats:f.stats}),E))}}e.TextSearchEngineAdapter=R;function I(A){return{path:A.resource&&A.resource.fsPath,results:A.results,numMatches:(A.results||[]).reduce((y,D)=>{if(D.ranges){const L=D;return y+(Array.isArray(L.ranges)?L.ranges.length:1)}else return y+1},0)}}}),define(ye[308],Ce([1,0,18,16,9,3,110,10,43,2,39,31,298,307]),function(te,e,o,t,T,R,I,A,y,D,L,P,v,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class E{constructor(p="searchProcess"){this.d=p,this.b=Object.create(null)}fileSearch(p){let w;const i=h(p),s=new R.Emitter({onDidAddFirstListener:()=>{w=(0,t.createCancelablePromise)(a=>this.doFileSearchWithEngine(v.Engine,i,u=>s.fire(u),a)),w.then(a=>s.fire(a),a=>s.fire({type:"error",error:{message:a.message,stack:a.stack}}))},onDidRemoveLastListener:()=>{w.cancel()}});return s.event}textSearch(p){let w;const i=h(p),s=new R.Emitter({onDidAddFirstListener:()=>{w=(0,t.createCancelablePromise)(a=>this.f(i,u=>s.fire(u),a)),w.then(a=>s.fire(a),a=>s.fire({type:"error",error:{message:a.message,stack:a.stack}}))},onDidRemoveLastListener:()=>{w.cancel()}});return s.event}f(p,w,i){return p.maxFileSize=(0,L.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new C.TextSearchEngineAdapter(p).search(i,w,w)}doFileSearch(p,w,i){return this.doFileSearchWithEngine(v.Engine,p,w,i)}doFileSearchWithEngine(p,w,i,s,a=E.a){let u=0;const l=n=>{Array.isArray(n)?(u+=n.length,i(n.map(r=>this.g(r)))):n.relativePath?(u++,i(this.g(n))):i(n)};if(w.sortByScore){let n=this.k(w,l,s);if(!n){const r=w.maxResults?Object.assign({},w,{maxResults:null}):w,m=new p(r);n=this.h(m,w,i,l,s)}return new Promise((r,m)=>{n.then(([S,k])=>{const M=k.map(q=>this.g(q));this.n(M,i,a),r(S)},m)})}const c=new p(w);return this.q(c,l,a,s).then(n=>({limitHit:n.limitHit,type:"success",stats:{detailStats:n.stats,type:this.d,fromCache:!1,resultCount:u,sortingTime:void 0}}))}g(p){return{path:p.base?(0,A.join)(p.base,p.relativePath):p.relativePath}}h(p,w,i,s,a){const u=new R.Emitter;let l=(0,t.createCancelablePromise)(n=>{let r=[];const m=S=>{Array.isArray(S)?r=S:(s(S),u.fire(S))};return this.q(p,m,-1,n).then(S=>[S,r])}),c;if(w.cacheKey){c=this.j(w.cacheKey);const n={promise:l,event:u.event,resolved:!1};c.resultsToSearchCache[w.filePattern||""]=n,l.then(()=>{n.resolved=!0},r=>{delete c.resultsToSearchCache[w.filePattern||""]}),l=this.r(l)}return l.then(([n,r])=>{const m=c?c.scorerCache:Object.create(null),S=(typeof w.maxResults!="number"||w.maxResults>0)&&y.StopWatch.create(!1);return this.l(w,r,m,a).then(k=>{const M=S?S.elapsed():-1;return[{type:"success",stats:{detailStats:n.stats,sortingTime:M,fromCache:!1,type:this.d,workspaceFolderCount:w.folderQueries.length,resultCount:k.length},messages:n.messages,limitHit:n.limitHit||typeof w.maxResults=="number"&&r.length>w.maxResults},k]})})}j(p){const w=this.b[p];return w||(this.b[p]=new f)}k(p,w,i){const s=p.cacheKey&&this.b[p.cacheKey];if(!s)return;const a=this.o(s,p.filePattern||"",w,i);if(a)return a.then(([u,l,c])=>{const n=y.StopWatch.create(!1);return this.l(p,l,s.scorerCache,i).then(r=>{const m=n.elapsed(),S={fromCache:!0,detailStats:c,type:this.d,resultCount:l.length,sortingTime:m};return[{type:"success",limitHit:u.limitHit||typeof p.maxResults=="number"&&l.length>p.maxResults,stats:S},r]})})}l(p,w,i,s){const a=(0,I.prepareQuery)(p.filePattern||""),u=(c,n)=>(0,I.compareItemsByFuzzyScore)(c,n,a,!0,d,i),l=typeof p.maxResults=="number"?p.maxResults:Number.MAX_VALUE;return o.topAsync(w,u,l,1e4,s)}n(p,w,i){if(i&&i>0)for(let s=0;s<p.length;s+=i)w(p.slice(s,s+i));else w(p)}o(p,w,i,s){const a=y.StopWatch.create(!1),u=w.indexOf(A.sep)>=0;let l;for(const m in p.resultsToSearchCache)if(w.startsWith(m)){if(u&&m.indexOf(A.sep)<0&&m!=="")continue;const S=p.resultsToSearchCache[m];l={promise:this.r(S.promise),event:S.event,resolved:S.resolved};break}if(!l)return null;const c=a.elapsed(),n=y.StopWatch.create(!1),r=l.event(i);return s&&s.onCancellationRequested(()=>{r.dispose()}),l.promise.then(([m,S])=>{if(s&&s.isCancellationRequested)throw(0,T.canceled)();const k=[],M=(0,I.prepareQuery)(w).normalizedLowercase;for(const q of S)!(0,P.isFilePatternMatch)(q,M)||k.push(q);return[m,k,{cacheWasResolved:l.resolved,cacheLookupTime:c,cacheFilterTime:n.elapsed(),cacheEntryCount:S.length}]})}q(p,w,i,s){return new Promise((a,u)=>{let l=[];s?.onCancellationRequested(()=>p.cancel()),p.search(c=>{c&&(i?(l.push(c),i>0&&l.length>=i&&(w(l),l=[])):w(c))},c=>{w(c)},(c,n)=>{l.length&&w(l),c?u(c):a(n)})})}clearCache(p){return delete this.b[p],Promise.resolve(void 0)}r(p){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(w,i){return p.then(w,i)}catch(w){return this.then(void 0,w)}finally(w){return p.finally(w)}}}}e.SearchService=E,E.a=512;class f{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const d=new class{getItemLabel(g){return(0,A.basename)(g.relativePath)}getItemDescription(g){return(0,A.dirname)(g.relativePath)}getItemPath(g){return g.relativePath}};function h(g){return{...g,folderQueries:g.folderQueries&&g.folderQueries.map(b),extraFileResources:g.extraFileResources&&g.extraFileResources.map(p=>D.URI.revive(p))}}function b(g){return{...g,folder:D.URI.revive(g.folder)}}}),define(ye[309],Ce([1,0,6,15,2,29,13,25,17,79,55,31,308,306,99,144]),function(te,e,o,t,T,R,I,A,y,D,L,P,v,C,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let d=class extends D.ExtHostSearch{constructor(b,g,p,w){super(b,p,w),this.s=R,this.t=-1,this.v=null,this.w=!1;const i=new E.OutputChannel("RipgrepSearchUD",this.n);this.registerTextSearchProvider(t.Schemas.vscodeUserData,new C.RipgrepSearchProvider(i)),g.remote.isRemote&&g.remote.authority&&this.x()}$enableExtensionHostSearch(){this.x()}x(){if(this.w)return;this.w=!0;const b=new E.OutputChannel("RipgrepSearchEH",this.n);this.registerTextSearchProvider(t.Schemas.file,new C.RipgrepSearchProvider(b)),this.y(t.Schemas.file,new v.SearchService("fileSearchProvider"))}y(b,g){const p=this.d++;return this.v=g,this.t=p,this.c.$registerFileSearchProvider(p,this.o(b)),(0,o.toDisposable)(()=>{this.v=null,this.c.$unregisterProvider(p)})}$provideFileSearchResults(b,g,p,w){const i=(0,D.reviveQuery)(p);return b===this.t?this.z(b,g,i,w):super.$provideFileSearchResults(b,g,p,w)}z(b,g,p,w){const i=s=>{if((0,P.isSerializedFileMatch)(s)&&(s=[s]),Array.isArray(s)){this.c.$handleFileMatch(b,g,s.map(a=>T.URI.file(a.path)));return}s.message&&this.n.debug("ExtHostSearch",s.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(p,i,w)}$clearCache(b){return this.v?.clearCache(b),super.$clearCache(b)}q(b,g){return new f.NativeTextSearchManager(b,g,void 0,"textSearchProvider")}};d=qe([We(0,y.IExtHostRpcService),We(1,A.IExtHostInitDataService),We(2,L.IURITransformerService),We(3,I.ILogService)],d),e.NativeExtHostSearch=d}),define(ye[310],Ce([1,0,88,281,293,292,309,305,282,78,42,79,76,41,54,73,280,279,13,294,49]),function(te,e,o,t,T,R,I,A,y,D,L,P,v,C,E,f,d,h,b,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,o.registerSingleton)(L.IExtHostExtensionService,A.ExtHostExtensionService,0),(0,o.registerSingleton)(b.ILoggerService,h.ExtHostLoggerService,1),(0,o.registerSingleton)(f.IExtensionStoragePaths,d.ExtensionStoragePaths,0),(0,o.registerSingleton)(D.IExtHostDebugService,R.ExtHostDebugService,0),(0,o.registerSingleton)(P.IExtHostSearch,I.NativeExtHostSearch,0),(0,o.registerSingleton)(v.IExtHostTask,T.ExtHostTask,0),(0,o.registerSingleton)(C.IExtHostTerminalService,t.ExtHostTerminalService,0),(0,o.registerSingleton)(E.IExtHostTunnelService,y.ExtHostTunnelService,0),(0,o.registerSingleton)(p.IExtHostVariableResolverProvider,g.NodeExtHostVariableResolverProviderService,0)}),define(ye[318],Ce([1,0,221,319,77,9,117,118,202,94,291,22,29,114,16,120,217,230,295,310]),function(te,e,o,t,T,R,I,A,y,D,L,P,v,C,E,f,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let c=0;c<process.execArgv.length;c++)process.execArgv[c]==="--inspect-port=0"&&(process.execArgv.splice(c,1),c--)}();const b=t(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const l=globalThis._VSCODE_NODE_MODULES.module,c=l._load;l._load=function(n){if(n==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return c.apply(this,arguments)}})();const g=process.exit.bind(process);function p(l){process.exit=function(c){if(l)g(c);else{const n=new Error("An extension called process.exit() and this was prevented.");console.warn(n.stack)}},process.crash=function(){const c=new Error("An extension called process.crash() and this was prevented.");console.warn(c.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let w=function(l){g()};function i(){const l=(0,h.readExtHostConnection)(process.env);if(l.type===3)return new Promise((c,n)=>{const r=m=>{const S=m[0],k=new I.BufferedEmitter;S.on("message",M=>k.fire(P.VSBuffer.wrap(M.data))),S.on("close",()=>{w("renderer closed the MessagePort")}),S.start(),c({onMessage:k.event,send:M=>S.postMessage(M.buffer)})};process.parentPort.on("message",m=>r(m.ports))});if(l.type===2)return new Promise((c,n)=>{let r=null;const m=setTimeout(()=>{w("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),S=108e5,k=3e5,M=new E.ProcessTimeRunOnceScheduler(()=>w("renderer disconnected for too long (1)"),S),q=new E.ProcessTimeRunOnceScheduler(()=>w("renderer disconnected for too long (2)"),k);process.on("message",(F,U)=>{if(F&&F.type==="VSCODE_EXTHOST_IPC_SOCKET"){U.setNoDelay(!0);const N=P.VSBuffer.wrap(Buffer.from(F.initialDataChunk,"base64"));let B;if(F.skipWebSocketFrames)B=new A.NodeSocket(U,"extHost-socket");else{const j=P.VSBuffer.wrap(Buffer.from(F.inflateBytes,"base64"));B=new A.WebSocketNodeSocket(new A.NodeSocket(U,"extHost-socket"),F.permessageDeflate,j,!1)}r?(M.cancel(),q.cancel(),r.beginAcceptReconnection(B,N),r.endAcceptReconnection(),r.sendResume()):(clearTimeout(m),r=new I.PersistentProtocol({socket:B,initialChunk:N}),r.sendResume(),r.onDidDispose(()=>w("renderer disconnected")),c(r),r.onSocketClose(()=>{M.schedule()}))}if(F&&F.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(q.isScheduled())return;M.isScheduled()&&q.schedule()}});const V={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(V)});{const c=l.pipeName;return new Promise((n,r)=>{const m=o.createConnection(c,()=>{m.removeListener("error",r);const S=new I.PersistentProtocol({socket:new A.NodeSocket(m,"extHost-renderer")});S.sendResume(),n(S)});m.once("error",r),m.on("close",()=>{w("renderer closed the socket")})})}}async function s(){const l=await i();return new class{constructor(){this.a=new I.BufferedEmitter,this.onMessage=this.a.event,this.b=!1,l.onMessage(c=>{(0,D.isMessageOfType)(c,2)?(this.b=!0,w("received terminate message from renderer")):this.a.fire(c)})}send(c){this.b||l.send(c)}async drain(){if(l.drain)return l.drain()}}}function a(l){return new Promise(c=>{const n=l.onMessage(r=>{n.dispose();const m=JSON.parse(r.toString()),S=m.commit,k=y.default.commit;if(S&&k&&S!==k&&g(55),m.parentPid){let M=0;setInterval(function(){try{process.kill(m.parentPid,0),M=0}catch(V){V&&V.code==="EPERM"?(M++,M>=3&&w(`parent process ${m.parentPid} does not exist anymore (3 x EPERM): ${V.message} (code: ${V.code}) (errno: ${V.errno})`)):w(`parent process ${m.parentPid} does not exist anymore: ${V.message} (code: ${V.code}) (errno: ${V.errno})`)}},1e3);let q;try{q=globalThis._VSCODE_NODE_MODULES["native-watchdog"],q.start(m.parentPid)}catch(V){(0,R.onUnexpectedError)(V)}}l.send((0,D.createMessageOfType)(0)),c({protocol:l,initData:m})});l.send((0,D.createMessageOfType)(1))})}async function u(){const l=[];process.on("unhandledRejection",(M,q)=>{l.push(q),setTimeout(()=>{const V=l.indexOf(q);V>=0&&q.catch(F=>{l.splice(V,1),(0,R.isCancellationError)(F)||(console.warn(`rejected promise not handled within 1 second: ${F}`),F&&F.stack&&console.warn(`stack trace: ${F.stack}`),M&&(0,R.onUnexpectedError)(M))})},1e3)}),process.on("rejectionHandled",M=>{const q=l.indexOf(M);q>=0&&l.splice(q,1)}),process.on("uncaughtException",function(M){(0,R.onUnexpectedError)(M)}),T.mark("code/extHost/willConnectToRenderer");const c=await s();T.mark("code/extHost/didConnectToRenderer");const n=await a(c);T.mark("code/extHost/didWaitForInitData");const{initData:r}=n;p(!!r.environment.extensionTestsLocationURI),r.environment.useHostProxy=b.useHostProxy!==void 0?b.useHostProxy!=="false":void 0,r.environment.skipWorkspaceStorageLock=(0,f.boolean)(b.skipWorkspaceStorageLock,!1);const m=new class{constructor(){this.pid=process.pid}exit(q){g(q)}exists(q){return v.Promises.exists(q)}realpath(q){return(0,C.realpath)(q)}};let S=null;r.remote.authority&&b.transformURIs&&(S=(0,d.createURITransformer)(r.remote.authority));const k=new L.ExtensionHostMain(n.protocol,r,m,S);w=M=>k.terminate(M)}u().catch(l=>console.log(l))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/727d2d32aea02baf7d13fa38787e8ed64dd858d0/core/vs/workbench/api/node/extensionHostProcess.js.map
